#include	"AjcInternal.h"
#include	"AjcCipCommon.h"

//**************************************************************************************************************//
//																												//
//	bꕗC^v^i`ohj																				//
//																												//
//**************************************************************************************************************//
//==============================================================================================================//
//	s~																									//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT BOOL			WINAPI AjcCipStop			(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		pW->fRunStop = TRUE;
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	IvV̐ݒ																							//
//																												//
//	@	F	hwnd		- EChnh																	//
//				fEnableOption	- uoptionv̉͋iTRUE:͂CFALSE:͂Ȃj						//
//				NumType			- l̃^CviAJCIPT_INTEGER or AJCIPT_REALj									//
//				fSigned			- uAJCIPT_INTEGERv̗̕L											//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI AjcCipSetOption	(HWND hwnd, BOOL fEnableOption, EAJCCIPTYP NumType, BOOL fSigned)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		pW->fEnableOption	= (fEnableOption != FALSE);
		pW->fSigned			= (fSigned		 != FALSE);
		if (NumType == AJCIPT_INTEGER || NumType == AJCIPT_REAL) {
			pW->NumType = NumType;
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	_uNbN̓ݒ																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				fNtcDblClk	- TRUE	- eECh֒ʒm															//
//							  FALSE - _OnDblClk()s															//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT BOOL			WINAPI AjcCipSetDblClkAct	(HWND hwnd, BOOL fNtcDblClk)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		pW->fNtcDblClk = fNtcDblClk;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	R[hi}NeLXgt@Cj̓ǂݏo																	//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pMacFile	- R[ht@CpX																//
//																												//
//	߂l	F	TRUE  - isj																			//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI AjcCipLoad	(HWND hwnd, C_BCP pMacFile)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		do {
			pW->fRunReady = FALSE;

			if (pMacFile == NULL) break;							//	t@CpX`FbN
			AjcSnPrintFA(pW->MacFile, MAX_PATH, "%s", pMacFile);
			_splitpath(pW->MacFile, pW->MacDrv, pW->MacDir, pW->MacFName, pW->MacFExt);
			_makepath (pW->MacPath, pW->MacDrv, pW->MacDir, NULL		, NULL		 );

			if (!(rc = CipReadMacroText(pW))) break;				//	R[ht@Cǂݏo
			if (!(rc = CipAnalize	   (pW))) break;				//	R[h́ivRpCj

			pW->fRunReady = TRUE;									//	usv

			rc = TRUE;
		} while(0);
	}

	return rc;
}
//==============================================================================================================//
//	R[hi}NeLXgj̎s																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pCall		- ֐Ăяo																	//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- WCxgL[̃R[obN -----------------------------------------------------------------//
static VO CALLBACK cbRemoveStdEvt(VOP pDat, UX cbp)
{
	HAJCCIP			pW	  = (HAJCCIP)cbp;
	PAJCCIPCALL		pCall = *((PAJCCIPCALL *)pDat);

	if (pCall != NULL) {
		AjcCipCallInfoDelete(pW->hWndBack, pCall);					//		Ăяoj
	}
}
//----- rboCxgL[̃R[obN ---------------------------------------------------------------//
static VO CALLBACK cbRemoveScpEvt(VOP pDat, UX cbp)
{
	HAJCCIP			pW	 = (HAJCCIP)cbp;
	PAJCCIPSCPEVT	p	 = (PAJCCIPSCPEVT)pDat;

	if (p->pDat != NULL) {
		free(p->pDat);
		p->pDat = NULL;
	}
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	WINAPI AjcCipExec	(HWND hwnd, PAJCCIPCALL pCall)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;
	UI			i;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		do {
			if (!pW->fRunReady) {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_NOTREADY, 0,
											  LNGSEL("}Ns̏łĂ܂B",
													 "Not ready for macro execution."));
				break;
			}
			if (pW->fExec) {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_EXEC, 0,
											  LNGSEL("}N͊ɎsłB",
													 "Macro is already executing."));
				break;
			}

			//----- sO ---------------------------------------------------------------------------------//
			//	G[R[hZbg
			pW->ErrCod = AJCIP_ERR_OK;
			//	tO񏉊
			pW->fRunStop	   = FALSE;							//	s~tO
			pW->fExeStop	   = FALSE;							//	sftO( _Stop()  )
			pW->fExePause	   = FALSE;							//	sftO( _Pause() )
			pW->fExeFileSearch = FALSE;							//	t@CtO
			pW->fBusyOnChkBox  = FALSE;							//	_OnChkBox()stO
			pW->fExeEventBusy  = FALSE;							//	CxgstO
			pW->fExeStdEvtBusy = FALSE;							//	W  CxgstO
			pW->fExeComEvtBusy = FALSE;							//	bnlCxgstO
			pW->nExeDisStdEvt  = 0;								//	W  Cxg
			pW->nExeDisComEvt  = 0;								//	bnlCxg
			pW->mskExeTimEvt   = 0;								//	^C}Cxg쒆tO
			pW->fExeRClick	   = 0;								//	ENbNtO
			pW->fExeDblClk	   = 0;								//	_uNbNtO
			memset(pW->fExeTimer, 0, sizeof pW->fExeTimer);		//	^C}CxgtO
			pW->fExeEnaStdPopupMenu = FALSE;					//	ENbNɂW|bvAbv̋(FALSE:֎~)
			//	Exit()eLXg
			memset(pW->ExitText, 0, sizeof pW->ExitText);
			//	WCxgL[
			pW->hFQueStdEvt = AjcFQueCreate(sizeof(PAJCCIPCALL ), (UX)pW, cbRemoveStdEvt);
			//	rboCxgL[
			pW->hFQueScpEvt = AjcFQueCreate(sizeof(AJCCIPSCPEVT), (UX)pW, cbRemoveScpEvt);
			//	ECheLXg
			AjcVthSetTitleText(pW->hWndVth, NULL, -1, -1, NULL);
			//	Xebvg[X񏉊
			pW->fStepPause		= FALSE;						//	ꎞ~tO
			pW->nStepCount		= 0;							//	XebvsJE^
			pW->fStepMsgBoxBusy	= FALSE;						//	bZ[W{bNX\tO
			pW->pStepTkn		= NULL;							//	Xebvg[X\pg[NAhX
			pW->SvStepLno		= -1;							//	Xebvg[X\psԍޔ
			pW->SvBrkLno		= -1;							//	u[Npsԍޔ
			pW->SvStepTkn		= EAJCTK_INVALID;				//	Xebvg[X\pg[NR[hޔ
			pW->ExeStepNo		= 0;							//	_Ci~bNXebvԍ
			//	slbEChN[Y
			if (pW->hWndTmcBack != NULL) {DestroyWindow(pW->hWndTmcBack); pW->hWndTmcBack = NULL;}
			//	ftHg̃vt@CZNVݒ
			AjcSnPrintFA(pW->ExeSect, sizeof pW->ExeSect, "%s\\DefSect", pW->MacFName);

			//----- ֐sJn -------------------------------------------------------------------------------//
			//	sJnʒm
			pW->fExec		 = TRUE;
			pW->ixIfNest	 = 0;
			pW->fStepSvPause = ~pW->fStepPause;
			pW->fStepSvExec  = ~pW->fExec;
			CipStepNtcExec(pW, FALSE);
			//	擪̊֐s
			rc = CipExeFuncCall(pW, pCall, NULL);
			//	sIʒm
			pW->fExec = FALSE;
			CipStepNtcExec(pW, FALSE);

			//----- s㏈ ---------------------------------------------------------------------------------//
			//	S^C}~
			CipGsrStopAllTimer(pW);
			//	ENbNWɖ߂
			AjcVthSetNtcRClk(pW->hWndVth, FALSE, 0, 0);
			//	_uNbNseLXg
			if (pW->pExeDblClkLine != NULL) {
				free(pW->pExeDblClkLine);
				pW->pExeDblClkLine = NULL;
			}
			//	WCxgL[
			if (pW->hFQueStdEvt != NULL) {
				PAJCCIPCALL pCall;
				while (AjcFQueDeque(pW->hFQueStdEvt, &pCall)) {
					AjcCipCallInfoDelete(pW->hWndBack, pCall);
				}
				AjcFQueDelete(pW->hFQueStdEvt);
				pW->hFQueStdEvt = NULL;
			}
			//	rboCxgL[
			if (pW->hFQueScpEvt != NULL) {
				AjcFQueDelete(pW->hFQueScpEvt);
				pW->hFQueScpEvt = NULL;
			}
			//	rbo,rboʒmpEChj
			for (i = 0; i < AJCCIPMAX_SCP; i++) {
				if (pW->ExeScp[i].hScp != NULL) {
					AjcScpDelete(pW->ExeScp[i].hScp);
					pW->ExeScp[i].hScp = NULL;
				}
				if (pW->ExeScp[i].hwnd != NULL) {
					DestroyWindow(pW->ExeScp[i].hwnd);
					pW->ExeScp[i].hwnd = NULL;
				}
			}
			memset(pW->ExeScp, 0, sizeof pW->ExeScp);
			//	t@CN[Y
			for (i = 1; i < AJCCIPMAX_FILES; i++) {
				if (pW->ExeFile[i].hFile != NULL) {
					fclose(pW->ExeFile[i].hFile);
					pW->ExeFile[i].hFile = NULL;
				}
			}
			memset(pW->ExeFile, 0, sizeof pW->ExeFile);
			//	ubN
			for (i = 1; i < AJCCIPMAX_MEMBLK; i++) {
				if (pW->ExeMemBlk[i].pMemAddr != NULL) {
					free(pW->ExeMemBlk[i].pMemAddr);
					pW->ExeMemBlk[i].pMemAddr = NULL;
				}
			}
			memset(pW->ExeMemBlk, 0, sizeof pW->ExeMemBlk);
			//	{^N[Y
			for (i = 0; i < MAX_BUTTON; i++) {
				if (pW->hButton[i] != NULL) {
					DestroyWindow(pW->hButton[i]);
					pW->hButton[i] = NULL;
				}
			}
			pW->mskBtnValid = 0;
			//	`FbN{bNXN[Y
			for (i = 0; i < MAX_CHKBOX; i++) {
				if (pW->hChkBox[i] != NULL) {
					DestroyWindow(pW->hChkBox[i]);
					pW->hChkBox[i] = NULL;
				}
			}
			pW->mskChkValid = 0;
			//	O֐Ăяö
			if (pW->ppNtcAgv != NULL) {
				free(pW->ppNtcAgv);
				pW->ppNtcAgv = NULL;
			}
			//	{^C`FbN{bNX̍NA[
			pW->BtnChkHeight  = 0;

			//	VT100EChzu
			CipGsrMoveVT100Window(pW);
		} while(0);
	}
	return rc;
}
//==============================================================================================================//
//	[UCxg̎s																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pCall		- ֐Ăяo																	//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI AjcCipEvent	(HWND hwnd, PAJCCIPCALL pCall)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		do {
			if (!pW->fExec) {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_EXEC, 0,
											  LNGSEL("}N͎sĂ܂B",
													 "Macro is not executed."));
				break;
			}
			pCall->pReturn = pW->pCur;						//	߂AhXi_~[Cۂɂ̓GL[ɍĐݒ肳j
			AjcFQueEnque(pW->hFQueStdEvt, (VOP)&pCall);		//	CxgEGL[
			rc = TRUE;
		} while(0);
	}
	return rc;
}

//==============================================================================================================//
//	vg																								//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pFmt		- o͕																		//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT BOOL			WINAPI AjcCipPutS			(HWND hwnd, C_BCP pTxt)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		AjcVthPutTextA(pW->hWndVth, pTxt, -1);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	vg																							//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pFmt		- 																		//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT BOOL			WINAPI AjcCipPrintF			(HWND hwnd, C_BCP pFmt, ...)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;
	va_list 	vls;
	BC			txt[MAX_PATH + 1024];

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		va_start(vls, pFmt);
		_vsnprintf(txt, sizeof txt, pFmt, vls);
		va_end	(vls);
		txt[(sizeof txt) - 1] = 0;

		if (pW->hWndVth != NULL) {
			AjcVthPutTextA(pW->hWndVth, txt, -1);
		}
		else {
			printf("%s", txt);
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	[U֐̃G[ʒm																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pCall		- ֐Ăяo																	//
//				pFmt		- 																		//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcCipNtcErrByUser	(HWND hwnd, PCAJCCIPCALL pCall, C_BCP pFmt, ...)
{
	HAJCCIP			pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL			rc = FALSE;
	AJCCIPEVPERR	cbp;
	va_list 		vls;
	UI				stl;					//	"t@CpX(sԍ)" ̒

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		//	t@CpXCsԍݒ
		AjcSnPrintFA(pW->NtcTxt, sizeof pW->NtcTxt, "%s(%4d): ", pW->MacFile, pCall->lno);
		stl = (UI)strlen(pW->NtcTxt);
		//	bZ[Wݒ
		va_start(vls, pFmt);
		_vsnprintf(&pW->NtcTxt[stl], (sizeof pW->NtcTxt) - stl, pFmt, vls);
		va_end	(vls);
		pW->NtcTxt[(sizeof pW->NtcTxt) - 1] = 0;
		//	G[ʒm
		cbp.err  = AJCIP_ERR_USER;
		cbp.lno  = pCall->lno;
		cbp.pMsg = pW->NtcTxt;
		SendMessage(pW->hParent, WM_COMMAND, MAKELONG(pW->CtrlId, AJCCIPN_ERR),
											 fCmdWithHdl ? (LPARAM)pW->hWndBack : (LPARAM)&cbp);
		//	G[R[hݒ
		pW->ErrCod = AJCIP_ERR_USER;
		//	߂l
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	_Exit()}N֐ɂw肳ꂽeLXg̎擾																//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	NULL	? i_Exit()Ŏw肳ꂽeLXgւ̃|C^j										//
//				NULL	? G[																				//
//==============================================================================================================//
AJCEXPORT C_BCP			WINAPI AjcCipGetExitText	(HWND hwnd)
{
	C_BCP	rc = NULL;

	HAJCCIP			pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		rc = pW->ExitText;
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽt@C擾																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				buf	  - t@Ci[obt@̃AhX													//
//																												//
//	߂l	F	TRUE:t@CCFALSE:t@CȂ														//
//==============================================================================================================//
AJCEXPORT BOOL			WINAPI AjcCipGetDroppedFile (HWND hwnd, BC buf[MAX_PATH])
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pW->hWndVth != NULL) {
			AjcVthGetDroppedFileA  (pW->hWndVth, buf);
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	hbvꂽfBNg擾																			//
//																												//
//	@	F	hwnd		- EChnh																	//
//				buf	  - fBNgi[obt@̃AhX												//
//																												//
//	߂l	F	TRUE:fBNgCFALSE:fBNgȂ												//
//==============================================================================================================//
AJCEXPORT BOOL 			WINAPI AjcCipGetDroppedDir	(HWND hwnd, BC buf[MAX_PATH])
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pW->hWndVth != NULL) {
			AjcVthGetDroppedDirA  (pW->hWndVth, buf);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽfBNg擾																			//
//																												//
//	@	F	hwnd		- EChnh																	//
//				buf	  - fBNgi[obt@̃AhX												//
//																												//
//	߂l	F	TRUE:fBNgCFALSE:fBNgȂ												//
//==============================================================================================================//
AJCEXPORT BOOL 			WINAPI AjcCipGetDroppedDirEx(HWND hwnd, BC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	BOOL		rc = FALSE;

	if (rc = AjcCipGetDroppedDir(hwnd, buf)) {
		if (fTailIsDelimiter) AjcPathCatA(buf, "", MAX_PATH);
		else				  PathRemoveBackslashA(buf);
	}
	return rc;
}

//==============================================================================================================//
//	֐Ăяȍ																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pFuncName	- ֐																			//
//																												//
//	߂l	F	NULL - i֐ĂяõAhXj												//
//				NULL - s																					//
//==============================================================================================================//
AJCEXPORT PAJCCIPCALL	WINAPI AjcCipCallInfoInit	(HWND hwnd, C_BCP pFuncName)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	PAJCCIPCALL	pCallInfo  = NULL;
	PAJCCIPFUNC	pFunc	= NULL;
	UI			stl;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pFuncName != NULL && *pFuncName != 0) {															//	֐H
			stl = (UI)strlen(pFuncName);																	//		֐̒ݒ
			if (pCallInfo = (PAJCCIPCALL)AJCMEM(sizeof(AJCCIPCALL))) {										//		Ăяo񊄂蓖āCH
				memset(pCallInfo, 0, sizeof(AJCCIPCALL));													//			ĂяoNA[
				if ((pFunc = (PAJCCIPFUNC)AjcAvlGetNodePtr(pW->hAvlFun, (UX)pFuncName, NULL)) != NULL) {	//			֐CH
					pCallInfo->lno = pFunc->pEntry->lno;													//				֐̍sԍݒ
					if (pCallInfo->pFunName = (BCP)AJCMEM(stl + 1)) {										//				֐̈mہCH
						strcpy(pCallInfo->pFunName, pFuncName);												//					֐Rs[
						if ((pCallInfo->hQueAgv = AjcFQueCreate(sizeof(AJCCIPAGV), 0, NULL)) != NULL) {		//					L[CH
							pCallInfo->rchVmg = pW->sFni[0].hVmg;											//						֐̉߂ϐݒ
							if (*pFuncName == '$') {														//						E
								pCallInfo->rcpSym = "$@rc";													//						E
							}
							else {																			//						E
								pCallInfo->rcpSym = "@rc";													//						E
							}
							pCallInfo->rcIx = 0;															//						E 
						}
						else {																				//					L[sH
							AjcCipCallInfoDelete(pW->hWndBack, pCallInfo);									//						Ăяoj
							pCallInfo = NULL;																//						߂lmtkk
						}
					}
					else {																					//				֐̈mێs
						AjcCipCallInfoDelete(pW->hWndBack, pCallInfo);										//					Ăяoj
						pCallInfo = NULL;																	//					߂lmtkk
					}
				}
				else {																						//			sH
					AjcCipCallInfoDelete(pW->hWndBack, pCallInfo);											//				Ăяoj
					pCallInfo = NULL;																		//				߂lmtkk
				}
			}
		}
	}
	return pCallInfo;
}
//==============================================================================================================//
//	֐Ăяo̔j																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pCallInfo	- ֐Ăяõobt@												//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI AjcCipCallInfoDelete	(HWND hwnd, PAJCCIPCALL pCallInfo)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;
	PAJCCIPAGV	pNode;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		//	֐
		if (pCallInfo->pFunName != NULL) {
			free(pCallInfo->pFunName);
			pCallInfo->pFunName = NULL;
		}
		//	L[
		if (pCallInfo->hQueAgv != NULL) {
			if (pNode = (PAJCCIPAGV)AjcFQueTopNode(pCallInfo->hQueAgv)) {
				do {
					if (pNode->typ == AJCIPT_STRING && pNode->val.pStr != NULL) {
						free((VOP)pNode->val.pStr);
						pNode->val.pStr = NULL;
					}
				} while(pNode = (PAJCCIPAGV)AjcFQueNextNode(pCallInfo->hQueAgv, pNode));
			}
			AjcFQueDelete(pCallInfo->hQueAgv);
			pCallInfo->hQueAgv = NULL;
		}
		//	Ăяo
		free(pCallInfo);
		//	߂l
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	֐Ăяoֈijǉ																			//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pCallInfo	- ֐Ăяo																	//
//				value		- ̒l																			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcCipCallInfoInsInteger	(HWND hwnd, PAJCCIPCALL pCallInfo, SLL value)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;
	AJCCIPAGV	agv;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pCallInfo->hQueAgv != NULL) {
			agv.seq		= pCallInfo->nArg;
			agv.typ		= AJCIPT_INTEGER;
			agv.val.sll = value;
			agv.fArr	= FALSE;
			if (rc = AjcFQueEnque(pCallInfo->hQueAgv, &agv)) {
				pCallInfo->nArg++;
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	֐Ăяoֈijǉ																			//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pCallInfo	- ֐Ăяo																	//
//				value		- ̒l																			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcCipCallInfoInsReal	(HWND hwnd, PAJCCIPCALL pCallInfo, double value)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;
	AJCCIPAGV	agv;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pCallInfo->hQueAgv != NULL) {
			agv.typ		= AJCIPT_REAL;
			agv.val.dbl = value;
			agv.fArr	= FALSE;
			if (rc = AjcFQueEnque(pCallInfo->hQueAgv, &agv)) {
				pCallInfo->nArg++;
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	֐Ăяoֈijǉ																		//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pCallInfo		- ֐Ăяo																//
//				value			- ̒l																		//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcCipCallInfoInsString	(HWND hwnd, PAJCCIPCALL pCallInfo, C_BCP pStr)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;
	AJCCIPAGV	agv;
	UI			stl = (UI)strlen(pStr);

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pCallInfo->hQueAgv != NULL) {
			agv.typ		= AJCIPT_STRING;
			agv.fArr	= FALSE;
			if (agv.val.pStr = (C_BCP)AJCMEM(stl + 1)) {
				strcpy((BCP)agv.val.pStr, pStr);
				if (rc = AjcFQueEnque(pCallInfo->hQueAgv, &agv)) {
					pCallInfo->nArg++;
					rc = TRUE;
				}
				else {
					free((VOP)agv.val.pStr);
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	֐̖߂l擾ij																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pNum		- ߂l̔zvfi[obt@isvNULL)								//
//																												//
//	߂l	F	NULL - ߂li64Bitljz̐擪AhX												//
//				NULL - s																					//
//==============================================================================================================//
AJCEXPORT C_ULLP	WINAPI AjcCipGetRetInt(HWND hwnd, UIP pNum)
{
	HAJCCIP			pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	C_ULLP			rc = NULL;
	PCAJCVMGNODEA	pNode;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pNode = AjcVmgGetNodeA(pW->sFni[0].hVmg, "@rc")) {
			if (pNum != NULL) *pNum = pNode->num;
			rc = (C_ULLP)pNode->arr.pSLL;
		}
	}
	return rc;
}
//==============================================================================================================//
//	֐̖߂l擾ij																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pNum		- ߂l̔zvfi[obt@isvNULL)								//
//																												//
//	߂l	F	NULL - ߂liljz̐擪AhX														//
//				NULL - s																					//
//==============================================================================================================//
AJCEXPORT const double * WINAPI AjcCipGetRetReal(HWND hwnd, UIP pNum)
{
	HAJCCIP			pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	const double *	rc = NULL;
	PCAJCVMGNODEA	pNode;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pNode = AjcVmgGetNodeA(pW->sFni[0].hVmg, "@rc")) {
			if (pNum != NULL) *pNum = pNode->num;
			rc = pNode->arr.pDBL;
		}
	}
	return rc;
}
//==============================================================================================================//
//	֐̖߂l擾ij																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pNum		- ߂l̔zvfi[obt@isvNULL)								//
//																												//
//	߂l	F	NULL - ߂l(ւ̃|C^jz̐擪AhX											//
//				NULL - s																					//
//==============================================================================================================//
AJCEXPORT const C_BCP *  WINAPI AjcCipGetRetStr(HWND hwnd, UIP pNum)
{
	HAJCCIP			pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	const C_BCP		*rc = NULL;
	PCAJCVMGNODEA	pNode;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pNode = AjcVmgGetNodeA(pW->sFni[0].hVmg, "@rc")) {
			if (pNum != NULL) *pNum = pNode->num;
			rc = pNode->arr.pStr;
		}
	}
	return rc;
}
//==============================================================================================================//
//	g[X\ ECh																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI AjcCipCreateTraceWindow(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		rc = CipTrcCreateWindow(pW);
	}
	return rc;
}
//==============================================================================================================//
//	g[X\ EChj																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI AjcCipDestroyTraceWindow(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (pW->hTrcBack != NULL) {
			DestroyWindow(pW->hTrcBack);
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	XebvEg[X ECh																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI AjcCipCreateStepWindow(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		rc = CipStepCreateWindow(pW);
	}
	return rc;
}
//==============================================================================================================//
//	XebvEg[X EChj																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI AjcCipDestroyStepWindow(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		if (!pW->fExec) {
			if (pW->hStepBack != NULL) {
				DestroyWindow(pW->hStepBack);
			}
			rc = TRUE;
		}
		else rc = (pW->hStepBack == NULL);
	}
	return rc;
}
//==============================================================================================================//
//	VT100G~[VECh̃nh擾																	//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	NULL : OK(VT100G~[VECh̃nh)											//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT HWND			WINAPI AjcCipGetVT100Handle		(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	HWND		rc = NULL;

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		rc = pW->hWndVth;
	}
	return rc;
}
//==============================================================================================================//
//	Xe[^X擾																							//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT BOOL			WINAPI AjcCipGetStatus			(HWND hwnd, PAJCCIPSTATE pState)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;

	if (pW != NULL && pW->id == AJCCIP_INSTID && pState != NULL) {
		//	l^Cvݒ
		switch (pW->NumType) {
			case AJCIPT_INTEGER:
				if (pW->fSigned) pState->eType = AJCCIPSTS_SINT;
				else			 pState->eType = AJCCIPSTS_UINT;
				break;
			case AJCIPT_REAL:
				pState->eType = AJCCIPSTS_REAL;
				break;
			default:
				pState->eType = AJCCIPSTS_UNKOWN;
				break;
		}
		//	sԐݒ
		if (pW->fExec) {
			pState->eExec = AJCCIPSTS_EXEC;
		}
		else {
			if (pW->fRunReady) pState->eExec = AJCCIPSTS_READY;
			else			   pState->eExec = AJCCIPSTS_NOTREADY;
		}
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	fobOp}NeLXg͌ʃ_vo																	//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
static BOOL CALLBACK cbNtcVar(PCAJCVMGNODEA pVarInfo, UX cbp)
{
	FILE		*hOut = (FILE*)cbp;
	UI			i;
	UBP			p;

	for (i = 0; i < pVarInfo->num; i++) {
		UI	stl = (UI)strlen(pVarInfo->pName);
		if (pVarInfo->num == 1) {
			fprintf(hOut, "%s = ", pVarInfo->pName);
		}
		else {
			if (i == 0) fprintf(hOut, "%s[%2d] = ", pVarInfo->pName, i);
			else		fprintf(hOut, "%*c[%2d] = ", stl, ' ', i);
		}
		switch (pVarInfo->type) {
			case AJCVMGT_INT:	fprintf(hOut, "%d"	, pVarInfo->arr.pSI [i]);	break;
			case AJCVMGT_LONG:	fprintf(hOut, "%lld", pVarInfo->arr.pSLL[i]);	break;
			case AJCVMGT_REAL:	fprintf(hOut, "%f"	, pVarInfo->arr.pDBL[i]);	break;
			case AJCVMGT_STR:
				fprintf(hOut, "\"");
				for (p = (UBP)pVarInfo->arr.pStr[i]; *p != 0; p++) {
					if (*p < 0x20) fprintf(hOut, "\\x%02x", *p);
					else		   fprintf(hOut, "%c"	  , *p);
				}
				fprintf(hOut, "\"");
				break;
		}
		fprintf(hOut, "\n");
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	WINAPI AjcCipDump(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BOOL		rc = FALSE;
	FILE		*hOut;
	PAJCCIPTKN	pTkn;
	UW			lno, nest;
	UI			i;
	BC			path[MAX_PATH];

	if (pW != NULL && pW->id == AJCCIP_INSTID) {
		GetTempPathA(MAX_PATH, path);
		AjcPathCatA(path, "AjrCip.txt", MAX_PATH);
		if (hOut = fopen(path, "wt")) {
			//	g[N_v
			fprintf(hOut, "----- Token information ----------\n");
			if (pTkn = pW->pTknTop) {
				nest = 0;
				lno  = pTkn->lno;
				fprintf(hOut, "[%4d]\n", lno);
				while (pTkn->tkn != EAJCTK_EOF) {
					if (lno != pTkn->lno) {
						lno = pTkn->lno;
						fprintf(hOut, "[%4d]\n", lno);
					}
					if (pTkn->tkn == EAJCTK_DLM_RMPART) {	//	'}'
						nest--;
					}
					fprintf(hOut, "%p:%2d: %*c'", pTkn, nest, (nest + 1) * 2, ' ');
					switch (pTkn->tkn) {
						case EAJCTK_RSV_IF:			//	Eif
						case EAJCTK_RSV_ELSE:		//	Eelse
						case EAJCTK_RSV_WHILE:		//	Ewhile
						case EAJCTK_RSV_FOR:		//	Efor
						case EAJCTK_RSV_BREAK:		//	Ebreak
						case EAJCTK_RSV_GOTO:		//	Egoto
							fprintf(hOut, "%s JMP=%p", CipGsrTknStr(pTkn), pTkn->u.pJmp);
							switch (pTkn->flgCtrl) {
								case AJCIP_WHILE_FRONT:		fprintf(hOut, " (Ou 'while')");	break;
								case AJCIP_WHILE_TAIL:		fprintf(hOut, " (u 'while')");	break;
							}
							break;
						case EAJCTK_DLM_SEMICOL:	//	E;
						case EAJCTK_DLM_RMPART:		//	E}
						case EAJCTK_DLM_RSPART:		//	E)
							if (pTkn->flgCtrl != 0) fprintf(hOut, "%s JMP=%p", CipGsrTknStr(pTkn), pTkn->u.pJmp);
							else					fprintf(hOut, "%s", CipGsrTknStr(pTkn));
							switch (pTkn->flgCtrl) {
								case AJCIP_WHILE_END:	fprintf(hOut, " (Ou 'while' ubN̏I[)"	);	break;
								case AJCIP_FOR_COND:	fprintf(hOut, " ('for' uv̖( ';' )"		);	break;
								case AJCIP_FOR_UPD:		fprintf(hOut, " ('for' uXVv̖( ')' )"		);	break;
								case AJCIP_FOR_END:		fprintf(hOut, " ('for' ubN̏I[( ';' or '}' )");	break;
								case AJCIP_FUNC_END:	fprintf(hOut, " (֐̖)"						);	break;
							}
							break;
						default:					//	Ȇ
							fprintf(hOut, "%s", CipGsrTknStr(pTkn));
							break;
					}
					fprintf(hOut, "' tkn = %4d\n", pTkn->tkn);
					if		(pTkn->tkn == EAJCTK_DLM_LMPART) {	//	'{'
						nest++;
					}
					pTkn++;
				}
			}
			//	Sϐl\
			for (i = 0; i < AJCCIPMAX_IXVMG; i++) {
				if (pW->sFni[i].hVmg != NULL) {
					fprintf(hOut, "----- Level %d Variables --------------\n", i);
					AjcVmgEnumVarA(pW->sFni[i].hVmg, (UX)hOut, cbNtcVar);
				}
			}
			//	t@CN[Y
			fclose(hOut);
			//	ʕ\
			ShellExecuteA(NULL, "open", path, NULL, NULL, SW_SHOWNORMAL);
			//	߂l
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//																												//
//	ʒm擾																								//
//																												//
//==============================================================================================================//
//	hbvfBNg
AJCEXPORT UI			WINAPI AjcCipGetNtcDirs			(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	UI			rc = 0;

	if (pW != NULL) {
		rc = pW->NtcDirs;
	}
	return rc;
}
//	hbvt@C
AJCEXPORT UI			WINAPI AjcCipGetNtcFiles		(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	UI			rc = 0;

	if (pW != NULL) {
		rc = pW->NtcFiles;
	}
	return rc;
}
//	O֐Ăяo
AJCEXPORT PAJCCIPEVPFUN	WINAPI AjcCipGetNtcEvpFun		(HWND hwnd)
{
	HAJCCIP			pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	PAJCCIPEVPFUN	rc = NULL;

	if (pW != NULL) {
		rc = &pW->NtcEvpFun;
	}
	return rc;
}
//	ʒmeLXgiG[bZ[WC_uNbNsj
AJCEXPORT BCP			WINAPI AjcCipGetNtcText			(HWND hwnd)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	BCP			rc = NULL;

	if (pW != NULL) {
		rc = pW->NtcTxt;
	}
	return rc;
}

