#include	"AjcInternal.h"
#include	"AjcCipCommon.h"

//**************************************************************************************************************//
//																												//
//	bꕗC^v^i̕]j																		//
//																												//
//**************************************************************************************************************//

#define	MAX_NEST	32				//	őlXg

#define	ISLV01(TKN)	((TKN) == EAJCTK_DLM_MULT || (TKN) == EAJCTK_DLM_DIV || (TKN) == EAJCTK_DLM_MOD)								/*	*	/	%		*/
#define	ISLV02(TKN)	((TKN) == EAJCTK_DLM_PLUS || (TKN) == EAJCTK_DLM_MINUS)															/*	+	-			*/
#define	ISLV03(TKN)	((TKN) == EAJCTK_DLM_SHL  || (TKN) == EAJCTK_DLM_SHR  )															/*	<<	>>			*/
#define	ISLV04(TKN)	((TKN) == EAJCTK_DLM_LO   || (TKN) == EAJCTK_DLM_HI || (TKN) == EAJCTK_DLM_LOEQ || (TKN) == EAJCTK_DLM_HIEQ)	/*	<	>	<=	>=	*/
#define	ISLV05(TKN)	((TKN) == EAJCTK_DLM_EQEQ || (TKN) == EAJCTK_DLM_NOTEQ)															/*	==	!=			*/
#define	ISLV06(TKN)	((TKN) == EAJCTK_DLM_AND )																						/*	&				*/
#define	ISLV07(TKN)	((TKN) == EAJCTK_DLM_XOR )																						/*	^				*/
#define	ISLV08(TKN)	((TKN) == EAJCTK_DLM_OR  )																						/*	|				*/
#define	ISLV09(TKN)	((TKN) == EAJCTK_DLM_LAND)																						/*	&&				*/
#define	ISLV10(TKN)	((TKN) == EAJCTK_DLM_LOR )																						/*	||				*/
#define	ISLV11(TKN)	((TKN) == EAJCTK_DLM_QUEST)																						/*	? (? exp : exp)	*/
#define	ISLV12(TKN) ((TKN) == EAJCTK_DLM_EQ 	|| (TKN) == EAJCTK_DLM_PLUSEQ || (TKN) == EAJCTK_DLM_MINUSEQ || \
					 (TKN) == EAJCTK_DLM_MULTEQ || (TKN) == EAJCTK_DLM_DIVEQ  || (TKN) == EAJCTK_DLM_MODEQ	 || \
					 (TKN) == EAJCTK_DLM_ANDEQ	|| (TKN) == EAJCTK_DLM_OREQ   || (TKN) == EAJCTK_DLM_XOREQ	 || \
					 (TKN) == EAJCTK_DLM_SHREQ	|| (TKN) == EAJCTK_DLM_SHLEQ)

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Z^Cv																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
typedef		SLL		TCALC;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	̕]p[J[N																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	UI			FmlNestCnt;					//	lXgJE^
	BOOL		fFmlCalc;					//	vZtOiCALCULATION(=TRUE ) : vZC
											//			   (SYNTAX_ONLY(=FALSE) : ̃V^bNX`FbN̂݁j
	HAJCFQUE	hFmlLsPart;					//	OPARTiAJCCIPLSPART̃L[j
} LWORK, *PLWORK;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Tu֐																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC		express		(HAJCCIP pW, PLWORK pL);
static	TCALC		expresses	(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl12		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl12s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl11		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl11s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl10		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl10s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl09		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl09s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl08		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl08s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl07		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl07s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl06		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl06s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl05		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl05s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl04		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl04s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl03		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl03s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl02		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl02s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		Lvl01		(HAJCCIP pW, PLWORK pL);
static	TCALC		Lvl01s		(HAJCCIP pW, PLWORK pL, TCALC n);
static	TCALC		part		(HAJCCIP pW, PLWORK pL);

static	BOOL	SetVarVal(HAJCCIP pW, PLWORK pL, HAJCVMGA hVmg, BCP pName, UI ix, TCALC n);

//==============================================================================================================//
//	̕]ij																							//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				pVal		 - ̕]li[obt@̃AhX											//
//				fCalculation - vZtO - CALCULATION(=TRUE)	: vZ										//
//											SYNTAX_ONLY(=FALSE) : ̃V^bNX`FbN̂					//
//																												//
//	߂l	F	TRUE F																						//
//				FALSEFs																						//
//																												//
//	@l	F	pW->pCur - ͎F̐擪g[N																//
//						   IF̒̃g[NiG[̏ꍇ́A̓r̃g[Nj						//
//==============================================================================================================//
BOOL	CipFmlINT(HAJCCIP pW, TCALC *pVal, BOOL fCalculation)
{
	TCALC		n;
	LWORK		lw;

	//	OPARTL[
	if (lw.hFmlLsPart = AjcFQueCreate(sizeof(AJCCIPLSPART), 0, NULL)) {

		//----- ϐ ---------------------------------//
		lw.FmlNestCnt	= 0;					//	lXgJE^
		lw.fFmlCalc		= fCalculation;			//	vZtO
		//----- ̍Ō̌ -----------------------------//
		pW->pFml		= pW->pCur;

		//----- Zs -----------------------------------//
		n = express(pW, &lw);

		//----- Zʊi[ -------------------------------//
		if (pVal != NULL) *pVal = n;

		//----- L[ ---------------------------------//
		AjcFQueDelete(lw.hFmlLsPart);
	}
	else {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno, 
							LNGSEL("Z]p̃[Nmۂł܂B",
								   "Work of formula allocation failure."));
	}
	return (pW->ErrCod == AJCIP_ERR_OK);
}
//--------------------------------------------------------------------------------------------------------------//
//	E X P R E S S																								//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	express(HAJCCIP pW, PLWORK pL)
{
	TCALC		n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		if (pL->FmlNestCnt < MAX_NEST) {
			pL->FmlNestCnt++;
			n = expresses(pW, pL, Lvl12(pW, pL));
			pL->FmlNestCnt--;
		}
		else {
			pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno, 
								LNGSEL("Z̃lXg[܂B",
									   "A nest of an arithmetic expression is too deep."));
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	E X P R E S S E S																							//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	expresses(HAJCCIP pW, PLWORK pL, TCALC n)
{
	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV12(pW->pCur->tkn)) {
		n = express(pW, pL);
	}
	return (pL->fFmlCalc ? n : 1);
}

//--------------------------------------------------------------------------------------------------------------//
//	Lvl12	(	=  +=  -=  *=  /=  %=  &=  |=  ^=  >>=	<<=	)													//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl12(HAJCCIP pW, PLWORK pL)
{
	TCALC		n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl12s(pW, pL, Lvl11(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl12s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl12s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;
	TCALC		m;
	AJCCIPLSPART LsPart;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV12(s = pW->pCur->tkn)) {
		if (AjcFQueDeque(pL->hFmlLsPart, (VOP)&LsPart) && LsPart.fLsVar) {	//	O͕ϐ
			//	̌|C^ݒ聕dne`FbN
			if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
			//	]Z
			m = Lvl11(pW, pL);
			if (!((s == EAJCTK_DLM_DIVEQ || s == EAJCTK_DLM_MODEQ) && m == 0)) {
				if (pW->fSigned) {
					switch (s) {
						case EAJCTK_DLM_EQ:		 n	 = m; break;		//	u	 = v
						case EAJCTK_DLM_PLUSEQ:	 n	+= m; break;		//	u	+= v
						case EAJCTK_DLM_MINUSEQ: n	-= m; break;		//	u	-= v
						case EAJCTK_DLM_MULTEQ:	 n	*= m; break;		//	u	*= v
						case EAJCTK_DLM_DIVEQ:	 n	/= m; break;		//	u	/= v
						case EAJCTK_DLM_MODEQ:	 n	%= m; break;		//	u	%= v
						case EAJCTK_DLM_ANDEQ:	 n	&= m; break;		//	u	&= v
						case EAJCTK_DLM_OREQ:	 n	|= m; break;		//	u	|= v
						case EAJCTK_DLM_XOREQ:	 n	^= m; break;		//	u	^= v
						case EAJCTK_DLM_SHREQ:	 n >>= m; break;		//	u >>= v
						case EAJCTK_DLM_SHLEQ:	 n <<= m; break;		//	u <<= v
					}
				}
				else {
					ULL		un = (ULL)n;
					ULL		um = (ULL)m;
					switch (s) {
						case EAJCTK_DLM_EQ:		 un   = um; break;		//	u	 = v
						case EAJCTK_DLM_PLUSEQ:	 un  += um; break;		//	u	+= v
						case EAJCTK_DLM_MINUSEQ: un  -= um; break;		//	u	-= v
						case EAJCTK_DLM_MULTEQ:	 un  *= um; break;		//	u	*= v
						case EAJCTK_DLM_DIVEQ:	 un  /= um; break;		//	u	/= v
						case EAJCTK_DLM_MODEQ:	 un  %= um; break;		//	u	%= v
						case EAJCTK_DLM_ANDEQ:	 un  &= um; break;		//	u	&= v
						case EAJCTK_DLM_OREQ:	 un  |= um; break;		//	u	|= v
						case EAJCTK_DLM_XOREQ:	 un  ^= um; break;		//	u	^= v
						case EAJCTK_DLM_SHREQ:	 un >>= um; break;		//	u >>= v
						case EAJCTK_DLM_SHLEQ:	 un <<= um; break;		//	u <<= v
					}
					n = (SLL)un;
				}
				//	ϐlݒ
				SetVarVal(pW, pL, LsPart.vLs.hVmg, LsPart.vLs.pSym, LsPart.vLs.ix, n);	//	CALCULATION̂ݕϐݒ
			}
			else {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno, 
									LNGSEL("[Z܂B",
										   "Division by zero."));
			}
		}
		else {							//	O͕ϐȊOH
			pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno, 
								LNGSEL("(%s)ϐȊOłB",
									   "A left side(%s) is not variable."), CipGsrTknStr(CipGsrGetBeforeToken(pW, pW->pCur)));
		}
	}
	return (pL->fFmlCalc ? n : 1);
}

//--------------------------------------------------------------------------------------------------------------//
//	Lvl11	(	?  :	)																						//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl11(HAJCCIP pW, PLWORK pL)
{
	TCALC		n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl11s(pW, pL, Lvl10(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl11s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl11s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	while (pW->ErrCod == AJCIP_ERR_OK  &&  pW->pCur->tkn == EAJCTK_DLM_QUEST) {		// u ? v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	^
		if (n) {
			//	u^v̏ʃxZ
			n = express(pW, pL);
			if (pW->ErrCod) break;
			//	u:vȂΏʃxZ
			if (pW->pCur->tkn == EAJCTK_DLM_COLON) {
				//	̌|C^ݒ聕dne`FbN
				if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
				//	uUṽ_~[Z
				express(pW, pL);
			}
			//	u:vȊOȂ΃G[
			else {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno, 
									LNGSEL("<%s> ̑OɃR(:)KvłB",
										   "Need ':' before <%s>"), CipGsrTknStr(pW->pCur));
			}
		}
		//	U
		else {
			//	u^ṽ_~[Z
			express(pW, pL);
			if (pW->ErrCod) break;
			//	u:vȂΏʃxZ
			if (pW->pCur->tkn == EAJCTK_DLM_COLON) {
				//	̌|C^ݒ聕dne`FbN
				if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
				//	uUv̉Z
				n = express(pW, pL);
			}
			//	u:vȊOȂ΃G[
			else {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno, 
									LNGSEL("<%s> ̑OɃR(:)KvłB",
										   "Need ':' before <%s>"), CipGsrTknStr(pW->pCur));
			}
		}
	}

	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl10	(	||	)																							//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl10(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl10s(pW, pL, Lvl09(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl10s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl10s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;
	TCALC		x;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV10(s = pW->pCur->tkn)) {		//	u || v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	WJ_au||v
		if (s == EAJCTK_DLM_LOR) {
			x = Lvl09(pW, pL);
			n = (n || x);
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl09	(	&&	)																							//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl09(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl09s(pW, pL, Lvl08(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl09s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl09s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;
	TCALC		x;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV09(s = pW->pCur->tkn)) {		//	u && v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	WJ_ρu&&v
		if (s == EAJCTK_DLM_LAND) {
			x = Lvl08(pW, pL);
			n = (n && x);
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl08	(	|	)																							//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl08(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl08s(pW, pL, Lvl07(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl08s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl08s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV08(s = pW->pCur->tkn)) {		//	u | v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	_au | v
		if (s == EAJCTK_DLM_OR) {
			n = (n | Lvl07(pW, pL));
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl07	(	^	)																							//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl07(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl07s(pW, pL, Lvl06(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl07s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl07s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV07(s = pW->pCur->tkn)) {		//	u ^ v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	r_au ^ v
		if (s == EAJCTK_DLM_XOR) {
			n = (n ^ Lvl06(pW, pL));
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl06	(	&	)																							//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl06(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl06s(pW, pL, Lvl05(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl06s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl06s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV06(s = pW->pCur->tkn)) {		//	u & v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	_ρu&v
		if (s == EAJCTK_DLM_AND) {
			n = (n & Lvl05(pW, pL));
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl05	(	==	!=	)																						//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl05(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl05s(pW, pL, Lvl04(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl05s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl05s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV05(s = pW->pCur->tkn)) {		//	u ==  != v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	rZu==, !=v
		switch (s) {
			case EAJCTK_DLM_EQEQ:	n = (n == Lvl04(pW, pL)); break;		//	u == v
			case EAJCTK_DLM_NOTEQ:	n = (n != Lvl04(pW, pL)); break;		//	u != v
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl04	(	<	>	<=	>=	)																				//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl04(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl04s(pW, pL, Lvl03(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl04s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl04s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV04(s = pW->pCur->tkn)) {		//	u <   >   <=  >= v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	召rZu<   >   <=  >=v
		if (pW->fSigned) {
			switch (s) {
				case EAJCTK_DLM_LO:		n = (TCALC)((SLL)n <  (SLL)Lvl03(pW, pL)); break;	//	u <  v
				case EAJCTK_DLM_HI:		n = (TCALC)((SLL)n >  (SLL)Lvl03(pW, pL)); break;	//	u >  v
				case EAJCTK_DLM_LOEQ:	n = (TCALC)((SLL)n <= (SLL)Lvl03(pW, pL)); break;	//	u <= v
				case EAJCTK_DLM_HIEQ:	n = (TCALC)((SLL)n >= (SLL)Lvl03(pW, pL)); break;	//	u >= v
			}
		}
		else {
			switch (s) {
				case EAJCTK_DLM_LO:		n = (TCALC)((ULL)n <  (ULL)Lvl03(pW, pL)); break;	//	u <  v
				case EAJCTK_DLM_HI:		n = (TCALC)((ULL)n >  (ULL)Lvl03(pW, pL)); break;	//	u >  v
				case EAJCTK_DLM_LOEQ:	n = (TCALC)((ULL)n <= (ULL)Lvl03(pW, pL)); break;	//	u <= v
				case EAJCTK_DLM_HIEQ:	n = (TCALC)((ULL)n >= (ULL)Lvl03(pW, pL)); break;	//	u >= v
			}
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl03	(	<<	>>	)																						//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl03(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl03s(pW, pL, Lvl02(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl03s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl03s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV03(s = pW->pCur->tkn)) {		//	u <<  >> v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	VtgZu<<	>>v
		if (pW->fSigned) {
			switch (s) {
				case EAJCTK_DLM_SHL:	n = (TCALC)((SLL)n << (SLL)Lvl02(pW, pL)); break;	//	u << v
				case EAJCTK_DLM_SHR:	n = (TCALC)((SLL)n >> (SLL)Lvl02(pW, pL)); break;	//	u >> v
			}
		}
		else {
			switch (s) {
				case EAJCTK_DLM_SHL:	n = (TCALC)((ULL)n << (ULL)Lvl02(pW, pL)); break;	//	u << v
				case EAJCTK_DLM_SHR:	n = (TCALC)((ULL)n >> (ULL)Lvl02(pW, pL)); break;	//	u >> v
			}
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl02	(	+	-	)																						//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl02(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl02s(pW, pL, Lvl01(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl02s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl02s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV02(s = pW->pCur->tkn)) {		//	u +   - v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	Zu+  -v
		switch (s) {
			case EAJCTK_DLM_PLUS:	n = (n + Lvl01(pW, pL)); break;	//	u + v
			case EAJCTK_DLM_MINUS:	n = (n - Lvl01(pW, pL)); break;	//	u - v
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl01	(	*	/	% 	)																					//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl01(HAJCCIP pW, PLWORK pL)
{
	TCALC	n = 0;

	if (pW->ErrCod == AJCIP_ERR_OK) {
		n = Lvl01s(pW, pL, part(pW, pL));
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl01s																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	Lvl01s(HAJCCIP pW, PLWORK pL, TCALC n)
{
	EAJCTKCODE	s;
	TCALC		p;

	while (pW->ErrCod == AJCIP_ERR_OK  &&  ISLV01(s = pW->pCur->tkn)) {		//	u *   /   % v
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) == EAJCTK_EOF) break;
		//	Zp[ci萔ϐlj擾
		p = part(pW, pL);
		//	ZxZu * / % v
		switch (s) {
			case EAJCTK_DLM_MULT:	if (pW->fSigned) n = (TCALC)((SLL)n * (SLL)p);
									else			 n = (TCALC)((ULL)n * (ULL)p);
									break;

			case EAJCTK_DLM_DIV:	if (p) {
										if (pW->fSigned) n = (TCALC)((SLL)n / (SLL)p);
										else			 n = (TCALC)((ULL)n / (ULL)p);
									}
									else {
										pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno, 
															LNGSEL("[Z܂B",
																   "Division by zero."));
									}
									break;

			case EAJCTK_DLM_MOD:	if (p) {
										if (pW->fSigned) n = (TCALC)((SLL)n % (SLL)p);
										else			 n = (TCALC)((ULL)n % (ULL)p);
									}
									else {
										pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno, 
															LNGSEL("[Z܂B",
																   "Division by zero."));
									}
									break;
		}
	}
	return (pL->fFmlCalc ? n : 1);
}
//--------------------------------------------------------------------------------------------------------------//
//	P A R T																										//
//--------------------------------------------------------------------------------------------------------------//
static	TCALC	part(HAJCCIP pW, PLWORK pL)
{
	TCALC		n	 = 0;				//	߂lilj
	PAJCCIPTKN	pNxt = pW->pCur + 1;	//	P̃g[N
	AJCCIPLSPART LsPart;				//	ŏIPART

	//	ǑQϐł邱ƂtO NA[
	memset(&LsPart, 0, sizeof LsPart);

	if (pW->ErrCod == AJCIP_ERR_OK) {	//	G[H

		//	JbR
		if		(pW->pCur->tkn == EAJCTK_DLM_LSPART) {
			//	̌|C^ݒ聕dne`FbN
			if (CipFmlSkipToken(pW) != EAJCTK_EOF) {			// EOFȊOH
				//	Zs
				n = express(pW, pL);
				if (pW->ErrCod == AJCIP_ERR_OK) {				// G[ȂH
					//	Ž傪EʂȂ΃XLbv
					if (pW->pCur->tkn == EAJCTK_DLM_RSPART) {
						//	̌|C^ݒi ')' XLbvj
						pW->pFml = pW->pCur++;
					}
					//	Ž傪EʈȊOȂ΃G[
					else {
						pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno,
											LNGSEL("̕\Ɍ肪܂B<%s>",
												   "Invalid formula expression <%s>."), CipGsrTknStr(pW->pCur));
					}
				}
			}
		}

		//	PZqi+-~!j
		else if (pW->pCur->tkn == EAJCTK_DLM_PLUS	||		//	+
				 pW->pCur->tkn == EAJCTK_DLM_MINUS	||		//	-
				 pW->pCur->tkn == EAJCTK_DLM_NOT	||		//	~
				 pW->pCur->tkn == EAJCTK_DLM_LNOT) {		//	!
			//	g[Nޔ
			EAJCTKCODE	s = pW->pCur->tkn;
			//	̌|C^ݒ聕dne`FbN
			if (CipFmlSkipToken(pW) != EAJCTK_EOF) {		// EOFȊOH
				//	Zp[ci萔ϐlj擾
				n = part(pW, pL);
				if (pW->ErrCod == AJCIP_ERR_OK) {			// upartvG[ȂH
					//	PZu-~!v
					switch (s) {
						case EAJCTK_DLM_MINUS:	n = ~n + 1;	break;
						case EAJCTK_DLM_NOT:	n = ~n;		break;
						case EAJCTK_DLM_LNOT:	n = !n;		break;
					}
				}
			}
		}

		//	萔ij
		else if (pW->pCur->tkn == EAJCTK_CIP_INTEGER) {
			//	萔lݒ
			n = (TCALC)pW->pCur->u.val;
			//	̌|C^ݒi萔XLbvj
			pW->pFml = pW->pCur++;
		}

		//	萔ij
		else if (pW->pCur->tkn == EAJCTK_CIP_REAL) {
			//	萔lݒ
			n = (TCALC)pW->pCur->u.dbl;
			//	̌|C^ݒi萔XLbvj
			pW->pFml = pW->pCur++;
		}

		//	{{[U`ivECNgj
		else if (pW->pCur->tkn == EAJCTK_DLM_PLUS2	&& IS_NUM_SYM(pNxt)) {
			pW->pFml = pW->pCur++;										//	'++' XLbv
			n = CipFmlGetVarInfoInt64(pW, &LsPart.vLs, pL->fFmlCalc);	//	ϐl擾
			//	ϐlCNgi߂lCNglj
			if (pW->ErrCod == AJCIP_ERR_OK) {
				n++;
				SetVarVal(pW, pL, LsPart.vLs.hVmg, LsPart.vLs.pSym, LsPart.vLs.ix, n);	//	CALCULATION̂ݕϐݒ
			}
		}

		//	||[U`ivEfNgj
		else if (pW->pCur->tkn == EAJCTK_DLM_MINUS2 && IS_NUM_SYM(pNxt)) {
			pW->pFml = pW->pCur++;										//	'--' XLbv
			n = CipFmlGetVarInfoInt64(pW, &LsPart.vLs, pL->fFmlCalc);	//	ϐl擾
			//	ϐlfNgi߂lfNglj
			if (pW->ErrCod == AJCIP_ERR_OK) {
				n--;
				SetVarVal(pW, pL, LsPart.vLs.hVmg, LsPart.vLs.pSym, LsPart.vLs.ix, n);	//	CALCULATION̂ݕϐݒ
			}
		}

		//	[U`iEEj--- ֐
		else if (IS_NUM_SYM(pW->pCur) && pNxt->tkn == EAJCTK_DLM_LSPART) { // 'Sym(' H
			AJCCIPVARINFO	vInf;
			vInf.hVmg = pW->sFni[0].hVmg;
			vInf.pSym = "@rc";
			vInf.ix   = 0;
			AjcVmgSetIntegerA(vInf.hVmg, "@rc", 0, 0);
			if (CipFmlCallFunc(pW, &vInf, pL->fFmlCalc)) {
				AjcVmgGetInt64A(vInf.hVmg, "@rc", 0, &n);
			}
		}
		//	[U`ilϐj
		else if (IS_NUM_SYM(pW->pCur)) {
			//	ϐl擾
			n = CipFmlGetVarInfoInt64(pW, &LsPart.vLs, pL->fFmlCalc);
			if (pW->ErrCod == AJCIP_ERR_OK) {
				//	 'ϐ{{'i|XgECNgj
				if		(pW->pCur->tkn == EAJCTK_DLM_PLUS2) {
					pW->pFml = pW->pCur++;		//	'++' XLbv
					//	ϐlCNgi߂l̓CNgO̒lj
					SetVarVal(pW, pL, LsPart.vLs.hVmg, LsPart.vLs.pSym, LsPart.vLs.ix, n + 1);	//	CALCULATION̂ݕϐݒ
				}
				//	 'ϐ||'i|XgEfNgj
				else if (pW->pCur->tkn == EAJCTK_DLM_MINUS2) {
					pW->pFml = pW->pCur++;		//	'--' XLbv
					//	ϐlfNgi߂l̓fNgO̒lj
					SetVarVal(pW, pL, LsPart.vLs.hVmg, LsPart.vLs.pSym, LsPart.vLs.ix, n - 1);	//	CALCULATION̂ݕϐݒ
				}
				//	 ϐ̂
				else {
					//	ǑQϐł邱ƂtOݒ
					LsPart.fLsVar = TRUE;
				}
			}
		}
		//	ϐ^
		else if (IS_STR_SYM(pW->pCur) || pW->pCur->tkn == EAJCTK_CIP_STRING) {
			SLL	cond;
			CipFmlStr(pW, &cond, pL->fFmlCalc);
			n = (TCALC)cond;
		}
		//	̑iG[j
		else {
			pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno,
								LNGSEL("̕\Ɍ肪܂B<%s>",
									   "Invalid formula expression <%s>."), CipGsrTknStr(pW->pCur));
		}
	}

	//	ŏIPARTݒiŏIPARTϐۂ̏j
	if (!(AjcFQueEnqTop(pL->hFmlLsPart, (C_VOP)&LsPart))) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_CALC, pW->pCur->lno,
							LNGSEL("̕]p̃sĂ܂B",
								   "Insufficient formula expression work."));
	}

	return (pL->fFmlCalc ? n : 1);
}

//--------------------------------------------------------------------------------------------------------------//
//	ϐlݒ																									//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SetVarVal(HAJCCIP pW, PLWORK pL, HAJCVMGA hVmg, BCP pName, UI ix, TCALC n)
{
	BOOL	rc = TRUE;

	if (pL->fFmlCalc) {
		rc = AjcVmgSetIntegerA(hVmg, pName, ix, n);
	}
	return rc;
}
