#include	"AjcInternal.h"
#include	"AjcCipCommon.h"

//**************************************************************************************************************//
//																												//
//	bꕗC^v^ig[X\j																		//
//																												//
//**************************************************************************************************************//

#define		MYSECT		CIP_TRC_SECT

#define		MAX_TXTLEN	512

//--------------------------------------------------------------------------------------------------------------//
//	Ɨ̈																									//
//--------------------------------------------------------------------------------------------------------------//
static	ATOM	ClassTrcBack = 0;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC_DEF(TrcBack);
AJC_DLGPROC_DEF(TrcDlg);

static	VO		ShowStepAndLineNo(HAJCCIP pW, UI lno);
static	VO		DisClose(HAJCCIP pW);
static	VO		EnaClose(HAJCCIP pW);

//==============================================================================================================//
//	Nݒ																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
BOOL	CipTrcInit(VO)
{
	BOOL		rc = TRUE;
	WNDCLASSA	wndclass;

	//	g[XpobNEChNX
	wndclass.style			= 0;
	wndclass.lpfnWndProc	= AJC_WNDPROC_NAME(TrcBack);
	wndclass.cbClsExtra 	= 0;
	wndclass.cbWndExtra 	= (sizeof(UX));
	wndclass.hInstance		= hDllInst;
	wndclass.hIcon			= NULL;
	wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	= hBruBtnFace;
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= "CAjaMacroTrace";
	ClassTrcBack = RegisterClassA(&wndclass);
	if (ClassTrcBack == 0) {
		rc = FALSE;
	}

	return rc;
}
//==============================================================================================================//
//	I㏈																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
VO		CipTrcEnd(VO)
{
	//	g[XpobNEChNXj
	if (ClassTrcBack != 0) {
		UnregisterClassA((BCP)ClassTrcBack, hDllInst);
		ClassTrcBack = 0;
	}
}
//==============================================================================================================//
//	Sϐ\																									//
//																												//
//	@	F	pW			- CX^Xnh																//
//				MaxArrNum	- z̍ő\ڐ																//
//				fDumpAll	- VXeϐ܂߂Sϐ\tO											//
//				lno			- sԍ																			//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
typedef struct {
	HAJCCIP		pW;
	UI			MaxArrNum;
	BOOL		fDumpAll;
} VARDMPPRM, *PVARDMPPRM;
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbDvNtcVar(PCAJCVMGNODEA pVarInfo, UX cbp)
{
	PVARDMPPRM	pCbp	  = (PVARDMPPRM)cbp;
	HAJCCIP 	pW		  = pCbp->pW;
	UI			MaxArrNum = pCbp->MaxArrNum;
	UI			i, n;
	UBP			p;

	n = __min(pVarInfo->num, MaxArrNum);
	for (i = 0; i < pVarInfo->num; i++) {
		if ((!mbsstr(pVarInfo->pName, "@") && !(pVarInfo->att & AJCVMGA_RDONLY))  ||  pCbp->fDumpAll) {
			UI	stl = (UI)strlen(pVarInfo->pName);
			if (pVarInfo->num == 1) {
				AjcVthPrintFA(pW->hTrcVth, "%s = ", pVarInfo->pName);
			}
			else {
				if (i == 0) AjcVthPrintFA(pW->hTrcVth, "%s[%2d] = ", pVarInfo->pName, i);
				else		AjcVthPrintFA(pW->hTrcVth, "%*c[%2d] = ", stl, ' ', i);
			}
			switch (pVarInfo->type) {
				case AJCVMGT_INT:	AjcVthPrintFA(pW->hTrcVth, "%d"	, pVarInfo->arr.pSI [i]);	break;
				case AJCVMGT_LONG:	AjcVthPrintFA(pW->hTrcVth, "%lld", pVarInfo->arr.pSLL[i]);	break;
				case AJCVMGT_REAL:	AjcVthPrintFA(pW->hTrcVth, "%f"	, pVarInfo->arr.pDBL[i]);	break;
				case AJCVMGT_STR:
					AjcVthPrintFA(pW->hTrcVth, "\"");
					for (p = (UBP)pVarInfo->arr.pStr[i]; *p != 0; p++) {
						if (*p < 0x20) AjcVthPrintFA(pW->hTrcVth, "\\x%02x", *p);
						else		   AjcVthPrintFA(pW->hTrcVth, "%c"	 , *p);
					}
					AjcVthPrintFA(pW->hTrcVth, "\"");
					break;
			}
			AjcVthPrintFA(pW->hTrcVth, "\n");
		}
		CipGsrDoEvent(pW);
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
VO		CipTrcVarDump(HAJCCIP pW, UI MaxArrNum, UI lno, BOOL fDumpAll)
{
	int			i, stl;

	BC			txt[1024];
	VARDMPPRM	cbp;

	//	EChN[Y֎~
	DisClose(pW);

	if (pW->hTrcBack != NULL) {
		//	XebvԍCsԍ\
		ShowStepAndLineNo(pW, lno);

		//	Sϐl\
		for (i = 0; i < AJCCIPMAX_IXVMG; i++) {
			if (pW->sFni[i].hVmg != NULL) {
				AjcSnPrintFA(txt, sizeof txt, "---------- Level %d, %s  Variables ", i,	(i == 0) ? "Global" : pW->sFni[i].CInf.pFunName);
				stl = (int)strlen(txt);
				if (stl < 80) {
					memset(&txt[stl], '-', 80 - stl);
					txt[80] = 0;
				}
				AjcVthPrintFA(pW->hTrcVth, "%s\n", txt);
				cbp.pW		  = pW;
				cbp.MaxArrNum = (UI)MaxArrNum;
				cbp.fDumpAll  = fDumpAll;
				AjcVmgEnumVarA(pW->sFni[i].hVmg, (UX)&cbp, cbDvNtcVar);
				CipGsrDoEvent(pW);
			}
		}
	}
	//	EChN[Y
	EnaClose(pW);
}
//==============================================================================================================//
//	eLXg\																								//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pText		- \eLXg																		//
//				lno			- sԍ																			//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
VO		CipTrcPutText(HAJCCIP pW, C_BCP pText, UI lno)
{
	//	EChN[Y֎~
	DisClose(pW);

	if (pW->hTrcBack == NULL) {
		CipTrcCreateWindow(pW);
	}

	if (pW->hTrcBack != NULL) {
		//	XebvԍCsԍ\
		ShowStepAndLineNo(pW, lno);
		//	eLXg\
		AjcVthPutTextA(pW->hTrcVth, pText, -1);
		//	Windows Event
		CipGsrDoEvent(pW);
	}
	//	EChN[Y
	EnaClose(pW);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	XebvԍCsԍ\																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowStepAndLineNo(HAJCCIP pW, UI lno)
{
	BOOL	fShowStepNo = AjcGetDlgItemChk(pW->hTrcDlg, IDC_CHK_SHOW_STEP);
	BOOL	fShowLineNo = AjcGetDlgItemChk(pW->hTrcDlg, IDC_CHK_SHOW_LINE);

	//	XebvԍCsԍ\
	if (fShowStepNo || fShowLineNo) {
		AjcVthPrintFA(pW->hTrcVth, "\x1B[31m\n<<< ");
		if (fShowStepNo && fShowLineNo) AjcVthPrintFA(pW->hTrcVth, "Step = %d, Line = %d", pW->ExeStepNo, lno);
		else if (fShowStepNo)			AjcVthPrintFA(pW->hTrcVth, "Step = %d"			, pW->ExeStepNo		);
		else if (fShowLineNo)			AjcVthPrintFA(pW->hTrcVth, "Line = %d"			, 				 lno);
		AjcVthPrintFA(pW->hTrcVth, " >>>\n\x1B[0m");
		CipGsrDoEvent(pW);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	EChN[Y֎~																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	DisClose(HAJCCIP pW)
{
	//	EChN[Y֎~
	pW->fTrcDisClose = TRUE;
	//	N[YtONA[
	pW->fTrcOpeClose = FALSE;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	EChN[Y																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	EnaClose(HAJCCIP pW)
{
	//	EChN[Y
	pW->fTrcDisClose = FALSE;
	//	֎~ԒɃN[Y삪΁AEChj
	if (pW->fTrcOpeClose) {
		pW->fTrcOpeClose = FALSE;
		if (pW->hTrcBack != NULL) {
			DestroyWindow(pW->hTrcBack);
		}
	}
}

//==============================================================================================================//
//	g[XECh																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
#define		IDC_VTH_TRC				5010				//	usgRg[hc
//--------------------------------------------------------------------------------------------------------------//
BOOL	CipTrcCreateWindow(HAJCCIP pW)
{
	BOOL		rc = TRUE;

	do {
		//	g[XpobNECh
		if (pW->hTrcBack == NULL) {
			pW->hTrcBack = CreateWindowA("CAjaMacroTrace",							// window class name
										LNGSEL("g[XECh", "Trace window"), // window caption
										WS_OVERLAPPEDWINDOW,						// window style
										0,											// initial x position
										0,											// initial y position
										500,										// initial x size
										300,										// initial y size
										NULL,										// parent window handle
										NULL,										// window menu handle
										hDllInst,									// program instance handle
										pW);										// creation parameters
			if (pW->hTrcBack == NULL) {
				rc = FALSE;
				break;
			}
			//	ECh\
			ShowWindow(pW->hTrcBack, SW_SHOWNORMAL);
		}
		else {
			ShowWindow(pW->hTrcBack, SW_SHOWNORMAL);
			SetFocus  (pW->hTrcBack);
		}
	} while(0);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	g[X obNEChvV[W																			//
//																												//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(TrcBack, WM_CREATE		)
{
	BOOL			rc = -1;
	LPCREATESTRUCT	p  = (LPCREATESTRUCT)lParam;
	HAJCCIP			pW = (HAJCCIP)p->lpCreateParams;
	RECT			r;
	int				cx, cy;
	BC				txt[512];

	do {
		//	EChEGNXg̈փ[N|C^ݒ
		MAjcSetWindowLong(hwnd, 0, (UX)pW);
		//	EChnhݒ
		pW->hTrcBack = hwnd;
		//	VT-100G~[VERg[
		AjcGetCtrlStrA(pW->hWndBack, txt, sizeof txt);
		strcat(txt, ", ML=10000");
		pW->hTrcVth = CreateWindowExA(0,													// extend style
									 "AjcCtrlVT100",									// window class name
									 txt,												// Caption
									 WS_CHILD | AJCVTHS_LFCTRL,							// style
									 0,													// initial x position
									 0,													// initial y position
									 0,													// initial x size
									 0,													// initial y size
									 hwnd,												// parent window handle
									 (HMENU)IDC_VTH_TRC,								// window menu handle
									 hDllInst,											// program instance handle
									 NULL);												// creation parameters
		if (pW->hTrcVth == NULL) {
			break;
		}
		ShowWindow(pW->hTrcVth, SW_SHOW);

		//	ACRݒ
		SendMessage(hwnd, WM_SETICON, ICON_SMALL, (LPARAM)hIcoApp);

		//	_CAO
		pW->hTrcDlg = CreateDialogParam(hDllInst, MAKEINTRESOURCE(IDD_CIPTRACE), pW->hTrcBack, AJC_DLGPROC_NAME(TrcDlg), (LPARAM)pW);
		if (pW->hTrcDlg == NULL) {
			DestroyWindow(pW->hTrcVth);
			pW->hTrcVth = NULL;
			break;
		}
		ShowWindow(pW->hTrcDlg, SW_SHOW);
		//	EChŏTCYݒ
		r.left = r.top = 0;
		r.right  = pW->szTrcDlg.cx;
		r.bottom = pW->szTrcDlg.cy + 100;
		AdjustWindowRect(&r, WS_OVERLAPPEDWINDOW, FALSE);
		pW->szTrcWnd.cx = r.right - r.left;
		pW->szTrcWnd.cy = r.bottom - r.top;
		//	EChTCY[h
		AjcLoadWndRectA(hwnd, MYSECT);
		//	EChŏTCYm
		GetWindowRect(hwnd, &r);
		cx = r.right - r.left;
		cy = r.bottom - r.top;
		if (cx < pW->szTrcWnd.cx || cy < pW->szTrcWnd.cy) {
			cx = __max(cx, pW->szTrcWnd.cx);
			cy = __max(cy, pW->szTrcWnd.cy);
			SetWindowPos(pW->hTrcBack, NULL, 0, 0, cx, cy, SWP_NOMOVE);
		}
		//	usgݒ񃍁[h
		AjcVthLoadPropA(pW->hTrcVth, MYSECT, NULL);
		//	߂lnj
		rc = 0;
	} while(0);

	return rc;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_WNDPROC(TrcBack, WM_DESTROY	)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);

	//	EChTCYZ[u
	AjcSaveWndRectA(hwnd, MYSECT);
	//	usgݒZ[u
	AjcVthSavePropA(pW->hTrcVth, MYSECT);

	//	qEChN[Y
	if (pW->hTrcVth != NULL) {DestroyWindow(pW->hTrcVth); pW->hTrcVth = NULL;}
	if (pW->hTrcDlg != NULL) {DestroyWindow(pW->hTrcDlg); pW->hTrcDlg = NULL;}
	pW->hTrcBack = NULL;

	return 0;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_WNDPROC(TrcBack, WM_CLOSE		)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);

	if (!pW->fTrcDisClose) {
		DestroyWindow(hwnd);
	}

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(TrcBack, WM_SIZING		)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	LPRECT		p = (LPRECT)lParam;
	int			w = p->right - p->left;
	int			h = p->bottom - p->top;

	if (w < pW->szTrcWnd.cx) p->right  = p->left + (pW->szTrcWnd.cx);
	if (h < pW->szTrcWnd.cy) p->bottom = p->top  + (pW->szTrcWnd.cy);

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(TrcBack, WM_SIZE		)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	int			cx = LOWORD(lParam);
	int			cy = HIWORD(lParam);

	//	_CAOEChݒ
	MoveWindow(pW->hTrcDlg, 0, 0			  , cx, 	 pW->szTrcDlg.cy, TRUE);
	//	VTHEChTCYݒ
	MoveWindow(pW->hTrcVth, 0, pW->szTrcDlg.cy, cx, cy - pW->szTrcDlg.cy, TRUE);

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(TrcBack)
	AJC_WNDMAP_MSG(TrcBack, WM_CREATE		)
	AJC_WNDMAP_MSG(TrcBack, WM_DESTROY		)
	AJC_WNDMAP_MSG(TrcBack, WM_CLOSE		)
	AJC_WNDMAP_MSG(TrcBack, WM_SIZING		)
	AJC_WNDMAP_MSG(TrcBack, WM_SIZE			)
AJC_WNDMAP_END
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	g[X _CAOvV[W																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
#define		DLGPROP		"TrcDlg"
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(TrcDlg, WM_INITDIALOG 	)
{
	HAJCCIP		pW = (HAJCCIP)lParam;
	RECT		r;

	pW->hTrcDlg = hDlg;
	SetPropA(hDlg, DLGPROP, (HANDLE)pW);

	//	peLXg
	SetWindowTextA	(pW->hTrcBack, LNGSEL("g[Xo", "Trace output"));
	AjcSetDlgItemStrA(hDlg, IDC_LBL_SHOW		, LNGSEL("_Trace() ɂ\o : "		, "Display output by _Trace() : "));
	AjcSetDlgItemStrA(hDlg, IDC_CHK_SHOW_STEP, LNGSEL("_Ci~bNEXebvԍ\", "Show dynamic step number"	));
	AjcSetDlgItemStrA(hDlg, IDC_CHK_SHOW_LINE, LNGSEL("sԍ\"					, "Show line number"			));

	AjcSetDlgItemStrA(hDlg, IDC_GRP_SHOWVAR	, LNGSEL("ϐ̕\"							, "Show variable value"			));
	AjcSetDlgItemStrA(hDlg, IDC_LBL_SHOWVAR	, LNGSEL("ϐ"								, "Variable name"				));
	AjcSetDlgItemStrA(hDlg, IDC_LBL_ARRMAX	, LNGSEL("z̍ő\ڐ"					, "Max. display number of array items"));
	AjcSetDlgItemStrA(hDlg, IDC_CMD_SHOW		, LNGSEL("ϐl \"						, "Show"						));

	AjcSetDlgItemStrA(hDlg, IDC_GRP_SETVAR	, LNGSEL("ϐ̐ݒ"							, "Set value to variable"		));
	AjcSetDlgItemStrA(hDlg, IDC_LBL_SETVAR	, LNGSEL("ϐ"								, "Variable name"				));
	AjcSetDlgItemStrA(hDlg, IDC_LBL_SETVAL	, LNGSEL("ϐl"								, "Setting value"				));
	AjcSetDlgItemStrA(hDlg, IDC_CMD_SET		, LNGSEL("ϐl ݒ"							, "Set value"					));
	//	_CAÕTCYݒ
	GetWindowRect(hDlg, &r);
	pW->szTrcDlg.cx = r.right - r.left;
	pW->szTrcDlg.cy = r.bottom - r.top;
	//	eLXgiS511oCgj
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SHOWVAR , MAX_TXTLEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SETVAR	, MAX_TXTLEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SETVAL	, MAX_TXTLEN - 1);
	//	_CAOڊ֘At
	MAjcSetDlgPropChk (hDlg, IDC_CHK_SHOW_STEP, FALSE	 , NULL);
	MAjcSetDlgPropChk (hDlg, IDC_CHK_SHOW_LINE, FALSE	 , NULL);
	MAjcSetDlgPropStrA(hDlg, IDC_TXT_SHOWVAR 	 , ""		 , NULL, 0);
	MAjcSetDlgPropUInt(hDlg, IDC_TXT_ARRMAX 	 , 10 , FALSE, NULL);
	MAjcSetDlgPropStrA(hDlg, IDC_TXT_SETVAR 	 , ""		 , NULL, 0);
	MAjcSetDlgPropStrA(hDlg, IDC_TXT_SETVAL 	 , ""		 , NULL, 0);
	//	_CAOݒ荀ڃ[h
	AjcLoadDlgProfilesA(hDlg, MYSECT);

	//	c[`bvERg[
	pW->hTrcTtp = CreateWindowEx(WS_EX_TOPMOST,
									TOOLTIPS_CLASS,
									NULL,
									TTS_ALWAYSTIP,
									CW_USEDEFAULT,
									CW_USEDEFAULT,
									CW_USEDEFAULT,
									CW_USEDEFAULT,
									hDlg, NULL,
									hDllInst, NULL);
	//	c[`bvǉ
	{	TOOLINFOA	ti;
		memset(&ti, 0, sizeof ti);
		ti.cbSize	= sizeof(TOOLINFO);
		ti.hwnd		= hDlg;
		ti.hinst	= hDllInst;
		ti.uFlags	= TTF_IDISHWND | TTF_SUBCLASS;

		ti.lpszText = LNGSEL("\ϐQiw莞́AJ} ( , )ŋ؂j",
							 "Displaying variables(Separate by comma(,) when specifying many variables)");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_SHOWVAR);	SendMessage(pW->hTrcTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL("\ϐiP̕ϐw肵Ăj", "A setting variable");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_SETVAR	);	SendMessage(pW->hTrcTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL("ݒ肷l(̏ꍇ͗[̃_uNI[g( \" )^A|XgtB( ' )͕sv)",
							 "Setting value (Need not both edges of (\") or (') in string)");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_SETVAL	);	SendMessage(pW->hTrcTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);

	}

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(TrcDlg, WM_DESTROY		)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);

	//	_CAOݒlޔ
	AjcSaveDlgProfilesA(hDlg, MYSECT);
	AjcReleaseDlgPropsA(hDlg);
	//	c[`bvj
	if (pW->hTrcTtp != NULL) {DestroyWindow(pW->hTrcTtp); pW->hTrcTtp = NULL;}
	//	vpeBj
	RemovePropA(hDlg, DLGPROP);

	return TRUE;
}
//----- ϐl\{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(TrcDlg, IDC_CMD_SHOW	)
{
	HAJCCIP			pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);
	HAJCVMGA		hVmg  = NULL;			//	VMGnh
	PCAJCVMGNODEA	pNode = NULL;			//	ϐm[h
	UI				nMaxArr;				//	z̍ő\
	BC				DlgTxt[MAX_TXTLEN];		//	ϐQi_CAOwlj

	if (HIWORD(wParam) == BN_CLICKED) {
		//	Fݒ
		AjcVthPutTextA(pW->hTrcVth, "\x1B[34m", -1);
		//	_CAOݒe擾
		nMaxArr = AjcGetDlgItemUInt(pW->hTrcDlg, IDC_TXT_ARRMAX);
		AjcGetDlgItemStrA(hDlg, IDC_TXT_SHOWVAR, DlgTxt, MAX_TXTLEN);
		AjcStrTrimA(DlgTxt, DlgTxt, MAX_TXTLEN);
		//	ϐQ\
		CipGsrShowVariableValue(pW, pW->hTrcVth, DlgTxt, nMaxArr);
		//	F
		AjcVthPutTextA(pW->hTrcVth, "\x1B[0m", -1);
	}
	return TRUE;
}
//----- ϐlݒ{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(TrcDlg, IDC_CMD_SET			)
{
	HAJCCIP			pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);
	HAJCVMGA		hVmg  = NULL;
	PCAJCVMGNODEA	pNode = NULL;			//	ϐm[h
	AJCCIPTRCVAR	va;						//	ϐ͏
	BC				VarExp[MAX_TXTLEN];		//	ϐ\i_CAOwlj

	if (HIWORD(wParam) == BN_CLICKED) {
		//	Fݒ
		AjcVthPutTextA(pW->hTrcVth, "\x1B[35m", -1);
		//	ϐݒ
		AjcGetDlgItemStrA(hDlg, IDC_TXT_SETVAR, VarExp, MAX_TXTLEN);
		AjcStrTrimA(VarExp, VarExp, MAX_TXTLEN);
		//	ϐ
		if (CipGsrAnalVarName(pW, VarExp, &va)) {
			//	ulfCX^X擾
			if ((hVmg = (HAJCVMGA)CipGsrGetVarInst(pW, va.pVarName)) && (pNode = AjcVmgGetNodeA(hVmg, va.pVarName))) {
				//	zCfNXȂ΁Aϐlݒ
				if (va.ixArr < pNode->num) {
					switch (pNode->type) {
						case AJCVMGT_LONG:
						{	SLL		n;
							if (pW->fSigned) n = AjcGetDlgItemSI64(hDlg, IDC_TXT_SETVAL);
							else			 n = AjcGetDlgItemUI64(hDlg, IDC_TXT_SETVAL);
							AjcVmgSetIntegerA(hVmg, va.pVarName, va.ixArr, n);
							if (pW->fSigned) AjcVthPrintFA(pW->hTrcVth, "  %s = %lld\n"	, VarExp, n);
							else			 AjcVthPrintFA(pW->hTrcVth, "  %s = %llu\n"	, VarExp, n);
							break;
						}
						case AJCVMGT_REAL:
						{	double n;
							n = AjcGetDlgItemReal(hDlg, IDC_TXT_SETVAL);
							AjcVmgSetRealA(hVmg, va.pVarName, va.ixArr, n);
							AjcVthPrintFA(pW->hTrcVth, "  %s = %f\n"	, VarExp, n);
							break;
						}
						case AJCVMGT_STR:
						{	BC		str[MAX_TXTLEN];
							AjcGetDlgItemStrA(hDlg, IDC_TXT_SETVAL, str, MAX_TXTLEN);
							AjcVmgSetStringA(hVmg, va.pVarName, va.ixArr, str);
							AjcVthPrintFA(pW->hTrcVth, "  %s = \"%s\"\n", VarExp, str);
							break;
						}
						default:
							AjcVthPrintFA(pW->hTrcVth, "  %s = Invalid type\n"	, VarExp);
							break;
					}
				}
				else AjcVthPrintFA(pW->hTrcVth,"  %s = Index over\n", VarExp);
			}
			else AjcVthPrintFA(pW->hTrcVth, "  %s = Not found\n", VarExp);
		}

		AjcVthPutTextA(pW->hTrcVth, "\x1B[0m", -1);
	}
	return TRUE;
}
//----- LZ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(TrcDlg, IDCANCEL			)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);

	DestroyWindow(hDlg);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(TrcDlg)
	AJC_DLGMAP_MSG(TrcDlg, WM_INITDIALOG	)
	AJC_DLGMAP_MSG(TrcDlg, WM_DESTROY		)

	AJC_DLGMAP_CMD(TrcDlg, IDC_CMD_SHOW		)
	AJC_DLGMAP_CMD(TrcDlg, IDC_CMD_SET		)
	AJC_DLGMAP_CMD(TrcDlg, IDCANCEL			)
AJC_DLGMAP_END


