#include	"AjcInternal.h"
#include	"AjcCipCommon.h"

//**************************************************************************************************************//
//																												//
//	bꕗC^v^iϐǗj																			//
//																												//
//**************************************************************************************************************//

//==============================================================================================================//
//	ϐ̍쐬																									//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//				type		- ϐ̃^Cv																		//
//				num			- z̗vf																		//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
BOOL			CipVmgGenVar	(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName, EAJCCIPTYP type, UI num)
{
	BOOL	rc = TRUE;

	if (AjcVmgGetNodeA(hVmg, pVarName) == NULL) {
		if (!(AjcVmgGenVarA(hVmg, pVarName, (AJCVMGTYPE)type, num))) {
			pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
										  LNGSEL("CipVmgGenVar: ϐ <%s> ̍쐬s܂",
												 "CipVmgGenVar: Variable <%s> generation failure."), pVarName);
			rc = FALSE;
		}
	}
	else {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgGenVar: ϐ <%s> ͊ɒ`Ă܂(CipVmgGenVar)",
											 "CipVmgGenVar: Multiple defined <%s>."), pVarName);
		rc = FALSE;
	}
	return rc;
}
//==============================================================================================================//
//	ϐ̍폜																									//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
BOOL			CipVmgDelVar(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName)
{
	BOOL	rc = TRUE;

	if (!AjcVmgDelVarA(hVmg, pVarName)) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgDelVar: ϐ <%s> ܂",
											 "CipVmgDelVar: Variable <%s> not found."), pVarName);
		rc = FALSE;
	}

	return rc;
}

//==============================================================================================================//
//	ϐlݒij																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				value		- ϐl																			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
BOOL			CipVmgSetInteger(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName, UI ix, SLL value)
{
	BOOL	rc = TRUE;

	if (!(AjcVmgSetIntegerA(hVmg, pVarName, ix, value))) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgSetInteger: ϐl <%s> ̐ݒs܂Bi`^zCfNXI[o[j",
											 "CipVmgSetInteger: Variable <%s> setting failure."), pVarName);
		rc = FALSE;
	}
	return rc;
}
//==============================================================================================================//
//	ϐlݒij																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				value		- ϐl																			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
BOOL			CipVmgSetReal	(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName, UI ix, double value)
{
	BOOL	rc = TRUE;

	if (!(AjcVmgSetRealA(hVmg, pVarName, ix, value))) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgSetReal: ϐl <%s> ̐ݒs܂Bi`^zCfNXI[o[j",
											 "CipVmgSetReal: Variable <%s> setting failure."), pVarName);
		rc = FALSE;
	}
	return rc;
}
//==============================================================================================================//
//	ϐlݒij																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				pStr		- ւ̃|C^																//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
BOOL			CipVmgSetString	(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName, UI ix, C_BCP pStr)
{
	BOOL	rc = TRUE;

	if (!(AjcVmgSetStringA(hVmg, pVarName, ix, pStr))) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgSetString: ϐl <%s> ̐ݒs܂Bi`^zCfNXI[o[^G[j",
											 "CipVmgSetString: Variable <%s> setting failure."), pVarName);
		rc = FALSE;
	}
	return rc;
}
//==============================================================================================================//
//	ϐl擾iUSrbgj																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				pValue		- ϐli[obt@̃AhX												//
//																												//
//	߂l	F	O - iϐ̃^Cvj																		//
//				O - s																						//
//==============================================================================================================//
BOOL			CipVmgGetInt64	(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName, UI ix, SLLP pValue)
{
	BOOL	rc = TRUE;

	if (AjcVmgGetInt64A(hVmg, pVarName, ix, pValue) == AJCVMGT_UNDEF) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgGetInt64: ϐl <%s> ̎擾s܂Bi`^zCfNXI[o[j",
											 "CipVmgGetInt64: Variable <%s> getting failure."), pVarName);
		rc = FALSE;
	}
	return rc;
}
//==============================================================================================================//
//	ϐl擾ij																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				pValue		- ϐli[obt@̃AhX												//
//																												//
//	߂l	F	O - iϐ̃^Cvj																		//
//				O - s																						//
//==============================================================================================================//
BOOL		CipVmgGetReal	(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName, UI ix, double *pValue)
{
	BOOL	rc = TRUE;

	if (AjcVmgGetRealA(hVmg, pVarName, ix, pValue) == AJCVMGT_UNDEF) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgGetReal: ϐl <%s> ̎擾s܂Bi`^zCfNXI[o[(CipVmgGetReal)j",
											 "CipVmgGetReal: Variable <%s> getting failure."), pVarName);
		rc = FALSE;
	}
	return rc;
}
//==============================================================================================================//
//	ϐl擾ij																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//																												//
//	߂l	F	NULL - iϐ̃^Cvj																	//
//				NULL - s																					//
//==============================================================================================================//
C_BCP			CipVmgGetString(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName, UI ix)
{
	C_BCP	rc;

	if ((rc = AjcVmgGetStringA(hVmg, pVarName, ix)) == NULL) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgGetString: ϐl <%s> ̎擾s܂Bi`^zCfNXI[o[j",
											 "CipVmgGetString: Variable <%s> getting failure."), pVarName);
	}
	return rc;
}

//==============================================================================================================//
//	ϐľ																								//
//																												//
//	@	F	pW				- CX^Xnh															//
//				lno				- sԍ																		//
//				hVmg			- ϐǗCX^X															//
//				pVarName1, ix1	- lϐւ̃|C^CzvfCfNX							//
//				pVarName2, ix2	- 	V																			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
BOOL			CipVmgSwap		(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName1, UI ix1, C_BCP pVarName2, UI ix2)
{
	BOOL	rc = TRUE;

	if (!(AjcVmgSwapA(hVmg, pVarName1, ix1, pVarName2, ix2))) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgSwap: ϐl <%s, %s> ̌s܂Bi`^zCfNXI[o[^G[j",
											 "CipVmgSwap: Variable <%s, %s> excahnging failure."), pVarName1, pVarName2);
	}
	return rc;
}
//==============================================================================================================//
//	zvf̎擾																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//																												//
//	߂l	F	O - iz̗vfj																		//
//				O - s																						//
//==============================================================================================================//
UI				CipVmgGetArrNum	(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName)
{
	UI		rc;

	if ((rc = AjcVmgGetArrNumA(hVmg, pVarName)) == 0) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgGetArrNum: ϐ <%s> ͒`Ă܂B",
											 "CipVmgGetArrNum: Undefined variable <%s>."), pVarName);
	}
	return rc;
}
//==============================================================================================================//
//	ϐm[h擾																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmg		- ϐǗCX^X																//
//				pVarName	- ϐւ̃|C^																//
//																												//
//	߂l	F	NULL - iϐm[h̃AhXj														//
//				NULL - s																					//
//==============================================================================================================//
PCAJCVMGNODEA	CipVmgGetNode	(HAJCCIP pW, UI lno, HAJCVMGA hVmg, C_BCP pVarName)
{
	PCAJCVMGNODEA	rc;

	if ((rc = AjcVmgGetNodeA(hVmg, pVarName)) == NULL) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgGetNode: ϐ <%s> ͒`Ă܂B",
											 "CipVmgGetNode: Undefined variable <%s>."), pVarName);
	}
	return rc;
}
//==============================================================================================================//
//	ϐ^z̃Rs[																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lno			- sԍ																			//
//				hVmgD		- Rs[CX^Xnh														//
//				pNameD		- Rs[ϐ																	//
//				hVmgS		- Rs[CX^Xnh														//
//				pNameD		- Rs[ϐ																	//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
BOOL			CipVmgCopy		(HAJCCIP pW, UI lno, HAJCVMGA hVmgD, C_BCP pNameD, HAJCVMGA hVmgS, C_BCP pNameS)
{
	BOOL	rc = TRUE;

	if (!(AjcVmgCopyA(hVmgD, pNameD, hVmgS, pNameS))) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, lno,
									  LNGSEL("CipVmgCopy: ϐ^z̃Rs[( <%s> -> <%s> )s܂Bi`^G[j",
											 "CipVmgCopy: Failed in a copy of a variable <%s> to <%s>."), pNameS, pNameD);
		rc = FALSE;
	}
	return rc;
}

