#include	"AjcInternal.h"
#include	"AjcCtrlBarGraphDef.h"
//**************************************************************************************************************//
//																												//
//	JX^Rg[i_Otj			ʃTu֐													//
//																												//
//**************************************************************************************************************//

//==============================================================================================================//
//	f[^ݒ																									//
//																												//
//	@	F	pTitle	- _̃^Cg																			//
//				data	- Otf[^̃AhX																//
//																												//
//	߂l	F	TRUE - CFALSE - s																		//
//==============================================================================================================//
BOOL	BarSetData(PWRK_BARGRAPH pW, C_WCP pTitle, double data[])
{
	SCROLLINFO		si;

	//----- obt@փf[^ݒ -------------------------------------------------------//
	memcpy (pW->pBuf[pW->ixBuf].val, (VOP)data, sizeof(double) * pW->prop.MaxItem);
	wcsncpy(pW->pBuf[pW->ixBuf].str, (VOP)pTitle, AJCBAR_MAXSTR);
	pW->pBuf[pW->ixBuf].str[AJCBAR_MAXSTR - 1] = 0;
	if (pW->nBuf < pW->prop.MaxBuf) pW->nBuf++;								//	obt@f[^XV
	pW->ixBuf = (pW->ixBuf + 1) % pW->prop.MaxBuf;							//	obt@CfNXXV

	//----- _Ot̑SC[WXV -------------------------------------------------//
	pW->ImgLen = pW->nBuf * pW->BarField;

	//----- XN[XV ---------------------------------------------------------//
	if (!pW->fScrBar) {														//	XN[o[񑀍쒆H
		BarSetViewInfoTail(pW);												//		\Jnʒuݒ
		BarSetScrollInfo(pW);												//		XN[ݒ
	}
	else {																	//	XN[o[쒆H
		si.cbSize = sizeof(SCROLLINFO);
		si.fMask  = SIF_POS;
		GetScrollInfo(pW->hBarStr, SB_HORZ, &si);							//		\JnʒuA
		pW->pxView = si.nPos;												//		XN[o[ʒuƂ
		pW->rxView = -((int)(si.nPos % pW->BarField));
		pW->ixView = BarDixToBix(pW, si.nPos / pW->BarField);
		SetViewInfoCurrent(pW);												//		݈ʒuȍ~̕\ݒ
	}
	BarReDraw(pW, FALSE);														//	ĕ`

	return TRUE;
}
//==============================================================================================================//
//	f[^NA[																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE - CFALSE - s																		//
//==============================================================================================================//
BOOL	BarPurge(PWRK_BARGRAPH pW)
{
	pW->ImgLen = 0;
	pW->pxView = 0;
	pW->rxView = 0;
	pW->ixView = 0;
	pW->nView  = 0;
	pW->nBuf   = 0;
	pW->ixBuf  = 0;
	BarSetScrollInfo(pW);
	BarReDraw(pW, FALSE);
	return TRUE;
}
//==============================================================================================================//
//	{[_[Fݒ																								//
//																												//
//	@	F	color	- {[_[J[																		//
//																												//
//	߂l	F	TRUE - CFALSE - s																		//
//==============================================================================================================//
BOOL	BarSetBorderColor(PWRK_BARGRAPH pW, COLORREF color)
{
	BOOL	rc = FALSE;
	HPEN	hPen;

	if (hPen = CreatePen(PS_SOLID, 1, color)) {
		if (pW->hPenBorder != NULL) DeleteObject(pW->hPenBorder);
		pW->RgbBorder  = color;
		pW->hPenBorder = hPen;
		InvalidateRect(pW->hBack, NULL, FALSE);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	vpeBݒ																								//
//																												//
//	@	F	pNew	- VvpeB																			//
//																												//
//	߂l	F	TRUE - CFALSE - s																		//
//==============================================================================================================//
BOOL	BarSetProp(PWRK_BARGRAPH pW, PCAJCBARPROP pNew)
{
	BOOL		rc = TRUE;
	PBARDATA	pTmpBuf;
	BOOL		fNeedReSize = FALSE;

	if (pNew->MaxBuf  >= 2 && pNew->MaxBuf	<= AJCBAR_MAXBUF	&&
		pNew->MaxItem >= 1 && pNew->MaxItem <= AJCBAR_MAXITEM) {
		if (pW->prop.MaxBuf != pNew->MaxBuf || pW->prop.MaxItem != pNew->MaxItem) {
			if ((pTmpBuf = (PBARDATA)AJCMEM(sizeof(BARDATA) * pNew->MaxBuf)) != NULL) {
				memset(pTmpBuf, 0, sizeof(BARDATA) * pNew->MaxBuf);
				pW->pxView = 0;
				pW->rxView = 0;
				pW->ixView = 0;
				pW->nView  = 0;
				pW->nBuf   = 0;
				pW->ixBuf  = 0;
				pW->prop.MaxBuf	 = pNew->MaxBuf;
				pW->prop.MaxItem = pNew->MaxItem;
				if (pW->pBuf != NULL) free(pW->pBuf);
				pW->pBuf = pTmpBuf;
			}
			else {
				if (pTmpBuf != NULL) free(pTmpBuf);
				rc = FALSE;
			}
		}
		//---- \̍\ωꍇ́AeEChč\ ----------//
		if (pW->prop.ScaleWidth != pNew->ScaleWidth ||	pW->prop.BarTtlLines != pNew->BarTtlLines) {
			fNeedReSize = TRUE;
		}
		//----- OtWωꍇ́AWʒm -------------//
		if (pW->prop.RngL != pNew->RngL || pW->prop.RngH != pNew->RngH) {
			PostMessage(pW->hBack, AJCBARM_NEEDNTC_RANGE, 0, 0);
		}
		pW->prop.RngL			= pNew->RngL;
		pW->prop.RngH			= pNew->RngH;
		pW->prop.Base			= pNew->Base;
		pW->prop.ScaleWidth		= __max(32, pNew->ScaleWidth );
		pW->prop.BarWidth		= __max( 4, pNew->BarWidth	 );
		pW->prop.MinWidth		= __max(10, pNew->MinWidth	 );
		pW->prop.BarTtlLines	= __max( 1, pNew->BarTtlLines);
		memcpy(pW->prop.rgb, &pNew->rgb, sizeof pW->prop.rgb);
		SetWindowPos(pW->hFilter, NULL, 0, 0, (BAR_FLT_WIDTH + 4) * pW->prop.MaxItem, BAR_FLT_HEIGHT + 4, SWP_NOMOVE);

		//----- Lȕ\ڐݒ -----------------------------------//
		BarSetValidItems(pW);

		//----- _\̒ݒ -------------------------------------//
		BarSetBarFieldLen(pW);

		//----- \ݒ -------------------------------------------//
		SetViewInfoCurrent(pW);

		//----- XN[XV -------------------------------------//
		BarSetScrollInfo(pW);

		//---- \̍\ωꍇ́AeEChč\ ----------//
		if (fNeedReSize) {
			SendMessage(pW->hBack, WM_SIZE, 0, MAKELONG(pW->BackW, pW->BackH));
		}

		//----- ĕ` -------------------------------------------------//
		BarReDraw(pW, FALSE);
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	vpeB擾																								//
//																												//
//	@	F	pBuf	- vpeBi[obt@																//
//																												//
//	߂l	F	TRUE - CFALSE - s																		//
//==============================================================================================================//
BOOL	BarGetProp(PWRK_BARGRAPH pW, PAJCBARPROP pBuf)
{
	memcpy(pBuf, &pW->prop, sizeof(AJCBARPROP));
	return TRUE;
}
//==============================================================================================================//
//	Wݒ																									//
//																												//
//	@	F	low, high	- W																			//
//																												//
//	߂l	F	TRUE - CFALSE - s																		//
//==============================================================================================================//
BOOL	BarSetRange(PWRK_BARGRAPH pW, double low, double high)
{
	BOOL			rc;
	AJCBARPROP		prop;

	memcpy(&prop, &pW->prop, sizeof(AJCBARPROP));
	prop.RngL = low;
	prop.RngH = high;
	rc = BarSetProp(pW, &prop);

	return rc;
}
//==============================================================================================================//
//	x[Xݒ																									//
//																												//
//	@	F	base	- x[Xl																				//
//																												//
//	߂l	F	TRUE - CFALSE - s																		//
//==============================================================================================================//
BOOL	BarSetBase(PWRK_BARGRAPH pW, double base)
{
	AJCBARPROP		prop;
	BOOL			rc;

	memcpy(&prop, &pW->prop, sizeof(AJCBARPROP));
	prop.Base = base;
	rc = BarSetProp(pW, &prop);

	return rc;
}
//==============================================================================================================//
//																												//
//	XN[̐ݒƃXN[o[\^\															//
//																												//
//==============================================================================================================//
VO		BarSetScrollInfo(PWRK_BARGRAPH pW)
{
	SCROLLINFO		si;

	//----- XN[ݒ -------------------------------------------//
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask  = SIF_PAGE | SIF_RANGE | SIF_POS;
	si.nMin	  = 0;
	si.nMax	  = pW->ImgLen;
	si.nPage  = pW->BarStrW;
	si.nPos	  = pW->pxView;
	SetScrollInfo(pW->hBarStr, SB_HORZ, &si, TRUE);

	//----- XN[o[\^\ ------------------------------------//
	if (pW->style & AJCBARS_NOSCROLLBAR) {
		ShowScrollBar(pW->hBarStr, SB_HORZ, FALSE);
	}
	else {
		if (pW->ImgLen <= pW->BarStrW) {
			ShowScrollBar(pW->hBarStr, SB_HORZ, FALSE);
		}
		else {
			ShowScrollBar(pW->hBarStr, SB_HORZ, TRUE);
		}
	}
}
//==============================================================================================================//
//																												//
//	݈ʒuȍ~̕\ݒ																					//
//																												//
//==============================================================================================================//
VO		SetViewInfoCurrent(PWRK_BARGRAPH pW)
{
	UI		nMaxView;
	int		dix, dixMax, rem;

	dix		   = BarBixToDix(pW, pW->ixView);						//	\擪f[^ECfNX
	rem		   = pW->BarStrW % pW->BarField;					//	\[sNZ
	nMaxView   = (pW->BarStrW / pW->BarField) + (rem != 0);		//	ő\\
	dixMax	   = pW->nBuf - nMaxView;							//	ŏf[^ECfNX
	dixMax	   = __max(dixMax, 0);								//	E
	if (dixMax < dix) {											//	f[^CfNX␳vH
		dix		   = dixMax;									//		f[^CfNX␳
		pW->ixView = BarDixToBix(pW, dix);							//		obt@CfNXݒ
	}
	if (rem == 0) pW->rxView = 0;								//	ɉBꂽ̃sNZ
	else		  pW->rxView = -((int)(pW->BarField - rem));	//	E
	pW->pxView = dix * pW->BarField + abs(pW->rxView);			//	Ot[ɑΉf[^sNZʒu
	pW->nView  = pW->nBuf - dix;								//	\
	pW->nView  = __min(pW->nView, nMaxView);					//	E
}
//==============================================================================================================//
//																												//
//	obt@CfNXf[^CfNXϊ																	//
//																												//
//==============================================================================================================//
UI		BarBixToDix(PWRK_BARGRAPH pW, UI bix)
{
	UI		rc;

	if (pW->nBuf < pW->prop.MaxBuf) {
		rc = bix;
	}
	else {
		if (bix >= pW->ixBuf) rc = bix - pW->ixBuf;
		else				  rc = ((pW->prop.MaxBuf - pW->ixBuf) + bix) % pW->prop.MaxBuf;
	}
	return rc;
}
//==============================================================================================================//
//																												//
//	f[^CfNXobt@CfNXϊ																	//
//																												//
//==============================================================================================================//
UI		BarDixToBix(PWRK_BARGRAPH pW, UI dix)
{
	UI		rc;

	if (pW->nBuf < pW->prop.MaxBuf) {
		rc = dix;
	}
	else {
		rc = (pW->ixBuf + dix) % pW->prop.MaxBuf;
	}
	return rc;
}
//==============================================================================================================//
//																												//
//	f[^lxʒuϊ																						//
//																												//
//==============================================================================================================//
int		BarDatToYPos(PWRK_BARGRAPH pW, double dat)
{
	double	y;

	if (pW->prop.RngL <= pW->prop.RngH) {
		y = (double)pW->ImageH * ((dat - pW->prop.RngL) / fabs(pW->prop.RngH - pW->prop.RngL));
		y = pW->ImageH - y;
	}
	else {
		y = (double)pW->ImageH * ((dat - pW->prop.RngH) / fabs(pW->prop.RngH - pW->prop.RngL));
	}
	return (int)y;
}
//==============================================================================================================//
//																												//
//	ĕ`																										//
//																												//
//==============================================================================================================//
VO		BarReDraw(PWRK_BARGRAPH pW, BOOL fClear)
{
//	InvalidateRect(pW->hBack  , NULL, fClear);
	InvalidateRect(pW->hScale , NULL, fClear);
	InvalidateRect(pW->hImage , NULL, fClear);
	InvalidateRect(pW->hTtlStr, NULL, fClear);
	InvalidateRect(pW->hBarStr, NULL, fClear);
	InvalidateRect(pW->hFilter, NULL, fClear);
}
//==============================================================================================================//
//																												//
//	Lȕ\ڐݒ																						//
//																												//
//==============================================================================================================//
VO		BarSetValidItems(PWRK_BARGRAPH pW)
{
	UI		n;
	UI		i;
	UI		msk;

	for (i = 0, n = 0, msk = 0x01; i < pW->prop.MaxItem; i++, msk <<= 1) {
		if (pW->MskFilt & msk) {
			n++;
		}
	}
	pW->ValidItems = n;
}
//==============================================================================================================//
//																												//
//	_\̒vZ																							//
//																												//
//==============================================================================================================//
VO		BarSetBarFieldLen(PWRK_BARGRAPH pW)
{
	//----- ܂Ot̏ꍇ -----------------------------------------//
	if (pW->style & AJCBARS_LINEGRAPH) {
		pW->BarField = __max(pW->prop.MinWidth, 10);
	}
	//----- _Ot̏ꍇ ---------------------------------------------//
	else {
		pW->BarField = pW->prop.BarWidth * pW->ValidItems + BAR_SPACE;
		pW->BarField = __max(pW->BarField, pW->prop.MinWidth);
		pW->ImgLen	 = pW->BarField * pW->nBuf;
	}
}
//==============================================================================================================//
//																												//
//	obNECh`																							//
//																												//
//==============================================================================================================//
VO		BarPaintBackWnd(PWRK_BARGRAPH pW, HDC hdc, int width, int height)
{
	HPEN		hPen;

	//----- {[_[` ---------------------------------------------------//
	if (pW->style & AJCBARS_NOBORDER) {
		hPen = (HPEN)SelectObject(hdc, hPenBtnFace);
	}
	else {
		if (pW->fEnable) hPen = (HPEN)SelectObject(hdc, pW->hPenBorder);
		else			 hPen = (HPEN)SelectObject(hdc, hPenGrayText);
	}
	MoveToEx(hdc, 0			, 0			, NULL);
	LineTo	(hdc, width - 1 , 0			);
	LineTo	(hdc, width - 1 , height - 1);
	LineTo	(hdc, 0			, height - 1);
	LineTo	(hdc, 0			, 0			);
	SelectObject(hdc, hPen);

	//----- \C` -------------------------------------------------//
	hPen = (HPEN)SelectObject(hdc, (HPEN)GetStockObject(BLACK_PEN));
	MoveToEx(hdc, pW->ScaleW + 1, 1				 , NULL);
	LineTo	(hdc, pW->ScaleW + 1, pW->BackH	 - 1	   );
	MoveToEx(hdc, 1				, pW->ScaleH + 1 , NULL);
	LineTo	(hdc, pW->BackW - 1 , pW->ScaleH + 1	   );
	SelectObject(hdc, hPen);

}
//==============================================================================================================//
//																												//
//	Rg[̃rbg}bvEC[W																	//
//																												//
//==============================================================================================================//
HBITMAP		BarCreateBitmap(PWRK_BARGRAPH pW)
{
	HBITMAP	hBmp = NULL;
	HBITMAP	svBmp;
	HDC		hdc, hmd, hmc;
	RECT	r;

	hdc = GetDC(pW->hBack);
	hmd = CreateCompatibleDC(hdc);
	hmc = CreateCompatibleDC(hdc);
	if (hmd != NULL) {
		hBmp = CreateCompatibleBitmap(hdc, pW->BackW, pW->BackH);
		if (hBmp != NULL) {
			svBmp = (HBITMAP)SelectObject(hmd, hBmp);
			//----- rbg}bvNA[ ------------------------//
			SetRect(&r, 0, 0, pW->BackW, pW->BackH);
			FillRect(hmd, &r, (HBRUSH)GetStockObject(WHITE_BRUSH));
			//----- qEChzu ------------------------------//
			if (hmc != NULL) {
				if (pW->hBmpScale != NULL) {
					SelectObject(hmc, pW->hBmpScale);
					GetWindowRect(pW->hScale, &r);
					MapWindowPoints(NULL, pW->hBack, (LPPOINT)&r, 2);
					BitBlt(hmd, r.left, r.top, r.right - r.left, r.bottom - r.top, hmc, 0, 0, SRCCOPY);
				}
				if (pW->hBmpImage != NULL) {
					SelectObject(hmc, pW->hBmpImage);
					GetWindowRect(pW->hImage, &r);
					MapWindowPoints(NULL, pW->hBack, (LPPOINT)&r, 2);
					BitBlt(hmd, r.left, r.top, r.right - r.left, r.bottom - r.top, hmc, 0, 0, SRCCOPY);
				}
				if (pW->hBmpTtlStr != NULL) {
					SelectObject(hmc, pW->hBmpTtlStr);
					GetWindowRect(pW->hTtlStr, &r);
					MapWindowPoints(NULL, pW->hBack, (LPPOINT)&r, 2);
					BitBlt(hmd, r.left, r.top, r.right - r.left, r.bottom - r.top, hmc, 0, 0, SRCCOPY);
				}
				if (pW->hBmpBarStr != NULL) {
					SelectObject(hmc, pW->hBmpBarStr);
					GetWindowRect(pW->hBarStr, &r);
					MapWindowPoints(NULL, pW->hBack, (LPPOINT)&r, 2);
					BitBlt(hmd, r.left, r.top, r.right - r.left, r.bottom - r.top, hmc, 0, 0, SRCCOPY);
				}
			}
			//----- obNECh` --------------------------//
			BarPaintBackWnd(pW, hmd, pW->BackW, pW->BackH);
			SelectObject(hmd, svBmp);
		}
	}
	if (hmd != NULL) DeleteDC(hmd);
	if (hmc != NULL) DeleteDC(hmc);
	ReleaseDC(pW->hBack, hdc);

	return hBmp;
}

//==============================================================================================================//
//																												//
//	f[^̕\ݒ																				//
//																												//
//==============================================================================================================//
VO		BarSetViewInfoTail(PWRK_BARGRAPH pW)
{

	if (pW->ImgLen < pW->BarStrW) {
		pW->nView  = pW->nBuf;			//	\
		pW->rxView = 0;					//	[獶ɉBꂽ̃sNZ
		pW->ixView = BarDixToBix(pW, 0);	//	\擪obt@ECfNX
		pW->pxView = 0;					//	Ot[ɑΉf[^sNZʒu
	}
	else {
		UI		nMaxView;
		int		dix, rem;

		rem		   = pW->BarStrW % pW->BarField;					//	\[sNZ
		nMaxView   = (pW->BarStrW / pW->BarField) + (rem != 0);		//	ő\\
		dix		   = pW->nBuf - nMaxView;							//	\擪f[^ECfNX
		dix		   = __max(dix, 0);									//	E
		pW->ixView = BarDixToBix(pW, dix);								//	\擪obt@CfNX
		if (rem == 0) pW->rxView = 0;								//	ɉBꂽ̃sNZ
		else		  pW->rxView = -((int)(pW->BarField - rem));	//	E
		pW->pxView = dix * pW->BarField + abs(pW->rxView);			//	Ot[ɑΉf[^sNZʒu
		pW->nView  = pW->nBuf - dix;								//	\
		pW->nView  = __min(pW->nView, nMaxView);					//	E
	}
}

