#include	"AjcInternal.h"
#include	"AjcCtrlInpValDef.h"
//**************************************************************************************************************//
//																												//
//	JX^Rg[iĺj			CECh													//
//																												//
//**************************************************************************************************************//

#define	IS_MY_INST(P)	(P != NULL && P->InstID == IV_INST_ID)

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC_DEF(Main);
static	VO		SetPropByText	  (PWRKINPVAL pW, WCP pTxt, PAJCIVPROP pProp);
static	VO		SetCtrlProp		  (PWRKINPVAL pW, PCAJCIVPROP pProp);
static	VO		BlinkStart		  (PWRKINPVAL pW);
static	VO		BlinkEnd		  (PWRKINPVAL pW);
static	VO		BlinkCancel		  (PWRKINPVAL pW);
static	VO		SetValueText	  (PWRKINPVAL pW, double val);
static	UI		MakeValueText	  (PWRKINPVAL pW, WCP pBuf, UI lBuf);
static	VO		SetControlPosition(PWRKINPVAL pW);
static	double	SldPosToValue	  (PWRKINPVAL pW, int pos);
static	int		ValueToSldPos	  (PWRKINPVAL pW, double val);
static	VO		NotifyValue		  (PWRKINPVAL pW);
static	VO		EnableCtrls		  (PWRKINPVAL pW, BOOL fEnable);
static	VO		SetCurrentValue	  (PWRKINPVAL pW, double NewVal);

//==============================================================================================================//
//																												//
//	EChvV[WEGg|CgԂ																//
//																												//
//==============================================================================================================//
WNDPROC		IvWndProcMain()
{
	return AJC_WNDPROC_NAME(Main);
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	CEChvV[W																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_CREATE		)
{
	LRESULT			rc = -1;
	PWRKINPVAL		pW = NULL;
	AJCIVPROP		prop;
	HFONT			hFont;
	WC				PropTxt[256];

	do {
		//----- [N -----------------------------------------------------------------------------------//
		if ((pW = (PWRKINPVAL)AJCMEM(sizeof(WRKINPVAL))) == NULL) break;
		memset(pW, 0, sizeof(WRKINPVAL));

		//----- CX^Xʂhcݒ -----------------------------------------------------------------------//
		pW->InstID = IV_INST_ID;

		//----- EChEGNXg̈փ[N|C^ݒ ---------------------------------------------------//
		MAjcSetWindowLong(hwnd, 0, (UX)pW);

		//----- EChLvVip^j擾 -----------------------------------------------------//
		pW->fFirstGetText = TRUE;
		GetWindowText(hwnd, PropTxt, AJCTSIZE(PropTxt));

		//----- EChnh^X^Cݒ -----------------------------------------------------------------//
		pW->hBack  = hwnd;
		pW->style  = (int)MAjcGetWindowLong(hwnd, GWL_STYLE);

		//----- ftHgvpeBݒ -----------------------------------------------------------------------//
		prop.min	   = 0.0;
		prop.max	   = 100.0;
		prop.SldUnit   = 1.0;
		prop.SldPage   = 10;
		prop.SpnStep   = 1.0;
		prop.TextLen   = 6;
		prop.Precision = 3;
		prop.HexLen    = 0;

		//----- `F񏉊 -------------------------------------------------------------------------------//
		pW->RgbBorder  = RGB(  0,	0,	 0);
		pW->RgbBlink   = RGB(255,	0, 255);
		if ((pW->hPenBorder = CreatePen(PS_SOLID, 1, pW->RgbBorder			  )) == NULL) break;
		if ((pW->hPenBlink	= CreatePen(PS_SOLID, 1, pW->RgbBlink			  )) == NULL) break;

		//----- XC_ERg[ ---------------------------------------------------------------------//
		pW->ctrls.s.sld.hwnd = CreateWindowEx(0, TRACKBAR_CLASS,	NULL,
											  WS_CHILD | WS_VISIBLE | WS_TABSTOP | TBS_HORZ | TBS_NOTICKS | TBS_BOTH,
											  0, 0, 0, 0, hwnd, (HMENU)IV_IDC_SLD, hDllInst, NULL);
		if (pW->ctrls.s.sld.hwnd == NULL) break;
		AJCTIP_SETFRIENDA(pW->ctrls.s.sld.hwnd);
		pW->ctrls.s.sld.WndProc = (WNDPROC)MAjcGetWindowLong(pW->ctrls.s.sld.hwnd, GWLP_WNDPROC);

		//----- GfBbgERg[ -------------------------------------------------------------------//
		pW->ctrls.s.txt.hwnd = CreateWindowEx(WS_EX_CLIENTEDGE, L"EDIT", NULL,
											  WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_CENTER | ES_READONLY,
											  0, 0, 0, 0, hwnd, (HMENU)IV_IDC_TXT, hDllInst, NULL);
		if (pW->ctrls.s.txt.hwnd == NULL) break;
		AJCTIP_SETFRIENDA(pW->ctrls.s.txt.hwnd);
		pW->ctrls.s.txt.WndProc = (WNDPROC)MAjcGetWindowLong(pW->ctrls.s.txt.hwnd, GWLP_WNDPROC);

		//----- {^ERg[ -----------------------------------------------------------------------//
		pW->ctrls.s.btn.hwnd = CreateWindowEx(0, L"BUTTON",	NULL,
											  WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON | BS_VCENTER | BS_CENTER,
											  0, 0, 0, 0, hwnd, (HMENU)IV_IDC_BTN, hDllInst, NULL);
		if (pW->ctrls.s.btn.hwnd == NULL) break;
		AJCTIP_SETFRIENDA(pW->ctrls.s.btn.hwnd);
		pW->ctrls.s.btn.WndProc = (WNDPROC)MAjcGetWindowLong(pW->ctrls.s.btn.hwnd, GWLP_WNDPROC);

		//----- XsERg[ -----------------------------------------------------------------------//
		pW->ctrls.s.spn.hwnd = CreateUpDownControl(WS_CHILD | WS_BORDER | WS_VISIBLE | WS_TABSTOP | UDS_ARROWKEYS,
												   0, 0, 0, 0, hwnd, IV_IDC_SPN, hDllInst, NULL, 0x7FFFFFFF, 0x80000000, 0);
		if (pW->ctrls.s.spn.hwnd == NULL) break;
		AJCTIP_SETFRIENDA(pW->ctrls.s.spn.hwnd);
		pW->ctrls.s.spn.WndProc = (WNDPROC)MAjcGetWindowLong(pW->ctrls.s.spn.hwnd, GWLP_WNDPROC);

		//----- eLXg{bNXɐeEChƓtHgݒ -------------------------------------------------//
		hFont = (HFONT)SendMessage(GetParent(pW->hBack), WM_GETFONT, 0, 0);
		SendMessage(pW->ctrls.s.txt.hwnd, WM_SETFONT, (WPARAM)hFont, TRUE);

		//----- {^tF[XƃtHgݒ--------------------------------------------------------------------//
		SendMessage	 (pW->ctrls.s.btn.hwnd, WM_SETFONT, (WPARAM)IvhFontBtnFace, TRUE);
		SetWindowText(pW->ctrls.s.btn.hwnd, L"...");

		//----- vpeBݒ ---------------------------------------------------------------------------------//
		SetPropByText(pW, PropTxt, &prop);
		SetCtrlProp	 (pW, &prop);

		//----- eLXgl\ -----------------------------------------------------------------------------//
		SetValueText(pW, pW->Value);
		AjcSetCtrlSldPos(pW->ctrls.s.sld.hwnd, ValueToSldPos(pW, pW->Value));

		//----- Rg[zu -------------------------------------------------------------------------------//
		SetControlPosition(pW);

		//----- Rg[̗LԐݒ ---------------------------------------------------------------------//
		EnableCtrls(pW, pW->fEnable = !(pW->style & WS_DISABLED));

		//----- Rg[TuNX ---------------------------------------------------------------------//
		IvSetSubClass(pW);

		//----- ftHgc[`bveLXgݒ -------------------------------------------------------------//
		if (pW->style & AJCIVS_DEFTIP) {
			IvSetDefaultTipText(pW);
		}

		//----- `bveLXg\ -------------------------------------------------------------------------//
		pW->fShowAlways = TRUE;

		//----- c[`bvETuNXʒmݒ -------------------------------------------------------------//
		if (!AjcTipTextSetNtcSubclass(pW->hBack, hwnd, AJCIVN_TIP_SUBCLASS, 0)) break;

		//----- ߂l -----------------------------------------------------------------------------------//
		rc = 0;
	} while(0);

	if (rc == -1) {
		if (pW != NULL) {
			int		i;
			for (i=0; i<IV_CTRLS; i++) {
				if (pW->ctrls.arr[i].hwnd) DestroyWindow(pW->ctrls.s.sld.hwnd);
			}
			if (pW->hPenBorder != NULL) DeleteObject(pW->hPenBorder);
			if (pW->hPenBlink  != NULL) DeleteObject(pW->hPenBlink );
			free(pW);
		}
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_DESTROY	)
{
	int			i;
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);

	//	qRg[QN[Y
	for (i=0; i<IV_CTRLS; i++) {
		if (pW->ctrls.arr[i].hwnd) DestroyWindow(pW->ctrls.s.sld.hwnd);
	}
	//	`bveLXg
	if (pW->pToolTipTxt != NULL) {
		free(pW->pToolTipTxt);
		pW->pToolTipTxt = NULL;
	}
	//	c[`bvETuNXʒm
	AjcTipTextClrNtcSubclass(pW->hBack);
	//	CX^X[N
	free(pW);

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_SIZE		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);

	pW->fDrawCtrls = TRUE;
	InvalidateRect(hwnd, NULL, TRUE);

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_TIMER		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	int			tc = GetTickCount() / 1000;

	if (pW->BlkSvTick != tc) {
		pW->BlkSvTick = tc;
		pW->fBlkDraw = TRUE;
		pW->fBlkOn	 = (tc & 1);
		InvalidateRect(hwnd, NULL, FALSE);
	}

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_HSCROLL	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	int			pos;

	if (wParam != SB_ENDSCROLL) {
		BlinkCancel(pW);
		pos = AjcGetCtrlSldPos(pW->ctrls.s.sld.hwnd);
		SetCurrentValue(pW, SldPosToValue(pW, pos));
		SetValueText(pW, pW->Value);	//	eLXg\
		NotifyValue(pW);				//	ʒm
	}
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_PAINT		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	PAINTSTRUCT	ps;
	HDC			hdc;
	HPEN		hPen  = NULL;
	HBRUSH		hBrush= NULL;

	hdc = BeginPaint(hwnd, &ps);

	hBrush = (HBRUSH)SelectObject(hdc, (HBRUSH)GetStockObject(NULL_BRUSH));

	//----- Rg[zu ----------------//
	if (pW->fDrawCtrls) {
		pW->fDrawCtrls = FALSE;
		SetControlPosition(pW);
	}
	//----- Og\ ------------------------//
	if (!(pW->style & AJCIVS_NOBORDER)) {
		if (pW->fEnable) hPen = (HPEN)SelectObject(hdc, pW->hPenBorder);
		else			 hPen = (HPEN)SelectObject(hdc, hPenGrayText);
	}
	else {
		hPen = (HPEN)SelectObject(hdc, hPenBtnFace);
	}
	RoundRect(hdc, 0, 0, pW->ww, pW->wh, 6, 6);
	hPen = (HPEN)SelectObject(hdc, hPen);
	//----- uN\ --------------------//
	if (pW->fBlkDraw) {
		int		x1 = pW->ctrls.s.txt.x - 1;
		int		y1 = pW->y - 1;
		int		x2 = pW->ctrls.s.btn.x + pW->ctrls.s.btn.cx + 1;
		int		y2 = pW->y + pW->cy + 1;
		if (pW->fBlkOn && !(pW->style & AJCIVS_NOBLINK)) hPen = (HPEN)SelectObject(hdc, pW->hPenBlink  );
		else											 hPen = (HPEN)SelectObject(hdc,	  hPenBtnFace);
		Rectangle(hdc, x1, y1, x2, y2);
		hPen = (HPEN)SelectObject(hdc, hPen);
		pW->fBlkDraw = FALSE;
	}
	if (hPen   != NULL) SelectObject(hdc, hPen	);
	if (hBrush != NULL) SelectObject(hdc, hBrush);
	EndPaint(hwnd, &ps);
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_GETTEXTLENGTH)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc;
	WC			tmp[512];

	if (pW->fFirstGetText) {
		rc = AjcDefWindowProc(hwnd, msg, wParam, lParam);
	}
	else {
		rc = MakeValueText(pW, tmp, AJCTSIZE(tmp));
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_GETTEXT	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc;

	if (pW->fFirstGetText) {
		pW->fFirstGetText = FALSE;
		rc = AjcDefWindowProc(hwnd, msg, wParam, lParam);
	}
	else {
		rc = MakeValueText(pW, (WCP)lParam, (UI)wParam);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_SETTEXT	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	WCP			p, pTmp;
	int			pos;

	if ((pTmp = (WCP)AjcTAlloc((UI)wcslen((WCP)lParam) + 1)) != NULL) {
		BlinkCancel(pW);
		//----- lݒ -----------------------//
		wcscpy(pTmp, (WCP)lParam);
		AjcStrRmvSepChar(pTmp);
		for (p=pTmp; MAjcIsBlankW(*p); p++);
		if (*p==L'0' && towupper(*(p+ 1)) == L'X')	SetCurrentValue(pW, AjcHexToUI(p));
		else										SetCurrentValue(pW, _wtof(pTmp));
		//----- Rg[֒l\ ---------//
		SetValueText(pW, pW->Value);
		//----- XC_ʒuݒ -------------//
		pos = ValueToSldPos(pW, pW->Value);
		AjcSetCtrlSldPos(pW->ctrls.s.sld.hwnd, pos);
		//----- ƃ[NJ ---------------//
		free(pTmp);
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_GETFONT	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	HFONT		hFont;
	
	hFont = (HFONT)SendMessage(pW->ctrls.s.txt.hwnd, WM_GETFONT, 0, 0);
	
	return (LRESULT)hFont;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_SETFONT	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);

	SendMessage(pW->ctrls.s.txt.hwnd, WM_SETFONT, wParam, lParam);

	pW->fDrawCtrls = TRUE;
	InvalidateRect(hwnd, NULL, FALSE);

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_STYLECHANGED)
{
	PWRKINPVAL		pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LPSTYLESTRUCT	p = (LPSTYLESTRUCT)lParam;
	int				sty;
	AJCIVPROP		prop;

	if (wParam == GWL_STYLE) {
		//----- VX^Clݒ --------------------------------//
		pW->style		= p->styleNew;
		//----- ^[hfׁ̈AvpeBĐݒ ------//
		memcpy(&prop, &pW->prop, sizeof prop);
		SetCtrlProp(pW, &prop);
		//----- l\ ----------------------------------------//
		SetValueText(pW, pW->Value);
		//----- eLXgACݒ ----------------------------//
		sty = (int)MAjcGetWindowLong(pW->ctrls.s.txt.hwnd, GWL_STYLE) & ~(ES_CENTER | ES_LEFT | ES_RIGHT);
		switch (pW->style & AJCIVS_ALIGN) {
			case AJCIVS_CENTER:	MAjcSetWindowLong(pW->ctrls.s.txt.hwnd, GWL_STYLE, sty | ES_CENTER); break;
			case AJCIVS_LEFT:	MAjcSetWindowLong(pW->ctrls.s.txt.hwnd, GWL_STYLE, sty | ES_LEFT  ); break;
			case AJCIVS_RIGHT:	MAjcSetWindowLong(pW->ctrls.s.txt.hwnd, GWL_STYLE, sty | ES_RIGHT ); break;
		}
		//----- Rg[Ĕzu ------------------------------//
		pW->fDrawCtrls	= TRUE;
		InvalidateRect(hwnd, NULL, FALSE);
	}
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_ENABLE)
{
	PWRKINPVAL		pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	EnableCtrls(pW, pW->fEnable = (BOOL)wParam);
	InvalidateRect(hwnd, NULL, FALSE);
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_RBUTTONDOWN)
{
	PWRKINPVAL		pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);

	if (pW->fNtcRClk) {
		if (pW->MsgRBDown != 0) {
			pW->NtcRClk.x		= (int)LOWORD(lParam);
			pW->NtcRClk.y		= (int)HIWORD(lParam);
			pW->NtcRClk.fShift	= ((wParam & MK_SHIFT  ) != 0);
			pW->NtcRClk.fCtrl	= ((wParam & MK_CONTROL) != 0);
			SendMessage(GetParent(hwnd), pW->MsgRBDown, wParam, lParam);
		}
	}

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_RBUTTONUP)
{
	PWRKINPVAL		pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);

	if (pW->fNtcRClk) {
		if (pW->MsgRBUp != 0) {
			SendMessage(GetParent(hwnd), pW->MsgRBUp, wParam, lParam);
		}
	}
	else {
		pW->NtcRClk.x		= (int)LOWORD(lParam);
		pW->NtcRClk.y		= (int)HIWORD(lParam);
		pW->NtcRClk.fShift	= ((wParam & MK_SHIFT  ) != 0);
		pW->NtcRClk.fCtrl	= ((wParam & MK_CONTROL) != 0);
		SendMessage(GetParent(hwnd), WM_COMMAND, 
						MAKELONG(MAjcGetWindowLong(pW->hBack, GWL_ID), AJCIVN_RCLICK),
						fCmdWithHdl ? (LPARAM)pW->hBack : (LPARAM)&pW->NtcRClk);
	}

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, IV_IDC_TXT	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, IV_IDC_BTN	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	double		SvVal = pW->Value;

	if (HIWORD(wParam) == BN_CLICKED) {
		if (!pW->fBlkBusy) {
			//	leLXgޔ
			memset(pW->SvText, 0, AJCTSIZE(pW->SvText));
			AjcGetCtrlStr(pW->ctrls.s.txt.hwnd, pW->SvText, AJCTSIZE(pW->SvText) - 1);
			//	l̓[h
			BlinkStart(pW);
		}
		else {
			//	l͊m
			BlinkEnd(pW);
			//	ʒm
			NotifyValue(pW);
		}
	}

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, IV_IDC_SPN	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LPNMUPDOWN	pUd = (LPNMUPDOWN)lParam;
	int			pos;

	if (pUd->hdr.code == UDN_DELTAPOS) {
		//----- uN~ ---------------------//
		BlinkCancel(pW);
		//----- lXV ---------------------------//
		SetCurrentValue(pW, pW->Value + (pUd->iDelta * pW->prop.SpnStep));
		//----- Rg[֒l\ -------------//
		SetValueText(pW, pW->Value);
		//----- XC_ʒuݒ -----------------//
		pos = ValueToSldPos(pW, pW->Value);
		AjcSetCtrlSldPos(pW->ctrls.s.sld.hwnd, pos);
		//----- lʒm ---------------------------//
		NotifyValue(pW);
	}
	
	return TRUE;	// Xs{^ʒu̕ύX֎~
}
//----- ݒieLXgČj--------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_SETTEXTFORMAT		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW)) {
		//----- vpeBlݒ ---------------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.TextLen   = (UI)wParam;
		prop.Precision = (SW)lParam;
		//----- vpeBXV -------------------//
		SetCtrlProp(pW, &prop);
		//----- ĕ`^Ĕzu -----------------------//
		pW->fDrawCtrls = TRUE;
		InvalidateRect(hwnd, NULL, TRUE);
		rc = TRUE;
	}
	return rc;
}
//----- vpeB擾iPAJCIVPROPC|j------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETPROP			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;

	if (IS_MY_INST(pW) && wParam != 0) {
		memcpy((VOP)wParam, &pW->prop, sizeof(AJCIVPROP));
		rc = TRUE;
	}
	return rc;
}
//----- vpeBݒiPAJCIVPROPC|j------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_SETPROP			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;

	if (IS_MY_INST(pW) && wParam != 0) {
		//----- vpeBݒ ---------------//
		SetCtrlProp(pW, (PAJCIVPROP)wParam);
		//----- Rg[֒l\ ---------//
		SetValueText(pW, pW->Value);
		//----- XC_ʒuݒ -------------//
		AjcSetCtrlSldPos(pW->ctrls.s.sld.hwnd, ValueToSldPos(pW, pW->Value));
		//----- ĕ`^Ĕzu -------------------//
		pW->fDrawCtrls = TRUE;
		InvalidateRect(hwnd, NULL, TRUE);
		rc = TRUE;
	}
	return rc;
}
//----- {[_[F擾i|C|j--------------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETBORDERCOLOR		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	COLORREF	rc = -1;

	if (IS_MY_INST(pW)) {
		rc = pW->RgbBorder;
	}
	return rc;
}
//----- {[_[FݒiFR[hC|j--------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_SETBORDERCOLOR		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	HPEN		hPen;

	if (IS_MY_INST(pW)) {
		if (hPen = CreatePen(PS_SOLID, 1, (COLORREF)wParam)) {
			if (pW->hPenBorder != NULL) DeleteObject(pW->hPenBorder);
			pW->RgbBorder  = (COLORREF)wParam;
			pW->hPenBorder = hPen;
			InvalidateRect(hwnd, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//----- uNF擾i|C|j--------------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETBLINKCOLOR		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	COLORREF	rc = -1;

	if (IS_MY_INST(pW)) {
		rc = pW->RgbBlink;
	}
	return rc;
}
//----- uNFݒiFR[hC|j--------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_SETBLINKCOLOR		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	HPEN		hPen;

	if (IS_MY_INST(pW)) {
		if (hPen = CreatePen(PS_SOLID, 1, (COLORREF)wParam)) {
			if (pW->hPenBlink != NULL) DeleteObject(pW->hPenBlink);
			pW->RgbBlink  = (COLORREF)wParam;
			pW->hPenBlink = hPen;
			InvalidateRect(hwnd, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//----- XC_nh擾i|C|j--------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETSLDHANDLE		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	HWND		rc = NULL;

	if (IS_MY_INST(pW)) {
		rc = pW->ctrls.s.sld.hwnd;
	}
	return (LRESULT)rc;
}
//----- eLXgnh擾i|C|j--------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETTXTHANDLE		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	return (LRESULT)pW->ctrls.s.txt.hwnd;
}
//----- {^nh擾i|C|j----------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETBTNHANDLE		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	HWND		rc = NULL;

	if (IS_MY_INST(pW)) {
		rc = pW->ctrls.s.btn.hwnd;
	}
	return (LRESULT)rc;
}
//----- Xsnh擾i|C|j----------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETSPNHANDLE		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	HWND		rc = NULL;

	if (IS_MY_INST(pW)) {
		rc = pW->ctrls.s.spn.hwnd;
	}
	return (LRESULT)rc;
}
//----- eLXg擾i|C|j--------------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETTXTLEN			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	UI			rc = 0;

	if (IS_MY_INST(pW)) {
		rc = pW->prop.TextLen;
	}
	return (LRESULT)rc;
}
//----- eLXgݒieLXgC|j------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_SETTXTLEN			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW)) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.TextLen = (UI)wParam;
		SetCtrlProp(pW, &prop);
		rc = TRUE;
	}
	return rc;
}
//----- l擾i|C|j------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_I_GETVALUE			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	int			rc = 0;

	if (IS_MY_INST(pW)) {
		rc = (int)pW->Value;
	}
	return rc;
}
//----- lݒilC|j--------------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_I_SETVALUE			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	int			pos;

	if (IS_MY_INST(pW)) {
		//----- uN~ -----------------//
		BlinkCancel(pW);
		//----- lݒ -----------------------//
		SetCurrentValue(pW, (int)wParam);
		//----- Rg[֒l\ ---------//
		SetValueText(pW, pW->Value);
		//----- XC_ʒuݒ -------------//
		pos = ValueToSldPos(pW, pW->Value);
		AjcSetCtrlSldPos(pW->ctrls.s.sld.hwnd, pos);
		//----- lʒm -----------------------//
		if (lParam != 0) {
			NotifyValue(pW);
		}
		rc = TRUE;
	}
	return rc;
}
//----- FWݒiŏlCőlj----------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_I_SETRANGE			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW)) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.min = (double)((int)wParam);
		prop.max = (double)((int)lParam);
		SetCtrlProp(pW, &prop);
		//----- Rg[֒l\ ---------//
		SetValueText(pW, pW->Value);
		//----- XC_ʒuݒ -------------//
		AjcSetCtrlSldPos(pW->ctrls.s.sld.hwnd, ValueToSldPos(pW, pW->Value));
		rc = TRUE;
	}
	return rc;
}
//----- Fl̍ŏPʁiŏPʁC|j-------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_I_SETSLDUNIT		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW)) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.SldUnit = (UI)wParam;
		SetCtrlProp(pW, &prop);
		rc = TRUE;
	}
	return rc;
}
//----- FXC_y[Wiy[WTCYC|j----------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_I_SETSLDPAGE		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW)) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.SldPage = (UI)wParam;
		SetCtrlProp(pW, &prop);
		rc = TRUE;
	}
	return rc;
}
//----- FXs̃XebviXebvTCYC|j------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_I_SETSPNSTEP		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW)) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.SpnStep = (UI)wParam;
		SetCtrlProp(pW, &prop);
		rc = TRUE;
	}
	return rc;
}
//----- l擾i&C|j--------------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_R_GETVALUE			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;

	if (IS_MY_INST(pW) && wParam != 0) {
		*((double *)wParam) = pW->Value;
		rc = TRUE;
	}
	return rc;
}
//----- lݒi&C|j--------------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_R_SETVALUE			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	int			pos;

	if (IS_MY_INST(pW) && wParam != 0) {
		//----- uN~ -----------------//
		BlinkCancel(pW);
		//----- lݒ -----------------------//
		SetCurrentValue(pW, *((double *)wParam));
		//----- Rg[֒l\ ---------//
		SetValueText(pW, pW->Value);
		//----- XC_ʒuݒ -------------//
		pos = ValueToSldPos(pW, pW->Value);
		AjcSetCtrlSldPos(pW->ctrls.s.sld.hwnd, pos);
		//----- lʒm -----------------------//
		if (lParam != 0) {
			NotifyValue(pW);
		}
		rc = TRUE;
	}
	return rc;
}
//----- FWݒi&ŏlC&őlj--------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_R_SETRANGE			)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW) && wParam != 0 && lParam != 0) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.min = *((double *)wParam);
		prop.max = *((double *)lParam);
		SetCtrlProp(pW, &prop);
		//----- Rg[֒l\ ---------//
		SetValueText(pW, pW->Value);
		//----- XC_ʒuݒ -------------//
		AjcSetCtrlSldPos(pW->ctrls.s.sld.hwnd, ValueToSldPos(pW, pW->Value));
		rc = TRUE;
	}
	return rc;
}
//----- Fl̍ŏPʁi&ŏPʁC|j-------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_R_SETSLDUNIT		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW) && wParam != 0) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.SldUnit = *((double *)wParam);
		SetCtrlProp(pW, &prop);
		rc = TRUE;
	}
	return rc;
}
//----- FXC_y[Wi&y[WTCYC|j---------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_R_SETSLDPAGE		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW) && wParam != 0) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.SldPage = *((double *)wParam);
		SetCtrlProp(pW, &prop);
		rc = TRUE;
	}
	return rc;
}
//----- FXs̃Xebvi&XebvTCYC|j-----------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_R_SETSPNSTEP		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW) && wParam != 0) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.SpnStep = *((double *)wParam);
		SetCtrlProp(pW, &prop);
		rc = TRUE;
	}
	return rc;
}
//----- FlxixC|j------------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_R_SETPREC		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;
	AJCIVPROP	prop;

	if (IS_MY_INST(pW)) {
		//----- vpeBlݒ -----------------//
		memcpy(&prop, &pW->prop, sizeof(AJCIVPROP));
		prop.Precision = (SW)wParam;
		SetCtrlProp(pW, &prop);
		rc = TRUE;
	}
	return rc;
}

//----- ENbNʒmݒ -------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_SETNTCRCLK		)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->fNtcRClk  = (BOOL)wParam;
		pW->MsgRBDown = LOWORD(lParam);
		pW->MsgRBUp	  = HIWORD(lParam);
		rc = TRUE;
	}
	return rc;
}

//----- lʒmvCxg(By PostMessage) -------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_NEEDNTC_INTVALUE)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);

	if (IS_MY_INST(pW)) {
		pW->fPendingNtcInt = FALSE;
		SendMessage(GetParent(pW->hBack),
					WM_COMMAND,
					MAKELONG(MAjcGetWindowLong(pW->hBack, GWL_ID), AJCIVN_INTVALUE),
					fCmdWithHdl ? (LPARAM)pW->hBack : (LPARAM)pW->Value);
	}
	return 0;
}
//----- lʒmvCxg(By PostMessage) -------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_NEEDNTC_REALVALUE)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);

	if (IS_MY_INST(pW)) {
		pW->fPendingNtcReal = FALSE;
		SendMessage(GetParent(pW->hBack),
					WM_COMMAND,
					MAKELONG(MAjcGetWindowLong(pW->hBack, GWL_ID), AJCIVN_REALVALUE),
					fCmdWithHdl ? (LPARAM)pW->hBack : (LPARAM)&pW->Value);
	}
	return 0;
}
//----- c[`bveLXgݒioCgj------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_SETTIPTEXTA	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (!pW->fEnaDefTip) {
			if (rc = SubSetTipTextA(&pW->pToolTipTxt, 0, (C_BCP)wParam)) {
				AjcTipTextAddW		   (pW->hBack, pW->pToolTipTxt);
				AjcTipTextSetCallBackA (pW->hBack, 0, NULL, NULL);
				AjcTipTextSetShowAlways(pW->hBack, pW->fShowAlways);
			}
		}
	}
	return rc;
}
//----- c[`bveLXgݒiChj------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_SETTIPTEXTW	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (!pW->fEnaDefTip) {
			if (rc = SubSetTipTextW(&pW->pToolTipTxt, 0, (C_WCP)wParam)) {
				AjcTipTextAddW		   (pW->hBack, pW->pToolTipTxt);
				AjcTipTextSetCallBackA (pW->hBack, 0, NULL, NULL);
				AjcTipTextSetShowAlways(pW->hBack, pW->fShowAlways);
			}
		}
	}
	return rc;
}
//----- c[`bveLXg擾ioCgj------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETTIPTEXTA	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = 0;

	if (IS_MY_INST(pW)) {
		if (wParam != 0	 &&	 lParam != 0) {
			rc = SubGetTipTextA(&pW->pToolTipTxt, 0, (BCP)wParam, (UI)lParam);
		}
	}
	return rc;
}
//----- c[`bveLXg擾iChj------------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVM_GETTIPTEXTW	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (wParam != 0 && lParam != 0) {
			rc = SubGetTipTextW(&pW->pToolTipTxt, 0, (WCP)wParam, (UI)lParam);
		}
	}
	return rc;
}
//----- c[`bveLXg̃TuNXʒm -------------------------------------------------------------//
AJC_WNDPROC(Main, AJCIVN_TIP_SUBCLASS	)
{
	PWRKINPVAL	pW = (PWRKINPVAL)MAjcGetWindowLong(hwnd, 0);
	LRESULT		rc = FALSE;

	//	TuNXʒm
	if (wParam) {
		//	eTuRg[̃c[`bv\
		IvClrDefaultTipText(pW);
	}
	//	TuNXʒm
	else {
		if (pW->fEnaDefTip) {
			//	eTuRg[̃c[`bv\
			IvSetDefaultTipText(pW);
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(Main)
	AJC_WNDMAP_MSG(Main, WM_CREATE				)
	AJC_WNDMAP_MSG(Main, WM_DESTROY				)
	AJC_WNDMAP_MSG(Main, WM_SIZE				)
	AJC_WNDMAP_MSG(Main, WM_TIMER				)
	AJC_WNDMAP_MSG(Main, WM_HSCROLL				)
	AJC_WNDMAP_MSG(Main, WM_PAINT				)
	AJC_WNDMAP_MSG(Main, WM_GETTEXTLENGTH		)
	AJC_WNDMAP_MSG(Main, WM_GETTEXT				)
	AJC_WNDMAP_MSG(Main, WM_SETTEXT				)
	AJC_WNDMAP_MSG(Main, WM_GETFONT				)
	AJC_WNDMAP_MSG(Main, WM_SETFONT				)
	AJC_WNDMAP_MSG(Main, WM_STYLECHANGED		)
	AJC_WNDMAP_MSG(Main, WM_ENABLE				)
	AJC_WNDMAP_MSG(Main, WM_RBUTTONDOWN			)
	AJC_WNDMAP_MSG(Main, WM_RBUTTONUP			)

	AJC_WNDMAP_CMD(Main, IV_IDC_TXT			)
	AJC_WNDMAP_CMD(Main, IV_IDC_BTN			)
	AJC_WNDMAP_NTC(Main, IV_IDC_SPN			)

	AJC_WNDMAP_MSG(Main, AJCIVM_SETTEXTFORMAT	)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETPROP			)
	AJC_WNDMAP_MSG(Main, AJCIVM_SETPROP			)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETBORDERCOLOR	)
	AJC_WNDMAP_MSG(Main, AJCIVM_SETBORDERCOLOR	)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETBLINKCOLOR	)
	AJC_WNDMAP_MSG(Main, AJCIVM_SETBLINKCOLOR	)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETSLDHANDLE	)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETTXTHANDLE	)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETBTNHANDLE	)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETSPNHANDLE	)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETTXTLEN		)
	AJC_WNDMAP_MSG(Main, AJCIVM_SETTXTLEN		)
	AJC_WNDMAP_MSG(Main, AJCIVM_I_GETVALUE		)
	AJC_WNDMAP_MSG(Main, AJCIVM_I_SETVALUE		)
	AJC_WNDMAP_MSG(Main, AJCIVM_I_SETRANGE		)
	AJC_WNDMAP_MSG(Main, AJCIVM_I_SETSLDUNIT	)
	AJC_WNDMAP_MSG(Main, AJCIVM_I_SETSLDPAGE	)
	AJC_WNDMAP_MSG(Main, AJCIVM_I_SETSPNSTEP	)
	AJC_WNDMAP_MSG(Main, AJCIVM_R_GETVALUE		)
	AJC_WNDMAP_MSG(Main, AJCIVM_R_SETVALUE		)
	AJC_WNDMAP_MSG(Main, AJCIVM_R_SETRANGE		)
	AJC_WNDMAP_MSG(Main, AJCIVM_R_SETSLDUNIT	)
	AJC_WNDMAP_MSG(Main, AJCIVM_R_SETSLDPAGE	)
	AJC_WNDMAP_MSG(Main, AJCIVM_R_SETSPNSTEP	)
	AJC_WNDMAP_MSG(Main, AJCIVM_R_SETPREC		)

	AJC_WNDMAP_MSG(Main, AJCIVM_SETNTCRCLK		)

	AJC_WNDMAP_MSG(Main, AJCIVM_NEEDNTC_INTVALUE )
	AJC_WNDMAP_MSG(Main, AJCIVM_NEEDNTC_REALVALUE)

	AJC_WNDMAP_MSG(Main, AJCIVM_SETTIPTEXTA		)
	AJC_WNDMAP_MSG(Main, AJCIVM_SETTIPTEXTW		)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETTIPTEXTA		)
	AJC_WNDMAP_MSG(Main, AJCIVM_GETTIPTEXTW		)

	AJC_WNDMAP_MSG(Main, AJCIVN_TIP_SUBCLASS	)
AJC_WNDMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	p^vpeBݒ																			//
//																												//
//	@	F	pTxt  - p^																			//
//				pProp - ݂̃vpeBlivpeBύX͏㏑j											//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetPropByText(PWRKINPVAL pW, WCP pTxt, PAJCIVPROP pProp)
{
	WCP			p  = NULL;
	AJCIVPROP	prop;

	if (wcsnicmp(pTxt, L"I:", 2) == 0	 ||	 wcsnicmp(pTxt, L"R:", 2) == 0) {
		//----- vpeBlRs[ -------------------------------------------//
		memcpy(&prop, pProp, sizeof(AJCIVPROP));
		//----- X^Cݒ ---------------------------------------------------//
		if	 (wcsnicmp(pTxt, L"I:", 2) == 0) pW->style &= ~AJCIVS_REALMODE;
		else								 pW->style |=  AJCIVS_REALMODE;
		//----- p^ ---------------------------------------------------//
		p = pTxt + 2;
		if (p = AjcStrTokW(p, L",")) {
			do {
				while (MAjcIsBlankW(*p)) p++;
				if		(wcsnicmp(p, L"L=" , 2) == 0) prop.min		 = AjcAscToReal(p+2);
				else if (wcsnicmp(p, L"R=" , 2) == 0) prop.max		 = AjcAscToReal(p+2);
				else if (wcsnicmp(p, L"U=" , 2) == 0) prop.SldUnit	 = AjcAscToReal(p+2);
				else if (wcsnicmp(p, L"G=" , 2) == 0) prop.SldPage	 = AjcAscToReal(p+2);
				else if (wcsnicmp(p, L"S=" , 2) == 0) prop.SpnStep	 = AjcAscToReal(p+2);
				else if (wcsnicmp(p, L"T=" , 2) == 0) prop.TextLen	 = AjcAscToInt(p+2);
				else if (wcsnicmp(p, L"P=" , 2) == 0) prop.Precision = (SW)AjcAscToInt(p+2);
				else if (wcsnicmp(p, L"H=" , 2) == 0) prop.HexLen	 = (SW)AjcAscToInt(p+2);
				else if (wcsnicmp(p, L"BC=", 3) == 0) SendMessage(pW->hBack, AJCIVM_SETBORDERCOLOR, AjcAscToInt(p+3), 0);
				else if (wcsnicmp(p, L"LC=", 3) == 0) SendMessage(pW->hBack, AJCIVM_SETBLINKCOLOR , AjcAscToInt(p+3), 0);
			} while(p = AjcStrTokW(NULL, L","));
		}
		//----- EChX^Cݒ -------------------------------------------//
		MAjcSetWindowLong(pW->hBack, GWL_STYLE, pW->style);

		//----- Rg[̃vpeBݒ -----------------------------------//
		memcpy(pProp, &prop, sizeof(AJCIVPROP));
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vpeBݒ																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetCtrlProp(PWRKINPVAL pW, PCAJCIVPROP pProp)
{
	//----- lŏPʐݒ -----------------------------------------------------------------------------------//
	pW->prop.SldUnit = fabs(pProp->SldUnit);
	//----- [hȂ΁Al̍ŏPʂPȏɒ -----------------------------------------------------//
	if (!(pW->style & AJCIVS_REALMODE)) {
		if (pW->prop.SldUnit < 1.0) pW->prop.SldUnit = 1.0;
	}
	else if (pW->prop.SldUnit == 0.0) {
		pW->prop.SldUnit = 0.000001;
	}
	//----- ő^ŏƑlݒ -----------------------------------------------------------------------------//
	pW->prop.min	 = pProp->min;
	pW->prop.max	 = pProp->max;
	pW->prop.SldPage = AjcAdjustMultValue(fabs(pProp->SldPage), pW->prop.SldUnit);
	pW->prop.SpnStep = AjcAdjustMultValue(fabs(pProp->SpnStep), pW->prop.SldUnit);
	//----- őlƍŏl̍lŏPʖ̏ꍇ́Aőlŏl}lŏPʂƂ -------------------//
	if (fabs(pW->prop.min - pW->prop.max) < pW->prop.SldUnit) {
		if (pProp->min < pProp->max) pW->prop.max = pW->prop.min + pW->prop.SldUnit;
		else						 pW->prop.max = pW->prop.min - pW->prop.SldUnit;
	}
	//----- [hȂ΁Aŏ^ől INT_MIN`INT_MAX ͈͓ɒ -------------------------------------//
	if (!(pW->style & AJCIVS_REALMODE)) {
		if		(pW->prop.min < (double)INT_MIN) pW->prop.min = (double)INT_MIN;
		else if (pW->prop.min > (double)INT_MAX) pW->prop.min = (double)INT_MAX;
		if		(pW->prop.max < (double)INT_MIN) pW->prop.max = (double)INT_MIN;
		else if (pW->prop.max > (double)INT_MAX) pW->prop.max = (double)INT_MAX;
	}
	//----- eLXgCxݒ -----------------------------------------------------------------------------//
	pW->prop.TextLen   = __max(1, (SI)pProp->TextLen);
	pW->prop.Precision =		  (SI)pProp->Precision;
	pW->prop.HexLen    = __max(0, (SI)pProp->HexLen);

	//----- l͈͂̍ŏlƍőlݒ -----------------------------------------------------------------------//
	pW->MinVal	 = __min(pProp->max, pProp->min);
	pW->MaxVal	 = __max(pProp->max, pProp->min);
	//----- l͈͒lݒ -------------------------------------------------------------------------------------//
	pW->ValWidth = fabs(pProp->max - pProp->min);
	//----- XC_͈͒l INT_MAX ȉɕ␳ ------------------------------------------------------------//
	if ((pW->ValWidth	  / pW->prop.SldUnit) <= (double)INT_MAX) pW->SldWidth = (UI)(pW->ValWidth	   / pW->prop.SldUnit);
	else														  pW->SldWidth = INT_MAX;
	//----- XC_y[Wl INT_MAX ȉɕ␳ --------------------------------------------------------------//
	if ((pW->prop.SldPage / pW->prop.SldUnit) <= (double)INT_MAX) pW->SldPgWid = (UI)(pW->prop.SldPage / pW->prop.SldUnit);
	else														  pW->SldPgWid = INT_MAX;
	//----- Xs{^̑ݒ -----------------------------------------------------------------------//
	if (pProp->min < pProp->max) {
		AjcSetCtrlSpnRange(pW->ctrls.s.spn.hwnd, -1,  1);
	}
	else {
		AjcSetCtrlSpnRange(pW->ctrls.s.spn.hwnd,  1, -1);
	}
	//----- XC_̃Wƃy[WTCYݒ -----------------------------------------------------------------//
	AjcSetCtrlSldRange(pW->ctrls.s.sld.hwnd, 0, pW->SldWidth, pW->SldPgWid);
	//----- ݂̐l𐔒lŏPʂ̔{ɕ␳ ---------------------------------------------------------------//
	SetCurrentValue(pW, pW->Value);
	//----- ݂̐leLXg\ ---------------------------------------------------------------------------//
	SetValueText(pW, pW->Value);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	uNieLXǵjJn																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		BlinkStart(PWRKINPVAL pW)
{
	RECT	r;
	int		w, h;

	pW->fBlkBusy  = TRUE;
	pW->fBlkDraw  = FALSE;
	pW->fBlkOn	  = FALSE;
	pW->BlkSvTick = GetTickCount() / 1000;
	SendMessage(pW->ctrls.s.txt.hwnd, EM_SETREADONLY, FALSE, 0);
	SetFocus   (pW->ctrls.s.txt.hwnd);
	SendMessage(pW->ctrls.s.txt.hwnd, EM_SETSEL, 0, -1);
	SetTimer(pW->hBack, IV_TID_BLINK, 30, NULL);

	if (!(pW->style & AJCIVS_NOBTN)) {
		GetWindowRect(pW->ctrls.s.btn.hwnd, &r);
		w = r.right - r.left;
		h = r.bottom - r.top;
		if ((h * 100 / w) < 200) {
			MAjcSetWindowLong(pW->ctrls.s.btn.hwnd, GWL_STYLE, MAjcGetWindowLong(pW->ctrls.s.btn.hwnd, GWL_STYLE) & ~BS_MULTILINE);
			SetWindowText(pW->ctrls.s.btn.hwnd, L"ok");
		}
		else {
			MAjcSetWindowLong(pW->ctrls.s.btn.hwnd, GWL_STYLE, MAjcGetWindowLong(pW->ctrls.s.btn.hwnd, GWL_STYLE) | BS_MULTILINE);
			SetWindowText(pW->ctrls.s.btn.hwnd, L"O\nK");
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	uNieLXǵjI																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		BlinkEnd(PWRKINPVAL pW)
{
	int		pos, i;
	double	val;
	WC		txt[256];

	if (pW->fBlkBusy) {
		pW->fBlkBusy  = FALSE;
		pW->fBlkDraw  = TRUE;
		pW->fBlkOn	  = FALSE;
		SendMessage(pW->ctrls.s.txt.hwnd, EM_SETREADONLY, TRUE, 0);
		KillTimer(pW->hBack, IV_TID_BLINK);
		//----- lݒ -----------------------//
		AjcGetCtrlStr(pW->ctrls.s.txt.hwnd, txt, AJCTSIZE(txt));
		for (i=0; i< AJCTSIZE(txt) - 1 && MAjcIsBlankW(txt[i]); i++);
		if (wcsnicmp(&txt[i], L"0x", 2) == 0) val = AjcGetCtrlHex (pW->ctrls.s.txt.hwnd);
		else								  val = AjcGetCtrlReal(pW->ctrls.s.txt.hwnd);
		SetCurrentValue(pW, val);
		//----- Rg[֒l\ ---------//
		SetValueText(pW, pW->Value);
		//----- XC_ʒuݒ -------------//
		pos = ValueToSldPos(pW, pW->Value);
		AjcSetCtrlSldPos(pW->ctrls.s.sld.hwnd, pos);
		//----- {^tF[X ---------------//
		SetWindowText(pW->ctrls.s.btn.hwnd, L"...");
		//----- ĕ` -----------------------//
		InvalidateRect(pW->hBack, NULL, FALSE);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	uNieLXǵjLZ																			//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		BlinkCancel(PWRKINPVAL pW)
{
	if (pW->fBlkBusy) {
		pW->fBlkBusy  = FALSE;
		pW->fBlkDraw  = TRUE;
		pW->fBlkOn	  = FALSE;
		SendMessage(pW->ctrls.s.txt.hwnd, EM_SETREADONLY, TRUE, 0);
		KillTimer(pW->hBack, IV_TID_BLINK);
		SetValueText(pW, pW->Value);
		SetWindowText(pW->ctrls.s.btn.hwnd, L"...");
		InvalidateRect(pW->hBack, NULL, FALSE);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	eLXgݒ																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetValueText(PWRKINPVAL pW, double val)
{
	if (pW->style & AJCIVS_SHOWHEX) {			//	PUi\H
		if (pW->prop.HexLen <= 0) AjcSetCtrlHex(pW->ctrls.s.txt.hwnd, (UI)val);
		else					  AjcSepCtrlHex(pW->ctrls.s.txt.hwnd, (UI)val, pW->prop.HexLen);
	}
	else {										//	POi\H
		if (pW->style & AJCIVS_SEPARATE) {
			if (pW->style & AJCIVS_REALMODE) AjcSepCtrlReal(pW->ctrls.s.txt.hwnd,	  val, pW->prop.Precision);
			else							 AjcSepCtrlSInt(pW->ctrls.s.txt.hwnd, (SI)val);
		}
		else {
			if (pW->style & AJCIVS_REALMODE) AjcSetCtrlReal(pW->ctrls.s.txt.hwnd,	  val, pW->prop.Precision);
			else							 AjcSetCtrlSInt(pW->ctrls.s.txt.hwnd, (SI)val);
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	\񐶐																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	UI	MakeValueText(PWRKINPVAL pW, WCP pBuf, UI lBuf)
{
	if (pW->style & AJCIVS_SHOWHEX) {			//	PUi\H
		if (pW->prop.HexLen <= 0) AjcSnPrintF(pBuf, lBuf, L"0x%X"	, (int)pW->Value);
		else					  AjcSnPrintF(pBuf, lBuf, L"0x%0*X"	, pW->prop.HexLen, (int)pW->Value);
	}
	else {										//	POi\H
		if (pW->style & AJCIVS_SEPARATE) {		//		؂LH
			if (pW->style & AJCIVS_REALMODE) {
				if (pW->prop.Precision >= 0) AjcSnPrtSep(pBuf, lBuf, L"%.*f", abs(pW->prop.Precision), pW->Value);
				else						 AjcSnPrtSep(pBuf, lBuf, L"%.*G", abs(pW->prop.Precision), pW->Value);
			}
			else {
				AjcSnPrtSep(pBuf, lBuf, L"%d"  , (int)pW->Value);
			}
		}
		else {									//		؂LȂH
			if (pW->style & AJCIVS_REALMODE) {
				if (pW->prop.Precision >= 0) AjcSnPrintF(pBuf, lBuf, L"%.*f", abs(pW->prop.Precision), pW->Value);
				else						 AjcSnPrintF(pBuf, lBuf, L"%.*G", abs(pW->prop.Precision), pW->Value);
			}
			else {
				AjcSnPrintF(pBuf, lBuf, L"%d"  , (int)pW->Value);
			}
		}
	}
	return (UI)wcslen(pBuf);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Rg[zu																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetControlPosition(PWRKINPVAL pW)
{
	TEXTMETRIC	tm;
	RECT		r;
	HDC			hdc;
	SIZE		sz1, sz2;
	int			x, cxChar, cyChar, lTxt;
	HFONT		hFont;

	//----- eLXg{bNX̌ݒ -------------------------------------------------------------------------//
	lTxt = pW->prop.TextLen;
	lTxt = __max(1, lTxt);
	//----- EChTCYݒ ---------------------------------------------------------------------------------//
	GetClientRect(pW->hBack, &r);
	pW->ww = r.right - r.left;
	pW->wh = r.bottom - r.top;
	//----- eLXgtHg̕ݒ -----------------------------------------------------------------------//
	hFont = (HFONT)SendMessage(pW->ctrls.s.txt.hwnd, WM_GETFONT, 0, 0);
	hdc   = GetDC(pW->hBack);
	hFont = (HFONT)SelectObject(hdc, hFont);
	GetTextMetrics(hdc, &tm);
	SelectObject(hdc, hFont);
	ReleaseDC(pW->hBack, hdc);
	cxChar = tm.tmAveCharWidth;
	cyChar = tm.tmHeight;
	//----- {^\ݒ -----------------------------------------------------------------------------------//
	hdc = GetDC(pW->ctrls.s.btn.hwnd);
	GetTextExtentPoint32(hdc, L"...", 1, &sz1);
	GetTextExtentPoint32(hdc, L"ok" , 1, &sz2);
	ReleaseDC(pW->ctrls.s.btn.hwnd, hdc);
	//----- Rg[̂xʒuƍݒ ---------------------------------------------------------------------//
	pW->y			   = 2;
	pW->cy			   = pW->wh - 4;
	//----- eRg[̕\ݒ -------------------------------------------------------------------------//
	pW->ctrls.s.btn.cx = pW->ctrls.s.spn.cx = pW->ctrls.s.txt.cx = pW->ctrls.s.sld.cx = 0;
	if (!(pW->style & AJCIVS_NOBTN)) pW->ctrls.s.btn.cx = __max(sz1.cx, sz2.cx) + 6;
									 pW->ctrls.s.txt.cx = cxChar * (lTxt + 1);
	if (!(pW->style & AJCIVS_NOSPN)) pW->ctrls.s.spn.cx = cyChar;
	if (!(pW->style & AJCIVS_NOSLD)) pW->ctrls.s.sld.cx = pW->ww - (pW->ctrls.s.btn.cx + pW->ctrls.s.spn.cx + pW->ctrls.s.txt.cx + 9);
	else							 pW->ctrls.s.txt.cx = pW->ww - (pW->ctrls.s.btn.cx + pW->ctrls.s.spn.cx						 + 9);
	//----- eRg[̕\wʒuݒ ---------------------------------------------------------------------//
	x = 3;
	if (!(pW->style & AJCIVS_NOSLD)) {pW->ctrls.s.sld.x = x; x += (pW->ctrls.s.sld.cx + 1);}
									 {pW->ctrls.s.txt.x = x; x += (pW->ctrls.s.txt.cx + 1);}
	if (!(pW->style & AJCIVS_NOBTN)) {pW->ctrls.s.btn.x = x; x += (pW->ctrls.s.btn.cx + 1);}
	if (!(pW->style & AJCIVS_NOSPN)) {pW->ctrls.s.spn.x = x;							   }
	//----- eRg[zu -------------------------------------------------------------------------------//
	if (!(pW->style & AJCIVS_NOSLD)) {
		if (pW->cy <= 24) {
			MoveWindow(pW->ctrls.s.sld.hwnd, pW->ctrls.s.sld.x, 1, pW->ctrls.s.sld.cx, pW->cy, TRUE);
		}
		else {
			MoveWindow(pW->ctrls.s.sld.hwnd, pW->ctrls.s.sld.x, 1 + ((pW->cy - 24) / 2), pW->ctrls.s.sld.cx, 24, TRUE);
		}
	}
									 MoveWindow(pW->ctrls.s.txt.hwnd, pW->ctrls.s.txt.x, 2, pW->ctrls.s.txt.cx, pW->cy, TRUE);
	if (!(pW->style & AJCIVS_NOBTN)) MoveWindow(pW->ctrls.s.btn.hwnd, pW->ctrls.s.btn.x, 2, pW->ctrls.s.btn.cx, pW->cy, TRUE);
	if (!(pW->style & AJCIVS_NOSPN)) MoveWindow(pW->ctrls.s.spn.hwnd, pW->ctrls.s.spn.x, 2, pW->ctrls.s.spn.cx, pW->cy, TRUE);
	//----- eRg[\^\ -----------------------------------------------------------------------//
	if (!(pW->style & AJCIVS_NOSLD)) ShowWindow(pW->ctrls.s.sld.hwnd, SW_SHOW); else ShowWindow(pW->ctrls.s.sld.hwnd, SW_HIDE);
									 ShowWindow(pW->ctrls.s.txt.hwnd, SW_SHOW);
	if (!(pW->style & AJCIVS_NOBTN)) ShowWindow(pW->ctrls.s.btn.hwnd, SW_SHOW); else ShowWindow(pW->ctrls.s.btn.hwnd, SW_HIDE);
	if (!(pW->style & AJCIVS_NOSPN)) ShowWindow(pW->ctrls.s.spn.hwnd, SW_SHOW); else ShowWindow(pW->ctrls.s.spn.hwnd, SW_HIDE);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	XC_ʒul ϊ																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	double	SldPosToValue(PWRKINPVAL pW, int pos)
{
	double	rc;
	
	if (pW->prop.min < pW->prop.max) {
		rc = pW->prop.min + (pW->ValWidth * (double)pos / (double)pW->SldWidth);
	}
	else {
		rc = pW->prop.min - (pW->ValWidth * (double)pos / (double)pW->SldWidth);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	lXC_ʒu ϊ																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	int		ValueToSldPos(PWRKINPVAL pW, double val)
{
	int		rc;
	
	if (pW->prop.min < pW->prop.max) {
		rc = (int)((val - pW->MinVal) * (double)pW->SldWidth / pW->ValWidth);
	}
	else {
		rc = (int)((pW->MaxVal - val) * (double)pW->SldWidth / pW->ValWidth);
	}
	
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	eECh֒lʒm																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		NotifyValue(PWRKINPVAL pW)
{
	if (pW->style & AJCIVS_REALMODE) {
		if (!pW->fPendingNtcReal) {
			pW->fPendingNtcReal = TRUE;
			PostMessage(pW->hBack, AJCIVM_NEEDNTC_REALVALUE, 0, 0);
		}
	}
	else {
		if (!pW->fPendingNtcInt) {
			pW->fPendingNtcInt = TRUE;
			PostMessage(pW->hBack, AJCIVM_NEEDNTC_INTVALUE, 0, 0);
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Rg[̗LԐݒ																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		EnableCtrls(PWRKINPVAL pW, BOOL fEnable)
{
	EnableWindow(pW->ctrls.s.sld.hwnd, fEnable);
	EnableWindow(pW->ctrls.s.txt.hwnd, fEnable);
	EnableWindow(pW->ctrls.s.btn.hwnd, fEnable);
	EnableWindow(pW->ctrls.s.spn.hwnd, fEnable);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	݂̐lݒ																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SetCurrentValue(PWRKINPVAL pW, double NewVal)
{
	//----- lŏPʂ̔{ɕ␳ --------------------------//
	pW->Value = AjcAdjustMultValue(NewVal, pW->prop.SldUnit);

	//----- őlJbg ----------------------------------------//
	if		(pW->Value >= pW->MaxVal) {
		pW->Value = pW->MaxVal;
	}
	//----- ŏlJbg ----------------------------------------//
	else if (pW->Value <= pW->MinVal) {
		pW->Value = pW->MinVal;
	}
}

