#include	"AjcInternal.h"
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	AjcCtrlXXXX ʃTu֐																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//==============================================================================================================//
//	c[`bvEeLXg擾iėpTu֐j																	//
//																												//
//	@	F	pTip		 - c[`bvւ̃|C^z														//
//				ix			 - zCfNX																	//
//				pBuf		 - c[`bvEeLXgi[obt@̃AhX							//
//				lBuf		 - c[`bvEeLXgi[obt@̕							//
//																												//
//	߂l	F	`bveLXg̃oCg^ipBuf=NULL̏ꍇ́AI[܂ށj							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
UI		SubGetTipTextA (C_WCP pTip[], UI ix, BCP pBuf, UI lBuf)
{
	UI		rc = 0;
	UI		len;

	if (pTip[ix] != NULL) {
		len = WideCharToMultiByte(CP_ACP, 0, pTip[ix], -1, NULL, 0, NULL, NULL);
		if (pBuf != NULL  &&  lBuf >= len) {
			WideCharToMultiByte(CP_ACP, 0, pTip[ix], -1, pBuf, lBuf, NULL, NULL);
			rc = (UI)strlen(pBuf);
		}
		else {
			rc = len;
		}
	}
	else {
		if (pBuf != NULL) {
			if (lBuf > 0) *pBuf = 0;
			rc = 0;
		}
		else {
			rc = 1;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
UI		SubGetTipTextW (C_WCP pTip[], UI ix, WCP pBuf, UI lBuf)
{
	UI		rc = 0;
	UI		len;

	if (pTip[ix] != NULL) {
		len = (UI)wcslen(pTip[ix]);
		if (pBuf != NULL && lBuf > len) {
			wcscpy(pBuf, pTip[ix]);
			rc = len;
		}
		else {
			rc = len + 1;
		}
	}
	else {
		if (pBuf != NULL) {
			if (lBuf > 0) *pBuf = 0;
			rc = 0;
		}
		else {
			rc = 1;
		}
	}
	return rc;
}
//==============================================================================================================//
//	tBB^i`FbN{bNXj̃c[`bvEeLXgݒ													//
//																												//
//	@	F	pTip		 - c[`bvւ̃|C^z														//
//				ix			 - zCfNX																	//
//				pTxt		 - ݒ肷c[`bvEeLXg̃AhX									//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
BOOL	SubSetTipTextA(WCP pTip[], UI ix, C_BCP pTxt)
{
	BOOL	rc = FALSE;
	WCP		pNew;
	UI		len;

	//	`bveLXgݒ
	if (pTxt != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pTxt, -1, NULL, 0);
		if (pNew = AjcTAllocW(len)) {
			//	`bveLXg
			if (pTip[ix] != NULL) free(pTip[ix]);
			//	V`bveLXgݒ
			pTip[ix] = pNew;
			MultiByteToWideChar(CP_ACP, 0, pTxt, -1, pTip[ix], len);
			rc = TRUE;
		}
	}
	else {
		//	`bveLXg
		if (pTip[ix] != NULL) free(pTip[ix]);
		//	`bveLXgNULL
		pTip[ix] = NULL;
		rc = TRUE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
BOOL	SubSetTipTextW(WCP pTip[], UI ix, C_WCP pTxt)
{
	BOOL	rc = FALSE;
	WCP		pNew;
	UI		len;

	//	`bveLXgݒ
	if (pTxt != NULL) {
		len = (UI)wcslen(pTxt);
		if (pNew = AjcTAllocW(len + 1)) {
			//	`bveLXg
			if (pTip[ix] != NULL) free(pTip[ix]);
			//	V`bveLXgݒ
			pTip[ix] = pNew;
			wcscpy(pTip[ix], pTxt);
			rc = TRUE;
		}
	}
	else {
		//	`bveLXg
		if (pTip[ix] != NULL) free(pTip[ix]);
		//	`bveLXgNULL
		pTip[ix] = NULL;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	^CgErbg}bv																					//
//																												//
//	@	F	pT			- ^Cg`񃏁[Nւ̃|C^												//
//				hwnd		- ^Cg`悷EChnh												//
//				pTtlTxt		- ^CgeLXg																	//
//				txtColor	- eLXg`F																	//
//				bakColor	- wiF																			//
//				hFont		- tHgnh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
BOOL	SubTtlBmpMake(PCTRL_TTLINFO  pT, HWND hwnd, C_WCP pTtlTxt, COLORREF txtColor, COLORREF bakColor, HFONT hFont)
{
	BOOL	rc = FALSE;
	RECT	wr;				//	ECh`
	RECT	tr;				//	^Cg`
	HDC		wdc;			//	EChcb
	UI		stl;			//	^CgeLXg
	HDC		mdc;			//	^Cgcb
	HBITMAP	hBmpSv = NULL;	//	rbg}bvnhޔ
	HBRUSH	hBru, hBruSv;
	HPEN	hPen, hPenSv;

	if (pTtlTxt != NULL && *pTtlTxt != 0) {
		//	ftHglݒ
		if (txtColor == -1  ) txtColor = RGB(255, 255, 255);
		if (bakColor == -1  ) bakColor = RGB(128, 128, 128);
		if (hFont    == NULL) hFont    = hDefFontVar;
		//	ECh`ݒ
		GetClientRect(hwnd, &wr);
		//	EChcb擾
		wdc = GetDC(hwnd);
		//	^CgeLXgݒ
		stl = (UI)wcslen(pTtlTxt);
		//	^Cgrbg}bvcb
		if (mdc = CreateCompatibleDC(wdc)) {
			hFont = (HFONT)SelectObject(mdc, hFont);
			//	^CgsNZTCYݒ
			GetTextExtentPoint32(mdc, pTtlTxt, stl, &pT->szBmp);
			pT->szBmp.cx += 4; pT->szBmp.cy += 2;		//	EQsNZC㉺PsNZZ
			tr.left   = tr.top = 0;
			tr.right  = pT->szBmp.cx;
			tr.bottom = pT->szBmp.cy;
			//	ÕEChL̃rbg}bv
			if (pT->hBmpEna != NULL) {
				DeleteObject(pT->hBmpEna);
			}
			//	EChL̃rbg}bv
			if (pT->hBmpEna = CreateCompatibleBitmap(wdc, pT->szBmp.cx, pT->szBmp.cy)) {
				hBmpSv = (HBITMAP)SelectObject(mdc, pT->hBmpEna);
				FillRect(mdc, &tr, (HBRUSH)GetStockObject(WHITE_BRUSH));
				SetBkMode(mdc, TRANSPARENT);
				hBruSv = NULL;
				hPenSv = NULL;
				if ((hBru = CreateSolidBrush(bakColor)) && (hPen = CreatePen(PS_SOLID, 1, (COLORREF)bakColor))) {
					hBruSv = (HBRUSH)SelectObject(mdc, hBru);
					hPenSv = ( HPEN )SelectObject(mdc, hPen);
					RoundRect(mdc, 0, 0, pT->szBmp.cx, pT->szBmp.cy, 3, 3);
					SetTextColor(mdc, txtColor);
					TextOut(mdc, 2, 1, pTtlTxt, stl);
				}
				if (hBruSv != NULL) DeleteObject(SelectObject(mdc, hBruSv));
				if (hPenSv != NULL) DeleteObject(SelectObject(mdc, hPenSv));
				SelectObject(mdc, hBmpSv);
			}
			//	ÕECh̃rbg}bv
			if (pT->hBmpDis != NULL) {
				DeleteObject(pT->hBmpDis);
			}
			//	ECh̃rbg}bv
			if (pT->hBmpDis = CreateCompatibleBitmap(wdc, pT->szBmp.cx, pT->szBmp.cy)) {
				hBmpSv = (HBITMAP)SelectObject(mdc, pT->hBmpDis);
				FillRect(mdc, &tr, (HBRUSH)GetStockObject(WHITE_BRUSH));
				SetBkMode(mdc, TRANSPARENT);
				hBruSv = NULL;
				hPenSv = NULL;
				if ((hBru = CreateSolidBrush(GetSysColor(COLOR_BTNSHADOW))) && (hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW)))) {
					hBruSv = (HBRUSH)SelectObject(mdc, hBru);
					hPenSv = ( HPEN )SelectObject(mdc, hPen);
					RoundRect(mdc, 0, 0, pT->szBmp.cx, pT->szBmp.cy, 3, 3);
					SetTextColor(mdc, GetSysColor(COLOR_BTNHILIGHT));
					TextOut(mdc, 2, 1, pTtlTxt, stl);
				}
				if (hBruSv != NULL) DeleteObject(SelectObject(mdc, hBruSv));
				if (hPenSv != NULL) DeleteObject(SelectObject(mdc, hPenSv));
				SelectObject(mdc, hBmpSv);
			}
			//	߂l=ݒ
			rc = (pT->hBmpEna != NULL && pT->hBmpDis != NULL);
			//	tHgZNV
			SelectObject(mdc, hFont);
			//	^Cgrbg}bvcb
			DeleteDC(mdc);
		}
		//	EChcb
		ReleaseDC(hwnd, wdc);
	}
	else {
		if (pT->hBmpEna != NULL) {DeleteObject(pT->hBmpEna); pT->hBmpEna = NULL;}
		if (pT->hBmpDis != NULL) {DeleteObject(pT->hBmpDis); pT->hBmpDis = NULL;}
		pT->szBmp.cx = pT->szBmp.cy = 0;
	}
	return rc;
}
//==============================================================================================================//
//	^CgErbg}bv`																					//
//																												//
//	@	F	pT			- ^Cg`񃏁[Nւ̃|C^												//
//				hwnd		- ^Cg`悷EChnh												//
//				hdc			- ^Cg`悷ECĥcb													//
//				y			- csNZʒu																	//
//				rMargin		- EChE[}[W																//
//				fEnable		- EChL																	//
//				BkColor		- wiF																			//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
BOOL	SubTtlBmpDraw (PCCTRL_TTLINFO pT, HWND hwnd, HDC hdc, int y, int rMargin, BOOL fEnable)
{
	return SubTtlBmpDrawC(pT, hwnd, hdc, y, rMargin, fEnable, (COLORREF)-1);
}
//--------------------------------------------------------------------------------------------------------------//
BOOL	SubTtlBmpDrawC(PCCTRL_TTLINFO pT, HWND hwnd, HDC hdc, int y, int rMargin, BOOL fEnable, COLORREF BkColor)
{
	BOOL	rc = FALSE;
	HDC		mdc;
	HBITMAP	hBmp;
	RECT	wr;

	//	^Cgrbg}bvcb쐬
	if (mdc = CreateCompatibleDC(hdc)) {
		//	rbg}bvI
		if (fEnable) hBmp = pT->hBmpEna;
		else         hBmp = pT->hBmpDis;
		if (hBmp != NULL) {
			hBmp = SelectObject(mdc, hBmp);
			//	rbg}bv̎lɔwiFݒ
			if (fEnable && BkColor != (COLORREF)-1) {
				SetPixel(mdc, 0              , 0              , BkColor);
				SetPixel(mdc, pT->szBmp.cx -1, 0              , BkColor);
				SetPixel(mdc, pT->szBmp.cx -1, pT->szBmp.cy -1, BkColor);
				SetPixel(mdc, 0              , pT->szBmp.cy -1, BkColor);
			}
			//	^Cgrbg}bvEChɃRs[
			GetClientRect(hwnd, &wr);
			BitBlt(hdc, wr.right - (pT->szBmp.cx + 2 + rMargin), y, pT->szBmp.cx, pT->szBmp.cy, mdc, 0, 0, SRCCOPY);
			//	rbg}bṽ}bsO
			SelectObject(mdc, hBmp);
			//	^Cgrbg}bvcb
			DeleteDC(mdc);
			//	߂lݒ
			rc = TRUE;
		}
		//	cb
		DeleteDC(mdc);
	}
	return rc;
}
//==============================================================================================================//
//	^CgErbg}bvj																					//
//																												//
//	@	F	pT			- ^Cg`񃏁[Nւ̃|C^												//
//				hwnd		- ^Cg`悷EChnh												//
//				hdc			- ^Cg`悷ECĥcb													//
//				rMargin		- EChE[}[W																//
//				fEnable		- EChL																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
BOOL	SubTtlBmpRemv(PCTRL_TTLINFO pT)
{
	BOOL	rc = FALSE;

	if (pT->hBmpEna != NULL) {
		DeleteObject(pT->hBmpEna);
		pT->hBmpEna = NULL;
	}
	if (pT->hBmpDis != NULL) {
		DeleteObject(pT->hBmpDis);
		pT->hBmpDis = NULL;
	}
	return rc;
}

