#include	"AjcInternal.h"
#include	"AjcCtrlTimeChartDef.h"
//**************************************************************************************************************//
//																												//
//	JX^Rg[i^C`[gj				`oh													//
//																												//
//**************************************************************************************************************//

#define	IS_MY_INST(P)	(P != NULL && P->InstID == TCH_INST_ID)

//--------------------------------------------------------------------------------------------------------------//
//	O[o[N																							//
//--------------------------------------------------------------------------------------------------------------//
ATOM	TchClassBack	= 0;			//	obNEChNX
ATOM	TchClassMain	= 0;			//	CEChNX
ATOM	TchClassFilter	= 0;			//	tB^EChNX
ATOM	TchClassMeasure	= 0;			//	W[EChNX
ATOM	TchClassForMSIL	= 0;			//	lrhkT|[g
HFONT	TchMyFont 		= NULL;			//	tHgnhiXP[l\pj

ULL		TchPfmFreq		= 0;			//	ptH[}XJE^̎giOFptH[}XJE^sj
HPEN	TchPenGauBar	= NULL;			//	ԑQ[Wo[̃y

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	ULL		GetUsCount		  (VO);

//==============================================================================================================//
//	Nݒ																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
BOOL	AjcCtrlTmChartInit(VO)
{
	BOOL		rc = FALSE;
	WNDCLASS	wndclass;
	LOGFONT		lf;
	LARGE_INTEGER freq;

	do {
		//----- ptH[}XJE^g擾 --------------//
		if (QueryPerformanceFrequency(&freq) != 0) {
			TchPfmFreq = freq.QuadPart;
		}
		//----- tHg --------------------------------------//
		lf.lfHeight			= -9;	lf.lfStrikeOut		= 0;
		lf.lfWidth			= 0;	lf.lfCharSet		= DEFAULT_CHARSET;
		lf.lfEscapement		= 0;	lf.lfOutPrecision	= 0;
		lf.lfOrientation	= 0;	lf.lfClipPrecision	= 0;
		lf.lfWeight			= 0;	lf.lfQuality		= 0;
		lf.lfItalic			= 0;	lf.lfPitchAndFamily	= VARIABLE_PITCH;
		lf.lfUnderline		= 0;	wcscpy(lf.lfFaceName, L"Arial");
		if ((TchMyFont = CreateFontIndirect(&lf)) == NULL) break;

		//----- ԑpQ[Wo[ y ----------------//
		if ((TchPenGauBar = CreatePen(PS_DOT, 1, TCH_GAUGE_COLOR)) == NULL) break;

		//----- JX^Rg[ENX -----------------//
		wndclass.style			= CS_HREDRAW | CS_VREDRAW | CS_GLOBALCLASS;
		wndclass.lpfnWndProc	= TchWndProcBack();
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= sizeof(PWRKTMCHART);
		wndclass.hInstance		= hDllInst;
		wndclass.hIcon			= NULL;
		wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= L"AjcCtrlTmChart";
		if ((TchClassBack = RegisterClass(&wndclass)) == 0) break;

		//----- C`EChNX ---------------------//
		wndclass.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
		wndclass.lpfnWndProc	= TchWndProcMain();
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= sizeof(PWRKTMCHART);
		wndclass.hInstance		= hDllInst;
		wndclass.hIcon			= NULL;
		wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);;
		wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= L"AjcTmChartMainClass";
		if ((TchClassMain = RegisterClass(&wndclass)) == 0) break;

		//----- tB^EEChNX ----------------------//
		wndclass.style			= 0;
		wndclass.lpfnWndProc	= TchWndProcFilt();
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= sizeof(PWRKTMCHART);
		wndclass.hInstance		= hDllInst;
		wndclass.hIcon			= NULL;
		wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);;
		wndclass.hbrBackground	= (HBRUSH)GetStockObject(LTGRAY_BRUSH);
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= L"AjcTmChartFilterClass";
		if ((TchClassFilter = RegisterClass(&wndclass)) == 0) break;

		//----- lrhkR[hT|[gp ---------------------//
		wndclass.style			= 0;
		wndclass.lpfnWndProc	= TchWndProcMSIL();
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= sizeof(VOP);
		wndclass.hInstance		= hDllInst;
		wndclass.hIcon			= NULL;
		wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= L"AjcTchForMSIL";
		if ((TchClassForMSIL = RegisterClass(&wndclass)) == 0) break;


		rc = TRUE;
	} while(0);

	if (rc == FALSE) {
		AjcCtrlTmChartEnd();
	}

	return rc;
}
//==============================================================================================================//
//	I㏈																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
VO		AjcCtrlTmChartEnd (VO)
{
	HINSTANCE	hModInst = GetModuleHandle(NULL);

	if (TchClassBack	!= 0	) {UnregisterClass((WCP)TchClassBack   , hDllInst); TchClassBack	= 0;   }
	if (TchClassMain	!= 0	) {UnregisterClass((WCP)TchClassMain   , hDllInst); TchClassMain	= 0;   }
	if (TchClassFilter	!= 0	) {UnregisterClass((WCP)TchClassFilter , hDllInst); TchClassFilter	= 0;   }
	if (TchClassMeasure	!= 0	) {UnregisterClass((WCP)TchClassMeasure, hDllInst); TchClassMeasure	= 0;   }
	if (TchClassForMSIL != 0	) {UnregisterClass((WCP)TchClassForMSIL, hDllInst); TchClassForMSIL = 0;   }
	if (TchMyFont 		!= NULL ) {DeleteObject   (TchMyFont					 ); TchMyFont 		= NULL;}
	if (TchPenGauBar 	!= NULL ) {DeleteObject   (TchPenGauBar					 ); TchPenGauBar	= NULL;}
}


//==============================================================================================================//
//	~																										//
//																												//
//	@	F	hwnd	- EChnh																		//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchStop			(HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fStop = TRUE;		//	vbg~
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	Jn																										//
//																												//
//	@	F	hwnd	- EChnh																		//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchStart			(HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fStop = FALSE;		//	vbgJn
			TchMesPeriReset(pW);	//	vbgvZbg
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	vbgf[^																							//
//																												//
//	@	F	hwnd	- EChnh																		//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchPurge	(HWND hwnd)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			//----- obt@NA[ ------------//
			pW->ixView = 0;
			pW->nView  = 0;
			pW->nBuf   = 0;
			pW->nTotal = 0;
			pW->ixBuf  = 0;
			//----- ĕ\ ----------------------//
			InvalidateRect(pW->hMain, NULL, FALSE);
			//----- obt@NA[ʒm --------//
			SendMessage(GetParent(pW->hBack), WM_COMMAND, MAKELONG(MAjcGetWindowLong(pW->hBack, GWL_ID), AJCTCN_CLEAR), (LPARAM)pW->hBack);
		}
	}
	return rc;
}
//==============================================================================================================//
//	f[^ݒ																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				dat		- f[^z̃AhX																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchPutRealData	(HWND hwnd, double dat[])
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && dat != NULL) {
			double			*pDat = dat;
			double			*pBuf = pW->pBuf + (pW->ixBuf * pW->prop.MaxItem);
			PTCH_VLINEBUF	 pVLi = pW->pVLi + (pW->ixBuf					);
			SCROLLINFO		si;
			UI				i, j, ix, nAve;

			//----- vbgv ----------------------//
			if (pW->MesPeriCnt == 0) {
				pW->MesPeriSrt = GetUsCount();
			}
			else {
				ULL		tick	= GetUsCount();
				ULL		elapsed = tick - pW->MesPeriSrt;
				pW->MesPeriAve	= (UI)(elapsed / pW->MesPeriCnt);
			}
			pW->MesPeriCnt++;		//	vbgJE^

			//----- vbgϒl𔽉f --------------//
			if (pW->MesPeriCnt == pW->MesPeriSetAveS) {
				pW->MesPeriAveS = pW->MesPeriAve;
			}

			//----- ړϏ --------------------------//
			//	ړϖiωPj
			if (pW->prop.AveNum <= 1) {
				for (i = 0; i < pW->prop.MaxItem; i++) {
					pW->AveDat[i] = *pDat++;
				}
			}
			//	ړϗL
			else {
				//	ړςݒ
				if (pW->nBuf < pW->prop.MaxBuf) nAve = pW->nBuf + 1;
				else							nAve = pW->nBuf;
				nAve = __min(nAve, pW->prop.AveNum);
				//	Zobt@NA[
				memset(pW->AveDat, 0, sizeof pW->AveDat);
				//	O̕ό|P̃f[^Z
				if (nAve >= 2) {
					for (i = 0; i < pW->prop.MaxItem; i++) {
						for (j = 0, ix = (pW->ixBuf == 0 ? pW->prop.MaxBuf - 1 : pW->ixBuf - 1);
							 j < nAve - 1;
							 j++  , ix = (ix		== 0 ? pW->prop.MaxBuf - 1 : ix 	   - 1)) {
							pW->AveDat[i] += *(pW->pBuf + ((ix * pW->prop.MaxItem) + i));
						}
					}
				}
				//	f[^Zω
				for (i = 0; i < pW->prop.MaxItem; i++) {
					pW->AveDat[i] += *pDat++;
					pW->AveDat[i] /= (double)nAve;
				}
			}
			//----- f[^ݒ ----------------------------//
			if (!pW->fStop) {													//	~ȊOH
				pW->nTotal++;													//		ʎZf[^XV
				memcpy(pBuf, pW->AveDat, sizeof(double) * pW->prop.MaxItem);	//		obt@փf[^ݒ
				memset(pVLi, 0, sizeof(TCH_VLINEBUF));							//		cCNA[
				if (pW->nBuf < pW->prop.MaxBuf) pW->nBuf++;						//		obt@f[^XV
				pW->ixBuf = (pW->ixBuf + 1) % pW->prop.MaxBuf;					//		obt@CfNXXV

				if (pW->fPause) {												//		\~H
					TchSetViewIndex(pW);										//			\Jnʒuݒ
					TchSetViewWidth(pW);										//			\f[^ݒ
				}
				else {															//		\~ȊOH
					si.cbSize = sizeof(SCROLLINFO);								//				
					si.fMask  = SIF_POS;										//				
					if (!pW->fScrBar) {											//			XN[o[񑀍쒆H
						TchSetViewIndex(pW);									//				\Jnʒuݒ
						si.nPos = TchBixToDix(pW, pW->ixView);					//				XN[o[XV
						SetScrollInfo(pW->hMain, SB_HORZ, &si, TRUE);			//				E
					}
					else {														//			XN[o[쒆H
						GetScrollInfo(pW->hMain, SB_HORZ, &si);					//				\JnʒuA
						pW->ixView = TchDixToBix(pW, si.nPos);					//				XN[o[ʒuƂ
					}
					TchSetViewWidth(pW);										//			\f[^ݒ
					InvalidateRect(pW->hMain, NULL, FALSE);						//			ĕ`
				}
			}
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	f[^ݒ																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				dat		- f[^z̃AhX																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchPutIntData   (HWND hwnd, int dat[])
{
	BOOL		rc = FALSE;
	UI			i;
	double		rdat[AJCTC_MAXITEM];

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && dat != NULL) {
			for (i=0; i<pW->prop.MaxItem; i++) {
				rdat[i] = (double)dat[i];
			}
			rc = AjcTchPutRealData(hwnd, rdat);
		}
	}
	return rc;
}

//==============================================================================================================//
//	Og\																									//
//																												//
//	@	F	hwnd	- EChnh																		//
//				fShow	- TRUE : \CFALSE : \															//
//				rgb		- \Fi|PFύXȂj																//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchShowBorder	(HWND hwnd, BOOL fShow, COLORREF rgb)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			int		sty;
			if (rgb != -1) {
				TchSetBorderColor(pW, rgb);
			}
			sty = (int)MAjcGetWindowLong(hwnd, GWL_STYLE);
			if (fShow) sty &= ~AJCTCS_NOBORDER;
			else	   sty |=  AJCTCS_NOBORDER;
			MAjcSetWindowLong(hwnd, GWL_STYLE, sty);
			InvalidateRect(hwnd, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	tB^\																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				fShow	- TRUE : \CFALSE : \															//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchShowFilter	(HWND hwnd, BOOL fShow)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			int		sty;
			sty = (int)MAjcGetWindowLong(hwnd, GWL_STYLE);
			if (fShow) sty &= ~AJCTCS_NOFILTER;
			else	   sty |=  AJCTCS_NOFILTER;
			MAjcSetWindowLong(hwnd, GWL_STYLE, sty);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	XP[\																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				fLine	- TRUE : XP[C\CFALSE : \												//
//				fValue	- TRUE : XP[l\	   CFALSE : \												//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchShowScale(HWND hwnd, BOOL fLine, BOOL fValue)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			int		sty;
			sty = (int)MAjcGetWindowLong(hwnd, GWL_STYLE);
			if (fLine)	sty &= ~AJCTCS_NOSCALELINE;
			else		sty |=	AJCTCS_NOSCALELINE;
			if (fValue) sty &= ~AJCTCS_NOSCALEVALUE;
			else		sty |=	AJCTCS_NOSCALEVALUE;
			MAjcSetWindowLong(hwnd, GWL_STYLE, sty);
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	vpeB擾																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				pBuf	- 擾vpeBi[obt@̃AhX										//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchGetProp		(HWND hwnd, PAJCTCPROP	pBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pBuf != NULL) {
			rc = TchGetProp(pW, pBuf);
		}
	}
	return rc;
}
//==============================================================================================================//
//	vpeBݒ																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				pProp	- ݒ肷vpeBf[^̃AhX													//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetProp		(HWND hwnd, PCAJCTCPROP pProp)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProp != NULL) {
			rc = TchSetProp(pW, pProp);
		}
	}
	return rc;
}

//==============================================================================================================//
//	W擾																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				low		- OtWi[obt@̃AhX											//
//				high	- Ot㕔Wi[obt@̃AhX											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchGetRealRange	(HWND hwnd, double *low, double *high)
{
	BOOL		rc = FALSE;
	AJCTCPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (rc = TchGetProp(pW, &prop)) {
				if (low  != NULL) *low	= prop.RngL;
				if (high != NULL) *high = prop.RngH;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Wݒ																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				low		- OtW																		//
//				high	- Ot㕔W																		//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetRealRange	(HWND hwnd, double low, double high)
{
	BOOL		rc = FALSE;
	AJCTCPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			memcpy(&prop, &pW->prop, sizeof(AJCTCPROP));
			prop.RngL = low;
			prop.RngH = high;
			rc = TchSetProp(pW, &prop);
		}
	}
	return rc;
}
//==============================================================================================================//
//	W擾																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				low		- OtWi[obt@̃AhX											//
//				high	- Ot㕔Wi[obt@̃AhX											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchGetIntRange  (HWND hwnd, int *low, int *high)
{
	BOOL		rc = FALSE;
	AJCTCPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (rc = TchGetProp(pW, &prop)) {
				if (low  != NULL) *low	= (int)prop.RngL;
				if (high != NULL) *high = (int)prop.RngL;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Wݒ																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				low		- OtW																		//
//				high	- Ot㕔W																		//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetIntRange	(HWND hwnd, int	   low, int	   high)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			double	l = (double)low;
			double	h = (double)high;
			rc = AjcTchSetRealRange(hwnd, l, h);
		}
	}
	return rc;
}
//==============================================================================================================//
//	W																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchAdjustRange	(HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			UI				n = pW->nBuf * pW->prop.MaxItem;
			double			min =  DBL_MAX;
			double			max = -DBL_MAX;
			double			ofs;
			double			*p;
			AJCTCPROP		prop;
			UI				i, msk;
			double			SvRngL = pW->prop.RngL;
			double			SvRngH = pW->prop.RngH;

			memcpy(&prop, &pW->prop, sizeof(AJCTCPROP));

			if (pW->nBuf != 0  &&  (pW->MskFilt & ((1 << pW->prop.MaxItem) - 1)) != 0) {
				//----- ŏl^ől ------------//
				for (i=0, msk=0x01, p=pW->pBuf; i<n; i++, msk<<=1, p++) {
					if (msk & (1 << pW->prop.MaxItem)) {
						msk = 0x01;
					}
					if (pW->MskFilt & msk) {
						ofs = pW->prop.Item[i % pW->prop.MaxItem].ofs;
						min = __min(min, (*p + ofs));
						max = __max(max, (*p + ofs));
					}
				}
				//----- }[Wݒ ------------------//
				if (min == max) {
					min--;
					max++;
				}
				else {
					min -= ((max - min) * 0.05);
					max += ((max - min) * 0.05);
				}
				//----- Wݒ --------------------//
				if (prop.RngL <= prop.RngH) {
					prop.RngL = min;
					prop.RngH = max;
				}
				else {
					prop.RngL = max;
					prop.RngH = min;
				}
				//----- Wωʒm -----------------//
				if (SvRngL != pW->prop.RngL || SvRngH != pW->prop.RngH) {
					pW->NtcRng.RngL = pW->prop.RngL;
					pW->NtcRng.RngH = pW->prop.RngH;
					SendMessage(GetParent(pW->hBack), WM_COMMAND,
								MAKELONG(MAjcGetWindowLong(pW->hBack, GWL_ID), AJCTCN_RANGE),
								fCmdWithHdl ? (LPARAM)pW->hBack : (LPARAM)&pW->NtcRng);
				}
				rc = TchSetProp(pW, &prop);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	obt@TCYݒ																							//
//																												//
//	@	F	hwnd	- EChnh																		//
//				n		- obt@̃TCYi[f[^Ŏw												//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetBufSize	(HWND hwnd, int n)
{
	BOOL		rc = FALSE;
	AJCTCPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			memcpy(&prop, &pW->prop, sizeof(AJCTCPROP));
			prop.MaxBuf = n;
			rc = TchSetProp(pW, &prop);
		}
	}
	return rc;
}
//==============================================================================================================//
//	f[^ڐݒ																							//
//																												//
//	@	F	hwnd	- EChnh																		//
//				n		- ݒ肷f[^ڐ																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetItemNumber (HWND hwnd, int n)
{
	BOOL		rc = FALSE;
	AJCTCPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			memcpy(&prop, &pW->prop, sizeof(AJCTCPROP));
			prop.MaxItem = n;
			rc = TchSetProp(pW, &prop);
		}
	}
	return rc;
}
//==============================================================================================================//
//	ωݒ																								//
//																												//
//	@	F	hwnd	- EChnh																		//
//				n		- ݒ肷f[^ڐ																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetAveNumber (HWND hwnd, int n)
{
	BOOL		rc = FALSE;
	AJCTCPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			memcpy(&prop, &pW->prop, sizeof(AJCTCPROP));
			prop.AveNum = n;
			rc = TchSetProp(pW, &prop);
		}
	}
	return rc;
}
//==============================================================================================================//
//	^CXP[ݒ																						//
//																												//
//	@	F	hwnd	- EChnh																		//
//				n		- ݒ肷^CXP[iO̓^CXP[\j									//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetTimeScale(HWND hwnd, int n)
{
	BOOL		rc = FALSE;
	AJCTCPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			memcpy(&prop, &pW->prop, sizeof(AJCTCPROP));
			prop.TmScale = n;
			rc = TchSetProp(pW, &prop);
		}
	}
	return rc;
}
//==============================================================================================================//
//	rbg}bv擾																							//
//																												//
//	@	F	hwnd	- EChnh																		//
//																												//
//	߂l	F	NULLFrbg}bvnh																	//
//				NULLFG[																					//
//==============================================================================================================//
AJCEXPORT	HBITMAP		WINAPI	AjcTchGetBitmap		(HWND hwnd)
{
	HBITMAP	hBm = NULL;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			hBm = CopyImage(pW->hBitmap, IMAGE_BITMAP, pW->ww, pW->wh, LR_COPYRETURNORG);
		}
	}
	return hBm;
}
//==============================================================================================================//
//	vt@CiǂݏoiWj																	//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV														//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPermInfoA		(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix)
{
	BOOL		rc = TRUE;

	rc = AjcTchLoadPermInfoExA(hwnd, pProfileSect, pKeyPrefix, AJCTCH_PERM_FILTER);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPermInfoW		(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix)
{
	BOOL		rc = TRUE;

	rc = AjcTchLoadPermInfoExW(hwnd, pProfileSect, pKeyPrefix, AJCTCH_PERM_FILTER);

	return rc;
}
//==============================================================================================================//
//	vt@Ciǂݏoiڎwj																//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV  isvNULL)										//
//				pKeyPrefix	 - L[̐擪ւ̃|C^isvNULL)										//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
#define			MKKEY(TAIL)		MkKey(pKeyPrefix, TAIL, szKey, AJCTSIZE(szKey))
static	C_WCP	MkKey(C_WCP pKeyPrefix, WCP pTail, WCP pKey, UI lKey)
{
	AjcSnPrintF(pKey, lKey, L"%s_%s", pKeyPrefix, pTail);
	return	pKey;
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPermInfoExA		(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmpSec = NULL;
	WCP		pTmpKey = NULL;

	do {
		if (pProfileSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
			if (len != 0 && (pTmpSec = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmpSec, len);
			}
			else break;
		}
		if (pKeyPrefix != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpKey = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpKey, len);
			}
			else break;
		}
		rc = AjcTchLoadPermInfoExW(hwnd, pTmpSec, pTmpKey, PermItem);
	} while(0);

	if (pTmpSec != NULL) free(pTmpSec);
	if (pTmpKey != NULL) free(pTmpKey);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPermInfoExW		(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem)
{
	BOOL		rc = FALSE;
	BOOL		fNeedUpdateProp = FALSE;
	AJCTCPROP	prop;
	WC			szKey[256];

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProfileSect != NULL && pKeyPrefix != NULL) {
			//----- ftHgvpeBlݒ -----------------------------------------------------------------//
			memcpy(&prop, &pW->prop, sizeof prop);
			//----- ZNVCiڑޔ ---------------------------------------------------------------//
			//	vt@CZNVCL[ړޔ
			AjcTchSetPermAttW(hwnd, pProfileSect, pKeyPrefix);
			pProfileSect = pW->PermSect;
			pKeyPrefix	 = pW->PermKey;
			//	iڑޔ
			pW->PermItem = PermItem;
			//----- 펞i -----------------------------------------------------------------------------//
			pW->GauBarL		= AjcGetProfileUInt(pProfileSect, MKKEY(L"GauBarL"	  ), pW->GauBarL	);	//	Q[Wʒu
			pW->GauBarH		= AjcGetProfileUInt(pProfileSect, MKKEY(L"GauBarH"	  ), pW->GauBarH	);	//	Q[Wʒu
			pW->fGauUseMes	= AjcGetProfileUInt(pProfileSect, MKKEY(L"fGauUseMes" ), pW->fGauUseMes	);	//	PʎԁvltO
			pW->GauSetUTime	= AjcGetProfileUInt(pProfileSect, MKKEY(L"GauSetUTime"), pW->GauSetUTime);	//	Pʎԁiݒlj[us]
			//----- tB^I ---------------------------------------------------------------------------//
			if (pW->PermItem & AJCTCH_PERM_FILTER) {
				UI	MskFilt = AjcGetProfileUInt(pProfileSect, MKKEY(L"MskFilt"), pW->MskFilt	);	//	tB^}XNl
				UI	i, msk;
				for (i = 0, msk = 0x01; i < AJCTC_MAXITEM; i++, msk <<= 1) {
					AjcTchSetFilter(hwnd, i, (MskFilt & msk) != 0);
				}
			}
			//----- Wl -----------------------------------------------------------------------------------//
			if (pW->PermItem & AJCTCH_PERM_RANGE) {
				prop.RngL = AjcGetProfileReal(pProfileSect, MKKEY(L"RngL")	, prop.RngL);	//	Wʒu
				prop.RngH = AjcGetProfileReal(pProfileSect, MKKEY(L"RngH")	, prop.RngH);	//	Wʒu
				//	vpeBXV̎|AtOݒ
				fNeedUpdateProp = TRUE;
			}
			//----- ̑ -------------------------------------------------------------------------------------//
			if (pW->PermItem & AJCTCH_PERM_OTHER) {
				prop.MaxBuf = AjcGetProfileUInt(pProfileSect, MKKEY(L"MaxBuf")	, prop.MaxBuf);		//	őf[^
				prop.AveNum = AjcGetProfileUInt(pProfileSect, MKKEY(L"AveNum")	, prop.AveNum);		//	ω
				//	vpeBXV̎|AtOݒ
				fNeedUpdateProp = TRUE;
			}
			//----- vpeBXV -----------------------------------------------------------------------------//
			rc = TRUE;
			if (fNeedUpdateProp) {
				rc = AjcTchSetProp(hwnd, &prop);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	vt@C։i񏑂																				//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSavePermInfo		(HWND hwnd)
{
	return AjcTchSavePermInfoExW(hwnd, NULL, NULL, AJCTCH_PERM_BYLOAD);
}
//==============================================================================================================//
//	vt@C։i񏑂																				//
//																												//
//	@	F	hwnd			- EChnh																//
//				pProfileSect	- ZNVւ̃|C^	isvNULL)										//
//				pKeyPrefix		- L[擪ւ̃|C^isvNULL)										//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSavePermInfoExA		(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmpSec = NULL;
	WCP		pTmpKey = NULL;

	do {
		if (pProfileSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
			if (len != 0 && (pTmpSec = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmpSec, len);
			}
			else break;
		}
		if (pKeyPrefix != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpKey = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpKey, len);
			}
			else break;
		}
		rc = AjcTchSavePermInfoExW(hwnd, pTmpSec, pTmpKey, PermItem);
	} while(0);

	if (pTmpSec != NULL) free(pTmpSec);
	if (pTmpKey != NULL) free(pTmpKey);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSavePermInfoExW		(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem)
{
	BOOL		rc = FALSE;
	AJCTCPROP	prop;
	WC			szKey[256];

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			//----- ZNVCL[Ci w薳Ȃ΁A[hɐݒ肵̂Ƃ ------------------//
			if (pProfileSect == NULL		 ) pProfileSect = pW->PermSect;
			if (pKeyPrefix	 == NULL		 ) pKeyPrefix	= pW->PermKey;
			if (PermItem & AJCTCH_PERM_BYLOAD) PermItem 	= pW->PermItem;
			//----- vt@CZ[u -------------------------------------------------------------------------//
			if (*pProfileSect != 0) {
				//	vpeBlݒ
				memcpy(&prop, &pW->prop, sizeof prop);
				//	펞i
				AjcPutProfileUInt(pProfileSect, MKKEY(L"GauBarL"	), pW->GauBarL		);	//	Q[Wʒu
				AjcPutProfileUInt(pProfileSect, MKKEY(L"GauBarH"	), pW->GauBarH		);	//	Q[Wʒu
				AjcPutProfileUInt(pProfileSect, MKKEY(L"fGauUseMes" ), pW->fGauUseMes	);	//	PʎԁvltO
				AjcPutProfileUInt(pProfileSect, MKKEY(L"GauSetUTime"), pW->GauSetUTime	);	//	Pʎԁiݒlj[us]
				//	tB^I
				if (PermItem & AJCTCH_PERM_FILTER) {
					AjcPutProfileUInt(pProfileSect, MKKEY(L"MskFilt"), pW->MskFilt	);		//	tB^}XNl
				}
				else {
					AjcDelProfileKey (pProfileSect, MKKEY(L"MskFilt"));
				}
				//	Wl
				if (PermItem & AJCTCH_PERM_RANGE) {
					AjcPutProfileReal(pProfileSect, MKKEY(L"RngL"	 ), prop.RngL	);		//	Wʒu
					AjcPutProfileReal(pProfileSect, MKKEY(L"RngH"	 ), prop.RngH	);		//	Wʒu
				}
				else {
					AjcDelProfileKey (pProfileSect, MKKEY(L"RngL"	 ));
					AjcDelProfileKey (pProfileSect, MKKEY(L"RngH"	 ));
				}
				//	̑
				if (PermItem & AJCTCH_PERM_OTHER) {
					AjcPutProfileUInt(pProfileSect, MKKEY(L"MaxBuf" ), prop.MaxBuf	);		//	őf[^
					AjcPutProfileUInt(pProfileSect, MKKEY(L"AveNum" ), prop.AveNum	);		//	ω
				}
				else {
					AjcDelProfileKey (pProfileSect, MKKEY(L"MaxBuf" ));
					AjcDelProfileKey (pProfileSect, MKKEY(L"AveNum" ));
				}
				rc = TRUE;
			}
		}
	}

	return rc;
}
//==============================================================================================================//
//	ȋiZNVCL[ړjݒ																//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSetPermAttA	(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix)
{
	return AjcTchSetPermAttExA(hwnd, pProfileSect, pKeyPrefix, AJCTCH_PERM_FILTER);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSetPermAttW	(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix)
{
	return AjcTchSetPermAttExW(hwnd, pProfileSect, pKeyPrefix, AJCTCH_PERM_FILTER);
}

//==============================================================================================================//
//	ȋiZNVCL[ړjݒ	iڎwj												//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSetPermAttExA	(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmpSec = NULL;
	WCP		pTmpKey = NULL;

	do {
		if (pProfileSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
			if (len != 0 && (pTmpSec = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmpSec, len);
			}
			else break;
		}
		if (pKeyPrefix != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpKey = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpKey, len);
			}
			else break;
		}
		rc = AjcTchSetPermAttExW(hwnd, pTmpSec, pTmpKey, PermItem);
	} while(0);

	if (pTmpSec != NULL) free(pTmpSec);
	if (pTmpKey != NULL) free(pTmpKey);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSetPermAttExW	(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem)
{
	BOOL		rc = FALSE;
	WC			szid[16];

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			//----- hcݒ -----------------------------------------------------------------------------//
			AjcSnPrintFW(szid, AJCTSIZE(szid), L"%06u", (UW)MAjcGetWindowLong(pW->hBack, GWL_ID));
			//----- ZNVݒ ---------------------------------------------------------------------------//
			if (pProfileSect != NULL) AjcSnPrintFW(pW->PermSect, AJCTSIZE(pW->PermSect) 	, L"%s"    , pProfileSect);
			else					  AjcSnPrintFW(pW->PermSect, AJCTSIZE(pW->PermSect) 	, L"STch%s", szid		 );
			//----- L[ړݒ -----------------------------------------------------------------------------//
			if (pKeyPrefix	 != NULL) AjcSnPrintFW(pW->PermKey , AJCTSIZE(pW->PermKey ) - 32, L"%s"    , pKeyPrefix);	// 32:㑱L[̂̍ől
			else					  AjcSnPrintFW(pW->PermKey , AJCTSIZE(pW->PermKey ) - 32, L"KTch%s", szid	   );
			//----- iڐݒ -----------------------------------------------------------------------------//
			pW->PermItem = PermItem;
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	vt@CvpeBǂݏo																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV														//
//				pDefProp	 - ftHgvpeBliݒlftHgƂꍇNULL)						//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPropA		(HWND hwnd, C_BCP pProfileSect, PCAJCTCPROP pDefProp)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmp = NULL;

	if (pProfileSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmp, len);
			rc = AjcTchLoadPropW(hwnd, pTmp, pDefProp);
		}
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPropW		(HWND hwnd, C_WCP pProfileSect, PCAJCTCPROP pDefProp)
{
	BOOL		rc = TRUE;
	AJCTCPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProfileSect != NULL) {

			if (pDefProp != NULL) memcpy(&prop, pDefProp, sizeof prop);
			else				  rc = AjcTchGetProp(hwnd, &prop);

			if (rc) {
				prop.RngL		  = AjcGetProfileReal(pProfileSect, L"RngL"	  , prop.RngL	   );
				prop.RngH		  = AjcGetProfileReal(pProfileSect, L"RngH"	  , prop.RngH	   );
				prop.TmScale	  = AjcGetProfileUInt(pProfileSect, L"TmScale", prop.TmScale   );
				prop.MaxBuf		  = AjcGetProfileUInt(pProfileSect, L"MaxBuf" , prop.MaxBuf	   );
				prop.MaxItem	  = AjcGetProfileUInt(pProfileSect, L"MaxItem", prop.MaxItem   );
				prop.AveNum		  = AjcGetProfileUInt(pProfileSect, L"AveNum" , prop.AveNum	   );

				prop.Item[0].ofs  = AjcGetProfileReal(pProfileSect, L"ofs0"	 , prop.Item[0].ofs);
				prop.Item[0].rgb  = AjcGetProfileUInt(pProfileSect, L"rgb0"	 , prop.Item[0].rgb);
				prop.Item[1].ofs  = AjcGetProfileReal(pProfileSect, L"ofs1"	 , prop.Item[1].ofs);
				prop.Item[1].rgb  = AjcGetProfileUInt(pProfileSect, L"rgb1"	 , prop.Item[1].rgb);
				prop.Item[2].ofs  = AjcGetProfileReal(pProfileSect, L"ofs2"	 , prop.Item[2].ofs);
				prop.Item[2].rgb  = AjcGetProfileUInt(pProfileSect, L"rgb2"	 , prop.Item[2].rgb);
				prop.Item[3].ofs  = AjcGetProfileReal(pProfileSect, L"ofs3"	 , prop.Item[3].ofs);
				prop.Item[3].rgb  = AjcGetProfileUInt(pProfileSect, L"rgb3"	 , prop.Item[3].rgb);
				prop.Item[4].ofs  = AjcGetProfileReal(pProfileSect, L"ofs4"	 , prop.Item[4].ofs);
				prop.Item[4].rgb  = AjcGetProfileUInt(pProfileSect, L"rgb4"	 , prop.Item[4].rgb);
				prop.Item[5].ofs  = AjcGetProfileReal(pProfileSect, L"ofs5"	 , prop.Item[5].ofs);
				prop.Item[5].rgb  = AjcGetProfileUInt(pProfileSect, L"rgb5"	 , prop.Item[5].rgb);
				prop.Item[6].ofs  = AjcGetProfileReal(pProfileSect, L"ofs6"	 , prop.Item[6].ofs);
				prop.Item[6].rgb  = AjcGetProfileUInt(pProfileSect, L"rgb6"	 , prop.Item[6].rgb);
				prop.Item[7].ofs  = AjcGetProfileReal(pProfileSect, L"ofs7"	 , prop.Item[7].ofs);
				prop.Item[7].rgb  = AjcGetProfileUInt(pProfileSect, L"rgb7"	 , prop.Item[7].rgb);

				rc = AjcTchSetProp(hwnd, &prop);
			}
		}
		else rc = FALSE;
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	vt@CփvpeB																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV														//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSavePropA		(HWND hwnd, C_BCP pProfileSect)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmp = NULL;

	if (pProfileSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmp, len);
			rc = AjcTchSavePropW(hwnd, pTmp);
		}
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSavePropW		(HWND hwnd, C_WCP pProfileSect)
{
	BOOL		rc = FALSE;
	AJCTCPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProfileSect != NULL) {
			if (rc = AjcTchGetProp(hwnd, &prop)) {
				AjcPutProfileReal(pProfileSect, L"RngL"	 , prop.RngL		);
				AjcPutProfileReal(pProfileSect, L"RngH"	 , prop.RngH		);
				AjcPutProfileUInt(pProfileSect, L"TmScale", prop.TmScale	);
				AjcPutProfileUInt(pProfileSect, L"MaxBuf" , prop.MaxBuf		);
				AjcPutProfileUInt(pProfileSect, L"MaxItem", prop.MaxItem	);
				AjcPutProfileUInt(pProfileSect, L"AveNum" , prop.AveNum		);

				AjcPutProfileReal(pProfileSect, L"ofs0"	 , prop.Item[0].ofs);
				AjcPutProfileUInt(pProfileSect, L"rgb0"	 , prop.Item[0].rgb);
				AjcPutProfileReal(pProfileSect, L"ofs1"	 , prop.Item[1].ofs);
				AjcPutProfileUInt(pProfileSect, L"rgb1"	 , prop.Item[1].rgb);
				AjcPutProfileReal(pProfileSect, L"ofs2"	 , prop.Item[2].ofs);
				AjcPutProfileUInt(pProfileSect, L"rgb2"	 , prop.Item[2].rgb);
				AjcPutProfileReal(pProfileSect, L"ofs3"	 , prop.Item[3].ofs);
				AjcPutProfileUInt(pProfileSect, L"rgb3"	 , prop.Item[3].rgb);
				AjcPutProfileReal(pProfileSect, L"ofs4"	 , prop.Item[4].ofs);
				AjcPutProfileUInt(pProfileSect, L"rgb4"	 , prop.Item[4].rgb);
				AjcPutProfileReal(pProfileSect, L"ofs5"	 , prop.Item[5].ofs);
				AjcPutProfileUInt(pProfileSect, L"rgb5"	 , prop.Item[5].rgb);
				AjcPutProfileReal(pProfileSect, L"ofs6"	 , prop.Item[6].ofs);
				AjcPutProfileUInt(pProfileSect, L"rgb6"	 , prop.Item[6].rgb);
				AjcPutProfileReal(pProfileSect, L"ofs7"	 , prop.Item[7].ofs);
				AjcPutProfileUInt(pProfileSect, L"rgb7"	 , prop.Item[7].rgb);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	vt@CvpeBCtB^ݒCEChX^Cǂݏo											//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV														//
//				pDefProp	 - ftHgvpeBliݒlftHgƂꍇNULL)						//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPropExA	(HWND hwnd, C_BCP pProfileSect, PCAJCTCPROP pDefProp)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmp = NULL;

	len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
	if (len != 0 && (pTmp = AjcTAlloc(len))) {
		MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmp, len);
		rc = AjcTchLoadPropExW(hwnd, pTmp, pDefProp);
	}
	if (pTmp != NULL) free(pTmp);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPropExW	(HWND hwnd, C_WCP pProfileSect, PCAJCTCPROP pDefProp)
{
	BOOL		rc = FALSE;
	AJCTCIPINFO	IpInf;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			int		i, msk, flt, styS, styU;
			if (rc = AjcTchLoadPropW(hwnd, pProfileSect, pDefProp)) {
				//----- ݂̃tB^l擾 ---------------------------------------------------//
				flt = 0;
				for (i = 0, msk = 0x0001; i < AJCTC_MAXITEM; i++, msk <<= 1) {
					if (AjcTchGetFilter(hwnd, i)) flt |= msk;
				}
				//----- vt@CtB^lǂݏo -------------------------------------//
				flt = AjcGetProfileUInt(pProfileSect, L"FilterValue", flt);
				//----- tB^lݒ ---------------------------------------------------------//
				for (i = 0, msk = 0x0001; i < AJCTC_MAXITEM; i++, msk <<= 1) {
					AjcTchSetFilter(hwnd, i, (flt & msk) != 0); 
				}
				//----- ݂̃X^Clǂݏo -----------------------------------------------//
				styS = (int)MAjcGetWindowLong(hwnd, GWL_STYLE);
				styU = (styS & 0xFFFF);
				//----- vt@CX^Clǂݏo -------------------------------------//
				styU  = AjcGetProfileUInt(pProfileSect, L"WndStyle", styU);
				styU &= 0xFFFF;
				//----- X^Cݒ -----------------------------------------------------------//
				styS &= ~0xFFFF;
				styS |= styU;
				MAjcSetWindowLong(hwnd, GWL_STYLE, styS);
				//----- vt@Cԏǂݏo ---------------------------------------//
				AjcTchGetIpInfo(hwnd, &IpInf);
				IpInf.IpKnd   = (AJCTCIPKND)AjcGetProfileUInt(pProfileSect, L"IpInf.IpKnd"	,(UI)IpInf.IpKnd  );
				IpInf.IpNum   = 			AjcGetProfileUInt(pProfileSect, L"IpInf.IpNum"	,	 IpInf.IpNum  );
				IpInf.IpWidth = 			AjcGetProfileUInt(pProfileSect, L"IpInf.IpWidth",	 IpInf.IpWidth);
				//----- ԏݒ -----------------------------------------------------------//
				AjcTchGetIpInfo(hwnd, &IpInf);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	vt@CփvpeBCtB^ݒCEChX^C											//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV														//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSavePropExA	(HWND hwnd, C_BCP pProfileSect)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmp = NULL;

	if (pProfileSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmp, len);
			rc = AjcTchSavePropExW(hwnd, pTmp);
		}
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchSavePropExW	(HWND hwnd, C_WCP pProfileSect)
{
	BOOL	rc = FALSE;
	AJCTCIPINFO	IpInf;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			int		i, msk, flt, sty;
			if (rc = AjcTchSaveProp(hwnd, pProfileSect)) {
				//----- ݂̃tB^l擾 ---------------------------------------------------//
				flt = 0;
				for (i = 0, msk = 0x0001; i < AJCTC_MAXITEM; i++, msk <<= 1) {
					if (AjcTchGetFilter(hwnd, i)) flt |= msk;
				}
				//----- vt@CփtB^l ---------------------------------------//
				AjcPutProfileUInt(pProfileSect, L"FilterValue", flt);
				//----- ݂̃X^Clǂݏo -----------------------------------------------//
				sty	 = (int)MAjcGetWindowLong(hwnd, GWL_STYLE);
				sty &= 0xFFFF;
				//----- vt@CփX^Cl ---------------------------------------//
				sty = AjcPutProfileUInt(pProfileSect, L"WndStyle", sty);
				//----- ԏǂݏo -------------------------------------------------------//
				AjcTchGetIpInfo(hwnd, &IpInf);
				//----- vt@C֕ԏ񏑂 -----------------------------------------//
				AjcPutProfileUInt(pProfileSect, L"IpInf.IpKnd"	,(UI)IpInf.IpKnd  );
				AjcPutProfileUInt(pProfileSect, L"IpInf.IpNum"	,	 IpInf.IpNum  );
				AjcPutProfileUInt(pProfileSect, L"IpInf.IpWidth",	 IpInf.IpWidth);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ENbNɂ|bvAbvj[̋^֎~															//
//																												//
//	@	F	hwnd		  - EChnh																//
//				fEnable		  - |bvAbvj[̋^֎~												//
//									TRUE  : iENbNʒmCShuft/Ctrl+ENbNʒmj					//
//									FALSE : ֎~iSẲENbNʒmj										//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchEnablePopupMenu(HWND hwnd, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			AjcTchSetNtcRClk(hwnd, !fEnable, WM_RBUTTONDOWN, WM_RBUTTONUP);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	ENbNʒmݒ																							//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				fNtcRClk	 - TRUE  : E{^DOWN/UPʒm	i|bvAbv͋֎~j								//
//							   FALSE : E{^DOWN/UPʒmi|bvAbvj								//
//				MsgRBDown	 - E{^̒ʒmbZ[WR[h@iȌꍇ͔ʒmj						//
//				MSgRBUp		 - E{^ꎞ̒ʒmbZ[WR[hiȌꍇ͔ʒmj						//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//																												//
//	@l	F						<|bvAbv>	<Shift/Ctrl+E>		<E-DOWN>	<E-UP>						//
//				NtcRClk	= FALSE	 	 		 	 ʒm				 ʒm		 ʒm						//
//				 		= TRUE		 ֎~			 ʒm				 MsgRBDown	 MsgRBUp					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchSetNtcRClk	(HWND hwnd, BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fNtcRClk  = fNtcRClk;
			pW->MsgRBDown = MsgRBDown;
			pW->MsgRBUp	  = MsgRBUp;
			rc = TRUE;
		}
	}
	return rc;
}


//==============================================================================================================//
//	c[`bvEeLXgݒ																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pTxt		 - c[`bvEeLXg̃AhX											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTchSetTipTextA (HWND hwnd, C_BCP pTxt)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (rc = SubSetTipTextA(&pW->pToolTipTxt, 0, pTxt)) {
				AjcTipTextAddW		   (pW->hBack, pW->pToolTipTxt);
				AjcTipTextSetShowAlways(pW->hBack, pW->fShowAlways);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTchSetTipTextW (HWND hwnd, C_WCP pTxt)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (rc = SubSetTipTextW(&pW->pToolTipTxt, 0, pTxt)) {
				AjcTipTextAddW		   (pW->hBack, pW->pToolTipTxt);
				AjcTipTextSetShowAlways(pW->hBack, pW->fShowAlways);
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	c[`bvEeLXg擾																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pBuf		 - c[`bvEeLXgi[obt@̃AhX							//
//				lBuf		 - c[`bvEeLXgi[obt@̕							//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTchGetTipTextA (HWND hwnd, BCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = SubGetTipTextA(&pW->pToolTipTxt, 0, pBuf, lBuf);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTchGetTipTextW (HWND hwnd, WCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = SubGetTipTextW(&pW->pToolTipTxt, 0, pBuf, lBuf);
		}
	}
	return rc;
}
//==============================================================================================================//
//	tBB^i`FbN{bNXj̃c[`bvEeLXgݒ													//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				n			 - `FbN{bNXECfNXiO`Vj											//
//				pTxt		 - c[`bvEeLXg̃AhX											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI		AjcTchSetChkBoxTipTextA(HWND hwnd, UI n, C_BCP pTxt)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (n < AJCTC_MAXITEM) {
				if (rc = SubSetTipTextA(pW->pChkBoxTool, n, pTxt)) {
					AjcTipTextAddW		   (pW->hChkFilt[n], pW->pChkBoxTool[n]);
					AjcTipTextSetShowAlways(pW->hChkFilt[n], pW->fChkBoxShowAlways[n]);
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI		AjcTchSetChkBoxTipTextW(HWND hwnd, UI n, C_WCP pTxt)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (n < AJCTC_MAXITEM) {
				if (rc = SubSetTipTextW(pW->pChkBoxTool, n, pTxt)) {
					AjcTipTextAddW		   (pW->hChkFilt[n], pW->pChkBoxTool[n]);
					AjcTipTextSetShowAlways(pW->hChkFilt[n], pW->fChkBoxShowAlways[n]);
				}
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	tBB^i`FbN{bNXj̃c[`bvEeLXg擾													//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				n			 - `FbN{bNXECfNXiO`Vj											//
//				pBuf		 - c[`bvEeLXgi[obt@̃AhX							//
//				lBuf		 - c[`bvEeLXgi[obt@̕							//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI		AjcTchGetChkBoxTipTextA(HWND hwnd, UI n, BCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (n < AJCTC_MAXITEM) {
				rc = SubGetTipTextA(pW->pChkBoxTool, n, pBuf, lBuf);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI		AjcTchGetChkBoxTipTextW(HWND hwnd, UI n, WCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (n < AJCTC_MAXITEM) {
				rc = SubGetTipTextW(pW->pChkBoxTool, n, pBuf, lBuf);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	c[`bvEeLXg\ݒ																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				fShowAlways	 - c[`bvEeLXg\													//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchSetTipShowAlways(HWND hwnd, BOOL fShowAlways)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fShowAlways = fShowAlways;
			AjcTipTextSetShowAlways(hwnd, pW->fShowAlways);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	c[`bvEeLXg\擾																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	c[`bvEeLXg\																	//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchGetTipShowAlways(HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->fShowAlways;
		}
	}
	return rc;
}
//==============================================================================================================//
//	tBB^i`FbN{bNXj̃c[`bvEeLXg\ݒ											//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				n			 - `FbN{bNXECfNXiO`PTj											//
//				fShowAlways	 - c[`bvEeLXg\													//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchSetChkBoxTipShowAlways(HWND hwnd, UI n, BOOL fShowAlways)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (n < AJCTC_MAXITEM) {
				pW->fChkBoxShowAlways[n] = fShowAlways;
				AjcTipTextSetShowAlways(pW->hChkFilt[n], pW->fChkBoxShowAlways[n]);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	tBB^i`FbN{bNXj̃c[`bvEeLXg\擾											//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				n			 - `FbN{bNXECfNXiO`PTj											//
//																												//
//	߂l	F	c[`bvEeLXg\																	//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchGetChkBoxTipShowAlways(HWND hwnd, UI n)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (n < AJCTC_MAXITEM) {
				rc = pW->fChkBoxShowAlways[n];
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	SẴc[`bvEeLXg\ݒ																	//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				fShowAlways	 - c[`bvEeLXg\													//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchSetTipShowAlwaysAll(HWND hwnd, BOOL fShowAlways)
{
	BOOL	rc = FALSE;
	int		i;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fShowAlways = fShowAlways;
			for (i = 0; i < AJCTC_MAXITEM; i++) {
				pW->fChkBoxShowAlways[i] = fShowAlways;
			}
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	ő匋ݒ																								//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				dist		 - ő匋iOFSj															//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetMaxLineDist(HWND hwnd, double MaxLineDist)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->MaxLineDist = MaxLineDist;
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	ő匋擾																								//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	ő匋iOFSj																		//
//==============================================================================================================//
AJCEXPORT	double		WINAPI	AjcTchGetMaxLineDist(HWND hwnd)
{
	double	rc = 0.0;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->MaxLineDist;
		}
	}
	return rc;
}

//==============================================================================================================//
//	XN[ʒu̎擾																						//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	݂̃XN[ʒuiO`j																	//
//==============================================================================================================//
AJCEXPORT	int			WINAPI	AjcTchGetScrollPos	(HWND hwnd)
{
	SCROLLINFO	si;

	si.nPos = 0;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			si.cbSize = sizeof(SCROLLINFO);
			si.fMask  = SIF_POS;
			GetScrollInfo(pW->hMain, SB_HORZ, &si);
		}
	}
	return si.nPos;
}

//==============================================================================================================//
//	XN[ʒu̐ݒ																						//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pos			 - ݒ肷XN[ʒu															//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetScrollPos	(HWND hwnd, int pos)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			SCROLLINFO	si;

			si.cbSize = sizeof(SCROLLINFO);
			si.fMask  = SIF_POS;
			si.nPos	  = pos;
			SetScrollInfo(pW->hMain, SB_HORZ, &si, TRUE);
			GetScrollInfo(pW->hMain, SB_HORZ, &si);

			pW->ixView = TchDixToBix(pW, si.nPos);
			TchSetViewWidth(pW);
			InvalidateRect(pW->hMain, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	tB^̐ݒ																								//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				n			 - `FbN{bNXECfNXiO`Vj											//
//				state		 - ݒ肷(FALSE:\CTRUE:\)											//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetFilter		(HWND hwnd, UI n, BOOL state)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (n < AJCTC_MAXITEM  &&  pW->hChkFilt[n] != NULL) {
				SendMessage(pW->hChkFilt[n], BM_SETCHECK, state, 0);
				SendMessage(pW->hFilter, WM_COMMAND, MAKELONG(TCH_IDC_CHK_BASE + n, BN_CLICKED), 0);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	tB^̎擾																								//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				n			 - `FbN{bNXECfNXiO`Vj											//
//																												//
//	߂l	F	tB^̐ݒ																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchGetFilter		(HWND hwnd, UI n)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (n < AJCTC_MAXITEM  &&  pW->hChkFilt[n] != NULL) {
				rc = (BOOL)SendMessage(pW->hChkFilt[n], BM_GETCHECK, 0, 0);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	i̐ݒj																							//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				id			 - ʁiO`Vj																//
//				color		 - `F																			//
//				width		 - ̑																			//
//				style		 - 	(AJCTCH_SOLID / DASH / DOT / DASHDOT / DASHDOTDOT / NULL)				//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetHLineAtt (HWND hwnd, UI id, COLORREF color, int width, int style)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			HPEN		hPen;
			if (id < TCH_MAX_HLINE	&&	style >= AJCTCH_SOLID && style <= AJCTCH_INSIDEFRAME) {
				pW->HLineTbl[id].color = color;
				pW->HLineTbl[id].width = width;
				pW->HLineTbl[id].style = style;
				if (hPen = CreatePen(style, width, color)) {
					if (pW->HLineTbl[id].hPen != NULL) {
						DeleteObject(pW->HLineTbl[id].hPen);
					}
					pW->HLineTbl[id].hPen = hPen;
					InvalidateRect(pW->hMain, NULL, FALSE);
					rc = TRUE;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	i`ʒu̐ݒj																						//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				id			 - ʁiO`Vj																//
//				pos			 - `ʒu																			//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchSetHLinePos (HWND hwnd, UI id, double pos)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (id < TCH_MAX_HLINE) {
				pW->HLineTbl[id].pos = pos;
				InvalidateRect(pW->hMain, NULL, FALSE);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	i`̋^֎~j																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				id			 - ʁiO`Vj																//
//				fEnable		 - TRUE	 : `																		//
//							   FALSE : `																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchEnableHLine (HWND hwnd, UI id, BOOL fEnable)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (id < TCH_MAX_HLINE) {
				pW->HLineTbl[id].fEnable = fEnable;
				InvalidateRect(pW->hMain, NULL, FALSE);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	c`iŌɊi[f[^̈ʒuɏc`悷j														//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				color		 - `F																			//
//				width		 - ̑																			//
//				style		 - 	(AJCTCH_SOLID / DASH / DOT / DASHDOT / DASHDOTDOT / NULL)				//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchSetVLine	 (HWND hwnd, COLORREF color, int width, int style)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			int				ix;
			PTCH_VLINEBUF	pVLi;

			if (pW->nBuf != 0) {
				if (pW->ixBuf == 0) ix = pW->prop.MaxBuf - 1;
				else				ix = pW->ixBuf - 1;

				pVLi = pW->pVLi + ix;
				pVLi->flag	 |= TCH_VLIF_VLINE;
				pVLi->width	  = (UB)width;
				pVLi->style	  = (UB)style;
				pVLi->rgb	  = color;
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	c`̋^֎~																						//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				fEnable		 - TRUE	 : `																		//
//							   FALSE : `																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchEnableVLine(HWND hwnd, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fVLiEnable = fEnable;
			InvalidateRect(pW->hMain, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	vbg_`iŌɊi[f[^̈ʒuɃvbg_i~j`悷j									//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				r			 - vbg_̔a																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchSetPoint (HWND hwnd, int r)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			int				ix;
			PTCH_VLINEBUF	pVLi;

			if (r > 0 && pW->nBuf != 0) {
				if (pW->ixBuf == 0) ix = pW->prop.MaxBuf - 1;
				else				ix = pW->ixBuf - 1;

				pVLi = pW->pVLi + ix;
				pVLi->flag |= TCH_VLIF_PLOT;
				pVLi->r 	= (UB)r;
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	vbg_`̋^֎~																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				fEnable		 - TRUE	 : `																		//
//							   FALSE : `																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTchEnablePoint(HWND hwnd, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fPointEnable = fEnable;
			InvalidateRect(pW->hMain, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽt@C擾																				//
//																												//
//	@	F	pW	  - CX^X[NAhX																//
//				buf	  - t@Ci[obt@̃AhX													//
//																												//
//	߂l	F	TRUE:t@CCFALSE:t@CȂ														//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcTchGetDroppedFileA (HWND hwnd, BC buf[MAX_PATH])
{
	BOOL	rc = FALSE;
	WC		tmp[MAX_PATH];

	if (buf != NULL) {
		if (rc = AjcTchGetDroppedFileW(hwnd, tmp)) {
			WideCharToMultiByte(CP_ACP, 0, tmp, -1, buf, MAX_PATH, NULL, NULL);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcTchGetDroppedFileW (HWND hwnd, WC buf[MAX_PATH])
{
	BOOL		rc = FALSE;
	UI			bytes;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && buf != NULL) {
			if (AjcRngGetData(pW->hRngFile, (VOP)&bytes, sizeof bytes) == sizeof bytes) {
				rc = (AjcRngGetData(pW->hRngFile, (VOP)buf, bytes) == bytes);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽfBNg擾																			//
//																												//
//	@	F	pW	  - CX^X[NAhX																//
//				buf	  - fBNgi[obt@̃AhX												//
//																												//
//	߂l	F	TRUE:fBNgCFALSE:fBNgȂ												//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcTchGetDroppedDirA  (HWND hwnd, BC buf[MAX_PATH])
{
	BOOL	rc = FALSE;
	WC		tmp[MAX_PATH];

	if (buf != NULL) {
		if (rc = AjcTchGetDroppedDirW(hwnd, tmp)) {
			WideCharToMultiByte(CP_ACP, 0, tmp, -1, buf, MAX_PATH, NULL, NULL);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcTchGetDroppedDirW  (HWND hwnd, WC buf[MAX_PATH])
{
	BOOL		rc = FALSE;
	UI			bytes;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && buf != NULL) {
			if (AjcRngGetData(pW->hRngDir, (VOP)&bytes, sizeof bytes) == sizeof bytes) {
				rc = (AjcRngGetData(pW->hRngDir, (VOP)buf, bytes) == bytes);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽfBNg擾íuvtwtj												//
//																												//
//	@	F	pW	  			 - CX^X[NAhX													//
//				buf	  			 - fBNgi[obt@̃AhX									//
//				fTailIsDelimiter - TRUE  : fBNgpX̖Ɂu\vt								//
//																												//
//	߂l	F	TRUE:fBNgCFALSE:fBNgȂ												//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcTchGetDroppedDirExA	(HWND hwnd, BC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	BOOL	rc = FALSE;
	WC		tmp[MAX_PATH];

	if (rc = AjcTchGetDroppedDirExW(hwnd, tmp, fTailIsDelimiter)) {
		WideCharToMultiByte(CP_ACP, 0, tmp, -1, buf, MAX_PATH, NULL, NULL);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcTchGetDroppedDirExW	(HWND hwnd, WC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	BOOL		rc = FALSE;

	if (rc = AjcTchGetDroppedDirW(hwnd, buf)) {
		if (fTailIsDelimiter) AjcPathCat(buf, L"", MAX_PATH);
		else				  PathRemoveBackslashW(buf);
	}
	return rc;
}
//==============================================================================================================//
//	^Cg̐ݒ																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pTitleText	- ^CgeLXgւ̃|C^iNULLw莞́A^Cg\j						//
//				TextColor	- eLXg`Fi|Pw莞͑OݒlCftHgFj						//
//				BackColor	- eLXgwiFi|Pw莞͑OݒlCftHgFO[j					//
//				hFont		- ^CgeLXg̃tHgiNULLw莞͑Oݒl^ftHg̃tHgj		//
//																												//
//	߂l	F	ECh擪s̈ʒuiO`j																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcTchSetTitleTextA(HWND hwnd, C_BCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont)
{
	BOOL		rc	 = FALSE;
	WCP			pTmp = NULL;
	UL			len;

	if (IsWindow(hwnd)) {
		do {
			if (pTitleText != NULL) {
				len = MultiByteToWideChar(CP_ACP, 0, pTitleText, -1, NULL, 0);
				if (len != 0  &&  (pTmp = AjcTAlloc(len + 1))) {
					MultiByteToWideChar(CP_ACP, 0, pTitleText, -1, pTmp, len);
				}
				else break;
			}
			rc = AjcTchSetTitleTextW(hwnd, pTmp, TextColor, BackColor, hFont);
			if (pTmp != NULL) free(pTmp);
		} while(0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcTchSetTitleTextW(HWND hwnd, C_WCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont)
{
	BOOL	rc	 = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			//	^CgeLXgErbg}bv
			SubTtlBmpMake(&pW->TtlInfo, pW->hBack, pTitleText, TextColor, BackColor, hFont);
			//	߂l
			rc = TRUE;
			//	ĕ`
			InvalidateRect(hwnd 	, NULL, TRUE);
			InvalidateRect(pW->hMain, NULL, TRUE);
		}
	}
	return rc;
}
//==============================================================================================================//
//	g`ԕ\̐ݒ																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pInfo		- g`ԕ\̃AhX														//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT BOOL	   WINAPI AjcTchSetIpInfo(HWND hwnd, PCAJCTCIPINFO pInfo)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd) 				&&
		pInfo != NULL				&&
		AJCTCIS_IPKND(pInfo->IpKnd)	&&
		pInfo->IpNum >= 10			&&
		pInfo->IpWidth >= AJCTCMIN_IPWID && pInfo->IpWidth <= AJCTCMAX_IPWID) {

		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);

		if (IS_MY_INST(pW)) {
			memcpy(&pW->IpInfo, pInfo,	sizeof(AJCTCIPINFO));
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	g`ԕ\̎擾																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pBuf		- g`ԕ\i[obt@̃AhX										//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT BOOL	   WINAPI AjcTchGetIpInfo(HWND hwnd, PAJCTCIPINFO pBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pBuf != NULL) {
			memcpy(pBuf, &pW->IpInfo, sizeof(AJCTCIPINFO));
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	\̒~^ĊJ																							//
//																												//
//	@	F	hwnd		- EChnh																	//
//				fPause		- \~tOiTRUE:\~CFALSE:\Jnj									//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTchPause(HWND hwnd, BOOL fPause)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (!(pW->fPause = fPause)) {						//	\ĊJH
				//	XN[o[ĕ\ƃEChĕ`
				TchSetScrollBar(pW);
				//	vmcĕ`
				InvalidateRect(pW->hMain, NULL, FALSE);
			}
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	`掞Ԍv̋^֎~																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				fEnable		- ^֎~tOiTRUE:CFALSE:֎~j											//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI AjcTchEnableMesDraw(HWND hwnd, BOOL fEnable)
{
	BOOL		rc	 = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fMesDrawEnable = fEnable;
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	vbgv\^\̐ݒ																		//
//																												//
//	@	F	hwnd		- EChnh																	//
//				fShow		- \tO																		//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI AjcTchMesPeriShow(HWND hwnd, BOOL fShow)
{
	BOOL		rc	 = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pW->fMesPeriShow = (fShow == TRUE)) {
				pW->MesPeriAveS = pW->MesPeriAve;
				SetTimer(pW->hMain, TCH_TID_MESPERISHOW, 5000, NULL);
			}
			InvalidateRect(pW->hMain, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	vbgv񃊃Zbg																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI AjcTchMesPeriReset(HWND hwnd)
{
	BOOL		rc	 = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			TchMesPeriReset(pW);
			InvalidateRect(pW->hMain, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	vbg擾																							//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	vbgf[^̓^[us]																	//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI AjcTchMesPeriGet(HWND hwnd)
{
	UI		rc = 0;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->MesPeriAve;
		}
	}
	return rc;
}
//==============================================================================================================//
//	ԌvQ[W擾																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pBuf		- ԌvQ[Wi[obt@̃AhX									//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcTchGetGauInfo(HWND hwnd, PAJCTCGAUINFO pBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pBuf != NULL) {
			pBuf->fGauEnable	= pW->fGauEnable;
			pBuf->GauBarL		= pW->GauBarL;
			pBuf->GauBarH		= pW->GauBarH;
			pBuf->fGauUseMes	= pW->fGauUseMes;
			pBuf->GauSetUTime	= pW->GauSetUTime;
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`tHgݒ																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				hFont		 - tHgnh																	//
//																												//
//	߂l	F	NULL : ÕtHgnh																	//
//				NULL : s																					//
//==============================================================================================================//
AJCEXPORT	HFONT	WINAPI		AjcTchSetTextFont	(HWND hwnd, HFONT hFont)
{
	HFONT	rc = NULL;
	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && hFont != NULL) {
			rc = pW->hFontTxo;
			pW->hFontTxo = hFont;
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`isNZʒuwj																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				x, y		 - `ʒu																			//
//				pTxt		 - `eLXg																		//
//																												//
//	߂l	F	0 : eLXgL[																				//
//				0 : s																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI		AjcTchTextOutA		(HWND hwnd, int x, int y, C_BCP pTxt)
{
	UI		rc = 0;
	UI		len;
	WCP		pTmp = NULL;

	len = MultiByteToWideChar(CP_ACP, 0, pTxt, -1, NULL, 0);
	if (len != 0 && (pTmp = AjcTAllocW(len))) {
		MultiByteToWideChar(CP_ACP, 0, pTxt, -1, pTmp, len);
		rc = AjcTchTextOutW(hwnd, x, y, pTmp);
	}
	if (pTmp != NULL) free(pTmp);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI		AjcTchTextOutW		(HWND hwnd, int x, int y, C_WCP pTxt)
{
	UI		rc = 0;
	PTCHTXO	pNode;
	UI		stl, len;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (stl = (UI)wcslen(pTxt)) {
				len = sizeof(TCHTXO) + stl * 2;
				if (pNode = malloc(len)) {
					memset(pNode, 0, sizeof(TCHTXO));
					pNode->pt.x = x;
					pNode->pt.y = y;
					wcscpy(pNode->txt, pTxt);
					if (AjcAvlInsNode(pW->hAvlTxo, pW->kAvlTxo, (C_VOP)pNode, len)) {
						rc = pW->kAvlTxo++;
						InvalidateRect(pW->hMain, NULL, FALSE);
					}
					free(pNode);
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`isNZʒuwj																		//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				x, y		 - `ʒu																			//
//				pFmt		 - eLXg																		//
//																												//
//	߂l	F	0 : eLXgL[																				//
//				0 : s																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI		AjcTchPrintFA		(HWND hwnd, int x, int y, C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	BC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		AjcVSnPrintFA(buf, 2048, pFmt, vls);
		va_end	(vls);
		rc = AjcTchTextOutA(hwnd, x, y, buf);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI		AjcTchPrintFW		(HWND hwnd, int x, int y, C_WCP pFmt, ...)
{
	UI		rc = 0;
	va_list	vls;
	WC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		AjcVSnPrintFW(buf, 2048, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcTchTextOutW(hwnd, x, y, buf);
	}
	return rc;
}
//==============================================================================================================//
//	`eLXg擾																							//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				key			 - eLXgL[																		//
//				pBuf		 - eLXgi[obt@ւ̃|C^isvNULLj									//
//				lBuft		 - eLXgi[obt@̃oCg^											//
//																												//
//	߂l	F	0 : `eLXg̃oCg^															//
//				0 : s																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI		AjcTchGetTextA		(HWND hwnd, UI key, BCP pBuf, UI lBuf)
{
	UI		rc = 0;
	PTCHTXO	pNode;
	UI		lNode;
	UI		stl;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pNode = (PTCHTXO)AjcAvlGetNodePtr(pW->hAvlTxo, key, &lNode)) {
				stl = (UI)wcslen(pNode->txt);
				rc = WideCharToMultiByte(CP_ACP, 0, pNode->txt, stl, NULL, 0, NULL, NULL);
				if (pBuf != NULL && lBuf != 0) {
					WideCharToMultiByte(CP_ACP, 0, pNode->txt, -1, pBuf, lBuf, NULL, NULL);
					pBuf[lBuf - 1] = 0;
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI		AjcTchGetTextW		(HWND hwnd, UI key, WCP pBuf, UI lBuf)
{
	UI		rc = 0;
	PTCHTXO	pNode;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pNode = AjcAvlGetNodePtr(pW->hAvlTxo, key, NULL)) {
				rc = (UI)wcslen(pNode->txt);
				if (pBuf != NULL && lBuf != 0) {
					wcsncpy(pBuf, pNode->txt, lBuf);
					pBuf[lBuf - 1] = 0;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	`eLXgNA[																						//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				key			 - eLXgL[																		//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : s																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI		AjcTchClearText		(HWND hwnd, UI key)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = AjcAvlDelNode(pW->hAvlTxo, key);
			InvalidateRect(pW->hMain, NULL, FALSE);
		}
	}
	return rc;
}

//==============================================================================================================//
//	SĂ̕`eLXgNA[																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : s																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI		AjcTchClearAllText		(HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			AjcAvlDelAllNodes(pW->hAvlTxo);
			pW->kAvlTxo = 1;
			InvalidateRect(pW->hMain, NULL, FALSE);
		}
	}
	return rc;
}
//==============================================================================================================//
//	Săf[^ivbgCeLXgjNA[																	//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : s																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI		AjcTchClear				(HWND hwnd)
{
	BOOL	rc = TRUE;

	rc &= AjcTchPurge		 (hwnd);
	rc &= AjcTchClearAllText (hwnd);

	return rc;
}

//==============================================================================================================//
//	CECh̃nh擾																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pBkWnd		- EChwiFi[obt@ւ̃|C^isvNULLj						//
//																												//
//	߂l	F	NULL : CECh̃nh																//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	HWND	WINAPI		AjcTchGetMainWindow(HWND hwnd, COLORREF *pBkGnd)
{
	HWND	rc = NULL;

	if (IsWindow(hwnd)) {
		PWRKTMCHART	pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pBkGnd != NULL) {
				*pBkGnd = RGB(255, 255, 255);
			}
			rc = pW->hMain;
		}
	}
	return rc;
}

//==============================================================================================================//
//																												//
//	ʒm擾																								//
//																												//
//==============================================================================================================//
//	ENbNʒm
AJCEXPORT	PAJCTCRCLK			WINAPI AjcTchGetNtcRClk		(HWND hwnd)
{
	PAJCTCRCLK	rc = NULL;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		rc = &pW->NtcRClk;
	}
	return rc;
}
//	hbvfBNg
AJCEXPORT	UI					WINAPI AjcTchGetNtcDirs		(HWND hwnd)
{
	UI		rc = 0;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcDirs;
	}
	return rc;
}
//	hbvt@C
AJCEXPORT	UI					WINAPI AjcTchGetNtcFiles	(HWND hwnd)
{
	UI		rc = 0;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcFiles;
	}
	return rc;
}
//	OtW
AJCEXPORT	PAJCTC_NTC_RANGE	WINAPI AjcTchGetNtcRng		(HWND hwnd)
{
	PAJCTC_NTC_RANGE	rc = NULL;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		rc = &pW->NtcRng;
	}
	return rc;
}
//	XN[ʒu
AJCEXPORT	UI					WINAPI AjcTchGetNtcScrPos	(HWND hwnd)
{
	UI		rc = 0;

	if (IsWindow(hwnd)) {
		PWRKTMCHART pW = (PWRKTMCHART)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcScrPos;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	`bNJE^擾iʂJE^j																			//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	ULL		GetUsCount(VO)
{
	ULL				rc = 0;
	LARGE_INTEGER	tick;

	if (TchPfmFreq != 0) {
		QueryPerformanceCounter(&tick);
		rc = tick.QuadPart * (ULL)1000000 / TchPfmFreq;
	}
	else {
		rc = (ULL)timeGetTime() * (ULL)1000;
	}
	return rc;
}
