#include	"AjcInternal.h"
#include	"AjcCtrlVT100Def.h"
//**************************************************************************************************************//
//																												//
//	JX^Rg[iusPOOG~[Vj		`oh												//
//																												//
//**************************************************************************************************************//

#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//--------------------------------------------------------------------------------------------------------------//
//	O[oϐ																								//
//--------------------------------------------------------------------------------------------------------------//
ATOM	VthClassBack	= 0;
ATOM	VthClassMain	= 0;
ATOM	VthClassForMSIL	= 0;

UI		VthErrTxtLen;
WC		VthErrorTxt[128] = L"*** Memory allocation failure ***";

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL		SubPutText (PWRKVT100 pW, C_WCP pTxt, UI lTxt);
static	HGLOBAL		GetSelectedText	(PWRKVT100 pW);
static	BOOL		SaveToTextFile	(PWRKVT100 pW, HAJCFILE hFile, BOOL fAllText);
static	BOOL		SaveToHtmlFile	(PWRKVT100 pW, HAJCFILE hFile, BOOL fAllText, UI FontSize);
static	BOOL		WriteHtmlLine 	(PWRKVT100 pW, HAJCFILE hFile, PLINEPTR pL, UI ixSC, UI ixEC);
static	BOOL		WriteHtmlText 	(PWRKVT100 pW, HAJCFILE hFile, C_WCP pTxt, UI lTxt);
static	BOOL		SaveAllTextToFileWithEsc(PWRKVT100 pW, HAJCFILE hFile);


//==============================================================================================================//
//	Nݒ																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
BOOL	AjcCtrlVT100Init(VO)
{
	BOOL		rc = FALSE;
	WNDCLASS	wndclass;
	UI			stl;

	do {
		//----- G[eLXg񏉊 ----------------------//
		stl = (UI)wcslen(VthErrorTxt);
		VthMemSetA(&VthErrorTxt[stl], 0x07, stl);
		//----- obNEChNX --------------------------//
		wndclass.style			= CS_GLOBALCLASS;
		wndclass.lpfnWndProc	= VthWndProcBack();
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= sizeof(PWRKVT100);
		wndclass.hInstance		= hDllInst;
		wndclass.hIcon			= NULL;
		wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= L"AjcCtrlVT100";
		if ((VthClassBack = RegisterClass(&wndclass)) == 0) break;

		//----- C`EChNX ---------------------//
		wndclass.style			= CS_DBLCLKS;
		wndclass.lpfnWndProc	= VthWndProcMain();
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= sizeof(PWRKVT100);
		wndclass.hInstance		= hDllInst;
		wndclass.hIcon			= NULL;
		wndclass.hCursor		= LoadCursor(NULL, IDC_IBEAM);
		wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= L"AjcVT100MainClass";
		if ((VthClassMain = RegisterClass(&wndclass)) == 0) break;

		//----- lrhkR[hT|[gp ---------------------//
		wndclass.style			= 0;
		wndclass.lpfnWndProc	= VthWndProcMSIL();
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= sizeof(VOP);
		wndclass.hInstance		= hDllInst;
		wndclass.hIcon			= NULL;
		wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= L"AjcVthForMSIL";
		if ((VthClassForMSIL = RegisterClass(&wndclass)) == 0) break;

		rc = TRUE;
	} while(0);

	if (rc == FALSE) {
		AjcCtrlVT100End();
	}

	return rc;
}
//==============================================================================================================//
//	I㏈																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
VO		AjcCtrlVT100End (VO)
{
	HINSTANCE	hModInst = GetModuleHandle(NULL);

	if (VthClassBack	!= 0) {UnregisterClass((WCP)VthClassBack   , hDllInst); VthClassBack	= 0;}
	if (VthClassMain	!= 0) {UnregisterClass((WCP)VthClassMain   , hDllInst); VthClassMain	= 0;}
	if (VthClassForMSIL != 0) {UnregisterClass((WCP)VthClassForMSIL, hDllInst); VthClassForMSIL = 0;}
}

//==============================================================================================================//
//	tH[JXݒ																								//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthSetFocus	   (HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = (SetFocus(pW->hMain) != NULL);
		}
	}
	return rc;
}
//==============================================================================================================//
//	vpeBݒ																								//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pProp  - ݒ肷vpeBf[^̃AhX														//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthSetPropA	   (HWND hwnd, PCAJCVTHPROPA pProp)
{
	BOOL		rc = FALSE;
	AJCVTHPROPW	propW;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProp != NULL) {
			memcpy(&propW, pProp, sizeof propW);
			MultiByteToWideChar(CP_ACP, 0, pProp->LogFont.lfFaceName, -1, propW.LogFont.lfFaceName, AJCTSIZE(propW.LogFont.lfFaceName));
			rc = AjcVthSetPropW(hwnd, &propW);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthSetPropW	   (HWND hwnd, PCAJCVTHPROPW pProp)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProp != NULL) {
			rc = VthSetCtrlProp(pW, pProp);
		}
	}
	return rc;
}
//==============================================================================================================//
//	vpeB擾																								//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pProp  - 擾vpeBf[^i[obt@̃AhX									//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthGetPropA	   (HWND hwnd, PAJCVTHPROPA	pBuf)
{
	BOOL		rc = FALSE;
	AJCVTHPROPW	propW;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pBuf != NULL) {
			if (rc = AjcVthGetPropW(hwnd, &propW)) {
				memcpy(pBuf, &propW, sizeof(AJCVTHPROPA));
				WideCharToMultiByte(CP_ACP, 0, propW.LogFont.lfFaceName, -1, pBuf->LogFont.lfFaceName,
																AJCTSIZE(pBuf->LogFont.lfFaceName), NULL, NULL);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthGetPropW	   (HWND hwnd, PAJCVTHPROPW	pBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pBuf != NULL) {
			memcpy(pBuf, &pW->prop, sizeof(AJCVTHPROP));
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	vpeBEZbgiECh̃vpeBݒj														//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthResetProp	   (HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			VthSetCtrlProp(pW, &pW->IniProp);
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	uq`lɃtBbgEChTCY擾																	//
//																												//
//	@	F	hwnd	- Rg[̃nh																//
//				pWidth	- sNZi[obt@̃AhX												//
//				pHeight - csNZi[obt@̃AhX												//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthGetVramFitSize(HWND hwnd, UIP pWidth, UIP pHeight)
{
	BOOL		rc = FALSE;
	RECT		r;
	UI			sty, exs;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			r.left	 = 0;
			r.right	 = pW->prop.VramW * pW->cxChar + (HMRG * 2);
			if ((pW->style & AJCVTHS_NOVSCROLL) == 0 && pW->prop.VramH < pW->LCnt) {
				r.right += GetSystemMetrics(SM_CXVSCROLL);
			}
			r.top	 = 0;
			r.bottom = pW->prop.VramH * pW->cyChar + (VMRG * 2);
			if ((pW->style & AJCVTHS_NOHSCROLL) == 0) {
				r.bottom += GetSystemMetrics(SM_CYHSCROLL);
			}

			sty = (UI)MAjcGetWindowLong(pW->hBack, GWL_STYLE);
			exs = (UI)MAjcGetWindowLong(pW->hBack, GWL_EXSTYLE);
			AdjustWindowRectEx(&r, sty, FALSE, exs);

			if (pWidth	!= NULL) *pWidth  = r.right - r.left;
			if (pHeight != NULL) *pHeight = r.bottom - r.top;

			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	P`																									//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				c	   - R[h																				//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthPutCharA	   (HWND hwnd, UI c)
{
	BOOL	rc = FALSE;
	BC		bc = (BC)c;

	rc =  AjcVthPutTextA(hwnd, &bc, 1);

	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthPutCharW	   (HWND hwnd, UI c)
{
	BOOL	rc = FALSE;
	UW		wc = (UW)c;

	rc = AjcVthPutTextW(hwnd, &wc, 1);

	return rc;
}

//==============================================================================================================//
//	eLXg`ij																						//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pTxt   - {dtbeLXgf[^̃AhX													//
//				lTxt   - eLXgi|P̏ꍇ́AvZj											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
static BOOL	  SubPutTextAuto(HWND hwnd, C_BCP pTxt, UI lTxt, BOOL (WINAPI *cbPutUtf8)(HWND hwnd, C_BCP pTxt, UI lTxt))
{
	BOOL		rc = FALSE;
	BCP			pSrc;
	AJCMBCKIND	mbk;
	PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);

	//	񒷎ݒ^␳
	lTxt = AjcStrAdjustLenA(pTxt, lTxt);
	//	eLXg`
	if (pSrc = (BCP)AJCMEM(lTxt + 1)) {
		memcpy(pSrc, pTxt, lTxt);
		pSrc[lTxt] = 0;
		if (lTxt != 0) {
			//--- R[hpf[^~ -----//
			AjcMbcPutData(pW->hMbc, pSrc);
			//--- R[hʂƃeLXgo ---//
			mbk = AjcMbcCheck(pW->hMbc);
			if (mbk <= 0) {
				mbk = pW->SvMbk;
			}
			switch(mbk) {
				default:
				case AJCMBC_SJIS:	rc = AjcVthPutTextA  (hwnd, pTxt, lTxt);	break;
				case AJCMBC_EUC:	rc = AjcVthPutTextEUC(hwnd, pTxt, lTxt);	break;
				case AJCMBC_UTF8:	rc = cbPutUtf8		 (hwnd, pTxt, lTxt);	break;
			}
			pW->SvMbk = mbk;
		}
		else rc = TRUE;
		free(pSrc);
	}
	return rc;
}
//----- oCgiUTF-WS-JISɕϊĕ`悷j-----------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthPutTextAutoA	   (HWND hwnd, C_BCP pTxt, UI lTxt)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			rc = SubPutTextAuto(hwnd, pTxt, lTxt, AjcVthPutTextUTF8A);
		}
	}
	return rc;
}
//----- Chi`悷j------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthPutTextAutoW	   (HWND hwnd, C_BCP pTxt, UI lTxt)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			rc = SubPutTextAuto(hwnd, pTxt, lTxt, AjcVthPutTextUTF8W);
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`i{dtbj																				//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pTxt   - {dtbeLXgf[^̃AhX													//
//				lTxt   - eLXgi|P̏ꍇ́AvZj											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthPutTextEUC	   (HWND hwnd, C_BCP pTxt, UI lTxt)
{
	BOOL		rc = FALSE;
	BCP			pEuc;
	BCP			pSJis;
	UI			lSJis;
	UI			lTail;
	AJCMBCINFO	mbi;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			//	񒷎ݒ^␳
			lTxt = AjcStrAdjustLenA(pTxt, lTxt);
			//	eLXg`
			if (pEuc = (BCP)AJCMEM(lTxt + 8 + 1)) {
				//	ޔĂ锼[oCgƃeLXg
				if (pW->SvStl == 0) {
					memcpy(pEuc, pTxt, lTxt);
				}
				else {
					memcpy(pEuc 		   , pW->SvStr, pW->SvStl);
					memcpy(pEuc + pW->SvStl, pTxt	  , lTxt	 );
					lTxt += pW->SvStl;
					pW->SvStl = 0;
				}
				pEuc[lTxt] = 0;

				if (lTxt != 0) {
					//	̔[oCgޔ
					AjcStrChkEucPart(pEuc, lTxt - 1, &mbi);
					lTail = mbi.ix + 1;
					if ((UI)mbi.len != lTail) {
						lTail = __min(lTail, lTxt);
						memcpy(pW->SvStr, pEuc + (lTxt - lTail), lTail);
						pW->SvStl = lTail;
						lTxt -= lTail;
					}
					//	dtbrihrϊAeLXg\
					if (lTxt != 0) {
						lSJis = AjcEucToSJisEx(pEuc, lTxt, NULL, 0);
						if (pSJis = (BCP)AJCMEM(lSJis)) {
							AjcEucToSJisEx(pEuc, lTxt, pSJis, lSJis);
							AjcVthPutTextA(hwnd, pSJis, lSJis);
							free(pSJis);
							rc = TRUE;
						}
					}
					else rc = TRUE;
				}
				else rc = TRUE;
				free(pEuc);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`itse|Wj																					//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pTxt   - tse|WeLXgf[^̃AhX														//
//				lTxt   - eLXgi|P̏ꍇ́AvZj											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//	ʃTu֐
static BOOL	  SubPutTextUTF8	   (HWND hwnd, C_BCP pTxt, UI lTxt, BOOL (*cbPutText)(HWND hwnd, C_BCP pUtf8, UI lTxt))
{
	BOOL		rc = FALSE;
	PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
	BCP			pUtf8;
	UI			lTail;
	AJCMBCINFO	mbi;

	//	񒷎ݒ^␳
	lTxt = AjcStrAdjustLenA(pTxt, lTxt);
	//	eLXg`
	if (pUtf8 = (BCP)AJCMEM(lTxt + 8 + 1)) {
		//	ޔĂ锼[oCgƃeLXg
		if (pW->SvStl == 0) {
			memcpy(pUtf8, pTxt, lTxt);
		}
		else {
			memcpy(pUtf8			, pW->SvStr, pW->SvStl);
			memcpy(pUtf8 + pW->SvStl, pTxt	   , lTxt	  );
			lTxt += pW->SvStl;
			pW->SvStl = 0;
		}
		pUtf8[lTxt] = 0;

		if (lTxt != 0) {
			//	̔[oCgޔ
			AjcStrChkUtf8Part(pUtf8, lTxt - 1, &mbi);
			lTail = mbi.ix + 1;
			if ((UI)mbi.len != lTail) {
				lTail = __min(lTail, lTxt);
				memcpy(pW->SvStr, pUtf8 + (lTxt - lTail), lTail);
				pW->SvStl = lTail;
				lTxt -= lTail;
			}
			//	tseWUNICODEϊAeLXg\
			if (lTxt != 0) {
				rc = cbPutText(hwnd, pUtf8, lTxt);
			}
			else rc = TRUE;
		}
		else rc = TRUE;
		free(pUtf8);
	}
	return rc;
}
//----- oCgiS-JISɕϊĕ\j-----------------------------------------------------------------------//
//	R[obN
static	BOOL	cbPutTextUTF8A(HWND hwnd, C_BCP pUtf8, UI lTxt)
{
	BOOL		rc = FALSE;
	PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
	BCP			pMbc = NULL;
	UI			lMbc = 0;

	if (lTxt != 0) {
		lMbc = AjcUtf8ToSJisEx(pUtf8, lTxt, NULL, 0);
		if (lMbc != 0 && (pMbc = AjcTAllocA(lMbc + 1))) {
			AjcUtf8ToSJisEx(pUtf8, lTxt, pMbc, lMbc);
			AjcVthPutTextA(hwnd, pMbc, lMbc);
			free(pMbc);
			rc = TRUE;
		}
	}
	else rc = TRUE;

	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - // 
AJCEXPORT BOOL	  WINAPI AjcVthPutTextUTF8A	   (HWND hwnd, C_BCP pTxt, UI lTxt)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			rc = SubPutTextUTF8(hwnd, pTxt, lTxt, cbPutTextUTF8A);
		}
	}
	return rc;
}
//----- ChiUNICODEɕϊĕ\j---------------------------------------------------------------------//
//	R[obN
static	BOOL	cbPutTextUTF8W(HWND hwnd, C_BCP pUtf8, UI lTxt)
{
	BOOL		rc = FALSE;
	PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
	WCP			pUni = NULL;
	UI			lUni = 0;

	if (lTxt != 0) {
		lUni = MultiByteToWideChar(CP_UTF8, 0, pUtf8, lTxt, NULL, 0);
		if (pUni = AjcTAllocW(lUni)) {
			MultiByteToWideChar(CP_UTF8, 0, pUtf8, lTxt, pUni, lUni);
			AjcVthPutTextW(hwnd, pUni, lUni);
			free(pUni);
			rc = TRUE;
		}
	}
	else rc = TRUE;

	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - // 
AJCEXPORT BOOL	  WINAPI AjcVthPutTextUTF8W	   (HWND hwnd, C_BCP pTxt, UI lTxt)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			rc = SubPutTextUTF8(hwnd, pTxt, lTxt, cbPutTextUTF8W);
		}
	}
	return rc;
}

//==============================================================================================================//
//	eLXg`iVtgihrj																				//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pTxt   - eLXgf[^̃AhX																//
//				lTxt   - eLXgi|P̏ꍇ́AvZj											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthPutTextA	   (HWND hwnd, C_BCP pTxt, UI lTxt)
{
	BOOL		rc = FALSE;
	WCP			pTmp;
	UL			len;
	WC			wc[4];

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			do {
				//	񒷎ݒ^␳
				lTxt = AjcStrAdjustLenA(pTxt, lTxt);
				//	eLXg`FbN
				if (lTxt == 0) {rc = TRUE; break;}
				//	O̔[oCg
				if (pW->SvMbc != 0) {
					BC		bc[2];
					bc[0] = pW->SvMbc;
					bc[1] = *pTxt;
					pW->SvMbc = 0;
					MultiByteToWideChar(CP_ACP, 0, bc, 2, wc, 1);
					if (!(rc = SubPutText(pW, wc, 1))) {
						break;
					}
					pTxt++;
					lTxt--;
				}
				//	eLXg`FbN
				if (lTxt == 0) {rc = TRUE; break;}
				//	SpPڂȂΑޔAO
				if (mbsbtype(pTxt, lTxt - 1) == _MBC_LEAD) {
					pW->SvMbc = pTxt[lTxt - 1];
					lTxt--;
				}
				//	eLXg`FbN
				if (lTxt == 0) {rc = TRUE; break;}
				//	MBC -> UNICODE ϊo
				len = MultiByteToWideChar(CP_ACP, 0, pTxt, lTxt, NULL, 0);
				if (len != 0  &&  (pTmp = AjcTAlloc(len + 1))) {
					MultiByteToWideChar(CP_ACP, 0, pTxt, lTxt, pTmp, len);
					pTmp[len] = 0;
					rc = SubPutText(pW, pTmp, len);
					free(pTmp);
				}
				else rc = FALSE;
			} while(0);
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthPutTextW	   (HWND hwnd, C_WCP pTxt, UI lTxt)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			lTxt = AjcStrAdjustLenW(pTxt, lTxt);
			if (lTxt != 0) {
				rc = SubPutText(pW, pTxt, lTxt);
			}
			else rc = TRUE;
		}
	}
	return rc;
}
//----- ʃTu -----------------------------------------------------------------------------------------------//
static	BOOL	SubPutText (PWRKVT100 pW, C_WCP pTxt, UI lTxt)
{
	BOOL	rc;
	UI		stl, bytes;

	stl  = (UI)wcslen(pTxt);
	lTxt = __min(lTxt, stl);
	bytes = lTxt * 2;
	rc = (AjcRngPutData(pW->hRngTxt, (VOP)pTxt, bytes) == bytes);		//	eLXgޔ
	bytes = AjcRngGetDataSize(pW->hRngTxt);								//	bytes = ݂̕\ۗoCg
	if (bytes >= pW->prop.PendSize) {									//	őۗTCYI[o[H
		VthSetMode(pW, MD_NORMAL);										//		͈͑IԁC\ۗ
	}
	VthPutTextToVRAM(pW);												//	uq`l`

	return rc;
}
//==============================================================================================================//
//	eLXg`																							//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pFmt   - eLXg																			//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthPrintFA	   (HWND hwnd, C_BCP pFmt, ...)
{
	BOOL		rc = FALSE;
	va_list 	vls;
	BC			buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnprintf(buf, 2048, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcVthPutTextA(hwnd, buf, -1);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	  WINAPI AjcVthPrintFW	   (HWND hwnd, C_WCP pFmt, ...)
{
	BOOL		rc = FALSE;
	va_list 	vls;
	WC			buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnwprintf(buf, 2048, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcVthPutTextW(hwnd, buf, -1);
	}
	return rc;
}
//==============================================================================================================//
//	^CX^v`																							//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	   WINAPI AjcVthTimeStamp	(HWND hwnd)
{
	BOOL		rc = FALSE;
	SYSTEMTIME	lt;

	GetLocalTime(&lt);
	rc = AjcVthPrintFW(hwnd, L"%02d:%02d:%02d.%03d", lt.wHour, lt.wMinute, lt.wSecond, lt.wMilliseconds);

	return rc;
}
//==============================================================================================================//
//	oCif[^̂PUi_v`																			//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pDat   - oCif[^̃AhX																//
//				lDat   - oCif[^̃oCg																//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	   WINAPI AjcVthHexDump		(HWND hwnd, C_UBP pDat, UI lDat)
{
	BOOL	rc = TRUE;
	WCP		p, pBuf;
	UI		lBuf = lDat * 3;
	UB		l, h;

	if (pDat != NULL && lDat > 0) {
		if (pBuf = AjcTAlloc(lBuf)) {
			p = pBuf;
			while (lDat > 0) {
				h = ((UB)(*pDat) >> 4);
				l = ((UB)(*pDat) & 15);
				*p++ = L' ';
				*p++ = (WC)(h < 10 ? (h | 0x30) : (h + L'A' - 10));
				*p++ = (WC)(l < 10 ? (l | 0x30) : (l + L'A' - 10));
				pDat++;
				lDat--;
			}
			rc = AjcVthPutTextW(hwnd, pBuf, lBuf);
			free(pBuf);
		}
		else {
			while (lDat--) {
				rc &= AjcVthPrintFW(hwnd, L" %02X", *pDat++);
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	J[\ʒuݒ																							//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				line   - sʒuiO`j																			//
//				col	   - ʒuiO`j																			//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthLocate	   (HWND hwnd, UI line, UI col)
{
	BOOL	rc = FALSE;

	rc = AjcVthPrintFW(hwnd, L"\x1B[%u;%uH", line + 1, col + 1);

	return rc;
}
//==============================================================================================================//
//	J[\ʒu擾																							//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pLine	- sʒuiO`ji[obt@̃AhX											//
//				pCol	- ʒuiO`ji[obt@̃AhX											//
//																												//
//	߂l	F	sʒu																							//
//==============================================================================================================//
AJCEXPORT UI	   WINAPI AjcVthGetCursorPos(HWND hwnd, UIP pLine, UIP pCol)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pLine != NULL) *pLine = pW->lp;
			if (pCol  != NULL) *pCol  = pW->cp;
			rc = pW->lp;
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXg\Fݒ																							//
//																												//
//	@	F	hwnd	  - Rg[̃nh																//
//				PaletteNo - pbgԍiO`Vj																//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthSetColor	   (HWND hwnd, UI PaletteNo)
{
	BOOL	rc = FALSE;

	rc = AjcVthPrintFW(hwnd, L"\x1B[%um", PaletteNo + 30);

	return rc;
}
//==============================================================================================================//
//	eLXg\F擾																							//
//																												//
//	@	F	hwnd	  - Rg[̃nh																//
//																												//
//	߂l	F	eLXg\Fipbgԍj																	//
//==============================================================================================================//
AJCEXPORT UI	   WINAPI AjcVthGetColor	(HWND hwnd)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = (pW->att & 7);
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXgwiFݒ																							//
//																												//
//	@	F	hwnd	  - Rg[̃nh																//
//				PaletteNo - pbgԍiO`Vj																//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthSetBkColor  (HWND hwnd, UI PaletteNo)
{
	BOOL	rc = FALSE;

	rc = AjcVthPrintFW(hwnd, L"\x1B[%um", PaletteNo + 40);

	return rc;
}
//==============================================================================================================//
//	eLXgwiF擾																							//
//																												//
//	@	F	hwnd	  - Rg[̃nh																//
//																												//
//	߂l	F	wiFipbgԍj																			//
//==============================================================================================================//
AJCEXPORT UI	   WINAPI AjcVthGetBkColor	(HWND hwnd)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = ((pW->att >> 4) & 7);
		}
	}
	return rc;
}
//==============================================================================================================//
//	ECh̔wiFݒ																						//
//																												//
//	@	F	hwnd		- Rg[̃nh															//
//				iPaletteNo	- wiF̃pbgԍ																//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	   WINAPI AjcVthSetWndBkColor(HWND hwnd, UI PaletteNo)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && PaletteNo < 8) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->IxBkWnd = PaletteNo;
			VthCreateBkWndObj(pW);
			InvalidateRect(pW->hBack, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	ECh̔wiF擾																						//
//																												//
//	@	F	hwnd	  - Rg[̃nh																//
//																												//
//	߂l	F	wiF̃pbgԍ																			//
//==============================================================================================================//
AJCEXPORT UI	WINAPI AjcVthGetWndBkColor(HWND hwnd)
{
	COLORREF	rc = (COLORREF)0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->IxBkWnd;
		}
	}
	return rc;
}
//==============================================================================================================//
//	pbg̐Fݒ																							//
//																												//
//	@	F	hwnd	  - Rg[̃nh																//
//				PaletteNo - pbgԍiO`Vj																//
//				rgb		  - pbgɐݒ肷F																//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthSetPalette  (HWND hwnd, UI PaletteNo, COLORREF rgb)
{
	BOOL		rc = FALSE;
	AJCVTHPROP	prop;

	if (IsWindow(hwnd)	&&	PaletteNo < 8) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			//	EChwiF̃yCuV
			VthCreateBkWndObj(pW);
			//	vpeB̃pbgFXV
			memcpy(&prop, &pW->prop, sizeof prop);
			prop.rgb[PaletteNo] = rgb;
			rc = VthSetCtrlProp(pW, &prop);
		}
	}
	return rc;
}
//==============================================================================================================//
//	pbg̐F擾																							//
//																												//
//	@	F	hwnd	  - Rg[̃nh																//
//				PaletteNo - pbgԍiO`Vj																//
//																												//
//	߂l	F	pbg̐FR[h																				//
//==============================================================================================================//
AJCEXPORT COLORREF WINAPI AjcVthGetPalette	(HWND hwnd, UI PaletteNo)
{
	COLORREF	rc = (COLORREF)0;

	if (IsWindow(hwnd)	&&	PaletteNo < 8) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = (pW->prop.rgb[PaletteNo & 7]);
		}
	}
	return rc;
}

//==============================================================================================================//
//	I																									//
//																												//
//	@	F	hwnd	 - Rg[̃nh																//
//				slp, scp - IJnsʒuCʒu																//
//				elp, ecp - IIsʒuCʒu																//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthSelect	(HWND hwnd, UI slp, UI scp, UI elp, UI ecp)
{
	BOOL		rc = FALSE;
	int			six, eix;
	PLINEPTR	pSL, pEL;		//	C|C^
	UBP			pSA, pEA;		//	|C^

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			//	Isʒu
			if (slp >= pW->LCnt) slp = pW->LCnt - 1;
			if (elp >= pW->LCnt) elp = pW->LCnt - 1;
			//	I͈͂̒
			if		(slp == elp) {							//	Jns  IsH
				if (scp > ecp) {							//		Jn  IH
					AjcMemSwap(&scp, &ecp, sizeof(UI));		//			JnƏI
				}
			}
			else if (slp > elp) {							//	Jns  IsH
				AjcMemSwap(&slp, &elp, sizeof(UI));			//		JnsƏIs
				AjcMemSwap(&scp, &ecp, sizeof(UI));			//		JnƏI
			}
			//	s|C^ݒ
			six = VthLnoToIx(pW, slp);	pSL = pW->pLPtr + six;
			eix = VthLnoToIx(pW, elp);	pEL = pW->pLPtr + eix;
			//	ʒuiYs̏I[ȉƂj
			if (scp > pSL->len) scp = pSL->len;
			if (ecp > pSL->len) ecp = pEL->len;
			//	JnʒuTQ[gQ[hڂȂ΁AP߂
			if (pSL->fVram) pSA = (UBP)(pSL->pTxt + (pW->prop.VramW)) + scp;
			else			pSA = (UBP)(pSL->pTxt + (pSL->len	   )) + scp;
			if (*pSA & VAT_SUR2) scp--;
			//	IʒuTQ[gQ[hڂȂ΁APi߂
			if (pEL->fVram) pEA = (UBP)(pEL->pTxt + (pW->prop.VramW)) + ecp;
			else			pEA = (UBP)(pEL->pTxt + (pEL->len 	   )) + ecp;
			if (*pEA & VAT_SUR2) ecp++;
			//	Iݒ
			if (slp != elp || scp != ecp) {	//	I͈͂isʒu^ʒûꂩقȂjH
				pW->SelInf.ixSL = six;
				pW->SelInf.ixSC = scp;
				pW->SelInf.ixEL = eix;
				pW->SelInf.ixEC = ecp;
				VthSetMode(pW, pW->Mode | MD_SELECT);
				InvalidateRect(hwnd 	, NULL, FALSE);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	SđI																									//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthSelectAll   (HWND hwnd)
{
	BOOL		rc = FALSE;
	UI			ix;
	PLINEPTR	pL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pW->LCnt != 0) {
				pW->SelInf.ixSL = pW->IxSrt;
				pW->SelInf.ixSC = 0;
				ix = VthLnoToIx(pW, pW->LCnt - 1);
				pL = pW->pLPtr + ix;
				pW->SelInf.ixEL = ix;
				pW->SelInf.ixEC = pL->len;
				VthSetMode(pW, pW->Mode | MD_SELECT);
				InvalidateRect(hwnd 	, NULL, FALSE);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Rs[																										//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthCopyText	   (HWND hwnd)
{
	BOOL		rc = FALSE;
	HGLOBAL		hGlobal;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (hGlobal = GetSelectedText(pW)) {
				//	Nbv{[hփRs[
				GlobalUnlock(hGlobal);
				OpenClipboard(pW->hBack);
				EmptyClipboard();
				SetClipboardData(CF_UNICODETEXT, hGlobal);
				CloseClipboard();
				//	Iԉ
				VthSetMode(pW, pW->Mode & ~MD_SELECT);
				InvalidateRect(pW->hMain, NULL, FALSE);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	tHgݒ																								//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//- - - tHg_CAONʒm - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	VO CALLBACK cbAvsfInit (HWND hDlg, UX cbp)	//	hDlg = Font setting dialog
{
	AjcMoveWindowToCenterOfMonitor(hDlg);
}
//- - - Ev{^ʒm - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
BOOL CALLBACK cbAvsfApply (HFONT hFont, UI lsp, UX cbp)
{
	HWND		hwnd = (HWND)cbp;
	PWRKVT100	pW	 = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
	AJCVTHPROP	prop;

	AjcVthGetProp(hwnd, &prop);
	GetObjectW(hFont, sizeof prop.LogFont, &prop.LogFont);
	prop.LSpace = lsp;
	AjcVthSetProp(hwnd, &prop);

	return TRUE;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	  WINAPI AjcVthSetFont	   (HWND hwnd)
{
	BOOL		rc = FALSE;
	AJCVTHPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			memcpy(&prop, &pW->prop, sizeof prop);
			memcpy(&pW->DwkFontInfo.lf, &prop.LogFont, sizeof pW->DwkFontInfo.lf);
			pW->DwkFontInfo.lsp = prop.LSpace;
			if (AjcCfFontDlgW(hwnd, 0, &pW->DwkFontInfo, &pW->DwkPermInfo, (UX)hwnd, cbAvsfInit, cbAvsfApply)) {	//	tHgݒnjH
				memcpy(&prop.LogFont, &pW->DwkFontInfo.lf, sizeof prop.LogFont);	//		vpeBɃtHgݒ
				prop.LSpace = pW->DwkFontInfo.lsp;
				if (!(rc = AjcVthSetProp(hwnd, &prop))) {							//		VtHgCvg
					MessageBoxW(hwnd, LNGSEL(L"̃tHg͐ݒł܂", L"This font can not be set !!"),
									  AppName, MB_APPLMODAL | MB_ICONERROR);
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Lbg\																								//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthShowCaret   (HWND hwnd, BOOL fShow)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fCaret = fShow;
			VthSetCaret(pW);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	SeLXgNA[																							//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	  WINAPI AjcVthClear(HWND hwnd)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			//----- ʕR[hobt@ -----------------------------------------------------------//
			AjcMbcReset(pW->hMbc);
			pW->SvMbk = AJCMBC_SJIS;
			//----- `FZbg -----------------------------------------------------------------------------//
		//	VrmSetAtt(pW, VAT_DEFAULT);
			//----- eLXgNA[ ---------------------------------------------------------------------------//
			VthClearAllText(pW);
			InvalidateRect(hwnd 	, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	  WINAPI AjcVthClearAllText(HWND hwnd)
{
	BOOL		rc = FALSE;

	rc = AjcVthClear(hwnd);

	return rc;
}

//==============================================================================================================//
//	hbvꂽt@C擾																				//
//																												//
//	@	F	pW	  - CX^X[NAhX																//
//				buf	  - t@Ci[obt@̃AhX													//
//																												//
//	߂l	F	TRUE:t@CCFALSE:t@CȂ														//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcVthGetDroppedFileA (HWND hwnd, BC buf[MAX_PATH])
{
	BOOL	rc = FALSE;
	WC		tmp[MAX_PATH];

	if (buf != NULL) {
		if (rc = AjcVthGetDroppedFileW(hwnd, tmp)) {
			WideCharToMultiByte(CP_ACP, 0, tmp, -1, buf, MAX_PATH, NULL, NULL);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcVthGetDroppedFileW (HWND hwnd, WC buf[MAX_PATH])
{
	BOOL		rc = FALSE;
	UI			bytes;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && buf != NULL) {
			if (AjcRngGetData(pW->hRngFile, (VOP)&bytes, sizeof bytes) == sizeof bytes) {
				rc = (AjcRngGetData(pW->hRngFile, (VOP)buf, bytes) == bytes);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽfBNg擾																			//
//																												//
//	@	F	pW	  - CX^X[NAhX																//
//				buf	  - fBNgi[obt@̃AhX												//
//																												//
//	߂l	F	TRUE:fBNgCFALSE:fBNgȂ												//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcVthGetDroppedDirA  (HWND hwnd, BC buf[MAX_PATH])
{
	BOOL	rc = FALSE;
	WC		tmp[MAX_PATH];

	if (buf != NULL) {
		if (rc = AjcVthGetDroppedDirW(hwnd, tmp)) {
			WideCharToMultiByte(CP_ACP, 0, tmp, -1, buf, MAX_PATH, NULL, NULL);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcVthGetDroppedDirW  (HWND hwnd, WC buf[MAX_PATH])
{
	BOOL		rc = FALSE;
	UI			bytes;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && buf != NULL) {
			if (AjcRngGetData(pW->hRngDir, (VOP)&bytes, sizeof bytes) == sizeof bytes) {
				rc = (AjcRngGetData(pW->hRngDir, (VOP)buf, bytes) == bytes);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽfBNg擾íuvtwtj												//
//																												//
//	@	F	pW				 - CX^X[NAhX													//
//				buf				 - fBNgi[obt@̃AhX									//
//				fTailIsDelimiter - TRUE  : fBNgpX̖Ɂu\vt								//
//								   FALSE : fBNgpX̖Ɂu\vtȂ								//
//																												//
//	߂l	F	TRUE:fBNgCFALSE:fBNgȂ												//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcVthGetDroppedDirExA	(HWND hwnd, BC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	BOOL	rc = FALSE;
	WC		tmp[MAX_PATH];

	if (rc = AjcVthGetDroppedDirExW(hwnd, tmp, fTailIsDelimiter)) {
		WideCharToMultiByte(CP_ACP, 0, tmp, -1, buf, MAX_PATH, NULL, NULL);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcVthGetDroppedDirExW	(HWND hwnd, WC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	BOOL		rc = FALSE;

	if (rc = AjcVthGetDroppedDirW(hwnd, buf)) {
		if (fTailIsDelimiter) AjcPathCat(buf, L"", MAX_PATH);
		else				  PathRemoveBackslashW(buf);
	}
	return rc;
}
//==============================================================================================================//
//	vt@CvpeBǂݏo																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV														//
//				pDefProp	 - ftHgvpeBliݒlftHgƂꍇNULL)						//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthLoadPropA		(HWND hwnd, C_BCP pProfileSect, PCAJCVTHPROPA pDefProp)
{
	BOOL			rc = FALSE;
	UI				len;
	WCP				pTmp = NULL;

	if (pProfileSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			//	ZNVCh
			MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmp, len);
			//	ftHgvpeBChACho[W`ohR[
			if (pDefProp != NULL) {
				AJCVTHPROPW	DefPropW;
				memcpy(&DefPropW, pDefProp, sizeof DefPropW);
				MultiByteToWideChar(CP_ACP, 0, pDefProp->LogFont.lfFaceName, -1, DefPropW.LogFont.lfFaceName, AJCTSIZE(DefPropW.LogFont.lfFaceName));
				rc = AjcVthLoadPropW(hwnd, pTmp, &DefPropW);
			}
			//	ftHgvpeBȂŁACho[W`ohR[
			else {
				rc = AjcVthLoadPropW(hwnd, pTmp, NULL);
			}
		}
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthLoadPropW		(HWND hwnd, C_WCP pProfileSect, PCAJCVTHPROPW pDefProp)
{
	BOOL		rc = TRUE;
	AJCVTHPROP	prop;
	WC			DefFaceName[LF_FACESIZE];

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProfileSect != NULL) {
			if (pDefProp != NULL) memcpy(&prop, pDefProp, sizeof prop);
			else				  rc = AjcVthGetProp(hwnd, &prop);
			if (rc) {
				prop.VramW		  = AjcGetProfileUInt(pProfileSect, L"VramW"   , prop.VramW	  );
				prop.VramH		  = AjcGetProfileUInt(pProfileSect, L"VramH"   , prop.VramH	  );
			//	prop.CaretH		  = AjcGetProfileUInt(pProfileSect, L"CaretH"  , prop.CaretH  );
				prop.MaxLines	  = AjcGetProfileUInt(pProfileSect, L"MaxLines", prop.MaxLines);
				prop.TabStep	  = AjcGetProfileUInt(pProfileSect, L"TabStep" , prop.TabStep );
				prop.LSpace		  = AjcGetProfileUInt(pProfileSect, L"LSpace"  , prop.LSpace  );
				prop.PendSize	  = AjcGetProfileUInt(pProfileSect, L"PendSize", prop.PendSize);

				prop.LogFont.lfHeight		  = AjcGetProfileSInt(pProfileSect, L"lfHeight"		   , prop.LogFont.lfHeight		 );
				prop.LogFont.lfWidth		  = AjcGetProfileUInt(pProfileSect, L"lfWidth"		   , prop.LogFont.lfWidth		 );
				prop.LogFont.lfEscapement	  = AjcGetProfileUInt(pProfileSect, L"lfEscapement"	   , prop.LogFont.lfEscapement	 );
				prop.LogFont.lfOrientation	  = AjcGetProfileUInt(pProfileSect, L"lfOrientation"   , prop.LogFont.lfOrientation	 );
				prop.LogFont.lfWeight		  = AjcGetProfileUInt(pProfileSect, L"lfWeight"		   , prop.LogFont.lfWeight		 );
				prop.LogFont.lfItalic		  = AjcGetProfileUInt(pProfileSect, L"lfItalic"		   , prop.LogFont.lfItalic		 );
				prop.LogFont.lfUnderline	  = AjcGetProfileUInt(pProfileSect, L"lfUnderline"	   , prop.LogFont.lfUnderline	 );
				prop.LogFont.lfStrikeOut	  = AjcGetProfileUInt(pProfileSect, L"lfStrikeOut"	   , prop.LogFont.lfStrikeOut	 );
				prop.LogFont.lfCharSet		  = AjcGetProfileUInt(pProfileSect, L"lfCharSet"	   , prop.LogFont.lfCharSet		 );
				prop.LogFont.lfOutPrecision	  = AjcGetProfileUInt(pProfileSect, L"lfOutPrecision"  , prop.LogFont.lfOutPrecision );
				prop.LogFont.lfClipPrecision  = AjcGetProfileUInt(pProfileSect, L"lfClipPrecision" , prop.LogFont.lfClipPrecision);
				prop.LogFont.lfQuality		  = AjcGetProfileUInt(pProfileSect, L"lfQuality"		  , prop.LogFont.lfQuality	 );
				prop.LogFont.lfPitchAndFamily = AjcGetProfileUInt(pProfileSect, L"lfPitchAndFamily", prop.LogFont.lfPitchAndFamily);
				wcsncpy(DefFaceName, prop.LogFont.lfFaceName, LF_FACESIZE);
				DefFaceName[LF_FACESIZE - 1] = 0;
				AjcGetProfileStr(pProfileSect, L"lfFaceName", DefFaceName, prop.LogFont.lfFaceName, LF_FACESIZE);

				prop.rgb[0]		  = AjcGetProfileUInt(pProfileSect, L"rgb0"	 , prop.rgb[0]);
				prop.rgb[1]		  = AjcGetProfileUInt(pProfileSect, L"rgb1"	 , prop.rgb[1]);
				prop.rgb[2]		  = AjcGetProfileUInt(pProfileSect, L"rgb2"	 , prop.rgb[2]);
				prop.rgb[3]		  = AjcGetProfileUInt(pProfileSect, L"rgb3"	 , prop.rgb[3]);
				prop.rgb[4]		  = AjcGetProfileUInt(pProfileSect, L"rgb4"	 , prop.rgb[4]);
				prop.rgb[5]		  = AjcGetProfileUInt(pProfileSect, L"rgb5"	 , prop.rgb[5]);
				prop.rgb[6]		  = AjcGetProfileUInt(pProfileSect, L"rgb6"	 , prop.rgb[6]);
				prop.rgb[7]		  = AjcGetProfileUInt(pProfileSect, L"rgb7"	 , prop.rgb[7]);

				rc = AjcVthSetProp(hwnd, &prop);
			}

			//----- Ot@Co͐ -------------------------------------------------------------------------//
			if (pW->hWndLgf != NULL) {
				AjcLgfLoadProp(pW->hWndLgf, pProfileSect);
			}

			//----- eLXgZ[u -------------------------------------------------------------------------//
			pW->SvTxtFormat   = AjcGetProfileUInt(pProfileSect, L"SvTxtFormat"	, pW->SvTxtFormat  );
			pW->SvTxtEncode   = AjcGetProfileUInt(pProfileSect, L"SvTxtEncode"	, pW->SvTxtEncode  );
			pW->SvTxtOutput   = AjcGetProfileUInt(pProfileSect, L"SvTxtOutput"	, pW->SvTxtOutput  );
			pW->SvTxtFontSize = AjcGetProfileUInt(pProfileSect, L"SvTxtFontSize", pW->SvTxtFontSize);
			pW->SvBom		  = AjcGetProfileUInt(pProfileSect, L"SvBom" 		, pW->SvBom		  );
			AjcGetProfileStr(pProfileSect, L"SvTxtPath", pW->SvTxtPath, pW->SvTxtPath, AJCTSIZE(pW->SvTxtPath));
		}
		else rc = FALSE;
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	vt@CփvpeB																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV														//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthSavePropA		(HWND hwnd, C_BCP pProfileSect)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmp = NULL;

	if (pProfileSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmp, len);
			rc = AjcVthSavePropW(hwnd, pTmp);
		}
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthSavePropW		(HWND hwnd, C_WCP pProfileSect)
{
	BOOL		rc = FALSE;
	AJCVTHPROP	prop;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProfileSect != NULL) {
			if (rc = AjcVthGetProp(hwnd, &prop)) {
				AjcPutProfileUInt(pProfileSect, L"VramW"		   , prop.VramW	  );
				AjcPutProfileUInt(pProfileSect, L"VramH"		   , prop.VramH	  );
			//	AjcPutProfileUInt(pProfileSect, L"CaretH"		   , prop.CaretH  );
				AjcPutProfileUInt(pProfileSect, L"MaxLines"		   , prop.MaxLines);
				AjcPutProfileUInt(pProfileSect, L"TabStep"		   , prop.TabStep );
				AjcPutProfileUInt(pProfileSect, L"LSpace"		   , prop.LSpace  );
				AjcPutProfileUInt(pProfileSect, L"PendSize"		   , prop.PendSize);
	
				AjcPutProfileSInt(pProfileSect, L"lfHeight"		   , prop.LogFont.lfHeight		  );
				AjcPutProfileUInt(pProfileSect, L"lfWidth"		   , prop.LogFont.lfWidth		  );
				AjcPutProfileUInt(pProfileSect, L"lfEscapement"	   , prop.LogFont.lfEscapement	  );
				AjcPutProfileUInt(pProfileSect, L"lfOrientation"   , prop.LogFont.lfOrientation	  );
				AjcPutProfileUInt(pProfileSect, L"lfWeight"		   , prop.LogFont.lfWeight		  );
				AjcPutProfileUInt(pProfileSect, L"lfItalic"		   , prop.LogFont.lfItalic		  );
				AjcPutProfileUInt(pProfileSect, L"lfUnderline"	   , prop.LogFont.lfUnderline	  );
				AjcPutProfileUInt(pProfileSect, L"lfStrikeOut"	   , prop.LogFont.lfStrikeOut	  );
				AjcPutProfileUInt(pProfileSect, L"lfCharSet"	   , prop.LogFont.lfCharSet		  );
				AjcPutProfileUInt(pProfileSect, L"lfOutPrecision"  , prop.LogFont.lfOutPrecision  );
				AjcPutProfileUInt(pProfileSect, L"lfClipPrecision" , prop.LogFont.lfClipPrecision );
				AjcPutProfileUInt(pProfileSect, L"lfQuality"	   , prop.LogFont.lfQuality		  );
				AjcPutProfileUInt(pProfileSect, L"lfPitchAndFamily", prop.LogFont.lfPitchAndFamily);
				AjcPutProfileStr (pProfileSect, L"lfFaceName"	   , prop.LogFont.lfFaceName	  );
	
				AjcPutProfileUInt(pProfileSect, L"rgb0"			   , prop.rgb[0]);
				AjcPutProfileUInt(pProfileSect, L"rgb1"			   , prop.rgb[1]);
				AjcPutProfileUInt(pProfileSect, L"rgb2"			   , prop.rgb[2]);
				AjcPutProfileUInt(pProfileSect, L"rgb3"			   , prop.rgb[3]);
				AjcPutProfileUInt(pProfileSect, L"rgb4"			   , prop.rgb[4]);
				AjcPutProfileUInt(pProfileSect, L"rgb5"			   , prop.rgb[5]);
				AjcPutProfileUInt(pProfileSect, L"rgb6"			   , prop.rgb[6]);
				AjcPutProfileUInt(pProfileSect, L"rgb7"			   , prop.rgb[7]);
			}
	
			//----- Ot@Co͐ -------------------------------------------------------------------------//
			if (pW->hWndLgf != NULL) {
				AjcLgfSaveProp(pW->hWndLgf, pProfileSect);
			}
	
			//----- eLXgZ[u -------------------------------------------------------------------------//
			AjcPutProfileUInt(pProfileSect, L"SvTxtFormat"	, pW->SvTxtFormat  );
			AjcPutProfileUInt(pProfileSect, L"SvTxtEncode"	, pW->SvTxtEncode  );
			AjcPutProfileUInt(pProfileSect, L"SvTxtOutput"	, pW->SvTxtOutput  );
			AjcPutProfileUInt(pProfileSect, L"SvTxtFontSize", pW->SvTxtFontSize);
			AjcPutProfileUInt(pProfileSect, L"SvBom" 		, pW->SvBom		   );
			AjcPutProfileStr (pProfileSect, L"SvTxtPath"	, pW->SvTxtPath	   );
		}
	}
	return rc;
}
//==============================================================================================================//
//	vt@CiǂݏoiWj																	//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV														//
//				pKeyPrefix	 - vt@CL[̐ړ															//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthLoadPermInfoA		(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix)
{
	BOOL		rc = TRUE;

	rc = AjcVthLoadPermInfoExA(hwnd, pProfileSect, pKeyPrefix, AJCVTH_PERM_FONT);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthLoadPermInfoW		(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix)
{
	BOOL		rc = TRUE;

	rc = AjcVthLoadPermInfoExW(hwnd, pProfileSect, pKeyPrefix, AJCVTH_PERM_FONT);

	return rc;
}
//==============================================================================================================//
//	vt@Ciǂݏoiڎwj																//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - vt@C̃ZNV														//
//				pKeyPrefix	 - vt@CL[̐ړ															//
//				PermItem	 - iځiAJCVTH_PERM_XXXXXj													//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
#define			MKKEY(TAIL)		MkKey(pKeyPrefix, TAIL, szKey, AJCTSIZE(szKey))
static	C_WCP	MkKey(C_WCP pKeyPrefix, WCP pTail, WCP pKey, UI lKey)
{
	AjcSnPrintF(pKey, lKey, L"%s_%s", pKeyPrefix, pTail);
	return	pKey;
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthLoadPermInfoExA		(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmpSec = NULL;
	WCP		pTmpKey = NULL;

	do {
		if (pProfileSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
			if (len != 0 && (pTmpSec = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmpSec, len);
			}
			else break;
		}
		if (pKeyPrefix != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpKey = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpKey, len);
			}
			else break;
		}
		rc = AjcVthLoadPermInfoExW(hwnd, pTmpSec, pTmpKey, PermItem);
	} while(0);

	if (pTmpSec != NULL) free(pTmpSec);
	if (pTmpKey != NULL) free(pTmpKey);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthLoadPermInfoExW		(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem)
{
	BOOL		rc = FALSE;
	BOOL		fNeedUpdateProp = FALSE;
	AJCVTHPROP	prop;
	WC			DefFaceName[LF_FACESIZE];
	WC			szKey[256];

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProfileSect != NULL && pKeyPrefix != NULL) {
			//----- ftHgvpeBlݒ -----------------------------------------------------------------//
			memcpy(&prop, &pW->prop, sizeof prop);
			//----- ZNVCiڑޔ ---------------------------------------------------------------//
			//	vt@CZNVCL[ړޔ
			AjcVthSetPermAttW(hwnd, pProfileSect, pKeyPrefix);
			pProfileSect = pW->PermSect;
			pKeyPrefix	 = pW->PermKey;
			//	iڑޔ
			pW->PermItem = PermItem;
			//----- 펞i -----------------------------------------------------------------------------//
			//	VT100ւ̓Kp
			pW->fSetF_T = AjcGetProfileUInt(pProfileSect, MKKEY(L"fSetF_T"), pW->fSetF_T);
			//----- s -----------------------------------------------------------------------------------//
			if (pW->PermItem & AJCVTH_PERM_LFACT) {
				UI	sty, lfa;
				sty  = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
				lfa  = AjcGetProfileUInt(pProfileSect, MKKEY(L"Style"), sty);
				lfa &=	AJCVTHS_LFACT_MASK;
				sty &= ~AJCVTHS_LFACT_MASK;
				MAjcSetWindowLong(hwnd, GWL_STYLE, sty | lfa);
			}
			//----- tHg -------------------------------------------------------------------------------//
			if (pW->PermItem & AJCVTH_PERM_FONT) {
				//	tHg
				prop.LogFont.lfHeight		  = AjcGetProfileSInt(pProfileSect, MKKEY(L"lfHeight"		 )	, prop.LogFont.lfHeight		 	);
				prop.LogFont.lfWidth		  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfWidth"		 )	, prop.LogFont.lfWidth		 	);
				prop.LogFont.lfEscapement	  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfEscapement"	 )	, prop.LogFont.lfEscapement	 	);
				prop.LogFont.lfOrientation	  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfOrientation"	 )	, prop.LogFont.lfOrientation	);
				prop.LogFont.lfWeight		  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfWeight"		 )	, prop.LogFont.lfWeight			);
				prop.LogFont.lfItalic		  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfItalic"		 )	, prop.LogFont.lfItalic			);
				prop.LogFont.lfUnderline	  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfUnderline"	 )	, prop.LogFont.lfUnderline		);
				prop.LogFont.lfStrikeOut	  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfStrikeOut"	 )	, prop.LogFont.lfStrikeOut		);
				prop.LogFont.lfCharSet		  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfCharSet"		 )	, prop.LogFont.lfCharSet		);
				prop.LogFont.lfOutPrecision	  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfOutPrecision"	 )	, prop.LogFont.lfOutPrecision	);
				prop.LogFont.lfClipPrecision  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfClipPrecision" )	, prop.LogFont.lfClipPrecision	);
				prop.LogFont.lfQuality		  = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfQuality"		 )	, prop.LogFont.lfQuality		);
				prop.LogFont.lfPitchAndFamily = AjcGetProfileUInt(pProfileSect, MKKEY(L"lfPitchAndFamily")	, prop.LogFont.lfPitchAndFamily	);
				wcsncpy(DefFaceName, prop.LogFont.lfFaceName, LF_FACESIZE);
				DefFaceName[LF_FACESIZE - 1] = 0;
				AjcGetProfileStr(pProfileSect, MKKEY(L"lfFaceName"), DefFaceName, prop.LogFont.lfFaceName, LF_FACESIZE);
				//	sԃXy[X
				prop.LSpace = AjcGetProfileUInt(pProfileSect, MKKEY(L"LSpace"), prop.LSpace);
				//	tHgI_CAO
				pW->DwkPermInfo.hd.id		 = AjcGetProfileHex (pProfileSect, MKKEY(L"id"			 ), pW->DwkPermInfo.hd.id		);
				pW->DwkPermInfo.hd.fPixel	 = AjcGetProfileUInt(pProfileSect, MKKEY(L"fPixel"		 ), pW->DwkPermInfo.hd.fPixel	);
				pW->DwkPermInfo.hd.fItalic	 = AjcGetProfileUInt(pProfileSect, MKKEY(L"fItalic" 	 ), pW->DwkPermInfo.hd.fItalic	);
				pW->DwkPermInfo.hd.fBold	 = AjcGetProfileUInt(pProfileSect, MKKEY(L"fBold"		 ), pW->DwkPermInfo.hd.fBold	);
				pW->DwkPermInfo.hd.fFixed	 = AjcGetProfileUInt(pProfileSect, MKKEY(L"fFSelFixed"	 ), pW->DwkPermInfo.hd.fFixed	);
				pW->DwkPermInfo.hd.Pixels	 = AjcGetProfileUInt(pProfileSect, MKKEY(L"Pixels"		 ), pW->DwkPermInfo.hd.Pixels	);
				pW->DwkPermInfo.hd.Points	 = AjcGetProfileUInt(pProfileSect, MKKEY(L"Points"		 ), pW->DwkPermInfo.hd.Points	);
				pW->DwkPermInfo.hd.LSpace	 = AjcGetProfileUInt(pProfileSect, MKKEY(L"LSpace"		 ), pW->DwkPermInfo.hd.LSpace	);
				pW->DwkPermInfo.hd.FixAttr.v = AjcGetProfileUInt(pProfileSect, MKKEY(L"FSelFixedAttr"), pW->DwkPermInfo.hd.FixAttr.v);
				pW->DwkPermInfo.hd.AnyAttr.v = AjcGetProfileUInt(pProfileSect, MKKEY(L"FSelPropoAttr"), pW->DwkPermInfo.hd.AnyAttr.v);
				AjcGetProfileStr(pProfileSect, MKKEY(L"FSelFixedFace"), pW->DwkPermInfo.FixFace, pW->DwkPermInfo.FixFace, LF_FACESIZE);
				AjcGetProfileStr(pProfileSect, MKKEY(L"FSelPropoFace"), pW->DwkPermInfo.AnyFace, pW->DwkPermInfo.AnyFace, LF_FACESIZE);
				//	vpeBXV̎|AtOݒ
				fNeedUpdateProp = TRUE;
			}
			//----- uq`lTCY -----------------------------------------------------------------------------//
			if (pW->PermItem & AJCVTH_PERM_VRAM) {
				prop.VramW = AjcGetProfileUInt(pProfileSect, MKKEY(L"VramW")	, prop.VramW	);
				prop.VramH = AjcGetProfileUInt(pProfileSect, MKKEY(L"VramH")	, prop.VramH	);
				//	vpeBXV̎|AtOݒ
				fNeedUpdateProp = TRUE;
			}
			//----- ̑ -------------------------------------------------------------------------------------//
			if (pW->PermItem & AJCVTH_PERM_OTHER) {
			//	prop.CaretH		= AjcGetProfileUInt(pProfileSect, MKKEY(L"CaretH"	), prop.CaretH		);
				prop.MaxLines	= AjcGetProfileUInt(pProfileSect, MKKEY(L"MaxLines"	), prop.MaxLines	);
				prop.TabStep	= AjcGetProfileUInt(pProfileSect, MKKEY(L"TabStep"	), prop.TabStep		);
				prop.PendSize	= AjcGetProfileUInt(pProfileSect, MKKEY(L"PendSize"	), prop.PendSize	);
				//	vpeBXV̎|AtOݒ
				fNeedUpdateProp = TRUE;
			}
			//----- vpeBXV -----------------------------------------------------------------------------//
			rc = TRUE;
			if (fNeedUpdateProp) {
				rc = AjcVthSetProp(hwnd, &prop);
			}
		}
	}

	return rc;
}
//==============================================================================================================//
//	vt@C։i񏑂																				//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcVthSavePermInfo		(HWND hwnd)
{
	return AjcVthSavePermInfoExW(hwnd, NULL, NULL, AJCVTH_PERM_BYLOAD);
}
//==============================================================================================================//
//	vt@C։i񏑂																				//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect	- ZNVւ̃|C^	isvNULL)										//
//				pKeyPrefix		- L[擪ւ̃|C^isvNULL)										//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthSavePermInfoExA		(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmpSec = NULL;
	WCP		pTmpKey = NULL;

	do {
		if (pProfileSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
			if (len != 0 && (pTmpSec = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmpSec, len);
			}
			else break;
		}
		if (pKeyPrefix != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpKey = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpKey, len);
			}
			else break;
		}
		rc = AjcVthSavePermInfoExW(hwnd, pTmpSec, pTmpKey, PermItem);
	} while(0);

	if (pTmpSec != NULL) free(pTmpSec);
	if (pTmpKey != NULL) free(pTmpKey);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthSavePermInfoExW		(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem)
{
	BOOL		rc = FALSE;
	AJCVTHPROP	prop;
	WC			szKey[256];

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			//----- ZNVCL[Ci w薳Ȃ΁A[hɐݒ肵̂Ƃ ------------------//
			if (pProfileSect == NULL		 ) pProfileSect = pW->PermSect;
			if (pKeyPrefix	 == NULL		 ) pKeyPrefix	= pW->PermKey;
			if (PermItem & AJCVTH_PERM_BYLOAD) PermItem 	= pW->PermItem;
			//----- vt@CZ[u -------------------------------------------------------------------------//
			if (*pProfileSect != 0) {
				//	vpeBlݒ
				memcpy(&prop, &pW->prop, sizeof prop);
				//	펞i
				//	VT100ւ̓Kp
				AjcPutProfileUInt(pProfileSect, MKKEY(L"fSetF_T"), pW->fSetF_T);
				//	s
				if (PermItem & AJCVTH_PERM_LFACT) {
					AjcPutProfileHex(pProfileSect, MKKEY(L"Style"), (UI)MAjcGetWindowLong(hwnd, GWL_STYLE));
				}
				else {
					AjcDelProfileKey (pProfileSect, MKKEY(L"Style"));
				}
				//	tHg
				if (PermItem & AJCVTH_PERM_FONT) {
					//	tHg
					AjcPutProfileSInt(pProfileSect, MKKEY(L"lfHeight"		 	), prop.LogFont.lfHeight		);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfWidth"		 	), prop.LogFont.lfWidth			);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfEscapement"	 	), prop.LogFont.lfEscapement	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfOrientation"	 	), prop.LogFont.lfOrientation	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfWeight"		 	), prop.LogFont.lfWeight		);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfItalic"		 	), prop.LogFont.lfItalic		);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfUnderline"	 	), prop.LogFont.lfUnderline		);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfStrikeOut"		), prop.LogFont.lfStrikeOut		);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfCharSet"			), prop.LogFont.lfCharSet		);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfOutPrecision"		), prop.LogFont.lfOutPrecision	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfClipPrecision"	), prop.LogFont.lfClipPrecision	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfQuality"			), prop.LogFont.lfQuality		);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"lfPitchAndFamily"	), prop.LogFont.lfPitchAndFamily);
					AjcPutProfileStr (pProfileSect, MKKEY(L"lfFaceName"	  		), prop.LogFont.lfFaceName		);
					//	sԃXy[X
					AjcPutProfileUInt(pProfileSect, MKKEY(L"LSpace"				), prop.LSpace);
					//	tHgI_CAO
					AjcPutProfileHex (pProfileSect, MKKEY(L"id" 		  		), pW->DwkPermInfo.hd.id		);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"fPixel" 	  		), pW->DwkPermInfo.hd.fPixel	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"fItalic"	  		), pW->DwkPermInfo.hd.fItalic  	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"fBold"		  		), pW->DwkPermInfo.hd.fBold	 	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"fFSelFixed"   		), pW->DwkPermInfo.hd.fFixed	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"Pixels" 	  		), pW->DwkPermInfo.hd.Pixels	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"Points" 	  		), pW->DwkPermInfo.hd.Points	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"LSpace" 	  		), pW->DwkPermInfo.hd.LSpace	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"FSelFixedAttr"		), pW->DwkPermInfo.hd.FixAttr.v );
					AjcPutProfileUInt(pProfileSect, MKKEY(L"FSelPropoAttr"		), pW->DwkPermInfo.hd.AnyAttr.v );
					AjcPutProfileStr (pProfileSect, MKKEY(L"FSelFixedFace"		), pW->DwkPermInfo.FixFace	 	);
					AjcPutProfileStr (pProfileSect, MKKEY(L"FSelPropoFace"		), pW->DwkPermInfo.AnyFace	 	);
				}
				else {
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfHeight"		 	));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfWidth"		 	));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfEscapement"	 	));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfOrientation"	 	));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfWeight"		 	));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfItalic"		 	));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfUnderline"	 	));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfStrikeOut"		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfCharSet"			));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfOutPrecision"		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfClipPrecision"	));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfQuality"			));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfPitchAndFamily"	));
					AjcDelProfileKey (pProfileSect, MKKEY(L"lfFaceName"	  		));

					AjcDelProfileKey (pProfileSect, MKKEY(L"LSpace"				));

					AjcDelProfileKey (pProfileSect, MKKEY(L"id" 		  		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"fPixel" 	  		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"fItalic"	  		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"fBold"		  		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"fFSelFixed"   		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"Pixels" 	  		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"Points" 	  		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"LSpace" 	  		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"FSelFixedAttr"		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"FSelPropoAttr"		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"FSelFixedFace"		));
					AjcDelProfileKey (pProfileSect, MKKEY(L"FSelPropoFace"		));
				}
				//	uq`lTCY
				if (PermItem & AJCVTH_PERM_VRAM) {
					AjcPutProfileUInt(pProfileSect, MKKEY(L"VramW"), prop.VramW	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"VramH"), prop.VramH	);
				}
				else {
					AjcDelProfileKey (pProfileSect, MKKEY(L"VramW"));
					AjcDelProfileKey (pProfileSect, MKKEY(L"VramH"));
				}
				//	̑
				if (PermItem & AJCVTH_PERM_OTHER) {
				//	AjcPutProfileUInt(pProfileSect, MKKEY(L"CaretH"	 ), prop.CaretH	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"MaxLines"), prop.MaxLines	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"TabStep" ), prop.TabStep	);
					AjcPutProfileUInt(pProfileSect, MKKEY(L"PendSize"), prop.PendSize	);
				}
				else {
					AjcDelProfileKey (pProfileSect, MKKEY(L"MaxLines"));
					AjcDelProfileKey (pProfileSect, MKKEY(L"TabStep" ));
					AjcDelProfileKey (pProfileSect, MKKEY(L"PendSize"));
				}
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ȋiZNVCL[ړjݒ																//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthSetPermAttA	(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix)
{
	return AjcVthSetPermAttExA(hwnd, pProfileSect, pKeyPrefix, AJCVTH_PERM_FONT);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthSetPermAttW	(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix)
{
	return AjcVthSetPermAttExW(hwnd, pProfileSect, pKeyPrefix, AJCVTH_PERM_FONT);
}

//==============================================================================================================//
//	ȋiZNVCL[ړjݒ	iڎwj												//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthSetPermAttExA	(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmpSec = NULL;
	WCP		pTmpKey = NULL;

	do {
		if (pProfileSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
			if (len != 0 && (pTmpSec = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmpSec, len);
			}
			else break;
		}
		if (pKeyPrefix != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpKey = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpKey, len);
			}
			else break;
		}
		rc = AjcVthSetPermAttExW(hwnd, pTmpSec, pTmpKey, PermItem);
	} while(0);

	if (pTmpSec != NULL) free(pTmpSec);
	if (pTmpKey != NULL) free(pTmpKey);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcVthSetPermAttExW	(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem)
{
	BOOL		rc = FALSE;
	WC			szid[16];

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pProfileSect != NULL && pKeyPrefix != NULL) {
			//----- hcݒ -----------------------------------------------------------------------------//
			AjcSnPrintFW(szid, AJCTSIZE(szid), L"%06u", (UW)MAjcGetWindowLong(hwnd, GWL_ID));
			//----- ZNVݒ ---------------------------------------------------------------------------//
			if (pProfileSect != NULL) AjcSnPrintFW(pW->PermSect, AJCTSIZE(pW->PermSect) 	, L"%s" 	, pProfileSect);
			else					  AjcSnPrintFW(pW->PermSect, AJCTSIZE(pW->PermSect) 	, L"SVth%s" , szid		  );
			//----- L[ړݒ -----------------------------------------------------------------------------//
			if (pKeyPrefix	 != NULL) AjcSnPrintFW(pW->PermKey , AJCTSIZE(pW->PermKey ) - 32, L"%s" 	, pKeyPrefix);	// 32:㑱L[̂̍ől
			else					  AjcSnPrintFW(pW->PermKey , AJCTSIZE(pW->PermKey ) - 32, L"Vth_%s_", szid		);
			//---- iڐݒ ------------------------------------------------------------------------------//
			pW->PermItem = PermItem;
			//----- ߂lnj -------------------------------------------------------------------------------//
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	ENbNɂ|bvAbvj[̋^֎~															//
//																												//
//	@	F	hwnd		  - EChnh																//
//				fEnable		  - |bvAbvj[̋^֎~												//
//									TRUE  : iENbNʒmCShuft/Ctrl+ENbNʒmj					//
//									FALSE : ֎~iSẲENbNʒmj										//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVthEnablePopupMenu(HWND hwnd, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			AjcVthSetNtcRClk(hwnd, !fEnable, WM_RBUTTONDOWN, WM_RBUTTONUP);
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	ENbNʒmݒ																							//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				fNtcRClk	 - TRUE  : E{^DOWN/UPʒm	i|bvAbv͋֎~j								//
//							   FALSE : E{^DOWN/UPʒmi|bvAbvj								//
//				MsgRBDown	 - E{^̒ʒmbZ[WR[h@iȌꍇ͔ʒmj						//
//				MSgRBUp		 - E{^ꎞ̒ʒmbZ[WR[hiȌꍇ͔ʒmj						//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//																												//
//	@l	F						<|bvAbv>	<Shift/Ctrl+E>		<E-DOWN>	<E-UP>						//
//				NtcRClk	= FALSE	 	 		 	 ʒm				 ʒm		 ʒm						//
//				 		= TRUE		 ֎~			 ʒm				 MsgRBDown	 MsgRBUp					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVthSetNtcRClk	(HWND hwnd, BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fNtcRClk  = fNtcRClk;
			pW->MsgRBDown = MsgRBDown;
			pW->MsgRBUp	  = MsgRBUp;
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	SeLXg擾																								//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pBuf   - eLXgi[obt@̃AhX													//
//				lBuf   - eLXgi[obt@̕														//
//																												//
//	߂l	F	pBuf != NULL && lBuf != 0 - obt@Ɋi[											//
//				pBuf == NULL || lBuf == 0 - Kvȃobt@TCYiI[܂ޕj						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UI	WINAPI AjcVthGetTextA	(HWND hwnd, BCP pBuf, UI lBuf)
{
	UI			len = 0;
	UI			i, ixL, lwc;
	PLINEPTR	pL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pBuf != NULL && lBuf > 0) {
				len = 0;
				ixL = pW->IxSrt;
				for (i = 0; i < pW->LCnt; i++) {
					pL	= pW->pLPtr + ixL;
					lwc = WideCharToMultiByte(CP_ACP, 0, pL->pTxt, pL->len, NULL, 0, NULL, NULL);
					if (lBuf >= (lwc + 3)) {
						WideCharToMultiByte(CP_ACP, 0, pL->pTxt, pL->len, pBuf, lBuf, NULL, NULL);
						pBuf += lwc;  lBuf -= lwc;
						if (!(lwc == 0 && i == pW->LCnt - 1)) {
							memcpy(pBuf, L"\r\n" , 4);
							pBuf += 2;	  lBuf -= 2;
						}
					}
					else {
						break;
					}
					len += (lwc + 2);
					ixL = ((ixL + 1) % pW->prop.MaxLines);
				}
				*pBuf = 0;
			}
			else {
				len = 0;
				ixL = pW->IxSrt;
				for (i = 0; i < pW->LCnt; i++) {
					pL = pW->pLPtr + ixL;
					lwc = WideCharToMultiByte(CP_ACP, 0, pL->pTxt, pL->len, NULL, 0, NULL, NULL);
					len += (lwc + 2);
					ixL = ((ixL + 1) % pW->prop.MaxLines);
				}
				len++;
			}
		}
	}
	return len;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UI	WINAPI AjcVthGetTextW	(HWND hwnd, WCP pBuf, UI lBuf)
{
	UI			len = 0;
	UI			i, ixL, stl;
	PLINEPTR	pL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pBuf != NULL && lBuf > 0) {
				len = 0;
				ixL = pW->IxSrt;
				for (i = 0; i < pW->LCnt; i++) {
					pL	= pW->pLPtr + ixL;
					stl = pL->len;
					if (lBuf >= (stl + 3)) {
						memcpy(pBuf, pL->pTxt, stl * 2); pBuf += stl;  lBuf -= stl;
						if (!(stl == 0 && i == pW->LCnt - 1)) {
							memcpy(pBuf, L"\r\n", 4);	 pBuf += 2;    lBuf -= 2;
						}
					}
					else {
						break;
					}
					len += (stl + 2);
					ixL = ((ixL + 1) % pW->prop.MaxLines);
				}
				*pBuf = 0;
			}
			else {
				len = 0;
				ixL = pW->IxSrt;
				for (i = 0; i < pW->LCnt; i++) {
					pL = pW->pLPtr + ixL;
					len += (pL->len + 2);
					ixL = ((ixL + 1) % pW->prop.MaxLines);
				}
				len++;
			}
		}
	}
	return len;
}
//==============================================================================================================//
//	IeLXg擾iV1.1.0ȍ~j																				//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pBuf   - IeLXgi[obt@̃AhX												//
//				lBuf   - IeLXgi[obt@̕													//
//																												//
//	߂l	F	pBuf != NULL && lBuf != 0 - obt@Ɋi[											//
//				pBuf == NULL || lBuf == 0 - Kvȃobt@TCYij										//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UI	WINAPI AjcVthGetSelectedTextA	(HWND hwnd, BCP pBuf, UI lBuf)
{
	UI			rc = 0;
	HGLOBAL		hGlobal;
	WCP			pBlk;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (hGlobal = GetSelectedText(pW)) {
				GlobalUnlock(hGlobal);
				pBlk = GlobalLock(hGlobal);
				if (pBuf != NULL  &&  lBuf != 0) {
					WideCharToMultiByte(CP_ACP, 0, pBlk, -1, pBuf, lBuf, NULL, NULL);
					pBuf[lBuf - 1] = 0;
					rc = (UI)strlen(pBuf);
				}
				else {
					rc = WideCharToMultiByte(CP_ACP, 0, pBlk, -1, NULL, 0, NULL, NULL);
				}
				GlobalUnlock(hGlobal);
				GlobalFree	(hGlobal);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UI	WINAPI AjcVthGetSelectedTextW	(HWND hwnd, WCP pBuf, UI lBuf)
{
	UI			rc = 0;
	HGLOBAL		hGlobal;
	WCP			pBlk;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (hGlobal = GetSelectedText(pW)) {
				GlobalUnlock(hGlobal);
				pBlk = (WCP)GlobalLock(hGlobal);
				if (pBuf != NULL  &&  lBuf != 0) {
					wcsncpy(pBuf, pBlk, lBuf);
					pBuf[lBuf - 1] = 0;
					rc = (UI)wcslen(pBuf);
				}
				else {
					rc = (UI)wcslen(pBlk) + 1;
				}
				GlobalUnlock(hGlobal);
				GlobalFree	(hGlobal);
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	_uNbNs̃eLXg擾iV1.1.0ȍ~j															//
//																												//
//	@	F	hwnd   - Rg[̃nh																	//
//				pBuf   - seLXgi[obt@̃AhX													//
//				lBuf   - seLXgi[obt@̕													//
//				pLine  - _uNbNobt@̍sʒu													//
//				pCol   - _uNbNʒu																//
//																												//
//	߂l	F	pBuf != NULL && lBuf != 0 - obt@Ɋi[											//
//				pBuf == NULL || lBuf == 0 - Kvȃobt@TCYij										//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UI	WINAPI AjcVthGetDblClickedLineA	  (HWND hwnd, BCP pBuf, UI lBuf)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pW->pDblClkLine != NULL) {
				if (pBuf != NULL  &&  lBuf != 0) {
					WideCharToMultiByte(CP_ACP, 0, pW->pDblClkLine, -1, pBuf, lBuf, NULL, NULL);
					pBuf[lBuf - 1] = 0;
					rc = (UI)strlen(pBuf);
				}
				else {
					rc = WideCharToMultiByte(CP_ACP, 0, pW->pDblClkLine, -1, NULL, 0, NULL, NULL);
				}
			}
			else if (lBuf != 0) *pBuf = 0;
		}
	}
	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT UI	WINAPI AjcVthGetDblClickedLineExA  (HWND hwnd, BCP pBuf, UI lBuf, UIP pLine, UIP pCol)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);

		rc = AjcVthGetDblClickedLineA(hwnd, pBuf, lBuf);

		if (pLine != NULL) *pLine = pW->DblClkLPos;
		if (pCol  != NULL) *pCol  = pW->DblClkTIdxA;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UI	WINAPI AjcVthGetDblClickedLineW	  (HWND hwnd, WCP pBuf, UI lBuf)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pW->pDblClkLine != NULL) {
				if (pBuf != NULL  &&  lBuf != 0) {
					wcsncpy(pBuf, pW->pDblClkLine, lBuf);
					pBuf[lBuf - 1] = 0;
					rc = (UI)wcslen(pBuf);
				}
				else {
					rc = (UI)wcslen(pW->pDblClkLine) + 1;
				}
			}
			else if (lBuf != 0) *pBuf = 0;
		}
	}
	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT UI	WINAPI AjcVthGetDblClickedLineExW  (HWND hwnd, WCP pBuf, UI lBuf, UIP pLine, UIP pCol)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);

		rc = AjcVthGetDblClickedLineW(hwnd, pBuf, lBuf);

		if (pLine != NULL) *pLine = pW->DblClkLPos;
		if (pCol  != NULL) *pCol  = pW->DblClkTIdxW;
	}
	return rc;
}

//==============================================================================================================//
//	c[`bvEeLXgݒ																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pTxt		 - c[`bvEeLXg̃AhX											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcVthSetTipTextA (HWND hwnd, C_BCP pTxt)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (rc = SubSetTipTextA(&pW->pToolTipTxt, 0, pTxt)) {
				AjcTipTextAddW		   (pW->hBack, pW->pToolTipTxt);
				AjcTipTextSetShowAlways(pW->hBack, pW->fShowAlways);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcVthSetTipTextW (HWND hwnd, C_WCP pTxt)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (rc = SubSetTipTextW(&pW->pToolTipTxt, 0, pTxt)) {
				AjcTipTextAddW		   (pW->hBack, pW->pToolTipTxt);
				AjcTipTextSetShowAlways(pW->hBack, pW->fShowAlways);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	c[`bvEeLXg擾																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pBuf		 - c[`bvEeLXgi[obt@̃AhX							//
//				lBuf		 - c[`bvEeLXgi[obt@̕							//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcVthGetTipTextA (HWND hwnd, BCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = SubGetTipTextA(&pW->pToolTipTxt, 0, pBuf, lBuf);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcVthGetTipTextW (HWND hwnd, WCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = SubGetTipTextW(&pW->pToolTipTxt, 0, pBuf, lBuf);
		}
	}
	return rc;
}
//==============================================================================================================//
//	c[`bvEeLXg\ݒ																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				fShowAlways	 - c[`bvEeLXg\													//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVthSetTipShowAlways(HWND hwnd, BOOL fShowAlways)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fShowAlways = fShowAlways;
			AjcTipTextSetShowAlways(hwnd, pW->fShowAlways);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	c[`bvEeLXg\擾																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	c[`bvEeLXg\																	//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVthGetTipShowAlways(HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->fShowAlways;
		}
	}
	return rc;
}

//==============================================================================================================//
//	tHgCsԃXy[X̐ݒ																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pLogFont	- ݒ肷tHgւ̃|C^iNULLFtHgݒ肵Ȃj					//
//				LSpace		- ݒ肷sԃXy[Xi-1 : sԃXy[Xݒ肵Ȃj								//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSetFontInfoA(HWND hwnd, const LOGFONTA *pLogFont, UI LSpace)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pLogFont != NULL || LSpace != -1) {
				AJCVTHPROPA	prop;
				AjcVthGetPropA(hwnd, &prop);
				if (pLogFont != NULL) {
					memcpy(&prop.LogFont, pLogFont, sizeof prop.LogFont);
				}
				if (LSpace != -1) {
					prop.LSpace = LSpace;
				}
				AjcVthSetPropA(hwnd, &prop);
			}
			rc = TRUE;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSetFontInfoW(HWND hwnd, const LOGFONTW *pLogFont, UI LSpace)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pLogFont != NULL || LSpace != -1) {
				AJCVTHPROPW	prop;
				AjcVthGetPropW(hwnd, &prop);
				if (pLogFont != NULL) {
					memcpy(&prop.LogFont, pLogFont, sizeof prop.LogFont);
				}
				if (LSpace != -1) {
					prop.LSpace = LSpace;
				}
				AjcVthSetPropW(hwnd, &prop);
			}
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	sԃXy[X̎擾																							//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	c[`bvEeLXg\																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthGetFontInfoA(HWND hwnd, LPLOGFONTA *pBuf, UIP pLSpace)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pBuf != NULL || pLSpace != NULL) {
				AJCVTHPROPA	prop;
				AjcVthGetPropA(hwnd, &prop);
				if (pBuf != NULL) {
					memcpy(pBuf, &prop.LogFont, sizeof(LOGFONTA));
				}
				if (pLSpace != NULL) {
					*pLSpace = prop.LSpace;
				}
			}
			rc = TRUE;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthGetFontInfoW(HWND hwnd, LPLOGFONTW *pBuf, UIP pLSpace)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100	pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pBuf != NULL || pLSpace != NULL) {
				AJCVTHPROPW	prop;
				AjcVthGetPropW(hwnd, &prop);
				if (pBuf != NULL) {
					memcpy(pBuf, &prop.LogFont, sizeof(LOGFONTW));
				}
				if (pLSpace != NULL) {
					*pLSpace = prop.LSpace;
				}
			}
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	TCY^s̍擾																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pCx			- ̕@isNZji[obt@̃AhXisvNULL)				//
//				pCy			- ̍isNZji[obt@̃AhXisvNULL)				//
//				pLy			- s̍@isNZji[obt@̃AhXisvNULL)				//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVthGetCharInfo(HWND hwnd, UIP pCx, UIP pCy, UIP pLy)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pCx != NULL) *pCx = pW->cxChar;
			if (pCy != NULL) *pCy = pW->cyCharOrg;
			if (pLy != NULL) *pLy = pW->cyChar;
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	EChɕ\\ȍs̎擾																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	EChɕ\\ȍs																		//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcVthGetLinesPerWindow(HWND hwnd)
{
	UI			rc = 0;
	RECT		r;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			GetClientRect(pW->hMain, &r);
			rc = ((r.bottom - r.top)) / pW->cyChar;
		}
	}
	return rc;
}
//==============================================================================================================//
//	obt@Ɋi[ĂLȍs̎擾	iAjcVthGetLineCount() Ɠj									//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	ECh擪s̈ʒu擾iO`j																//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcVthGetValidLines(HWND hwnd)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->LCnt;
		}
	}
	return rc;
}
//==============================================================================================================//
//	ECh擪s̍sʒu擾iO`j																			//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	ECh擪s̈ʒuiO`j																	//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcVthGetIxOfWndTopLine(HWND hwnd)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pW->IxSrt <= pW->IxWTop) {
				rc = pW->IxWTop - pW->IxSrt;
			}
			else {
				rc = (pW->prop.MaxLines - pW->IxSrt) + pW->IxWTop;
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	^Cg̐ݒ																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pTitleText	- ^CgeLXgւ̃|C^iNULLw莞́A^Cg\j						//
//				TextColor	- eLXg`Fi|Pw莞͑OݒlCftHgFj						//
//				BackColor	- eLXgwiFi|Pw莞͑OݒlCftHgFO[j					//
//				hFont		- ^CgeLXg̃tHgiNULLw莞͑Oݒl^ftHg̃tHgj		//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSetTitleTextA(HWND hwnd, C_BCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont)
{
	BOOL		rc	 = FALSE;
	WCP			pTmp = NULL;
	UL			len;

	do {
		if (pTitleText != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pTitleText, -1, NULL, 0);
			if (len != 0  &&  (pTmp = AjcTAlloc(len + 1))) {
				MultiByteToWideChar(CP_ACP, 0, pTitleText, -1, pTmp, len);
			}
			else break;
		}
		rc = AjcVthSetTitleTextW(hwnd, pTmp, TextColor, BackColor, hFont);
		if (pTmp != NULL) free(pTmp);
	} while(0);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSetTitleTextW(HWND hwnd, C_WCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont)
{
	BOOL	rc	 = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			do {
			//	^CgeLXgErbg}bv
			SubTtlBmpMake(&pW->TtlInfo, pW->hBack, pTitleText, TextColor, BackColor, hFont);
				//	߂l
				rc = TRUE;
				//	ĕ`
				InvalidateRect(hwnd 	, NULL, TRUE);
			} while(0);
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXgt@C֏																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pPath		- t@CpX																		//
//				fAllText	- TRUE:SeLXgCFALSE:IeLXg												//
//				tec			- R[hʁiAJCTEC_MBC / UTF_8 / EUC_J / UTF_16LE / UTF_16BEj				//
//				fBom		- anlo̓tO																	//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[^t@Cݎs															//
//==============================================================================================================//
static	const BC	bom_utf8   [3] = {0xEF, 0xBB, 0xBF};

//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSaveTextToFileA(HWND hwnd, C_BCP pPath, BOOL fAllText, EAJCTEC tec, BOOL fBom)
{
	BOOL	rc = FALSE;
	int		len;
	WCP		pTmp;

	if (pPath != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pPath, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pPath, -1, pTmp, len);
			rc = AjcVthSaveTextToFileW(hwnd, pTmp, fAllText, tec, fBom);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSaveTextToFileW(HWND hwnd, C_WCP pPath, BOOL fAllText, EAJCTEC tec, BOOL fBom)
{
	BOOL		rc	  = FALSE;
	HAJCFILE	hFile = NULL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pPath != NULL) {
			if ((hFile = AjcFCreate(pPath, tec, fBom)) != NULL) {
				SaveToTextFile(pW, hFile, fAllText);
				AjcFClose(hFile);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXggslkt@C֏																		//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pPath		- t@CpX																		//
//				fAllText	- TRUE:SeLXgCFALSE:IeLXg												//
//				FontSize	- tHgTCYiP`Vj															//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[^t@Cݎs															//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSaveHtmlToFileA(HWND hwnd, C_BCP pPath, BOOL fAllText, UI FontSize)
{
	BOOL	rc = FALSE;
	int		len;
	WCP		pTmp;

	if (pPath != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pPath, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pPath, -1, pTmp, len);
			rc = AjcVthSaveHtmlToFileW(hwnd, pTmp, fAllText, FontSize);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSaveHtmlToFileW(HWND hwnd, C_WCP pPath, BOOL fAllText, UI FontSize)
{
	BOOL		rc	  = FALSE;
	HAJCFILE	hFile = NULL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pPath != NULL) {
			if ((hFile = AjcFCreate(pPath, AJCTEC_UTF_8, TRUE)) != NULL) {
				SaveToHtmlFile(pW, hFile, fAllText, FontSize);
				AjcFClose(hFile);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	drbV[PXtASeLXgt@C֏													//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pPath		- t@CpX																		//
//				tec			- R[hʁiAJCTEC_MBC / UTF_8 / EUC_J / UTF_16LE / UTF_16BEj				//
//				fBom		- anlo̓tO																	//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[^t@Cݎs															//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSaveAllTextWithEscA(HWND hwnd, C_BCP pPath, EAJCTEC tec, BOOL fBom)
{
	BOOL	rc = FALSE;
	int		len;
	WCP		pTmp;

	if (pPath != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pPath, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pPath, -1, pTmp, len);
			rc = AjcVthSaveAllTextWithEscW(hwnd, pTmp, tec, fBom);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	   WINAPI AjcVthSaveAllTextWithEscW(HWND hwnd, C_WCP pPath, EAJCTEC tec, BOOL fBom)
{
	BOOL		rc	  = FALSE;
	HAJCFILE	hFile = NULL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pPath != NULL) {
			if ((hFile = AjcFCreate(pPath, tec, fBom)) != NULL) {
				SaveAllTextToFileWithEsc(pW, hFile);
				AjcFClose(hFile);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	obt@Ɋi[Ăs̎擾 		iAjcVthGetValidLines() Ɠj									//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	Fobt@Ɋi[ĂsiG[͂OԂ܂j											//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI AjcVthGetLineCount(HWND hwnd)
{
	UI		rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->LCnt;
		}
	}
	return rc;
}
//==============================================================================================================//
//	}EXJ[\ʒu̍sCʒu擾																			//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pLine		- sʒu iO`ji[obt@̃AhXisvNULLj						//
//				pCol		- ʒuiO`ji[obt@̃AhXisvNULLj						//
//																												//
//	߂l	FTRUE	- 																						//
//			  FALSE - J[\̓ECh͈͊O																	//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcVthGetCursorPosInfo(HWND hwnd, UIP pLine, UIP pCol)
{
	BOOL	rc = FALSE;
	POINT	pt;
	int		x, y;
	int		lp, cp, tix;
	WCP		pTxt = NULL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			GetCursorPos(&pt);
			MapWindowPoints(HWND_DESKTOP, hwnd, &pt, 1);
			x = pt.x;
			y = pt.y;
			if (x >= 0 && x < (int)pW->ww && y >= 0 && y < (int)pW->wh) {
				if (pTxt = VthMusToTextIdx(pW, x, y, &lp, &tix, &cp)) {
					if (lp == 0 || lp < (int)pW->LCnt) {
						if (pLine != NULL) *pLine = lp;
						if (pCol  != NULL) *pCol  = cp;
						rc = TRUE;
					}
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	wsʒu̍seLXg擾 																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pos			- sʒuiO`j																	//
//				pBuf		- 擾seLXgi[obt@̃AhXisvNULLj					//
//				lBif		- 擾seLXgi[obt@̕										//
//																												//
//	߂l	F	OFwsʒũeLXg̕ȉI[(0x00)܂ށj									//
//				OFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI AjcVthGetLineTextA(HWND hwnd, UI pos, BCP pBuf, UI lBuf)
{
	UI			rc = 0;
	UI			ix, len;
	PLINEPTR	pL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pos < pW->LCnt) {
				ix = VthLnoToIx(pW, pos);
				pL = pW->pLPtr + ix;
				if (pBuf != NULL && lBuf > 0) {
					len = __min(pL->len, lBuf - 1);
					VthMemSetA(pBuf, 0, lBuf);
					rc = WideCharToMultiByte(CP_ACP, 0, pL->pTxt, len, pBuf, lBuf - 1, NULL, NULL);
				}
				else {
					rc = WideCharToMultiByte(CP_ACP, 0, pL->pTxt, pL->len, NULL, 0, NULL, NULL) + 1;
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI AjcVthGetLineTextW(HWND hwnd, UI pos, WCP pBuf, UI lBuf)
{
	UI			rc = 0;
	UI			ix, len;
	PLINEPTR	pL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pos < pW->LCnt) {
				ix = VthLnoToIx(pW, pos);
				pL = pW->pLPtr + ix;
				if (pBuf != NULL && lBuf > 0) {
					len = __min(pL->len, lBuf - 1);
					wcsncpy(pBuf, pL->pTxt, len);
					pBuf[len] = 0;
					rc = len;
				}
				else {
					rc = pL->len + 1;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	cXN[ʒu̎擾 																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	FcXN[ʒuiO`j																			//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI AjcVthGetVScrollPos(HWND hwnd)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = VthIxToLno(pW, pW->IxWTop);
		}
	}
	return rc;
}
//==============================================================================================================//
//	XN[ʒu̎擾 																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	FXN[ʒuiO`j																			//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI AjcVthGetHScrollPos(HWND hwnd)
{
	UI			rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->IxOfs;
		}
	}
	return rc;
}
//==============================================================================================================//
//	cXN[ʒu̐ݒ 																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pos			- XN[ʒuiO`j															//
//																												//
//	߂l	FTRUE	- OK																						//
//			  FALSE - Error																						//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcVthSetVScrollPos(HWND hwnd, UI pos)
{
	BOOL		rc = FALSE;
	UI			wl;		//	EChs
	UI			ov;		//	I[o[s

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pos < pW->LCnt) {
				wl = pW->wh / pW->cyChar;
				if (pos + wl >= pW->LCnt) {
					ov = ((pos + wl) - pW->LCnt);
					if (ov < pos) pos -= ov;
					else		  pos  = 0;
				}
				VthSetVScrollInfo(pW, pos);
				InvalidateRect(pW->hMain, NULL, FALSE);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	XN[ʒu̐ݒ 																						//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pos			- XN[ʒuiO`j															//
//																												//
//	߂l	FTRUE	- OK																						//
//			  FALSE - Error																						//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcVthSetHScrollPos(HWND hwnd, UI pos)
{
	BOOL		rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			VthSetHScrollInfo(pW, pos);
			InvalidateRect(pW->hMain, NULL, FALSE);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	EChTCYisCj̎擾																		//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pSize		- EChTCYi[obt@̃AhX										//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVthGetWindowSize(HWND hwnd, LPSIZE pSize)
{
	BOOL		rc = FALSE;
	RECT		r;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			GetClientRect(pW->hMain, &r);
			if (pSize != NULL) {
				pSize->cx = ((r.right - r.left)) / pW->cxChar;
				pSize->cy = ((r.bottom - r.top)) / pW->cyChar;
			}
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	̉ƃXN[																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pStr		- 																		//
//				delimiter	- ؂蕶iȌꍇ͋؂蕶j											//
//																												//
//	߂l	F	 -1 : sXN[ʒu																		//
//				 -1 : - G[																				//
//==============================================================================================================//
//	\悤ɃXN[
//		pLine	- 񂪌seLXg
//		lp		- 񂪌sʒu
//		cp		- 񂪌ʒu
//		stl		- ̒
//
static	VO		SubSrhScroll(PWRKVT100 pW, C_WCP pLine, int lp, int cp, int stl)
{
	HDC				hdc;
	int				wcp, wlp;	//	ECh̍[ʒuC[sʒu
	int				wcy;		//	ECh̍s
	int				pws;		//	eLXg擪`ECh擪܂ł̃sNZ
	int				pxs;		//	ECh擪`擪܂ł̃sNZ
	int				pxe;		//	ECh擪`񖖔܂ł̃sNZ
	int				ov;			//	EChE[I[o[镶
	SIZE			sz;			//	sXNs鐔擾[N
	//	cb擾
	hdc = GetDC(pW->hMain);
	//	ECh̍[ʒuC[sʒuݒ
	wcp = pW->IxOfs;
	wlp = VthIxToLno(pW, pW->IxWTop);
	//	ECh̍sZo
	wcy	= pW->wh / pW->cyChar;
	//	eLXg擪`ECh擪܂ł̃sNZZo
	pws		= pW->cxChar * wcp;
	//	ECh擪`擪܂ł̃sNZZo
	VthGetTextExtentPoint(pW, hdc, pLine, cp	  , &sz);
	pxs = sz.cx - pws;
	//	ECh擪`񖖔܂ł̃sNZZo
	VthGetTextExtentPoint(pW, hdc, pLine, cp + stl, &sz);
	pxe = sz.cx - pws;
	//	̃sNZ
	VthGetTextExtentPoint(pW, hdc, pLine + cp, stl, &sz);
	//	XN[ʒuݒ
	if (sz.cx > (int)pW->ww) {						//	񂪃ECh傫H
		pW->ScrPos.x = cp;
	}
	else if (pxs < 0) {								//	擪ECh[荶H
		int		len = (-pxs / pW->cxChar);
		if (wcp >= len) pW->ScrPos.x = wcp - len;
		else			pW->ScrPos.x = 0;
	}
	else if (pxe > (int)pW->ww) {					//	񖖔EChE[EH
		ov = (pxe - pW->ww) / pW->cxChar + 1;
		pW->ScrPos.x = wcp + ov;
	}
	else {											//	̓EChH
		pW->ScrPos.x = wcp;
	}
	//	XN[sʒuݒ
	if (lp < wlp  ||  lp >= wlp + wcy) {			//	s̓ECh͈͊OH
		if (lp >= (wcy / 2)) pW->ScrPos.y = lp - (wcy / 2);
		else				 pW->ScrPos.y = 0;
	}
	else {											//	s̓ECh͈͓H
		pW->ScrPos.y = wlp;							//		XN[isʒuݒj
	}
	//	XN[
	AjcVthSetHScrollPos(pW->hBack, pW->ScrPos.x);
	AjcVthSetVScrollPos(pW->hBack, pW->ScrPos.y);
	//	cb
	ReleaseDC(pW->hMain, hdc);
}
//	v[֌ݒ
static	BOOL	SubRegistStrToPool(HAJCSPL hSpl, C_WCP pStr, WC delimiter)
{
	BOOL	rc = TRUE;
	int		stl;
	WC		dlm[2];

	if (delimiter == 0) {
		if (AjcSplRegistW(hSpl, pStr) == NULL) rc = FALSE;
	}
	else {
		WCP		p, pTmp = NULL;
		stl = (int)wcslen(pStr);
		dlm[0] = delimiter; dlm[1] = 0;
		if (p = pTmp = AjcTAlloc(stl + 1)) {
			wcscpy(pTmp, pStr);
			if (p = AjcStrTokW(pTmp, dlm)) {
				do {
					AjcStrTrimW(p, p, (UI)wcslen(p) + 1);
					if (AjcSplRegistW(hSpl, p) == NULL) {rc = FALSE; break;}
				} while (p = AjcStrTokW(NULL, dlm));
			}
			free(pTmp);
		}
		else rc = FALSE;
	}
	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	R[obNp^
typedef struct {
	C_WCP		pLine;			//	[IN ]seLXg̐擪AhX
	C_WCP		pStr;			//	[OUT]iȂꍇNULLݒj
	C_WCP		pFind;			//	[OUT]ʒuiseLXg̃AhXj
	int			stl;			//	[OUT]̒
} CBP_SRHTXT_DN, *PCBP_SRHTXT_DN;
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	v[̃R[obN
static	BOOL CALLBACK cbNtcSrhStrDn(C_WCP pStr, UX cbp)
{
	PCBP_SRHTXT_DN	pCbp = (PCBP_SRHTXT_DN)cbp;
	int				stl	 = (int)wcslen(pStr);
	C_WCP			pFind = NULL;

	if (pFind = wcsstr(pCbp->pLine, pStr)) {				//	񂪌H
		if (pCbp->pFind == NULL 	||						//											or
			pFind < pCbp->pFind		||						//		ʒu񒆂ōō[	or
			pFind == pCbp->pFind && stl > pCbp->stl) {		//		ʒu񒷂H
			pCbp->pStr	 = pStr;							//			ݒ
			pCbp->pFind  = pFind;							//			ʒuݒ
			pCbp->stl	 = stl;								//			񒷐ݒ
		}
	}
	return TRUE;
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcVthSearchBelowA(HWND hwnd, C_BCP pStr, BC delimiter)
{
	UI		rc = -1;
	int		len;
	WCP		pTmp;
	WC		wdlm[8];

	if (pStr != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pStr, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pStr, -1, pTmp, len);
			memset(wdlm, 0, sizeof wdlm);
			MultiByteToWideChar(CP_ACP, 0, &delimiter, 1, wdlm, 8);
			rc = AjcVthSearchBelowW(hwnd, pTmp, wdlm[0]);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcVthSearchBelowW(HWND hwnd, C_WCP pStr, WC delimiter)
{
	UI				rc	  = -1;
	HAJCSPL			hSpl  = NULL;			//	v[
	int				lTxt;					//	eLXgobt@
	WCP				pTxt = NULL;			//	eLXgobt@|C^
	int				txl;					//	s̒
	int				lp, ix;					//	񌟈ʒu
	int				stl  = 0;				//	
	CBP_SRHTXT_DN	Cbp;					//	R[obNp^

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			do {
				//	p^`FbN
				if (pStr == NULL) break;
				//	eLXgobt@m
				lTxt = pW->prop.VramW + 1;
				if ((pTxt = AjcTAlloc(lTxt)) == NULL) break;
				//	v[
				if ((hSpl = AjcSplCreate(AJCSPL_CMP_MIX)) == NULL) break;
				//	v[֌ݒ
				if (!SubRegistStrToPool(hSpl, pStr, delimiter)) break;
				//	XN[sʒuωȂ΁AJnʒuĐݒ
				lp = VthIxToLno(pW, pW->IxWTop);
				if (pW->ScrPos.y != lp) {
					pW->ScrPos.y  = lp;
					pW->SrhPos.y  = VthIxToLno(pW, pW->IxWTop);
					pW->SrhPos.x  = 0;
				}
				//	̌
				ix = pW->SrhPos.x;
				for (lp = pW->SrhPos.y; lp < (int)pW->LCnt; lp++) {
					//	seLXg擾
					AjcVthGetLineTextW(pW->hBack, lp, pTxt, lTxt);
					if (txl = (int)wcslen(pTxt)) {
						//	seLXg
						memset(&Cbp, 0, sizeof Cbp);
						Cbp.pLine = pTxt + ix;
						AjcSplEnumStrW(hSpl, (UX)&Cbp, cbNtcSrhStrDn, FALSE);
						if (Cbp.pStr != NULL) {	//	񂠂
							//	CfNXC񒷐ݒ
							ix = (int)(((UX)Cbp.pFind - (UX)pTxt) / 2);
							stl = Cbp.stl;
							//	XN[
							SubSrhScroll(pW, Cbp.pLine, lp, ix, stl);
							//	I
							AjcVthSelect(pW->hBack, lp, ix, lp, ix + stl);
							//	I
							break;
						}
					}
					ix = 0;
				}
				//	̌ʒuݒ
				if (stl != 0) {					//	񂪌H
					if (MAjcIsLeadW(*Cbp.pFind)) {
						pW->SrhPos.x = ix + 1;
						_ASSERT(MAjcIsTrailW(*(Cbp.pFind + 1)));
						pW->SrhPos.x++;
					}
					else {
						pW->SrhPos.x = ix + 1;
					}
					pW->SrhPos.y = lp;
				}
				else {							//	͌ȂH
					//	ECh[s̍s
					pW->SrhPos.y = VthIxToLno(pW, pW->IxWTop) + (pW->wh / pW->cyChar);
					if (pW->LCnt > 0) pW->SrhPos.y = __min(pW->SrhPos.y, (LONG)(pW->LCnt - 1));
					else			  pW->SrhPos.y = 0;
					//	s
					pW->SrhPos.x = AjcVthGetLineTextW(pW->hBack, pW->SrhPos.y, NULL, 0);
					if (pW->SrhPos.x > 0) pW->SrhPos.x--;	//	I[Z
				}
				//	߂lsXN[ʒu
				rc = VthIxToLno(pW, pW->IxWTop);
			} while(0);
			//	񂪌ȂꍇAIԉ
			if (stl == 0) {
				VthSetMode(pW, pW->Mode & ~MD_SELECT);
			}
			//	\[X
			if (pTxt != NULL) free(pTxt);
			if (hSpl != NULL) AjcSplDelete(hSpl);
		}
	}
	return rc;
}
//==============================================================================================================//
//	̏ƃXN[																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pStr		- 																		//
//				delimiter	- ؂蕶iȌꍇ͋؂蕶j											//
//																												//
//	߂l	F	 -1 : sXN[ʒu																		//
//				 -1 : G[																					//
//==============================================================================================================//
//	R[obNp^
typedef struct {
	C_WCP		pLine;			//	[IN ]seLXg擪AhX
	int			ix;				//	[IN ]JnCfNX
	C_WCP		pStr;			//	[OUT]iȂꍇNULLݒj
	int			ixFind;			//	[OUT]CfNX
	int			stl;			//	[OUT]O񌩂̕
} CBP_SRHTXT_UP, *PCBP_SRHTXT_UP;
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	v[̃R[obN
static	BOOL CALLBACK cbNtcSrhStrUp(C_WCP pStr, UX cbp)
{
	PCBP_SRHTXT_UP	pCbp = (PCBP_SRHTXT_UP)cbp;
	int				stl	 = (int)wcslen(pStr);
	int				ix	 = pCbp->ix;
	C_WCP			p	 = NULL;

	while (ix >= 0) {										//	s܂Ń[v
		p	= pCbp->pLine + ix;								//		ʒu|C^ݒ
		if (wcsncmp(p, pStr, stl) == 0) {					//		񂪌H
			if (pCbp->stl == 0	   ||						//												or
				ix >  pCbp->ixFind ||						//			ʒu񒆂ōŉE[	or
				ix == pCbp->ixFind && stl > pCbp->stl) {	//			ʒu񒷂H
				pCbp->pStr	 = pStr;						//				ݒ
				pCbp->ixFind = ix;							//				CfNXݒ
				pCbp->stl	 = stl;							//				񒷐ݒ
			}
		}
		ix--;												//		ʒuֈړ
	}
	return TRUE;
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcVthSearchAboveA(HWND hwnd, C_BCP pStr, BC delimiter)
{
	UI		rc = -1;
	int		len;
	WCP		pTmp;
	WC		wdlm[8];

	if (pStr != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pStr, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pStr, -1, pTmp, len);
			memset(wdlm, 0, sizeof wdlm);
			MultiByteToWideChar(CP_ACP, 0, &delimiter, 1, wdlm, 8);
			rc = AjcVthSearchAboveW(hwnd, pTmp, wdlm[0]);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcVthSearchAboveW(HWND hwnd, C_WCP pStr, WC delimiter)
{
	UI				rc	  = -1;
	HAJCSPL			hSpl  = NULL;			//	v[
	int				lTxt;					//	eLXgobt@
	WCP				pTxt = NULL;			//	eLXgobt@|C^
	int				txl;					//	s̒
	int				lp, ix;					//	񌟍ʒu
	int				stl = 0;				//	
	CBP_SRHTXT_UP	Cbp;					//	R[obNp^

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			do {
				//	p^`FbN
				if (pStr == NULL) break;
				//	eLXgobt@m
				lTxt = pW->prop.VramW + 1;
				if ((pTxt = AjcTAlloc(lTxt)) == NULL) break;
				//	v[
				if ((hSpl = AjcSplCreate(AJCSPL_CMP_MIX)) == NULL) break;
				//	v[֌ݒ
				if (!SubRegistStrToPool(hSpl, pStr, delimiter)) break;
				//	XN[sʒuωȂ΁AJnʒuĐݒ
				lp = VthIxToLno(pW, pW->IxWTop);
				if (pW->ScrPos.y != lp) {
					pW->ScrPos.y = lp;
					//	JnʒuiECh[s̎s̍sj
					pW->SrhPos.y = lp + (pW->wh / pW->cyChar);
					if (pW->LCnt > 0) pW->SrhPos.y = __min(pW->SrhPos.y, (LONG)(pW->LCnt - 1));
					else			  pW->SrhPos.y = 0;
					//	s
					pW->SrhPos.x = 0;
				}
				//	̌
				if (pW->SrhPos.y != 0 || pW->SrhPos.x != 0) {
					lp = pW->SrhPos.y;
					ix = pW->SrhPos.x;
					while (lp >= 0) {
						//	seLXg擾
						AjcVthGetLineTextW(pW->hBack, lp, pTxt, lTxt);
						if (txl = (int)wcslen(pTxt)) {
							//	CfNX
							ix	= __min(ix, txl -1);
							//	seLXgs
							memset(&Cbp, 0, sizeof Cbp);
							Cbp.pLine = pTxt;
							Cbp.ix	  = ix;
							AjcSplEnumStrW(hSpl, (UX)&Cbp, cbNtcSrhStrUp, FALSE);
							if (Cbp.pStr != NULL) {		//	񂠂
								stl = Cbp.stl;
								ix	= Cbp.ixFind;
								//	XN[
								SubSrhScroll(pW, Cbp.pLine, lp, ix, stl);
								//	I
								AjcVthSelect(pW->hBack, lp, ix, lp, ix + stl);
								//	I
								break;
							}
						}
						//	sʒuXV
						lp--;
						ix = pW->prop.VramW - 1;
					}
					//	̌ʒuݒ
					if (stl != 0) {					//	񂪌H
						if (ix >= 1) {
							pW->SrhPos.y = lp;
							pW->SrhPos.x = ix - 1;
						}
						else {
							if (lp > 0) {
								pW->SrhPos.y = lp - 1;
								pW->SrhPos.x = pW->prop.VramW - 1;
							}
							else {
								pW->SrhPos.y = 0;
								pW->SrhPos.x = 0;
							}
						}
						//	TQ[gQ[hڂȂ΁AɂP߂
						if (MAjcIsTrailW(Cbp.pLine[pW->SrhPos.x])) {
							_ASSERT(pW->SrhPos.x != 0);
							pW->SrhPos.x--;
						}
					}
					else {							//	͌ȂH
						//	ECh[s
						pW->SrhPos.y = VthIxToLno(pW, pW->IxWTop);
						//	s
						pW->SrhPos.x = 0;
					}
				}
				rc = VthIxToLno(pW, pW->IxWTop);
			} while(0);
			//	񂪌ȂꍇAIԉ
			if (stl == 0) {
				VthSetMode(pW, pW->Mode & ~MD_SELECT);
			}
			//	\[X
			if (pTxt != NULL) free(pTxt);
			if (hSpl != NULL) AjcSplDelete(hSpl);
		}
	}

	return rc;
}
//==============================================================================================================//
//	\̒~^ĊJ																							//
//																												//
//	@	F	hwnd		- EChnh																	//
//				fPause		- \~tOiTRUE:\~CFALSE:\Jnj									//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVthPause(HWND hwnd, BOOL fPause)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (!(pW->fPause = fPause)) {
				//	ŏIy[WփXN[
				if (!(pW->style & AJCVTHS_NOSCRL)) {
					VthScrollToBottom(pW);
				}
				//	XN[ݒ
				else {
					VthSetVScrollInfo(pW, -1);
				}
				//	Lbgݒ
				VthSetCaret(pW);
				//	ĕ`
				InvalidateRect(pW->hMain, NULL, FALSE);
			}
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	s̐ݒ|bvAbvj[Ɋ܂߂邩ۂ̐ݒ													//
//																												//
//	@	F	hwnd		- EChnh																	//
//				flag		- TRUE	: s̐ݒ|bvAbvj[Ɋ܂߂								//
//							  FALSE : s̐ݒ|bvAbvj[Ɋ܂߂Ȃ							//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVthSetLFActInPopupMenu(HWND hwnd, BOOL flag)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (flag) MAjcSetWindowLong(hwnd, GWL_STYLE, MAjcGetWindowLong(hwnd, GWL_STYLE) & ~AJCVTHS_FIXEDLF);
			else	  MAjcSetWindowLong(hwnd, GWL_STYLE, MAjcGetWindowLong(hwnd, GWL_STYLE) |  AJCVTHS_FIXEDLF);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	s̐ݒ|bvAbvj[Ɋ܂߂邩ۂ̐ݒl擾												//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	TRUE  : TRUE  : s̐ݒ|bvAbvj[Ɋ܂߂									//
//				FALSE : s̐ݒ|bvAbvj[Ɋ܂߂Ȃ ^ G[								//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVthGetLFActInPopupMenu(HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = !(MAjcGetWindowLong(hwnd, GWL_STYLE) & AJCVTHS_FIXEDLF);
		}
	}
	return rc;
}

//==============================================================================================================//
//	CfNXʒuϊ																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pTxt		- seLXg																		//
//				idx			- CfNX																	//
//																												//
//	߂l	F	CfNXɑΉ錅ʒu																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI AjcVthIdxToCPosA(HWND hwnd, C_BCP pTxt, UI idx)
{
	UI		rc = 0;
	UI		lTxt;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			if (lTxt = (UI)strlen(pTxt)) {
				idx  = __min(idx, lTxt - 1);
				if (idx != 0 && mbsbtype(pTxt, idx) == _MBC_TRAIL) idx--;
				rc = idx;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI AjcVthIdxToCPosW(HWND hwnd, C_WCP pTxt, UI idx)
{
	UI		rc = 0;
	UI		lTxt;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			if (lTxt = (UI)wcslen(pTxt)) {
				rc = VthIdxToCPos(pTxt, lTxt, idx);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ʒuCfNXϊ																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pTxt		- seLXg																		//
//				pos			- ʒu																			//
//																												//
//	߂l	F	CfNXɑΉ錅ʒu																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI AjcVthCPosToIdxA(HWND hwnd, C_BCP pTxt, UI pos)
{
	UI		rc = 0;
	UI		lTxt;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			if (lTxt = (UI)strlen(pTxt)) {
				pos  = __min(pos, lTxt - 1);
				if (pos != 0 && mbsbtype(pTxt, pos) == _MBC_TRAIL) pos--;
				rc = pos;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI AjcVthCPosToIdxW(HWND hwnd, C_WCP pTxt, UI pos)
{
	UI		rc = 0;
	UI		lTxt;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW) && pTxt != NULL) {
			if (lTxt = (UI)wcslen(pTxt)) {
				rc = VthCPosToIdx(pTxt, lTxt, pos);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	CECh̃nh擾																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pBkWnd		- EChwiFi[obt@ւ̃|C^isvNULLj						//
//																												//
//	߂l	F	NULL : CECh̃nh																//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	HWND	WINAPI		AjcVthGetMainWindow(HWND hwnd, COLORREF *pBkGnd)
{
	HWND	rc = NULL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (pBkGnd != NULL) {
				*pBkGnd = RGB(255, 255, 255);
			}
			rc = pW->hMain;
		}
	}
	return rc;
}
//==============================================================================================================//
//																												//
//	ʒm擾																								//
//																												//
//==============================================================================================================//
//	ENbNʒm
AJCEXPORT	PAJCVTHRCLK	WINAPI AjcVthGetNtcRClk		(HWND hwnd)
{
	PAJCVTHRCLK	rc = NULL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = &pW->NtcRClk;
	}
	return rc;
}
//	_uNbNʒm
AJCEXPORT	UI		WINAPI AjcVthGetNtcDblClk	(HWND hwnd)
{
	UI		rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcDblClk;
	}
	return rc;
}
//	hbvfBNg
AJCEXPORT	UI			WINAPI AjcVthGetNtcDirs		(HWND hwnd)
{
	UI	rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcDirs;
	}
	return rc;
}
//	hbvt@C
AJCEXPORT	UI			WINAPI AjcVthGetNtcFiles	(HWND hwnd)
{
	UI	rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcFiles;
	}
	return rc;
}
//	̓L[R[h
AJCEXPORT	UI			WINAPI AjcVthGetNtcKey		(HWND hwnd)
{
	UI	rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcKey;
	}
	return rc;
}
//	L[
AJCEXPORT	UI			WINAPI AjcVthGetNtcKeyRep	(HWND hwnd)
{
	UI	rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = pW->KeyRep;
	}
	return rc;
}
//	_uNbN̉zL[
AJCEXPORT	UI			WINAPI AjcVthGetNtcKeyFlg	(HWND hwnd)
{
	UI	rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcKeyFlg;
	}
	return rc;
}
//	TCY̕ωʒm̍s̍
AJCEXPORT	UI			WINAPI AjcVthGetNtcCyLine	(HWND hwnd)
{
	UI	rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcCyLine;
	}
	return rc;
}
//	XN[ʒm̍[ʒu
AJCEXPORT	UI			WINAPI AjcVthGetNtcLeft	(HWND hwnd)
{
	UI	rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcLeft;
	}
	return rc;
}
//	cXN[ʒm̏[sʒu
AJCEXPORT	UI			WINAPI AjcVthGetNtcTop	(HWND hwnd)
{
	UI	rc = 0;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		rc = pW->NtcTop;
	}
	return rc;
}

//==============================================================================================================//
//	[h擾ifobOpj																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//																												//
//	߂l	F	[h																						//
//==============================================================================================================//
AJCEXPORT UI	   WINAPI AjcVthGetMode(HWND hwnd)
{
	UI		rc = -1;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->Mode;
		}
	}
	return rc;
}

//==============================================================================================================//
//	ftHgtHgݒiJj																			//
//																												//
//	@	F	hwnd		- EChnh																	//
//				hFont		- tHgnh																	//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI AjcVthSetDefFont(HWND hwnd, HFONT hFont)
{
	BOOL	rc = FALSE;
	LOGFONT	lf;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			if (rc = (GetObject(hFont, sizeof(LOGFONT), &lf) == sizeof(LOGFONT))) {
				memcpy(&pW->lfDefFont, &lf, sizeof(LOGFONT));
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	uq`l擾iJj																					//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pBuf		- uq`li[obt@̃AhX											//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcVthGetVramInfo(HWND hwnd, PAJCVTHVRAMINFO pBuf)
{
	BOOL		rc = FALSE;
	PLINEPTR	pL;

	if (IsWindow(hwnd)) {
		PWRKVT100 pW = (PWRKVT100)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pBuf->pVram		= pW->pVram;			//	uq`l擪AhX
			pBuf->width		= pW->prop.VramW;		//	Ps̕
			pBuf->height	= pW->prop.VramH;		//	s
			pBuf->LineBytes	= pW->VramLSize;		//	uq`lPs̃oCg
			pBuf->lp		= pW->lp;				//	J[\sʒu
			pBuf->cp		= pW->cp;				//	J[\ʒu
			pBuf->ix		= pW->cpx;				//	J[\ʒuɑΉeLXgCfNX
			//	uq`lŏs̍sCfNX
			pL = pW->pLPtr + pW->IxVTop;
			pBuf->ltop = (UI)(((UX)pL->pTxt - (UX)pW->pVram) / pW->VramLSize);
			rc = TRUE;
		}
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	I͈͂̃eLXg擾																						//
//																												//
//	@	F	pW		- Ɨ̈̃AhX																	//
//																												//
//	߂l	F	NULL - I𒆂̃eLXgiobt@ɃeLXgi[j									//
//				NULL - I𒆂̃eLXgȂ/obt@mەs\													//
//--------------------------------------------------------------------------------------------------------------//
static	HGLOBAL	GetSelectedText(PWRKVT100 pW)
{
	HGLOBAL		hGlobal = NULL;
	UI			ixL, ixSL, ixSC, ixEL, ixEC, len;
	PLINEPTR	pL;
	WCP			pBlk;

	if (pW->Mode & MD_SELECT) {
		VthAdjustSelectInfo(pW, &ixSL, &ixSC, &ixEL, &ixEC);
		//----- s͈͂̑I ------------------------------------------------//
		if (ixSL == ixEL) {
			pL = pW->pLPtr + ixSL;
			if (ixSC < pL->len && ixSC < ixEC) {
				len = __min(ixEC, pL->len) - ixSC;
				if (hGlobal = GlobalAlloc(GHND | GMEM_SHARE, (len + 3) * 2)) {
					pBlk = GlobalLock(hGlobal);
					memcpy(pBlk, pL->pTxt + ixSC, len * 2); pBlk += len;
					if (ixEC > pL->len && 
						ixEL  != ((pW->IxSrt + (pW->LCnt - 1)) % pW->prop.MaxLines)) {
						memcpy(pBlk, L"\r\n", 4); pBlk += 2;
					}
					*pBlk = 0;
				}
			}
		}
		//----- sI ------------------------------------------------------//
		else {
			len = 0;
			//----- 擪sTCYvZ ----------------------//
			ixL = ixSL;
			pL	= pW->pLPtr + ixL;
			if (ixSC < pL->len) {
				len += (pL->len - ixSC);
			}
			len += 2;
			//----- ԍsTCYvZ ----------------------//
			ixL = ((ixL + 1) % pW->prop.MaxLines);
			while (ixL != ixEL) {
				pL = pW->pLPtr + ixL;
				len += (pL->len + 2);
				ixL = ((ixL + 1) % pW->prop.MaxLines);
			}
			//----- ŏIsTCYvZ ----------------------//
			pL = pW->pLPtr + ixL;
			if (ixEC < pL->len) len += (ixEC	   );
			else				len += (pL->len + 2);
			//----- 蓖 ------------------------//
			if (hGlobal = GlobalAlloc(GHND | GMEM_SHARE, (len + 1) * 2)) {
				pBlk = GlobalLock(hGlobal);
				//----- 擪sRs[ ----------------------//
				ixL = ixSL;
				pL	= pW->pLPtr + ixL;
				if (ixSC < pL->len) {
					len = (pL->len - ixSC);
					memcpy(pBlk, pL->pTxt + ixSC, len * 2); pBlk += len;
				}
				memcpy(pBlk, L"\r\n", 4); pBlk += 2;
				//----- ԍsRs[ ----------------------//
				ixL = ((ixL + 1) % pW->prop.MaxLines);
				while (ixL != ixEL) {
					pL = pW->pLPtr + ixL;
					len = pL->len;
					memcpy(pBlk, pL->pTxt, len * 2); pBlk += len;
					memcpy(pBlk, L"\r\n" , 4	  ); pBlk += 2;
					ixL = ((ixL + 1) % pW->prop.MaxLines);
				}
				//----- ŏIsRs[ ----------------------//
				pL = pW->pLPtr + ixL;
				if (ixEC <= pL->len) {
					memcpy(pBlk, pL->pTxt, ixEC * 2); pBlk += ixEC;
				}
				else {
					memcpy(pBlk, pL->pTxt, pL->len * 2); pBlk += pL->len;
					if (ixEL != ((pW->IxSrt + (pW->LCnt - 1)) % pW->prop.MaxLines)) {
						memcpy(pBlk, L"\r\n", 4); pBlk += 2;
					}
				}
				//----- I[ݒ --------------------------//
				*pBlk = 0;
			}
		}
	}
	return hGlobal;
}
//--------------------------------------------------------------------------------------------------------------//
//	eLXgt@C֏																				//
//																												//
//	@	F	pW			- Ɨ̈̃AhX																//
//				hFile		- t@Cnh																	//
//				fAllText	- TRUE:SeLXgCFALSE:IeLXg												//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - I𒆂̃eLXgȂ																	//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SaveToTextFile(PWRKVT100 pW, HAJCFILE hFile, BOOL fAllText)
{
	BOOL		rc = FALSE;
	UI			ixL, ixSL, ixSC, ixEL, ixEC, len;
	PLINEPTR	pL;

	if (pW->LCnt != 0) {
		if (fAllText || (pW->Mode & MD_SELECT)) {	//	SeLXgó^IeLXgH
			if (fAllText) {							//		SeLXgo
				ixSL  = pW->IxSrt;					//			擪sCfNX
				ixSC  = 0;							//			擪CfNX
				ixEL  = pW->IxSrt + pW->LCnt - 1;	//			ŏIsCfNX
				ixEL %= pW->prop.MaxLines;			//			E
				ixEC  = pW->prop.VramW;				//			ŏICfNX
			}
			else {									//		IeLXgo
				VthAdjustSelectInfo(pW, &ixSL, &ixSC, &ixEL, &ixEC);
			}
			//----- s͈͂̑I ------------------------------------------------//
			if (ixSL == ixEL) {
				pL = pW->pLPtr + ixSL;
				if (ixSC < pL->len && ixSC < ixEC) {
					len = __min(ixEC, pL->len) - ixSC;
					AjcFPutS(hFile, pL->pTxt + ixSC, len);
					if (ixEC > pL->len && 
						ixEL  != ((pW->IxSrt + (pW->LCnt - 1)) % pW->prop.MaxLines)) {
						AjcFPutSW(hFile, L"\n", -1);
					}
					rc = TRUE;
				}
			}
			//----- sI ------------------------------------------------------//
			else {
				//----- 擪s --------------------//
				ixL = ixSL;
				pL	= pW->pLPtr + ixL;
				if (ixSC < pL->len) {
					len = (pL->len - ixSC);
					AjcFPutSW(hFile, pL->pTxt + ixSC, len);
				}
				AjcFPutSW(hFile, L"\n", -1);
				//----- ԍs --------------------//
				ixL = ((ixL + 1) % pW->prop.MaxLines);
				while (ixL != ixEL) {
					pL = pW->pLPtr + ixL;
					len = pL->len;
					AjcFPutSW(hFile, pL->pTxt, len);
					AjcFPutSW(hFile, L"\n"	 , -1 );
					ixL = ((ixL + 1) % pW->prop.MaxLines);
				}
				//----- ŏIs --------------------//
				pL = pW->pLPtr + ixL;
				if (ixEC <= pL->len) {
					AjcFPutSW(hFile, pL->pTxt, ixEC);
				}
				else {
					AjcFPutS(hFile, pL->pTxt, pL->len);
					if (ixEL != ((pW->IxSrt + (pW->LCnt - 1)) % pW->prop.MaxLines)) {
						AjcFPutSW(hFile, L"\n", -1);
					}
				}
				//----- ߂l ----------------------//
				rc = TRUE;
			}
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	I͈͂gslkt@C֏																		//
//																												//
//	@	F	pW			- Ɨ̈̃AhX																//
//				hFile		- t@Cnh																	//
//				fAllText	- TRUE:SeLXgCFALSE:IeLXg												//
//				FontSize	- tHgTCYiP`Vj															//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - I𒆂̃eLXgȂ																	//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SaveToHtmlFile(PWRKVT100 pW, HAJCFILE hFile, BOOL fAllText, UI FontSize)
{
	BOOL		rc = FALSE;
	UI			ixL, ixSL, ixSC, ixEL, ixEC;
	PLINEPTR	pL;
	WC			txt[512];

	if (pW->LCnt != 0) {
		pW->HtmlSvAtt = 0xFF;
		if (fAllText || (pW->Mode & MD_SELECT)) {	//	SeLXgó^IeLXgH
			if (fAllText) {							//		SeLXgo
				ixSL  = pW->IxSrt;					//			擪sCfNX
				ixSC  = 0;							//			擪CfNX
				ixEL  = pW->IxSrt + pW->LCnt - 1;	//			ŏIsCfNX
				ixEL %= pW->prop.MaxLines;			//			E
				ixEC  = pW->prop.VramW;				//			ŏICfNX
			}
			else {									//		IeLXgo
				VthAdjustSelectInfo(pW, &ixSL, &ixSC, &ixEL, &ixEC);
			}
			//----- tHgTCY ----------------------------------------------//
			FontSize = __max(1, FontSize);
			FontSize = __min(7, FontSize);
			//----- 擪 ----------------------------------------------------------//
			AjcFPutSA(hFile, "<html>\n", -1);
			AjcFPutSA(hFile, "<head>\n", -1);
			AjcFPutSA(hFile, "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n", -1);
			AjcFPutSA(hFile, "</head>\n", -1);
			AjcFPutSA(hFile, "<body bgcolor=\"#ffffff\">\n", -1);
			AjcSnPrintF(txt, AJCTSIZE(txt), L"<font size=\"%d\" face=\"%s\">\n", FontSize, pW->prop.LogFont.lfFaceName, -1);
			AjcFPutS(hFile, txt, -1);
			//----- s͈͂̑I ------------------------------------------------//
			if (ixSL == ixEL) {
				pL = pW->pLPtr + ixSL;
				if (ixSC < pL->len && ixSC < ixEC) {
					WriteHtmlLine(pW, hFile, pL, ixSC, ixEC);
					if (ixEC > pL->len && 
						ixEL  != ((pW->IxSrt + (pW->LCnt - 1)) % pW->prop.MaxLines)) {
						AjcFPutSA(hFile, "<br>\r\n", -1);
					}
					rc = TRUE;
				}
			}
			//----- sI ------------------------------------------------------//
			else {
				//----- 擪s --------------------//
				ixL = ixSL;
				pL	= pW->pLPtr + ixL;
				if (ixSC < pL->len) {
					WriteHtmlLine(pW, hFile, pL, ixSC, pW->prop.VramW);
				}
				AjcFPutSA(hFile, "<br>\n", -1);
				//----- ԍs --------------------//
				ixL = ((ixL + 1) % pW->prop.MaxLines);
				while (ixL != ixEL) {
					pL = pW->pLPtr + ixL;
					WriteHtmlLine(pW, hFile, pL, 0, pW->prop.VramW);
					AjcFPutSA(hFile, "<br>\n", -1);
					ixL = ((ixL + 1) % pW->prop.MaxLines);
				}
				//----- ŏIs --------------------//
				pL = pW->pLPtr + ixL;
				if (ixEC <= pL->len) {
					WriteHtmlLine(pW, hFile, pL, 0, ixEC);
				}
				else {
					WriteHtmlLine(pW, hFile, pL, 0, ixEC);
					if (ixEL != ((pW->IxSrt + (pW->LCnt - 1)) % pW->prop.MaxLines)) {
						AjcFPutSA(hFile, "<br>\n", -1);
					}
				}
				//----- ߂l ----------------------//
				rc = TRUE;
			}
			//----- I[ ----------------------------------------------------------//
			if (pW->HtmlSvAtt != 0xFF)	AjcFPutSA(hFile, "</span>\n", -1);
										AjcFPutSA(hFile, "</font>\n", -1);
										AjcFPutSA(hFile, "</body>\n", -1);
										AjcFPutSA(hFile, "</html>\n", -1);
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	gslks																							//
//																												//
//	@	F	pW		- Ɨ̈̃AhX																	//
//				hFile	- t@Cnh																		//
//				pL		- ރeLXgւ̍s|C^														//
//				ixSC	- 擪CfNX																	//
//				ixEC	- I[CfNX																	//
//																												//
//	߂l	F	TRUE  : OK																						//
//				FALSE : Error																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	WriteHtmlLine(PWRKVT100 pW, HAJCFILE hFile, PLINEPTR pL, UI ixSC, UI ixEC)
{
	BOOL	rc = FALSE;
	UI		len = 0;
	UI		i, ix, bc, fc;
	WCP		pTxt;
	UBP		pAtt;
	WC		txt[128];

	if (ixSC < ixEC) {
		pTxt = pL->pTxt;
		if (pL->fVram) pAtt = (UBP)(pL->pTxt + pW->prop.VramW);
		else		   pAtt = (UBP)(pL->pTxt + pL->len);
		len = __min(ixEC, pL->len) - ixSC;

		ix = ixSC;
		for (i = 0; i < len; i++) {
			if ((pAtt[ix] & (VAT_BC | VAT_FC)) != pW->HtmlSvAtt) {
				WriteHtmlText(pW, hFile, pTxt + ixSC, ix - ixSC);
				if (pW->HtmlSvAtt != 0xFF) AjcSnPrintF(txt, AJCTSIZE(txt), L"</span>\n");
				bc = (pAtt[ix] & VAT_BC) >> 4;
				fc = (pAtt[ix] & VAT_FC);
				bc = pW->prop.rgb[bc]; bc = ((bc & 0x00FF0000) >> 16) | (bc & 0x0000FF00) | ((bc & 0x000000FF) << 16);
				fc = pW->prop.rgb[fc]; fc = ((fc & 0x00FF0000) >> 16) | (fc & 0x0000FF00) | ((fc & 0x000000FF) << 16);
				AjcSnPrintFW(txt, AJCTSIZE(txt), L"<span style=\"background-color:#%06X;color:#%06X\">\n", bc, fc);
				AjcFPutSW(hFile, txt, -1);
				pW->HtmlSvAtt = (pAtt[ix] & (VAT_BC | VAT_FC));
				ixSC = ix++;
			}
			else ix++;
		}
		if (ixSC < ix) {
			WriteHtmlText(pW, hFile, pTxt + ixSC, ix - ixSC);
		}
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	gslkeLXgt@C֏																		//
//																												//
//	@	F	pW		- Ɨ̈̃AhX																	//
//				hFile	- t@Cnh																		//
//				pTxt	- ރeLXg̃AhX(SJIS)														//
//				lTxt	- ރeLXg̃oCg															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	WriteHtmlText(PWRKVT100 pW, HAJCFILE hFile, C_WCP pTxt, UI lTxt)
{
	BOOL	rc = TRUE;
	UI		i, j;

	for (i = 0; i < lTxt;) {
		if (pTxt[i] == 0x20) {
			if (!AjcFPutSA(hFile, "&nbsp;", -1)) {
				rc = FALSE;
			}
			i++;
		}
		else {
			for (j = i; pTxt[j] != 0x20 && j < lTxt; j++);
			if (!AjcFPutSW(hFile, pTxt + i, j - i)) {
				rc = FALSE;
			}
			i = j;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	drbV[PXtASeLXgt@C֏													//
//																												//
//	@	F	pW			- Ɨ̈̃AhX																//
//				hFile		- t@Cnh																	//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SaveAllTextToFileWithEsc(PWRKVT100 pW, HAJCFILE hFile)
{
	BOOL		rc = FALSE;
	int			ixL, ixSL, ixEL, len, i, j;
	PLINEPTR	pL;
	WCP			pT;
	UBP			pA;
	UB			Tc, SvTc = -1;
	UB			Bc, SvBc = -1;
	WC			esc[32];

	if (pW->LCnt != 0) {
		ixSL  = pW->IxSrt;					//	擪sCfNX
		ixEL  = pW->IxSrt + pW->LCnt - 1;	//	ŏIsCfNX
		ixEL %= pW->prop.MaxLines;			//	E
		//-----  ------------------------//
		ixL = ixSL;
		while (ixL != ixEL) {
			//	s|C^ݒ
			pL = pW->pLPtr + ixL;					//	s|C^zGg
			pT = pL->pTxt;							//	seLXg|C^
			if (pL->fVram) {						//	uq`lH
				pA = (UBP)(pT + pW->prop.VramW);	//		uq`l̍s|C^
			}
			else {
				pA = (UBP)(pT + pL->len);			//		obt@f[^̍s|C^
			}
			//	Lf[^ݒ
			len = pL->len;

			if (len > 0) {
				//	Pso
				i = j = 0;
				while (j < len) {
					Bc = (UB)((pA[j] & VAT_BC) >> 4);
					Tc = (UB) (pA[j] & VAT_FC);
					if (Tc != SvTc || Bc != SvBc) {		//	\Fω
						//	\FωÕeLXgo
						AjcFPutSW(hFile, &pT[i], j - i);
						//	drbV[PXo
						if (Tc != SvTc) {
							//	eLXgF
							AjcSnPrintFW(esc, AJCTSIZE(esc), L"\x1B[3%dm", Tc);
							AjcFPutSW(hFile, esc, -1);
							SvTc = Tc;
						}
						if (Bc != SvBc) {
							//	wiF
							AjcSnPrintFW(esc, AJCTSIZE(esc), L"\x1B[4%dm", Bc);
							AjcFPutSW(hFile, esc, -1);
							SvBc = Bc;
						}
						i = j;
					}
					j++;
				}
				//	seLXgo
				if (i <= j) {
					AjcFPutSW(hFile, &pT[i], j - i);
				}
			}
			//	so
			AjcFPutSW(hFile, L"\n", -1);
			//	̍sCfNXݒ
			ixL = ((ixL + 1) % pW->prop.MaxLines);
		}
		//----- Zbgo ------------------//
		AjcFPutSW(hFile, L"\x1B[0m", -1);
		//----- ߂l ----------------------//
		rc = TRUE;
	}
	return rc;
}

