#include	"AjcInternal.h"

#define	INST_ID			0xFED49C21
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//**************************************************************************************************************//
//																												//
//	XbhԁEŒ蒷[{bNXʐM																		//
//																												//
//**************************************************************************************************************//

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	MailSize  - [f[^TCYioCgj														//
//				cbp 	  - R[obNp^																//
//				cbRemove  - [ʒmpR[obNisv͂mtkkj									//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
AJCEXPORT	HAJCFMBX	WINAPI	AjcFMbxCreate(UI MailSize, UX cbp, VO (CALLBACK *cbRemove)(VOP pDat, UX cbp))
{
	HAJCFMBX	pW;
	BOOL		fErr = TRUE;

	if ((pW = (HAJCFMBX)AJCMEM(sizeof(AJCFMBX))) != NULL) {
		memset(pW, 0, sizeof *pW);
		pW->InstID = INST_ID;
		do {
			if ((pW->hEvt  = CreateEvent(NULL, FALSE, FALSE, NULL))  == NULL) break;
			if ((pW->hFQue = AjcFQueCreate(MailSize, cbp, cbRemove)) == NULL) break;
			InitializeCriticalSection(&pW->cs);
			fErr = FALSE;
		} while (0);

		if (fErr) {
			if (pW->hEvt  != NULL) CloseHandle(pW->hEvt);
			if (pW->hFQue != NULL) AjcFQueDelete(pW->hFQue);
			free(pW);
			pW = NULL;
		}
	}
	return pW;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcFMbxDelete(HAJCFMBX pW)
{
	if (IS_MY_INST(pW)) {
		if (pW->hEvt  != NULL) CloseHandle(pW->hEvt);
		if (pW->hFQue != NULL) AjcFQueDelete(pW->hFQue);
		DeleteCriticalSection(&pW->cs);
		free(pW);
	}
}

//==============================================================================================================//
//	փ[f[^ǉ																						//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - ֑}郁[f[^̃AhX														//
//																												//
//	߂l	F	sqtd@Fnj																				//
//				e`krdFG[																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcFMbxEnque	(HAJCFMBX pW, C_VOP pDat)
{
	BOOL		rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pDat != NULL) {
			EnterCriticalSection(&pW->cs);
			if (rc = AjcFQueEnque(pW->hFQue, pDat)) {
				rc = SetEvent(pW->hEvt);
			}
			LeaveCriticalSection(&pW->cs);
		}
	}
	return rc;
}
//==============================================================================================================//
//	擪փ[f[^}																						//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - 擪֑}m[hf[^̃AhX														//
//																												//
//	߂l	F	sqtd@Fnj																				//
//				e`krdFG[																				//
//==============================================================================================================//
AJCEXPORT	BOOL 		WINAPI	AjcFMbxEnqTop	(HAJCFMBX pW, C_VOP pDat)
{
	BOOL		rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pDat != NULL) {
			EnterCriticalSection(&pW->cs);
			if (rc = AjcFQueEnqTop(pW->hFQue, pDat)) {
				rc = SetEvent(pW->hEvt);
			}
			LeaveCriticalSection(&pW->cs);
		}
	}
	return rc;
}
//==============================================================================================================//
//	擪[f[^o																					//
//																												//
//	@	F	pW 	   - CX^Xnh																	//
//				pBuf   - o[f[^i[obt@̃AhX										//
//				msTime - ҂[ms]i|P̏ꍇ͖j														//
//																												//
//	߂l	F	OFo[f[^̃oCg															//
//				OF[Ȃ^G[																		//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcFMbxDeque	(HAJCFMBX pW, VOP pBuf, UI msTime)
{
	UI			rc = 0;

	if (IS_MY_INST(pW)) {
		if (pBuf != NULL) {
			EnterCriticalSection(&pW->cs);
			if (rc = AjcFQueDeque(pW->hFQue, pBuf)) {
				ResetEvent(pW->hEvt);
				LeaveCriticalSection(&pW->cs);
			}
			else {
				LeaveCriticalSection(&pW->cs);
				if (WaitForSingleObject(pW->hEvt, msTime == -1 ? INFINITE : msTime) == WAIT_OBJECT_0) {
					EnterCriticalSection(&pW->cs);
					rc = AjcFQueDeque(pW->hFQue, pBuf);
					LeaveCriticalSection(&pW->cs);
				}
				else {
					rc = 0;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	S[f[^																					//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcFMbxPurge	(HAJCFMBX pW)
{
	if (IS_MY_INST(pW)) {
		EnterCriticalSection(&pW->cs);
		AjcFQuePurge(pW->hFQue);
		LeaveCriticalSection(&pW->cs);
	}
}
//==============================================================================================================//
//	݂̃[f[^𓾂																					//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//																												//
//	߂l	F	݂̃m[h																					//
//==============================================================================================================//
AJCEXPORT	UI	  WINAPI	AjcFMbxGetCount	(HAJCFMBX pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		EnterCriticalSection(&pW->cs);
		rc = AjcFQueGetCount(pW->hFQue);
		LeaveCriticalSection(&pW->cs);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI	  WINAPI	AjcFMbxNumber	(HAJCFMBX pW)
{
	return AjcFMbxGetCount(pW);
}
