#include	"AjcInternal.h"

#define	INST_ID			0x92134BE6
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//**************************************************************************************************************//
//																												//
//	XbhԁEϒ[{bNXʐM																		//
//																												//
//**************************************************************************************************************//

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	cbp 	  - R[obNp^																//
//				cbRemove  - [ʒmpR[obNisv͂mtkkj									//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
AJCEXPORT	HAJCVMBX	WINAPI	AjcVMbxCreate(UX cbp, VO (CALLBACK *cbRemove)(VOP pDat, UI lDat, UX cbp))
{
	HAJCVMBX	pW;
	BOOL		fErr = TRUE;

	if ((pW = (HAJCVMBX)AJCMEM(sizeof(AJCVMBX))) != NULL) {
		memset(pW, 0, sizeof *pW);
		pW->InstID = INST_ID;
		do {
			if ((pW->hEvt  = CreateEvent(NULL, FALSE, FALSE, NULL))  == NULL) break;
			if ((pW->hVQue = AjcVQueCreate(cbp, cbRemove))			 == NULL) break;
			InitializeCriticalSection(&pW->cs);
			fErr = FALSE;
		} while (0);

		if (fErr) {
			if (pW->hEvt  != NULL) CloseHandle(pW->hEvt);
			if (pW->hVQue != NULL) AjcVQueDelete(pW->hVQue);
			free(pW);
			pW = NULL;
		}
	}
	return pW;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcVMbxDelete(HAJCVMBX pW)
{
	if (IS_MY_INST(pW)) {
		if (pW->hEvt  != NULL) CloseHandle(pW->hEvt);
		if (pW->hVQue != NULL) AjcVQueDelete(pW->hVQue);
		DeleteCriticalSection(&pW->cs);
		free(pW);
	}
}

//==============================================================================================================//
//	[f[^ʒm																							//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - ʒm郁[f[^̃AhX															//
//				lDat - ʒm郁[f[^̃oCg															//
//																												//
//	߂l	F	sqtd@Fnj																				//
//				e`krdFG[																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcVMbxEnque	(HAJCVMBX pW, C_VOP pDat, UI lDat)
{
	BOOL		rc = FALSE;

	if (IS_MY_INST(pW)) {
		EnterCriticalSection(&pW->cs);
		if (rc = AjcVQueEnque(pW->hVQue, pDat, lDat)) {
			rc = SetEvent(pW->hEvt);
		}
		LeaveCriticalSection(&pW->cs);
	}
	return rc;
}
//==============================================================================================================//
//	D惁[f[^ʒm																						//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - 擪֑}m[hf[^̃AhX														//
//				lDat - ʒm郁[f[^̃oCg															//
//																												//
//	߂l	F	sqtd@Fnj																				//
//				e`krdFG[																				//
//==============================================================================================================//
AJCEXPORT	BOOL 		WINAPI	AjcVMbxEnqTop	(HAJCVMBX pW, C_VOP pDat, UI lDat)
{
	BOOL		rc = FALSE;

	if (IS_MY_INST(pW)) {
		EnterCriticalSection(&pW->cs);
		if (rc = AjcVQueEnqTop(pW->hVQue, pDat, lDat)) {
			rc = SetEvent(pW->hEvt);
		}
		LeaveCriticalSection(&pW->cs);
	}
	return rc;
}
//==============================================================================================================//
//	擪[f[^o																					//
//																												//
//	@	F	pW 	   - CX^Xnh																	//
//				pBuf   - o[f[^i[obt@̃AhX										//
//				lBuf   - o[f[^i[obt@̃oCg										//
//				msTime - ҂[ms]i|P̏ꍇ͖j														//
//																												//
//	߂l	F	OFo[f[^̃oCg															//
//				OF[Ȃ^G[																		//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcVMbxDeque	(HAJCVMBX pW, VOP pBuf, UI lBuf, UI msTime)
{
	UI			rc = 0;

	if (IS_MY_INST(pW)) {
		EnterCriticalSection(&pW->cs);
		if (rc = AjcVQueDeque(pW->hVQue, pBuf, lBuf)) {
			ResetEvent(pW->hEvt);
			LeaveCriticalSection(&pW->cs);
		}
		else {
			LeaveCriticalSection(&pW->cs);
			if (WaitForSingleObject(pW->hEvt, msTime == -1 ? INFINITE : msTime) == WAIT_OBJECT_0) {
				EnterCriticalSection(&pW->cs);
				rc = AjcVQueDeque(pW->hVQue, pBuf, lBuf);
				LeaveCriticalSection(&pW->cs);
			}
			else {
				rc = 0;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	擪[f[^oiVj																			//
//																												//
//	@	F	pW 	   - CX^Xnh																	//
//				pBuf   - o[f[^i[obt@̃AhX										//
//				lBuf   - o[f[^i[obt@̃oCg										//
//				msTime - ҂[ms]i|P̏ꍇ͖j														//
//																												//
//	߂l	F	OFo[f[^̃oCg															//
//				-1F[Ȃ^G[																		//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcVMbxDequeEx	(HAJCVMBX pW, VOP pBuf, UI lBuf, UI msTime)
{
	UI			rc = -1;

	if (IS_MY_INST(pW)) {
		EnterCriticalSection(&pW->cs);
		if ((rc = AjcVQueDequeEx(pW->hVQue, pBuf, lBuf)) != -1) {
			ResetEvent(pW->hEvt);
			LeaveCriticalSection(&pW->cs);
		}
		else {
			LeaveCriticalSection(&pW->cs);
			if (WaitForSingleObject(pW->hEvt, msTime == -1 ? INFINITE : msTime) == WAIT_OBJECT_0) {
				EnterCriticalSection(&pW->cs);
				rc = AjcVQueDequeEx(pW->hVQue, pBuf, lBuf);
				LeaveCriticalSection(&pW->cs);
			}
			else {
				rc = -1;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	S[f[^																					//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcVMbxPurge	(HAJCVMBX pW)
{
	if (IS_MY_INST(pW)) {
		EnterCriticalSection(&pW->cs);
		AjcVQuePurge(pW->hVQue);
		LeaveCriticalSection(&pW->cs);
	}
}
//==============================================================================================================//
//	݂̃[f[^𓾂																					//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//																												//
//	߂l	F	݂̃m[h																					//
//==============================================================================================================//
AJCEXPORT	UI	  WINAPI	AjcVMbxGetCount	(HAJCVMBX pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		EnterCriticalSection(&pW->cs);
		rc = AjcVQueGetCount(pW->hVQue);
		LeaveCriticalSection(&pW->cs);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI	  WINAPI	AjcVMbxNumber	(HAJCVMBX pW)
{
	return AjcVMbxGetCount(pW);
}
//==============================================================================================================//
//	݂̃[f[^̑oCg擾																			//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//																												//
//	߂l	F	݂̃[f[^̑oCg																	//
//==============================================================================================================//
AJCEXPORT	ULL	  		WINAPI	AjcVMbxGetTotalBytes(HAJCVMBX pW)
{
	ULL			rc = 0;
	PAJCVQNODE	pNode;
	UI			bytes;

	if (IS_MY_INST(pW)) {
		EnterCriticalSection(&pW->cs);
		if (pNode = (PAJCVQNODE)AjcVQueTopNode(pW->hVQue, &bytes)) {
			do {
				rc += bytes;
			} while (pNode = AjcVQueNextNode(pW->hVQue, pNode, &bytes));
		}
		LeaveCriticalSection(&pW->cs);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	ULL	  		WINAPI	AjcVMbxBytes	(HAJCVMBX pW)
{
	return AjcVMbxGetTotalBytes(pW);
}
