#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	bZ[W}bviECh^_CAOvV[W̊ȑfj												//
//																												//
//**************************************************************************************************************//

#define	AJCMMP_DEFWNDPROC_PROP	"AjcMmpSubClassProp"

static	VO			SubMmpInitTbl(PAJCMSGTBL pMsgTbl, PAJCMSGCHAINPTR pChain, BOOL fUnicode);
static	BOOL		SubSetProp	 (HWND hwnd, C_BCP pName, WNDPROC WndProc);
static	WNDPROC		SubGetProp	 (HWND hwnd, C_BCP pName);
static	BOOL		SubRemoveProp(HWND hwnd, C_BCP pName);

//==============================================================================================================//
//	bZ[W}bve[u																				//
//																												//
//	@F	pMsgTbl	- bZ[W}bve[ũAhX													//
//				pChain	- bZ[W}bv`FC|C^Q̃AhX											//
//																												//
//	߂lF	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		CALLBACK	AjcMmpInitTblA	(PAJCMSGTBL pMsgTbl, PAJCMSGCHAINPTR pChain)
{
	SubMmpInitTbl(pMsgTbl, pChain, FALSE);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		CALLBACK	AjcMmpInitTblW	(PAJCMSGTBL pMsgTbl, PAJCMSGCHAINPTR pChain)
{
	SubMmpInitTbl(pMsgTbl, pChain, TRUE);
}
//----- ʃTu -----------------------------------------------------------------------------------------------//
static		VO					SubMmpInitTbl	(PAJCMSGTBL pMsgTbl, PAJCMSGCHAINPTR pChain, BOOL fUnicode)
{
	PAJCMSGTBL	*ppMsg = &pChain->pMsg;
	PAJCMSGTBL	*ppCmd = &pChain->pCmd;
	PAJCMSGTBL	*ppNtc = &pChain->pNtc;

	while (pMsgTbl->MsgType != AJCMSGTYPE_END) {
		switch (pMsgTbl->MsgType) {
			case AJCMSGTYPE_MSG:
				if		(pMsgTbl->msg == WM_COMMAND) pChain->pWmCmd = pMsgTbl;
				else if (pMsgTbl->msg == WM_NOTIFY ) pChain->pWmNtc = pMsgTbl;
				else {
					if (pMsgTbl->pRwm != NULL) {
						if (fUnicode) pMsgTbl->msg = RegisterWindowMessageW((WCP)pMsgTbl->pRwm);
						else		  pMsgTbl->msg = RegisterWindowMessageA((BCP)pMsgTbl->pRwm);
					}
					*ppMsg = pMsgTbl;
					 ppMsg = &pMsgTbl->pNxt;
				}
				break;

			case AJCMSGTYPE_CMD:
				*ppCmd = pMsgTbl;
				 ppCmd = &pMsgTbl->pNxt;
				break;

			case AJCMSGTYPE_NTC:
				*ppNtc = pMsgTbl;
				 ppNtc = &pMsgTbl->pNxt;
				break;
		}
		pMsgTbl++;
	}
}
//==============================================================================================================//
//	EChvV[W																						//
//																												//
//	@F	pChain	- bZ[W}bv`FC|C^Q̃AhX											//
//				hwnd	- EChnh																		//
//				msg 	- bZ[WR[h																		//
//				wParam	- p^																				//
//				lParam	- p^																				//
//				MyProc	- EChvV[W																//
//				pName	- vV[W																		//
//																												//
//	߂lF	bZ[Wnh̖߂l																		//
//==============================================================================================================//
AJCEXPORT	LRESULT	CALLBACK	AjcMmpWndMsgHandle(PAJCMSGCHAINPTR pChain, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam, WNDPROC MyProc, C_BCP pName)
{
	LRESULT		rc;
	WNDPROC		OldProc;	//	̃IWiEChvV[W
	WNDPROC		OrgProc;	//	ṼIWiEChvV[W

	//-----  WM_COMMAND --------------------------------------------------------------------------------------//
	if		(msg == WM_COMMAND) {
		int			cmd = LOWORD(wParam);
		PAJCMSGTBL	pCmd;

		//	R}h(LOWORD(wParam))
		for (pCmd = pChain->pCmd; pCmd != NULL && pCmd->cmd != cmd; pCmd = pCmd->pNxt);

		//	R}hLȂ΁AYR}hANVs
		if (pCmd != NULL) {
			rc = pCmd->func(hwnd, msg, wParam, lParam);
		}
		//	WM_COMMANDLȂ΁AWM_COMMANDANVs
		else if (pChain->pWmCmd) {
			rc = pChain->pWmCmd->func(hwnd, msg, wParam, lParam);
		}
		//	̑EE
		else {
			//	TuNXɂAvV[WȂH
			if ((OrgProc = SubGetProp(hwnd, pName)) == NULL) {
				//	ftHgEChvV[Ws
				if ((OldProc = (WNDPROC)GetPropA(hwnd, AJCMMP_DEFWNDPROC_PROP)) && OldProc != MyProc)
					rc = AjcCallWindowProc(OldProc, hwnd, msg, wParam, lParam);
				else
					rc = AjcDefWindowProc ( 		hwnd, msg, wParam, lParam);
			}
			//	TuNXɂAvV[WH
			else {
				//	vV[Ws
				rc = AjcCallWindowProc(OrgProc, hwnd, msg, wParam, lParam);
			}
		}
	}
	//-----  WM_NOTIFY ---------------------------------------------------------------------------------------//
	else if (msg == WM_NOTIFY ) {
		HWND		hw = (HWND)wParam;
		LPNMHDR		pH = (LPNMHDR)lParam;
		int			cmd = (int)(IsWindow(hw) ? MAjcGetWindowLong(hw, GWL_ID) : pH->idFrom);
		PAJCMSGTBL	pNtc;

		//	ʒmR[h
		for (pNtc = pChain->pNtc; pNtc != NULL && pNtc->cmd != cmd; pNtc = pNtc->pNxt);

		//	ʒmR[hLȂ΁AYʒmANVs
		if (pNtc != NULL) {
			rc = pNtc->func(hwnd, msg, wParam, lParam);
		}
		//	WM_NOTIFYLȂ΁AWM_NOTIFYANVs
		else if (pChain->pWmNtc) {
			rc = pChain->pWmNtc->func(hwnd, msg, wParam, lParam);
		}
		//	̑EE
		else {
			//	TuNXɂAvV[WȂH
			if ((OrgProc = SubGetProp(hwnd, pName)) == NULL) {
				//	ftHgEChvV[Ws
				if ((OldProc = (WNDPROC)GetPropA(hwnd, AJCMMP_DEFWNDPROC_PROP)) && OldProc != MyProc)
					rc = AjcCallWindowProc(OldProc, hwnd, msg, wParam, lParam);
				else
					rc = AjcDefWindowProc ( 		hwnd, msg, wParam, lParam);
			}
			//	TuNXɂAvV[WH
			else {
				//	vV[Ws
				rc = AjcCallWindowProc(OrgProc, hwnd, msg, wParam, lParam);
			}
		}
	}
	//-----  ̑̃bZ[W ------------------------------------------------------------------------------//
	else {
		PAJCMSGTBL	pMsg;

		//	bZ[W
		for (pMsg = pChain->pMsg; pMsg != NULL && pMsg->msg != msg; pMsg = pMsg->pNxt);

		//	bZ[WLȂ΁AYbZ[WANVs
		if (pMsg != NULL) {
			rc = pMsg->func(hwnd, msg, wParam, lParam);
		}
		//	bZ[WEEE
		else {
			//	TuNXɂAvV[WȂH
			if ((OrgProc = SubGetProp(hwnd, pName)) == NULL) {
				//	ftHgEChvV[Ws
				if ((OldProc = (WNDPROC)GetPropA(hwnd, AJCMMP_DEFWNDPROC_PROP)) && OldProc != MyProc)
					rc = AjcCallWindowProc(OldProc, hwnd, msg, wParam, lParam);
				else
					rc = AjcDefWindowProc ( 		hwnd, msg, wParam, lParam);
			}
			//	TuNXɂAvV[WH
			else {
				//	vV[Ws
				rc = AjcCallWindowProc(OrgProc, hwnd, msg, wParam, lParam);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	_CAOvV[W																						//
//																												//
//	@F	pChain	- bZ[W}bv`FC|C^Q̃AhX											//
//				hwnd	- EChnh																		//
//				msg 	- bZ[WR[h																		//
//				wParam	- p^																				//
//				lParam	- p^																				//
//																												//
//	߂lF	bZ[Wnh̖߂liꍇFALSE)													//
//==============================================================================================================//
AJCEXPORT	LRESULT	CALLBACK	AjcMmpDlgMsgHandle(PAJCMSGCHAINPTR pChain, HWND hDlg, UI msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT	rc = FALSE;

	//-----  WM_COMMAND --------------------------------------------------------------------------------------//
	if		(msg == WM_COMMAND) {
		int			cmd = LOWORD(wParam);
		PAJCMSGTBL	pCmd;

		//	R}h(LOWORD(wParam))
		for (pCmd = pChain->pCmd; pCmd != NULL && pCmd->cmd != cmd; pCmd = pCmd->pNxt);

		//	R}hLȂ΁AYR}hANVs
		if (pCmd != NULL) {
			rc = pCmd->func(hDlg, msg, wParam, lParam);
		}
		//	WM_COMMANDLȂ΁AWM_COMMANDANVs
		else if (pChain->pWmCmd) {
			rc = pChain->pWmCmd->func(hDlg, msg, wParam, lParam);
		}
	}
	//-----  WM_NOTIFY ---------------------------------------------------------------------------------------//
	else if (msg == WM_NOTIFY ) {
		int			cmd;
		PAJCMSGTBL	pNtc;
		LPNMHDR		p = (LPNMHDR)lParam;

		//	qECh̒ʒmȂ΁AqECĥhcݒ
		if (IsWindow((HWND)p->idFrom) && (MAjcGetWindowLong((HWND)p->idFrom, GWL_STYLE) & WS_CHILD)) {
			cmd = (int)MAjcGetWindowLong((HWND)wParam, GWL_ID);
		}
		//	̑̏ꍇARg[̎ʎqݒ
		else {
			cmd = (int)p->idFrom;
		}

		//	ʎq
		for (pNtc = pChain->pNtc; pNtc != NULL && pNtc->cmd != cmd; pNtc = pNtc->pNxt);

		//	ʎqȂ΁AYANVs
		if (pNtc != NULL) {
			rc = pNtc->func(hDlg, msg, wParam, lParam);
		}
		//	WM_NOTIFYȂ΁AWM_NOTIFYANVs
		else if (pChain->pWmNtc) {
			rc = pChain->pWmNtc->func(hDlg, msg, wParam, lParam);
		}
	}
	//-----  ̑̃bZ[W ------------------------------------------------------------------------------//
	else {
		PAJCMSGTBL	pMsg;

		//	bZ[W
		for (pMsg = pChain->pMsg; pMsg != NULL && pMsg->msg != msg; pMsg = pMsg->pNxt);

		//	bZ[WLȂ΁AYbZ[WANVs
		if (pMsg != NULL) {
			rc = pMsg->func(hDlg, msg, wParam, lParam);
		}
	}
	return rc;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	TuNXɊւt@NV																			//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
#define	SBC_XQUE	L"AJCSBC_CALL_STACK"
typedef struct {
	C_BCP		pName;		//	vV[W̖O
	WNDPROC		wpNew;		//	TuNXVEChvV[W
	WNDPROC		wpOld;		//	̃EChvV[W
} SBCNODE, *PSBCNODE;
typedef const SBCNODE *PCSBCNODE;
//==============================================================================================================//
//	EChvV[W̃TuNXiVj																//
//																												//
//	@F	hwnd	- EChnh																		//
//				pName	- vV[W																		//
//				NewProc - VEChvV[W																//
//																												//
//	߂lF	 NULL - IWiEChvV[W̃AhX												//
//				 NULL - s																					//
//==============================================================================================================//
AJCEXPORT	WNDPROC	CALLBACK AjcMmpSetSubclass	  (HWND hwnd, C_BCP pName, WNDPROC NewProc)
{
	WNDPROC		rc	  = NULL;
	HAJCXQUE	hXQue = NULL;
	SBCNODE		node  = {0};
	PSBCNODE	pNode = NULL;

	if (IsWindow(hwnd) && pName != NULL && *pName != 0) {
		//	vV[WX^bNpoL[
		if ((hXQue = (HAJCXQUE)GetPropW(hwnd, SBC_XQUE)) == NULL) {
			if ((hXQue = AjcXQueCreate(0, NULL)) != NULL) {
				SetProp(hwnd, SBC_XQUE, (HANDLE)hXQue);
			}
		}
		if (hXQue != NULL) {
			//	vV[WGg
			if ((pNode = (PSBCNODE)AjcXQueTopNode(hXQue, NULL)) && strcmp(pNode->pName, pName) != 0) {
				while ((pNode = (PSBCNODE)AjcXQueNextNode(hXQue, pNode, NULL)) && strcmp(pNode->pName, pName) != 0);
			}
			//	ꖼ̖H
			if (pNode == NULL) {
				//	Vm[hǉ
				if (pNode = (PSBCNODE)AjcXQueEnque(hXQue, &node, sizeof node)) {
					//	VEChvV[Wݒ
					if (rc = (WNDPROC)AjcSetWindowLongPtr(hwnd, GWLP_WNDPROC, (UX)NewProc)) {
						//	ftHgEEChvV[WEChɊ֘At
						SubSetProp(hwnd, pName, rc);
						//	vV[WX^bNփEChvV[Wݒ
						pNode->pName = pName;
						pNode->wpNew = NewProc;
						pNode->wpOld = rc;
					}
					//	G[Ȃ΃m[hj
					else {
						AjcXQueRemove(hXQue, (C_VOP)pNode);
					}
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	EChvV[W̃TuNXiVj															//
//																												//
//	@F	hwnd	- EChnh																		//
//				pName	- vV[W																		//
//																												//
//	߂lF	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT	BOOL CALLBACK AjcMmpClrSubclass    (HWND hwnd, C_BCP pName)
{
	BOOL		rc		= FALSE;
	HAJCXQUE	hXQue	= NULL;
	PSBCNODE	pNode	= NULL;
	PSBCNODE	pNext	= NULL;
	PSBCNODE	pPrev	= NULL;

	if (IsWindow(hwnd) && pName != NULL && *pName != 0) {
		//	vV[WX^bNEL[CX^XLH
		if (hXQue = (HAJCXQUE)GetPropW(hwnd, SBC_XQUE)) {
			//	vV[WGg
			if ((pNode = (PSBCNODE)AjcXQueTopNode(hXQue, NULL)) && strcmp(pNode->pName, pName) != 0) {
				do {
					pPrev = pNode;
				} while ((pNode = (PSBCNODE)AjcXQueNextNode(hXQue, pNode, NULL)) && strcmp(pNode->pName, pName) != 0);
			}
			//	vV[WGgH
			if (pNode != NULL) {
				//	GgH
				if (pNext = (PSBCNODE)AjcXQueNextNode(hXQue, pNode, NULL)) {
					//	m[h̃ftHgEvV[W֘AtύX
					if (pNext->wpOld == pNode->wpNew) {
						SubSetProp(hwnd, pNext->pName, pNode->wpOld);
					}
					//	m[h̃ftHgEvV[WύX
					pNext->wpOld = pNode->wpOld;
					//	m[h̃ftHgvV[W֘At
					SubRemoveProp(hwnd, pNode->pName);
					//	m[h폜
					AjcXQueRemove(hXQue, (C_VOP)pNode);
				}
				//	GgigŏIGgjH
				else {
					//	PÕm[hLH
					if (pPrev != NULL) {
						//	1Õm[h̃vV[WL
						AjcSetWindowLongPtr(hwnd, GWLP_WNDPROC, (UX)pPrev->wpNew);
						//	m[h̃ftHgvV[W֘At
						SubRemoveProp(hwnd, pNode->pName);
						//	m[h폜
						AjcXQueRemove(hXQue, (C_VOP)pNode);
					}
					//	PÕm[hHiĝPGĝ݁j
					else {
						//	ftHgvV[WݒicvV[Wݒj
						AjcSetWindowLongPtr(hwnd, GWLP_WNDPROC, (UX)pNode->wpOld);
						//	m[h̃ftHgvV[W֘At
						SubRemoveProp(hwnd, pNode->pName);
						//	CX^X
						AjcXQueDelete(hXQue);
						//	CX^X֘At
						RemoveProp(hwnd, SBC_XQUE);
					}
				}
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	TuNX폜iVj																				//
//																												//
//	@F	hwnd	- EChnh																		//
//				pName	- vV[W																		//
//																												//
//	߂lF	TRUE  - 																					//
//				FALSE - siTuNXGgj														//
//==============================================================================================================//
AJCEXPORT	BOOL CALLBACK AjcMmpDelSubclass    (HWND hwnd, C_BCP pName)
{
	BOOL		rc		= FALSE;
	HAJCXQUE	hXQue	= NULL;
	PSBCNODE	pNode	= NULL;

	if (hXQue = (HAJCXQUE)GetPropW(hwnd, SBC_XQUE)) {
		RemoveProp(hwnd, SBC_XQUE); 
		rc = AjcXQueDelete(hXQue);
	}
	return rc;
}
//==============================================================================================================//
//	TuNX̎擾iVj																			//
//																												//
//	@F	hwnd	- EChnh																		//
//				pBuf	- TuNXi[obt@̃AhX	isvNULLj						//
//				nBuf	- TuNXi[obt@̃Gg										//
//																												//
//	߂lF	TuNX̌																				//
//==============================================================================================================//
AJCEXPORT	UI	CALLBACK AjcMmpGetSubclassInfo (HWND hwnd, AJCSBCINFO buf[], UI nBuf)
{
	UI			rc	  = 0;
	HAJCXQUE	hXQue;
	PSBCNODE	pNode = NULL;

	if (IsWindow(hwnd)) {
		if (hXQue = (HAJCXQUE)GetPropW(hwnd, SBC_XQUE)) {
			//	vV[WGg[v
			if (pNode = (PSBCNODE)AjcXQueTopNode(hXQue, NULL)) {
				do {
					rc++;
					if (buf != NULL && nBuf >= rc) {
						buf->pName = pNode->pName;
						buf->wpNew = pNode->wpNew;
						buf->wpOld = pNode->wpOld;
						buf->wpRet = SubGetProp(hwnd, pNode->pName);
						buf++;
					}
				} while (pNode = (PSBCNODE)AjcXQueNextNode(hXQue, pNode, NULL));
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ftHgEChvV[W̐ݒiVj																//
//																												//
//	@F	hwnd	- EChnh																		//
//				pName	- vV[W																		//
//				WndProc - ftHgEChvV[W														//
//																												//
//	߂lF	TRUE  - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	CALLBACK AjcMmpSetDefWndProcEx(HWND hwnd, C_BCP pName, WNDPROC DefWndProc)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		rc = SubSetProp(hwnd, pName, (HANDLE)DefWndProc);
	}
	return rc;
}
//==============================================================================================================//
//	ftHgEChvV[W擾iVj																//
//																												//
//	@F	hwnd	- EChnh																		//
//				pName	- vV[W																		//
//																												//
//	߂lF	 NULL - ftHgEChvV[W̃AhX												//
//				 NULL - s																					//
//==============================================================================================================//
AJCEXPORT	WNDPROC	CALLBACK AjcMmpGetDefWndProcEx (HWND hwnd, C_BCP pName)
{
	WNDPROC		rc = NULL;

	if (IsWindow(hwnd)) {
		rc = SubGetProp(hwnd, pName);
	}
	return rc;
}
//==============================================================================================================//
//	ftHgEChvV[W̌ĂяoiVj															//
//																												//
//	@F	hwnd	- EChnh																		//
//				pName	- vV[W																		//
//				msg		- ftHgEChvV[Wւ̃p^											//
//				wParam	-	V																					//
//				lParam	-	V																					//
//																												//
//	߂lF	bZ[W̌																			//
//==============================================================================================================//
AJCEXPORT	LRESULT	CALLBACK AjcMmpCallOrgWndProc(HWND hwnd, C_BCP pName, UI msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT		rc = 0;
	WNDPROC		OrgWp;

	if (IsWindow(hwnd)) {
		if (OrgWp = SubGetProp(hwnd, pName)) rc = AjcCallWindowProc(OrgWp, hwnd, msg, wParam, lParam);
		else								 rc = AjcDefWindowProc (	   hwnd, msg, wParam, lParam);
	}
	return rc;
}
//==============================================================================================================//
//	ftHgEChvV[W̐ݒij																//
//																												//
//	@F	hwnd	- EChnh																		//
//				WndProc - ftHgEChvV[W														//
//																												//
//	߂lF	TRUE  - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	CALLBACK AjcMmpSetDefWndProc(HWND hwnd, WNDPROC DefWndProc)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		rc = SetPropA(hwnd, AJCMMP_DEFWNDPROC_PROP, (HANDLE)DefWndProc);
	}
	return rc;
}
//==============================================================================================================//
//	ftHgEChvV[W擾ij																//
//																												//
//	@F	hwnd	- EChnh																		//
//																												//
//	߂lF	 NULL - ftHgEChvV[W̃AhX												//
//				 NULL - s																					//
//==============================================================================================================//
AJCEXPORT	WNDPROC	CALLBACK AjcMmpGetDefWndProc (HWND hwnd)
{
	WNDPROC		rc = NULL;

	if (IsWindow(hwnd)) {
		rc = GetPropA(hwnd, AJCMMP_DEFWNDPROC_PROP);
	}
	return rc;
}
//==============================================================================================================//
//	ftHgEChvV[W̌Ăяoij															//
//																												//
//	@F	hwnd	- EChnh																		//
//				msg		- ftHgEChvV[Wւ̃p^											//
//				wParam	-	V																					//
//				lParam	-	V																					//
//																												//
//	߂lF	bZ[W̌																			//
//==============================================================================================================//
AJCEXPORT	LRESULT	CALLBACK AjcMmpCallDefWndProc(HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT		rc = 0;
	WNDPROC		DefWp;

	if (IsWindow(hwnd)) {
		if (DefWp = GetPropA(hwnd, AJCMMP_DEFWNDPROC_PROP)) rc = AjcCallWindowProc(DefWp, hwnd, msg, wParam, lParam);
		else												rc = AjcDefWindowProc (		  hwnd, msg, wParam, lParam);
	}
	return rc;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	Tu֐																								//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//--------------------------------------------------------------------------------------------------------------//
//	EChvpeBɃvV[Wo^																		//
//																												//
//	@F	hwnd	- EChnh																		//
//				pName	- vV[W̖																	//
//				WndProc	- vV[W̃AhX																//
//																												//
//	߂lF	TRUE  - 																					//
//				FALSE - s																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubSetProp(HWND hwnd, C_BCP pName, WNDPROC WndProc)
{
	BOOL	rc = FALSE;
	BC		name[256];

	if (IsWindow(hwnd) && pName != NULL && *pName != 0) {
		AjcSnPrintFA(name, AJCTSIZE(name), "AjcMmpOrgProc_%s", pName);
		rc = SetPropA(hwnd, name, (HANDLE)WndProc);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	EChvpeBvV[W擾																		//
//																												//
//	@F	hwnd	- EChnh																		//
//				pName	- vV[W̖																	//
//																												//
//	߂lF	 NULL - 擾vV[W̃AhX														//
//				 NULL - s																					//
//--------------------------------------------------------------------------------------------------------------//
static	WNDPROC	SubGetProp(HWND hwnd, C_BCP pName)
{
	WNDPROC	rc = NULL;
	BC		name[256];

	if (IsWindow(hwnd) && pName != NULL && *pName != 0) {
		AjcSnPrintFA(name, AJCTSIZE(name), "AjcMmpOrgProc_%s", pName);
		rc = (WNDPROC)GetPropA(hwnd, name);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	EChvpeB																						//
//																												//
//	@F	hwnd	- EChnh																		//
//				pName	- vV[W̖																	//
//																												//
//	߂lF	 NULL - 擾vV[WshX															//
//				 NULL - s																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubRemoveProp(HWND hwnd, C_BCP pName)
{
	BOOL	rc = FALSE;
	BC		name[256];

	if (IsWindow(hwnd) && pName != NULL && *pName != 0) {
		AjcSnPrintFA(name, AJCTSIZE(name), "AjcMmpOrgProc_%s", pName);
		rc = (RemovePropA(hwnd, name) != NULL);
	}
	return rc;
}
