//
//	AcsFormula.c - vvZXi#if / #elifjŎw肳ꂽ̕]
//
#include	"AjcInternal.h"
#include	"AjcPp.h"

#define	MAX_NEST	32				//	őlXg

#define	ISLV01(TKN)	((TKN) == EAJCTK_DLM_MULT || (TKN) == EAJCTK_DLM_DIV || (TKN) == EAJCTK_DLM_MOD)								/*	*	/	%		*/
#define	ISLV02(TKN)	((TKN) == EAJCTK_DLM_PLUS || (TKN) == EAJCTK_DLM_MINUS)															/*	+	-			*/
#define	ISLV03(TKN)	((TKN) == EAJCTK_DLM_SHL  || (TKN) == EAJCTK_DLM_SHR  )															/*	<<	>>			*/
#define	ISLV04(TKN)	((TKN) == EAJCTK_DLM_LO   || (TKN) == EAJCTK_DLM_HI || (TKN) == EAJCTK_DLM_LOEQ || (TKN) == EAJCTK_DLM_HIEQ)	/*	<	>	<=	>=	*/
#define	ISLV05(TKN)	((TKN) == EAJCTK_DLM_EQEQ || (TKN) == EAJCTK_DLM_NOTEQ)															/*	==	!=			*/
#define	ISLV06(TKN)	((TKN) == EAJCTK_DLM_AND )																						/*	&				*/
#define	ISLV07(TKN)	((TKN) == EAJCTK_DLM_XOR )																						/*	^				*/
#define	ISLV08(TKN)	((TKN) == EAJCTK_DLM_OR  )																						/*	|				*/
#define	ISLV09(TKN)	((TKN) == EAJCTK_DLM_LAND)																						/*	&&				*/
#define	ISLV10(TKN)	((TKN) == EAJCTK_DLM_LOR )																						/*	||				*/
#define	ISLV11(TKN)	((TKN) == EAJCTK_DLM_QUEST || (TKN) == EAJCTK_DLM_COLON)														/*	?  :			*/

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	int				express		(HAJCPPC pW);
static	int				expresses	(HAJCPPC pW, int n);
static	int				Lvl11		(HAJCPPC pW);
static	int				Lvl11s		(HAJCPPC pW, int n);
static	int				Lvl10		(HAJCPPC pW);
static	int				Lvl10s		(HAJCPPC pW, int n);
static	int				Lvl09		(HAJCPPC pW);
static	int				Lvl09s		(HAJCPPC pW, int n);
static	int				Lvl08		(HAJCPPC pW);
static	int				Lvl08s		(HAJCPPC pW, int n);
static	int				Lvl07		(HAJCPPC pW);
static	int				Lvl07s		(HAJCPPC pW, int n);
static	int				Lvl06		(HAJCPPC pW);
static	int				Lvl06s		(HAJCPPC pW, int n);
static	int				Lvl05		(HAJCPPC pW);
static	int				Lvl05s		(HAJCPPC pW, int n);
static	int				Lvl04		(HAJCPPC pW);
static	int				Lvl04s		(HAJCPPC pW, int n);
static	int				Lvl03		(HAJCPPC pW);
static	int				Lvl03s		(HAJCPPC pW, int n);
static	int				Lvl02		(HAJCPPC pW);
static	int				Lvl02s		(HAJCPPC pW, int n);
static	int				Lvl01		(HAJCPPC pW);
static	int				Lvl01s		(HAJCPPC pW, int n);
static	int				part		(HAJCPPC pW);

static	EAJCTKCODE		SkipSylAndChkEOL(HAJCPPC pW);
static	EAJCTKCODE		SkipSyl			(HAJCPPC pW);

//==============================================================================================================//
//	vvZXi#if / #elifjŎw肳ꂽ̕]															//
//																												//
//	@	F	pTkn	- ̐擪g[N																		//
//				pResult	- Zʂi[obt@̃AhX													//
//																												//
//	߂l	F	O - nj																						//
//				O - G[R[h																				//
//==============================================================================================================//
AJCPPCERROR PpcFormulaExpression(HAJCPPC pW, PAJCPPCTKNNODE pTkn, int *pResult)
{
	int		n;

	//----- fobOig[Nj\ -------------//
	#ifdef _DEBUG
	{	PAJCPPCTKNNODE	p = pTkn;
		while ( p != NULL) {
			p = p->pNxt;
		}
	}
	#endif

	//----- ϐ ---------------------------------//
	pW->pFmlCur		= pTkn;					//	݂̌|C^
	pW->FmlNestCnt	= 0;					//	lXgJE^
	pW->FmlSclErr	= AJCPPC_ERROR_OK;		//	G[R[h
	pW->nstDmyRgtInLAndLOr = 0;				//	u&&vu||v̉E]Ȃ|̃tOilXglj

	//----- Zs -----------------------------------//
	n = express(pW);

	//----- Z̏I[`FbN -----------------------//
	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		if (!(pW->pFmlCur->pNxt == NULL || pW->pFmlCur->tkn == EAJCTK_EOF)) {
			pW->FmlSclErr = AJCPPC_SCLERR_EXPRESSION;
			PPC_ERR(pW->FmlSclErr, pW->pFmlCur->pFile, pW->pFmlCur->lno, pW->pFmlCur->pSyl);
		}
	}

	//----- Zʊi[ -------------------------------//
	if (pResult != NULL) *pResult = n;

	return pW->FmlSclErr;
}

//--------------------------------------------------------------------------------------------------------------//
//	E X P R E S S																								//
//--------------------------------------------------------------------------------------------------------------//
static	int	express(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		if (pW->FmlNestCnt < MAX_NEST) {
			pW->FmlNestCnt++;
			n = expresses(pW, Lvl11(pW));
			pW->FmlNestCnt--;
		}
		else {
			pW->FmlSclErr = AJCPPC_SCLERR_OVERNEST;
			PPC_ERR(pW->FmlSclErr, pW->pFmlCur->pFile, pW->pFmlCur->lno, 0);
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	E X P R E S S E S																							//
//--------------------------------------------------------------------------------------------------------------//
static	int	expresses(HAJCPPC pW, int n)
{
	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV11(pW->pFmlCur->tkn)) {
		n = express(pW);
	}
	return n;
}

//--------------------------------------------------------------------------------------------------------------//
//	Lvl11																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl11(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl11s(pW, Lvl10(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl11s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl11s(HAJCPPC pW, int n)
{
	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  pW->pFmlCur->tkn == EAJCTK_DLM_QUEST) {	// u ? v
		//	XLbvdnk`FbN
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		if (n) {
			n = Lvl10(pW);
			if (pW->FmlSclErr) break;
			if (pW->pFmlCur->tkn == EAJCTK_DLM_COLON) {		//	u : v
				if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
				Lvl10(pW);
			}
		}
		else {
			Lvl10(pW);
			if (pW->FmlSclErr) break;
			if (pW->pFmlCur->tkn == EAJCTK_DLM_COLON) {		//	u : v
				if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
				n = Lvl10(pW);
			}
		}
	}

	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl10																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl10(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl10s(pW, Lvl09(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl10s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl10s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;
	int			x;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV10(s = pW->pFmlCur->tkn)) {	//	u || v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		if (s == EAJCTK_DLM_LOR) {
			if (!n) {
				x = Lvl09(pW);
				n = (n || x);
			}
			else {
				pW->nstDmyRgtInLAndLOr++;		//	u||v̉E_~[Z ݒ
				x = Lvl09(pW);
				pW->nstDmyRgtInLAndLOr--;		//	u||v̉E_~[Z ilXgZj
			}
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl09																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl09(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl09s(pW, Lvl08(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl09s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl09s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;
	int			x;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV09(s = pW->pFmlCur->tkn)) {	//	u && v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		switch (s) {
			case EAJCTK_DLM_LAND:
				if (n) {
					x = Lvl08(pW);
					n = (n && x);
				}
				else {
					pW->nstDmyRgtInLAndLOr++;		//	u&&v̉E_~[Z ݒ
					Lvl08(pW);
					pW->nstDmyRgtInLAndLOr--;		//	u&&v̉E_~[Z ilXgZj
				}
				break;
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl08																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl08(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl08s(pW, Lvl07(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl08s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl08s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV08(s = pW->pFmlCur->tkn)) {	//	u | v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		switch (s) {
			case EAJCTK_DLM_OR:	n = (n | Lvl07(pW));	break;
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl07																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl07(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl07s(pW, Lvl06(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl07s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl07s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV07(s = pW->pFmlCur->tkn)) {	//	u ^ v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		switch (s) {
			case EAJCTK_DLM_XOR:	n = (n ^ Lvl06(pW));	break;
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl06																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl06(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl06s(pW, Lvl05(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl06s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl06s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV06(s = pW->pFmlCur->tkn)) {	//	u & v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		switch (s) {
			case EAJCTK_DLM_AND:	n = (n & Lvl05(pW));	break;
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl05																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl05(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl05s(pW, Lvl04(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl05s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl05s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV05(s = pW->pFmlCur->tkn)) {	//	u ==  != v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		switch (s) {
			case EAJCTK_DLM_EQEQ:	n = (n == Lvl04(pW));	break;		//	u == v
			case EAJCTK_DLM_NOTEQ:	n = (n != Lvl04(pW));	break;		//	u != v
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl04																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl04(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl04s(pW, Lvl03(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl04s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl04s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV04(s = pW->pFmlCur->tkn)) {	//	u <   >   <=  >= v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		switch (s) {
			case EAJCTK_DLM_LO:		n = (n <  Lvl03(pW));	break;	//	u <  v
			case EAJCTK_DLM_HI:		n = (n >  Lvl03(pW));	break;	//	u >  v
			case EAJCTK_DLM_LOEQ:	n = (n <= Lvl03(pW));	break;	//	u <= v
			case EAJCTK_DLM_HIEQ:	n = (n >= Lvl03(pW));	break;	//	u >= v
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl03																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl03(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl03s(pW, Lvl02(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl03s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl03s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV03(s = pW->pFmlCur->tkn)) {	//	u <<  >> v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		switch (s) {
			case EAJCTK_DLM_SHL:	n = (n << Lvl02(pW));	break;	//	u << v
			case EAJCTK_DLM_SHR:	n = (n >> Lvl02(pW));	break;	//	u >> v
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl02																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl02(HAJCPPC pW)
{
	int		n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl02s(pW, Lvl01(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl02s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl02s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV02(s = pW->pFmlCur->tkn)) {	//	u +   - v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		switch (s) {
			case EAJCTK_DLM_PLUS:	n = (n + Lvl01(pW));	break;	//	u + v
			case EAJCTK_DLM_MINUS:	n = (n - Lvl01(pW));	break;	//	u - v
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl01																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl01(HAJCPPC pW)
{
	int	n = 0;

	if (pW->FmlSclErr == AJCPPC_ERROR_OK) {
		n = Lvl01s(pW, part(pW));
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	Lvl01s																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	Lvl01s(HAJCPPC pW, int n)
{
	EAJCTKCODE	s;
	int			p;

	while (pW->FmlSclErr == AJCPPC_ERROR_OK  &&  ISLV01(s = pW->pFmlCur->tkn)) {	//	u *   /   % v
		if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;
		p = part(pW);
		switch (s) {
			case EAJCTK_DLM_MULT:	n = (n * p);
									break;

			case EAJCTK_DLM_DIV:	if (p) n = (n / p);
									else if (!pW->nstDmyRgtInLAndLOr) {		//	u&&v̉E_~[Z̓[Z𖳎
										pW->FmlSclErr = AJCPPC_SCLERR_DIVZERO;
										PPC_ERR(pW->FmlSclErr, pW->pFmlCur->pFile, pW->pFmlCur->lno, 0);
									}
									break;

			case EAJCTK_DLM_MOD:	if (p) n = (n % p);
									else if (!pW->nstDmyRgtInLAndLOr) {		//	u&&v̉E_~[Z̓[Z𖳎
										pW->FmlSclErr = AJCPPC_SCLERR_DIVZERO;
										PPC_ERR(pW->FmlSclErr, pW->pFmlCur->pFile, pW->pFmlCur->lno, 0);
									}
									break;
		}
	}
	return n;
}
//--------------------------------------------------------------------------------------------------------------//
//	P A R T																										//
//--------------------------------------------------------------------------------------------------------------//
static	int	part(HAJCPPC pW)
{
	int		n = 0;

	do {
		if (pW->FmlSclErr) break;								//	G[ȂΒ~

		if		(pW->pFmlCur->tkn == EAJCTK_DLM_LSPART) {		//	JbR
			if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;		//		XLbv
			n = express(pW);									//		Zs
			if (pW->FmlSclErr) break;							//		G[ȂΒ~
			if (pW->pFmlCur->tkn == EAJCTK_DLM_RSPART) {		//		EJbRH
				if (SkipSyl(pW) == EAJCTK_EOF) break;			//			XLbv
			}
			else {												//		EJbRłȂH
				pW->FmlSclErr = AJCPPC_SCLERR_NOTCLS;			//			G[
				PPC_ERR(pW->FmlSclErr, pW->pFmlCur->pFile, pW->pFmlCur->lno, 0);
			}
		}
		else if (pW->pFmlCur->tkn == EAJCTK_DLM_PLUS	||		//	PZqi+-~!j
				 pW->pFmlCur->tkn == EAJCTK_DLM_MINUS	||		//
				 pW->pFmlCur->tkn == EAJCTK_DLM_NOT	||			//
				 pW->pFmlCur->tkn == EAJCTK_DLM_LNOT) {			//

			EAJCTKCODE	s = pW->pFmlCur->tkn;					//		PZqޔ

			if (SkipSylAndChkEOL(pW) == EAJCTK_EOF) break;		//		XLbv
			n = part(pW);										//		l𓾂
			if (pW->FmlSclErr) break;							//		G[ȂΒ~
			switch (s) {										//		PZs
				case EAJCTK_DLM_MINUS:	n = ~n + 1;	break;		//		E
				case EAJCTK_DLM_NOT:	n = ~n;		break;		//		E
				case EAJCTK_DLM_LNOT:	n = !n;		break;		//		E
			}
		}
		else if (pW->pFmlCur->tkn == EAJCTK_VAL_DECIMAL ||		//	萔iPOi^PUij
				 pW->pFmlCur->tkn == EAJCTK_VAL_HEXA) {			//		E
			n = (int)AjcAscToIntA(pW->pFmlCur->pSyl);			//		萔lݒ
			if (SkipSyl(pW) == EAJCTK_EOF) break;				//		XLbv
		}
		else if (pW->pFmlCur->tkn == EAJCTK_VAL_OCTAL) {		//	萔iWij
			n = (int)AjcOctToUIA(pW->pFmlCur->pSyl);			//		萔lݒ
			if (SkipSyl(pW) == EAJCTK_EOF) break;				//		XLbv
		}
		else if (pW->pFmlCur->tkn == EAJCTK_VAL_REAL) {			//	萔ij
			n = (int)AjcAscToRealA(pW->pFmlCur->pSyl);			//		萔lݒ
			if (SkipSyl(pW) == EAJCTK_EOF) break;				//		XLbv
		}
		else {													//	̑
			if (pW->pFmlCur->tkn == EAJCTK_USR_NAME) {			//		V{H
				if (pW->nstDmyRgtInLAndLOr) {					//			u&&v̉E_~[ZH
					n = 1;										//				̒l(1)Ԃ
					if (SkipSyl(pW) == EAJCTK_EOF) break;		//				XLbv
				}
				else {											//			ʏ̉ZH
					pW->FmlSclErr = AJCPPC_SCLERR_INVSYL;		//				G[
					PPC_ERR(pW->FmlSclErr, pW->pFmlCur->pFile, pW->pFmlCur->lno, pW->pFmlCur->pSyl);
				}
			}
			else {												//		V{ȊOH
				pW->FmlSclErr = AJCPPC_SCLERR_INVSYL;			//			G[
				PPC_ERR(pW->FmlSclErr, pW->pFmlCur->pFile, pW->pFmlCur->lno, pW->pFmlCur->pSyl);
			}
		}
	} while(0);
	return n;
}

/*--------------------------------------------------------------------------------------------------------------*/
/*	XLbvdnk`FbNidnkȂ΃G[j														*/
/*--------------------------------------------------------------------------------------------------------------*/
static	EAJCTKCODE	SkipSylAndChkEOL(HAJCPPC pW)
{
	EAJCTKCODE	rc;

	if ((rc = SkipSyl(pW)) == EAJCTK_EOF) {					//	XLbv̌͂dnkH
		pW->FmlSclErr = AJCPPC_SCLERR_EOL;					//	G[irŏIj
		PPC_ERR(pW->FmlSclErr, pW->pFmlCur->pFile, pW->pFmlCur->lno, 0);
	}
	return rc;
}
/*--------------------------------------------------------------------------------------------------------------*/
/*	XLbv																								*/
/*--------------------------------------------------------------------------------------------------------------*/
static	EAJCTKCODE	SkipSyl(HAJCPPC pW)
{
	EAJCTKCODE	rc;

	//	̌傪΁Ãm[hAhXݒ肵AYg[NR[hԂ
	if (pW->pFmlCur->pNxt != NULL) {
		pW->pFmlCur = pW->pFmlCur->pNxt;
		rc = (EAJCTKCODE)pW->pFmlCur->tkn;
	}
	//	̌傪ꍇA_~[̃g[Nm[hisj쐬AuEAJCTK_EOFvԂ
	else {
		memcpy(&pW->FmlEolNode, pW->pFmlCur, sizeof(AJCPPCTKNNODE));
		pW->FmlEolNode.pNxt = &pW->FmlEolNode;
		pW->FmlEolNode.tkn	= (UW)EAJCTK_EOF;
		pW->FmlEolNode.pSyl = "<EOL>";
		pW->pFmlCur = &pW->FmlEolNode;
		rc = EAJCTK_EOF;
	}
	return rc;
}
