//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	bvRpC	lrhkpT|[gR[h															//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
#include	"AjcInternal.h"
#include	"AjcPp.h"

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
__declspec(thread) static AJCPPCERROR	TlsErr;
__declspec(thread) static UX			TlsP1;
__declspec(thread) static UX			TlsP2;
__declspec(thread) static UX			TlsP3;


//--------------------------------------------------------------------------------------------------------------//
//																												//
//	oCg[hɕϊĕv[֊i[															//
//																												//
//--------------------------------------------------------------------------------------------------------------//
#define		WIDE(X)		ConvertToWideChar(pW, (UX)X)
//--------------------------------------------------------------------------------------------------------------//
static	C_WCP		ConvertToWideChar(HAJCPPC pW, UX prm)
{
	C_WCP	rc	 = L"";
	WCP		pTmp = NULL;
	BCP		pDat = (BCP)prm;

	if (pDat == NULL) {
		rc = AjcSplRegistW(pW->hSplMSIL, L"");
	}
	else {
		UI len;
		if (len = AjcByteCharToWideChar(pDat, NULL, 0)) {
			if (pTmp = (WCP)AJCMEM(len * 2)) {
				AjcByteCharToWideChar(pDat, pTmp, len);
				rc = AjcSplRegistW(pW->hSplMSIL, pTmp);
				free(pTmp);
			}
		}
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Cxgʒm																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO CALLBACK cbMyNtc(AJCPPCNOTIFY ntc, UX p1, UX p2, UX p3, UX cbp)
{
	HAJCPPC pW = (HAJCPPC)cbp;
	PAJCPPCTKNNODE pTkn;
	PAJCPPCMACINFO pMac;

	switch (ntc) {
		//	ꂩ̃Cxgʒm
		case AJCPPC_NTC_ANYEVT:
			if (pW->cbNtcAnyEvt != NULL) {
				if (p1 != AJCPPC_NTC_TOKEN) {	//	MSIL̏ꍇAAJCPPC_NTC_TOKEN͏O
					pW->cbNtcAnyEvt	(ntc);												//	ʒmR[hiCxgʁj
				}
			}
			break;

			//	ݏ̃t@CCsԍʒm
		case AJCPPC_NTC_FILE_LNO:
			if (pW->cbNtcFileLno != NULL) {
				pW->cbNtcFileLno	(WIDE(p1), (UI)p2, (UI)p3);							//	t@CCsԍClXg
			}
			break;

		//	CN[ht@CJnʒm
		case AJCPPC_NTC_SRH_START:
			AjcByteCharToWideChar((C_BCP)p1, pW->SvIncName, MAX_PATH);
			if (pW->cbNtcSrhStart != NULL) {
				pW->cbNtcSrhStart	(WIDE(p1), WIDE(p2));								//	hmbCJntH_pX
			}
			break;

		//	CN[ht@C̃tH_ʒm
		case AJCPPC_NTC_SRH_DIR:
			if (pW->cbNtcSrhDir != NULL) {
				pW->cbNtcSrhDir		(pW->SvIncName, WIDE(p1));							//	hmbCtH_pX
			}
			break;

		//	CN[ht@CIʒm
		case AJCPPC_NTC_SRH_END:
			if (pW->cbNtcSrhEnd != NULL) {
				pW->cbNtcSrhEnd		(WIDE(p1), (BOOL)p2);								//	hmbC
			}
			break;

		case AJCPPC_NTC_OPTSYM:
			if (pW->cbNtcOptSym != NULL) {
				pTkn = (PAJCPPCTKNNODE)p1;
				pW->cbNtcOptSym		(WIDE(pTkn->pFile), pTkn->lno, WIDE(pTkn->pSyl));	//	t@CpXCsԍCV{
			}
			break;

		//	}N`ʒm
		case AJCPPC_NTC_MACDEF:
			if (pW->cbNtcMacDef != NULL) {
				pTkn = (PAJCPPCTKNNODE)p1;
				pMac = (PAJCPPCMACINFO)p2;
				pW->cbNtcMacDef	(WIDE(pTkn->pFile), pTkn->lno, WIDE(pMac->pMacName));	//	t@CpXCsԍC}N
			}
			break;

		//	}NQƒʒm
		case AJCPPC_NTC_MACREF:
			if (pW->cbNtcMacRef != NULL) {
				pTkn = (PAJCPPCTKNNODE)p1;
				pMac = (PAJCPPCMACINFO)p2;
				pW->cbNtcMacRef	(WIDE(pTkn->pFile), pTkn->lno, WIDE(pMac->pMacName));	//	t@CpXCsԍC}N
			}
			break;

		//	t@Co͒ʒm
		case AJCPPC_NTC_OUTLOOP:
			if (pW->cbNtcOutput != NULL) {
				pW->cbNtcOutput	();
			}
			break;

		//	\[Xt@CGR[hʒm
		case AJCPPC_NTC_SRCTEC:
			if (pW->cbNtcSrcTec != NULL) {
				pW->cbNtcSrcTec(WIDE(p1), (EAJCTEC)p2, (BOOL)p3);
			}
			break;

		//	\[Xǂݏog[Nʒmigpj
		case AJCPPC_NTC_TOKEN:
		//	if (pW->cbNtcToken != NULL) {
		//		pW->cbNtcToken		((UI)p1, WIDE(p2));									//	g[NR[hCg[N
		//	}
			break;

	}
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	G[ʒm																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO CALLBACK cbMyErr(AJCPPCERROR  err, UX p1, UX p2, UX p3, UX cbp)
{
	HAJCPPC pW = (HAJCPPC)cbp;

	//	G[ޔ
	TlsErr = err;
	TlsP1  = p1;
	TlsP2  = p2;
	TlsP3  = p3;

	if (pW->cbNtcError != NULL) {
		pW->cbNtcError(err, WIDE(p1), (UI)p2, WIDE(p3));
	}
}

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	NULL : iCX^Xnhj															//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	HAJCPPC		WINAPI	AjcPpcCreateForMSIL(VO)
{
	HAJCPPC		pW = NULL;
	if (pW = AjcPpcCreate(NULL, NULL, NULL, 0, cbMyNtc, cbMyErr)) {
		pW->hSplMSIL = AjcSplCreateW(AJCSPL_CMP_NODISTINGUISH);
		pW->cbp 	 = (UX)pW;
	}
	return pW;
}

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW		  - CX^Xnh																//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcDeleteForMSIL(HAJCPPC pW)
{
	BOOL	rc = FALSE;
	if (IS_PP_INST(pW)) {
		if (pW->hSplMSIL != NULL) AjcSplDelete(pW->hSplMSIL);
		AjcPpcDelete(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	vvZXERpC																					//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pSrcPath	- \[XvOpX																//
//																												//
//	߂l	F	AJCPPCR_OK : nj																				//
//				AJCPPCR_OK : g[NP^G[														//
//==============================================================================================================//
AJCEXPORT	AJCPPCRESULT	WINAPI	AjcPpcCompileForMSIL(HAJCPPC pW, C_WCP pSrcPath)
{
	AJCPPCRESULT	rc;
	BC				SrcPath[MAX_PATH];

	AjcWideCharToByteChar(pSrcPath, SrcPath, MAX_PATH);
	rc = AjcPpcCompile(pW, SrcPath);
	return rc;
}
//==============================================================================================================//
//	g[NXg[̃t@Co																			//
//																												//
//	@	F	pOut	- o̓t@CpX																		//
//				fExpInc	- TRUE : CN[heWJ													//
//						  FALSE: #includê܂܎ciCN[he͓WJȂj					//
//				CommOutOfkndPP - Rgo͂vvZXw肷iAJCPPC_PPK_XXXXXj					//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcTokenStreamToFileForMSIL(HAJCPPC pW, C_WCP pOut, BOOL fExpInc, UI CommOutOfkndPP)
{
	BOOL	rc;
	BC		OutPath[MAX_PATH];

	AjcWideCharToByteChar(pOut, OutPath, MAX_PATH);
	rc = AjcPpcTokenStreamToFile(pW, OutPath, fExpInc, CommOutOfkndPP);
	return rc;

}
//==============================================================================================================//
//	x[XpXݒ																								//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pBasePath - x[XpXւ̃|C^																//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcSetBasePath(HAJCPPC pW, C_WCP pBasePath)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		if (pBasePath != NULL) {
			WideCharToMultiByte(CP_ACP, 0, pBasePath, -1, pW->BasePath, MAX_PATH, NULL, NULL);
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	CN[hpX Zbg																					//
//																												//
//	@	F	pW		  - CX^Xnh																//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcIncPathReset(HAJCPPC pW)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		//	CN[hpXQ
		if (pW->pIncArr != NULL) {
			PAJCLBXITEMA	p = pW->pIncArr;
			while (p->pStr != NULL) {
				free(p->pStr);
				p++;
			}
			free(pW->pIncArr);
			pW->pIncArr = NULL;
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	CN[hpX e[u																				//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				n		  - Gg																			//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcIncPathCreate(HAJCPPC pW, UI n)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		if (pW->pIncArr = AJCMEM(sizeof(AJCLBXITEMA) * (n + 1))) {
			memset(pW->pIncArr, 0, sizeof(AJCLBXITEMA) * (n + 1));
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	CN[hpX e[uGgݒ																		//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				ix		  - GgCfNX																	//
//				pIncPath  - CN[hpXւ̃|C^														//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcIncPathSet(HAJCPPC pW, UI ix, C_WCP pIncPath)
{
	BOOL	rc = FALSE;
	UI		len;

	if (IS_PP_INST(pW)) {
		if (pW->pIncArr != NULL) {
			if (pIncPath != NULL) {
				len = WideCharToMultiByte(CP_ACP, 0, pIncPath, -1, NULL, 0, NULL, NULL);
				if (len != 0 && (pW->pIncArr[ix].pStr = (BCP)AJCMEM(len))) {
					WideCharToMultiByte(CP_ACP, 0, pIncPath, -1, pW->pIncArr[ix].pStr, len, NULL, NULL);
					rc = TRUE;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	IvVV{ Zbg																					//
//																												//
//	@	F	pW		  - CX^Xnh																//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcOptSymReset(HAJCPPC pW)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		//	IvVV{Q
		if (pW->pOptArr != NULL) {
			PAJCLBXITEMA	p = pW->pOptArr;
			while (p->pStr != NULL) {
				free(p->pStr);
				p++;
			}
			free(pW->pOptArr);
			pW->pOptArr = NULL;
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	IvVV{ e[u																				//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				n		@- Gg																			//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcOptSymCreate(HAJCPPC pW, UI n)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		if (pW->pOptArr = AJCMEM(sizeof(AJCLBXITEMA) * (n + 1))) {
			memset(pW->pOptArr, 0, sizeof(AJCLBXITEMA) * (n + 1));
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	IvVV{ e[uGgݒ																		//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				ix		  - GgCfNX																	//
//				pOptSym  - IvVV{ւ̃|C^														//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcOptSymSet(HAJCPPC pW, UI ix, C_WCP pOptSym)
{
	BOOL	rc = FALSE;
	UI		len;

	if (IS_PP_INST(pW)) {
		if (pW->pOptArr != NULL) {
			if (pOptSym != NULL) {
				len = WideCharToMultiByte(CP_ACP, 0, pOptSym, -1, NULL, 0, NULL, NULL);
				if (len != 0 && (pW->pOptArr[ix].pStr = (BCP)AJCMEM(len))) {
					WideCharToMultiByte(CP_ACP, 0, pOptSym, -1, pW->pOptArr[ix].pStr, len, NULL, NULL);
					rc = TRUE;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	R[obNݒ																							//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				ix		  - GgCfNX																	//
//				pOptSym  - IvVV{ւ̃|C^														//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcAnyEvt	(HAJCPPC pW, VO (CALLBACK *cbNtcAnyEvt	)(AJCPPCNOTIFY ntc						 )) {pW->cbNtcAnyEvt   = cbNtcAnyEvt;  }
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcFileLno	(HAJCPPC pW, VO (CALLBACK *cbNtcFileLno	)(C_WCP pFileName, UI lno, UI nest		 )) {pW->cbNtcFileLno  = cbNtcFileLno; }
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcSrhStart	(HAJCPPC pW, VO (CALLBACK *cbNtcSrhStart)(C_WCP pIncName , C_WCP pSrhPath		 )) {pW->cbNtcSrhStart = cbNtcSrhStart;}
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcSrhDir	(HAJCPPC pW, VO (CALLBACK *cbNtcSrhDir	)(C_WCP pIncName , C_WCP pSrhDir		 )) {pW->cbNtcSrhDir   = cbNtcSrhDir;  }
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcSrhEnd	(HAJCPPC pW, VO (CALLBACK *cbNtcSrhEnd	)(C_WCP pIncName , BOOL  fFind			 )) {pW->cbNtcSrhEnd   = cbNtcSrhEnd;  }
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcOptSym	(HAJCPPC pW, VO (CALLBACK *cbNtcOptSym	)(C_WCP pFilePath, UI lno, C_WCP pSyl	 )) {pW->cbNtcOptSym   = cbNtcOptSym;  }
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcMacDef	(HAJCPPC pW, VO (CALLBACK *cbNtcMacDef	)(C_WCP pFilePath, UI lno, C_WCP pMac	 )) {pW->cbNtcMacDef   = cbNtcMacDef;  }
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcMacRef	(HAJCPPC pW, VO (CALLBACK *cbNtcMacRef	)(C_WCP pFilePath, UI lno, C_WCP pMac	 )) {pW->cbNtcMacRef   = cbNtcMacRef;  }
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcOutput	(HAJCPPC pW, VO (CALLBACK *cbNtcOutput	)(VO		 							 )) {pW->cbNtcOutput   = cbNtcOutput;  }
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcSrcTec	(HAJCPPC pW, VO (CALLBACK *cbNtcSrcTec	)(C_WCP pFilePath, EAJCTEC tec, BOOL fBOM)) {pW->cbNtcSrcTec   = cbNtcSrcTec;  }
AJCEXPORT	VO WINAPI	AjcPpcSetCbNtcError		(HAJCPPC pW, VO (CALLBACK *cbNtcError	)(AJCPPCERROR err, C_WCP p1, UI p2, C_WCP p3)){pW->cbNtcError  = cbNtcError;   }

//==============================================================================================================//
//	G[bZ[WeLXg擾																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	G[bZ[WeLXg																		//
//==============================================================================================================//
AJCEXPORT	VO	WINAPI	AjcPpcGetErrMsgTextForMSIL(WCP pBuf, UI lBuf)
{
	if (pBuf != NULL && lBuf > 0) {
		MultiByteToWideChar(CP_ACP, 0, AjcPpcGetErrMsgText(TlsErr, TlsP1, TlsP2, TlsP3), -1, pBuf, lBuf);
		pBuf[lBuf - 1] = 0;
	}
}

