#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	vZX																						//
//																												//
//**************************************************************************************************************//


#define	INST_ID			0x625DEABC
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)



//==============================================================================================================//
//	vZXɃmہiEChwj																		//
//																												//
//	@	F	hwnd		 - vZX̃EChnh														//
//				size		 - TCYioCgj															//
//																												//
//	߂l	F	NULL : CX^Xnh																	//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	HAJCPM	WINAPI	AjcPmCreateByWnd(HWND hwnd, UX size)
{
	HAJCPM	pW = NULL;

	if (pW = (HAJCPM)AJCMEM(sizeof(AJCPM))) {
		memset(pW, 0, sizeof(AJCPM));
		pW->InstID = INST_ID;
		pW->ThreadID = GetWindowThreadProcessId(hwnd, &pW->ProcessID);
		if(pW->ThreadID && pW->ProcessID) {
			if (pW->hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pW->ProcessID)) {
				pW->u.pVoid = VirtualAllocEx(pW->hProcess, NULL, size, MEM_COMMIT, PAGE_READWRITE);
				if (pW->u.pVoid == NULL) {
					FREE(pW); pW = NULL;
				}
			}
			else {FREE(pW); pW = NULL;}
		}
		else {FREE(pW); pW = NULL;}
	}
	return pW;
}
//==============================================================================================================//
//	vZXɃmہivZXhcwj																	//
//																												//
//	@	F	pid			 - vZXhc																		//
//				size		 - TCYioCgj															//
//																												//
//	߂l	F	NULL : CX^Xnh																	//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	HAJCPM	WINAPI	AjcPmCreateByPid(UL pid, UX size)
{
	HAJCPM	pW = NULL;

	if (pW = (HAJCPM)AJCMEM(sizeof(AJCPM))) {
		memset(pW, 0, sizeof(AJCPM));
		pW->InstID	  = INST_ID;
		pW->ProcessID = pid;
		if (pW->hProcess = OpenProcess(PROCESS_VM_READ | PROCESS_VM_WRITE, FALSE, pW->ProcessID)) {
			pW->u.pVoid = VirtualAllocEx(pW->hProcess, NULL, size, MEM_COMMIT, PAGE_READWRITE);
			if (pW->u.pVoid == NULL) {
				FREE(pW); pW = NULL;
			}
		}
		else {FREE(pW); pW = NULL;}
	}
	return pW;
}
//==============================================================================================================//
//	vZXɊmۂj																			//
//																												//
//	@	F	pW			 - CX^Xnh																//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcPmDelete(HAJCPM pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		VirtualFreeEx(pW->hProcess, pW->u.pVoid, 0, MEM_RELEASE);
		CloseHandle(pW->hProcess);
		free(pW);
		rc = TRUE;
	}
	return TRUE;
}

//==============================================================================================================//
//	vZXɊmۂ֏																		//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				loc		- ʒuioCgP[ViO`j												//
//				pSrc	- \[Xf[^̃AhX																//
//				len		- ރoCg																		//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//																												//
//	@l	F	uloc + lenvmۂTCYȉł邱													//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcPmWrite(HAJCPM pW, UX loc, C_VOP pSrc, UX len)
{
	BOOL	rc = FALSE;
	SIZE_T	bytes = -1;

	if (IS_MY_INST(pW)) {
		WriteProcessMemory(pW->hProcess, pW->u.pByte + loc, pSrc, len, &bytes);
		if (len == bytes) {
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	vZXɊmۂ̓ǂݏo																		//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				loc		- ʒuioCgP[ViO`j												//
//				pBuf	- ǂݏo0ci[obt@̃AhX											//
//				len		- ǂݏooCg																		//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//																												//
//	@l	F	uloc + lenvmۂTCYȉł邱												//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcPmRead(HAJCPM pW, UX loc, VOP pBuf, UX len)
{
	BOOL	rc = FALSE;
	SIZE_T	bytes = -1;

	if (IS_MY_INST(pW)) {
		ReadProcessMemory(pW->hProcess, pW->u.pByte + loc, pBuf, len, &bytes);
		if (len == bytes) {
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	vZX̃AhX擾																				//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				loc		- ʒuioCgP[ViO`j												//
//																												//
//	߂l	F	oCgP[ṼAhXiG[̏ꍇ͂OԂj									//
//==============================================================================================================//
AJCEXPORT	UX		WINAPI	AjcPmGetAddr(HAJCPM pW, UX loc)
{
	UX		rc = 0;

	if (IS_MY_INST(pW)) {
		rc = (UX)(pW->u.pByte + loc);
	}
	return rc;
}

//==============================================================================================================//
//	vZX̃EChփbZ[WM																		//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				hwnd	- MECh																		//
//				msg		- MbZ[WR[h																	//
//				lParam	- ǂݏof[^i[obt@̃AhX											//
//				wParam	- ǂݏooCg																		//
//																												//
//	߂l	F	bZ[W̖߂l																				//
//																												//
//	@l	F	uloc + lenvmۂTCYȉł邱												//
//==============================================================================================================//
static	VO	SubWriteParam(HAJCPM pW)
{
	//	vZXւ̃f[^݃f[^^ǂݏoobt@C[WRs[(wParam)
	if (pW->wp.flg != AJCPMRW_NONE) {
		AjcPmWrite(pW, pW->wp.loc, pW->wp.pMem, pW->wp.len);
	}

	//	vZXւ̃f[^݃f[^^ǂݏoobt@C[WRs[(lParam)
	if (pW->lp.flg != AJCPMRW_NONE) {
		AjcPmWrite(pW, pW->lp.loc, pW->lp.pMem, pW->lp.len);
	}
}
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubReadParam(HAJCPM pW)
{
	//	vZXf[^ǂݏo(wParam)
	if (pW->wp.flg == AJCPMRW_R) {
		AjcPmRead(pW, pW->wp.loc, pW->wp.pMem, pW->wp.len);
	}

	//	vZXf[^ǂݏo(lParam)
	if (pW->lp.flg == AJCPMRW_R) {
		AjcPmRead(pW, pW->lp.loc, pW->lp.pMem, pW->lp.len);
	}
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	LRESULT	WINAPI	AjcPmSendMessageA(HAJCPM pW, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT		rc = 999;

	//	vZX̃փf[^Rs[
	SubWriteParam(pW);

	//	bZ[WM
	rc = SendMessageA(hwnd, msg, wParam, lParam);

	//	vZX̃f[^Rs[
	SubReadParam(pW);

	//	f[^ǂݏNA[
	memset(&pW->wp, 0, sizeof pW->wp);
	memset(&pW->lp, 0, sizeof pW->lp);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	LRESULT	WINAPI	AjcPmSendMessageW(HAJCPM pW, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT		rc = 999;

	//	vZX̃փf[^Rs[
	SubWriteParam(pW);

	//	bZ[WM
	rc = SendMessageW(hwnd, msg, wParam, lParam);

	//	vZX̃f[^Rs[
	SubReadParam(pW);

	//	f[^ǂݏNA[
	memset(&pW->wp, 0, sizeof pW->wp);
	memset(&pW->lp, 0, sizeof pW->lp);

	return rc;
}
//==============================================================================================================//
//	vZX̃EChփbZ[W|Xg																	//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				hwnd	- MECh																		//
//				msg		- ʒuioCgP[ViO`j												//
//				lParam	- ǂݏo0ci[obt@̃AhX											//
//				wParam	- ǂݏooCg																		//
//																												//
//	߂l	F	bZ[W̖߂l																				//
//																												//
//	@l	F	uloc + lenvmۂTCYȉł邱												//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	LRESULT	WINAPI	AjcPmPostMessageA(HAJCPM pW, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT		rc = 0;

	//	vZX̃փf[^Rs[
	SubWriteParam(pW);

	//	bZ[W |Xg
	rc = PostMessageA(hwnd, msg, wParam, lParam);

	//	f[^ǂݏNA[
	memset(&pW->wp, 0, sizeof pW->wp);
	memset(&pW->lp, 0, sizeof pW->lp);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	LRESULT	WINAPI	AjcPmPostMessageW(HAJCPM pW, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT		rc = 0;

	//	vZX̃փf[^Rs[
	SubWriteParam(pW);

	//	bZ[W |Xg
	rc = PostMessageW(hwnd, msg, wParam, lParam);

	//	f[^ǂݏNA[
	memset(&pW->wp, 0, sizeof pW->wp);
	memset(&pW->lp, 0, sizeof pW->lp);

	return rc;
}
//==============================================================================================================//
//	wParam ݐݒ																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				len		- oCg																				//
//				pMem	- f[^AhX																		//
//																												//
//	߂l	F	vZX̃P[V																//
//																												//
//	@l	F	uloc + lenvmۂTCYȉł邱												//
//==============================================================================================================//
AJCEXPORT	WPARAM	WINAPI	AjcPmSetWpForWrite(HAJCPM pW, UX len, VOP pMem)
{
	pW->wp.flg	= AJCPMRW_W;
	pW->wp.loc	= 0;
	pW->wp.len	= len;
	pW->wp.pMem = pMem;

	return (WPARAM)( pW->u.pByte + pW->wp.loc);
}

//==============================================================================================================//
//	lParam ݐݒ																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				len		- oCg																				//
//				pMem	- f[^AhX																		//
//																												//
//	߂l	F	vZX̃P[V																//
//																												//
//	@l	F	uloc + lenvmۂTCYȉł邱													//
//==============================================================================================================//
AJCEXPORT	LPARAM	WINAPI	AjcPmSetLpForWrite(HAJCPM pW, UX len, VOP pMem)
{
	pW->lp.flg	= AJCPMRW_W;
	pW->lp.loc	= (pW->wp.flg != AJCPMRW_NONE) ? pW->wp.len : 0;
	pW->lp.len	= len;
	pW->lp.pMem = pMem;

	return (LPARAM)(pW->u.pByte + pW->lp.loc);
}
//==============================================================================================================//
//	wParam ǂݏoݒ																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				len		- oCg																				//
//				pMem	- obt@AhX																		//
//																												//
//	߂l	F	vZX̃P[V																//
//																												//
//	@l	F	uloc + lenvmۂTCYȉł邱													//
//==============================================================================================================//
AJCEXPORT	WPARAM	WINAPI	AjcPmSetWpForRead(HAJCPM pW, UX len, VOP pMem)
{
	pW->wp.flg	= AJCPMRW_R;
	pW->wp.loc	= 0;
	pW->wp.len	= len;
	pW->wp.pMem = pMem;

	return (WPARAM)(pW->u.pByte + pW->wp.loc);
}

//==============================================================================================================//
//	lParam ǂݏoݒ																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				len		- oCg																				//
//				pMem	- obt@AhX																		//
//																												//
//	߂l	F	vZX̃P[V																//
//																												//
//	@l	F	uloc + lenvmۂTCYȉł邱													//
//==============================================================================================================//
AJCEXPORT	LPARAM	WINAPI	AjcPmSetLpForRead(HAJCPM pW, UX len, VOP pMem)
{
	pW->lp.flg	= AJCPMRW_R;
	pW->lp.loc	= (pW->wp.flg != AJCPMRW_NONE) ? pW->wp.len : 0;
	pW->lp.len	= len;
	pW->lp.pMem = pMem;

	return (LPARAM)(pW->u.pByte + pW->lp.loc);
}


