#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	ϒL[i`Xgj																					//
//																												//
//**************************************************************************************************************//


#define	INST_ID			0x816CD9AF
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)


//==============================================================================================================//
//	`Xgiϒf[^j																				//
//==============================================================================================================//
//--------------------------------------------------------------------------------------------------------------//
//	}N																									//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCVQUE_ENTER		if (pW->fMultiThread) EnterCriticalSection(&pW->cs);
#define		AJCVQUE_LEAVE		if (pW->fMultiThread) LeaveCriticalSection(&pW->cs);


//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	cbp 	 - R[obNp^																	//
//				cbRemove - m[hʒmpR[obNisv͂mtkkj										//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
AJCEXPORT HAJCVQUE	WINAPI	AjcVQueCreate(UX cbp, VO (CALLBACK *cbRemove)(VOP pDat, UI len, UX cbp))
{
	HAJCVQUE  pW;

	if ((pW = (HAJCVQUE)AJCMEM(sizeof(AJCVQUE))) != NULL) {
		memset(pW, 0, sizeof *pW);
		pW->InstID	= INST_ID;
		pW->pTop	= NULL;
		pW->pLas	= NULL;
		pW->num		= 0;
		pW->cbp 	= cbp;
		pW->cbRemove= cbRemove;
	}
	return pW;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI	AjcVQueDelete(HAJCVQUE pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AjcVQuePurge(pW);
		if (pW->fMultiThread) {
			DeleteCriticalSection(&pW->cs);
		}
		free(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	}`Xbh̋^֎~																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				fEnable - FALSE : }`Xbh֎~															//
//						  TRUE	: }`Xbh															//
//																												//
//	߂l	F	Ő^֎~																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVQueEnableMultiThread(HAJCVQUE pW, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		rc = pW->fMultiThread;
		if (fEnable) {
			if (!pW->fMultiThread) {
				InitializeCriticalSection(&pW->cs);
				pW->fMultiThread = TRUE;
			}
		}
		else {
			if (pW->fMultiThread) {
				pW->fMultiThread = FALSE;
				DeleteCriticalSection(&pW->cs);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	փm[hǉ																							//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - ֑}m[hf[^̃AhX														//
//				len  - ֑}m[hf[^̃oCg														//
//																												//
//	߂l	F	TRUE  / NULL - ǉm[h̃AhX														//
//				FALSE / NULL - G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVQueEnque	(HAJCVQUE pW, C_VOP pDat, UI len)
{
	return (AjcVQueEnqueEx(pW, pDat, len) != NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	VOP		WINAPI	AjcVQueEnqueEx	(HAJCVQUE pW, C_VOP pDat, UI len)
{
	VOP		rc = FALSE;
	PAJCVQNODE	pNew;

	if (IS_MY_INST(pW) && pDat != NULL) {
		AJCVQUE_ENTER
		if ((pNew = (PAJCVQNODE)AJCMEM(sizeof(AJCVQNODE) + len)) != NULL) {	//	ubN蓖āCH
			pNew->pNxt = 0;													//		Vakj
			pNew->len = len;												//		E
			memcpy(pNew + 1, pDat, len);									//		E
			if (pW->pLas == NULL) {											//		L[COH
				pW->pTop = pW->pLas = pNew;									//			VakjL[CO
			}
			else {															//		ǉL[COH
				pW->pLas->pNxt = pNew;										//			Vakj𖖔փL[CO
				pW->pLas	   = pNew;										//			E
			}
			pW->num++;														//		m[hXV
			rc = pNew + 1;													//		߂lnj
		}
		else {																//	ubN蓖āCsH
			rc = NULL;														//		߂lG[
		}
		AJCVQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	擪փm[h}																							//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - 擪֑}m[hf[^̃AhX														//
//				len  - 擪֑}m[hf[^̃oCg														//
//																												//
//	߂l	F	NULL - ǉm[h̃AhX																//
//				NULL - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVQueEnqTop	(HAJCVQUE pW, C_VOP pDat, UI len)
{
	return (AjcVQueEnqTopEx(pW, pDat, len) != NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	VOP		WINAPI	AjcVQueEnqTopEx	(HAJCVQUE pW, C_VOP pDat, UI len)
{
	VOP			rc = NULL;
	PAJCVQNODE	pNew;

	if (IS_MY_INST(pW) && pDat != NULL) {
		AJCVQUE_ENTER
		if ((pNew = (PAJCVQNODE)AJCMEM(sizeof(AJCVQNODE) + len)) != NULL) {	//	ubN蓖āCH
			pNew->len	= len;												//		E
			memcpy(pNew + 1, pDat, len);									//		E
			if (pW->pTop == NULL) {											//		L[COH
				pNew->pNxt = NULL;											//			VakjL[CO
				pW->pTop = pW->pLas = pNew;									//			E
			}
			else {															//		ǉL[COH
				pNew->pNxt = pW->pTop;										//			Vakj擪փL[CO
				pW->pTop   = pNew;											//			E
			}
			pW->num++;														//		m[hXV
			rc = pNew + 1;													//		߂lnj
		}
		else {																//	ubN蓖āCsH
			rc = NULL;														//		߂lG[
		}
		AJCVQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	擪m[ho																						//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pBuf - om[h̃f[^i[obt@̃AhXisv͂mtkkj					//
//				bfl  - om[h̃f[^i[obt@̗e(oCgj								//
//																												//
//	߂l	F	OFom[hf[^̃oCg															//
//				OFm[hȂ																				//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcVQueDeque	(HAJCVQUE pW, VOP pBuf, UI bfl)
{
	UI			rc = 0;
	PAJCVQNODE	pCur;

	if (IS_MY_INST(pW)) {
		AJCVQUE_ENTER
		if ((pCur = pW->pTop) != NULL) {										//	m[hH
			if ((pW->pTop = pCur->pNxt) == NULL) {								//		擪ĎOC̴ĂȂH
				pW->pLas = NULL;												//			Xg|C^mtkk
			}
			if (pBuf != NULL) memcpy(pBuf, (pCur + 1), __min(bfl, pCur->len));	//		obt@փm[hf[^Rs[
			rc = pCur->len;														//		߂lm[hf[^TCY
			free(pCur);															//		Om[hJ
			pW->num--;															//		m[hZ
		}
		else {																	//	m[hȂH
			rc = 0;																//		߂lm[hȂ
		}
		AJCVQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	擪m[hoiVj																					//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pBuf - om[h̃f[^i[obt@̃AhXisv͂mtkkj					//
//				bfl  - om[h̃f[^i[obt@̗e(oCgj								//
//																												//
//	߂l	F	OFom[hf[^̃oCg															//
//				-1Fm[hȂ^G[																		//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcVQueDequeEx	(HAJCVQUE pW, VOP pBuf, UI bfl)
{
	UI			rc = -1;
	PAJCVQNODE	pCur;

	if (IS_MY_INST(pW)) {
		AJCVQUE_ENTER
		if ((pCur = pW->pTop) != NULL) {										//	m[hH
			if ((pW->pTop = pCur->pNxt) == NULL) {								//		擪ĎOC̴ĂȂH
				pW->pLas = NULL;												//			Xg|C^mtkk
			}
			if (pBuf != NULL) memcpy(pBuf, (pCur + 1), __min(bfl, pCur->len));	//		obt@փm[hf[^Rs[
			rc = pCur->len;														//		߂lm[hf[^TCY
			free(pCur);															//		Om[hJ
			pW->num--;															//		m[hZ
		}
		else {																	//	m[hȂH
			rc = -1;															//		߂lm[hȂ
		}
		AJCVQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[h																							//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL	  WINAPI	AjcVQuePurge(HAJCVQUE pW)
{
	BOOL		rc = FALSE;
	PAJCVQNODE	pCur, svp;

	if (IS_MY_INST(pW)) {
		AJCVQUE_ENTER
		pCur = pW->pTop;									//	擪akjAhXݒ
		while (pCur) {										//	Sakj[v
			if (pW->cbRemove) {								//		ʒmR[obNH
				pW->cbRemove(pCur + 1, pCur->len, pW->cbp);	//			R[obN
			}
			svp = pCur;										//		akjAhXޔ
			pCur = pCur->pNxt;								//		̂akjAhXݒ
			free(svp);										//		akjJ
		}
		pW->pTop = pW->pLas = NULL;							//	L[`FC|C^
		pW->num = 0;										//	m[hO
		AJCVQUE_LEAVE
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	݂̃m[h𓾂																						//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//																												//
//	߂l	F	݂̃m[h																					//
//==============================================================================================================//
AJCEXPORT	UI	  WINAPI	AjcVQueGetCount	(HAJCVQUE pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AJCVQUE_ENTER
		rc = pW->num;
		AJCVQUE_LEAVE
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI	  WINAPI	AjcVQueNumber	(HAJCVQUE pW)
{
	return AjcVQueGetCount(pW);
}

//==============================================================================================================//
//	Q̂krs\A																					//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pSrc - Akrs̃nhîkrs͋ɂȂ܂j										//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcVQueMerge	(HAJCVQUE pW, HAJCVQUE pSrc)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && IS_MY_INST(pSrc)) {
		AJCVQUE_ENTER
		if (pSrc->fMultiThread) EnterCriticalSection(&pSrc->cs);
		if (pW->pLas == 0) {				//	AɃm[hȂH
			pW->pTop = pSrc->pTop;			//		A`FCAAփRs[
			pW->pLas = pSrc->pLas;			//		E
			pW->num  = pSrc->num;			//		E
		}
		else if (pSrc->num) {				//	AɃm[h & Am[hH
			pW->pLas->pNxt = pSrc->pTop;	//		A`FCAA̖֒ǉ
			pW->pLas	   = pSrc->pLas;	//		E
			pW->num += pSrc->num;			//		E
		}
		pSrc->pTop = NULL;					//	A`FCZbg
		pSrc->pLas = NULL;					//	E
		pSrc->num  = 0;						//	E
		if (pSrc->fMultiThread) LeaveCriticalSection(&pSrc->cs);
		AJCVQUE_LEAVE
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	擪m[hf[^̃AhX𓾂																			//
//																												//
//	@	F	pW 	   - CX^Xnh																	//
//				pBytes - 擪m[hf[^̃oCgi[obt@̃AhX									//
//																												//
//	߂l	F	mtkkF擪m[hf[^̃AhX															//
//				mtkkFm[hȂ																			//
//==============================================================================================================//
AJCEXPORT	VOP   WINAPI	AjcVQueTopNode	(HAJCVQUE pW, UIP pBytes)
{
	VOP		rc = NULL;

	if (IS_MY_INST(pW)) {
		AJCVQUE_ENTER
		if (pW->pTop != NULL) {								//	擪m[hH
			if (pBytes != NULL) *pBytes = pW->pTop->len;	//		f[^oCgݒ
			rc = pW->pTop + 1;								//		߂l擪m[h̃f[^AhX
		}
		AJCVQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	̃m[hf[^̃AhX𓾂																			//
//																												//
//	@	F	pW 			 - CX^Xnh																//
//				pCurrentNode - ݂̃m[hf[^AhX														//
//				pBytes		 - m[hf[^̃oCgi[obt@̃AhX								//
//																												//
//	߂l	F	mtkkF̃m[hf[^̃AhX															//
//				mtkkFm[hȂ																			//
//==============================================================================================================//
AJCEXPORT	VOP   WINAPI	AjcVQueNextNode	(HAJCVQUE pW, C_VOP pCurrentNode, UIP pBytes)
{
	VOP			rc = NULL;
	PAJCVQNODE	pNode;

	if (IS_MY_INST(pW)) {
		AJCVQUE_ENTER
		if (pCurrentNode) {									//	m[hH
			pNode = (PAJCVQNODE)pCurrentNode;				//		m[h̃m[h擪AhXݒ
			pNode--;										//		E
			if (pNode = pNode->pNxt) {						//		m[hH
				if (pBytes != NULL) *pBytes = pNode->len;	//			f[^oCgݒ
				rc = pNode + 1;								//			߂lm[h̃f[^AhX
			}
		}
		AJCVQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z񐶐																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pNum		- zvfi[obt@̃AhX											//
//																												//
//	߂l	F	NULL : Sm[hւ̃|C^z̐擪AhX													//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	PCAJCVQUEPTR  WINAPI AjcVQueCreatePtrArr(HAJCVQUE pW, UIP pNum)
{
	PCAJCVQUEPTR rc    = NULL;
	PAJCVQUEPTR  pArr  = NULL;
	VOP		 	 pNode = NULL;
	UI		 	 ix    = 0;
	UI			 len;

	if (IS_MY_INST(pW)) {
		AJCVQUE_ENTER
		if (pArr  =  (PAJCVQUEPTR)AJCMEM(sizeof(AJCVQUEPTR) * (pW->num + 1))) {
			memset(pArr, 0, sizeof(AJCVQUEPTR) * (pW->num + 1));
			if (pNode = AjcVQueTopNode(pW, &len)) {
				do {
					pArr[ix].pNode = pNode;
					pArr[ix].len   = len;
					ix++;
				} while (pNode = AjcVQueNextNode(pW, pNode, &len));
			}
			if (pNum != NULL) *pNum = ix;
			rc = pArr;
		}
		AJCVQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z																				//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				pArr		 - Sm[hւ̃|C^z̐擪AhX											//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO	 			WINAPI AjcVQueReleasePtrArr(HAJCVQUE pW, PCAJCVQUEPTR pArr)
{
	if (IS_MY_INST(pW)) {
		AJCVQUE_ENTER
		if (pArr != NULL) free((VOP)pArr);
		AJCVQUE_LEAVE
	}
}

