#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	ϒL[ioXgj																				//
//																												//
//**************************************************************************************************************//


#define	INST_ID			0x7264198A
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)


//--------------------------------------------------------------------------------------------------------------//
//	}N																									//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCXQUE_ENTER		if (pW->fMultiThread) EnterCriticalSection(&pW->cs);
#define		AJCXQUE_LEAVE		if (pW->fMultiThread) LeaveCriticalSection(&pW->cs);


//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	cbp 	 - R[obNp^																	//
//				cbRemove - m[hʒmpR[obNisv͂mtkkj										//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
AJCEXPORT HAJCXQUE	WINAPI	AjcXQueCreate(UX cbp, VO (CALLBACK *cbRemove)(VOP pDat, UI len, UX cbp))
{
	HAJCXQUE  pW;

	if ((pW = (HAJCXQUE)AJCMEM(sizeof(AJCXQUE))) != NULL) {
		memset(pW, 0, sizeof *pW);
		pW->InstID	= INST_ID;
		pW->pTop	= NULL;
		pW->pLas	= NULL;
		pW->num		= 0;
		pW->cbp 	= cbp;
		pW->cbRemove= cbRemove;
	}
	return pW;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI	AjcXQueDelete(HAJCXQUE pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AjcXQuePurge(pW);
		if (pW->fMultiThread) {
			DeleteCriticalSection(&pW->cs);
		}
		free(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	}`Xbh̋^֎~																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				fEnable - FALSE : }`Xbh֎~															//
//						  TRUE	: }`Xbh															//
//																												//
//	߂l	F	Ő^֎~																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcXQueEnableMultiThread(HAJCXQUE pW, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		rc = pW->fMultiThread;
		if (fEnable) {
			if (!pW->fMultiThread) {
				InitializeCriticalSection(&pW->cs);
				pW->fMultiThread = TRUE;
			}
		}
		else {
			if (pW->fMultiThread) {
				pW->fMultiThread = FALSE;
				DeleteCriticalSection(&pW->cs);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	փm[hǉ																							//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - ֑}m[hf[^̃AhX														//
//				len  - ֑}m[hf[^̃oCg														//
//																												//
//	߂l	F	NULL - ǉm[h̃AhX																//
//				NULL - G[																					//
//==============================================================================================================//
AJCEXPORT	VOP		WINAPI	AjcXQueEnque	(HAJCXQUE pW, C_VOP pDat, UI len)
{
	VOP		rc = FALSE;
	PAJCXQNODE	pNew;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		if ((pNew = (PAJCXQNODE)AJCMEM(sizeof(AJCXQNODE) + len)) != NULL) {	//	ubN蓖āCH
			pNew->id   = AJCXQUEID;											//		m[hhc
			pNew->len  = len;												//		f[^
			if (pDat != NULL) memcpy(pNew + 1, pDat, len);					//		f[^
			else              memset(pNew + 1, 0   , len);					//		E
			if (pW->pLas == NULL) {											//		L[COH
				pNew->pBfr = NULL;											//			VakjL[CO
				pNew->pNxt = NULL;											//			E
				pW->pTop = pW->pLas = pNew;									//			E
			}
			else {															//		ǉL[COH
				pNew->pBfr     = pW->pLas;									//			Vakj𖖔փL[CO
				pNew->pNxt     = NULL;										//			E
				pW->pLas->pNxt = pNew;										//			E
				pW->pLas	   = pNew;										//			E
			}
			pW->num++;														//		m[hXV
			rc = pNew + 1;													//		߂lnj
		}
		else {																//	ubN蓖āCsH
			rc = NULL;														//		߂lG[
		}
		AJCXQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	擪փm[h}																							//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - 擪֑}m[hf[^̃AhX														//
//				len  - 擪֑}m[hf[^̃oCg														//
//																												//
//	߂l	F	NULL - ǉm[h̃AhX																//
//				NULL - G[																					//
//==============================================================================================================//
AJCEXPORT	VOP	WINAPI	AjcXQueEnqTop	(HAJCXQUE pW, C_VOP pDat, UI len)
{
	VOP			rc = NULL;
	PAJCXQNODE	pNew;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		if ((pNew = (PAJCXQNODE)AJCMEM(sizeof(AJCXQNODE) + len)) != NULL) {	//	ubN蓖āCH
			pNew->id  = AJCXQUEID;											//		m[hhc
			pNew->len = len;												//		f[^
			if (pDat != NULL) memcpy(pNew + 1, pDat, len);					//		f[^
			else              memset(pNew + 1, 0   , len);					//		E
			if (pW->pTop == NULL) {											//		L[COH
				pNew->pBfr     = NULL;										//			VakjL[CO
				pNew->pNxt     = NULL;										//			E
				pW->pTop       = pW->pLas = pNew;							//			E
			}
			else {															//		ǉL[COH
				pNew->pBfr     = NULL;										//			Vakj擪փL[CO
				pNew->pNxt     = pW->pTop;									//			E
				pW->pTop->pBfr = pNew;										//			E
				pW->pTop       = pNew;										//			E
			}
			pW->num++;														//		m[hXV
			rc = pNew + 1;													//		߂lnj
		}
		else {																//	ubN蓖āCsH
			rc = NULL;														//		߂lG[
		}
		AJCXQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	wm[h̒Oփm[h}																				//
//																												//
//	@	F	pW 	    - CX^Xnh																	//
//				pDat    - 擪֑}m[hf[^̃AhX													//
//				len     - 擪֑}m[hf[^̃oCg													//
//				pInsPtr - }ʒum[h̃m[hf[^AhXiNULLF֑}j								//
//																												//
//	߂l	F	NULL - ǉm[h̃AhX																//
//				NULL - G[																					//
//==============================================================================================================//
AJCEXPORT	VOP	WINAPI	AjcXQueInsert	(HAJCXQUE pW, C_VOP pDat, UI len, C_VOP pInsPtr)
{
	VOP			rc = NULL;
	PAJCXQNODE	pNew;
	PAJCXQNODE	pIns;

	if (IS_MY_INST(pW)) {
		//	֑}
		if (pInsPtr == NULL) {
			rc = AjcXQueEnque(pW, pDat, len);
		}
		//	wm[h̒Oɑ}
		else {
			pIns = ((PAJCXQNODE)pInsPtr) - 1;
			if (pIns->id == AJCXQUEID) {
				AJCXQUE_ENTER
				if ((pNew = (PAJCXQNODE)AJCMEM(sizeof(AJCXQNODE) + len)) != NULL) {	//	ubN蓖āCH
					pNew->id  = AJCXQUEID;											//		m[hhc
					pNew->len = len;												//		f[^
					if (pDat != NULL) memcpy(pNew + 1, pDat, len);					//		f[^
					else              memset(pNew + 1, 0   , len);					//		E
					if      (pIns->pBfr == NULL) {									//		}|Cg͐擪m[hH
						rc = AjcXQueEnqTop(pW, pDat, len);							//			m[h擪֑}
					}
					else {															//		}|Cg͐擪m[hȊOH
						pNew->pBfr       = pIns->pBfr;								//			VakjA
						pNew->pNxt       = pIns;									//			E
						pNew->pBfr->pNxt = pNew;									//			E
						pNew->pNxt->pBfr = pNew;									//			E
						pW->num++;													//			m[hXV
						rc = pNew + 1;												//			߂lnj
					}
				}
				else {																//	ubN蓖āCsH
					rc = NULL;														//		߂lG[
				}
				AJCXQUE_LEAVE
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	wm[h폜																							//
//																												//
//	@	F	pW 	    - CX^Xnh																	//
//				pDelPtr - 폜m[h̃f[^AhX														//
//																												//
//	߂l	F	-1Fom[hf[^̃oCg															//
//				-1Fm[hȂ^G[																		//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcXQueRemove	(HAJCXQUE pW, C_VOP pDelPtr)
{
	UI			rc = -1;
	PAJCXQNODE	pDel;

	if (IS_MY_INST(pW) && pDelPtr != NULL) {
		AJCXQUE_ENTER
		pDel = ((PAJCXQNODE)pDelPtr) - 1;
		if (pW->pTop != NULL && pDel->id == AJCXQUEID) {						//	m[hH
			//	|C^ύX
			if (pDel->pBfr) {
				pDel->pBfr->pNxt = pDel->pNxt;
			}
			else {
				pW->pTop = pDel->pNxt;
			}
			//	O|C^ύX
			if (pDel->pNxt) {
				pDel->pNxt->pBfr = pDel->pBfr;
			}
			else {
				pW->pLas = pDel->pBfr;
			}
			//	m[hhciR[obÑm[hd폜h~j
			pDel->id = 0x12345678;
			//	ʒmR[obN
			if (pW->cbRemove) {
				pW->cbRemove(pDel + 1, pDel->len, pW->cbp);
			}
			//	m[hJ
			free(pDel);															//		Om[hJ
			//	m[hZ
			pW->num--;															//		
		}
		else {																	//	m[hȂH
			rc = -1;															//		߂lm[hȂ
		}
		AJCXQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[h																							//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL	  WINAPI	AjcXQuePurge(HAJCXQUE pW)
{
	BOOL		rc = FALSE;
	PAJCXQNODE	pCur, svp;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		pCur = pW->pTop;									//	擪akjAhXݒ
		while (pCur) {										//	Sakj[v
			pCur->id = 0x12345678;							//		m[hhc
			if (pW->cbRemove) {								//		ʒmR[obNH
				pW->cbRemove(pCur + 1, pCur->len, pW->cbp);	//			R[obN
			}
			svp = pCur;										//		akjAhXޔ
			pCur = pCur->pNxt;								//		̂akjAhXݒ
			free(svp);										//		akjJ
		}
		pW->pTop = pW->pLas = NULL;							//	L[`FC|C^
		pW->num = 0;										//	m[hO
		AJCXQUE_LEAVE
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	擪m[ho																						//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pBuf - om[h̃f[^i[obt@̃AhXisv͂mtkkj					//
//				bfl  - om[h̃f[^i[obt@̗e(oCgj								//
//																												//
//	߂l	F	-1Fom[hf[^̃oCg															//
//				-1Fm[hȂ^G[																		//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcXQueDeque	(HAJCXQUE pW, VOP pBuf, UI bfl)
{
	UI			rc = -1;
	PAJCXQNODE	pCur;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		if ((pCur = pW->pTop) != NULL) {										//	m[hH
			if ((pW->pTop = pCur->pNxt) == NULL) {								//		擪m[hOC̃m[hȂH
				pW->pLas = NULL;												//			Xg|C^mtkk
			}
			else {																//		̃m[hH
				pCur->pNxt->pBfr = NULL;										//			V擪m[h̃obN|C^
			}
			if (pBuf != NULL) memcpy(pBuf, (pCur + 1), __min(bfl, pCur->len));	//		obt@փm[hf[^Rs[
			rc = pCur->len;														//		߂lm[hf[^TCY
			free(pCur);															//		Om[hJ
			pW->num--;															//		m[hZ
		}
		else {																	//	m[hȂH
			rc = -1;															//		߂lm[hȂ
		}
		AJCXQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	݂̃m[h𓾂																						//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//																												//
//	߂l	F	݂̃m[h																					//
//==============================================================================================================//
AJCEXPORT	UI	  WINAPI	AjcXQueGetCount	(HAJCXQUE pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		rc = pW->num;
		AJCXQUE_LEAVE
	}
	return rc;
}

//==============================================================================================================//
//	Q̂krs\A																					//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pSrc - Akrs̃nhîkrs͋ɂȂ܂j										//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcXQueMerge	(HAJCXQUE pW, HAJCXQUE pSrc)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && IS_MY_INST(pSrc)) {
		AJCXQUE_ENTER
		if (pSrc->fMultiThread) EnterCriticalSection(&pSrc->cs);
		if (pW->pLas == 0) {				//	AɃm[hȂH
			pW->pTop = pSrc->pTop;			//		A`FCAAփRs[
			pW->pLas = pSrc->pLas;			//		E
			pW->num  = pSrc->num;			//		E
		}
		else if (pSrc->num) {				//	AɃm[h & Am[hH
			pW->pLas->pNxt   = pSrc->pTop;	//		A`FCAA̖֒ǉ
			pW->pLas	     = pSrc->pLas;	//		E
			pSrc->pTop->pBfr = pW->pLas;	//		E
			pW->num += pSrc->num;			//		E
		}
		pSrc->pTop = NULL;					//	A`FCZbg
		pSrc->pLas = NULL;					//	E
		pSrc->num  = 0;						//	E
		if (pSrc->fMultiThread) LeaveCriticalSection(&pSrc->cs);
		AJCXQUE_LEAVE
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	擪m[hf[^̃AhX𓾂																			//
//																												//
//	@	F	pW 	   - CX^Xnh																	//
//				pBytes - 擪m[hf[^̃oCgi[obt@̃AhX									//
//																												//
//	߂l	F	mtkkF擪m[hf[^̃AhX															//
//				mtkkFm[hȂ																			//
//==============================================================================================================//
AJCEXPORT	VOP   WINAPI	AjcXQueTopNode	(HAJCXQUE pW, UIP pBytes)
{
	VOP		rc = NULL;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		if (pW->pTop != NULL) {								//	擪m[hH
			if (pBytes != NULL) *pBytes = pW->pTop->len;	//		f[^oCgݒ
			rc = pW->pTop + 1;								//		߂l擪m[h̃f[^AhX
		}
		AJCXQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[hf[^̃AhX𓾂																			//
//																												//
//	@	F	pW 	   - CX^Xnh																	//
//				pBytes - m[hf[^̃oCgi[obt@̃AhX									//
//																												//
//	߂l	F	mtkkFm[hf[^̃AhX															//
//				mtkkFm[hȂ																			//
//==============================================================================================================//
AJCEXPORT	VOP   WINAPI	AjcXQueLastNode	(HAJCXQUE pW, UIP pBytes)
{
	VOP		rc = NULL;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		if (pW->pTop != NULL) {								//	擪m[hH
			if (pBytes != NULL) *pBytes = pW->pLas->len;	//		f[^oCgݒ
			rc = pW->pLas + 1;								//		߂l擪m[h̃f[^AhX
		}
		AJCXQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	̃m[hf[^̃AhX𓾂																			//
//																												//
//	@	F	pW 			 - CX^Xnh																//
//				pCurrentNode - ݂̃m[hf[^AhX														//
//				pBytes		 - m[hf[^̃oCgi[obt@̃AhX								//
//																												//
//	߂l	F	mtkkF̃m[hf[^̃AhX															//
//				mtkkFm[hȂ																			//
//==============================================================================================================//
AJCEXPORT	VOP   WINAPI	AjcXQueNextNode	(HAJCXQUE pW, C_VOP pCurrentNode, UIP pBytes)
{
	VOP			rc = NULL;
	PAJCXQNODE	pNode;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		if (pCurrentNode) {									//	m[hH
			pNode = (PAJCXQNODE)pCurrentNode;				//		m[h̃m[h擪AhXݒ
			pNode--;										//		E
			if (pNode = pNode->pNxt) {						//		m[hH
				if (pBytes != NULL) *pBytes = pNode->len;	//			f[^oCgݒ
				rc = pNode + 1;								//			߂lm[h̃f[^AhX
			}
		}
		AJCXQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Õm[hf[^̃AhX𓾂																			//
//																												//
//	@	F	pW 			 - CX^Xnh																//
//				pCurrentNode - ݂̃m[hf[^AhX														//
//				pBytes		 - m[hf[^̃oCgi[obt@̃AhX								//
//																												//
//	߂l	F	mtkkFÕm[hf[^̃AhX														//
//				mtkkFm[hȂ																			//
//==============================================================================================================//
AJCEXPORT	VOP   WINAPI	AjcXQuePrevNode	(HAJCXQUE pW, C_VOP pCurrentNode, UIP pBytes)
{
	VOP			rc = NULL;
	PAJCXQNODE	pNode;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		if (pCurrentNode) {									//	m[hH
			pNode = (PAJCXQNODE)pCurrentNode;				//		m[h̃m[h擪AhXݒ
			pNode--;										//		E
			if (pNode = pNode->pBfr) {						//		m[hH
				if (pBytes != NULL) *pBytes = pNode->len;	//			f[^oCgݒ
				rc = pNode + 1;								//			߂lm[h̃f[^AhX
			}
		}
		AJCXQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z񐶐																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pNum		- zvfi[obt@̃AhX											//
//																												//
//	߂l	F	NULL : Sm[hւ̃|C^z̐擪AhX													//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	PCAJCXQUEPTR  WINAPI AjcXQueCreatePtrArr(HAJCXQUE pW, UIP pNum)
{
	PCAJCXQUEPTR rc    = NULL;
	PAJCXQUEPTR  pArr  = NULL;
	VOP		 	 pNode = NULL;
	UI		 	 ix    = 0;
	UI			 len;

	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		if (pArr  =  (PAJCXQUEPTR)AJCMEM(sizeof(AJCXQUEPTR) * (pW->num + 1))) {
			memset(pArr, 0, sizeof(AJCXQUEPTR) * (pW->num + 1));
			if (pNode = AjcXQueTopNode(pW, &len)) {
				do {
					pArr[ix].pNode = pNode;
					pArr[ix].len   = len;
					ix++;
				} while (pNode = AjcXQueNextNode(pW, pNode, &len));
			}
			if (pNum != NULL) *pNum = ix;
			rc = pArr;
		}
		AJCXQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z																				//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				pArr		 - Sm[hւ̃|C^z̐擪AhX											//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO	 			WINAPI AjcXQueReleasePtrArr(HAJCXQUE pW, PCAJCXQUEPTR pArr)
{
	if (IS_MY_INST(pW)) {
		AJCXQUE_ENTER
		if (pArr != NULL) free((VOP)pArr);
		AJCXQUE_LEAVE
	}
}

