#include	"AjcInternal.h"
#include	"AjcSerialComPortDef.h"
//**************************************************************************************************************//
//																												//
//	bnl|[go								`oh														//
//																												//
//**************************************************************************************************************//

#define	IS_MY_INST(P)	(P != NULL && P->InstID == SCP_INST_ID)

//--------------------------------------------------------------------------------------------------------------//
//	O[o[N																							//
//--------------------------------------------------------------------------------------------------------------//
ATOM	ScpClassForMSIL	= 0;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SubDeleteResource(HAJCSCP pW);
static	VO		LoadProfile(HAJCSCP pW, C_WCP pSect);
static	VO		SaveProfile(HAJCSCP pW, C_WCP pSect);
static	UI		SubDlgParamEasy	 (HAJCSCP pW, HWND hWndOwner, LPPOINT pPt);
static	UI		SubDlgParamDetail(HAJCSCP pW, HWND hWndOwner, LPPOINT pPt);

//==============================================================================================================//
//	Nݒ																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
BOOL	AjcCtrlSerialComPInit(VO)
{
	BOOL		rc = FALSE;
	WNDCLASS	wndclass;

	do {
		//----- lrhkR[hT|[gp ---------------------//
		wndclass.style			= 0;
		wndclass.lpfnWndProc	= ScpWndProcMSIL();
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= sizeof(VOP);
		wndclass.hInstance		= hDllInst;
		wndclass.hIcon			= NULL;
		wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= L"AjcScpForMSIL";
		if ((ScpClassForMSIL = RegisterClass(&wndclass)) == 0) break;

		rc = TRUE;
	} while(0);

	if (rc == FALSE) {
		AjcCtrlSerialComPEnd();
	}

	return rc;
}
//==============================================================================================================//
//	I㏈																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
VO		AjcCtrlSerialComPEnd (VO)
{
	if (ScpClassForMSIL != 0 ) {UnregisterClass((WCP)ScpClassForMSIL, hDllInst); ScpClassForMSIL = 0;}
}
//--------------------------------------------------------------------------------------------------------------//
//	CX^XiʃTu֐j																			//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//--------------------------------------------------------------------------------------------------------------//
//----- CxgʒmL[R[obN -------------------------------------------------------------------//
static	VO	CALLBACK cbFQueRemove(VOP pvEvtInf, UX cbp)
{
	PSCP_EVTINF	*pEvtInf = (PSCP_EVTINF *)pvEvtInf;

	if ((*pEvtInf)->pDat != NULL) {
		free((*pEvtInf)->pDat);
		(*pEvtInf)->pDat = NULL;
	}
}
//----- ʃTu -----------------------------------------------------------------------------------------------//
static	HAJCSCP		SubScpCreate(BOOL fUnicode, C_WCP pSect, BOOL fCreateMySlot,
												C_WCP pMySlot, C_WCP pRmtHost, C_WCP pRmtSlot, UI nMaxMessageSize, UI lReadTimeout, LPSECURITY_ATTRIBUTES lpSecurityAttributes)
{
	HAJCSCP	pW	 = NULL;
	BOOL	fErr = TRUE;
	int		len;

	do {
		//----- CX^X[Nm -------------------------------------------------------------------------//
		if ((pW = (HAJCSCP)AJCMEM(sizeof(AJCSCP))) == NULL) break;
		memset(pW, 0, sizeof(AJCSCP));
		//----- vt@CZNVݒ ---------------------------------------------------------------------//
		if (pSect != NULL && *pSect != 0) {
			AjcSnPrintF(pW->ProfileSect, AJCTSIZE(pW->ProfileSect), L"%s", pSect);
		}
		else {
			memset(pW->ProfileSect, 0, sizeof pW->ProfileSect);
		}
		//----- CX^X[N -----------------------------------------------------------------------//
		pW->InstID			= SCP_INST_ID;
		pW->PortNo			= 1;
		pW->fUnicode		= fUnicode;
		pW->ChunkMode		= AJCSCP_CM_BIN;
		pW->RxTxtCode		= AJCSCP_TXT_SJIS;
		pW->TxTxtCode		= AJCSCP_TXT_SJIS;
		pW->EvtMask			= AJCSCP_EV_DEFAULT_EVT;
		pW->hWndNtc			= NULL;
		pW->MsgNtc			= 0;
		//----- ʐMp^̃ftHgݒ -------------------------------------------------------------------//
		//	ftHglݒicbaC^CAEgj
		AjcScpGetDefaultParam(&pW->CommDcb, &pW->CommTmo);
		//	ftHgݒiM~Fԁj----------------------------------------------------------------//
		pW->MesTxTime = 300;		//	M~F
		pW->MesRxTime = 300;		//	M~F
		//	ftHglݒi[Xbgj
		wcscpy(pW->SlotInfo.MySlotName , L"MySlot");
		wcscpy(pW->SlotInfo.RmtHostName, L"");
		wcscpy(pW->SlotInfo.RmtSlotName, L"RmtSlot");
		pW->SlotInfo.fTxDelay	= FALSE;
		pW->SlotInfo.TxDelayBPS	= 100;
		//	ftHglݒi\Pbgj
		wcscpy(pW->SockInfo.ServName, L"127.0.0.1");
		pW->SockInfo.PortNo = 14238;
		//----- [Xbgݒ -------------------------------------------------------------------------//
		if (pMySlot  != NULL) AjcSnPrintF(pW->SlotInfo.MySlotName , AJCTSIZE(pW->SlotInfo.MySlotName) , L"%s", pMySlot );
		if (pRmtHost != NULL) AjcSnPrintF(pW->SlotInfo.RmtHostName, AJCTSIZE(pW->SlotInfo.RmtHostName), L"%s", pRmtHost);
		if (pRmtSlot != NULL) AjcSnPrintF(pW->SlotInfo.RmtSlotName, AJCTSIZE(pW->SlotInfo.RmtSlotName), L"%s", pRmtSlot);
		//----- vt@CZNVʐMp^ǂݏo -------------------------------------------------//
		if (pW->ProfileSect[0] != 0) {
			LoadProfile(pW, NULL);
		}
		//----- [{bNXnh ---------------------------------------------------------------------//
		if (!(pW->hVMbxTxD	  = AjcVMbxCreate( 				   0, NULL 			  ))) break;	//	Mf[^
		if (!(pW->hFMbxNtc	  = AjcFMbxCreate(sizeof(PSCP_EVTINF), 0, cbFQueRemove))) break;	//	[U`oւ̃Cxgʒmp
		//----- NeBJZNVIuWFNg -------------------------------------------------------//
		InitializeCriticalSection(&pW->CsCommApi);
		InitializeCriticalSection(&pW->CsTxDelay);
		//----- v^C} ---------------------------------------------------------------------------------//
		if ((pW->hMesTxDelay = AjcMesTimeCreate(NULL)) == NULL) break;	//	Mxp
		//----- [XbgMx񏉊 -----------------------------------------------------------//
		pW->fTxDelay			 = pW->SlotInfo.fTxDelay;				//	MxtO
		pW->TxDelayBPS			 = pW->SlotInfo.TxDelayBPS * 1024;		//	Mx[Bytes / sec]
		pW->TxDelayBytesCount	 = 0;									//	MxpoCgJE^
		pW->TxDelayTickCount	 = 0;									//	MxpEoߎ[us]
		//----- oCgyAM -------------------------------------------------------------------------//
		pW->fBpLBFirst	= TRUE;											//	Low Byte First
		pW->BpSeq		= 0;											//	MoCgJE^iO`Pj
		//----- XbhIwtONA[ -----------------------------------------------------------------//
		pW->fThreadEnd = FALSE;
		//----- f[^MXbh -------------------------------------------------------------------------//
		if (!ScpStartThreadTx(pW)) break;
		//----- f[^MXbh -------------------------------------------------------------------------//
		if (!ScpStartThreadRx(pW)) break;
		//----- MĎXbh ---------------------------------------------------------------------------//
		if (!ScpStartThreadObs(pW)) break;
		//----- zXgݒ ---------------------------------------------------------------------------------//
		len = AJCTSIZE(pW->SlotInfo.MyHostName);
		GetComputerName(pW->SlotInfo.MyHostName, &len);
		//----- CreateMailSlot()̈ޔ ---------------------------------------------------------------------//
		pW->MaxMsgSize	= nMaxMessageSize;
		pW->ReadTimeout = lReadTimeout;
		//----- ZLeBޔ ---------------------------------------------------------------------------//
		//	ZLeBޔ
		pW->pSecAttr = NULL;
		ScpSaveSlot(pW, lpSecurityAttributes);
		//----- [Xbg ---------------------------------------------------------------------------//
		if (fCreateMySlot) {
			ScpCreateMySlot(pW);
		}
		//----- \PbgCxgʒmpCxgIuWFNg -------------------------------------------------//
		if ((pW->hEvtSock = WSACreateEvent()) == NULL) {
			break;
		}
		//----- G[tONA[ ---------------------------------------------------------------------------//
		fErr = FALSE;
	} while(0);

	//----- G[Ȃ΁AS\[X -------------------------------------------------------------------//
	if (fErr) {
		SubDeleteResource(pW);
		pW = NULL;
	}

	return pW;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreateA(VO)
{
	return AjcScpCreateExA("SerialComPort" , FALSE,	"MySlot",	"",  "RmtSlot");
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreateW(VO)
{
	return AjcScpCreateExW(L"SerialComPort", FALSE, L"MySlot",	L"", L"RmtSlot");
}
//==============================================================================================================//
//	CX^Xivt@CEZNVwj															//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreatePfA(C_BCP pSect)
{
	return AjcScpCreateExA(pSect, FALSE,  "MySlot",  "",  "RmtSlot");
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreatePfW(C_WCP pSect)
{
	return AjcScpCreateExW(pSect, FALSE, L"MySlot", L"", L"RmtSlot");
}
//==============================================================================================================//
//	CX^Xi[Xbgpj																		//
//																												//
//	@	F	pSect			- vt@CZNViNULLw莞́Avt@C֋L^Ȃj			//
//				fCreateMySlot	- [XbgtO													//
//				pMySlot			- Xbg		iNULLw莞̓vt@CǂݏolL)					//
//				pRmtHost		- [gzXg	iNULLw莞̓vt@CǂݏolL)					//
//				pRmtSlot		- [gXbgiNULLw莞̓vt@CǂݏolL)					//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreateSlotA(C_BCP pSect, BOOL fCreateMySlot, C_BCP pMySlot, C_BCP pRmtHost, C_BCP pRmtSlot)
{
	return AjcScpCreateSlotExA(pSect, fCreateMySlot, pMySlot, pRmtHost, pRmtSlot, 0, 0, NULL);
}
//----- Ch	--------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreateSlotW(C_WCP pSect, BOOL fCreateMySlot, C_WCP pMySlot, C_WCP pRmtHost, C_WCP pRmtSlot)
{
	return AjcScpCreateSlotExW(pSect, fCreateMySlot, pMySlot, pRmtHost, pRmtSlot, 0, 0, NULL);
}
//--------------------------------------------------------------------------------------------------------------//
//----- oCgi񐄏j------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreateExA(C_BCP pSect, BOOL fCreateMySlot, C_BCP pMySlot, C_BCP pRmtHost, C_BCP pRmtSlot)
{
	return AjcScpCreateSlotExA(pSect, fCreateMySlot, pMySlot, pRmtHost, pRmtSlot, 0, 0, NULL);
}
//----- Chi񐄏j -----------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreateExW(C_WCP pSect, BOOL fCreateMySlot, C_WCP pMySlot, C_WCP pRmtHost, C_WCP pRmtSlot)
{
	return AjcScpCreateSlotExW(pSect, fCreateMySlot, pMySlot, pRmtHost, pRmtSlot, 0, 0, NULL);
}
//==============================================================================================================//
//	CX^Xi[XbgpDvt@CZNVC[XbgIvVwj					//
//																												//
//	@	F	pSect			- vt@CZNViNULLw莞́Avt@C֋L^Ȃj			//
//				fCreateMySlot	- [XbgtO													//
//				pMySlot			- Xbg		iNULLw莞̓vt@CǂݏolL)					//
//				pRmtHost		- [gzXg	iNULLw莞̓vt@CǂݏolL)					//
//				pRmtSlot		- [gXbgiNULLw莞̓vt@CǂݏolL)					//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreateSlotExA(C_BCP pSect, BOOL fCreateMySlot, C_BCP pMySlot, C_BCP pRmtHost, C_BCP pRmtSlot, UI nMaxMessageSize, UI lReadTimeout, LPSECURITY_ATTRIBUTES lpSecurityAttributes)
{
	HAJCSCP	pW		  = NULL;
	WCP		pSectB	  = NULL;
	WCP		pMySlotB  = NULL;
	WCP		pRmtHostB = NULL;
	WCP		pRmtSlotB = NULL;
	int		len;

	do {
		//	ZNVϊ
		if (pSect != NULL) {
			len = AjcByteCharToWideChar(pSect, NULL, 0);
			if (pSectB = AjcTAlloc(len)) {
				AjcByteCharToWideChar(pSect, pSectB, len);
			}
			else break;
		}
		//	Xbgϊ
		if (pMySlot != NULL) {
			len = AjcByteCharToWideChar(pMySlot, NULL, 0);
			if (pMySlotB = AjcTAlloc(len)) {
				AjcByteCharToWideChar(pMySlot, pMySlotB, len);
			}
			else break;
		}
		//	[gERs[^ϊ
		if (pRmtHost != NULL) {
			len = AjcByteCharToWideChar(pRmtHost, NULL, 0);
			if (pRmtHostB = AjcTAlloc(len)) {
				AjcByteCharToWideChar(pRmtHost, pRmtHostB, len);
			}
			else break;
		}
		//	[gEXbgϊ
		if (pRmtSlot != NULL) {
			len = AjcByteCharToWideChar(pRmtSlot, NULL, 0);
			if (pRmtSlotB = AjcTAlloc(len)) {
				AjcByteCharToWideChar(pRmtSlot, pRmtSlotB, len);
			}
			else break;
		}
		//	rboCX^X
		pW = SubScpCreate(FALSE, pSectB, fCreateMySlot, pMySlotB, pRmtHostB, pRmtSlotB, nMaxMessageSize, lReadTimeout, lpSecurityAttributes);

	} while(0);

	if (pSectB	  != NULL) free(pSectB	 );
	if (pMySlotB  != NULL) free(pMySlotB );
	if (pRmtHostB != NULL) free(pRmtHostB);
	if (pRmtSlotB != NULL) free(pRmtSlotB);

	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP		WINAPI	AjcScpCreateSlotExW(C_WCP pSect, BOOL fCreateMySlot, C_WCP pMySlot, C_WCP pRmtHost, C_WCP pRmtSlot, UI nMaxMessageSize, UI lReadTimeout, LPSECURITY_ATTRIBUTES lpSecurityAttributes)
{
	HAJCSCP	pW = NULL;

	pW = SubScpCreate(TRUE, pSect, fCreateMySlot, pMySlot, pRmtHost, pRmtSlot, nMaxMessageSize, lReadTimeout, lpSecurityAttributes);

	return pW;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL			WINAPI	AjcScpDelete		(HAJCSCP pW)
{
	BOOL	rc = FALSE;
	UI		Count = 0;

	if (IS_MY_INST(pW)) {
		//----- vt@CZNV֒ʐMp^Z[u ---------------------//
		SaveProfile(pW, NULL);
		//----- S\[X -------------------------------------------------//
		SubDeleteResource(pW);

		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	[hݒ																									//
//																												//
//	@	F	pW				- CX^Xnh															//
//				hWndNtc			- [U`oւ̃CxgʒmpEChnh									//
//				WndMsgNtc		- [U`oւ̃CxgʒmpEChbZ[W								//
//				ChunkMode		- `Nf[^ʒm[h														//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetMode		(HAJCSCP pW, HWND hWndNtc, UI WndMsgNtc, AJCSCP_CHUNKMODE ChunkMode)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (hWndNtc == NULL	 ||	 IsWindow(hWndNtc)) {
			pW->hWndNtc	   = hWndNtc;
			pW->MsgNtc	   = WndMsgNtc;
			pW->ChunkMode  = ChunkMode;
			if (hWndNtc != NULL) pW->EvtMask = AjcScpSetEvtMask(pW, AJCSCP_EV_DEFAULT_POST);
			else				 pW->EvtMask = AjcScpSetEvtMask(pW, AJCSCP_EV_DEFAULT_EVT);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	|[gI[vibnl|[gCʐMp^wj															//
//																												//
//	@	F	pW			- CX^Xnh																//
//				Port		- |[gԍ																		//
//				Rate		- ʐM[g[bps]																	//
//				DataBits	- f[^rbgiV`Wj															//
//				Parity		- peBrbgdli'N', 'O', 'E'j												//
//				StpBit		- XgbvrbgiP`Qj														//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpOpen(HAJCSCP pW, UI Port, UI Rate, UI DataBits, UI Parity, UI StopBit)
{
	BOOL			rc = FALSE;
	DCB				dcb;

	if (IS_MY_INST(pW)) {
		//----- R[hobt@Zbg --------------//
		AjcSsepMbcReset(pW->hSsep);
		//----- ʐM\[XI[vȂ΁AN[Y --//
		if (pW->hPort != NULL) {
			AjcScpClose(pW);
			pW->hPort = NULL;
		}
		//----- bnl|[g[hݒ ----------------------//
		pW->PortSel = AJCSCP_SEL_COMPORT;
		//----- |[gԍݒCύXʒm --------------------//
		if (Port != pW->PortNo) {
			pW->PortNo = Port;
			ScpNtcPortStateToUser(pW, AJCSCP_PORTNO);
		}
		//----- ftHgcbaRs[ ----------------------//
		memcpy(&dcb, &pW->CommDcb, sizeof dcb);
		//----- [glݒ --------------------------------//
		if (Rate != 0) {
			dcb.BaudRate = Rate;
		}
		//----- f[^ݒ --------------------------------//
		switch (DataBits) {
			case 7:	dcb.ByteSize = 7; break;
			case 8:	dcb.ByteSize = 8; break;
		}
		//----- peBݒ --------------------------------//
		switch (Parity) {
			case 'N':	dcb.fParity = 0; dcb.Parity = 0; break;
			case 'O':	dcb.fParity = 1; dcb.Parity = 1; break;
			case 'E':	dcb.fParity = 1; dcb.Parity = 2; break;
		}
		//----- Xgbvrbgݒ ------------------------//
		switch (StopBit) {
			case 1:	dcb.StopBits = 0; break;
			case 2:	dcb.StopBits = 2; break;
		}
		//----- bnl|[gI[v ------------------------//
		rc = AjcScpOpenEx(pW, Port, &dcb, NULL);
	}
	return rc;
}
//==============================================================================================================//
//	|[gI[vibnl|[gCcbawj																	//
//																												//
//	@	F	pW			- CX^Xnh																//
//				Port		- |[gԍ																		//
//				pDcb		- cbãAhX																//
//				pTmo		- ^CAEg̃AhX														//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpOpenEx		(HAJCSCP pW, UI Port, LPDCB pDcb, LPCOMMTIMEOUTS pTmo)
{
	BOOL	rc = FALSE;
	UI		CommErr;

	if (IS_MY_INST(pW)) {
		do {
			//----- R[hobt@Zbg -------------------------------------------------------------//
			AjcSsepMbcReset(pW->hSsep);
			//----- MeLXg[oCg^[hZbg -----------------------------------------------------//
			pW->SvSndA = 0;
			pW->SvSndW = 0;
			//----- |[gԍ`FbN -------------------------------------------------------------------------//
			if (Port == 0 || Port > 255) break;
			//----- ʐM\[XI[vȂ΁AN[Y -------------------------------------------------//
			if (pW->hPort != NULL) {
				AjcScpClose(pW);
				pW->hPort = NULL;
			}
			//----- |[g[hݒ ---------------------------------------------------------------------------//
			pW->PortSel = AJCSCP_SEL_COMPORT;
			//----- |[gԍCcbaCslnݒ -------------------------------------------------------------//
			if (Port != 0  &&  Port != pW->PortNo) {
				pW->PortNo = Port;
				ScpNtcPortStateToUser(pW, AJCSCP_PORTNO);
			}
			if (pDcb != NULL) memcpy(&pW->CommDcb, pDcb, sizeof pW->CommDcb);
			if (pTmo != NULL) memcpy(&pW->CommTmo, pTmo, sizeof pW->CommTmo);
			//----- |[gI[v -----------------------------------------------------------------------------//
			if ((pW->hPort = ScpOpenFile(pW)) == NULL) break;

			//----- VXeMobt@TCYݒ -----------------------------------------------------------//
			ScpClearCommError(pW, &CommErr, NULL);
			if (!ScpSetupComm(pW, SCP_SYSRXBUFSIZE, SCP_SYSTXBUFSIZE))	break;

			//----- cbaݒ ---------------------------------------------------------------------------------//
			ScpClearCommError(pW, &CommErr, NULL);
			if (!ScpSetCommState(pW, &pW->CommDcb)) break;

			//----- ^CAEglݒ -------------------------------------------------------------------------//
			ScpClearCommError(pW, &CommErr, NULL);
			if (!ScpSetCommTimeouts(pW, &pW->CommTmo))	break;

			//----- csqCqsrZbg -----------------------------------------------------------------------//
			ScpEscapeCommFunction(pW, SETDTR);
			ScpEscapeCommFunction(pW, SETRTS);

			//----- G[Zbg -----------------------------------------------------------------------------//
			ScpClearCommError(pW, &CommErr, NULL);

			//----- MʒmtOZbg -------------------------------------------------------------------//
			pW->GpiState = AJCSCP_FIRST;

			//----- Mobt@NA[ -----------------------------------------------------------------------//
			pW->ixRxb = pW->ixNpk = 0;
			memset(pW->RxBuf, 0, sizeof pW->RxBuf);
			memset(pW->NpBuf, 0, sizeof pW->NpBuf);

			//----- oCgyAMJE^NA[ -------------------------------------------------------------//
			pW->BpSeq = 0;

			//----- G[tO ---------------------------------------------------------------------------//
			rc = TRUE;
		} while(0);

		//----- Ȃ΃I[vʒm -------------------------------------------------------------------------//
		if (rc) {
			ScpNtcPortStateToUser(pW, AJCSCP_OPENED);
		}
		//----- G[Ȃ΁Abnl|[gN[YAG[ʒm -----------------------------------------------//
		else {
		//	AjcScpClose(pW);
			ScpNtcPortStateToUser(pW, AJCSCP_OPENFAIL);
		}
	}
	return rc;
}
//==============================================================================================================//
//	|[gI[vi[Xbgj																			//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pRmtHost	- [gzXg	i_CAOł̐ݒϖ̂gpꍇNULL)					//
//				pRmtSlot	- [gXbgi_CAOł̐ݒϖ̂gpꍇNULL)					//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScpOpenSlotA		(HAJCSCP pW, C_BCP pRmtHost, C_BCP pRmtSlot)
{
	BOOL	rc = TRUE;
	UI		len;
	WCP		pHostB = NULL;
	WCP		pSlotB = NULL;

	if (pRmtHost != NULL) {
		len = AjcByteCharToWideChar(pRmtHost, NULL, 0);
		if (pHostB = AjcTAlloc(len)) {
			AjcByteCharToWideChar(pRmtHost, pHostB, len);
		}
		else rc = FALSE;
	}

	if (pRmtSlot != NULL) {
		len = AjcByteCharToWideChar(pRmtSlot, NULL, 0);
		if (pSlotB = AjcTAlloc(len)) {
			AjcByteCharToWideChar(pRmtSlot, pSlotB, len);
		}
		else rc = FALSE;
	}

	if (rc) {
		rc = AjcScpOpenSlotW(pW, pHostB, pSlotB);
	}

	if (pHostB != NULL) free(pHostB);
	if (pSlotB != NULL) free(pSlotB);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScpOpenSlotW		(HAJCSCP pW, C_WCP pRmtHost, C_WCP pRmtSlot)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		//----- R[hobt@Zbg -----------------------------------------------------------------//
		AjcSsepMbcReset(pW->hSsep);
		//----- MeLXg[oCg^[hZbg ---------------------------------------------------------//
		pW->SvSndA = 0;
		pW->SvSndW = 0;
		//----- ʐM\[XI[vȂ΁AN[Y -----------------------------------------------------//
		if (pW->hPort != NULL) {
			AjcScpClose(pW);
			pW->fTxSlotOpened = FALSE;
			pW->hPort		  = NULL;
		}
		//----- Xbg[hݒ -----------------------------------------------------------------------------//
		pW->PortSel = AJCSCP_SEL_MAILSLOT;

		//----- XbgȂ΁A ---------------------------------------------------------------//
		if (pW->hSlot == NULL && pW->SlotInfo.MySlotName[0] != 0) {
			ScpCreateMySlotAndNtcErr(pW);
		}

		//----- [gzXgݒ -----------------------------------------------------------------------//
		if (pRmtHost != NULL) {
			AjcSnPrintF(pW->SlotInfo.RmtHostName, AJCTSIZE(pW->SlotInfo.RmtHostName), L"%s", pRmtHost);
		}
		//----- [gXbgݒ ---------------------------------------------------------------------//
		if (pRmtSlot != NULL) {
			AjcSnPrintF(pW->SlotInfo.RmtSlotName, AJCTSIZE(pW->SlotInfo.RmtSlotName), L"%s", pRmtSlot);
		}
		//----- M|[gI[v -------------------------------------------------------------------------//
		//	M|[gw肳Ăꍇ́AۂɃI[v
		if (pW->SlotInfo.RmtSlotName[0] != 0) {
			if ((pW->hPort = ScpOpenFile(pW)) != NULL) {
				pW->fTxSlotOpened = TRUE;
				rc				  = TRUE;
			}
			else {
				pW->fTxSlotOpened = FALSE;
				rc				  = FALSE;
			}
		}
		//	M|[gw肳ĂȂꍇ́Aۂɂ̓I[vɁAI[v삪sꂽ|AtOݒ
		else {
			pW->fTxSlotOpened = TRUE;	//	I[vs|AtOݒ
			rc = TRUE;					//i[gXbgw̏ꍇ́Aۂɂ͑M|[gI[vȂj
		}
		//----- Mx񏉊 ---------------------------------------------------------------------//
		pW->TxDelayBytesCount	= 0;							//	MxpoCgJE^
		pW->TxDelayTickCount	= 0;							//	Mxpv[us]
		AjcMesTimeInterval(pW->hMesTxDelay);					//	ԌvZbg

		//----- Mobt@NA[ -----------------------------------------------------------------------//
		pW->ixRxb = pW->ixNpk = 0;
		memset(pW->RxBuf, 0, sizeof pW->RxBuf);
		memset(pW->NpBuf, 0, sizeof pW->NpBuf);

		//----- oCgyAMJE^NA[ -------------------------------------------------------------//
		pW->BpSeq = 0;

		//----- Ȃ΃I[vʒm ---------------------------------------------------------------------//
		if (rc) {
			ScpNtcPortStateToUser(pW, AJCSCP_OPENED);
		}
		//----- G[Ȃ΁AG[ʒm -------------------------------------------------------------------//
		else {
		//	AjcScpClose(pW);
			ScpNtcPortStateToUser(pW, AJCSCP_OPENFAIL);
		}
	}
	return rc;
}
//==============================================================================================================//
//	|[gI[vi\Pbgj																					//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pServ		- T[ozXg	i_CAOł̐ݒϖ̂gpꍇNULL)					//
//				PortNo		- |[gԍ		i_CAOł̐ݒσ|[gԍgpꍇ͂O)				//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScpOpenSockA		(HAJCSCP pW, C_BCP pServ, UI PortNo)
{
	BOOL	rc = TRUE;
	UI		len;
	WCP		pServW = NULL;

	if (pServ != NULL) {
		len = AjcByteCharToWideChar(pServ, NULL, 0);
		if (pServW = AjcTAlloc(len)) {
			AjcByteCharToWideChar(pServ, pServW, len);
		}
		else rc = FALSE;
	}

	if (rc) {
		rc = AjcScpOpenSockW(pW, pServW, PortNo);
	}

	if (pServW != NULL) free(pServW);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScpOpenSockW		(HAJCSCP pW, C_WCP pServ, UI PortNo)
{
	BOOL		rc = FALSE;
	ADDRINFO	*pAI = NULL;

	if (IS_MY_INST(pW)) {
		//----- R[hobt@Zbg -----------------------------------------------------------------//
		AjcSsepMbcReset(pW->hSsep);
		//----- MeLXg[oCg^[hZbg ---------------------------------------------------------//
		pW->SvSndA = 0;
		pW->SvSndW = 0;
		//----- ʐM\[XI[vȂ΁AN[Y -----------------------------------------------------//
		if (pW->hPort != NULL) {
			AjcScpClose(pW);
			pW->hPort = NULL;
		}
		//----- \Pbg[hݒ -----------------------------------------------------------------------------//
		pW->PortSel = AJCSCP_SEL_SOCKET;

		//----- T[oC|[gԍݒ -----------------------------------------------------------------------//
		if (pServ  != NULL) {AjcSnPrintF(pW->SockInfo.ServName, AJCTSIZE(pW->SockInfo.ServName), L"%s", pServ);}
		if (PortNo != 0   ) {pW->SockInfo.PortNo = PortNo;}

		//----- \PbgI[vi\Pbgڑj ---------------------------------------------------------------//
		if ((pW->hPort = ScpOpenFile(pW)) != NULL) {
			rc = TRUE;
		}
		//----- Mobt@NA[ ---------------------------------------------------------------------------//
		pW->ixRxb = pW->ixNpk = 0;
		memset(pW->RxBuf, 0, sizeof pW->RxBuf);
		memset(pW->NpBuf, 0, sizeof pW->NpBuf);

		//----- oCgyAMJE^NA[ -----------------------------------------------------------------//
		pW->BpSeq = 0;

		//----- G[Ȃ΁A\PbgN[YAG[ʒm ---------------------------------------------------//
		if (!rc) {
		//	AjcScpClose(pW);
			ScpNtcPortStateToUser(pW, AJCSCP_OPENFAIL);
		}
	}
	return rc;
}
//==============================================================================================================//
//	|[gI[viIσ|[gj																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpOpenDefault	(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:	rc = AjcScpOpenEx(pW, pW->PortNo, NULL, NULL);	break;
			case AJCSCP_SEL_MAILSLOT:	rc = AjcScpOpenSlot(pW, NULL, NULL);			break;
			case AJCSCP_SEL_SOCKET:		rc = AjcScpOpenSock(pW, NULL, 0   );			break;
		}
	}
	return rc;
}
//==============================================================================================================//
//	|[gI[vi\[XIj																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				sel 		- ŏɃI[v郊\[X(AJCSCP_SEL_COMPORT / EE_MAILSLOT / EE_SOCKET)		//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI		AjcScpOpenSelect (HAJCSCP pW, AJCSCP_PORTSEL sel)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (sel == AJCSCP_SEL_COMPORT || sel == AJCSCP_SEL_MAILSLOT || sel == AJCSCP_SEL_SOCKET) {
			//	w胊\[XI[v
			switch (sel) {
				case AJCSCP_SEL_COMPORT:	rc = AjcScpOpenEx(pW, pW->PortNo, NULL, NULL);	break;
				case AJCSCP_SEL_MAILSLOT:	rc = AjcScpOpenSlot(pW, NULL, NULL);			break;
				case AJCSCP_SEL_SOCKET:		rc = AjcScpOpenSock(pW, NULL, 0   );			break;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	|[gN[Y																								//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpClose			(HAJCSCP pW)
{
	BOOL	rc = TRUE;
	UI		Count = 0;

	if (IS_MY_INST(pW)) {
		//	ʐM|[gN[Y
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:			//	bnl|[g
				if (pW->hPort != NULL) {
					ScpPurgeComm(pW, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
					rc = ScpCloseFile(pW);
				}
				break;

			case AJCSCP_SEL_MAILSLOT:			//	[Xbg
				if (pW->fTxSlotOpened) {
					rc = ScpCloseFile(pW);
				}
				break;

			case AJCSCP_SEL_SOCKET:				//	\Pbg
				if (pW->hPort != NULL) {
					rc = ScpCloseFile(pW);
				}
				break;
		}
		//	|[gN[Yʒm
		ScpNtcPortStateToUser(pW, AJCSCP_CLOSED);
		//	[Xbgj
		if (pW->PortSel == AJCSCP_SEL_MAILSLOT) {
			//	Mp [XbgN[Y
			if (pW->hSlot != NULL) {						//	[XbgρH
				if (pW->SlotInfo.RmtHostName[0] != 0) {		//		[gzXgLH
					CloseHandle(pW->hSlot);					//			[XbgN[Y
					pW->hSlot = NULL;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ݒ肳ĂʐM|[gʎ擾																			//
//																												//
//	@	F	pW				- CX^Xnh															//
//																												//
//	߂l	F	0: ݒ肳Ă|[gԍi1`256Fbnl|[gC256F[Xbgj						//
//				0: G[																						//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcScpGetSelectedPort(HAJCSCP pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:	rc = pW->PortNo;	break;
			case AJCSCP_SEL_MAILSLOT:	rc = 256;			break;
			case AJCSCP_SEL_SOCKET:		rc = 257;			break;
		}
	}
	return rc;
}

//==============================================================================================================//
//	|[gI[vԎ擾																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	O  - I[vԁi1`255 : bnl|[gԍC256 : [Xbg, 257 : \Pbgj			//
//				O  - N[Y																			//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcScpIsOpened		(HAJCSCP pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:
				if (pW->hPort != NULL) {
					rc = pW->PortNo;
				}
				break;

			case AJCSCP_SEL_MAILSLOT:
				if (pW->fTxSlotOpened) {
					rc = 256;
				}
				break;

			case AJCSCP_SEL_SOCKET:
				if (pW->hPort != NULL && pW->fConnect) {
					rc = 257;
				}
				break;
		}
	}
	return rc;
}
//==============================================================================================================//
//	M|[gI[vԎ擾																					//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	TRUE  - I[v																			//
//				FALSE - N[Y																			//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpIsTxOpened	(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:
				if (pW->hPort != NULL) {
					rc = TRUE;
				}
				break;

			case AJCSCP_SEL_MAILSLOT:
				if (pW->hPort != NULL) {
					rc = TRUE;
				}
				break;

			case AJCSCP_SEL_SOCKET:
				if (pW->hPort != NULL && pW->fConnect) {
					rc = TRUE;
				}
				break;
		}
	}
	return rc;
}
//==============================================================================================================//
//	M|[gI[vԎ擾																					//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	TRUE  - I[v																			//
//				FALSE - N[Y																			//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpIsRxOpened	(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:
				if (pW->hPort != NULL) {
					rc = TRUE;
				}
				break;

			case AJCSCP_SEL_MAILSLOT:
				if (pW->hSlot != NULL) {
					rc = TRUE;
				}
				break;

			case AJCSCP_SEL_SOCKET:
				if (pW->hPort != NULL && pW->fConnect) {
					rc = TRUE;
				}
				break;
		}
	}
	return rc;
}
//==============================================================================================================//
//	PM																									//
//																												//
//	@	F	pW			- CX^Xnh																//
//				code		- M镶̕R[h															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//																												//
//	l	F	}`oCg𑗐Mꍇ́Å֐QxR[Ă								//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScpSendCharA		(HAJCSCP pW, BC code)
{
	BOOL	rc = FALSE;
	BC		txt[4];

	if (IS_MY_INST(pW) && AjcScpIsTxOpened(pW)) {
		//	SpPoCgڑޔȂH
		if (pW->SvSndA == 0) {
			if (MAjcIsLeadA(code)) {
				pW->SvSndA = code;
				rc = TRUE;
			}
			else {
				txt[0] = code;
				txt[1] = 0;
				rc = AjcScpSendTextA(pW, txt, 1);
			}
		}
		//	SpPoCgڑޔH
		else {
			//	QoCg쐬M
			txt[0] = pW->SvSndA;
			txt[1] = code;
			txt[2] = 0;
			rc = AjcScpSendTextA(pW, txt, 2);
			//	SpPoCgڑޔNA[
			pW->SvSndA = 0;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScpSendCharW		(HAJCSCP pW, WC code)
{
	BOOL	rc = FALSE;
	WC		txt[2];

	if (IS_MY_INST(pW) && AjcScpIsTxOpened(pW)) {
		//	TQ[gP[hڑޔȂH
		if (pW->SvSndA == 0) {
			if (MAjcIsLeadW(code)) {
				pW->SvSndW = code;
				rc = TRUE;
			}
			else {
				txt[0] = code;
				txt[1] = 0;
				rc = AjcScpSendTextW(pW, txt, 1);
			}
		}
		//	TQ[gP[hڑޔH
		else {
			//	Q[h쐬M
			txt[0] = pW->SvSndW;
			txt[1] = code;
			txt[2] = 0;
			rc = AjcScpSendTextW(pW, txt, 2);
			//	TQ[gP[hڑޔNA[
			pW->SvSndW = 0;
		}
	}
	return rc;
}
//==============================================================================================================//
//	PSrbg[hf[^ioCgyAjM - Low byte first													//
//																												//
//	@	F	pW			- CX^Xnh																//
//				data		- MPSrbgf[^															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI		AjcScpSendWord14LF	(HAJCSCP pW, UI data)
{
	BOOL	rc = FALSE;
	UB		sd[2];

	if (IS_MY_INST(pW) && AjcScpIsTxOpened(pW)) {
		sd[0] = (UB)(0x80 | (data & 0x7F));
		sd[1] = (UB)((data >> 7) & 0x7F);
		rc = AjcVMbxEnque(pW->hVMbxTxD, sd, sizeof sd);
	}
	return rc;
}
//==============================================================================================================//
//	PSrbg[hf[^ioCgyAjM - High byte first													//
//																												//
//	@	F	pW			- CX^Xnh																//
//				code		- MPSrbgf[^															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI		AjcScpSendWord14HF	(HAJCSCP pW, UI data)
{
	BOOL	rc = FALSE;
	UB		sd[2];

	if (IS_MY_INST(pW) && AjcScpIsTxOpened(pW)) {
		sd[0] = (UB)(0x80 | ((data >> 7) & 0x7F));
		sd[1] = (UB)((data & 0x7F));
		rc = AjcVMbxEnque(pW->hVMbxTxD, sd, sizeof sd);
	}
	return rc;
}
//==============================================================================================================//
//	PSrbg[hf[^ioCgyAjM̃oCgݒ													//
//																												//
//	@	F	pW				- CX^Xnh															//
//				fLowByteFirst	- TRUE	: ʃoCgCʃoCg̏ŎM										//
//								  FALSE : ʃoCgCʃoCg̏ŎM										//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI		AjcScpSetByteSeqRxWord14	(HAJCSCP pW, BOOL fLowByteFirst)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->fBpLBFirst = (fLowByteFirst != 0);
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	PSrbg[hf[^ioCgyAjM̃oCg擾													//
//																												//
//	@	F	pW				- CX^Xnh															//
//				fLowByteFirst	- TRUE	: ʃoCgCʃoCg̏ŎM										//
//								  FALSE : ʃoCgCʃoCg̏ŎM										//
//																												//
//	߂l	F	TRUE  - ʃoCgCʃoCg̏ŎM														//
//				FALSE - ʃoCgCʃoCg̏ŎM														//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI		AjcScpGetByteSeqRxWord14	(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		rc = pW->fBpLBFirst;
	}
	return rc;
}

//==============================================================================================================//
//	eLXgf[^M																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pTxt		- MeLXgf[^̃AhXiVtgihr^tmhbncdeLXgj			//
//				lTxt		- MeLXgf[^̕i|P̏ꍇ͎Zoj							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScpSendTextA		(HAJCSCP pW, C_BCP pTxt, UI lTxt)
{
	BOOL		rc	= FALSE;
	AJCMBCKIND	mbk = AJCMBC_SJIS;
	BCP			pAlt = NULL;

	if (IS_MY_INST(pW) && pTxt != NULL && AjcScpIsTxOpened(pW)) {
		rc = TRUE;
		do {
			//	\[XeLXgݒ
			lTxt = AjcStrAdjustLenA(pTxt, lTxt);
			if (lTxt == 0) break;
			//	O̔[oCgƃeLXg𓮓Iobt@Ɋi[
			if (pW->SvSndA != 0) {
				if (pAlt = AjcTAllocA(1 + lTxt + 1)) {
					*pAlt = pW->SvSndA;
					strncpy(pAlt + 1, pTxt, lTxt);
					*(pAlt + (1 + lTxt)) = 0;
					//	eLXg|C^؂ւ
					pTxt = pAlt;
					lTxt++;
				}
				else {
					rc = FALSE;
				}
				pW->SvSndA = 0;
			}
			if (!rc) break;
			//	eLXg̖SpPoCgڂȂ΁AޔĖO
			if (mbsbtype(pTxt, lTxt - 1) == _MBC_LEAD) {
				pW->SvSndA = pTxt[lTxt - 1];
				lTxt--;
			}
			if (lTxt == 0) break;
			//	MeLXgR[hݒ
			switch (pW->TxTxtCode) {
				default:
				case AJCSCP_TXT_SJIS:	mbk = AJCMBC_SJIS;						break;	//	Vtgihr
				case AJCSCP_TXT_EUC:	mbk = AJCMBC_EUC;						break;	//	dtb@@@
				case AJCSCP_TXT_UTF8:	mbk = AJCMBC_UTF8;						break;	//	tse|W@
				case AJCSCP_TXT_AUTO:													//	
										switch (pW->RxTxtCode) {
											case AJCSCP_TXT_SJIS:	mbk = AJCMBC_SJIS;						break;
											case AJCSCP_TXT_EUC:	mbk = AJCMBC_EUC;						break;
											case AJCSCP_TXT_UTF8:	mbk = AJCMBC_UTF8;						break;
											case AJCSCP_TXT_AUTO:	mbk = AjcSsepGetLastMbcKind(pW->hSsep);	break;
										}
										break;
			}
			//	MR[hVtgihr
			if (mbk == AJCMBC_SJIS) {
				C_BCP	p = pTxt;
				UI		len;
				//	MeLXgGL[
				while (lTxt > 0) {
					switch (pW->PortSel) {
						case AJCSCP_SEL_COMPORT:	len = __min(lTxt, AJCSCPMAX_TXSIZE_COMPORT );	break;
						case AJCSCP_SEL_MAILSLOT:	len = __min(lTxt, AJCSCPMAX_TXSIZE_MAILSLOT);	break;
						case AJCSCP_SEL_SOCKET:		len = __min(lTxt, AJCSCPMAX_TXSIZE_SOCKET  );	break;
					}
					if (!(rc = AjcVMbxEnque(pW->hVMbxTxD, p, len))) break;
					p	 += len;
					lTxt -= len;
				}
			}
			//	MR[hdtb^tseW
			else {
				BCP			pTop = NULL;
				BCP			pTmp = NULL;
				UI			lTmp = 0;
				UI			len;
				do {
					//	R[hϊ(SJIS -> EUC)
					if (mbk == AJCMBC_EUC) {
						lTmp = AjcSJisToEucEx(pTxt, lTxt, NULL, 0);
						if ((pTop = AJCMEM(lTmp)) == NULL) break;
						AjcSJisToEucEx(pTxt, lTxt, pTop, lTmp);
					}
					//	R[hϊ(SJIS -> UTF-8)
					else {
						lTmp = AjcMbcToUtf8Ex(pTxt, lTxt, NULL, 0);
						if ((pTop = AJCMEM(lTmp)) == NULL) break;
						AjcMbcToUtf8Ex(pTxt, lTxt, pTop, lTmp);
					}
					//	MeLXgGL[
					pTmp = pTop;
					while (lTmp > 0) {
						switch (pW->PortSel) {
							case AJCSCP_SEL_COMPORT:	len = __min(lTmp, AJCSCPMAX_TXSIZE_COMPORT );	break;
							case AJCSCP_SEL_MAILSLOT:	len = __min(lTmp, AJCSCPMAX_TXSIZE_MAILSLOT);	break;
							case AJCSCP_SEL_SOCKET:		len = __min(lTmp, AJCSCPMAX_TXSIZE_SOCKET  );	break;
						}
						if (!(rc = AjcVMbxEnque(pW->hVMbxTxD, pTmp, len))) break;
						pTmp += len;
						lTmp -= len;
					}
				} while (0);
				//	ϊobt@
				if (pTop != NULL) free(pTop);
			}
		} while(0);
		//	؂ւobt@
		if (pAlt != NULL) free(pAlt);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScpSendTextW		(HAJCSCP pW, C_WCP pTxt, UI lTxt)
{
	BOOL		rc	= FALSE;
	AJCMBCKIND	mbk = AJCMBC_SJIS;
	WCP			pAlt = NULL;

	if (IS_MY_INST(pW) && pTxt != NULL && AjcScpIsTxOpened(pW)) {
		rc = TRUE;
		do {
			//	\[XeLXgݒ
			lTxt = AjcStrAdjustLenW(pTxt, lTxt);
			if (lTxt == 0) break;
			//	O̔[[hƃeLXg𓮓Iobt@Ɋi[
			if (pW->SvSndW != 0) {
				if (pAlt = AjcTAllocW(1 + lTxt + 1)) {
					*pAlt = pW->SvSndW;
					wcsncpy(pAlt + 1, pTxt, lTxt);
					*(pAlt + (1 + lTxt)) = 0;
					//	eLXg|C^؂ւ
					pTxt = pAlt;
					lTxt++;
				}
				else {
					rc = FALSE;
				}
				pW->SvSndW = 0;
			}
			if (!rc) break;
			//	eLXg̖TQ[gP[hڂȂ΁AޔĖO
			if (MAjcIsLeadW(pTxt[lTxt - 1])) {
				pW->SvSndW = pTxt[lTxt - 1];
				lTxt--;
			}
			if (lTxt == 0) break;
			//	MeLXgR[hݒ
			switch (pW->TxTxtCode) {
				default:
				case AJCSCP_TXT_SJIS:	mbk = AJCMBC_SJIS;						break;	//	Vtgihr
				case AJCSCP_TXT_EUC:	mbk = AJCMBC_EUC;						break;	//	dtb
				case AJCSCP_TXT_UTF8:	mbk = AJCMBC_UTF8;						break;	//	tse|W
				case AJCSCP_TXT_AUTO:													//	
										switch (pW->RxTxtCode) {
											case AJCSCP_TXT_SJIS:	mbk = AJCMBC_SJIS;						break;
											case AJCSCP_TXT_EUC:	mbk = AJCMBC_EUC;						break;
											case AJCSCP_TXT_UTF8:	mbk = AJCMBC_UTF8;						break;
											case AJCSCP_TXT_AUTO:	mbk = AjcSsepGetLastMbcKind(pW->hSsep);	break;
										}
										break;
			}
			//	MR[hVtgihr
			if (mbk == AJCMBC_SJIS) {
				BCP		pTxd;
				UI		lTxd;
				C_BCP	p;
				UI		len;
				lTxd = WideCharToMultiByte(CP_ACP, 0, pTxt, lTxt, NULL, 0, NULL, NULL);
				if (pTxd = AjcTAllocA(lTxd)) {
					WideCharToMultiByte(CP_ACP, 0, pTxt, lTxt, pTxd, lTxd, NULL, NULL);
					//	MeLXgGL[
					p = pTxd;
					while (lTxd > 0) {
						switch (pW->PortSel) {
							case AJCSCP_SEL_COMPORT:	len = __min(lTxd, AJCSCPMAX_TXSIZE_COMPORT );	break;
							case AJCSCP_SEL_MAILSLOT:	len = __min(lTxd, AJCSCPMAX_TXSIZE_MAILSLOT);	break;
							case AJCSCP_SEL_SOCKET:		len = __min(lTxd, AJCSCPMAX_TXSIZE_SOCKET  );	break;
						}
						if (!(rc = AjcVMbxEnque(pW->hVMbxTxD, p, len))) break;
						p	 += len;
						lTxd -= len;
					}
					free(pTxd);
				}
			}
			//	MR[hdtb^tseW
			else {
				BCP			pTop = NULL;
				BCP			pTmp = NULL;
				UI			lTmp = 0;
				UI			len;
				do {
					//	R[hϊ(UNICODE -> EUC)
					if (mbk == AJCMBC_EUC) {
						BCP		pSJis;
						UI		lSJis;
						lSJis = WideCharToMultiByte(CP_ACP, 0, pTxt, lTxt, NULL, 0, NULL, NULL);
						if ((pSJis = AjcTAllocA(lSJis)) == NULL) break;
						WideCharToMultiByte(CP_ACP, 0, pTxt, lTxt, pSJis, lSJis, NULL, NULL);
						lTmp = AjcSJisToEucEx(pSJis, lSJis, NULL, 0);
						if ((pTop = AjcTAllocA(lTmp)) == NULL) {free(pSJis); break;}
						AjcSJisToEucEx(pSJis, lSJis, pTop, lTmp);
					}
					//	R[hϊ(UNICODE -> UTF-8)
					else {
						lTmp = WideCharToMultiByte(CP_UTF8, 0, pTxt, lTxt, NULL, 0, NULL, NULL);
						if ((pTop = AjcTAllocA(lTmp)) == NULL) break;
						WideCharToMultiByte(CP_UTF8, 0, pTxt, lTxt, pTop, lTmp, NULL, NULL);
					}
					//	MeLXgGL[
					pTmp = pTop;
					while (lTmp > 0) {
						switch (pW->PortSel) {
							case AJCSCP_SEL_COMPORT:	len = __min(lTmp, AJCSCPMAX_TXSIZE_COMPORT );	break;
							case AJCSCP_SEL_MAILSLOT:	len = __min(lTmp, AJCSCPMAX_TXSIZE_MAILSLOT);	break;
							case AJCSCP_SEL_SOCKET:		len = __min(lTmp, AJCSCPMAX_TXSIZE_SOCKET  );	break;
						}
						if (!(rc = AjcVMbxEnque(pW->hVMbxTxD, pTmp, len))) break;
						pTmp += len;
						lTmp -= len;
					}
					//	ϊobt@
					free(pTop);
				} while (0);
			}
		} while(0);
		//	؂ւobt@
		if (pAlt != NULL) free(pAlt);
	}
	return rc;
}
//==============================================================================================================//
//	eLXgf[^M																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pFmt		- eLXg																		//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI		AjcScpSendTextFA	(HAJCSCP pW, C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	BC		txt[2048];

	if (IS_MY_INST(pW) && pFmt != NULL && AjcScpIsTxOpened(pW)) {
		va_start(vls, pFmt);
		_vsnprintf(txt, 2048, pFmt, vls);
		txt[2047] = 0;
		va_end	(vls);
		rc = AjcScpSendTextA(pW, txt, -1);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI		AjcScpSendTextFW	(HAJCSCP pW, C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	WC		txt[2048];

	if (IS_MY_INST(pW) && pFmt != NULL && AjcScpIsTxOpened(pW)) {
		va_start(vls, pFmt);
		_vsnwprintf(txt, 2048, pFmt, vls);
		txt[2047] = 0;
		va_end	(vls);
		rc = AjcScpSendTextW(pW, txt, -1);
	}
	return rc;
}
//==============================================================================================================//
//	oCif[^M																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pDat		- MoCif[^̃AhX													//
//				lDat		- MoCif[^̃oCg													//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSendBinData	(HAJCSCP pW, C_VOP pDat, UI lDat)
{
	BOOL	rc = FALSE;
	C_UBP	p = (C_UBP)pDat;
	UI		len;

	if (IS_MY_INST(pW) && pDat != NULL && AjcScpIsTxOpened(pW)) {
		while (lDat > 0) {
			switch (pW->PortSel) {
				case AJCSCP_SEL_COMPORT:	len = __min(lDat, AJCSCPMAX_TXSIZE_COMPORT );	break;
				case AJCSCP_SEL_MAILSLOT:	len = __min(lDat, AJCSCPMAX_TXSIZE_MAILSLOT);	break;
				case AJCSCP_SEL_SOCKET:		len = __min(lDat, AJCSCPMAX_TXSIZE_SOCKET  );	break;
			}

			if (!(rc = AjcVMbxEnque(pW->hVMbxTxD, p, len))) break;

			p	 += len;
			lDat -= len;
		}
	}
	return rc;
}
//==============================================================================================================//
//	pPbgf[^M																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pPkt		- MpPbgf[^̃AhXipPbgMNUULłOK)					//
//				lPkt		- MpPbgf[^̃oCgipPbgM͂O)							//
//																												//
//	߂l	F	Sȏ	- OKiۂ̑MoCgj																//
//				O		- Error																					//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcScpSendPacket	(HAJCSCP pW, C_VOP pPkt, UI lPkt)
{
	UI			rc = 0;
	UBP			pImg;
	UI			lImg, len;
	UBP			p;

	if (IS_MY_INST(pW) && (pPkt != NULL || lPkt == 0) && AjcScpIsTxOpened(pW)) {
		if (pImg = (UBP)AjcSsepMakePacket(pW->hSsep, pPkt, lPkt, &lImg)) {
			rc = lImg;
			p = pImg;
			while (lImg > 0) {
				switch (pW->PortSel) {
					case AJCSCP_SEL_COMPORT:	len = __min(lImg, AJCSCPMAX_TXSIZE_COMPORT );	break;
					case AJCSCP_SEL_MAILSLOT:	len = __min(lImg, AJCSCPMAX_TXSIZE_MAILSLOT);	break;
					case AJCSCP_SEL_SOCKET:		len = __min(lImg, AJCSCPMAX_TXSIZE_SOCKET  );	break;
				}
				if (!AjcVMbxEnque(pW->hVMbxTxD, p, len)) {rc = 0; break;}
				p	 += len;
				lImg -= len;
			}
			AjcSsepRelease(pImg);
		}
	}
	return rc;
}
//==============================================================================================================//
//	u[NMo^~																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//				fBreak		- TRUE - oCFALSE - ~															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSendBreak		(HAJCSCP pW, BOOL fBreak)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pW->PortSel == AJCSCP_SEL_COMPORT) {
			if (fBreak) rc = ScpSetCommBreak(pW);
			else		rc = ScpClearCommBreak(pW);
		}
	}
	return rc;
}
//==============================================================================================================//
//	Cxg}XNݒ																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				Mask		- Cxg}XN																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetEvtMask	(HAJCSCP pW, UI Mask)
{
	UI		evt;

	if (IS_MY_INST(pW)) {
		pW->EvtMask = Mask;
		//----- Xg[Cxgݒ -------------------//
		evt = ScpEvtToSsepEvt(pW->EvtMask);
		AjcSsepSetEvent(pW->hSsep, evt);
	}
	return TRUE;
}
//==============================================================================================================//
//	Cxg}XN擾																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	Cxg}XN																					//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcScpGetEvtMask	(HAJCSCP pW)
{
	UI		rc =  0;

	if (IS_MY_INST(pW)) {
		rc = pW->EvtMask;
	}
	return rc;
}

//==============================================================================================================//
//	csqMݒ																								//
//																												//
//	@	F	pW			- CX^Xnh																//
//				fActive		- TRUE - DTR ON, FALSE - DTR OFF													//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetDTR		(HAJCSCP pW, BOOL fActive)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pW->PortSel == AJCSCP_SEL_COMPORT) {
			if (fActive) rc = ScpEscapeCommFunction(pW, SETDTR);
			else		 rc = ScpEscapeCommFunction(pW, CLRDTR);
		}
	}
	return rc;
}
//==============================================================================================================//
//	qsrMݒ																								//
//																												//
//	@	F	pW			- CX^Xnh																//
//				fActive		- TRUE - DTR ON, FALSE - DTR OFF													//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetRTS		(HAJCSCP pW, BOOL fActive)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pW->PortSel == AJCSCP_SEL_COMPORT) {
			if (fActive) rc = ScpEscapeCommFunction(pW, SETRTS);
			else		 rc = ScpEscapeCommFunction(pW, CLRRTS);
		}
	}
	return rc;
}
//==============================================================================================================//
//	MԎ擾																								//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	M																						//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcScpGetSigState	(HAJCSCP pW)
{
	UI		rc = 0;
	DWORD	mst;

	if (IS_MY_INST(pW)) {
		if (pW->PortSel == AJCSCP_SEL_COMPORT) {
			if (ScpGetCommModemStatus(pW, &mst)) {
				if (mst & MS_CTS_ON ) rc |= AJCSCP_CTS;
				if (mst & MS_DSR_ON ) rc |= AJCSCP_DSR;
				if (mst & MS_RING_ON) rc |= AJCSCP_RING;
				if (mst & MS_RLSD_ON) rc |= AJCSCP_RLSD;
			}
			else rc = 0;
		}
	}
	return rc;
}
//==============================================================================================================//
//	M҂f[^oCg擾																					//
//																												//
//	@	F	pW				- CX^Xnh															//
//																												//
//	߂l	F	M҂f[^oCg																			//
//==============================================================================================================//
AJCEXPORT	ULL		WINAPI	AjcScpGetTxBytes		(HAJCSCP pW)
{
	ULL		rc = 0;

	if (IS_MY_INST(pW)) {
		rc = AjcVMbxGetTotalBytes(pW->hVMbxTxD);
	}
	return rc;
}

//==============================================================================================================//
//	SMσf[^j																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpPurgeRecvData	(HAJCSCP pW)
{
	BOOL	rc = TRUE;

	if (IS_MY_INST(pW)) {
		if (pW->PortSel == AJCSCP_SEL_COMPORT) {
			rc = ScpPurgeComm(pW, PURGE_RXABORT | PURGE_RXCLEAR);
		}
		AjcFMbxPurge(pW->hFMbxNtc);
		pW->BpSeq = 0;
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	SM҂f[^j																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpPurgeSendData	(HAJCSCP pW)
{
	BOOL	rc = TRUE;

	if (IS_MY_INST(pW)) {
		if (pW->PortSel == AJCSCP_SEL_COMPORT) {
			rc = ScpPurgeComm(pW, PURGE_TXABORT | PURGE_TXCLEAR);
		}
		AjcVMbxPurge(pW->hVMbxTxD);
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	SMf[^j																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpPurgeAllData	(HAJCSCP pW)
{
	BOOL	rc = TRUE;

	if (IS_MY_INST(pW)) {
		if (pW->PortSel == AJCSCP_SEL_COMPORT) {
			rc = ScpPurgeComm(pW, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		}
		AjcVMbxPurge(pW->hVMbxTxD);
		AjcFMbxPurge(pW->hFMbxNtc);
		pW->BpSeq = 0;
	}
	else rc = FALSE;

	return rc;
}

//==============================================================================================================//
//	cbaƃ^CAEgݒ																			//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pDcb		- ݒ肷cbãAhX														//
//				pTmo		- ݒ肷^CAEg̃AhX												//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetParam(HAJCSCP pW, const DCB *pDcb, const COMMTIMEOUTS *pTmo)
{
	BOOL	rc = TRUE;

	if (IS_MY_INST(pW)) {
		if (pDcb != NULL) {
			memcpy(&pW->CommDcb, pDcb, sizeof(DCB));
			rc &= ScpSetCommState	(pW, &pW->CommDcb);
		}
		if (pTmo != NULL) {
			memcpy(&pW->CommTmo, pTmo, sizeof(COMMTIMEOUTS));
			rc &= ScpSetCommTimeouts(pW, &pW->CommTmo);
		}
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	cbaƃ^CAEg擾																			//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pDcb		- 擾cbai[obt@̃AhX		isv͂mtkkj		//
//				pTmo		- 擾^CAEgi[obt@̃AhX	isv͂mtkkj		//
//																												//
//	߂l	F	|[gԍ																						//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcScpGetParam(HAJCSCP pW, LPDCB pDcb, LPCOMMTIMEOUTS pTmo)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		if (pDcb != NULL) memcpy(pDcb, &pW->CommDcb, sizeof(DCB));
		if (pTmo != NULL) memcpy(pTmo, &pW->CommTmo, sizeof(COMMTIMEOUTS));
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:	pW->PortNo;	break;
			case AJCSCP_SEL_MAILSLOT:	rc = 256;	break;
			case AJCSCP_SEL_SOCKET:		rc = 257;	break;
		}
	}
	return rc;
}

//==============================================================================================================//
//	Cxg҂																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pwParam		- CxgR[hi[obt@̃AhX										//
//				plParam		- Cxgf[^i[obt@̃AhX									//
//				msTime		- Cxg҂[ms]															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - ^CAEg																			//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpWaitEvent		(HAJCSCP pW, WPARAM *pwParam, LPARAM *plParam, UI msTime)
{
	BOOL		rc = FALSE;
	PSCP_EVTINF		pEvtInf;

	if (IS_MY_INST(pW) && pwParam != NULL && plParam != NULL) {
		if (AjcFMbxDeque(pW->hFMbxNtc, &pEvtInf, msTime)) {
			if (pEvtInf != NULL) {
				*pwParam = pEvtInf->Evt;
				*plParam = (LPARAM)pEvtInf;
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Cxgf[^擾																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lParam		- Cxgf[^																//
//				ppDat		- Mf[^̃AhXi[obt@̃AhX									//
//				plDat		- Mf[^̃oCgi[obt@̃AhX									//
//				pParam		- p^i[obt@̃AhX											//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Cxgf[^Ȃ																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcScpGetEventData	(HAJCSCP pW, LPARAM lParam, VOP *ppDat, UIP plDat, UIP pParam)
{
	BOOL		rc = FALSE;
	PSCP_EVTINF		pEvtInf;

	if (IS_MY_INST(pW) && lParam != 0) {
		pEvtInf = (PSCP_EVTINF)lParam;
		if (ppDat  != NULL) *ppDat	= pEvtInf->pDat;
		if (plDat  != NULL) *plDat	= pEvtInf->lDat;
		if (pParam != NULL) *pParam = pEvtInf->param;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	Cxgf[^J																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				lParam		- Cxgf[^																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpRelEventData	(HAJCSCP pW, LPARAM lParam)
{
	BOOL		rc = FALSE;
	PSCP_EVTINF		pEvtInf;

	if (IS_MY_INST(pW) && lParam != 0) {
		pEvtInf = (PSCP_EVTINF)lParam;
		//	CxgiCxgf[^(pDat) AjcMain::AjcReleaseInstance() -> AjcSerialComPortSubFunc::cbReleaseEvtInf()oRŉj
		AjcReleaseInstance(pEvtInf);
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	pPbgt[Fׂ̐R[hݒ																//
//																												//
//	@	F	pW			- CX^Xnh																//
//				stx			- rswR[hl																	//
//				etx			- dswR[hl																	//
//				dle			- ckdR[hl																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetPktCtrlCode(HAJCSCP pW, UI stx, UI etx, UI dle)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (stx != 0) AjcSsepSetStx(pW->hSsep, stx);
		if (etx != 0) AjcSsepSetEtx(pW->hSsep, etx);
		if (dle != 0) AjcSsepSetDle(pW->hSsep, dle);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	pPbgt[Fׂ̐R[h擾																//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pStx		- rswR[hli[obt@̃AhXisv͂mtkkj					//
//				pEtx		- dswR[hli[obt@̃AhXisv͂mtkkj					//
//				pDle		- ckdR[hli[obt@̃AhXisv͂mtkkj					//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpGetPktCtrlCode(HAJCSCP pW, UIP pStx, UIP pEtx, UIP pDle)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pStx != NULL) *pStx= AjcSsepGetStx(pW->hSsep);
		if (pEtx != NULL) *pEtx= AjcSsepGetEtx(pW->hSsep);
		if (pDle != NULL) *pDle= AjcSsepGetDle(pW->hSsep);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	pPbgt[M^CAEglݒ																		//
//																												//
//	@	F	pW			- CX^Xnh																//
//				msTime		- ^CAEg[ms]																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetPktTimeout (HAJCSCP pW, UI msTime)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AjcSsepSetPktTimeOut(pW->hSsep, msTime);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	pPbgt[M^CAEgl擾																		//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pMsTime		- ^CAEg[ms]i[obt@̃AhXisv͂mtkkj				//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpGetPktTimeout (HAJCSCP pW, UIP pMsTime)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pMsTime != NULL) {
			*pMsTime = AjcSsepGetPktTimeOut(pW->hSsep);
		}
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	ʐMp^ݒ_CAOɂbnl|[g̑I^֎~												//
//																												//
//	@	F	pW				- CX^Xnh															//
//				fEnableComPort	- TRUE	: ʐMp^ݒ_CAOɂbnl|[g̑I				//
//								  FALSE : @@V@@@@@@@@@@@V@@@@@@@@I֎~				//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
static VO	SubSetPortSel(HAJCSCP pW)
{
	if ((pW->mskRbt & AJCSCPRBT_ComPort ) && pW->PortSel == AJCSCP_SEL_COMPORT ) pW->PortSel = AJCSCP_SEL_MAILSLOT;
	if ((pW->mskRbt & AJCSCPRBT_MailSlot) && pW->PortSel == AJCSCP_SEL_MAILSLOT) pW->PortSel = AJCSCP_SEL_SOCKET;
	if ((pW->mskRbt & AJCSCPRBT_Socket	) && pW->PortSel == AJCSCP_SEL_SOCKET  ) pW->PortSel = AJCSCP_SEL_COMPORT;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcScpEnableComPortSelection	(HAJCSCP pW, BOOL fEnableComPort)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (fEnableComPort) pW->mskRbt &= ~AJCSCPRBT_ComPort;
		else				pW->mskRbt |=  AJCSCPRBT_ComPort;
		SubSetPortSel(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	ʐMp^ݒ_CAOɂ郁[Xbg̑I^֎~												//
//																												//
//	@	F	pW			- CX^Xnh																//
//				fEnable		- TRUE	: ʐMp^ݒ_CAOɂ郁[Xbg̑I					//
//							  FALSE : @@V@@@@@@@@@@@V@@@@@@@@@I֎~					//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcScpEnableMailslotSelection	(HAJCSCP pW, BOOL fEnableMailSlot)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (fEnableMailSlot) pW->mskRbt &= ~AJCSCPRBT_MailSlot;
		else				 pW->mskRbt |=	AJCSCPRBT_MailSlot;
		SubSetPortSel(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	ʐMp^ݒ_CAOɂ\PbgʐM̑I^֎~												//
//																												//
//	@	F	pW			- CX^Xnh																//
//				fEnable		- TRUE	: ʐMp^ݒ_CAOɂ\PbgʐM̑I					//
//							  FALSE : @@V@@@@@@@@@@@V@@@@@@@@I֎~					//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcScpEnableSocketSelection	(HAJCSCP pW, BOOL fEnableSocket)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (fEnableSocket) pW->mskRbt &= ~AJCSCPRBT_Socket;
		else			   pW->mskRbt |=  AJCSCPRBT_Socket;
		SubSetPortSel(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	ʐMp^ݒ_CAOɂbnl|[gC[Xbg̑I^֎~								//
//																												//
//	@	F	pW				- CX^Xnh															//
//				fEnableComPort	- TRUE	: ʐMp^ݒ_CAOɂbnl|[ǵ@I				//
//							  	  FALSE : @@V@@@@@@@@@@@V@@@@@@@@@I֎~				//
//				fEnableMailSlot	- TRUE	: ʐMp^ݒ_CAOɂ郁[Xbg̑I				//
//							  	  FALSE : @@V@@@@@@@@@@@V@@@@@@@@@I֎~				//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcScpEnablePortSelection	(HAJCSCP pW, BOOL fEnableComPort, BOOL fEnableMailSlot)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AjcScpEnableComPortSelection (pW, fEnableComPort );
		AjcScpEnableMailslotSelection(pW, fEnableMailSlot);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	ʐMp^ݒ_CAOɂbnl|[gC[XbgC\PbgʐM̑I^֎~					//
//																												//
//	@	F	pW				- CX^Xnh															//
//				fEnableComPort	- TRUE	: ʐMp^ݒ_CAOɂbnl|[ǵ@I				//
//							  	  FALSE : @@V@@@@@@@@@@@V@@@@@@@@@I֎~				//
//				fEnableMailSlot	- TRUE	: ʐMp^ݒ_CAOɂ郁[Xbg̑I				//
//							  	  FALSE : @@V@@@@@@@@@@@V@@@@@@@@@I֎~				//
//				fEnableSocket	- TRUE	: ʐMp^ݒ_CAOɂ\PbgʐM@̑I				//
//							  	  FALSE : @@V@@@@@@@@@@@V@@@@@@@@@I֎~				//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcScpEnablePortSelectionEx	(HAJCSCP pW, BOOL fEnableComPort, BOOL fEnableMailSlot, BOOL fEnableSocket)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AjcScpEnableComPortSelection (pW, fEnableComPort );
		AjcScpEnableMailslotSelection(pW, fEnableMailSlot);
		AjcScpEnableSocketSelection  (pW, fEnableSocket  );
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	_CAOɂʐMp^ݒ																			//
//																												//
//	@	F	pW			- CX^Xnh																//
//				hWndOwner	- I[i[ECh̃nh														//
//				x, y		- _CAO\ʒuiXN[Wj												//
//																												//
//	߂l	F	ȉ̃rbg̑gݍ킹																		//
//					AJCSCPDGR_PORTCHANGED	- |[gύX														//
//					AJCSCPDGR_DCBCHANGED	- cbaύX														//
//					AJCSCPDGR_TMOCHANGED	- ^C}ύX														//
//					AJCSCPDGR_SELCHANGED	- bnl|[g^[Xbg̑IύX							//
//					AJCSCPDGR_SLOTCHANGED	- [XbgύX											//
//					AJCSCPDGR_OKBUTTON		- nj{^ɂI												//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcScpDlgParamEasy	(HAJCSCP pW, HWND hWndOwner)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		if (!(pW->mskRbt & AJCSCPRBT_ComPort) || !(pW->mskRbt & AJCSCPRBT_MailSlot) || !(pW->mskRbt & AJCSCPRBT_Socket)) {
			rc = SubDlgParamEasy(pW, hWndOwner, NULL);
		}
	}
	return rc;
}
//----- \ʒuw -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcScpDlgParamEasyEx(HAJCSCP pW, HWND hWndOwner, int x, int y)
{
	UI		rc = 0;
	POINT	pt;

	if (IS_MY_INST(pW)) {
		if (!(pW->mskRbt & AJCSCPRBT_ComPort) || !(pW->mskRbt & AJCSCPRBT_MailSlot) || !(pW->mskRbt & AJCSCPRBT_Socket)) {
			pt.x = x;
			pt.y = y;
			rc = SubDlgParamEasy(pW, hWndOwner, &pt);
		}
	}
	return rc;
}
//==============================================================================================================//
//	_CAOɂbnl|[gʐMp^ڍאݒ															//
//																												//
//	@	F	pW			- CX^Xnh																//
//				hWndOwner	- I[i[ECh̃nh														//
//				x, y		- _CAO\ʒuiXN[Wj												//
//																												//
//	߂l	F	ȉ̃rbg̑gݍ킹																		//
//					AJCSCPDGR_PORTCHANGED	- |[gύX														//
//					AJCSCPDGR_DCBCHANGED	- cbaύX														//
//					AJCSCPDGR_TMOCHANGED	- ^C}ύX														//
//					AJCSCPDGR_OKBUTTON		- nj{^ɂI												//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcScpDlgParamDetail(HAJCSCP pW, HWND hWndOwner)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		rc = SubDlgParamDetail(pW, hWndOwner, NULL);
	}
	return rc;
}
//----- \ʒuw -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcScpDlgParamDetailEx(HAJCSCP pW, HWND hWndOwner, int x, int y)
{
	UI		rc = 0;
	POINT	pt;

	if (IS_MY_INST(pW)) {
		pt.x = x;
		pt.y = y;
		rc = SubDlgParamDetail(pW, hWndOwner, &pt);
	}
	return rc;
}
//==============================================================================================================//
//	_CAÕO[ڐݒ																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				mskGray		- O[ڃ}XN																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetDialogGrayMask(HAJCSCP pW, UI mskGray)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->mskGray = mskGray;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	ftHgp^icbaƃ^CAEgj擾															//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pDcb		- ftHgcbali[obt@̃AhX									//
//				pTmo		- ftHg^CAEgi[obt@̃AhX							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcScpGetDefaultParam(LPDCB pDcb, LPCOMMTIMEOUTS pTmo)
{
	if (pDcb != NULL) {
		pDcb->DCBlength			= sizeof(DCB);
		pDcb->BaudRate			= 9600;
		pDcb->fBinary			= 1;
		pDcb->fParity			= 0;
		pDcb->fOutxCtsFlow		= 0;
		pDcb->fOutxDsrFlow		= 0;
		pDcb->fDtrControl		= 0;
		pDcb->fDsrSensitivity	= 0;
		pDcb->fTXContinueOnXoff = 0;
		pDcb->fOutX				= 0;
		pDcb->fInX				= 0;
		pDcb->fErrorChar		= 0;
		pDcb->fNull				= 0;
		pDcb->fRtsControl		= 0;
		pDcb->fAbortOnError		= 0;
		pDcb->XonLim			= 512;
		pDcb->XoffLim			= 1536;
		pDcb->ByteSize			= 8;
		pDcb->Parity			= 0;
		pDcb->StopBits			= 0;
		pDcb->XonChar			= 0x11;
		pDcb->XoffChar			= 0x13;
		pDcb->ErrorChar			= '?';
		pDcb->EofChar			= 0x1A;
		pDcb->EvtChar			= 0x03;
	}
	if (pTmo != NULL) {
		pTmo->ReadIntervalTimeout			= 0;
		pTmo->ReadTotalTimeoutMultiplier	= 0;
		pTmo->ReadTotalTimeoutConstant		= 30;
		pTmo->WriteTotalTimeoutMultiplier	= 0;
		pTmo->WriteTotalTimeoutConstant		= 0;
	}
}
//==============================================================================================================//
//	Function	:	rrdonh擾																		//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	Return		:	rrdonh																			//
//==============================================================================================================//
AJCEXPORT	HAJCSSEP	WINAPI	AjcScpGetSsepHandle(HAJCSCP pW)
{
	HAJCSSEP	rc = NULL;

	if (IS_MY_INST(pW)) {
		rc = pW->hSsep;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	bnl|[g̗																			//
//																												//
//	Argument	:	pMap		- 񋓌ʂi[obt@̃AhX											//
//					lMap		- 񋓌ʂi[obt@̃oCgiő񋓐j							//
//					CurrentPort - ɗ񋓂|[gԍiȌꍇ͖j									//
//																												//
//	Return		:	񋓂VA|[ǧ																//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcScpEnumSerialPorts(UBP pMap, UI lMap, UI CurrentPort)
{
	UI		rc = 0;
	HANDLE	hFile;
	HKEY	hKey;
	UI		ix, pno;
	UL		type, valsize, namesize, dmy;
	BCP		p;
	BC		name[256];
	BC		val [256];
	UB		map [256];

	if (pMap != NULL) {
		//----- }bv@NA[ -------------------------------------------------------------------------------//
		memset(map, FALSE, sizeof map);
		//----- ɗ񋓂|[gԍݒ ---------------------------------------------------------------------//
		pno = (CurrentPort & 255);
		if (pno != 0) {
			map[pno] = TRUE;
		}
		//----- WXg ---------------------------------------------------------------------------------//
		if (RegCreateKeyExA(HKEY_LOCAL_MACHINE,					//		L[CH
							"HARDWARE\\DEVICEMAP\\SERIALCOMM",	//		E	iTuL[j
							0,									//		E	iɂOj
							NULL,								//		E	iL[NXCTuL[̏ꍇ͕svj
							REG_OPTION_VOLATILE,				//		E	iVOLATILEwj
							KEY_READ,							//		E	iL[ANZXIvVj
							NULL,								//		E	iL[̃ZLeBj
							&hKey,								//		E	inhi[obt@̃AhXj
							&dmy) == ERROR_SUCCESS) {			//		E	iR[hi[obt@̃|C^j

			ix=0;
			valsize = sizeof val; namesize = sizeof name;
			while (RegEnumValueA(hKey, ix, name, &namesize, NULL, &type, (UBP)val, &valsize) == ERROR_SUCCESS) {
				if (type == REG_SZ) {
					if ((p = mbsistr(val, "COM")) != NULL) {
						pno = atoi(p + 3);
						if (pno >= 1 && pno <= 255) {
							map[pno] = TRUE;
						}
					}
				}
				ix++;
				valsize = sizeof val; namesize = sizeof name;
			}
			RegCloseKey(hKey);
		}
		//----- |[gI[vɂǉ -----------------------------------------------------------------------//
		for (pno=1,ix=0; pno<=255; pno++) {
			if (!map[pno]) {
				sprintf(name, "\\\\.\\COM%u", pno);
				if ((hFile = CreateFileA(name,
							GENERIC_WRITE | GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE) {
					CloseHandle(hFile);
					map[pno] = TRUE;
				}
			}
		}
		//----- 񋓌ʐݒ ---------------------------------------------------------------------------------------//
		for (pno = 1, ix = 0; pno <= 255 && ix < lMap; pno++) {
			if (map[pno]) {
				pMap[ix++] = (UB)pno;
				rc++;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	|[gpX̎擾																			//
//																												//
//	@		F	pW			- CX^Xnh															//
//																												//
//	Return		:	|[gpXւ̃|C^																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcScpGetPortPathNameA(HAJCSCP pW)
{
	BCP		rc = NULL;

	if (IS_MY_INST(pW)) {
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:		//	bnl|[g
				if (pW->PortNo <= 9) AjcSnPrintFA(pW->PortName.BStr, AJCTSIZE(pW->PortName.BStr), "COM%u"		, pW->PortNo);
				else				 AjcSnPrintFA(pW->PortName.BStr, AJCTSIZE(pW->PortName.BStr), "\\\\.\\COM%u", pW->PortNo);
				break;

			case AJCSCP_SEL_MAILSLOT:		//	[Xbg
				if (pW->SlotInfo.RmtHostName[0] == 0 || AjcStrSameAsAllChar(pW->SlotInfo.RmtHostName, ' ')) {
					AjcSnPrintFA(pW->PortName.BStr, AJCTSIZE(pW->PortName.BStr), "\\\\.\\mailslot\\%S", pW->SlotInfo.RmtSlotName);
				}
				else {
					AjcSnPrintFA(pW->PortName.BStr, AJCTSIZE(pW->PortName.BStr), "\\\\%S\\mailslot\\%S", pW->SlotInfo.RmtHostName,
																								 		 pW->SlotInfo.RmtSlotName);
				}
				break;

			case AJCSCP_SEL_SOCKET:			//	\Pbg
				AjcSnPrintFA(pW->PortName.BStr, AJCTSIZE(pW->PortName.BStr), "%S:%u", pW->SockInfo.ServName, pW->SockInfo.PortNo);
				break;
		}
		rc = pW->PortName.BStr;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcScpGetPortPathNameW(HAJCSCP pW)
{
	WCP		rc = NULL;

	if (IS_MY_INST(pW)) {
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:		//	bnl|[g
				if (pW->PortNo <= 9) AjcSnPrintFW(pW->PortName.WStr, AJCTSIZE(pW->PortName.WStr), L"COM%u"		  , pW->PortNo);
				else				 AjcSnPrintFW(pW->PortName.WStr, AJCTSIZE(pW->PortName.WStr), L"\\\\.\\COM%u", pW->PortNo);
				break;

			case AJCSCP_SEL_MAILSLOT:		//	[Xbg
				if (pW->SlotInfo.RmtHostName[0] == 0 || AjcStrSameAsAllChar(pW->SlotInfo.RmtHostName, ' ')) {
					AjcSnPrintFW(pW->PortName.WStr,  AJCTSIZE(pW->PortName.WStr), L"\\\\.\\mailslot\\%s", pW->SlotInfo.RmtSlotName);
				}
				else {
					AjcSnPrintFW(pW->PortName.WStr, AJCTSIZE(pW->PortName.WStr), L"\\\\%s\\mailslot\\%s", pW->SlotInfo.RmtHostName,
																								 	   pW->SlotInfo.RmtSlotName);
				}
				break;

			case AJCSCP_SEL_SOCKET:			//	\Pbg
				AjcSnPrintFW(pW->PortName.WStr, AJCTSIZE(pW->PortName.WStr), L"%s:%u", pW->SockInfo.ServName, pW->SockInfo.PortNo);
				break;
		}
		rc = pW->PortName.WStr;
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	|[g̎擾																				//
//																												//
//	@		F	pW			- CX^Xnh															//
//																												//
//	Return		:	|[gւ̃|C^																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcScpGetPortNameA(HAJCSCP pW)
{
	BCP		rc = NULL;

	if (IS_MY_INST(pW)) {
		pW->PortName.BStr[0] = 0;
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:		//	bnl|[g
				AjcSnPrintFA(pW->PortName.BStr, AJCTSIZE(pW->PortName.BStr), "COM%u", pW->PortNo);
				break;

			case AJCSCP_SEL_MAILSLOT:		//	[Xbg
				AjcSnPrintFA(pW->PortName.BStr, AJCTSIZE(pW->PortName.BStr), "mailslot\\%S", pW->SlotInfo.RmtSlotName);
				break;

			case AJCSCP_SEL_SOCKET:			//	\Pbg
				AjcSnPrintFA(pW->PortName.BStr, AJCTSIZE(pW->PortName.BStr), "%S:%u", pW->SockInfo.ServName, pW->SockInfo.PortNo);
				break;
		}
		rc = pW->PortName.BStr;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcScpGetPortNameW(HAJCSCP pW)
{
	WCP		rc = NULL;

	if (IS_MY_INST(pW)) {
		pW->PortName.WStr[0] = 0;
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:		//	bnl|[g
				AjcSnPrintFW(pW->PortName.WStr, AJCTSIZE(pW->PortName.WStr), L"COM%u", pW->PortNo);
				break;

			case AJCSCP_SEL_MAILSLOT:		//	[Xbg
				AjcSnPrintFW(pW->PortName.WStr, AJCTSIZE(pW->PortName.WStr), L"mailslot\\%s"	, pW->SlotInfo.RmtSlotName);
				break;

			case AJCSCP_SEL_SOCKET:			//	\Pbg
				AjcSnPrintFW(pW->PortName.WStr, AJCTSIZE(pW->PortName.WStr), L"%s:%u", pW->SockInfo.ServName, pW->SockInfo.PortNo);
				break;
		}
		rc = pW->PortName.WStr;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	|[g̃foCX̎擾																	//
//																												//
//	@		F	pPortName	- bnl|[g("COM1" ` "COM255")											//
//					pBuf		- foCXi[obt@̃AhX										//
//					lBuf		- foCXi[obt@̕											//
//																												//
//	Return		:	pBuf != NULL && lBuf != 0 : i[foCX̕										//
//					pBuf == NULL || lBuf == 0 : foCXi[̂ɕKvȃobt@̕iI[܂ށj//
//					0						  : Error															//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcScpGetPortDevNameA(C_BCP pPortName, BCP pBuf, UI lBuf)
{
	int				rc		 = 0;
	int				i;
	HDEVINFO		hDevInfo = NULL;
	SP_DEVINFO_DATA	DeviceInfoData = {sizeof(SP_DEVINFO_DATA)};
	BCP				pTmp	= NULL;
	UL				lTmp	= 0;
	HKEY			hKey	= (HKEY)INVALID_HANDLE_VALUE;
	UL				nlen;
	BC				name[32] = {0};

	if (pPortName != NULL) {
		do {
			if (!(hDevInfo = SetupDiGetClassDevs(&GUID_DEVINTERFACE_COMPORT, NULL, NULL, (DIGCF_PRESENT | DIGCF_DEVICEINTERFACE)))) break;

			if (pBuf != NULL && lBuf != 0) {
				for(i = 0; SetupDiEnumDeviceInfo(hDevInfo, i, &DeviceInfoData) && mbsicmp(pPortName, name) != 0; i++) {
					do {
						//	foCX̃obt@TCY擾
						lTmp = 0;
						SetupDiGetDeviceRegistryPropertyA(hDevInfo, &DeviceInfoData, SPDRP_DEVICEDESC, NULL, NULL, 0, &lTmp);
						if (lTmp != 0) {
							//	foCXobt@蓖
							if (pTmp = (BCP)AJCMEM(lTmp)) {
								BOOL			success;
								LONG			rsu;
								UL				typ = 0;
								//	foCX擾
								success = SetupDiGetDeviceRegistryPropertyA(hDevInfo, &DeviceInfoData, SPDRP_DEVICEDESC, NULL, (PBYTE)pTmp, lTmp, &lTmp);
								if (success != TRUE) break;
								//	WXgL[nh I[v
								hKey = SetupDiOpenDevRegKey(hDevInfo, &DeviceInfoData, DICS_FLAG_GLOBAL, 0, DIREG_DEV, KEY_QUERY_VALUE);
								if (hKey == INVALID_HANDLE_VALUE) break;
								//	WXgli|[gj擾
								nlen = sizeof(name);
								rsu = RegQueryValueExA(hKey,  "PortName", NULL, &typ, (LPBYTE)name, &nlen);
								if (rsu != ERROR_SUCCESS ) break;
								//	|[gvȂ΃foCXC߂lݒ
								if (mbsicmp(pPortName, name) == 0) {
									AjcSnPrintFA(pBuf, lBuf, "%s", pTmp);
									rc = (int)strlen(pBuf);
								}
							}
						}
					} while (0);

					if (pTmp != NULL				) {free(pTmp);			pTmp = NULL;				}
					if (hKey != INVALID_HANDLE_VALUE) {RegCloseKey(hKey);	hKey = INVALID_HANDLE_VALUE;}
				}
			}
			else {
				for(i = 0; SetupDiEnumDeviceInfo(hDevInfo, i, &DeviceInfoData) && mbsicmp(pPortName, name) != 0; i++) {
					do {
						LONG			rsu;
						DWORD			typ = 0;
						//	foCX̃obt@TCY擾
						rc = 0;
						SetupDiGetDeviceRegistryPropertyA(hDevInfo, &DeviceInfoData, SPDRP_DEVICEDESC, NULL, NULL, 0, (PDWORD)&rc);
						if (rc == 0) break;
						//	WXgL[nh I[v
						hKey = SetupDiOpenDevRegKey(hDevInfo, &DeviceInfoData, DICS_FLAG_GLOBAL, 0, DIREG_DEV, KEY_QUERY_VALUE);
						if (hKey == INVALID_HANDLE_VALUE) break;
						//	WXgli|[gj擾
						nlen = sizeof(name);
						rsu = RegQueryValueExA(hKey,  "PortName", NULL, &typ, (LPBYTE)name, &nlen);
						if (rsu != ERROR_SUCCESS ) break;
					} while (0);

					if (hKey != INVALID_HANDLE_VALUE) {RegCloseKey(hKey);	hKey = (HKEY)INVALID_HANDLE_VALUE;}
				}
			}
		} while(0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcScpGetPortDevNameW(C_WCP pPortName, WCP pBuf, UI lBuf)
{
	int				rc		 = 0;
	int				i;
	HDEVINFO		hDevInfo = NULL;
	SP_DEVINFO_DATA	DeviceInfoData = {sizeof(SP_DEVINFO_DATA)};
	WCP				pTmp	= NULL;
	UL				lTmp	= 0;
	HKEY			hKey	= (HKEY)INVALID_HANDLE_VALUE;
	UL				nlen;
	WC				name[32] = {0};

	if (pPortName != NULL) {
		do {
			if (!(hDevInfo = SetupDiGetClassDevs(&GUID_DEVINTERFACE_COMPORT, NULL, NULL, (DIGCF_PRESENT | DIGCF_DEVICEINTERFACE)))) break;

			if (pBuf != NULL && lBuf != 0) {
				for(i = 0; SetupDiEnumDeviceInfo(hDevInfo, i, &DeviceInfoData) && wcsicmp(pPortName, name) != 0; i++) {
					do {
						//	foCX̃obt@TCY擾
						lTmp = 0;
						SetupDiGetDeviceRegistryPropertyW(hDevInfo, &DeviceInfoData, SPDRP_DEVICEDESC, NULL, NULL, 0, &lTmp);
						if (lTmp != 0) {
							//	foCXobt@蓖
							if (pTmp = (WCP)AJCMEM(lTmp * 2)) {
								BOOL			success;
								LONG			rsu;
								DWORD			typ = 0;
								//	foCX擾
								success = SetupDiGetDeviceRegistryPropertyW(hDevInfo, &DeviceInfoData, SPDRP_DEVICEDESC, NULL, (PBYTE)pTmp, lTmp, &lTmp);
								if (success != TRUE) break;
								//	WXgL[nh I[v
								hKey = SetupDiOpenDevRegKey(hDevInfo, &DeviceInfoData, DICS_FLAG_GLOBAL, 0, DIREG_DEV, KEY_QUERY_VALUE);
								if (hKey == INVALID_HANDLE_VALUE) break;
								//	WXgli|[gj擾
								nlen = AJCTSIZE(name);
								rsu = RegQueryValueExW(hKey,  L"PortName", NULL, &typ, (PBYTE)name, (PDWORD)&nlen);
								if (rsu != ERROR_SUCCESS ) break;
								//	|[gvȂ΃foCXC߂lݒ
								if (wcsicmp(pPortName, name) == 0) {
									AjcSnPrintFW(pBuf, lBuf, L"%s", pTmp);
									rc = (int)wcslen(pBuf);
								}
							}
						}
					} while (0);

					if (pTmp != NULL				) {free(pTmp);			pTmp = NULL;				}
					if (hKey != INVALID_HANDLE_VALUE) {RegCloseKey(hKey);	hKey = INVALID_HANDLE_VALUE;}
				}
			}
			else {
				for(i = 0; SetupDiEnumDeviceInfo(hDevInfo, i, &DeviceInfoData) && wcsicmp(pPortName, name) != 0; i++) {
					do {
						LONG			rsu;
						DWORD			typ = 0;
						//	foCX̃obt@TCY擾
						rc = 0;
						SetupDiGetDeviceRegistryPropertyW(hDevInfo, &DeviceInfoData, SPDRP_DEVICEDESC, NULL, NULL, 0, (PDWORD)&rc);
						if (rc == 0) break;
						// oCgɒ
						rc /= 2;
						//	WXgL[nh I[v
						hKey = SetupDiOpenDevRegKey(hDevInfo, &DeviceInfoData, DICS_FLAG_GLOBAL, 0, DIREG_DEV, KEY_QUERY_VALUE);
						if (hKey == INVALID_HANDLE_VALUE) break;
						//	WXgli|[gj擾
						nlen = AJCTSIZE(name);
						rsu = RegQueryValueExW(hKey,  L"PortName", NULL, &typ, (LPBYTE)name, &nlen);
						if (rsu != ERROR_SUCCESS ) break;
					} while (0);

					if (hKey != INVALID_HANDLE_VALUE) {RegCloseKey(hKey);	hKey = (HKEY)INVALID_HANDLE_VALUE;}
				}
			}
		} while(0);
	}
	return rc;
}
//==============================================================================================================//
//	`Nf[^̎M[hieLXg^oCijݒ														//
//																												//
//	@	F	pW				- CX^Xnh															//
//				ChunkMode		- `Nf[^ʒm[h														//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcScpSetChunkMode		(HAJCSCP pW, AJCSCP_CHUNKMODE ChunkMode)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->ChunkMode = ChunkMode;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	`Nf[^̎M[hieLXg^oCij擾														//
//																												//
//	@	F	pW				- CX^Xnh															//
//																												//
//	߂l	F	`Nf[^ʒm[h																		//
//==============================================================================================================//
AJCEXPORT	AJCSCP_CHUNKMODE WINAPI	AjcScpGetChunkMode		(HAJCSCP pW)
{
	AJCSCP_CHUNKMODE	rc = 0;

	if (IS_MY_INST(pW)) {
		rc = pW->ChunkMode;
	}
	return rc;
}
//==============================================================================================================//
//	MGR[hʐݒ																					//
//																												//
//	@		F	pW				- CX^Xnh														//
//					code			- R[h															//
//																												//
//	߂l		F	TRUE  - OK																					//
//					FALSE - Error																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetRxTextCode(HAJCSCP pW, AJCSCP_TEXTCODE code)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		switch (code) {
			case AJCSCP_TXT_SJIS:				//	Vtgihr
			case AJCSCP_TXT_EUC:				//	dtb@@@
			case AJCSCP_TXT_UTF8:				//	tse|W@
			case AJCSCP_TXT_AUTO:				//	ʁ@@
				//	R[hobt@Zbg
				AjcMbcReset(pW->hSsep->hMbc);
				//	R[hʐݒ
				pW->RxTxtCode = code;
				rc = TRUE;
				break;

			default:
				rc = FALSE;
				break;
		}
	}
	return rc;
}
//==============================================================================================================//
//	MGR[hʎ擾																					//
//																												//
//	@		F	pW				- CX^Xnh														//
//																												//
//	߂l		F	R[hʁiAJCSCP_TXT_SJIS / EUC / UTF8 / AUTOj										//
//==============================================================================================================//
AJCEXPORT	AJCSCP_TEXTCODE	WINAPI	AjcScpGetRxTextCode(HAJCSCP pW)
{
	AJCSCP_TEXTCODE	rc = (AJCSCP_TEXTCODE)0;

	if (IS_MY_INST(pW)) {
		rc = pW->RxTxtCode;
	}
	return rc;
}
//==============================================================================================================//
//	ۂ̎MGR[hʎ擾																			//
//																												//
//	@		F	pW				- CX^Xnh														//
//																												//
//	߂l		F	R[hʁiAJCSCP_TXT_SJIS / EUC / UTF8j												//
//==============================================================================================================//
AJCEXPORT	AJCSCP_TEXTCODE	WINAPI	AjcScpGetActualRxTextCode(HAJCSCP pW)
{
	AJCSCP_TEXTCODE	rc = (AJCSCP_TEXTCODE)0;
	AJCMBCKIND		mbk;

	if (IS_MY_INST(pW)) {
		if ((rc = pW->RxTxtCode) == AJCSCP_TXT_AUTO) {
			mbk = AjcSsepGetMbcKind(pW->hSsep);
			switch (mbk) {
				case AJCMBC_SJIS:	rc = AJCSCP_TXT_SJIS;	break;
				case AJCMBC_EUC:	rc = AJCSCP_TXT_EUC	;	break;
				case AJCMBC_UTF8:	rc = AJCSCP_TXT_UTF8;	break;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	MGR[hʐݒ																					//
//																												//
//	@		F	pW				- CX^Xnh														//
//					code			- R[h															//
//																												//
//	߂l		F	TRUE  - OK																					//
//					FALSE - Error																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetTxTextCode(HAJCSCP pW, AJCSCP_TEXTCODE code)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		switch (code) {
			case AJCSCP_TXT_SJIS:				//	Vtgihr
			case AJCSCP_TXT_EUC:				//	dtb@@@
			case AJCSCP_TXT_UTF8:				//	tse|W@
			case AJCSCP_TXT_AUTO:				//	
				pW->TxTxtCode = code;
				rc = TRUE;
				break;

			default:
				rc = FALSE;
				break;
		}
	}
	return rc;
}
//==============================================================================================================//
//	MGR[hʎ擾																					//
//																												//
//	@		F	pW				- CX^Xnh														//
//																												//
//	߂l		F	R[hʁiAJCSCP_TXT_SJIS / EUC / UTF8 / AUTOj										//
//==============================================================================================================//
AJCEXPORT	AJCSCP_TEXTCODE	WINAPI	AjcScpGetTxTextCode(HAJCSCP pW)
{
	AJCSCP_TEXTCODE	rc = (AJCSCP_TEXTCODE)0;

	if (IS_MY_INST(pW)) {
		rc = pW->TxTxtCode;
	}
	return rc;
}
//==============================================================================================================//
//	ۂ̑MGR[hʎ擾																			//
//																												//
//	@		F	pW				- CX^Xnh														//
//																												//
//	߂l		F	R[hʁiAJCSCP_TXT_SJIS / EUC / UTF8j												//
//==============================================================================================================//
AJCEXPORT	AJCSCP_TEXTCODE	WINAPI	AjcScpGetActualTxTextCode(HAJCSCP pW)
{
	AJCSCP_TEXTCODE	rc = (AJCSCP_TEXTCODE)0;

	if (IS_MY_INST(pW)) {
		if ((rc = pW->TxTxtCode) == AJCSCP_TXT_AUTO) {
			rc = AjcScpGetActualRxTextCode(pW);
		}
	}
	return rc;
}
//==============================================================================================================//
//	[Xbg																						//
//																												//
//	@	F	pW				- CX^Xnh															//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpCreateMySlot(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	rc = AjcScpCreateMySlotEx(pW, 0, 0, NULL);

	return rc;
}
//==============================================================================================================//
//	[Xbgi[XbgIvVwj														//
//																												//
//	@	F	pW						- CX^Xnh													//
//				nMaxMessageSize			- ő僁bZOTCY													//
//				lReadTimeout			- ǂݏo^CAEg[ms]												//
//				lpSecurityAttributes	- ZLeBւ̃|C^											//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpCreateMySlotEx(HAJCSCP pW, UI nMaxMessageSize, UI lReadTimeout, LPSECURITY_ATTRIBUTES lpSecurityAttributes)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		//	̃[Xbgj
		if (pW->hSlot != NULL) {
			CloseHandle(pW->hSlot);
			pW->hSlot = NULL;
		}
		//	CreateMailSlot()̈ޔ
		pW->MaxMsgSize	= nMaxMessageSize;
		pW->ReadTimeout = lReadTimeout;
		//	ZLeBޔ
		ScpSaveSlot(pW, lpSecurityAttributes);
		//	[Xbg
		rc = ScpCreateMySlotAndNtcErr(pW);
	}
	return rc;
}
//==============================================================================================================//
//	[Xbg																						//
//																												//
//	@	F	pW				- CX^Xnh															//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpDeleteMySlot(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pW->hSlot != NULL) {
			CloseHandle(pW->hSlot);
			pW->hSlot = NULL;
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	[XbgԎ擾																				//
//																												//
//	@	F	pW				- CX^Xnh															//
//																												//
//	߂l	F	TRUE F[Xbg																	//
//				FALSEF[Xbg																	//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpMySlotIsCreated(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		rc = (pW->hSlot != NULL);
	}
	return rc;
}
//==============================================================================================================//
//	[Xbg̃pX擾																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pBuf		- XbgpXi[obt@̃AhX										//
//				lBuf		- XbgpXi[obt@̕										//
//																												//
//	߂l	F	XbgpXւ̃|C^																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcScpGetMySlotPathNameA(HAJCSCP pW)
{
	BCP		rc = NULL;

	if (IS_MY_INST(pW)) {
		AjcSnPrintFA(pW->PortName.BStr, AJCTSIZE(pW->PortName.BStr), "\\\\%S\\mailslot\\%S" , pW->SlotInfo.MyHostName, pW->SlotInfo.MySlotName);
		rc = pW->PortName.BStr;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcScpGetMySlotPathNameW(HAJCSCP pW)
{
	WCP		rc = NULL;

	if (IS_MY_INST(pW)) {
		AjcSnPrintFW(pW->PortName.WStr, AJCTSIZE(pW->PortName.WStr), L"\\\\%s\\mailslot\\%s", pW->SlotInfo.MyHostName, pW->SlotInfo.MySlotName);
		rc = pW->PortName.WStr;
	}
	return rc;
}
//==============================================================================================================//
//	Rs[^擾																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pBuf		- Rs[^i[obt@̃AhX										//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpGetMyComputerNameA(HAJCSCP pW, BC pBuf[AJCMAX_HOSTNAME_LENGTH])
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pBuf != NULL) {
		AjcWideCharToByteChar(pW->SlotInfo.MyHostName, pBuf, AJCMAX_HOSTNAME_LENGTH);
		rc = TRUE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpGetMyComputerNameW(HAJCSCP pW, WC pBuf[AJCMAX_HOSTNAME_LENGTH])
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pBuf != NULL) {
		AjcSnPrintF(pBuf, AJCMAX_HOSTNAME_LENGTH, L"%s", pW->SlotInfo.MyHostName);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	[Xbgݒ																					//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pMySlot		- Xbg̃AhX			iݒ莞NULLj								//
//				pRmtHost	- [gRs[^̃AhX	iݒ莞NULLj								//
//				pRmtSlot	- [gXbg̃AhX		iݒ莞NULLj								//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpSetMailSlotNamesA(HAJCSCP pW, C_BCP pMySlot, C_BCP pRmtHost, C_BCP pRmtSlot)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pMySlot  != NULL) AjcByteCharToWideChar(pMySlot , pW->SlotInfo.MySlotName , AJCTSIZE(pW->SlotInfo.MySlotName ));
		if (pRmtHost != NULL) AjcByteCharToWideChar(pRmtHost, pW->SlotInfo.RmtHostName, AJCTSIZE(pW->SlotInfo.RmtHostName));
		if (pRmtSlot != NULL) AjcByteCharToWideChar(pRmtSlot, pW->SlotInfo.RmtSlotName, AJCTSIZE(pW->SlotInfo.RmtSlotName));
		rc = TRUE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpSetMailSlotNamesW(HAJCSCP pW, C_WCP pMySlot, C_WCP pRmtHost, C_WCP pRmtSlot)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pMySlot  != NULL) AjcSnPrintF(pW->SlotInfo.MySlotName , AJCTSIZE(pW->SlotInfo.MySlotName ), pMySlot );
		if (pRmtHost != NULL) AjcSnPrintF(pW->SlotInfo.RmtHostName, AJCTSIZE(pW->SlotInfo.RmtHostName), pRmtHost);
		if (pRmtSlot != NULL) AjcSnPrintF(pW->SlotInfo.RmtSlotName, AJCTSIZE(pW->SlotInfo.RmtSlotName), pRmtSlot);
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	[Xbg擾																					//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pMySlot		- Xbg̃AhX			isvNULLj								//
//				pRmtHost	- [gRs[^̃AhX	isvNULLj								//
//				pRmtSlot	- [gXbg̃AhX		isvNULLj								//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpGetMailSlotNamesA(HAJCSCP pW, BC pMySlot[AJCMAX_SLOTNAME_LENGTH], BC pRmtHost[AJCMAX_HOSTNAME_LENGTH], BC pRmtSlot[AJCMAX_SLOTNAME_LENGTH])
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pMySlot  != NULL) AjcWideCharToByteChar(pW->SlotInfo.MySlotName , pMySlot , AJCMAX_SLOTNAME_LENGTH);
		if (pRmtHost != NULL) AjcWideCharToByteChar(pW->SlotInfo.RmtHostName, pRmtHost, AJCMAX_HOSTNAME_LENGTH);
		if (pRmtSlot != NULL) AjcWideCharToByteChar(pW->SlotInfo.RmtSlotName, pRmtSlot, AJCMAX_SLOTNAME_LENGTH);
		rc = TRUE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpGetMailSlotNamesW(HAJCSCP pW, WC pMySlot[AJCMAX_SLOTNAME_LENGTH], WC pRmtHost[AJCMAX_HOSTNAME_LENGTH], WC pRmtSlot[AJCMAX_SLOTNAME_LENGTH])
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pMySlot  != NULL) AjcSnPrintF(pMySlot , AJCMAX_SLOTNAME_LENGTH, L"%s", pW->SlotInfo.MySlotName );
		if (pRmtHost != NULL) AjcSnPrintF(pRmtHost, AJCMAX_HOSTNAME_LENGTH, L"%s", pW->SlotInfo.RmtHostName);
		if (pRmtSlot != NULL) AjcSnPrintF(pRmtSlot, AJCMAX_SLOTNAME_LENGTH, L"%s", pW->SlotInfo.RmtSlotName);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	[XbgMx̐ݒ																			//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				flag	- MxtOiTRUE:CFALSE:Ȃj									//
//				bps		- Mx[Kbytes / sec]															//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpSetTxSpeedLimit(HAJCSCP pW, BOOL flag, UI bps)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->fTxDelay	= flag;
		pW->TxDelayBPS	= bps * 1024;

		pW->SlotInfo.fTxDelay  = flag;
		pW->SlotInfo.TxDelayBPS= bps;

		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	[XbgMx̎擾																			//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				pBps	- Mx[Kbytes / sec] i[obt@̃AhX								//
//																												//
//	߂l	F	MxtOiTRUE:CFALSE:Ȃj											//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcScpGetTxSpeedLimit(HAJCSCP pW, UIP pBps)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pBps != NULL) {
			*pBps = pW->TxDelayBPS / 1024;
		}
		rc = pW->fTxDelay;
	}
	return rc;
}
//==============================================================================================================//
//	M~̔FԐݒ																						//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				msTime	- M~̔F[ms]	i|PFݒj											//
//																												//
//	߂l	F	ȎM~̔F[us]																	//
//==============================================================================================================//
AJCEXPORT	ULL			WINAPI		AjcScpSetRecognizeTxStopTime(HAJCSCP pW, UI msTime)
{
	ULL		rc = -1;

	if (IS_MY_INST(pW)) {
		rc = pW->MesTxTime;
		if (msTime != -1) {
			pW->MesTxTime = msTime;
		}
	}
	return rc;
}
//==============================================================================================================//
//	M~̔FԐݒ																						//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				msTime	- M~̔F[ms]	i|PFݒj											//
//																												//
//	߂l	F	O̎M~̔F[us]																	//
//==============================================================================================================//
AJCEXPORT	ULL			WINAPI		AjcScpSetRecognizeRxStopTime(HAJCSCP pW, UI msTime)
{
	ULL		rc = -1;

	if (IS_MY_INST(pW)) {
		rc = pW->MesRxTime;
		if (msTime != -1) {
			pW->MesRxTime = msTime;
		}
	}
	return rc;
}
//==============================================================================================================//
//	vt@C|[gp^ǂݏoiJj															//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				pSect	- vt@CZNViNULL̏ꍇ́ApW->ProfileSect)								//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpLoadParamFromProfileA(HAJCSCP pW, C_BCP pSect)
{
	BOOL	rc = FALSE;
	int		len;
	WCP		pTmp;

	if (IS_MY_INST(pW)) {
		if (pSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
			if (len != 0 && (pTmp = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
				LoadProfile(pW, pTmp);
				free(pTmp);
			}
		}
		else {
			LoadProfile(pW, NULL);
		}
		rc = TRUE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpLoadParamFromProfileW(HAJCSCP pW, C_WCP pSect)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		LoadProfile(pW, pSect);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	|[gp^vt@CɃZ[uiJj																//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				pSect	- vt@CZNViNULL̏ꍇ́ApW->ProfileSect)								//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpSaveParamToProfileA(HAJCSCP pW, C_BCP pSect)
{
	BOOL	rc = FALSE;
	int		len;
	WCP		pTmp;

	if (IS_MY_INST(pW)) {
		if (pSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
			if (len != 0 && (pTmp = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
				SaveProfile(pW, pTmp);
				free(pTmp);
			}
		}
		else {
			SaveProfile(pW, NULL);
		}
		rc = TRUE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcScpSaveParamToProfileW(HAJCSCP pW, C_WCP pSect)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		SaveProfile(pW, pSect);
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	S\[X																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubDeleteResource(HAJCSCP pW)
{
	UI		ix;
	HANDLE	hdls[3] = {NULL};

	if (pW != NULL) {
		//----- \PbgCxgʒmpCxgIuWFNgj -------------------------------------------------//
		if (pW->hEvtSock != NULL) {
			CloseHandle(pW->hEvtSock);
		}
		//----- [XbgN[Y ------------------------------------------------------------------------//
		if (pW->hSlot != NULL) {
			CloseHandle(pW->hSlot);
			pW->hSlot = NULL;
		}
		//----- ZLeB ---------------------------------------------------------------------------//
		if (pW->pSecAttr != NULL) {
			AJCFREE(pW->pSecAttr);
			pW->pSecAttr = NULL;
		}
		//----- |[gN[Y ---------------------------------------------------------------------------------//
		AjcScpClose(pW);
		//----- TuXbh~ -------------------------------------------------------------------------------//
		ix = 0;
		if (pW->hThreadTx  != NULL) hdls[ix++] = pW->hThreadTx;
		if (pW->hThreadRx  != NULL) hdls[ix++] = pW->hThreadRx;
		if (pW->hThreadObs != NULL) hdls[ix++] = pW->hThreadObs;
		pW->fThreadEnd = TRUE;
		if (ix != 0) WaitForMultipleObjects( ix, hdls, TRUE, 3000);
		//----- TuXbhj -------------------------------------------------------------------------------//
		if (pW->hThreadTx  != NULL) {CloseHandle(pW->hThreadTx ); pW->hThreadTx  = NULL;}
		if (pW->hThreadRx  != NULL) {CloseHandle(pW->hThreadRx ); pW->hThreadRx  = NULL;}
		if (pW->hThreadObs != NULL) {CloseHandle(pW->hThreadObs); pW->hThreadObs = NULL;}
		//----- oCgXg[IuWFNg -----------------------------------------------------------//
		if (pW->hSsep	 != NULL) {AjcSsepDelete(pW->hSsep);	pW->hSsep	 = NULL;}
		//----- [{bNXnh ---------------------------------------------------------------------//
		if (pW->hVMbxTxD != NULL) {AjcVMbxDelete(pW->hVMbxTxD); pW->hVMbxTxD = NULL;}
		if (pW->hFMbxNtc != NULL) {AjcFMbxDelete(pW->hFMbxNtc); pW->hFMbxNtc = NULL;}
		//----- NeBJZNVIuWFNg ---------------------------------------------------------//
		DeleteCriticalSection(&pW->CsCommApi);
		DeleteCriticalSection(&pW->CsTxDelay);
		//----- v^C} ---------------------------------------------------------------------------------//
		if (pW->hMesTxDelay	 != NULL) {AjcMesTimeDelete(pW->hMesTxDelay);	pW->hMesTxDelay  = NULL;}
		//----- CX^X[NJ -------------------------------------------------------------------------//
		AJCFREE(pW);
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	vt@Cǂݏo																						//
//																												//
//	@	F	pW				- CX^Xnh															//
//				pSect			- vt@CZNV														//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static VO	LoadProfile(HAJCSCP pW, C_WCP pSect)
{
	//	NULL̏ꍇAftHgZNVݒ
	if (pSect == NULL || *pSect == 0) {
		pSect = pW->ProfileSect;
	}

	if (pSect != NULL && *pSect != 0) {
		//----- bnl^XbgI -----------------------------------------------------------------------//
		pW->PortSel						= AjcGetProfileUInt(pSect, L"PortSel" , AJCSCP_SEL_COMPORT);
		//----- |[gԍ -------------------------------------------------------------------------------------//
		pW->PortNo						= AjcGetProfileUInt(pSect, L"PortNo" , 1);
		//----- cba -----------------------------------------------------------------------------------------//
		pW->CommDcb.DCBlength			= sizeof(DCB);
		pW->CommDcb.BaudRate			= AjcGetProfileUInt(pSect, L"BaudRate"			, pW->CommDcb.BaudRate			);
		pW->CommDcb.fBinary				= AjcGetProfileUInt(pSect, L"fBinary"			, pW->CommDcb.fBinary			);
		pW->CommDcb.fParity				= AjcGetProfileUInt(pSect, L"fParity"		   	, pW->CommDcb.fParity			);
		pW->CommDcb.fOutxCtsFlow		= AjcGetProfileUInt(pSect, L"fOutxCtsFlow"		, pW->CommDcb.fOutxCtsFlow		);
		pW->CommDcb.fOutxDsrFlow		= AjcGetProfileUInt(pSect, L"fOutxDsrFlow"		, pW->CommDcb.fOutxDsrFlow		);
		pW->CommDcb.fDtrControl			= AjcGetProfileUInt(pSect, L"fDtrControl"	   	, pW->CommDcb.fDtrControl		);
		pW->CommDcb.fDsrSensitivity		= AjcGetProfileUInt(pSect, L"fDsrSensitivity"	, pW->CommDcb.fDsrSensitivity	);
		pW->CommDcb.fTXContinueOnXoff	= AjcGetProfileUInt(pSect, L"fTXContinueOnXoff"	, pW->CommDcb.fTXContinueOnXoff	);
		pW->CommDcb.fOutX				= AjcGetProfileUInt(pSect, L"fOutX"				, pW->CommDcb.fOutX				);
		pW->CommDcb.fInX				= AjcGetProfileUInt(pSect, L"fInX"				, pW->CommDcb.fInX				);
		pW->CommDcb.fErrorChar			= AjcGetProfileUInt(pSect, L"fErrorChar"		, pW->CommDcb.fErrorChar		);
		pW->CommDcb.fNull			  	= AjcGetProfileUInt(pSect, L"fNull"				, pW->CommDcb.fNull			  	);
		pW->CommDcb.fRtsControl			= AjcGetProfileUInt(pSect, L"fRtsControl"		, pW->CommDcb.fRtsControl		);
		pW->CommDcb.fAbortOnError		= AjcGetProfileUInt(pSect, L"fAbortOnError"		, pW->CommDcb.fAbortOnError		);
		pW->CommDcb.XonLim				= AjcGetProfileUInt(pSect, L"XonLim"			, pW->CommDcb.XonLim			);
		pW->CommDcb.XoffLim				= AjcGetProfileUInt(pSect, L"XoffLim"			, pW->CommDcb.XoffLim			);
		pW->CommDcb.ByteSize			= AjcGetProfileUInt(pSect, L"ByteSize"			, pW->CommDcb.ByteSize			);
		pW->CommDcb.Parity				= AjcGetProfileUInt(pSect, L"Parity"			, pW->CommDcb.Parity			);
		pW->CommDcb.StopBits			= AjcGetProfileUInt(pSect, L"StopBits"			, pW->CommDcb.StopBits			);
		pW->CommDcb.XonChar				= AjcGetProfileUInt(pSect, L"XonChar"			, pW->CommDcb.XonChar			);
		pW->CommDcb.XoffChar			= AjcGetProfileUInt(pSect, L"XoffChar"			, pW->CommDcb.XoffChar			);
		pW->CommDcb.ErrorChar			= AjcGetProfileUInt(pSect, L"ErrorChar"			, pW->CommDcb.ErrorChar			);
		pW->CommDcb.EofChar				= AjcGetProfileUInt(pSect, L"EofChar"			, pW->CommDcb.EofChar			);
		pW->CommDcb.EvtChar				= AjcGetProfileUInt(pSect, L"EvtChar"			, pW->CommDcb.EvtChar			);
		//----- ^C} -------------------------------------------------------------------------------------//
		pW->CommTmo.ReadIntervalTimeout			= AjcGetProfileUInt(pSect, L"ReadIntervalTimeout"		 , pW->CommTmo.ReadIntervalTimeout		  );
		pW->CommTmo.ReadTotalTimeoutMultiplier	= AjcGetProfileUInt(pSect, L"ReadTotalTimeoutMultiplier" , pW->CommTmo.ReadTotalTimeoutMultiplier );
		pW->CommTmo.ReadTotalTimeoutConstant	= AjcGetProfileUInt(pSect, L"ReadTotalTimeoutConstant"	 , pW->CommTmo.ReadTotalTimeoutConstant	  );
		pW->CommTmo.WriteTotalTimeoutMultiplier	= AjcGetProfileUInt(pSect, L"WriteTotalTimeoutMultiplier", pW->CommTmo.WriteTotalTimeoutMultiplier);
		pW->CommTmo.WriteTotalTimeoutConstant	= AjcGetProfileUInt(pSect, L"WriteTotalTimeoutConstant"	 , pW->CommTmo.WriteTotalTimeoutConstant  );
		//----- [Xbg -----------------------------------------------------------------------------//
		AjcGetProfileStr (pSect, L"MySlotName" , pW->SlotInfo.MySlotName , pW->SlotInfo.MySlotName , AJCTSIZE(pW->SlotInfo.MySlotName ));
		AjcGetProfileStr (pSect, L"RmtHostName", pW->SlotInfo.RmtHostName, pW->SlotInfo.RmtHostName, AJCTSIZE(pW->SlotInfo.RmtHostName));
		AjcGetProfileStr (pSect, L"RmtSlotName", pW->SlotInfo.RmtSlotName, pW->SlotInfo.RmtSlotName, AJCTSIZE(pW->SlotInfo.RmtSlotName));
	//	if (pW->SlotInfo.MySlotName [0] == 0) strcpy(pW->SlotInfo.MySlotName , "MySlot");
	//	if (pW->SlotInfo.RmtSlotName[0] == 0) strcpy(pW->SlotInfo.RmtSlotName, "RmtSlot");
		pW->SlotInfo.fTxDelay			= AjcGetProfileUInt(pSect, L"fTxDelay"	, pW->SlotInfo.fTxDelay		);
		pW->SlotInfo.TxDelayBPS			= AjcGetProfileUInt(pSect, L"TxDelayBPS", pW->SlotInfo.TxDelayBPS	);
		//----- [XbgMx񏉊 -----------------------------------------------------------//
		pW->fTxDelay			 = pW->SlotInfo.fTxDelay;				//	MxtO
		pW->TxDelayBPS			 = pW->SlotInfo.TxDelayBPS * 1024;		//	Mx[Bytes / sec]
		pW->TxDelayBytesCount	 = 0;									//	MxpoCgJE^
		pW->TxDelayTickCount	 = 0;									//	MxpEoߎ[us]
		//----- \Pbg -----------------------------------------------------------------------------------//
		AjcGetProfileStr (pSect, L"SockServName" , pW->SockInfo.ServName, pW->SockInfo.ServName , AJCTSIZE(pW->SockInfo.ServName));
		pW->SockInfo.PortNo = (UW)AjcGetProfileUInt(pSect, L"SockPortNo", pW->SockInfo.PortNo);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	vt@C																						//
//																												//
//	@	F	pW				- CX^Xnh															//
//				pSect			- vt@CZNV														//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static VO	SaveProfile(HAJCSCP pW, C_WCP pSect)
{
	//	NULL̏ꍇAftHgZNVݒ
	if (pSect == NULL || *pSect == 0) {
		pSect = pW->ProfileSect;
	}

	//	
	if (pSect != NULL && *pSect != 0) {
		//----- bnl^XbgI -----------------------------------------------------------------------//
		AjcPutProfileUInt(pSect, L"PortSel"			, pW->PortSel					);
		//----- |[gԍ -------------------------------------------------------------------------------------//
		AjcPutProfileUInt(pSect, L"PortNo"			, pW->PortNo					);
		//----- cba -----------------------------------------------------------------------------------------//
		AjcPutProfileUInt(pSect, L"BaudRate"		 , pW->CommDcb.BaudRate			);
		AjcPutProfileUInt(pSect, L"fBinary"		   	 , pW->CommDcb.fBinary			);
		AjcPutProfileUInt(pSect, L"fParity"		   	 , pW->CommDcb.fParity			);
		AjcPutProfileUInt(pSect, L"fOutxCtsFlow"	 , pW->CommDcb.fOutxCtsFlow		);
		AjcPutProfileUInt(pSect, L"fOutxDsrFlow"	 , pW->CommDcb.fOutxDsrFlow		);
		AjcPutProfileUInt(pSect, L"fDtrControl"	   	 , pW->CommDcb.fDtrControl		);
		AjcPutProfileUInt(pSect, L"fDsrSensitivity"	 , pW->CommDcb.fDsrSensitivity	);
		AjcPutProfileUInt(pSect, L"fTXContinueOnXoff", pW->CommDcb.fTXContinueOnXoff);
		AjcPutProfileUInt(pSect, L"fOutX"			 , pW->CommDcb.fOutX			);
		AjcPutProfileUInt(pSect, L"fInX"			 , pW->CommDcb.fInX				);
		AjcPutProfileUInt(pSect, L"fErrorChar"	   	 , pW->CommDcb.fErrorChar		);
		AjcPutProfileUInt(pSect, L"fNull"			 , pW->CommDcb.fNull			);
		AjcPutProfileUInt(pSect, L"fRtsControl"	   	 , pW->CommDcb.fRtsControl		);
		AjcPutProfileUInt(pSect, L"fAbortOnError"	 , pW->CommDcb.fAbortOnError	);
		AjcPutProfileUInt(pSect, L"XonLim"			 , pW->CommDcb.XonLim			);
		AjcPutProfileUInt(pSect, L"XoffLim"		   	 , pW->CommDcb.XoffLim			);
		AjcPutProfileUInt(pSect, L"ByteSize"		 , pW->CommDcb.ByteSize			);
		AjcPutProfileUInt(pSect, L"Parity"		   	 , pW->CommDcb.Parity			);
		AjcPutProfileUInt(pSect, L"StopBits"		 , pW->CommDcb.StopBits			);
		AjcPutProfileUInt(pSect, L"XonChar"		   	 , pW->CommDcb.XonChar			);
		AjcPutProfileUInt(pSect, L"XoffChar"		 , pW->CommDcb.XoffChar			);
		AjcPutProfileUInt(pSect, L"ErrorChar"		 , pW->CommDcb.ErrorChar		);
		AjcPutProfileUInt(pSect, L"EofChar"		   	 , pW->CommDcb.EofChar			);
		AjcPutProfileUInt(pSect, L"EvtChar"		   	 , pW->CommDcb.EvtChar			);
		//----- ^C} -------------------------------------------------------------------------------------//
		AjcPutProfileUInt(pSect, L"ReadIntervalTimeout"		 	, pW->CommTmo.ReadIntervalTimeout			);
		AjcPutProfileUInt(pSect, L"ReadTotalTimeoutMultiplier"	, pW->CommTmo.ReadTotalTimeoutMultiplier	);
		AjcPutProfileUInt(pSect, L"ReadTotalTimeoutConstant"	, pW->CommTmo.ReadTotalTimeoutConstant		);
		AjcPutProfileUInt(pSect, L"WriteTotalTimeoutMultiplier"	, pW->CommTmo.WriteTotalTimeoutMultiplier	);
		AjcPutProfileUInt(pSect, L"WriteTotalTimeoutConstant"	, pW->CommTmo.WriteTotalTimeoutConstant		);
		//----- [Xbg -----------------------------------------------------------------------------//
		AjcPutProfileStr (pSect, L"MySlotName" 		, pW->SlotInfo.MySlotName	);
		AjcPutProfileStr (pSect, L"RmtHostName"		, pW->SlotInfo.RmtHostName	);
		AjcPutProfileStr (pSect, L"RmtSlotName"		, pW->SlotInfo.RmtSlotName	);
		AjcPutProfileUInt(pSect, L"fTxDelay"		, pW->SlotInfo.fTxDelay		);
		AjcPutProfileUInt(pSect, L"TxDelayBPS"		, pW->SlotInfo.TxDelayBPS	);
		//----- \Pbg -----------------------------------------------------------------------------------//
		AjcPutProfileStr (pSect, L"SockServName", pW->SockInfo.ServName);
		AjcPutProfileUInt(pSect, L"SockPortNo"	, pW->SockInfo.PortNo  );
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	_CAOɂʐMp^ݒiȈՁj																	//
//																												//
//	@	F	pW			- CX^Xnh																//
//				hWndOwner	- I[i[ECh̃nh														//
//				pPt			- \ʒuiXN[Wj													//
//																												//
//	߂l	F	ȉ̃rbg̑gݍ킹																		//
//					AJCSCPDGR_SELCHANGED	- \[XIύX													//
//					AJCSCPDGR_PORTCHANGED	- bnl|[gύX													//
//					AJCSCPDGR_DCBCHANGED	- cbaύX														//
//					AJCSCPDGR_TMOCHANGED	- ^C}ύX														//
//					AJCSCPDGR_SELCHANGED	- bnl|[g^[Xbg̑IύX							//
//					AJCSCPDGR_SLOTCHANGED	- [XbgύX											//
//					AJCSCPDGR_SOCKCHANGED	- \PbgύX													//
//					AJCSCPDGR_OKBUTTON		- nj{^ɂI												//
//--------------------------------------------------------------------------------------------------------------//
static	UI		SubDlgParamEasy	(HAJCSCP pW, HWND hWndOwner, LPPOINT pPt)
{
	UI				rc = 0;
	AJCSCP_PORTSEL	sel;
	UI				port;
	DCB				dcb;
	BOOL			fToDetail	= FALSE;
	BOOL			fNeedReOpen = FALSE;
	AJCSCP_SLOTINFO	slot;
	AJCSCP_SOCKINFO	sock;

	//	\[XIݒi_CAOݒpj
	sel = pW->PortSel;

	//	bnl|[gݒi_CAOݒpj
	port = pW->PortNo;
	memcpy(&dcb, &pW->CommDcb, sizeof(DCB));

	//	[Xbg,\Pbgݒi_CAOpj
	memcpy(&slot, &pW->SlotInfo, sizeof pW->SlotInfo);
	memcpy(&sock, &pW->SockInfo, sizeof pW->SockInfo);

	//	_CAOɂ|[gݒ
	rc = AjcScpDlgSetParamEasy(hWndOwner, pW, &sel, &port, &dcb, &fToDetail, &slot, &sock, pW->ProfileSect, pW->mskRbt, pW->mskGray, pPt);

	//	nj{^̏
	if (rc & AJCSCPDGR_OKBUTTON) {													//	nj{^H
		//	|[gI[vԂ̏ꍇAuăI[vvvtOݒ
		if (pW->PortSel != AJCSCP_SEL_MAILSLOT) {
			if (pW->hPort != NULL ) fNeedReOpen = TRUE;
		}
		else {
			if (pW->fTxSlotOpened ) fNeedReOpen = TRUE;
		}

		//	ʐM\[XύXꂽꍇA\[X̑IύXꂽ|AtOݒ
		if (sel != pW->PortSel) rc |= AJCSCPDGR_SELCHANGED;

		//	VɑIꂽ\[XɂAe\[Xݒ菈
		switch (sel) {
			//	bnl|[gI
			case AJCSCP_SEL_COMPORT:
				//	\[XIύX^|[gԍύXH
				if		(rc & (AJCSCPDGR_SELCHANGED | AJCSCPDGR_PORTCHANGED)) {
					//	\[XIÕ|[gN[Y
					if (fNeedReOpen) AjcScpClose(pW);
					//	bnl|[gݒlXV
					pW->PortNo = port;
					memcpy(&pW->CommDcb, &dcb, sizeof(DCB));
					//	\[XIXV
					pW->PortSel = sel;
					//	bnl|[găI[v
					if (fNeedReOpen) AjcScpOpenDefault(pW);
				}
				//	cbaύXH
				else if (rc & AJCSCPDGR_DCBCHANGED ) {
					//	\[XIÕ|[gN[Y
					if (fNeedReOpen) AjcScpClose(pW);
					//	cbaXV
					memcpy(&pW->CommDcb, &dcb, sizeof(DCB));
					//	bnl|[găI[v
					if (fNeedReOpen) AjcScpOpenDefault(pW);
				}
				break;

			//	[XbgI
			case AJCSCP_SEL_MAILSLOT:
				//	\[XIύX^[XbgݒeύXH
				if ((rc & AJCSCPDGR_SELCHANGED) || memcmp(&slot, &pW->SlotInfo, sizeof pW->SlotInfo) != 0) {
					//	\[XIÕ|[gN[Y
					if (fNeedReOpen) AjcScpClose(pW);
					//	[XbgXV
					memcpy(&pW->SlotInfo, &slot, sizeof pW->SlotInfo);
					pW->fTxDelay	= pW->SlotInfo.fTxDelay;
					pW->TxDelayBPS	= pW->SlotInfo.TxDelayBPS * 1024;
					//	ʐM\[XIXV
					pW->PortSel = sel;
					//	[XbgĐ
					if (pW->hSlot != NULL) ScpCreateMySlotAndNtcErr(pW);
					//	[XbgăI[v
					if (fNeedReOpen) AjcScpOpenDefault(pW);
				}
				break;

			//	\PbgI
			case AJCSCP_SEL_SOCKET:
				//	\[XIύX^\PbgݒeύXH
				if ((rc & AJCSCPDGR_SELCHANGED) || memcmp(&sock, &pW->SockInfo, sizeof pW->SockInfo) != 0) {
					//	\[XIÕ|[gN[Y
					if (fNeedReOpen) AjcScpClose(pW);
					//	ʐM\[XIXV
					pW->PortSel = sel;
					//	\PbgXV
					memcpy(&pW->SockInfo, &sock, sizeof pW->SockInfo);
					//	\PbgăI[v
					if (fNeedReOpen) AjcScpOpenDefault(pW);	
				}
				break;
		}
		//	\[XIݒ
		pW->PortSel = sel;

		//	\[XύXʒm
		if (rc & (AJCSCPDGR_SELCHANGED | AJCSCPDGR_PORTCHANGED | AJCSCPDGR_SLOTCHANGED | AJCSCPDGR_SOCKCHANGED)) {
			ScpNtcPortStateToUser(pW, AJCSCP_PORTNO);
		}
	}
	//	LZ^ڍאݒ{^̏
	else {																			//	LZ^ڍאݒ{^H
		if (fToDetail) {															//		ڍאݒ{^
			rc = SubDlgParamDetail(pW, hWndOwner, pPt);								//			ڍאݒ_CAO
		}
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	_CAOɂʐMp^ݒiڍׁj																	//
//																												//
//	@	F	pW			- CX^Xnh																//
//				hWndOwner	- I[i[ECh̃nh														//
//				pPt			- \ʒuiXN[Wj													//
//																												//
//	߂l	F	ȉ̃rbg̑gݍ킹																		//
//					AJCSCPDGR_SELCHANGED	- \[XIύX													//
//					AJCSCPDGR_PORTCHANGED	- |[gύX														//
//					AJCSCPDGR_DCBCHANGED	- cbaύX														//
//					AJCSCPDGR_TMOCHANGED	- ^C}ύX														//
//					AJCSCPDGR_OKBUTTON		- nj{^ɂI												//
//--------------------------------------------------------------------------------------------------------------//
static	UI	SubDlgParamDetail(HAJCSCP pW, HWND hWndOwner, LPPOINT pPt)
{
	BOOL			rc = 0;
	AJCSCP_PORTSEL	sel;
	UI				port;
	DCB				dcb;
	COMMTIMEOUTS	tmo;
	BOOL			fNeedReOpen = FALSE;

	//	\[XIޔ
	sel = pW->PortSel;

	//	bnl|[gݒi_CAOݒpj
	port = pW->PortNo;
	memcpy(&dcb, &pW->CommDcb, sizeof(DCB));
	memcpy(&tmo, &pW->CommTmo, sizeof(COMMTIMEOUTS));

	//	_CAOɂ|[gݒ
	rc = AjcScpDlgSetParamDetail(hWndOwner, &port, &dcb, &tmo, SCP_SYSRXBUFSIZE, pW->mskGray, pPt);

	//	nj{^H
	if (rc & AJCSCPDGR_OKBUTTON) {

		//	|[gI[vԂ̏ꍇAuăI[vvvtOݒ
		if (pW->PortSel != AJCSCP_SEL_MAILSLOT) {
			if (pW->hPort != NULL ) fNeedReOpen = TRUE;
		}
		else {
			if (pW->fTxSlotOpened ) fNeedReOpen = TRUE;
		}

		//	ʐM\[XύXꂽꍇA\[X̑IύXꂽ|AtOݒ
		if (sel != AJCSCP_SEL_COMPORT) rc |= AJCSCPDGR_SELCHANGED;

		//	\[XIύX^|[gԍύXH
		if (rc & (AJCSCPDGR_SELCHANGED | AJCSCPDGR_PORTCHANGED)) {
			//	\[XIÕ|[gN[Y
			if (fNeedReOpen) AjcScpClose(pW);
			//	bnl|[gݒ
			pW->PortNo = port;
			memcpy(&pW->CommDcb, &dcb, sizeof(DCB));
			memcpy(&pW->CommTmo, &tmo, sizeof(COMMTIMEOUTS));
			//	\[XI = bnl|[g
			pW->PortSel = AJCSCP_SEL_COMPORT;
			//	bnl|[găI[v
			if (fNeedReOpen) AjcScpOpenDefault(pW);
			//	|[gԍωʒm
			ScpNtcPortStateToUser(pW, AJCSCP_PORTNO);
		}
		//	cba^slnύXH
		else if (rc & (AJCSCPDGR_DCBCHANGED | AJCSCPDGR_TMOCHANGED)) {
			//	\[XIÕ|[gN[Y
			if (fNeedReOpen) AjcScpClose(pW);
			//	cba^slnXV
			memcpy(&pW->CommDcb, &dcb, sizeof(DCB));
			memcpy(&pW->CommTmo, &tmo, sizeof(COMMTIMEOUTS));
			//	\[XI = bnl|[g
			pW->PortSel = AJCSCP_SEL_COMPORT;
			//	bnl|[găI[v
			if (fNeedReOpen) AjcScpOpenDefault(pW);
		}
	}

	return rc;
}
