#include	"AjcInternal.h"
#include	"AjcSerialComPortDef.h"
//**************************************************************************************************************//
//																												//
//	bnl|[go								VXe`oh̃bp[									//
//																												//
//**************************************************************************************************************//

//
//																											
//|[go͂`oh̃bp[																				
//																											
//
//----- [XbgMݒ ------------------------------------------------------------------------------//
BOOL			ScpGetMailslotInfo(HAJCSCP pW, LPDWORD lpMaxMessageSize, LPDWORD lpNextSize, LPDWORD lpMessageCount, LPDWORD lpReadTimeout)
{
	BOOL	rc = FALSE;
	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hSlot != NULL) {
		rc = GetMailslotInfo(pW->hSlot, lpMaxMessageSize, lpNextSize, lpMessageCount, lpReadTimeout);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL			ScpClearCommBreak		(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = ClearCommBreak(pW->hPort);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpClearCommError		(HAJCSCP pW, LPDWORD lpErrors, LPCOMSTAT lpStat)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = ClearCommError(pW->hPort, lpErrors, lpStat);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpEscapeCommFunction	(HAJCSCP pW, DWORD dwFunc)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = EscapeCommFunction(pW->hPort, dwFunc);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpGetCommModemStatus	(HAJCSCP pW, LPDWORD lpModemStat)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = GetCommModemStatus(pW->hPort, lpModemStat);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpGetCommState			(HAJCSCP pW, LPDCB lpDCB)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = GetCommState(pW->hPort, lpDCB);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpGetCommTimeouts		(HAJCSCP pW, LPCOMMTIMEOUTS lpCommTimeouts)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = GetCommTimeouts(pW->hPort, lpCommTimeouts);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpPurgeComm				(HAJCSCP pW, DWORD dwFlags)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = PurgeComm(pW->hPort, dwFlags);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpSetCommBreak			(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = SetCommBreak(pW->hPort);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpSetCommMask			(HAJCSCP pW, DWORD dwMask)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = SetCommMask(pW->hPort, dwMask);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpSetCommState			(HAJCSCP pW, LPDCB lpDCB)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = SetCommState(pW->hPort, lpDCB);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpSetCommTimeouts		(HAJCSCP pW, LPCOMMTIMEOUTS lpCommTimeouts)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = SetCommTimeouts(pW->hPort, lpCommTimeouts);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpSetupComm				(HAJCSCP pW, DWORD dwInQUeue, DWORD dwOutQueue)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = SetupComm(pW->hPort, dwInQUeue, dwOutQueue);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpWaitCommEvent			(HAJCSCP pW, LPDWORD lpEvtMask, LPOVERLAPPED lpOverlapped)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	if (pW->hPort != NULL) {
		rc = WaitCommEvent(pW->hPort, lpEvtMask, lpOverlapped);
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
HANDLE			ScpOpenFile(HAJCSCP pW)
{
	HANDLE		rc = NULL;
	WC			PortName[MAX_PATH];

	EnterCriticalSection(&pW->CsCommApi);
	switch (pW->PortSel) {
		case AJCSCP_SEL_COMPORT:		//	bnl|[g
			AjcSnPrintF(PortName, AJCTSIZE(PortName), L"\\\\.\\COM%u"		, pW->PortNo	);
			rc = CreateFile(PortName, GENERIC_WRITE | GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			break;

		case AJCSCP_SEL_MAILSLOT:		//	[Xbg
			if (pW->SlotInfo.RmtHostName[0] == 0 || AjcStrSameAsAllChar(pW->SlotInfo.RmtHostName, L' ')) 
				AjcSnPrintF(PortName, AJCTSIZE(PortName), L"\\\\.\\mailslot\\%s" ,							 pW->SlotInfo.RmtSlotName);
			else
				AjcSnPrintF(PortName, AJCTSIZE(PortName), L"\\\\%s\\mailslot\\%s", pW->SlotInfo.RmtHostName, pW->SlotInfo.RmtSlotName);

			rc = CreateFile(PortName, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			break;

		case AJCSCP_SEL_SOCKET:			//	\Pbg
		{	ADDRINFOW	hints;
			ADDRINFOW	*pAI = NULL;
			UI			rsu;
			WC			szPort[AJCMAX_PORTNAME_LENGTH + 1];
			//	\Pbgڑ
			AjcSnPrintF(szPort, AJCTSIZE(szPort), L"%u", pW->SockInfo.PortNo);
			memset(&hints, 0, sizeof hints);
			hints.ai_socktype = SOCK_STREAM;
			hints.ai_family   = PF_UNSPEC;
			if (GetAddrInfoW(pW->SockInfo.ServName, szPort, NULL, &pAI) == 0 && pAI != NULL) {
				pW->hPort = (HANDLE)socket(pAI->ai_family, SOCK_STREAM, 0);
				if ((SOCKET)pW->hPort != INVALID_SOCKET) {
					WSAEventSelect((SOCKET)pW->hPort, pW->hEvtSock, FD_CONNECT | FD_WRITE | FD_READ | FD_CLOSE);
					//	ڑ
					rsu = connect((SOCKET)pW->hPort, pAI->ai_addr, (int)pAI->ai_addrlen);
					//	connectȂ΁A߂l\Pbgnh
					if (rsu != SOCKET_ERROR || WSAGetLastError() == WSAEWOULDBLOCK) {
						rc = pW->hPort;
					}
					//	connectsȂ΁A\PbgNULLԂ
					else {
						closesocket((SOCKET)pW->hPort);
						rc = (HANDLE)INVALID_SOCKET;
					}
				}
				FreeAddrInfoW(pAI);
			}
			break;
		}
	}

	if (rc != INVALID_HANDLE_VALUE) {	// INVALID_HANDLE_VALUE  INVALID_SOCKET͓l( -1 )
		pW->hPort = rc;
	}
	else {
		pW->hPort = NULL;
		rc		  = NULL;
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL			ScpCloseFile(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);
	switch (pW->PortSel) {
		case AJCSCP_SEL_COMPORT:	if (pW->hPort != NULL) {								//	bnl|[g
										rc =  CloseHandle(pW->hPort);
									}
									break;

		case AJCSCP_SEL_MAILSLOT:	if (pW->fTxSlotOpened) {								//	[Xbg
										if (pW->hPort != NULL) {
											rc =  CloseHandle(pW->hPort);
										}
										else {
											rc = TRUE;	//	MXbgI[v́AN[Y
										}
										pW->fTxSlotOpened = FALSE;
									}
									break;

		case AJCSCP_SEL_SOCKET:		if (pW->hPort != NULL) {
										WSAEventSelect((SOCKET)pW->hEvtSock, NULL, 0);			//	\Pbg
										rc = TRUE;
										if (shutdown   ((SOCKET)pW->hPort, SD_BOTH) != 0) rc = FALSE;
										if (closesocket((SOCKET)pW->hPort		  ) != 0) rc = FALSE;
										pW->fConnect   = FALSE;
										pW->fSockRead  = FALSE;
										pW->fSockWrite = FALSE;
									}
									break;
	}
	pW->hPort = NULL;
	LeaveCriticalSection(&pW->CsCommApi);

	return rc;
}
//==============================================================================================================//
BOOL		   ScpReadFile(HAJCSCP pW, LPVOID lpBuffer, DWORD dwNumberOfBytesToRead,
											LPDWORD lpdwNumberOfBytesRead, LPOVERLAPPED lpOverLapped)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);

	*lpdwNumberOfBytesRead = 0;

	switch (pW->PortSel) {
		case AJCSCP_SEL_COMPORT:		//	bnl|[g
			if (pW->hPort != NULL) {
				//	bnl|[gǂݏo
				if (!(rc = ReadFile(pW->hPort, lpBuffer, dwNumberOfBytesToRead, lpdwNumberOfBytesRead, lpOverLapped))) {
					ScpNtcEvtToUser(pW, AJCSCP_EV_ERR, NULL, 0, AJCSCP_CE_RXERR);
				}
			}
			break;

		case AJCSCP_SEL_MAILSLOT:		//	[Xbg
			if (pW->hSlot != NULL) {
				//	[Xbgf[^ǂݏo
				if (!(rc = ReadFile(pW->hSlot, lpBuffer, dwNumberOfBytesToRead, lpdwNumberOfBytesRead, lpOverLapped))) {
					ScpNtcEvtToUser(pW, AJCSCP_EV_ERR, NULL, 0, AJCSCP_CE_RXERR);
				}
				//	[XbgI[vԂłȂꍇ́AǂݏooCgOƂ
				//	 |[gN[Y(AjcScpClose)ĂA[Xbg͐ĂB
				//	   ̂߁A|[gN[Y(AjcScpClose)ĂA[XbgɂMJjY͐ĂB
				//	   |[gN[Y(AjcScpClose)ꍇ́AMoCgOƂāAMĂȂ悤ɋUB
				if (!pW->fTxSlotOpened) {
					*lpdwNumberOfBytesRead = 0;
				}
			}
			break;

		case AJCSCP_SEL_SOCKET:			//	\Pbg
		{	UI		rxl;
			UI		RetryCnt;
			if (pW->hPort != NULL) {
				//	\Pbgǂݏo
				if (pW->fSockRead) {
					pW->fSockRead = FALSE;
					//	Mf[^ǂݏo
					rxl = recv((SOCKET)pW->hPort, (BCP)lpBuffer, dwNumberOfBytesToRead, 0);
					//	ɂ͊łȂubLOE\Pbg̑̏ꍇ̓gC
					RetryCnt = 0;
					while (rxl == SOCKET_ERROR && WSAGetLastError() == WSAEWOULDBLOCK && RetryCnt < SCP_RTY_WSAEWOULDBLOCK && !pW->fThreadEnd) {
						LeaveCriticalSection(&pW->CsCommApi);
						Sleep(SCP_TIM_WSAEWOULDBLOCK);
						EnterCriticalSection(&pW->CsCommApi);
						RetryCnt++;
						rxl = recv((SOCKET)pW->hPort, (BCP)lpBuffer, dwNumberOfBytesToRead, 0);
					}
					//	MnjȂ΁AMoCgݒ
					if (rxl != SOCKET_ERROR) {
						*lpdwNumberOfBytesRead = rxl;
						rc = TRUE;
					}
					//	MmfȂ΁AMG[ʒm
					else {
						ScpNtcEvtToUser(pW, AJCSCP_EV_ERR, NULL, 0, AJCSCP_CE_RXERR);
					}
				}
			}
			break;
		}
	}
	LeaveCriticalSection(&pW->CsCommApi);
	return rc;
}
//==============================================================================================================//
BOOL		   ScpWriteFile(HAJCSCP pW, LPVOID lpBuffer, DWORD dwNumberOfBytesToWrite,
										LPDWORD lpdwNumberOfBytesWrite, LPOVERLAPPED lpOverLapped)
{
	BOOL	rc = FALSE;

	EnterCriticalSection(&pW->CsCommApi);

	*lpdwNumberOfBytesWrite = 0;

	switch (pW->PortSel) {
		case AJCSCP_SEL_COMPORT:		//	bnl|[g
			if (pW->hPort != NULL) {
				if (!(rc = WriteFile(pW->hPort, lpBuffer, dwNumberOfBytesToWrite, lpdwNumberOfBytesWrite, lpOverLapped))) {
					ScpNtcEvtToUser(pW, AJCSCP_EV_ERR, NULL, 0, AJCSCP_CE_TXERR);
				}
			}
			break;

		case AJCSCP_SEL_MAILSLOT:		//	[Xbg
		{	ULL		cyc;
			UI		bps;
			if (pW->hPort != NULL) {
				//----- Mx̔r -----------------------------------------------------------------//
				if (pW->fTxDelay) {
					EnterCriticalSection(&pW->CsTxDelay);
				}
				//----- MJňoߎԎZo ---------------------------------------------------------------//
				if (pW->fTxDelay) {
					if (pW->TxDelayBytesCount == 0) {
					//	AjcTrace(L"TxDelayBytesCount == 0\n");	// @@@
						pW->TxDelayTickCount = 0;
						AjcMesTimeInterval(pW->hMesTxDelay);
					}
					else {
						//	[us]擾
						cyc = AjcMesTimeInterval(pW->hMesTxDelay);
						//	MԉZ
						pW->TxDelayTickCount += cyc;
					}
					//	MoCgZ
					pW->TxDelayBytesCount  += dwNumberOfBytesToWrite;
				}
				//----- [Xbgփf[^M -----------------------------------------------------------------//
				if (rc = WriteFile(pW->hPort, lpBuffer, dwNumberOfBytesToWrite, lpdwNumberOfBytesWrite, lpOverLapped)) {
					//----- Mx ---------------------------------------------------------------------------//
					if (pW->fTxDelay) {
						if (pW->TxDelayTickCount != 0) {
							bps = (UI)((pW->TxDelayBytesCount * (ULL)1000000) / pW->TxDelayTickCount);
							if (bps > pW->TxDelayBPS) {
							//	AjcTrace(L"bps = %d, TxDelayBytesCount=%lld, TxDelayTickCount=%lld\n", bps, pW->TxDelayBytesCount, pW->TxDelayTickCount);	// @@@
								Sleep(1); // ŏԃEFCg
							}
						}
					}
				}
				else {
					ScpNtcEvtToUser(pW, AJCSCP_EV_ERR, NULL, 0, AJCSCP_CE_TXERR);
				}
				//----- Mx̔r -----------------------------------------------------------------//
				if (pW->fTxDelay) {
					LeaveCriticalSection(&pW->CsTxDelay);
				}
			}
			break;
		}
		case AJCSCP_SEL_SOCKET:			//	\Pbg
		{	UI		txl;
			UI		RetryCnt;
			if (pW->hPort != NULL) {
				if (pW->fSockWrite) {
					//	f[^M
					txl = send((SOCKET)pW->hPort, (BCP)lpBuffer, dwNumberOfBytesToWrite, 0);
					//	ɂ͊łȂubLOE\Pbg̑̏ꍇ̓gC
					RetryCnt = 0;
					while (txl == SOCKET_ERROR && WSAGetLastError() == WSAEWOULDBLOCK && RetryCnt < SCP_RTY_WSAEWOULDBLOCK && !pW->fThreadEnd) {
						LeaveCriticalSection(&pW->CsCommApi);
						Sleep(SCP_TIM_WSAEWOULDBLOCK);
						EnterCriticalSection(&pW->CsCommApi);
						RetryCnt++;
						txl = send((SOCKET)pW->hPort, (BCP)lpBuffer, dwNumberOfBytesToWrite, 0);
					}
				//	#ifdef _DEBUG
				//		if (RetryCnt != 0) {
				//			AjcTrace("RetryCnt = %d\n", RetryCnt);
				//		}
				//	#endif
					//	MnjȂ΁AMoCgݒ
					if (txl != SOCKET_ERROR) {
						*lpdwNumberOfBytesWrite = txl;
						rc = TRUE;
					}
					//	MmfȂ΁AMG[ʒm
					else {
						ScpNtcEvtToUser(pW, AJCSCP_EV_ERR, NULL, 0, AJCSCP_CE_TXERR);
					}
				}
			}
			break;
		}
	}
	LeaveCriticalSection(&pW->CsCommApi);

	return rc;
}
