#include	"AjcInternal.h"
#include	"AjcSockClientDef.h"
//**************************************************************************************************************//
//																												//
//	\Pbg ( TCP/IP ) NCAg						ڑCMXbh							//
//																												//
//**************************************************************************************************************//
//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	UI _stdcall 	CommThread(VOP pVoid);
static	VO				CommProc  (VOP pVoid);
static	BOOL CALLBACK	cbEvtSsep(UI evt, VOP pDat, UI lDat, UX cbp);

//==============================================================================================================//
//																												//
//	Xg[CX^X																				//
//																												//
//==============================================================================================================//
BOOL	SctCreSsep(HAJCSCT pW)
{
	BOOL	rc = FALSE;

	//	Xg[CX^X
	if ((pW->hSsep = AjcSsepCreateA(pW->EvtMask & AJCSCT_EV_SSEP, (UX)pW, cbEvtSsep)) != NULL) {
		AjcSsepEnableMultiThread(pW->hSsep, TRUE);				//	}`Xbh
		AjcSsepSetPktTimeOut	(pW->hSsep, pW->PktTimeout);	//	pPbgM^CAEgݒ
		AjcSsepSetStx			(pW->hSsep, pW->stx);			//	STXݒ
		AjcSsepSetEtx			(pW->hSsep, pW->etx);			//	ETXݒ
		AjcSsepSetDle			(pW->hSsep, pW->dle);			//	DLEݒ
		rc = TRUE;
	}

	return rc;
}
//==============================================================================================================//
//																												//
//	MXbhJn																							//
//																												//
//==============================================================================================================//
BOOL	SctStartThreadComm(HAJCSCT pW)
{
	BOOL	rc = FALSE;

	//----- MXbhJn -----------------------------------------------------------------------------------//
	pW->fExit = FALSE;
	if ((pW->hThread = (HANDLE)_beginthreadex(NULL,				//	ZLeB
											  0,				//	X^bNTCY
											  CommThread,		//	Xbh֐
											  (VOP)pW,			//	Xbh
											  0,				//	XbhtO
											  &pW->idThread)	//	Xbhʎq
									) != NULL) {
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	ڑCʐMXbh																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	UI _stdcall CommThread(VOP pVoid)
{
	HAJCSCT		pW	  = (HAJCSCT)pVoid;
	int			nLen;
	ADDRINFOW	aiHint;
	PADDRINFOW	pAi   = NULL;

	do {
		//	AhX擾
		memset(&aiHint, 0, sizeof aiHint);
		aiHint.ai_family   = pW->AddressFamily;
		aiHint.ai_socktype = SOCK_STREAM;
		aiHint.ai_flags    = AI_PASSIVE;
		if (GetAddrInfoW(pW->pServ, pW->pPort, &aiHint, &pAi) == 0 && pAi != NULL) {

			//	ڑp\Pbg
			if ((pW->hSock = socket(pAi->ai_family, pAi->ai_socktype, pAi->ai_protocol)) == INVALID_SOCKET) {
				pW->hSock = 0;
				//	ڑvҋ@p\PbgsG[ʒm
				SctNtcEvtToUser(pW, AJCSCT_EV_ERR, NULL, 0, AJCSCT_ERR_SOCKET);
				break;
			}

			//	IPV6̐ݒ
			if (pAi->ai_family == AF_INET6) {
				int on = 1;
				if (setsockopt(pW->hSock, IPPROTO_IPV6, IPV6_V6ONLY, (C_BCP)&on, sizeof(on)) == SOCKET_ERROR) {
					//	IPV6̐ݒ莸sG[ʒm
					SctNtcEvtToUser(pW, AJCSCT_EV_ERR, NULL, 0, AJCSCT_ERR_SOCKOPT);
					break;
				}
			}

			//	ڑ(connect()̓ubNj
			nLen = sizeof(AJCSCTSAIN);
			if (connect(pW->hSock, pAi->ai_addr, (int)pAi->ai_addrlen) == SOCKET_ERROR) {
				int		err;
				//	ؒf
				pW->State = AJCSCT_DISCONNECT;
				//	CONNECTsG[ʒm
				//	ʐMI(܂AڑȂ)\PbgN[YׁAconnect()͎s
				err = WSAGetLastError();
				if (err != WSAENOTSOCK) {	// \Pbgł̃\Pbgi=\PbgN[YɂG[jȊOH
					SctNtcEvtToUser(pW, AJCSCT_EV_CNFAIL, NULL, 0, err);
				}
				break;
			}

			//	ڑʒm
			SctNtcEvtToUser(pW, AJCSCT_EV_CONNECT, NULL, 0, 0);
			//	ڑ
			pW->State = AJCSCT_CONNECT;
			//	ڑtOݒ
			pW->fConnected = TRUE;

			//	AhX
			FreeAddrInfoW(pAi);
			pAi = NULL;

			//	ʐM
			CommProc(pW);
		}
		//	AhX擾s
		else {
			SctNtcEvtToUser(pW, AJCSCT_EV_ERR, NULL, 0, AJCSCT_ERR_ADDRINFO);
		}
	} while(0);

	//	AhXiG[u[N̎cj
	if (pAi != NULL) {
		FreeAddrInfoW(pAi);
		pAi = NULL;
	}

	//	\PbgN[Y
	if (pW->hSock != 0) {
		closesocket(pW->hSock);
		pW->hSock = 0;
	}

	//	ʐMItO Zbg
	pW->fEnding  = FALSE;

	//	ؒfʒmCʐMtO Zbg
	if (pW->fConnected) {
		SctNtcEvtToUser(pW, AJCSCT_EV_DISCONNECT, NULL, 0, 0);
		pW->fConnected = FALSE;
		pW->State      = AJCSCT_DISCONNECT;
	}

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
//	ʐM																									//
//--------------------------------------------------------------------------------------------------------------//
static	VO		CommProc(VOP pVoid)
{
	HAJCSCT			pW = (HAJCSCT)pVoid;
	HANDLE			hEvtSel  = NULL;
	BOOL			fRecvOp  = TRUE;	//	MtO(TRUE:WSARecvsvCFALSE:WaitForSingleObjectsvj
	BOOL			fSendOp  = TRUE;	//	MtO(TRUE:WSASEndsvCFALSE:WaitForSingleObjectsvj
	AJCMBCKIND		mbk;				//	MeLXgR[h
	UL				lrx;
	UL				rxflags  = 0	, txflags = 0;
	UL				rxbytes  = 0	, txbytes = 0;
	WSABUF			rxwsabuf = {0}	, txwsabuf = {0};
	WSAOVERLAPPED	rxover	 = {0}	, txover   = {0};
	UB								  txbuf[AJCSCTMAX_TXBUF];

	do {
		//	CxgZNgpCxgIuWFNg
		if ((hEvtSel = WSACreateEvent()) == NULL) {
			SctNtcEvtToUser(pW, AJCSCT_EV_ERR, NULL, 0, AJCSCT_ERR_CREEVT);
			break;
		}
		//	CxgZNgݒ
		WSAEventSelect(pW->hSock, hEvtSel, FD_CLOSE);

		//	Mݒ
		txwsabuf.buf  = (BCP)txbuf;
		txwsabuf.len  = sizeof txbuf;
		if ((txover.hEvent = WSACreateEvent()) == NULL) {
			SctNtcEvtToUser(pW, AJCSCT_EV_ERR, NULL, 0, AJCSCT_ERR_CREEVT);
			break;
		}
		//	Mݒ
		rxwsabuf.buf  = &pW->RxBuf[pW->ixRxb];
		rxwsabuf.len  = AJCSCTMAX_RXBUF;
		if ((rxover.hEvent = WSACreateEvent()) == NULL) {
			SctNtcEvtToUser(pW, AJCSCT_EV_ERR, NULL, 0, AJCSCT_ERR_CREEVT);
			break;
		}
		//	f[^M[v
		while (!pW->fExit) {
			BOOL	fBusy = FALSE;	//	MiWSARecv/WSASendjtOi[vɃNA[j
			//	ʐMؒf̏ꍇAMȂƂ錾
			if (pW->fExit) {
				shutdown(pW->hSock, SD_SEND);
			}
			//	ؒf`FbN
			if (WaitForSingleObject(hEvtSel, 0) == WAIT_OBJECT_0) {
				WSANETWORKEVENTS nwev;
				if (WSAEnumNetworkEvents(pW->hSock, hEvtSel, &nwev) != SOCKET_ERROR) {
					if (nwev.lNetworkEvents & FD_CLOSE) {
						break;
					}
				}
			}
			//	f[^M
			if (fRecvOp) {
				//	Ms
				rxbytes = 0;
				rxflags = 0;
				rxwsabuf.buf  = pW->RxBin;
				rxwsabuf.len  = AJCSCTMAX_RXBUF;
				if (WSARecv(pW->hSock, &rxwsabuf, 1, &rxbytes, &rxflags, &rxover, NULL) == 0 || WSAGetLastError() == WSA_IO_PENDING) {
					//	́AWaitoForSingleObject()s
					fRecvOp = FALSE;
					//	M{(WSARecv/WSASendjL̎|Aݒ
					fBusy = TRUE;
				}
				else {
					//	M쎸sG[ʒm
					SctNtcEvtToUser(pW, AJCSCT_EV_RXERR, NULL, 0, FALSE);
					//	ŏԃEFCg
					Sleep(1);
				}
			}
			else {
				if (WaitForSingleObject(rxover.hEvent, 0) == WAIT_OBJECT_0) {
					//	MVOiԂɐݒ
					WSAResetEvent(rxover.hEvent);
					//	f[^M擾
					if (WSAGetOverlappedResult(pW->hSock, &rxover, &rxbytes, FALSE, &rxflags)) {
						if (rxbytes != 0) {
							//	Mobt@֎MoCif[^]
							memcpy(&pW->RxBuf[pW->ixRxb], pW->RxBin, rxbytes);
							//	R[hpf[^^
							pW->RxBuf[pW->ixRxb + rxbytes] = 0;
							AjcSsepPutMbc(pW->hSsep, (C_BCP)pW->RxBuf);
							//	MeLXgR[hݒ
							switch (pW->RxTxtCode) {
								default:
								case AJCSCT_TXT_SJIS:	mbk = AJCMBC_SJIS;					break;	//	Vtgihr
								case AJCSCT_TXT_EUC:	mbk = AJCMBC_EUC;					break;	//	dtb@@@
								case AJCSCT_TXT_UTF8:	mbk = AJCMBC_UTF8;					break;	//	tse|W@
								case AJCSCT_TXT_AUTO:	mbk = AjcSsepGetMbcKind(pW->hSsep);	break;	//	ʁ@
							}
							//	MoCgXg[
							if (rxbytes != 0 && (pW->EvtMask & AJCSCT_EV_SSEP)) {
								AjcSsepPutData(pW->hSsep, &pW->RxBuf[pW->ixRxb], rxbytes);
							}
							//	Mobt@ɃeLXgI[ݒ
							pW->RxBuf[pW->ixRxb + rxbytes] = 0;
							//	ۂ̃f[^ݒiO̒r}`oCgZj
							lrx = pW->ixRxb + rxbytes;
							//	`Nf[^Mʒm
							if (pW->EvtMask & AJCSCT_EV_RXCHUNK) {
								//	oCi`NMʒm
								if (pW->ChunkMode & AJCSCT_CM_BIN) {
									UBP		pBin;
									if (pBin = (UBP)AJCMEM(rxbytes)) {
										memcpy(pBin, pW->RxBin, rxbytes);
										SctNtcEvtToUser(pW, AJCSCT_EV_RXCHUNK, pBin, rxbytes, 0);
									}
								}
								//	eLXg`NMʒm
								if (pW->ChunkMode & AJCSCT_CM_TEXT) {
									UI			i;
									BOOL		fInvChunk = FALSE;
									//	rɐR[h(0x09`0x0D, 0x1BȊO)邩`FbN
									for (i = 0; i < rxbytes; i++) {
										if (MAjcIsCntrlA(rxwsabuf.buf[i]) && !MAjcIsSpaceA(rxwsabuf.buf[i]) &&
																						   rxwsabuf.buf[i] != 0x1B) {
											fInvChunk = TRUE;
											break;
										}
									}
									//	LeLXg`FbN
									if (lrx != 0) {
										//	rɐR[h(0x09`0x0DȊO)ꍇ́As`NeLXgƂăoCî܂ܒʒm
										if (fInvChunk) {
											UBP		pBin;
											if (pBin = (UBP)AJCMEM(lrx)) {
												memcpy(pBin, pW->RxBuf, lrx);
												SctNtcEvtToUser(pW, AJCSCT_EV_INVCHUNK, pBin, lrx, 0);
											}
											pW->ixRxb = 0;
										}
										//	ȃeLXg`Nʒm
										else {
											//	I[ݒ
											pW->RxBuf[lrx] = 0;
											//	obt@CfNXݒiOۗf[^ƐVMf[^܂߂oCgj
											pW->ixRxb = lrx;
											//	擾ƃ[Uւ̒ʒm
											if (pW->fUnicode) {
												WCP		pWcs;
												if (pWcs = AjcExtractCompletedTextW((BCP)pW->RxBuf, AJCSCTMAX_RXBUF, (UIP)&lrx, mbk)) {
													pW->ixRxb = lrx;
													pW->RxBuf[lrx] = 0;
													SctNtcEvtToUser(pW, AJCSCT_EV_RXCHUNK, pWcs, (UI)wcslen(pWcs), 2);
												}
											}
											else {
												BCP		pSJis;
												if (pSJis = AjcExtractCompletedTextA((BCP)pW->RxBuf, AJCSCTMAX_RXBUF, (UIP)&lrx, mbk)) {
													pW->ixRxb = lrx;
													pW->RxBuf[lrx] = 0;
													SctNtcEvtToUser(pW, AJCSCT_EV_RXCHUNK, pSJis, (UI)strlen(pSJis), 1);
												}
											}
										}
									}
								}
							}
							//	pPbgOMeLXgʒmi擾ƃ[Uւ̒ʒmj
							if (pW->fUnicode) {
								WCP		pWcs;
								if (pWcs = AjcExtractCompletedTextW((BCP)pW->NpBuf, AJCSCTMAX_RXBUF, (UIP)&pW->ixNpk, mbk)) {
									pW->NpBuf[pW->ixNpk] = 0;
									SctNtcEvtToUser(pW, AJCSCT_EV_RXNOPKT, pWcs, (UI)wcslen(pWcs), 2);
								}
							}
							else {
								BCP		pSJis;
								if (pSJis = AjcExtractCompletedTextA((BCP)pW->NpBuf, AJCSCTMAX_RXBUF, (UIP)&pW->ixNpk, mbk)) {
									pW->NpBuf[pW->ixNpk] = 0;
									SctNtcEvtToUser(pW, AJCSCT_EV_RXNOPKT, pSJis, (UI)strlen(pSJis), 1);
								}
							}
						}
						else {	//	Mf[^irxbytes == 0j
							//	ؒf̏ꍇAɉbIƂAI
							if (pW->fExit) {
								shutdown(pW->hSock, SD_BOTH);
								break;
							}
						}
					}
					else {	//	WSAGetOverlappedResult()s
						//	Mdh^nsG[ʒm
						SctNtcEvtToUser(pW, AJCSCT_EV_RXERR, NULL, 0, TRUE);
						//	ŏԃEFCg
						Sleep(1);
					}
					//	́AWSARecv()s
					fRecvOp = TRUE;
				}
				else {	//	WaitForSingleObject()̃^CAEgi܂AMf[^͖j
					//	ؒf̏ꍇAɉbIƂAI
					if (pW->fExit) {
						shutdown(pW->hSock, SD_BOTH);
						break;
					}
				}
			}
			//	f[^M
			if (!pW->fExit) {
				if (fSendOp) {	//	M
					if ((txwsabuf.len = AjcVMbxDequeEx(pW->hVMbxTxD, txbuf, sizeof txbuf, 0)) != -1) {
						pW->fTxBusy = TRUE;
						txbytes = 0;
						txflags = 0;
						if (WSASend(pW->hSock, &txwsabuf, 1, &txbytes, txflags, &txover, NULL) == 0 || WSAGetLastError() == WSA_IO_PENDING) {
							//	́AWaitForSingleObject()s
							fSendOp = FALSE;
							//	M{(WSARecv/WSASendjL̎|Aݒ
							fBusy	= TRUE;
						}
						else {
							//	M쎸sG[ʒm
							SctNtcEvtToUser(pW, AJCSCT_EV_TXERR, NULL, 0, FALSE);
							//	ŏԃEFCg
							Sleep(1);
						}
					}
					else {
						//	Mʒm
						if (pW->fTxBusy) {
							pW->fTxBusy = FALSE;
							SctNtcEvtToUser(pW, AJCSCT_EV_TXEMPTY , NULL, 0, 0);
						}
					}
				}
				else {			//	M҂
					//	MȂ΁ȂMցEE
					if (WaitForSingleObject(txover.hEvent, 0) == WAIT_OBJECT_0) {
						//	MVOiԂɐݒ
						WSAResetEvent(txover.hEvent);
						//	f[^M擾
						if (!WSAGetOverlappedResult(pW->hSock, &txover, &txbytes, FALSE, &txflags)) {
							//	Mpdh^nsG[ʒm
							SctNtcEvtToUser(pW, AJCSCT_EV_TXERR, NULL, 0, TRUE);
							//	ŏԃEFCg
							Sleep(1);
						}
						//	́AWSASend()s
						fSendOp = TRUE;
					}
				}
			}
			//	M{삪΁iWSARecv/WSASendsȊO(=M҂)Ȃ΁jŏԃX[v
			if (!fBusy) {
				Sleep(1);
			}
		} // f[^M[vI[
	} while(0);

	//	\[X
	if (hEvtSel 		!= NULL) {CloseHandle(hEvtSel		 ); hEvtSel			= NULL;}
	if (rxover.hEvent	!= NULL) {CloseHandle(rxover.hEvent  ); rxover.hEvent	= NULL;}
	if (txover.hEvent	!= NULL) {CloseHandle(txover.hEvent  ); txover.hEvent	= NULL;}
	//	\PbgN[Y
	if (pW->hSock != 0		   ) {closesocket(pW->hSock);		pW->hSock		= 0;   }
}
//--------------------------------------------------------------------------------------------------------------//
//	Xg[ʒm																							//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbEvtSsep(UI evt, VOP pvData, UI lDat, UX cbp)
{
	BOOL		rc = TRUE;
	HAJCSCT		pW = (HAJCSCT)cbp;
	AJCMBCKIND	mbk;							//	MeLXgR[h
	BCP			pDat =(BCP)pvData;

	switch (evt) {
		case AJCSSEP_EV_TXT:												//	eLXgf[^
			//	MeLXgR[hݒ
			switch (pW->RxTxtCode) {
				default:
				case AJCSCT_TXT_SJIS:	mbk = AJCMBC_SJIS;					break;	//	Vtgihr
				case AJCSCT_TXT_EUC:	mbk = AJCMBC_EUC;					break;	//	dtb@@@
				case AJCSCT_TXT_UTF8:	mbk = AJCMBC_UTF8;					break;	//	tse|W@
				case AJCSCT_TXT_AUTO:	mbk = AjcSsepGetMbcKind(pW->hSsep);	break;	//	ʁ@
			}
			//----- UNICODE ------------------------------------------------------------------------------------//
			if (pW->fUnicode) {
				//	 S-JIS
				if (mbk == AJCMBC_SJIS) {
					WCP		pWid;
					UI		lWid;
					lWid = MultiByteToWideChar(CP_ACP, 0, pDat, -1, NULL, 0);
					if (lWid != 0 && (pWid = (WCP)AJCMEM(lWid * 2))) {
						MultiByteToWideChar(CP_ACP, 0, pDat, -1, pWid, lWid);			//	Ch֕ϊ
						SctNtcEvtToUser(pW, evt, pWid, (UI)wcslen(pWid), 2);			//	Chʒm
					}
				}
				//	 EUC
				else if (mbk == AJCMBC_EUC) {
					BCP		pSJis;
					WCP		pWid;
					UI		lSJis, lWid;
					lSJis = AjcEucToSJis(pDat, NULL, 0);
					if (pSJis = (BCP)AJCMEM(lSJis)) {
						AjcEucToSJis(pDat, pSJis, lSJis);
						lWid = MultiByteToWideChar(CP_ACP, 0, pSJis, -1, NULL, 0);		//	EUC->SJIS ϊ
						if (lWid != 0 && (pWid = (WCP)AJCMEM(lWid * 2))) {
							MultiByteToWideChar(CP_ACP, 0, pSJis, -1, pWid, lWid);		//	Ch֕ϊ
							SctNtcEvtToUser(pW, evt, pWid, (UI)wcslen(pWid), 2);		//	Chʒm
						}
						free(pSJis);
					}
				}
				//	 UTF-8
				else if (mbk == AJCMBC_UTF8) {
					WCP		pWid;
					UI		lWid;
					lWid = MultiByteToWideChar(CP_UTF8, 0, pDat, -1, NULL, 0);
					if (lWid != 0 && (pWid = (WCP)AJCMEM(lWid * 2))) {
						MultiByteToWideChar(CP_UTF8, 0, pDat, -1, pWid, lWid);
						SctNtcEvtToUser(pW, evt, pWid, (UI)wcslen(pWid), 2);			//	Chʒm
					}
				}
				rc = TRUE;																//	pDatJ
			}
			//----- }`oCg -------------------------------------------------------------------------------//
			else {
				BCP		pSJis = pDat;
				UI		lSJis = lDat;
				//	 S-JIS
				if (mbk == AJCMBC_SJIS) {
					SctNtcEvtToUser(pW, evt, pDat, lDat, 1);					//	r|ihr̂܂ܒʒm
					rc = FALSE;													//	pDat͉Ȃ
				}
				//	 EUC
				else if (mbk == AJCMBC_EUC) {
					lSJis = AjcEucToSJis(pDat, NULL, 1);
					if (pSJis = (BCP)AJCMEM(lSJis)) {							//	ϊ\H
						AjcEucToSJis(pDat, pSJis, lSJis);						//		r|ihr֕ϊ
						lSJis = (UI)strlen(pSJis);
						SctNtcEvtToUser(pW, evt, pSJis, lSJis, 1);				//		ϊʒm
					}
					rc = TRUE;													//	pDat͉
				}
				//	 UTF-8
				else if (mbk == AJCMBC_UTF8) {
					lSJis = AjcUtf8ToMbc(pDat, NULL, 1);						//
					if (pSJis = (BCP)AJCMEM(lSJis)) {							//	ϊ\H
						AjcUtf8ToMbc(pDat, pSJis, lSJis);						//		r|ihr֕ϊ
						lSJis = (UI)strlen(pSJis);
						SctNtcEvtToUser(pW, evt, pSJis, lSJis, 1);				//		ϊʒm
					}
					rc = TRUE;													//	pDat͉
				}
			}
			break;

		case AJCSSEP_EV_ESC:													//	drbR[hf[^
		case AJCSSEP_EV_CTRL:													//	R[h
			if (pW->fUnicode) {													//		ChH
				WCP		pWid;
				UI		lWid;
				lWid = MultiByteToWideChar(CP_ACP, 0, pDat, -1, NULL, 0);
				if (lWid != 0 && (pWid = (WCP)AJCMEM(lWid * 2))) {
					MultiByteToWideChar(CP_ACP, 0, pDat, -1, pWid, lWid);		//			Ch֕ϊ
					SctNtcEvtToUser(pW, evt, pWid, (UI)wcslen(pWid), 2);		//			Chʒm
				}
				rc = TRUE;														//			pDatJ
			}
			else {																//		oCgH
				SctNtcEvtToUser(pW, evt, pDat, lDat, 1);						//			ʒmf[^̂܂ܒʒm
				rc = FALSE;														//			pDat͉Ȃ
			}
			break;

		case AJCSSEP_EV_PKT:													//	pPbgf[^
			SctNtcEvtToUser(pW, evt, pDat, lDat, 0);							//		pPbgf[^ʒm
			rc = FALSE;															//		pDat͉Ȃ
			break;

		case AJCSSEP_EV_NOPKT:													//	pPbgOoCgf[^
			if (pW->ixNpk < AJCSCTMAX_RXBUF) {									//		pPbgOf[^obt@Ƀf[^i[
				pW->NpBuf[pW->ixNpk++] = *pDat;
				pW->NpBuf[pW->ixNpk  ] = 0;
			}
			rc = TRUE;															//		pDat͉
			break;
	}
	return rc;
}
