#include	"AjcInternal.h"
#include	"AjcSockServerDef.h"
//**************************************************************************************************************//
//																												//
//	\Pbg ( TCP/IP ) T[o							O[oTu֐										//
//																												//
//**************************************************************************************************************//
//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO	 CALLBACK	cbReleaseEvtInf(VOP pVoid);

//==============================================================================================================//
//	NCAgJE^																					//
//==============================================================================================================//
HANDLE	SsvInitClientCount(HAJCSSV pW)
{
	pW->ClientCount = 0;
	InitializeCriticalSection(&pW->csClients);
	if ((pW->hEvtNoClients = CreateEvent(NULL, TRUE, TRUE, NULL)) == NULL) {
		SsvNtcEvtToUser(pW, AJCSSV_EV_ERR, NULL, 0, AJCSSV_ERR_CREEVT, NULL);
	}
	return pW->hEvtNoClients;
}
//==============================================================================================================//
//	NCAgJE^폜																					//
//==============================================================================================================//
VO		SsvDeleteClientCount(HAJCSSV pW)
{
	DeleteCriticalSection(&pW->csClients);
	CloseHandle(pW->hEvtNoClients);
}
//==============================================================================================================//
//	NCAgJE^XV																					//
//==============================================================================================================//
VO		SsvIncrementClientCount(HAJCSSV pW)
{
	EnterCriticalSection(&pW->csClients);
	pW->ClientCount++;
	LeaveCriticalSection(&pW->csClients);
	ResetEvent(pW->hEvtNoClients);
}
//==============================================================================================================//
//	NCAgJE^Z																					//
//==============================================================================================================//
VO		SsvDecrementClientCount(HAJCSSV pW)
{
	EnterCriticalSection(&pW->csClients);
	if (pW->ClientCount > 0) pW->ClientCount--;
	LeaveCriticalSection(&pW->csClients);
	if (pW->ClientCount == 0) SetEvent(pW->hEvtNoClients);
}
//==============================================================================================================//
//	CfNXԍ蓖																						//
//==============================================================================================================//
UI		SsvAllocIx(HAJCSSV pW)
{
	UI		rc = 0;
	UI		n  = (pW->MaxClients / 32) + ((pW->MaxClients % 32) != 0);
	UI		i, j, ix, msk;

	for (i = 0; i < n; i++) {
		if (pW->pIxMap[i] != 0xFFFFFFFF) {
			for (j = 0, msk = 0x01; j < 32; j++, msk <<= 1) {
				if ((pW->pIxMap[i] & msk) == 0) {
					ix = i * 32 + j;
					if (ix < pW->MaxClients) {
						pW->pIxMap[i] |= msk;
						rc = ix;
						goto aix_exit;
					}
				}
			}
		}
	}
aix_exit:;
	return rc;
}
//==============================================================================================================//
//	CfNXԍ蓖ĉ																					//
//==============================================================================================================//
VO		SsvReleaseIx(HAJCSSV pW, UI ix)
{
	pW->pIxMap[ix / 32] &= ~(0x01 << (ix % 32));
}

//
//																											
//[U`oփCxgʒm																					
//																											
//

//==============================================================================================================//
//	[U`oփCxgʒm																					//
//																												//
//		Cxgʒmp̃\[XiEVTENFj́AvOIɎc\邽߁A						//
//	   AjcAllocInstance/AjcReleaseInstanceŊmہ^JAvZXIɃN[AbvB					//
//==============================================================================================================//
VO	SsvNtcEvtToUser	 (HAJCSSV pW, UI EvtMask, VOP pDat, UI lDat, UI param, HAJCSSVCLI pC)
{
	PSSVEVTINF	pEvtInf;

	//	ʏ폈 and ʒmΏۃCxgH
	if (!pW->fEnding && (pW->EvtMask & EvtMask)) {
		//	CxgʒmmہCH
		if (pEvtInf = (PSSVEVTINF)AjcAllocInstance(sizeof(SSVEVTINF), cbReleaseEvtInf)) {
			pEvtInf->Evt   = EvtMask;
			pEvtInf->pDat  = pDat;
			pEvtInf->lDat  = lDat;
			pEvtInf->param = param;
			pEvtInf->pC    = pC;
			//	EChbZ[WɂʒmH
			if (pW->hWndNtc != NULL) {
				//	ʒmECh͗LEEE
				if (IsWindow(pW->hWndNtc)) {
					//	EChbZ[Wɂʒm
					if (!PostMessage(pW->hWndNtc, pW->MsgNtc, EvtMask, (LPARAM)pEvtInf)) {
						//	śAŏԃEFCgAgC
						Sleep(1);
						if (!PostMessage(pW->hWndNtc, pW->MsgNtc, EvtMask, (LPARAM)pEvtInf)) {
							//	ēxśAʒm
							AjcReleaseInstance(pEvtInf);
						}
					}
				}
				//	ʒmEChȂ΁Aʒm
				else {
					AjcReleaseInstance(pEvtInf);
				}
			}
			//	CxgIuWFNgɂʒmH
			else {
				//	CxgIuWFNgɂʒm
				if (!AjcFMbxEnque(pW->hFMbxNtc, &pEvtInf)) {
					//	śAʒmm
					AjcReleaseInstance(pEvtInf);
				}
			}
		}
		//	CxgʒmmہCsH
		else {
			if (pDat != NULL) {
				free(pDat);
			}
		}
	}
	//	I or ʒmΏۊOCxgH
	else {
		if (pDat != NULL) {
			free(pDat);
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	cCxgʒmp\[XJivZXIɎsj														//
//--------------------------------------------------------------------------------------------------------------//
static	VO CALLBACK cbReleaseEvtInf(VOP pVoid)
{
	PSSVEVTINF	pEvtInf = (PSSVEVTINF)pVoid;

	//	NCAg[N
	if (pEvtInf->Evt & AJCSSV_EV_DISCONNECT) {
		if (pEvtInf->pC != NULL) {
			SsvCbEndOfClientThread(pEvtInf->pC);
			pEvtInf->pC = NULL;
		}
	}
	//	ʒmf[^
	if (pEvtInf->pDat != NULL) {
		free(pEvtInf->pDat);
		pEvtInf->pDat = NULL;
	}
}
