#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	ԑJڐ																								//
//																												//
//**************************************************************************************************************//

//--------------------------------------------------------------------------------------------------------------//
//	Ɨ̈																									//
//--------------------------------------------------------------------------------------------------------------//
static	ATOM	StcHideClass = 0;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	int					SubExecEvent(HAJCSTC pW, PCAJCSTC_EVT_NF pEvt);
static	VO					SubPreFunc	(HAJCSTC pW, const UB pft[AJCSTC_MAX_PSF]);
static	VO					SubTimStart (HAJCSTC pW, UW tmc);
static	VO					SubTimStop	(HAJCSTC pW, UW tmc);

static	LRESULT CALLBACK 	WndStcHideProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

//==============================================================================================================//
//	Nݒ																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
BOOL	AjcStcInit(VO)
{
	WNDCLASS	wndclass;

	wndclass.style			= 0;
	wndclass.lpfnWndProc	= WndStcHideProc;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= sizeof(HAJCSTC);
	wndclass.hInstance		= hDllInst;
	wndclass.hIcon			= NULL;
	wndclass.hCursor		= NULL;
	wndclass.hbrBackground	= (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= L"AjcStcHideClass";
	return ((StcHideClass	= RegisterClass(&wndclass)) != 0);
}
//==============================================================================================================//
//	I㏈																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
VO		AjcStcEnd (VO)
{
	if (StcHideClass != 0) {
		UnregisterClass(L"AjcStcHideClass", hDllInst);
		StcHideClass = 0;
	}
}

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pCom	- ̏Ԃ瓖YԂ֑Jڎ̃ANVe[uisv͂mtkkj					//
//				pRel	- YԂ瑼̏Ԃ֑Jڎ̃ANVe[uisv͂mtkkj					//
//				pEvt	- CxgANVe[ũAhX													//
//				nState	- Ԃ̌																			//
//				cbp 	- R[obNp^																	//
//				cbPsf	- vZbgt@NVnh														//
//				cbNtc	- ԑJڐʒmpR[obN														//
//																												//
//	߂l	F	NULL : CX^Xnh																	//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT HAJCSTC	WINAPI AjcStcCreate(PCAJCSTC_STSACT pCom,
										PCAJCSTC_STSACT pRel,
										PCAJCSTC_EVT_NF pEvt,
										int 			 nState,
										UX				 cbp ,
										VO (CALLBACK *cbPsf)(UI pno, int sts, UX cbp),
										VO (CALLBACK *cbNtc)(AJCSTC_NTC ntc, UL p1, UL p2, UX cbp))
{
	HAJCSTC	pW = NULL;
	int		i;

	do {
		//----- CX^X[N -------------------------------------------------------------------------//
		if (!(pW = (HAJCSTC)AJCMEM(sizeof(AJCSTC)))) break;
		memset(pW, 0, sizeof(AJCSTC));
		//----- ECh -----------------------------------------------------------------------------------//
		pW->hwnd = CreateWindow(L"AjcStcHideClass",			// window class name
								L"",						// window caption
								0,							// window style
								0,							// initial x position
								0,							// initial y position
								0,							// initial x size
								0,							// initial y size
								NULL,						// parent window handle
								NULL,						// window menu handle
								hDllInst,					// program instance handle
								pW);						// creation parameters
		if (pW->hwnd == NULL) {free(pW); pW = NULL; break;}
		ShowWindow(pW->hwnd, SW_HIDE);
		//----- CX^X[N -----------------------------------------------------------------------//
		pW->fBusy	= 0;							//	CxgtO
		pW->CurSts	= 0;							//	݂̏
		pW->nState	= nState;						//	Ԃ̌
		pW->pCom	= pCom;							//	̏Ԃ瓖YԂ֑Jڎ̃ANVe[u
		pW->pRel	= pRel;							//	YԂ瑼̏Ԃ֑Jڎ̃ANVe[u
		pW->pEvt	= pEvt;							//	CxgANVe[u
		pW->six		= 0;							//	Cxgobt@ECfNX
		pW->eix		= 0;							//	E
		pW->cbp		= cbp;							//	R[obNp^
		pW->cbPsf	= cbPsf;						//	vZbgt@NVʒmpR[obN
		pW->cbNtc	= cbNtc;
		//	^CAEgCxgNA[
		for (i = 0; i < AJCSTC_MAX_TMINFO; i++) {
			pW->TmInfo[i].EvtCode = -1;
		}
	} while(0);

	return pW;
}

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT VO		WINAPI AjcStcDelete(HAJCSTC pW)
{
	if (pW != NULL) {
		if (pW->hwnd != NULL) DestroyWindow(pW->hwnd);
		free(pW);
	}
}

//==============================================================================================================//
//	^C}ݒ																								//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				tid 	- ^C}hciO`j																	//
//				msTime	- ^C}l[ms]																			//
//				EvtCode - ^CAEgECxgR[h															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcStcSetTimerInfo	(HAJCSTC pW, UI tid, UI msTime, int EvtCode)
{
	BOOL	rc = FALSE;

	if (tid <AJCSTC_MAX_TMINFO) {
		pW->TmInfo[tid].msTime	= msTime;
		pW->TmInfo[tid].EvtCode = EvtCode;
		rc = TRUE;
	}

	return rc;
}
//==============================================================================================================//
//	^C}EX^[g																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				tid 	- ^C}hciO`j																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcStcTimerStart (HAJCSTC pW, UI tid)
{
	BOOL	rc = FALSE;

	if (tid < AJCSTC_MAX_TMINFO) {
		//	^C}N
		SetTimer(pW->hwnd, tid + 1, pW->TmInfo[tid].msTime, NULL);
		//	^C}Nʒm
		if (pW->cbNtc != NULL) {
			pW->cbNtc(AJCSTC_NTC_TIMSRT, tid, pW->TmInfo[tid].msTime, pW->cbp);
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	^C}EXgbv																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				tid 	- ^C}hciO`j																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcStcTimerStop (HAJCSTC pW, UI tid)
{
	BOOL	rc = FALSE;

	if (tid < AJCSTC_MAX_TMINFO) {
		//	^C}~
		KillTimer(pW->hwnd, tid + 1);
		//	^C}~ʒm
		if (pW->cbNtc != NULL) {
			pW->cbNtc(AJCSTC_NTC_TIMSTP, tid, 0, pW->cbp);
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	݂̏ԃR[h擾																						//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	݂̏ԃR[h																				//
//==============================================================================================================//
AJCEXPORT int		WINAPI AjcStcGetCurrentState(HAJCSTC pW)
{
	return pW->CurSts;
}
//==============================================================================================================//
//	݂̏ԃR[hݒ																						//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				sts 	- ԃR[h																			//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI AjcStcSetCurrentState(HAJCSTC pW, int sts)
{
	BOOL	rc = FALSE;

	if (((UI)sts) <= AJCSTC_MAX_STS) {
		pW->CurSts = sts;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	Cxgs																								//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				evt 	- CxgR[h																		//
//																												//
//	߂l	F	JڐԃR[hiԑJڂȂꍇ͕ωȂj												//
//				-1	- Busy																						//
//				-2	- Error																						//
//==============================================================================================================//
AJCEXPORT int		WINAPI AjcStcExecEvent		(HAJCSTC pW, int evt)
{
	int		rc = -1;
	UI		nix;


	do {
		//----- CxgGL[iCxgUۗj----------------------------------------------------//
		nix = ((pW->eix + 1) % AJCSTC_MAX_EVT);
		if (nix != pW->six) {
			pW->EvtBuf[pW->eix] = evt;
			pW->eix = nix;
		}
		else {rc = -2; break;}
		//----- CxgsiCxgs(vZbgt@NṼCxgs)̏ꍇ͎sȂ ---//
		if (!pW->fBusy) {
			//	Cxgs̎|AtOݒ
			pW->fBusy = TRUE;
			//	ۗ̃Cxgs
			while (pW->six != pW->eix) {
				if (pW->cbNtc != NULL) {
					pW->cbNtc(AJCSTC_NTC_EVT, pW->CurSts, pW->EvtBuf[pW->six], pW->cbp);
				}
				rc = SubExecEvent(pW, pW->pEvt + (pW->nState * pW->EvtBuf[pW->six]));
				if (pW->cbNtc != NULL  &&  rc != pW->CurSts) {
					pW->cbNtc(AJCSTC_NTC_STS, rc, 0, pW->cbp);
				}
				pW->CurSts = rc;
				pW->six = ((pW->six + 1) % AJCSTC_MAX_EVT);
			}
			//	CxgstO
			pW->fBusy = FALSE;
		}
	} while(0);

	return rc;
}
//==============================================================================================================//
//	ҋ@̑SCxgj																						//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT VO 		WINAPI AjcStcPurge			(HAJCSTC pW)
{
	pW->six = pW->eix = 0;
}
//--------------------------------------------------------------------------------------------------------------//
//	Cxgs																								//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				pEvt	- CxgANVe[u̓YCxgGgEAhX							//
//																												//
//	߂l	F	JڐԃR[hiԑJڂȂꍇ͕ωȂj												//
//				-1	- Busy																						//
//				-2	- Error																						//
//--------------------------------------------------------------------------------------------------------------//
static int		SubExecEvent(HAJCSTC pW, PCAJCSTC_EVT_NF pEvt)
{
	int		NewSts = pW->CurSts;
	PCAJCSTC_STSACT	pCom = pW->pCom;
	PCAJCSTC_STSACT	pRel = pW->pRel;

	//	CxgANVe[u̓YԃGgAhXݒ
	pEvt += pW->CurSts;
	//	JڐԔԍݒ
	NewSts = pEvt->sts;
	//	ԑJږȂ΁ȀԂ瓖YԂ֑Jڎ̃ANVe[u𖳎
	if (NewSts == AJCSTC_NOCHG) {
		pCom = NULL;
	}
	//	ԑJږ^ԂȂ΁AYԂ瑼̏Ԃ֑Jڎ̃ANVe[u𖳎
	if (NewSts == AJCSTC_NOCHG	||	NewSts == pW->CurSts) {
		pRel = NULL;
	}
	//----------------------------------------------------------------------------------------------------------//
	//	^C}~																								//
	//----------------------------------------------------------------------------------------------------------//
	//	CxgANVe[ũ^C}~
	SubTimStop(pW, pEvt->tmc);
	//	ԑJڎ̎Ԃɂ^C}~
	if (pRel != NULL) {
		SubTimStop(pW, (pRel + pW->CurSts)->tmc);
	}
	//	ԑJڎ̑Jڐɂ^C}~
	if (pCom != NULL) {
		SubTimStop(pW, (pCom + NewSts)->tmc);
	}
	//----------------------------------------------------------------------------------------------------------//
	//	vZbgt@NVs																			//
	//----------------------------------------------------------------------------------------------------------//
	//----- CxgANVe[ũvZbgt@NVs -------------------------------------------//
	SubPreFunc(pW, pEvt->pft);
	//	ԑJڎ̎ԂɂvZbgt@NVs	
	if (pRel != NULL) {
		SubPreFunc(pW, (pRel + pW->CurSts)->pft);
	}
	//	ԑJڎ̑JڐɂvZbgt@NVs	
	if (pCom != NULL) {
		SubPreFunc(pW, (pCom + NewSts)->pft);
	}
	//----------------------------------------------------------------------------------------------------------//
	//	^C}N																								//
	//----------------------------------------------------------------------------------------------------------//
	//	CxgANVe[ũ^C}N	
	SubTimStart(pW, pEvt->tmc);
	//	ԑJڎ̎Ԃɂ^C}N	
	if (pRel != NULL) {
		SubTimStart(pW, (pRel + pW->CurSts)->tmc);
	}
	//	ԑJڎ̑Jڐɂ^C}N	
	if (pCom != NULL) {
		SubTimStart(pW, (pCom + NewSts)->tmc);
	}

	return(NewSts != AJCSTC_NOCHG ? NewSts : pW->CurSts);
}
//--------------------------------------------------------------------------------------------------------------//
//	vZbgt@NVs																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubPreFunc(HAJCSTC pW, const UB pft[AJCSTC_MAX_PSF])
{
	UI		i;

	if (pW->cbPsf != NULL) {
		for (i=0; i<AJCSTC_MAX_PSF; i++) {
			if (pft[i] != AJCSTC_NOPSF) {
				pW->cbPsf(pft[i], pW->CurSts, pW->cbp);
			}
		}
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	^C}N																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubTimStart(HAJCSTC pW, UW tmc)
{
	UI		tid;
	UW		tmd;

	if (tmc != 0) {
		for (tid = 0; tmc != 0; tid++, tmc <<= 2) {
			//	^C}ANVR[hݒ
			tmd = (UW)(tmc & AJCSTC_TIM_CTL);
			//	P^C}^TCNbN^C}NȂ΁EE
			if (tmd == AJCSTC_TIM_START || tmd == AJCSTC_TIM_CYC) {
				//	TCNbNtOݒ
				if (tmd == AJCSTC_TIM_CYC) pW->fCyclic[tid] = TRUE;
				else					   pW->fCyclic[tid] = FALSE;
				//	^C}N
				SetTimer(pW->hwnd, tid + 1, pW->TmInfo[tid].msTime, NULL);
				//	^C}Nʒm
				if (pW->cbNtc != NULL) {
					pW->cbNtc(AJCSTC_NTC_TIMSRT, tid, pW->TmInfo[tid].msTime, pW->cbp);
				}
			}
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	^C}~																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubTimStop(HAJCSTC pW, UW tmc)
{
	UI		tid;

	if (tmc != 0) {
		for (tid = 0; tmc != 0; tid++, tmc <<= 2) {
			//	^C}~Ȃ΁EE
			if ((tmc & AJCSTC_TIM_CTL) == AJCSTC_TIM_STOP) {
				//	^C}~
				KillTimer(pW->hwnd, tid + 1);
				//	^C}~ʒm
				if (pW->cbNtc != NULL) {
					pW->cbNtc(AJCSTC_NTC_TIMSTP, tid, 0, pW->cbp);
				}
			}
		}
	}
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	EChvV[W																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	LRESULT CALLBACK 	WndStcHideProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HAJCSTC	pW;
	UI		tid;

	switch (msg) {
		//------------------------------------------------------------------------------------------------------//
		case WM_CREATE:
		{	LPCREATESTRUCT p = (LPCREATESTRUCT)lParam;
			pW = p->lpCreateParams;
			//	EChɃCX^X[N֘At
			MAjcSetWindowLong(hwnd, 0, (UX)pW);
			return 0;
		}
		//------------------------------------------------------------------------------------------------------//
		case WM_TIMER:
			pW = (HAJCSTC)MAjcGetWindowLong(hwnd, 0);
			//	^C}hcݒ
			tid = (UI)(wParam - 1);
			//	P^C}Ȃ΁A^C}~
			if (!pW->fCyclic[tid]) {
				KillTimer(hwnd, wParam);
			}
			//	^CAEgCxgs
			if (pW->TmInfo[tid].EvtCode != -1) {
				AjcStcExecEvent(pW, pW->TmInfo[tid].EvtCode);
			}
			return 0;
		//------------------------------------------------------------------------------------------------------//
		case WM_DESTROY:
			return 0;
	 }
	 return AjcDefWindowProc(hwnd, msg, wParam, lParam) ;
}
