#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	vԏ̕\iq_CAOj																			//
//																												//
//**************************************************************************************************************//
#define	INST_ID			0x27835A1F
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);
static	VO	SubMoveWindow(HAJCMSTVIEW pW);

//==============================================================================================================//
//	Function	:	v_CAO̕\																	//
//																												//
//	Argument	:	hParent		- eECh̃nh															//
//					cbp			- R[obNp^															//
//					cbGetInfo	- v擾R[obNnh												//
//					cbNtcClosed	- _CAON[YʒmpR[obN											//
//																												//
//	Return		:	 NULL	- i_CAOnhj														//
//					 NULL	- s																				//
//==============================================================================================================//
AJCEXPORT	HWND	WINAPI	AjcViewMesTimeCreate (HWND hParent, UX cbp, VO (CALLBACK *cbGetInfo  )(PAJCMSTINFO pBuf, UX cbp),
																		VO (CALLBACK *cbNtcClosed)( 			     UX cbp))
{
	HWND		rc = NULL;
	HAJCMSTVIEW	pW;

	if ((pW = (HAJCMSTVIEW)AJCMEM(sizeof(AJCMSTVIEW))) != NULL) {
		memset(pW, 0, sizeof *pW);
		pW->InstID		= INST_ID;
		pW->hParent		= hParent;
		pW->cbp			= cbp;
		pW->cbGetInfo	= cbGetInfo;
		pW->cbNtcClosed	= cbNtcClosed;
		if (pW->hMyDlg = CreateDialogParam(hDllInst, MAKEINTRESOURCE(IDD_MSTVIEW), hParent, AJC_DLGPROC_NAME(Main), (LPARAM)pW)) {
			SubMoveWindow(pW);
			rc = pW->hMyDlg;
		}
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	v_CAO̔j																	//
//																												//
//	Argument	:	pW		- CX^Xnh																//
//																												//
//	Return		:	TRUE	- 																				//
//					FALSE	- s																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcViewMesTimeDelete(HWND hDlg)
{
	BOOL		rc = FALSE;

	if (IsWindow(hDlg)) {
		HAJCMSTVIEW	pW = (HAJCMSTVIEW)GetProp(hDlg, L"AjcMstView");
		if (IS_MY_INST(pW)) {
			DestroyWindow(pW->hMyDlg);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	v_CAO̔zu																	//
//																												//
//	Argument	:	pW		- CX^Xnh																//
//																												//
//	Return		:	TRUE	- 																				//
//					FALSE	- s																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcViewMesTimeMove(HWND hDlg)
{
	BOOL		rc = FALSE;

	if (IsWindow(hDlg)) {
		HAJCMSTVIEW	pW = (HAJCMSTVIEW)GetProp(hDlg, L"AjcMstView");
		if (IS_MY_INST(pW)) {
			SubMoveWindow(pW);
			rc = TRUE;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	v\_CAOeECh̉Eɔzu																//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubMoveWindow(HAJCMSTVIEW pW)
{
	RECT	pr, dr;
	int		pw, ph;
	int		dw, dh;

	GetClientRect(pW->hParent, &pr);
	pw = pr.right - pr.left;
	ph = pr.bottom - pr.top;
	GetWindowRect(pW->hMyDlg , &dr);
	dw = dr.right - dr.left;
	dh = dr.bottom - dr.top;
	MoveWindow(pW->hMyDlg, pw - dw - 4, ph - dh - 4, dw, dh, TRUE);
	InvalidateRect(pW->hMyDlg, NULL, TRUE);
	ShowWindow(pW->hMyDlg, SW_SHOW);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	`摬x\_CAO																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG	)
{
	HAJCMSTVIEW	pW = (HAJCMSTVIEW)lParam;

	//	CX^X֘At
	SetProp(hDlg, L"AjcMstView", pW);

	//	peLXg
	AjcSetDlgItemStr(hDlg, IDC_LBL_AVE , LNGSEL(L""	 , L"Ave." ));
	AjcSetDlgItemStr(hDlg, IDC_LBL_MAX , LNGSEL(L"ő"	 , L"Max." ));
	AjcSetDlgItemStr(hDlg, IDC_LBL_MIN , LNGSEL(L"ŏ"	 , L"Min." ));
	AjcSetDlgItemStr(hDlg, IDC_LBL_CNT , LNGSEL(L""	 , L"Count"));
	AjcSetDlgItemStr(hDlg, IDC_LBL_FREQ, LNGSEL(L"g", L"Freq."));

	//	c[`bvERg[
		pW->hToolTip = CreateWindowEx(WS_EX_TOPMOST,
								TOOLTIPS_CLASS,
								NULL,
								TTS_ALWAYSTIP,
								CW_USEDEFAULT,
								CW_USEDEFAULT,
								CW_USEDEFAULT,
								CW_USEDEFAULT,
								pW->hParent,
								NULL,
								hDllInst, NULL);
	//	c[`bvǉ
	{	TOOLINFO	ti;
		memset(&ti, 0, sizeof ti);
		ti.cbSize	= sizeof(TOOLINFO);
		ti.hwnd		= pW->hParent;
		ti.hinst	= hDllInst;
		ti.uFlags	= TTF_IDISHWND | TTF_SUBCLASS;

		ti.lpszText = LNGSEL(L"`掞ԏ", L"Drawing time informations");
		ti.uId = (UX)hDlg;		SendMessage(pW->hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL(L"ϕ`掞[us]"			, L"Average drawing time[us]");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_AVE);		SendMessage(pW->hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL(L"ő`掞[us]"			, L"Maximum drawing time [us]");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_MAX);		SendMessage(pW->hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL(L"ŏ`掞[us]"			, L"Minimum drawing time [us]");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_MIN);		SendMessage(pW->hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL(L"`"					, L"Number of draws");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_CNT);		SendMessage(pW->hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL(L"vg[Hz]"			, L"Measurement frequency [Hz]");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_FREQ);	SendMessage(pW->hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL(L"`掞ԏ܂"	, L"Close drawing time information");
		ti.uId = (UX)GetDlgItem(hDlg, IDCANCEL);		SendMessage(pW->hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti);

	}
	//	vĎ^C}N
	SetTimer(hDlg, 1, 1000, NULL);

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	HAJCMSTVIEW	pW = (HAJCMSTVIEW)GetProp(hDlg, L"AjcMstView");
	TOOLINFO	ti;

	//	N[Yʒm
	if (pW->cbNtcClosed != NULL) {
		pW->cbNtcClosed(pW->cbp);
	}

	if (pW->hToolTip != NULL) {
		//	c[`bv폜
		memset(&ti, 0, sizeof ti);
		ti.cbSize	= sizeof(TOOLINFO);
		ti.hwnd		= pW->hParent;
		ti.hinst	= hDllInst;
		ti.uFlags	= TTF_IDISHWND | TTF_SUBCLASS;
		ti.lpszText = L"";

		ti.uId = (UX)hDlg;								SendMessage(pW->hToolTip, TTM_DELTOOL, 0, (LPARAM)&ti);
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_AVE);		SendMessage(pW->hToolTip, TTM_DELTOOL, 0, (LPARAM)&ti);
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_MAX);		SendMessage(pW->hToolTip, TTM_DELTOOL, 0, (LPARAM)&ti);
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_MIN);		SendMessage(pW->hToolTip, TTM_DELTOOL, 0, (LPARAM)&ti);
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_CNT);		SendMessage(pW->hToolTip, TTM_DELTOOL, 0, (LPARAM)&ti);
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_FREQ);	SendMessage(pW->hToolTip, TTM_DELTOOL, 0, (LPARAM)&ti);
		ti.uId = (UX)GetDlgItem(hDlg, IDCANCEL);		SendMessage(pW->hToolTip, TTM_DELTOOL, 0, (LPARAM)&ti);

		//	c[`bvRg[j
		DestroyWindow(pW->hToolTip);
	}
	//	CX^X
	free(pW);

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_TIMER		)
{
	HAJCMSTVIEW	pW	= (HAJCMSTVIEW)GetProp(hDlg, L"AjcMstView");
	AJCMSTINFO	mti = {0};

	if (pW->cbGetInfo != NULL) {
		pW->cbGetInfo(&mti, pW->cbp);
		//	`摬x\
		AjcSepDlgItemUI64(hDlg, IDC_TXT_FREQ, mti.Freq);
		AjcSepDlgItemUI64(hDlg, IDC_TXT_CNT , mti.Cnt );
		AjcSepDlgItemUI64(hDlg, IDC_TXT_AVE , mti.Ave );
		AjcSepDlgItemUI64(hDlg, IDC_TXT_MAX , mti.Max );
		AjcSepDlgItemUI64(hDlg, IDC_TXT_MIN , mti.Min );
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL		)
{
	HAJCMSTVIEW	pW = (HAJCMSTVIEW)GetProp(hDlg, L"AjcMstView");

	//	_CAOj
	DestroyWindow(hDlg);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG		)
	AJC_DLGMAP_MSG(Main, WM_DESTROY			)
	AJC_DLGMAP_MSG(Main, WM_TIMER			)
	AJC_DLGMAP_CMD(Main, IDCANCEL			)
AJC_DLGMAP_END

