#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	ϐǗ																									//
//																												//
//**************************************************************************************************************//

#define	INST_ID			0x9245FC7A
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//--------------------------------------------------------------------------------------------------------------//
//	Q؃R[obNiϐrj																		//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static int CALLBACK cbCompA(UX key1, UX key2, UX cbp)
{
	return mbscmp((C_BCP)key1, (C_BCP)key2);
}
//----- Ch ---------------------------------------------------------------------------------------------//
static int CALLBACK cbCompW(UX key1, UX key2, UX cbp)
{
	return wcscmp((WCP)key1, (WCP)key2);
}
//--------------------------------------------------------------------------------------------------------------//
//	Q؃R[obNim[h폜j																			//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static VO CALLBACK cbDelNodeA(UX key, C_VOP pNodeData, UI len, UI nest, UX cbp)
{
	PCAJCVMGNODEA	pNode = (PCAJCVMGNODEA)pNodeData;

	if (pNode->pName != NULL) {
		AjcTFree((VOP)pNode->pName);
	}
	if (pNode->arr.vp != NULL) {
		if (pNode->type == AJCVMGT_STR) {
			UI i;
			for (i = 0; i < pNode->num; i++) {
				if (pNode->arr.pStr[i] != NULL) {
					AjcTFree(pNode->arr.pStr[i]);
				}
			}
		}
		AjcTFree(pNode->arr.vp);
	}
}
//----- Ch ---------------------------------------------------------------------------------------------//
static VO CALLBACK cbDelNodeW(UX key, C_VOP pNodeData, UI len, UI nest, UX cbp)
{
	PCAJCVMGNODEW	pNode = (PCAJCVMGNODEW)pNodeData;

	if (pNode->pName != NULL) {
		AjcTFree((VOP)pNode->pName);
	}
	if (pNode->arr.vp != NULL) {
		if (pNode->type == AJCVMGT_STR) {
			UI i;
			for (i = 0; i < pNode->num; i++) {
				if (pNode->arr.pStr[i] != NULL) {
					AjcTFree(pNode->arr.pStr[i]);
				}
			}
		}
		AjcTFree(pNode->arr.vp);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	Q؃R[obNiSm[hǂݏoj																		//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static BOOL CALLBACK WINAPI cbNtcNodeA(UX key, C_VOP pNodeData, UI len, UI nest, UX cbp)
{
	BOOL		rc = TRUE;
	HAJCVMGA	pW = (HAJCVMGA)cbp;

	rc = pW->cbNtcVar((PCAJCVMGNODEA)pNodeData, pW->cbp);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static BOOL CALLBACK WINAPI cbNtcNodeW(UX key, C_VOP pNodeData, UI len, UI nest, UX cbp)
{
	BOOL		rc = TRUE;
	HAJCVMGW	pW = (HAJCVMGW)cbp;

	rc = pW->cbNtcVar((PCAJCVMGNODEW)pNodeData, pW->cbp);

	return rc;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	NULL - iCX^Xnhj															//
//				NULL - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT HAJCVMGA		WINAPI AjcVmgCreateA(VO)
{
	HAJCVMGA	hVmg = NULL;

	if (hVmg = (HAJCVMGA)AJCMEM(sizeof(AJCVMGA))) {
		memset(hVmg, 0, sizeof(AJCVMGA));
		hVmg->InstID = INST_ID;
		if (!(hVmg->hAvlVar = AjcAvlCreate((UX)hVmg, cbCompA, cbDelNodeA))) {
			free(hVmg);
			hVmg = NULL;
		}
	}
	return hVmg;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT HAJCVMGW		WINAPI AjcVmgCreateW(VO)
{
	HAJCVMGW	hVmg = NULL;

	if (hVmg = (HAJCVMGW)AJCMEM(sizeof(AJCVMGW))) {
		memset(hVmg, 0, sizeof(AJCVMGW));
		hVmg->InstID = INST_ID;
		if (!(hVmg->hAvlVar = AjcAvlCreate((UX)hVmg, cbCompW, cbDelNodeW))) {
			free(hVmg);
			hVmg = NULL;
		}
	}
	return hVmg;
}

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT VO			WINAPI AjcVmgDeleteA(HAJCVMGA pW)
{
	if (IS_MY_INST(pW)) {
		if (pW->hAvlVar != NULL) {
			AjcAvlDelete(pW->hAvlVar);
		}
		free(pW);
	}
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT VO			WINAPI AjcVmgDeleteW(HAJCVMGW pW)
{
	if (IS_MY_INST(pW)) {
		if (pW->hAvlVar != NULL) {
			AjcAvlDelete(pW->hAvlVar);
		}
		free(pW);
	}
}

//==============================================================================================================//
//	Sϐj																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT VO			WINAPI AjcVmgPurgeA(HAJCVMGA pW)
{
	if (IS_MY_INST(pW)) {
		if (pW->hAvlVar != NULL) {
			AjcAvlDelAllNodes(pW->hAvlVar);
		}
	}
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT VO			WINAPI AjcVmgPurgeW(HAJCVMGW pW)
{
	if (IS_MY_INST(pW)) {
		if (pW->hAvlVar != NULL) {
			AjcAvlDelAllNodes(pW->hAvlVar);
		}
	}
}

//==============================================================================================================//
//	ϐ̍쐬																									//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//				type		- ϐ̃^Cv																		//
//				num			- z̗vf																		//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgGenVarA(HAJCVMGA pW, C_BCP pVarName, AJCVMGTYPE type, UI num)
{
	BOOL	rc = FALSE;
	AJCVMGNODEA	Node;

	if (IS_MY_INST(pW) && pVarName != NULL) {

		//	m[hNA[
		memset(&Node, 0, sizeof Node);
		//	vf␳
		if (num == 0) num = 1;

		//	ϐl̈m
		Node.num = num;
		switch (type) {
			//	l̏ꍇ͑Svf[NA[
			case AJCVMGT_INT:	if (Node.arr.pSI = (SIP)AJCMEM(sizeof(SI) * num)) {
									memset(Node.arr.pSI, 0, sizeof(SI) * num);
								}
								break;
			case AJCVMGT_LONG:	if (Node.arr.pSLL = (SLLP)AJCMEM(sizeof(SLL) * num)) {
									memset(Node.arr.pSLL, 0, sizeof(SLL) * num);
								}
							 	break;
			case AJCVMGT_REAL:	if (Node.arr.pDBL = (double*)AJCMEM(sizeof(double) * num)) {
									memset(Node.arr.pDBL, 0, sizeof(double) * num);
								}
								break;
			//	̏ꍇ͑Svfɋ󕶎ݒ
			case AJCVMGT_STR:	if (Node.arr.pStr = (BCP *)AJCMEM(sizeof(BCP) * num)) {
									UI	i;
									for (i = 0; i < num; i++) {
										if (Node.arr.pStr[i] = AjcTAllocA(1)) {
											*Node.arr.pStr[i] = 0;
										}
										else {
											UI	j;
											for (j = 0; j < i; j++) {
												AjcTFree(Node.arr.pStr[j]);
											}
											Node.arr.pStr = NULL;
											break;
										}
									}
								}
								break;
		}
		//	ϐC^Cvݒ
		if (Node.arr.vp != NULL) {
			if (Node.pName = AjcTAllocA((UI)strlen(pVarName) + 1)) {
				strcpy(Node.pName, pVarName);
				Node.type  = type;
				rc = AjcAvlInsNode(pW->hAvlVar, (UX)Node.pName, &Node, sizeof Node);
			}
		}
		//	s̓\[X
		if (rc == FALSE) {
			if (Node.pName  != NULL) AjcTFree(Node.pName);
			if (Node.arr.vp != NULL) free(Node.arr.vp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgGenVarW(HAJCVMGW pW, C_WCP pVarName, AJCVMGTYPE type, UI num)
{
	BOOL	rc = FALSE;
	AJCVMGNODEW	Node;

	if (IS_MY_INST(pW) && pVarName != NULL) {

		//	m[hNA[
		memset(&Node, 0, sizeof Node);
		//	vf␳
		if (num == 0) num = 1;

		//	ϐl̈m
		Node.num = num;
		switch (type) {
			//	l̏ꍇ͑Svf[NA[
			case AJCVMGT_INT:	if (Node.arr.pSI = (SIP)AJCMEM(sizeof(SI) * num)) {
									memset(Node.arr.pSI, 0, sizeof(SI) * num);
								}
								break;
			case AJCVMGT_LONG:	if (Node.arr.pSLL = (SLLP)AJCMEM(sizeof(SLL) * num)) {
									memset(Node.arr.pSLL, 0, sizeof(SLL) * num);
								}
							 	break;
			case AJCVMGT_REAL:	if (Node.arr.pDBL = (double*)AJCMEM(sizeof(double) * num)) {
									memset(Node.arr.pDBL, 0, sizeof(double) * num);
								}
								break;
			//	̏ꍇ͑Svfɋ󕶎ݒ
			case AJCVMGT_STR:	if (Node.arr.pStr = (WCP *)AJCMEM(sizeof(WCP) * num)) {
									UI	i;
									for (i = 0; i < num; i++) {
										if (Node.arr.pStr[i] = AjcTAllocW(1)) {
											*Node.arr.pStr[i] = 0;
										}
										else {
											UI	j;
											for (j = 0; j < i; j++) {
												AjcTFree(Node.arr.pStr[j]);
											}
											Node.arr.pStr = NULL;
											break;
										}
									}
								}
								break;
		}
		//	ϐC^Cvݒ
		if (Node.arr.vp != NULL) {
			if (Node.pName = AjcTAllocW((UI)wcslen(pVarName) + 1)) {
				wcscpy(Node.pName, pVarName);
				Node.type  = type;
				rc = AjcAvlInsNode(pW->hAvlVar, (UX)Node.pName, &Node, sizeof Node);
			}
		}
		//	s̓\[X
		if (rc == FALSE) {
			if (Node.pName  != NULL) AjcTFree(Node.pName);
			if (Node.arr.vp != NULL) free(Node.arr.vp);
		}
	}
	return rc;
}
//==============================================================================================================//
//	ϐ̑ݒ																								//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//				att			- ϐ̑(AJCVMGA_XXXXX)															//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgSetAttA(HAJCVMGA pW, C_BCP pVarName, UI att)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEA	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			pNode->att = att;
			rc = TRUE;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgSetAttW(HAJCVMGA pW, C_WCP pVarName, UI att)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEW	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			pNode->att = att;
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	ϐ̑擾																								//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//																												//
//	߂l	F	-1 - iϐ̑lj																		//
//				-1 - s																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UI			WINAPI AjcVmgGetAttA(HAJCVMGA pW, C_BCP pVarName)
{
	UI				rc = -1;
	PAJCVMGNODEA	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			rc = pNode->att;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UI			WINAPI AjcVmgGetAttW(HAJCVMGA pW, C_WCP pVarName)
{
	UI				rc = -1;
	PAJCVMGNODEW	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			rc = pNode->att;
		}
	}
	return rc;
}

//==============================================================================================================//
//	ϐ̍폜																									//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgDelVarA(HAJCVMGA pW, C_BCP pVarName)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		rc = AjcAvlDelNode(pW->hAvlVar, (UX)pVarName);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgDelVarW(HAJCVMGW pW, C_WCP pVarName)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		rc = AjcAvlDelNode(pW->hAvlVar, (UX)pVarName);
	}
	return rc;
}

//==============================================================================================================//
//	ϐlݒij																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				value		- ϐl																			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgSetIntegerA(HAJCVMGA pW, C_BCP pVarName, UI ix, SLL value)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEA	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (!(pNode->att & AJCVMGA_RDONLY)) {
				if (pNode->num > ix) {
					switch (pNode->type) {
						case AJCVMGT_INT:	pNode->arr.pSI [ix] = (SI    )value; rc = TRUE; break;
						case AJCVMGT_LONG:	pNode->arr.pSLL[ix] = (SLL   )value; rc = TRUE; break;
						case AJCVMGT_REAL:	pNode->arr.pDBL[ix] = (double)value; rc = TRUE; break;
					}
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgSetIntegerW(HAJCVMGW pW, C_WCP pVarName, UI ix, SLL value)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEW	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (!(pNode->att & AJCVMGA_RDONLY)) {
				if (pNode->num > ix) {
					switch (pNode->type) {
						case AJCVMGT_INT:	pNode->arr.pSI [ix] = (SI    )value; rc = TRUE; break;
						case AJCVMGT_LONG:	pNode->arr.pSLL[ix] = (SLL   )value; rc = TRUE; break;
						case AJCVMGT_REAL:	pNode->arr.pDBL[ix] = (double)value; rc = TRUE; break;
					}
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ϐlݒij																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				value		- ϐl																			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgSetRealA	(HAJCVMGA pW, C_BCP pVarName, UI ix, double value)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEA	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (!(pNode->att & AJCVMGA_RDONLY)) {
				if (pNode->num > ix) {
					switch (pNode->type) {
						case AJCVMGT_INT:	pNode->arr.pSI [ix] = (SI    )value; rc = TRUE; break;
						case AJCVMGT_LONG:	pNode->arr.pSLL[ix] = (SLL   )value; rc = TRUE; break;
						case AJCVMGT_REAL:	pNode->arr.pDBL[ix] = (double)value; rc = TRUE; break;
					}
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgSetRealW	(HAJCVMGW pW, C_WCP pVarName, UI ix, double value)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEW	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (!(pNode->att & AJCVMGA_RDONLY)) {
				if (pNode->num > ix) {
					switch (pNode->type) {
						case AJCVMGT_INT:	pNode->arr.pSI [ix] = (SI    )value; rc = TRUE; break;
						case AJCVMGT_LONG:	pNode->arr.pSLL[ix] = (SLL   )value; rc = TRUE; break;
						case AJCVMGT_REAL:	pNode->arr.pDBL[ix] = (double)value; rc = TRUE; break;
					}
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ϐlݒij																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				pStr		- ւ̃|C^																//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgSetStringA	(HAJCVMGA pW, C_BCP pVarName, UI ix, C_BCP pStr)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEA	pNode;
	BCP				pNewStr = NULL;

	if (IS_MY_INST(pW) && pVarName != NULL && pStr != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (!(pNode->att & AJCVMGA_RDONLY)) {
				if (pNode->num > ix && pNode->type == AJCVMGT_STR) {
					if (pNewStr = AjcTAllocA((UI)strlen(pStr) + 1)) {
						if (pNode->arr.pStr[ix] != NULL) {
							AjcTFree(pNode->arr.pStr[ix]);
						}
						pNode->arr.pStr[ix] = pNewStr;
						strcpy(pNode->arr.pStr[ix], pStr);
						rc = TRUE;
					}
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgSetStringW	(HAJCVMGW pW, C_WCP pVarName, UI ix, C_WCP pStr)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEW	pNode;
	WCP				pNewStr = NULL;

	if (IS_MY_INST(pW) && pVarName != NULL && pStr != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (!(pNode->att & AJCVMGA_RDONLY)) {
				if (pNode->num > ix && pNode->type == AJCVMGT_STR) {
					if (pNewStr = AjcTAllocW((UI)wcslen(pStr) + 1)) {
						if (pNode->arr.pStr[ix] != NULL) {
							AjcTFree(pNode->arr.pStr[ix]);
						}
						pNode->arr.pStr[ix] = pNewStr;
						wcscpy(pNode->arr.pStr[ix], pStr);
						rc = TRUE;
					}
				}
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	ϐl擾iRQrbgj																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				pValue		- ϐli[obt@̃AhX												//
//																												//
//	߂l	F	O - iϐ̃^Cvj																		//
//				O - s																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT AJCVMGTYPE	WINAPI AjcVmgGetInt32A(HAJCVMGA pW, C_BCP pVarName, UI ix, SIP pValue)
{
	AJCVMGTYPE		rc = AJCVMGT_UNDEF;
	PAJCVMGNODEA	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (pNode->num > ix) {
				switch (pNode->type) {
					case AJCVMGT_INT:	if (pValue != NULL) {*pValue = (SI)pNode->arr.pSI [ix];} rc = pNode->type; break;
					case AJCVMGT_LONG:	if (pValue != NULL) {*pValue = (SI)pNode->arr.pSLL[ix];} rc = pNode->type; break;
					case AJCVMGT_REAL:	if (pValue != NULL) {*pValue = (SI)pNode->arr.pDBL[ix];} rc = pNode->type; break;
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT AJCVMGTYPE	WINAPI AjcVmgGetInt32W(HAJCVMGW pW, C_WCP pVarName, UI ix, SIP pValue)
{
	AJCVMGTYPE		rc = AJCVMGT_UNDEF;
	PAJCVMGNODEW	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (pNode->num > ix) {
				switch (pNode->type) {
					case AJCVMGT_INT:	if (pValue != NULL) {*pValue = (SI)pNode->arr.pSI [ix];} rc = pNode->type; break;
					case AJCVMGT_LONG:	if (pValue != NULL) {*pValue = (SI)pNode->arr.pSLL[ix];} rc = pNode->type; break;
					case AJCVMGT_REAL:	if (pValue != NULL) {*pValue = (SI)pNode->arr.pDBL[ix];} rc = pNode->type; break;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ϐl擾iUSrbgj																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				pValue		- ϐli[obt@̃AhX												//
//																												//
//	߂l	F	O - iϐ̃^Cvj																		//
//				O - s																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT AJCVMGTYPE	WINAPI AjcVmgGetInt64A(HAJCVMGA pW, C_BCP pVarName, UI ix, SLLP pValue)
{
	AJCVMGTYPE		rc = AJCVMGT_UNDEF;
	PAJCVMGNODEA	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (pNode->num > ix) {
				switch (pNode->type) {
					case AJCVMGT_INT:	if (pValue != NULL) {*pValue = (SLL)pNode->arr.pSI [ix];} rc = pNode->type; break;
					case AJCVMGT_LONG:	if (pValue != NULL) {*pValue = (SLL)pNode->arr.pSLL[ix];} rc = pNode->type; break;
					case AJCVMGT_REAL:	if (pValue != NULL) {*pValue = (SLL)pNode->arr.pDBL[ix];} rc = pNode->type; break;
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT AJCVMGTYPE	WINAPI AjcVmgGetInt64W(HAJCVMGW pW, C_WCP pVarName, UI ix, SLLP pValue)
{
	AJCVMGTYPE		rc = AJCVMGT_UNDEF;
	PAJCVMGNODEW	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (pNode->num > ix) {
				switch (pNode->type) {
					case AJCVMGT_INT:	if (pValue != NULL) {*pValue = (SLL)pNode->arr.pSI [ix];} rc = pNode->type; break;
					case AJCVMGT_LONG:	if (pValue != NULL) {*pValue = (SLL)pNode->arr.pSLL[ix];} rc = pNode->type; break;
					case AJCVMGT_REAL:	if (pValue != NULL) {*pValue = (SLL)pNode->arr.pDBL[ix];} rc = pNode->type; break;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ϐl擾ij																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//				pValue		- ϐli[obt@̃AhX												//
//																												//
//	߂l	F	O - iϐ̃^Cvj																		//
//				O - s																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT AJCVMGTYPE	WINAPI AjcVmgGetRealA	(HAJCVMGA pW, C_BCP pVarName, UI ix, double *pValue)
{
	AJCVMGTYPE		rc = AJCVMGT_UNDEF;
	PAJCVMGNODEA	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (pNode->num > ix) {
				switch (pNode->type) {
					case AJCVMGT_INT:	if (pValue != NULL) {*pValue = (double)pNode->arr.pSI [ix];} rc = pNode->type; break;
					case AJCVMGT_LONG:	if (pValue != NULL) {*pValue = (double)pNode->arr.pSLL[ix];} rc = pNode->type; break;
					case AJCVMGT_REAL:	if (pValue != NULL) {*pValue = (double)pNode->arr.pDBL[ix];} rc = pNode->type; break;
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT AJCVMGTYPE	WINAPI AjcVmgGetRealW	(HAJCVMGW pW, C_WCP pVarName, UI ix, double *pValue)
{
	AJCVMGTYPE		rc = AJCVMGT_UNDEF;
	PAJCVMGNODEW	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (pNode->num > ix) {
				switch (pNode->type) {
					case AJCVMGT_INT:	if (pValue != NULL) {*pValue = (double)pNode->arr.pSI [ix];} rc = pNode->type; break;
					case AJCVMGT_LONG:	if (pValue != NULL) {*pValue = (double)pNode->arr.pSLL[ix];} rc = pNode->type; break;
					case AJCVMGT_REAL:	if (pValue != NULL) {*pValue = (double)pNode->arr.pDBL[ix];} rc = pNode->type; break;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ϐl擾ij																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//				ix			- vfCfNX																	//
//																												//
//	߂l	F	NULL - 																					//
//				NULL - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT C_BCP	WINAPI AjcVmgGetStringA	(HAJCVMGA pW, C_BCP pVarName, UI ix)
{
	C_BCP			rc = NULL;
	PAJCVMGNODEA	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (pNode->num > ix) {
				if (pNode->type == AJCVMGT_STR) {
					rc = pNode->arr.pStr[ix];
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT C_WCP	WINAPI AjcVmgGetStringW	(HAJCVMGW pW, C_WCP pVarName, UI ix)
{
	C_WCP			rc = NULL;
	PAJCVMGNODEW	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			if (pNode->num > ix) {
				if (pNode->type == AJCVMGT_STR) {
					rc = pNode->arr.pStr[ix];
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	ϐľ																								//
//																												//
//	@	F	pW				- CX^Xnh															//
//				pVarName1, ix1	- lϐւ̃|C^CzvfCfNX							//
//				pVarName2, ix2	- 	V																			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	WINAPI AjcVmgSwapA(HAJCVMGA pW, C_BCP pVarName1, UI ix1, C_BCP pVarName2, UI ix2)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEA	pNode1, pNode2;

	if (IS_MY_INST(pW) && pVarName1 != NULL && pVarName2 != NULL) {
		pNode1 = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName1, NULL);
		pNode2 = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName2, NULL);
		if (pNode1 != NULL && pNode2 != NULL && !(pNode1->att & AJCVMGA_RDONLY) && !(pNode2->att & AJCVMGA_RDONLY) && pNode1->num > ix1 && pNode2->num > ix2) {
			switch (pNode1->type) {
				case AJCVMGT_INT:
					switch (pNode2->type) {
						case AJCVMGT_INT:	{SI     sv = pNode1->arr.pSI [ix1]; pNode1->arr.pSI [ix1] = (SI    )pNode2->arr.pSI [ix2]; pNode2->arr.pSI [ix2] = (SI    )sv; rc = TRUE; break;}
						case AJCVMGT_LONG:	{SI     sv = pNode1->arr.pSI [ix1]; pNode1->arr.pSI [ix1] = (SI    )pNode2->arr.pSLL[ix2]; pNode2->arr.pSLL[ix2] = (SLL   )sv; rc = TRUE; break;}
						case AJCVMGT_REAL:	{SI     sv = pNode1->arr.pSI [ix1]; pNode1->arr.pSI [ix1] = (SI    )pNode2->arr.pDBL[ix2]; pNode2->arr.pDBL[ix2] = (double)sv; rc = TRUE; break;}
					}
					break;
				case AJCVMGT_LONG:
					switch (pNode2->type) {
						case AJCVMGT_INT:	{SLL    sv = pNode1->arr.pSLL[ix1]; pNode1->arr.pSLL[ix1] = (SLL   )pNode2->arr.pSI [ix2]; pNode2->arr.pSI [ix2] = (SI    )sv; rc = TRUE; break;}
						case AJCVMGT_LONG:	{SLL    sv = pNode1->arr.pSLL[ix1]; pNode1->arr.pSLL[ix1] = (SLL   )pNode2->arr.pSLL[ix2]; pNode2->arr.pSLL[ix2] = (SLL   )sv; rc = TRUE; break;}
						case AJCVMGT_REAL:	{SLL    sv = pNode1->arr.pSLL[ix1]; pNode1->arr.pSLL[ix1] = (SLL   )pNode2->arr.pDBL[ix2]; pNode2->arr.pDBL[ix2] = (double)sv; rc = TRUE; break;}
					}
					break;
				case AJCVMGT_REAL:
					switch (pNode2->type) {
						case AJCVMGT_INT:	{double sv = pNode1->arr.pDBL[ix1]; pNode1->arr.pDBL[ix1] = (double)pNode2->arr.pSI [ix2]; pNode2->arr.pSI [ix2] = (SI    )sv; rc = TRUE; break;}
						case AJCVMGT_LONG:	{double sv = pNode1->arr.pDBL[ix1]; pNode1->arr.pDBL[ix1] = (double)pNode2->arr.pSLL[ix2]; pNode2->arr.pSLL[ix2] = (SLL   )sv; rc = TRUE; break;}
						case AJCVMGT_REAL:	{double sv = pNode1->arr.pDBL[ix1]; pNode1->arr.pDBL[ix1] = (double)pNode2->arr.pDBL[ix2]; pNode2->arr.pDBL[ix2] = (double)sv; rc = TRUE; break;}
					}
					break;
				case AJCVMGT_STR:
					if (pNode2->type == AJCVMGT_STR) {
						BCP		pSv = pNode1->arr.pStr[ix1];
						pNode1->arr.pStr[ix1] = pNode2->arr.pStr[ix2];
						pNode2->arr.pStr[ix2] = pSv;
						rc = TRUE;
					}
					break;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	WINAPI AjcVmgSwapW(HAJCVMGW pW, C_WCP pVarName1, UI ix1, C_WCP pVarName2, UI ix2)
{
	BOOL			rc = FALSE;
	PAJCVMGNODEW	pNode1, pNode2;

	if (IS_MY_INST(pW) && pVarName1 != NULL && pVarName2 != NULL) {
		pNode1 = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName1, NULL);
		pNode2 = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName2, NULL);
		if (pNode1 != NULL && pNode2 != NULL && !(pNode1->att & AJCVMGA_RDONLY) && !(pNode2->att & AJCVMGA_RDONLY) && pNode1->num > ix1 && pNode2->num > ix2) {
			switch (pNode1->type) {
				case AJCVMGT_INT:
					switch (pNode2->type) {
						case AJCVMGT_INT:	{SI     sv = pNode1->arr.pSI [ix1]; pNode1->arr.pSI [ix1] = (SI    )pNode2->arr.pSI [ix2]; pNode2->arr.pSI [ix2] = (SI    )sv; rc = TRUE; break;}
						case AJCVMGT_LONG:	{SI     sv = pNode1->arr.pSI [ix1]; pNode1->arr.pSI [ix1] = (SI    )pNode2->arr.pSLL[ix2]; pNode2->arr.pSLL[ix2] = (SLL   )sv; rc = TRUE; break;}
						case AJCVMGT_REAL:	{SI     sv = pNode1->arr.pSI [ix1]; pNode1->arr.pSI [ix1] = (SI    )pNode2->arr.pDBL[ix2]; pNode2->arr.pDBL[ix2] = (double)sv; rc = TRUE; break;}
					}
					break;
				case AJCVMGT_LONG:
					switch (pNode2->type) {
						case AJCVMGT_INT:	{SLL    sv = pNode1->arr.pSLL[ix1]; pNode1->arr.pSLL[ix1] = (SLL   )pNode2->arr.pSI [ix2]; pNode2->arr.pSI [ix2] = (SI    )sv; rc = TRUE; break;}
						case AJCVMGT_LONG:	{SLL    sv = pNode1->arr.pSLL[ix1]; pNode1->arr.pSLL[ix1] = (SLL   )pNode2->arr.pSLL[ix2]; pNode2->arr.pSLL[ix2] = (SLL   )sv; rc = TRUE; break;}
						case AJCVMGT_REAL:	{SLL    sv = pNode1->arr.pSLL[ix1]; pNode1->arr.pSLL[ix1] = (SLL   )pNode2->arr.pDBL[ix2]; pNode2->arr.pDBL[ix2] = (double)sv; rc = TRUE; break;}
					}
					break;
				case AJCVMGT_REAL:
					switch (pNode2->type) {
						case AJCVMGT_INT:	{double sv = pNode1->arr.pDBL[ix1]; pNode1->arr.pDBL[ix1] = (double)pNode2->arr.pSI [ix2]; pNode2->arr.pSI [ix2] = (SI    )sv; rc = TRUE; break;}
						case AJCVMGT_LONG:	{double sv = pNode1->arr.pDBL[ix1]; pNode1->arr.pDBL[ix1] = (double)pNode2->arr.pSLL[ix2]; pNode2->arr.pSLL[ix2] = (SLL   )sv; rc = TRUE; break;}
						case AJCVMGT_REAL:	{double sv = pNode1->arr.pDBL[ix1]; pNode1->arr.pDBL[ix1] = (double)pNode2->arr.pDBL[ix2]; pNode2->arr.pDBL[ix2] = (double)sv; rc = TRUE; break;}
					}
					break;
				case AJCVMGT_STR:
					if (pNode2->type == AJCVMGT_STR) {
						WCP		pSv = pNode1->arr.pStr[ix1];
						pNode1->arr.pStr[ix1] = pNode2->arr.pStr[ix2];
						pNode2->arr.pStr[ix2] = pSv;
						rc = TRUE;
					}
					break;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	zvf̎擾																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//																												//
//	߂l	F	O - iz̗vfj																		//
//				O - s																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UI			WINAPI AjcVmgGetArrNumA(HAJCVMGA pW, C_BCP pVarName)
{
	UI				rc = 0;
	PAJCVMGNODEA	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			rc = pNode->num;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UI			WINAPI AjcVmgGetArrNumW(HAJCVMGW pW, C_WCP pVarName)
{
	UI				rc = 0;
	PAJCVMGNODEW	pNode;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		if (pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL)) {
			rc = pNode->num;
		}
	}
	return rc;
}

//==============================================================================================================//
//	ϐm[h擾																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVarName	- ϐւ̃|C^																//
//																												//
//	߂l	F	NULL - iϐm[h̃AhXj														//
//				NULL - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT PCAJCVMGNODEA	WINAPI AjcVmgGetNodeA(HAJCVMGA pW, C_BCP pVarName)
{
	PAJCVMGNODEA	pNode = NULL;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		pNode = (PAJCVMGNODEA)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL);
	}
	return pNode;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT PCAJCVMGNODEW	WINAPI AjcVmgGetNodeW(HAJCVMGW pW, C_WCP pVarName)
{
	PAJCVMGNODEW	pNode = NULL;

	if (IS_MY_INST(pW) && pVarName != NULL) {
		pNode = (PAJCVMGNODEW)AjcAvlGetNodePtr(pW->hAvlVar, (UX)pVarName, NULL);
	}
	return pNode;
}
//==============================================================================================================//
//	o^ϕϐ̗																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//				cbp			- R[obNp^																//
//				cbNtcVar	- R[obN֐																	//
//																												//
//	߂l	F	o^ϕϐ̌																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UI 			WINAPI AjcVmgEnumVarA(HAJCVMGA pW, UX cbp, BOOL (CALLBACK *cbNtcVar)(PCAJCVMGNODEA pVarInfo, UX cbp))
{
	UI	rc = 0;

	if (IS_MY_INST(pW) && cbNtcVar != NULL) {
		pW->cbp		 = cbp;
		pW->cbNtcVar = cbNtcVar;
		rc = AjcAvlEnumNodes(pW->hAvlVar, cbNtcNodeA, FALSE);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UI 			WINAPI AjcVmgEnumVarW(HAJCVMGW pW, UX cbp, BOOL (CALLBACK *cbNtcVar)(PCAJCVMGNODEW pVarInfo, UX cbp))
{
	UI	rc = 0;

	if (IS_MY_INST(pW) && cbNtcVar != NULL) {
		pW->cbp		 = cbp;
		pW->cbNtcVar = cbNtcVar;
		rc = AjcAvlEnumNodes(pW->hAvlVar, cbNtcNodeW, FALSE);
	}
	return rc;
}
//==============================================================================================================//
//	ϐ^z̃Rs[																							//
//																												//
//	@	F	pWD			- Rs[CX^Xnh														//
//				pNameD		- Rs[ϐ																	//
//				pWS			- Rs[CX^Xnh														//
//				pNameD		- Rs[ϐ																	//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgCopyA(HAJCVMGA pWD, C_BCP pNameD, HAJCVMGA pWS, C_BCP pNameS)
{
	BOOL			rc     = TRUE;
	PCAJCVMGNODEA	pNodeS = NULL;
	PCAJCVMGNODEA	pNodeD = NULL;
	UI				ix     = 0;

	if (IS_MY_INST(pWD) && pNameD != NULL && IS_MY_INST(pWS) && pNameS != NULL) {
		do {
			//	Rs[m[h擾
			if ((pNodeS = AjcVmgGetNodeA(pWS, pNameS)) == NULL) {rc = FALSE; break;}
			//	Rs[m[h擾
			pNodeD = AjcVmgGetNodeA(pWD, pNameD);

			if (pNodeD == NULL || !(pNodeD->att & AJCVMGA_RDONLY)) { // Rs[ϐ^݉H
				//	Rs[ϐ폜
				AjcVmgDelVarA(pWD, pNameD);
				//	Rs[ϐ쐬m[h擾
				if (AjcVmgGenVarA(pWD, pNameD, pNodeS->type, pNodeS->num)) {
					if ((pNodeD = AjcVmgGetNodeA(pWD, pNameD)) == NULL) {rc = FALSE; break;}
				}
				else {rc = FALSE; break;}
				//	ϐ̓eRs[
				for (ix = 0; ix < pNodeD->num; ix++) {
					switch (pNodeD->type) {
						case AJCVMGT_INT:	pNodeD->arr.pSI [ix] = pNodeS->arr.pSI [ix]; break;
						case AJCVMGT_LONG:	pNodeD->arr.pSLL[ix] = pNodeS->arr.pSLL[ix]; break;
						case AJCVMGT_REAL:	pNodeD->arr.pDBL[ix] = pNodeS->arr.pDBL[ix]; break;
						case AJCVMGT_STR:
						{	BCP	pTmp;
							UI	stl = (UI)strlen(pNodeS->arr.pStr[ix]) + 1;
							if (pTmp = AjcTAllocA(stl)) {
								strcpy(pTmp, pNodeS->arr.pStr[ix]);
								if (pNodeD->arr.pStr[ix] != NULL) {
									AjcTFree(pNodeD->arr.pStr[ix]);
								}
								pNodeD->arr.pStr[ix] = pTmp;
							}
							else rc = FALSE;
							break;
						}
					}
				}
				//	G[Ȃ΁ARs[ϐ폜
				if (rc == FALSE) {
					AjcVmgDelVarA(pWD, pNameD);
				}
			}
		} while (0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI AjcVmgCopyW(HAJCVMGW pWD, C_WCP pNameD, HAJCVMGW pWS, C_WCP pNameS)
{
	BOOL			rc     = TRUE;
	PCAJCVMGNODEW	pNodeS = NULL;
	PCAJCVMGNODEW	pNodeD = NULL;
	UI				ix     = 0;

	if (IS_MY_INST(pWD) && pNameD != NULL && IS_MY_INST(pWS) && pNameS != NULL) {
		do {
			//	Rs[m[h擾
			if ((pNodeS = AjcVmgGetNodeW(pWS, pNameS)) == NULL) {rc = FALSE; break;}
			//	Rs[m[h擾
			pNodeD = AjcVmgGetNodeW(pWD, pNameD);

			if (pNodeD == NULL || !(pNodeD->att & AJCVMGA_RDONLY)) { // Rs[ϐ^݉H
				//	Rs[ϐ폜
				AjcVmgDelVarW(pWD, pNameD);
				//	Rs[ϐ쐬m[h擾
				if (AjcVmgGenVarW(pWD, pNameD, pNodeS->type, pNodeS->num)) {
					if ((pNodeD = AjcVmgGetNodeW(pWD, pNameS)) == NULL) {rc = FALSE; break;}
				}
				else {rc = FALSE; break;}
				//	ϐ̓eRs[
				for (ix = 0; ix < pNodeD->num; ix++) {
					switch (pNodeD->type) {
						case AJCVMGT_INT:	pNodeD->arr.pSI [ix] = pNodeS->arr.pSI [ix]; break;
						case AJCVMGT_LONG:	pNodeD->arr.pSLL[ix] = pNodeS->arr.pSLL[ix]; break;
						case AJCVMGT_REAL:	pNodeD->arr.pDBL[ix] = pNodeS->arr.pDBL[ix]; break;
						case AJCVMGT_STR:
						{	WCP	pTmp;
							UI	stl = (UI)wcslen(pNodeS->arr.pStr[ix]) + 1;
							if (pTmp = AjcTAllocW(stl)) {
								wcscpy(pTmp, pNodeS->arr.pStr[ix]);
								if (pNodeD->arr.pStr[ix] != NULL) {
									AjcTFree(pNodeD->arr.pStr[ix]);
								}
								pNodeD->arr.pStr[ix] = pTmp;
							}
							else rc = FALSE;
							break;
						}
					}
				}
				//	G[Ȃ΁ARs[ϐ폜
				if (rc == FALSE) {
					AjcVmgDelVarW(pWD, pNameD);
				}
			}
		} while (0);
	}
	return rc;
}
