#include	"AjcInternal.h"

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static BCP MkKeyNameA(C_BCP pPrefix, C_BCP pName);
static WCP MkKeyNameW(C_WCP pPrefix, C_WCP pName);

//==============================================================================================================//
//	vt@CEChʒu[h																		//
//																												//
//	@F	hwnd	   - EChnh																	//
//				pSec	   - vt@CZNVւ̃|C^												//
//				pKeyPrefix - L[vtBbNXւ̃|C^													//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLoadWndPosA		 (HWND hwnd, C_BCP pSec)
{
	return AjcLoadWndPosExA(hwnd, pSec, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	 WINAPI AjcLoadWndPosExA	 (HWND hwnd, C_BCP pSec, C_BCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	RECT	r;
	int		x, y;

	if (pSec == NULL) pSec = "AjcWndPos";

	if (IsWindow(hwnd)) {
		if (rc = GetWindowRect(hwnd, &r)) {
			x  = AjcGetProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndPX"), r.left);
			y  = AjcGetProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndPY"), r.top);
			SetWindowPos(hwnd, NULL, x, y, 0, 0, SWP_NOSIZE);
			AjcMoveOutWndToOrigin(hwnd);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLoadWndPosW		 (HWND hwnd, C_WCP pSec)
{
	return AjcLoadWndPosExW(hwnd, pSec, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	 WINAPI AjcLoadWndPosExW	 (HWND hwnd, C_WCP pSec, C_WCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	RECT	r;
	int		x, y;

	if (pSec == NULL) pSec = L"AjcWndPos";

	if (IsWindow(hwnd)) {
		if (rc = GetWindowRect(hwnd, &r)) {
			x  = AjcGetProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndPX"), r.left);
			y  = AjcGetProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndPY"), r.top);
			SetWindowPos(hwnd, NULL, x, y, 0, 0, SWP_NOSIZE);
			AjcMoveOutWndToOrigin(hwnd);
		}
	}
	return rc;
}
//==============================================================================================================//
//	vt@CEChʒuƃTCY[h																//
//																												//
//	@F	hwnd	  - EChnh																	//
//				pSec	   - vt@CZNVւ̃|C^												//
//				pKeyPrefix - L[vtBbNXւ̃|C^													//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLoadWndRectA		 (HWND hwnd, C_BCP pSec)
{
	return AjcLoadWndRectExA(hwnd, pSec, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	 WINAPI AjcLoadWndRectExA	 (HWND hwnd, C_BCP pSec, C_BCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	RECT	r;
	int		x, y, cx, cy;

	if (pSec == NULL) pSec = "AjcWndRect";

	if (IsWindow(hwnd)) {
		if (rc = GetWindowRect(hwnd, &r)) {
			x  = AjcGetProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndPX"), r.left);
			y  = AjcGetProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndPY"), r.top);
			cx = AjcGetProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndCX"), r.right - r.left);
			cy = AjcGetProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndCY"), r.bottom - r.top);
			SetWindowPos(hwnd, NULL, x, y, cx, cy, 0);
			AjcMoveOutWndToOrigin(hwnd);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLoadWndRectW		 (HWND hwnd, C_WCP pSec)
{
	return AjcLoadWndRectExW(hwnd, pSec, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	 WINAPI AjcLoadWndRectExW	 (HWND hwnd, C_WCP pSec, C_WCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	RECT	r;
	int		x, y, cx, cy;

	if (pSec == NULL) pSec = L"AjcWndRect";

	if (IsWindow(hwnd)) {
		if (rc = GetWindowRect(hwnd, &r)) {
			x  = AjcGetProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndPX"), r.left);
			y  = AjcGetProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndPY"), r.top);
			cx = AjcGetProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndCX"), r.right - r.left);
			cy = AjcGetProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndCY"), r.bottom - r.top);
			SetWindowPos(hwnd, NULL, x, y, cx, cy, 0);
			AjcMoveOutWndToOrigin(hwnd);
		}
	}
	return rc;
}
//==============================================================================================================//
//	vt@CփEChʒuZ[u																			//
//																												//
//	@F	hwnd	  - EChnh																	//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcSaveWndPosA		 (HWND hwnd, C_BCP pSec)
{
	return AjcSaveWndPosExA(hwnd, pSec, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	 WINAPI AjcSaveWndPosExA	 (HWND hwnd, C_BCP pSec, C_BCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	WINDOWPLACEMENT	wp;

	if (pSec == NULL) pSec = "AjcWndPos";

	if (IsWindow(hwnd)) {
		wp.length = sizeof(WINDOWPLACEMENT);
		if (rc = GetWindowPlacement(hwnd, &wp)) {
			AjcPutProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndPX"), wp.rcNormalPosition.left);
			AjcPutProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndPY"), wp.rcNormalPosition.top);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcSaveWndPosW		 (HWND hwnd, C_WCP pSec)
{
	return AjcSaveWndPosExW(hwnd, pSec, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	 WINAPI AjcSaveWndPosExW	 (HWND hwnd, C_WCP pSec, C_WCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	WINDOWPLACEMENT	wp;

	if (pSec == NULL) pSec = L"AjcWndPos";

	if (IsWindow(hwnd)) {
		wp.length = sizeof(WINDOWPLACEMENT);
		if (rc = GetWindowPlacement(hwnd, &wp)) {
			AjcPutProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndPX"), wp.rcNormalPosition.left);
			AjcPutProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndPY"), wp.rcNormalPosition.top);
		}
	}
	return rc;
}
//==============================================================================================================//
//	vt@CփEChʒuƃTCYZ[u																	//
//																												//
//	@F	hwnd	  - EChnh																	//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcSaveWndRectA		 (HWND hwnd, C_BCP pSec)
{
	return AjcSaveWndRectExA(hwnd, pSec, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	 WINAPI AjcSaveWndRectExA	 (HWND hwnd, C_BCP pSec, C_BCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	WINDOWPLACEMENT	wp;

	if (pSec == NULL) pSec = "AjcWndRect";

	if (IsWindow(hwnd)) {
		wp.length = sizeof(WINDOWPLACEMENT);
		if (rc = GetWindowPlacement(hwnd, &wp)) {
			AjcPutProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndPX"), wp.rcNormalPosition.left);
			AjcPutProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndPY"), wp.rcNormalPosition.top);
			AjcPutProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndCX"), wp.rcNormalPosition.right - wp.rcNormalPosition.left);
			AjcPutProfileSIntA(pSec, MkKeyNameA(pKeyPrefix, "AjcWndCY"), wp.rcNormalPosition.bottom - wp.rcNormalPosition.top);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcSaveWndRectW		 (HWND hwnd, C_WCP pSec)
{
	return AjcSaveWndRectExW(hwnd, pSec, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT BOOL	 WINAPI AjcSaveWndRectExW	 (HWND hwnd, C_WCP pSec, C_WCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	WINDOWPLACEMENT	wp;

	if (pSec == NULL) pSec = L"AjcWndRect";

	if (IsWindow(hwnd)) {
		wp.length = sizeof(WINDOWPLACEMENT);
		if (rc = GetWindowPlacement(hwnd, &wp)) {
			AjcPutProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndPX"), wp.rcNormalPosition.left);
			AjcPutProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndPY"), wp.rcNormalPosition.top);
			AjcPutProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndCX"), wp.rcNormalPosition.right - wp.rcNormalPosition.left);
			AjcPutProfileSIntW(pSec, MkKeyNameW(pKeyPrefix, L"AjcWndCY"), wp.rcNormalPosition.bottom - wp.rcNormalPosition.top);
		}
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	ECḧꕔBĂꍇEChj^ֈړ									*/
/*																												*/
/*	Argument	:	hwnd - EChnh																		*/
/*																												*/
/*	Return		:	TRUE  - OK																					*/
/*					FALSE - NG																					*/
/*==============================================================================================================*/
AJCEXPORT	BOOL	WINAPI	AjcMoveWndIntoMonitor (HWND hwnd)
{
	return AjcMoveWndRectIntoMonitor(hwnd, NULL);
}
/*==============================================================================================================*/
/*	Function	:	ECh`̈ꕔBĂꍇ`j^ֈړ								*/
/*																												*/
/*	Argument	:	hwnd  - EChnh																	*/
/*					pRect - ECh̋`̈iʍWCEChŜ̏ꍇNULLj							*/
/*																												*/
/*	Return		:	TRUE  - OK																					*/
/*					FALSE - NG																					*/
/*==============================================================================================================*/
AJCEXPORT	BOOL	WINAPI	AjcMoveWndRectIntoMonitor (HWND hwnd, LPRECT pRect)
{
	BOOL			rc = FALSE;
	UI				i, nMon;
	AJCMONITORSINFO	ifMon;				//	j^Q`
	RECT			rcMon;				//	j^`
	RECT			rcWnd;				//	ECh`
	int				wx, wy, ww, wh;		//	EChʒuCTCY
	int				rx, ry, rw, rh;		//	ECh`̈ʒuCTCY
	int				sqr, sqrMax = 0;

	if (IsWindow(hwnd)) {
		//	ECh`CCݒ
		GetWindowRect(hwnd, &rcWnd);
		wx = rcWnd.left;
		wy = rcWnd.top;
		ww = rcWnd.right  - rcWnd.left;
		wh = rcWnd.bottom - rcWnd.top;
		//	EChS̎w
		if (pRect == NULL) {
			pRect = &rcWnd;
		}
		//	ej^`擾
		nMon = AjcGetMonitorsInfo(&ifMon);
		//	ECh`̏郂j^
		for (i = 0; i < nMon; i++) {
			sqr = AjcGetDupRect(pRect, &ifMon.rcMon[i], NULL);
			if (sqr > sqrMax) {
				sqrMax = sqr;
				memcpy(&rcMon, &ifMon.rcMon[i], sizeof rcMon);
			}
		}
		//	j^ꍇ́AECh郂j^
		if (sqrMax == 0 && pRect != &rcWnd) {
			for (i = 0; i < nMon; i++) {
				sqr = AjcGetDupRect(&rcWnd, &ifMon.rcMon[i], NULL);
				if (sqr > sqrMax) {
					sqrMax = sqr;
					memcpy(&rcMon, &ifMon.rcMon[i], sizeof rcMon);
				}
			}
		}
		//	郂j^H
		if (sqrMax != 0) {
			rx	= pRect->left;
			ry	= pRect->top;
			rw = pRect->right  - pRect->left;
			rh = pRect->bottom - pRect->top;
			//	EChE[oꍇAwɈړ
			if (rx + rw > rcMon.right) {
				wx -= (rx + rw - rcMon.right);
			}
			//	ECh[oꍇAwEɈړ
			if (rx < rcMon.left) {
				wx += (rcMon.left - rx);
			}
			//	ECh[oꍇAxɈړ
			if (ry + rh > rcMon.bottom) {
				wy -= (ry + rh - rcMon.bottom);
			}
			//	ECh[oꍇAxɈړ
			if (ry < rcMon.top) {
				wy += (rcMon.top - ry);
			}
			//	j^ֈړ
			SetWindowPos(hwnd, NULL, wx, wy, 0, 0, SWP_NOSIZE);
		}
		//	j^΁A_ֈړ
		else {
			SetWindowPos(hwnd, NULL, 0, 0, 0, 0, SWP_NOSIZE);
		}
		//	߂l
		rc = TRUE;
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	EChŜBĂꍇ ECh_ֈړ										*/
/*																												*/
/*	Argument	:	hwnd - EChnh																		*/
/*																												*/
/*	Return		:	TRUE  - OK																					*/
/*					FALSE - NG																					*/
/*==============================================================================================================*/
AJCEXPORT	BOOL	WINAPI	AjcMoveOutWndToOrigin (HWND hwnd)
{
	BOOL	rc = FALSE;
	UI		Bounds = 0;
	UI		Sqr    = 0;
	RECT	rcWnd;

	if (IsWindow(hwnd)) {
		GetWindowRect(hwnd, &rcWnd);
		if (!AjcIsSeeEntireInMonitors(&rcWnd, &Bounds, &Sqr)) {
			if (Bounds == 0) {
				SetWindowPos(hwnd, NULL, 0, 0, 0, 0, SWP_NOSIZE);
			}
		}
		rc = TRUE;
	}
	return rc;
}

/*==============================================================================================================*/
/*	Function	:	Sj^ŋ`Ă邩`FbN													*/
/*																												*/
/*	Argument	:	hwnd	- EChnh																	*/
/*					pRect	- `iʍWj																*/
/*					pBounds - Ă郂j^i[obt@̃AhXisvNULLj					*/
/*					pSqr	- Ă鑍ʐςi[obt@̃AhXisvNULLj						*/
/*																												*/
/*	Return		:	TRUE  - Ŝ																		*/
/*					FALSE - ꕔ^SȂ																*/
/*==============================================================================================================*/
AJCEXPORT	BOOL	WINAPI	AjcIsSeeEntireInMonitors (LPRECT pRect, UIP pBounds, UIP pSqr)
{
	BOOL			rc	 = FALSE;		//	߂l
	UI				nSee = 0;			//	Ă郂j^
	BOOL			fSee;				//	Yj^ŌĂ邱ƂtO
	UI				sqr  = 0;			//	Ăʐ
	UI				i, nMon;			//	j^
	AJCMONITORSINFO	ifMon;				//	j^Q`
	BOOL			fUL = FALSE;		//	オĂ邱ƂtO
	BOOL			fUR = FALSE;		//	EオĂ邱ƂtO
	BOOL			fDL = FALSE;		//	Ă邱ƂtO
	BOOL			fDR = FALSE;		//	EĂ邱ƂtO

	if (pRect != NULL) {
		//	ej^`擾
		nMon = AjcGetMonitorsInfo(&ifMon);
		//	ECh`̏郂j^
		for (i = 0; i < nMon; i++) {
			fSee = FALSE;
			//	オĂ邩`FbN
			if (pRect->top >= ifMon.rcMon[i].top && pRect->top < ifMon.rcMon[i].bottom) {
				//	Ă邩`FbN
				if (pRect->left  >= ifMon.rcMon[i].left && pRect->left	< ifMon.rcMon[i].right) {
					fUL = TRUE; fSee = TRUE;
				}
				//	EĂ邩`FbN
				if (pRect->right >= ifMon.rcMon[i].left && pRect->right < ifMon.rcMon[i].right) {
					fUR = TRUE; fSee = TRUE;
				}
			}
			//	Ă邩`FbN
			if (pRect->bottom >= ifMon.rcMon[i].top && pRect->bottom < ifMon.rcMon[i].bottom) {
				//	Ă邩`FbN
				if (pRect->left  >= ifMon.rcMon[i].left && pRect->left	< ifMon.rcMon[i].right) {
					fDL = TRUE; fSee = TRUE;
				}
				//	EĂ邩`FbN
				if (pRect->right >= ifMon.rcMon[i].left && pRect->right < ifMon.rcMon[i].right) {
					fDR = TRUE; fSee = TRUE;
				}
			}
			//	Ă郂j^ƖʐύXV
			if (fSee) {
				nSee++;
				sqr += AjcGetDupRect(&ifMon.rcMon[i], pRect, NULL);
			}
		}
		//	܂Ă郂j^ݒ
		if (pBounds != NULL) {
			*pBounds = nSee;
		}
		//	ʐϐݒ
		if (pSqr != NULL) {
			*pSqr = sqr;
		}
		//	ŜĂ΁A߂lTRUE
		if (fUL && fUR && fDL && fDR) {
			rc = TRUE;
		}
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	BĂECh͂߂ʒu܂ňړi񐄏j										*/
/*																												*/
/*	Argument	:	hwnd - EChnh																		*/
/*																												*/
/*	Return		:	TRUE  - OK																					*/
/*					FALSE - NG																					*/
/*==============================================================================================================*/
AJCEXPORT	BOOL	WINAPI	AjcMoveWindowToGripped(HWND hwnd)
{
	BOOL	rc = FALSE;
	BOOL	fNeedMove = FALSE;
	HWND	hParent;
	RECT	rcParent;
	RECT	rcMyWnd, rcGrid;
	int		x;
	UX		ws	= MAjcGetWindowLong(hwnd, GWL_STYLE);
	UX		wes = MAjcGetWindowLong(hwnd, GWL_EXSTYLE);

	do {
		if (!IsWindow(hwnd)) break;
		//----- fXNgbvƈ^eEChENCAg̃TCY擾 -----//
		if (hParent = GetParent(hwnd)) {
			GetClientRect(hParent, &rcParent);
		}
		else {
			SystemParametersInfo(SPI_GETWORKAREA, 0, &rcParent, 0);
		}

		//----- EChTCYƁAObhiLvVo[̃Z^jTCY擾 -----//
		GetWindowRect(hwnd, &rcMyWnd);
		memcpy(&rcGrid, &rcMyWnd, sizeof rcGrid);
		if (wes & WS_EX_TOOLWINDOW) rcGrid.bottom = rcGrid.top + GetSystemMetrics(SM_CYSMCAPTION);
		else						rcGrid.bottom = rcGrid.top + GetSystemMetrics(SM_CYCAPTION);
		rcGrid.left	 += __min((GetSystemMetrics(SM_CXSIZE) * 2), (rcGrid.right - rcGrid.left) / 2);
		rcGrid.right -= __min((GetSystemMetrics(SM_CXSIZE) * 4), rcGrid.right - rcGrid.left);

		//----- LvVo[ɉBĂ΁A[ʒu܂Ŗ߂ -----//
		if (rcGrid.top	  < rcParent.top   ) {
			x = rcParent.top - rcGrid.top;
			rcMyWnd.top	   += x;
			rcMyWnd.bottom += x;
			fNeedMove = TRUE;
		}
		//----- LvVo[ɉBĂ΁A[ʒu܂Ŗ߂ -----//
		if (rcGrid.bottom > rcParent.bottom) {
			x = rcGrid.bottom - rcParent.bottom;
			rcMyWnd.top	   -= x;
			rcMyWnd.bottom -= x;
			fNeedMove = TRUE;
		}
		//----- LvVo[ɉBĂ΁A[ʒu܂Ŗ߂ -----//
		if (rcGrid.right < rcParent.left) {
			x = rcParent.left - rcGrid.right;
			rcMyWnd.left  += x;
			rcMyWnd.right += x;
			fNeedMove = TRUE;
		}
		//----- LvVo[EɉBĂ΁AE[ʒu܂Ŗ߂ -----//
		if (rcGrid.left > rcParent.right) {
			x = rcGrid.left - rcParent.right;
			rcMyWnd.left  -= x;
			rcMyWnd.right -= x;
			fNeedMove = TRUE;
		}
		//----- EChړ -----//
		if (fNeedMove) {
			MoveWindow(hwnd, rcMyWnd.left, rcMyWnd.top, rcMyWnd.right - rcMyWnd.left,
														rcMyWnd.bottom - rcMyWnd.top, TRUE);
		}
		rc = TRUE;

	} while(0);

	return rc;
}
/*==============================================================================================================*/
/*	Function	:	BĂgbvxEChECh͂߂ʒu܂ňړi񐄏j					*/
/*																												*/
/*	Argument	:	hwnd  - EChnh																	*/
/*					ratio - ^Cgo[̌Ă镔̊[%]												*/
/*							^Cgo[̌Ă镔ratioȉȂ΃ECh_ֈړ				*/
/*																												*/
/*	Return		:	TRUE  - OK																					*/
/*					FALSE - NG																					*/
/*==============================================================================================================*/
typedef struct {
	int		ix;
	RECT	rcGrid;
	LPRECT	prcWork;
} AMVG_WORKAREA, *PAMVG_WORKAREA;
//--------------------------------------------------------------------------------------------------------------//
//	fBXvBʒm
static	BOOL CALLBACK cbAmwgEnumDisplay(HMONITOR hMon, HDC hdcMon, LPRECT prcMon, LPARAM lParam)
{
	PAMVG_WORKAREA	pWA = (PAMVG_WORKAREA)lParam;
	HMONITOR		hMonitor = NULL;
	MONITORINFOEX	MonitorInfoEx;
	POINT			pt;

	pt.x = (prcMon->left + prcMon->right) / 2;
	pt.y = (prcMon->top + prcMon->bottom) / 2;
	hMonitor = MonitorFromPoint(pt, MONITOR_DEFAULTTONEAREST);
	memset(&MonitorInfoEx, 0, sizeof MonitorInfoEx);
	MonitorInfoEx.cbSize = sizeof(MonitorInfoEx);
	GetMonitorInfo(hMonitor, (LPMONITORINFO)&MonitorInfoEx);
	memcpy(&pWA->prcWork[pWA->ix], &MonitorInfoEx.rcWork, sizeof(RECT));
	pWA->ix++;

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
//	`ChEChʒm
static	BOOL CALLBACK cbAmwgEnumChild(HWND hw, LPARAM lParam)
{
	PAMVG_WORKAREA	pWA = (PAMVG_WORKAREA)lParam;
	RECT			wr;

	GetWindowRect(hw, &wr);
	if (AjcGetDupRect(&pWA->rcGrid, &wr, NULL) != 0) {
		if (wr.left > pWA->rcGrid.left && wr.right < pWA->rcGrid.right) {
			pWA->rcGrid.left  = __max(pWA->rcGrid.left , wr.right);
		}
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcMoveWindowToGrippedEx(HWND hwnd, UI ratio)
{
	BOOL			rc		 = FALSE;
	int				i, nDisplay = 0;
	AMVG_WORKAREA	AmvgWa;
	int				sqGrid, sqDup;
	int				per;
	UX				wes = MAjcGetWindowLong(hwnd, GWL_EXSTYLE);

	//	[NNA[
	memset(&AmvgWa, 0, sizeof AmvgWa);

	do {
		if (!IsWindow(hwnd)								 ) break;
		if (MAjcGetWindowLong(hwnd, GWL_STYLE) & WS_CHILD) break;
		//----- j^擾 ---------------------------------------------------------------//
		nDisplay = GetSystemMetrics(SM_CMONITORS);
		//----- j^̈m ---------------------------------------------------------//
		if ((AmvgWa.prcWork = (LPRECT)AJCMEM(sizeof(RECT) * nDisplay)) == NULL) break;
		memset(AmvgWa.prcWork, 0, sizeof(RECT) * nDisplay);
		//----- SfBXvC̍Ɨ̈擾 ---------------------------------------------//
		if (!EnumDisplayMonitors(NULL, NULL, cbAmwgEnumDisplay, (LPARAM)&AmvgWa)) break;
		//----- ECh̃^Cgo[`𓾂 -------------------------------------------//
		GetWindowRect(hwnd, &AmvgWa.rcGrid);
		if (wes & WS_EX_TOOLWINDOW) AmvgWa.rcGrid.bottom = AmvgWa.rcGrid.top + GetSystemMetrics(SM_CYSMCAPTION) - 1;
		else						AmvgWa.rcGrid.bottom = AmvgWa.rcGrid.top + GetSystemMetrics(SM_CYCAPTION) - 1;
		AmvgWa.rcGrid.right -= (GetSystemMetrics(SM_CXSIZE) * 3); // E[̃{^O
		if (AmvgWa.rcGrid.right <= AmvgWa.rcGrid.left) break;
		//----- ^Cgo[qEChƏdȂ镔O ---------------------------//
		EnumChildWindows(hwnd, cbAmwgEnumChild, (LPARAM)&AmvgWa);
		if (AmvgWa.rcGrid.right <= AmvgWa.rcGrid.left) break;
		//----- ^Cgo[iObhj̖ʐώZo -------------------------------------//
		sqGrid = (AmvgWa.rcGrid.right - AmvgWa.rcGrid.left) * (AmvgWa.rcGrid.bottom - AmvgWa.rcGrid.top);
		//----- SfBXvCƃECh^Cgo[̏dȂʐς߂ -------------------//
		sqDup = 0;
		for (i = 0; i < nDisplay; i++) {
			sqDup += AjcGetDupRect(&AmvgWa.rcGrid, &AmvgWa.prcWork[i], NULL);
		}
		per = sqDup * 100 / sqGrid;
		//----- dȂĂʐς΁A_ֈړ -----------------------------------//
		if ((UI)per < ratio) {
			SetWindowPos(hwnd, NULL, 0, 0, 0, 0, SWP_NOSIZE);
		}
		rc = TRUE;
	} while(0);

	if (AmvgWa.prcWork != NULL) free(AmvgWa.prcWork);

	return rc;
}
/*==============================================================================================================*/
/*	Function	:	ECheECh^I[i[ECh^j^^vC}j^ֈړ			*/
/*																												*/
/*	Argument	:	hwnd - EChnh																		*/
/*																												*/
/*	Return		:	TRUE  - OK																					*/
/*					FALSE - NG																					*/
/*==============================================================================================================*/
AJCEXPORT	BOOL	WINAPI	AjcMoveWindowToCenter(HWND hwnd)
{
	BOOL	rc = FALSE;
	int		sx, sy, scx, scy;
	int		wx, wy, wcx, wcy;
	HWND	hScr;
	RECT	rw, rs;

	if (IsWindow(hwnd)) {
		GetWindowRect(hwnd, &rw);
		if		(hScr = GetWindow(hwnd, GW_OWNER)) {
			//	ECh̃XN[WCTCYݒ
			wx	= rw.left;
			wy	= rw.top;
			wcx = rw.right - rw.left;
			wcy = rw.bottom - rw.top;
			//	I[i[ECh̃XN[WCTCYݒ
			GetClientRect(hScr, &rs);
			MapWindowPoints(hScr, NULL, (LPPOINT)&rs, 2);
			sx	= rs.left;
			sy	= rs.top;
			scx = rs.right - rs.left;
			scy = rs.bottom - rs.top;
			//	EChI[i[ECh̒ֈړ
			SetWindowPos(hwnd, NULL, sx + (scx - wcx) / 2, sy + (scy - wcy) / 2, 0, 0, SWP_NOSIZE);
		}
		else if (hScr = GetParent(hwnd)) {
			//	ECh̃NCAgWCTCYݒ
			MapWindowPoints(NULL, hScr, (LPPOINT)&rw, 2);
			wx	= rw.left;
			wy	= rw.top;
			wcx = rw.right - rw.left;
			wcy = rw.bottom - rw.top;
			//	eECh̃NCAgWCTCYݒ
			GetClientRect(hScr, &rs);
			sx	= rs.left;
			sy	= rs.top;
			scx = rs.right - rs.left;
			scy = rs.bottom - rs.top;
			//	ECheECh̒ֈړ
			SetWindowPos(hwnd, NULL, sx + (scx - wcx) / 2, sy + (scy - wcy) / 2, 0, 0, SWP_NOSIZE);
		}
		else {
			//	EChj^̒ֈړ
			AjcMoveWindowToCenterOfMonitor(hwnd);
		}
		rc = TRUE;
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	EChʒֈړ																*/
/*																												*/
/*	Argument	:	hwnd - EChnh																		*/
/*																												*/
/*	Return		:	TRUE  - OK																					*/
/*					FALSE - NG																					*/
/*==============================================================================================================*/
AJCEXPORT	BOOL	WINAPI	AjcMoveWindowToCenterOfScreen(HWND hwnd)
{
	BOOL	rc = FALSE;
	int		sx, sy, scx, scy;
	int		wx, wy, wcx, wcy;
	RECT	rw, rs;

	if (IsWindow(hwnd)) {
		//	ECḧʒuƃTCYݒ
		GetWindowRect(hwnd, &rw);
		wx	= rw.left;
		wy	= rw.top;
		wcx = rw.right - rw.left;
		wcy = rw.bottom - rw.top;
		//	j^Ŝ̈ʒuƃTCYݒ
		AjcGetMonitorsRect(&rs);
		sx	= rs.left;
		sy	= rs.top;
		scx = rs.right - rs.left;
		scy = rs.bottom - rs.top;
		//	EChj^Ŝ̒ֈړ
		SetWindowPos(hwnd, NULL, sx + (scx - wcx) / 2, sy + (scy - wcy) / 2, 0, 0, SWP_NOSIZE);
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	EChj^ֈړ																*/
/*																												*/
/*	Argument	:	hwnd - EChnh																		*/
/*																												*/
/*	Return		:	TRUE  - OK																					*/
/*					FALSE - NG																					*/
/*==============================================================================================================*/
AJCEXPORT	BOOL	WINAPI	AjcMoveWindowToCenterOfMonitor(HWND hwnd)
{
	BOOL	rc = FALSE;
	int		sx, sy, scx, scy;
	int		wx, wy, wcx, wcy;
	RECT	rw, rs;

	if (IsWindow(hwnd)) {
		//	ECḧʒuƃTCYݒ
		GetWindowRect(hwnd, &rw);
		wx	= rw.left;
		wy	= rw.top;
		wcx = rw.right - rw.left;
		wcy = rw.bottom - rw.top;
		//	j^`擾
		AjcGetMonitorInfoOfWindow(hwnd, &rs, NULL);
		//	j^̈ʒuƃTCYݒ
		sx	= rs.left;
		sy	= rs.top;
		scx = rs.right - rs.left;
		scy = rs.bottom - rs.top;
		//	EChj^ֈړ
		SetWindowPos(hwnd, NULL, sx + (scx - wcx) / 2, sy + (scy - wcy) / 2, 0, 0, SWP_NOSIZE);

		rc = TRUE;
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	ECh𑼂̃ECh̒ֈړ														*/
/*																												*/
/*	Argument	:	hwnd	- EChnh																	*/
/*					hWndScr - ̃EChnh																*/
/*																												*/
/*	Return		:	TRUE  - OK																					*/
/*					FALSE - NG																					*/
/*==============================================================================================================*/
AJCEXPORT	BOOL	WINAPI	AjcMoveWindowToCenterOfWindow(HWND hwnd, HWND hWndScr)
{
	BOOL	rc = FALSE;
	RECT	rs, rw;
	int		sx, sy, scx, scy;
	int		wx, wy, wcx, wcy;

	if (IsWindow(hwnd) && IsWindow(hWndScr)) {
		GetClientRect(hWndScr, &rs);
		MapWindowPoints(hWndScr, NULL, (LPPOINT)&rs, 2);
		sx = rs.left;	scx = rs.right - rs.left;
		sy = rs.top;	scy = rs.bottom - rs.top;
		GetWindowRect(hwnd, &rw);
		wx = rw.left;	wcx = rw.right - rw.left;
		wy = rw.top;	wcy = rw.bottom - rw.top;
		SetWindowPos(hwnd, NULL, sx + (scx - wcx) / 2, sy + (scy - wcy) / 2, 0, 0, SWP_NOSIZE);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	tH[JXĂECh擾																		//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	 NULL - itH[JXĂECh̃nhj										//
//				 NULL - s																					//
//==============================================================================================================//
AJCEXPORT	HWND WINAPI AjcGetFocusWindow(VO) 
{
	HWND	rc;
	DWORD ActiveThreadID;
	DWORD ActiveProcessID;

	ActiveThreadID = GetWindowThreadProcessId(GetForegroundWindow(), &ActiveProcessID);
	if (AttachThreadInput(GetCurrentThreadId(), ActiveThreadID, TRUE)) {
		rc = GetFocus();
		AttachThreadInput(GetCurrentThreadId(), ActiveThreadID, FALSE);
	}
	else {
		rc = GetFocus();
	}
	return rc;
}

//==============================================================================================================//
//	wEChtH[JX																				//
//																												//
//	@	F	hwnd	- tH[JXECh̃nh														//
//																												//
//	߂l	F	TRUE  F 																					//
//				FALSE F s																					//
//==============================================================================================================//
AJCEXPORT	BOOL WINAPI AjcSetFocusWindow(HWND hwnd) 
{
	BOOL	rc = 0;
	DWORD	ActiveThreadID;
	DWORD	ActiveProcessID;

	if (IsWindow(hwnd)) {
		ActiveThreadID = GetWindowThreadProcessId(GetForegroundWindow(), &ActiveProcessID);
		if (AttachThreadInput(GetCurrentThreadId(), ActiveThreadID, TRUE)) {
			rc = SetForegroundWindow(hwnd);
		//	AttachThreadInput(GetCurrentThreadId(), ActiveThreadID, FALSE);
		}
		else {
			rc = SetForegroundWindow(hwnd);
		}
	}
	return (rc != 0);
}
//==============================================================================================================//
//	ʏ\̃ECh`擾																			//
//																												//
//	@	F	hwnd	- EChnh																		//
//				pRect	- `i[obt@̃AhX													//
//																												//
//	߂l	F	-1FECh̏(SW_HIDE/SW_MINIMIZE/SW_SHOW/SW_SHOWNORMALEEE)							//
//				-1FG[																					//
//==============================================================================================================//
AJCEXPORT	int	WINAPI	AjcGetWindowNormalRect(HWND hwnd, LPRECT pRect)
{
	int				rc = -1;
	WINDOWPLACEMENT	wpl;

	if (IsWindow(hwnd)) {
		//	ECh擾
		if (GetWindowPlacement(hwnd, &wpl)) {
			//	ʏ\̋`ݒ
			if (pRect != NULL) {
				memcpy(pRect, &wpl.rcNormalPosition, sizeof(RECT));
			}
			rc = wpl.showCmd;
		}
	}
	return rc;
}
//==============================================================================================================//
//	Xbh̑SgbvxEChփbZ[WM															//
//																												//
//	@	F	msg		- bZ[WR[h																		//
//				wParam	- p^																				//
//				lParam	- @@V																				//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
typedef struct {
	UI		msg;
	WPARAM	wParam;
	LPARAM	lParam;
	HWND	hWndPre;
	HWND	hWndPost;
} PARAM_SENDTHREAD, *PPARAM_SENDTHREAD;
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbSendThreadEnum(HWND hwnd, LPARAM lParam)
{
	PPARAM_SENDTHREAD p = (PPARAM_SENDTHREAD)lParam;

	if (GetParent(hwnd) == NULL) {
		SendMessage(hwnd, p->msg, p->wParam, p->lParam);
	}

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	VO	WINAPI	AjcSendMessageToThreadWindows(UI msg, WPARAM wParam, LPARAM lParam)
{
	PARAM_SENDTHREAD	prm;

	prm.msg		  = msg;
	prm.wParam	  = wParam;
	prm.lParam	  = lParam;
	prm.hWndPre	  = NULL;
	prm.hWndPost  = NULL;
	EnumThreadWindows(GetCurrentThreadId(), cbSendThreadEnum, (LPARAM)&prm);
}
//==============================================================================================================//
//	Xbh̑SgbvxEChƁAw肳ꂽQ̃EChւփbZ[WM								//
//																												//
//	@	F	msg		- bZ[WR[h																		//
//				wParam	- p^																				//
//				lParam	- @@V																				//
//				hWndPre - SXbhEChɐ삯ăZ[W𑗐MECh̃nh	isvNULLj	//
//				hWndPost- SXbhECȟɃZ[W𑗐MECh̃nh		isvNULLj	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
static	BOOL CALLBACK cbSendThreadExEnum(HWND hwnd, LPARAM lParam)
{
	PPARAM_SENDTHREAD p = (PPARAM_SENDTHREAD)lParam;

	if (GetParent(hwnd) == NULL && hwnd != p->hWndPre && hwnd != p->hWndPost) {
		SendMessage(hwnd, p->msg, p->wParam, p->lParam);
	}

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	VO	WINAPI	AjcSendMessageToThreadWindowsEx(UI msg, WPARAM wParam, LPARAM lParam, HWND hWndPre, HWND hWndPost)
{
	PARAM_SENDTHREAD	prm;

	//--- 'Pre'EChփbZ[WM --------------------------------------//
	if (hWndPre != NULL) {
		SendMessage(hWndPre , msg, wParam, lParam);
	}

	//--- Pre, PostEChȊOփbZ[WM ------------------------------//
	prm.msg		  = msg;
	prm.wParam	  = wParam;
	prm.lParam	  = lParam;
	prm.hWndPre	  = hWndPre;
	prm.hWndPost  = hWndPost;
	EnumThreadWindows(GetCurrentThreadId(), cbSendThreadExEnum, (LPARAM)&prm);

	//--- 'Post'EChփbZ[WM -------------------------------------//
	if (hWndPost != NULL) {
		SendMessage(hWndPost, msg, wParam, lParam);
	}
}
//==============================================================================================================//
//	Xbh̑SgbvxECh^֎~																//
//																												//
//	@	F	fEnable	- TRUE:CFALSE:֎~																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
static	BOOL CALLBACK cbEnableThreadEnum(HWND hwnd, LPARAM lParam)
{
	PPARAM_SENDTHREAD p = (PPARAM_SENDTHREAD)lParam;

	if (GetParent(hwnd) == NULL) {
		EnableWindow(hwnd, (BOOL)lParam);
	}

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	VO	WINAPI	AjcEnableThreadWindows(BOOL fEnable)
{
	EnumThreadWindows(GetCurrentThreadId(), cbEnableThreadEnum, fEnable);
}

//==============================================================================================================//
//	WindowsCxgi_CAObZ[WȂj															//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	bZ[W																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI WINAPI AjcDoEventA(VO) 
{
	UI		rc = 0;
	MSG		msg;

	while (PeekMessageA(&msg, NULL, 0, 0, PM_REMOVE)) {
		do {
			TranslateMessage(&msg);
			DispatchMessageA(&msg);
		} while (0);
		rc++;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI WINAPI AjcDoEventW(VO) 
{
	UI		rc = 0;
	MSG		msg;

	while (PeekMessageW(&msg, NULL, 0, 0, PM_REMOVE)) {
		do {
			TranslateMessage(&msg);
			DispatchMessageW(&msg);
		} while (0);
		rc++;
	}
	return rc;
}
//==============================================================================================================//
//	WindowsCxgi_CAObZ[Wtj															//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	bZ[W																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI WINAPI AjcDoEventExA(UI nDialog, ...) 
{
	UI		rc = 0;
	MSG		msg;
	UI		i;
	HWND	hdlg;
	va_list vls;

	va_start(vls, nDialog);

	while (PeekMessageA(&msg, NULL, 0, 0, PM_REMOVE)) {
		do {
			for (i = 0; i < nDialog; i++) {
				hdlg = va_arg(vls, HWND);
				if (IsWindow(hdlg)) {
					if (IsDialogMessageA(hdlg, &msg)) goto exit_struct;
				}
			}
			TranslateMessage(&msg);
			DispatchMessageA(&msg);
		} while (0);
exit_struct:;
		rc++;
	}

	va_end	(vls);

	return rc;
}

//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI WINAPI AjcDoEventExW(UI nDialog, ...) 
{
	UI		rc = 0;
	MSG		msg;
	UI		i;
	HWND	hdlg;
	va_list vls;

	va_start(vls, nDialog);

	while (PeekMessageW(&msg, NULL, 0, 0, PM_REMOVE)) {
		do {
			for (i = 0; i < nDialog; i++) {
				hdlg = va_arg(vls, HWND);
				if (IsWindow(hdlg)) {
					if (IsDialogMessageW(hdlg, &msg)) goto exit_struct;
				}
			}
			TranslateMessage(&msg);
			DispatchMessageW(&msg);
		} while (0);
exit_struct:;
		rc++;
	}

	va_end	(vls);

	return rc;
}

//==============================================================================================================//
//	EChnhAst@C̃pX擾																//
//																												//
//	@	F	hwnd	- EChnh																		//
//				pBuf	- st@C̃pXi[obt@̃AhX	isvNULLj					//
//				lBuf	- st@C̃pXi[obt@̕										//
//																												//
//	߂l	F	NULLFCX^Xnh																	//
//				NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT HINSTANCE	WINAPI	AjcGetExePathNameA(HWND hwnd, BCP pBuf, int lBuf)
{
	UI		ProcessId	= 0;
	HANDLE	hProcess	= NULL;
	HMODULE hModule		= NULL;
	UI		dummy		= 0;

	if (IsWindow(hwnd)) {
		do {
			GetWindowThreadProcessId(hwnd, &ProcessId);

			// vZXnh
			if ((hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, ProcessId)) == NULL) {
				break;
			}

			// W[nh
			if(!EnumProcessModules(hProcess, &hModule, sizeof(HMODULE), &dummy)) {
				hModule = NULL;
				break;
			}

			// t@C(tpX)
			if (pBuf != NULL  &&  lBuf > 0) {
				if(!GetModuleFileNameExA(hProcess, hModule, pBuf, lBuf)) {
					hModule = NULL;
					break;
				}
			}
		} while(0);

		CloseHandle(hProcess);
		//	hModule̓N[YĂ͂Ȃ
	}
	return hModule;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT HINSTANCE	WINAPI	AjcGetExePathNameW(HWND hwnd, WCP pBuf, int lBuf)
{
	UI		ProcessId	= 0;
	HANDLE	hProcess	= NULL;
	HMODULE hModule		= NULL;
	UI		dummy		= 0;

	if (IsWindow(hwnd)) {
		do {
			GetWindowThreadProcessId(hwnd, &ProcessId);

			// vZXnh
			if ((hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, ProcessId)) == NULL) {
				break;
			}

			// W[nh
			if(!EnumProcessModules(hProcess, &hModule, sizeof(HMODULE), &dummy)) {
				hModule = NULL;
				break;
			}

			// t@C(tpX)
			if (pBuf != NULL  &&  lBuf > 0) {
				if(!GetModuleFileNameExW(hProcess, hModule, pBuf, lBuf)) {
					hModule = NULL;
					break;
				}
			}
		} while(0);

		CloseHandle(hProcess);
		//	hModule̓N[YĂ͂Ȃ
	}
	return hModule;
}

//--------------------------------------------------------------------------------------------------------------//
//	ړƃL[̂쐬																			//
//																												//
//	@	F	pPrefix	- ړꕶ																			//
//				pName	- 																					//
//																												//
//	߂l	F	̂ւ̃|C^																		//
//--------------------------------------------------------------------------------------------------------------//
#define		MAX_KEY_LEN		256
__declspec(thread) static BC szKeyNameA[MAX_KEY_LEN];
__declspec(thread) static WC szKeyNameW[MAX_KEY_LEN];
//----- oCg ---------------------------------------------------------------------------------------------//
static BCP MkKeyNameA(C_BCP pPrefix, C_BCP pName)
{
	szKeyNameA[0] = 0;

	if (pPrefix != NULL && pName != NULL) {
		AjcSnPrintFA(szKeyNameA, MAX_KEY_LEN, "%s_%s", pPrefix, pName);
	}
	else if (pPrefix != NULL) AjcSnPrintFA(szKeyNameA, MAX_KEY_LEN, "%s", pPrefix);
	else if (pName	 != NULL) AjcSnPrintFA(szKeyNameA, MAX_KEY_LEN, "%s", pName);

	return szKeyNameA;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static WCP MkKeyNameW(C_WCP pPrefix, C_WCP pName)
{
	szKeyNameW[0] = 0;

	if (pPrefix != NULL && pName != NULL) {
		AjcSnPrintFW(szKeyNameW, MAX_KEY_LEN, L"%s_%s", pPrefix, pName);
	}
	else if (pPrefix != NULL) AjcSnPrintFW(szKeyNameW, MAX_KEY_LEN, L"%s", pPrefix);
	else if (pName	 != NULL) AjcSnPrintFW(szKeyNameW, MAX_KEY_LEN, L"%s", pName);

	return szKeyNameW;
}
//==============================================================================================================//
//	NXݒ																								//
//																												//
//	@	F	hwnd			- EChnh																//
//				ix				- ݒ肷lɑ΂ 0 n܂ItZbg										//
//				data			- ݒl																		//
//																												//
//	߂l	F	SetClassLongPtr()̖߂l																		//
//==============================================================================================================//
AJCEXPORT UX		WINAPI	AjcSetClassLongPtr(HWND hwnd, UI ix, UX data)
{
	UX		rc = 0;
	if (IsWindowUnicode(hwnd)) 
		rc = SetClassLongPtrW(hwnd, ix, data);
	else					   
		rc = SetClassLongPtrA(hwnd, ix, data);
	return rc;
}
//==============================================================================================================//
//	NX擾																								//
//																												//
//	@	F	hwnd			- EChnh																//
//				ix				- ݒ肷lɑ΂ 0 n܂ItZbg										//
//				data			- ݒl																		//
//																												//
//	߂l	F	SetClassLongPtr()̖߂l																		//
//==============================================================================================================//
AJCEXPORT UX		WINAPI	AjcGetClassLongPtr(HWND hwnd, UI ix)
{
	UX		rc = 0;
	if (IsWindowUnicode(hwnd)) 
		rc = GetClassLongPtrW(hwnd, ix);
	else					   
		rc = GetClassLongPtrA(hwnd, ix);
	return rc;
}
//==============================================================================================================//
//	EChkݒ																					//
//																												//
//	@	F	hwnd			- EChnh																//
//				ix				- ݒ肷lɑ΂ 0 n܂ItZbg										//
//				data			- ݒl																		//
//																												//
//	߂l	F	Oݒ̃EChO																	//
//==============================================================================================================//
AJCEXPORT UX	WINAPI	AjcSetWindowLongPtr(HWND hwnd, UI ix, UX data)
{
	UX		rc = 0;
	UI		styWin, styBtn;

	//	EChX^C̐ݒH
	if (ix == GWL_STYLE) {
		//	TuNX{^Ȃ΁AEChX^CƃTuNX{^X^C
		if (AjcDgcGetSbcButtonStyle(hwnd, NULL)) {
			//	TuNX{^X^CݒiݒłX^C͌肳j
			styBtn = AjcDgcSetSbcButtonStyle(hwnd, (UI)(data & 0x0000FFFF));
			//	ۂ̃EChX^C擾
			if (IsWindowUnicode(hwnd)) styWin = (UI)GetWindowLongPtrW(hwnd, ix);
			else					   styWin = (UI)GetWindowLongPtrA(hwnd, ix);
			//	ۂ̃EChX^CݒiAA{^X^C͕ύXȂj
			if (IsWindowUnicode(hwnd)) SetWindowLongPtrW(hwnd, ix, (data & 0xFFFF0000) | (styWin & 0x0000FFFF));
			else					   SetWindowLongPtrA(hwnd, ix, (data & 0xFFFF0000) | (styWin & 0x0000FFFF));
			//	߂lݒiEChX^Ci16Bitjƃ{^X^Ci16Bitj̍j
			rc = ((styWin & 0xFFFF0000) | styBtn);
		}
		//	TuNX{^ȊOȂ΁AEChX^Ĉ܂ܐݒ
		else {
			if (IsWindowUnicode(hwnd)) rc = SetWindowLongPtrW(hwnd, ix, data);
			else					   rc = SetWindowLongPtrA(hwnd, ix, data);
		}
	}
	//	EChX^CȊO̎擾H
	else {
		if (IsWindowUnicode(hwnd)) rc = SetWindowLongPtrW(hwnd, ix, data);
		else					   rc = SetWindowLongPtrA(hwnd, ix, data);
	}
	return rc;
}

//==============================================================================================================//
//	EChk擾																					//
//																												//
//	@	F	hwnd			- EChnh																//
//				ix				- ݒ肷lɑ΂ 0 n܂ItZbg										//
//																												//
//	߂l	F	EChO																				//
//==============================================================================================================//
AJCEXPORT UX	WINAPI	AjcGetWindowLongPtr(HWND hwnd, UI ix)
{
	UX		rc = 0;
	UI		styWin, styBtn;

	//	EChX^C̎擾H
	if (ix == GWL_STYLE) {
		//	EChX^C擾
		if (IsWindowUnicode(hwnd)) styWin = (UI)GetWindowLongPtrW(hwnd, ix);
		else					   styWin = (UI)GetWindowLongPtrA(hwnd, ix);
		//	TuNX{^Ȃ΁AEChX^CƃTuNX{^X^C
		if (AjcDgcGetSbcButtonStyle(hwnd, &styBtn)) {
			rc = (styWin & 0xFFFF0000) | styBtn;
		}
		//	TuNX{^ȊOȂ΁AEChX^Ĉ܂ܕԂ
		else {
			rc = styWin;
		}
	}
	//	EChX^CȊO̎擾H
	else {
		if (IsWindowUnicode(hwnd)) rc = GetWindowLongPtrW(hwnd, ix);
		else					   rc = GetWindowLongPtrA(hwnd, ix);
	}
	return rc;
}

//==============================================================================================================//
//	ftHgEChvV[W̎s																		//
//																												//
//	@	F	hwnd			- EChnh																//
//				msg				- bZ[W																	//
//				lParam, wParam	- p^																		//
//																												//
//	߂l	F	DefWindowProc()̖߂l																			//
//==============================================================================================================//
AJCEXPORT LRESULT	WINAPI	AjcDefWindowProc(HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT	rc;
	if (IsWindowUnicode(hwnd)) 
		rc = DefWindowProcW(hwnd, msg, wParam, lParam);
	else					   
		rc = DefWindowProcA(hwnd, msg, wParam, lParam);
	return rc;
}
//==============================================================================================================//
//	EChvV[W̌Ăяo																				//
//																												//
//	@	F	wndproc			- EChvV[W															//
//				hwnd			- EChnh																//
//				msg				- bZ[W																	//
//				lParam, wParam	- p^																		//
//																												//
//	߂l	F	CallWindowProc()̖߂l																		//
//==============================================================================================================//
AJCEXPORT LRESULT	WINAPI	AjcCallWindowProc(WNDPROC wndproc, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT	rc;
	if (IsWindowUnicode(hwnd)) 
		rc = CallWindowProcW(wndproc, hwnd, msg, wParam, lParam);
	else					   
		rc = CallWindowProcA(wndproc, hwnd, msg, wParam, lParam);
	return rc;
}
//==============================================================================================================//
//	EChʒu擾																							//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pX, pY		- EChʒui[obt@̃AhX											//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI	AjcGetWindowPos(HWND hwnd, UIP pX, UIP pY)
{
	BOOL	rc = FALSE;
	RECT	r;

	if (IsWindow(hwnd) && pX != NULL && pY != NULL) {
		GetWindowRect(hwnd, &r);
		*pX = r.left;
		*pY = r.top;
		rc = TRUE;
	}
	return rc;
}
