#include	"AjcInternal.h"
#include	"AjcXYModemL.h"

#define	INST_ID			0xBBCC569A
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

/*--------------------------------------------------------------------------------------------------------------*/
/*	^C}^gC																						*/
/*--------------------------------------------------------------------------------------------------------------*/
#define		TIMRX_REQ_INTERVAL		 1000			//	MFMv(NAK/C/G)MC^o	[ms]  ( t0 )
#define		TIMRX_WAI_REC			10000			//	MFR[h^dnsM҂^C}	[ms]  ( t1 )

#define		TIMTX_WAI_REQ			60000			//	MFMv(NAK/C/G)M҂^C}	[ms]  ( t0 )
#define		TIMTX_WAI_ACK			 3000			//	MF`bjM҂^C}			[ms]  ( t1 )

#define		RTYRX_TX_ACK			3				//	MF`bjđ			 ( r1 )
#define		RTYTX_TX_REC			3				//	MFR[h^dnsđ ( r1 )

/*--------------------------------------------------------------------------------------------------------------*/
/*	RX^g																								*/
/*--------------------------------------------------------------------------------------------------------------*/
static	const UB	csC  [] = {'C'	 };
static	const UB	csG  [] = {'G'	 };
static	const UB	csACK[] = {CC_ACK};
static	const UB	csNAK[] = {CC_NAK};
static	const UB	csEOT[] = {CC_EOT};
static	const UB	csCAN[] = {CC_CAN, CC_CAN, CC_CAN};

/*--------------------------------------------------------------------------------------------------------------*/
/*	Tu֐																								*/
/*--------------------------------------------------------------------------------------------------------------*/
static VO	SubXymInit (HAJCXYM  pW, UX cbp,
						 VO		(CALLBACK *cbNotice )(UI knd, UX Param, UX cbp),
						 VO		(CALLBACK *cbGetFile)(PAJCXYMFILEINFOV pBuf, UX cbp),
						 VO		(CALLBACK *cbGetData)(VOP pBuf, UI lBuf, UIP pBytes, UX cbp),
						 VO		(CALLBACK *cbSend	)(C_VOP pTxD, UI lTxD, UX cbp));

static	VO	CALLBACK	cbPreFunc(UI pno, int sts, UX bcp);
static	VO	SetDatL  (HAJCXYM pW);
static	VO	DoEvent  (HAJCXYM pW, UI evt);
static	UL	OctToLong(C_UBP pStr);

/*==============================================================================================================*/
/*	CX^X																							*/
/*																												*/
/*	@	F	cbp 	 - R[obNp^																	*/
/*				cbNotice - Cxgʒm֐̃AhXisv͂mtkkj										*/
/*				cbGetFile- t@C擾֐̃AhX														*/
/*				cbGetData- t@Cf[^ǂݏo֐̃AhX													*/
/*				cbSend	 - f[^M֐̃AhX																*/
/*																												*/
/*	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						*/
/*				mtkkFG[																				*/
/*==============================================================================================================*/
/*----- oCg ---------------------------------------------------------------------------------------------*/
AJCEXPORT HAJCXYM	WINAPI	AjcXymCreateA(UX cbp,
										  VO (CALLBACK *cbNotice )(UI knd, UX Param				, UX cbp),
										  VO (CALLBACK *cbGetFile)(PAJCXYMFILEINFOA pBuf		, UX cbp),
										  VO (CALLBACK *cbGetData)(VOP pBuf, UI lBuf, UIP pBytes, UX cbp),
										  VO (CALLBACK *cbSend	 )(C_VOP pTxD, UI lTxD			, UX cbp))
{
	HAJCXYM	pW;

	if ((pW = (HAJCXYM)AJCMEM(sizeof(AJCXYM))) != NULL) {
		SubXymInit(pW, cbp, cbNotice, (AJCXYMCB_GETFILEV)cbGetFile, cbGetData, cbSend);
		pW->fUnicode = FALSE;
	}

	return pW;
}
/*----- Ch ---------------------------------------------------------------------------------------------*/
AJCEXPORT HAJCXYM	WINAPI	AjcXymCreateW(UX cbp,
										  VO (CALLBACK *cbNotice )(UI knd, UX Param				, UX cbp),
										  VO (CALLBACK *cbGetFile)(PAJCXYMFILEINFOW pBuf		, UX cbp),
										  VO (CALLBACK *cbGetData)(VOP pBuf, UI lBuf, UIP pBytes, UX cbp),
										  VO (CALLBACK *cbSend	 )(C_VOP pTxD, UI lTxD			, UX cbp))
{
	HAJCXYM	pW;

	if ((pW = (HAJCXYM)AJCMEM(sizeof(AJCXYM))) != NULL) {
		SubXymInit(pW, cbp, cbNotice, (AJCXYMCB_GETFILEV)cbGetFile, cbGetData, cbSend);
		pW->fUnicode = TRUE;
	}

	return pW;
}
/*--------------------------------------------------------------------------------------------------------------*/
/*	CX^Xݒ																						*/
/*																												*/
/*	@	F	pW		 - CX^X[ÑAhX															*/
/*				cbp		 - R[obNp^																	*/
/*				cbNotice - Cxgʒm֐̃AhXisv͂mtkkj										*/
/*				cbGetFile- t@C擾֐̃AhX														*/
/*				cbGetData- t@Cf[^ǂݏo֐̃AhX													*/
/*				cbSend	 - f[^M֐̃AhX																*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*--------------------------------------------------------------------------------------------------------------*/
static VO	SubXymInit (HAJCXYM  pW, UX cbp,
						 VO		(CALLBACK *cbNotice )(UI knd, UX Param				, UX cbp),
						 VO		(CALLBACK *cbGetFile)(PAJCXYMFILEINFOV pBuf			, UX cbp),
						 VO		(CALLBACK *cbGetData)(VOP pBuf, UI lBuf, UIP pBytes	, UX cbp),
						 VO		(CALLBACK *cbSend	)(C_VOP pTxD, UI lTxD			, UX cbp))
{
	memset(pW, 0, sizeof *pW);
	pW->InstID 		= INST_ID;
	pW->hStc		= AjcStcCreate(XymStsTbl, NULL, XymEvtTbl[0], XYS_NUM, (UX)pW, cbPreFunc, NULL);
	pW->cbp			= cbp;
	pW->cbNotice	= cbNotice;
	pW->cbGetFile	= (AJCXYMCB_GETFILEV)cbGetFile;
	pW->cbGetData	= cbGetData;
	pW->cbSend		= cbSend;

	pW->tx_t0 = TIMTX_WAI_REQ;		pW->tx_r0 = 0;
	pW->tx_t1 = TIMTX_WAI_ACK;		pW->tx_r1 = RTYTX_TX_REC;

	pW->rx_t0 = TIMRX_REQ_INTERVAL;	pW->rx_r0 = 0;
	pW->rx_t1 = TIMRX_WAI_REC;		pW->rx_r1 = RTYRX_TX_ACK;
}
/*==============================================================================================================*/
/*	CX^X																							*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*==============================================================================================================*/
AJCEXPORT VO	WINAPI	AjcXymDelete(HAJCXYM pW)
{
	if (IS_MY_INST(pW)) {
		if (pW->hStc != NULL) {AjcStcDelete(pW->hStc); pW->hStc = NULL;}
		free(pW);
	}
}
/*==============================================================================================================*/
/*	t@CMJn																							*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*				Protocol - vgR																		*/
/*																												*/
/*	߂l	F	sqtd   : nj																				*/
/*				e`krd : G[																				*/
/*==============================================================================================================*/
AJCEXPORT BOOL	WINAPI	AjcXymTxStart (HAJCXYM	pW, AJCXYMPROTOCOL Protocol)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (AjcStcGetCurrentState(pW->hStc) == AJCSTC_STS_IDLE	&&	ISXYP_OK(Protocol)	&&	pW->cbGetFile  &&  pW->cbGetData) {
			pW->bix = 0;																	//	Mobt@NA[
			if (pW->knd == AJCXYP_YMODEM_G) {												//	Y-MODEM-G
				AjcStcSetTimerInfo(pW->hStc, XYTIM_WAIREQ, pW->tx_t0, XYE_TIMOUT_0_YG);		//	Mv(NAK/C/G)M҂^C}
				AjcStcSetTimerInfo(pW->hStc, XYTIM_WAIACK, pW->tx_t1, XYE_TIMOUT_1_YG);		//	`bjM҂^C}
			}
			else {																			//	Y-MODEM-GȊO
				AjcStcSetTimerInfo(pW->hStc, XYTIM_WAIREQ, pW->tx_t0, XYE_TIMOUT_0);		//	Mv(NAK/C/G)M҂^C}
				AjcStcSetTimerInfo(pW->hStc, XYTIM_WAIACK, pW->tx_t1, XYE_TIMOUT_1);		//	`bjM҂^C}
			}
			pW->tim0 = pW->tx_t0;	pW->rty0 = pW->tx_r0;
			pW->tim1 = pW->tx_t1;	pW->rty1 = pW->tx_r1;
			pW->RtyCnt0 = pW->RtyCnt1 = 0;
			AjcStcSetCurrentState(pW->hStc, AJCSTC_STS_IDLE);	/*	ACh									*/
			pW->knd 	   = (UI)Protocol;						/*	vgRʐݒ								*/
			SetDatL(pW);										/*	ĺَʂɂőްނ޲Đݒ	*/

			DoEvent(pW, XYE_REQ_TXSRT);							/*	t@CMJnCxgs					*/

			rc = TRUE;
		}
	}
	return rc;
}

/*==============================================================================================================*/
/*	t@CMJn																							*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*				Protocol - vgR																		*/
/*																												*/
/*	߂l	F	sqtd   : nj																				*/
/*				e`krd : G[																				*/
/*==============================================================================================================*/
AJCEXPORT BOOL	WINAPI	AjcXymRxStart (HAJCXYM	pW, AJCXYMPROTOCOL Protocol)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (AjcStcGetCurrentState(pW->hStc) == AJCSTC_STS_IDLE	&&	ISXYP_OK(Protocol)) {
			pW->bix = 0;																			//	Mobt@NA[
			if (pW->knd == AJCXYP_YMODEM_G) {														//	Y-MODEM-G
				AjcStcSetTimerInfo(pW->hStc, XYTIM_REQCYC, pW->rx_t0, XYE_TIMOUT_0_YG);				//	Mv(NAK/C/G)MC^o
				AjcStcSetTimerInfo(pW->hStc, XYTIM_WAIREC, pW->rx_t1, XYE_TIMOUT_1_YG);				//	R[h^dnsM҂^C}
			}
			else {																					//	Y-MODEM-GȊO
				AjcStcSetTimerInfo(pW->hStc, XYTIM_REQCYC, pW->rx_t0, XYE_TIMOUT_0);				//	Mv(NAK/C/G)MC^o
				AjcStcSetTimerInfo(pW->hStc, XYTIM_WAIREC, pW->rx_t1, XYE_TIMOUT_1);				//	R[h^dnsM҂^C}
			}
			pW->tim0 = pW->rx_t0;	pW->rty0 = pW->rx_r0;
			pW->tim1 = pW->rx_t1;	pW->rty1 = pW->rx_r1;
			pW->RtyCnt0 = pW->RtyCnt1 = 0;
			AjcStcSetCurrentState(pW->hStc, AJCSTC_STS_IDLE);	/*	ACh									*/
			pW->knd 	   = (UI)Protocol;						/*	vgRʐݒ								*/
			SetDatL(pW);										/*	ĺَʂɂőްޓݒ			*/

			DoEvent(pW, XYE_REQ_RXSRT);							/*	t@CMJnCxgs					*/

			rc = TRUE;
		}
	}
	return rc;
}

/*==============================================================================================================*/
/*	M^C}擾																						*/
/*																												*/
/*	@	F	pW		- CX^Xnh																	*/
/*				t0, r0	- MFgp																		*/
/*						@MFMv(NAK/C/G)oC^o[ms]  gC							*/
/*				t1, r1	- MF`bj^m`jM҂^C}[ms]	   f[^^dnsđx				*/
/*						@MFf[^^dnsM҂^C}[ms]	   đv(NAK)ox				*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*==============================================================================================================*/
AJCEXPORT	VO	WINAPI	AjcXymGetTxTimeInfo(HAJCXYM pW, UIP t0, UIP r0, UIP t1, UIP r1)
{
	if (IS_MY_INST(pW)) {
		if (t0 != NULL) *t0 = pW->tx_t0;
		if (r0 != NULL) *r0 = pW->tx_r0;
		if (t1 != NULL) *t1 = pW->tx_t1;
		if (r1 != NULL) *r1 = pW->tx_r1;
	}
}

/*==============================================================================================================*/
/*	M^C}ݒ																						*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*				t0, r0	- MFgp																		*/
/*						@MFMv(NAK/C/G)oC^o[ms]  gC							*/
/*				t1, r1	- MF`bj^m`jM҂^C}[ms]	   f[^^dnsđx				*/
/*						@MFf[^^dnsM҂^C}[ms]	   đv(NAK)ox				*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*==============================================================================================================*/
AJCEXPORT	VO	WINAPI	AjcXymSetTxTimeInfo(HAJCXYM pW, UI t0, UI r0, UI t1, UI r1)
{
	if (IS_MY_INST(pW)) {
		pW->tx_t0	= t0;
		pW->tx_r0	= r0;
		pW->tx_t1	= t1;
		pW->tx_r1	= r1;
	}
}
/*==============================================================================================================*/
/*	M^C}擾																						*/
/*																												*/
/*	@	F	pW		- CX^Xnh																	*/
/*				t0, r0	- MFgp																		*/
/*						@MFMv(NAK/C/G)oC^o[ms]  gC							*/
/*				t1, r1	- MF`bj^m`jM҂^C}[ms]	   f[^^dnsđx				*/
/*						@MFf[^^dnsM҂^C}[ms]	   đv(NAK)ox				*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*==============================================================================================================*/
AJCEXPORT	VO	WINAPI	AjcXymGetRxTimeInfo(HAJCXYM pW, UIP t0, UIP r0, UIP t1, UIP r1)
{
	if (IS_MY_INST(pW)) {
		if (t0 != NULL) *t0 = pW->rx_t0;
		if (r0 != NULL) *r0 = pW->rx_r0;
		if (t1 != NULL) *t1 = pW->rx_t1;
		if (r1 != NULL) *r1 = pW->rx_r1;
	}
}

/*==============================================================================================================*/
/*	M^C}ݒ																						*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*				t0, r0	- MFgp																		*/
/*						@MFMv(NAK/C/G)oC^o[ms]  gC							*/
/*				t1, r1	- MF`bj^m`jM҂^C}[ms]	   f[^^dnsđx				*/
/*						@MFf[^^dnsM҂^C}[ms]	   đv(NAK)ox				*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*==============================================================================================================*/
AJCEXPORT	VO	WINAPI	AjcXymSetRxTimeInfo(HAJCXYM pW, UI t0, UI r0, UI t1, UI r1)
{
	if (IS_MY_INST(pW)) {
		pW->rx_t0	= t0;
		pW->rx_r0	= r0;
		pW->rx_t1	= t1;
		pW->rx_r1	= r1;
	}
}

/*==============================================================================================================*/
/*	t@C]~																							*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*==============================================================================================================*/
AJCEXPORT VO	WINAPI	AjcXymStop	   (HAJCXYM  pW)
{
	if (IS_MY_INST(pW)) {
		DoEvent(pW, XYE_REQ_STOP);
	}
}
/*==============================================================================================================*/
/*	VA̎Mf[^^																			*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*				rxd 	 - Mf[^oCg																		*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*==============================================================================================================*/
AJCEXPORT VO	WINAPI	AjcXymPutRxChar(HAJCXYM  pW, UI rxd)
{
	UI		evt = 0xFFFF;
	UI		i;
	UB		sum;

	if (IS_MY_INST(pW)) {
		//----- Mixlncdl|fȊOj----------------------------------------------------------------------*/
		if		(ISXYM_TX) {
			/*------------------------------------------------------------------------------------------------------*/
			/*	t@CM̏																				*/
			/*------------------------------------------------------------------------------------------------------*/
			switch (rxd) {
				case 'C':															/*	'b'M					*/
								if (pW->knd != AJCXYP_YMODEM_G) {					/*		xlncdl|fȊOH	*/
									if (pW->knd == AJCXYP_XMODEM_SUM) {				/*		@XMODEM(SUM)H			*/
										pW->knd = AJCXYP_XMODEM_CRC;				/*			ĺٕύX(XM-CRC)	*/
										SetDatL(pW);								/*			ĺُĐݒ	*/
										if (pW->cbNotice)							/*			ĺٕύXʒm		*/
											pW->cbNotice(AJCXYN_PROTOCOL, pW->knd, pW->cbp);
									}
									evt = XYE_RXREQ;								/*		  ubMv			*/
								}
								break;

				case 'G':															/*	'f'M					*/
								if (pW->knd == AJCXYP_YMODEM_G) {					/*		xlncdl|fH		*/
									evt = XYE_RXREQ_YG;								/*			u'f'Mv		*/
								}
								break;

				case CC_ACK:														/*	`bjM				*/
								if (IS_XMODEM)										/*		wlncdlH			*/
									evt = XYE_RXACK_XM;								/*			uACKM(X-MODEM)v*/
								else												/*		xlncdlH			*/
									evt = XYE_RXACK_YM;								/*			uACKM(Y-MODEM)v*/
								pW->RtyCnt1 = 0;									/*		ACK҂ײر		*/
								break;

				case CC_NAK:														/*	m`jM				*/
																					/*		Mv && XMODEMH	*/
								if (AjcStcGetCurrentState(pW->hStc) == AJCSTC_STS_TX_RCVREQ && IS_XMODEM) {
									if (pW->knd != AJCXYP_XMODEM_SUM) {				/*		@XMODEM(SUM)ȊOH		*/
										pW->knd  = AJCXYP_XMODEM_SUM;				/*			ĺٕύX(XM-SUM)	*/
										SetDatL(pW);								/*			ĺُĐݒ	*/
										if (pW->cbNotice)							/*			ĺٕύXʒm		*/
											pW->cbNotice(AJCXYN_PROTOCOL, pW->knd, pW->cbp);
									}
									evt = XYE_RXREQ;								/*			uMvMn	*/
								}
								else {												/*		Mv҂ȊOH		*/
									evt = XYE_RXNAK;								/*			um`jMv	*/
								}
								break;

				case CC_CAN:														/*	b`mM				*/
								evt = XYE_RXCAN;									/*		ub`mMv			*/
								break;
			}

		}
		//----- Mixlncdl|fj--------------------------------------------------------------------------*/
		else if (ISYMG_TX) {
			switch (rxd) {
				case CC_CAN:														/*	b`mM				*/
								evt = XYE_RXCAN;									/*		ub`mMv			*/
								break;
			}
		}
		//----- M ---------------------------------------------------------------------------------------------*/
		else if (ISXYM_RX) {
			/*------------------------------------------------------------------------------------------------------*/
			/*	t@CM̏																				*/
			/*------------------------------------------------------------------------------------------------------*/
			if (pW->bix == 0) {												/*	R[hMȊOH							*/
				switch (rxd) {
					case CC_SOH:											/*		rngM								*/
									pW->DatL = 128;							/*			f[^PQW						*/
									pW->RecL = 3 + pW->DatL + pW->ChkL;		/*			R[hݒ							*/
									pW->buf[pW->bix++] = (UB)rxd;			/*			obt@ɎMoCgi[				*/
									break;

					case CC_STX:											/*		rswM								*/
									if (pW->knd == AJCXYP_XMODEM_SUM ||		/*			XMODEM(SUM/CRC)H						*/
										pW->knd == AJCXYP_XMODEM_CRC) {		/*			E										*/
										pW->knd  = AJCXYP_XMODEM_1K;		/*			ĺٕύX(XM-1K)						*/
										SetDatL(pW);						/*			ĺُĐݒ						*/
									}
									pW->DatL = 1024;						/*			R[hPj						*/
									pW->RecL = 3 + pW->DatL + pW->ChkL;		/*			R[hݒ							*/
									pW->buf[pW->bix++] = (UB)rxd;			/*			obt@ɎMoCgi[				*/
									break;

					case CC_EOT:											/*		dnsM								*/
									if (IS_XMODEM)							/*			wlncdlH							*/
										evt = XYE_RXEOT_XM;					/*				udnsM(XMODEM)v				*/
									else									/*			xlncdlH							*/
										evt = XYE_RXEOT_YM;					/*				udnsM(YMODEM)v				*/
									break;

					case CC_CAN:											/*		b`mM								*/
									evt = XYE_RXCAN;						/*			ub`mMv							*/
									break;
				}
			}
			else {															/*	R[hMH								*/
				pW->buf[pW->bix++] = (UB)rxd;								/*		obt@ɎMoCgi[					*/
				if (pW->bix >= (3 + pW->DatL + pW->ChkL)) {					/*		SoCgMH							*/
					if (pW->knd == AJCXYP_YMODEM_G) {						/*			xlncdl|fH						*/
						if (pW->buf[1] ==  pW->rno			&&				/*				MR[h`FbNnjH			*/
							pW->buf[2] == (UB)(~pW->rno)	&&				/*				E									*/
							AjcChkXMODEM_BE(&pW->buf[3], pW->DatL + 2)) {	/*				E									*/
							evt = XYE_RXREC_OK_YM;							/*					uR[hMiOK,YMODEMjv	*/
						}
						else {												/*				MR[h`FbNmfH			*/
							evt = XYE_RXREC_NG_YG;							/*					uںގM(NG,YMODEM-G)v		*/
						}
					}
					else {													/*			xlncdl|fȊOH					*/
						do {
							if (pW->knd == AJCXYP_XMODEM_SUM) {				/*				wlncdl|rtlH				*/
								sum = 0;									/*					`FbNTZo				*/
								for (i=3; i<131; i++) sum += pW->buf[i];	/*					E								*/
								if (sum != pW->buf[131]) {					/*					T`FbNmfH				*/
									evt = XYE_RXREC_NG;						/*						uںގM(NG)v			*/
									break;									/*						aqd`j				*/
								}
							}
							else {											/*				wlncdl|rtlȊOH			*/
								if (!AjcChkXMODEM_BE(&pW->buf[3], pW->DatL + 2)) {	/*			bqb`FbNmfH			*/
									evt = XYE_RXREC_NG;						/*						uںގM(NG)v			*/
									break;									/*						aqd`j				*/
								}
							}
							if (pW->buf[1] ==  (pW->rno - 1) &&				/*				PÕR[hԍH				*/
								pW->buf[2] == (UB)(~(pW->rno - 1))) {		/*				E									*/
								evt = XYE_RXREC_BF;							/*					uںގM(BF)v				*/
								break;										/*					aqd`j					*/
							}
							if (pW->buf[1] !=  pW->rno ||					/*				R[hԍmfH					*/
								pW->buf[2] != (UB)(~pW->rno)) {				/*				E									*/
								evt = XYE_RXREC_NG;							/*					uںގM(NG)v				*/
								break;										/*					aqd`j					*/
							}
							if (IS_XMODEM) evt = XYE_RXREC_OK_XM;			/*				ׂĂnjȂ΁uںގM(OK)v	*/
							else		   evt = XYE_RXREC_OK_YM;			/*				E									*/
						} while(0);

					}/*if (pW->knd == AJCXYP_YMODEM_G)*/

					if (evt == XYE_RXREC_OK_XM || evt == XYE_RXREC_OK_YM) {	/*			uR[hM(OK)vH					*/
						pW->RtyCnt1 = 0;									/*				REC҂ײر					*/
						if (IS_YMODEM && pW->buf[1] == 0 && pW->buf[3] == 0) {	/*			YMODEM && RNO=0 && ް擪=0H		*/
							evt = XYE_RXREC_NUL;							/*					uںގM(ͯ)v			*/
						}
					}
					pW->bix = 0;											/*			obt@CfNXZbg				*/

				}															/*		[END OF SoCgM]					*/
			}																/*	[END OF R[hM^M]				*/
		}
		/*----------------------------------------------------------------------------------------------------------------------*/
		if (evt != 0xFFFF) {												/*	LȃCxgH							*/
			DoEvent(pW, evt);												/*		Cxgs								*/
		}
	}
}
/*==============================================================================================================*/
/*	VAւ̑Mʒmixlncdl|fɂt@CM̂݃R[vj							*/
/*																												*/
/*		@xlncdl|f̏ꍇAׂẴt@Cf[^𑗐MAM҂āAdns𑗏o܂A		*/
/*		{W[ł́Af[^Mo܂BiM҂̃^CAEgo܂j			*/
/*		@{֐ɂAׂẴt@Cf[^̑MƂʒmKv܂B					*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*==============================================================================================================*/
AJCEXPORT VO	WINAPI	AjcXymTxEnd    (HAJCXYM  pW)
{
	if (IS_MY_INST(pW)) {
		if (pW->knd == AJCXYP_YMODEM_G) {
			DoEvent(pW, XYE_TXEND);
		}
	}
}
/*==============================================================================================================*/
/*	Ԏ擾																								*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*																												*/
/*	߂l	F	ԁiOFAChԁCP`FʐMj														*/
/*==============================================================================================================*/
AJCEXPORT UI	WINAPI	AjcXymGetState(HAJCXYM	pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		rc = AjcStcGetCurrentState(pW->hStc);
	}
	return rc;
}

/*--------------------------------------------------------------------------------------------------------------*/
/*	mʁnvgRʂɂAőf[^ƁA`FbNoCgݒ肷B									*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	SetDatL(HAJCXYM pW)
{
	switch (pW->knd) {
		case AJCXYP_XMODEM_SUM:	pW->MaxL =	128; pW->ChkL = 1;	pW->rno = 1; break;
		case AJCXYP_XMODEM_CRC:	pW->MaxL =	128; pW->ChkL = 2;	pW->rno = 1; break;
		case AJCXYP_XMODEM_1K:	pW->MaxL = 1024; pW->ChkL = 2;	pW->rno = 1; break;
		case AJCXYP_YMODEM_STD:	pW->MaxL = 1024; pW->ChkL = 2;	pW->rno = 0; break;
		case AJCXYP_YMODEM_G:	pW->MaxL = 1024; pW->ChkL = 2;	pW->rno = 0; break;
	}

}
/*--------------------------------------------------------------------------------------------------------------*/
/*	vZbgt@NV																					*/
/*																												*/
/*	@	F	pW		 - CX^Xnh																	*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_REQ		(HAJCXYM pW)			/*	MviNAK / C / GjM								*/
{
	C_UBP		pTxd;
	UI 			len;

	switch (pW->knd) {
		case AJCXYP_XMODEM_SUM:	pTxd = csNAK; len = sizeof csNAK;	break;
		case AJCXYP_XMODEM_CRC:	pTxd = csC;   len = sizeof csC;		break;
		case AJCXYP_XMODEM_1K:	pTxd = csC;   len = sizeof csC;		break;
		case AJCXYP_YMODEM_STD:	pTxd = csC;   len = sizeof csC;		break;
		case AJCXYP_YMODEM_G:	pTxd = csG;   len = sizeof csG;		break;
	}
	pW->cbSend(pTxd, len, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_ACK		(HAJCXYM pW)			/*	`bjM												*/
{
	pW->cbSend(csACK, sizeof csACK, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_ACKNYG	(HAJCXYM pW)			/*	`bjMixlncdl|fȊOj						*/
{
	if (pW->knd != AJCXYP_YMODEM_G) {
		pW->cbSend(csACK, sizeof csACK, pW->cbp);
	}
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_NAK		(HAJCXYM pW)			/*	m`jM												*/
{
	if (pW->RtyCnt1++ >= pW->rty1) {				/*	gCAEgH	*/
		DoEvent(pW, XYE_RTYOUT_1);					/*		ײ			*/
	}
	else {											/*	gC͈͓H	*/
		pW->cbSend(csNAK, sizeof csNAK, pW->cbp);	/*		NAKo			*/
	}
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_EOT		(HAJCXYM pW)			/*	dnsM												*/
{
	pW->cbSend(csEOT, sizeof csEOT, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_CAN		(HAJCXYM pW)			/*	b`mM												*/
{
	pW->cbSend(csCAN, sizeof csCAN, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_ATT		(HAJCXYM pW)			/*	R[hM										*/
{
	if (pW->DatL == 128) pW->buf[0] = CC_SOH;
	else				 pW->buf[0] = CC_STX;
	pW->buf[1] = 0x00;
	pW->buf[2] = 0xFF;
	AjcSetXMODEM_BE(&pW->buf[3], pW->DatL + 2);
	pW->RecL = pW->DatL + 5;
	pW->cbSend(pW->buf, pW->RecL, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_REC		(HAJCXYM pW)			/*	f[^R[hM										*/
{
	UI	i;
	UB	sum = 0;

	if (pW->DatL == 128) pW->buf[0] = CC_SOH;
	else				 pW->buf[0] = CC_STX;
	pW->buf[1] =  pW->rno;
	pW->buf[2] = (UB)(~pW->rno);
	if (pW->knd == AJCXYP_XMODEM_SUM) {
		for (i=3; i<131; i++) sum += pW->buf[i];
		pW->buf[131] = sum;
		pW->RecL = pW->DatL + 4;
	}
	else {
		AjcSetXMODEM_BE(&pW->buf[3], pW->DatL + 2);
		pW->RecL = pW->DatL + 5;
	}
	pW->cbSend(pW->buf, pW->RecL, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_RTY		(HAJCXYM pW)			/*	R[hđ											*/
{
	if (pW->RtyCnt1++ >= pW->rty1) {				/*	gCAEgH	*/
		DoEvent(pW, XYE_RTYOUT_1);					/*		ײ			*/
	}
	else {											/*	gC͈͓H	*/
		pW->cbSend(pW->buf, pW->RecL, pW->cbp);		/*		R[hđ	*/
	}
}

/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_TX_FILE		(HAJCXYM pW)			/*	St@Cf[^M									*/
{
	UI		bytes;

	memset(&pW->buf[3], 0x1A, pW->MaxL);						/*	t@Cf[^擾							*/
	pW->cbGetData(&pW->buf[3], pW->MaxL, &bytes, pW->cbp);		/*	E											*/

	while (bytes != 0) {										/*		dne܂Ń[v						*/
		if (bytes <= 128) pW->DatL = 128;						/*			f[^ݒ						*/
		else			  pW->DatL = pW->MaxL;					/*			E									*/

		pW->rno++;												/*			ںޔԍXV						*/
		pf_TX_REC(pW);											/*			PR[hM						*/

		memset(&pW->buf[3], 0x1A, pW->MaxL);					/*			̃t@Cf[^擾				*/
		pW->cbGetData(&pW->buf[3], pW->MaxL, &bytes, pW->cbp);	/*			E									*/
	}
}

/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_GET_FILE		(HAJCXYM pW)				/*	t@C擾									*/
{
	AJCXYMFILEINFOV	fi;
	UI				ix;
	UB				str[64];

	
	pW->cbGetFile(&fi, pW->cbp);								/*	R[obNit@C擾j			*/

	if (fi.pFName != NULL) {									/*	t@CH							*/
		memset(&pW->buf[3], 0, 1024);							/*		obt@Ƀt@Cݒ				*/
		ix = 3;													/*		E										*/
		if (pW->fUnicode) {										/*		E										*/
			WideCharToMultiByte(CP_ACP, 0, fi.pFName, -1,		/*		E										*/
				&pW->buf[ix], MAX_PATH, NULL, NULL);			/*		E										*/
		}														/*		E										*/
		else {													/*		E										*/
			strncpy(&pW->buf[ix], fi.pFName, MAX_PATH);			/*		E										*/
		}														/*		E										*/
		ix += (UI)(strlen(&pW->buf[ix]) + 1);					/*		E										*/
		strcat (&pW->buf[ix], _ui64toa(fi.size, str, 10));		/*		E										*/
		ix +=  (UI)strlen(&pW->buf[ix]);						/*		E										*/
		pW->buf[ix++] = ' ';									/*		E										*/
		strcat (&pW->buf[ix], _ui64toa(fi.time, str, 8));		/*		E										*/
		if (pW->DatL <= 128) pW->DatL = 128;					/*		f[^ݒ						*/
		else				 pW->DatL = 1024;					/*		E										*/

		if (IS_XMODEM)											/*		CxgiLȃt@C擾js	*/
			DoEvent(pW, XYE_FI_VALID_XM);						/*		E										*/
		else if (pW->knd == AJCXYP_YMODEM_STD)					/*		E										*/
			DoEvent(pW, XYE_FI_VALID_YM);						/*		E										*/
		else													/*		E										*/
			DoEvent(pW, XYE_FI_VALID_YG);						/*		E										*/
	}
	else {														/*	t@CȂH							*/
		memset(&pW->buf[3], 0, 128);							/*		̑f[^ݒ						*/
		pW->DatL = 128;											/*		f[^PQW					*/

		if (IS_XMODEM)											/*		Cxgĩt@C擾js	*/
			DoEvent(pW, XYE_FI_NULL_XM);						/*		E										*/
		else if (pW->knd == AJCXYP_YMODEM_STD)					/*		E										*/
			DoEvent(pW, XYE_FI_NULL_YM);						/*		E										*/
		else													/*		E										*/
			DoEvent(pW, XYE_FI_NULL_YG);						/*		E										*/

	}
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_GET_DATA		(HAJCXYM pW)			/*	t@Cf[^擾										*/
{
	UI		bytes;

	memset(&pW->buf[3], 0x1A, pW->MaxL);
	pW->cbGetData(&pW->buf[3], pW->MaxL, &bytes, pW->cbp);

	if (bytes != 0) {
		if (bytes <= 128) pW->DatL = 128;
		else			  pW->DatL = pW->MaxL;
		DoEvent(pW, XYE_FDATA);
	}
	else {
		DoEvent(pW, XYE_EOF);
	}
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_INI_RNO		(HAJCXYM pW)			/*	R[hԍ										*/
{
	if (IS_XMODEM) pW->rno = 1;
	else		   pW->rno = 0;
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_UPD_RNO		(HAJCXYM pW)			/*	R[hԍXV										*/
{
	pW->rno++;
}
/*--------------------------------------------------------------------------------------------------------------*/
__declspec(thread) static WC TempFNameW[MAX_PATH] = {0};

static	VO	pf_N_FINFO		(HAJCXYM pW)			/*	t@Cʒm										*/
{
	AJCXYMFILEINFOV	fi;
	size_t			ix;

	if (IS_XMODEM) {
		if (pW->fUnicode) fi.pFName = L"XMODEM.TMP";
		else			  fi.pFName =  "XMODEM.TMP";
		fi.size   = (ULL)0x7FFFFFFFFFFFFFFF;
		fi.time   = 0;
	}
	else {
		if (pW->fUnicode) {
			MultiByteToWideChar(CP_ACP, 0, (BCP)&pW->buf[3], -1, TempFNameW, MAX_PATH);
			fi.pFName = TempFNameW;
		}
		else			  {
			fi.pFName = &pW->buf[3];
		}
		ix = 3 + strlen(&pW->buf[3]) + 1;
		fi.size = _atoi64(&pW->buf[ix]);
		while (_ismbcdigit(pW->buf[ix])  && ix < pW->DatL + 3) {ix++;}
		while (MAjcIsBlankA(pW->buf[ix]) && ix < pW->DatL + 3) {ix++;}
		fi.time = OctToLong(&pW->buf[ix]);
	}
	if (pW->cbNotice) {
		pW->cbNotice(AJCXYN_RXFILEINFO, (UX)(&fi), pW->cbp);
	}
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_N_TXREC		(HAJCXYM pW)			/*	PR[hMʒm									*/
{
	if (pW->cbNotice)
		pW->cbNotice(AJCXYN_TXREC, pW->DatL, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_N_RXREC		(HAJCXYM pW)			/*	PR[hMʒm										*/
{
	if (pW->cbNotice) {
		if (pW->DatL == 128)
			pW->cbNotice(AJCXYN_RXREC_128, (UX)&pW->buf[3], pW->cbp);
		else
			pW->cbNotice(AJCXYN_RXREC_1K , (UX)&pW->buf[3], pW->cbp);
	}
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_N_RETRY		(HAJCXYM pW)			/*	đʒm											*/
{
	if (pW->RtyCnt1 <= pW->rty1) {					/*	gCAEgH	*/
		if (pW->cbNotice)
			pW->cbNotice(AJCXYN_RETRY, 0, pW->cbp);
	}
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_N_EOF		(HAJCXYM pW)			/*	dneʒm												*/
{
	if (pW->cbNotice)
		pW->cbNotice(AJCXYN_EOF, 0, pW->cbp);
}

/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_N_END		(HAJCXYM pW)			/*	t@C]ʒm									*/
{
	if (pW->cbNotice)
		pW->cbNotice(AJCXYN_COMPLETE, 0, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_N_RX_CAN		(HAJCXYM pW)			/*	t@C]~ib`mM					jʒm	*/
{
	if (pW->cbNotice)
		pW->cbNotice(AJCXYN_RX_CAN, 0, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_N_USRSTP		(HAJCXYM pW)			/*	t@C]~i[U̒~v			jʒm	*/
{
	if (pW->cbNotice)
		pW->cbNotice(AJCXYN_USERSTOP, 0, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_N_TIMOUT		(HAJCXYM pW)			/*	t@C]~i^CAEg					jʒm	*/
{
	if (pW->cbNotice)
		pW->cbNotice(AJCXYN_TIMEOUT, 0, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	pf_N_ABORT		(HAJCXYM pW)			/*	t@C]~iYMODEM-GŕsR[hM	jʒm	*/
{
	if (pW->cbNotice)
		pW->cbNotice(AJCXYN_ABORT, 0, pW->cbp);
}
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	CALLBACK	cbPreFunc(UI pno, int sts, UX cbp)
{
	HAJCXYM	pW = (HAJCXYM)cbp;

	switch (pno) {
		case AJCSTC_PF_TX_REQ:		pf_TX_REQ	(pW);	break;	/*	MviNAK / C / GjM						*/
		case AJCSTC_PF_TX_ACK:		pf_TX_ACK	(pW);	break;	/*	`bjM										*/
		case AJCSTC_PF_TX_ACKNYG:	pf_TX_ACKNYG(pW);	break;	/*	`bjMixlncdl|fȊOj				*/
		case AJCSTC_PF_TX_NAK:		pf_TX_NAK	(pW);	break;	/*	m`jM										*/
		case AJCSTC_PF_TX_EOT:		pf_TX_EOT	(pW);	break;	/*	dnsM										*/
		case AJCSTC_PF_TX_CAN:		pf_TX_CAN	(pW);	break;	/*	b`mM										*/
		case AJCSTC_PF_TX_ATT:		pf_TX_ATT	(pW);	break;	/*	R[hM								*/
		case AJCSTC_PF_TX_REC:		pf_TX_REC	(pW);	break;	/*	f[^R[hM								*/
		case AJCSTC_PF_TX_FILE:		pf_TX_FILE	(pW);	break;	/*	St@Cf[^M							*/
		case AJCSTC_PF_TX_RTY:		pf_TX_RTY	(pW);	break;	/*	gC`FbNR[hđ					*/

		case AJCSTC_PF_GET_FILE:	pf_GET_FILE	(pW);	break;	/*	t@C擾								*/
		case AJCSTC_PF_GET_DATA:	pf_GET_DATA	(pW);	break;	/*	t@Cf[^擾								*/

		case AJCSTC_PF_INI_RNO:		pf_INI_RNO	(pW);	break;	/*	R[hԍ								*/
		case AJCSTC_PF_UPD_RNO:		pf_UPD_RNO	(pW);	break;	/*	R[hԍXV								*/

		case AJCSTC_PF_N_FINFO:		pf_N_FINFO	(pW);	break;	/*	t@Cʒm								*/
		case AJCSTC_PF_N_TXREC:		pf_N_TXREC	(pW);	break;	/*	PR[hMʒm							*/
		case AJCSTC_PF_N_RXREC:		pf_N_RXREC	(pW);	break;	/*	PR[hMʒm								*/
		case AJCSTC_PF_N_RETRY:		pf_N_RETRY	(pW);	break;	/*	đʒm									*/
		case AJCSTC_PF_N_EOF:		pf_N_EOF	(pW);	break;	/*	dneʒm										*/

		case AJCSTC_PF_N_END:		pf_N_END	(pW);	break;	/*	t@C]ʒm							*/
		case AJCSTC_PF_N_RX_CAN:	pf_N_RX_CAN	(pW);	break;	/*	t@C]~ʒmib`mM			 j	*/
		case AJCSTC_PF_N_USRSTP:	pf_N_USRSTP	(pW);	break;	/*	@V@@@@@@ʒmi[U̒~v	 j	*/
		case AJCSTC_PF_N_TIMOUT:	pf_N_TIMOUT	(pW);	break;	/*	@V@@@@@@ʒmi^CAEg			 j	*/
		case AJCSTC_PF_N_ABORT:		pf_N_ABORT	(pW);	break;	/*	@V@@@@@@ʒmȋ				 j	*/
	}
}
/*--------------------------------------------------------------------------------------------------------------*/
/*	Cxgs																								*/
/*																												*/
/*	@	F	pW	   - CX^Xnh																	*/
/*				evt    - Cxgԍ																			*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*--------------------------------------------------------------------------------------------------------------*/
static	VO	DoEvent(HAJCXYM pW, UI evt)
{
	AjcStcExecEvent(pW->hStc, evt);
}
/*--------------------------------------------------------------------------------------------------------------*/
/*	Wi񁨐lϊ																						*/
/*																												*/
/*	@	F	pW	   - CX^Xnh																	*/
/*				evt    - Cxgԍ																			*/
/*																												*/
/*	߂l	F	Ȃ																							*/
/*--------------------------------------------------------------------------------------------------------------*/
static	UL	OctToLong(C_UBP pStr)
{
	UL		rc = 0;

	while (*pStr >= '0' && *pStr <= '7') {
		rc <<= 3;
		rc |= ( *pStr & 15);
		pStr++;
	}
	return rc;
}

