#include	"AjcInternal.h"
#include	"AjcXYModemL.h"


#define		TM		AJCTM
#define		SM		AJCSM
#define		PF		AJCPF

/*==========================================================================================================================*/
/*																															*/
/*		ԑJڎANVe[u																						*/
/*																															*/
/*==========================================================================================================================*/
const AJCSTC_STSACT	XymStsTbl [ XYS_NUM ] = {
/*  Status-            TimerControl      PresetFunctions                                                   	*/
/*                      0  1  2  3                                                                          */
/*  0:IDLE      */ {TM( R, R, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ	*/ {TM( S, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT	*/ {TM( _, S, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ */ {TM( S, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT */ {TM( _, S, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT */ {TM( _, S, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL	*/ {TM( _, S, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG	*/ {TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ	*/ {TM( S, _, _, _ ),PF( INI_RNO  , TX_REQ   , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ */ {TM( S, _, _, _ ),PF( __       , TX_REQ   , __       , __       , __       , __       )},
/* 10:RX_RCVDAT	*/ {TM( _, S, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
};

/*==========================================================================================================================*/
/*																															*/
/*	CxgANVe[u																								*/
/*																															*/
/*==========================================================================================================================*/
const AJCSTC_EVT_NF	XymEvtTbl [ XYE_NUM ] [ XYS_NUM ] = {
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 0] : t@CMJnv																								*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( TX_RCVREQ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 1] : t@CMJnv																								*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( RX_SNDREQ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 2] : ]~v																										*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , __       , N_USRSTP , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_USRSTP , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_USRSTP , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_USRSTP , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_USRSTP , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_USRSTP , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_USRSTP , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , __       , N_USRSTP , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_USRSTP , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_USRSTP , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 3] : Mvim`j^bjM																						*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( INI_RNO  , GET_FILE , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , GET_DATA , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 4] : MvifjM																								*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( INI_RNO  , GET_FILE , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( TX_SNDYMG),TM( _, _, _, _ ),PF( __       , TX_FILE  , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 5] : m`jM																										*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, S, _, _ ),PF( TX_RTY   , N_RETRY  , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, S, _, _ ),PF( TX_RTY   , N_RETRY  , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, S, _, _ ),PF( TX_EOT   , N_RETRY  , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, S, _, _ ),PF( TX_RTY   , N_RETRY  , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 6] : `bjMiwlncdlj																						*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( N_TXREC  , UPD_RNO  , GET_DATA , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_END    , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 7] : `bjMixlncdlj																						*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( TX_RCVDRQ),TM( _, _, _, _ ),PF( __       , UPD_RNO  , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( N_TXREC  , UPD_RNO  , GET_DATA , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( TX_RCVREQ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_END    , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 8] : dnsMiwlncdlj																						*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_ACK   , N_EOF    , N_END    , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_ACK   , N_EOF    , N_END    , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[ 9] : dnsMixlncdlj																						*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( RX_SNDREQ),TM( _, _, _, _ ),PF( TX_ACK   , N_EOF    , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( RX_SNDREQ),TM( _, _, _, _ ),PF( TX_ACK   , N_EOF    , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[10] : b`mM																										*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( __       , N_RX_CAN , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_EOF    , N_RX_CAN , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_EOF    , N_RX_CAN , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_EOF    , N_RX_CAN , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_EOF    , N_RX_CAN , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_EOF    , N_RX_CAN , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_EOF    , N_RX_CAN , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( __       , N_RX_CAN , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_EOF    , N_RX_CAN , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( N_EOF    , N_RX_CAN , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[11] : f[^R[hMinjCwlncdlj																			*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( RX_RCVDAT),TM( R, _, _, _ ),PF( TX_ACKNYG, N_FINFO  , N_RXREC  , UPD_RNO  , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( RX_RCVDAT),TM( _, _, _, _ ),PF( TX_ACKNYG, __       , N_RXREC  , UPD_RNO  , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[12] : f[^R[hMinjCxlncdlj																			*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( RX_SNDDRQ),TM( R, _, _, _ ),PF( TX_ACKNYG, N_FINFO  , UPD_RNO  , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( RX_RCVDAT),TM( R, _, _, _ ),PF( TX_ACKNYG, N_RXREC  , UPD_RNO  , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( RX_RCVDAT),TM( _, _, _, _ ),PF( TX_ACKNYG, N_RXREC  , UPD_RNO  , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[13] : kwb_MinjCxlncdl^xlncdl|fj															*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_ACKNYG, N_END    , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( RX_RCVDAT),TM( R, _, _, _ ),PF( TX_ACKNYG, N_RXREC  , UPD_RNO  , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( RX_RCVDAT),TM( _, _, _, _ ),PF( TX_ACKNYG, N_RXREC  , UPD_RNO  , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[14] : f[^R[hMiaeCxlncdl|fȊOEEPORNOj													*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( RX_RCVDAT),TM( _, _, _, _ ),PF( TX_ACKNYG, __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[15] : f[^R[hMimfCxlncdl|fȊOj																	*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( RX_RCVDAT),TM( _, _, _, _ ),PF( TX_NAK   , N_RETRY  , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[16] : f[^R[hMimfCxlncdl|fj																		*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_ABORT  , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_ABORT  , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_ABORT  , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[17] : Mixlncdl|fj																						*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( TX_ACKEOT),TM( _, _, _, _ ),PF( TX_EOT   , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[18] : Lȃt@C擾iwlncdlj																			*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( GET_DATA , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[19] : Lȃt@C擾ixlncdlj																			*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( TX_ACKATT),TM( _, _, _, _ ),PF( TX_ATT   , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[20] : Lȃt@C擾ixlncdl|fj																		*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( TX_RCVDRQ),TM( _, _, _, _ ),PF( TX_ATT   , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[21] : ̃t@C擾iwlncdlj																				*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( TX_ACKEOT),TM( _, _, _, _ ),PF( TX_EOT   , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[22] : ̃t@C擾ixlncdlj																				*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( TX_ACKNUL),TM( _, _, _, _ ),PF( TX_ATT   , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[23] : ̃t@C擾ixlncdl|fj																			*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_ATT   , N_END    , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[24] : Lȃt@Cf[^擾																							*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( TX_ACKDAT),TM( _, _, _, _ ),PF( TX_REC   , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( TX_ACKDAT),TM( _, _, _, _ ),PF( TX_REC   , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( TX_ACKDAT),TM( _, _, _, _ ),PF( TX_REC   , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( TX_ACKDAT),TM( _, _, _, _ ),PF( TX_REC   , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[25] : t@CI[o																									*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( TX_ACKEOT),TM( _, _, _, _ ),PF( N_EOF    , TX_EOT   , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( TX_ACKEOT),TM( _, _, _, _ ),PF( N_EOF    , TX_EOT   , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( TX_ACKEOT),TM( _, _, _, _ ),PF( N_EOF    , TX_EOT   , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( TX_ACKEOT),TM( _, _, _, _ ),PF( N_EOF    , TX_EOT   , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[26] : ^CAEgiOj	TX=Mv(NAK/C/G)M҂ρCRX=Mv(NAK/C/G)o							*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , __       , N_TIMOUT , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( S, _, _, _ ),PF( TX_REQ   , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( S, _, _, _ ),PF( TX_REQ   , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[27] : ^CAEgiOCxlncdl|fj																				*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , __       , N_TIMOUT , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( S, _, _, _ ),PF( TX_REQ   , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( S, _, _, _ ),PF( TX_REQ   , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[28] : gCAEgiOj																								*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , __       , N_TIMOUT , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , __       , N_TIMOUT , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[29] : ^CAEgiPj	TX=`bjM҂^C}CRX=R[hM҂^C}											*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( __       ),TM( _, S, _, _ ),PF( TX_RTY   , N_RETRY  , __       , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( __       ),TM( _, S, _, _ ),PF( TX_RTY   , N_RETRY  , __       , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( __       ),TM( _, S, _, _ ),PF( TX_RTY   , N_RETRY  , __       , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( __       ),TM( _, S, _, _ ),PF( TX_RTY   , N_RETRY  , __       , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( __       ),TM( _, S, _, _ ),PF( TX_NAK   , N_RETRY  , __       , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[30] : ^CAEgiPCxlncdl|fj																				*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
},
/*--------------------------------------------------------------------------------------------------------------------------*/
/*	[31] : gCAEgiPj																								*/
/*--------------------------------------------------------------------------------------------------------------------------*/
/* Current state  Next state    TimerControl      PresetFunctions                                                           */
/*                                    0  1  2  3                                                                            */
/*  0:IDLE     */{{SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  1:TX_RCVREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , __       , N_TIMOUT , __       , __       , __       )},
/*  2:TX_ACKATT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  3:TX_RCVDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/*  4:TX_ACKDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  5:TX_ACKEOT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  6:TX_ACKNUL*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
/*  7:TX_SNDYMG*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},

/*  8:RX_SNDREQ*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , __       , N_TIMOUT , __       , __       , __       )},
/*  9:RX_SNDDRQ*/{ SM( __       ),TM( _, _, _, _ ),PF( __       , __       , __       , __       , __       , __       )},
/* 10:RX_RCVDAT*/{ SM( IDLE     ),TM( _, _, _, _ ),PF( TX_CAN   , N_EOF    , N_TIMOUT , __       , __       , __       )},
},
};
