#include	<AjxCpp.h>

using namespace AjxControl;


//==============================================================================================================//
//																												//
//	bꎚ啪NX(ASCII)																					//
//																												//
//==============================================================================================================//

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNiPsǂݏov, ASCIIj																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbCtkA (BCP pBuf, UI lBuf, UX cbp)
{
	CAjxCtk*	p = (CAjxCtk*)cbp;
	return p->OnGetLine(pBuf, lBuf);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNiPsǂݏov, UNICODEj																	//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbCtkW (WCP pBuf, UI lBuf, UX cbp)
{
	CAjxCtk*	p = (CAjxCtk*)cbp;
	return p->OnGetLine(pBuf, lBuf);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxCtk::CAjxCtk(BOOL fUnicode) 
{
	m_Ix	= 0;
	memset(m_hCtk, 0, sizeof m_hCtk);

	if (m_fUnicode = fUnicode) m_hCtk[m_Ix] = AjcCtkCreateW(AJCTKFLG_DOTSYMBOL | AJCTKFLG_LBF_4K, cbCtkW, (UX)this);
	else					   m_hCtk[m_Ix] = AjcCtkCreateA(AJCTKFLG_DOTSYMBOL | AJCTKFLG_LBF_4K, cbCtkA, (UX)this);


	if (m_hCtk[m_Ix] == NULL) {
		throw std::runtime_error("CTK cannot creation.");
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxCtk::~CAjxCtk()
{
	while (m_Ix >= 0) {
		if (m_hCtk[m_Ix] != NULL) {
			AjcCtkDelete(m_hCtk[m_Ix]);
			m_hCtk[m_Ix] = NULL;
		}
		m_Ix--;
	}
}

//	Zbg
BOOL	CAjxCtk::Reset			()
{
	return AjcCtkReset			(m_hCtk[m_Ix]);
}
//	@\tO̐ݒ
BOOL	CAjxCtk::SetFlag		(UI flag)
{
	return AjcCtkSetFlag(m_hCtk[m_Ix], flag);
}
//	@\tO̎擾
UI		CAjxCtk::GetFlag		()
{
	return AjcCtkGetFlag		(m_hCtk[m_Ix]);
}
//	ǂݏo(ASCII)
BOOL	CAjxCtk::GetToken		(BCP pStrBuf, UI lStrBuf)
{
	return AjcCtkGetTokenA		(m_hCtk[m_Ix], pStrBuf, lStrBuf);
}
//	ǂݏo(UNICODE)
BOOL	CAjxCtk::GetToken		(WCP pStrBuf, UI lStrBuf)
{
	return AjcCtkGetTokenW		(m_hCtk[m_Ix], pStrBuf, lStrBuf);
}
//	݂̎擾(ASCII)
BOOL	CAjxCtk::PeekToken		(BCP pStrBuf, UI lStrBuf)
{
	return AjcCtkPeekTokenA		(m_hCtk[m_Ix], pStrBuf, lStrBuf);
}
//	݂̎擾(UNICODE)
BOOL	CAjxCtk::PeekToken		(WCP pStrBuf, UI lStrBuf)
{
	return AjcCtkPeekTokenW		(m_hCtk[m_Ix], pStrBuf, lStrBuf);
}
//	ǂݏoʒȗޔ
BOOL		CAjxCtk::Push		()
{
	BOOL	rc = FALSE;
	HAJCTK	hCtk;

	if (m_Ix < CAJX_CTKMAX_STACK - 1) {
		if (hCtk = AjcCtkGetReplicatedHandle(m_hCtk[m_Ix])) {
			m_Ix++;
			m_hCtk[m_Ix] = hCtk;
			rc = TRUE;
		}
	}
	return rc;
}
//	ǂݏoʒủ
BOOL		CAjxCtk::Pop		()
{
	BOOL	rc = FALSE;

	if (m_Ix >= 1) {
		AjcCtkDelete(m_hCtk[m_Ix]);
		m_Ix--;
	}
	return rc;
}
//	g[NR[hɑΉ镶̎擾
C_BCP	GetTokenString	(EAJCTKCODE tkn)
{
	return AjcCtkGetTokenStringA(tkn);
}
//----- g[N擾 ---------------------------------------------------------------------------------------//
//	G[R[h擾
UI			CAjxCtk::Error		()
{
	return AJCTK_ERROR			(m_hCtk[m_Ix]);
}
//	g[NR[h擾
EAJCTKCODE	CAjxCtk::Token		()
{
	return AJCTK_TOKEN			(m_hCtk[m_Ix]);
}
//	l萔̃TtBbNXR[h擾
EAJCTKSUF	CAjxCtk::Suffix	()
{
	return AJCTK_SUFFIX		(m_hCtk[m_Ix]);
}
//	tO擾
UI			CAjxCtk::Flag	()
{
	return AJCTK_FLAG		(m_hCtk[m_Ix]);
}
//	Y傪݂A\[XvO̍sԍ擾
UI			CAjxCtk::Line	()
{
	return	AJCTK_LINE(m_hCtk[m_Ix]);
}
//	Y傪݂AČʒuԂ܂i^uPƂČvZj
UI			CAjxCtk::Loc	()
{
	return	AJCTK_LOC(m_hCtk[m_Ix]);
}
//	Y傪݂A^u(0x09)lČʒuԂ܂iTabStep̓^uXebvj
UI			CAjxCtk::Pos	(UI TabStep)
{
	return	AJCTK_POS(m_hCtk[m_Ix], TabStep);
}

//----- g[N`FbN ---------------------------------------------------------------------------------------//
//	g[N`FbNi[UV{j
BOOL		CAjxCtk::IsUsrSym	(EAJCTKCODE tkn)
{
	return AJCTKIS_USRSYM(tkn);
}
//	g[N`FbNi\񖼁j
BOOL		CAjxCtk::IsRsvSym	(EAJCTKCODE tkn)
{
	return AJCTKIS_RSVSYM(tkn);
}
//	g[N`FbNilj
BOOL		CAjxCtk::IsValue	(EAJCTKCODE tkn)
{
	return AJCTKIS_VALUE(tkn);
}
//	g[N`FbNij
BOOL		CAjxCtk::IsString	(EAJCTKCODE tkn)
{
	return AJCTKIS_STRING(tkn);
}
//	g[N`FbNipXj
BOOL		CAjxCtk::IsPathName	(EAJCTKCODE tkn)
{
	return AJCTKIS_PATHNAME(tkn);
}
//	g[N`FbNif~^j
BOOL		CAjxCtk::IsDelimit	(EAJCTKCODE tkn)
{
	return AJCTKIS_DELIMIT(tkn);
}
//	g[N`FbNiV{j
BOOL		CAjxCtk::IsSymbol	(EAJCTKCODE tkn)
{
	return AJCTKIS_SYMBOL(tkn);
}
//	g[N`FbNiV{^lj
BOOL		CAjxCtk::IsValSym	(EAJCTKCODE tkn)
{
	return AJCTKIS_VALSYM(tkn);
}
//	g[N`FbNi󔒁j
BOOL		CAjxCtk::IsSpace	(EAJCTKCODE tkn)
{
	return AJCTKIS_SPACE(tkn);
}

//----- z֐ ---------------------------------------------------------------------------------------//
//	Psǂݏov(ASCII)
BOOL  CAjxCtk::OnGetLine	(BCP pBuf, UI lBuf)
{
	return FALSE;
}
//	Psǂݏov(UNICODE)
BOOL  CAjxCtk::OnGetLine	(WCP pBuf, UI lBuf)
{
	return FALSE;
}
