#include	<AjxCpp.h>

#define	PROP_NAME_PARENT	"_AjcG3dSubClassed_"
#define	PROP_NAME_CTRL		"_AjcG3dWndProp_"

using namespace AjxControl;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	eECh̃TuNXEvV[W																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(SBC_G3D, WM_COMMAND			)
{
	CAjxG3d*	p = (CAjxG3d*)::GetPropA((HWND)lParam, PROP_NAME_CTRL);

	if (p != NULL) {
		switch (HIWORD(wParam)) {
			case AJC3DGN_ROTTHETA:	p->OnNtcRotTheta(AjcG3dGetNtcRotTheta((HWND)lParam));	break;	//	_pxʒm
			case AJC3DGN_PLOTLIST:	p->OnNtcPlotList(AjcG3dGetNtcList	  ((HWND)lParam));	break;	//	vbgXgʒm
			case AJC3DGN_CLEAR:		p->OnNtcClear	(AjcG3dGetNtcClrFact  ((HWND)lParam));	break;	//	f[^NA[ʒm
			case AJC3DGN_DBLCLK:	p->OnNtcDblClk	();										break;	//	_uNbNʒm
			case AJC3DGN_DROPFILE:	p->OnNtcDropFile(AjcG3dGetNtcFiles	  ((HWND)lParam));	break;	//	t@Chbvʒm
			case AJC3DGN_DROPDIR:	p->OnNtcDropDir (AjcG3dGetNtcDirs	  ((HWND)lParam));	break;	//	tH_hbvʒm
			case AJC3DGN_RCLICK:	p->OnNtcRClick	(AjcG3dGetNtcRClk	  ((HWND)lParam));	break;	//	ENbNʒm
		}
	}
	return MAjcMmpCallOrgWndProc(SBC_G3D);
}
//----- WM_DESTROY ---------------------------------------------------------------------------------------------//
AJC_WNDPROC(SBC_G3D, WM_DESTROY			)
{
	//	eECh̃vpeB
	if (::GetPropA(hwnd, PROP_NAME_PARENT) != NULL) {
		::RemovePropA(hwnd, PROP_NAME_PARENT);
	}
	return MAjcMmpCallOrgWndProc(SBC_G3D);
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(SBC_G3D)
	AJC_WNDMAP_MSG(SBC_G3D, WM_COMMAND	   )
	AJC_WNDMAP_MSG(SBC_G3D, WM_DESTROY	   )
AJC_WNDMAP_END


//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxG3d::CAjxG3d() 
{
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxG3d::~CAjxG3d()
{
	//	Rg[ECh̃vpeB폜
	if (::GetPropA(m_hCtrl, PROP_NAME_CTRL) != NULL) ::RemovePropA(m_hCtrl, PROP_NAME_CTRL);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	o֐																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- Rct@NV -----------------------------------------------------------------------------//
//	RcOt[h
BOOL	CAjxG3d::Init			(double x1, double y1, double z1, double x2, double y2, double z2, UI style)
{
	return AjcG3dInit			(m_hCtrl, x1, y1, z1, x2, y2, z2, style);
}
//	RcOt[hixNgwj
BOOL	CAjxG3d::Init			(PCAJC3DVEC pLo, PAJC3DVEC pHi, PAJC3DVEC pRot, UI style)
{
	return AjcG3dInitV			(m_hCtrl, pLo, pHi, pRot, style);
}
//	ʃAOݒiRcj
BOOL	CAjxG3d::SetPlane 		(AJCG3DAXIS_DIR HoriAxis, AJCG3DAXIS_DIR VertAxis)
{
	return AjcG3dSetPlane		(m_hCtrl, HoriAxis, VertAxis);
}
//	vpeBݒ
BOOL	CAjxG3d::SetProp		(PCAJC3DGPROP pProp)
{
	return AjcG3dSetProp		(m_hCtrl, pProp);
}
//	vpeB擾
BOOL	CAjxG3d::GetProp		(PAJC3DGPROP  pBuf)
{
	return AjcG3dGetProp		(m_hCtrl, pBuf);
}
//	W
BOOL	CAjxG3d::AdjustRange	()
{
	return AjcG3dAdjustRange	(m_hCtrl);
}
//	ẽWݒ
BOOL	CAjxG3d::SetRange		(double x1, double y1, double z1, double x2, double y2, double z2)
{
	return AjcG3dSetRange		(m_hCtrl, x1, y1, z1, x2, y2, z2);
}
//	e̒Sʒuݒ
BOOL	CAjxG3d::SetCenter		(double xc, double yc, double zc)
{
	return AjcG3dSetCenter		(m_hCtrl, xc, yc, zc);
}
//	e̕iajݒ
BOOL	CAjxG3d::SetWidth		(double xr, double yr, double zr)
{
	return AjcG3dSetWidth		(m_hCtrl, xr, yr, zr);
}
//	ẽW𓯂ɂ
BOOL	CAjxG3d::SetSameRangeWidth	()
{
	return AjcG3dSetSameRangeWidth(m_hCtrl);
}
//	Wݒ肳ꂽ̈̃AXyNgݒ肷
BOOL	CAjxG3d::SetFixedAspect	(BOOL fFixed)
{
	return AjcG3dSetFixedAspect	(m_hCtrl, fFixed);
}
//	\Fݒ
BOOL	CAjxG3d::SetColor		(UI id, COLORREF rgbP, COLORREF rgbN)
{
	return AjcG3dSetColor		(m_hCtrl, id, rgbP, rgbN);
}
//	vbgf[^ݒ
BOOL	CAjxG3d::SetPlotNumber	(UI id, UI PlotNumber)
{
	return AjcG3dSetPlotNumber	(m_hCtrl, id, PlotNumber);
}
//	vbgf[^̃sNZTCYݒ
BOOL	CAjxG3d::SetPlotSize	(UI id, UI PixelSize, UI PixelSizeE)
{
	return AjcG3dSetPlotSize	(m_hCtrl, id, PixelSize, PixelSizeE);
}
//	vbgf[^^
BOOL	CAjxG3d::PutPlotData	(UI id, double x, double y, double z)
{
	return AjcG3dPutPlotData	(m_hCtrl, id, x, y, z);
}
//	vbgf[^^ixNgwj
BOOL	CAjxG3d::PutPlotData	(UI id, PCAJC3DVEC pPoint)
{
	return AjcG3dPutPlotDataV	(m_hCtrl, id, pPoint);
}
//	sNZ`
BOOL	CAjxG3d::Pixel			(UI id, double x , double y , double z , UI PixelSize)
{
	return AjcG3dPixel			(m_hCtrl, id, x, y, z, PixelSize);
}
//	sNZ`ixNgwj
BOOL	CAjxG3d::Pixel			(UI id, PCAJC3DVEC pPoint, UI PixelSize)
{
	return AjcG3dPixelV			(m_hCtrl, id, pPoint, PixelSize);
}
//	C`
BOOL	CAjxG3d::Line			(UI id, double x1, double y1, double z1, double x2, double y2, double z2)
{
	return AjcG3dLine			(m_hCtrl, id, x1, y1, z1, x2, y2, z2);
}
//	C`ixNgwj
BOOL	CAjxG3d::Line			(UI id, PCAJC3DVEC p1, PCAJC3DVEC p2)
{
	return AjcG3dLineV			(m_hCtrl, id, p1, p2);
}
//	C^̎n_ݒ
BOOL	CAjxG3d::MoveTo			(UI id, double x, double y, double z)
{
	return AjcG3dMoveTo			(m_hCtrl, id, x, y, z);
}
//	C^̎n_ݒixNgwj
BOOL	CAjxG3d::MoveTo			(UI id, PCAJC3DVEC ps)
{
	return AjcG3dMoveToV		(m_hCtrl, id, ps);
}
//	C̏I_ݒ肵C`
BOOL	CAjxG3d::LineTo			(UI id, double x, double y, double z)
{
	return AjcG3dLineTo			(m_hCtrl, id, x, y, z);
}
//	C̏I_ݒ肵C`ixNgwj
BOOL	CAjxG3d::LineTo			(UI id, PCAJC3DVEC pe)
{
	return AjcG3dLineToV		(m_hCtrl, id, pe);
}
//	`
BOOL	CAjxG3d::Arrow			(UI id, double x1, double y1, double z1, double x2, double y2, double z2)
{
	return AjcG3dArrow			(m_hCtrl, id, x1, y1, z1, x2, y2, z2);
}
//	`ixNgwj
BOOL	CAjxG3d::Arrow			(UI id, PCAJC3DVEC p1, PCAJC3DVEC p2)
{
	return AjcG3dArrowV			(m_hCtrl, id, p1, p2);
}
//	C̏I_ݒ肵`
BOOL	CAjxG3d::ArrowTo		(UI id, double x, double y, double z)
{
	return AjcG3dArrowTo		(m_hCtrl, id, x, y, z);
}
//	C̏I_ݒ肵`ixNgwj
BOOL	CAjxG3d::ArrowTo		(UI id, PCAJC3DVEC pe)
{
	return AjcG3dArrowToV		(m_hCtrl, id, pe);
}
//	Op``
BOOL	CAjxG3d::Triangle		(UI id, double x1, double y1, double z1, double x2, double y2, double z2, double x3, double y3, double z3)
{
	return AjcG3dTriangle		(m_hCtrl, id, x1, y1, z1, x2, y2, z2, x3, y3, z3);
}
//	Op``ixNgwj
BOOL	CAjxG3d::Triangle		(UI id, PCAJC3DVEC p1, PCAJC3DVEC p2, PCAJC3DVEC p3)
{
	return AjcG3dTriangleV		(m_hCtrl, id, p1, p2, p3);
}
//		lp``
BOOL	CAjxG3d::Square			(UI id, double x1, double y1, double z1, double x2, double y2, double z2, double x3, double y3, double z3, double x4, double y4, double z4)
{
	return AjcG3dSquare			(m_hCtrl, id, x1, y1, z1, x2, y2, z2, x3, y3, z3, x4, y4, z4);
}
//	lp``ixNgwj
BOOL	CAjxG3d::Square			(UI id, PCAJC3DVEC p1, PCAJC3DVEC p2, PCAJC3DVEC p3, PCAJC3DVEC p4)
{
	return AjcG3dSquareV		(m_hCtrl, id, p1, p2, p3, p4);
}
//	́^̕`
BOOL	CAjxG3d::Cube			(UI id, double xc, double yc, double zc, double xr, double yr, double zr, UI division)
{
	return AjcG3dCube			(m_hCtrl, id, xc, yc, zc, xr, yr, zr,division);
}
//	́^̕`ixNgwj
BOOL	CAjxG3d::Cube			(UI id, PCAJC3DVEC pCent, double xr, double yr, double zr, UI division)
{
	return AjcG3dCubeV			(m_hCtrl, id, pCent, xr, yr, zr, division);
}
//	^ȋ`
BOOL	CAjxG3d::Sphere			(UI id, double xc, double yc, double zc, double xr, double yr, double zr, UI slice, UI stack)
{
	return AjcG3dSphere			(m_hCtrl, id, xc, yc, zc, xr, yr, zr, slice, stack);
}
//	^ȋ`ixNgwj
BOOL	CAjxG3d::Sphere			(UI id, PCAJC3DVEC pCent, double rx, double ry, double rz, UI slice, UI stack)
{
	return AjcG3dSphereV		(m_hCtrl, id, pCent, rx, ry, rz, slice, stack);
}
//	RcԏɔCӂ̕ʂ`
BOOL	CAjxG3d::DefPlane		(UI id, double xc, double yc, double zc, double xv, double yv, double zv, double xo, double yo, double zo)
{
	return AjcG3dDefPlane		(m_hCtrl, id, xc, yc, zc, xv, yv, zv, xo, yo, zo);
}
//	RcԏɔCӂ̕ʂ`ixNgwj
BOOL	CAjxG3d::DefPlane		(UI id, PCAJC3DLVEC pLVec, PCAJC3DVEC pVOrg)
{
	return AjcG3dDefPlaneV		(m_hCtrl, id, pLVec, pVOrg);
}
//	_ݒ
BOOL	CAjxG3d::SetAngle		(double rtx, double rty, double rtz)
{
	return AjcG3dSetAngle		(m_hCtrl, rtx, rty, rtz);
}
//	_w|xʂɐݒ
BOOL	CAjxG3d::SetAngleXY		()
{
	return AjcG3dSetAngleXY		(m_hCtrl);
}
//	_w|yʂɐݒ
BOOL	CAjxG3d::SetAngleXZ		()
{
	return AjcG3dSetAngleXZ		(m_hCtrl);
}
//	_x|yʂɐݒ
BOOL	CAjxG3d::SetAngleYZ		()
{
	return AjcG3dSetAngleYZ		(m_hCtrl);
}
//	_RcC[Wɐݒ
BOOL	CAjxG3d::SetAngle3D		()
{
	return AjcG3dSetAngle3D		(m_hCtrl);
}
//	rbg}bv擾
HBITMAP	CAjxG3d::GetBitmap		()
{
	return AjcG3dGetBitmap		(m_hCtrl);
}
//	vt@CvpeBlǏo(ASCII)
BOOL	CAjxG3d::LoadProp		(C_BCP pProfileSect, PCAJC3DGPROP pDefProp)	
{
	return AjcG3dLoadPropA		(m_hCtrl, pProfileSect, pDefProp);
}

//	vt@CvpeBlǏo(UNICODE)
BOOL	CAjxG3d::LoadProp 		(C_WCP pProfileSect, PCAJC3DGPROP pDefProp)
{
	return AjcG3dLoadPropW		(m_hCtrl, pProfileSect, pDefProp);
}
//	vt@CփvpeBl(ASCII)
BOOL	CAjxG3d::SaveProp 		(C_BCP pProfileSect)
{
	return AjcG3dSavePropA		(m_hCtrl, pProfileSect);
}
//	vt@CփvpeBl(UNICODE)
BOOL	CAjxG3d::SaveProp 		(C_WCP pProfileSect)
{
	return AjcG3dSavePropW		(m_hCtrl, pProfileSect);
}
//	vt@Cڍ׃vpeBlǏo(ASCII)
BOOL	CAjxG3d::LoadPropEx		(C_BCP pProfileSect, PCAJC3DGPROP pDefProp)
{
	return AjcG3dLoadPropExA	(m_hCtrl, pProfileSect, pDefProp);
}
//	vt@Cڍ׃vpeBlǏo(UNICODE)
BOOL	CAjxG3d::LoadPropEx		(C_WCP pProfileSect, PCAJC3DGPROP pDefProp)
{
	return AjcG3dLoadPropExW	(m_hCtrl, pProfileSect, pDefProp);
}
//	vt@C֏ڍ׃vpeBl(ASCII)
BOOL	CAjxG3d::SavePropEx		(C_BCP pProfileSect)
{
	return AjcG3dSavePropExA	(m_hCtrl, pProfileSect);
}
//	vt@C֏ڍ׃vpeBl(UNICODE)
BOOL	CAjxG3d::SavePropEx		(C_WCP pProfileSect)
{
	return AjcG3dSavePropExW	(m_hCtrl, pProfileSect);
}
//	eLXg`tHgݒ
HFONT	CAjxG3d::SetTextFont	(HFONT hFont)
{
	return AjcG3dSetTextFont	(m_hCtrl, hFont);
}
//	eLXg`isNZʒuwj(ASCII)
UI		CAjxG3d::TextOut		(int x, int y, C_BCP pTxt)
{
	return AjcG3dTextOutA		(m_hCtrl, x, y, pTxt);
}
//	eLXg`isNZʒuwj(UNICODE)
UI		CAjxG3d::TextOut		(int x, int y, C_WCP pTxt)
{
	return AjcG3dTextOutW		(m_hCtrl, x, y, pTxt);
}
//	eLXg`isNZʒuwj(ASCII)	
UI		CAjxG3d::PrintF			(int x, int y, C_BCP pFmt, ...)
{
	UI		rc = 0;
	va_list vls;
	BC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		AjcVSnPrintFA(buf, 2046, pFmt, vls);
		va_end	(vls);
		rc = AjcG3dTextOutA(m_hCtrl, x, y, buf);
	}
	return rc;
}
//	eLXg`isNZʒuwj(UNICODE)
UI		CAjxG3d::PrintF			(int x, int y, C_WCP pFmt, ...)
{
	UI		rc = 0;
	va_list vls;
	WC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		AjcVSnPrintFW(buf, 2048, pFmt, vls);
		va_end	(vls);
		rc = AjcG3dTextOutW(m_hCtrl, x, y, buf);
	}
	return rc;
}
//	eLXg`iRcWwj(ASCII)
UI		CAjxG3d::TextOutV		(AJCG3DTXOMD md, PCAJC3DVEC pV, C_BCP pTxt)
{
	return	AjcG3dTextOutVA		(m_hCtrl, md, pV, pTxt);
}
//	eLXg`iRcWwj(UNICODE)
UI		CAjxG3d::TextOutV		(AJCG3DTXOMD md, PCAJC3DVEC pV, C_WCP pTxt)
{
	return	AjcG3dTextOutVW		(m_hCtrl, md, pV, pTxt);
}
//	eLXg`iRcWwj(ASCII)	
UI		CAjxG3d::PrintFV		(AJCG3DTXOMD md, PCAJC3DVEC pV, C_BCP pFmt, ...)
{
	UI		rc = 0;
	va_list vls;
	BC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		AjcVSnPrintFA(buf, 2048, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcG3dTextOutVA(m_hCtrl, md, pV, buf);
	}
	return rc;
}
//	eLXg`iRcWwj(UNICODE)
UI		CAjxG3d::PrintFV		(AJCG3DTXOMD md, PCAJC3DVEC pV, C_WCP pFmt, ...)
{
	UI		rc = 0;
	va_list	vls;
	WC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		AjcVSnPrintFW(buf, 2048, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcG3dTextOutVW(m_hCtrl, md, pV, buf);
	}
	return rc;
}
//	`eLXg擾(ASCII)	
UI		CAjxG3d::GetText		(UI key, BCP pBuf, UI lBuf)
{
	return AjcG3dGetTextA		(m_hCtrl, key, pBuf, lBuf);
}
//	`eLXg擾(UNICODE)
UI		CAjxG3d::GetText		(UI key, WCP pBuf, UI lBuf)
{
	return AjcG3dGetTextW		(m_hCtrl, key, pBuf, lBuf);
}
//	}``f[^NA[
BOOL	CAjxG3d::ClearShape		(UI id)
{
	return AjcG3dClearShape		(m_hCtrl, id);
}
//	SĂ̐}``f[^NA[
BOOL	CAjxG3d::ClearShape		()
{
	return AjcG3dClearAllShape	(m_hCtrl);
}
//	vbgf[^NA[
BOOL	CAjxG3d::ClearPlot		(UI id)
{
	return AjcG3dClearPlot		(m_hCtrl, id);
}
//	SẴvbgf[^NA[
BOOL	CAjxG3d::ClearPlot		()
{
	return AjcG3dClearAllPlot	(m_hCtrl);
}
//	`eLXgNA[
BOOL	CAjxG3d::ClearText		(UI key)
{
	return AjcG3dClearText		(m_hCtrl, key);
}
//	 SĂ̕`eLXgNA[
BOOL	CAjxG3d::ClearText		()
{
	return AjcG3dClearAllText	(m_hCtrl);
}

//----- ʕ`t@NViQc^Rcʁj -------------------------------------------------------//
//	ʂɃsNZ`
BOOL	CAjxG3d::Pixel 			(UI id, double x, double y, UI PixelSize)
{
	return AjcG2dPixel			(m_hCtrl, id, x, y, PixelSize);
}
//	ʂɃsNZ`ixNgwj
BOOL	CAjxG3d::Pixel 			(UI id, PCAJC2DVEC pPoint, UI PixelSize)
{
	return AjcG2dPixelV			(m_hCtrl, id, pPoint, PixelSize);
}
//	ʂɃC`
BOOL	CAjxG3d::Line			(UI id, double x1, double y1, double x2, double y2)
{
	return AjcG2dLine			(m_hCtrl, id, x1, y1, x2, y2);
}
//	ʂɃC`ixNgwj
BOOL	CAjxG3d::Line			(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2)
{
	return AjcG2dLineV			(m_hCtrl, id, p1, p2);
}
//	ʂɕ`悷郉C^̎n_ݒ
BOOL	CAjxG3d::MoveTo			(UI id, double x, double y)
{
	return AjcG2dMoveTo			(m_hCtrl, id, x, y);
}
//	ʂɕ`悷郉C^̎n_ݒixNgwj
BOOL	CAjxG3d::MoveTo			(UI id, PCAJC2DVEC ps)
{
	return AjcG2dMoveToV		(m_hCtrl, id, ps);
}
//	I_w肵ʂɃC`
BOOL	CAjxG3d::LineTo			(UI id, double x, double y)
{
	return AjcG2dLineTo			(m_hCtrl, id, x, y);
}
//	I_w肵ʂɃC`ixNgwj
BOOL	CAjxG3d::LineTo			(UI id, PCAJC2DVEC pe)
{
	return AjcG2dLineToV		(m_hCtrl, id, pe);
}
//	ʂɖ`
BOOL	CAjxG3d::Arrow			(UI id, double x1, double y1, double x2, double y2)
{
	return AjcG2dArrow			(m_hCtrl, id, x1, y1, x2, y2);
}
//	ʂɖ`ixNgwj
BOOL	CAjxG3d::Arrow			(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2)
{
	return AjcG2dArrowV			(m_hCtrl, id, p1, p2);
}
//	I_w肵ʂɖ`
BOOL	CAjxG3d::ArrowTo		(UI id, double x, double y)
{
	return AjcG2dArrowTo		(m_hCtrl, id, x, y);
}
//	I_w肵ʂɖ`ixNgwj
BOOL	CAjxG3d::ArrowTo		(UI id, PCAJC2DVEC pe)
{
	return AjcG2dArrowToV		(m_hCtrl, id, pe);
}
//	ʂɎOp``
BOOL	CAjxG3d::Triangle		(UI id, double x1, double y1, double x2, double y2, double x3, double y3)
{
	return AjcG2dTriangle		(m_hCtrl, id, x1, y1, x2, y2, x3, y3);
}
//	ʂɎOp``ixNgwj
BOOL	CAjxG3d::Triangle		(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2, PCAJC2DVEC p3)
{
	return AjcG2dTriangleV		(m_hCtrl, id, p1, p2, p3);
}
//	ʂɎlp``
BOOL	CAjxG3d::Square			(UI id, double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4)
{
	return AjcG2dSquare			(m_hCtrl, id, x1, y1, x2, y2, x3, y3, x4, y4);
}
//	ʂɎlp``ixNgwj
BOOL	CAjxG3d::Square			(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2, PCAJC2DVEC p3, PCAJC2DVEC p4)
{
	return AjcG2dSquareV		(m_hCtrl, id, p1, p2, p3, p4);
}
//	ʂɒ``
BOOL	CAjxG3d::Rectangle		(UI id, double x1, double y1, double x2, double y2)
{
	return AjcG2dRectangle		(m_hCtrl, id, x1, y1, x2, y2);
}
//	ʂɒ``ixNgwj
BOOL	CAjxG3d::Rectangle		(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2)
{
	return AjcG2dRectangleV		(m_hCtrl, id, p1, p2);
}
//	ʂɉ~^ȉ~`
BOOL	CAjxG3d::Ellipse		(UI id, double xc, double yc, double rx, double ry)
{
	return AjcG2dEllipse		(m_hCtrl, id, xc, yc, rx, ry);
}
//	ʂɉ~^ȉ~`ixNgwj
BOOL	CAjxG3d::Ellipse		(UI id, PCAJC2DVEC pCent, double rx, double ry)
{
	return AjcG2dEllipseV		(m_hCtrl, id, pCent, rx, ry);
}
//	ʂɐ``
BOOL	CAjxG3d::Star			(UI id, double xc, double yc, double r1, double r2, UI nVtx, double rot, BOOL fInLine)
{
	return AjcG2dStarEx			(m_hCtrl, id, xc, yc, r1, r2, nVtx, rot, fInLine);
}
//	ʂɐ``ixNgwj
BOOL	CAjxG3d::Star			(UI id, PCAJC2DVEC pCent    , double r1, double r2, UI nVtx, double rot, BOOL fInLine)
{
	return AjcG2dStarVEx		(m_hCtrl, id, pCent , r1, r2, nVtx, rot, fInLine);
}
//----- Qc^Rcʃt@NV -------------------------------------------------------------------//
//	ENbNɂ|bvAbvj[̋^֎~
BOOL	CAjxG3d::EnablePopupMenu	(BOOL fEnable)
{
	return AjcG3dEnablePopupMenu	(m_hCtrl, fEnable);
}
//	ENbNʒmݒ
BOOL	CAjxG3d::SetNtcRClk			(BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp)
{
	return	AjcG3dSetNtcRClk		(m_hCtrl, fNtcRClk, MsgRBDown, MsgRBUp);
}
//	c[`bv̐ݒ(ASCII)
BOOL	CAjxG3d::SetTipText			(C_BCP pTxt)
{
	return	AjcG3dSetTipTextA		(m_hCtrl, pTxt);
}
//	c[`bv̐ݒ(UNICODE)
BOOL	CAjxG3d::SetTipText			(C_WCP pTxt)
{
	return	AjcG3dSetTipTextW		(m_hCtrl, pTxt);
}
//	c[`bv̎擾(ASCII)
UI		CAjxG3d::GetTipText			(BCP pBuf, UI lBuf)
{
	return	AjcG3dGetTipTextA		(m_hCtrl, pBuf, lBuf);
}
//	c[`bv̎擾(UNICODE)
UI		CAjxG3d::GetTipText			(WCP pBuf, UI lBuf)
{
	return	AjcG3dGetTipTextW		(m_hCtrl, pBuf, lBuf);
}
//	tB^E`FbN{bNXEc[`bv̐ݒ(ASCII)
BOOL	CAjxG3d::SetChkBoxTipText	(UI n, C_BCP pTxt)
{
	return	AjcG3dSetChkBoxTipTextA	(m_hCtrl, n, pTxt);
}
//	tB^E`FbN{bNXEc[`bv̐ݒ(UNICODE)
BOOL	CAjxG3d::SetChkBoxTipText	(UI n, C_WCP pTxt)
{
	return	AjcG3dSetChkBoxTipTextW	(m_hCtrl, n, pTxt);
}
//	tB^E`FbN{bNXEc[`bv̎擾(ASCII)
UI		CAjxG3d::GetChkBoxTipText	(UI n, BCP pBuf, UI lBuf)
{
	return	AjcG3dGetChkBoxTipTextA	(m_hCtrl, n, pBuf, lBuf);
}
//	tB^E`FbN{bNXEc[`bv̎擾(UNICODE)
UI		CAjxG3d::GetChkBoxTipText	(UI n, WCP pBuf, UI lBuf)
{
	return	AjcG3dGetChkBoxTipTextW	(m_hCtrl, n, pBuf, lBuf);
}
//	c[`bv\̐ݒ
BOOL	CAjxG3d::SetTipShowAlways	(BOOL fShowAlways)
{
	return	AjcG3dSetTipShowAlways	(m_hCtrl, fShowAlways);
}
//	c[`bv\̎擾
BOOL	CAjxG3d::GetTipShowAlways	()
{
	return	AjcG3dGetTipShowAlways	(m_hCtrl);
}
//	tB^E`FbN{bNXEc[`bv̐ݒ
BOOL	CAjxG3d::SetChkBoxTipShowAlways(UI n, BOOL fShowAlways)
{
	return	AjcG3dSetChkBoxTipShowAlways(m_hCtrl, n, fShowAlways);
}
//	tB^E`FbN{bNXEc[`bv̎擾
BOOL	CAjxG3d::GetChkBoxTipShowAlways(UI n)
{
	return	AjcG3dGetChkBoxTipShowAlways(m_hCtrl, n);
}
//	Sc[`bv\̐ݒ
BOOL	CAjxG3d::SetTipShowAlwaysAll(BOOL fShowAlways)
{
	return	AjcG3dSetTipShowAlwaysAll(m_hCtrl, fShowAlways);
}
//	tB^̐ݒ
BOOL	CAjxG3d::SetFilter 		(UI n, BOOL state)
{
	return	AjcG3dSetFilter		(m_hCtrl, n, state);
}
//	tB^̎擾
BOOL	CAjxG3d::GetFilter 		(UI n)
{
	return	AjcG3dGetFilter		(m_hCtrl, n);
}
//	hbvꂽt@C擾(ASCII)
BOOL	CAjxG3d::GetDroppedFile	(BC buf[MAX_PATH])
{
	return	AjcG3dGetDroppedFileA(m_hCtrl, buf);
}
//	hbvꂽt@C擾(UNICODE)
BOOL	CAjxG3d::GetDroppedFile (WC buf[MAX_PATH])
{
	return	AjcG3dGetDroppedFileW(m_hCtrl, buf);
}
//	hbvꂽfBNg擾(ASCII)
BOOL	CAjxG3d::GetDroppedDir		(BC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	return	AjcG3dGetDroppedDirExA(m_hCtrl, buf, fTailIsDelimiter);
}
//	hbvꂽfBNg擾(UNICODE)
BOOL	CAjxG3d::GetDroppedDir	(WC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	return	AjcG3dGetDroppedDirExW(m_hCtrl, buf, fTailIsDelimiter);
}
//	^Cg̐ݒ(ASCII)
BOOL	CAjxG3d::SetTitleText	(C_BCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont)	
{
	return	AjcG3dSetTitleTextA	(m_hCtrl, pTitleText, TextColor, BackColor, hFont);
}
//	^Cg̐ݒ(UNICODE)
BOOL	CAjxG3d::SetTitleText		(C_WCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont)	
{
	return	AjcG3dSetTitleTextW	(m_hCtrl, pTitleText, TextColor, BackColor, hFont);
}
//	ʕ\̒~^ĊJ
BOOL	CAjxG3d::Pause				(BOOL fPause)
{
	return	AjcG3dPause			(m_hCtrl, fPause);
}
//	`掞Ԍv̋^֎~
BOOL	CAjxG3d::EnableMesDraw		(BOOL fEnable)
{
	return	AjcG3dEnableMesDraw	(m_hCtrl, fEnable);
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	z֐																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- A^b`@----------------------------------------------------------------------------------------------//
VO		CAjxG3d::Attach(HWND hwnd)
{
	HWND	hParent;
	BC		cname[256];

	m_hCtrl   = NULL;

	if (::IsWindow(hwnd)) {
		::GetClassNameA(hwnd, cname, sizeof cname);
		if (::strcmp(cname, "AjcCtrl3dGraph") == 0) {
			//	[N
			m_hCtrl = hwnd;
			hParent = ::GetParent(hwnd);
			//	Rg[ this |C^֘At
			::SetPropA(m_hCtrl, PROP_NAME_CTRL, (HANDLE)this);
			//	eEChTuNXidTuNX}~j
			if (::GetPropA(hParent, PROP_NAME_PARENT) == NULL) {
				MAjcMmpSetSubclass(SBC_G3D, hParent);
				::SetPropA(hParent, PROP_NAME_PARENT, (HANDLE)this);
			}
		}
		else throw std::runtime_error("G3D cannot be generated due to an invalid window class.");
	}
	else throw std::runtime_error("G3D cannot be generated due to an invalid window handle.");
}
//----- _px(_xNg)ʒm -----------------------------------------------------------------------------//
VO		CAjxG3d::OnNtcRotTheta(PCAJC3DVEC pVec)
{
}
//----- vbgXgʒm -------------------------------------------------------------------------------------//
VO		CAjxG3d::OnNtcPlotList(PCAJC3DGPLOTLIST pList)
{
}
//----- f[^NA[ʒm -------------------------------------------------------------------------------------//
VO		CAjxG3d::OnNtcClear(int Factor)
{
}
//----- _uNbNʒm -------------------------------------------------------------------------------------//
VO		CAjxG3d::OnNtcDblClk()
{
}
//----- t@Chbvʒm -----------------------------------------------------------------------------------//
VO		CAjxG3d::OnNtcDropFile(UI n)
{
}
//----- tH_hbvʒm -----------------------------------------------------------------------------------//
VO		CAjxG3d::OnNtcDropDir (UI n)
{
}
//----- ENbNʒm -----------------------------------------------------------------------------------------//
VO		CAjxG3d::OnNtcRClick(PCAJC3DGRCLK pRClk)
{
}

