#include	<AjxCpp.h>

using namespace AjxControl;


//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNiCxgʒmj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO CALLBACK cbNotice(UI knd, UX Param, UX cbp)
{
	CAjxXym*	p = (CAjxXym*)cbp;
	return p->OnNotice(knd, Param);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNit@C擾vj																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static VO CALLBACK cbGetFileA(PAJCXYMFILEINFOA pBuf, UX cbp)
{
	CAjxXym*	p = (CAjxXym*)cbp;
	p->OnGetFile(pBuf);
}
//----- Ch ---------------------------------------------------------------------------------------------//
static VO CALLBACK cbGetFileW(PAJCXYMFILEINFOW pBuf, UX cbp)
{
	CAjxXym*	p = (CAjxXym*)cbp;
	p->OnGetFile(pBuf);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNit@Cf[^擾vj																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbGetData(VOP pBuf, UI len, UIP pBytes, UX cbp)
{
	CAjxXym*	p = (CAjxXym*)cbp;
	p->OnGetData(pBuf, len, pBytes);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNif[^ovj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static VO  CALLBACK cbSend(C_VOP pTxD, UI len, UX cbp)
{
	CAjxXym*	p = (CAjxXym*)cbp;
	p->OnSend(pTxD, len);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxXym::CAjxXym(BOOL fUnicode) 
{
	m_fUnicode = fUnicode;

	if (fUnicode) {		//	For UNICODE
		m_hXym = AjcXymCreateW((UX)this, cbNotice, cbGetFileW, cbGetData, cbSend);
	}
	else {				//	For ASCII
		m_hXym = AjcXymCreateA((UX)this, cbNotice, cbGetFileA, cbGetData, cbSend);
	}

	if (m_hXym == NULL) {
		throw std::runtime_error("XYM cannot creation.");
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxXym::~CAjxXym()
{
	if (m_hXym != NULL) {
		AjcXymDelete(m_hXym);
		m_hXym = NULL;
	}
}

//----- o֐ ---------------------------------------------------------------------------------------------//
//	M^C}擾
VO		CAjxXym::GetTxTimeInfo	(UIP t0, UIP r0, UIP t1, UIP r1)
{
	AjcXymGetTxTimeInfo(m_hXym, t0, r0, t1, r1);
}
//	M^C}ݒ
VO		CAjxXym::SetTxTimeInfo	(UI  t0, UI  r0, UI  t1, UI  r1)
{
	AjcXymSetTxTimeInfo(m_hXym, t0, r0, t1, r1);
}
//	M^C}擾
VO		CAjxXym::GetRxTimeInfo	(UIP t0, UIP r0, UIP t1, UIP r1)
{
	AjcXymGetRxTimeInfo(m_hXym, t0, r0, t1, r1);
}
//	M^C}ݒ
VO		CAjxXym::SetRxTimeInfo	(UI  t0, UI  r0, UI  t1, UI  r1)
{
	AjcXymSetRxTimeInfo(m_hXym, t0, r0, t1, r1);
}

//	t@CMJn
BOOL	CAjxXym::TxStart		(AJCXYMPROTOCOL Protocol)
{
	return AjcXymTxStart(m_hXym, Protocol);
}
//	t@CMJn
BOOL	CAjxXym::RxStart		(AJCXYMPROTOCOL Protocol)
{
	return AjcXymRxStart(m_hXym, Protocol);
}
//	t@C]~
VO		CAjxXym::Stop		()
{
	AjcXymStop(m_hXym);
}
//	VA̎Mf[^^
VO		CAjxXym::PutRxChar	(UI rxd)
{
	AjcXymPutRxChar(m_hXym, rxd);
}
//	VAւ̑Mʒmixlncdl|fpj
VO		CAjxXym::TxEnd		()
{
	AjcXymTxEnd(m_hXym);
}
//----- z֐ -----------------------------------------------------------------------------------------------//
//	Cxgʒm
VO		CAjxXym::OnNotice	(UI knd, UX Param				)
{
}
//	t@C擾v(ASCII)
VO		CAjxXym::OnGetFile	(PAJCXYMFILEINFOA pBuf			)
{
}
//	t@C擾v(UNICODE)
VO		CAjxXym::OnGetFile	(PAJCXYMFILEINFOW pBuf			)
{
}
//	t@Cf[^擾v
VO		CAjxXym::OnGetData	(VOP pBuf, UI lBuf, UIP pBytes	)
{
}
//	f[^ov
VO		CAjxXym::OnSend		(C_VOP pTxD, UI lTxD			)
{
}
