//
//	SW_3DGraphic1.c
//

#include	<AjrCstXX.h>
#include	<math.h>
#include	<tchar.h>
#include	"resource.h"

//--------------------------------------------------------------------------------------------------------------//
//	^C}hc																									//
//--------------------------------------------------------------------------------------------------------------//
#define		TID_PLOT_PERIOD		1		//	vbgf[^

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;							//	ckkCX^Xnh
static	HWND			hDlgMain;						//	_CAO{bNXnh
static	SIZE			szDlg;							//	_CAO̍ŏTCY
static	HWND			hWndG3d;						//	RcOtRg[̃EChnh
static	HWND			hWndVth;						//	O\Rg[̃EChnh
static	BOOL			fPlot = FALSE;					//	vbgtO
static	RECT			rcG3d, rcVth;					//	̃ECh`
static	BOOL			fTest1 = FALSE;
static	BOOL			fTest2 = FALSE;
static	BOOL			fTest3 = FALSE;

//	̒SƔa
#define		CX		0.2
#define		CY		0.4
#define		CZ		0.1
#define		R		2.0

//	`Fhc
#define		ID_PLOT1		0		//	vbg_P
#define		ID_PLOT2		1		//	vbg_Q
#define		ID_BALL			3		//	Zo
#define		ID_INS1			4		//	̓ډ~P
#define		ID_INS2			12		//	̓ډ~Q

#define		ID_TRACK1		8		//	O~P
#define		ID_TRACK2		9		//	O~Q

#define		ID_2DGRID		6		//	Qc
#define		ID_2DSHAPE		7		//	Qc}`
#define		ID_3DSHAPE		5		//	Qc}`
#define		ID_TXTPOINT		1		//	eLXg`|Cg

//	vbg_Zp^
static	AJCSPD_PARAM	prm[2] = {
//		  vCent 	   radius  noise  xrot	yrot  pitch
		{{CX, CY, CZ}, R,	   3.0,   0.5,	0.8,  9.0},
		{{CX, CY, CZ}, R,	   3.0,   0.6,	0.7,  8.5},
};
//	vbg_ZCX^Xnh
HAJCSPD		hSpd[2] = {NULL};


//	vbgf[^Wobt@
#define	MAX_PLOT	4
typedef struct {
	UI			id1, id2, id3;							//	`Fhc
	double		dist;									//	vbgԂ̍Œ዗
	UI			num;									//	vbgW
	UI			cnt;									//	vbgf[^JE^
	AJC3DVEC	plt[MAX_PLOT];							//	vbg_Wobt@
	AJC3DVEC	cent;									//	S
	double		radius;									//	a
	AJC3DVEC	vec;									//	@
} PLOTINFO, *PPLOTINFO;

//	Zopvbgobt@
//									   id1		  id2		id3 	  dist		 num
static	PLOTINFO	PltBall		=	 { ID_INS1	, ID_INS2,	ID_BALL,  R * 0.6,	 4	 };

//	O~Zopvbgobt@
//									   id1		  id2		id3 	  dist		 num
static	PLOTINFO	PltCir[2]	=	{{ ID_TRACK1, 0 	 ,	0	   ,  R * 0.4,	 3	 },
									 { ID_TRACK2, 0 	 ,	0	   ,  R * 0.4,	 3	 }};

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);

static	VO		SetControlSize(HWND hDlg);
static	C_UTP	CALLBACK cbGetTipText(HWND hCtrl, UTP pBuf, UI lBuf, UX cbp);
static	VO		BallCorrectAndShow(PCAJC3DVEC pVec, PPLOTINFO pBuf);
static	VO		CirCorrectAndShow (PCAJC3DVEC pVec, PPLOTINFO pBuf);
static	VO		DrawInscribedCircle(PCAJC3DCIRINFO pCif, int id);
static	VO		SetStyleToCheckBox(VO);
static	VO		SetCheckBoxToStyle(VO);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;
	RECT	rect;

	hInst = hInstance;

	//----- CE_CAOI[v -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DLGMAIN), NULL, AJC_DLGPROC_NAME(Main));
	//----- EChŏTCYޔ ---------------------//
	GetWindowRect(hDlgMain, &rect);
	szDlg.cx = rect.right - rect.left;
	szDlg.cy = rect.bottom - rect.top;
	//----- _CAO\ -----------------------------//
	ShowWindow(hDlgMain, SW_SHOW);

	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	hDlgMain = hDlg;
	hWndG3d = GetDlgItem(hDlgMain, IDC_3DGRAPH);
	hWndVth = GetDlgItem(hDlgMain, IDC_VTH_LOG);
	//----- X^C`FbN{bNX̃c[`bvݒ -----------//
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_NODEPTHCTRL) , TEXT("ߕ\i_̎Oƌ̐Fj֎~")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_NOFILTER   ) , TEXT("f[^\^\p`FbN{bNX\")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_NOBORDER   ) , TEXT("Og\")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_NOANGLE	  ) , TEXT("hbOɂ]֎~")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_AXIS_X	  ) , TEXT("w\")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_AXIS_Y	  ) , TEXT("x\")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_AXIS_Z	  ) , TEXT("y\")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_RECTSCALE  ) , TEXT("XP[\i\ʂSCALE_XY/XZ/YZŎwj")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_ELPSSCALE  ) , TEXT("S~XP[\i\ʂSCALE_XY/XZ/YZŎwj")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_SPHERESCALE) , TEXT("̃XP[\")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_SCALE_XY   ) , TEXT("wxʂɃXP[\iXP[RECTSCALE, ELPSSCALEŎwj")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_SCALE_XZ   ) , TEXT("wyʂɃXP[\iXP[RECTSCALE, ELPSSCALEŎwj")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_SCALE_YZ   ) , TEXT("xyʂɃXP[\iXP[RECTSCALE, ELPSSCALEŎwj")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_VAL_X	  ) , TEXT("w̒l\")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_VAL_Y	  ) , TEXT("x̒l\")); 
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_CHK_VAL_Z	  ) , TEXT("y̒l\")); 
	//----- tB^`FbN{bNX̃c[`bvݒ -----------//
	AjcG3dSetChkBoxTipText(hWndG3d, ID_PLOT1 , TEXT("vbg_P")); 
	AjcG3dSetChkBoxTipText(hWndG3d, ID_PLOT2 , TEXT("vbg_Q")); 
	AjcG3dSetChkBoxTipText(hWndG3d, ID_BALL  , TEXT("Zo"  )); 
	AjcG3dSetChkBoxTipText(hWndG3d, ID_INS1  , TEXT("̓ډ~P")); 
	AjcG3dSetChkBoxTipText(hWndG3d, ID_INS2  , TEXT("̓ډ~Q")); 
	AjcG3dSetChkBoxTipText(hWndG3d, ID_TRACK1, TEXT("O~P"	  )); 
	AjcG3dSetChkBoxTipText(hWndG3d, ID_TRACK2, TEXT("O~Q"	  )); 
	//----- ̃ECh`ݒ -------------------------------//
	GetWindowRect(hWndG3d, &rcG3d); MapWindowPoints(NULL, hDlg, (LPPOINT)&rcG3d, 2);
	GetWindowRect(hWndVth, &rcVth); MapWindowPoints(NULL, hDlg, (LPPOINT)&rcVth, 2);
	SetControlSize(hDlg);
	//----- `bveLXg\ݒi󋵈ˑŋ\j--------//
	AjcTipTextAddEx(hWndG3d, TEXT(""), -1, -1, NULL, -1, -1, -1);
	AjcTipTextSetCallBack(hWndG3d, 0, NULL, cbGetTipText);
	//----- ^Cgݒ -----------------------------------------//
	AjcG3dSetTitleText(hWndG3d, TEXT(" {̋S=(0.2, 0.4, 0.1), a=2.0 "), -1, -1, NULL);
	//----- RcOt[hݒ ---------------------------------//
	AjcG3dInitV(hWndG3d, NULL, NULL, NULL, (AJC3DGS_AXIS | AJC3DGS_SCALEVALUE));
	//----- vbgf[^Z -----------------------------//
	hSpd[0] = AjcSpdCreate(0);
	hSpd[1] = AjcSpdCreate(0);
	//----- EChX^Cl`FbN{bNXɐݒ -----------//
	SetStyleToCheckBox();
	//----- vbg -------------------------------------//
	AjcSetDlgItemUInt(hDlg, IDC_INP_PLOTNUM0, 100);
	AjcSetDlgItemUInt(hDlg, IDC_INP_PLOTNUM1, 100);
	//----- ݒl[h -----------------------------------------//
	AjcDlgItemSetPermAtt(hDlg, IDC_TXT_3DGRAPH, AJCCTL_PSEL_EXCLUDE); // GetText͏O
	AjcLoadAllControlSettings(hDlg, TEXT("Settings"), AJCOPT2(AJCCTL_SELACT_, CHKEXCLUDE, NTCINP));
	//	`FbN{bNXX^Cݒ
	SetCheckBoxToStyle();
	//	vbg``FbN{bNXf
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CHK_PLOTLINE, BN_CLICKED), (WPARAM)hDlg);
	//----- OtWݒ -------------------------------------//
	AjcG3dSetCenter(hWndG3d, CX, CY, CZ);
	AjcG3dSetWidth (hWndG3d, R, R, R);
	//----- _RcC[W̃AOɐݒ -------------------//
	AjcG3dSetAngle3D(hWndG3d);

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	//----- ݒlZ[u -----------------------------------------//
	AjcSaveAllControlSettings(hDlg);
	AjcDelAllCtrlPermAtt(hDlg); // \[X 
	//----- vbgf[^ZI -------------------------------//
	AjcSpdDelete(hSpd[0]);
	AjcSpdDelete(hSpd[1]);
	//----- vOI ---------------------------------------//
	PostQuitMessage(0);
	return TRUE;
}
//----- TCYύX -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_SIZING			)
{
	LPRECT	pRect = (LPRECT)lParam;
	SIZE	sz;

	sz.cx = pRect->right - pRect->left;
	sz.cy = pRect->bottom - pRect->top;
	
	if (sz.cx < szDlg.cx) pRect->right	= pRect->left + szDlg.cx;
	if (sz.cy < szDlg.cy) pRect->bottom = pRect->top  + szDlg.cy;

	return TRUE;
}
//----- TCYύX ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_SIZE			)
{
	SetControlSize(hDlg);

	return TRUE;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	VO		SetControlSize(HWND hDlg)
{
	RECT	r;
	int		w, h;

	GetClientRect(hDlg, &r);
	w = r.right - r.left;
	h = r.bottom - r.top;
	MoveWindow(hWndG3d, rcG3d.left, 0		 , w - rcG3d.left - 4	   , h			   - 4, FALSE);
	MoveWindow(hWndVth, rcVth.left, rcVth.top, rcVth.right - rcVth.left, h - rcVth.top - 4, FALSE);
	InvalidateRect(hDlg, NULL, TRUE);
}
//----- COMMAND ------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_COMMAND		)
{
	BOOL		rc = FALSE;
	int 		cmd = LOWORD(wParam);
	UI			ix;
	AJC3DGPROP	prop;

	//----- X^Cݒ`FbN{bNX -------------------------------------------------//
	if (cmd >= IDC_CHK_RECTSCALE && cmd <= IDC_CHK_AXIS_Z && HIWORD(wParam) == BN_CLICKED) {
		//	`FbN{bNX̓eX^Cɔf
		SetCheckBoxToStyle();
		rc = TRUE;
	}
	//----- vbgݒ葀 -----------------------------------------------------------------//
	if (cmd >= IDC_INP_PLOTNUM0 && cmd <= IDC_INP_PLOTNUM1 && HIWORD(wParam) == AJCIVN_INTVALUE) {
		ix = cmd - IDC_INP_PLOTNUM0;
		AjcG3dGetProp(hWndG3d, &prop);
		prop.Item[ix].MaxPlot = (UI)lParam;
		AjcG3dSetProp(hWndG3d, &prop);
		rc = TRUE;
	}

	return rc;
}
//----- WM_TIMER -----------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_TIMER		)
{
	UI			id;
	AJC3DVEC	v[2];

	switch (wParam) {
		case TID_PLOT_PERIOD:						//	vbgf[^
			for (id = 0; id < 2; id++) {
				//	_ȃvbgf[^
				AjcSpdCalcV(hSpd[id], &v[id]);
				//	vbgf[^^
				AjcG3dPutPlotDataV(hWndG3d, id, &v[id]);
				//	f[^WƎZo̕\
				BallCorrectAndShow(&v[id], &PltBall);
				//	O~f[^WƎZoO~̕\
				CirCorrectAndShow (&v[id], &PltCir[id]);
			}
			//	O\
			AjcVthTimeStamp(hWndVth);
			AjcVthPrintF(hWndVth, TEXT(": x1=%6.2f, y1=%6.2f, z1=%6.2f | x2=%6.2f, y2=%6.2f, z2=%6.2f\n"),
																 v[0].x, v[0].y, v[0].z, v[1].x, v[1].y, v[1].z);
			break;
	}
	return TRUE;
}
//----- vbgCE`FbN{bNX -----------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CHK_PLOTLINE)
{
	AJC3DGPROP	prop;

	if (HIWORD(wParam) == BN_CLICKED) {
		AjcG3dGetProp(hWndG3d, &prop);
		prop.fPlotLine = AjcGetDlgItemChk(hDlg, IDC_CHK_PLOTLINE);
		AjcG3dSetProp(hWndG3d, &prop);
	}
	return TRUE;
}
//----- TvO -----------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_INP_PERIOD)
{
	if (HIWORD(wParam) == AJCIVN_INTVALUE) {
		if (fPlot) {
			SetTimer(hDlgMain, TID_PLOT_PERIOD, AjcGetDlgItemUInt(hDlg, IDC_INP_PERIOD), NULL);
		}
	}
	return TRUE;
}
//----- mCYĺiAjcLoadAllControlSettings()ŁAAJCCTL_SELACT_NTCINP ẅׁAɂsj----//
AJC_DLGPROC(Main, IDC_INP_NOISE	)
{
	if (HIWORD(wParam) == AJCIVN_REALVALUE) {
		prm[0].noise = prm[1].noise = *((double *)lParam);
		AjcSpdSetParam(hSpd[0], &prm[0]);
		AjcSpdSetParam(hSpd[1], &prm[1]);
	}
	return TRUE;
}
//----- vbgJn^~{^ -------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_START_STOP)
{
	if (fPlot) {
		fPlot = FALSE;
		KillTimer(hDlg, TID_PLOT_PERIOD);
		AjcSetDlgItemStr(hDlg, IDC_CMD_START_STOP, TEXT("vbgJn"));
	}
	else {
		fPlot = TRUE;
		SetTimer(hDlgMain, TID_PLOT_PERIOD, AjcGetDlgItemUInt(hDlg, IDC_INP_PERIOD), NULL);
		AjcSetDlgItemStr(hDlg, IDC_CMD_START_STOP, TEXT("vbg~"));
	}
	return TRUE;
}
//----- eXgP{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_TEST1 	)
{

	if (!fTest1) {
		AjcG3dCube	   (hWndG3d, ID_3DSHAPE, +0.1, +0.2, +0.3,	0.2, 0.3, 0.4, 8);
		AjcG3dSphere   (hWndG3d, ID_3DSHAPE, +0.7, +0.6, +0.8,	0.2, 0.3, 0.4, 12, 8);
		AjcG3dMoveTo   (hWndG3d, ID_3DSHAPE, -0.6,	0.2,  0.3);
		AjcG3dLineTo   (hWndG3d, ID_3DSHAPE, -0.3, -0.2, -0.1);
		AjcG3dTriangle (hWndG3d, ID_3DSHAPE, -0.8, -0.7, -0.6,	-0.4, -0.3, -0.5,  -0.4, -0.5, -0.3);
		AjcG3dSquare   (hWndG3d, ID_3DSHAPE,  0.0, -0.1,  0.6,	-0.2, -0.5,  0.6,  -0.7, -0.5,	0.3, -0.6,-0.3, 0.1);
		fTest1 = TRUE;
	}
	else {
		AjcG3dClearShape(hWndG3d, ID_3DSHAPE);
		fTest1 = FALSE;
	}
	return TRUE;
}
//----- eXgQ{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_TEST2 	)
{
	UI		idAll = -1;
	double	x, y;

	if (!fTest2) {
		AjcG3dDefPlane(hWndG3d, idAll, 0.2, 0.1, 0.0,	0.6738, -0.5510, 0.4924,  0.1, 0.0, 0.0);
		AjcG2dRectangle(hWndG3d, ID_2DGRID, -0.9, -0.9,  +0.9, +0.9);
		for (x = -0.8; x < -0.01; x += 0.2) AjcG2dLine(hWndG3d, ID_2DGRID, x, -0.9, x, +0.9);
		for (x =  0.2; x <	0.89; x += 0.2) AjcG2dLine(hWndG3d, ID_2DGRID, x, -0.9, x, +0.9);
		for (y = -0.8; y < -0.01; y += 0.2) AjcG2dLine(hWndG3d, ID_2DGRID, -0.9, y, +0.9, y);
		for (y =  0.2; y <	0.89; y += 0.2) AjcG2dLine(hWndG3d, ID_2DGRID, -0.9, y, +0.9, y);
		AjcG2dLine	  (hWndG3d, ID_2DSHAPE, -0.9,  0.0,	+0.9,	0.0);
		AjcG2dLine	  (hWndG3d, ID_2DSHAPE,	0.0, -0.9,	 0.0, +0.9);
		AjcG2dTriangle(hWndG3d, ID_2DSHAPE, -0.6, -0.7,	-0.3, -0.3,  -0.1, -0.7);
		AjcG2dSquare  (hWndG3d, ID_2DSHAPE,	0.2,  0.3,	0.4, 0.7,	0.9, 0.7,  0.7, 0.3);
		AjcG2dPixel   (hWndG3d, ID_2DSHAPE,	0.3, -0.5,	2);
		AjcG2dEllipse (hWndG3d, ID_2DSHAPE,	0.3, -0.5,	0.4, 0.3);
		AjcG2dPixel   (hWndG3d, ID_2DSHAPE, 0.6, 0.8, 3);
		fTest2 = TRUE;
	}
	else {
		AjcG3dClearShape(hWndG3d, ID_2DGRID);
		AjcG3dClearShape(hWndG3d, ID_2DSHAPE);
		fTest2 = FALSE;
	}
	return TRUE;
}
//----- eXgR{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_TEST3 	)
{
	AJC3DVEC	v = {1, 1, 1};

	if (!fTest3) {
		AjcG3dPixelV  (hWndG3d, ID_TXTPOINT, &v, 3);
		AjcG3dTextOutV(hWndG3d, AJCG3DTXOMD_BELLOW_CENTER, &v, TEXT("\x1B[1;31m        \n(1, 1, 1)"));
		fTest3 = TRUE;
	}
	else {
		AjcG3dClearShape(hWndG3d, ID_TXTPOINT);
		AjcG3dClearAllText(hWndG3d);
		fTest3 = FALSE;
	}
	return TRUE;
}
//----- NA[{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_CLEAR 	)
{
	AjcG3dClear(hWndG3d);
	fTest1 = fTest2 = fTest3 = FALSE;
	return TRUE;
}
//----- GetText {^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_GETTEXT	)
{
	UT		txt[1024];

	GetWindowText(hWndG3d, txt, 1024);
	AjcSetDlgItemStr(hDlg, IDC_TXT_3DGRAPH, txt);
	return TRUE;
}
//----- SetText {^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SETTEXT	)
{
	UT		txt[1024];

	AjcGetDlgItemStr(hDlg, IDC_TXT_3DGRAPH, txt, 1024);
	SetWindowText(hWndG3d, txt);
	return TRUE;
}
//----- Enable {^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_ENABLE	)
{
	EnableWindow(hWndG3d, TRUE);
	return TRUE;
}
//----- Disable {^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_DISABLE	)
{
	EnableWindow(hWndG3d, FALSE);
	return TRUE;
}
//----- RcOtRg[ ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_3DGRAPH		)
{
	POINT	 pt;

	switch (HIWORD(wParam)) {
		case AJC3DGN_RCLICK:							//	ENbNʒm
		{	PAJC3DGRCLK	p = (PAJC3DGRCLK)lParam;
			UT			txt[64] = {0};
			AjcSnPrintF(txt, 64, TEXT("%s%sENbN(x = %d, y = %d)"), p->fShift ? TEXT("Shift+") : TEXT(""),
																			 p->fCtrl  ? TEXT("Ctrl+" ) : TEXT(""),
																			 p->x, p->y);
			GetCursorPos(&pt);
			AjcTipTextShow(pt.x, pt.y + 20, txt, 3000, NULL);
			break;
		}
		case AJC3DGN_DROPDIR:							//	fBNghbv
		{	UT		path[MAX_PATH];
			UT		txt[4096];
			MAjcStrCpy(txt, AJCTSIZE(txt), TEXT("-- Dir dropped --\n"));
			while (AjcG3dGetDroppedDir(hWndG3d, path)) {
				MAjcStrCat(txt, AJCTSIZE(txt), path);
				MAjcStrCat(txt, AJCTSIZE(txt), TEXT("\n"));
			}
			GetCursorPos(&pt);
			AjcTipTextShow(pt.x, pt.y + 20, txt, 3000, NULL);
			break;
		}
		case AJC3DGN_DROPFILE:							//	t@Chbv
		{	UT		path[MAX_PATH];
			UT		txt[4096];
			MAjcStrCpy(txt, AJCTSIZE(txt), TEXT("-- File dropped --\n"));
			while (AjcG3dGetDroppedFile(hWndG3d, path)) {
				MAjcStrCat(txt, AJCTSIZE(txt), path);
				MAjcStrCat(txt, AJCTSIZE(txt), TEXT("\n"));
			}
			GetCursorPos(&pt);
			AjcTipTextShow(pt.x, pt.y + 20, txt, 3000, NULL);
			break;
		}
		case AJC3DGN_PLOTLIST:							//	vbgXgʒm
		{	PCAJC3DGPLOTLIST p = (PCAJC3DGPLOTLIST)lParam;
			static UT txt[128];
			AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("x=%.2f, y=%.2f, z=%.2f"), p->lst[0].vec.x, p->lst[0].vec.y, p->lst[0].vec.z);
			GetCursorPos(&pt);
			AjcTipTextShow(pt.x, pt.y + 20, txt, 3000, NULL);
			break;
		}
	}
	return TRUE;
}
//----- uCancelv{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG	   )
	AJC_DLGMAP_MSG(Main, WM_SIZING		   )
	AJC_DLGMAP_MSG(Main, WM_SIZE		   )
	AJC_DLGMAP_MSG(Main, WM_DESTROY 	   )
	AJC_DLGMAP_MSG(Main, WM_COMMAND 	   )
	AJC_DLGMAP_MSG(Main, WM_TIMER		   )

	AJC_DLGMAP_CMD(Main, IDC_CHK_PLOTLINE  )
	AJC_DLGMAP_CMD(Main, IDC_INP_PERIOD	   )
	AJC_DLGMAP_CMD(Main, IDC_INP_NOISE	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_START_STOP)
	AJC_DLGMAP_CMD(Main, IDC_CMD_TEST1	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_TEST2	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_TEST3	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_CLEAR	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_GETTEXT   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_SETTEXT   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_ENABLE    )
	AJC_DLGMAP_CMD(Main, IDC_CMD_DISABLE   )
	AJC_DLGMAP_CMD(Main, IDC_3DGRAPH	   )
	AJC_DLGMAP_CMD(Main, IDCANCEL		   )
AJC_DLGMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	`bveLXgR[obN																					//
//--------------------------------------------------------------------------------------------------------------//
static	C_UTP	CALLBACK cbGetTipText(HWND hCtrl, UTP pBuf, UI lBuf, UX cbp)
{
	//	`bveLXgijݒ
	AjcSnPrintF(pBuf, lBuf,
					TEXT("ZoF\n")
					TEXT("  S = (%6.2f, %6.2f, %6.2f )\n")
					TEXT("  a =  %.2f"), PltBall.cent.x, PltBall.cent.y, PltBall.cent.z, PltBall.radius);
	return pBuf;
}
//--------------------------------------------------------------------------------------------------------------//
//	Zopvbg_̎Wƕ`																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO		BallCorrectAndShow(PCAJC3DVEC pVec, PPLOTINFO pBuf)
{
	UI		i;

	//	vbgԂ̍Œ዗`FbN
	for (i = 0; i < pBuf->cnt; i++) {
		if (AjcV3dDistP2P(pVec, &pBuf->plt[i]) < pBuf->dist) {
			break;
		}
	}
	//	vbg_̎W
	if (i >= pBuf->cnt) {
		memcpy(&pBuf->plt[i], pVec, sizeof(AJC3DVEC));
		pBuf->cnt++;
	}
	//	̎Zoƕ\
	if (pBuf->cnt >= pBuf->num) {
		AJC3DSPHINFO	sph;
		if ((pBuf->radius = AjcV3dCalcSphereVEx(&pBuf->plt[0], &pBuf->plt[1], &pBuf->plt[2], &pBuf->plt[3],
																					 &pBuf->cent, &sph)) != -1) {
			//	Q̕ʉ~̊px30xȏȂ΋`
			double t = AjcV3dTheta(&sph.cif1.lvc.v, &sph.cif2.lvc.v);
			if (t > 30 && t < 180 - 30) {
				//	Ő\NA[
				AjcG3dClearShape(hWndG3d, pBuf->id3);
				//	\
				AjcG3dSphereV(hWndG3d, pBuf->id3, &pBuf->cent, pBuf->radius, pBuf->radius, pBuf->radius, 8, 8);
				//	O̓ډ~\NA[
				AjcG3dClearShape(hWndG3d, pBuf->id1);
				AjcG3dClearShape(hWndG3d, pBuf->id2);
				//	Q̓ډ~`
				if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_BALLINFO)) {
					//	S_`
					AjcG3dPixelV(hWndG3d, pBuf->id1, &pBuf->cent, 3);
					AjcG3dPixelV(hWndG3d, pBuf->id2, &pBuf->cent, 3);
					//	ɓڂQ̉~̏`
					DrawInscribedCircle(&sph.cif1, pBuf->id1);
					DrawInscribedCircle(&sph.cif2, pBuf->id2);
					//	ډ~S狅Sւ̐
					AjcG3dLineV(hWndG3d, pBuf->id1, &sph.cif1.lvc.p, &pBuf->cent);
					AjcG3dLineV(hWndG3d, pBuf->id2, &sph.cif2.lvc.p, &pBuf->cent);
				}
			}
		}
		//	̏NA[
		pBuf->cnt = 0;
		memset(pBuf->plt, 0, sizeof pBuf->plt);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	O~Zopvbg_̎Wƕ`																			//
//--------------------------------------------------------------------------------------------------------------//
static	VO		CirCorrectAndShow(PCAJC3DVEC pVec, PPLOTINFO pBuf)
{
	UI		i;

	//	vbgԂ̍Œ዗`FbN
	for (i = 0; i < pBuf->cnt; i++) {
		if (AjcV3dDistP2P(pVec, &pBuf->plt[i]) < pBuf->dist) {
			break;
		}
	}
	//	vbg_̎W
	if (i >= pBuf->cnt) {
		memcpy(&pBuf->plt[i], pVec, sizeof(AJC3DVEC));
		pBuf->cnt++;
	}
	
	//	O~̎Zoƕ\
	if (pBuf->cnt >= pBuf->num) {
		AJC3DCIRINFO	cif;
		if ((pBuf->radius = AjcV3dCalcCircleVEx(&pBuf->plt[0], &pBuf->plt[1], &pBuf->plt[2],
																		 &pBuf->cent, &pBuf->vec , &cif)) != -1) {
			if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_CIRINFO)) {
				//	ŐO~`NA[
				AjcG3dClearShape(hWndG3d, pBuf->id1);
				//	R_`
				AjcG3dPixelV(hWndG3d, pBuf->id1, &pBuf->plt[0], 4);
				AjcG3dPixelV(hWndG3d, pBuf->id1, &pBuf->plt[1], 4);
				AjcG3dPixelV(hWndG3d, pBuf->id1, &pBuf->plt[2], 4);
				//	ډ~`
				DrawInscribedCircle(&cif, pBuf->id1);
			}
		}
		//	O~̏NA[
		pBuf->cnt = 0;
		memset(pBuf->plt, 0, sizeof pBuf->plt);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	Zo̓ډ~^O~̕`																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO		DrawInscribedCircle(PCAJC3DCIRINFO pCif, int id)
{
	//	~ɓڂQ̒ƒ[_
	AjcG3dLineV (hWndG3d, id, &pCif->lt1.p1, &pCif->lt1.p2);
	AjcG3dLineV (hWndG3d, id, &pCif->lt2.p1, &pCif->lt2.p2);
	AjcG3dPixelV(hWndG3d, id, &pCif->lt1.p1, 4);
	AjcG3dPixelV(hWndG3d, id, &pCif->lt1.p2, 4);
	AjcG3dPixelV(hWndG3d, id, &pCif->lt2.p1, 4);
	AjcG3dPixelV(hWndG3d, id, &pCif->lt2.p2, 4);
	//	ڐ_̐
	AjcG3dLineV (hWndG3d, id, &pCif->lc1.p1, &pCif->lc1.p2);
	AjcG3dLineV (hWndG3d, id, &pCif->lc2.p1, &pCif->lc2.p2);
	//	ډ~Ɠډ~̒S_
	AjcG3dDefPlaneV(hWndG3d, id, &pCif->lvc, NULL);
	AjcG2dEllipse  (hWndG3d, id, 0, 0, pCif->cr, pCif->cr);
	AjcG2dPixel    (hWndG3d, id, 0, 0, 4);
}

//--------------------------------------------------------------------------------------------------------------//
//	EChX^Cl`FbN{bNXɐݒ																	//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetStyleToCheckBox(VO)
{
	UI		sty;

	sty = (UI)MAjcGetWindowLong(hWndG3d, GWL_STYLE);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_NODEPTHCTRL , (sty & AJC3DGS_NODEPTHCTRL  ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_NOBORDER    , (sty & AJC3DGS_NOBORDER	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_NOFILTER    , (sty & AJC3DGS_NOFILTER	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_NOANGLE	   , (sty & AJC3DGS_NOANGLE 	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_AXIS_X	   , (sty & AJC3DGS_SHOWAXIS_X	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_AXIS_Y	   , (sty & AJC3DGS_SHOWAXIS_Y	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_AXIS_Z	   , (sty & AJC3DGS_SHOWAXIS_Z	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_RECTSCALE   , (sty & AJC3DGS_RECTSCALE	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_ELPSSCALE   , (sty & AJC3DGS_ELPSSCALE	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_SPHERESCALE , (sty & AJC3DGS_SPHERESCALE  ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_LINE_XY	   , (sty & AJC3DGS_SCALE_XY	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_LINE_XZ	   , (sty & AJC3DGS_SCALE_XZ	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_LINE_YZ	   , (sty & AJC3DGS_SCALE_YZ	 ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_VAL_X	   , (sty & AJC3DGS_SCALEVALUE_X ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_VAL_Y	   , (sty & AJC3DGS_SCALEVALUE_Y ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_VAL_Z	   , (sty & AJC3DGS_SCALEVALUE_Z ) != 0);
}
//--------------------------------------------------------------------------------------------------------------//
//	`FbN{bNX̐ݒX^Cɔf																		//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetCheckBoxToStyle(VO)
{
	UI		sty;

	sty = (UI)MAjcGetWindowLong(hWndG3d, GWL_STYLE);
	sty &= 0xFFFF0000;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_NODEPTHCTRL )) sty |= AJC3DGS_NODEPTHCTRL;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_NOBORDER    )) sty |= AJC3DGS_NOBORDER;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_NOFILTER    )) sty |= AJC3DGS_NOFILTER;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_NOANGLE	   )) sty |= AJC3DGS_NOANGLE;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_AXIS_X	   )) sty |= AJC3DGS_SHOWAXIS_X;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_AXIS_Y	   )) sty |= AJC3DGS_SHOWAXIS_Y;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_AXIS_Z	   )) sty |= AJC3DGS_SHOWAXIS_Z;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_RECTSCALE   )) sty |= AJC3DGS_RECTSCALE;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_ELPSSCALE   )) sty |= AJC3DGS_ELPSSCALE;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_SPHERESCALE )) sty |= AJC3DGS_SPHERESCALE;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_SCALE_XY    )) sty |= AJC3DGS_SCALE_XY;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_SCALE_XZ    )) sty |= AJC3DGS_SCALE_XZ;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_SCALE_YZ    )) sty |= AJC3DGS_SCALE_YZ;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_VAL_X	   )) sty |= AJC3DGS_SCALEVALUE_X;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_VAL_Y	   )) sty |= AJC3DGS_SCALEVALUE_Y;
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_VAL_Z	   )) sty |= AJC3DGS_SCALEVALUE_Z;
	MAjcSetWindowLong(hWndG3d, GWL_STYLE, sty);
}
