//
//	SW_AvlTreeC.c
//
#include	<AjrCstXX.h>
#include	<stdio.h>
#include	<conio.h>
#include	<time.h>
#include	<tchar.h>

//----- [N -------------------------------------------------------------------------------------------------//
static	HAJCAVL 	hAvl = NULL;

//----- m[hf[^` ---------------------------------------------------------------------------------------//
typedef struct {
	UTP 	pTimStr;			//	q[v̎ւ̃|C^
} NODEDATA, *PNODEDATA;

//----- m[h폜̃R[obN֐ -------------------------------------------------------------------------//
static	VO	 CALLBACK cbRemove(UX key, VOP pData, UI len, UI nest, UX cbp)
{
	AjcPrintF(TEXT("Deleted   - key=%4u, len=%d, nest=%d, data='%s'\n"), (UI)key, len, nest, ((PNODEDATA)pData)->pTimStr);
	AjcTFree(((PNODEDATA)pData)->pTimStr);
}
//----- Sm[h擾iSm[hvgjpR[obN֐ -----------------------------------------------------//
static BOOL CALLBACK cbPrintNode(UX key, VOP pData, UI len, UI nest, UX cbp)
{
	PAJCAVLNODE pNode = ((PAJCAVLNODE)pData) - 1;

	AjcPrintF(TEXT("%-26s:%*u, %d\n"), ((PNODEDATA)pData)->pTimStr, nest * 6, (UI)key, pNode->bal);
	return TRUE;
}
//----- ݎ񐶐iݎi[AIւ̃|C^Ԃj----------------------------//
static	UTP		GetTimeStr(VO)
{
	UTP			rc;
	SYSTEMTIME	st;
	UI			len;
	UT			szTim[64];

	GetLocalTime(&st);
	AjcSnPrintF(szTim, AJCTSIZE(szTim), TEXT("%02d:%02d:%02d.%03d"), st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
	len = (UI)_tcslen(szTim) + 1;
	MAjcStrCpy(rc = AjcTAlloc(len), len, szTim);
	return rc;
}
//----- ͒ʒm -----------------------------------------------------------------------------------------//
static VO CALLBACK cbNtcArgs(int argc, UT *argv[], C_UTP pTxt, UX cbp)
{
	NODEDATA	Node;

	//	̓eLXg\
	AjcPrintF(TEXT("%s\n"), pTxt);
	//	R}hs
	if (argc >= 1) {
		//	m[h}
		if		(_tcsicmp(argv[0], TEXT("I")) == 0) {
			if (argc == 2) {
				Node.pTimStr = GetTimeStr();
				if (!AjcAvlInsNode(hAvl, _ttoi(argv[1]), &Node, sizeof Node)) {
					if (Node.pTimStr != NULL) AjcTFree(Node.pTimStr); Node.pTimStr = NULL;
					AjcPrintF(TEXT("m[h̑}s܂B\n"));
				}
			}
			else AjcPrintF(TEXT("*** Invalid parameter.\n"));
		}
		//	m[hu
		else if (_tcsicmp(argv[0], TEXT("R")) == 0) {
			if (argc == 2) {
				Node.pTimStr = GetTimeStr();
				if (!AjcAvlRepNode(hAvl, _ttoi(argv[1]), &Node, sizeof Node)) {
					if (Node.pTimStr != NULL) AjcTFree(Node.pTimStr); Node.pTimStr = NULL;
					AjcPrintF(TEXT("m[h̒us܂B\n"));
				}
			}
			else AjcPrintF(TEXT("*** Invalid parameter.\n"));
		}
		//	m[h̑}^u
		else if (_tcsicmp(argv[0], TEXT("X")) == 0) {
			if (argc == 2) {
				Node.pTimStr = GetTimeStr();
				if (!AjcAvlInsOrRepNode(hAvl, _ttoi(argv[1]), &Node, sizeof Node)) {
					if (Node.pTimStr != NULL) AjcTFree(Node.pTimStr); Node.pTimStr = NULL;
					AjcPrintF(TEXT("m[h̑}^us܂B\n"));
				}
			}
			else AjcPrintF(TEXT("*** Invalid parameter.\n"));
		}
		//	m[h폜
		else if (_tcsicmp(argv[0], TEXT("D"))  == 0) {
			if (argc == 2) {
				if (!AjcAvlDelNode(hAvl, _ttoi(argv[1]))) {
					AjcPrintF(TEXT("m[h̍폜s܂B\n"));
				}
			}
			else AjcPrintF(TEXT("*** Invalid parameter.\n"));
		}
		//	Sm[hj
		else if (_tcsicmp(argv[0], TEXT("A"))  == 0) {
			if (!AjcAvlDelAllNodes(hAvl)) {
				AjcPrintF(TEXT("Sm[h̍폜s܂B\n"));
			}
		}
		//	Sm[h\
		else if (_tcsicmp(argv[0], TEXT("P"))  == 0) {
			AjcAvlEnumNodes(hAvl, cbPrintNode, TRUE);
		}
		//	̑
		else {
			AjcPrintF(TEXT("*** Invalid command.\n"));
		}
	}
}
//----- R\[Inh -----------------------------------------------------------------------------//
static BOOL CALLBACK cbConApExit(DWORD CtrlType)
{
	//	`ukCX^X
	if (hAvl != NULL) {
		AjcAvlDelete(hAvl);
		hAvl = NULL;
	}
	return FALSE;	//	FALSE : ̃nhR[
}
//==============================================================================================================//
int  AjcMain(int argc, UTP argv[])
{
	NODEDATA	Node;

	AjcSetStdoutMode();

	//----- R\[Inhݒ ---------------------------------------------------------------------//
	SetConsoleCtrlHandler(cbConApExit, TRUE);

	//----- CX^X -----------------------------------------------------------------------------------//
	hAvl = AjcAvlCreate(0, NULL, cbRemove);

	//	R}hj[
	AjcPrintF(TEXT("\n ȉ̃R}h͂ĂB\n\n"));
	AjcPrintF(TEXT("  I   nnn     : m[h}, key=nnn\n"));
	AjcPrintF(TEXT("  R   nnn     : m[hu, key=nnn\n"));
	AjcPrintF(TEXT("  X   nnn     : m[h̑}^u, key=nnn\n"));
	AjcPrintF(TEXT("  D   nnn     : m[h폜, key=nnn\n"));
	AjcPrintF(TEXT("  A           : Sm[hj\n"));
	AjcPrintF(TEXT("  P           : Sm[h\\n"));
	AjcPrintF(TEXT("  <ESC>L[   : I\n"));
	AjcPrintF(TEXT("\n"));

	//----- m[ho^^\ -------------------------------------------------------------------------------//
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited  50"));	AjcAvlInsNode(hAvl,  50, &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited  60"));	AjcAvlInsNode(hAvl,  60, &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited  70"));	AjcAvlInsNode(hAvl,  70, &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited  80"));	AjcAvlInsNode(hAvl,  80, &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited  90"));	AjcAvlInsNode(hAvl,  90, &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited 100"));	AjcAvlInsNode(hAvl, 100, &Node, sizeof Node);
	AjcAvlEnumNodes(hAvl, cbPrintNode, TRUE);

	//----- R}h ---------------------------------------------------------------------------------------//
	AjcPrintF(TEXT("Input(%2d) : "), AjcAvlGetCount(hAvl));
	while (AjcConInputByNtc(0, cbNtcArgs)) {
		AjcPrintF(TEXT("Input(%2d) : "), AjcAvlGetCount(hAvl));
	}
	if (hAvl != NULL) {
		AjcAvlDelete(hAvl);
		hAvl = NULL;
	}

	return 0;
}


