﻿//
//	SW_DlgColor.c
//

#include	<AjrCstXX.h>
#include	<math.h>
#include	<tchar.h>
#include	"resource.h"

//--------------------------------------------------------------------------------------------------------------//
//	ワーク																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;							//	ＤＬＬインスタンスハンドル
static	HMENU			hMenuBar;
static	HWND			hDlgMain;						//	ダイアログボックスハンドル
static	HWND			hVth;
static	HBITMAP			hBmp1, hBmp2, hBmp3, hBmp4, hBmp5, hBmp6;
static	HBRUSH			hBruCtrl;

//--------------------------------------------------------------------------------------------------------------//
//	内部サブ関数																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);
static	VO	EvtLog(HWND hDlg, WPARAM wParam, LPARAM lParam, HWND hVth);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 			msg;

	hInst = hInstance;

	//----- 描画色設定 ---------------------------------//
	AjcDgcSetup();
	AjcDgcSetColors (RGB(255, 240, 255), RGB(0, 0, 192));

	//----- メイン・ダイアログオープン -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DLGMAIN), NULL, AJC_DLGPROC_NAME(Main));
	//----- ダイアログ表示 -----------------------------//
	ShowWindow(hDlgMain, SW_SHOW);

	//----- メッセージループ ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	ダイアログ・プロシージャ																					//
//																												//
//==============================================================================================================//
//----- ダイアログ初期化 ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	hDlgMain = hDlg;
	hVth	 = GetDlgItem(hDlg, IDC_VTH);

	hBruCtrl = CreateSolidBrush(RGB(255, 255, 225));
	hBmp1 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP1));
	hBmp2 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP2));
	hBmp3 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP3));
	hBmp4 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP4));
	hBmp5 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP5));
	hBmp6 = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP6));
	AjcSetDlgItemChk(hDlg, IDC_CHK_ENA_DIS, TRUE);
	AjcSetDlgItemChk(hDlg, IDC_RBT4 	  , TRUE);
	return TRUE;
}
//----- ウインド破棄 -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	DeleteObject(hBruCtrl);
	//----- プログラム終了 ---------------------------------------//
	PostQuitMessage(0);
	return TRUE;
}
//----- WM_COMMAND ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_COMMAND	 	)
{
	HWND	hCtrl = GetDlgItem(hDlg, LOWORD(wParam));
	UT		cname[256];

	GetClassName(hCtrl, cname, 256);
	if (_tcscmp(cname, TEXT("Button")) == 0) {
		EvtLog(hDlg, wParam, lParam, GetDlgItem(hDlg, IDC_VTH));
		SetTimer(hDlg, 1, 300, NULL);
	}
	return TRUE;
}
//----- WM_RBUTTONDOWN -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_RBUTTONDOWN	)
{
	HMENU		hMenu	 = NULL;
	HMENU		hMTxt, hMBmp;
	HMENU		hPopup	 = NULL;
	int			id;
	POINT		pt;

	hMenu  = LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENU1));
	hMTxt = CreatePopupMenu();
	InsertMenu(hMTxt, 0, MF_BYPOSITION | MFT_OWNERDRAW 												 , 5001, TEXT("\x1B[TNormal"));
	InsertMenu(hMTxt, 1, MF_BYPOSITION | MFT_OWNERDRAW 					| MFS_CHECKED				 , 5002, TEXT("CHK"));
	InsertMenu(hMTxt, 2, MF_BYPOSITION | MFT_OWNERDRAW | MFT_RADIOCHECK | MFS_CHECKED				 , 5003, TEXT("RBT"));
	InsertMenu(hMTxt, 3, MF_BYPOSITION | MF_SEPARATOR										   		 ,	  0, NULL 		);
	InsertMenu(hMTxt, 4, MF_BYPOSITION | MFT_OWNERDRAW 								  | MFS_DISABLED , 5004, TEXT("DIS"));
	InsertMenu(hMTxt, 5, MF_BYPOSITION | MFT_OWNERDRAW 					| MFS_CHECKED | MFS_DISABLED , 5005, TEXT("CHK, DIS"));
	InsertMenu(hMTxt, 6, MF_BYPOSITION | MFT_OWNERDRAW | MFT_RADIOCHECK | MFS_CHECKED | MFS_DISABLED , 5006, TEXT("RBT. DIS"));
	hMBmp = CreatePopupMenu();
	InsertMenu(hMBmp, 0, MF_BYPOSITION | MFT_OWNERDRAW 												 , 5011, (UTP)hBmp1);
	InsertMenu(hMBmp, 1, MF_BYPOSITION | MFT_OWNERDRAW 					| MFS_CHECKED				 , 5012, (UTP)hBmp2);
	InsertMenu(hMBmp, 2, MF_BYPOSITION | MFT_OWNERDRAW | MFT_RADIOCHECK | MFS_CHECKED				 , 5013, (UTP)hBmp3);
	InsertMenu(hMBmp, 3, MF_BYPOSITION | MF_SEPARATOR										   		 ,	  0, NULL 	   );
	InsertMenu(hMBmp, 4, MF_BYPOSITION | MFT_OWNERDRAW 								  | MFS_DISABLED , 5014, (UTP)hBmp4);
	InsertMenu(hMBmp, 5, MF_BYPOSITION | MFT_OWNERDRAW 					| MFS_CHECKED | MFS_DISABLED , 5015, (UTP)hBmp5);
	InsertMenu(hMBmp, 6, MF_BYPOSITION | MFT_OWNERDRAW | MFT_RADIOCHECK | MFS_CHECKED | MFS_DISABLED , 5016, (UTP)hBmp6);
	hPopup = CreatePopupMenu();
	InsertMenu(hPopup, 0, MF_BYPOSITION  |MFT_OWNERDRAW | MF_POPUP, (UX)hMTxt, TEXT("Text Menu"));
	InsertMenu(hPopup, 1, MF_BYPOSITION | MFT_OWNERDRAW | MF_POPUP , (UX)hMBmp, (UTP)hBmp1);
	GetCursorPos(&pt);
	id = AjcDgcTrackPopupMenuEx(hPopup, TPM_RETURNCMD | TPM_TOPALIGN, pt.x, pt.y, hDlg, NULL);
	DestroyMenu(hPopup);
	DestroyMenu(hMenu);
	DestroyMenu(hMTxt);
	DestroyMenu(hMBmp);

	return TRUE;
}

//----- WM_TIMER -----------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_TIMER	 		)
{
	KillTimer(hDlg, 1);
	AjcVthPrintF(GetDlgItem(hDlg, IDC_VTH), TEXT("\n"));
	return TRUE;
}
//----- WM_INITMENU --------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITMENU	 	)
{
	return 0;
}
//----- 「Cancel」ボタン ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//----- 全て許可／禁止 -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CHK_ENA_DIS	)
{
	BOOL	f = AjcGetDlgItemChk(hDlg, IDC_CHK_ENA_DIS);
	AjcEnableDlgGroup(hDlg, IDC_GRP_ALL, f, f);
	return TRUE;
}
//----- BS_FLAT 設定 -------------------------------------------------------------------------------------------//
#define	SET_STY(ID, STY) 																						\
	if (AjcGetDlgItemChk(hDlg, LOWORD(wParam))) MAjcSetWindowLong(GetDlgItem(hDlg, ID), GWL_STYLE, 				\
													MAjcGetWindowLong(GetDlgItem(hDlg, ID), GWL_STYLE) |  STY); \
	else										 MAjcSetWindowLong(GetDlgItem(hDlg, ID), GWL_STYLE,				\
													MAjcGetWindowLong(GetDlgItem(hDlg, ID), GWL_STYLE) & ~STY);	\
	InvalidateRect(GetDlgItem(hDlg, ID), NULL, TRUE)

AJC_DLGPROC(Main, IDC_CHK_SET_FLAT	)
{
	SET_STY(IDC_BTN_PUSH_L, BS_FLAT);
	SET_STY(IDC_BTN_PUSH_S, BS_FLAT);
	SET_STY(IDC_CHK1	  , BS_FLAT);
	SET_STY(IDC_CHK2L	  , BS_FLAT);
	SET_STY(IDC_CHK2S	  , BS_FLAT);
	SET_STY(IDC_CHK3L	  , BS_FLAT);
	SET_STY(IDC_CHK3S	  , BS_FLAT);
	SET_STY(IDC_CHK4L	  , BS_FLAT);
	SET_STY(IDC_CHK4S	  , BS_FLAT);
	SET_STY(IDC_GRP_RBT   , BS_FLAT);
	SET_STY(IDC_RBT1	  , BS_FLAT);
	SET_STY(IDC_RBT2L	  , BS_FLAT);
	SET_STY(IDC_RBT2S	  , BS_FLAT);
	SET_STY(IDC_RBT3	  , BS_FLAT);
	SET_STY(IDC_RBT4	  , BS_FLAT);
	return TRUE;
}
//----- BS_NOTIFY 設定 -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CHK_SET_NOTIFY)
{
	SET_STY(IDC_BTN_PUSH_L, BS_NOTIFY);
	SET_STY(IDC_BTN_PUSH_S, BS_NOTIFY);
	SET_STY(IDC_CHK1	  , BS_NOTIFY);
	SET_STY(IDC_CHK2L	  , BS_NOTIFY);
	SET_STY(IDC_CHK2S	  , BS_NOTIFY);
	SET_STY(IDC_CHK3L	  , BS_NOTIFY);
	SET_STY(IDC_CHK3S	  , BS_NOTIFY);
	SET_STY(IDC_CHK4L	  , BS_NOTIFY);
	SET_STY(IDC_CHK4S	  , BS_NOTIFY);
	SET_STY(IDC_GRP_RBT   , BS_NOTIFY);
	SET_STY(IDC_RBT1	  , BS_NOTIFY);
	SET_STY(IDC_RBT2L	  , BS_NOTIFY);
	SET_STY(IDC_RBT2S	  , BS_NOTIFY);
	SET_STY(IDC_RBT3	  , BS_NOTIFY);
	SET_STY(IDC_RBT4	  , BS_NOTIFY);
	return TRUE;
}
//----- C 更新 -------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_UPD_C		)
{
	AjcSetDlgItemChk(hDlg, IDC_CHK3S, (AjcGetDlgItemChk(hDlg, IDC_CHK3S) + 1) % 3);
	return TRUE;
}
//----- CHK4L 更新 ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_UPD_CHK4L	)
{
	AjcSetDlgItemChk(hDlg, IDC_CHK4L, (AjcGetDlgItemChk(hDlg, IDC_CHK4L) + 1) % 2);
	return TRUE;
}
//----- RBT3 更新 ----------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_UPD_RBT3	)
{
	AjcSetDlgItemChk(hDlg, IDC_RBT3, (AjcGetDlgItemChk(hDlg, IDC_RBT3) + 1) % 2);
	return TRUE;
}
//----- RBT4 更新 ----------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_UPD_RBT4	)
{
	AjcSetDlgItemChk(hDlg, IDC_RBT4, (AjcGetDlgItemChk(hDlg, IDC_RBT4) + 1) % 2);
	return TRUE;
}
//----- IDC_BTN_SPECIAL ----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_BTN_SPECIAL	)
{
	return TRUE;
}
//-----  AJCM_CTLCOLOR_BTN -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, AJCM_CTLCOLOR_BTN)
{
	PAJCDGCCTLCOLOR	pCC = (PAJCDGCCTLCOLOR)wParam;

	if ((HWND)lParam == GetDlgItem(hDlg, IDC_BTN_SPECIAL))	{
		pCC->hBrush    = hBruCtrl;
		pCC->TextColor = RGB(255,0,0);
	}
	return TRUE;
}
//-----  AJCM_CTLCOLOR_ANY -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, AJCM_CTLCOLOR_ANY)
{
	PAJCDGCCTLCOLOR	pCC = (PAJCDGCCTLCOLOR)wParam;

	if ((HWND)lParam == GetDlgItem(hDlg, IDC_CHK1))	{
		pCC->TextColor = RGB(255,0,0);
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG		)
	AJC_DLGMAP_MSG(Main, WM_DESTROY 		)
	AJC_DLGMAP_MSG(Main, WM_COMMAND 		)
	AJC_DLGMAP_MSG(Main, WM_RBUTTONDOWN		)
	AJC_DLGMAP_MSG(Main, WM_TIMER	 		)
	AJC_DLGMAP_MSG(Main, WM_INITMENU 		)

	AJC_DLGMAP_CMD(Main, IDCANCEL			)
	AJC_DLGMAP_CMD(Main, IDC_CHK_ENA_DIS	)
	AJC_DLGMAP_CMD(Main, IDC_CHK_SET_FLAT	)
	AJC_DLGMAP_CMD(Main, IDC_CHK_SET_NOTIFY	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_UPD_C		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_UPD_CHK4L	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_UPD_RBT3	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_UPD_RBT4	)
	AJC_DLGMAP_CMD(Main, IDC_BTN_SPECIAL	)
	AJC_DLGMAP_DGB(Main, AJCM_CTLCOLOR_BTN	)
	AJC_DLGMAP_DGC(Main, AJCM_CTLCOLOR_ANY	)
AJC_DLGMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	イベントログ表示																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	EvtLog(HWND hDlg, WPARAM wParam, LPARAM lParam, HWND hVth)
{
	UT		txt[256];

	AjcGetDlgItemStr(hDlg, LOWORD(wParam), txt, 256);
	AjcVthPrintF(hVth, TEXT("%s : "), txt);

	switch (HIWORD(wParam)) {
		case BN_CLICKED:	AjcVthPrintF(hVth, TEXT("BN_CLICKED\n"));	break;
		case BN_DBLCLK:		AjcVthPrintF(hVth, TEXT("BN_DBLCLK\n"));	break;
		case BN_KILLFOCUS:	AjcVthPrintF(hVth, TEXT("BN_KILLFOCUS\n"));	break;
		case BN_SETFOCUS:	AjcVthPrintF(hVth, TEXT("BN_SETFOCUS\n"));	break;
	}
}
