//
//	SW_PrintImage.c
//

#include	<AjrCstXX.h>
#include	<Shlwapi.h>
#include	<io.h>
#include	<tchar.h>
#include	<sys/stat.h>
#include	"resource.h"
#pragma comment(lib, "shlwapi.lib")

#define	PICL	400

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;							//	ckkCX^Xnh
static	HWND			hDlgMain;						//	_CAO{bNXnh
static	HWND			hLbx;

static	BOOL			fImgValid = FALSE;
static	BOOL			fPrintContinue;
static	HAJCPRN 		hPrn;							//	CX^X
static	AJCPRN_INFO		PrnInfo;						//	v^
static	AJC_IMGINFO 	ImgInfo;						//	C[W
static	HBITMAP 		hBmpPic = NULL; 				//	sN`rbg}bvnh
static	UT				ImgFile[MAX_PATH];				//	sN`t@C


//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);

static	VO		DrawToPic(VO);
static	BOOL	SearchImageFile(VO);

static	BOOL CALLBACK cbQueryPage	   (PCAJCPRN_INFO pPrnInfo, PAJCPRN_PGINFO pPageInfo, UX cbp);
static	BOOL CALLBACK cbDrawByDibSectDC(HDC hdc, PCAJCPRN_INFO pPrnInfo, PCAJCDIBINFO pDibInfo, UX cbp);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;

	hInst = hInstance;
	memset(&ImgInfo, 0, sizeof ImgInfo);

	//----- CE_CAOI[v -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, AJC_DLGPROC_NAME(Main));
	ShowWindow(hDlgMain, SW_SHOW);

	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	hDlgMain = hDlg;
	hLbx	 = GetDlgItem(hDlg, IDC_LBX_FILES);

	SetWindowPos(GetDlgItem(hDlg, IDC_PIC_IMAGE), NULL, 0, 0, PICL, PICL, SWP_NOMOVE);

	//----- CX^X --------------------------//
	hPrn = AjcPrnCreate();
	//----- y[WJnʒmR[obNݒ ------------//
	AjcPrnSetCallbackQueryPage(hPrn, cbQueryPage);
	//----- Py[WpR[obNݒ ----------------//
	AjcPrnSetCallbackByDibSect(hPrn, cbDrawByDibSectDC);
	//----- v^ǂݏo --------------------------//
	AjcSetDlgItemStr(hDlg, IDC_LBL_PRNAME, AjcPrnGetInfo(hPrn, &PrnInfo));
	//----- _CAO ------------------------------//
	AjcSetDlgItemUInt(hDlg, IDC_INP_SPC_L, PrnInfo.MrgIf.mm.l);
	AjcSetDlgItemUInt(hDlg, IDC_INP_SPC_R, PrnInfo.MrgIf.mm.r);
	AjcSetDlgItemUInt(hDlg, IDC_INP_SPC_U, PrnInfo.MrgIf.mm.u);
	AjcSetDlgItemUInt(hDlg, IDC_INP_SPC_D, PrnInfo.MrgIf.mm.d);
	//----- ݒl[h ----------------------------------//
	AjcLoadAllControlSettings(hDlg, TEXT("Settings"), AJCCTL_SELACT_ALL | AJCCTL_SELACT_NTCALL);
	//----- 摜\ --------------------------------------//
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_LBX_FILES, AJCLBXN_SELCHANGE), (LPARAM)hLbx);
	//----- 摜IԊĎ^C}N --------------------//
	SetTimer(hDlg, 1, 100, NULL);

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	//----- ^C}~ ------------------------------------//
	KillTimer(hDlg, 1);
	//----- ݒlZ[u ----------------------------------//
	AjcSaveAllControlSettings(hDlg);
	//----- \[X ----------------------------------//
	AjcPrnDelete(hPrn);
	AjcImgFuncRelease(&ImgInfo);
	//----- vOI --------------------------------//
	PostQuitMessage(0);

	return TRUE;
}
//----- WM_TIMER -----------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_TIMER			)
{
	if (AjcLbxGetCurSel(hLbx) >= 0 && ImgInfo.fValid) {
		ShowWindow(GetDlgItem(hDlg, IDC_PIC_IMAGE), SW_SHOW);
		AjcEnableDlgItem(hDlg, IDC_CMD_START, TRUE);
	}
	else {
		ShowWindow(GetDlgItem(hDlg, IDC_PIC_IMAGE), SW_HIDE);
		AjcEnableDlgItem(hDlg, IDC_CMD_START, FALSE);
	}
	return TRUE;
}
//----- WM_COMMAND ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_COMMAND		)
{
	int 	cmd = LOWORD(wParam);

	if (cmd == IDC_INP_SPC_U || cmd == IDC_INP_SPC_D || cmd == IDC_INP_SPC_L || cmd == IDC_INP_SPC_R) {
		if (HIWORD(wParam) == AJCIVN_INTVALUE) {
			AJCPRN_MARGIN	mrg;
			mrg.u = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_U);
			mrg.d = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_D);
			mrg.l = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_L);
			mrg.r = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_R);
			AjcPrnSetMargin(hPrn, &mrg);
		}
	}
	return TRUE;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//----- v^̐ݒ{^ -----------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SETPRN	)
{
	if (AjcPrnSelectDlg(hPrn, &PrnInfo, 0, hDlg)) {
		//	v^\
		AjcSetDlgItemStr(hDlg, IDC_LBL_PRNAME, AjcPrnGetInfo(hPrn, NULL));
	}
	return TRUE;
}
//----- Jn{^ ----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_START )
{
	AJCPRN_OPT	opt = {0};

	if (HIWORD(wParam) == BN_CLICKED) {
		opt.Flags = (
		//	AJCPRNF_DISABLECOPIES		|	//	uv𖳌
		//	AJCPRNF_DISABLEPAGEINFO		|	//	ú͈v𖳌ɂ
		//	AJCPRNF_ALLPAGES			|	//	uׂāvIԂɂ
		//	AJCPRNF_SELECTION			|	//	uIvIԂɂ
		//	AJCPRNF_NOSELECTION			|	//	uIv𖳌Ԃɂ
		//	AJCPRNF_PAGENUMS			|	//	uy[WwvIԂɂ
		//	AJCPRNF_NOPAGENUMS			|	//	uy[Wwv𖳌Ԃɂ
		//	AJCPRNF_NOWARNING			|	//	̃v^ȂꍇɌxbZ[W\
		//	AJCPRNF_PRINTTOFILE			|	//	ut@C֏óv`FbN
		//	AJCPRNF_DISABLEPRINTTOFILE	|	//	ut@C֏óv𖳌
		//	AJCPRNF_HIDEPRINTTOFILE		|	//	t@C֏óv\
			AJCPRNF_USEDEVMODECOPIES	|	//	AvŁuPʂňvT|[gł邱Ƃw
			0);
		opt.nCopies 	= 1;				//	Rs[
		opt.nFromPage	= 1;				//	Jny[W
		opt.nToPage		= 1;				//	Iy[W
		opt.nMinPage	= 1;				//	y[W͈͂̍ŏl
		opt.nMaxPage	= 10;				//	y[W͈͂̍ŏl
		if (AjcPrnPrintDlg(hPrn, NULL, &opt, hDlg)) {
			//--- v^\ ------------//
			AjcSetDlgItemStr(hDlg, IDC_LBL_PRNAME, AjcPrnGetInfo(hPrn, NULL));
			//--- ptO ------//
			fPrintContinue = TRUE;
			//--- ~{^̂ݗL ------//
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_ALL ), FALSE, FALSE);
			EnableWindow  (GetDlgItem(hDlg, IDC_CMD_STOP), TRUE);
			//--- Jn ------------------//
			AjcPrnStart (hPrn, (opt.Flags & AJCPRNF_OUTPUTTOFILE) != 0);
			//--- O[ԉ -----------//
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_ALL ), TRUE, TRUE);
			EnableWindow  (GetDlgItem(hDlg, IDC_CMD_STOP), FALSE);
		}
	}
	return TRUE;
}
//----- ~{^ ----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STOP		)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		//--- O[ԉ -----------//
		AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_ALL ), TRUE, TRUE);
		EnableWindow  (GetDlgItem(hDlg, IDC_CMD_STOP), FALSE);
		//--- I̎|Aݒ -------//
		fPrintContinue = FALSE;
	}
	return TRUE;
}
//----- Xg{bNX̒ʒm -------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_LBX_FILES		)
{
	int				ix;
	static UT SvFile[MAX_PATH];

	if (HIWORD(wParam) == AJCLBXN_SELCHANGE) {
		if ((ix = AjcLbxGetCurSel(hLbx)) >= 0) {				//	IڗL
			AjcLbxGetText(hLbx, ix, ImgFile, MAX_PATH);			//	It@CpX擾
			if (MAjcStrCmp(ImgFile, SvFile) != 0) {				//		Õt@CƈقȂH
				AjcImgFuncRelease(&ImgInfo);					//			Oǂݏoς̃C[W
				if (AjcImgFuncRead(&ImgInfo, ImgFile)) {		//			C[Wt@CǂݏoCH
					DrawToPic();								//				C[W\
				}
			//	else MessageBox(hDlg, TEXT("C[Wt@C̓ǂݏos܂B"), TEXT("SW_PrintImage"), MB_ICONERROR);
				MAjcStrCpy(SvFile, MAX_PATH, ImgFile);			//			C[Wt@CpXޔ
			}
		}
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG		)
	AJC_DLGMAP_MSG(Main, WM_DESTROY 		)
	AJC_DLGMAP_MSG(Main, WM_TIMER	 		)
	AJC_DLGMAP_MSG(Main, WM_COMMAND 		)
	AJC_DLGMAP_CMD(Main, IDCANCEL			)
	AJC_DLGMAP_CMD(Main, IDC_CMD_SETPRN 	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_START		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_STOP		)
	AJC_DLGMAP_CMD(Main, IDC_LBX_FILES		)
AJC_DLGMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	sN`Rg[ɂɃC[W`																		//
//																												//
//	@	F@Ȃ																							//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO		DrawToPic(VO)
{
	HDC 	hdc, mdc;
	HBITMAP hSvBmp;
	HPEN	hSvPen;
	HBRUSH	hSvBru;
	int 	pw, ph;
	RECT	rcS, rcD;

	if(ImgInfo.fValid) {
		//	摜̃AXyNgɍ킹sN`TCYݒ
		if (ImgInfo.height >= ImgInfo.width) {pw = PICL * ImgInfo.width / ImgInfo.height; ph = PICL;}	//	c
		else								 {pw = PICL; ph = PICL * ImgInfo.height / ImgInfo.width;}	//	
		//	cbݒ
		hdc = GetDC(hDlgMain);
		mdc = CreateCompatibleDC(hdc);
		//	`rbg}bvIuWFNg쐬
		if (hBmpPic != NULL) DeleteObject(hBmpPic);
		hBmpPic = CreateCompatibleBitmap(hdc, pw, ph);
		hSvBmp	= (HBITMAP)SelectObject(mdc, hBmpPic);
		//	pNA[
		hSvPen = (HPEN	)SelectObject(mdc, GetStockObject(NULL_PEN));
		hSvBru = (HBRUSH)SelectObject(mdc, CreateSolidBrush(GetSysColor(COLOR_BTNFACE)));
		Rectangle(mdc, 0, 0, pw + 1, ph + 1);
		SelectObject(mdc, hSvPen);
		DeleteObject(SelectObject(mdc, hSvBru));
		//	cbփC[W`
		SetRect(&rcS, 0, 0, ImgInfo.width, ImgInfo.height);
		SetRect(&rcD, 0, 0, pw, ph);
		AjcImgFuncDraw(&ImgInfo, &rcS, mdc, &rcD);
		//	쐬rbg}bṽnhݒ
		hBmpPic = (HBITMAP)SelectObject(mdc, hSvBmp);
		//	cb
		DeleteDC(mdc);
		ReleaseDC(hDlgMain, hdc);
		//	sN``
		SendDlgItemMessage(hDlgMain, IDC_PIC_IMAGE, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hBmpPic);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	R[obNiy[WJnj																				//
//																												//
//	@	F	pPrnInfo	- v^																		//
//				pPgInfo		- y[Wi]TCYČjւ̃|C^									//
//				cbp 		- R[obNp^																//
//																												//
//	߂l	F	TRUE  - p																				//
//				FALSE - Iiȍ~AɏIj												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbQueryPage(PCAJCPRN_INFO pPrnInfo, PAJCPRN_PGINFO pPgInfo, UX cbp)
{
	BOOL	rc = TRUE;

	AjcDoEvent();				//	~{^`FbN
	rc = fPrintContinue;		//	E

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	R[obNicha֕`j																				//
//																												//
//	@	F	hdc 		- chaZNVrbg}bv̂cb												//
//				pPrnInfo	- v^ւ̃|C^															//
//				pDibInfo	- chaZNVւ̃|C^													//
//				cbp 		- R[obNp^																//
//																												//
//	߂l	F	TRUE  - p																				//
//				FALSE - Iĩy[WɏIj													//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbDrawByDibSectDC(HDC hdc, PCAJCPRN_INFO pPrnInfo, PCAJCDIBINFO pDibInfo, UX cbp)
{
	BOOL	rc = FALSE;
	RECT	rcS, rcR, rcB;

	//	C[W``ݒ
	rcS.left   = 0;
	rcS.top    = 0;
	rcS.right  = ImgInfo.width;
	rcS.bottom = ImgInfo.height;
	//	C[W``Zoiy[W50%̃TCYj
	rcR.left   = pDibInfo->width  / 4;
	rcR.top    = pDibInfo->height / 4;
	rcR.right  = rcR.left + pDibInfo->width  / 2;
	rcR.bottom = rcR.top  + pDibInfo->height / 2;
	//	AXyNgێăC[W``Zo
	AjcAspGetZoomedRect(&rcS, &rcR, &rcB);
	//	C[W`
	AjcImgFuncDraw(&ImgInfo, &rcS, hdc, &rcB);
	//	Og`
	{
		HBRUSH hBru = (HBRUSH)SelectObject(hdc, GetStockObject(NULL_BRUSH));
		HPEN   hPen = (HPEN  )SelectObject(hdc, CreatePen(PS_SOLID, 5, RGB(0, 0, 0)));
		//	y[WOg
		Rectangle(hdc, 0, 0, pDibInfo->width, pDibInfo->height);
		//	C[WOg
		Rectangle(hdc, rcR.left, rcR.top, rcR.right, rcR.bottom);
		SelectObject(hdc, hBru);
		DeleteObject(SelectObject(hdc, hPen));
	}
	return FALSE;		//	FALSE:ICTRUEFp
}
