//
//	SW_Profile.c
//
#include	<AjrCstXX.h>
#include	<Shlwapi.h>
#include	<stdio.h>
#include	<tchar.h>
#include	"resource.h"

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;							//	ckkCX^Xnh
static	HWND			hWndBack;						//	obNEChnh
static	HWND			hDlgConf;						//	ݒp_CAEnh
static	HWND			hDlgMain;						//	C_CAEnh
static	HWND			hVthLog;						//	OEChnh
static	UT				MyPath[MAX_PATH];				//	vOݒlޔpWXgpX
static	UT				MySect[] = _T("Settings");		//	vOݒlޔpZNV
static	BOOL			fVolatile  = TRUE;				//	ꎞL^tO

//----- vt@Cq^veXg  ftHgl^ݒl -----------------------------------------------------//
static	UI				defUInt =	10, wdUInt =  11;
static	SI				defSInt =  -10, wdSInt = -11;
static	UI				defHex	= 0x10, wdHex  = 0x11;
static	double			defReal = 10.0, wdReal = 11.0;
static	UT				defStr[256] = TEXT("DefStr"),	wdStr[256] = TEXT("WrtStr");

static	UI				wdArr[3] = {10, 20, 30};
static	double			wdBin[3] = {10.0, 20.0, 30.0};

//----- vt@Cq^veXg  ǂݏol -------------------------------------------------------------------//
static	UI				rdUInt;
static	SI				rdSInt;
static	UI				rdHex;
static	double			rdReal;
static	UT				rdStr[256];

static	UI				rdArr[3];
static	double			rdBin[3];

#define	MAX_ARR	((sizeof rdArr) / (sizeof rdArr[0]))

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC_DEF(Back);
AJC_DLGPROC_DEF(Conf);
AJC_DLGPROC_DEF(Main);

static	VO		SetProfileInfo(HWND hDlg);

static	VO		ReadSect1(VO);
static	VO		ReadSect2(VO);
static	VO		SaveRegInfo(VO);
static	VO		RecvRegInfo(VO);
static	VO		LoadAllDlgItems(HWND hDlg, C_UTP pSect);
static	VO		SaveAllDlgItems(HWND hDlg);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 		msg;
	WNDCLASS	wndclass;
	UT			buf[MAX_PATH];
	UT			drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];

	hInst = hInstance;

	//----- vOpINIt@CpXݒ --------//
	GetModuleFileName(NULL, buf, MAX_PATH);
	MAjcSplitPath(buf	, drv, dir, fname, ext);
	MAjcMakePath (MyPath, drv, dir, fname, TEXT(".ini"));
	PathCombine  (MyPath, MyPath, NULL);

	//----- obNECh -------------------------//
	wndclass.style			= 0;
	wndclass.lpfnWndProc	= AJC_WNDPROC_NAME(Back);
	wndclass.cbClsExtra 	= 0;
	wndclass.cbWndExtra 	= 0;
	wndclass.hInstance		= hInst;
	wndclass.hIcon			= NULL;
	wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= TEXT("SW_Profile");
	RegisterClass(&wndclass);

	hWndBack = CreateWindow(TEXT("SW_Profile"),			// window class name
							TEXT("SW_Profile"),			// window caption
							WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME,		// window style
							0,							// initial x position
							0,							// initial y position
							0,							// initial x size
							0,							// initial y size
							NULL,						// parent window handle
							NULL,						// window menu handle
							hInst,						// program instance handle
							NULL);						// creation parameters

	//----- ECh\ -------------------------------//
	ShowWindow(hWndBack, iCmdShow);
	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgConf, &msg)) break;
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}
	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	obNEChEvV[W																				//
//																												//
//==============================================================================================================//
//----- WM_CREATE ----------------------------------------------------------------------------------------------//
AJC_WNDPROC(Back, WM_CREATE 		)
{
	RECT	rm, r1, r2;
	int		w1, h1, w2, h2;
	int		sty = (int)MAjcGetWindowLong(hwnd, GWL_STYLE);
	int		exs = (int)MAjcGetWindowLong(hwnd, GWL_EXSTYLE);

	hWndBack = hwnd;
	//----- _CAO -------------------------------------------//
	hDlgConf = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DLGCONF), hWndBack, AJC_DLGPROC_NAME(Conf));
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DLGMAIN), hWndBack, AJC_DLGPROC_NAME(Main));
	//----- _CAOTCYݒ -------------------------------------//
	GetWindowRect(hDlgConf, &r1);	GetWindowRect(hDlgMain, &r2);
	w1 = r1.right - r1.left;		w2 = r2.right - r2.left;
	h1 = r1.bottom - r1.top;		h2 = r2.bottom - r2.top;
	//----- EChTCYݒ ---------------------------------------//
	sty = (int)MAjcGetWindowLong(hWndBack, GWL_STYLE);
	exs = (int)MAjcGetWindowLong(hWndBack, GWL_EXSTYLE);
	rm.left = rm.top = 0;
	rm.right  = __max(w1, w2);
	rm.bottom = h1 + h2;
	AdjustWindowRectEx(&rm, sty, FALSE, exs);
	SetWindowPos(hwnd, NULL, 0, 0, rm.right - rm.left, rm.bottom - rm.top, SWP_NOMOVE);
	//----- _CAOړ -------------------------------------------//
	SetWindowPos(hDlgConf, NULL, 0, 0 , 0, 0, SWP_NOSIZE);
	SetWindowPos(hDlgMain, NULL, 0, h1, 0, 0, SWP_NOSIZE);
	//----- ECh\ ---------------------------------------------//
	ShowWindow(hDlgMain, SW_SHOW);
	ShowWindow(hDlgConf, SW_SHOW);

	return 0;
}
//----- WM_DESTROY ---------------------------------------------------------------------------------------------//
AJC_WNDPROC(Back, WM_DESTROY		)
{
	//----- _CAOj -------------------------------------------//
	DestroyWindow(hDlgConf);
	DestroyWindow(hDlgMain);
	//----- vOI -------------------------------------------//
	PostQuitMessage(0);
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(Back)
	AJC_WNDMAP_MSG(Back, WM_CREATE	   )
	AJC_WNDMAP_MSG(Back, WM_DESTROY    )
AJC_WNDMAP_END
//==============================================================================================================//
//																												//
//	ݒE_CAOEvV[W																			//
//																												//
//==============================================================================================================//
static	BOOL			fEndOfInit = FALSE;				//	ItO
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Conf, WM_INITDIALOG 	)
{
	UT		txt[MAX_PATH];
	UT		drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], fext[_MAX_EXT];

	hDlgConf = hDlg;
	//	_CAOڂ̃ftHgݒ
	AjcSetDlgItemChk(hDlg, IDC_RBT_REG, TRUE);			//	ANZX恁WXg
	AjcSetDlgItemChk(hDlg, IDC_CHK_VOLATILE, TRUE);		//	ꎞL^
	AjcGetIniFilePath(txt, MAX_PATH);					//	INIt@CpX
	MAjcSplitPath(txt, drv, dir,fname, fext);
	MAjcStrCat(fname, _MAX_FNAME, TEXT("_Data"));
	MAjcMakePath (txt, drv, dir, fname, fext);
	AjcSetDlgItemStr(hDlg, IDC_TXT_INIPATH, txt);
	AjcGetRegRootPath(txt, MAX_PATH);					//	WXg[gpX
	AjcSetDlgItemStr(hDlg, IDC_TXT_ROOTPATH, txt);
	AjcGetRegMidPath(txt, MAX_PATH);					//	WXg~hpX
	MAjcStrCat(txt, MAX_PATH, TEXT("_Data"));
	AjcSetRegMidPath(txt);
	AjcSetDlgItemStr(hDlg, IDC_TXT_MIDPATH, txt);
	AjcGetProfilePath(txt, MAX_PATH);					//	WXgpX
	AjcSetDlgItemStr(hDlg, IDC_TXT_REGPATH, txt);
	AjcGetBinDataDir(txt, MAX_PATH);					//	oCif[^i[tH_pX
	AjcSetDlgItemStr(hDlg, IDC_TXT_BINPATH, txt);
	//	_CAOݒl[h
	LoadAllDlgItems(hDlg, TEXT("Settings"));
	//	I̎|ݒ
	fEndOfInit =TRUE;
	//	vt@CANZXݒ
	SetProfileInfo(hDlg);
	//	vt@Cǂݏo
	ReadSect1();
	ReadSect2();

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Conf, WM_DESTROY		)
{
	//	_CAOݒlZ[u
	SaveAllDlgItems(hDlg);

	return TRUE;
}
//----- WM_COMMAND ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Conf, WM_COMMAND		)
{
	UI		cmd = LOWORD(wParam);
	UI		act = HIWORD(wParam);

	//	I
	if (fEndOfInit) {
		//	ݒύXȂ΃vt@CANZXݒ肵Sf[^ǂݏo
		if (((cmd == IDC_RBT_INI || cmd == IDC_RBT_REG || cmd == IDC_CHK_VOLATILE) && act == BN_CLICKED) || act == EN_CHANGE) {
			SetProfileInfo(hDlg);
			ReadSect1();
			ReadSect2();
		}
	}
	return TRUE;
}
//----- INIt@CpXJ{^ ----------------------------------------------------------------------------//
AJC_DLGPROC(Conf, IDC_CMD_OPENINI	)
{
	UT		path[MAX_PATH];
	AjcGetDlgItemStr(hDlg, IDC_TXT_INIPATH, path, MAX_PATH);
	ShellExecute(NULL, TEXT("open"), path, NULL, NULL, SW_SHOWNORMAL);
	return TRUE;
}
//----- LZ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Conf, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Conf)
	AJC_DLGMAP_MSG(Conf, WM_INITDIALOG	   )
	AJC_DLGMAP_MSG(Conf, WM_DESTROY		   )
	AJC_DLGMAP_MSG(Conf, WM_COMMAND		   )

	AJC_DLGMAP_CMD(Conf, IDC_CMD_OPENINI   )
	AJC_DLGMAP_CMD(Conf, IDCANCEL		   )
AJC_DLGMAP_END
//--------------------------------------------------------------------------------------------------------------//
//	vt@CANZXݒ																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SetProfileInfo(HWND hDlg)
{
	UT		txt[MAX_PATH];

	//	f[^pvt@CL^ݒ
	if (AjcGetDlgItemChk(hDlg, IDC_RBT_INI)) {
		AjcSetProfileIsRegistory(FALSE);									//	ANZX恁INIt@C
		AjcGetDlgItemStr(hDlg, IDC_TXT_INIPATH, txt, MAX_PATH);				//	INIt@CpXݒ
		AjcSetIniFilePath(txt);
	}
	else {
		AjcSetProfileIsRegistory(TRUE);										//	ANZX恁WXg
		AjcGetDlgItemStr(hDlg, IDC_TXT_ROOTPATH, txt, MAX_PATH);			//	WXg[gpXݒ
		AjcSetRegRootPath(txt);
		AjcGetDlgItemStr(hDlg, IDC_TXT_MIDPATH, txt, MAX_PATH);				//	WXg~hpXݒ
		AjcSetRegMidPath(txt);
		AjcSetRegOptionVolatile(AjcGetDlgItemChk(hDlg, IDC_CHK_VOLATILE));	//	PvL^^ꎞL^ݒ
	}
	AjcGetDlgItemStr(hDlg, IDC_TXT_BINPATH, txt, MAX_PATH);					//	oCif[^i[pXݒ
	AjcSetBinDataDir(txt);

}
//==============================================================================================================//
//																												//
//	f[^E_CAOEvV[W																			//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	hDlgMain = hDlg;
	hVthLog	 = GetDlgItem(hDlg, IDC_VTH_LOG);

	//	vt@CeXg̃ftHglݒ
	AjcSetDlgItemUInt(hDlg, IDC_TXT_UINTDEF, defUInt);
	AjcSetDlgItemSInt(hDlg, IDC_TXT_SINTDEF, defSInt);
	AjcSetDlgItemHex (hDlg, IDC_TXT_HEXDEF , defHex );
	AjcSetDlgItemReal(hDlg, IDC_TXT_REALDEF, defReal, 2);
	AjcSetDlgItemStr (hDlg, IDC_TXT_STRDEF , defStr);

	AjcSetDlgItemUInt(hDlg, IDC_TXT_UINTWD , wdUInt);
	AjcSetDlgItemSInt(hDlg, IDC_TXT_SINTWD , wdSInt);
	AjcSetDlgItemHex (hDlg, IDC_TXT_HEXWD  , wdHex );
	AjcSetDlgItemReal(hDlg, IDC_TXT_REALWD , wdReal , 2);
	AjcSetDlgItemStr (hDlg, IDC_TXT_STRWD  , wdStr );

	AjcSetDlgItemSInt(hDlg, IDC_TXT_ARRWD0 , wdArr[0]);
	AjcSetDlgItemSInt(hDlg, IDC_TXT_ARRWD1 , wdArr[1]);
	AjcSetDlgItemSInt(hDlg, IDC_TXT_ARRWD2 , wdArr[2]);

	AjcSetDlgItemReal(hDlg, IDC_TXT_BINWD0 , wdBin[0], 2);
	AjcSetDlgItemReal(hDlg, IDC_TXT_BINWD1 , wdBin[1], 2);
	AjcSetDlgItemReal(hDlg, IDC_TXT_BINWD2 , wdBin[2], 2);
	//	_CAOݒl[h
	LoadAllDlgItems(hDlg, TEXT("Data"));
	//	vt@Cǂݏo
	ReadSect1();
	ReadSect2();

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	//	_CAOݒlZ[u
	SaveAllDlgItems(hDlg);

	return TRUE;
}
//----- UInt v{^ ------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_UINTW 	)
{
	wdUInt = AjcGetDlgItemUInt(hDlg, IDC_TXT_UINTWD);
	AjcSetDlgItemUInt(hDlg, IDC_TXT_UINTWD, wdUInt);
	AjcPutProfileUInt(TEXT("SECT1"), TEXT("KeyUInt"), wdUInt);

	return TRUE;
}
//----- UInt q{^ ------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_UINTR 	)
{
	rdUInt = AjcGetProfileUInt(TEXT("SECT1"), TEXT("KeyUInt"), defUInt);
	AjcSetDlgItemUInt(hDlg, IDC_TXT_UINTRD, rdUInt);

	return TRUE;
}
//----- UInt cdk{^ --------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_UINTDEL	)
{
	AjcDelProfileKey(TEXT("SECT1"), TEXT("KeyUInt"));
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_UINTR, BN_CLICKED), (LPARAM)GetDlgItem(hDlg, IDC_CMD_UINTR));

	return TRUE;
}
//----- SInt v{^ ------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SINTW 	)
{
	wdSInt = AjcGetDlgItemSInt(hDlg, IDC_TXT_SINTWD);
	AjcSetDlgItemSInt(hDlg, IDC_TXT_SINTWD, wdSInt);
	AjcPutProfileSInt(TEXT("SECT1"), TEXT("KeySInt"), wdSInt);

	return TRUE;
}
//----- SInt q{^ ------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SINTR 	)
{
	rdSInt = AjcGetProfileSInt(TEXT("SECT1"), TEXT("KeySInt"), defSInt);
	AjcSetDlgItemSInt(hDlg, IDC_TXT_SINTRD, rdSInt);

	return TRUE;
}
//----- SInt cdk{^ --------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SINTDEL	)
{
	AjcDelProfileKey(TEXT("SECT1"), TEXT("KeySInt"));
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_SINTR, BN_CLICKED), (LPARAM)GetDlgItem(hDlg, IDC_CMD_SINTR));

	return TRUE;
}
//----- Hex v{^ -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_HEXW		)
{
	wdHex = AjcGetDlgItemHex(hDlg, IDC_TXT_HEXWD);
	AjcSetDlgItemHex(hDlg, IDC_TXT_HEXWD, wdHex);
	AjcPutProfileHex(TEXT("SECT1"), TEXT("KeyHex"), wdHex);

	return TRUE;
}
//----- Hex q{^ -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_HEXR		)
{
	rdHex = AjcGetProfileHex(TEXT("SECT1"), TEXT("KeyHex"), defHex);
	AjcSetDlgItemHex(hDlg, IDC_TXT_HEXRD, rdHex);

	return TRUE;
}
//----- Hex cdk{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_HEXDEL	)
{
	AjcDelProfileKey(TEXT("SECT1"), TEXT("KeyHex"));
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_HEXR , BN_CLICKED), (LPARAM)GetDlgItem(hDlg, IDC_CMD_HEXR ));

	return TRUE;
}
//----- Real v{^ ------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_REALW 	)
{
	wdReal = AjcGetDlgItemReal(hDlg, IDC_TXT_REALWD);
	AjcSetDlgItemReal(hDlg, IDC_TXT_REALWD, wdReal, 2);
	AjcPutProfileReal(TEXT("SECT1"), TEXT("KeyReal"), wdReal);

	return TRUE;
}
//----- Real q{^ ------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_REALR 	)
{
	rdReal = AjcGetProfileReal(TEXT("SECT1"), TEXT("KeyReal"), defReal);
	AjcSetDlgItemReal(hDlg, IDC_TXT_REALRD, rdReal, 2);

	return TRUE;
}
//----- Real cdk{^ --------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_REALDEL	)
{
	AjcDelProfileKey(TEXT("SECT1"), TEXT("KeyReal"));
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_REALR, BN_CLICKED), (LPARAM)GetDlgItem(hDlg, IDC_CMD_REALR));

	return TRUE;
}
//----- Str v{^ -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STRW		)
{
	AjcGetDlgItemStr(hDlg, IDC_TXT_STRWD, wdStr, AJCTSIZE(wdStr));
	AjcSetDlgItemStr(hDlg, IDC_TXT_STRWD, wdStr);
	AjcPutProfileStr(TEXT("SECT1"), TEXT("KeyStr"), wdStr);

	return TRUE;
}
//----- Str q{^ -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STRR		)
{
	AjcGetProfileStr(TEXT("SECT1"), TEXT("KeyStr"), defStr, rdStr, AJCTSIZE(rdStr));
	AjcSetDlgItemStr(hDlg, IDC_TXT_STRRD, rdStr);

	return TRUE;
}
//----- Str cdk{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STRDEL	)
{
	AjcDelProfileKey(TEXT("SECT1"), TEXT("KeyStr"));
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_STRR , BN_CLICKED), (LPARAM)GetDlgItem(hDlg, IDC_CMD_STRR ));

	return TRUE;
}
//----- Arr v{^ -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_ARRW		)
{
	wdArr[0] = AjcGetDlgItemUInt(hDlg, IDC_TXT_ARRWD0);
	wdArr[1] = AjcGetDlgItemUInt(hDlg, IDC_TXT_ARRWD1);
	wdArr[2] = AjcGetDlgItemUInt(hDlg, IDC_TXT_ARRWD2);
	AjcSetDlgItemUInt(hDlg, IDC_TXT_ARRWD0, wdArr[0]);
	AjcSetDlgItemUInt(hDlg, IDC_TXT_ARRWD1, wdArr[1]);
	AjcSetDlgItemUInt(hDlg, IDC_TXT_ARRWD2, wdArr[2]);
	AjcPutProfileArr(TEXT("SECT2"), TEXT("KeyArr"), wdArr, sizeof wdArr[0], sizeof wdArr / sizeof wdArr[0]);

	return TRUE;
}
//----- Arr q{^ -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_ARRR		)
{
	if (AjcGetProfileArr(TEXT("SECT2"), TEXT("KeyArr"), rdArr, sizeof rdArr[0], sizeof rdArr / sizeof rdArr[0]) == MAX_ARR) {
		AjcSetDlgItemUInt(hDlg, IDC_TXT_ARRRD0, rdArr[0]);
		AjcSetDlgItemUInt(hDlg, IDC_TXT_ARRRD1, rdArr[1]);
		AjcSetDlgItemUInt(hDlg, IDC_TXT_ARRRD2, rdArr[2]);
	}
	else {
		AjcSetDlgItemStr(hDlg, IDC_TXT_ARRRD0, TEXT("-"));
		AjcSetDlgItemStr(hDlg, IDC_TXT_ARRRD1, TEXT("-"));
		AjcSetDlgItemStr(hDlg, IDC_TXT_ARRRD2, TEXT("-"));
	}

	return TRUE;
}
//----- Arr cdk{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_ARRDEL	)
{
	AjcDelProfileKey(TEXT("SECT2"), TEXT("KeyArr"));
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_ARRR, BN_CLICKED), (LPARAM)GetDlgItem(hDlg, IDC_CMD_ARRR));

	return TRUE;
}
//----- Bin v{^ -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_BINW		)
{
	wdBin[0] = AjcGetDlgItemReal(hDlg, IDC_TXT_BINWD0);
	wdBin[1] = AjcGetDlgItemReal(hDlg, IDC_TXT_BINWD1);
	wdBin[2] = AjcGetDlgItemReal(hDlg, IDC_TXT_BINWD2);
	AjcSetDlgItemReal(hDlg, IDC_TXT_BINWD0, wdBin[0], 2);
	AjcSetDlgItemReal(hDlg, IDC_TXT_BINWD1, wdBin[1], 2);
	AjcSetDlgItemReal(hDlg, IDC_TXT_BINWD2, wdBin[2], 2);
	AjcPutProfileBin(TEXT("SECT2"), TEXT("KeyBin"), wdBin, sizeof wdBin);

	return TRUE;
}
//----- Bin q{^ -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_BINR		)
{
	if (AjcGetProfileBin(TEXT("SECT2"), TEXT("KeyBin"), rdBin, sizeof rdBin) == sizeof rdBin) {
		AjcSetDlgItemReal(hDlg, IDC_TXT_BINRD0, rdBin[0], 2);
		AjcSetDlgItemReal(hDlg, IDC_TXT_BINRD1, rdBin[1], 2);
		AjcSetDlgItemReal(hDlg, IDC_TXT_BINRD2, rdBin[2], 2);
	}
	else {
		AjcSetDlgItemStr(hDlg, IDC_TXT_BINRD0, TEXT("-"));
		AjcSetDlgItemStr(hDlg, IDC_TXT_BINRD1, TEXT("-"));
		AjcSetDlgItemStr(hDlg, IDC_TXT_BINRD2, TEXT("-"));
	}
	return TRUE;
}
//----- Bin cdk{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_BINDEL	)
{
	AjcDelProfileKey(TEXT("SECT2"), TEXT("KeyBin"));
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_BINR, BN_CLICKED), (LPARAM)GetDlgItem(hDlg, IDC_CMD_BINR));

	return TRUE;
}
//----- SECT1 ZNV{^ -----------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SECT1DEL	)
{
	AjcDelProfileSect(TEXT("SECT1"));
	ReadSect1();

	return TRUE;
}
//----- SECT2 ZNV{^ -----------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SECT2DEL	)
{
	AjcDelProfileSect(TEXT("SECT2"));
	ReadSect2();

	return TRUE;
}
//----- ZNVW ---------------------------------------------------------------------------------------//
static BOOL CALLBACK cbEnumName (C_UTP pName, UX cbp)
{
	AjcVthPrintF(hVthLog, TEXT("  E%s\n"), pName);
	return TRUE;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJC_DLGPROC(Main, IDC_CMD_DATASECT	)
{
	int		n;
	AjcVthPrintF(hVthLog, TEXT("\n--- ZNVW ---\n"));
	n = AjcEnumProfileSect(0, cbEnumName);
	AjcVthPrintF(hVthLog, TEXT("  %d sections found.\n"), n);
	return TRUE;
}
//----- L[WiSECT1j-------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_DATAKEY1	)
{
	int		n;
	AjcVthPrintF(hVthLog, TEXT("\n--- ZNV(SECT1)̃L[W ---\n"));
	n = AjcEnumProfileKey(TEXT("SECT1"), 0, cbEnumName);
	AjcVthPrintF(hVthLog, TEXT("  %d keys found.\n"), n);
	return TRUE;
}
//----- L[WiSECT2j-------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_DATAKEY2	)
{
	int		n;
	AjcVthPrintF(hVthLog, TEXT("\n--- ZNV(SECT2)̃L[W ---\n"));
	n = AjcEnumProfileKey(TEXT("SECT2"), 0, cbEnumName);
	AjcVthPrintF(hVthLog, TEXT("  %d keys found.\n"), n);
	return TRUE;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG	   )
	AJC_DLGMAP_MSG(Main, WM_DESTROY 	   )

	AJC_DLGMAP_CMD(Main, IDC_CMD_UINTW	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_UINTR	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_UINTDEL   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_SINTW	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_SINTR	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_SINTDEL   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_HEXW	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_HEXR	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_HEXDEL    )
	AJC_DLGMAP_CMD(Main, IDC_CMD_REALW	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_REALR	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_REALDEL   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_STRW	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_STRR	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_STRDEL    )
	AJC_DLGMAP_CMD(Main, IDC_CMD_ARRW	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_ARRR	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_ARRDEL    )
	AJC_DLGMAP_CMD(Main, IDC_CMD_BINW	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_BINR	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_BINDEL    )
	AJC_DLGMAP_CMD(Main, IDC_CMD_SECT1DEL  )
	AJC_DLGMAP_CMD(Main, IDC_CMD_SECT2DEL  )
	AJC_DLGMAP_CMD(Main, IDC_CMD_DATASECT  )
	AJC_DLGMAP_CMD(Main, IDC_CMD_DATAKEY1  )
	AJC_DLGMAP_CMD(Main, IDC_CMD_DATAKEY2  )
	AJC_DLGMAP_CMD(Main, IDCANCEL		   )
AJC_DLGMAP_END
//--------------------------------------------------------------------------------------------------------------//
//	SECT1ZNV̑Sf[^ǂݏo																			//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ReadSect1(VO)
{
	SendMessage(hDlgMain, WM_COMMAND, MAKELONG(IDC_CMD_UINTR, BN_CLICKED), (LPARAM)GetDlgItem(hDlgMain, IDC_CMD_UINTR));
	SendMessage(hDlgMain, WM_COMMAND, MAKELONG(IDC_CMD_SINTR, BN_CLICKED), (LPARAM)GetDlgItem(hDlgMain, IDC_CMD_SINTR));
	SendMessage(hDlgMain, WM_COMMAND, MAKELONG(IDC_CMD_HEXR , BN_CLICKED), (LPARAM)GetDlgItem(hDlgMain, IDC_CMD_HEXR ));
	SendMessage(hDlgMain, WM_COMMAND, MAKELONG(IDC_CMD_REALR, BN_CLICKED), (LPARAM)GetDlgItem(hDlgMain, IDC_CMD_REALR));
	SendMessage(hDlgMain, WM_COMMAND, MAKELONG(IDC_CMD_STRR , BN_CLICKED), (LPARAM)GetDlgItem(hDlgMain, IDC_CMD_STRR ));
}
//--------------------------------------------------------------------------------------------------------------//
//	SECT2ZNV̑Sf[^ǂݏo																			//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ReadSect2(VO)
{
	SendMessage(hDlgMain, WM_COMMAND, MAKELONG(IDC_CMD_ARRR, BN_CLICKED), (LPARAM)GetDlgItem(hDlgMain, IDC_CMD_ARRR));
	SendMessage(hDlgMain, WM_COMMAND, MAKELONG(IDC_CMD_BINR, BN_CLICKED), (LPARAM)GetDlgItem(hDlgMain, IDC_CMD_BINR));
}
//--------------------------------------------------------------------------------------------------------------//
//	WXgL^ޔA̋L^ݒ																//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SaveRegInfo(VO)
{
	//	L^ޔ
	AjcPushProfileStack();
	//	̋L^ݒ
	AjcSetProfileIsRegistory(TRUE);
	AjcSetRegOptionVolatile(FALSE);
	AjcSetRegRootPath(TEXT("Software\\AjrCstXX"));
	AjcSetRegMidPath (TEXT("SW_Profile\\Conf"));
}
//--------------------------------------------------------------------------------------------------------------//
//	WXgL^  																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO	RecvRegInfo(VO)
{
	AjcPopProfileStack();
}
//--------------------------------------------------------------------------------------------------------------//
//	̃WXg_CAȎSڂ[h																//
//--------------------------------------------------------------------------------------------------------------//
static	VO	LoadAllDlgItems(HWND hDlg, C_UTP pSect)
{
	SaveRegInfo();												//	WXgL^ޔA̋L^ݒ
	AjcLoadAllControlSettings(hDlg, pSect, AJCCTL_SELACT_ALL);	//	_CAȎSڂ[h
	RecvRegInfo();												//	WXgL^ 	

}
//--------------------------------------------------------------------------------------------------------------//
//	̃WXgɃ_CAȎSڂZ[u																//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SaveAllDlgItems(HWND hDlg)
{
	SaveRegInfo();												//	WXgL^ޔA̋L^ݒ
	AjcSaveAllControlSettings(hDlg);							//	_CAȎSڂZ[u
	RecvRegInfo();												//	WXgL^ 	
}
