//
// SW_SSepC.c
//
#include	<AjrCstXX.h>
#include	<stdio.h>
#include	<tchar.h>

//----- CX^Xnh --------------------------------------------//
static	HAJCSSEP	hSsep;
//----- R[h ------------------------------------------------------//
#define STX 0x02
#define ETX 0x03
#define DLE 0x10
#define ESC 0x1B
//----- oCgXg[f[^ ------------------------------------------//
static	UB			Data1[] = {0x1B, '[' , 'A' , 'D' , 'E' , 'F' , 0x0D, 'G' , 'H' , 0x0D, DLE};
static	UB			Data2[] = {STX , 0x09, DLE , DLE , 0x11, DLE , ETX , 'X' , 'Y' , 0x0D};

//--------------------------------------------------------------------------------------------------------------//
//	eLXgf[^̃_v\																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO	DumpText(UTP pDat, UI lDat)
{
	AjcPrintF(TEXT("\""));
	while (lDat--) {
		if (_istcntrl(*pDat)) AjcPrintF(TEXT("\\x%02X"), *pDat);
		else				  AjcPrintF(TEXT("%c"), *pDat);
		pDat++;
	}
	AjcPrintF(TEXT("\""));
}
//--------------------------------------------------------------------------------------------------------------//
//	pPbgf[^̃_v\																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO	DumpPacket(UBP pDat, UI lDat)
{
	while (lDat--) {
		AjcPrintF(TEXT(" %02X"), *pDat++);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	CxgʒmpR[obN֐																				//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL  CALLBACK cbEvent(UI evt, VOP pDat, UI lDat, UX cbp)
{
	switch (evt) {
		case AJCSSEP_EV_TXT:					//	eLXgʒm
			AjcPrintF(TEXT("TXT  : "));
			DumpText((UTP)pDat, lDat);
			AjcPrintF(TEXT("\n"));
			break;

		case AJCSSEP_EV_ESC:					//	drbR[hʒm
			AjcPrintF(TEXT("ESC  : "));
			DumpText((UTP)pDat, lDat);
			AjcPrintF(TEXT("\n"));
			break;

		case AJCSSEP_EV_CTRL:					//	R[hʒm
			AjcPrintF(TEXT("CTRL : "));
			DumpText((UTP)pDat, lDat);
			AjcPrintF(TEXT("\n"));
			break;

		case AJCSSEP_EV_PKT:					//	pPbgf[^ʒm
			AjcPrintF(TEXT("PKT  : "));
			DumpPacket((UBP)pDat, lDat);
			AjcPrintF(TEXT("\n"));
			break;

	}
	return TRUE;	// TRUE:f[^J
}
//--------------------------------------------------------------------------------------------------------------//
//	m a i n 																									//
//--------------------------------------------------------------------------------------------------------------//
int  AjcMain(int argc, UTP argv[])
{
	AjcSetStdoutMode();

	hSsep = AjcSsepCreate(AJCSSEP_EV_ALL, 0, cbEvent);			   //  CX^X
	AjcSsepPutData(hSsep, Data1, sizeof Data1); 				   //  oCgXg[P^
	AjcSsepPutData(hSsep, Data2, sizeof Data2); 				   //  oCgXg[Q^
	AjcSsepDelete(hSsep);										   //  CX^X

	getchar();
	return 0;
}
