//
//	SW_SerialComPort3.c
//

#define AJCSOCKSERV_H_
#define AJCSOCKCLIENT_H_
#include	<AjrCstXX.h>
#include	<tchar.h>
#include	"resource.h"

#define WM_SCPEVENT 	(WM_USER + 100)

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;									//	ckkCX^Xnh
static	HWND			hDlgMain		= NULL;					//	_CAO{bNXnh
static	HWND			hVthLog			= NULL;					//	OECh

static	HAJCSCP 		hScp			= NULL;					//	VAʐMCX^Xnh
static	HBITMAP			hBmpProgImage	= NULL;					//	rbg}bvnh
static	HAJCVQUE		hVQue			= NULL;					//	L[nhio̓pX~ρj
static	HANDLE			fhInp			= INVALID_HANDLE_VALUE;	//	̓t@Cnh
static	HANDLE			fhOut			= INVALID_HANDLE_VALUE;	//	o̓t@Cnh
static	ULL				FileSize		= 0;					//	̓t@CTCY
static	UI				Unmatch			= 0;					//	rsvt@C
static	UI				ListCount		= 0;					//	St@C
static	UI				TxCount			= 0;					//	MoCgJE^
static	UI				RxCount			= 0;					//	MoCgJE^
static	BOOL			fSendBusy		= FALSE;				//	tO
static	UT				InpDir[MAX_PATH];						//	̓fBNgpX
static	UT				OutDir[MAX_PATH];						//	o̓fBNgpX
static	UT				InpFilePath[MAX_PATH];					//	̓t@CpX
static	UT				OutFilePath[MAX_PATH];					//	o̓t@CpX

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);
static	VO		EnableButtons(HWND hDlg, BOOL fbtnParam, BOOL fbtnOpen, BOOL fbtnStart, BOOL fbtnStop);
static	BOOL	SendNextFile(VO);
static	BOOL	FileOpen(VO);
static	VO		FileSend(VO);
static	BOOL CALLBACK cbFind(UI nest, UTP pPath, UTP pName, UI attrib, UI wtime, UX cbp);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;

	hInst = hInstance;

	//----- CE_CAOI[v -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DLGMAIN), NULL, AJC_DLGPROC_NAME(Main));
	ShowWindow(hDlgMain, SW_SHOW);

	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG )
{
	hDlgMain   = hDlg;
	hVthLog    = GetDlgItem(hDlg, IDC_VTH);

	//	EChʒu[h
	AjcLoadWndPos(hDlg, NULL);

	hScp = AjcScpCreateEx(TEXT("ComPortSect"), TRUE, NULL, NULL, NULL);		//	CX^X
	AjcScpSetMode(hScp, hDlg, WM_SCPEVENT, AJCSCP_CM_BIN);					//	[hݒ
	AjcScpSetEvtMask(hScp, AJCSCP_EV_PORTSTATE |							//	Cxg}XNݒ
						   AJCSCP_EV_RXCHUNK | AJCSCP_EV_RXPKT | AJCSCP_EV_TXEMPTY);
	AjcScpSetPktTimeout(hScp, 60000);	//	pPbgM^CXgiᑬʐMpɒ߂ɐݒj
	//	rbg}bv\
	AjcChangeBitmapColor((hBmpProgImage = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_PROGIMAGE ))),
													 RGB(255, 255, 255), GetSysColor(COLOR_BTNFACE));
	SendDlgItemMessage(hDlg, IDC_PIC, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hBmpProgImage);
	//	L[
	hVQue = AjcVQueCreate(0, NULL);
	//	_CAOڂ̊֘At
	MAjcSetDlgPropStr (hDlg, IDC_TXT_INPPATH  , TEXT("" ), NULL , 0);
	MAjcSetDlgPropStr (hDlg, IDC_TXT_OUTPATH  , TEXT("" ), NULL , 0);
	AjcLoadDlgProfiles(hDlg, TEXT("DlgSetting"));
	//	|[g\
	AjcSetDlgItemStr(hDlg, IDC_LBL_PORTNAME, AjcScpGetPortName(hScp));

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY	)
{
	//	EChʒuZ[u
	AjcSaveWndPos(hDlg, NULL);
	//	_CAOڂ̃Z[u
	AjcSaveDlgProfiles(hDlg, TEXT("DlgSetting"));
	AjcReleaseDlgProps(hDlg);
	//	\[X
	if (hBmpProgImage != NULL) DeleteObject(hBmpProgImage);
	if (hScp		  != NULL) AjcScpDelete(hScp);
	if (hVQue		  != NULL) AjcVQueDelete(hVQue);
	//	vOI
	PostQuitMessage(0);
	return TRUE;
}
//----- rblCxgʒm -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_SCPEVENT	)
{
	static	UI		TotalBytes = 0;
	VOP 	pDat;
	UI		len, param;

	AjcScpGetEventData(hScp, lParam, &pDat, &len, &param);				//	Cxgf[^擾
	if(wParam & AJCSCP_EV_RXCHUNK ) {									//	`Nf[^MʒmH

	}
	if(wParam & AJCSCP_EV_PORTSTATE) {									//	|[gԒʒm
		//	|[g\
		AjcSetDlgItemStr(hDlg, IDC_LBL_PORTNAME, (UTP)pDat);
		switch (param) {
			case AJCSCP_OPENED: 	// I[v
				AjcSetDlgItemStr(hDlg, IDC_LBL_PORTSTATE, TEXT("Opened"));
				AjcSetDlgItemStr(hDlg, IDC_CMD_OPEN, TEXT("N[Y"));
				EnableButtons(hDlg, FALSE, TRUE, TRUE, FALSE);
				break;

			case AJCSCP_CLOSED: 	// N[Y
				if (fSendBusy) {
					SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_STOP, BN_CLICKED), (LPARAM)hDlg);
				} 
				AjcSetDlgItemStr(hDlg, IDC_LBL_PORTSTATE, TEXT("Closed"));
				AjcSetDlgItemStr(hDlg, IDC_CMD_OPEN, TEXT("I[v"));
				EnableButtons(hDlg, TRUE, TRUE, FALSE, FALSE);
				break;

			case AJCSCP_OPENFAIL:	// I[vs
				AjcSetDlgItemStr(hDlg, IDC_LBL_PORTSTATE, TEXT("Open failure"));
				EnableButtons(hDlg, TRUE, TRUE, FALSE, FALSE);
				break;

			case AJCSCP_PORTCHG:	// ʐM\[Xω
				AjcSetDlgItemStr(hDlg, IDC_LBL_PORTSTATE, TEXT("Port changed"));
				break;
		}
	}
	else if (wParam & AJCSCP_EV_RXCHUNK) {								//	oCi`NMʒm
		if (param == 0) {
			RxCount += len;
			AjcSepDlgItemUInt(hDlg, IDC_LBL_BYTES_RX, RxCount);
		}
	}
	else if (wParam & AJCSCP_EV_RXPKT) {								//	pPbgMʒm
		//	pPbgit@CI[jȊOȂ΁AMf[^t@C֏o
		if (len != 0) {
			if (fhOut != INVALID_HANDLE_VALUE) {
				UL	bytes;
				WriteFile(fhOut, pDat, len, &bytes, NULL);
			}
		}
		//	pPbgit@CI[jȂ΁Ãt@CMցEE
		else {
			//	o̓t@CN[Y
			if (fhOut != INVALID_HANDLE_VALUE) {CloseHandle(fhOut); fhOut = INVALID_HANDLE_VALUE;}
			//	t@CRyA
			if (AjcFileCompare(InpFilePath, OutFilePath)) {
				AjcVthPrintF(hVthLog, TEXT("OK (Match)\n"));
			}
			else {
				Unmatch++;
				AjcVthPrintF(hVthLog, TEXT("\x1B[31mNG (Unmatch)\x1B[0m\n"));
			}
			//	̃t@CMJn
			SendNextFile();
		}
	}
	else if (wParam & AJCSCP_EV_TXEMPTY) {								//	Mʒm
		//	̃t@Cf[^M
		if (fhInp != INVALID_HANDLE_VALUE) {
			FileSend();
		}
	}

	AjcScpRelEventData(hScp, lParam);									//	Cxgf[^J

	return TRUE;
}
//----- LZ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL		)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//----- |[gݒ{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_PARAM	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		AjcScpDlgParamEasy(hScp, hDlg);
	}
	return TRUE;
}
//----- I[v{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_OPEN	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		if (AjcScpIsOpened(hScp)) {
			AjcScpClose(hScp);
		}
		else {
			AjcScpOpenDefault(hScp);
			EnableButtons(hDlg, FALSE, FALSE, FALSE, FALSE);
			AjcSetDlgItemStr(hDlg, IDC_LBL_PORTSTATE, TEXT("Open in progress..."));
		}
	}
	return TRUE;
}
//----- Jn{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_START	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		//	o̓pXݒ
		AjcGetDlgItemStr(hDlg, IDC_TXT_INPPATH, InpDir, MAX_PATH);
		AjcGetDlgItemStr(hDlg, IDC_TXT_OUTPATH, OutDir, MAX_PATH);
		if (InpDir[0] != 0 && OutDir[0] != 0) {
			if (MAjcStrICmp(InpDir, OutDir) != 0) {
				//	o̓pXXgNA[
				AjcVQuePurge(hVQue);
				//	t@Cio̓pXXg쐬j
				ListCount = 0;
				Unmatch	= 0;
				AjcSearchFilesEx(InpDir, TEXT("*.*"), TRUE, FALSE, 0, cbFind);
				//	tH_\Rs[
				if (ListCount != 0) {
					UT		txt[MAX_PATH * 64];
					//	o̓tH_̑St@C폜
					AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("%s ̑St@C폜܂B낵łH"), OutDir);
					if (MessageBox(hDlg, txt, TEXT("SW_SerialComPort4"), MB_YESNO) == IDYES) {
						//	t@CԍNA[
						ListCount = 0;
						//	oCgJE^NA[
						AjcSepDlgItemUInt(hDlg, IDC_LBL_BYTES_TX, TxCount = 0);
						AjcSepDlgItemUInt(hDlg, IDC_LBL_BYTES_RX, RxCount = 0);
						//	ONA[
						AjcVthClear(hVthLog);
						//	{^O[
						EnableButtons(hDlg, FALSE, FALSE, FALSE, TRUE);
						//	tH_NA[
						AjcCleanFolder(OutDir, 0, NULL);
						//	tH_\Rs[
						AjcCopyFolderStruct(InpDir, OutDir, AJCFSC_FORCETIME);
						//	t@CI[vMJn
						SendNextFile();
					}
				} else AjcVthPutText(hVthLog, TEXT("\x1B[31m̓tH_Ƀt@C܂B\x1B[0m"), -1);

			} else AjcVthPutText(hVthLog,TEXT("\x1B[31mo̓tH_łB\x1B[0m"), -1);

		} else AjcVthPutText(hVthLog, TEXT("\x1B[31mo̓tH_ݒ肳Ă܂B\x1B[0m"), -1);
	}
	return TRUE;
}
//----- ~{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STOP	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		//	MtONA[
		fSendBusy = FALSE;
		//	|[gN[Y
		AjcScpClose(hScp);
		//	t@CN[Y
		if (fhInp != INVALID_HANDLE_VALUE) {CloseHandle(fhInp); fhInp = INVALID_HANDLE_VALUE;}
		if (fhOut != INVALID_HANDLE_VALUE) {CloseHandle(fhOut); fhOut = INVALID_HANDLE_VALUE;}
		//	ObZ[W
		AjcVthPrintF(hVthLog, TEXT("\n\n--- [vobNeXgLZ܂ ---\n"));
	}
	return TRUE;
}
//----- ̓tH_ݒ{^ ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_INPPATH)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		UT	path[MAX_PATH];
		AjcGetDlgItemStr(hDlg, IDC_TXT_INPPATH, path, MAX_PATH);
		if (AjcGetFolderName(hDlg, TEXT("̓tH_"), path, path, TRUE)) {
			AjcSetDlgItemStr(hDlg, IDC_TXT_INPPATH, path);
		}
	}
	return TRUE;
}
//----- o̓tH_ݒ{^ ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_OUTPATH)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		UT	path[MAX_PATH];
		AjcGetDlgItemStr(hDlg, IDC_TXT_INPPATH, path, MAX_PATH);
		if (AjcGetFolderName(hDlg, TEXT("o̓tH_"), path, path, TRUE)) {
			AjcSetDlgItemStr(hDlg, IDC_TXT_OUTPATH, path);
		}
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG	)
	AJC_DLGMAP_MSG(Main, WM_DESTROY 	)
	AJC_DLGMAP_MSG(Main, WM_SCPEVENT	)
	AJC_DLGMAP_CMD(Main, IDCANCEL		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_PARAM	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_OPEN	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_START	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_STOP	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_INPPATH)
	AJC_DLGMAP_CMD(Main, IDC_CMD_OUTPATH)
AJC_DLGMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	t@Cʒm																							//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbFind(UI nest, UTP pPath, UTP pName, UI attrib, UI wtime, UX cbp)
{
	UT		out  [MAX_PATH];
	UT		inout[MAX_PATH * 2 + 16];

	if (!(attrib & _A_SUBDIR)) {
		ListCount++;
		//	o̓t@CpXݒiZ~R(;)ŋ؂j
		MAjcStrCpy(out, MAX_PATH, OutDir);
		AjcPathCat(out, pPath + MAjcStrLen(InpDir), MAX_PATH);
		AjcSnPrintF(inout, AJCTSIZE(inout), TEXT("%s;%s"), pPath, out);
		AjcVQueEnque(hVQue, (C_VOP)inout, ((UI)MAjcStrLen(inout) + 1) * sizeof(UT));
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
//	̃t@CM																							//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SendNextFile(VO)
{
	BOOL	rc = FALSE;

	if (FileOpen()) {
		fSendBusy = TRUE;
		FileSend();
		rc = TRUE;
	}
	else {
		fSendBusy = FALSE;
		AjcScpClose(hScp);
		AjcVthPrintF(hVthLog, TEXT("\n--- [vobNeXgI܂ ---\n"));
		AjcVthPrintF(hVthLog, TEXT("    [vobNsv : %d / %d[files]\n"), Unmatch, ListCount);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	t@CI[viTRUE:[TCYȊÕt@CI[vCFALSE:t@CȂj								//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	FileOpen(VO)
{
	BOOL	rc = FALSE;
	UTP		pInp;
	UTP		pOut;
	UT		inout[MAX_PATH * 2 + 16];

	while (AjcVQueDeque(hVQue, (VOP)inout, sizeof(inout))) {
		ListCount++;
		//	o̓pXݒ
		pInp = MAjcStrTok(inout, TEXT(";")); if (pInp != NULL) MAjcStrCpy(InpFilePath, MAX_PATH, pInp);
		pOut = MAjcStrTok(NULL , TEXT(";")); if (pOut != NULL) MAjcStrCpy(OutFilePath, MAX_PATH, pOut);
		//	O\
		AjcVthPrintF(hVthLog, TEXT("\n%3d : %s\n"), ListCount, pInp);
		AjcVthPrintF(hVthLog, TEXT("   -> %s - "), pOut);
		//	o̓t@CI[v
		fhInp = CreateFile(pInp, GENERIC_READ , 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		fhOut = CreateFile(pOut, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (fhInp != INVALID_HANDLE_VALUE && fhOut != INVALID_HANDLE_VALUE) {
			//	t@CTCYݒ
			FileSize = AjcGetFileSize(pInp);
			//	[TCYȂ΁At@CN[Y
			if (FileSize == 0) {
				AjcVthPrintF(hVthLog, TEXT("OK (Zero size)\n"));
				CloseHandle(fhInp); fhInp = INVALID_HANDLE_VALUE;
				CloseHandle(fhOut); fhOut = INVALID_HANDLE_VALUE;
			}
			//	[TCYȊOȂ΁At@[I[v|Ԃ
			else {
				rc = TRUE;
				break;
			}
		}
		else {
			Unmatch++;
			AjcVthPrintF(hVthLog, TEXT("\x1B[31mNG (Open/Creation failure)\x1B[0m\n"));
			if (fhInp != INVALID_HANDLE_VALUE) {CloseHandle(fhInp); fhInp = INVALID_HANDLE_VALUE;}
			if (fhOut != INVALID_HANDLE_VALUE) {CloseHandle(fhOut); fhOut = INVALID_HANDLE_VALUE;}
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	t@CM																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO	FileSend()
{
	UL		bytes = 0;
	UB		buf[1024];

	//	obt@TCY𒴂cf[^LȂ΁Af[^MAoCgZ
	if (FileSize > sizeof buf) {
		ReadFile(fhInp, buf, sizeof buf, &bytes, NULL);
		TxCount  += AjcScpSendPacket(hScp, buf, bytes);
		FileSize -= bytes;
	}
	//	obt@TCYȉ̎cf[^LȂ΁At@Cf[^M
	else if (FileSize != 0) {
		ReadFile(fhInp, buf, (UI)FileSize, &bytes, NULL);
		TxCount  += AjcScpSendPacket(hScp, buf, bytes);
		FileSize -= bytes;
	}
	//	cf[^Ȃ΁At@CI[pPbg𑗐M
	else {
		//	pPbgM
		TxCount += AjcScpSendPacket(hScp, buf, 0);
		//	̓t@CN[Y
		if (fhInp != INVALID_HANDLE_VALUE) {CloseHandle(fhInp); fhInp = INVALID_HANDLE_VALUE;}
	}
	//	MoCgJEg\
	AjcSepDlgItemUInt(hDlgMain, IDC_LBL_BYTES_TX, TxCount);
}
//--------------------------------------------------------------------------------------------------------------//
//	{^Q^֎~																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	EnableButtons(HWND hDlg, BOOL fbtnParam, BOOL fbtnOpen, BOOL fbtnStart, BOOL fbtnStop)
{
	AjcEnableDlgItem(hDlg, IDC_CMD_PARAM, fbtnParam);
	AjcEnableDlgItem(hDlg, IDC_CMD_OPEN , fbtnOpen );
	AjcEnableDlgItem(hDlg, IDC_CMD_START, fbtnStart);
	AjcEnableDlgItem(hDlg, IDC_CMD_STOP , fbtnStop );
}
