//
//	SW_ShowImage.c
//
#include	<AjrCstXX.h>
#include	<tchar.h>

//--------------------------------------------------------------------------------------------------------------//
//	Ɨ̈																									//
//--------------------------------------------------------------------------------------------------------------//
static	HWND			hWndMain	= NULL; 		//	CECh
static	AJC_IMGINFO 	ImgInfo;					//	C[W

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC_DEF(Main);

//==============================================================================================================//
//	W i n M a i n																								//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	WNDCLASS	wndclass;
	MSG 		msg;

	memset(&ImgInfo, 0, sizeof ImgInfo);

	//----- ECh ---------------------------------------------------------------------------------------//
	wndclass.style			= 0;
	wndclass.lpfnWndProc	= AJC_WNDPROC_NAME(Main);
	wndclass.cbClsExtra 	= 0;
	wndclass.cbWndExtra 	= 0;
	wndclass.hInstance		= hInstance;
	wndclass.hIcon			= NULL;
	wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);;
	wndclass.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= TEXT("CSW_ShowImage");
	RegisterClass (&wndclass);

	hWndMain = CreateWindow(TEXT("CSW_ShowImage"),	// window class name
							TEXT("SW_ShowImage"),	// window caption
							WS_OVERLAPPEDWINDOW,	// style
							0,						// initial x position
							0,						// initial y position
							512,					// initial x size
							384,					// initial y size
							NULL,					// parent window handle
							NULL,					// window menu handle
							hInstance,				// program instance handle
							NULL) ; 				// creation parameters

	//----- ECh\ ---------------------------------------------------------------------------------------//
	ShowWindow(hWndMain, iCmdShow);

	//----- bZ[W[v -----------------------------------------------------------------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage (&msg);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	EChEvV[W																						//
//																												//
//==============================================================================================================//
AJC_WNDPROC(Main, WM_CREATE 		)
{
	hWndMain   = hwnd;

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_DESTROY		)
{
	AjcImgFuncRelease(&ImgInfo);								//	ǂݏoς̃C[W
	PostQuitMessage(0);

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_SIZE			)
{
	InvalidateRect(hwnd, NULL, FALSE);
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_RBUTTONDOWN	)		//	ENbNŁA\C[Wt@CI
{
	static	UT	path[MAX_PATH] = {0};
	UT			txt[MAX_PATH + 64];

	if (AjcGetOpenFile(hWndMain, TEXT("C[Wt@Cݒ"),
					TEXT("All Files (*.*)/*.*/Bitmap File (*.bmp)/*.bmp/.jpg File/*.jpg/.png File/*.png/.gif File/*.gif"),
					TEXT("bmp"), path, MAX_PATH)) {

		AjcSnPrintF(txt, MAX_PATH, TEXT("SW_ShowImage (%s)"), path); //  ECh^Cg\
		SetWindowText(hwnd, txt);									 //	E
		AjcImgFuncRelease(&ImgInfo);								 //	ǂݏoς̃C[W
		if (AjcImgFuncRead	 (&ImgInfo, path)) {					 //	C[Wt@Cǂݏo
			InvalidateRect(hwnd, NULL, TRUE);						 //	ĕ`
		}
		else {
			MessageBox(hwnd, TEXT("C[W̓ǂݏos܂"), TEXT("SW_ShowImage"), MB_ICONERROR);
		}
	}
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(Main, WM_PAINT			)
{
	HDC 		hdc;
	PAINTSTRUCT ps;
	RECT		rcS, rcR, rcB;

	hdc = BeginPaint(hwnd, &ps);
	if (ImgInfo.fValid) {
		SetRect(&rcS, 0, 0, ImgInfo.width, ImgInfo.height);		//	͑`
		SetRect(&rcR, 0, 0, 500 		 , 500			 );		//	o͑`
		AjcAspGetZoomedRect(&rcS, &rcR, &rcB);					//	gk`Zo
		AjcImgFuncDraw(&ImgInfo, &rcS, hdc, &rcB);				//	C[W`
		AdjustWindowRect(&rcB, WS_OVERLAPPEDWINDOW, FALSE);		//	EChTCYC[Wɍ킹
		SetWindowPos(hwnd, NULL, 0, 0, rcB.right - rcB.left, rcB.bottom - rcB.top, SWP_NOMOVE);
	}
	else {
		UTP 	p =  TEXT("ENbNŕ\C[Wt@CIĂB");
		TextOut(hdc, 10, 10, p,  (UI)MAjcStrLen(p));
	}
	EndPaint(hwnd, &ps);

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(Main)
	AJC_WNDMAP_MSG(Main, WM_CREATE		)
	AJC_WNDMAP_MSG(Main, WM_DESTROY 	)
	AJC_WNDMAP_MSG(Main, WM_SIZE		)
	AJC_WNDMAP_MSG(Main, WM_RBUTTONDOWN )
	AJC_WNDMAP_MSG(Main, WM_PAINT		)
AJC_WNDMAP_END

