//
//	SW_StateCtrl.c
//

#include	<AjrCstXX.h>
#include	<math.h>
#include	<tchar.h>
#include	<mmsystem.h>

#include	"resource.h"

#define		SOUND_TIMES		3		//	

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;				//	ckkCX^Xnh
static	HWND			hDlgMain;			//	_CAO{bNXnh
static	HWND			hVth;				//	usgECh
static	HAJCSTC 		hStc;				//	ԑJڐnh
static	UI				CntSound;			//	񐔃JE^
static	UI				SrtTick;			//	Jn
static	UI				msTimer;			//	ݒ莞[ms]
static	UI				svSec;				//	oߕbޔ
static	HGLOBAL			hWavData;			//	Wavf[^\[X
static	VOP				pWavData;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);
static	VO		Log(C_UTP pFmt, ...);

//--------------------------------------------------------------------------------------------------------------//
//																											//
//--------------------------------------------------------------------------------------------------------------//
enum {
	AJCSTC_STS_IDLE 	,			//	0: ҋ@
	AJCSTC_STS_ACTIVE	,			//	1: ^C}쒆
	AJCSTC_STS_RINGING	,			//	2: 

	STS_NUM 						//	Ԑ
};

//--------------------------------------------------------------------------------------------------------------//
//	Cxg																									//
//--------------------------------------------------------------------------------------------------------------//
enum {
	EVT_START	,					//	0: rs`qs{^
	EVT_TMO_T0	,					//	1: ^CAEgĎ^C}(t0)^CAEg
	EVT_TMO_T1	,					//	2: Lb`^C}(t1)^CAEg
	EVT_TMO_T2	,					//	3: C^o^C}(t2)^CAEg
	EVT_OVER	,					//	4: 񐔖
	EVT_STOP	,					//	5: rsno{^

	EVT_NUM 						//	Cxg
};
//--------------------------------------------------------------------------------------------------------------//
//	vZbgt@NV																					//
//--------------------------------------------------------------------------------------------------------------//
enum {
	AJCSTC_PF_CNT_INI 	,			//	񐔏
	AJCSTC_PF_SET_TIM	,			//	Lb`^C}Ԑݒ
	AJCSTC_PF_DSP_LAP	,			//	oߎԕ\
	AJCSTC_PF_SOUND 	,			//	^񐔖`FbN
	AJCSTC_PF_QUIET 	,			//	~
	AJCSTC_PF_ENA_SRT	,			//	X^[g{^
	AJCSTC_PF_DIS_SRT	,			//	X^[g{^֎~
	AJCSTC_PF_ENA_STP	,			//	Xgbv{^
	AJCSTC_PF_DIS_STP	,			//	Xgbv{^֎~

	PF_NUM							//	vZbgt@NV
};

#define TM	AJCTM
#define SM	AJCSM
#define PF	AJCPF

//--------------------------------------------------------------------------------------------------------------//
//	̏ԁԂ֑Jڎ (IDLEԂ֑JڎASTART{^CSTOP{^֎~C~CSϒ~)			//
//--------------------------------------------------------------------------------------------------------------//
static const AJCSTC_STSACT ComTbl[STS_NUM] = {
//					 t0  t1  t2  t3 	 Pre-set functions
/* 0:IDLE	 */ { TM( R , R , R , _), PF( ENA_SRT , DIS_STP , QUIET   , __		, __	  , __		)},
/* 1:ACTIVE  */ { TM( _ , _ , _ , _), PF( __	  , __		, __	  , __		, __	  , __		)},
/* 2:RINGING */ { TM( _ , _ , _ , _), PF( __	  , __		, __	  , __		, __	  , __		)},
};
//--------------------------------------------------------------------------------------------------------------//
//	ԁ̏Ԃ֑Jڎ (IDLEԂ瑼̏Ԃ֑JڎASTART{^֎~CSTOP{^)					//
//--------------------------------------------------------------------------------------------------------------//
static const AJCSTC_STSACT RelTbl[STS_NUM] = {
//					 t0  t1  t2  t3 	 Pre-set functions
/* 0:IDLE	 */ { TM( _ , _ , _ , _), PF( DIS_SRT , ENA_STP , __	  , __		, __	  , __		)},
/* 1:ACTIVE  */ { TM( _ , _ , _ , _), PF( __	  , __		, __	  , __		, __	  , __		)},
/* 2:RINGING */ { TM( _ , _ , _ , _), PF( __	  , __		, __	  , __		, __	  , __		)},
};
//--------------------------------------------------------------------------------------------------------------//
//	ԑJڕ\																									//
//--------------------------------------------------------------------------------------------------------------//
static	const AJCSTC_EVT_NF  EvtTbl[ EVT_NUM ][ STS_NUM ] = {
//----- [ 0] - rs`qs{^ ----------------------------------------------------------------------------//
//				  NextState 	   t0  t1  t2  t3 	   Pre-set functions
/* 0:IDLE	 */{{SM( ACTIVE  ), TM( C , S , _ , _), PF( CNT_INI , SET_TIM , DSP_LAP , __	  , __		, __	  )},
/* 1:ACTIVE  */ {SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )},
/* 2:RINGING */ {SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )}},

//----- [ 1] - Ď^C}(t0)^CAEg ----------------------------------------------------------------------//
//				  NextState  	  t0  t1  t2  t3 	   Pre-set functions
/* 0:IDLE	 */{{SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )},
/* 1:ACTIVE  */ {SM( __ 	 ), TM( _ , _ , _ , _), PF( DSP_LAP , __	  , __		, __	  , __		, __	  )},
/* 2:RINGING */ {SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )}},

//----- [ 2] - Lb`^C}(t1)^CAEg ------------------------------------------------------------------//
//				  NextState 	   t0  t1  t2  t3 	   Pre-set functions
/* 0:IDLE	 */{{SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )},
/* 1:ACTIVE  */ {SM( RINGING ), TM( R , _ , C , _), PF( DSP_LAP , SOUND   , __		, __	  , __		, __	  )},
/* 2:RINGING */ {SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )}},

//----- [ 3] - C^o^C}(t2)^CAEg ------------------------------------------------------------//
//				  NextState 	   t0  t1  t2  t3 	   Pre-set functions
/* 0:IDLE	 */{{SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )},
/* 1:ACTIVE  */ {SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )},
/* 2:RINGING */ {SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, SOUND   , __		, __	  , __		, __	  )}},

//----- [ 4] - 񐔖 ------------------------------------------------------------------------------------//
//				  NextState 	   t0  t1  t2  t3 	   Pre-set functions
/* 0:IDLE	 */{{SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )},
/* 1:ACTIVE  */ {SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )},
/* 2:RINGING */ {SM( IDLE	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )}},

//----- [ 5] - rsno{^ ------------------------------------------------------------------------------//
//				  NextState 	   t0  t1  t2  t3 	   Pre-set functions
/* 0:IDLE	 */{{SM( __ 	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )},
/* 1:ACTIVE  */ {SM( IDLE	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )},
/* 2:RINGING */ {SM( IDLE	 ), TM( _ , _ , _ , _), PF( __		, __	  , __		, __	  , __		, __	  )}},
};
//--------------------------------------------------------------------------------------------------------------//
//	vZbgt@NVs@R[obN֐																//
//																												//
//	@	F	pno    - vZbgt@NVԍ															//
//				sts    - ݂̏ԃR[h																		//
//				cbp    - R[obNp^igpj 														//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbPsf(UI pno, int sts, UX cbp)
{
	switch (pno) {
		//------------------------------------------------------------------------------------------------------//
		case AJCSTC_PF_CNT_INI 	:			//	񐔏
			//	O\
			Log(TEXT("   Func: CNT_INI   - 񐔏\n"));
			//	񐔃JE^NA[
			CntSound = 0;
			break;
		//------------------------------------------------------------------------------------------------------//
		case AJCSTC_PF_SET_TIM 	:			//	Lb`^C}Ԑݒ
		{	UI	tm = AjcGetDlgItemUInt(hDlgMain, IDC_INP_MINUTE) * 60000 + AjcGetDlgItemUInt(hDlgMain, IDC_INP_SECOND) * 1000;
			//	O\
			Log(TEXT("   Func: SET_TIM   - Lb`^C}Ԑݒ(t1=%dms)\n"), tm);
			//	^C}ݒ
			SrtTick = GetTickCount();
			AjcStcSetTimerInfo(hStc, 1, tm, EVT_TMO_T1);
			break;
		}
		//------------------------------------------------------------------------------------------------------//
		case AJCSTC_PF_DSP_LAP	:			//	oߎԕ\
		{	UI	tm, second, minute;
			UT	txt[128];
			//	O\ĩO͕pɂɏo͂邽ߊj
			//	Log(TEXT("   Func: DSP_LAP   - oߎԕ\\n"));
			//	oߎԕ\
			tm = GetTickCount() - SrtTick;
			second = tm / 1000;
			minute = second / 60;
			if (second == 0 || second != svSec) {
				AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("%02d : %02d"), minute, second % 60);
				AjcSetDlgItemStr(hDlgMain, IDC_TXT_LAP, txt);
			}
			svSec = second;
			break;
		}
		//------------------------------------------------------------------------------------------------------//
		case AJCSTC_PF_SOUND 	:			//	
		{	UT	txt[128];
			//	񐔍XV
			CntSound++;
			//	O\
			AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("(%d)"), CntSound);
			Log(TEXT("   Func: SOUND     - %s\n"), txt);
			//	񐔖
			if (CntSound <= SOUND_TIMES) {
				RECT	r;
				int		w, h;
				SIZE	sz;
				//	EChɃc[`bvŁuv\
				GetWindowRect(hDlgMain, &r);
				w = r.right - r.left;
				h = r.bottom - r.top;
				AjcTipTextGetSize(0, 0, txt, NULL, TRUE, &sz);
				AjcTipTextShow(r.left + (w - sz.cx) / 2, r.top + (h - sz.cy) / 2, txt, 1000, NULL);
				//	r[v
				PlaySound((UTP)pWavData, NULL, SND_MEMORY | SND_ASYNC);
			}
			//	񐔖
			else {
				AjcStcExecEvent(hStc, EVT_OVER);
			}
			break;
		}
		//------------------------------------------------------------------------------------------------------//
		case AJCSTC_PF_QUIET 	:			//	~
			//	O\
			Log(TEXT("   Func: QUIET     - ~\n"));
			//	c[`bv
			AjcTipTextHide();
			//	~
			PlaySound(NULL, NULL, 0);
			break;
		//------------------------------------------------------------------------------------------------------//
		case AJCSTC_PF_ENA_SRT 	:			//	X^[g{^
			//	O\
			Log(TEXT("   Func: ENA_SRT   - X^[g{^\n"));
			//	X^[g{^
			AjcEnableDlgGroup(hDlgMain, IDC_GRP_START, TRUE, TRUE);
			break;
		//------------------------------------------------------------------------------------------------------//
		case AJCSTC_PF_DIS_SRT 	:			//	X^[g{^֎~
			//	O\
			Log(TEXT("   Func: DIS_SRT   - X^[g{^֎~\n"));
			//	X^[g{^֎~
			AjcEnableDlgGroup(hDlgMain, IDC_GRP_START, FALSE, FALSE);
			break;
		//------------------------------------------------------------------------------------------------------//
		case AJCSTC_PF_ENA_STP 	:			//	Xgbv{^
			//	O\
			Log(TEXT("   Func: ENA_STP   - Xgbv{^\n"));
			//	Xgbv{^
			AjcEnableDlgItem(hDlgMain, IDC_CMD_STOP, TRUE);
			break;
		//------------------------------------------------------------------------------------------------------//
		case AJCSTC_PF_DIS_STP 	:			//	Xgbv{^֎~
			//	O\
			Log(TEXT("   Func: DIS_STP   - Xgbv{^֎~\n"));
			//	Xgbv{^֎~
			AjcEnableDlgItem(hDlgMain, IDC_CMD_STOP, FALSE);
			break;
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	ԑJڒʒm@R[obN֐																				//
//																												//
//	@	F	ntc    - ʒmR[h 																			//
//				p1, p2 - ʒmp^																			//
//				cbp    - R[obNp^igpj 														//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static C_UTP	pSts[STS_NUM] = {_T("IDLE   (ҋ@)    "),
								 _T("ACTIVE (^C}쒆)"),
								 _T("RINGING()      "),
				};
static C_UTP	pEvt[EVT_NUM] = {_T("START (rs`qs{^)")  ,
								 _T("TMO_T0(^CAEgĎ^C}(t0)^CAEg)"),
								 _T("TMO_T1(Lb`^C}(t1)^CAEg)"),
								 _T("TMO_T2(C^o^C}(t2)^CAEg)"),
								 _T("OVER  (񐔖)"),
								 _T("STOP  (rsno{^)"),
				};

static	VO CALLBACK cbNtc(AJCSTC_NTC ntc, UL p1, UL p2, UX cbp)
{
	switch (ntc) {
		case AJCSTC_NTC_EVT:	Log(TEXT(" = %s, Cxg = %s\n"  ), pSts[p1], pEvt[p2]);	break;
		case AJCSTC_NTC_STS:	Log(TEXT("    J --> %s\n"	   ), pSts[p1]			);	break;
		case AJCSTC_NTC_TIMSRT: Log(TEXT("   ^C} %d START (%dms)\n" ), p1, p2			);	break;
		case AJCSTC_NTC_TIMSTP: Log(TEXT("   ^C} %d STOP\n"		   ), p1				);	break;
	}
}

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;

	hInst = hInstance;

	//	CE_CAOI[v	
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DLGMAIN), NULL, AJC_DLGPROC_NAME(Main));
	//	_CAO\	
	ShowWindow(hDlgMain, SW_SHOW);

	//	bZ[W[v	
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	hDlgMain = hDlg;
	hVth	 = GetDlgItem(hDlgMain, IDC_VTH);

	//	Wav\[X[h
	hWavData = LoadResource(hInst,
					FindResource(hInst, MAKEINTRESOURCE(IDR_WAV1), TEXT("WAV")));
	pWavData = LockResource(hWavData);

	//	`bveLXg̃tHgݒ
	AjcTipTextSetDefFont((HFONT)SendMessage(hDlg, WM_GETFONT, 0, 0));

	//	ԑJڐCX^X	
	hStc = AjcStcCreate(ComTbl, RelTbl, EvtTbl[0], STS_NUM, 0, cbPsf, cbNtc);
	//	^C}ɃCxg֘At
	AjcStcSetTimerInfo(hStc, 0,  100, EVT_TMO_T0); 	//	0: Ď^C}
	AjcStcSetTimerInfo(hStc, 2, 5000, EVT_TMO_T2); 	//	2: C^o^C}

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	//		ԑJڐCX^X
	AjcStcDelete(hStc);
	//	WAV\[X
	FreeResource(hWavData);
	//	vOI
	PostQuitMessage(0);
	return TRUE;
}
//----- START{^ --------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_START		)
{
	//	ONA[
	AjcVthClear(hVth);
	//	X^[g{^Cxg
	AjcStcExecEvent(hStc, EVT_START);
	return TRUE;
}
//----- STOP{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STOP		)
{
	//	Xgbv{^Cxg
	AjcStcExecEvent(hStc, EVT_STOP);
	return TRUE;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	//	Xgbv{^Cxg
	AjcStcExecEvent(hStc, EVT_STOP);
	//	EChN[Y
	DestroyWindow(hDlg);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG	   )
	AJC_DLGMAP_MSG(Main, WM_DESTROY 	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_START	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_STOP	   )
	AJC_DLGMAP_CMD(Main, IDCANCEL		   )
AJC_DLGMAP_END
//--------------------------------------------------------------------------------------------------------------//
//	Oo																									//
//--------------------------------------------------------------------------------------------------------------//
static	VO		Log(C_UTP pFmt, ...)
{
	static	BOOL fNeedLF = FALSE;
	static	UT	 svTxt[1024];
	va_list 	 vls;
	UT			 txt[1024] = {0};


	va_start(vls, pFmt);
	AjcVSnPrintF(txt, 1024, pFmt, vls);
	txt[1023] = 0;
	va_end	(vls);

	AjcVthTimeStamp(hVth);
	AjcVthPutText(hVth, TEXT(" "), -1);
	if (MAjcStrCmp(svTxt, txt) != 0) {
		if (fNeedLF) {
			AjcVthPutText(hVth, TEXT("\n"), -1);
			fNeedLF = FALSE;
		}
		AjcVthPutText(hVth, TEXT(" "), -1);
		AjcVthPutText(hVth, txt, -1);
		MAjcStrCpy(svTxt, AJCTSIZE(svTxt), txt);
	}
	else {
		AjcVthPutText(hVth, TEXT("EEEEEE\r"), -1);
	}
}

