//
//	SW_XYModemRx.c
//
#include	<AjrCstXX.h>
#include	<io.h>
#include	<tchar.h>
#include	<sys/stat.h>
#include	"resource.h"

#define WM_SCPEVENT 	(WM_USER + 100)

//--------------------------------------------------------------------------------------------------------------//
//	萔																										//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {COMM_232C , COMM_LAN} 				ECOMM;
typedef enum {XM_SUM, XM_CRC, XM_1K, YM_STD, YM_G}	EPROTOCOL;

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;							//	ckkCX^Xnh
static	HWND			hDlgMain;						//	_CAO{bNXnh
static	HWND			hVthLog;

static	HAJCXYM 		hXym;							//	XYMedemCX^Xnh
static	HAJCSCP 		hScp;							//	rblCX^Xnh
static	AJCXYMFILEINFO	FileInfo;						//	t@CíCTCYCtj

static	HANDLE			hFile = INVALID_HANDLE_VALUE;	//	Mt@Cnh
static	SLL 			RxRemBytes; 					//	Mt@CTCYJE^
static	UT				DirPath [MAX_PATH]; 			//	fBNgEpX
static	UT				FilePath[MAX_PATH]; 			//	t@CpX

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);

static VO CALLBACK cbNotice (UI knd, UX Param				, UX cbp);
static VO CALLBACK cbSend	(C_VOP pTxD, UI len 			, UX cbp);

static	VO				ShowOnOpened(VO);
static	VO				ShowOnClosed(VO);
static	AJCXYMPROTOCOL	SubGetProtocol		(EPROTOCOL		protocol);
static	UTP 			SubProtocolNameByRbt(EPROTOCOL		protocol);
static	UTP 			SubProtocolNameByXym(AJCXYMPROTOCOL protocol);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;

	hInst = hInstance;

	//----- CE_CAOI[v -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, AJC_DLGPROC_NAME(Main));
	ShowWindow(hDlgMain, SW_SHOW);

	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	UI	t0, t1, r0, r1;

	hDlgMain = hDlg;
	hVthLog  = GetDlgItem(hDlg, IDC_VTH_LOG);

	//--- c[`bv -------------------------------------------//
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_TXT_T0), TEXT("Mv(NAK/C/G)o[ms]"));
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_TXT_T1), TEXT("f[^^dnsM҂^C}[ms]"));
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_TXT_R1), TEXT("đv(NAK)o"));
	//--- rboCX^X ---------------------------------//
	hScp = AjcScpCreate();
	AjcScpSetMode(hScp, hDlg, WM_SCPEVENT, AJCSCP_CM_BIN);
	AjcScpSetEvtMask(hScp, AJCSCP_EV_PORTSTATE | AJCSCP_EV_RXCHUNK | AJCSCP_EV_TXEMPTY);
	//--- eLXg{bNXւ̃hbv ---------------------//
	AjcEnableDlgItemToDrop (hDlg, IDC_TXT_XM_FILE, AJCDROP_FILE);
	AjcEnableDlgItemToDrop (hDlg, IDC_TXT_YM_DIR , AJCDROP_DIR );
	//--- WI{^O[v ---------------------------------//
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_PROTOCOL));
	//--- X-Modem / Y-Modem CX^X ---------------------//
	hXym = AjcXymCreate(0, cbNotice, NULL, NULL, cbSend);
	//--- _CAOڂ̏ ---------------------------------//
	AjcXymGetRxTimeInfo(hXym, &t0, &r0, &t1, &r1);
	AjcSetDlgItemUInt(hDlg, IDC_GRP_PROTOCOL, XM_SUM  );
	AjcSetDlgItemStr (hDlg, IDC_TXT_XM_FILE , TEXT(""));
	AjcSetDlgItemStr (hDlg, IDC_TXT_YM_DIR	, TEXT(""));
	AjcSetDlgItemChk (hDlg, IDC_CHK_TXERR	 , FALSE  );
	AjcSetDlgItemUInt(hDlg, IDC_INP_TXERR	 , 0	  );
	AjcSetDlgItemUInt(hDlg, IDC_TXT_T0		 , t0	  );
	AjcSetDlgItemUInt(hDlg, IDC_TXT_R0		 , r0	  );
	AjcSetDlgItemUInt(hDlg, IDC_TXT_T1		 , t1	  );
	AjcSetDlgItemUInt(hDlg, IDC_TXT_R1		 , r1	  );
	//----- _CAOڂ̃[h -------------------------------//
	AjcLoadAllControlSettings (hDlg, TEXT("DlgSetting"), AJCOPT2(AJCCTL_SELACT_, ALL, NTCRBT));
	//--- |[gI[v -----------------------------------------//
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_OPEN, BN_CLICKED),0);

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	//----- CX^Xj ------------------------------//
	AjcScpDelete(hScp); 	//	SCPCX^X
	AjcXymDelete(hXym); 	//	X-Modem / Y-Modem CX^X
	//----- _CAOڂ̃Z[u ------------------------//
	AjcSaveAllControlSettings(hDlg);

	PostQuitMessage(0);
	return TRUE;
}
//----- rblCxgʒm -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_SCPEVENT		)
{
	UI		time = GetTickCount();
	UI		len, param;
	union {UBP pBin; UTP pTxt; VOP vp;} u;
	UT		txt[128];

	AjcScpGetEventData(hScp, lParam, &u.vp, &len, &param);				//	Cxgf[^擾
	if(wParam & AJCSCP_EV_PORTSTATE) {									//	|[gԒʒm
		switch (param) {
			case AJCSCP_CLOSED: ShowOnClosed(); break;					//		EN[Y
			case AJCSCP_OPENED: ShowOnOpened(); break;					//		EI[v
			case AJCSCP_OPENFAIL:										//		EI[vs
				AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("%s open falure!"), AjcScpGetPortPathName(hScp));
				MessageBox(hDlgMain, txt, TEXT("Error"), MB_ICONERROR);
				break;
		}
	}
	if(wParam & AJCSCP_EV_RXCHUNK ) {									//	`Nf[^MʒmioCij
		UI		i;
		UBP 	pTop, p;

		if (pTop = malloc(len)) {
			memcpy(p = pTop, u.pBin, len);
			if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_RXERR) && len >= 5) {
				if (AjcGetDlgItemSInt(hDlgMain, IDC_INP_RXERR) > (rand() % 100)) {
					*(p + 4) ^= 0xFF;
				}
			}
			for (i = 0; i < len; i++) {
				AjcXymPutRxChar(hXym, *p++);
			}
			free(pTop);
		}
		else {
			p = u.pBin;
			for (i = 0; i < len; i++) {
				AjcXymPutRxChar(hXym, *p++);
			}
		}
	}
	AjcScpRelEventData(hScp, lParam);									//	Cxgf[^J

	return TRUE;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//----- I[v^N[Y {^ ------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_OPEN		)
{
	if (AjcScpIsOpened(hScp)) {
		//	ʐMȂ΁A~{^
		if (AjcXymGetState(hXym) != 0) {
			SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_STOP, BN_CLICKED), (LPARAM)GetDlgItem(hDlg, IDC_CMD_OPEN));
		}
		//	|[gN[Y
		AjcScpClose(hScp);
	}
	else {
		//	|[gI[v
		AjcScpOpenDefault(hScp);
	}
	return TRUE;
}
//----- |[gݒ{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_EASY		)
{
	AjcScpDlgParamEasy(hScp, hDlg);
	return TRUE;
}
//----- vgȒI --------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_GRP_PROTOCOL	)
{
	if (HIWORD(wParam) == AJCRBTN_SELECT) {
		if (lParam <= XM_1K) {
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_XM_FILE), TRUE , TRUE );
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_YM_DIR ), FALSE, FALSE);
		}
		else {
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_XM_FILE), FALSE, FALSE);
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_YM_DIR ), TRUE , TRUE );
		}
	}
	return TRUE;
}
//----- wlncdlMt@Cݒ ------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_XM_FILE	)
{
	struct __stat64 st;

	if (_tstat64(FilePath, &st) != 0) {
		FilePath[0] = 0;
	}
	if (AjcGetSaveFile(hDlg, TEXT("Mt@C"), TEXT("AllFiles(*.*)/*.*"), TEXT("txt"), FilePath, MAX_PATH)) {
		AjcSetDlgItemStr(hDlg, IDC_TXT_XM_FILE, FilePath);
	}

	return TRUE;
}
//----- xlncdlMtH_ݒ ------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_YM_DIR	)
{
	if (AjcGetFolderName(hDlg, TEXT("MtH_"), TEXT("̃tH_֑SMt@Ci[܂"), DirPath, MAX_PATH)) {
		AjcSetDlgItemStr(hDlg, IDC_TXT_YM_DIR, DirPath);
	}
	return TRUE;
}
//----- MJn{^ ----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_RECV		)
{
	EPROTOCOL	protocol = (EPROTOCOL)AjcGetDlgItemUInt(hDlg, IDC_GRP_PROTOCOL);
	UI			t0 = AjcGetDlgItemUInt(hDlg, IDC_TXT_T0);
	UI			r0 = AjcGetDlgItemUInt(hDlg, IDC_TXT_R0);
	UI			t1 = AjcGetDlgItemUInt(hDlg, IDC_TXT_T1);
	UI			r1 = AjcGetDlgItemUInt(hDlg, IDC_TXT_R1);

	AjcXymSetRxTimeInfo (hXym, t0, r0, t1, r1);								//	^C}ݒ
	do {
		if (protocol <= XM_1K) {											//	w|lncdlH
			UT		drv[_MAX_DRIVE], dir[_MAX_DIR];
			AjcGetDlgItemStr(hDlg, IDC_TXT_XM_FILE, FilePath, MAX_PATH);	//		Mt@CpXݒ
			MAjcSplitPath(FilePath, drv, dir, NULL, NULL);					//		fBNgpXݒ
			MAjcMakePath (DirPath, drv, dir, NULL, NULL);					//		E
		}
		else {																//	x|lncdlH
			AjcGetDlgItemStr(hDlg, IDC_TXT_YM_DIR, DirPath, MAX_PATH);		//		i[tH_ݒ
		}

		AjcEnableGroup(GetDlgItem(hDlgMain, IDC_GRP_PROTOCOL), FALSE, FALSE);
		EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_SEND), FALSE);
		EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP), TRUE );

		AjcVthPrintF(hVthLog, TEXT("========== RECEIVING START (%s) ==========\n"), SubProtocolNameByRbt(protocol));
		AjcXymRxStart(hXym, SubGetProtocol(protocol));	//	MJn
	} while(0);

	return TRUE;
}
//----- M~{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STOP		)
{
	AjcXymStop(hXym);
	AjcEnableGroup(GetDlgItem(hDlgMain, IDC_GRP_PROTOCOL), TRUE , TRUE );
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_SEND	), TRUE );
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP	), FALSE);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG		)
	AJC_DLGMAP_MSG(Main, WM_DESTROY 		)
	AJC_DLGMAP_MSG(Main, WM_SCPEVENT		)
	AJC_DLGMAP_CMD(Main, IDCANCEL			)
	AJC_DLGMAP_CMD(Main, IDC_GRP_PROTOCOL	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_XM_FILE	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_YM_DIR 	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_OPEN		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_EASY		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_RECV		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_STOP		)
AJC_DLGMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	t@C																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubWrite(VOP pDat, UL len)
{
	UL	bytes;
	if (hFile != INVALID_HANDLE_VALUE) {
		if (RxRemBytes > (SLL)len)	{WriteFile(hFile, pDat, (UI)len 	  , &bytes, NULL); RxRemBytes -= len;}
		else				  		{WriteFile(hFile, pDat, (UI)RxRemBytes, &bytes, NULL); RxRemBytes  = 0;  }
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	Cxgʒm@R[obN֐																				//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbNotice(UI knd, UX Param, UX cbp)
{
	switch (knd) {
		case AJCXYN_RXFILEINFO: memcpy(&FileInfo, (VO*)Param, sizeof FileInfo); 				//	t@CM
								if ( AjcGetDlgItemUInt(hDlgMain, IDC_GRP_PROTOCOL) >= YM_STD) { //	  xlncdlH
									MAjcStrCpy(FilePath, MAX_PATH, DirPath);					//		  Mt@Cݒ
									AjcPathCat(FilePath, FileInfo.pFName, MAX_PATH);			//		  E
								}
								AjcVthPrintF(hVthLog, TEXT("File receive '%s'\n"), FilePath);	//		t@CO\
								RxRemBytes	= FileInfo.size;									//		Mt@CTCYݒ
								if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);			//		iÖׁjOt@CN[Y
								hFile = CreateFile(FilePath, GENERIC_WRITE, 0, NULL,			//		Mt@CI[v
									CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
								break;

		case AJCXYN_RXREC_128:	AjcVthPrintF(hVthLog, TEXT(".")); SubWrite((VO*)Param, 128);	//	PR[hMi128 aj
								break;
		case AJCXYN_RXREC_1K:	AjcVthPrintF(hVthLog, TEXT(".")); SubWrite((VO*)Param, 1024);	//	PR[hMiPjaj
								break;
		case AJCXYN_RETRY:		AjcVthPrintF(hVthLog, TEXT("R"));								//	đ
								break;
		case AJCXYN_EOF:		AjcVthPrintF(hVthLog, TEXT("E\n")); 							//	t@CI[idnej
								if (FileInfo.time) {											//		t@CtH
									SYSTEMTIME	st;
									FILETIME	ft;
									AjcTime1970ToSysTime(FileInfo.time, &st);					//			VXe^C֕ύX
									SystemTimeToFileTime(&st, &ft); 							//			t@C^CɕύX
									SetFileTime(hFile, &ft, &ft, &ft);							//			t@Cݒ
								}
								CloseHandle(hFile);
								hFile = INVALID_HANDLE_VALUE;
								break;

		case AJCXYN_PROTOCOL:	AjcVthPrintF(hVthLog, TEXT("Protocol change to '%s'\n"),		//	vgRύX
										SubProtocolNameByXym((AJCXYMPROTOCOL)Param));
								break;
		case AJCXYN_COMPLETE:	AjcVthPrintF(hVthLog, TEXT("Complete.\n"));						//	MI
								break;
		case AJCXYN_RX_CAN: 	AjcVthPrintF(hVthLog, TEXT("Stop by Received CAN\n"));			//	M~ib`mMj
								break;
		case AJCXYN_USERSTOP:	AjcVthPrintF(hVthLog, TEXT("Stop by user\n"));					//	M~i[U~j
								break;
		case AJCXYN_TIMEOUT:	AjcVthPrintF(hVthLog, TEXT("Stop by Timeout\n")); 				//	M~i^CAEgj
								break;
		case AJCXYN_ABORT:		AjcVthPrintF(hVthLog, TEXT("Stop by abort\n")); 				//	M~ȋj
								break;
	}
	if ((knd & AJCXYN_END) != 0) {		// ]I
		AjcEnableGroup(GetDlgItem(hDlgMain, IDC_GRP_PROTOCOL), TRUE, TRUE);
		EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_RECV), TRUE );
		EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP), FALSE);
		if (hFile != INVALID_HANDLE_VALUE)	CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	f[^o@R[obN֐																				//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbSend(C_VOP pTxD, UI len, UX cbp)
{
	AjcScpSendBinData(hScp, pTxD, len);
}

//--------------------------------------------------------------------------------------------------------------//
//	bnl|[gI[v̕\																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowOnOpened(VO)
{
	UT	txt[64];

	AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("t@CM SW_XYModemRx ( %s )"), AjcScpGetPortName(hScp));
	SetWindowText(hDlgMain, txt);												//	ECh^Cg
	AjcSetDlgItemStr(hDlgMain, IDC_CMD_OPEN, TEXT("CLOSE"));					//	{^tF[X
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_EASY	  ), FALSE);
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_SEND	  ), TRUE );
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP	  ), FALSE);
}
//--------------------------------------------------------------------------------------------------------------//
//	bnl|[gN[Y̕\																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowOnClosed(VO)
{
	SetWindowText(hDlgMain, TEXT("t@CM SW_XYModemRx ( Disconnect )"));	 //  ECh^Cg
	AjcSetDlgItemStr(hDlgMain, IDC_CMD_OPEN, TEXT("OPEN")); 					//	{^tF[X
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_EASY	  ), TRUE );
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_SEND	  ), FALSE);
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP	  ), FALSE);
}
//--------------------------------------------------------------------------------------------------------------//
//	vgRʒlϊ																						//
//--------------------------------------------------------------------------------------------------------------//
static AJCXYMPROTOCOL SubGetProtocol(EPROTOCOL protocol)
{
	AJCXYMPROTOCOL	rc;

	switch (protocol) {
		default:
		case XM_SUM:	rc = AJCXYP_XMODEM_SUM; 	break;
		case XM_CRC:	rc = AJCXYP_XMODEM_CRC; 	break;
		case XM_1K: 	rc = AJCXYP_XMODEM_1K;		break;
		case YM_STD:	rc = AJCXYP_YMODEM_STD; 	break;
		case YM_G:		rc = AJCXYP_YMODEM_G;		break;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	vgR擾																						//
//--------------------------------------------------------------------------------------------------------------//
static UTP SubProtocolNameByRbt(EPROTOCOL protocol)
{
	UTP 	rc = TEXT("");

	switch (protocol) {
		case XM_SUM:	rc = TEXT("X-MODEM ( SUM )");	break;
		case XM_CRC:	rc = TEXT("X-MODEM ( CRC )");	break;
		case XM_1K: 	rc = TEXT("X-MODEM ( 1KB )");	break;
		case YM_STD:	rc = TEXT("Y-MODEM" 		);	break;
		case YM_G:		rc = TEXT("Y-MODEM-G"		);	break;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	UTP SubProtocolNameByXym(AJCXYMPROTOCOL protocol)
{
	UTP 	rc = TEXT("");

	switch (protocol) {
		case AJCXYP_XMODEM_SUM: rc = TEXT("X-MODEM ( SUM )");	break;
		case AJCXYP_XMODEM_CRC: rc = TEXT("X-MODEM ( CRC )");	break;
		case AJCXYP_XMODEM_1K:	rc = TEXT("X-MODEM ( 1KB )");	break;
		case AJCXYP_YMODEM_STD: rc = TEXT("Y-MODEM" 		);	break;
		case AJCXYP_YMODEM_G:	rc = TEXT("Y-MODEM-G"		);	break;
	}
	return rc;
}
