//
//	SW_XYModemTx.c
//
#include	<AjrCstXX.h>
#include	<io.h>
#include	<tchar.h>
#include	<sys/stat.h>
#include	"resource.h"

#define WM_SCPEVENT 	(WM_USER + 100)

//--------------------------------------------------------------------------------------------------------------//
//	萔																										//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {COMM_232C , COMM_LAN} 				ECOMM;
typedef enum {XM_SUM, XM_CRC, XM_1K, YM_STD, YM_G}	EPROTOCOL;

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;							//	ckkCX^Xnh
static	HWND			hDlgMain;						//	_CAO{bNXnh
static	HWND			hVthLog;

static	HAJCXYM 		hXym;
static	HAJCSCP 		hScp;

static	BOOL			fFindFirst		= TRUE; 		//	t@CtO
static	SX				hFind			= -1;			//	t@Cnh
static	struct _tfinddata64_t	FindData;				//	t@Cʃf[^
static	HANDLE			hFile = INVALID_HANDLE_VALUE;	//	Mt@Cnh
static	SLL				TxRemBytes; 					//	Mt@CTCY
static	UT				DirPath [MAX_PATH]; 			//	fBNgEpX
static	UT				FilePath[MAX_PATH]; 			//	t@CpX
static	UT				WildCard[MAX_PATH]; 			//	ChJ[hEpX

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);

static VO CALLBACK cbGetFile(PAJCXYMFILEINFO pBuf			, UX cbp);
static VO CALLBACK cbGetData(VOP pBuf, UI len, UIP pBytes	, UX cbp);
static VO CALLBACK cbNotice (UI knd, UX Param				, UX cbp);
static VO CALLBACK cbSend	(C_VOP pTxD, UI len 			, UX cbp);

static	VO				ShowOnOpened(VO);
static	VO				ShowOnClosed(VO);
static	AJCXYMPROTOCOL	SubGetProtocol		(EPROTOCOL		protocol);
static	UTP 			SubProtocolNameByRbt(EPROTOCOL		protocol);
static	UTP 			SubProtocolNameByXym(AJCXYMPROTOCOL protocol);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;

	hInst = hInstance;

	//----- CE_CAOI[v -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, AJC_DLGPROC_NAME(Main));
	ShowWindow(hDlgMain, SW_SHOW);

	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	UI	t0, t1, r0, r1;

	hDlgMain = hDlg;
	hVthLog  = GetDlgItem(hDlg, IDC_VTH_LOG);

	//--- c[`bv -------------------------------------------//
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_TXT_T0), TEXT("Mv(NAK/C/G)M҂^C}[ms]"));
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_TXT_T1), TEXT("`bj^m`jM҂^C}[ms]"));
	AjcTipTextAdd(GetDlgItem(hDlg, IDC_TXT_R1), TEXT("f[^^dnsđx"));
	//--- rboCX^X ---------------------------------//
	hScp = AjcScpCreate();
	AjcScpSetMode(hScp, hDlg, WM_SCPEVENT, AJCSCP_CM_BIN);
	AjcScpSetEvtMask(hScp, AJCSCP_EV_PORTSTATE | AJCSCP_EV_RXCHUNK | AJCSCP_EV_TXEMPTY);
	//--- eLXg{bNXւ̃hbv ---------------------//
	AjcEnableDlgItemToDrop (hDlg, IDC_TXT_XM_FILE, AJCDROP_FILE);
	AjcEnableDlgItemToDrop (hDlg, IDC_TXT_YM_DIR , AJCDROP_DIR );
	//--- WI{^O[v ---------------------------------//
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_PROTOCOL));
	//--- X-Modem / Y-Modem CX^X ---------------------//
	hXym = AjcXymCreate(0, cbNotice, cbGetFile, cbGetData, cbSend);
	//--- _CAOڂ̏ ---------------------------------//
	AjcXymGetTxTimeInfo(hXym, &t0, &r0, &t1, &r1);
	AjcSetDlgItemUInt(hDlg, IDC_GRP_PROTOCOL, XM_SUM  );
	AjcSetDlgItemStr (hDlg, IDC_TXT_XM_FILE , TEXT(""));
	AjcSetDlgItemStr (hDlg, IDC_TXT_YM_DIR	, TEXT(""));
	AjcSetDlgItemChk (hDlg, IDC_CHK_TXERR	 , FALSE  );
	AjcSetDlgItemUInt(hDlg, IDC_INP_TXERR	 , 0	  );
	AjcSetDlgItemUInt(hDlg, IDC_TXT_T0		 , t0	  );
	AjcSetDlgItemUInt(hDlg, IDC_TXT_R0		 , r0	  );
	AjcSetDlgItemUInt(hDlg, IDC_TXT_T1		 , t1	  );
	AjcSetDlgItemUInt(hDlg, IDC_TXT_R1		 , r1	  );
	//----- _CAOڂ̃[h -------------------------------//
	AjcLoadAllControlSettings (hDlg, TEXT("DlgSetting"), AJCOPT2(AJCCTL_SELACT_, ALL, NTCRBT));
	//--- |[gI[v -----------------------------------------//
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_OPEN, BN_CLICKED),0);

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	//----- CX^Xj ------------------------------//
	AjcScpDelete(hScp); //	SCPCX^X
	AjcXymDelete(hXym); //	X-Modem / Y-Modem CX^X
	//----- _CAOڂ̃Z[u ------------------------//
	AjcSaveAllControlSettings(hDlg);

	PostQuitMessage(0);
	return TRUE;
}
//----- rboCxgʒm -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_SCPEVENT		)
{
	UI		time = GetTickCount();
	UI		len, param;
	union {UBP pBin; UTP pTxt; VOP vp;} u;
	UT		txt[128];

	AjcScpGetEventData(hScp, lParam, &u.vp, &len, &param);				//	Cxgf[^擾
	if(wParam & AJCSCP_EV_PORTSTATE) {									//	|[gԒʒm
		switch (param) {
			case AJCSCP_CLOSED: ShowOnClosed(); break;					//		EN[Y
			case AJCSCP_OPENED: ShowOnOpened(); break;					//		EI[v
			case AJCSCP_OPENFAIL:										//		EI[vs
				AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("%s open falure!"), AjcScpGetPortPathName(hScp));
				MessageBox(hDlgMain, txt, TEXT("Error"), MB_ICONERROR);
				break;
		}
	}
	if(wParam & AJCSCP_EV_RXCHUNK ) {									//	`Nf[^MʒmioCij
		UI		i;
		UBP 	p = u.pBin;
		for (i = 0; i < len; i++) {
			AjcXymPutRxChar(hXym, *p++);
		}
	}
	if(wParam & AJCSCP_EV_TXEMPTY) {									//	M
		if (hXym->knd == AJCXYP_YMODEM_G && TxRemBytes <= 0) {			//		YMODEM-G and Sf[^oς݁H
			AjcXymTxEnd(hXym);											//			YMODEM-Gt@CMʒm
		}
	}
	AjcScpRelEventData(hScp, lParam);									//	Cxgf[^J

	return TRUE;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//----- I[v^N[Y {^ ------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_OPEN		)
{
	if (AjcScpIsOpened(hScp)) {
		//	ʐMȂ΁A~{^
		if (AjcXymGetState(hXym) != 0) {
			SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_CMD_STOP, BN_CLICKED), (LPARAM)GetDlgItem(hDlg, IDC_CMD_OPEN));
		}
		//	|[gN[Y
		AjcScpClose(hScp);
	}
	else {
		//	|[gI[v
		AjcScpOpenDefault(hScp);
	}
	return TRUE;
}
//----- |[gݒ{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_EASY		)
{
	AjcScpDlgParamEasy(hScp, hDlg);
	return TRUE;
}
//----- vgȒI --------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_GRP_PROTOCOL	)
{
	if (HIWORD(wParam) == AJCRBTN_SELECT) {
		if (lParam <= XM_1K) {
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_XM_FILE), TRUE , TRUE );
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_YM_DIR ), FALSE, FALSE);
		}
		else {
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_XM_FILE), FALSE, FALSE);
			AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_YM_DIR ), TRUE , TRUE );
		}
	}
	return TRUE;
}
//----- wlncdlMt@Cݒ ------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_XM_FILE	)
{
	struct __stat64 st;
	UT				drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], fext[_MAX_EXT];

	if (_tstat64(FilePath, &st) != 0) {
		FilePath[0] = 0;
	}
	if (AjcGetOpenFile(hDlg, TEXT("Mt@C"), TEXT("AllFiles(*.*)/*.*"), TEXT("txt"), FilePath, MAX_PATH)) {
		AjcSetDlgItemStr(hDlg, IDC_TXT_XM_FILE, FilePath);
		MAjcSplitPath(FilePath, drv, dir, fname, fext);
		MAjcMakePath (DirPath , drv, dir, NULL , NULL);
	}

	return TRUE;
}
//----- xlncdlMtH_ݒ ------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_YM_DIR	)
{
	if (AjcGetFolderName(hDlg, TEXT("MtH_"), TEXT("tH_̑St@C𑗐M܂"), DirPath, MAX_PATH)) {
		AjcSetDlgItemStr(hDlg, IDC_TXT_YM_DIR, DirPath);
	}
	return TRUE;
}
//----- MJn{^ ----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SEND		)
{
	EPROTOCOL	protocol = (EPROTOCOL)AjcGetDlgItemUInt(hDlg, IDC_GRP_PROTOCOL);
	UI			t0 = AjcGetDlgItemUInt(hDlg, IDC_TXT_T0);
	UI			r0 = AjcGetDlgItemUInt(hDlg, IDC_TXT_R0);
	UI			t1 = AjcGetDlgItemUInt(hDlg, IDC_TXT_T1);
	UI			r1 = AjcGetDlgItemUInt(hDlg, IDC_TXT_R1);

	AjcXymSetTxTimeInfo (hXym, t0, r0, t1, r1);								//	^C}ݒ
	do {
		if (protocol <= XM_1K) {											//	w|lncdlH
			UT		drv[_MAX_DRIVE], dir[_MAX_DIR];
			AjcGetDlgItemStr(hDlg, IDC_TXT_XM_FILE, FilePath, MAX_PATH);	//		]t@Cݒ
			MAjcStrCpy(WildCard, AJCTSIZE(WildCard), FilePath);
			MAjcSplitPath(FilePath, drv, dir, NULL, NULL);					//		ChJ[hݒ
			MAjcMakePath (DirPath, drv, dir, NULL, NULL);					//		E
		}
		else {																//	x|lncdlH
			AjcGetDlgItemStr(hDlg, IDC_TXT_YM_DIR, DirPath, MAX_PATH);		//		]tH_ݒ
			MAjcStrCpy(WildCard, AJCTSIZE(WildCard), DirPath); 				//		ChJ[hݒ
			AjcPathCat(WildCard, TEXT("*.*"), MAX_PATH);					//		E
		}

		AjcEnableGroup(GetDlgItem(hDlgMain, IDC_GRP_PROTOCOL), FALSE, FALSE);
		EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_SEND), FALSE);
		EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP), TRUE );

		AjcVthPrintF(hVthLog, TEXT("========== TRANSFER START (%s) ==========\n"), SubProtocolNameByRbt(protocol));
		fFindFirst		= TRUE; 						//	t@CtOEZbg
		AjcXymTxStart(hXym, SubGetProtocol(protocol));	//	MJn
	} while(0);

	return TRUE;
}
//----- M~{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STOP		)
{
	AjcXymStop(hXym);
	AjcEnableGroup(GetDlgItem(hDlgMain, IDC_GRP_PROTOCOL), TRUE , TRUE );
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_SEND	), TRUE );
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP	), FALSE);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG		)
	AJC_DLGMAP_MSG(Main, WM_DESTROY 		)
	AJC_DLGMAP_MSG(Main, WM_SCPEVENT		)
	AJC_DLGMAP_CMD(Main, IDCANCEL			)
	AJC_DLGMAP_CMD(Main, IDC_GRP_PROTOCOL	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_XM_FILE	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_YM_DIR 	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_OPEN		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_EASY		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_SEND		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_STOP		)
AJC_DLGMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	t@C擾@R[obN֐																			//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbGetFile(PAJCXYMFILEINFO pBuf, UX cbp)
{
	BOOL	fEndOfFind	= FALSE;
	BOOL	fFileOpened = FALSE;

	while (!fEndOfFind	&&	!fFileOpened) {
		//----- t@C ------------------------------------------------------------//
		do {
			if (fFindFirst) {if ((hFind = _tfindfirst64(WildCard, &FindData)) == -1) fEndOfFind = TRUE;}
			else			{if (_tfindnext64(hFind, &FindData) 			  == -1) fEndOfFind = TRUE;}
			fFindFirst = FALSE;
		} while (!fEndOfFind && (FindData.attrib & (_A_HIDDEN | _A_SUBDIR | _A_SYSTEM)));

		//----- t@Cݒ --------------------------------------------------------//
		if (!fEndOfFind) {
			AjcStrCpy(FilePath,MAX_PATH, DirPath);
			AjcPathCat(FilePath, FindData.name, MAX_PATH);
			if (hFile != INVALID_HANDLE_VALUE) {
				CloseHandle(hFile);
			}
			hFile = CreateFile(FilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			if (hFile != INVALID_HANDLE_VALUE) {
				GetFileSizeEx(hFile, (LARGE_INTEGER*)&TxRemBytes);	//	t@CoCgTCYݒ
				MAjcStrCpy(FilePath, MAX_PATH, DirPath); 			//	t@CpXݒ
				AjcPathCat(FilePath, FindData.name, MAX_PATH);		//	E
				pBuf->pFName = FindData.name;						//	t@C
				GetFileSizeEx(hFile, (PLARGE_INTEGER)&pBuf->size);	//	t@CTCY
				pBuf->time	 = (UL)(FindData.time_write);			//	t@Citsbj
				AjcVthPrintF(hVthLog, TEXT("File transfer <%s>\n"), FilePath);
				fFileOpened = TRUE;
			}
			else {
				AjcVthPrintF(hVthLog, TEXT("File open failure <%s>\n"));
				fFileOpened = FALSE;
			}
		}
		else  pBuf->pFName = NULL;
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	t@Cf[^擾@R[obN֐																		//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbGetData(VOP pBuf, UI len, UIP pBytes, UX cbp)
{
	ReadFile(hFile, pBuf, len, (ULP)pBytes, NULL);			//	t@Cf[^ǂݏo
	TxRemBytes -= (*pBytes);								//	oCgJE^XV
}
//--------------------------------------------------------------------------------------------------------------//
//	Cxgʒm@R[obN֐																				//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbNotice(UI knd, UX Param, UX cbp)
{
	switch (knd) {
		case AJCXYN_TXREC:		AjcVthPrintF(hVthLog, TEXT("."));						break;	//	PR[hM
		case AJCXYN_RETRY:		AjcVthPrintF(hVthLog, TEXT("R"));						break;	//	đ
		case AJCXYN_EOF:		AjcVthPrintF(hVthLog, TEXT("E\n")); 					break;	//	t@CI[idnej
		case AJCXYN_PROTOCOL:	AjcVthPrintF(hVthLog, TEXT("Protocol change to '%s'\n"),		//	vgRύX
										SubProtocolNameByXym((AJCXYMPROTOCOL)Param));	break;
		case AJCXYN_COMPLETE:	AjcVthPrintF(hVthLog, TEXT("Complete.\n")); 			break;	//	MI
		case AJCXYN_RX_CAN: 	AjcVthPrintF(hVthLog, TEXT("Stop by Received CAN\n"));	break;	//	M~ib`mMj
		case AJCXYN_USERSTOP:	AjcVthPrintF(hVthLog, TEXT("Stop by user\n"));			break;	//	M~i[U~j
		case AJCXYN_TIMEOUT:	AjcVthPrintF(hVthLog, TEXT("Stop by Timeout\n"));		break;	//	M~i^CAEgj
		case AJCXYN_ABORT:		AjcVthPrintF(hVthLog, TEXT("Stop by abort\n")); 		break;	//	M~ȋj
	}
	if ((knd & AJCXYN_END) != 0) {		// ]I
		AjcEnableGroup(GetDlgItem(hDlgMain, IDC_GRP_PROTOCOL), TRUE , TRUE );
		EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_SEND), TRUE );
		EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP), FALSE);
		if (hFind != -1) _findclose(hFind);
		hFind = -1;
		if (hFile != INVALID_HANDLE_VALUE)	CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	f[^o@R[obN֐																				//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbSend(C_VOP pTxD, UI len, UX cbp)
{
	if (AjcGetDlgItemChk(hDlgMain, IDC_CHK_TXERR) && len >= 128) {
		UB sv;
		sv = *((UBP)pTxD + (len - 1));
		if (AjcGetDlgItemSInt(hDlgMain, IDC_INP_TXERR) > (rand() % 100)) {
			*((UBP)pTxD + (len - 1)) ^= 0xFF;
		}
		AjcScpSendBinData(hScp, pTxD, len);
		*((UBP)pTxD + (len - 1))  = sv;
	}
	else {
		AjcScpSendBinData(hScp, pTxD, len);
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	bnl|[gI[v̕\																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowOnOpened(VO)
{
	UT	txt[64];

	AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("t@CM SW_XYModemTx ( %s )"), AjcScpGetPortName(hScp));
	SetWindowText(hDlgMain, txt);										//	ECh^Cg
	AjcSetDlgItemStr(hDlgMain, IDC_CMD_OPEN, TEXT("CLOSE"));			//	{^tF[X
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_EASY	  ), FALSE);
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_SEND	  ), TRUE );
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP	  ), FALSE);
}
//--------------------------------------------------------------------------------------------------------------//
//	bnl|[gN[Y̕\																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowOnClosed(VO)
{
	SetWindowText(hDlgMain, TEXT("t@CM SW_XYModemTx ( Disconnect )"));		 //  ECh^Cg
	AjcSetDlgItemStr(hDlgMain, IDC_CMD_OPEN, TEXT("OPEN")); 			//	{^tF[X
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_EASY	  ), TRUE );
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_SEND	  ), FALSE);
	EnableWindow(GetDlgItem(hDlgMain, IDC_CMD_STOP	  ), FALSE);
}
//--------------------------------------------------------------------------------------------------------------//
//	vgRʒlϊ																						//
//--------------------------------------------------------------------------------------------------------------//
static AJCXYMPROTOCOL SubGetProtocol(EPROTOCOL protocol)
{
	AJCXYMPROTOCOL	rc;

	switch (protocol) {
		default:
		case XM_SUM:	rc = AJCXYP_XMODEM_SUM; 	break;
		case XM_CRC:	rc = AJCXYP_XMODEM_CRC; 	break;
		case XM_1K: 	rc = AJCXYP_XMODEM_1K;		break;
		case YM_STD:	rc = AJCXYP_YMODEM_STD; 	break;
		case YM_G:		rc = AJCXYP_YMODEM_G;		break;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	vgR擾																						//
//--------------------------------------------------------------------------------------------------------------//
static UTP SubProtocolNameByRbt(EPROTOCOL protocol)
{
	UTP 	rc = TEXT("");

	switch (protocol) {
		case XM_SUM:	rc = TEXT("X-MODEM ( SUM )");	break;
		case XM_CRC:	rc = TEXT("X-MODEM ( CRC )");	break;
		case XM_1K: 	rc = TEXT("X-MODEM ( 1KB )");	break;
		case YM_STD:	rc = TEXT("Y-MODEM" 		);	break;
		case YM_G:		rc = TEXT("Y-MODEM-G"		);	break;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	UTP SubProtocolNameByXym(AJCXYMPROTOCOL protocol)
{
	UTP 	rc = TEXT("");

	switch (protocol) {
		case AJCXYP_XMODEM_SUM: rc = TEXT("X-MODEM ( SUM )");	break;
		case AJCXYP_XMODEM_CRC: rc = TEXT("X-MODEM ( CRC )");	break;
		case AJCXYP_XMODEM_1K:	rc = TEXT("X-MODEM ( 1KB )");	break;
		case AJCXYP_YMODEM_STD: rc = TEXT("Y-MODEM" 		);	break;
		case AJCXYP_YMODEM_G:	rc = TEXT("Y-MODEM-G"		);	break;
	}
	return rc;
}
