//
//	SP_AVL.cpp
//
#include	<AjxCpp.h>
#include	<tchar.h>
using namespace AjxControl;

//	m[hf[^`
typedef struct {
	UTP 	pTimStr;			//	q[v̎ւ̃|C^
} NODEDATA, *PNODEDATA;

//----- CAjxAvs, CAjxCon ̔hNX --------------------------------------------------------------------------//
class CAjxAvsEx : public CAjxAvs, public CAjxCon
{
private:
	NODEDATA	m_Node;
public:
	//	RXgN^im[ho^j
	CAjxAvsEx()
	{
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited AAA")); InsNode(TEXT("AAA"), &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited BBB")); InsNode(TEXT("BBB"), &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited CCC")); InsNode(TEXT("CCC"), &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited DDD")); InsNode(TEXT("DDD"), &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited EEE")); InsNode(TEXT("EEE"), &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited FFF")); InsNode(TEXT("FFF"), &m_Node, sizeof m_Node);
	}
	//	fXgN^
	~CAjxAvsEx()
	{
		//	fXgNg OnNtcRemove() 𔭐ɂ DelAllNodes() \bhs܂
		DelAllNodes();
	}
	//	m[h폜ʒm
	VO OnNtcRemove (C_UTP pKey, VOP pNodeData, UI len, UI nest) override
	{
		SAjxCon::PrintF(TEXT("m[h폜܂ - key=%s, len=%d, nest=%d, data='%s'\n"), pKey, len, nest, ((PNODEDATA)pNodeData)->pTimStr);
		AjcTFree(((PNODEDATA)pNodeData)->pTimStr);
	}

	//	m[h񋓒ʒm
	BOOL OnNtcNode	(C_UTP pKey, VOP pNodeData, UI len, UI nest) override
	{
		PAJCAVLNODE pNode = ((PAJCAVLNODE)pNodeData) - 1;
		SAjxCon::PrintF(TEXT("%-26s:%*s, %d\n"), ((PNODEDATA)pNodeData)->pTimStr, nest * 6, pKey, pNode->bal);
		return TRUE;
	}
	//	̓eLXgʒm(ASCII)
	VO		OnNtcStr(int argc, UT *argv[], C_UTP pTxt) override
	{
		//	̓eLXg\
		SAjxCon::PrintF(TEXT("%s\n"), pTxt);
		//	R}hs
		if (argc >= 1) {
			//	m[h}
			if		(_tcsicmp(argv[0], TEXT("I")) == 0) {
				if (argc == 2) {
					if (!InsNode(argv[1], &(m_Node.pTimStr = GetTimeStr()), sizeof m_Node)) {
						if (m_Node.pTimStr != NULL) AjcTFree(m_Node.pTimStr); m_Node.pTimStr = NULL;
						SAjxCon::PrintF(TEXT("m[h̑}s܂B\n"));
					}
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	m[hu
			else if (_tcsicmp(argv[0], TEXT("R")) == 0) {
				if (argc == 2) {
					if (!RepNode(argv[1], &(m_Node.pTimStr = GetTimeStr()), sizeof m_Node)) {
						if (m_Node.pTimStr != NULL) AjcTFree(m_Node.pTimStr); m_Node.pTimStr = NULL;
						SAjxCon::PrintF(TEXT("m[h̒us܂B\n"));
					}
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	m[h̑}^u
			else if (_tcsicmp(argv[0], TEXT("X")) == 0) {
				if (argc == 2) {
					if (!InsOrRepNode(argv[1], &(m_Node.pTimStr = GetTimeStr()), sizeof m_Node)) {
						if (m_Node.pTimStr != NULL) AjcTFree(m_Node.pTimStr); m_Node.pTimStr = NULL;
						SAjxCon::PrintF(TEXT("m[h̑}^us܂B\n"));
					}
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	m[h폜
			else if (_tcsicmp(argv[0], TEXT("D"))  == 0) {
				if (argc == 2) {
					if (!DelNode(argv[1])) {
						SAjxCon::PrintF(TEXT("m[h̍폜s܂B\n"));
					}
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	Sm[hj
			else if (_tcsicmp(argv[0], TEXT("A"))  == 0) {
				if (!DelAllNodes()) {
					SAjxCon::PrintF(TEXT("Sm[h̍폜s܂B\n"));
				}
			}
			//	Sm[h\
			else if (_tcsicmp(argv[0], TEXT("P"))  == 0) {
				EnumNodes(TRUE);
			}
			//	̑
			else {
				SAjxCon::PrintF(TEXT("*** Invalid command.\n"));
			}
		}
	}

private:
	//	ݎ񐶐iݎi[AIւ̃|C^Ԃj
	UTP		GetTimeStr()
	{
		UTP			rc;
		SYSTEMTIME	st;
		UI			len;
		UT			szTim[64];

		GetLocalTime(&st);
		AjcSnPrintF(szTim, AJCTSIZE(szTim), TEXT("%02d:%02d:%02d.%03d"), st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
		len = (UI)_tcslen(szTim) + 1;
		MAjcStrCpy(rc = AjcTAlloc(len), len, szTim);
		return rc;
	}
};

//----- m a i n ------------------------------------------------------------------------------------------------//
int AjcMain()
{
	CAjxAvsEx avs;

	SAjxCon::SetStdMode();

	//	R}hj[
	SAjxCon::PrintF(TEXT("  I   SSSSS  : m[h}, key=\"SSSSS\"\n"));
	SAjxCon::PrintF(TEXT("  R   SSSSS  : m[hu, key=\"SSSSS\"\n"));
	SAjxCon::PrintF(TEXT("  X   SSSSS  : m[h̑}^u, key=\"SSSSS\"\n"));
	SAjxCon::PrintF(TEXT("  D   SSSSS  : m[h폜, key=\"SSSSS\"\n"));
	SAjxCon::PrintF(TEXT("  A          : Sm[hj\n"));
	SAjxCon::PrintF(TEXT("  P          : Sm[h\\n"));
	SAjxCon::PrintF(TEXT("  <ESC>L[  : I\n"));
	SAjxCon::PrintF(TEXT("\n"));

	//	m[h\
	avs.EnumNodes(TRUE);
	//	R}h͂j[s
	SAjxCon::PrintF(TEXT("Input(%3u) - "), avs.GetCount());
	while (avs.Input(TEXT(""))) {
		SAjxCon::PrintF(TEXT("Input(%3u) - "), avs.GetCount());
	}
	return 0;
}
