//
//	SP_LZH.cpp
//
#include	<AjxCpp.h>
#include	<tchar.h>
#include	<direct.h>
using namespace AjxControl;

//----- CAjxLzh̔hNX ------------------------------------------------------------------------------------//
class CAjxLzhEx : public CAjxLzh
{
public:
	FILE*	m_hFileLzh;
	//	RXgN^
	CAjxLzhEx()
	{
		m_hFileLzh = NULL;
	}
	//	LZHt@CI[v
	errno_t OpenLzhFile(UTP pPath)
	{
		return _tfopen_s(&m_hFileLzh, pPath, TEXT("rb"));
	}
	//	LZHt@CN[Y
	VO		CloseLzhFile()
	{
		if (m_hFileLzh != NULL) {
			fclose(m_hFileLzh);
			m_hFileLzh = NULL;
		}
	}
	//	t@Cǂݏov
	UI		OnRead		(VOP pBuf, UI lBuf) override
	{
		return (UI)fread(pBuf, 1, lBuf, m_hFileLzh);
	}
	//	t@Cǂݏoʒuݒv
	VO		OnSeek		(UL  ofs)	override
	{
		fseek(m_hFileLzh, ofs, SEEK_SET);
	}
};

CAjxLzhEx	lzh;

//----- m a i n ------------------------------------------------------------------------------------------------//
int AjcMain(int argc, UTP argv[])
{
	UW			crc;						//	bqbZo[N
	AJCLZHERR	err;						//	kygfR[h G[R[h
	HAJCLZH 	hLzhSearch = NULL;			//	kygnhipj
	HAJCLZH 	hLzhRead   = NULL;			//	kygnhiǏopj
	FILE		*hFileLzh  = NULL;			//	kygɃt@CEnh
	FILE		*hFileOut  = NULL;			//	o̓t@Cnh
	UT			szPath	  [MAX_PATH];		//	pXҏW[N
	UT			szTopDir  [MAX_PATH];		//	擪tH_pX
	BOOL		fIgnoreDir = TRUE;			//	fBNgtO
	AJCLZHFILEINFO	FInfo;					//	t@C
	UT			drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], fext[_MAX_EXT];
	UI			rbytes; 					//	ǂݏooCg
	UB			buf[1024];					//	ǂݏoobt@

	SAjxCon::SetStdMode();

	//	kyg(.lzh)t@CI[v
	if (argc >= 2 && lzh.OpenLzhFile(argv[1]) == 0) {
		//	gbvtH_ݒ
		MAjcSplitPath(argv[1] , drv, dir, fname, fext);
		MAjcMakePath (szTopDir, drv, dir, NULL , NULL);
		//	ɓ̃t@C
		if ((hLzhSearch = lzh.FindFirst(TEXT("*.*"))) != NULL) {
			//	ɓ̑St@C[v
			do {
				//----- t@C擾 ---------------------------------------------------------------------------//
				lzh.GetFileInfo(hLzhSearch, &FInfo);
				//----- tH_쐬 -------------------------------------------------------------------------------//
				if (FInfo.szDirName[0] != 0) {
					UTP 	p;
					UT		tmp [MAX_PATH];
					MAjcStrCpy(szPath, AJCTSIZE(szPath), szTopDir);
					MAjcStrCpy(tmp, AJCTSIZE(tmp), FInfo.szDirName);
					if (p = MAjcStrTok(tmp, TEXT("\\"))) {
						do {
							AjcPathCat(szPath, p, MAX_PATH);
							 _tmkdir(szPath);
						} while (p = MAjcStrTok(NULL, TEXT("\\")));
					}
				}
				//----- t@Co -------------------------------------------------------------------------------//
				if (hLzhRead = lzh.Open(FInfo.szPathName, 0)) {
					SAjxCon::PrintF(TEXT("Extracting %s - "), FInfo.szFileName);
					MAjcStrCpy(szPath, MAX_PATH, szTopDir);
					AjcPathCat(szPath, FInfo.szPathName, MAX_PATH);
					if (_tfopen_s(&hFileOut, szPath, TEXT("wb")) == 0) {
						//	t@Co͂ƂbqbZo
						crc = 0;
						while (rbytes = lzh.Read(hLzhRead, buf, sizeof buf)) {
							crc = AjcPartCrc16R(buf, rbytes, crc);
							fwrite(buf, 1, rbytes, hFileOut);
						}
						//	bqb`FbN
						if ((err = lzh.GetLastError()) == AJCLZHERR_OK) {
							if (crc == hLzhRead->crc) SAjxCon::PrintF(TEXT("OK\n"));
							else					  SAjxCon::PrintF(TEXT("NG (CRC error)\n"));
						}
						else {
							SAjxCon::PrintF(TEXT("NG (err = 0x%04X)\n"), err);
						}
						//	o̓t@CEN[Y
						fclose(hFileOut);
					}
					else {
						SAjxCon::PrintF(TEXT("NG (Creation failure)\n"));
					}
					// kygǂݏonhEN[Y
					lzh.Close(hLzhRead);
				}
				else {
					SAjxCon::PrintF(TEXT("File not found (%s)\n"), FInfo.szPathName);
				}
			} while(lzh.FindNext(hLzhSearch));
			// kygnhEN[Y
			lzh.Close(hLzhSearch);
		}
		else {
			SAjxCon::PrintF(TEXT("kygɓɃt@C܂\n"));
		}
		//	kyg(.lzh)t@C N[Y
		lzh.CloseLzhFile();
	}
	else {
		SAjxCon::PrintF(TEXT("kygɃt@C̃I[vs\n"));
	}

	SAjxCon::PrintF(TEXT("Hit Enter Key!!"));
	getchar();
	return 0;
}
