//
//	SP_MBX.cpp
//
#include	<AjxCpp.h>
#include	<tchar.h>
#include	<process.h>

using namespace AjxControl;

static const UTP pTxt[] = {TEXT("kC"), TEXT("{錧"), TEXT("s"), TEXT("{"), TEXT("")};
static	BOOL	fThreadBusy = FALSE;
static	CRITICAL_SECTION	cs;

//	m[hf[^
typedef struct {
	UT		str[32];
} NODE, *PNODE;

//	CAjxMbx̔hNX
class CAjxMbxEx : public CAjxMbx
{
	//	m[hʒm
	VO OnNtcRemove	(VOP pNodeData) override
	{	PNODE pNode = (PNODE)pNodeData;
		SAjxCon::PrintF(TEXT(" Removed %s\n"), pNode->str);
	}
};

//----- [f[^\ ---------------------------------------------------------------------------------------//
VO		PrintData(PNODE pNode, C_UTP pAct, C_UTP pName)
{
	EnterCriticalSection(&cs);
	SAjxCon::PrintF(TEXT(" %s %s by %s.\n"), pAct, pNode->str, pName);
	LeaveCriticalSection(&cs);
}

//----- TuXbh -------------------------------------------------------------------------------------------//
VO		SubThread(VOP vop)
{
	CAjxMbx* p = (CAjxMbx*)vop;
	NODE	node;

	for (;;) {
		//	CXbh̒ʒmf[^\
		if (p->Deque(&node)) {
			PrintData(&node, TEXT("Deque"), TEXT("Sub-thread\n"));
			//	f[^ "s" Ȃ΁AXbhI
			if (_tcscmp(node.str, TEXT("s")) == 0) {
				break;
			}
		}
	}
	//	TuXbhI
	fThreadBusy = FALSE;
	_endthread();
}


//----- m a i n ------------------------------------------------------------------------------------------------//
int AjcMain()
{
	CAjxMbxEx	mbx;

	SAjxCon::SetStdMode();

	InitializeCriticalSection(&cs);

	//	TuXbh
	fThreadBusy = TRUE;
	_beginthread(SubThread, 0, (VOP)&mbx);
	//	m[h̃ftHgTCYݒ
	mbx.SetDefSize(sizeof(NODE));
	//	m[h}
	for (int i = 0; i < 5; i++) {
		NODE		node;
		_tcscpy_s(node.str, 32, pTxt[i]);
		mbx.Enque(&node);
		PrintData(&node, TEXT("Enque"), TEXT("Main"));
		Sleep(100);
	}
	SAjxCon::PrintF(TEXT("\n"));
	//	TuXbh̏I҂
	while (fThreadBusy) Sleep(1);
	//	cm[h
	mbx.Purge();

	DeleteCriticalSection(&cs);

	SAjxCon::PrintF(TEXT("\nHit Enter Key"));
	getchar();
	return 0;
}
