#ifndef	AJCCTRLTIMECHART_H_
#define	AJCCTRLTIMECHART_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcTchLoadPermInfo		AjcTchLoadPermInfoW
	#define	AjcTchLoadPermInfoEx	AjcTchLoadPermInfoExW
	#define	AjcTchSavePermInfoEx	AjcTchSavePermInfoExW
	#define	AjcTchSetPermAtt		AjcTchSetPermAttW
	#define	AjcTchSetPermAttEx		AjcTchSetPermAttExW
	#define	AjcTchLoadProp			AjcTchLoadPropW
	#define	AjcTchSaveProp			AjcTchSavePropW
	#define	AjcTchLoadPropEx		AjcTchLoadPropExW
	#define	AjcTchSavePropEx		AjcTchSavePropExW
	#define	AjcTchSetTipText		AjcTchSetTipTextW
	#define	AjcTchGetTipText		AjcTchGetTipTextW
	#define	AjcTchSetChkBoxTipText	AjcTchSetChkBoxTipTextW
	#define	AjcTchGetChkBoxTipText	AjcTchGetChkBoxTipTextW
	#define	AjcTchGetDroppedFile	AjcTchGetDroppedFileW
	#define	AjcTchGetDroppedDir		AjcTchGetDroppedDirW
	#define	AjcTchGetDroppedDirEx	AjcTchGetDroppedDirExW
	#define	AjcTchSetTitleText		AjcTchSetTitleTextW
	#define	AjcTchTextOut			AjcTchTextOutW
	#define	AjcTchPrintF			AjcTchPrintFW
	#define	AjcTchGetText			AjcTchGetTextW
#else
	#define	AjcTchLoadPermInfo		AjcTchLoadPermInfoA
	#define	AjcTchLoadPermInfoEx	AjcTchLoadPermInfoExA
	#define	AjcTchSavePermInfoEx	AjcTchSavePermInfoExA
	#define	AjcTchSetPermAtt		AjcTchSetPermAttA
	#define	AjcTchSetPermAttEx		AjcTchSetPermAttExA
	#define	AjcTchLoadProp			AjcTchLoadPropA
	#define	AjcTchSaveProp			AjcTchSavePropA
	#define	AjcTchLoadPropEx		AjcTchLoadPropExA
	#define	AjcTchSavePropEx		AjcTchSavePropExA
	#define	AjcTchSetTipText		AjcTchSetTipTextA
	#define	AjcTchGetTipText		AjcTchGetTipTextA
	#define	AjcTchSetChkBoxTipText	AjcTchSetChkBoxTipTextA
	#define	AjcTchGetChkBoxTipText	AjcTchGetChkBoxTipTextA
	#define	AjcTchGetDroppedFile	AjcTchGetDroppedFileA
	#define	AjcTchGetDroppedDir		AjcTchGetDroppedDirA
	#define	AjcTchGetDroppedDirEx	AjcTchGetDroppedDirExA
	#define	AjcTchSetTitleText		AjcTchSetTitleTextA
	#define	AjcTchTextOut			AjcTchTextOutA
	#define	AjcTchPrintF			AjcTchPrintFA
	#define	AjcTchGetText			AjcTchGetTextA
#endif
//--------------------------------------------------------------------------------------------------------------//
//	Rg[̃X^C																						//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTCS_NOBORDER		0x0080			//	Bit7   : Og\
#define	AJCTCS_NOSCALELINE	0x0040			//	Bit6   : XP[EC\
#define	AJCTCS_NOSCALEVALUE	0x0020			//	Bit5   : XP[l\
#define	AJCTCS_NOFILTER		0x0010			//	Bit4   : tB^\
#define	AJCTCS_NOSCROLLBAR	0x0008			//	Bit3   : XN[o[\

//--------------------------------------------------------------------------------------------------------------//
//	g`ԕ\																							//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCTCIPK_WND	 = 0	,				//	\f[^
	AJCTCIPK_ALL			,				//	Sf[^
	AJCTCIPK_NEW			,				//	ŐVf[^
} AJCTCIPKND;

#define	AJCTCIS_IPKND(X)	(((AJCTCIPKND)(X)) == AJCTCIPK_WND || ((AJCTCIPKND)(X)) == AJCTCIPK_ALL || ((AJCTCIPKND)(X)) == AJCTCIPK_NEW)

//--------------------------------------------------------------------------------------------------------------//
//	g`ԕ																									//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTCMIN_IPWID		2			//	ŏԕ
#define	AJCTCMAX_IPWID		100			//	őԕ

//--------------------------------------------------------------------------------------------------------------//
//	g`ԕ\																							//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	AJCTCIPKND	IpKnd;					//	g`ԕ\
	UI			IpNum;					//	ŐVf[^\̍őf[^
	UI			IpWidth;				//	ԕ\ig`̈L΂{j
} AJCTCIPINFO, *PAJCTCIPINFO;
typedef const AJCTCIPINFO *PCAJCTCIPINFO;

//--------------------------------------------------------------------------------------------------------------//
//	Rg[̃vpeB																					//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTC_MAXBUF	100000
#define	AJCTC_MAXITEM	8

typedef struct {
	double		ofs;					//	ItZbgiۂ̃f[^lɉlj
	COLORREF	rgb;					//	\F
} AJCTCITEM, *PAJCTCITEM;

typedef struct {
	double		RngL, RngH;				//	Ot㉺̍Wl
	UI			TmScale;				//	^CXP[\iXP[c̕CO͏c\j
	UI			MaxBuf;					//	őf[^
	UI			MaxItem;				//	őACe
	UI			AveNum;					//	ω
	AJCTCITEM	Item[AJCTC_MAXITEM];	//	ACeEvpeB
} AJCTCPROP, *PAJCTCPROP;
typedef const AJCTCPROP *PCAJCTCPROP;

//--------------------------------------------------------------------------------------------------------------//
//	Wʒm																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	double	RngL;		//	OtWʒl
	double	RngH;		//	OtWʒl
} AJCTC_NTC_RANGE, *PAJCTC_NTC_RANGE;
typedef const AJCTC_NTC_RANGE *PCAJCTC_NTC_RANGE;

//--------------------------------------------------------------------------------------------------------------//
//	ENbNʒm																							//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	int			x;									//	J[\W
	int			y;									//	J[\W
	BOOL		fShift;								//	SHIFTL[tO
	BOOL		fCtrl;								//	CTRL L[tO
} AJCTCRCLK, *PAJCTCRCLK;
typedef const AJCTCRCLK *PCAJCTCRCLK;

//--------------------------------------------------------------------------------------------------------------//
//	ԌvQ[W																							//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	BOOL		fGauEnable;							//	Q[WtO
	UI			GauBarL;							//	Q[Wʒu
	UI			GauBarH;							//	Q[Wʒu
	BOOL		fGauUseMes;							//	PʎԁvltO
	UI			GauSetUTime;						//	Pʎԁiݒlj[us]
} AJCTCGAUINFO, *PAJCTCGAUINFO;
typedef const AJCTCGAUINFO *PCAJCTCGAUINFO;

//--------------------------------------------------------------------------------------------------------------//
//																										//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTCH_SOLID		PS_SOLID			/*								*/
#define	AJCTCH_DASH			PS_DASH				/*	_ij			-------		*/
#define	AJCTCH_DOT			PS_DOT				/*	_iZj			.......		*/
#define	AJCTCH_DASHDOT		PS_DASHDOT			/*	P_			_._._._		*/
#define	AJCTCH_DASHDOTDOT	PS_DASHDOTDOT		/*	Q_			_.._.._		*/
#define	AJCTCH_NULL			PS_NULL				/*								*/
#define	AJCTCH_INSIDEFRAME	PS_INSIDEFRAME		/*	CTCht[				*/

//--------------------------------------------------------------------------------------------------------------//
//	i																									//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTCH_PERM_FILTER		0x0001	//	tB^I
#define	AJCTCH_PERM_RANGE		0x0002	//	W
#define	AJCTCH_PERM_OTHER		0x0080	//	̑

#define	AJCTCH_PERM_ALL			0x00FF	//	LS

#define	AJCTCH_PERM_BYLOAD		0x8000	//	[hɎw肳ꂽliZ[û݁j

//--------------------------------------------------------------------------------------------------------------//
//	Rg[̃bZ[W																					//
//--------------------------------------------------------------------------------------------------------------//
//----- ʒmbZ[W -----------------------------------------------------------------------------------------//
#define	AJCTCN_RANGE				(WM_APP + 20)	//	OtWʒm		|					PAJCTC_NTC_RANGE
#define	AJCTCN_SCRPOS				(WM_APP + 21)	//	XN[ʒuʒm		|					NX[ʒu
#define	AJCTCN_CLEAR				(WM_APP + 22)	//	f[^NA[ʒm		|					|
#define	AJCTCN_DBLCLK				(WM_APP + 23)	//	_uNbNʒm		|					|
#define	AJCTCN_DROPFILE				(WM_APP + 24)	//	t@Chbvʒm	|					t@C
#define	AJCTCN_DROPDIR				(WM_APP + 25)	//	tH_hbvʒm	|					fBNg
#define	AJCTCN_RCLICK				(WM_APP + 26)	//	ENbNʒm			|					PAJCTCRCLK

//----- gpbZ[W -------------------------------------------------------------------------------------//
#define	AJCTCM_NEEDNTC_RANGE		(WM_APP + 90)	//	Wʒmv

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTchStop			(HWND hwnd);
AJCEXPORT	BOOL		WINAPI	AjcTchStart			(HWND hwnd);
AJCEXPORT	BOOL		WINAPI	AjcTchPurge			(HWND hwnd);
AJCEXPORT	BOOL		WINAPI	AjcTchPutRealData	(HWND hwnd, double dat[]);
AJCEXPORT	BOOL		WINAPI	AjcTchPutIntData	(HWND hwnd, int    dat[]);

AJCEXPORT	BOOL		WINAPI	AjcTchShowBorder	(HWND hwnd, BOOL fShow, COLORREF rgb);
AJCEXPORT	BOOL		WINAPI	AjcTchShowFilter	(HWND hwnd, BOOL fShow);
AJCEXPORT	BOOL		WINAPI	AjcTchShowScale 	(HWND hwnd, BOOL fLine, BOOL fValue);

AJCEXPORT	BOOL		WINAPI	AjcTchGetProp		(HWND hwnd, PAJCTCPROP	pBuf);
AJCEXPORT	BOOL		WINAPI	AjcTchSetProp		(HWND hwnd, PCAJCTCPROP pProp);

AJCEXPORT	BOOL		WINAPI	AjcTchGetRealRange	(HWND hwnd, double *low, double *high);
AJCEXPORT	BOOL		WINAPI	AjcTchSetRealRange	(HWND hwnd, double	low, double  high);
AJCEXPORT	BOOL		WINAPI	AjcTchGetIntRange	(HWND hwnd, int    *low, int	*high);
AJCEXPORT	BOOL		WINAPI	AjcTchSetIntRange	(HWND hwnd, int 	low, int	 high);
AJCEXPORT	BOOL		WINAPI	AjcTchAdjustRange	(HWND hwnd);
AJCEXPORT	BOOL		WINAPI	AjcTchSetBufSize	(HWND hwnd, int n);
AJCEXPORT	BOOL		WINAPI	AjcTchSetItemNumber (HWND hwnd, int n);
AJCEXPORT	BOOL		WINAPI	AjcTchSetAveNumber	(HWND hwnd, int n);
AJCEXPORT	BOOL		WINAPI	AjcTchSetTimeScale	(HWND hwnd, int n);

AJCEXPORT	HBITMAP		WINAPI	AjcTchGetBitmap 	(HWND hwnd);

AJCEXPORT	BOOL		WINAPI	AjcTchLoadPermInfoA		(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix);
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPermInfoW		(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix);

AJCEXPORT	BOOL		WINAPI	AjcTchLoadPermInfoExA	(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem);
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPermInfoExW	(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem);

AJCEXPORT	BOOL		WINAPI	AjcTchSavePermInfo		(HWND hwnd);

AJCEXPORT	BOOL		WINAPI	AjcTchSavePermInfoExA	(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem);
AJCEXPORT	BOOL		WINAPI	AjcTchSavePermInfoExW	(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem);

AJCEXPORT	BOOL		WINAPI	AjcTchSetPermAttA	(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix);
AJCEXPORT	BOOL		WINAPI	AjcTchSetPermAttW	(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix);

AJCEXPORT	BOOL		WINAPI	AjcTchSetPermAttExA	(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem);
AJCEXPORT	BOOL		WINAPI	AjcTchSetPermAttExW	(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem);

AJCEXPORT	BOOL		WINAPI	AjcTchLoadPropA 	(HWND hwnd, C_BCP pProfileSect, PCAJCTCPROP pDefProp);
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPropW 	(HWND hwnd, C_WCP pProfileSect, PCAJCTCPROP pDefProp);

AJCEXPORT	BOOL		WINAPI	AjcTchSavePropA 	(HWND hwnd, C_BCP pProfileSect);
AJCEXPORT	BOOL		WINAPI	AjcTchSavePropW 	(HWND hwnd, C_WCP pProfileSect);

AJCEXPORT	BOOL		WINAPI	AjcTchLoadPropExA	(HWND hwnd, C_BCP pProfileSect, PCAJCTCPROP pDefProp);
AJCEXPORT	BOOL		WINAPI	AjcTchLoadPropExW	(HWND hwnd, C_WCP pProfileSect, PCAJCTCPROP pDefProp);

AJCEXPORT	BOOL		WINAPI	AjcTchSavePropExA	(HWND hwnd, C_BCP pProfileSect);
AJCEXPORT	BOOL		WINAPI	AjcTchSavePropExW	(HWND hwnd, C_WCP pProfileSect);

AJCEXPORT	BOOL		WINAPI	AjcTchEnablePopupMenu(HWND hwnd, BOOL fEnable);
AJCEXPORT	BOOL		WINAPI	AjcTchSetNtcRClk	 (HWND hwnd, BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp);

AJCEXPORT	BOOL		WINAPI	AjcTchSetTipTextA	(HWND hwnd, C_BCP pTxt);
AJCEXPORT	BOOL		WINAPI	AjcTchSetTipTextW	(HWND hwnd, C_WCP pTxt);

AJCEXPORT	BOOL		WINAPI	AjcTchGetTipTextA	(HWND hwnd, BCP pBuf, UI lBuf);
AJCEXPORT	BOOL		WINAPI	AjcTchGetTipTextW	(HWND hwnd, WCP pBuf, UI lBuf);

AJCEXPORT	BOOL		WINAPI	AjcTchSetTipShowAlways(HWND hwnd, BOOL fShowAlways);
AJCEXPORT	BOOL		WINAPI	AjcTchGetTipShowAlways(HWND hwnd);

AJCEXPORT	BOOL		WINAPI	AjcTchSetChkBoxTipShowAlways(HWND hwnd, UI n, BOOL fShowAlways);
AJCEXPORT	BOOL		WINAPI	AjcTchGetChkBoxTipShowAlways(HWND hwnd, UI n);

AJCEXPORT	BOOL		WINAPI	AjcTchSetTipShowAlwaysAll(HWND hwnd, BOOL fShowAlways);

AJCEXPORT	BOOL		WINAPI	AjcTchSetChkBoxTipTextA(HWND hwnd, UI n, C_BCP pTxt);
AJCEXPORT	BOOL		WINAPI	AjcTchSetChkBoxTipTextW(HWND hwnd, UI n, C_WCP pTxt);

AJCEXPORT	BOOL		WINAPI	AjcTchGetChkBoxTipTextA(HWND hwnd, UI n, BCP pBuf, UI lBuf);
AJCEXPORT	BOOL		WINAPI	AjcTchGetChkBoxTipTextW(HWND hwnd, UI n, WCP pBuf, UI lBuf);

AJCEXPORT	BOOL		WINAPI	AjcTchSetMaxLineDist(HWND hwnd, double MaxLineDist);
AJCEXPORT	double		WINAPI	AjcTchGetMaxLineDist(HWND hwnd);

AJCEXPORT	int			WINAPI	AjcTchGetScrollPos	(HWND hwnd);
AJCEXPORT	BOOL		WINAPI	AjcTchSetScrollPos	(HWND hwnd, int pos);

AJCEXPORT	BOOL		WINAPI	AjcTchSetFilter 	(HWND hwnd, UI n, BOOL state);
AJCEXPORT	BOOL		WINAPI	AjcTchGetFilter 	(HWND hwnd, UI n);

AJCEXPORT	BOOL		WINAPI	AjcTchSetHLineAtt (HWND hwnd, UI id, COLORREF color, int width, int style);
AJCEXPORT	BOOL		WINAPI	AjcTchSetHLinePos (HWND hwnd, UI id, double pos);
AJCEXPORT	BOOL		WINAPI	AjcTchEnableHLine (HWND hwnd, UI id, BOOL fEnable);

AJCEXPORT	BOOL		WINAPI	AjcTchSetVLine	 (HWND hwnd, COLORREF color, int width, int style);
AJCEXPORT	BOOL		WINAPI	AjcTchEnableVLine(HWND hwnd, BOOL fEnable);

AJCEXPORT	BOOL		WINAPI	AjcTchSetPoint	 (HWND hwnd, int r);
AJCEXPORT	BOOL		WINAPI	AjcTchEnablePoint(HWND hwnd, BOOL fEnable);

AJCEXPORT	BOOL		WINAPI	AjcTchGetDroppedFileA (HWND hwnd, BC buf[MAX_PATH]);
AJCEXPORT	BOOL		WINAPI	AjcTchGetDroppedFileW (HWND hwnd, WC buf[MAX_PATH]);

AJCEXPORT	BOOL		WINAPI	AjcTchGetDroppedDirA  (HWND hwnd, BC buf[MAX_PATH]);
AJCEXPORT	BOOL		WINAPI	AjcTchGetDroppedDirW  (HWND hwnd, WC buf[MAX_PATH]);

AJCEXPORT	BOOL		WINAPI AjcTchGetDroppedDirExA (HWND hwnd, BC buf[MAX_PATH], BOOL fTailIsDelimiter);
AJCEXPORT	BOOL		WINAPI AjcTchGetDroppedDirExW (HWND hwnd, WC buf[MAX_PATH], BOOL fTailIsDelimiter);

AJCEXPORT	BOOL		WINAPI AjcTchSetTitleTextA(HWND hwnd, C_BCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont);
AJCEXPORT	BOOL		WINAPI AjcTchSetTitleTextW(HWND hwnd, C_WCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont);

AJCEXPORT	BOOL		WINAPI AjcTchSetIpInfo(HWND hwnd, PCAJCTCIPINFO pInfo);
AJCEXPORT	BOOL		WINAPI AjcTchGetIpInfo(HWND hwnd, PAJCTCIPINFO	pBuf );

AJCEXPORT	BOOL		WINAPI AjcTchPause(HWND hwnd, BOOL fPause);

AJCEXPORT	BOOL		WINAPI AjcTchEnableMesDraw(HWND hwnd, BOOL fEnable);

AJCEXPORT	BOOL		WINAPI AjcTchMesPeriShow   (HWND hwnd, BOOL fShow);
AJCEXPORT	BOOL		WINAPI AjcTchMesPeriReset  (HWND hwnd);
AJCEXPORT	UI			WINAPI AjcTchMesPeriGet    (HWND hwnd);

AJCEXPORT	BOOL		WINAPI AjcTchGetGauInfo(HWND hwnd, PAJCTCGAUINFO pBuf);


AJCEXPORT	HFONT		WINAPI	AjcTchSetTextFont	(HWND hwnd, HFONT hFont);

AJCEXPORT	UI			WINAPI	AjcTchTextOutA		(HWND hwnd, int x, int y, C_BCP pTxt);
AJCEXPORT	UI			WINAPI	AjcTchTextOutW		(HWND hwnd, int x, int y, C_WCP pTxt);

AJCEXPORT	UI			WINAPI	AjcTchPrintFA		(HWND hwnd, int x, int y, C_BCP pFmt, ...);
AJCEXPORT	UI			WINAPI	AjcTchPrintFW		(HWND hwnd, int x, int y, C_WCP pFmt, ...);

AJCEXPORT	UI			WINAPI	AjcTchGetTextA		(HWND hwnd, UI key, BCP pBuf, UI lBuf);
AJCEXPORT	UI			WINAPI	AjcTchGetTextW		(HWND hwnd, UI key, WCP pBuf, UI lBuf);

AJCEXPORT	BOOL		WINAPI	AjcTchClearText		(HWND hwnd, UI key);
AJCEXPORT	BOOL		WINAPI	AjcTchClearAllText	(HWND hwnd);

AJCEXPORT	BOOL		WINAPI	AjcTchClear			(HWND hwnd);

AJCEXPORT	HWND		WINAPI	AjcTchGetMainWindow	(HWND hwnd, COLORREF *pBkGnd);

//----- ʒm擾 -------------------------------------------------------------------------------------------//
AJCEXPORT	PAJCTCRCLK			WINAPI AjcTchGetNtcRClk		(HWND hwnd);
AJCEXPORT	UI					WINAPI AjcTchGetNtcDirs		(HWND hwnd);
AJCEXPORT	UI					WINAPI AjcTchGetNtcFiles	(HWND hwnd);
AJCEXPORT	PAJCTC_NTC_RANGE	WINAPI AjcTchGetNtcRng		(HWND hwnd);
AJCEXPORT	UI					WINAPI AjcTchGetNtcScrPos	(HWND hwnd);


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpECh																						//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
AJCEXPORT HWND WINAPI AjcTchCreateForMSIL(HWND hOwner, BOOL fShowScrollBar, VO (CALLBACK *cbRengeChanged)(double low, double high),
																			VO (CALLBACK *cbNtcScrollPos)(UI pos ),
																			VO (CALLBACK *cbFileDrop	)(UI n	 ),
																			VO (CALLBACK *cbDirDrop 	)(UI n	 ),
																			VO (CALLBACK *cbRClick)(int x, int y, BOOL shift, BOOL ctrl));
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpX^C̐ݒ^擾֐																			//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//----- Rg[̊OgE\^\	(AJCTCS_NOBORDER) --------------------------------------------------//
AJCEXPORT BOOL WINAPI AjcTchGetSty_NOBORDER    (HWND hwnd		 );
AJCEXPORT VO   WINAPI AjcTchSetSty_NOBORDER    (HWND hwnd, BOOL f);

//----- XP[C\^\			(AJCTCS_NOSCALELINE) -----------------------------------------------//
AJCEXPORT BOOL WINAPI AjcTchGetSty_NOSCALELINE (HWND hwnd		 );
AJCEXPORT VO   WINAPI AjcTchSetSty_NOSCALELINE (HWND hwnd, BOOL f);

//----- XP[lE\^\			(AJCTCS_NOSCALELINE) -----------------------------------------------//
AJCEXPORT BOOL WINAPI AjcTchGetSty_NOSCALEVALUE(HWND hwnd		 );
AJCEXPORT VO   WINAPI AjcTchSetSty_NOSCALEVALUE(HWND hwnd, BOOL f);

//----- tB^\^\				(AJCTCS_NOFILTER) --------------------------------------------------//
AJCEXPORT BOOL WINAPI AjcTchGetSty_NOFILTER    (HWND hwnd		 );
AJCEXPORT VO   WINAPI AjcTchSetSty_NOFILTER    (HWND hwnd, BOOL f);

//----- XN[o[\^\			(AJCTCS_NOSCROLLBAR) -----------------------------------------------//
AJCEXPORT BOOL WINAPI AjcTchGetSty_NOSCROLLBAR (HWND hwnd		 );
AJCEXPORT VO   WINAPI AjcTchSetSty_NOSCROLLBAR (HWND hwnd, BOOL f);

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpvpeB̐ݒ^擾֐																		//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//----- ʃWl 		(RngL) -----------------------------------------------------------------------------//
AJCEXPORT double WINAPI AjcTchGetProp_RngL(HWND hwnd);
AJCEXPORT VO	 WINAPI AjcTchSetProp_RngL(HWND hwnd, double n);

//----- ʃWl 		(RngH) -----------------------------------------------------------------------------//
AJCEXPORT double WINAPI AjcTchGetProp_RngH(HWND hwnd);
AJCEXPORT VO	 WINAPI AjcTchSetProp_RngH(HWND hwnd, double n);

//----- ̃\	(TmScale) --------------------------------------------------------------------------//
AJCEXPORT UI	 WINAPI AjcTchGetProp_TmScale(HWND hwnd);
AJCEXPORT VO	 WINAPI AjcTchSetProp_TmScale(HWND hwnd, UI n);

//----- obt@e		(MaxBuf) ---------------------------------------------------------------------------//
AJCEXPORT UI	 WINAPI AjcTchGetProp_MaxBuf(HWND hwnd);
AJCEXPORT VO	 WINAPI AjcTchSetProp_MaxBuf(HWND hwnd, UI n);

//----- őf[^ڐ	(MaxItem) --------------------------------------------------------------------------//
AJCEXPORT UI	 WINAPI AjcTchGetProp_MaxItem(HWND hwnd);
AJCEXPORT VO	 WINAPI AjcTchSetProp_MaxItem(HWND hwnd, UI n);

//----- ω			(AveNum) ---------------------------------------------------------------------------//
AJCEXPORT UI	 WINAPI AjcTchGetProp_AveNum(HWND hwnd);
AJCEXPORT VO	 WINAPI AjcTchSetProp_AveNum(HWND hwnd, UI n);

//----- ItZbg			(Item[ix].ofs) ---------------------------------------------------------------------//
AJCEXPORT double WINAPI AjcTchGetProp_ofs(HWND hwnd, UI ix);
AJCEXPORT VO	 WINAPI AjcTchSetProp_ofs(HWND hwnd, UI ix, double n);

//----- \F				(Item[ix].rgb) ---------------------------------------------------------------------//
AJCEXPORT UI	 WINAPI AjcTchGetProp_rgb(HWND hwnd, UI ix);
AJCEXPORT VO	 WINAPI AjcTchSetProp_rgb(HWND hwnd, UI ix, UI n);

//----- g`ԕ\ ---------------------------------------------------------------------------------------//
AJCEXPORT UI	 WINAPI AjcTchGetProp_IpKnd(HWND hwnd);
AJCEXPORT VO	 WINAPI AjcTchSetProp_IpKnd(HWND hwnd, UI n);

//----- ŐVf[^ԕ\̍őf[^ ---------------------------------------------------------------------//
AJCEXPORT UI	 WINAPI AjcTchGetProp_IpNum(HWND hwnd);
AJCEXPORT VO	 WINAPI AjcTchSetProp_IpNum(HWND hwnd, UI n);

//----- ԕ\ig`̈L΂{j ---------------------------------------------------------------------//
AJCEXPORT UI	 WINAPI AjcTchGetProp_IpWidth(HWND hwnd);
AJCEXPORT VO	 WINAPI AjcTchSetProp_IpWidth(HWND hwnd, UI n);

//----- EChTCY -----------------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcTchSetProp_WndSize(HWND hwnd, UI width, UI height);

//----- t@CCtH_ hbv̋^֎~ ----------------------------------------------------------------//
AJCEXPORT VO	WINAPI AjcTchSetProp_AcceptFiles(HWND hwnd, BOOL fEnable);
AJCEXPORT BOOL	WINAPI AjcTchGetProp_AcceptFiles(HWND hwnd);

//----- `bveLXgݒ^擾 -------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTchSetTipTextForMSIL(HWND hwnd, C_WCP pTxt);
AJCEXPORT	UI		WINAPI	AjcTchGetTipTextForMSIL(HWND hwnd, WCP pBuf, UI lBuf);

//----- `FbN{bNX̃`bveLXgݒ^擾 -------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTchSetChkBoxTipTextForMSIL(HWND hwnd, UI n, C_WCP pTxt);
AJCEXPORT	UI		WINAPI	AjcTchGetChkBoxTipTextForMSIL(HWND hwnd, UI n, WCP pBuf, UI lBuf);

//----- f[^^ ---------------------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI	AjcTchPutData1	(HWND hwnd, double dat0);
AJCEXPORT VO WINAPI	AjcTchPutData2	(HWND hwnd, double dat0, double dat1);
AJCEXPORT VO WINAPI	AjcTchPutData3	(HWND hwnd, double dat0, double dat1, double dat2);
AJCEXPORT VO WINAPI	AjcTchPutData4	(HWND hwnd, double dat0, double dat1, double dat2, double dat3);
AJCEXPORT VO WINAPI	AjcTchPutData5	(HWND hwnd, double dat0, double dat1, double dat2, double dat3, double dat4);
AJCEXPORT VO WINAPI	AjcTchPutData6	(HWND hwnd, double dat0, double dat1, double dat2, double dat3, double dat4, double dat5);
AJCEXPORT VO WINAPI	AjcTchPutData7	(HWND hwnd, double dat0, double dat1, double dat2, double dat3, double dat4, double dat5, double dat6);
AJCEXPORT VO WINAPI	AjcTchPutData8	(HWND hwnd, double dat0, double dat1, double dat2, double dat3, double dat4, double dat5, double dat6, double dat7);


/****************************************************************************************************************/
#endif
