#ifndef	AJCDATEANDTIME_H_
#define	AJCDATEANDTIME_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcDateStr					AjcDateStrW
	#define	AjcTimeStr					AjcTimeStrW
	#define	AjcSetDateFromText			AjcSetDateFromTextW
	#define	AjcSetDateFromTextEx		AjcSetDateFromTextExW
	#define	AjcSetTimeFromText			AjcSetTimeFromTextW
	#define	AjcSetTimeFromTextEx		AjcSetTimeFromTextExW
	#define	AjcSetDateAndTimeFromText 	AjcSetDateAndTimeFromTextW
	#define	AjcSetDateAndTimeFromTextEx	AjcSetDateAndTimeFromTextExW
#else
	#define	AjcDateStr					AjcDateStrA
	#define	AjcTimeStr					AjcTimeStrA
	#define	AjcSetDateFromText			AjcSetDateFromTextA
	#define	AjcSetDateFromTextEx		AjcSetDateFromTextExA
	#define	AjcSetTimeFromText			AjcSetTimeFromTextA
	#define	AjcSetTimeFromTextEx		AjcSetTimeFromTextExA
	#define	AjcSetDateAndTimeFromText 	AjcSetDateAndTimeFromTextA
	#define	AjcSetDateAndTimeFromTextEx	AjcSetDateAndTimeFromTextExA
#endif

/*--------------------------------------------------------------------------------------------------------------*/
/*	twtO																							*/
/*--------------------------------------------------------------------------------------------------------------*/
#define	AJCDATEFLAG_YYMMDD	0x8000		/*	N̏Ŏw													*/
#define	AJCDATEFLAG_MMDDYY	0x4000		/*	N̏Ŏw													*/
#define	AJCDATEFLAG_DDMMYY	0x2000		/*	N̏Ŏw													*/
#define	AJCDATEFLAG_MMYYDD	0x1000		/*	N̏Ŏw													*/

#define	AJCDATEFLAG_FORM	0xF000

#define	AJCDATEFLAG_ADJUST	0x0080		/*	N1970`2105A1`12A1`28,29,30 or 31͈͓̔ɕ␳		*/
#define	AJCDATEFLAG_SETDEF	0x0040		/*	w̍ڂɋKliN=2000, =1, =1jݒ肷				*/
#define	AJCDATEFLAG_SETDOW	0x0020		/*	j(wDayOfWeek)ݒ肷											*/

#define	AJCTIMEFLAG_ADJUST	0x0008		/*	00`23A00`59Ab00`58C~b=000`999͈͓̔ɕ␳	*/
#define	AJCTIMEFLAG_SETDEF	0x0004		/*	w̎ڂɋKliOjݒ肷							*/

/*--------------------------------------------------------------------------------------------------------------*/
/*	vg^Cv																								*/
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT	BOOL	WINAPI	AjcTime1970ToSysTime(UI Time1970, LPSYSTEMTIME pStime);
AJCEXPORT	UI		WINAPI	AjcSysTimeToTime1970 (const SYSTEMTIME *pStime);
AJCEXPORT	BOOL	WINAPI	AjcSysTimeToLocalTime(const SYSTEMTIME *pStime, LPSYSTEMTIME pLtime);
AJCEXPORT	BOOL	WINAPI	AjcTimeUpdate(const SYSTEMTIME *pStime, LPSYSTEMTIME pUpdated, int Second);

AJCEXPORT	BCP		WINAPI	AjcDateStrA(const SYSTEMTIME *pStime);
AJCEXPORT	WCP		WINAPI	AjcDateStrW(const SYSTEMTIME *pStime);

AJCEXPORT	BCP		WINAPI	AjcTimeStrA(const SYSTEMTIME *pStime, BOOL fMilliseconds);
AJCEXPORT	WCP		WINAPI	AjcTimeStrW(const SYSTEMTIME *pStime, BOOL fMilliseconds);

AJCEXPORT	BOOL	WINAPI	AjcSetDateFromTextA				(C_BCP pDateText, LPSYSTEMTIME pSt, BCP *pNext);
AJCEXPORT	BOOL	WINAPI	AjcSetDateFromTextW				(C_WCP pDateText, LPSYSTEMTIME pSt, WCP *pNext);

AJCEXPORT	BOOL	WINAPI	AjcSetDateFromTextExA			(C_BCP pDateText, LPSYSTEMTIME pSt, BCP *pNext, UI flag, BC dlm);
AJCEXPORT	BOOL	WINAPI	AjcSetDateFromTextExW			(C_WCP pDateText, LPSYSTEMTIME pSt, WCP *pNext, UI flag, WC dlm);

AJCEXPORT	BOOL	WINAPI	AjcSetTimeFromTextA				(C_BCP pTimeText, LPSYSTEMTIME pSt, BCP *pNext);
AJCEXPORT	BOOL	WINAPI	AjcSetTimeFromTextW				(C_WCP pTimeText, LPSYSTEMTIME pSt, WCP *pNext);

AJCEXPORT	BOOL	WINAPI	AjcSetTimeFromTextExA			(C_BCP pTimeText, LPSYSTEMTIME pSt, BCP *pNext, UI flag, BC dlm, BC dms);
AJCEXPORT	BOOL	WINAPI	AjcSetTimeFromTextExW			(C_WCP pTimeText, LPSYSTEMTIME pSt, WCP *pNext, UI flag, WC dlm, WC dms);

AJCEXPORT	BOOL	WINAPI	AjcSetDateAndTimeFromTextA 		(C_BCP pText	, LPSYSTEMTIME pSt, BCP *pNext);
AJCEXPORT	BOOL	WINAPI	AjcSetDateAndTimeFromTextW 		(C_WCP pText	, LPSYSTEMTIME pSt, WCP *pNext);

AJCEXPORT	BOOL	WINAPI	AjcSetDateAndTimeFromTextExA	(C_BCP pText	, LPSYSTEMTIME pSt, BCP *pNext, UI flag, BC dlm_d, BC dlm_t, BC dms);
AJCEXPORT	BOOL	WINAPI	AjcSetDateAndTimeFromTextExW	(C_WCP pText	, LPSYSTEMTIME pSt, WCP *pNext, UI flag, WC dlm_d, WC dlm_t, WC dms);

AJCEXPORT	BOOL	WINAPI	AjcGetRandomDateAndTime (LPSYSTEMTIME pSt, LPSYSTEMTIME pStSrt, LPSYSTEMTIME pStEnd);

/*--------------------------------------------------------------------------------------------------------------*/
/*	lrhkT|[gp																							*/
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT	BOOL	WINAPI	AjcMsilTime1970ToSysTime(UI Time1970, UIP pYear, UIP pMonth, UIP pDay, UIP pHour, UIP pMinute, UIP pSecond);
AJCEXPORT	UI		WINAPI	AjcMsilSysTimeToTime1970(UI Year, UI Month, UI Day, UI Hour, UI Minute, UI Second);
AJCEXPORT	BOOL	WINAPI	AjcMsilSysTimeToLocalTime(UIP pYear, UIP pMonth, UIP pDay, UIP pHour, UIP pMinute, UIP pSecond);


/****************************************************************************************************************/
#endif
