#ifndef	AJCDLGITEM_H_
#define	AJCDLGITEM_H_
/****************************************************************************************************************/

/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define		AjcGetDlgItemStr 				AjcGetDlgItemStrW
	#define		AjcGetDlgItemStrLen				AjcGetDlgItemStrLenW
	#define		AjcGetDlgItemCboLen				AjcGetDlgItemCboLenW
	#define		AjcGetDlgItemCboItem			AjcGetDlgItemCboItemW
	#define		AjcGetDlgItemCboFind			AjcGetDlgItemCboFindW
	#define		AjcGetDlgItemCboMaxLen			AjcGetDlgItemCboMaxLenW
	#define		AjcSetDlgItemStr 				AjcSetDlgItemStrW
	#define		AjcSetDlgItemEdtLimit			AjcSetDlgItemEdtLimitW
	#define		AjcSetDlgItemCboAdd				AjcSetDlgItemCboAddW
	#define		AjcSetDlgItemCboIns				AjcSetDlgItemCboInsW
	#define		AjcSetDlgItemCboList			AjcSetDlgItemCboListW
	#define		AjcSetDlgItemCboLimit			AjcSetDlgItemCboLimitW
	#define		AjcSetDlgPropUInt				AjcSetDlgPropUIntW
	#define		AjcSetDlgPropSInt				AjcSetDlgPropSIntW
	#define		AjcSetDlgPropHex 				AjcSetDlgPropHexW
	#define		AjcSetDlgPropReal				AjcSetDlgPropRealW
	#define		AjcSetDlgPropU8					AjcSetDlgPropUI8W
	#define		AjcSetDlgPropSI8				AjcSetDlgPropSI8W
	#define		AjcSetDlgPropH8 				AjcSetDlgPropH8W
	#define		AjcSetDlgPropUI16				AjcSetDlgPropUI16W
	#define		AjcSetDlgPropSI16				AjcSetDlgPropSI16W
	#define		AjcSetDlgPropH16 				AjcSetDlgPropH16W
	#define		AjcSetDlgPropUI64				AjcSetDlgPropUI64W
	#define		AjcSetDlgPropSI64				AjcSetDlgPropSI64W
	#define		AjcSetDlgPropH64 				AjcSetDlgPropH64W
	#define		AjcSetDlgPropChk 				AjcSetDlgPropChkW
	#define		AjcSetDlgPropStr				AjcSetDlgPropStrW
	#define		AjcSetDlgItemFStr				AjcSetDlgItemFStrW
	#define		AjcSetDlgPropCbo				AjcSetDlgPropCboW
	#define		AjcLoadDlgProfiles 				AjcLoadDlgProfilesW
	#define		AjcSaveDlgProfiles 				AjcSaveDlgProfilesW
	#define		AjcRefreshDlgValues				AjcRefreshDlgValuesW
	#define		AjcGetDlgValues    				AjcGetDlgValuesW
	#define		AjcSetDlgValues    				AjcSetDlgValuesW
	#define		AjcReleaseDlgProps				AjcReleaseDlgPropsW

	#define		MAjcSetDlgPropUInt				MAjcSetDlgPropUIntW
	#define		MAjcSetDlgPropSInt				MAjcSetDlgPropSIntW
	#define		MAjcSetDlgPropHex				MAjcSetDlgPropHexW
	#define		MAjcSetDlgPropReal				MAjcSetDlgPropRealW
	#define		MAjcSetDlgPropUI8				MAjcSetDlgPropUI8W
	#define		MAjcSetDlgPropSI8				MAjcSetDlgPropSI8W
	#define		MAjcSetDlgPropH8				MAjcSetDlgPropH8W
	#define		MAjcSetDlgPropUI16				MAjcSetDlgPropUI16W
	#define		MAjcSetDlgPropSI16				MAjcSetDlgPropSI16W
	#define		MAjcSetDlgPropH16				MAjcSetDlgPropH16W
	#define		MAjcSetDlgPropUI64				MAjcSetDlgPropUI64W
	#define		MAjcSetDlgPropSI64				MAjcSetDlgPropSI64W
	#define		MAjcSetDlgPropH64				MAjcSetDlgPropH64W
	#define		MAjcSetDlgPropChk				MAjcSetDlgPropChkW
	#define		MAjcSetDlgPropStr				MAjcSetDlgPropStrW
	#define		MAjcSetDlgPropCbo				MAjcSetDlgPropCboW

	#define		AjcDlgLoadGrpControlSettings	AjcDlgLoadGrpControlSettingsW
	#define		AjcDlgSaveGrpControlSettingsEx	AjcDlgSaveGrpControlSettingsExW
	#define		AjcDlgItemLoadTextBox			AjcDlgItemLoadTextBoxW
	#define		AjcDlgItemLoadTextBoxEx			AjcDlgItemLoadTextBoxExW
	#define		AjcDlgItemSaveTextBox			AjcDlgItemSaveTextBoxW
	#define		AjcDlgItemSaveTextBoxEx			AjcDlgItemSaveTextBoxExW
	#define		AjcDlgItemLoadChkBox			AjcDlgItemLoadChkBoxW
	#define		AjcDlgItemSaveChkBox			AjcDlgItemSaveChkBoxW
	#define		AjcDlgItemComboBox				AjcDlgItemComboBoxW
	#define		AjcDlgItemLoadComboBox			AjcDlgItemLoadComboBoxW
	#define		AjcDlgItemSaveComboBox			AjcDlgItemSaveComboBoxW
	#define		AjcDlgItemIsComboBoxSaved		AjcDlgItemIsComboBoxSavedW
	#define		AjcDlgItemLoadListBox			AjcDlgItemLoadListBoxW
	#define		AjcDlgItemSaveListBox			AjcDlgItemSaveListBoxW

#else
	#define		AjcGetDlgItemStr 				AjcGetDlgItemStrA
	#define		AjcGetDlgItemStrLen				AjcGetDlgItemStrLenA
	#define		AjcGetDlgItemCboLen				AjcGetDlgItemCboLenA
	#define		AjcGetDlgItemCboItem			AjcGetDlgItemCboItemA
	#define		AjcGetDlgItemCboFind			AjcGetDlgItemCboFindA
	#define		AjcGetDlgItemCboMaxLen			AjcGetDlgItemCboMaxLenA
	#define		AjcSetDlgItemStr 				AjcSetDlgItemStrA
	#define		AjcSetDlgItemEdtLimit			AjcSetDlgItemEdtLimitA
	#define		AjcSetDlgItemCboAdd				AjcSetDlgItemCboAddA
	#define		AjcSetDlgItemCboIns				AjcSetDlgItemCboInsA
	#define		AjcSetDlgItemCboList			AjcSetDlgItemCboListA
	#define		AjcSetDlgItemCboLimit			AjcSetDlgItemCboLimitA
	#define		AjcSetDlgPropUInt				AjcSetDlgPropUIntA
	#define		AjcSetDlgPropSInt				AjcSetDlgPropSIntA
	#define		AjcSetDlgPropHex 				AjcSetDlgPropHexA
	#define		AjcSetDlgPropReal				AjcSetDlgPropRealA
	#define		AjcSetDlgPropU8					AjcSetDlgPropUI8A
	#define		AjcSetDlgPropSI8				AjcSetDlgPropSI8A
	#define		AjcSetDlgPropH8 				AjcSetDlgPropH8A
	#define		AjcSetDlgPropUI16				AjcSetDlgPropUI16A
	#define		AjcSetDlgPropSI16				AjcSetDlgPropSI16A
	#define		AjcSetDlgPropH16 				AjcSetDlgPropH16A
	#define		AjcSetDlgPropUI64				AjcSetDlgPropUI64A
	#define		AjcSetDlgPropSI64				AjcSetDlgPropSI64A
	#define		AjcSetDlgPropH64 				AjcSetDlgPropH64A
	#define		AjcSetDlgPropChk 				AjcSetDlgPropChkA
	#define		AjcSetDlgPropStr				AjcSetDlgPropStrA
	#define		AjcSetDlgItemFStr				AjcSetDlgItemFStrA
	#define		AjcSetDlgPropCbo				AjcSetDlgPropCboA
	#define		AjcLoadDlgProfiles 				AjcLoadDlgProfilesA
	#define		AjcSaveDlgProfiles 				AjcSaveDlgProfilesA
	#define		AjcRefreshDlgValues				AjcRefreshDlgValuesA
	#define		AjcGetDlgValues    				AjcGetDlgValuesA
	#define		AjcSetDlgValues    				AjcSetDlgValuesA
	#define		AjcReleaseDlgProps				AjcReleaseDlgPropsA

	#define		MAjcSetDlgPropUInt				MAjcSetDlgPropUIntA
	#define		MAjcSetDlgPropSInt				MAjcSetDlgPropSIntA
	#define		MAjcSetDlgPropHex				MAjcSetDlgPropHexA
	#define		MAjcSetDlgPropReal				MAjcSetDlgPropRealA
	#define		MAjcSetDlgPropUI8				MAjcSetDlgPropUI8A
	#define		MAjcSetDlgPropSI8				MAjcSetDlgPropSI8A
	#define		MAjcSetDlgPropH8				MAjcSetDlgPropH8A
	#define		MAjcSetDlgPropUI16				MAjcSetDlgPropUI16A
	#define		MAjcSetDlgPropSI16				MAjcSetDlgPropSI16A
	#define		MAjcSetDlgPropH16				MAjcSetDlgPropH16A
	#define		MAjcSetDlgPropUI64				MAjcSetDlgPropUI64A
	#define		MAjcSetDlgPropSI64				MAjcSetDlgPropSI64A
	#define		MAjcSetDlgPropH64				MAjcSetDlgPropH64A
	#define		MAjcSetDlgPropChk				MAjcSetDlgPropChkA
	#define		MAjcSetDlgPropStr				MAjcSetDlgPropStrA
	#define		MAjcSetDlgPropCbo				MAjcSetDlgPropCboA

	#define		AjcDlgLoadGrpControlSettings	AjcDlgLoadGrpControlSettingsA
	#define		AjcDlgSaveGrpControlSettingsEx	AjcDlgSaveGrpControlSettingsExA
	#define		AjcDlgItemLoadTextBox			AjcDlgItemLoadTextBoxA
	#define		AjcDlgItemLoadTextBoxEx			AjcDlgItemLoadTextBoxExA
	#define		AjcDlgItemSaveTextBox			AjcDlgItemSaveTextBoxA
	#define		AjcDlgItemSaveTextBoxEx			AjcDlgItemSaveTextBoxExA
	#define		AjcDlgItemLoadChkBox			AjcDlgItemLoadChkBoxA
	#define		AjcDlgItemSaveChkBox			AjcDlgItemSaveChkBoxA
	#define		AjcDlgItemComboBox				AjcDlgItemComboBoxA
	#define		AjcDlgItemLoadComboBox			AjcDlgItemLoadComboBoxA
	#define		AjcDlgItemSaveComboBox			AjcDlgItemSaveComboBoxA
	#define		AjcDlgItemIsComboBoxSaved		AjcDlgItemIsComboBoxSavedA
	#define		AjcDlgItemLoadListBox			AjcDlgItemLoadListBoxA
	#define		AjcDlgItemSaveListBox			AjcDlgItemSaveListBoxA

#endif

//	oCg}N
#define	MAjcSetDlgPropUIntA(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropUIntA(hDlg, id, #id, def, fComma	   , pVar)
#define	MAjcSetDlgPropSIntA(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropSIntA(hDlg, id, #id, def, fComma	   , pVar)
#define	MAjcSetDlgPropHexA( hDlg, id, def, digits	  , pVar)	AjcSetDlgPropHexA (hDlg, id, #id, def, digits	   , pVar)
#define	MAjcSetDlgPropRealA(hDlg, id, def, fComma, prec, pVar)	AjcSetDlgPropRealA(hDlg, id, #id, def, fComma, prec, pVar)
#define	MAjcSetDlgPropUI8A( hDlg , id, def, fComma	  , pVar)	AjcSetDlgPropUI8A (hDlg, id, #id, def, fComma	   , pVar)
#define	MAjcSetDlgPropSI8A( hDlg , id, def, fComma	  , pVar)	AjcSetDlgPropSI8A (hDlg, id, #id, def, fComma	   , pVar)
#define	MAjcSetDlgPropH8A(	hDlg  , id, def, digits	  , pVar)	AjcSetDlgPropH8A  (hDlg, id, #id, def, digits	   , pVar)
#define	MAjcSetDlgPropUI16A(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropUI16A(hDlg, id, #id, def, fComma	   , pVar)
#define	MAjcSetDlgPropSI16A(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropSI16A(hDlg, id, #id, def, fComma	   , pVar)
#define	MAjcSetDlgPropH16A( hDlg , id, def, digits	  , pVar)	AjcSetDlgPropH16A (hDlg, id, #id, def, digits	   , pVar)
#define	MAjcSetDlgPropUI64A(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropUI64A(hDlg, id, #id, def, fComma	   , pVar)
#define	MAjcSetDlgPropSI64A(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropSI64A(hDlg, id, #id, def, fComma	   , pVar)
#define	MAjcSetDlgPropH64A( hDlg, id, def, digits	  , pVar)	AjcSetDlgPropH64A (hDlg, id, #id, def, digits	   , pVar)
#define	MAjcSetDlgPropChkA( hDlg, id, def			  , pVar)	AjcSetDlgPropChkA (hDlg, id, #id, def			   , pVar)
#define	MAjcSetDlgPropStrA( hDlg, id, def		, pVar, lVar)	AjcSetDlgPropStrA (hDlg, id, #id, def		 , pVar, lVar)
#define	MAjcSetDlgPropCboA( hDlg, id, pDefList, DefIx  , pVar)	AjcSetDlgPropCboA (hDlg, id, #id, pDefList, DefIx  , pVar)

//	Ch}N
#define	MAjcSetDlgPropUIntW(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropUIntW(hDlg, id, L#id, def, fComma		, pVar)
#define	MAjcSetDlgPropSIntW(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropSIntW(hDlg, id, L#id, def, fComma		, pVar)
#define	MAjcSetDlgPropHexW( hDlg, id, def, digits	  , pVar)	AjcSetDlgPropHexW (hDlg, id, L#id, def, digits		, pVar)
#define	MAjcSetDlgPropRealW(hDlg, id, def, fComma, prec, pVar)	AjcSetDlgPropRealW(hDlg, id, L#id, def, fComma, prec, pVar)
#define	MAjcSetDlgPropUI8W( hDlg , id, def, fComma	  , pVar)	AjcSetDlgPropUI8W (hDlg, id, L#id, def, fComma		, pVar)
#define	MAjcSetDlgPropSI8W( hDlg , id, def, fComma	  , pVar)	AjcSetDlgPropSI8W (hDlg, id, L#id, def, fComma		, pVar)
#define	MAjcSetDlgPropH8W(	hDlg  , id, def, digits	  , pVar)	AjcSetDlgPropH8W  (hDlg, id, L#id, def, digits		, pVar)
#define	MAjcSetDlgPropUI16W(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropUI16W(hDlg, id, L#id, def, fComma		, pVar)
#define	MAjcSetDlgPropSI16W(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropSI16W(hDlg, id, L#id, def, fComma		, pVar)
#define	MAjcSetDlgPropH16W( hDlg , id, def, digits	  , pVar)	AjcSetDlgPropH16W (hDlg, id, L#id, def, digits		, pVar)
#define	MAjcSetDlgPropUI64W(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropUI64W(hDlg, id, L#id, def, fComma		, pVar)
#define	MAjcSetDlgPropSI64W(hDlg, id, def, fComma	  , pVar)	AjcSetDlgPropSI64W(hDlg, id, L#id, def, fComma		, pVar)
#define	MAjcSetDlgPropH64W( hDlg, id, def, digits	  , pVar)	AjcSetDlgPropH64W (hDlg, id, L#id, def, digits		, pVar)
#define	MAjcSetDlgPropChkW( hDlg, id, def			  , pVar)	AjcSetDlgPropChkW (hDlg, id, L#id, def				, pVar)
#define	MAjcSetDlgPropStrW( hDlg, id, def		, pVar, lVar)	AjcSetDlgPropStrW (hDlg, id, L#id, def		  , pVar, lVar)
#define	MAjcSetDlgPropCboW( hDlg, id, pDefList, DefIx  , pVar)	AjcSetDlgPropCboW (hDlg, id, L#id, pDefList, DefIx	, pVar)


/*--------------------------------------------------------------------------------------------------------------*/
/*	vg^Cv																								*/
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT UI	 WINAPI AjcGetDlgItemUInt(HWND hDlg, int id);
AJCEXPORT SI	 WINAPI AjcGetDlgItemSInt(HWND hDlg, int id);
AJCEXPORT UI	 WINAPI AjcGetDlgItemHex (HWND hDlg, int id);
AJCEXPORT double WINAPI AjcGetDlgItemReal(HWND hDlg, int id);
AJCEXPORT ULL	 WINAPI AjcGetDlgItemUI64(HWND hDlg, int id);
AJCEXPORT SLL	 WINAPI AjcGetDlgItemSI64(HWND hDlg, int id);
AJCEXPORT ULL	 WINAPI AjcGetDlgItemH64 (HWND hDlg, int id);
AJCEXPORT UI	 WINAPI AjcGetDlgItemChk (HWND hDlg, int id);
AJCEXPORT UI	 WINAPI AjcGetDlgItemStrA(HWND hDlg, int id, BCP   pBuf, UI lBuf);
AJCEXPORT UI	 WINAPI AjcGetDlgItemStrW(HWND hDlg, int id, WCP   pBuf, UI lBuf);
AJCEXPORT UI	 WINAPI AjcGetDlgItemStrLenA(HWND hDlg, int id);
AJCEXPORT UI	 WINAPI AjcGetDlgItemStrLenW(HWND hDlg, int id);

AJCEXPORT BOOL	 WINAPI AjcSetOptDlgItemUInt(HWND hDlg, int id, UI	   value, BOOL fComma  );
AJCEXPORT BOOL	 WINAPI AjcSetOptDlgItemSInt(HWND hDlg, int id, SI	   value, BOOL fComma  );
AJCEXPORT BOOL	 WINAPI AjcSetOptDlgItemHex (HWND hDlg, int id, UI	   value, int digits   );
AJCEXPORT BOOL	 WINAPI AjcSetOptDlgItemReal(HWND hDlg, int id, double value, int precision);
AJCEXPORT BOOL	 WINAPI AjcSetOptDlgItemUI64(HWND hDlg, int id, ULL    value, BOOL fComma  );
AJCEXPORT BOOL	 WINAPI AjcSetOptDlgItemSI64(HWND hDlg, int id, SLL    value, BOOL fComma  );
AJCEXPORT BOOL	 WINAPI AjcSetOptDlgItemH64 (HWND hDlg, int id, ULL    value, int digits   );

AJCEXPORT BOOL	 WINAPI AjcSetDlgItemUInt(HWND hDlg, int id, UI 	value);
AJCEXPORT BOOL 	 WINAPI AjcSetDlgItemSInt(HWND hDlg, int id, SI 	value);
AJCEXPORT BOOL 	 WINAPI AjcSetDlgItemHex (HWND hDlg, int id, UI 	value);
AJCEXPORT BOOL 	 WINAPI AjcSetDlgItemReal(HWND hDlg, int id, double value, int prec);
AJCEXPORT BOOL 	 WINAPI AjcSetDlgItemUI64(HWND hDlg, int id, ULL	value);
AJCEXPORT BOOL 	 WINAPI AjcSetDlgItemSI64(HWND hDlg, int id, SLL	value);
AJCEXPORT BOOL 	 WINAPI AjcSetDlgItemH64 (HWND hDlg, int id, ULL	value);

AJCEXPORT BOOL 	 WINAPI AjcSepDlgItemUInt(HWND hDlg, int id, UI 	value);
AJCEXPORT BOOL 	 WINAPI AjcSepDlgItemSInt(HWND hDlg, int id, SI 	value);
AJCEXPORT BOOL 	 WINAPI AjcSepDlgItemHex (HWND hDlg, int id, UI 	value, int col );
AJCEXPORT BOOL 	 WINAPI AjcSepDlgItemReal(HWND hDlg, int id, double value, int prec);
AJCEXPORT BOOL 	 WINAPI AjcSepDlgItemUI64(HWND hDlg, int id, ULL	value);
AJCEXPORT BOOL 	 WINAPI AjcSepDlgItemSI64(HWND hDlg, int id, SLL	value);
AJCEXPORT BOOL 	 WINAPI AjcSepDlgItemH64 (HWND hDlg, int id, ULL	value, int col );

AJCEXPORT BOOL	 WINAPI AjcSetDlgItemChk	(HWND hDlg, int id, UI state);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemRbt	(HWND hDlg, int id, int idFirst, int idLast);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemStrA	(HWND hDlg, int id, C_BCP pStr);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemStrW	(HWND hDlg, int id, C_WCP pStr);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemFStrA	(HWND hDlg, int id, C_BCP pFmt, ...);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemFStrW	(HWND hDlg, int id, C_WCP pFmt, ...);

AJCEXPORT BOOL	 WINAPI AjcSetDlgItemEdtLimitA(HWND hDlg, int id, UI limit);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemEdtLimitW(HWND hDlg, int id, UI limit);

AJCEXPORT UI	 WINAPI AjcGetDlgItemCboIx	   (HWND hDlg, int id);
AJCEXPORT UI	 WINAPI AjcGetDlgItemCboCount  (HWND hDlg, int id);
AJCEXPORT UI	 WINAPI AjcGetDlgItemCboLenA   (HWND hDlg, int id, UI ix);
AJCEXPORT UI	 WINAPI AjcGetDlgItemCboLenW   (HWND hDlg, int id, UI ix);
AJCEXPORT UI	 WINAPI AjcGetDlgItemCboItemA  (HWND hDlg, int id, UI ix, BCP pBuf, UI lBuf);
AJCEXPORT UI	 WINAPI AjcGetDlgItemCboItemW  (HWND hDlg, int id, UI ix, WCP pBuf, UI lBuf);
AJCEXPORT SX	 WINAPI AjcGetDlgItemCboData   (HWND hDlg, int id, UI ix);
AJCEXPORT UI	 WINAPI AjcGetDlgItemCboFindA  (HWND hDlg, int id, UI ix, C_BCP pStr, UI flag);
AJCEXPORT UI	 WINAPI AjcGetDlgItemCboFindW  (HWND hDlg, int id, UI ix, C_WCP pStr, UI flag);
AJCEXPORT UI	 WINAPI AjcGetDlgItemCboMaxLenA(HWND hDlg, int id);
AJCEXPORT UI	 WINAPI AjcGetDlgItemCboMaxLenW(HWND hDlg, int id);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemCboIx	   (HWND hDlg, int id, UI ix);
AJCEXPORT UI	 WINAPI AjcSetDlgItemCboAddA   (HWND hDlg, int id, UI ix, C_BCP pItem, UI flag);
AJCEXPORT UI	 WINAPI AjcSetDlgItemCboAddW   (HWND hDlg, int id, UI ix, C_WCP pItem, UI flag);
AJCEXPORT UI	 WINAPI AjcSetDlgItemCboInsA   (HWND hDlg, int id, UI ix, C_BCP pItem, UI flag);
AJCEXPORT UI	 WINAPI AjcSetDlgItemCboInsW   (HWND hDlg, int id, UI ix, C_WCP pItem, UI flag);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemCboDel    (HWND hDlg, int id, UI ix);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemCboData   (HWND hDlg, int id, UI ix, SX data);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemCboListA  (HWND hDlg, int id, C_BCP pList);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemCboListW  (HWND hDlg, int id, C_WCP pList);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemCboLimitA (HWND hDlg, int id, UI limit);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemCboLimitW (HWND hDlg, int id, UI limit);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemCboReset  (HWND hDlg, int id);

AJCEXPORT BOOL	 WINAPI AjcSetDlgItemPgsRange(HWND hDlg, int id, int low, int high);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemPgsPos  (HWND hDlg, int id, int pos);

AJCEXPORT int	 WINAPI AjcGetDlgItemSldPos  (HWND hDlg, int id);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemSldRange(HWND hDlg, int id, int low, int high, int page);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemSldPos  (HWND hDlg, int id, int pos);

AJCEXPORT BOOL	 WINAPI AjcSetDlgItemSpnInfo (HWND hDlg, int id, int low, int high, int idBuddy);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemSpnRange(HWND hDlg, int id, int low, int high);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemSpnBuddy(HWND hDlg, int id, int idBuddy);
AJCEXPORT HWND	 WINAPI AjcSetDlgItemTopMostInSiblings (HWND hDlg, int id);
AJCEXPORT HWND	 WINAPI AjcSetDlgItemBackMostInSiblings(HWND hDlg, int id);

//----- EDITRg[̃hbv -------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcEnableDlgItemToDrop			(HWND hDlg, int id, 		   UI optDrop);
AJCEXPORT BOOL	 WINAPI AjcEnableDlgItemToDropEx		(HWND hDlg, int id, int idGrp, UI optDrop);

//----- Rg[̈ʒu^` 擾^ݒ --------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcGetDlgItemPos	(HWND hDlg, int id, LPPOINT pPoint);
AJCEXPORT BOOL	 WINAPI AjcGetDlgItemSize	(HWND hDlg, int id, LPSIZE	pSize);
AJCEXPORT BOOL	 WINAPI AjcGetDlgItemRect	(HWND hDlg, int id, LPRECT	pRect);

AJCEXPORT BOOL	 WINAPI AjcSetDlgItemPos	(HWND hDlg, int id, int x, int y);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemPosV	(HWND hDlg, int id, const POINT *pPos);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemSize	(HWND hDlg, int id, int cx, int cy);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemSizeV	(HWND hDlg, int id, const SIZE *pSize);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemRect	(HWND hDlg, int id, int x, int y, int cx, int cy);
AJCEXPORT BOOL	 WINAPI AjcSetDlgItemRectV	(HWND hDlg, int id, const RECT *pRect);

//----- Rg[̃OBݒ -------------------------------------------------------------------------------//
AJCEXPORT BOOL	WINAPI AjcEnableDlgItem		  (HWND hDlg, int id	, BOOL fEnable);
AJCEXPORT BOOL	WINAPI AjcShowDlgItem		  (HWND hDlg, int id	, BOOL fShow);
AJCEXPORT BOOL	WINAPI AjcShowAndEnableDlgItem(HWND hDlg, int id, BOOL fShow, BOOL fEnable);

AJCEXPORT BOOL	WINAPI AjcEnableDlgGroup   (HWND hDlg, int idGrp, BOOL fEnaGrpBox, BOOL fEnaCtrls);
AJCEXPORT BOOL	WINAPI AjcShowDlgGroup	   (HWND hDlg, int idGrp, BOOL fShow);
AJCEXPORT BOOL	WINAPI AjcShowDlgGroupEx   (HWND hDlg, int idGrp, BOOL fShowGrpBox, BOOL fShowCtrls);
AJCEXPORT BOOL	WINAPI AjcMoveDlgGroupToLoc(HWND hDlg, int idGrp, int x, int y);
AJCEXPORT BOOL	WINAPI AjcMoveDlgGroupToCtl(HWND hDlg, int idGrp, int idCtl);
AJCEXPORT BOOL	WINAPI AjcMoveDlgGroupToOrg(HWND hDlg, int idGrp);

//----- O[vECh ---------------------------------------------------------------------------------//
AJCEXPORT UI	WINAPI AjcDlgItemEnumInGroup(HWND hDlg, int idGrp, UX cbp, BOOL (CALLBACK *cbEnum)(HWND hCtrl, UX cbp));

//----- vt@C GNX`FW ----------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropUIntA	(HWND hDlg, int id, C_BCP pKey, UI	   defValue, BOOL fComma  , UI	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropUIntW	(HWND hDlg, int id, C_WCP pKey, UI	   defValue, BOOL fComma  , UI	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropSIntA	(HWND hDlg, int id, C_BCP pKey, SI	   defValue, BOOL fComma  , SI	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropSIntW	(HWND hDlg, int id, C_WCP pKey, SI	   defValue, BOOL fComma  , SI	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropHexA	(HWND hDlg, int id, C_BCP pKey, UI	   defValue, int digits   , UI	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropHexW	(HWND hDlg, int id, C_WCP pKey, UI	   defValue, int digits   , UI	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropRealA	(HWND hDlg, int id, C_BCP pKey, double defValue, BOOL fComma  , int prec, double *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropRealW	(HWND hDlg, int id, C_WCP pKey, double defValue, BOOL fComma  , int prec, double *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropUI8A	(HWND hDlg, int id, C_BCP pKey, UB	   defValue, BOOL fComma  , UB	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropUI8W	(HWND hDlg, int id, C_WCP pKey, UB	   defValue, BOOL fComma  , UB	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropSI8A	(HWND hDlg, int id, C_BCP pKey, SB	   defValue, BOOL fComma  , SB	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropSI8W	(HWND hDlg, int id, C_WCP pKey, SB	   defValue, BOOL fComma  , SB	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropH8A	(HWND hDlg, int id, C_BCP pKey, UB	   defValue, int digits   , UB	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropH8W	(HWND hDlg, int id, C_WCP pKey, UB	   defValue, int digits   , UB	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropUI16A	(HWND hDlg, int id, C_BCP pKey, UW	   defValue, BOOL fComma  , UW	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropUI16W	(HWND hDlg, int id, C_WCP pKey, UW	   defValue, BOOL fComma  , UW	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropSI16A	(HWND hDlg, int id, C_BCP pKey, SW	   defValue, BOOL fComma  , SW	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropSI16W	(HWND hDlg, int id, C_WCP pKey, SW	   defValue, BOOL fComma  , SW	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropH16A	(HWND hDlg, int id, C_BCP pKey, UW	   defValue, int digits   , UW	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropH16W	(HWND hDlg, int id, C_WCP pKey, UW	   defValue, int digits   , UW	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropUI64A	(HWND hDlg, int id, C_BCP pKey, ULL    defValue, BOOL fComma  , ULL    *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropUI64W	(HWND hDlg, int id, C_WCP pKey, ULL    defValue, BOOL fComma  , ULL    *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropSI64A	(HWND hDlg, int id, C_BCP pKey, SLL    defValue, BOOL fComma  , SLL    *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropSI64W	(HWND hDlg, int id, C_WCP pKey, SLL    defValue, BOOL fComma  , SLL    *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropH64A	(HWND hDlg, int id, C_BCP pKey, ULL    defValue, int digits   , ULL    *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropH64W	(HWND hDlg, int id, C_WCP pKey, ULL    defValue, int digits   , ULL    *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropChkA	(HWND hDlg, int id, C_BCP pKey, UI	   defState 			  , UI	   *pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropChkW	(HWND hDlg, int id, C_WCP pKey, UI	   defState 			  , UI	   *pVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropStrA	(HWND hDlg, int id, C_BCP pKey, C_BCP pDefStr, BCP pVar, int lVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropStrW	(HWND hDlg, int id, C_WCP pKey, C_WCP pDefStr, WCP pVar, int lVar);

AJCEXPORT BOOL	 WINAPI AjcSetDlgPropCboA	(HWND hDlg, int id, C_BCP pKey, C_BCP pDefLst, UI DefIx, UIP pVar);
AJCEXPORT BOOL	 WINAPI AjcSetDlgPropCboW	(HWND hDlg, int id, C_WCP pKey, C_WCP pDefLst, UI DefIx, UIP pVar);

AJCEXPORT BOOL	 WINAPI AjcLoadDlgProfilesA (HWND hDlg, C_BCP pSec);
AJCEXPORT BOOL	 WINAPI AjcLoadDlgProfilesW (HWND hDlg, C_WCP pSec);

AJCEXPORT BOOL	 WINAPI AjcSaveDlgProfilesA (HWND hDlg, C_BCP pSec);
AJCEXPORT BOOL	 WINAPI AjcSaveDlgProfilesW (HWND hDlg, C_WCP pSec);

AJCEXPORT BOOL	 WINAPI AjcRefreshDlgValuesA(HWND hDlg);
AJCEXPORT BOOL	 WINAPI AjcRefreshDlgValuesW(HWND hDlg);

AJCEXPORT BOOL	 WINAPI AjcGetDlgValuesA	(HWND hDlg);
AJCEXPORT BOOL	 WINAPI AjcGetDlgValuesW	(HWND hDlg);

AJCEXPORT BOOL	 WINAPI AjcSetDlgValuesA	(HWND hDlg);
AJCEXPORT BOOL	 WINAPI AjcSetDlgValuesW	(HWND hDlg);

AJCEXPORT BOOL	 WINAPI AjcReleaseDlgPropsA (HWND hDlg);
AJCEXPORT BOOL	 WINAPI AjcReleaseDlgPropsW (HWND hDlg);


//----- _CAOڂ̉i ---------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcDlgLoadGrpControlSettingsA(HWND hDlg, int idGrp, C_BCP pSect, UI act);
AJCEXPORT 	BOOL	WINAPI	AjcDlgLoadGrpControlSettingsW(HWND hDlg, int idGrp, C_WCP pSect, UI act);

AJCEXPORT 	BOOL	WINAPI	AjcDlgSaveGrpControlSettings(HWND hDlg, int idGrp);

AJCEXPORT 	BOOL	WINAPI	AjcDlgSaveGrpControlSettingsExA(HWND hDlg, int idGrp, C_BCP pSect, UI act);
AJCEXPORT 	BOOL	WINAPI	AjcDlgSaveGrpControlSettingsExW(HWND hDlg, int idGrp, C_WCP pSect, UI act);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSetPermAtt   (HWND hDlg, UI id   , UI att);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSetPermAttGrp(HWND hDlg, UI idGrp, UI att);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadTextBoxA(HWND hDlg, UI id, C_BCP pSect);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadTextBoxW(HWND hDlg, UI id, C_WCP pSect);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadTextBoxExA(HWND hDlg, UI id, C_BCP pSect, BOOL fExcRdOnly);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadTextBoxExW(HWND hDlg, UI id, C_WCP pSect, BOOL fExcRdOnly);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveTextBoxA(HWND hDlg, UI id, C_BCP pSect);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveTextBoxW(HWND hDlg, UI id, C_WCP pSect);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveTextBoxExA(HWND hDlg, UI id, C_BCP pSect, BOOL fExcRdOnly);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveTextBoxExW(HWND hDlg, UI id, C_WCP pSect, BOOL fExcRdOnly);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadChkBoxA(HWND hDlg, UI id, C_BCP pSect, BOOL fNtc);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadChkBoxW(HWND hDlg, UI id, C_WCP pSect, BOOL fNtc);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveChkBoxA(HWND hDlg, UI id, C_BCP pSect);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveChkBoxW(HWND hDlg, UI id, C_WCP pSect);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadComboBoxA(HWND hDlg, UI id, C_BCP pSect, UI sel, BOOL fNtc);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadComboBoxW(HWND hDlg, UI id, C_WCP pSect, UI sel, BOOL fNtc);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveComboBoxA(HWND hDlg, UI id, C_BCP pSect, UI sel);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveComboBoxW(HWND hDlg, UI id, C_WCP pSect, UI sel);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemIsComboBoxSavedA(HWND hDlg, UI id, C_BCP pSect);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemIsComboBoxSavedW(HWND hDlg, UI id, C_WCP pSect);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadListBoxA(HWND hDlg, UI id, C_BCP pSect, UI sel);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemLoadListBoxW(HWND hDlg, UI id, C_WCP pSect, UI sel);

AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveListBoxA(HWND hDlg, UI id, C_BCP pSect, UI sel);
AJCEXPORT 	BOOL	WINAPI	AjcDlgItemSaveListBoxW(HWND hDlg, UI id, C_WCP pSect, UI sel);

/****************************************************************************************************************/
#endif
