#ifndef	AJCGETFILEDIR_H_
#define	AJCGETFILEDIR_H_
/****************************************************************************************************************/

/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcGetSaveFile			AjcGetSaveFileW
	#define	AjcGetOpenFile			AjcGetOpenFileW
	#define	AjcGetOpenFiles			AjcGetOpenFilesW
	#define	AjcGetOpenFilesEx		AjcGetOpenFilesExW
	#define	AjcOpenedFilesArray		AjcOpenedFilesArrayW
	#define	AjcGetFilesArrayItemLen	AjcGetFilesArrayItemLenW
	#define	AjcGetFilesArrayItemStr	AjcGetFilesArrayItemStrW
	#define	AjcGetFolderName		AjcGetFolderNameW
	#define	AjcGetFolderNameEx		AjcGetFolderNameExW
	#define	AjcGetAppPath			AjcGetAppPathW
	#define	AjcGetAppName			AjcGetAppNameW
	#define	AjcGetAppPathByHWnd		AjcGetAppPathByHWndW
	#define	AjcGetAppPathEx			AjcGetAppPathByHWndW
#else
	#define	AjcGetSaveFile			AjcGetSaveFileA
	#define	AjcGetOpenFile			AjcGetOpenFileA
	#define	AjcGetOpenFiles			AjcGetOpenFilesA
	#define	AjcGetOpenFilesEx		AjcGetOpenFilesExA
	#define	AjcOpenedFilesArray		AjcOpenedFilesArrayA
	#define	AjcGetFilesArrayItemLen	AjcGetFilesArrayItemLenA
	#define	AjcGetFilesArrayItemStr	AjcGetFilesArrayItemStrA
	#define	AjcGetFolderName		AjcGetFolderNameA
	#define	AjcGetFolderNameEx		AjcGetFolderNameExA
	#define	AjcGetAppPath			AjcGetAppPathA
	#define	AjcGetAppName			AjcGetAppNameA
	#define	AjcGetAppPathByHWnd		AjcGetAppPathByHWndA
	#define	AjcGetAppPathEx			AjcGetAppPathByHWndA
#endif

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcGetSaveFileA(HWND hWnd, C_BCP pTitle, C_BCP pFilter, C_BCP pDefExt, BCP pBuf, UI lBuf);
AJCEXPORT	BOOL	WINAPI	AjcGetSaveFileW(HWND hWnd, C_WCP pTitle, C_WCP pFilter, C_WCP pDefExt, WCP pBuf, UI lBuf);

AJCEXPORT	BOOL	WINAPI	AjcGetOpenFileA(HWND hWnd, C_BCP pTitle, C_BCP pFilter, C_BCP pDefExt, BCP pBuf, UI lBuf);
AJCEXPORT	BOOL	WINAPI	AjcGetOpenFileW(HWND hWnd, C_WCP pTitle, C_WCP pFilter, C_WCP pDefExt, WCP pBuf, UI lBuf);

AJCEXPORT	BCP *	WINAPI	AjcGetOpenFilesA(HWND hWnd, C_BCP pInitialPath, C_BCP pTitle, C_BCP pFilter, C_BCP pDefExt, BOOL fMulti, UIP pNum);
AJCEXPORT	WCP *	WINAPI	AjcGetOpenFilesW(HWND hWnd, C_WCP pInitialPath, C_WCP pTitle, C_WCP pFilter, C_WCP pDefExt, BOOL fMulti, UIP pNum);

AJCEXPORT	BCP *	WINAPI	AjcGetOpenFilesExA(HWND hWnd, C_BCP pTitle, C_BCP pFilter, C_BCP pDefExt, UI flags, BCP pBuf, UI lBuf, UIP pNum);
AJCEXPORT	WCP *	WINAPI	AjcGetOpenFilesExW(HWND hWnd, C_WCP pTitle, C_WCP pFilter, C_WCP pDefExt, UI flags, WCP pBuf, UI lBuf, UIP pNum);

AJCEXPORT	BCP * 	WINAPI	AjcOpenedFilesArrayA(C_BCP pFileStrings, UIP pNumber);
AJCEXPORT	WCP	* 	WINAPI	AjcOpenedFilesArrayW(C_WCP pFileStrings, UIP pNumber);

AJCEXPORT	UI		WINAPI	AjcGetFilesArrayItemLenA(BCP pArr[], UI ix);
AJCEXPORT	UI		WINAPI	AjcGetFilesArrayItemLenW(WCP pArr[], UI ix);

AJCEXPORT	VO		WINAPI	AjcGetFilesArrayItemStrA(BCP pArr[], UI ix, BCP pBuf, UI lBuf);
AJCEXPORT	VO		WINAPI	AjcGetFilesArrayItemStrW(WCP pArr[], UI ix, WCP pBuf, UI lBuf);

AJCEXPORT	VO		WINAPI	AjcReleaseOpenedFilesArray(VOP pArr);

AJCEXPORT	BOOL	WINAPI	AjcGetFolderNameA(HWND hWnd, C_BCP pWndTtl, C_BCP pBoxTtl, BC pBuf[MAX_PATH], BOOL fTailIsDelimiter);
AJCEXPORT	BOOL	WINAPI	AjcGetFolderNameW(HWND hWnd, C_WCP pWndTtl, C_WCP pBoxTtl, WC pBuf[MAX_PATH], BOOL fTailIsDelimiter);

AJCEXPORT	BOOL	WINAPI	AjcGetFolderNameExA(HWND hWnd, C_BCP pWndTtl, C_BCP pBoxTtl, BC pBuf[MAX_PATH], BOOL fTailIsDelimiter, UI flags);
AJCEXPORT	BOOL	WINAPI	AjcGetFolderNameExW(HWND hWnd, C_WCP pWndTtl, C_WCP pBoxTtl, WC pBuf[MAX_PATH], BOOL fTailIsDelimiter, UI flags);

AJCEXPORT	BOOL	WINAPI	AjcGetAppPathA(BCP pBuf, UI bfl);
AJCEXPORT	BOOL	WINAPI	AjcGetAppPathW(WCP pBuf, UI bfl);

AJCEXPORT	BOOL	WINAPI	AjcGetAppNameA(BCP pBuf, UI bfl);
AJCEXPORT	BOOL	WINAPI	AjcGetAppNameW(WCP pBuf, UI bfl);

AJCEXPORT	BOOL	WINAPI	AjcGetAppPathByHWndA(HWND hWnd, BCP pBuf, UI bfl);
AJCEXPORT	BOOL	WINAPI	AjcGetAppPathByHWndW(HWND hWnd, WCP pBuf, UI bfl);

/****************************************************************************************************************/
#endif
