#ifndef	AJCPROCESSMEM_H_
#define	AJCPROCESSMEM_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcPmSendMessage	AjcPmSendMessageW
	#define	AjcPmPostMessage	AjcPmPostMessageW
#else
	#define	AjcPmSendMessage	AjcPmSendMessageA
	#define	AjcPmPostMessage	AjcPmPostMessageA
#endif
//--------------------------------------------------------------------------------------------------------------//
//	}N																										//
//--------------------------------------------------------------------------------------------------------------//
//	vZXփbZ[WM̃f[^ݎwiwParamj
#define		AJCPM_WPARAM_W(HPM, PTR, LEN)	AjcPmSetWpForWrite(HPM, LEN, (VOP)PTR)

//	vZXփbZ[WM̃f[^ݎwilParamj
#define		AJCPM_LPARAM_W(HPM, PTR, LEN)	AjcPmSetLpForWrite(HPM, LEN, (VOP)PTR)

//	vZXփbZ[WM̃f[^ǂݏow(wParam)
#define		AJCPM_WPARAM_R(HPM, PTR, LEN)	AjcPmSetWpForRead(HPM, LEN, (VOP)PTR)

//	vZXփbZ[WM̃f[^ǂݏow(lParam)
#define		AJCPM_LPARAM_R(HPM, PTR, LEN)	AjcPmSetLpForRead(HPM, LEN, (VOP)PTR)

//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCPMRW_NONE	= 0,
	AJCPMRW_W		= 1,
	AJCPMRW_R		= 2,
} AJCPMRWFLG;

//	bZ[WM̓ǂݏ
typedef	struct {
	AJCPMRWFLG	flg;		//	AJCPMRW_WF݁CAJCPMRW_R:ǂݏoCAJCPMRW_NONE:ǂݏ
	UX			loc;		//	vZXʒu
	UX			len;		//	ǂݏooCg
	VOP			pMem;		//	݃f[^AhX^ǂݏof[^i[obt@AhX
} AJCPMRW;

//	CX^X[N
typedef struct {
	UI		InstID;			//	CX^Xhc
	UL		ProcessID;		//	vZXhc
	UL		ThreadID;		//	Xbhhc
	HANDLE	hProcess;		//	vZXnh
	union {					//	vZXʒu
		VOP		pVoid;
		UBP		pByte;
		LPARAM	lParam;
	} u;
	AJCPMRW		wp;			//	vZXփbZ[WM̃q^v(wParam)
	AJCPMRW		lp;			//	vZXփbZ[WM̃q^v(lParam)
} AJCPM, *HAJCPM;

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCPM	WINAPI	AjcPmCreateByWnd(HWND hwnd, UX size);
AJCEXPORT	HAJCPM	WINAPI	AjcPmCreateByPid(UL pid, UX size);
AJCEXPORT	BOOL	WINAPI	AjcPmDelete (HAJCPM pW);
AJCEXPORT	BOOL	WINAPI	AjcPmWrite	(HAJCPM pW, UX loc, C_VOP pSrc, UX len);
AJCEXPORT	BOOL	WINAPI	AjcPmRead	(HAJCPM pW, UX loc, VOP	pBuf, UX len);
AJCEXPORT	UX		WINAPI	AjcPmGetAddr(HAJCPM pW, UX loc);

AJCEXPORT	LRESULT	WINAPI	AjcPmSendMessageA(HAJCPM pW, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam);
AJCEXPORT	LRESULT	WINAPI	AjcPmSendMessageW(HAJCPM pW, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam);

AJCEXPORT	LRESULT	WINAPI	AjcPmPostMessageA(HAJCPM pW, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam);
AJCEXPORT	LRESULT	WINAPI	AjcPmPostMessageW(HAJCPM pW, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam);

AJCEXPORT	WPARAM	WINAPI	AjcPmSetWpForWrite(HAJCPM pW, UX len, VOP pMem);
AJCEXPORT	LPARAM	WINAPI	AjcPmSetLpForWrite(HAJCPM pW, UX len, VOP pMem);
AJCEXPORT	WPARAM	WINAPI	AjcPmSetWpForRead (HAJCPM pW, UX len, VOP pMem);
AJCEXPORT	LPARAM	WINAPI	AjcPmSetLpForRead (HAJCPM pW, UX len, VOP pMem);

/****************************************************************************************************************/
#endif
