#ifndef	AJCQUEX_H_
#define	AJCQUEX_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//	L[wb_																								//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCXQUEID		0x1289FB3A
typedef  struct _AJCXQNODE {
	UI		id;						//	=AJCXQUEID
	struct	_AJCXQNODE	*pBfr;		//	ÕubNւ̃|C^
	struct	_AJCXQNODE	*pNxt;		//	̃ubNւ̃|C^
	UI		len;					//	f[^oCg
} AJCXQNODE, *PAJCXQNODE;

//--------------------------------------------------------------------------------------------------------------//
//	|C^zGg̍\̒`}N																		//
//--------------------------------------------------------------------------------------------------------------//
#define		MAJCXQUEPTR(ST, PT)											\
typedef struct {														\
	PT		pNode;					/*	m[hւ̃|C^	*/			\
	UI		len;					/*	m[h̃oCg	*/			\
} ST, *P##ST;															\
typedef const ST *PC##ST;

MAJCXQUEPTR(AJCXQUEPTR, VOP)

//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
typedef  struct _AJCXQUE {
	UI			InstID;					//	CX^Xʂhc
	PAJCXQNODE	pTop;					//	擪m[hւ̃|C^
	PAJCXQNODE	pLas;					//	ŏIm[hւ̃|C^
	UI			num;					//	m[h

	BOOL				fMultiThread;	//	rtO
	CRITICAL_SECTION	cs;				//	NeBJZNVEIuWFNg

	UX			cbp;									//	R[obNp^
	VO (CALLBACK *cbRemove)(VOP pDat, UI len, UX cbp);	//	m[hʒmpR[obN

} AJCXQUE, *LPAJCXQUE, *HAJCXQUE;
//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCXQUE	WINAPI	AjcXQueCreate(UX cbp, VO (CALLBACK *cbRemove)(VOP pDat, UI len, UX cbp));
AJCEXPORT	BOOL		WINAPI	AjcXQueDelete	(HAJCXQUE hXQue);

AJCEXPORT	VOP			WINAPI	AjcXQueEnque	(HAJCXQUE hXQue, C_VOP pDat, UI lDat);
AJCEXPORT	VOP			WINAPI	AjcXQueEnqTop	(HAJCXQUE hXQue, C_VOP pDat, UI lDat);
AJCEXPORT	VOP			WINAPI	AjcXQueInsert	(HAJCXQUE hXQue, C_VOP pDat, UI lDat, C_VOP pIns);
AJCEXPORT	UI			WINAPI	AjcXQueRemove	(HAJCXQUE hXQue, C_VOP pDat);
AJCEXPORT	BOOL		WINAPI	AjcXQuePurge	(HAJCXQUE hXQue);
AJCEXPORT	UI			WINAPI	AjcXQueDeque	(HAJCXQUE hXQue, VOP pBuf, UI lBuf);
AJCEXPORT	UI			WINAPI	AjcXQueGetCount	(HAJCXQUE hXQue);
AJCEXPORT	BOOL		WINAPI	AjcXQueMerge	(HAJCXQUE hXQue, HAJCXQUE pSrc);

AJCEXPORT	VOP			WINAPI	AjcXQueTopNode	(HAJCXQUE hXQue, UIP pBytes);
AJCEXPORT	VOP			WINAPI	AjcXQueLastNode	(HAJCXQUE hXQue, UIP pBytes);
AJCEXPORT	VOP			WINAPI	AjcXQueNextNode	(HAJCXQUE hXQue, C_VOP pCurrentNode, UIP pBytes);
AJCEXPORT	VOP			WINAPI	AjcXQuePrevNode	(HAJCXQUE hXQue, C_VOP pCurrentNode, UIP pBytes);

AJCEXPORT	PCAJCXQUEPTR WINAPI AjcXQueCreatePtrArr (HAJCXQUE hXQue, UIP pNum);
AJCEXPORT	VO	 		 WINAPI AjcXQueReleasePtrArr(HAJCXQUE hXQue, PCAJCXQUEPTR pArr);

AJCEXPORT	BOOL		WINAPI	AjcXQueEnableMultiThread(HAJCXQUE hFQue, BOOL fEnable);

/****************************************************************************************************************/
#endif
