#ifndef	AJCSEPSTREAM_H_
#define	AJCSEPSTREAM_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcSsepCreate	AjcSsepCreateW
	#define	AjcSsepPutText	AjcSsepPutTextW
#else
	#define	AjcSsepCreate	AjcSsepCreateA
	#define	AjcSsepPutText	AjcSsepPutTextA
#endif
//--------------------------------------------------------------------------------------------------------------//
//	CxgR[h																								//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCSSEP_EV_TXT		0x01				//	eLXgf[^ʒm
#define	AJCSSEP_EV_ESC		0x02				//	drbR[hf[^ʒm
#define	AJCSSEP_EV_PKT		0x04				//	pPbgf[^ʒm
#define	AJCSSEP_EV_CTRL		0x08				//	R[hʒm
#define	AJCSSEP_EV_NOPKT	0x10				//	pPbgOoCgf[^

#define	AJCSSEP_EV_ALL	(AJCSSEP_EV_TXT | AJCSSEP_EV_ESC | AJCSSEP_EV_PKT | AJCSSEP_EV_CTRL | AJCSSEP_EV_NOPKT)

//--------------------------------------------------------------------------------------------------------------//
//	[h																									//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCSSEP_MD_IDLE	= 0	,					//	ACh
	AJCSSEP_MD_TXT		,					//	eLXgf[^
	AJCSSEP_MD_ESC		,					//	drbR[hf[^
	AJCSSEP_MD_PKT							//	pPbgf[^
} AJCSSEP_MODE;

//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCSSEP_BUFSIZE	1024

typedef  struct {
	UI				InstID;						//	CX^Xhc
	AJCSSEP_MODE	Mode;						//	[h

	UI				evt;						//	Cxg

	BOOL			fUnicode;					//	UNICODEtO
	BOOL			fDle;						//	ckd̒tO
	BC				TxtIncMap[256];				//	eLXgɊ܂߂鐧R[h}bv
	BC				stx, etx, dle;				//	pPbgpR[h

	UI				PktTimSrt;					//	Ō̃pPbgf[^oCgݒ肵
	UI				PktTimOut;					//	pPbgf[^̃^CAEglmmsn

	HAJCMBC			hMbc;						//	R[hpnh
	AJCMBCKIND		SvMbk;						//	R[hʂ̑ޔ

	HAJCRNG			hRng;						//	f[^Eobt@Enh
	UB				RngBuf[AJCSSEP_BUFSIZE];	//	f[^p X^eBbNobt@

	BOOL				fMultiThread;			//	rtO
	CRITICAL_SECTION	cs;						//	NeBJZNVEIuWFNg

	UX			cbp;							//	R[obNp^
	BOOL (CALLBACK *cbEvent)(UI evt, VOP pDat, UI lDat, UX cbp);

} AJCSSEP, *HAJCSSEP;
//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSSEP	WINAPI	AjcSsepCreateA(UI evt, UX cbp, BOOL (CALLBACK *cbEvent)(UI evt, VOP pDat, UI lDat, UX cbp));
AJCEXPORT	HAJCSSEP	WINAPI	AjcSsepCreateW(UI evt, UX cbp, BOOL (CALLBACK *cbEvent)(UI evt, VOP pDat, UI lDat, UX cbp));

AJCEXPORT	VO			WINAPI	AjcSsepDelete(HAJCSSEP hSsep);
AJCEXPORT	BOOL		WINAPI	AjcSsepEnableMultiThread(HAJCSSEP hSsep, BOOL fEnable);

AJCEXPORT	AJCSSEP_MODE WINAPI	AjcSsepPutData	(HAJCSSEP hSsep, C_UBP pDat, UI lDat);

AJCEXPORT	AJCSSEP_MODE WINAPI	AjcSsepPutTextA	(HAJCSSEP hSsep, C_BCP pTxt, UI lTxt);
AJCEXPORT	AJCSSEP_MODE WINAPI	AjcSsepPutTextW	(HAJCSSEP hSsep, C_WCP pTxt, UI lTxt);

AJCEXPORT	VO	 		WINAPI	AjcSsepReset	(HAJCSSEP hSsep);
AJCEXPORT	VO			WINAPI	AjcSsepSetEvent (HAJCSSEP hSsep, UI evt);
AJCEXPORT	UI			WINAPI	AjcSsepGetEvent (HAJCSSEP hSsep);

AJCEXPORT	VO			WINAPI	AjcSsepSetIncTxt(HAJCSSEP pW, UI num, ...);
AJCEXPORT	VO			WINAPI	AjcSsepSetStx	(HAJCSSEP hSsep, UI stx);
AJCEXPORT	VO			WINAPI	AjcSsepSetEtx	(HAJCSSEP hSsep, UI etx);
AJCEXPORT	VO			WINAPI	AjcSsepSetDle	(HAJCSSEP hSsep, UI dle);
AJCEXPORT	VO			WINAPI	AjcSsepSetPktTimeOut(HAJCSSEP hSsep, UI time);

AJCEXPORT	UI			WINAPI	AjcSsepGetStx	(HAJCSSEP hSsep);
AJCEXPORT	UI			WINAPI	AjcSsepGetEtx	(HAJCSSEP hSsep);
AJCEXPORT	UI			WINAPI	AjcSsepGetDle	(HAJCSSEP hSsep);
AJCEXPORT	UI			WINAPI	AjcSsepGetPktTimeOut(HAJCSSEP hSsep);

AJCEXPORT	VOP			WINAPI	AjcSsepMakePacket(HAJCSSEP hSsep, C_VOP pDat, UI lDat, UIP pBytes);
AJCEXPORT	VO			WINAPI	AjcSsepRelease	 (VOP pMemBlk);

//	R[h@\
AJCEXPORT	VO			WINAPI	AjcSsepPutMbc		 (HAJCSSEP hSsep, C_BCP pTxt);
AJCEXPORT	AJCMBCKIND	WINAPI	AjcSsepGetMbcKind	 (HAJCSSEP hSsep);
AJCEXPORT	AJCMBCKIND	WINAPI	AjcSsepGetLastMbcKind(HAJCSSEP hSsep);
AJCEXPORT	VO	 		WINAPI	AjcSsepMbcReset		 (HAJCSSEP hSsep);

/****************************************************************************************************************/
#endif
