#ifndef	AJCSOCKSERV_H_
#define	AJCSOCKSERV_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcSsvStart				AjcSsvStartW
	#define	AjcSsvSendChar			AjcSsvSendCharW
	#define	AjcSsvSendText			AjcSsvSendTextW
	#define	AjcSsvSendTextF			AjcSsvSendTextFW
	#define	AjcSsvGetIpAddrStr		AjcSsvGetIpAddrStrW
#else
	#define	AjcSsvStart				AjcSsvStartA
	#define	AjcSsvSendChar			AjcSsvSendCharA
	#define	AjcSsvSendText			AjcSsvSendTextA
	#define	AjcSsvSendTextF			AjcSsvSendTextFA
	#define	AjcSsvGetIpAddrStr		AjcSsvGetIpAddrStrA
#endif


//	CxgR[h
#define	AJCSSV_EV_RXTEXT		AJCSSEP_EV_TXT				//	eLXgf[^ʒm		0x01
#define	AJCSSV_EV_RXESC			AJCSSEP_EV_ESC				//	drbR[hf[^ʒm	0x02
#define	AJCSSV_EV_RXPKT			AJCSSEP_EV_PKT				//	pPbgf[^ʒm		0x04
#define	AJCSSV_EV_RXCTRL		AJCSSEP_EV_CTRL				//	R[hʒm			0x08
#define	AJCSSV_EV_RXNOPKT		AJCSSEP_EV_NOPKT			//	pPbgOeLXg		0x10

#define	AJCSSV_EV_RXCHUNK		0x00000100					//	`Nf[^Mʒm
#define	AJCSSV_EV_INVCHUNK		0x00000200					//	s`NeLXgMʒm
#define	AJCSSV_EV_TXEMPTY		0x00000400					//	Mʒm
#define	AJCSSV_EV_CONNECT		0x00000800					//	ڑʒm
#define	AJCSSV_EV_DISCONNECT	0x00001000					//	ؒfʒm
#define	AJCSSV_EV_START			0x00002000					//	T[oJnʒm
#define	AJCSSV_EV_STOP			0x00004000					//	T[o~ʒm

#define	AJCSSV_EV_RXERR			0x00010000					//	MG[ʒm
#define	AJCSSV_EV_TXERR			0x00020000					//	MG[ʒm
#define	AJCSSV_EV_OVERR			0x00040000					//	NCAgڑI[o[
#define	AJCSSV_EV_ERR			0x08000000					//	̑̃G[ʒm

#define	AJCSSV_EV_SSEP			(AJCSSV_EV_RXTEXT  | AJCSSV_EV_RXESC	  | AJCSSV_EV_RXCTRL  | AJCSSV_EV_RXPKT | AJCSSV_EV_RXNOPKT)
#define	AJCSSV_EV_COMM			(AJCSSV_EV_RXCHUNK | AJCSSV_EV_INVCHUNK   | AJCSSV_EV_TXEMPTY					)
#define	AJCSSV_EV_GENERAL		(AJCSSV_EV_CONNECT | AJCSSV_EV_DISCONNECT | AJCSSV_EV_START   | AJCSSV_EV_STOP	)
#define	AJCSSV_EV_ERRS			(AJCSSV_EV_RXERR   | AJCSSV_EV_TXERR	  | AJCSSV_EV_ERR						)
#define	AJCSSV_EV_CLIENT		(AJCSSV_EV_SSEP    | AJCSSV_EV_COMM 	  | AJCSSV_EV_CONNECT | AJCSSV_EV_DISCONNECT | AJCSSV_EV_RXERR | AJCSSV_EV_TXERR)
#define	AJCSSV_EV_ALL			(AJCSSV_EV_SSEP    | AJCSSV_EV_COMM 	  | AJCSSV_EV_GENERAL | AJCSSV_EV_ERRS)

//	G[R[h
#define	AJCSSV_ERR_CREEVT			 10						//	IʒmpCxgIuWFNgs
#define	AJCSSV_ERR_SOCKET			 20						//	ڑvҋ@p\Pbgs(socket)
#define	AJCSSV_ERR_BIND				 30						//	oChsibindtj
#define	AJCSSV_ERR_LISTEN			 40						//	LISTENs(listen)
#define	AJCSSV_ERR_ACCEPT			 50						//	ACCEPTsiacceptj
#define	AJCSSV_ERR_ADDRINFO			 60						//	AhX擾sigetaddrinfoj
#define	AJCSSV_ERR_SOCKOPT			 70						//	\PbgIvVݒ莸s(setsockopt)
#define	AJCSSV_ERR_THREADPOWCTRL	 80						//	dXbhJns
#define	AJCSSV_ERR_THREADLISTEN		 90						//	ڑҋ@XbhJns
#define	AJCSSV_ERR_THREADCLIENT		100						//	NCAgʐMXbhJns
#define	AJCSSV_ERR_CRESSEP			110						//	Xg[CX^Xs
#define	AJCSSV_ERR_CREMBXTXD		120						//	Mf[^p[{bNXs
#define	AJCSSV_ERR_TIMEOUT			130						//	T[oI^CAEg
#define	AJCSSV_ERR_CRETHREADWORK	140						//	NCAgXbhp[Nmێs
#define	AJCSSV_ERR_CONNOVER			150						//	NCAgڑI[o[
#define	AJCSSV_ERR_CREIXMAP			160						//	CfNX蓖ėp}bve[us

//	eLXgER[h
typedef enum {
	AJCSSV_TXT_SJIS		=	AJCMBC_SJIS	,					//	Vtgihr(=1)
	AJCSSV_TXT_EUC		=	AJCMBC_EUC	,					//	dtb@@@(=2)
	AJCSSV_TXT_UTF8		=	AJCMBC_UTF8	,					//	tse|W@(=3)
	AJCSSV_TXT_AUTO		=	9	,							//	ʁ@@
} AJCSSV_TEXTCODE;

//	Mobt@TCY
#define	AJCSSVMAX_RXBUF	1024
#define	AJCSSVMAX_TXBUF	1024

//	`NEf[^E[h
typedef enum {
	AJCSSV_CM_BIN	=	0x01	,				//	oCi`N
	AJCSSV_CM_TEXT	=	0x02	,				//	eLXg`N
	AJCSSV_CM_BOTH	=	0x03	,				//	
} AJCSSV_CHUNKMODE;

//	AhXXg[W
typedef union {
	struct sockaddr_in		sain;
	struct sockaddr_in6		sain6;
	struct sockaddr_storage storage;
} AJCSSVSAIN, *PAJCSSVSAIN;
typedef const AJCSSVSAIN *PCAJCSSVSAIN;

//	T[oNIvV
typedef enum {
	AJCSSV_SOP_NOOPT			= 0   ,		//	IvV
	AJCSSV_SOP_SUP_SLEEP		= 0x01,		//	X[v}~
	AJCSSV_SOP_SUP_DISPOFF		= 0x02,		//	fBXvBOFF}~
	AJCSSV_SOP_SUP_ALL			= 0x03,		//	X[vfBXvBOFF}~
} AJCSSV_SERVOPT, *PAJCSSV_SERVOPT;

#define		AJCSSV_SERVOPT_MASK		0x03

//	CX^X[N
typedef struct {
	UI					InstID;								//	CX^Xʂhc
	BOOL				fStarted;							//	T[oJnσtO
	BOOL				fEnding;							//	AjcSsvStop()/AjcSsvDelete()ɂItO
	UI					CliSeqNo;							//	NCAgڑԍ

	//	CX^X[N
	UI					EvtMask;							//	ʒmCxg}XN
	AJCSSV_CHUNKMODE	ChunkMode;							//	`Nʒm[h
	AJCSSV_TEXTCODE		RxTxtCode;							//	MeLXgR[h
	AJCSSV_TEXTCODE		TxTxtCode;							//	MeLXgR[h
	UI					PktTimeout;							//	pPbgM^CAEg[ms]
	UB					stx, etx, dle;						//	pPbgF邽߂̐R[h
	UB					dummy;
	HAJCFMBX			hFMbxNtc;							//	[U`oւ̃Cxgʒmp[{bNXnh
	HAJCAVL				hAvlCli;							//	NCAgCX^Xo^p`uk

	//	T[oJn[N
	BOOL				fUnicode;							//	UNICODEtO
	UI					MaxClients;							//	NCAgőڑ
	AJCSSV_SERVOPT		opt;								//	T[oNIvV
	HWND				hWndNtc;							//	CxgʒmpEChnh
	UI					MsgNtc;								//	CxgʒmbZ[WR[h
	SOCKET				hSockListen;						//	TCP/IPXg[\Pbg
	HANDLE				hEvtExit;							//	T[oICxg
	HANDLE				hEvtNoClients;						//	SNCAgICxg
	HANDLE				hThreadPowCtrl;						//	dXbhnh
	UL					idThreadPowCtrl;					//	dXbhhc
	HANDLE				hThreadListen;						//	ڑҋ@Xbhnh
	UL					idThreadListen;						//	ڑҋ@Xbhhc
	UIP					pIxMap;								//	CfNX蓖ėp}bve[u

	CRITICAL_SECTION	csClients;							//	ڑJE^̔rp
	int					ClientCount;						//	ڑNCAg


	//----- MSILT|[gp ----------------------------------------------------//
	HWND	hWndForMsil;						//	MSILp_~[EChnh

} AJCSSV, *HAJCSSV;
typedef const AJCSSV *PCAJCSSV;

//	NCAgXbh [N
typedef struct {
	UI			InstID;				//	CX^Xʂhc
	UI			SeqNo;				//	NCAgڑԍ
	UI			ix;					//	NCAg̃CfNX
	BOOL		fExit;				//	NCAgItO
	HAJCSSV		pW;					//	CX^X[Nւ̃|C^
	SOCKET		hSockClient;		//	NCAg\Pbgnh
	AJCSSVSAIN	SockAddr;			//	\PbgAhX
	UI			ThreadId;			//	Xbhhc
	UX			UserData;			//	[Uf[^
	HAJCSSEP	hSsep;				//	Xg[CX^X
	HANDLE		hThreadClient;		//	NCAgXbhnh
	UI			idThreadClient;		//	NCAgXbhʎq
	HAJCVMBX	hVMbxTxD;			//	Mf[^E[{bNXnh
	BOOL		fTxBusy;			//	MoptO
	BC			SvSndA, dmy1;		//	eLXgM̑SpPoCgڑޔobt@
	WC			SvSndW;				//	eLXgM̃TQ[gPڑޔobt@
	UI			ixRxb;							//	Mobt@󕔕̃CfNXiO̔[}`oCgj
	UB			RxBuf[AJCSSVMAX_RXBUF + 8];		//	eLXgMf[^obt@if[^{r}`oCg(1`5)j{I[(0x00)j
	UB			RxBin[AJCSSVMAX_RXBUF];			//	oCiMf[^obt@
	UI			ixNpk;							//	pPbgOobt@󕔕̃CfNXiO̔[}`oCgj
	BC			NpBuf[AJCSSVMAX_RXBUF + 8];		//	pPbgOobt@if[^{r}`oCg(1`5)j{I[(0x00)j
} AJCSSVCLI, *HAJCSSVCLI;
typedef const AJCSSVCLI *PCAJCSSVCLI;

//	vg^Cv
AJCEXPORT	HAJCSSV	 		WINAPI	AjcSsvCreate		 (VO);
AJCEXPORT	BOOL			WINAPI	AjcSsvDelete		 (HAJCSSV hSsv);

AJCEXPORT	BOOL			WINAPI	AjcSsvSetOpt		 (HAJCSSV hSsv, AJCSSV_SERVOPT opt);
AJCEXPORT	AJCSSV_SERVOPT	WINAPI	AjcSsvGetOpt		 (HAJCSSV hSsv);

AJCEXPORT	BOOL			WINAPI	AjcSsvStartA(HAJCSSV hSsv, C_BCP pPort, int AddressFamily, UI MaxClients, HWND hWndNtc, UI WndMsgNtc);
AJCEXPORT	BOOL			WINAPI	AjcSsvStartW(HAJCSSV hSsv, C_WCP pPort, int AddressFamily, UI MaxClients, HWND hWndNtc, UI WndMsgNtc);
AJCEXPORT	BOOL			WINAPI	AjcSsvStop			 (HAJCSSV hSsv, UI msTimeout);

AJCEXPORT	BOOL			 WINAPI	AjcSsvSetChunkMode	 (HAJCSSV hSsv, AJCSSV_CHUNKMODE ChunkMode);
AJCEXPORT	AJCSSV_CHUNKMODE WINAPI	AjcSsvGetChunkMode	 (HAJCSSV hSsv);
AJCEXPORT	BOOL			WINAPI	AjcSsvSetEvtMask	 (HAJCSSV hSsv, UI EvtMsk);
AJCEXPORT	UI		 		WINAPI	AjcSsvGetEvtMask	 (HAJCSSV hSsv);
AJCEXPORT	BOOL			WINAPI	AjcSsvSetRxTextCode	 (HAJCSSV hSsv, AJCSSV_TEXTCODE code);
AJCEXPORT	AJCSSV_TEXTCODE	WINAPI	AjcSsvGetRxTextCode	 (HAJCSSV hSsv);
AJCEXPORT	BOOL			WINAPI	AjcSsvSetTxTextCode	 (HAJCSSV hSsv, AJCSSV_TEXTCODE code);
AJCEXPORT	AJCSSV_TEXTCODE	WINAPI	AjcSsvGetTxTextCode	 (HAJCSSV hSsv);
AJCEXPORT	BOOL			WINAPI	AjcSsvWaitEvent		 (HAJCSSV hSsv, WPARAM *pwParam, LPARAM *plParam, UI msTime);
AJCEXPORT	BOOL			WINAPI	AjcSsvGetEventData	 (HAJCSSV hSsv, LPARAM lParam, VOP *ppDat, UIP plDat, UIP pParam);
AJCEXPORT	UI				WINAPI	AjcSsvGetClient		 (HAJCSSV hSsv, LPARAM lParam, HAJCSSVCLI *hClient);
AJCEXPORT	BOOL			WINAPI	AjcSsvRelEventData	 (HAJCSSV hSsv, LPARAM lParam);
AJCEXPORT	BOOL			WINAPI	AjcSsvSetPktCtrlCode (HAJCSSV hSsv, UI stx, UI etx, UI dle);
AJCEXPORT	BOOL			WINAPI	AjcSsvGetPktCtrlCode (HAJCSSV hSsv, UIP pStx, UIP pEtx, UIP pDle);
AJCEXPORT	BOOL			WINAPI	AjcSsvSetPktTimeout	 (HAJCSSV hSsv, UI msTime);
AJCEXPORT	BOOL			WINAPI	AjcSsvGetPktTimeout	 (HAJCSSV hSsv, UIP pMsTime);
AJCEXPORT	UI				WINAPI	AjcSsvGetClientCount (HAJCSSV hSsv);
AJCEXPORT	UI				WINAPI	AjcSsvGetConnectCount(HAJCSSV hSsv);
AJCEXPORT	UI				WINAPI	AjcSsvEnumClients	 (HAJCSSV hSsv, UX cbp, BOOL (CALLBACK *cbNtcClients)(HAJCSSVCLI hClient, UX cbp));



AJCEXPORT	BOOL			WINAPI	AjcSsvDisconnect	(HAJCSSVCLI hClient);

AJCEXPORT	BOOL			WINAPI	AjcSsvSendCharA		(HAJCSSVCLI hClient, BC code);
AJCEXPORT	BOOL			WINAPI	AjcSsvSendCharW		(HAJCSSVCLI hClient, WC code);

AJCEXPORT	BOOL			WINAPI	AjcSsvSendTextA		(HAJCSSVCLI hClient, C_BCP pTxt, UI lTxt);
AJCEXPORT	BOOL			WINAPI	AjcSsvSendTextW		(HAJCSSVCLI hClient, C_WCP pTxt, UI lTxt);

AJCEXPORT	BOOL			WINAPI	AjcSsvSendTextFA	(HAJCSSVCLI hClient, C_BCP pFmt, ...);
AJCEXPORT	BOOL			WINAPI	AjcSsvSendTextFW	(HAJCSSVCLI hClient, C_WCP pFmt, ...);

AJCEXPORT	BOOL			WINAPI	AjcSsvSendBinData	(HAJCSSVCLI hClient, C_VOP pDat, UI lDat);
AJCEXPORT	UI				WINAPI	AjcSsvSendPacket	(HAJCSSVCLI hClient, C_VOP pPkt, UI lPkt);

AJCEXPORT	BOOL			WINAPI	AjcSsvPurgeRecvData	(HAJCSSVCLI hClient);
AJCEXPORT	BOOL			WINAPI	AjcSsvPurgeSendData	(HAJCSSVCLI hClient);
AJCEXPORT	BOOL			WINAPI	AjcSsvPurgeAllData	(HAJCSSVCLI hClient);

AJCEXPORT	BOOL			WINAPI	AjcSsvSetClientData	(HAJCSSVCLI hClient, UX   data);
AJCEXPORT	BOOL			WINAPI	AjcSsvGetClientData	(HAJCSSVCLI hClient, UXP pData);

AJCEXPORT	UI				WINAPI	AjcSsvGetSeqNo		(HAJCSSVCLI hClient);
AJCEXPORT	UI				WINAPI	AjcSsvGetIndex		(HAJCSSVCLI hClient);

AJCEXPORT	C_BCP			WINAPI	AjcSsvGetIpAddrStrA	(HAJCSSVCLI hClient, BCP pBuf, UI lBuf);
AJCEXPORT	C_WCP			WINAPI	AjcSsvGetIpAddrStrW	(HAJCSSVCLI hClient, WCP pBuf, UI lBuf);

AJCEXPORT	UI				WINAPI	AjcSsvGetThreadId	(HAJCSSVCLI hClient);
AJCEXPORT	SOCKET			WINAPI	AjcSsvGetSocket		(HAJCSSVCLI hClient);

AJCEXPORT	AJCSSV_TEXTCODE	WINAPI	AjcSsvGetActualRxTextCode(HAJCSSVCLI hClient);
AJCEXPORT	AJCSSV_TEXTCODE	WINAPI	AjcSsvGetActualTxTextCode(HAJCSSVCLI hClient);

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpT|[gR[h																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//----- Rg[ECh -------------------------------------------------------------------------------//
AJCEXPORT HAJCSSV WINAPI AjcSsvCreateForMSIL(	VO	 (CALLBACK *cbRxText		)(HAJCSSVCLI hClient, C_WCP text),
												VO	 (CALLBACK *cbRxEsc			)(HAJCSSVCLI hClient, C_WCP text),
												VO	 (CALLBACK *cbRxCtrl		)(HAJCSSVCLI hClient, int	ctrl),
												VO	 (CALLBACK *cbRxPacket		)(HAJCSSVCLI hClient, C_VOP pData, int lData),
												VO	 (CALLBACK *cbRxNoPkt		)(HAJCSSVCLI hClient, C_WCP text),
												VO	 (CALLBACK *cbTxEmpty		)(HAJCSSVCLI hClient),
												VO	 (CALLBACK *cbRxChunkTxt	)(HAJCSSVCLI hClient, C_WCP text),
												VO	 (CALLBACK *cbRxChunkBin	)(HAJCSSVCLI hClient, C_VOP pData, int lData),
												VO	 (CALLBACK *cbRxInvChunk	)(HAJCSSVCLI hClient, C_VOP pData, int lData),
												VO	 (CALLBACK *cbConnect		)(HAJCSSVCLI hClient),
												VO	 (CALLBACK *cbDisconnect	)(HAJCSSVCLI hClient),
												VO	 (CALLBACK *cbRecvError		)(HAJCSSVCLI hClient, BOOL fOverlapped),
												VO	 (CALLBACK *cbSendError		)(HAJCSSVCLI hClient, BOOL fOverlapped),
												VO	 (CALLBACK *cbStart			)(VO),
												VO	 (CALLBACK *cbStop			)(VO),
												VO	 (CALLBACK *cbGeneralError	)(UI ErrCode),
												BOOL (CALLBACK *cbEnumClients	)(HAJCSSVCLI pC, UX cbp));
//----- T[oJn ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL WINAPI AjcSsvStartForMSIL(HAJCSSV hSsv, C_WCP pPort, int AddressFamily, UI MaxClients, BOOL fOnEvent);
//----- NCAg ---------------------------------------------------------------------------------------//
AJCEXPORT UI WINAPI AjcSsvEnumClientsForMSIL(HAJCSSV hSsv, UX cbp);
//----- I -----------------------------------------------------------------------------------------------//
AJCEXPORT BOOL WINAPI AjcSsvDeleteForMSIL(HAJCSSV hSsv);



/****************************************************************************************************************/
#endif
