#ifndef	AJCTEXTFILE_H_
#define	AJCTEXTFILE_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//	tmhbncd^`rbhh																					//
//--------------------------------------------------------------------------------------------------------------//
#ifdef	UNICODE
	#define		AjcFOpen			AjcFOpenW
	#define		AjcFGetS			AjcFGetSW
	#define		AjcFGetSEx			AjcFGetSExW
	#define		AjcFGetC			AjcFGetCW
	#define		AjcFGetCode			AjcFGetCodeW
	#define		AjcFGetPoint		AjcFGetPointW
	#define		AjcFGetBytePoint	AjcFGetBytePointW
	#define		AjcFSavePoint		AjcFSavePointW
	#define		AjcFCreate			AjcFCreateW
	#define		AjcFAppend			AjcFAppendW
	#define		AjcFPutS			AjcFPutSW
	#define		AjcFPutC			AjcFPutCW
	#define		AjcFPutCode			AjcFPutCodeW
	#define		AjcFPrintF			AjcFPrintFW
	#define		AjcFVPrintF			AjcFVPrintFW
	#define		AjcFTecDialog		AjcFTecDialogW
#else
	#define		AjcFOpen			AjcFOpenA
	#define		AjcFGetS			AjcFGetSA
	#define		AjcFGetSEx			AjcFGetSExA
	#define		AjcFGetC			AjcFGetCA
	#define		AjcFGetCode			AjcFGetCodeA
	#define		AjcFGetPoint		AjcFGetPointA
	#define		AjcFGetBytePoint	AjcFGetBytePointW
	#define		AjcFSavePoint		AjcFSavePointA
	#define		AjcFCreate			AjcFCreateA
	#define		AjcFAppend			AjcFAppendA
	#define		AjcFPutS			AjcFPutSA
	#define		AjcFPutC			AjcFPutCA
	#define		AjcFPutCode			AjcFPutCodeA
	#define		AjcFPrintF			AjcFPrintFA
	#define		AjcFVPrintF			AjcFVPrintFA
	#define		AjcFTecDialog		AjcFTecDialogA
#endif

//--------------------------------------------------------------------------------------------------------------//
//	sR[hϊ[h																						//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCFLF_NONE				= 0	,		//	ϊ

	AJCFLF_LF_TO_CRLF			,		//	ke  bqCkeit@Cݎ̃ftHgj
	AJCFLF_LF_TO_CR				,		//	ke  bq

	AJCFLF_CR_TO_CRLF			,		//	bq  bqCke
	AJCFLF_CR_TO_LF				,		//	bq  ke

	AJCFLF_CRLF_TO_LF			,		//	bqCke  keit@CǂݏõftHgj
	AJCFLF_CRLF_TO_CR			,		//	bqCke  bq

	AJCFLF_LF					,		//	keŉsCϊ
	AJCFLF_CR					,		//	bqŉsCϊ
	AJCFLF_LF_CRSKIP			,		//	keŉsCbq
	AJCFLF_CR_LFSKIP			,		//	bqŉsCke

} AJCFLFCONV, *PAJCFLFCONV;

#define		AJCFLFCONV_MIN	AJCFLF_NONE
#define		AJCFLFCONV_MAX	AJCFLF_CR_LFSKIP


//----- ͉s[h -----------------------------------------------------------------------------------------//
typedef enum {
	AJCFILF_LF			= 1	,	//	keŉsCbq͓ǂݔ΂
	AJCFILF_LF_CROUT		,	//	keŉsCbq͂̂܂܏o
	AJCFILF_CR				,	//	bqŉsCke͓ǂݔ΂
	AJCFILF_CR_LFOUT		,	//	bqŉsDke͂̂܂܏o
} AJCFINP_LFMODE, *PAJCFINP_LFMODE;

#define	AJCFILF_MIN		AJCFILF_LF
#define	AJCFILF_MAX		AJCFILF_CR_LFOUT

//----- o͉s[h -----------------------------------------------------------------------------------------//
typedef enum {
	AJCFOLF_CRLF		= 1	,	//	sR[hbqCkeo
	AJCFOLF_LF				,	//	sR[hkeo
	AJCFOLF_CR				,	//	sR[hbqo
} AJCFOUT_LFMODE, *PAJCFOUT_LFMODE;

#define	AJCFOLF_MIN		AJCFOLF_CRLF
#define	AJCFOLF_MAX		AJCFOLF_CR

//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTF_MAX_BUFW		1024
#define	AJCTF_MAX_BUFA		(AJCTF_MAX_BUFW * 2)

typedef union {
	BCP			bcp;
	WCP			wcp;
	VOP			vop;
} AJCFUPTR;

typedef struct {
	UI				iid;					//	CX^Xhc
	AJCFLFCONV		LfCnv;					//	sR[hϊ[h
	HANDLE			hFile;					//	t@Cnh
	EAJCTEC			tec;					//	eLXgGR[hʁiUTF-16̏ꍇ́AAJCTEC_MBCݒj
	BOOL			fInp;					//	o̓[hiFALSE:Output, TRUE:Input)

	//--- t@Cǂݏo ------------------------------------------------------//
	ULL				FSizeA;					//	t@CTCYioCgj
	ULL				FSizeW;					//	t@CTCYij
	ULL				FIx;					//	t@CCfNXiǂݏooCgʒu^ʒuj
	HANDLE			hMap;					//	t@C}bsOnh

	AJCFUPTR		pInpTop;				//	t@C}bsO擪AhX
	AJCFUPTR 		pInp;					//	t@C}bsOǂݏo|C^

	BOOL			fExistBOM;				//	̓t@ĈanlLtO

	UI				lFmtBuf;				//	pobt@ij
	AJCFUPTR		pFmtBuf;				//	pobt@|C^

	BC				szLfA[3];				//	sR[hioCgt@Cpj
	WC				szLfW[3];				//	sR[hiCht@Cpj

	//--- t@Cݏ ------------------------------------------------------//
	BOOL			fBomOut;				//	anlo̓tOio͌NA[j
	UI				SvOutC;					//	݃eLXg̃}`oCgPoCgځ^TQ[gPڑޔi|PFޔȂj

	//--- t@C݁^P͗pobt@ ------------------------------------//
	UI				BufBytes;				//	obt@Ɋi[ĂeLXg̃oCg
	UI				BufChars;				//	obt@Ɋi[ĂeLXg̃oCg^
	UI				ixBuf;					//	obt@CfNX
	ULL				BufFIx;					//	obt@擪ɑΉt@CCfNXiǂݏooCgʒu^ʒuj
	union {									//	AjcFGetC()pǂݏoobt@
		BC			mbc[AJCTF_MAX_BUFA];	//	obt@ioCgj
		WC			uni[AJCTF_MAX_BUFW];	//	obt@iChj
	} buf;

	//----- t@Cǂݏo|C^ޔ ----------------------------------------//
	ULL				Sv_FIx;					//	t@CCfNXޔ
	AJCFUPTR		Sv_pInp;				//	t@C}bsOǂݏo|C^

	//----- R[obN ------------------------------------------------------------//
	UX		cbp;									//	R[obNp^
	BOOL	(CALLBACK *cbNtcRPos)(ULL pos, UX cbp);	//	ǂݏoςݕʒm

} AJCFILE, *HAJCFILE;

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
//	eLXgt@C
AJCEXPORT	HAJCFILE	WINAPI	AjcFOpenA	(C_BCP pPath, EAJCTEC tec);
AJCEXPORT	HAJCFILE	WINAPI	AjcFOpenW	(C_WCP pPath, EAJCTEC tec);

AJCEXPORT	HAJCFILE	WINAPI	AjcFAttachOpened	(HANDLE hFile, EAJCTEC tec);

AJCEXPORT	BCP			WINAPI	AjcFGetSA	(HAJCFILE hFile, BCP pBuf, UI lBuf);
AJCEXPORT	WCP			WINAPI	AjcFGetSW	(HAJCFILE hFile, WCP pBuf, UI lBuf);

AJCEXPORT	BCP			WINAPI	AjcFGetSExA	(HAJCFILE hFile, BCP pBuf, UI lBuf, UX cbp, BOOL (CALLBACK *cbNtcRPos)(ULL pos, UX cbp));
AJCEXPORT	WCP			WINAPI	AjcFGetSExW	(HAJCFILE hFile, WCP pBuf, UI lBuf, UX cbp, BOOL (CALLBACK *cbNtcRPos)(ULL pos, UX cbp));

AJCEXPORT	BC			WINAPI	AjcFGetCA	(HAJCFILE hFile);
AJCEXPORT	WC			WINAPI	AjcFGetCW	(HAJCFILE hFile);

AJCEXPORT	UI			WINAPI	AjcFGetCodeA(HAJCFILE hFile);
AJCEXPORT	UI			WINAPI	AjcFGetCodeW(HAJCFILE hFile);

AJCEXPORT	ULL			WINAPI	AjcFGetPointA(HAJCFILE pW);
AJCEXPORT	ULL			WINAPI	AjcFGetPointW(HAJCFILE pW);

AJCEXPORT	ULL			WINAPI	AjcFGetBytePointA(HAJCFILE pW);
AJCEXPORT	ULL			WINAPI	AjcFGetBytePointW(HAJCFILE pW);

AJCEXPORT	BOOL		WINAPI	AjcFSetPoint(HAJCFILE pW, ULL point);

AJCEXPORT	ULL			WINAPI	AjcFSavePointA(HAJCFILE hFile);
AJCEXPORT	ULL			WINAPI	AjcFSavePointW(HAJCFILE hFile);

AJCEXPORT	BOOL		WINAPI	AjcFRecvPoint(HAJCFILE hFile);

AJCEXPORT	BOOL		WINAPI	AjcFEof		(HAJCFILE hFile);


//	eLXgt@Co
AJCEXPORT	HAJCFILE	WINAPI	AjcFCreateA	(C_BCP pPath, EAJCTEC tec, BOOL fBOM);
AJCEXPORT	HAJCFILE	WINAPI	AjcFCreateW	(C_WCP pPath, EAJCTEC tec, BOOL fBOM);

AJCEXPORT	HAJCFILE	WINAPI	AjcFAppendA	(C_BCP pPath, EAJCTEC tec, BOOL fBOM);
AJCEXPORT	HAJCFILE	WINAPI	AjcFAppendW	(C_WCP pPath, EAJCTEC tec, BOOL fBOM);

AJCEXPORT	HAJCFILE	WINAPI	AjcFAttachCreated(HANDLE hFile, EAJCTEC tec, BOOL fBOM);

AJCEXPORT	BOOL		WINAPI	AjcFPutSA	(HAJCFILE hFile, C_BCP pText, UI lText);
AJCEXPORT	BOOL		WINAPI	AjcFPutSW	(HAJCFILE hFile, C_WCP pText, UI lText);

AJCEXPORT	BOOL		WINAPI	AjcFPutCA	(HAJCFILE pW, BC c);
AJCEXPORT	BOOL		WINAPI	AjcFPutCW	(HAJCFILE pW, WC c);

AJCEXPORT	BOOL		WINAPI	AjcFPutCodeA(HAJCFILE hFile, UI c);
AJCEXPORT	BOOL		WINAPI	AjcFPutCodeW(HAJCFILE hFile, UI c);

AJCEXPORT	BOOL		WINAPI	AjcFPrintFA	(HAJCFILE hFile, C_BCP pFmt, ...);
AJCEXPORT	BOOL		WINAPI	AjcFPrintFW	(HAJCFILE hFile, C_WCP pFmt, ...);

AJCEXPORT	BOOL		WINAPI	AjcFVPrintFA	(HAJCFILE hFile, C_BCP pFmt, va_list vls);
AJCEXPORT	BOOL		WINAPI	AjcFVPrintFW	(HAJCFILE hFile, C_WCP pFmt, va_list vls);

//	eLXgt@CN[Y
AJCEXPORT	BOOL		WINAPI	AjcFClose	(HAJCFILE hFile);

//	eLXgt@CN[YȂŃCX^X
AJCEXPORT	BOOL		WINAPI	AjcFDetach	(HAJCFILE hFile);

//	s[hݒ^擾
AJCEXPORT	BOOL		WINAPI	AjcFSetLfConv (HAJCFILE  hFile, AJCFLFCONV mode);
AJCEXPORT	AJCFLFCONV	WINAPI	AjcFGetLfConv (HAJCFILE  hFile);

//	eLXgGR[hʎ擾
AJCEXPORT	EAJCTEC		WINAPI	AjcFGetTec	(HAJCFILE hFile);

//	̓t@ĈanlL̎擾
AJCEXPORT	BOOL		WINAPI	AjcFGetBOM(HAJCFILE hFile);

//	o̓[h擾
AJCEXPORT	BOOL		WINAPI	AjcFIsModeInput(HAJCFILE hFile);

//	obt@ݒ
AJCEXPORT	BOOL		WINAPI	AjcFSetFmtLen	(HAJCFILE hFile, UI len);

//	t@Cnh擾
AJCEXPORT	HANDLE		WINAPI	AjcFGetFileHandle	(HAJCFILE hFile);

//	GR[hʐݒ_CAO
AJCEXPORT	BOOL		WINAPI	AjcFTecDialogA(HWND hOwner, C_BCP pTitle, HICON hIcon, PEAJCTEC pInpTec, PEAJCTEC pOutTec, BOOL *pOutBom);
AJCEXPORT	BOOL		WINAPI	AjcFTecDialogW(HWND hOwner, C_WCP pTitle, HICON hIcon, PEAJCTEC pInpTec, PEAJCTEC pOutTec, BOOL *pOutBom);

/****************************************************************************************************************/
#endif
