#ifndef	AJCTIPCTL_H_
#define	AJCTIPCTL_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//	tmhbncd^`rbhh																					//
//--------------------------------------------------------------------------------------------------------------//
#ifdef	UNICODE
	#define	AjcTipTextAdd			AjcTipTextAddW
	#define	AjcTipTextAddEx			AjcTipTextAddExW
	#define	AjcTipTextAddF			AjcTipTextAddFW
	#define	AjcTipTextAddFEx		AjcTipTextAddFExW
	#define	AjcTipTextSetCallBack	AjcTipTextSetCallBackW
	#define	AjcTipTextGetInfo		AjcTipTextGetInfoW
	#define	AjcTipTextRegistPrefix	AjcTipTextRegistPrefixW

	#define	AJCTIPCTRL_SETHWND		AJCTIPCTRL_SETHWNDW
	#define	AJCTIPCTRL_PROPNAME		AJCTIPCTRL_PROPNAMEW
	#define	AJCTIPFRIEND_PROPNAME	AJCTIPFRIEND_PROPNAMEW
	#define	AJCTIP_SETFRIEND		AJCTIP_SETFRIENDW
#else
	#define	AjcTipTextAdd			AjcTipTextAddA
	#define	AjcTipTextAddEx			AjcTipTextAddExA
	#define	AjcTipTextAddF			AjcTipTextAddFA
	#define	AjcTipTextAddFEx		AjcTipTextAddFExA
	#define	AjcTipTextSetCallBack	AjcTipTextSetCallBackA
	#define	AjcTipTextGetInfo		AjcTipTextGetInfoA
	#define	AjcTipTextRegistPrefix	AjcTipTextRegistPrefixA

	#define	AJCTIPCTRL_SETHWND		AJCTIPCTRL_SETHWNDA
	#define	AJCTIPCTRL_PROPNAME		AJCTIPCTRL_PROPNAMEA
	#define	AJCTIPFRIEND_PROPNAME	AJCTIPFRIEND_PROPNAMEA
	#define	AJCTIP_SETFRIEND		AJCTIP_SETFRIENDA
#endif


//--------------------------------------------------------------------------------------------------------------//
//	`bveLXg̕\ʒu[h																				//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCTIP_POS_UNDER_CONTROL	= 0	,	//	c[`bvΏۃRg[̉ɕ\
	AJCTIP_POS_UNDER_CURSOR		= 1	,	//	c[`bv}EXJ[\̉ɕ\
} AJCTIP_POSMODE, *PAJCTIP_POSMODE;

//--------------------------------------------------------------------------------------------------------------//
//	`bveLXgݒ																						//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	HWND		hCtrl;					//	Rg[̃EChnh
	int			msDelay;				//	\x[ms]
	int			msShow;					//	\	[ms]
	HFONT		hFont;					//	tHgnh	(NULL : ftHgtHgj
	COLORREF	TextColor;				//	eLXg`F		(-1 : ftHgF)
	COLORREF	BackGround;				//	wiF				(-1 : ftHgF)
	COLORREF	BorderColor;			//	Og`F			(-1 : ftHgFC-2 : Og\)
	UI			WindowTime;				//	Rg[ԈړP\[ms]
	HFONT		hDefFont;				//	ftHg̃tHgnh
	COLORREF	DefTextColor;			//		V	  ̃eLXg`F
	COLORREF	DefBackGround;			//		V	  ̔wiF
	COLORREF	DefBorderColor;			//		V	  ̊Og`F
	int			DefMsDelay;				//		V	  ̕\x
	int			DefMsShow;				//		V	  ̕\
} AJCTIPINFO, *PAJCTIPINFO;
typedef const AJCTIPINFO *PCAJCTIPINFO;

//--------------------------------------------------------------------------------------------------------------//
//	`bv̑ΏۃECh																				//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCTIPCTRL_PROPNAMEA		 "AJCTIPCTRLHWND"
#define		AJCTIPCTRL_PROPNAMEW		L"AJCTIPCTRLHWND"

#define		AJCTIPCTRL_SETHWNDA(HCTRL, TIPWND)		SetPropA(HCTRL, AJCTIPCTRL_PROPNAMEA, (HANDLE)TIPWND)
#define		AJCTIPCTRL_SETHWNDW(HCTRL, TIPWND)		SetPropW(HCTRL, AJCTIPCTRL_PROPNAMEW, (HANDLE)TIPWND)

//--------------------------------------------------------------------------------------------------------------//
//	`bv̗FBEChiyI[_[ʂłȉ̃vpeBݒ肳Ăꍇ͓EChƂ݂Ȃj//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCTIPFRIEND_PROPNAMEA		 "AjcTipCtrlFriend"
#define		AJCTIPFRIEND_PROPNAMEW		L"AjcTipCtrlFriend"
#define		AJCTIPFRIEND_ID				(0x978145B3)

#define		AJCTIP_SETFRIENDA(HFRIEND)		SetPropA(HFRIEND, AJCTIPFRIEND_PROPNAMEA, (HANDLE)((UX)AJCTIPFRIEND_ID))
#define		AJCTIP_SETFRIENDW(HFRIEND)		SetPropW(HFRIEND, AJCTIPFRIEND_PROPNAMEW, (HANDLE)((UX)AJCTIPFRIEND_ID))

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTipTextEnableMultiThread(BOOL fEnable);

AJCEXPORT AJCTIP_POSMODE WINAPI AjcTipTextSetTipPosMode (AJCTIP_POSMODE PosMode);

AJCEXPORT BOOL	 WINAPI AjcTipTextAddA(HWND hCtrl, C_BCP pTxt);
AJCEXPORT BOOL	 WINAPI AjcTipTextAddW(HWND hCtrl, C_WCP pTxt);

AJCEXPORT BOOL	 WINAPI AjcTipTextAddExA(HWND hCtrl, C_BCP pTxt, int msDelay, int msShow, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor);
AJCEXPORT BOOL	 WINAPI AjcTipTextAddExW(HWND hCtrl, C_WCP pTxt, int msDelay, int msShow, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor);

AJCEXPORT BOOL	 WINAPI AjcTipTextAddFA(HWND hCtrl, C_BCP pFmt, ...);
AJCEXPORT BOOL	 WINAPI AjcTipTextAddFW(HWND hCtrl, C_WCP pFmt, ...);

AJCEXPORT BOOL	 WINAPI AjcTipTextAddFExA(HWND hCtrl, int msDelay, int msShow, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor, C_BCP pFmt, ...);
AJCEXPORT BOOL	 WINAPI AjcTipTextAddFExW(HWND hCtrl, int msDelay, int msShow, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor, C_WCP pFmt, ...);

AJCEXPORT BOOL	 WINAPI AjcTipTextSetShowAlways(HWND hCtrl, BOOL fShowAlways);
AJCEXPORT BOOL	 WINAPI AjcTipTextGetShowAlways(HWND hCtrl);

AJCEXPORT VO	 WINAPI AjcTipTextSetShowForActive(BOOL fShowForActive);
AJCEXPORT BOOL	 WINAPI AjcTipTextGetShowForActive(VO);

AJCEXPORT BOOL	 WINAPI AjcTipTextSetCallBackA(HWND hCtrl, UX cbp, BOOL (CALLBACK *cbChkCursor)(HWND hCtrl, LPPOINT ptClient, UX cbp), C_BCP (CALLBACK *cbGetText)(HWND hCtrl, BCP pBuf, UI lBuf, UX cbp));
AJCEXPORT BOOL	 WINAPI AjcTipTextSetCallBackW(HWND hCtrl, UX cbp, BOOL (CALLBACK *cbChkCursor)(HWND hCtrl, LPPOINT ptClient, UX cbp), C_WCP (CALLBACK *cbGetText)(HWND hCtrl, WCP pBuf, UI lBuf, UX cbp));

AJCEXPORT BOOL	 WINAPI AjcTipTextSetCallBackNoBufA(HWND hCtrl, UX cbp, BOOL (CALLBACK *cbChkCursor)(HWND hCtrl, LPPOINT ptClient, UX cbp), C_BCP (CALLBACK *cbGetText)(HWND hCtrl, UX cbp));
AJCEXPORT BOOL	 WINAPI AjcTipTextSetCallBackNoBufW(HWND hCtrl, UX cbp, BOOL (CALLBACK *cbChkCursor)(HWND hCtrl, LPPOINT ptClient, UX cbp), C_WCP (CALLBACK *cbGetText)(HWND hCtrl, UX cbp));

AJCEXPORT BOOL	 WINAPI AjcTipTextEnable		(HWND hCtrl, BOOL fEnable);
AJCEXPORT BOOL	 WINAPI AjcTipTextGetEnableState(HWND hCtrl);

AJCEXPORT VO	 WINAPI AjcTipTextEnableAll 	   (BOOL fEnable);
AJCEXPORT BOOL	 WINAPI AjcTipTextGetEnableAllState(VO);

AJCEXPORT BOOL	 WINAPI AjcTipTextRemove(HWND hCtrl);
AJCEXPORT BOOL	 WINAPI AjcTipTextRemoveAll(VO);

AJCEXPORT UI	 WINAPI AjcTipTextGetInfoA(HWND hCtrl, PAJCTIPINFO pInfoBuf, BCP pTxtBuf, UI lTxtBuf);
AJCEXPORT UI	 WINAPI AjcTipTextGetInfoW(HWND hCtrl, PAJCTIPINFO pInfoBuf, WCP pTxtBuf, UI lTxtBuf);

AJCEXPORT BOOL	 WINAPI AjcTipTextSetNtcSubclass(HWND hCtrl, HWND hNtc, UI msg, UX lParam);
AJCEXPORT BOOL	 WINAPI AjcTipTextClrNtcSubclass(HWND hCtrl);

AJCEXPORT VO	 WINAPI AjcTipTextSetWindowTime(int msTime);
AJCEXPORT int	 WINAPI AjcTipTextGetWindowTime(VO);

AJCEXPORT VO	 WINAPI AjcTipTextSetDefMsDelay(int msDelay);
AJCEXPORT int	 WINAPI AjcTipTextGetDefMsDelay(VO);

/****************************************************************************************************************/
#endif
