#ifndef		AJCXYMODEM_H_
#define		AJCXYMODEM_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcXymCreate		AjcXymCreateW
	#define	AJCXYMFILEINFO		AJCXYMFILEINFOW
	#define	PAJCXYMFILEINFO		PAJCXYMFILEINFOW
	#define	PCAJCXYMFILEINFO	PCAJCXYMFILEINFOW
#else
	#define	AjcXymCreate		AjcXymCreateA
	#define	AJCXYMFILEINFO		AJCXYMFILEINFOA
	#define	PAJCXYMFILEINFO		PAJCXYMFILEINFOA
	#define	PCAJCXYMFILEINFO	PCAJCXYMFILEINFOA
#endif
/*--------------------------------------------------------------------------------------------------------------*/
/*	CX^X[N																							*/
/*--------------------------------------------------------------------------------------------------------------*/
/*----- t@CioCgj------------------------------------------------------------------------------*/
typedef  struct  {
	BCP		pFName;					/*	t@Cւ̃|C^iAAt@CȈꍇ͂mtkkj			*/
	ULL		size;					/*	t@CTCY															*/
	UL		time;					/*	t@C^Ci1970-01-01 00:00:00 ̒ʎZb (UTC) j				*/
} AJCXYMFILEINFOA, *PAJCXYMFILEINFOA;
typedef const AJCXYMFILEINFOA *PCAJCXYMFILEINFOA;

/*----- t@CiChj------------------------------------------------------------------------------*/
typedef  struct  {
	WCP		pFName;					/*	t@Cւ̃|C^iAAt@CȈꍇ͂mtkkj			*/
	ULL		size;					/*	t@CTCY															*/
	UL		time;					/*	t@C^Ci1970-01-01 00:00:00 ̒ʎZb (UTC) j				*/
} AJCXYMFILEINFOW, *PAJCXYMFILEINFOW;
typedef const AJCXYMFILEINFOW *PCAJCXYMFILEINFOW;

/*----- t@CioCg^Ch ʁj-------------------------------------------------------------*/
typedef  struct  {
	VOP		pFName;					/*	t@Cւ̃|C^iAAt@CȈꍇ͂mtkkj			*/
	ULL		size;					/*	t@CTCY															*/
	UL		time;					/*	t@C^Ci1970-01-01 00:00:00 ̒ʎZb (UTC) j				*/
} AJCXYMFILEINFOV, *PAJCXYMFILEINFOV;
typedef const AJCXYMFILEINFOV *PCAJCXYMFILEINFOV;

/*----- R[obN^Cvit@C擾j------------------------------------------------------------------*/
typedef	VO (CALLBACK *AJCXYMCB_GETFILEA)	(PAJCXYMFILEINFOA pBuf, UX cbp);
typedef	VO (CALLBACK *AJCXYMCB_GETFILEW)	(PAJCXYMFILEINFOW pBuf, UX cbp);
typedef	VO (CALLBACK *AJCXYMCB_GETFILEV)	(PAJCXYMFILEINFOV pBuf, UX cbp);

/*--------------------------------------------------------------------------------------------------------------*/
typedef  struct  _AJCXYM {
	UI		InstID;					/*	CX^Xhc														*/
	BOOL	fUnicode;				/*	ChtO														*/
	HAJCSTC	hStc;					/*	ԑJڐCX^Xnh										*/
	UI		knd;					/*	vgR															*/

	UI		RecL;					/*	MFOɑMR[h̃oCgi132/133/1029j				*/
									/*	MFM̃R[hi132/133/1029j								*/

	UI		MaxL;					/*	őf[^i128 / 1024j												*/
	UI		DatL;					/*	f[^i128 / 1024j													*/
	UI		ChkL;					/*	`FbNoCgi1:SUM, 2:CRCj										*/

	UI		tx_t0, tx_t1;			/*	M^C}															*/
	UI		tx_r0, tx_r1;			/*	MgC															*/

	UI		rx_t0, rx_t1;			/*	M^C}															*/
	UI		rx_r0, rx_r1;			/*	MgC															*/

	UI		tim0;					/*	MFMv҂	MFMv(NAK/C/G)MC^o[ms]	*/
	UI		tim1;					/*	MFACKM҂[ms]		MFR[h^EOTM҂[ms]			*/

	UI		rty0, RtyCnt0;			/*	MFgp				MFgp								*/
	UI		rty1, RtyCnt1;			/*	MFACKMgC		MFR[h^EOTMgC			*/

	UB		rno;					/*	R[hԍ															*/
	UI		bix;					/*	obt@CfNX														*/
	UB		buf[1024 + 5];			/*	Mobt@															*/

	UX		cbp;					/*	R[obNp^													*/
	VO	(CALLBACK *cbNotice )(UI knd, UX Param				, UX cbp);
	VO	(CALLBACK *cbGetFile)(PAJCXYMFILEINFOV pBuf 		, UX cbp);
	VO	(CALLBACK *cbGetData)(VOP pBuf, UI len, UIP pBytes	, UX cbp);
	VO	(CALLBACK *cbSend	)(C_VOP pTxD, UI len 			, UX cbp);

} AJCXYM, *HAJCXYM;

/*--------------------------------------------------------------------------------------------------------------*/
/*	ʒmR[h																									*/
/*--------------------------------------------------------------------------------------------------------------*/
#define		AJCXYN_RXFILEINFO		0x0010				/*	Mt@Cʒm								*/
#define		AJCXYN_TXREC			0x0020				/*	PR[hM									*/
#define		AJCXYN_RXREC_128		0x0021				/*	PR[hMiPQWoCgR[hj				*/
#define		AJCXYN_RXREC_1K			0x0022				/*	PR[hMiPjaR[hj					*/
#define		AJCXYN_RETRY			0x0030				/*	đ											*/
#define		AJCXYN_EOF				0x0040				/*	dneʒm											*/
#define		AJCXYN_PROTOCOL			0x0050				/*	ʐMvgRύXʒm								*/

#define		AJCXYN_USER				0x7000				/*	[U`pi0x7000`0x7FFFj						*/

#define		AJCXYN_END				0x8000
#define		AJCXYN_COMPLETE			(AJCXYN_END + 0)	/*	t@C]									*/
#define		AJCXYN_RX_CAN			(AJCXYN_END + 1)	/*	t@C]~ib`mM					j	*/
#define		AJCXYN_USERSTOP			(AJCXYN_END + 2)	/*	@V@@@@@@i[U̒~v			j	*/
#define		AJCXYN_TIMEOUT			(AJCXYN_END + 3)	/*	@V@@@@@@i^CAEg					j	*/
#define		AJCXYN_ABORT			(AJCXYN_END + 4)	/*	@V@@@@@@ȋ						j	*/

/*--------------------------------------------------------------------------------------------------------------*/
/*	vgR																								*/
/*--------------------------------------------------------------------------------------------------------------*/
#define		AJCXYP_XMODEM		0x10
#define		AJCXYP_YMODEM		0x20

typedef enum {
	AJCXYP_XMODEM_SUM	=	(AJCXYP_XMODEM + 1)	,
	AJCXYP_XMODEM_CRC	=	(AJCXYP_XMODEM + 2)	,
	AJCXYP_XMODEM_1K	=	(AJCXYP_XMODEM + 3)	,

	AJCXYP_YMODEM_STD	=	(AJCXYP_YMODEM + 1)	,
	AJCXYP_YMODEM_G		=	(AJCXYP_YMODEM + 2)	,
} AJCXYMPROTOCOL;
/*--------------------------------------------------------------------------------------------------------------*/
/*	vg^Cv																								*/
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT HAJCXYM	WINAPI	AjcXymCreateA(UX cbp,
										  VO (CALLBACK *cbNotice )(UI knd, UX Param					, UX cbp),
										  VO (CALLBACK *cbGetFile)(PAJCXYMFILEINFOA pBuf			, UX cbp),
										  VO (CALLBACK *cbGetData)(  VOP pBuf, UI lBuf, UIP pBytes	, UX cbp),
										  VO (CALLBACK *cbSend	 )(C_VOP pTxD, UI lTxD				, UX cbp));

AJCEXPORT HAJCXYM	WINAPI	AjcXymCreateW(UX cbp,
										  VO (CALLBACK *cbNotice )(UI knd, UX Param					, UX cbp),
										  VO (CALLBACK *cbGetFile)(PAJCXYMFILEINFOW pBuf			, UX cbp),
										  VO (CALLBACK *cbGetData)(  VOP pBuf, UI lBuf, UIP pBytes	, UX cbp),
										  VO (CALLBACK *cbSend	 )(C_VOP pTxD, UI lTxD				, UX cbp));

AJCEXPORT VO	WINAPI	AjcXymDelete(HAJCXYM hAjcXym);

AJCEXPORT BOOL	WINAPI		AjcXymTxStart		(HAJCXYM hXym, AJCXYMPROTOCOL Protocol);
AJCEXPORT BOOL	WINAPI		AjcXymRxStart		(HAJCXYM hXym, AJCXYMPROTOCOL Protocol);
AJCEXPORT VO	WINAPI		AjcXymSetTxTimeInfo	(HAJCXYM hXym, UI  t0, UI  r0, UI  t1, UI  r1);
AJCEXPORT VO	WINAPI		AjcXymGetTxTimeInfo	(HAJCXYM hXym, UIP t0, UIP r0, UIP t1, UIP r1);
AJCEXPORT VO	WINAPI		AjcXymSetRxTimeInfo	(HAJCXYM hXym, UI  t0, UI  r0, UI  t1, UI  r1);
AJCEXPORT VO	WINAPI		AjcXymGetRxTimeInfo	(HAJCXYM hXym, UIP t0, UIP r0, UIP t1, UIP r1);
AJCEXPORT VO	WINAPI		AjcXymStop			(HAJCXYM hXym);
AJCEXPORT VO	WINAPI		AjcXymPutRxChar 	(HAJCXYM hXym, UI rxd);
AJCEXPORT VO	WINAPI		AjcXymTxEnd 		(HAJCXYM hXym);
AJCEXPORT UI	WINAPI		AjcXymGetState		(HAJCXYM hXym);

/****************************************************************************************************************/
#endif
