#ifndef	AJXAVS_H_
#define	AJXAVS_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	tQ؁iL[j																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	NX`(ASCII)																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxAvs {
		BOOL	m_fUnicode;						//	UNICODE / ASCII ʃtO

	public:
		HAJCAVS	m_hAvs;							//	`ukCX^Xhnh
		BOOL	m_fDestruct;					//	fXgNgtO

		#ifdef UNICODE
			CAjxAvs(BOOL fUnicode = TRUE);		//	RXgN^(UNICODE)
		#else
			CAjxAvs(BOOL fUnicode = FALSE);		//	RXgN^(UNICODE)
		#endif
		~CAjxAvs();								//	fXgN^

		BOOL	EnableMultiThread	(BOOL fEnable);								//	}`Xbh̋^֎~

		//----- m[hANZX ---------------------------------------------------------------------------------//
		BOOL	InsNode				(C_BCP key, C_VOP pNodeData, UI len);		//	m[h}(ASCII)
		BOOL	InsNode				(C_WCP key, C_VOP pNodeData, UI len);		//	m[h}(UNICODE)

		int		GetNode				(C_BCP key, VOP   pBuf,	  UI lBuf);			//	m[h擾(ASCII)
		int		GetNode				(C_WCP key, VOP   pBuf,	  UI lBuf);			//	m[h擾(UNICODE)

		VOP		GetNodePtr			(C_BCP	key, UIP pLen = NULL);				//	m[hAhX擾(ASCII)
		VOP		GetNodePtr			(C_WCP	key, UIP pLen = NULL);				//	m[hAhX擾(UNICODE)

		BOOL	RepNode				(C_BCP key, C_VOP pNodeData, UI len);		//	m[hu(ASCII)
		BOOL	RepNode				(C_WCP key, C_VOP pNodeData, UI len);		//	m[hu(UNICODE)

		BOOL	InsOrRepNode		(C_BCP key, C_VOP pNodeData, UI len);		//	m[h}^u(ASCII)
		BOOL	InsOrRepNode		(C_WCP key, C_VOP pNodeData, UI len);		//	m[h}^u(UNICODE)

		BOOL	DelNode				(C_BCP key);								//	m[h폜(ASCII)
		BOOL	DelNode				(C_WCP key);								//	m[h폜(UNICODE)

		BOOL	DelAllNodes			();											//	Sm[h폜

		//----- ̑ -----------------------------------------------------------------------------------------//
		UI		GetCount			();															//	m[h擾
		UI		EnumNodes			(BOOL fDownSeq = FALSE);									//	Sm[h̃V[PVȓǂݏo

		BOOL	CreatePtrArr	(PCAJCAVSPTRA *ppArr, UIP pNum = NULL, BOOL fDownSeq = FALSE);	//	Sm[hւ̃|C^z񐶐(ASCII)
		BOOL	CreatePtrArr	(PCAJCAVSPTRW *ppArr, UIP pNum = NULL, BOOL fDownSeq = FALSE);	//	Sm[hւ̃|C^z񐶐(UNICODE)

		BOOL		ReleasePtrArr	(PCAJCAVSPTRA pArr);										//	Sm[hւ̃|C^z(ASCII)
		BOOL		ReleasePtrArr	(PCAJCAVSPTRW pArr);										//	Sm[hւ̃|C^z(UNICODE)

		//----- z֐ ---------------------------------------------------------------------------------------//
		virtual VO	 OnNtcRemove	(C_BCP key, VOP pNodeData, UI len, UI nest);	//	m[h폜ʒm(ASCII)
		virtual VO	 OnNtcRemove	(C_WCP key, VOP pNodeData, UI len, UI nest);	//	m[h폜ʒm(UNICODE)

		virtual BOOL OnNtcNode		(C_BCP key, VOP pNodeData, UI len, UI nest);	//	m[hǂݏoʒm(ASCII)
		virtual BOOL OnNtcNode		(C_WCP key, VOP pNodeData, UI len, UI nest);	//	m[hǂݏoʒm(UNICODE)
	};
}

/****************************************************************************************************************/
#endif
