#ifndef	AJXCON_H_
#define	AJXCON_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R\[ X^eBbN Rg[																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT SAjxCon {
	public:
		static BOOL		SetStdMode			(EAJCTEC tec = AJCTEC_MBC, BOOL fBom = FALSE);			//	Wó^WG[ ̃[hݒ

		static int		PutS				(C_BCP pStr);											//	R\[(Wo)֏o(ASCII)
		static int		PutS				(C_WCP pStr);											//	R\[(Wo)֏o(UNICODE)

		static int		PrintF				(C_BCP pFmt, ...);										//	R\[(Wo)֏o(ASCII)
		static int		PrintF				(C_WCP pFmt, ...);										//	R\[(Wo)֏o(UNICODE)

		static int	 	ErrPrintF			(C_BCP pFmt, ...);										//	R\[(WG[)֏o(ASCII)
		static int	 	ErrPrintF			(C_WCP pFmt, ...);										//	R\[(WG[)֏o(UNICODE)

		static BOOL		GetScreenBufferInfo	(LPSIZE pBufSize, LPRECT pRcWnd = NULL, LPSIZE pMaxWndSize = NULL);	//	R\[擾
		static BOOL		GetMaxWndSize		(int *pCx  , int *pCy);									//	EChőTCY擾

		static BOOL		SetBufSize			(int cx, int cy);										//	obt@TCYݒ
		static BOOL		GetBufSize 			(int *pCx  , int *pCy);									//	obt@TCY擾

		static BOOL		SetWndRect			(int left  , int top  , int right  , int bottom  );		//	R\[ECh`ݒ
		static BOOL		GetWndRect			(int *pLeft, int *pTop, int *pRight, int *pBottom);		//	R\[ECh`擾

		static BOOL		SetColor			(COLORREF	 ForeColor,   COLORREF	BackColor = (COLORREF)-1);	//	\Fݒ
		static BOOL		GetColor			(LPCOLORREF pForeColor, LPCOLORREF pBackColor = NULL);			//	\F擾

		static BOOL		SelPalette			(UI ForePalette, UI BackPalette);						//	\FpbgI
		static COLORREF GetForeColor		();														//	Fpbgl̎擾
		static COLORREF GetBackColor		();														//	wiFpbgl̎擾

		static BOOL		SetPalette			(const COLORREF Palette[16]);							//	\pbgݒiSpbgj
		static BOOL	 	SetPalByIx			(UI ix, COLORREF color);								//	\pbgݒiPpbgj

		static UI		GetPalette			(COLORREF Palette[16]);									//	\pbg擾iSpbgj
		static COLORREF GetPalByIx			(UI ix);												//	\pbg擾iPpbgj

		static BOOL		SetCursor			(int x, int y);											//	J[\ʒuݒ
		static BOOL		GetCursor			(int *pX, int *pY);										//	J[\ʒu擾
	};
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R\[ 																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxCon {
	public:

		CAjxCon();									//	RXgN^
		~CAjxCon();									//	fXgN^

		//----- ASCII ------------------------------------------------------------------------------------------//
		//	Pśi̓obt@wŐj
		BOOL	 Input (C_BCP pHelpText, UI lInpField = 80, UI lBuf = 256, UI fOpt = 0, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1);

		//	Pśi̓obt@wj
		BOOL	 Input (UI lInpField,
						BCP pBuf		  , UI lBuf,
						C_BCP pHelpText = NULL, UI fOpt = 0, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1);

		//	PśieLXgwj
		BOOL	 Input (C_BCP pInitialText, UI lInpField,
						BCP pBuf		  , UI lBuf,
						C_BCP pHelpText = NULL, UI fOpt = 0, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1);



		//----- UNICODE ----------------------------------------------------------------------------------------//
		//	Pśi̓obt@wŐj
		BOOL	 Input (C_WCP pHelpText, UI lInpField = 80, UI lBuf = 256, UI fOpt = 0, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1);

		//	Pśi̓obt@wj
		BOOL	 Input (UI lInpField,
						WCP pBuf		  , UI lBuf,
						C_WCP pHelpText = NULL, UI fOpt = 0, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1);

		//	PśieLXgwj
		BOOL	 Input (C_WCP pInitialText, UI lInpField,
						WCP pBuf		  , UI lBuf,
						C_WCP pHelpText = NULL, UI fOpt = 0, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1);

		//----- z֐ ---------------------------------------------------------------------------------------//
		virtual VO OnNtcStr(int argc, BC *argv[], C_BCP pTxt);			//	̓eLXgʒm(ASCII)
		virtual VO OnNtcStr(int argc, WC *argv[], C_WCP pTxt);			//	̓eLXgʒm(UNICODE)

	};
}
/****************************************************************************************************************/
#endif
