#ifndef	AJXCTRL_H_
#define	AJXCTRL_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	_CAO{bNX	iRg[̃ANZXj																//
//																												//
//--------------------------------------------------------------------------------------------------------------//

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	NX`																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT SAjxCtrl {
public:
		//----- Rg[ANZX ---------------------------------------------------------------------------//
		static UI		GetCtrlUInt					(HWND hCtrl);										//	Rg[̎擾iȂj
		static SI		GetCtrlSInt					(HWND hCtrl);										//	Rg[̎擾itj
		static UI		GetCtrlHex					(HWND hCtrl);										//	Rg[̎擾iPUij
		static double	GetCtrlReal					(HWND hCtrl);										//	Rg[̎擾ij
		static ULL		GetCtrlUI64					(HWND hCtrl);										//	Rg[̎擾iȂj
		static SLL		GetCtrlSI64					(HWND hCtrl);										//	Rg[̎擾itj
		static ULL		GetCtrlH64					(HWND hCtrl);										//	Rg[̎擾iPUij
		static UI		GetCtrlChk					(HWND hCtrl);										//	Rg[̎擾i`FbN{bNXj
		static UI		GetCtrlStr					(HWND hCtrl, BCP   pBuf, UI lBuf);					//	Rg[̎擾i, ASCIIj
		static UI		GetCtrlStr					(HWND hCtrl, WCP   pBuf, UI lBuf);					//	Rg[̎擾i,UNICODEj

	#ifdef UNICODE
		static UI		GetCtrlStrLen				(HWND hCtrl, BOOL fUnicode = TRUE);					//	Rg[̎擾i, UNICODEj
	#else
		static UI		GetCtrlStrLen				(HWND hCtrl, BOOL fUnicode = FALSE);				//	Rg[̎擾i, ASCIIj
	#endif

		static int	 	GetCtrlSldPos				(HWND hCtrl);										//	Rg[̎擾iXC_̈ʒuj
		static UI		GetCtrlCboIx				(HWND hCtrl);										//	Rg[̎擾iR{{bNXECfNXj
		static UI		GetCtrlCboCount				(HWND hCtrl);										//	Rg[̎擾iR{{bNXEڐj

	#ifdef UNICODE
		static UI		GetCtrlCboLen				(HWND hCtrl, UI ix, BOOL fUnicode = TRUE);			//	Rg[̎擾iR{{bNXE, UNICODEj
	#else
		static UI		GetCtrlCboLen				(HWND hCtrl, UI ix, BOOL fUnicode = FALSE);			//	Rg[̎擾iR{{bNXE, ASCIIj
	#endif

		static UI		GetCtrlCboItem				(HWND hCtrl, UI ix, BCP pBuf, UI lBuf);				//	Rg[̎擾iR{{bNXEڂ̕, ASCIIj
		static UI		GetCtrlCboItem				(HWND hCtrl, UI ix, WCP pBuf, UI lBuf);				//	Rg[̎擾iR{{bNXEڂ̕, UNICODEj
		static SX		GetCtrlCboData				(HWND hCtrl, UI ix);								//	Rg[̎擾iR{{bNXEf[^lj
		static UI		GetCtrlCboFind				(HWND hCtrl, UI ix, C_BCP pStr, UI flag = AJCCBF_ALL);	//	Rg[̎擾iR{{bNXE񌟍, ASCIIj
		static UI		GetCtrlCboFind				(HWND hCtrl, UI ix, C_WCP pStr, UI flag = AJCCBF_ALL);	//	Rg[̎擾iR{{bNXE񌟍, UNICODEj

	#ifdef UNICODE
		static UI		GetCtrlCboMaxLen			(HWND hCtrl, BOOL fUnicode = TRUE);					//	Rg[̎擾iR{{bNXEڌQ̂̍ő啶, UNICODEj
	#else
		static UI		GetCtrlCboMaxLen			(HWND hCtrl, BOOL fUnicode = FALSE);				//	Rg[̎擾iR{{bNXEڌQ̂̍ő啶, ASCIIj
	#endif

		static BOOL		SetCtrlUInt					(HWND hCtrl, UI 	value);							//	Rg[̐ݒiȂj
		static BOOL 	SetCtrlSInt					(HWND hCtrl, SI 	value);							//	Rg[̐ݒitj
		static BOOL 	SetCtrlHex					(HWND hCtrl, UI 	value);							//	Rg[̐ݒiPUij
		static BOOL 	SetCtrlReal					(HWND hCtrl, double value, int prec);				//	Rg[̐ݒij
		static BOOL 	SetCtrlUI64					(HWND hCtrl, ULL	value);							//	Rg[̐ݒiȂj
		static BOOL 	SetCtrlSI64					(HWND hCtrl, SLL	value);							//	Rg[̐ݒitj
		static BOOL 	SetCtrlH64					(HWND hCtrl, ULL	value);							//	Rg[̐ݒiPUij
		static BOOL 	SepCtrlUInt					(HWND hCtrl, UI 	value);							//	Rg[̐ݒiȂC	R؂j
		static BOOL 	SepCtrlSInt					(HWND hCtrl, SI 	value);							//	Rg[̐ݒitC	R؂j
		static BOOL 	SepCtrlHex					(HWND hCtrl, UI 	value, int col );				//	Rg[̐ݒiPUi	C	wj
		static BOOL 	SepCtrlReal					(HWND hCtrl, double value, int prec);				//	Rg[̐ݒiC		  R؂j
		static BOOL 	SepCtrlUI64					(HWND hCtrl, ULL	value);							//	Rg[̐ݒiȂCR؂j
		static BOOL 	SepCtrlSI64					(HWND hCtrl, SLL	value);							//	Rg[̐ݒitCR؂j
		static BOOL 	SepCtrlH64					(HWND hCtrl, ULL	value, int col);				//	Rg[̐ݒiPUi	Cwj
		static BOOL	SetCtrlChk					(HWND hCtrl, UI state);									//	Rg[̐ݒi`FbN{bNXj
		static BOOL	SetCtrlRbt					(HWND hCtrl, int idFirst, int idLast);					//	Rg[̐ݒiWI{^j
		static BOOL	SetCtrlStr					(HWND hCtrl, C_BCP pStr);								//	Rg[̐ݒi, ASCIIj
		static BOOL	SetCtrlStr					(HWND hCtrl, C_WCP pStr);								//	Rg[̐ݒi, UNICODEj
		static BOOL	SetCtrlFStr					(HWND hCtrl, C_BCP pFmt, ...);							//	Rg[̐ݒi, ASCIIj
		static BOOL	SetCtrlFStr					(HWND hCtrl, C_WCP pFmt, ...);							//	Rg[̐ݒi, ASCIIj

	#ifdef UNICODE
		static BOOL	SetCtrlEdtLimit				(HWND hCtrl, UI limit, BOOL fUnicode = TRUE);			//	Rg[̐ݒiGfBbgRg[̌, UNICODEj
	#else
		static BOOL	SetCtrlEdtLimit				(HWND hCtrl, UI limit, BOOL fUnicode = FALSE);			//	Rg[̐ݒiGfBbgRg[̌, ASCIIj
	#endif

		static BOOL	SetCtrlCboIx				(HWND hCtrl, UI ix);									//	Rg[̐ݒiR{{bNXECfNXj
		static UI		SetCtrlCboAdd				(HWND hCtrl, UI ix, C_BCP pItem, UI flag);			//	Rg[̐ݒiR{{bNXEڂ̕, ASCIIj
		static UI		SetCtrlCboAdd				(HWND hCtrl, UI ix, C_WCP pItem, UI flag);			//	Rg[̐ݒiR{{bNXEڂ̕, UNICODEj
		static UI		SetCtrlCboIns				(HWND hCtrl, UI ix, C_BCP pItem, UI flag);			//	Rg[̐ݒiR{{bNXEڑ}, ASCIIj
		static UI		SetCtrlCboIns				(HWND hCtrl, UI ix, C_WCP pItem, UI flag);			//	Rg[̐ݒiR{{bNXEڑ}, UNICODEj
		static BOOL	SetCtrlCboDel				(HWND hCtrl, UI ix);									//	Rg[̐ݒiR{{bNXEڍ폜j
		static BOOL	SetCtrlCboData				(HWND hCtrl, UI ix, SX data);							//	Rg[̐ݒiR{{bNXEf[^lj
		static BOOL	SetCtrlCboList				(HWND hCtrl, C_BCP pList);								//	Rg[̐ݒiR{{bNXEڃXg, ASCIIj
		static BOOL	SetCtrlCboList				(HWND hCtrl, C_WCP pList);								//	Rg[̐ݒiR{{bNXEڃXg, UNICODEj

	#ifdef UNICODE
		static BOOL	SetCtrlCboLimit				(HWND hCtrl, UI limit, BOOL fUnicode = TRUE);			//	Rg[̐ݒiR{{bNXE͉\, UNICODEj
	#else
		static BOOL	SetCtrlCboLimit				(HWND hCtrl, UI limit, BOOL fUnicode = FALSE);			//	Rg[̐ݒiR{{bNXE͉\, ASCIIj
	#endif

		static BOOL	SetCtrlCboReset				(HWND hCtrl);											//	Rg[̐ݒiR{{bNXEZbgj
		static BOOL	SetCtrlPgsRange				(HWND hCtrl, int low, int high);						//	Rg[̐ݒivOXo[̃Wj
		static BOOL	SetCtrlPgsPos				(HWND hCtrl, int pos);									//	Rg[̐ݒivOXo[̈ʒuj
		static BOOL	SetCtrlSldRange				(HWND hCtrl, int low, int high, int page);				//	Rg[̐ݒiXC_̃Wj
		static BOOL	SetCtrlSldPos				(HWND hCtrl, int pos);									//	Rg[̐ݒiXC_̈ʒuj
		static BOOL	SetCtrlSpnInfo 				(HWND hCtrl, int low, int high, HWND hBuddy);			//	Rg[̐ݒiXs{^̃WƃofBECh
		static BOOL	SetCtrlSpnRange				(HWND hCtrl, int low, int high);						//	Rg[̐ݒiXs{^̃W
		static BOOL	SetCtrlSpnBuddy				(HWND hCtrl, HWND hBuddy);								//	Rg[̐ݒiXs{^̃ofBECh

		static HWND	SetCtrlTopMostInSiblings	(HWND hCtrl);											//	Rg[ZEChōđOʂɐݒ肷
		static HWND	SetCtrllBackMostInSiblings	(HWND hCtrl);											//	Rg[ZEChōĔwʂɐݒ肷
		static BOOL	EnableCtrlToDrop			(HWND hCtrl, UI optDrop = AJCDROP_DIR_AND_FILE);		//	EDITRg[ɃtH_^t@Chbv\ɂigj

		//----- Rg[̃OBݒ^\^ړ -----------------------------------------------------------//
		static BOOL	EnableCtrl					(HWND hCtrl, BOOL fEnable);								//	Rg[̗L^
		static BOOL	EnableGroup					(HWND hCtrl, BOOL fEnaGrpBox, BOOL fEnaCtrls);			//	O[v{bNX̑SRg[L^
		static BOOL	ShowGroup					(HWND hCtrl, BOOL fShow);								//	O[v{bNXƃO[v{bNX̑SRg[\^\
		static BOOL	ShowGroup					(HWND hCtrl, BOOL fShowGrpBox, BOOL fShowCtrls);		//	O[v{bNXO[v{bNX̑SRg[\^\igj
		static BOOL	MoveGroupToLoc				(HWND hCtrl, int x, int y);								//	O[v{bNXƃO[v{bNX̑SRg[wʒuֈړ
		static BOOL	MoveGroupToCtl				(HWND hCtrl, HWND hctl);								//	O[v{bNXƃO[v{bNX̑SRg[wRg[̈ʒuֈړ
		static BOOL	MoveGroupToOrg				(HWND hCtrl);											//	O[v{bNXƃO[v{bNX̑SRg[ړÖʒuɖ߂

		//----- Rg[̉i ---------------------------------------------------------------------------//
		static BOOL	DelAllCtrlPermAtt			(HWND hWnd);												//	SRg[̉i
		static BOOL	LoadAllControlSettings		(HWND hWnd, C_BCP pSect, UI act = AJCCTL_SELACT_ALL | AJCCTL_SELACT_NTCALL);	//	SRg[̐ݒe̓ǂݏo(ASCII)
		static BOOL	LoadAllControlSettings		(HWND hWnd, C_WCP pSect, UI act = AJCCTL_SELACT_ALL | AJCCTL_SELACT_NTCALL);	//	SRg[̐ݒe̓ǂݏo(UNICODE)
		static BOOL	SaveAllControlSettings		(HWND hWnd);												//	SRg[̐ݒȅ

		static BOOL	CtrlSetPermAtt				(HWND hCtrl, UI att);										//	eRg[̉i̐ݒ
		static BOOL	CtrlLoadTextBox				(HWND hCtrl, C_BCP pSect, BOOL fExcRdOnly = TRUE);			//	eLXg{bNX̓ǂݏo(Ǐop̓w, ASCII)
		static BOOL	CtrlLoadTextBox				(HWND hCtrl, C_WCP pSect, BOOL fExcRdOnly = TRUE);			//	eLXg{bNX̓ǂݏo(Ǐop̓w, UNICODE)
		static BOOL	CtrlSaveTextBox				(HWND hCtrl, C_BCP pSect, BOOL fExcRdOnly = TRUE);			//	eLXg{bNX̏(Ǐop̓w, ASCII)
		static BOOL	CtrlSaveTextBox				(HWND hCtrl, C_WCP pSect, BOOL fExcRdOnly = TRUE);			//	eLXg{bNX̏(Ǐop̓w, UNICODE)
		static BOOL	CtrlLoadChkBox				(HWND hCtrl, C_BCP pSect, BOOL fNtc = FALSE);				//	`FbN{bNX^WI{^̓ǂݏo(ASCII)
		static BOOL	CtrlLoadChkBox				(HWND hCtrl, C_WCP pSect, BOOL fNtc = FALSE);				//	`FbN{bNX^WI{^̓ǂݏo(UNICODE)
		static BOOL	CtrlSaveChkBox				(HWND hCtrl, C_BCP pSect);									//	`FbN{bNX^WI{^̏(ASCII)
		static BOOL	CtrlSaveChkBox				(HWND hCtrl, C_WCP pSect);									//	`FbN{bNX^WI{^̏(UNICODE)

		static BOOL	CtrlLoadComboBox			(HWND hCtrl, C_BCP pSect, UI sel = 0, BOOL fNtc = FALSE);	//	R{{bNX̓ǂݏo(ASCII)
		static BOOL	CtrlLoadComboBox			(HWND hCtrl, C_WCP pSect, UI sel = 0, BOOL fNtc = FALSE);	//	R{{bNX̓ǂݏo(UNICODE)
		static BOOL	CtrlSaveComboBox			(HWND hCtrl, C_BCP pSect, UI sel = 0);						//	R{{bNX̏(ASCII)
		static BOOL	CtrlSaveComboBox			(HWND hCtrl, C_WCP pSect, UI sel = 0);						//	R{{bNX̏(UNICODE)
		static BOOL	CtrlLoadListBox				(HWND hCtrl, C_BCP pSect, UI sel = 0);						//	Xg{bNX̓ǂݏo(ASCII)
		static BOOL	CtrlLoadListBox				(HWND hCtrl, C_WCP pSect, UI sel = 0);						//	Xg{bNX̓ǂݏo(UNICODE)
		static BOOL	CtrlSaveListBox				(HWND hCtrl, C_BCP pSect, UI sel = 0);						//	Xg{bNX̏(ASCII)
		static BOOL	CtrlSaveListBox				(HWND hCtrl, C_WCP pSect, UI sel = 0);						//	Xg{bNX̏(UNICODE)
	};
}
/****************************************************************************************************************/
#endif
