#ifndef	AJXFILE_H_
#define	AJXFILE_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	eLXgt@CANZX Rg[																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxFile {
		HAJCFILE	m_hFile;			//	t@Cnh
		UI			m_BufLen;			//	obt@
		BOOL		m_fUnicode;			//	UNICODE/ASCII
	public:

		#ifdef UNICODE
			CAjxFile(BOOL fUnicode = TRUE);		//	RXgN^(UNICODE)
		#else
			CAjxFile(BOOL fUnicode = FALSE);	//	RXgN^(ASCII)
		#endif
		~CAjxFile();					//	fXgN^

		//	eLXgt@C
		BOOL		FOpen	(C_BCP pPath, EAJCTEC tec = AJCTEC_AUTO);								//	̓eLXgt@CI[v(ASCII)
		BOOL		FOpen	(C_WCP pPath, EAJCTEC tec = AJCTEC_AUTO);								//	̓eLXgt@CI[v(UNICODE)

		BOOL		FAttachOpened(HANDLE hFile, EAJCTEC tec);										//	I[vσt@C̃nhgpăCX^X

		BCP			FGetS	(BCP pBuf, UI lBuf);													//	(ASCII)
		WCP			FGetS	(WCP pBuf, UI lBuf);													//	(UNICODE)

		UI			FGetC	();																		//	P(ASCII/UNICODEp)
		BC			FGetCA	();																		//	P(ASCII)
		WC			FGetCW	();																		//	P(UNICODE)

		ULL			FSavePoint();																	//	t@Cǂݏo|Cgޔ
		BOOL		FRecvPoint();																	//	t@Cǂݏo|Cg

		BOOL		FEof	();																		//	̓t@Ĉdne`FbN


		//	eLXgt@Co
		BOOL		FCreate	(C_BCP pPath, EAJCTEC tec = AJCTEC_AUTO, BOOL fBOM = FALSE);			//	o̓eLXgt@C(ASCII)
		BOOL		FCreate	(C_WCP pPath, EAJCTEC tec = AJCTEC_AUTO, BOOL fBOM = FALSE);			//	o̓eLXgt@C(UNICODE)

		BOOL		FAttachCreated(HANDLE hFile, EAJCTEC tec, BOOL fBOM);							//	σt@C̃nhgpăCX^X

		BOOL		FPutS	(C_BCP pText, UI lText = -1);											//	o(ASCII)
		BOOL		FPutS	(C_WCP pText, UI lText = -1);											//	o(UNICODE)

		BOOL		FPutC	(BC c);																	//	Po(ASCII)
		BOOL		FPutC	(WC c);																	//	Po(UNICODE)

		BOOL		FPrintF	(C_BCP pFmt, ...);														//	o(ASCII)
		BOOL		FPrintF	(C_WCP pFmt, ...);														//	o(UNICODE)

		BOOL		FVPrintF(C_BCP pFmt, va_list vls);												//	o(όp^̃|C^w, ASCII)
		BOOL		FVPrintF(C_WCP pFmt, va_list vls);												//	o(όp^̃|C^w, UNICODE)

		//	̑
		BOOL		FClose	();																		//	eLXgt@CN[Y

		BOOL		FDetach	();																		//	eLXgt@CN[YȂŃCX^X

		EAJCTEC		FGetTec	();																		//	eLXgGR[hʎ擾

		BOOL		FGetBOM();																		//	̓t@ĈanlL̎擾

		BOOL		FIsActive();																	//	t@CI[v^Ԃ`FbN

		BOOL		FIsModeInput();																	//	o̓[h擾

		BOOL		FSetFmtLen	(UI len);															//	obt@ݒ

		HANDLE		FGetFileHandle();																//	t@Cnh擾
	};
}
/****************************************************************************************************************/
#endif
