#ifndef	AJXSCT_H_
#define	AJXSCT_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	\PbgʐMiNCAgj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	NX`																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxSct {
		ATOM	m_Atom;					//	CxgʒmpNXnh
		HWND	m_hWndEvt;				//	CxgʒmpECh

	public:
		HAJCSCT	m_hSct;					//	rbsCX^Xhnh
		BOOL	m_fUnicode;				//	UNICODEtO

		CAjxSct();						//	RXgN^
		~CAjxSct();						//	fXgN^

		//----- o֐ -------------------------------------------------------------------------------------//
		//	ڑ
		#ifdef _CONSOLE		//	R\[Av
			BOOL	Connect	(C_BCP pServ, C_BCP pPort, int AddressFamily = AF_INET, BOOL fUseWaitEvent = TRUE );	//	(ASCII)
			BOOL	Connect	(C_WCP pServ, C_WCP pPort, int AddressFamily = AF_INET, BOOL fUseWaitEvent = TRUE );	//	(UNICODE)
		#else				//	WindowsAv
			BOOL	Connect	(C_BCP pServ, C_BCP pPort, int AddressFamily = AF_INET, BOOL fUseWaitEvent = FALSE);	//	(ASCII)
			BOOL	Connect	(C_WCP pServ, C_WCP pPort, int AddressFamily = AF_INET, BOOL fUseWaitEvent = FALSE);	//	(UNICODE)
		#endif

		BOOL				Disconnect		(UI msTimeout = 10000);									//	ؒf

		AJCSCT_STATE		GetState		();														//	Ԏ擾

		BOOL				SetChunkMode	(AJCSCT_CHUNKMODE ChunkMode);							//	`Nf[^̎M[hݒ
		AJCSCT_CHUNKMODE	GetChunkMode	();														//	`Nf[^̎M[h擾

		BOOL				SetEvtMask		(UI EvtMsk);											//	Cxg}XNݒ
		UI		 			GetEvtMask		();														//	Cxg}XN擾

		BOOL				SetRxTextCode	(AJCSCT_TEXTCODE code);									//	MeLXg̕R[hݒ
		AJCSCT_TEXTCODE		GetRxTextCode	();														//	MeLXg̕R[h擾

		BOOL				SetTxTextCode	(AJCSCT_TEXTCODE code);									//	MeLXg̕R[hݒ
		AJCSCT_TEXTCODE		GetTxTextCode	();														//	MeLXg̕R[h擾

		AJCSCT_TEXTCODE		GetActualRxTextCode	();													//	ۂ̎MeLXg̕R[h擾
		AJCSCT_TEXTCODE		GetActualTxTextCode	();													//	ۂ̑MeLXg̕R[h擾

		BOOL				WaitEvent		(UI msTime);											//	Cxg҂

		BOOL				SetPktCtrlCode	(UI stx = 0x02, UI etx = 0x02, UI dle = 0x10);			//	pPbgt[Fׂ̐R[hݒ
		BOOL				GetPktCtrlCode	(UIP pStx = NULL, UIP pEtx = NULL, UIP pDle = NULL);	//	pPbgt[Fׂ̐R[h擾

		BOOL				SetPktTimeout	(UI msTime);											//	pPbgt[M^CAEglݒ
		BOOL				GetPktTimeout	(UIP pMsTime);											//	pPbgt[M^CAEgl擾

		BOOL				SendChar		(BC code);												//	PM(ASCII)
		BOOL				SendChar		(WC code);												//	PM(UNICODE)

		BOOL				SendText		(C_BCP pTxt, UI lTxt = -1);								//	eLXgf[^M(ASCII)
		BOOL				SendText		(C_WCP pTxt, UI lTxt = -1);								//	eLXgf[^M(UNICODE)

		BOOL				SendTextF		(C_BCP pFmt, ...);										//	eLXgM(ASCII)
		BOOL				SendTextF		(C_WCP pFmt, ...);										//	eLXgM(UNICODE)

		BOOL				SendBinData		(C_VOP pDat, UI lDat);									//	oCif[^M
		UI					SendPacket		(C_VOP pPkt, UI lPkt);									//	pPbgf[^M

		BOOL				PurgeRecvData	();														//	SMσf[^j
		BOOL				PurgeSendData	();														//	SM҂f[^j
		BOOL				PurgeAllData	();														//	SMf[^j

		//----- z֐ ---------------------------------------------------------------------------------------//
		virtual	VO	OnNtcConnect	();											//	ڑʒm
		virtual	VO	OnNtcDisconnect	();											//	ؒfʒm

		virtual VO	OnNtcRxTextChunk(C_BCP pText);								//	eLXg`NMʒm(ASCII)
		virtual VO	OnNtcRxTextChunk(C_WCP pText);								//	eLXg`NMʒm(UNICODE)

		virtual VO	OnNtcRxBinChunk	(C_VOP pData, UI Bytes);					//	oCi`NMʒm

		virtual VO	OnNtcRxText		(C_BCP pText);								//	eLXgMʒm(ASCII)
		virtual VO	OnNtcRxText		(C_WCP pText);								//	eLXgMʒm(UNICODE)

		virtual VO	OnNtcRxEsc		(C_BCP pData);								//	drbV[PXMʒm(ASCII)
		virtual VO	OnNtcRxEsc		(C_WCP pData);								//	drbV[PXMʒm(UNICODE)

		virtual VO	OnNtcRxCtrl		(UI Ctrl);									//	R[hMʒm
		virtual VO	OnNtcRxPkt		(C_VOP pData, UI Bytes);					//	pPbgMʒm
		virtual VO	OnNtcTxEmpty	();											//	Mʒm

		virtual VO	OnNtcRxNoPkt	(C_BCP pText);								//	pPbgOf[^Mʒm(ASCII)
		virtual VO	OnNtcRxNoPkt	(C_WCP pText);								//	pPbgOf[^Mʒm(UNICODE)

		virtual VO	OnNtcInvChunk	(C_VOP pData, UI lData);					//	seLXg`NMʒm

		virtual	VO	OnNtcCnErr		(UI param);									//	ڑsʒm
		virtual VO	OnNtcRxErr		(UI param);									//	MG[ʒm
		virtual VO	OnNtcTxErr		(UI param);									//	MG[ʒm
		virtual VO	OnNtcErr		(UI param);									//	G[ʒm

	};
}
/****************************************************************************************************************/
#endif
