#ifndef	AJXTIP_H_
#define	AJXTIP_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	c[`bv X^eBbN Rg[																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT SAjxTip {
	public:

		//--- AjcTipCtl.h ---//

		static	BOOL			EnableMultiThread(BOOL fEnable);							//	}`Xbh̋^֎~

		static	AJCTIP_POSMODE	SetTipPosMode (AJCTIP_POSMODE PosMode);						//	c[`bv\ʒu[h̐ݒ

		static	BOOL	 		Add(HWND hCtrl, C_BCP pTxt, int msDelay = 1000, int msShow = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);	//	c[`bv̊֘At(ASCII)
		static	BOOL	 		Add(HWND hCtrl, C_WCP pTxt, int msDelay = 1000, int msShow = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);	//	c[`bv̊֘At(UNICODE)

		static	BOOL	 		SetShowAlways(HWND hCtrl, BOOL fShowAlways);				//	c[`bv\̐ݒ
		static	BOOL	 		GetShowAlways(HWND hCtrl);									//	c[`bv\̎擾

		static	VO				SetShowForActive(BOOL fShowForActive);						//	Sc[`bv\̐ݒ
		static	BOOL	 		GetShowForActive(VO);										//	Sc[`bv\̎擾

		static	BOOL			Enable			(HWND hCtrl, BOOL fEnable);					//	`bveLXg̕\^֎~ݒ
		static	BOOL			GetEnableState	(HWND hCtrl);								//	`bveLXg̕\^֎~Ԏ擾

		static	VO				EnableAll		 (BOOL fEnable);							//	SẴ`bveLXg̕\^֎~ݒ
		static	BOOL			GetEnableAllState(VO);										//	SẴ`bveLXg̕\^֎~Ԏ擾

		static	BOOL	 		Remove(HWND hCtrl);											//	̃c[`bv̊֘At
		static	BOOL	 		Remove();													//	SẴc[`bv̊֘At

		static	UI	 			GetInfo(HWND hCtrl, PAJCTIPINFO pInfoBuf, BCP pTxtBuf, UI lTxtBuf);	//	c[`bv̊֘At擾(ASCII)
		static	UI	 			GetInfo(HWND hCtrl, PAJCTIPINFO pInfoBuf, WCP pTxtBuf, UI lTxtBuf);	//	c[`bv̊֘At擾(UNICODE)

		static	BOOL			SetNtcSubclass(HWND hCtrl, HWND hNtc, UI msg, UX lParam);	//	TuNX̒ʒmݒ
		static	BOOL			ClrNtcSubclass(HWND hCtrl);									//	TuNX̒ʒm

		static	VO	 			SetWindowTime(int msTime);									//	Rg[ԈړP\Ԑݒ
		static	int	 			GetWindowTime();											//	Rg[ԈړP\Ԏ擾

		static	VO	 			SetDefMsDelay(int msDelay);									//	ftHg̕\xԂ̐ݒ
		static	int	 			GetDefMsDelay();											//	ftHg̕\xԂ̎擾


		//--- AjcTipTxt.h ---//

		static	BOOL	 		Show(int x, int y,							 C_BCP pTxt, int msTime = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);	//	c[`bv̕\(ASCII)
		static	BOOL	 		Show(int x, int y, int minWidth, int height, C_BCP pTxt, int msTime = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);

		static	BOOL	 		Show(int x, int y,							 C_WCP pTxt, int msTime = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);	//	c[`bv̏ڍו\(UNICODE)
		static	BOOL	 		Show(int x, int y, int minWidth, int height, C_WCP pTxt, int msTime = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);

		static	BOOL	 		ShowCenter(HWND hwnd,							C_BCP pTxt, int msTime = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);	//	c[`bvEChɕ\(ASCII)
		static	BOOL	 		ShowCenter(HWND hwnd, int minWidth, int height, C_BCP pTxt, int msTime = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);
		static	BOOL	 		ShowCenter(HWND hwnd,							C_WCP pTxt, int msTime = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);	//	c[`bvEChɕ\(UNICODE)
		static	BOOL	 		ShowCenter(HWND hwnd, int minWidth, int height, C_WCP pTxt, int msTime = 3000, HFONT hFont = NULL, COLORREF TextColor = (COLORREF)-1, COLORREF BackGround = (COLORREF)-1, COLORREF BorderColor = (COLORREF)-1);

		static	BOOL	 		GetSize(int w, int h, C_BCP pTxt, HFONT hFont, BOOL fBorder, LPSIZE pBuf);	//	c[`bv̕\TCY擾(ASCII)
		static	BOOL	 		GetSize(int w, int h, C_WCP pTxt, HFONT hFont, BOOL fBorder, LPSIZE pBuf);	//	c[`bv̕\TCY擾(UNICODE)

		static	VO	 			Move(int x, int y);											//	c[`bvEChړ

		static	VO	 			MoveCursor();												//	J[\c[`bv̒ֈړ
		static	VO	 			MoveCursor(AJCTIP_CURMOVE cm);								//	J[\c[`bv̎wʒuֈړ

		static	VO	 			Hide();														//	c[`bv\

		static	BOOL	 		GetRect(LPRECT pRect);										//	c[`bvECh̋`擾

		static	BOOL	 		SetPalette(int ix, COLORREF color);							//	pbgF̐ݒ
		static	COLORREF		GetPalette(int ix);											//	pbgF̎擾

		static	VO	 			SetDefTextColor  (COLORREF color);							//	ftHg̃eLXg\Fݒ
		static	COLORREF		GetDefTextColor  ();										//	ftHg̃eLXg\F擾

		static	VO	 			SetDefBorderColor(COLORREF color);							//	ftHg̊Og\Fݒ
		static	COLORREF		GetDefBorderColor();										//	ftHg̊Og\F擾

		static	VO	 			SetDefBkColor	  (COLORREF color);							//	ftHg̔wi\Fݒ
		static	COLORREF		GetDefBkColor	  ();										//	ftHg̔wi\F擾

		static	VO	 			SetDefFont		  (HFONT hFont);							//	ftHgtHg̐ݒ
		static	HFONT	 		GetDefFont		  ();										//	ftHgtHg̎擾

		static	VO	 			SetDefMsShow	  (int msShow);								//	ftHg̕\Ԃ̐ݒ
		static	int	 			GetDefMsShow	  ();										//	ftHg̕\Ԃ̎擾
	};
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	󋵈ˑc[`bv Rg[																			//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxTip {
		BOOL	m_fUnicode;						//	UNICODE / ASCII ʃtO
	public:
		HWND	m_hCtrl;

		#ifdef UNICODE
			CAjxTip(BOOL fUnicode = TRUE);								//	RXgN^(UNICODE)
		#else
			CAjxTip(BOOL fUnicode = FALSE);								//	RXgN^(ASCII)
		#endif
		~CAjxTip();														//	fXgN^

		VO				Attach(HWND hCtrl);								//	A^b`iRg[nh[j
		virtual BOOL	OnChkCursor(HWND hCtrl, LPPOINT ptClient);		//	J[\ʒu`FbN

		virtual VO		OnNeedText (HWND hCtrl, BCP pBuf, UI lBuf);		//	c[`bveLXg擾v(ASCII)
		virtual VO		OnNeedText (HWND hCtrl, WCP pBuf, UI lBuf);		//	c[`bveLXg擾v(UNICODE)
	};
}
/****************************************************************************************************************/
#endif
