#include	"AjcInternal.h"

#define	INST_ID			0x90BBA6B5
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//**************************************************************************************************************//
//																												//
//	tQ؁i`ur؁CL[j																			//
//																												//
//**************************************************************************************************************//

#define		AVS_ENTER	if (pW->fMultiThread) EnterCriticalSection(&pW->cs);
#define		AVS_LEAVE	if (pW->fMultiThread) LeaveCriticalSection(&pW->cs);

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	int		CALLBACK cbMyStrCmpA(UX key1, UX key2, UX cbp);
static	int		CALLBACK cbMyStrCmpW(UX key1, UX key2, UX cbp);

static	VO		CALLBACK cbMyNtcDel (UX key, VOP pNode, UI len, UI nest, UX cbp);

//==============================================================================================================//
//	`urCX^X̐																					//
//																												//
//	@	F	CmpMode			 - r[hiAJCCMP_{RECOGNIZE_WIDTH / IGNORE_WIDTH / ALPHABETIC} j	//
//				cbp 			 - R[obNp^															//
//				cbNtcDelNodeData - 폜m[hf[^ʒmpR[obNisv́Amtkkj						//
//																												//
//	߂l	F	NULL - njiCX^Xnhj															//
//				NULL - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCAVS	WINAPI	AjcAvsCreateA(EAJCCMPMODE CmpMode, UX cbp, VO (CALLBACK *cbNtcDelNodeData)(C_BCP pKey, VOP pNodeData, UI len, UI nest, UX cbp))
{
	HAJCAVS		pW = NULL;

	if ((pW = (HAJCAVS)AJCMEM(sizeof(AJCAVS))) != NULL) {
		//	CX^X[N
		memset(pW, 0, sizeof *pW);
		pW->InstID	 = INST_ID;
		pW->fUnicode = FALSE;
		pW->CmpMode  = CmpMode;
		pW->cbp 	 = cbp;
		pW->hAvl	 = AjcAvlCreate ((UX)pW, cbMyStrCmpA, cbMyNtcDel);
		pW->hSpl	 = AjcSplCreateA(CmpMode);
		pW->u.cbNtcDelA = cbNtcDelNodeData;
		//	sȂ΁A\[X
		if (pW->hAvl == NULL || pW->hSpl == NULL) {
			if (pW->hAvl == NULL) AjcAvlDelete(pW->hAvl);
			if (pW->hSpl == NULL) AjcSplDelete(pW->hSpl);
			free(pW);
			pW = NULL;
		}
	}
	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCAVS	WINAPI	AjcAvsCreateW(EAJCCMPMODE CmpMode, UX cbp, VO (CALLBACK *cbNtcDelNodeData)(C_WCP pKey, VOP pNodeData, UI len, UI nest, UX cbp))
{
	HAJCAVS		pW = NULL;

	if ((pW = (HAJCAVS)AJCMEM(sizeof(AJCAVS))) != NULL) {
		//	CX^X[N
		memset(pW, 0, sizeof *pW);
		pW->InstID	 = INST_ID;
		pW->fUnicode = TRUE;
		pW->CmpMode  = CmpMode;
		pW->cbp 	 = cbp;
		pW->hAvl	 = AjcAvlCreate ((UX)pW, cbMyStrCmpW, cbMyNtcDel);
		pW->hSpl	 = AjcSplCreateW(CmpMode);
		pW->u.cbNtcDelW = cbNtcDelNodeData;
		//	sȂ΁A\[X
		if (pW->hAvl == NULL || pW->hSpl == NULL) {
			if (pW->hAvl != NULL) AjcAvlDelete(pW->hAvl);
			if (pW->hSpl != NULL) AjcSplDelete(pW->hSpl);
			free(pW);
			pW = NULL;
		}
	}
	return pW;
}

//==============================================================================================================//
//	`urCX^X̍폜																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - p^G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcAvsDelete			(HAJCAVS pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {

		AVS_ENTER
		if (pW->hAvl != NULL) AjcAvlDelete(pW->hAvl);
		if (pW->hSpl != NULL) AjcSplDelete(pW->hSpl);
		AVS_LEAVE

		if (pW->fMultiThread) {
			DeleteCriticalSection(&pW->cs);
		}
		free(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	}`Xbh̋^֎~																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				fEnable - FALSE : }`Xbh֎~															//
//						  TRUE	: }`Xbh															//
//																												//
//	߂l	F	Ő^֎~																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcAvsEnableMultiThread	(HAJCAVS pW, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		rc = pW->fMultiThread;
		if (fEnable) {
			if (!pW->fMultiThread) {
				InitializeCriticalSection(&pW->cs);
				pW->fMultiThread = TRUE;
			}
		}
		else {
			if (pW->fMultiThread) {
				pW->fMultiThread = FALSE;
				DeleteCriticalSection(&pW->cs);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	R[obNp^̐ݒ																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				cbp 	- R[obNp^																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - p^G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcAvsSetCbp			(HAJCAVS pW, UX cbp)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		pW->cbp = cbp;
		AVS_LEAVE
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	r[h̐ݒ																						//
//																												//
//	@	F	pW		 - CX^X[ÑAhX															//
//				CmpMode	 - r[hiAJCCMP_{RECOGNIZE_WIDTH / IGNORE_WIDTH / ALPHABETIC} j			//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - p^G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcAvsSetCompMode			(HAJCAVS pW, EAJCCMPMODE CmpMode)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		pW->CmpMode = CmpMode;
		AVS_LEAVE
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	m[h}																									//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pKey 	  - L[ւ̃|C^																//
//				pNodeData - }m[hf[^̃AhX														//
//				len 	  - }m[hf[^̃oCgiO`UTTRTj									//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - L[̃m[h^m[h蓖Ďs^p^G[							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsInsNodeA			(HAJCAVS pW, C_BCP pKey, C_VOP pNodeData, UI len)
{
	BOOL	rc = FALSE;
	C_BCP	pTmp;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		if (pTmp = AjcSplRegistA(pW->hSpl, pKey)) {
			if (!(rc = AjcAvlInsNode(pW->hAvl, (UX)pTmp, pNodeData, len))) {
			//	AjcSplRemoveA(pW->hSpl, pKey);	//	L[sC
			}
		}
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsInsNodeW			(HAJCAVS pW, C_WCP pKey, C_VOP pNodeData, UI len)
{
	BOOL	rc = FALSE;
	C_WCP	pTmp;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		if (pTmp = AjcSplRegistW(pW->hSpl, pKey)) {
			if (!(rc = AjcAvlInsNode(pW->hAvl, (UX)pTmp, pNodeData, len))) {
			//	AjcSplRemoveW(pW->hSpl, pKey);	//	L[sC
			}
		}
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[h擾im[hj																					//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pKey 	  - L[ւ̃|C^																//
//				pBuf	  - m[hf[^i[obt@̃AhXisv͂mtkkj				//
//				lBuf	  - m[hf[^i[obt@̃oCg									//
//																												//
//	߂l	F	-1 - njiYm[hEf[^̃oCgj														//
//				-1 - w肳ꂽL[Ȃ																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcAvsGetNodeA			(HAJCAVS pW, C_BCP pKey, VOP	 pBuf,		UI lBuf)
{
	int		rc = -1;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		rc = AjcAvlGetNodeByKey(pW->hAvl, (UX)pKey, pBuf, lBuf);
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcAvsGetNodeW			(HAJCAVS pW, C_WCP pKey, VOP	 pBuf,		UI lBuf)
{
	int		rc = -1;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		rc = AjcAvlGetNodeByKey(pW->hAvl, (UX)pKey, pBuf, lBuf);
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[h|C^擾im[hj																			//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pKey 	  - L[ւ̃|C^																//
//				pLen	  - m[hf[^̃oCgi[obt@̃AhXisv͂mtkkj	//
//																												//
//	߂l	F	NULL - njiYm[hEf[^ւ̃|C^j													//
//				NULL - w肳ꂽL[Ȃ^p^G[											//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	VOP		WINAPI	AjcAvsGetNodePtrA		(HAJCAVS pW, C_BCP pKey, UIP pLen)
{
	VOP		rc = NULL;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		rc = AjcAvlGetNodePtr(pW->hAvl, (UX)pKey, pLen);
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	VOP		WINAPI	AjcAvsGetNodePtrW		(HAJCAVS pW, C_WCP pKey, UIP pLen)
{
	VOP		rc = NULL;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		rc = AjcAvlGetNodePtr(pW->hAvl, (UX)pKey, pLen);
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[h̃L[ւ̃|C^擾																			//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pNode 	  - m[hւ̃|C^																	//
//																												//
//	߂l	F	NULL - njiYm[hEL[ւ̃|C^j												//
//				NULL - w肳ꂽL[Ȃ^p^G[											//
//==============================================================================================================//
AJCEXPORT	C_VOP		WINAPI	AjcAvsGetNodeKey		(HAJCAVS pW, VOP pNode)
{
	C_VOP	rc = NULL;
	UX		key;

	if (IS_MY_INST(pW) && pNode != NULL) {
		key = AjcAvlGetNodeKey(pW->hAvl, pNode);
		if (key != -1) rc = (C_VOP)key;
	}
	return rc;
}
//==============================================================================================================//
//	擪m[h擾																								//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				ppKey	  - 擪m[h̃L[l(ւ̃|C^)i[obt@̃AhXisvNULLj	//
//				pBuf	  - m[hf[^i[obt@̃AhXisv͂mtkkj				//
//				lBuf	  - m[hf[^i[obt@̃oCg									//
//																												//
//	߂l	F	-1 - njiYm[hEf[^̃oCgj														//
//				-1 - m[hȂ																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcAvsGetTopNodeA		(HAJCAVS pW, C_BCP *ppKey, VOP pBuf, UI lBuf)
{
	int		rc = -1;

	if (IS_MY_INST(pW) && ppKey != NULL) {
		AVS_ENTER
		rc = AjcAvlGetTopNode(pW->hAvl, (UXP)ppKey, pBuf, lBuf);
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcAvsGetTopNodeW		(HAJCAVS pW, C_WCP *ppKey, VOP pBuf, UI lBuf)
{
	int		rc = -1;

	if (IS_MY_INST(pW) && ppKey != NULL) {
		AVS_ENTER
		rc = AjcAvlGetTopNode(pW->hAvl, (UXP)ppKey, pBuf, lBuf);
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	ŏIm[h擾																								//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				ppKey	  - ŏIm[h̃L[l(ւ̃|C^)i[obt@̃AhXisvNULLj	//
//				pBuf	  - m[hf[^i[obt@̃AhXisv͂mtkkj				//
//				lBuf	  - m[hf[^i[obt@̃oCg									//
//																												//
//	߂l	F	-1 - njiYm[hEf[^̃oCgj														//
//				-1 - m[hȂ																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcAvsGetLastNodeA		(HAJCAVS pW, C_BCP *ppKey, VOP pBuf, UI lBuf)
{
	int		rc = -1;

	if (IS_MY_INST(pW) && ppKey != NULL) {
		AVS_ENTER
		rc = AjcAvlGetLastNode(pW->hAvl, (UXP)ppKey, pBuf, lBuf);
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcAvsGetLastNodeW		(HAJCAVS pW, C_WCP *ppKey, VOP pBuf, UI lBuf)
{
	int		rc = -1;

	if (IS_MY_INST(pW) && ppKey != NULL) {
		AVS_ENTER
		rc = AjcAvlGetLastNode(pW->hAvl, (UXP)ppKey, pBuf, lBuf);
		AVS_LEAVE
	}
	return rc;
}

//==============================================================================================================//
//	m[hu																									//
//																												//
//	@	F	pW		  	- CX^Xnh																//
//				pKey 	  	- L[ւ̃|C^															//
//				pNodeData	- uVm[hf[^̃AhX													//
//				len 	 	- uVm[hf[^̃oCgiO`UTTRTj								//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - w肳ꂽL[Ȃ^m[h蓖Ďs^p^G[					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsRepNodeA			(HAJCAVS pW, C_BCP pKey, C_VOP pNodeData, UI len)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		rc = AjcAvlRepNode(pW->hAvl, (UX)pKey, pNodeData, len);
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsRepNodeW			(HAJCAVS pW, C_WCP pKey, C_VOP pNodeData, UI len)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		rc = AjcAvlRepNode(pW->hAvl, (UX)pKey, pNodeData, len);
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[h}^u																							//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pKey 	  - L[ւ̃|C^																//
//				pNodeData - um[hf[^̃AhX														//
//				len		  - um[hf[^̃oCg														//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - m[h蓖Ďs^p^G[												//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsInsOrRepNodeA		(HAJCAVS pW, C_BCP pKey, C_VOP pNodeData, UI len)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		if (AjcAvlGetNodePtr(pW->hAvl, (UX)pKey, NULL) != NULL) {
			rc = AjcAvsRepNodeA(pW, pKey, pNodeData, len);
		}
		else {
			rc = AjcAvsInsNodeA(pW, pKey, pNodeData, len);
		}
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsInsOrRepNodeW		(HAJCAVS pW, C_WCP pKey, C_VOP pNodeData, UI len)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		if (AjcAvlGetNodePtr(pW->hAvl, (UX)pKey, NULL) != NULL) {
			rc = AjcAvsRepNodeW(pW, pKey, pNodeData, len);
		}
		else {
			rc = AjcAvsInsNodeW(pW, pKey, pNodeData, len);
		}
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[h폜																									//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				key 	  - 폜m[h̃L[																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - w肳ꂽL[̃m[hȂ^p^G[									//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsDelNodeA			(HAJCAVS pW, C_BCP pKey)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		if (rc = AjcAvlDelNode(pW->hAvl, (UX)pKey)) {
			AjcSplRemoveA(pW->hSpl, pKey);
		}
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsDelNodeW			(HAJCAVS pW, C_WCP pKey)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pKey != NULL && *pKey != 0) {
		AVS_ENTER
		if (rc = AjcAvlDelNode(pW->hAvl, (UX)pKey)) {
			AjcSplRemoveW(pW->hSpl, pKey);
		}
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[h폜																								//
//																												//
//	@	F	pW			 - CX^Xnh																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - p^G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcAvsDelAllNodes		(HAJCAVS pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = AjcAvlDelAllNodes(pW->hAvl);
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[h擾																								//
//																												//
//	@	F	pW			 - CX^Xnh																//
//																												//
//	߂l	F	m[hip^G[́AOԂj														//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcAvsGetCount	(HAJCAVS pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = AjcAvlGetCount(pW->hAvl);
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[h擾																								//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				cbp			 - R[obNp^																//
//				cbNtcNode	 - 擾m[hʒmR[obN֐isv͂mtkkj						//
//				fDownSeq	 - FALSE:CTRUE:~															//
//																												//
//	߂l	F	m[h																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcAvsEnumNodesA (HAJCAVS pW, AJCAVS_CBNTCA cbNtcNodeData, BOOL fDownSeq)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = AjcAvlEnumNodesEx(pW->hAvl, pW->cbp, (AJCAVL_CBNTC)cbNtcNodeData, fDownSeq);
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcAvsEnumNodesW (HAJCAVS pW, AJCAVS_CBNTCW cbNtcNodeData, BOOL fDownSeq)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = AjcAvlEnumNodesEx(pW->hAvl, pW->cbp, (AJCAVL_CBNTC)cbNtcNodeData, fDownSeq);
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[h擾iR[obNp^wj																	//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				cbp			 - R[obNp^																//
//				cbNtcNode	 - 擾m[hʒmR[obN֐isv͂mtkkj						//
//				fDownSeq	 - FALSE:CTRUE:~															//
//																												//
//	߂l	F	m[h																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcAvsEnumNodesExA (HAJCAVS pW, UX cbp, AJCAVS_CBNTCA cbNtcNodeData, BOOL fDownSeq)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = AjcAvlEnumNodesEx(pW->hAvl, cbp, (AJCAVL_CBNTC)cbNtcNodeData, fDownSeq);
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcAvsEnumNodesExW (HAJCAVS pW, UX cbp, AJCAVS_CBNTCW cbNtcNodeData, BOOL fDownSeq)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = AjcAvlEnumNodesEx(pW->hAvl, cbp, (AJCAVL_CBNTC)cbNtcNodeData, fDownSeq);
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z񐶐																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pNum		- zvfi[obt@̃AhXisvNULL)								//
//				fDownSeq	- FALSE:CTRUE:~																//
//																												//
//	߂l	F	NULL : Sm[hւ̃|C^z̐擪AhX													//
//				NULL : G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	PCAJCAVSPTRA	WINAPI	AjcAvsCreatePtrArrA(HAJCAVS pW, UIP pNum, BOOL fDownSeq)
{
	PCAJCAVSPTRA	rc = NULL;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = (PCAJCAVSPTRA)AjcAvlCreatePtrArr(pW->hAvl, pNum, fDownSeq);
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	PCAJCAVSPTRW	WINAPI	AjcAvsCreatePtrArrW(HAJCAVS pW, UIP pNum, BOOL fDownSeq)
{
	PCAJCAVSPTRW	rc = NULL;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = (PCAJCAVSPTRW)AjcAvlCreatePtrArr(pW->hAvl, pNum, fDownSeq);
		AVS_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				ppArr		- Sm[hւ̃|C^z̐擪AhX											//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsReleasePtrArrA(HAJCAVS pW, PCAJCAVSPTRA pArr)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = AjcAvlReleasePtrArr(pW->hAvl, (PCAJCAVLPTR)pArr);
		AVS_LEAVE
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcAvsReleasePtrArrW(HAJCAVS pW, PCAJCAVSPTRW pArr)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AVS_ENTER
		rc = AjcAvlReleasePtrArr(pW->hAvl, (PCAJCAVLPTR)pArr);
		AVS_LEAVE
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	r																									//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	int		CALLBACK cbMyStrCmpA(UX key1, UX key2, UX cbp)
{
	int		rc;
	HAJCAVS	pW = (HAJCAVS)cbp;

	rc = AjcStrCmpExA((C_BCP)key1, (C_BCP)key2, pW->CmpMode);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	int		CALLBACK cbMyStrCmpW(UX key1, UX key2, UX cbp)
{
	int		rc;
	HAJCAVS	pW = (HAJCAVS)cbp;

	rc = AjcStrCmpExW((C_WCP)key1, (C_WCP)key2, pW->CmpMode);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	m[h폜ʒm																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO		CALLBACK cbMyNtcDel (UX key, VOP pNode, UI len, UI nest, UX cbp)
{
	HAJCAVS	pW = (HAJCAVS)cbp;

	if (pW->fUnicode) {
		if (pW->u.cbNtcDelA != NULL) {
			pW->u.cbNtcDelA((C_BCP)key, pNode, len, nest, pW->cbp);
		}
	}
	else {
		if (pW->u.cbNtcDelW != NULL) {
			pW->u.cbNtcDelW((C_WCP)key, pNode, len, nest, pW->cbp);
		}
	}
}
