#include	"AjcInternal.h"

//==============================================================================================================//
//	rbg}bv̐FύX																						//
//																												//
//	@	F	hBmp	- FύXrbg}bṽnh													//
//				before	- ύXO̐F																			//
//				after	- ύX̐F																			//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcChangeBitmapColor(HBITMAP hBmp, COLORREF rgbBefore, COLORREF rgbAfter)
{
	BOOL		rc = FALSE;
	BITMAP		BmpInfo;
	HDC			hdc = NULL;
	HDC			hmd = NULL;
	int			x, y;
	COLORREF	rgb;

	do {
		if (hBmp                            == NULL) break;
		if ((hdc = GetDC(NULL)			  ) == NULL) break;
		if ((hmd = CreateCompatibleDC(hdc)) == NULL) break;
		SelectObject(hmd, hBmp);

		GetObject(hBmp, sizeof(BITMAP), &BmpInfo);
		for (y = 0; y < BmpInfo.bmHeight; y++) { for (x = 0; x < BmpInfo.bmWidth; x++) {
			rgb = GetPixel(hmd, x, y);
			if (rgb == rgbBefore) {
				SetPixel(hmd, x, y, rgbAfter);
			}
		}}
		rc = TRUE;
	} while(0);

	if (hmd != NULL) DeleteDC(hmd);
	if (hdc != NULL) DeleteDC(hdc);

	return rc;
}
//==============================================================================================================//
//	rbg}bvf[^Nbv{[h֊i[																//
//																												//
//	@F	hBitmap	- Nbv{[h֊i[rbg}bvf[^											//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT	BOOL  	WINAPI AjcSetBitmapToClipboard (HBITMAP hBitmap)
{
	BOOL	rc = FALSE;
	HBITMAP	hBmp;

	if (hBitmap != NULL) {
		BITMAP	bm;
		if (GetObject(hBitmap, sizeof(BITMAP), &bm) != 0) {
			hBmp = CopyImage(hBitmap, IMAGE_BITMAP, bm.bmWidth, bm.bmHeight, LR_COPYRETURNORG);
			if (hBmp != NULL) {
				if (OpenClipboard(NULL) != 0) {
					EmptyClipboard();
					SetClipboardData(CF_BITMAP, hBmp);
					CloseClipboard();
					rc = TRUE;
				}
				else {
					DeleteObject(hBmp);
				}
			 }
		}
	}
	return rc;
}
//==============================================================================================================//
//	Nbv{[hrbg}bvf[^擾																//
//																												//
//	@F	Ȃ																							//
//																												//
//	߂l	F	NULL - i擾rbg}bvf[^̃nhj											//
//				NULL - s																					//
//==============================================================================================================//
AJCEXPORT	HBITMAP	WINAPI AjcGetBitmapFromClipboard (VO)
{
	HBITMAP	rc	 = NULL;
	HBITMAP	hBmp = NULL;

	if (IsClipboardFormatAvailable(CF_BITMAP)) {
		if (OpenClipboard(NULL) != 0) {
			if (hBmp = (HBITMAP)GetClipboardData(CF_BITMAP)) {
				rc = CopyImage(hBmp, IMAGE_BITMAP, 0, 0, LR_COPYRETURNORG);
			}
			CloseClipboard();
		}
	}
	return rc;
}

//==============================================================================================================//
//	rbg}bv}C쐬																				//
//																												//
//	@F	hBitmap   - rbg}bvIuWFNg̃nh													//
//				pFilePath - o͂rbg}bvt@C̃pX												//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
static		BOOL		   SubAjcWriteBitmapToFile	(HBITMAP hBitmap, C_VOP pFilePath, BOOL fUnicode)
{
	BOOL				rc = FALSE;
	HANDLE				hFile 			= INVALID_HANDLE_VALUE;
	HDC					hDC				= NULL;
	DWORD				dw				= 0;
	DWORD				dwHeaderSize	= 0;
	DWORD				dwScanDataSize	= 0;
	BITMAPFILEHEADER	bmpFileHeader;
	BITMAPINFOHEADER	*pBmpInfoHdr	= NULL;
	UBP					pHeaderBuffer	= NULL;
	UBP					pScanDataBuffer	= NULL;
	BITMAP				bmp;

	do {
		if (hBitmap   == NULL) break;
		if (pFilePath == NULL) break;
		if (GetObject(hBitmap, sizeof(BITMAP), &bmp) == 0) break;

		if (bmp.bmBitsPixel < 24) dwHeaderSize = sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * (int)((UX)1 << bmp.bmBitsPixel);
		else					  dwHeaderSize = sizeof(BITMAPINFOHEADER);
		if ((pHeaderBuffer = (UBP)AJCMEM(dwHeaderSize)) == NULL) break;
		memset(pHeaderBuffer, 0, dwHeaderSize);

		pBmpInfoHdr 			= (BITMAPINFOHEADER*)pHeaderBuffer;
		pBmpInfoHdr->biBitCount = bmp.bmBitsPixel;

		pBmpInfoHdr->biSize 		 = sizeof(BITMAPINFOHEADER);
		pBmpInfoHdr->biWidth		 = bmp.bmWidth;
		pBmpInfoHdr->biHeight		 = bmp.bmHeight;
		pBmpInfoHdr->biPlanes		 = 1;
		pBmpInfoHdr->biCompression	 = BI_RGB;
		pBmpInfoHdr->biSizeImage	 = 0;
		pBmpInfoHdr->biXPelsPerMeter = 0;
		pBmpInfoHdr->biYPelsPerMeter = 0;
		pBmpInfoHdr->biClrUsed		 = 0;
		pBmpInfoHdr->biClrImportant  = 0;

		if ((hDC = GetDC(NULL)) == NULL) break;
		GetDIBits(hDC, hBitmap, 0, bmp.bmHeight, NULL, (LPBITMAPINFO)pBmpInfoHdr, DIB_RGB_COLORS);
		dwScanDataSize = pBmpInfoHdr->biSizeImage;
		if ((pScanDataBuffer = (UBP)AJCMEM(dwScanDataSize)) == NULL) break;;
		GetDIBits(hDC, hBitmap, 0, bmp.bmHeight, pScanDataBuffer, (LPBITMAPINFO)pBmpInfoHdr, DIB_RGB_COLORS);
		ReleaseDC(NULL, hDC);

		bmpFileHeader.bfType = 0x4D42;	/* "BM" */
		bmpFileHeader.bfReserved1 = 0;
		bmpFileHeader.bfReserved2 = 0;

		bmpFileHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + dwHeaderSize;
		bmpFileHeader.bfSize	= dwScanDataSize + bmpFileHeader.bfOffBits;

		if (fUnicode) {
			if ((hFile = CreateFileW((C_WCP)pFilePath, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) break;
		}
		else {
			if ((hFile = CreateFileA((C_BCP)pFilePath, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) break;
		}
		if (WriteFile(hFile, &bmpFileHeader, sizeof(BITMAPFILEHEADER), &dw, NULL) == 0) break;
		if (WriteFile(hFile, pHeaderBuffer, dwHeaderSize, &dw, NULL)			  == 0) break;
		if (WriteFile(hFile, pScanDataBuffer, dwScanDataSize, &dw, NULL)		  == 0) break;

		rc = TRUE;

	} while(0);

	if (hDC 			!= NULL) ReleaseDC(NULL, hDC);
	if (pHeaderBuffer	!= NULL) free(pHeaderBuffer  );
	if (pScanDataBuffer != NULL) free(pScanDataBuffer);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);

	return rc;
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcWriteBitmapToFileA	(HBITMAP hBitmap, C_BCP pFilePath)
{
	return SubAjcWriteBitmapToFile	(hBitmap, (C_VOP)pFilePath, FALSE);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcWriteBitmapToFileW	(HBITMAP hBitmap, C_WCP pFilePath)
{
	return SubAjcWriteBitmapToFile	(hBitmap, (C_VOP)pFilePath, TRUE);
}

//==============================================================================================================//
//	rbg}bvt@C̓ǂݏoichaZNV쐬j														//
//																												//
//	@	F	pFilePath - rbg}bvt@C̃pX														//
//				pWidth	  - rbg}bv̉TCYi[obt@̃AhX		isvNULLj			//
//				pHeight	  - rbg}bv̏cTCYi[obt@̃AhX		isvNULLj			//
//				pBmpInfo  - rbg}bvi[obt@̃AhX			isvNULLj			//
//				ppImage	  - C[Wf[^ւ̃|C^i[obt@̃AhX	isvNULLj			//
//																												//
//	߂l	F	NULLFrbg}bvnh																	//
//				NULLFG[																					//
//==============================================================================================================//
static	  HBITMAP 			SubCreateDibFromFile(C_VOP pFilePath, UIP pWidth, UIP pHeight, PAJCBITMAPINFO pBmpInfo, VOP *ppImage, BOOL fUnicode)
{
	HBITMAP				rc = NULL;
	UBP					pBits;
	DWORD				dwBytesRead;
	HANDLE				hFile = INVALID_HANDLE_VALUE;
	HBITMAP				hBitmap;
	BITMAPFILEHEADER	BmapFh;			//	rbg}bvt@Cwb_
	LPBITMAPINFO		pBmapIf = NULL;	//	rbg}bv
	UI					lBmapIf = 0;	//	rbg}bṽTCY
	UI					lImage	= 0;	//	C[Wf[^oCg

	do {
		if (pFilePath == NULL) break;
		//----- rbg}bvt@C I[v ------------------------------------------------------------------//
		if (fUnicode) {
			if ((hFile = CreateFileW((C_WCP)pFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == 
																									INVALID_HANDLE_VALUE) {
				break;
			}
		}
		else {
			if ((hFile = CreateFileA((C_BCP)pFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == 
																									INVALID_HANDLE_VALUE) {
				break;
			}
		}
		//----- rbg}bvt@Cwb_ǂݏo -------------------------------------------------------------//
		if (!ReadFile (hFile, &BmapFh, sizeof(BITMAPFILEHEADER), &dwBytesRead, NULL)) {
			break;
		}
		//----- rbg}bvt@Cwb_̓e`FbN -------------------------------------------------------//
		if (dwBytesRead != sizeof(BITMAPFILEHEADER) || BmapFh.bfType != *(WORD *)"BM") {
			break;
		}
		//----- rbg}bvǂݏo -----------------------------------------------------------------------//
		lBmapIf = BmapFh.bfOffBits - sizeof(BITMAPFILEHEADER) ;
		pBmapIf = (LPBITMAPINFO)AJCMEM(lBmapIf);
		if (pBmapIf == NULL) break;
		if (!ReadFile(hFile, pBmapIf, lBmapIf, &dwBytesRead, NULL)) {
			break;
		}
		//----- rbg}bvǂݏoTCY`FbN ---------------------------------------------------------//
		if (dwBytesRead != lBmapIf) {
			break;
		}
		//----- chardbshnm쐬 -----------------------------------------------------------------------//
		if ((hBitmap = CreateDIBSection (NULL, pBmapIf, DIB_RGB_COLORS, (void **)&pBits, NULL, 0)) == NULL) {
			break;
		}
		//----- rbg}bvC[Wǂݏo -------------------------------------------------------------------//
		lImage = BmapFh.bfSize - BmapFh.bfOffBits;
		if (!ReadFile(hFile, pBits, lImage, &dwBytesRead, NULL)) {
			DeleteObject(hBitmap);
			break;
		}
		//---- C[WǂݏoTCY`FbN ------------------------------------------------------------------//
		if (dwBytesRead != lImage) {
			DeleteObject(hBitmap);
			break;
		}
		//----- ߂ݒ -----------------------------------------------------------------------------------//
		//-- rbg}bvTCY -------------//
		if (pBmapIf->bmiHeader.biSize == sizeof(BITMAPCOREHEADER)) {
			if (pWidth	!= NULL) *pWidth  = ((BITMAPCOREHEADER *) pBmapIf)->bcWidth;
			if (pHeight != NULL) *pHeight = ((BITMAPCOREHEADER *) pBmapIf)->bcHeight;
		}
		else {
			if (pWidth	!= NULL) *pWidth  = pBmapIf->bmiHeader.biWidth;
			if (pHeight != NULL) *pHeight = pBmapIf->bmiHeader.biHeight;
		}
		//-- rbg}bv -------------------//
		if (pBmpInfo != NULL) {
			memset(pBmpInfo, 0, sizeof(AJCBITMAPINFO));
			if		(pBmapIf->bmiHeader.biSize == sizeof(BITMAPINFOHEADER)) memcpy(pBmpInfo, pBmapIf, sizeof(BITMAPINFOHEADER));
			else if (pBmapIf->bmiHeader.biSize == sizeof(BITMAPV4HEADER))	memcpy(pBmpInfo, pBmapIf, sizeof(BITMAPV4HEADER));
			else if (pBmapIf->bmiHeader.biSize == sizeof(BITMAPV5HEADER))	memcpy(pBmpInfo, pBmapIf, sizeof(BITMAPV5HEADER));
			else															memcpy(pBmpInfo, pBmapIf, sizeof(BITMAPCOREHEADER));
		}
		//-- rbg}bvEC[WAhX -----//
		if (ppImage != NULL) {
			*ppImage = pBits;
		}
		//----- ߂lirbg}bvnhjݒ -------------------------------------------------------------//
		rc = hBitmap;
	} while(0);

	//----- \[XJ ---------------------------------------------------------------------------------------//
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);
	if (pBmapIf != NULL) free(pBmapIf); pBmapIf = NULL;

	return rc;
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT HBITMAP WINAPI	AjcCreateDibFromFileA(C_BCP pFilePath, UIP pWidth, UIP pHeight, PAJCBITMAPINFO pBmpInfo, VOP *ppImage)
{
	return SubCreateDibFromFile((C_VOP)pFilePath, pWidth, pHeight, pBmpInfo, ppImage, FALSE);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT HBITMAP WINAPI	AjcCreateDibFromFileW(C_WCP pFilePath, UIP pWidth, UIP pHeight, PAJCBITMAPINFO pBmpInfo, VOP *ppImage)
{
	return SubCreateDibFromFile((C_VOP)pFilePath, pWidth, pHeight, pBmpInfo, ppImage, TRUE);
}
//==============================================================================================================//
//	rbg}bvTCY̎擾																					//
//																												//
//	@	F	hBitmap		- rbg}bvnh																//
//				pSize		- rbg}bṽTCYi[obt@̃AhX		isvNULLj			//
//																												//
//	߂l	F	0FsNZ̐F߂ɕKvȃrbg														//
//				0FG[																						//
//==============================================================================================================//
AJCEXPORT UI WINAPI	AjcGetBitmapSize(HBITMAP hBitmap, LPSIZE pSize)
{
	UI		rc = 0;
	BITMAP	BmpInfo;

	if (GetObject(hBitmap, sizeof(BITMAP), &BmpInfo) == sizeof(BITMAP)) {
		if (pSize != NULL) {
			pSize->cx = BmpInfo.bmWidth;
			pSize->cy = BmpInfo.bmHeight;
		}
		rc = BmpInfo.bmBitsPixel;
	}
	return rc;
}
//==============================================================================================================//
//	ACRTCY̎擾																						//
//																												//
//	@	F	hIcon		- ACRnh																	//
//				pSize		- ACR̃TCYi[obt@̃AhX		isvNULLj				//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : s																					//
//==============================================================================================================//
AJCEXPORT BOOL WINAPI	AjcGetIconSize(HICON hIcon, LPSIZE pSize)
{
	BOOL		rc = FALSE;
	ICONINFO	ii = {0};

	if (GetIconInfo(hIcon, &ii)) {
		BITMAP bm;
		if (GetObject(ii.hbmMask, sizeof(bm), &bm) == sizeof(bm)) {
			pSize->cx = bm.bmWidth;
			pSize->cy = ii.hbmColor ? bm.bmHeight : bm.bmHeight / 2;
		}
		rc = TRUE;
	}
	if (ii.hbmMask ) DeleteObject(ii.hbmMask);
	if (ii.hbmColor) DeleteObject(ii.hbmColor);

	return rc;
}

