#include	"AjcInternal.h"
#include	"AjcCipCommon.h"

//**************************************************************************************************************//
//																												//
//	bꕗC^v^i]pTu֐j																	//
//																												//
//**************************************************************************************************************//
//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubSetCallInfo	(HAJCCIP pW, PAJCCIPCALL pCallInfo, BOOL fCalculation);
static	BOOL	GetVarInfo		(HAJCCIP pW, PAJCCIPVARINFO pVi, BOOL fCalculation);
static	BOOL	SubGetVarInf	(HAJCCIP pW, PAJCCIPTKN pSymTkn, SLL ix, PAJCCIPVARINFO pVi);

//==============================================================================================================//
//	̕]																								//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				pVal		 - r̕]li[obt@̃AhX									//
//				fCalculation - vZtO - CALCULATION(=TRUE)	: ֐s								//
//											SYNTAX_ONLY(=FALSE) : V^bNX`FbN̂						//
//																												//
//	߂l	F	TRUE F																						//
//				FALSEFs																						//
//																												//
//	@l	F	pW->pCur - ͎F擪g[N															//
//						   IF̒̃g[N														//
//==============================================================================================================//
#define	ISOP_STRCMP(TKN)	((TKN) == EAJCTK_DLM_EQEQ	||	\
							 (TKN) == EAJCTK_DLM_NOTEQ	||	\
							 (TKN) == EAJCTK_DLM_LO		||	\
							 (TKN) == EAJCTK_DLM_HI 	||	\
							 (TKN) == EAJCTK_DLM_LOEQ 	||	\
							 (TKN) == EAJCTK_DLM_HIEQ)
//-------------------------------------------------------------------------------------------------------------//
BOOL	CipFmlStr(HAJCCIP pW, SLL *pVal, BOOL fCalculation)
{
	BOOL		rc	  = FALSE;					//	߂l
	PCAJCCIPTKN	pSym1 = NULL, pSym2 = NULL;		//	ӂ̃V{g[N
	PCAJCCIPTKN	pOpe  = NULL;					//	Zq
	PCAJCCIPTKN	pNxt  = NULL;					//	̃g[N|C^[N
	C_BCP			pStr1 = NULL, pStr2 = NULL;	//	ӂ̕
	AJCCIPVARINFO	vInf1, vInf2;				//	ӂ̕ϐ
	BOOL			fVar = FALSE;				//	ӂϐł邱ƂtO

	do {
		//----- ӂ̕擾 -------------------------------------//
		if (IS_STR_SYM(pW->pCur)) {
			pSym1 = pW->pCur;
			pNxt  = pW->pCur + 1;
			//	֐
			if (pNxt->tkn == EAJCTK_DLM_LSPART) {
				vInf1.hVmg = pW->sFni[0].hVmg;
				vInf1.pSym = "$@rc1";
				vInf1.ix   = 0;
				if (!CipFmlCallFunc(pW, &vInf1, fCalculation)) {
					break;
				}
				pStr1 = AjcVmgGetStringA(vInf1.hVmg, "$@rc1", 0);
			}
			//	ϐ
			else {
				fVar = TRUE;
				if (fCalculation) {
					if ((pStr1 = CipFmlGetVarInfoStr(pW, &vInf1, fCalculation)) == NULL) {
						break;
					}
				}
				else {
					pW->pCur++;		//	ϐXLbv
				}
			}
		}
		else if (pW->pCur->tkn == EAJCTK_CIP_STRING) {
			pStr1 = pW->pCur->u.pStr;		//	ݒ
			pW->pCur++;						//	XLbv
		}
		else {
			pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pW->pCur->lno,
									  LNGSEL("̕\Ɍ肪܂B",
											 "Missing string formula."));
			break;
		}
		//----- Zqg[NޔCXLbv -------------------------//
		pOpe = pW->pCur;
		//----- 񉉎ZqȊOȂ΁Alݒ ---------------//
		if (!((ISOP_STRCMP(pOpe->tkn) || (fVar && pOpe->tkn == EAJCTK_DLM_EQ)))) {
			//	ZqȊȌꍇ́AP̓eŖ߂lݒ肵AI
			int		sl	= sizeof(*pVal);
			int		dl	= (int)strlen(pStr1);
			int		len = __min(sl, dl);
			C_BCP	sp	= pStr1;
			BCP		dp	= ((BCP)pVal) + (len - 1);
			*pVal = 0;
			while (len-- > 0) {
				*dp-- = *sp++;
			}
			rc = TRUE;
			break;
		}
		//----- 񉉎ZqXLbv ---------------------------------//
		pW->pCur++;
		//----- Eӂ̕擾 -------------------------------------//
		if (IS_STR_SYM(pW->pCur)) {
			pSym2 = pW->pCur;
			pNxt  = pW->pCur + 1;
			//	֐
			if (pNxt->tkn == EAJCTK_DLM_LSPART) {
				vInf2.hVmg = pW->sFni[0].hVmg;
				vInf2.pSym = "$@rc2";
				vInf2.ix   = 0;
				if (!CipFmlCallFunc(pW, &vInf2, fCalculation)) {
					break;
				}
				pStr2 = AjcVmgGetStringA(vInf2.hVmg, "$@rc2", 0);
			}
			//	ϐ
			else {
				if (fCalculation) {
					if ((pStr2 = CipFmlGetVarInfoStr(pW, &vInf2, fCalculation)) == NULL) {
						break;
					}
				}
				else {
					pW->pCur++;		//	ϐXLbv
				}
			}
		}
		else if (pW->pCur->tkn == EAJCTK_CIP_STRING) {
			pStr2 = pW->pCur->u.pStr;		//	ݒ
			pW->pCur++;						//	XLbv
		}
		else {
			pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pW->pCur->lno,
									  LNGSEL("̕\Ɍ肪܂B",
											 "Missing string formula."));
			break;
		}
		if (fCalculation) {
			//----- rZs -----------------------------------------//
			if (ISOP_STRCMP(pOpe->tkn)) {
				switch (pOpe->tkn) {
					case EAJCTK_DLM_EQEQ:	*pVal = (mbscmp(pStr1, pStr2) == 0);	break;
					case EAJCTK_DLM_NOTEQ:	*pVal = (mbscmp(pStr1, pStr2) != 0);	break;
					case EAJCTK_DLM_LO:		*pVal = (mbscmp(pStr1, pStr2) <  0);	break;
					case EAJCTK_DLM_HI:		*pVal = (mbscmp(pStr1, pStr2) >  0);	break;
					case EAJCTK_DLM_LOEQ:	*pVal = (mbscmp(pStr1, pStr2) <= 0);	break;
					case EAJCTK_DLM_HIEQ:	*pVal = (mbscmp(pStr1, pStr2) >= 0);	break;
				}
				rc = TRUE;
			}
			//----- ] -------------------------------------------//
			else if (fVar) {
				if (rc = CipVmgSetString(pW, pOpe->lno, vInf1.hVmg, vInf1.pSym, vInf1.ix, pStr2)) {
					*pVal = (*pStr2 != 0);
				}
			}
			else {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pW->pCur->lno,
										  LNGSEL("̕\Ɍ肪܂B",
												 "Missing string formula."));
			}
		}
		else {
			*pVal = 1;
			rc	  = TRUE;
		}
	} while(0);

	return rc;
}
//==============================================================================================================//
//	֐̌Ăяoi}N-g[Nɂ֐Ăяoj															//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				pVi			 - ֐߂li[ϐ̏iNULL:ϐj									//
//				fCalculation - vZtO - CALCULATION(=TRUE)	: ֐Ăяos						//
//											SYNTAX_ONLY(=FALSE) : V^bNX`FbN̂						//
//																												//
//	߂l	F	TRUE  - ֐̌Ăяo																		//
//				FALSE - ֐̌ĂяoŃG[																//
//																												//
//	@	F	pW->pCur - g[N擪i֐j																//
//																												//
//	o@	F	pW->pCur - ߂lTRUE  - \̒̃g[Ni 'func(EE)' ̎j							//
//==============================================================================================================//
BOOL	CipFmlCallFunc(HAJCCIP pW, PAJCCIPVARINFO pVi, BOOL fCalculation)
{
	BOOL		rc	 = FALSE;
	PAJCCIPTKN	pTop = pW->pCur;
	AJCCIPCALL	CallInfo;

	pW->ixIfNest++;

	if (pW->pCur->tkn == EAJCTK_USR_NAME) {					//	'Symbol' H
		//	֐ĂяoNA[
		memset(&CallInfo, 0, sizeof CallInfo);
		//	֐Ăяo
		do {
			//	L[CX^X
			if ((CallInfo.hQueAgv = AjcFQueCreate(sizeof(AJCCIPAGV), 0, NULL)) == NULL) {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_MEM, pTop->lno,
											  LNGSEL("֐ĂяoɊւp[N̊mۂɎs܂B",
													 "Arguments work in function call allocation failure."));
				break;
			}
			//	߂ϐݒ
			if (pVi != NULL) {
				CallInfo.rchVmg = pVi->hVmg;
				CallInfo.rcpSym = pVi->pSym;
				CallInfo.rcIx	= pVi->ix;
			}
			//	֐Ăяoݒ
			if (!SubSetCallInfo(pW, &CallInfo, fCalculation)) {
				break;
			}
			//	֐Ăяos
			if (fCalculation) {
				if (pW->fRunReady) {
					rc = CipExeFuncCall(pW, &CallInfo, pTop);
				}
				else {
					pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pTop->lno,
												  LNGSEL("֐sł܂B",
														 "Do not execute the function."));
				}
			}
			else {
				rc = TRUE;	//	V^NX`FbN͊֐sɂnjԂ
			}
		} while(0);

		//	֐Ăяoj
		if (CallInfo.hQueAgv != NULL) {
			AjcFQueDelete(CallInfo.hQueAgv);
			CallInfo.hQueAgv = NULL;
		}
	}
	pW->ixIfNest--;

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubSetCallInfo(HAJCCIP pW, PAJCCIPCALL pCallInfo, BOOL fCalculation)
{
	BOOL			rc = FALSE;
	AJCCIPAGV		agv;
	PCAJCVMGNODEA	pArgNode;
	UI				ixFuncArg = 0;

	do {
		//	֐ݒ
		pCallInfo->pFunName = pW->pCur->u.pStr;
		//	sԍݒ
		pCallInfo->lno		= pW->pCur->lno;
		//	֐XLbv
		pW->pCur++;
		//	'(' XLbv
		pW->pCur++;

		//	ݒ
		pCallInfo->nArg = 0;
		while (pW->pCur->tkn != EAJCTK_DLM_RSPART &&pW->pCur->tkn != EAJCTK_EOF) {	// ')', EOF ȊO
			PAJCCIPTKN pNx1 = pW->pCur + 1;
			PAJCCIPTKN pNx2 = pW->pCur + 2;
			//	NA[
			memset(&agv, 0, sizeof agv);
			//	ԍݒ
			agv.seq = pCallInfo->nArg;
			//	zw`FbN
			if (pW->pCur->tkn == EAJCTK_USR_NAME && pNx1->tkn == EAJCTK_DLM_LLPART && pNx2->tkn == EAJCTK_DLM_RLPART) {	//	'var[]' H
				HAJCVMGA	hVmgS	 = NULL;
				PAJCCIPTKN	pSym	 = pW->pCur;
				//	^Cvݒ
				if (*pW->pCur->u.pStr == '$') agv.typ = AJCIPT_STRING;
				else						  agv.typ = pW->NumType;
				//	ztOݒ
				agv.fArr = TRUE;
				//	zϐCX^XCϐݒ
				if (fCalculation) {
					if (agv.val.arr.hVmg  = CipFmlGetVarInst(pW, pSym)) {
						agv.val.arr.pName = pSym->u.pStr;
						//	'var[]' XLbv
						pW->pCur = pNx2 + 1;
					}
					else {
						break;		//	G[Ȃ΁AI
					}
				}
				else {
					//	'var[]' XLbv
					pW->pCur = pNx2 + 1;
				}
			}
			//	ϐ^֐
			else if (IS_STR_SYM(pW->pCur)) {
				//	֐
				if (pNx1->tkn == EAJCTK_DLM_LSPART) {
					AJCCIPVARINFO	vInf;
					BC				ArgName[20];
					//	p̓ϐ쐬
					AjcSnPrintFA(ArgName, sizeof ArgName, "$@arg%d%d", pW->ixIfNest, ixFuncArg);
					ixFuncArg++;
					if ((pArgNode = AjcVmgGetNodeA(pW->sFni[pW->ixFni].hVmg, ArgName)) == NULL) {	//	YϐH
						//	ϐ쐬
						if (!CipVmgGenVar(pW, pCallInfo->lno, pW->sFni[pW->ixFni].hVmg, ArgName, AJCVMGT_STR, 1)) {
							break;
						}
						pArgNode = (PCAJCVMGNODEA)AjcVmgGetNodeA(pW->sFni[pW->ixFni].hVmg, ArgName);
					}
					//	ݒ
					vInf.hVmg = pW->sFni[pW->ixFni].hVmg;
					vInf.pSym = pArgNode->pName;
					vInf.ix   = 0;
					if (!CipFmlCallFunc(pW, &vInf, fCalculation)) {
						break;
					}
					agv.typ 	 = AJCIPT_STRING;
					agv.val.pStr = AjcVmgGetStringA(vInf.hVmg, ArgName, 0);
				}
				//	ϐ
				else {
					AJCCIPVARINFO	vInf;
					agv.typ 	 = AJCIPT_STRING;
					if (fCalculation) {
						if (GetVarInfo(pW, &vInf, fCalculation)) {
							agv.val.pStr = AjcVmgGetStringA(vInf.hVmg, vInf.pSym, vInf.ix);
						}
						else {
							break;
						}
					}
					else {
						//	ϐXLbv
						pW->pCur++;
					}
				}
			}
			//	
			else if (pW->pCur->tkn == EAJCTK_CIP_STRING) {
				agv.typ 	 = AJCIPT_STRING;
				agv.val.pStr = pW->pCur->u.pStr;
				pW->pCur++;			//	XLbv
			}
			//	
			else {
				agv.typ = pW->NumType;
				switch (pW->NumType) {
					case AJCIPT_INTEGER: CipFmlINT(pW, &agv.val.sll, fCalculation);	break;
					case AJCIPT_REAL:	 CipFmlDBL(pW, &agv.val.dbl, fCalculation);	break;
				}
				//	G[ȂΏI
				if (pW->ErrCod != AJCIP_ERR_OK) break;
			}
			//	m[hǉ
			AjcFQueEnque(pCallInfo->hQueAgv, &agv);
			pCallInfo->nArg++;
			//	',' XLbv
			if (pW->pCur->tkn != EAJCTK_DLM_RSPART) {
				if (pW->pCur->tkn == EAJCTK_DLM_COMMA) {
					pW->pCur++;
				}
				else {
					pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pW->pCur->lno,
												  LNGSEL("֐ <%s> Ăяö ',' ŋ؂邩A ')' ŕĂ܂B",
														 "Missing ',' or Not closed by ')' in arguments of function <%s>."), pCallInfo->pFunName);
					break;
				}
			}
		}
		//	G[ȂΏI
		if (pW->ErrCod != AJCIP_ERR_OK) break;
		//	')' `FbN
		if (pW->pCur->tkn != EAJCTK_DLM_RSPART) {		//	')' ȊOH
			pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pW->pCur->lno,
										  LNGSEL("֐ <%s> Ăяö ')' ŕĂ܂B",
												 "Not closed by ')' in arguments of function <%s>."), pCallInfo->pFunName);
			break;
		}
		pW->pCur++;										//	')' XLbv
		//	߂AhXݒ
		pCallInfo->pReturn = pW->pCur;
		//	߂lnj
		rc = TRUE;
	} while(0);

	return rc;
}
//==============================================================================================================//
//	ϐ擾																								//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pVi			- ϐi[obt@̃AhX													//
//				pVal		- ϐ^Cvl i[obt@̃AhX												//
//				fCalculation - vZtO - CALCULATION(=TRUE)	: zCfNXvZ						//
//											SYNTAX_ONLY(=FALSE) : V^bNX`FbN̂						//
//																												//
//	߂l	F	ϐ̒li^^ւ̃|C^j														//
//																												//
//	pW->pCur	:	 - ϐ\̐擪g[Niϐj														//
//					o - ϐ\̎̃g[N																//
//==============================================================================================================//
SLL		CipFmlGetVarInfoInt64(HAJCCIP pW, PAJCCIPVARINFO pVi, BOOL fCalculation)
{
	SLL			rc	 = 1;
	PAJCCIPTKN	pSym = pW->pCur;

	if (GetVarInfo(pW, pVi, fCalculation)) {
		if (fCalculation) {
			if (!AjcVmgGetInt64A(pVi->hVmg, pVi->pSym, pVi->ix, &rc)) {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pSym->lno,
										  LNGSEL("lϐ <%s> ̕\Ɍ肪܂B",
												 "Missing expression in numeric variable <%s>."), pSym->u.pStr);
			}
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
double	CipFmlGetVarInfoReal (HAJCCIP pW, PAJCCIPVARINFO pVi, BOOL fCalculation)
{
	double		rc	 = 1.0;
	PAJCCIPTKN	pSym = pW->pCur;

	if (GetVarInfo(pW, pVi, fCalculation)) {
		if (fCalculation) {
			if (!AjcVmgGetRealA(pVi->hVmg, pVi->pSym, pVi->ix, &rc)) {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pSym->lno,
										  LNGSEL("lϐ %s> ̕\Ɍ肪܂B",
												 "Missing expression in numeric variable <%s>."), pSym->u.pStr);
			}
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
C_BCP		CipFmlGetVarInfoStr  (HAJCCIP pW, PAJCCIPVARINFO pVi, BOOL fCalculation)
{
	C_BCP		rc = NULL;
	PAJCCIPTKN	pSym = pW->pCur;

	if (GetVarInfo(pW, pVi, fCalculation)) {
		if (fCalculation) {
			if ((rc = AjcVmgGetStringA(pVi->hVmg, pVi->pSym, pVi->ix)) == NULL) {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pSym->lno,
										  LNGSEL("ϐ <%s> ̕\Ɍ肪܂B",
												 "Missing expression in string variable <%s>."), pSym->u.pStr);
			}
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	GetVarInfo(HAJCCIP pW, PAJCCIPVARINFO pVi, BOOL fCalculation)
{
	BOOL		rc = FALSE;
	SLL			ix;
	PAJCCIPTKN	pSymTkn;

	//	V{ޔ
	pSymTkn = pW->pCur;
	//	̌|C^ݒi V{XLbvj
	pW->pFml = pW->pCur++;
	//	zϐH
	if (pW->pCur->tkn == EAJCTK_DLM_LLPART) {				//	'[' H
		//	̌|C^ݒ聕dne`FbN
		if (CipFmlSkipToken(pW) != EAJCTK_EOF) {			//	EOFȊOH
			//	zvfԍݒ
			if (CipFmlINT(pW, &ix, fCalculation)) {			//	]CnjH
				//	Ž傪 ']' Ȃ΃XLbvlݒ
				if (pW->pCur->tkn == EAJCTK_DLM_RLPART) {	//	']' H
					//	̌|C^ݒi ']' XLbvj
					pW->pFml = pW->pCur++;
					//	zϐlݒ
					if (fCalculation) {
						rc = SubGetVarInf(pW, pSymTkn, ix, pVi);
					}
					else rc = TRUE;
				}
				//	Ž傪 ']' ȊOȂ΃G[
				else {
					pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pW->pCur->lno,
											  LNGSEL("<%s> ̑O ']' KvłB",
													 "Need ']' before <%s>."), CipGsrTknStr(pW->pCur));
				}
			}
		}
	}
	//	PϐH
	else {
		//	Pϐlݒ
		if (fCalculation) {
			rc = SubGetVarInf(pW, pSymTkn, 0, pVi);
		}
		else rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubGetVarInf(HAJCCIP pW, PAJCCIPTKN pSymTkn, SLL ix, PAJCCIPVARINFO pVi)
{
	BOOL			rc = FALSE;
	PCAJCVMGNODEA	pNode;

	do {
		//	ϐl擾
		if (pW->ixFni != 0) {
			if (pNode = AjcVmgGetNodeA(pW->sFni[pW->ixFni].hVmg, pSymTkn->u.pStr)) {
				if (pNode->num > ix) {
					//	ϐޔ
					pVi->hVmg = pW->sFni[pW->ixFni].hVmg;
					pVi->pSym = pSymTkn->u.pStr;
					pVi->ix   = (UI)ix;
					rc = TRUE;
				}
				else {
					pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, pW->pCur->lno,
										LNGSEL("zCfNXl(%d)傫܂B",
											   "Over array index value (%d)."), (UI)ix);
				}
				break;
			}
		}
		//	ÓIϐl擾
		if (pNode = AjcVmgGetNodeA(pW->sFni[0].hVmg, pSymTkn->u.pStr)) {
			if (pNode->num > ix) {
				//	ϐޔ
				pVi->hVmg = pW->sFni[0].hVmg;
				pVi->pSym = pSymTkn->u.pStr;
				pVi->ix   = (UI)ix;
				rc = TRUE;
			}
			else {
				pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, pW->pCur->lno,
									LNGSEL("zCfNXl(%d)傫܂B",
										   "Over array index value (%d)."), (UI)ix);
			}
		}
		else {
			pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_VMG, pSymTkn->lno,
								LNGSEL("ϐ <%s> ͒`Ă܂B",
									   "Undefined Variable <%s>."), CipGsrTknStr(pSymTkn));
		}
	} while(0);

	return rc;
}

//==============================================================================================================//
//	siϐ̃CX^X擾j																				//
//																												//
//	@	F	pW			- CX^X[N																//
//				pSymTkn		- V{g[N																	//
//																												//
//	߂l	F	NULL:iϐǗCX^Xj																//
//				NULL:G[																					//
//																												//
//			F	pW->pCur - V{g[N																		//
//==============================================================================================================//
static	HAJCVMGA	CipFmlGetVarInst(HAJCCIP pW, PAJCCIPTKN pSymTkn)
{
	HAJCVMGA		rc = NULL;
	PCAJCVMGNODEA	pNode;

	do {
		//	ϐCX^X擾
		if (pW->ixFni != 0) {
			if (pNode = AjcVmgGetNodeA(pW->sFni[pW->ixFni].hVmg, pSymTkn->u.pStr)) {
				rc = pW->sFni[pW->ixFni].hVmg;
				break;
			}
		}
		//	ÓIϐCX^X擾
		if (pNode = CipVmgGetNode(pW, pSymTkn->lno, pW->sFni[0].hVmg, pSymTkn->u.pStr)) {
			rc = pW->sFni[0].hVmg;
		}
		else {
			pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pSymTkn->lno,
								LNGSEL("ϐ <%s> ͒`Ă܂B",
									   "Undefined Variable <%s>."), CipGsrTknStr(pSymTkn));
		}
	} while(0);

	return rc;
}
//==============================================================================================================//
//	XLbvdne`FbNidneȂ΃G[j														//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	̃g[ÑR[h																			//
//																												//
//	pW->pCur	:	 - ݂̃g[N																		//
//					o - ̃g[N																			//
//==============================================================================================================//
EAJCTKCODE	CipFmlSkipToken(HAJCCIP pW)
{
	EAJCTKCODE	rc;

	if (pW->pCur->tkn != EAJCTK_EOF) {				//	͂dneȊOH
		pW->pFml = pW->pCur++;
		rc = pW->pCur->tkn;
	}
	if (pW->pCur->tkn == EAJCTK_EOF) {
		pW->ErrCod = CipGsrNtcErr(pW, AJCIP_ERR_SYNTAX, pW->pCur->lno,
							LNGSEL("̓rłdneo܂B",
								   "EOF was detected in the formula expression."));
		rc = EAJCTK_EOF;
	}
	return rc;
}
