#include	"AjcInternal.h"
#include	"AjcCipCommon.h"

//**************************************************************************************************************//
//																												//
//	bꕗC^v^iXebvg[Xj																	//
//																												//
//**************************************************************************************************************//

#define		MYSECT		CIP_STEP_SECT

#define		MAX_TXTLEN	512

//--------------------------------------------------------------------------------------------------------------//
//	Ɨ̈																									//
//--------------------------------------------------------------------------------------------------------------//
static	ATOM	ClassStepStepBack = 0;
static	HICON	hIcoRun		= NULL;
static	HICON	hIcoPause	= NULL;
static	HICON	hIcoEnd		= NULL;
static	HICON	hIcoStep	= NULL;

static	BC		AppNameA[MAX_PATH];

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC_DEF(StepBack);
AJC_DLGPROC_DEF(StepDlg);

static	BOOL	ChkBreakLno(HAJCCIP pW);
static	VO		ShowByExecState(HAJCCIP pW);
static	VO		ShowOnExec(HAJCCIP pW);
static	VO		ShowOnPause(HAJCCIP pW);
static	VO		ShowNotExec(HAJCCIP pW);

//==============================================================================================================//
//	Nݒ																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
BOOL	CipStepInit(VO)
{
	BOOL		rc = TRUE;
	WNDCLASSA	wndclass;

	//	g[XpobNEChNX
	wndclass.style			= 0;
	wndclass.lpfnWndProc	= AJC_WNDPROC_NAME(StepBack);
	wndclass.cbClsExtra 	= 0;
	wndclass.cbWndExtra 	= (sizeof(UX));
	wndclass.hInstance		= hDllInst;
	wndclass.hIcon			= NULL;
	wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	= hBruBtnFace;
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= "CAjaMacroStepTrace";
	ClassStepStepBack = RegisterClassA(&wndclass);
	if (ClassStepStepBack == 0) {
		rc = FALSE;
	}

	//	ACR[h
	hIcoRun   = (HICON)LoadImageA(hDllInst, MAKEINTRESOURCEA(IDI_CIP_RUN	), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	hIcoPause = (HICON)LoadImageA(hDllInst, MAKEINTRESOURCEA(IDI_CIP_PAUSE	), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	hIcoEnd   = (HICON)LoadImageA(hDllInst, MAKEINTRESOURCEA(IDI_CIP_END	), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	hIcoStep  = (HICON)LoadImageA(hDllInst, MAKEINTRESOURCEA(IDI_CIP_STEP	), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

	//	AvP[VioCgj
	WideCharToMultiByte(CP_ACP, 0, AppName, -1, AppNameA, AJCTSIZE(AppNameA), NULL, NULL);

	return rc;
}
//==============================================================================================================//
//	I㏈																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
VO		CipStepEnd(VO)
{
	//	g[XpobNEChNXj
	if (ClassStepStepBack != 0) {
		UnregisterClassA((BCP)ClassStepStepBack, hDllInst);
		ClassStepStepBack = 0;
	}
	//	rbg}bvj
	if (hIcoRun   != NULL) {DeleteObject(hIcoRun  ); hIcoRun   = NULL;}
	if (hIcoPause != NULL) {DeleteObject(hIcoPause); hIcoPause = NULL;}
	if (hIcoEnd   != NULL) {DeleteObject(hIcoEnd  ); hIcoEnd   = NULL;}
	if (hIcoStep  != NULL) {DeleteObject(hIcoStep ); hIcoStep  = NULL;}
}
//==============================================================================================================//
//	Xebvg[X̕\^֎~																			//
//																												//
//	@	F	pW			- CX^Xnh																//
//				fEnable		- TRUE	- Xebvg[X̕\												//
//							  FALSE - Xebvg[X̕\֎~												//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
VO			CipStepEnable(HAJCCIP pW, BOOL fEnable)
{
	pW->fStepTrace = (fEnable != 0);

	if (pW->hStepBack != NULL) {
		AjcSetDlgItemChk(pW->hStepDlg, IDC_CHK_ENASTEP, pW->fStepTrace);
		CipGsrDoEvent(pW);
	}
}
//==============================================================================================================//
//	Xebvg[X _Ci~bNXebvԍ\																//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pNxt		- \Ig[NAhXĩg[N̒O܂ŕ\j							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
VO			CipStepDynNo(HAJCCIP pW)
{
	do {
		if (pW->hStepBack == NULL	)	break;		//	Xebvg[XECh
		if (!pW->fStepTrace			)	break;		//	Xebvg[X֎~

		//	_Ci~bNXebvԍ\
		AjcVthPrintFA(pW->hStepVth, "\n\x1b[34m\x1B[46mStep: %-80d\x1B[0m", pW->ExeStepNo);
	} while(0);

	//	Windows Event
	CipGsrDoEvent(pW);
}
//==============================================================================================================//
//	Xebvg[X g[N\																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pNxt		- \Ig[NAhXĩg[N̒O܂ŕ\j							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
VO			CipStepShowToken(HAJCCIP pW, PAJCCIPTKN pNxt)
{
	UI			SvLno = -1;
	PAJCCIPTKN	pTkn;

	do {
		if (pW->hStepBack == NULL		)	break;		//	Xebvg[XECh
		if (!pW->fStepTrace				)	break;		//	Xebvg[X֎~
		if (pW->pStepTkn == NULL		)	break;		//	g[NAhXݒ
		if ((UX)pW->pStepTkn > (UX)pNxt	)	break;		//	Jnʒu  Iʒu

		//	Windows Event
		CipGsrDoEvent(pW);
		//	֐lXgxA֐Ăяo\
		if		(pW->SvStepNest < pW->ixFni) {
			PAJCCIPAGV	pNode;
			AjcVthPrintFA(pW->hStepVth, "\n\x1B[31m");
			AjcVthPrintFA(pW->hStepVth, "[%d: function  %s(", pW->ixFni, pW->sFni[pW->ixFni].CInf.pFunName);
			if (pNode = (PAJCCIPAGV)AjcFQueTopNode(pW->sFni[pW->ixFni].CInf.hQueAgv)) {
				do {
					if (pNode->seq != 0) AjcVthPrintFA(pW->hStepVth, ", ");
					if (pNode->fArr) {
						switch (pNode->typ) {
							case AJCIPT_INTEGER:
							{	SLL		v = 0;
								AjcVmgGetInt64A(pNode->val.arr.hVmg,  pNode->val.arr.pName, 0, &v);
								if (pW->fSigned)	AjcVthPrintFA(pW->hStepVth, "{%lld ...}"  , v);
								else				AjcVthPrintFA(pW->hStepVth, "{%llu ...}"  , v);
								break;
							}
							case AJCIPT_REAL:
							{	double v = 0.0;
								AjcVmgGetRealA(pNode->val.arr.hVmg,  pNode->val.arr.pName, 0, &v);
								AjcVthPrintFA(pW->hStepVth, "{%f ...}", v);
								break;
							}
							case AJCIPT_STRING:
							{	C_BCP		p = AjcVmgGetStringA(pNode->val.arr.hVmg,  pNode->val.arr.pName, 0);
								AjcVthPrintFA(pW->hStepVth, "{\"%s\" ...}", p != NULL ? p : "???");
								break;
							}
							default:
								AjcVthPrintFA(pW->hStepVth, "{??? ...}");
								break;
						}
					}
					else {
						switch (pNode->typ) {
							case AJCIPT_INTEGER:
								if (pW->fSigned)	AjcVthPrintFA(pW->hStepVth, "%lld"  , pNode->val.sll);
								else				AjcVthPrintFA(pW->hStepVth, "%llu"  , pNode->val.sll);
								break;
							case AJCIPT_REAL:		AjcVthPrintFA(pW->hStepVth, "%f"    , pNode->val.dbl);	break;
							case AJCIPT_STRING:		AjcVthPrintFA(pW->hStepVth, "\"%s\"", pNode->val.pStr);	break;
							default:				AjcVthPrintFA(pW->hStepVth, "???");						break;
						}
					}
				} while (pNode = (PAJCCIPAGV)AjcFQueNextNode(pW->sFni[pW->ixFni].CInf.hQueAgv, pNode));
			}
			AjcVthPrintFA(pW->hStepVth, ")]\x1B[0m");
			pW->SvStepNest = pW->ixFni;
			pW->SvStepLno  = -1;
			pW->SvStepTkn  = EAJCTK_INVALID;
		}
		//	֐lXgxA֐C߂l\
		else if (pW->SvStepNest > pW->ixFni) {
			AjcVthPrintFA(pW->hStepVth, "\n\x1B[31m");
			AjcVthPrintFA(pW->hStepVth, "[%d: return to %s()", pW->ixFni, pW->sFni[pW->ixFni].CInf.pFunName);
			if (pW->sFni[pW->SvStepNest].CInf.rchVmg != NULL) {
				PAJCCIPCALL   pCInf = &pW->sFni[pW->SvStepNest].CInf;
				PCAJCVMGNODEA pNode = AjcVmgGetNodeA(pCInf->rchVmg, pCInf->rcpSym);
				switch (pNode->type) {
					case AJCIPT_INTEGER:
						if (pW->fSigned)	AjcVthPrintFA(pW->hStepVth, ", value = %lld "	, pNode->arr.pSLL[pCInf->rcIx]);
						else				AjcVthPrintFA(pW->hStepVth, ", value = %llu "	, pNode->arr.pSLL[pCInf->rcIx]);
						break;
					case AJCIPT_REAL:		AjcVthPrintFA(pW->hStepVth, ", value = %f "		, pNode->arr.pDBL[pCInf->rcIx]); break;
					case AJCIPT_STRING:		AjcVthPrintFA(pW->hStepVth, ", value = \"%s\" "	, pNode->arr.pStr[pCInf->rcIx]); break;
				}
			}
			AjcVthPrintFA(pW->hStepVth, "]\x1B[0m");
			pW->SvStepNest = pW->ixFni;
			pW->SvStepLno  = -1;
			pW->SvStepTkn  = EAJCTK_INVALID;
		}
		//	pNxt̒O܂ł̃g[N\
		pTkn = pW->pStepTkn;
		while (pTkn != pNxt && pTkn != NULL) {
			//	sԍωAsԍ\
			if (pW->SvStepLno != pTkn->lno) {
				AjcVthSetColor(pW->hStepVth, 0);
				AjcVthPrintFA(pW->hStepVth, "\n%5u: %*c", pTkn->lno, pW->ixFni * 4, ' ');
				pW->SvStepLno  = pTkn->lno;
				pW->SvStepTkn  = EAJCTK_INVALID;
			}
			//	󔒑}
			if (pW->SvStepTkn != EAJCTK_INVALID) {
				if (AJCTKIS_VALSYM(pW->SvStepTkn) && (AJCTKIS_VALSYM(pTkn->tkn))) {
					AjcVthPrintFA(pW->hStepVth, " ");
				}
			}
			//	g[N\
			AjcVthPrintFA(pW->hStepVth, "%s", CipGsrTknStr(pTkn));
			//	Windows Event
			CipGsrDoEvent(pW);
			//	g[NR[hޔ
			pW->SvStepTkn = pTkn->tkn;
			//	̃g[NAhXݒ
			pTkn++;
		}
		//	g[NAhXޔ
		pW->pStepTkn = pTkn;
	} while (0);

	//	Windows Event
	CipGsrDoEvent(pW);
}
//==============================================================================================================//
//	Xebvg[X ϐl\																					//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
VO			CipStepShowVariable	(HAJCCIP pW)
{
	HAJCVMGA		hVmg  = NULL;			//	VMGnh
	PCAJCVMGNODEA	pNode = NULL;			//	ϐm[h
	UI				nMaxArr;				//	z̍ő\
	BC				DlgTxt[MAX_TXTLEN];		//	ϐQi_CAOwlj

	do {
		if (pW->hStepBack == NULL		)	break;		//	Xebvg[XECh
		if (!pW->fStepTrace				)	break;		//	Xebvg[X֎~

		//	Fݒ
		AjcVthPutTextA(pW->hStepVth, "\x1B[34m", -1);
		//	_CAOݒe擾
		nMaxArr = AjcGetDlgItemUInt(pW->hStepDlg, IDC_TXT_ARRMAX);
		AjcGetDlgItemStrA(pW->hStepDlg, IDC_TXT_CHASE, DlgTxt, MAX_TXTLEN);
		AjcStrTrimA(DlgTxt, DlgTxt, MAX_TXTLEN);
		//	ϐQ\
		AjcVthPutTextA(pW->hStepVth, "\n", -1);
		CipGsrShowVariableValue(pW, pW->hStepVth, DlgTxt, nMaxArr);
		//	F
		AjcVthPutTextA(pW->hStepVth, "\x1B[0m", -1);
		//	Windows Event
		CipGsrDoEvent(pW);
	} while(0);
}
//==============================================================================================================//
//	sJn/f/~ʒm																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//				fForced		- ftO																	//
//																												//
//	߂l	F	TRUE  - Xebvg[XECh I[v														//
//				FALSE - Xebvg[XECh N[Y														//
//==============================================================================================================//
VO		CipStepNtcExec(HAJCCIP pW, BOOL fForced)
{
	//	Xebvg[XECh I[v
	if (pW->hStepBack != NULL) {
		//	ftOݒ
		if (pW->fExec && (fForced || ChkBreakLno(pW))) {	//	s  f^u[NsH
			pW->fStepPause = TRUE;							//		ftOݒ
		}

		//	sԂɂ\ؑ
		ShowByExecState(pW);

		//	fԂȂ΁A~
		if (pW->fStepPause) {
			AjcVthPrintFA(pW->hStepVth, "\n\x1B[31m");
			AjcVthPrintFA(pW->hStepVth, "+ PAUSE / BREAK, Line = %d\n", pW->pCur->lno);
			AjcVthPrintFA(pW->hStepVth, "\n\x1B[0m");
			while (pW->fStepPause && !pW->fRunStop) {
				Sleep(1);
				CipGsrDoEvent(pW);
			}
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	u[Ns`FbN																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL		ChkBreakLno(HAJCCIP pW)
{
	BOOL	rc = FALSE;
	UI		lno;
	BCP		p;
	BC		txt[MAX_TXTLEN];

	if (pW->SvBrkLno != pW->pCur->lno) {								//	OƈقȂsԍH
		pW->SvBrkLno  = pW->pCur->lno;									//		sԍޔ
		if (AjcGetDlgItemChk(pW->hStepDlg, IDC_CHK_SETBRK)) {			//		u[N|CgݒLH
			AjcGetDlgItemStrA(pW->hStepDlg, IDC_TXT_BRKLNO,				//			_CAOݒsԍQeLXg擾
												txt, MAX_TXTLEN);		//			E
			//	sԍ`FbN
			p = txt;
			while (*p != 0) {											//			eLXgI[܂Ń[v
				while (MAjcIsBlankA(*p)) p++;							//				󔒃XLbv
				if (_ismbcdigit(*p)) {									//				H
					lno = atoi(p);										//					wsԍݒ
					if (lno == pW->pCur->lno) {							//					݂̍sԍƈvH
						rc = TRUE;										//						߂lݒ
						break;											//						I
					}
					else {												//					݂̍sԍƕsvH
						while (*p != ',' && *p != 0) p++;				//						J}̎܂ŃXLbv
						if (*p == ',') p++;								//						E
					}
				}
				else {													//				ȊOH
					while (*p != ',' && *p != 0) p++;					//					J}̎܂ŃXLbv
					if (*p == ',') p++;									//					E
				}
			}
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	sԂɂ\ؑ																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	ShowByExecState(HAJCCIP pW)
{
	if (pW->hStepBack != NULL) {
		if (pW->fStepSvExec != pW->fExec || pW->fStepSvPause != pW->fStepPause) {
			//	s
			if (pW->fExec) {							//	}NsH
				if (pW->fStepPause) {					//		fԁH
					ShowOnPause(pW);					//			ꎞ~̕\
				}
				else {									//		sH
					ShowOnExec(pW);						//			s̕\
				}
			}
			//	s~
			else {										//	}NsH
				ShowNotExec(pW);						//		s̕\
			}
			pW->fStepSvExec  = pW->fExec;
			pW->fStepSvPause = pW->fStepPause;
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	s̕\																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowOnExec(HAJCCIP pW)
{
	AjcEnableDlgGroup(pW->hStepDlg, IDC_GRP_CHASE, FALSE, FALSE);
	AjcEnableDlgGroup(pW->hStepDlg, IDC_GRP_BREAK, FALSE, FALSE);
	AjcEnableDlgGroup(pW->hStepDlg, IDC_GRP_BTN  , TRUE , FALSE);
	AjcEnableDlgItem (pW->hStepDlg, IDC_CMD_PAUSE, TRUE);
	AjcEnableDlgItem (pW->hStepDlg, IDC_CMD_STOP , TRUE);
	AjcVthSetTitleTextA(pW->hStepVth, LNGSEL(" s ", " Running "), -1, -1, NULL);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	ꎞ~̕\																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowOnPause(HAJCCIP pW)
{
	AjcEnableDlgGroup(pW->hStepDlg, IDC_GRP_CHASE, TRUE , TRUE );
	AjcEnableDlgGroup(pW->hStepDlg, IDC_GRP_BREAK, TRUE , TRUE );
	AjcEnableDlgGroup(pW->hStepDlg, IDC_GRP_BTN  , TRUE , TRUE );
	AjcEnableDlgItem (pW->hStepDlg, IDC_CMD_PAUSE, FALSE);
	AjcVthSetTitleTextA(pW->hStepVth, LNGSEL(" ꎞ~ ", " Pause "), -1, -1, NULL);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	~̕\																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowNotExec(HAJCCIP pW)
{
	AjcEnableDlgGroup(pW->hStepDlg, IDC_GRP_CHASE, TRUE , TRUE );
	AjcEnableDlgGroup(pW->hStepDlg, IDC_GRP_BREAK, TRUE , TRUE );
	AjcEnableDlgGroup(pW->hStepDlg, IDC_GRP_BTN  , FALSE, FALSE);
	AjcVthSetTitleTextA(pW->hStepVth, LNGSEL(" ~ ", " Stopped "), -1, -1, NULL);
}
//==============================================================================================================//
//	Xebvg[XECh																				//
//																												//
//	@	F	pCall		- ֐Ăяo																	//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
#define		IDC_VTH_STEP			5010				//	usgRg[hc
//--------------------------------------------------------------------------------------------------------------//
BOOL	CipStepCreateWindow(HAJCCIP pW)
{
	BOOL		rc = TRUE;

	do {

		//	g[XpobNECh
		if (pW->hStepBack == NULL) {
			//	}Ns̓EChI[vłȂ
			if (pW->fExec) {
				if (!pW->fStepMsgBoxBusy) {
					 pW->fStepMsgBoxBusy = TRUE;
					 AjcBell();
					 CipGerMessageBoxOK(pW, pW->hWndVth,
									LNGSEL("}NśAXebvg[XEChI[vł܂B",
									"Can not be opened 'StepTraceWindow' during macro-execution."), AppNameA);
					 pW->fStepMsgBoxBusy = FALSE;
					 break;
				}
			}
			//	ECh
			pW->hStepBack = CreateWindowA("CAjaMacroStepTrace",								// window class name
										 LNGSEL("Xebvg[X", "Step trace window"),	// window caption
										 WS_OVERLAPPEDWINDOW,								// window style
										 0,													// initial x position
										 0,													// initial y position
										 500,												// initial x size
										 300,												// initial y size
										 NULL,												// parent window handle
										 NULL,												// window menu handle
										 hDllInst,											// program instance handle
										 pW);												// creation parameters
			if (pW->hStepBack == NULL) {
				rc = FALSE;
				break;
			}
			//	ECh\
			ShowWindow(pW->hStepBack, SW_SHOWNORMAL);
		}
		else {
			ShowWindow(pW->hStepBack, SW_SHOWNORMAL);
			SetFocus  (pW->hStepBack);
		}
	} while(0);

	CipGsrDoEvent(pW);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Xebvg[X obNEChvV[W																	//
//																												//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(StepBack, WM_CREATE		)
{
	BOOL			rc = -1;
	LPCREATESTRUCT	p  = (LPCREATESTRUCT)lParam;
	HAJCCIP			pW = (HAJCCIP)p->lpCreateParams;
	RECT			r;
	int				cx, cy;
	BC				txt[512];

	do {
		//	EChEGNXg̈փ[N|C^ݒ
		MAjcSetWindowLong(hwnd, 0, (UX)pW);
		//	EChnhݒ
		pW->hStepBack = hwnd;
		//	VT-100G~[VERg[
		AjcGetCtrlStrA(pW->hWndBack, txt, sizeof txt);
		strcat(txt, ", ML=20000, 6=0x00E0E0E0");
		pW->hStepVth = CreateWindowExA(0,											// extend style
									 "AjcCtrlVT100",								// window class name
									 txt,											// caption
									 WS_CHILD | AJCVTHS_LFCTRL,						// style
									 0,												// initial x position
									 0,												// initial y position
									 0,												// initial x size
									 0,												// initial y size
									 hwnd,											// parent window handle
									 (HMENU)IDC_VTH_STEP,							// window menu handle
									 hDllInst,										// program instance handle
									 NULL);											// creation parameters
		if (pW->hStepVth == NULL) {
			break;
		}
		ShowWindow(pW->hStepVth, SW_SHOW);

		//	ACRݒ
		SendMessage(hwnd, WM_SETICON, ICON_SMALL, (LPARAM)hIcoApp);

		//	_CAO
		pW->hStepDlg = CreateDialogParam(hDllInst, MAKEINTRESOURCE(IDD_CIPSTEP), pW->hStepBack, AJC_DLGPROC_NAME(StepDlg), (LPARAM)pW);
		if (pW->hStepDlg == NULL) {
			DestroyWindow(pW->hStepVth);
			pW->hStepVth = NULL;
			break;
		}
		ShowWindow(pW->hStepDlg, SW_SHOW);
		//	EChŏTCYݒ
		r.left = r.top = 0;
		r.right  = pW->szStepDlgB.cx;
		r.bottom = pW->szStepDlgB.cy + 100;
		AdjustWindowRect(&r, WS_OVERLAPPEDWINDOW, FALSE);
		pW->szStepWnd.cx = r.right - r.left;
		pW->szStepWnd.cy = r.bottom - r.top;
		//	EChTCY[h
		AjcLoadWndRectA(hwnd, CIP_STEP_SECT);
		//	EChŏTCYm
		GetWindowRect(hwnd, &r);
		cx = r.right - r.left;
		cy = r.bottom - r.top;
		if (cx < pW->szStepWnd.cx || cy < pW->szStepWnd.cy) {
			cx = __max(cx, pW->szStepWnd.cx);
			cy = __max(cy, pW->szStepWnd.cy);
			SetWindowPos(pW->hStepBack, NULL, 0, 0, cx, cy, SWP_NOMOVE);
		}
		//	usgݒ񃍁[h
		AjcVthLoadPropA(pW->hStepVth, MYSECT, NULL);
		//	߂lnj
		rc = 0;

	} while(0);

	return rc;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_WNDPROC(StepBack, WM_DESTROY	)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);

	//	EChTCYZ[u
	AjcSaveWndRectA(hwnd, CIP_STEP_SECT);
	//	usgݒZ[u
	AjcVthSavePropA(pW->hStepVth, MYSECT);

	//	qEChN[Y
	if (pW->hStepVth != NULL) {DestroyWindow(pW->hStepVth); pW->hStepVth = NULL;}
	if (pW->hStepDlg != NULL) {DestroyWindow(pW->hStepDlg); pW->hStepDlg = NULL;}
	pW->hStepBack = NULL;

	return 0;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_WNDPROC(StepBack, WM_CLOSE		)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);

	//	}Ns̓EChN[YłȂ
	if (pW->fExec) {
		if (!pW->fStepMsgBoxBusy) {
			 pW->fStepMsgBoxBusy = TRUE;
			 AjcBell();
			 CipGerMessageBoxOK(pW, pW->hStepVth,
							LNGSEL("}NśAXebvg[XEChN[Ył܂B",
							"Can not be opened 'StepTraceWindow' during macro-execution."), AppNameA);
			 pW->fStepMsgBoxBusy = FALSE;
		}
	}
	//	}NsȂ΁AEChN[Y
	else {
		DestroyWindow(hwnd);
	}
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(StepBack, WM_SIZING		)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	LPRECT		p = (LPRECT)lParam;
	int			w = p->right - p->left;
	int			h = p->bottom - p->top;

	if (w < pW->szStepWnd.cx) p->right	= p->left + (pW->szStepWnd.cx);
	if (h < pW->szStepWnd.cy) p->bottom = p->top  + (pW->szStepWnd.cy);

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(StepBack, WM_SIZE		)
{
	HAJCCIP		pW = (HAJCCIP)MAjcGetWindowLong(hwnd, 0);
	int			cx = LOWORD(lParam);
	int			cy = HIWORD(lParam);
	int			dcy = AjcGetDlgItemChk(pW->hStepDlg, IDC_CHK_SETBRK) ? pW->szStepDlgB.cy : pW->szStepDlgA.cy;

	//	_CAOEChݒ
	MoveWindow(pW->hStepDlg, 0, 0  , cx,	  dcy, TRUE);
	//	VTHEChTCYݒ
	MoveWindow(pW->hStepVth, 0, dcy, cx, cy - dcy, TRUE);

	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(StepBack)
	AJC_WNDMAP_MSG(StepBack, WM_CREATE		)
	AJC_WNDMAP_MSG(StepBack, WM_DESTROY		)
	AJC_WNDMAP_MSG(StepBack, WM_CLOSE		)
	AJC_WNDMAP_MSG(StepBack, WM_SIZING		)
	AJC_WNDMAP_MSG(StepBack, WM_SIZE		)
AJC_WNDMAP_END

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Xebvg[X _CAOvV[W																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
#define		DLGPROP		"StepDlg"
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(StepDlg, WM_INITDIALOG 	)
{
	HAJCCIP		pW = (HAJCCIP)lParam;
	RECT		r1, r2;

	pW->hStepDlg = hDlg;
	SetPropA(hDlg, DLGPROP, (HANDLE)pW);

	//	peLXg
	SetWindowTextA(pW->hWndBack, LNGSEL("XebvEg[X", "Step trace"));
	AjcSetDlgItemStrA(hDlg, IDC_GRP_CHASE, LNGSEL("ϐ̒ǐ i w莞́AJ}( , )ŋ؂ j",
												  "Chase of the variable (Separate by comma(,) when specifying many variables)"	));
	AjcSetDlgItemStrA(hDlg, IDC_LBL_ARRMAX	, LNGSEL("z̍ő\ڐ"			, "Max. display number of array items"		));
	AjcSetDlgItemStrA(hDlg, IDC_CHK_ENASTEP	, LNGSEL("Xebvg[X"			, "Enable step trace"						));
	AjcSetDlgItemStrA(hDlg, IDC_CHK_SETBRK	, LNGSEL("u[N|Cgݒ肷"	, "Set break point"							));
	AjcSetDlgItemStrA(hDlg, IDC_GRP_BREAK	, LNGSEL("u[N|Cg iu[NsԍwCw莞̓J}( , ) ŋ؂j",
													 "Break point( line number to break. Separate by comma(,) when specifying many lines)"));
	AjcSetDlgItemStrA(hDlg, IDC_LBL_BRKLNO	, LNGSEL("sԍ"						, "Lines"									));

	//	{^փACR\
	SendDlgItemMessage(hDlg, IDC_CMD_RUN  , BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcoRun  );
	SendDlgItemMessage(hDlg, IDC_CMD_PAUSE, BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcoPause);
	SendDlgItemMessage(hDlg, IDC_CMD_STOP , BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcoEnd  );
	SendDlgItemMessage(hDlg, IDC_CMD_STEP , BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcoStep );

	//	eLXgiS511oCgj
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_CHASE , MAX_TXTLEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_STEP  , MAX_TXTLEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_BRKLNO, MAX_TXTLEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SETVAL, MAX_TXTLEN - 1);

	//	_CAÕTCYݒ
	GetWindowRect(hDlg, &r1);
	GetWindowRect(GetDlgItem(hDlg, IDC_GRP_BREAK), &r2);
	pW->szStepDlgA.cx = r1.right - r1.left;
	pW->szStepDlgA.cy = r2.top - r1.top;
	pW->szStepDlgB.cx = r1.right - r1.left;
	pW->szStepDlgB.cy = r1.bottom - r1.top;

	//	_CAOڊ֘At
	MAjcSetDlgPropStrA(hDlg, IDC_TXT_CHASE	, ""		  , NULL, 0);
	MAjcSetDlgPropUInt(hDlg, IDC_TXT_ARRMAX , 10   , FALSE, NULL);
	MAjcSetDlgPropUInt(hDlg, IDC_TXT_STEP	, 1    , FALSE, NULL);
	MAjcSetDlgPropChk (hDlg, IDC_CHK_SETBRK	, FALSE 	  , NULL);
	MAjcSetDlgPropStrA(hDlg, IDC_TXT_BRKLNO	 , ""		  , NULL, 0);

	//	_CAOݒ荀ڃ[h
	AjcLoadDlgProfilesA(hDlg, MYSECT);

	//	Xebvg[XtOi`FbN{bNXjݒ
	AjcSetDlgItemChk(hDlg, IDC_CHK_ENASTEP, pW->fStepTrace);

	//	c[`bvERg[
	pW->hStepTtp = CreateWindowEx(WS_EX_TOPMOST,
									TOOLTIPS_CLASS,
									NULL,
									TTS_ALWAYSTIP,
									CW_USEDEFAULT,
									CW_USEDEFAULT,
									CW_USEDEFAULT,
									CW_USEDEFAULT,
									hDlg, NULL,
									hDllInst, NULL);
	//	c[`bvǉ
	{	TOOLINFOA	ti;
		memset(&ti, 0, sizeof ti);
		ti.cbSize	= sizeof(TOOLINFO);
		ti.hwnd		= hDlg;
		ti.hinst	= hDllInst;
		ti.uFlags	= TTF_IDISHWND | TTF_SUBCLASS;

		ti.lpszText = LNGSEL("ǐՂϐQ", "variables to chase");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_CHASE );	SendMessage(pW->hStepTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL("sp", "Continuing execution");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_CMD_RUN	);	SendMessage(pW->hStepTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL("ꎞ~", "Pause");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_CMD_PAUSE	);	SendMessage(pW->hStepTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL("~", "Stop");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_CMD_STOP	);	SendMessage(pW->hStepTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL("Xebvs", "Step execution");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_CMD_STEP	);	SendMessage(pW->hStepTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL("sXebv", "Execution steps");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_STEP	);	SendMessage(pW->hStepTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);

		ti.lpszText = LNGSEL("u[NsԍQ", "Break line numbers");
		ti.uId = (UX)GetDlgItem(hDlg, IDC_TXT_BRKLNO);	SendMessage(pW->hStepTtp, TTM_ADDTOOL, 0, (LPARAM)&ti);
	}

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(StepDlg, WM_DESTROY		)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);

	//	fԉ
	pW->fStepPause = FALSE;
	//	_CAOݒlޔ
	AjcSaveDlgProfilesA(hDlg, MYSECT);
	AjcReleaseDlgProps(hDlg);
	//	c[`bvj
	if (pW->hStepTtp != NULL) {DestroyWindow(pW->hStepTtp); pW->hStepTtp = NULL;}
	//	vpeBj
	RemovePropA(hDlg, DLGPROP);

	return TRUE;
}
//----- LZ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(StepDlg, IDCANCEL			)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);

	DestroyWindow(hDlg);
	return TRUE;
}
//----- s{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(StepDlg, IDC_CMD_RUN		)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);

	if (HIWORD(wParam) == BN_CLICKED) {
		//	fԉ
		pW->fStepPause = FALSE;
	}
	return TRUE;
}
//----- ꎞ~{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(StepDlg, IDC_CMD_PAUSE		)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);

	if (HIWORD(wParam) == BN_CLICKED) {
		//	fԐݒ
		pW->fExePause = TRUE;
	}
	return TRUE;
}
//----- ~{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(StepDlg, IDC_CMD_STOP		)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);

	if (HIWORD(wParam) == BN_CLICKED) {
		//	s~
		pW->fRunStop = TRUE;
	}
	return TRUE;
}
//----- Xebvs{^ -------------------------------------------------------------------------------------//
AJC_DLGPROC(StepDlg, IDC_CMD_STEP		)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);

	if (HIWORD(wParam) == BN_CLICKED) {
		//	Xebvݒ
		pW->nStepCount = AjcGetDlgItemUInt(pW->hStepDlg, IDC_TXT_STEP);
		//	fԐݒ
		pW->fStepPause = FALSE;
	}
	return TRUE;
}
//----- `FbN{bNXiXebvg[Xj----------------------------------------------------------------//
AJC_DLGPROC(StepDlg, IDC_CHK_ENASTEP	)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);

	if (HIWORD(wParam) == BN_CLICKED) {
		pW->fStepTrace = AjcGetDlgItemChk(hDlg, IDC_CHK_ENASTEP);
	}
	return TRUE;
}
//----- `FbN{bNXiu[N|Cgݒ肷j----------------------------------------------------------//
AJC_DLGPROC(StepDlg, IDC_CHK_SETBRK		)
{
	HAJCCIP		pW = (HAJCCIP)GetPropA(hDlg, DLGPROP);
	RECT		r;
	int			cx, cy;

	if (HIWORD(wParam) == BN_CLICKED) {
		GetClientRect(pW->hStepBack, &r);
		cx = r.right - r.left;
		cy = r.bottom - r.top;
		SendMessage(pW->hStepBack, WM_SIZE, SIZE_RESTORED, MAKELONG(cx, cy));
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(StepDlg)
	AJC_DLGMAP_MSG(StepDlg, WM_INITDIALOG	)
	AJC_DLGMAP_MSG(StepDlg, WM_DESTROY		)

	AJC_DLGMAP_CMD(StepDlg, IDCANCEL		)
	AJC_DLGMAP_CMD(StepDlg, IDC_CMD_RUN		)
	AJC_DLGMAP_CMD(StepDlg, IDC_CMD_PAUSE	)
	AJC_DLGMAP_CMD(StepDlg, IDC_CMD_STOP	)
	AJC_DLGMAP_CMD(StepDlg, IDC_CMD_STEP	)
	AJC_DLGMAP_CMD(StepDlg, IDC_CHK_ENASTEP	)
	AJC_DLGMAP_CMD(StepDlg, IDC_CHK_SETBRK	)
AJC_DLGMAP_END
