//**************************************************************************************************************//
//																												//
//	JX^Rg[iRcOtBbNj	ʒ`														//
//																												//
//**************************************************************************************************************//

#define	G3D_ELPSPOINTS		60

#define	G3D_FLT_WIDTH		16				//	tB^`FbN{bNX̕
#define	G3D_FLT_HEIGHT		16				//		  V				̍

#define	G3D_IDC_BTN_WIDE	4001			//	Ch{^hc
#define	G3D_IDC_BTN_ZOOM	4002			//	Y[{^hc
#define	G3D_IDC_CHK_BASE	4100			//	`FbN{bNXhc

#define	G3D_BTN_WIDTH		20				//	{^TCY
#define	G3D_BTN_HEIGHT		23				//	{^cTCY
#define	G3D_BTN_MRG			3

#define	G3D_SPHERE_SCALE_SLICE	16			//	̃XP[̐
#define	G3D_SPHERE_SCALE_STACK	16			//	̃XP[̐
#define	G3D_SPHERE_PTBUF	(G3D_ELPSPOINTS * 2)

#define	G3D_INST_ID			0xF15D8BE2

//--------------------------------------------------------------------------------------------------------------//
//	`																									//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	GIC_POINT		= 1	,
	GIC_LINE			,
	GIC_TRIAN			,
	GIC_SQUA			,
	GIC_ELPS			,
	GIC_FILL			,
} GICODE;
//----- `wb_ -----------------------------------------------------------------------------------------//
typedef struct {
	UW		gic;	//	`
	UW		id;		//	f[^ڔԍ(0 ` 15)
	UI		seq;	//	`揇
} GIHEAD, *PGIHEAD;
typedef  const GIHEAD *PCGIHEAD;
//----- |Cg -------------------------------------------------------------------------------------------//
typedef struct {
	AJC3DVEC	v3;
	POINT		v2;
} GI_VEC, *PGI_VEC;
typedef const GI_VEC *PCGI_VEC;

//----- _ -----------------------------------------------------------------------------------------------------//
typedef struct {
	GIHEAD		h;
	GI_VEC		p;
	UI			siz;
} GI_POINT, *PGI_POINT;
typedef const GI_POINT *PCGI_POINT;
//-----  -----------------------------------------------------------------------------------------------------//
typedef struct {
	GIHEAD		h;
	GI_VEC		p1, p2;
	BOOL		fArrow;
} GI_LINE, *PGI_LINE;
typedef const GI_LINE *PCGI_LINE;
//----- Op` -------------------------------------------------------------------------------------------------//
typedef struct {
	GIHEAD		h;
	GI_VEC		p1, p2, p3;
} GI_TRIAN, *PGI_TRIAN;
typedef const GI_TRIAN *PCGI_TRIAN;
//----- lp` -------------------------------------------------------------------------------------------------//
typedef struct {
	GIHEAD		h;
	GI_VEC		p1, p2, p3, p4;
} GI_SQUA, *PGI_SQUA;
typedef const GI_SQUA *PCGI_SQUA;
//----- ~ -----------------------------------------------------------------------------------------------------//
typedef struct {
	GIHEAD		h;
	GI_VEC		p[G3D_ELPSPOINTS];
	UI			siz;
} GI_ELPS, *PGI_ELPS;
typedef const GI_ELPS *PCGI_ELPS;
//----- hԂ ---------------------------------------------------------------------------------------------//
typedef struct {
	GIHEAD		h;
	UI			idBorder;		// EFi-1FSurfaceC-1FBorderj
	GI_VEC		p;
} GI_FILL, *PGI_FILL;
typedef const GI_FILL *PCGI_FILL;
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	GIHEAD		h;
	GI_POINT	poi;
	GI_LINE		line;
	GI_TRIAN	tri;
	GI_SQUA		squa;
	GI_ELPS		elps;
	GI_FILL		fill;
} GI_INFO, *PGI_INFO, **PPGI_INFO;
typedef const GI_INFO *PCGI_INFO;
//--------------------------------------------------------------------------------------------------------------//
//	C`p|Cg																					//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	UI			ix;					//	z̃CfNXi= Lzf[^j
	UI			nArr;				//	őzvfimۂzvfj
	HPEN		*pPen;				//	`FyIuWFNgEzւ̃|C^
	POINT		*pPt;				//	`_zւ̃|C^
} POLYINFO, *PPOLYINFO;
typedef const POLYINFO *PCPOLYINFO;
//--------------------------------------------------------------------------------------------------------------//
//	vbg																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	UI			ix;					//	vbgf[^CfNXi0 ` Item[n].MaxPlot - 1)
	UI			cnt;				//	vbgf[^		i0 ` Item[n].MaxPlot	  )
	PGI_VEC		pBuf;				//	vbgf[^zւ̃|C^
} PLOTINFO, *PPLOTINFO;
typedef const PLOTINFO *PCPLOTINFO;

//--------------------------------------------------------------------------------------------------------------//
//	XP[																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	double	min, max;				//	XP[Jn_ƏI_
	double	step;					//	XP[`Xebv
	UI		digit, prec;			//	Ə̌
} SCALEINFO, *PSCALEINFO;
typedef const SCALEINFO *PCSCALEINFO;
//--------------------------------------------------------------------------------------------------------------//
//	`F																									//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	COLORREF	RgbP , RgbN;		//	`F
	HBRUSH		hBruP, hBruN;		//	`uVnh
	HPEN		hPenP, hPenN;		//	`ynh
	GI_VEC		gv;					//	C`pړ_ޔobt@
	double		t;					//	_Ɠ_̊Jpxi_Opxj
} RGBINFO, *PRGBINFO;
typedef const RGBINFO *PCRGBINFO;

//--------------------------------------------------------------------------------------------------------------//
//	ACe																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	RGBINFO		RgbInfo;			//	`F
	HAJCVQUE	hQueDat;			//	`f[^L[
	PLOTINFO	plot;				//	vbg
	AJC3DLVEC	PlnLVec;			//	ʒ`iSʒuƖ@j
	AJC3DVEC	PlnOrg;				//	ʒ`ixNgiwƂȂxNgjj
} DATA_ITEM, *PDATA_ITEM;
typedef const DATA_ITEM *PCDATA_ITEM;
//--------------------------------------------------------------------------------------------------------------//
//	`																									//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	UI			MyIx;				//	CfNXiOFwCPFxCQFyj
	double		Cent;				//	Sʒu
	double		r;					//	a
	RGBINFO		RgbInfo;			//	`F
	GI_VEC		s, e;				//	`͈
	SCALEINFO	Sif;				//	XP[O
} AXIS_INF, *PAXIS_INF;
typedef const AXIS_INF *PCAXIS_INF;
//--------------------------------------------------------------------------------------------------------------//
//	hbO																								//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	DRAGMD_STOP	= 0	,				//	hbO
	DRAGMD_XY		,				//	w^x]hbO
	DRAGMD_Z		,				//	y]hbO
} DRAGMODE;

//--------------------------------------------------------------------------------------------------------------//
//	ʉ]pxe[u																						//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	union {
		struct {SW x, y, z;} s;
		ULL					 ull;
	} u;
	AJCG3DAXIS_DIR	xDir;		//	ʂw̎
	AJCG3DAXIS_DIR	yDir;		//	ʂx̎
} ROTPLANE, *PROTPLANE;
typedef const ROTPLANE *PCROTPLANE;

#define	MAX_ROTPLANE	343

extern	const ROTPLANE	G3dRotPlane[MAX_ROTPLANE];

extern PCROTPLANE	G3dRpSearchTheta(int rx, int ry, int rz);						//	e[ủ]px
extern PCROTPLANE	G3dRpSearchAngle(AJCG3DAXIS_DIR xDir, AJCG3DAXIS_DIR yDir);		//	e[ũAOiŏɌ́j

//--------------------------------------------------------------------------------------------------------------//
//	eLXg``ukm[h																					//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	BOOL		fPix;				//	\ʒusNZʒutO
	AJCG3DTXOMD	md;					//	RcWw莞̃eLXg`@
	union {
		AJC3DVEC	v;				//	`ʒu
		POINT		pt;
	} u;
	WC			txt[1];				//	`eLXg
} G3DTXO, *PG3DTXO;

//--------------------------------------------------------------------------------------------------------------//
//	ECh[N																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	UI			InstID;							//	CX^Xʂhc
	HWND		hMain;							//	CEChnhiOtBbN`EChj
	HWND		hFilter;						//	tB^EChnh
	HWND		hChkFilt[AJC3DG_MAXITEM];		//	tB^E`FbN{bNX
	UI			style;							//	EChX^C
	BOOL		fEnable;						//	Rg[̗L
	UI			ww, wh;							//	ECh̕ƍ
	COLORREF	RgbBorder;						//	{[_[F
	HPEN		hPenBorder;						//	{[_[`ynh
	HBITMAP		hBmpImg;						//	XN[rbg}bviS̕`pj
	HBITMAP		hBmpSca;						//	XN[rbg}bviXP[`pj
	HBITMAP		hBmpDat;						//	XN[rbg}bvif[^`pj
	BOOL		f2dMode;						//	QcOt[h
	BOOL		fFirstGetText;					//	ŏWM_GETTEXTtO
	UI			MskFilt;						//	tB^}XN
	AJC3DVEC	VSiten;							//	_ւ̃xNg
	AJC3DMAT	MatX, MatY, MatZ;				//	]sf[^
	AXIS_INF	AxisInfo[3];					//	`
	UI			DatSeq;							//	f[^`揇ԍ
	HAJCAVL		hAvlDat;						//	f[^`揇̕`m[h|C^
	DATA_ITEM	DatItem[AJC3DG_MAXITEM];		//	eACe
	//----- ʕ\̎蓖 -----------------------------------------------------------------------------//
	AJCG3DAXIS_DIR	PlaneAxisH;
	AJCG3DAXIS_DIR	PlaneAxisV;
	//----- XP[pqfa -------------------------------------------------------------------------------//
	RGBINFO		RgbScale;
	//----- XP[ĩXP[CXP[CCRj̍ĕ`tO ---------------------------------------//
	BOOL		fReDrawScale;
	//----- f[^̍ĕ`tO -------------------------------------------------------------------------------//
	BOOL		fReDrawData;
	//----- MoveTo / LineTo pRc|Cgobt@ -------------------------------------------------------------//
	AJC3DVEC	V3dMoveTo[AJC3DG_MAXITEM];
	AJC2DVEC	V2dMoveTo[AJC3DG_MAXITEM];
	//----- ̃XP[`p|Cgobt@ -----------------------------------------------------------------//
	POLYINFO	SphPolyInfo;					//	̃XP[EC`p |Cg
	HPEN		clSphBuf[G3D_SPHERE_PTBUF];		//	̃XP[EC`p `F(HPEN)obt@
	POINT		ptSphBuf[G3D_SPHERE_PTBUF];		//	̃XP[EC`p |Cgobt@
	//----- cb -----------------------------------------------------------------------------------------//
	HDC			mdc;							//	S̕`pcb
	HDC			sdc;							//	XP[`pcb
	HDC			ddc;							//	f[^`pcb
	//----- \~tO -------------------------------------------------------------------------------------//
	BOOL		fPause;							//	\~tO
	//----- XP[ ---------------------------------------------------------------------------------------//
	UI			SifCxChar, SifCyChar;			//	̕ƍ
	UI			SifCyUnit;						//	XP[l`Ԋu
	//----- hbO ---------------------------------------------------------------------------------------//
	DRAGMODE	DrgMode;						//	hbO
	POINT		DrgSrt, DrgEnd;					//	hbOJnCI_
	AJC3DVEC	DrgRot;							//	hbOJn̉]px
	//----- vpeB -----------------------------------------------------------------------------------------//
	AJC3DGPROP	prop;
	//----- ENbNʒm ---------------------------------------------------------------------------------//
	BOOL		fNtcRClk;						//	ENbNʒmtOiTRUE:ʒmCFALSE:ʒmȂj
	UI			MsgRBDown;						//	E{^_E̒ʒmbZ[WR[h
	UI			MsgRBUp;						//	E{^Abv̒ʒmbZ[WR[h
	//----- Ch^Y[{^ ---------------------------------------------------------------------------//
	BOOL		fShowBtn;						//	{^\
	HWND		hBtnWide;						//	Ch{^nh
	HWND		hBtnZoom;						//	Y[{^nh
	//----- c[`bv -----------------------------------------------------------------------------------//
	WCP			pToolTipTxt;						//	OtBbÑc[qgbZ[W
	WCP			pChkBoxTool[AJC3DG_MAXITEM];		//	`FbN{bNX̃c[qgbZ[W
	BOOL		fShowAlways;						//	OtBbÑc[qg\
	BOOL		fChkBoxShowAlways[AJC3DG_MAXITEM];	//	`FbN{bNX̃c[qg\
	//----- hbvt@Cꎞۗobt@ -------------------------------------------------------------//
	HAJCRNG		hRngFile;						//	Oobt@nh
	UB			StaRngFile[1024];				//	X^eBbNOobt@
	//----- hbvchqꎞۗobt@ ---------------------------------------------------------------//
	HAJCRNG		hRngDir;						//	Oobt@nh
	UB			StaRngDir[1024];				//	X^eBbNOobt@
	//----- ^Cg` -----------------------------------------------------------------------------//
	CTRL_TTLINFO TtlInfo;						//	^Cgrbg}bv
	//----- ʒm -------------------------------------------------------------------------------------------//
	AJC3DVEC			NtcRotTheta;			//	_xNg
	UI					NtcClrFact;				//	NA[e
	AJC3DGRCLK			NtcRClk;				//	ENbNʒm
	UI					NtcDirs;				//	hbvfBNg
	UI					NtcFiles;				//	hbvt@C
	AJC3DGPLOTLIST		PlotList;				//	vbgXg
	//----- `掞Ԍv -----------------------------------------------------------------------------------//
	BOOL				fMesDrawEnable;			//	`掞Ԍv|bvAbvj[̋^֎~
	HWND				hDlgMesDraw;			//	`掞Ԍv\_CAO
	HAJCMESTIME			hMesDraw;				//	`掞ԌvCX^X
	AJCMSTINFO			MesDraw;				//	`掞Ԍvf[^
	//----- eLXg` -----------------------------------------------------------------------------------//
	HFONT				hFontTxo;				//	eLXg`tHg
	HAJCTXO				hTxo;					//	eLXg`CX^X
	UI					kAvlTxo;				//	eLXg``ukL[
	HAJCAVL				hAvlTxo;				//	eLX``uk
} WRK3DGRAPH, *PWRK3DGRAPH;

//--------------------------------------------------------------------------------------------------------------//
//	O[oϐ																								//
//--------------------------------------------------------------------------------------------------------------//
extern	ATOM	G3dClassMain;
extern	ATOM	G3dClassFilter;
extern	ATOM	G3dClassForMSIL;
extern	HFONT	G3dhMyFont;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																									//
//--------------------------------------------------------------------------------------------------------------//
extern	WNDPROC		G3dWndProcMain();
extern	WNDPROC		G3dWndProcFilt();
extern	WNDPROC		G3dWndProcMSIL();

extern	HWND	G3dCreateDlgSetRange(PWRK3DGRAPH pW);
extern	HWND	G3dCreateDlgSetPlane(PWRK3DGRAPH pW);
extern	HWND	G3dCreateWndFilter	(PWRK3DGRAPH pW, WCP pClsName);

//----- AjcCtrlG3dSubFunc.c ------------------------------------------------------------------------------------//
extern	BOOL	G3dSetCtrlProp(PWRK3DGRAPH pW, PCAJC3DGPROP pNew);
extern	BOOL	G3dSetBorderColor(PWRK3DGRAPH pW, COLORREF color);
extern	VO		G3dCnvAllPoints(PWRK3DGRAPH pW);
extern	VO		G3dCnv3dTo2d(PWRK3DGRAPH pW, PCAJC3DVEC p3D, LPPOINT p2D);
extern	int		G3dCnvValToX(PWRK3DGRAPH pW, double cent, double r, double val, BOOL fRev);
extern	int		G3dCnvValToY(PWRK3DGRAPH pW, double cent, double r, double val, BOOL fRev);
extern	VO		G3dSetAngleXY(PWRK3DGRAPH pW);
extern	VO		G3dSetAngleXZ(PWRK3DGRAPH pW);
extern	VO		G3dSetAngleYZ(PWRK3DGRAPH pW);
extern	VO		G3dSetAngle3D(PWRK3DGRAPH pW);

extern	PCROTPLANE	G3dIsAnglePlane	(PWRK3DGRAPH pW);
extern	BOOL		G3dIsAngleXY	(PWRK3DGRAPH pW);
extern	BOOL		G3dIsAngleXZ	(PWRK3DGRAPH pW);
extern	BOOL		G3dIsAngleYZ	(PWRK3DGRAPH pW);
extern	BOOL		G3dIsAngle3D	(PWRK3DGRAPH pW);

extern	VO		G3dSetScaleInfo(PWRK3DGRAPH pW);
extern	VO		G3dPlanePointTo3dPoint(PWRK3DGRAPH pW, PCAJC2DVEC p2d, PCAJC3DLVEC pCent, PCAJC3DVEC pBase, PAJC3DVEC p3dBuf);
extern	VO		G3dSet3dMode(PWRK3DGRAPH pW);
extern	VO		G3dSet2dMode(PWRK3DGRAPH pW);

//----- AjcCtrlG3dDrawImage.c ----------------------------------------------------------------------------------//
extern	VO		G3dDrawImage(PWRK3DGRAPH pW);

extern	BOOL	G3dMakeMetaBall(HWND hwnd, PCAJC3DVEC pCent, double rx, double ry, double rz, UI slice, UI stack,
									 UX cbp, BOOL (*cb)(PWRK3DGRAPH pW, PGI_ELPS pElps, UX cbp));
extern	VO		G3dMakeEllipseData(PWRK3DGRAPH pW, PCAJC2DVEC p2d, double rx, double ry,
															 PCAJC3DLVEC pCent, PCAJC3DVEC pBase, PGI_ELPS pBuf);

//----- AjcCtrlG3dDrawText.c -----------------------------------------------------------------------------------//
extern	VO		G3dDrawText(PWRK3DGRAPH pW);

