#include	"AjcInternal.h"
#include	"AjcCtrlListBoxDef.h"
//**************************************************************************************************************//
//																												//
//	JX^Rg[iXg{bNXj					`oh												//
//																												//
//**************************************************************************************************************//

#define	IS_MY_INST(P)	(P != NULL && P->InstID == LBX_INST_ID)

//--------------------------------------------------------------------------------------------------------------//
//	O[o[N																							//
//--------------------------------------------------------------------------------------------------------------//
ATOM	LbxClassBack	= 0;
ATOM	LbxClassMain	= 0;

//==============================================================================================================//
//	Nݒ																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
BOOL	AjcCtrlListBoxInit(VO)
{
	BOOL		rc = FALSE;
	WNDCLASS	wndclass;

	do {
		//----- obNEChNX --------------------------//
		wndclass.style			= CS_GLOBALCLASS;
		wndclass.lpfnWndProc	= LbxWndProcBack();
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= sizeof(PWRKLISTBOX);
		wndclass.hInstance		= hDllInst;
		wndclass.hIcon			= NULL;
		wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground	= hBruBtnFace;
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= L"AjcCtrlListBox";
		if ((LbxClassBack = RegisterClass(&wndclass)) == 0) break;

		rc = TRUE;
	} while(0);

	if (rc == FALSE) {
		AjcCtrlListBoxEnd();
	}

	return rc;
}
//==============================================================================================================//
//	I㏈																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
VO		AjcCtrlListBoxEnd (VO)
{
	if (LbxClassBack	!= 0) {UnregisterClass((WCP)LbxClassBack   , hDllInst); LbxClassBack	= 0;}
	if (LbxClassMain	!= 0) {UnregisterClass((WCP)LbxClassMain   , hDllInst); LbxClassMain	= 0;}
}

//==============================================================================================================//
//	SXg{bNXڂ̎擾																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pCount		 - SXg{bNXڐi[obt@̃AhXisvNULL)				//
//																												//
//	߂l	F	NULLFSXg{bNXڂ̔z̐擪AhX												//
//				NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT PAJCLBXITEMA	WINAPI	AjcLbxGetAllItemsA	(HWND hwnd, UIP pCount)
{
	PWRKLISTBOX		pW;
	PAJCLBXITEMA	rc = NULL;
	PAJCLBXITEMA	pTbl;
	int				n, i, stl;
	int				cnt = 0;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		n = (int)SendMessageA(pW->hLbx, LB_GETCOUNT, 0, 0);
		if (rc = (PAJCLBXITEMA)AJCMEM(sizeof(AJCLBXITEMA) * (n + 1))) {
			pTbl = rc;
			for (i = 0; i < n; i++) {
				if ((stl = (int)SendMessageA(pW->hLbx, LB_GETTEXTLEN, i, 0)) >= 0) {
					if (pTbl->pStr = AjcTAllocA(stl + 1)) {
						SendMessageA(pW->hLbx, LB_GETTEXT, i, (LPARAM)pTbl->pStr);
						pTbl->data = (UX)SendMessageA(pW->hLbx, LB_GETITEMDATA, i, 0);
						cnt++;
						pTbl++;
					}
				}
			}
			pTbl->pStr = NULL;
			pTbl->data = 0;
		}
	}
	if (pCount != NULL) *pCount = cnt;

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT PAJCLBXITEMW	WINAPI	AjcLbxGetAllItemsW	(HWND hwnd, UIP pCount)
{
	PWRKLISTBOX		pW;
	PAJCLBXITEMW	rc = NULL;
	PAJCLBXITEMW	pTbl;
	int				n, i, stl;
	int				cnt = 0;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		n = (int)SendMessage(pW->hLbx, LB_GETCOUNT, 0, 0);
		if (rc = (PAJCLBXITEMW)AJCMEM(sizeof(AJCLBXITEMW) * (n + 1))) {
			pTbl = rc;
			for (i = 0; i < n; i++) {
				if ((stl = (int)SendMessage(pW->hLbx, LB_GETTEXTLEN, i, 0)) >= 0) {
					if (pTbl->pStr = AjcTAlloc(stl + 1)) {
						SendMessage(pW->hLbx, LB_GETTEXT, i, (LPARAM)pTbl->pStr);
						pTbl->data = (UX)SendMessage(pW->hLbx, LB_GETITEMDATA, i, 0);
						cnt++;
						pTbl++;
					}
				}
			}
			pTbl->pStr = NULL;
			pTbl->data = 0;
		}
	}
	if (pCount != NULL) *pCount = cnt;

	return rc;
}
//==============================================================================================================//
//	擾SXg{bNXڂ̃																	//
//																												//
//	@	F	pAllItemBuf	 - SXg{bNXڂ̔z̃AhX												//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT VO			WINAPI	AjcLbxRelAllItems	(VOP pAllItemBuf)
{
	PAJCLBXITEMW	pTbl;

	if (pAllItemBuf != NULL) {
		pTbl = pAllItemBuf;
		while (pTbl->pStr != NULL) {
			free(pTbl->pStr);
			pTbl++;
		}
		free(pAllItemBuf);
	}
}

//==============================================================================================================//
//	IĂ郊Xg{bNXڂ̎擾																		//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pCount		 - IĂ郊Xg{bNXڐi[obt@̃AhXisvNULL)	//
//																												//
//	߂l	F	NULLFIĂ郊Xg{bNXڂ̔z̐擪AhX									//
//				NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT PAJCLBXITEMA	WINAPI	AjcLbxGetSelectedItemsA	(HWND hwnd, UIP pCount)
{
	PWRKLISTBOX		pW;
	PAJCLBXITEMA	rc = NULL;
	PAJCLBXITEMA	pTbl;
	int				n, i, stl;
	int				cnt = 0;
	int				selcnt;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if ((n = (int)SendMessageA(pW->hLbx, LB_GETCOUNT, 0, 0)) > 0) {
			//----- IڐJEg -----------------------------//
			selcnt = 0;
			for (i = 0; i < n; i++) {
				if (SendMessageA(pW->hLbx, LB_GETSEL, i, 0) > 0) {
					selcnt++;
				}
			}
			//----- ݒ ---------------------------------------//
			if (selcnt > 0) {
				if (rc = (PAJCLBXITEMA)AJCMEM(sizeof(AJCLBXITEMA) * (selcnt + 1))) {
					pTbl = rc;
					for (i = 0; i < n; i++) {
						if (SendMessageA(pW->hLbx, LB_GETSEL, i, 0) > 0) {
							if ((stl = (int)SendMessageA(pW->hLbx, LB_GETTEXTLEN, i, 0)) >= 0) {
								if (pTbl->pStr = AjcTAllocA(stl + 1)) {
									SendMessageA(pW->hLbx, LB_GETTEXT, i, (LPARAM)pTbl->pStr);
									pTbl->data = (UX)SendMessageA(pW->hLbx, LB_GETITEMDATA, i, 0);
									cnt++;
									pTbl++;
								}
							}
						}
					}
					pTbl->pStr = NULL;
					pTbl->data = 0;
				}
			}
		}
	}
	if (pCount != NULL) *pCount = cnt;

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT PAJCLBXITEMW	WINAPI	AjcLbxGetSelectedItemsW	(HWND hwnd, UIP pCount)
{
	PWRKLISTBOX		pW;
	PAJCLBXITEMW	rc = NULL;
	PAJCLBXITEMW	pTbl;
	int				n, i, stl;
	int				cnt = 0;
	int				selcnt;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if ((n = (int)SendMessage(pW->hLbx, LB_GETCOUNT, 0, 0)) > 0) {
			//----- IڐJEg -----------------------------//
			selcnt = 0;
			for (i = 0; i < n; i++) {
				if (SendMessage(pW->hLbx, LB_GETSEL, i, 0)) {
					selcnt++;
				}
			}
			//----- ݒ ---------------------------------------//
			if (selcnt > 0) {
				if (rc = (PAJCLBXITEMW)AJCMEM(sizeof(AJCLBXITEMA) * (selcnt + 1))) {
					pTbl = rc;
					for (i = 0; i < n; i++) {
						if (SendMessage(pW->hLbx, LB_GETSEL, i, 0)) {
							if ((stl = (int)SendMessage(pW->hLbx, LB_GETTEXTLEN, i, 0)) >= 0) {
								if (pTbl->pStr = AjcTAlloc(stl + 1)) {
									SendMessage(pW->hLbx, LB_GETTEXT, i, (LPARAM)pTbl->pStr);
									pTbl->data = (UX)SendMessage(pW->hLbx, LB_GETITEMDATA, i, 0);
									cnt++;
									pTbl++;
								}
							}
						}
					}
					pTbl->pStr = NULL;
					pTbl->data = 0;
				}
			}
		}
	}
	if (pCount != NULL) *pCount = cnt;

	return rc;
}
//==============================================================================================================//
//	擾IσXg{bNXڂ̃																//
//																												//
//	@	F	pSelectedItemBuf - IĂ郊Xg{bNXڂ̔z̃AhX								//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT VO			WINAPI	AjcLbxRelSelectedItems	(VOP pSelectedItemBuf)
{
	PAJCLBXITEMW	pTbl;

	if (pSelectedItemBuf != NULL) {
		pTbl = pSelectedItemBuf;
		while (pTbl->pStr != NULL) {
			free(pTbl->pStr);
			pTbl++;
		}
		free(pSelectedItemBuf);
	}
}
//==============================================================================================================//
//	ĩ[h																							//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pSect		 - vt@CZNV															//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxLoadPermInfoA  (HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmpSec = NULL;
	WCP		pTmpKey = NULL;

	do {
		if (pProfileSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
			if (len != 0 && (pTmpSec = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmpSec, len);
			}
			else break;
		}
		if (pKeyPrefix != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpKey = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpKey, len);
			}
			else break;
		}
		rc = AjcLbxLoadPermInfoW(hwnd, pTmpSec, pTmpKey);
	} while(0);

	if (pTmpSec != NULL) free(pTmpSec);
	if (pTmpKey != NULL) free(pTmpKey);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxLoadPermInfoW  (HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix)
{
	PWRKLISTBOX	pW;
	BOOL		rc	  = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		//	ZNVCL[ړޔ
		AjcLbxSetPermAttW(hwnd, pProfileSect, pKeyPrefix);
		//	SXgڂ̃[h
		rc = AjcLbxLoadItems(hwnd, pProfileSect, pKeyPrefix);
	}
	return rc;
}

//==============================================================================================================//
//	ĩZ[u																							//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
AJCEXPORT BOOL			WINAPI	AjcLbxSavePermInfo(HWND hwnd)
{
	return AjcLbxSavePermInfoExW(hwnd, NULL, NULL);
}
//==============================================================================================================//
//	ĩZ[uiZNVwj																		//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - ZNVւ̃|C^															//
//				pKeyPrefix	 - L[ړꖼւ̃|C^														//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxSavePermInfoExA(HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmpSec = NULL;
	WCP		pTmpKey = NULL;

	do {
		if (pProfileSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
			if (len != 0 && (pTmpSec = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmpSec, len);
			}
			else break;
		}
		if (pKeyPrefix != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpKey = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpKey, len);
			}
			else break;
		}
		rc = AjcLbxSavePermInfoExW(hwnd, pTmpSec, pTmpKey);
	} while(0);

	if (pTmpSec != NULL) free(pTmpSec);
	if (pTmpKey != NULL) free(pTmpKey);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxSavePermInfoExW(HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		//----- ZNVCL[w薳Ȃ΁A[hɐݒ肵̂Ƃ -------------------------------//
		if (pProfileSect == NULL) pProfileSect = pW->PermSect;
		if (pKeyPrefix	 == NULL) pKeyPrefix   = pW->PermKey;
		//----- vt@CZ[u -------------------------------------------------------------------------//
		if (*pProfileSect != 0) {
			rc = AjcLbxSaveItems(hwnd, pProfileSect, pKeyPrefix);
		}
	}
	return rc;
}

//==============================================================================================================//
//	ȋiZNVCL[ړjݒ																//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pProfileSect - ZNVւ̃|C^															//
//				pKeyPrefix	 - L[ړꖼւ̃|C^														//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxSetPermAttA  (HWND hwnd, C_BCP pProfileSect, C_BCP pKeyPrefix)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmpSec = NULL;
	WCP		pTmpKey = NULL;

	do {
		if (pProfileSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, NULL, 0);
			if (len != 0 && (pTmpSec = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pProfileSect, -1, pTmpSec, len);
			}
			else break;
		}
		if (pKeyPrefix != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpKey = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpKey, len);
			}
			else break;
		}
		rc = AjcLbxSetPermAttW(hwnd, pTmpSec, pTmpKey);
	} while(0);

	if (pTmpSec != NULL) free(pTmpSec);
	if (pTmpKey != NULL) free(pTmpKey);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxSetPermAttW  (HWND hwnd, C_WCP pProfileSect, C_WCP pKeyPrefix)
{
	PWRKLISTBOX	pW;
	BOOL		rc	  = FALSE;
	WC			szid[16];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		//----- hcݒ -----------------------------------------------------------------------------//
		AjcSnPrintFW(szid, AJCTSIZE(szid), L"%06u", (UW)MAjcGetWindowLong(hwnd, GWL_ID));
		//----- ZNVݒ ---------------------------------------------------------------------------//
		if (pProfileSect != NULL) AjcSnPrintFW(pW->PermSect, AJCTSIZE(pW->PermSect) 	, L"%s" 	, pProfileSect);
		else					  AjcSnPrintFW(pW->PermSect, AJCTSIZE(pW->PermSect) 	, L"SLbx%s" , szid		  );
		//----- L[ړݒ -----------------------------------------------------------------------------//
		if (pKeyPrefix	 != NULL) AjcSnPrintFW(pW->PermKey , AJCTSIZE(pW->PermKey ) - 32, L"%s" 	, pKeyPrefix);	// 32:㑱L[̂̍ől
		else					  AjcSnPrintFW(pW->PermKey , AJCTSIZE(pW->PermKey ) - 32, L"Lbx_%s_", szid		);
	}
	return rc;
}

//==============================================================================================================//
//	SXgڂ̃[h																						//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pSect		 - vt@CZNV															//
//				pKeyPrefix	 - vt@CL[̂̐擪													//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxLoadItemsA	(HWND hwnd, C_BCP pSect, C_BCP pKeyPrefix)
{
	BOOL		rc	  = FALSE;
	UI			len   = 0;
	WCP			pTmpS = NULL;
	WCP			pTmpK = NULL;

	if (pSect != NULL && pKeyPrefix != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmpS = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmpS, len);
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpK = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpK, len);
				rc = AjcLbxLoadItemsW(hwnd, pTmpS, pTmpK);
			}
		}
		if (pTmpS != NULL) free(pTmpS);
		if (pTmpK != NULL) free(pTmpK);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxLoadItemsW	(HWND hwnd, C_WCP pSect, C_WCP pKeyPrefix)
{
	PWRKLISTBOX	pW;
	BOOL		rc	 = FALSE;
	int			i	 = 0;
	int			ix, nList;
	BOOL		fSel	= FALSE;
	UX			data	= 0;
	WCP			pszSel	= NULL;
	WCP			pszData = NULL;
	WC			szSec[256];
	WC			key[256];
	WC			txt[LBX_MAXLEN * 2 + 1];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pSect != NULL && pKeyPrefix != NULL) {
			//	vt@CZNVRs[
			AjcSnPrintFW(szSec, AJCTSIZE(szSec), L"%s", pSect);
			//	Xgڐ擾
			AjcSnPrintF(key , AJCTSIZE(key), L"%s_Cnt", pKeyPrefix);
			nList = AjcGetProfileUInt(szSec, key, -1);
			if (nList != -1) {
				//	Xg{bNXZbg
				SendMessage(pW->hLbx, LB_RESETCONTENT, 0, 0);
				//	ŏ̍ړǂݏo
				AjcSnPrintF(key, AJCTSIZE(key), L"%s_%06d",  pKeyPrefix, i++);
				AjcGetProfileStr(szSec, key, L"@@NONE@@", txt, LBX_MAXLEN);
				//	ڂԃ[v
				while (wcscmp(txt, L"@@NONE@@") != 0) {
					pszSel = AjcStrStripEnclose(txt);
					if (pszSel	!= NULL) pszSel  = AjcStrTokW(pszSel, L",");
					if (pszSel	!= NULL) pszData = AjcStrTokW(NULL	, L",");
					if (pszSel	!= NULL) fSel = _wtoi(pszSel);
					if (pszData != NULL) data = (UX)AjcHexToULL(pszData);
					if (pW->style & AJCLBXS_TRIM) AjcStrTrim(txt, txt, AJCTSIZE(txt));
					ix = (int)SendMessage(pW->hLbx, LB_ADDSTRING, 0, (LPARAM)txt);
					if (fSel) {
						if (pW->style & AJCLBXS_SINGLE) SendMessage(pW->hLbx, LB_SETCURSEL, ix	, 0 );
						else							SendMessage(pW->hLbx, LB_SETSEL   , TRUE, ix);
					}
					SendMessage(pW->hLbx, LB_SETITEMDATA, ix, (LPARAM)data);
					//	̍ړǂݏo
					AjcSnPrintF(key, AJCTSIZE(key), L"%s_%06d",  pKeyPrefix, i++);
					AjcGetProfileStr(szSec, key, L"@@NONE@@", txt, LBX_MAXLEN);
				}
			}
			//----- ő剡ݒ --------------------//
			LbxSetHoriExtentByAllItem(pW);

			rc = TRUE;
		}
	}

	return rc;
}
//==============================================================================================================//
//	SXgڂ̃Z[uiZNVCL[vtBbNXwj													//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pSect		 - vt@CZNV															//
//				pKeyPrefix	 - vt@CL[̂̐擪													//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxSaveItemsA(HWND hwnd, C_BCP pSect, C_BCP pKeyPrefix)
{
	BOOL		rc	  = FALSE;
	UI			len   = 0;
	WCP			pTmpS = NULL;
	WCP			pTmpK = NULL;

	if (pSect != NULL && pKeyPrefix != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmpS = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmpS, len);
			len = MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, NULL, 0);
			if (len != 0 && (pTmpK = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pKeyPrefix, -1, pTmpK, len);
				rc = AjcLbxSaveItemsW(hwnd, pTmpS, pTmpK);
			}
		}
		if (pTmpS != NULL) free(pTmpS);
		if (pTmpK != NULL) free(pTmpK);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL			WINAPI	AjcLbxSaveItemsW(HWND hwnd, C_WCP pSect, C_WCP pKeyPrefix)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;
	int			nList, i, n;
	BOOL		fSel;
	ULL			data;
	WC			key[256];
	WC			tmp[LBX_MAXLEN * 2 + 1];
	WC			txt[LBX_MAXLEN * 2 + 16];
	WC			szSec[256];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pSect != NULL && pKeyPrefix != NULL) {
			//	vt@CZNVRs[
			AjcSnPrintFW(szSec, AJCTSIZE(szSec), L"%s", pSect);
			//	Xg{bNXڐ擾
			nList = (int)SendMessage(pW->hLbx, LB_GETCOUNT, 0, 0);
			if (nList != LB_ERR) {
				//	Xg{bNXڐZ[u
				AjcSnPrintF(key, AJCTSIZE(key), L"%s_Cnt", pKeyPrefix);
				AjcPutProfileUInt(pSect, key, nList);
				//	Xg{bNXڃZ[u
				if ((n = (int)SendMessage(pW->hLbx, LB_GETCOUNT, 0, 0)) > 0) {
					for (i = 0; i < n; i++) {
						fSel = (BOOL)(SendMessage(pW->hLbx, LB_GETSEL	  , i, 0) != 0);
						data =	(ULL) SendMessage(pW->hLbx, LB_GETITEMDATA, i, 0);
						SendMessage(pW->hLbx, LB_GETTEXT, i, (LPARAM)txt);
						AjcStrEnclose(txt, tmp, AJCTSIZE(tmp), '\'');
						AjcSnPrintF(txt, AJCTSIZE(txt), L"%s%d,%llx", tmp, fSel != 0, data);
						AjcSnPrintF(key, AJCTSIZE(key), L"%s_%06d", pKeyPrefix, i);
						AjcPutProfileStr(pSect, key, txt);
					}
				}
				//	Xg{bNXڂꍇ́Avt@C̑Sڍ폜
				else {
					i = 0;
				}
				//----- ڐȏ̃vt@CL[폜 ------------//
				AjcSnPrintF(key, AJCTSIZE(key), L"%s_%06d", pKeyPrefix, i);
				AjcGetProfileStr(pSect, key, L"$$AJCLBX_NONE$$", txt, AJCTSIZE(txt));
				while (wcscmp(txt, L"$$AJCLBX_NONE$$") != 0) {
					AjcDelProfileKey(pSect, key);
					i++;
					AjcSnPrintF(key, AJCTSIZE(key), L"%s_%06d", pKeyPrefix, i);
					AjcGetProfileStr(pSect, key, L"$$AJCLBX_NONE$$", txt, AJCTSIZE(txt));
				}
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	c[`bvEeLXgݒ																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pTxt		 - c[`bvEeLXg̃AhX											//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcLbxSetTipTextA (HWND hwnd, C_BCP pTxt)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (rc = SubSetTipTextA(&pW->pToolTipTxt, 0, pTxt)) {
			AjcTipTextAddW		   (hwnd, pW->pToolTipTxt);
			AjcTipTextSetShowAlways(hwnd, pW->fShowAlways);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcLbxSetTipTextW (HWND hwnd, C_WCP pTxt)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (rc = SubSetTipTextW(&pW->pToolTipTxt, 0, pTxt)) {
			AjcTipTextAddW		   (hwnd, pW->pToolTipTxt);
			AjcTipTextSetShowAlways(hwnd, pW->fShowAlways);
		}
	}
	return rc;
}
//==============================================================================================================//
//	c[`bvEeLXg擾																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pBuf		 - c[`bvEeLXgi[obt@̃AhX							//
//				lBuf		 - c[`bvEeLXgi[obt@̕							//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcLbxGetTipTextA (HWND hwnd, BCP pBuf, UI lBuf)
{
	PWRKLISTBOX	pW;
	BOOL	rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = SubGetTipTextA(&pW->pToolTipTxt, 0, pBuf, lBuf);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcLbxGetTipTextW (HWND hwnd, WCP pBuf, UI lBuf)
{
	PWRKLISTBOX	pW;
	BOOL	rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = SubGetTipTextW(&pW->pToolTipTxt, 0, pBuf, lBuf);
	}
	return rc;
}
//==============================================================================================================//
//	c[`bvEeLXg\ݒ																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				fShowAlways	 - c[`bvEeLXg\													//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcLbxSetTipShowAlways(HWND hwnd, BOOL fShowAlways)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKLISTBOX	pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			pW->fShowAlways = fShowAlways;
			AjcTipTextSetShowAlways(hwnd, pW->fShowAlways);
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	c[`bvEeLXg\擾																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	c[`bvEeLXg\																	//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcLbxGetTipShowAlways(HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		PWRKLISTBOX	pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0);
		if (IS_MY_INST(pW)) {
			rc = pW->fShowAlways;
		}
	}
	return rc;
}

//==============================================================================================================//
//	Xg{bNXڂ̒ǉi\[gCꕶ͒ǉsj												//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pStr		 - ǉ郊Xg{bNXڕ̃AhX										//
//																												//
//	߂l	F	OFǉXg{bNXڂ̃CfNXiO`j											//
//				OFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxAddStringA		(HWND hwnd, C_BCP pStr)
{
	BOOL		rc	  = -1;
	UI			len   = 0;
	WCP			pTmp  = NULL;

	if (pStr != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pStr, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pStr, -1, pTmp, len);
			rc = AjcLbxAddStringW(hwnd, pTmp);
		}
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxAddStringW		(HWND hwnd, C_WCP pStr)
{
	PWRKLISTBOX	pW;
	int			rc = -1;
	WC			str[LBX_MAXLEN];
	WC			txt[LBX_MAXLEN];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pStr != NULL) {
			AjcSnPrintF(str, LBX_MAXLEN, L"%s", pStr);
			if (AjcLbxFindString(hwnd, 0, str) < 0) {
				if ((pW->style & AJCLBXS_SORT ) && (pW->style & AJCLBXS_COMP_EXACT)) {	//	\[g聕p召ʂH
					int	n, i, ix;
					//	}ʒu
					n  = (int)SendMessage(pW->hLbx, LB_GETCOUNT, 0, 0);
					ix = -1;
					for (i = 0; i < n; i++) {
						if (SendMessage(pW->hLbx, LB_GETTEXT, i, (LPARAM)txt) >= 0) {
							if (pW->style & AJCLBXS_SORT_EXACT) {	
								if (wcscmp(str, txt) < 0) {
									ix = i;
									break;
								}
							}
							else {
								if		(wcsicmp(str, txt) == 0) {
									ix = i + (wcscmp(str, txt) > 0);
									break;
								}
								else if (wcsicmp(str, txt) <= 0) {
									ix = i;
									break;
								}
							}
						}
					}
					//	ڑ}
					if (pW->style & AJCLBXS_TRIM) AjcStrTrimW(str, str, AJCTSIZE(str));
					rc = (int)SendMessage(pW->hLbx, LB_INSERTSTRING, ix, (LPARAM)str);
				}
				else {																	//	\[g^p召ʖH
					//	ڒǉ
					if (pW->style & AJCLBXS_TRIM) AjcStrTrimW(str, str, AJCTSIZE(str));
					rc = (int)SendMessage(pW->hLbx, LB_ADDSTRING, 0, (LPARAM)str);
				}
				LbxUpdHoriExtentByStrW(pW, str);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂ̑}i\[gȂCꕶ͑}sj												//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - }ʒũCfNX																//
//				pStr		 - ǉ郊Xg{bNXڕ̃AhX										//
//																												//
//	߂l	F	OF}Xg{bNXڂ̃CfNXiO`j											//
//				OFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxInsertStringA		(HWND hwnd, UI ix, C_BCP pStr)
{
	PWRKLISTBOX	pW;
	int			rc = -1;
	BC			str[LBX_MAXLEN];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pStr != NULL) {
			AjcSnPrintFA(str, LBX_MAXLEN, "%s", pStr);
			if (AjcLbxFindStringA(hwnd, 0, str) < 0) {
				if (pW->style & AJCLBXS_TRIM) AjcStrTrimA(str, str, AJCTSIZE(str));
				rc = (int)SendMessageA(pW->hLbx, LB_INSERTSTRING, ix, (LPARAM)str);
				LbxUpdHoriExtentByStrA(pW, str);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxInsertStringW		(HWND hwnd, UI ix, C_WCP pStr)
{
	PWRKLISTBOX	pW;
	int			rc = -1;
	WC			str[LBX_MAXLEN];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pStr != NULL) {
			AjcSnPrintFW(str, LBX_MAXLEN, L"%s", pStr);
			if (AjcLbxFindStringW(hwnd, 0, str) < 0) {
				if (pW->style & AJCLBXS_TRIM) AjcStrTrimW(str, str, AJCTSIZE(str));
				rc = (int)SendMessage(pW->hLbx, LB_INSERTSTRING, ix, (LPARAM)str);
				LbxUpdHoriExtentByStrW(pW, str);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂ̍폜																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - 폜郊Xgڂ̃CfNXiO`j											//
//																												//
//	߂l	F	OFcXg{bNXڂ̌															//
//				OFG[																					//
//==============================================================================================================//
AJCEXPORT int	 WINAPI	AjcLbxDeleteString		(HWND hwnd, UI ix)
{
	PWRKLISTBOX	pW;
	int			rc = -1;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = (int)SendMessage(pW->hLbx, LB_DELETESTRING, ix, 0);
	}
	return rc;
}

//==============================================================================================================//
//	Xg{bNXڂ̌																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - JnCfNXi|P̏ꍇ͐擪猟j								//
//				pStr		 - 镶̃AhX															//
//																												//
//	߂l	F	OFXg{bNXڂ̃CfNXiO`j											//
//				OFw蕶񂪌Ȃ^G[															//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxFindStringA		(HWND hwnd, UI ix, C_BCP pStr)
{
	BOOL		rc	  = -1;
	UI			len   = 0;
	WCP			pTmp  = NULL;

	if (pStr != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pStr, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pStr, -1, pTmp, len);
			rc = AjcLbxFindStringW(hwnd, ix, pTmp);
		}
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxFindStringW		(HWND hwnd, UI ix, C_WCP pStr)
{
	PWRKLISTBOX	pW;
	int			rc = -1;
	int			n, i, j;
	BOOL		fFind;
	WC			txt[LBX_MAXLEN];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pStr != NULL) {
			if ((n = (int)SendMessage(pW->hLbx, LB_GETCOUNT, 0, 0)) > 0) {
				for (i = 0, j = (((int)ix < 0 || (int)ix >= n) ? 0 : (int)ix); i < n; i++, j = ((j + 1) % n)) {
					if (SendMessage(pW->hLbx, LB_GETTEXT, j, (LPARAM)txt) >= 0) {
						if (pW->style & AJCLBXS_COMP_EXACT) fFind = (wcscmp (txt, pStr) == 0);
						else								fFind = (wcsicmp(txt, pStr) == 0);
						if (fFind) {rc = j; break;}
					}
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂ̍ڐ擾																				//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	OFXg{bNX̍ڐiO`j															//
//				OFG[																					//
//==============================================================================================================//
AJCEXPORT int	 WINAPI	AjcLbxGetCount			(HWND hwnd)
{
	PWRKLISTBOX	pW;
	int		rc = -1;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = (int)SendMessage(pW->hLbx, LB_GETCOUNT, 0, 0);
	}

	return rc;
}
//==============================================================================================================//
//	IĂ郊Xg{bNXڂ̃CfNX擾iPÎ݁j											//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	OFIĂ鍀ڂ̃CfNX															//
//				OFG[																					//
//==============================================================================================================//
AJCEXPORT int	 WINAPI	AjcLbxGetCurSel			(HWND hwnd)
{
	PWRKLISTBOX	pW;
	int			rc = -1;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = (int)SendMessage(pW->hLbx, LB_GETCURSEL, 0, 0);
	}

	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂ̑IԎ擾																			//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - Xg{bNXڂ̃CfNX													//
//																												//
//	߂l	F	TRUE Fw荀ڂ͑I																		//
//				FALSEFw荀ڂ͔I																		//
//				OFG[																					//
//==============================================================================================================//
AJCEXPORT BOOL	 WINAPI	AjcLbxGetSel			(HWND hwnd, UI ix)
{
	PWRKLISTBOX	pW;
	int			rc = -1;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if ((rc = (int)SendMessage(pW->hLbx, LB_GETSEL, ix, 0)) > 0) {
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	IĂ郊Xg{bNXڂ̌擾iI[ĥ݁j											//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	OFIĂ郊Xg{bNXڂ̌													//
//				OFPI[h^G[																	//
//==============================================================================================================//
AJCEXPORT int	 WINAPI	AjcLbxGetSelCount		(HWND hwnd)
{
	PWRKLISTBOX	pW;
	int			rc = -1;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pW->style & AJCLBXS_SINGLE) {
			rc = (int)(SendMessage(pW->hLbx, LB_GETCURSEL, 0, 0) >= 0);
		}
		else {
			rc = (int)SendMessage(pW->hLbx, LB_GETSELCOUNT, 0, 0);
		}
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂ̎擾																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - 擾郊Xg{bNXڂ̃CfNXiO`j									//
//				pBuf		 - 擾Xg{bNXڂi[obt@̃AhX							//
//				lBuf		 - 擾Xg{bNXڂi[obt@̕								//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcLbxGetTextA		(HWND hwnd, UI ix, BCP pBuf, UI lBuf)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;
	WC			txt[LBX_MAXLEN];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pBuf != NULL && lBuf > 0) {
			if (rc = AjcLbxGetTextW(hwnd, ix, txt, AJCTSIZE(txt))) {
				WideCharToMultiByte(CP_ACP, 0, txt, -1, pBuf, lBuf, NULL, NULL);
				pBuf[lBuf - 1] = 0;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcLbxGetTextW		(HWND hwnd, UI ix, WCP pBuf, UI lBuf)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;
	int			len;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pBuf != NULL && lBuf > 0) {
			len = (int)SendMessage(pW->hLbx, LB_GETTEXTLEN, ix, 0);
			if (len >= 0 && len < (int)lBuf) {
				rc = ((int)SendMessage(pW->hLbx, LB_GETTEXT, ix, (LPARAM)pBuf) != LB_ERR);
				pBuf[lBuf - 1] = 0;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂ̕擾																				//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - 擾郊Xg{bNXڂ̃CfNXiO`j									//
//																												//
//	߂l	F	OFXg{bNXڂ̕																//
//				OFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxGetTextLenA		(HWND hwnd, UI ix)
{
	PWRKLISTBOX	pW;
	int			rc = -1;
	BC			txt[LBX_MAXLEN];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (AjcLbxGetTextA(hwnd, ix, txt, AJCTSIZE(txt))) {
			rc = (int)strlen(txt);
		}
	}

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxGetTextLenW		(HWND hwnd, UI ix)
{
	PWRKLISTBOX	pW;
	int			rc = -1;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc =  (int)SendMessage(pW->hLbx, LB_GETTEXTLEN, ix, 0);
	}

	return rc;
}
//==============================================================================================================//
//	SXg{bNXڂ̏																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT BOOL	 WINAPI	AjcLbxResetContent		(HWND hwnd)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		SendMessage(pW->hLbx, LB_RESETCONTENT, 0, 0);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂ̑Iiwj																		//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - IJnCfNXi|P̏ꍇ͑Sj											//
//				pStr		 - 镶̃AhX															//
//																												//
//	߂l	F	OFXg{bNXڂ̃CfNXiO`j											//
//				OFw蕶񂪌Ȃ^G[															//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxSelectStringA		(HWND hwnd, UI ix, C_BCP pStr)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;
	int			len;
	WCP			pTmp = NULL;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pStr != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pStr, -1, NULL, 0);
			if (len != 0 && (pTmp = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pStr, -1, pTmp, len);
				rc = AjcLbxSelectStringW(hwnd, ix, pTmp);
			}
		}
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcLbxSelectStringW		(HWND hwnd, UI ix, C_WCP pStr)
{
	PWRKLISTBOX	pW;
	int			rc = -1;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pStr != NULL) {
			if ((rc = AjcLbxFindStringW(hwnd, ix, pStr)) >= 0) {
				if (pW->style & AJCLBXS_SINGLE) {
					SendMessage(pW->hLbx, LB_SETCURSEL, rc, 0);
				}
				else {
					SendMessage(pW->hLbx, LB_SETSEL, TRUE, rc);
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڐ̐ݒ																					//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				count		 - ݒ肷鍀ڐ																	//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
AJCEXPORT BOOL	 WINAPI	AjcLbxSetCount			(HWND hwnd, UI count)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = ((int)SendMessage(pW->hLbx, LB_SETCOUNT, count, 0) >= 0);
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂ̑IiCfNXwj																	//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - IԂɂ郊Xg{bNXڂ̃CfNXi|P̏ꍇ͑I𖳂Ԃɐݒj	//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
AJCEXPORT BOOL	 WINAPI	AjcLbxSetCurSel			(HWND hwnd, UI ix)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pW->style & AJCLBXS_SINGLE) {
			rc = ((int)SendMessage(pW->hLbx, LB_SETCURSEL, ix, 0) != LB_ERR);
		}
		else {
			rc = ((int)SendMessage(pW->hLbx, LB_SETSEL, TRUE, ix) != LB_ERR);
		}
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂ̑I^IԐݒ																	//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - IԂɂ郊Xg{bNXڂ̃CfNX										//
//				fSelect		 - TRUE:IԂɐݒCFALSE:IԂɐݒ										//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
AJCEXPORT BOOL	 WINAPI	AjcLbxSetSel			(HWND hwnd, UI ixItem, BOOL fSelect)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;
	int			ix = (int)ixItem;
	int			n;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (fSelect) {													//	IԂɂH
			if (pW->style & AJCLBXS_SINGLE) {							//		PI[hH
				n = (int)SendMessage(pW->hLbx, LB_GETCOUNT, 0, 0);		//			ڐ擾
				if (ix >= 0 && ix < n) {								//			CfNX͔͈͓H
					rc = ((int)SendMessage(pW->hLbx, LB_SETCURSEL, ix, 0) != LB_ERR);
				}
			}
			else {														//		I[hH
				rc = ((int)SendMessage(pW->hLbx, LB_SETSEL, TRUE, ix) != LB_ERR);
			}
		}
		else {															//	IԂɂ
			if (pW->style & AJCLBXS_SINGLE) {							//		PI[hH
				SendMessage(pW->hLbx, LB_SETCURSEL, -1, 0);
				rc = TRUE;
			}
			else {														//		I[hH
				rc = ((int)SendMessage(pW->hLbx, LB_SETSEL, FALSE, ix) != LB_ERR);
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	Xg{bNXڂɐl֘At																		//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - IԂɂ郊Xg{bNXڂ̃CfNXi|P̏ꍇ͑I𖳂Ԃɐݒj	//
//				data		 - Xg{bNXڂɊ֘At鐔l												//
//																												//
//	߂l	F	TRUE:OKCFALSE:G[																			//
//==============================================================================================================//
AJCEXPORT BOOL	 WINAPI	AjcLbxSetItemData		(HWND hwnd, UI ix, UX data)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = ((int)SendMessage(pW->hLbx, LB_SETITEMDATA, ix, data) != LB_ERR);
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNXڂɊ֘Atꂽl̎擾																//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				ix			 - IԂɂ郊Xg{bNXڂ̃CfNXi|P̏ꍇ͑I𖳂Ԃɐݒj	//
//																												//
//	߂l	F	Xg{bNXڂɊ֘Atꂽl															//
//==============================================================================================================//
AJCEXPORT UX	 WINAPI	AjcLbxGetItemData		(HWND hwnd, UI ix)
{
	PWRKLISTBOX	pW;
	UX			rc = -1;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = (UX)SendMessage(pW->hLbx, LB_GETITEMDATA, ix, 0);
	}
	return rc;
}
//==============================================================================================================//
//	΃AhXϊ̃x[XfBNgpXݒ																//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pBasePath	 - x[XfBNgpXi΃pXϊgpȂꍇNULLj						//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcLbxSetBasePathA		(HWND hwnd, C_BCP pBasePath)
{
	PWRKLISTBOX	pW;
	BOOL		rc	 = FALSE;
	WCP			pTmp = NULL;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pBasePath != NULL  &&  *pBasePath != 0) {
			int len = MultiByteToWideChar(CP_ACP, 0, pBasePath, -1, NULL, 0);
			if (len != 0 && (pTmp = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pBasePath, -1, pTmp, len);
				rc = AjcLbxSetBasePathW(hwnd, pTmp);
			}
			if (pTmp != NULL) free(pTmp);
		}
		else {
			pW->BasePath[0] = 0;
			rc = TRUE;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcLbxSetBasePathW		(HWND hwnd, C_WCP pBasePath)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;
	WC			path[MAX_PATH];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pBasePath != NULL  &&  *pBasePath != 0) {
			AjcSnPrintF(path, MAX_PATH, L"%s", pBasePath);
			if (AjcPathIsDirectory(path)) {
				AjcSnPrintF(pW->BasePath, MAX_PATH, L"%s", path);
				rc = TRUE;
			}
		}
		else {
			pW->BasePath[0] = 0;
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	ENbNʒmݒ																							//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				fRClk		 - ENbNʒmtOiTRUE:ʒmCFALSE:ʒmȂj							//
//				MsgRBDown	 - E{^̒ʒmbZ[WR[h@iȌꍇ͔ʒmj						//
//				MSgRBUp		 - E{^ꎞ̒ʒmbZ[WR[hiȌꍇ͔ʒmj						//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcLbxSetNtcRClk	(HWND hwnd, BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		pW->fNtcRClk  = fNtcRClk;
		pW->MsgRBDown = MsgRBDown;
		pW->MsgRBUp	  = MsgRBUp;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	t@CĨtB^CftHggq̐ݒ															//
//																												//
//	@	F	hwnd		 - EChnh																	//
//				pFilter		 - tB^̃AhX		isvNULLj									//
//				pDefExt		 - ftHggq̃AhX	isvNULL)										//
//																												//
//	߂l	F	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcLbxSetFileFilterA(HWND hwnd, C_BCP pFilter, C_BCP pDefExt)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pFilter != NULL) {
			MultiByteToWideChar(CP_ACP, 0, pFilter, -1, pW->FileFilter, AJCTSIZE(pW->FileFilter));
			pW->FileFilter[AJCTSIZE(pW->FileFilter) - 1] = 0;
		}
		if (pDefExt != NULL) {
			MultiByteToWideChar(CP_ACP, 0, pDefExt, -1, pW->FileDefExt, AJCTSIZE(pW->FileDefExt));
			pW->FileDefExt[AJCTSIZE(pW->FileDefExt) - 1] = 0;
		}
		rc = TRUE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcLbxSetFileFilterW(HWND hwnd, C_WCP pFilter, C_WCP pDefExt)
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pFilter != NULL) AjcSnPrintF(pW->FileFilter, AJCTSIZE(pW->FileFilter), L"%s", pFilter);
		if (pDefExt != NULL) AjcSnPrintF(pW->FileDefExt, AJCTSIZE(pW->FileDefExt), L"%s", pDefExt);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽt@C擾																				//
//																												//
//	@	F	pW	  - CX^X[NAhX																//
//				buf	  - t@Ci[obt@̃AhX													//
//																												//
//	߂l	F	TRUE:t@CCFALSE:t@CȂ														//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLbxGetDroppedFileA (HWND hwnd, BC buf[MAX_PATH])
{
	BOOL	rc = FALSE;
	WC		tmp[MAX_PATH];

	if (buf != NULL) {
		if (rc = AjcLbxGetDroppedFileW(hwnd, tmp)) {
			WideCharToMultiByte(CP_ACP, 0, tmp, -1, buf, MAX_PATH, NULL, NULL);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLbxGetDroppedFileW (HWND hwnd, WC buf[MAX_PATH])
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;
	UI			bytes;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (buf != NULL) {
			if (AjcRngGetData(pW->hRngFile, (VOP)&bytes, sizeof bytes) == sizeof bytes) {
				rc = (AjcRngGetData(pW->hRngFile, (VOP)buf, bytes) == bytes);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽfBNg擾																			//
//																												//
//	@	F	pW	  - CX^X[NAhX																//
//				buf	  - fBNgi[obt@̃AhX												//
//																												//
//	߂l	F	TRUE:fBNgCFALSE:fBNgȂ												//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLbxGetDroppedDirA  (HWND hwnd, BC buf[MAX_PATH])
{
	BOOL	rc = FALSE;
	WC		tmp[MAX_PATH];

	if (buf != NULL) {
		if (rc = AjcLbxGetDroppedDirW(hwnd, tmp)) {
			WideCharToMultiByte(CP_ACP, 0, tmp, -1, buf, MAX_PATH, NULL, NULL);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLbxGetDroppedDirW  (HWND hwnd, WC buf[MAX_PATH])
{
	PWRKLISTBOX	pW;
	BOOL		rc = FALSE;
	UI			bytes;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (buf != NULL) {
			if (AjcRngGetData(pW->hRngDir, (VOP)&bytes, sizeof bytes) == sizeof bytes) {
				rc = (AjcRngGetData(pW->hRngDir, (VOP)buf, bytes) == bytes);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	hbvꂽfBNg擾íuvtwtj												//
//																												//
//	@	F	pW				 - CX^X[NAhX													//
//				buf				 - fBNgi[obt@̃AhX									//
//				fTailIsDelimiter - TRUE  : fBNgpX̖Ɂu\vt								//
//								   FALSE : fBNgpX̖Ɂu\vtȂ								//
//																												//
//	߂l	F	TRUE:fBNgCFALSE:fBNgȂ												//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLbxGetDroppedDirExA	(HWND hwnd, BC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	BOOL		rc = FALSE;
	WC			dir[MAX_PATH];

	if (rc = AjcLbxGetDroppedDirW(hwnd, dir)) {
		WideCharToMultiByte(CP_ACP, 0, dir, -1, buf, MAX_PATH, NULL, NULL);
		buf[MAX_PATH - 1] = 0;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLbxGetDroppedDirExW	(HWND hwnd, WC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	BOOL		rc = FALSE;

	if (rc = AjcLbxGetDroppedDirW(hwnd, buf)) {
		if (fTailIsDelimiter) AjcPathCat(buf, L"", MAX_PATH);
		else				  PathRemoveBackslashW(buf);
	}
	return rc;
}
//==============================================================================================================//
//	폜ڂ̕擾																					//
//																												//
//	@	F	pW	  - CX^X[NAhX																//
//				buf	  - fBNgi[obt@̃AhX												//
//																												//
//	߂l	F	TRUE:폜ڂCFALSE:폜ږȂiI[j													//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLbxGetRemovedItemA  (HWND hwnd, BCP pBuf, UI lBuf)
{
	PWRKLISTBOX	pW;
	BOOL		rc	  = FALSE;
	UI			bytes = 0;
	WC			txt[LBX_MAXLEN];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pBuf != NULL && lBuf != 0) {
			if (AjcRngGetData(pW->hRngDel, (VOP)&bytes, sizeof bytes) == sizeof bytes) {
				if (rc = (AjcRngGetData(pW->hRngDel, (VOP)txt, bytes) == bytes)) {
					WideCharToMultiByte(CP_ACP, 0, txt, -1, pBuf, lBuf, NULL, NULL);
					pBuf[lBuf - 1] = 0;
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcLbxGetRemovedItemW  (HWND hwnd, WCP pBuf, UI lBuf)
{
	PWRKLISTBOX	pW;
	BOOL		rc	  = FALSE;
	UI			bytes = 0;
	BC			txt[LBX_MAXLEN];

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pBuf != NULL && lBuf != 0) {
			if (AjcRngGetData(pW->hRngDel, (VOP)&bytes, sizeof bytes) == sizeof bytes) {
				if (rc = (AjcRngGetData(pW->hRngDel, (VOP)txt, bytes) == bytes)) {
					AjcSnPrintF(pBuf, lBuf, L"%s", txt);
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	CECh̃nh擾																				//
//																												//
//	@	F	hwnd		- EChnh																	//
//				pBkWnd		- EChwiFi[obt@ւ̃|C^isvNULLj						//
//																												//
//	߂l	F	NULL : CECh̃nh																//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	HWND	WINAPI		AjcLbxGetMainWindow(HWND hwnd, COLORREF *pBkGnd)
{
	PWRKLISTBOX	pW;
	HWND		rc = NULL;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		if (pBkGnd != NULL) {
			*pBkGnd = RGB(255, 255, 255);
		}
		rc = pW->hBack;
	}
	return rc;
}

//==============================================================================================================//
//																												//
//	ʒm擾																								//
//																												//
//==============================================================================================================//
//	ENbN
AJCEXPORT PAJCLBXRCLK	WINAPI	AjcLbxGetNtcRClk	(HWND hwnd)
{
	PWRKLISTBOX	pW;
	PAJCLBXRCLK	rc = NULL;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = &pW->NtcRClk;
	}
	return rc;
}
//	hbvfBNg
AJCEXPORT UI			WINAPI	AjcLbxGetNtcDirs	(HWND hwnd)
{
	PWRKLISTBOX	pW;
	UI			rc = 0;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = pW->NtcDirs;
	}
	return rc;
}
//	hbvt@C
AJCEXPORT UI			WINAPI	AjcLbxGetNtcFiles	(HWND hwnd)
{
	PWRKLISTBOX	pW;
	UI			rc = 0;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = pW->NtcFiles;
	}
	return rc;
}

//	폜ڐ
AJCEXPORT UI			WINAPI	AjcLbxGetNtcRemovedItems(HWND hwnd)
{
	PWRKLISTBOX	pW;
	UI			rc = 0;

	if (IsWindow(hwnd) && (pW = (PWRKLISTBOX)MAjcGetWindowLong(hwnd, 0)) && pW->InstID == LBX_INST_ID) {
		rc = pW->NtcDelItems;
	}
	return rc;
}
