#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	ėpTu֐																								//
//																												//
//**************************************************************************************************************//

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//


//==============================================================================================================//
//	chaZNV̐																						//
//																												//
//	@F	width		- rbg}bv̕@isNZj												//
//				height		- rbg}bv̍icsNZj												//
//				BitCount	- C[Wf[^̃rbg															//
//				pBuf		- chaZNV̏i[obt@̃AhXisv͂mtkkj	//
//																												//
//	߂lF	NULLFrbg}bvEnh																	//
//				NULLFG[																					//
//==============================================================================================================//
AJCEXPORT HBITMAP	WINAPI AjcDibCreate		(int width, int height, int BitCount, PAJCDIBINFO pBuf)
{
	HBITMAP				rc = NULL;
	BITMAPINFOHEADER	bmih;
	UBP					pBits;
	int					lsz;

	if (width > 0  &&  height > 0  &&  (BitCount == 24 || BitCount == 32)) {
		bmih.biSize			= sizeof(BITMAPINFOHEADER);
		bmih.biWidth		= width;
		bmih.biHeight		= height;
		bmih.biPlanes		= 1;
		bmih.biBitCount		= BitCount;
		bmih.biCompression	= BI_RGB;
		bmih.biSizeImage	= 0;
		bmih.biXPelsPerMeter= 0;
		bmih.biYPelsPerMeter= 0;
		bmih.biClrUsed		= 0;
		bmih.biClrImportant	= 0;
		if (rc = CreateDIBSection(NULL, (BITMAPINFO *)&bmih, 0, &pBits, NULL, 0)) {
			lsz = ((width * BitCount + 31) & ~31) >> 3;
			if (pBuf != NULL) {
				pBuf->hBmp		= rc;
				pBuf->BitCount	= BitCount;
				pBuf->width		= width;
				pBuf->height	= height;
				pBuf->PixelSize	= BitCount / 8;
				pBuf->LineSize	= lsz;
				pBuf->pImage	= pBits;
			}
			memset(pBits, 0, lsz * height);
		}
	}
	return rc;
}

//==============================================================================================================//
//	chaZNVw̐FŃNA[																		//
//																												//
//	@F	pDibInfo	- chaZNṼAhX													//
//				rgb			- NA[F																	//
//																												//
//	߂lF	TRUE F																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcDibClear			(PAJCDIBINFO pDibInfo, COLORREF rgb)
{
	BOOL	rc = FALSE;
	int		x, y;
	UB		r, g, b;
	UBP		p;

	if (pDibInfo != NULL && pDibInfo->BitCount >= 24) {
		r = (UB)GetRValue(rgb);
		g = (UB)GetGValue(rgb);
		b = (UB)GetBValue(rgb);
		for (y = 0; y < pDibInfo->height; y++) {
			p = pDibInfo->pImage + (pDibInfo->LineSize * y);
			for (x = 0; x < pDibInfo->width; x++) {
				*(p + 0) = b;
				*(p + 1) = g;
				*(p + 2) = r;
				p += pDibInfo->PixelSize;
			}
		}
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	chaZNVփrbg}bvRs[																		//
//																												//
//	@F	pDibInfo					- Rs[chaZNṼAhX							//
//				dpx, dpy, dcx, dcy / ptDest	- Rs[`̈ʒuƃTCY										//
//				hBitmap						- Rs[̃rbg}bvnh									//
//				spx, spy, scx, scy / ptSrc	- Rs[`̈ʒuƃTCY										//
//				rop							- X^[Iy[V											//
//																												//
//	߂lF	TRUE F																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcDibCopyBitmap	(PAJCDIBINFO pDibInfo, int dpx, int dpy, int dcx, int dcy, HBITMAP hBitmap , int spx, int spy, int scx, int scy, int rop)
{
	BOOL		rc = FALSE;
	BITMAP		BmpInfo;
	HDC			hdc, ddc, sdc;
	HBITMAP		hBmpD, hBmpS;

	if (pDibInfo != NULL && hBitmap != NULL) {
		GetObject(hBitmap, sizeof(BITMAP), &BmpInfo);
		if (dpx >= 0 && dpx < pDibInfo->width && dpy >= 0 && dpy < pDibInfo->height &&
			spx >= 0 && spx < BmpInfo.bmWidth && spy >= 0 && spy < BmpInfo.bmHeight) {
			//----- Rs[rbg}bvTCYݒ -------------------------------------//
			if (dcx <= 0) dcx = pDibInfo->width  - dpx;
			if (dcy <= 0) dcy = pDibInfo->height - dpy;
			//----- Rs[rbg}bvTCY␳ -------------------------------------//
			if (dpx + dcx > pDibInfo->width ) dcx = pDibInfo->width  - dpx;
			if (dpy + dcy > pDibInfo->height) dcy = pDibInfo->height - dpy;
			//----- Rs[rbg}bvTCYݒ -------------------------------------//
			if (scx <= 0) scx = BmpInfo.bmWidth  - spx;
			if (scy <= 0) scy = BmpInfo.bmHeight - spy;
			//----- Rs[rbg}bvTCY␳ -------------------------------------//
			if (spx + scx > BmpInfo.bmWidth ) scx = BmpInfo.bmWidth  - spx;
			if (spy + scy > BmpInfo.bmHeight) scy = BmpInfo.bmHeight - spy;
			//----- Rs[ -------------------------------------------------------------//
			hdc   = GetDC(NULL);
			ddc   = CreateCompatibleDC(hdc);
			sdc   = CreateCompatibleDC(hdc);
			hBmpD = (HBITMAP)SelectObject(ddc, pDibInfo->hBmp);
			hBmpS = (HBITMAP)SelectObject(sdc, hBitmap);
			if (dcx == scx	&&	dcy == scy) {
				rc = BitBlt(ddc, dpx, dpy, dcx, dcy, sdc, spx, spy, rop);
			}
			else {
				rc = StretchBlt(ddc, dpx, dpy, dcx, dcy, sdc, spx, spy, scx, scy, rop);
			}
			SelectObject(ddc, hBmpD);
			SelectObject(sdc, hBmpS);
			DeleteDC(ddc);
			DeleteDC(sdc);
			ReleaseDC(NULL, hdc);
		}
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT BOOL		WINAPI AjcDibCopyBitmapV(PAJCDIBINFO pDibInfo, const RECT *rcDest, HBITMAP hBitmap , const RECT *rcSrc, int rop)
{
	BOOL	rc = FALSE;

	if (rcDest != NULL && rcSrc != NULL) {
		rc = AjcDibCopyBitmap(pDibInfo, rcDest->left, rcDest->top, rcDest->right - rcDest->left, rcDest->bottom - rcDest->top,
							  hBitmap , rcSrc ->left, rcSrc ->top, rcSrc ->right - rcSrc ->left, rcSrc ->bottom - rcSrc ->top, rop);
	}
	return rc;
}
//==============================================================================================================//
//	chaZNVchaZNV֓̐F͈͂̕Rs[										//
//																												//
//	@F	pDibDest					- Rs[chaZNṼAhX							//
//				dpx, dpy, dcx, dcy / rcDest	- Rs[`̈ʒuƃTCY										//
//				pDibSrc						- Rs[chaZNṼAhX							//
//				spx, spy		   / ptSrc	- Rs[`̈ʒu												//
//				rgbBase						- Rs[ΏۂƂF̃x[Xl										//
//				distance					- Rs[ΏۂƂF̋											//
//																												//
//	߂lF	TRUE F																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcDibCorrectedCopy	(PAJCDIBINFO pDibDest, int dpx, int dpy, int dcx, int dcy, PAJCDIBINFO pDibSrc , int spx, int spy, COLORREF rgbBase, double distance)
{
	BOOL	rc = FALSE;
	int		scx, scy, tcx, tcy, cx, cy;
	int		r, g, b, sr, sg, sb;
	UBP		pDL, pSL, pDB, pSB;
	double	len;

	if (pDibDest != NULL && pDibDest->BitCount >= 24 && dpx >= 0 && dpx < pDibDest->width && dpy >= 0 && dpy < pDibDest->height &&
		pDibSrc  != NULL && pDibSrc ->BitCount >= 24 && spx >= 0 && spx < pDibSrc ->width && spy >= 0 && spy < pDibSrc ->height) {
		//----- Rs[rbg}bvTCYݒ -------------------------------------//
		if (dcx <= 0) dcx = pDibDest->width  - dpx;
		if (dcy <= 0) dcy = pDibDest->height - dpy;
		//----- Rs[rbg}bvTCY␳ -------------------------------------//
		if (dpx + dcx > pDibDest->width ) dcx = pDibDest->width  - dpx;
		if (dpy + dcy > pDibDest->height) dcy = pDibDest->height - dpy;
		//----- Rs[̍ősNZݒ ---------------------------------------//
		scx = pDibSrc->width  - spx;
		scy = pDibSrc->height - spy;
		//----- Rs[TCYݒ ---------------------------------------------------//
		tcx = __min(dcx, scx);
		tcy = __min(dcy, scy);
		//----- F̑IƃRs[ ---------------------------------------------------//
		r = (UB)GetRValue(rgbBase);
		g = (UB)GetGValue(rgbBase);
		b = (UB)GetBValue(rgbBase);
		pDL = pDibDest->pImage + (pDibDest->LineSize * (pDibDest->height - dpy - 1));
		pSL = pDibSrc ->pImage + (pDibSrc ->LineSize * (pDibSrc ->height - spy - 1));
		for (cy = 0; cy < tcy; cy++) {
			pDB = pDL + (pDibDest->PixelSize * dpx);
			pSB = pSL + (pDibSrc ->PixelSize * spx);
			for (cx = 0; cx < tcx; cx++) {
				sb = *(pSB + 0);
				sg = *(pSB + 1);
				sr = *(pSB + 2);
				len = sqrt(pow(r - sr, 2.0) + pow(g - sg, 2.0) + pow(b - sb, 2.0));
				if (len <= distance) {
					memcpy(pDB, pSB, 3);
				}
				pDB += pDibDest->PixelSize;
				pSB += pDibSrc ->PixelSize;
			}
			pDL -= pDibDest->LineSize;
			pSL -= pDibSrc ->LineSize;
		}
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT BOOL		WINAPI AjcDibCorrectedCopyV	(PAJCDIBINFO pDibDest, const RECT *rcDest, PAJCDIBINFO pDibSrc , const POINT *ptSrc, COLORREF rgbBase, double distance)
{
	BOOL	rc = FALSE;

	if (rcDest != NULL && ptSrc != NULL) {
		rc = AjcDibCorrectedCopy(pDibDest, rcDest->left, rcDest->top, rcDest->right - rcDest->left, rcDest->bottom - rcDest->top,
								 pDibSrc , ptSrc ->x   , ptSrc ->y  , rgbBase, distance);
	}
	return rc;
}
//==============================================================================================================//
//	chaZNVchaZNV֓̐F͈͂̕Rs[									//
//																												//
//	@F	pDibDest			- Rs[chaZNṼAhX									//
//				dpx, dpy, dcx, dcy	- Rs[`̈ʒuƃTCY												//
//				pDibSrc				- Rs[chaZNṼAhX									//
//				spx, spy, scx, scy	- Rs[`̈ʒuƃTCY												//
//				rgbBase				- Rs[OƂF̃x[Xl												//
//				distance			- Rs[OƂF̋													//
//																												//
//	߂lF	TRUE F																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcDibExcludedCopy 	(PAJCDIBINFO pDibDest, int dpx, int dpy, int dcx, int dcy, PAJCDIBINFO pDibSrc , int spx, int spy, COLORREF rgbBase, double distance)
{
	BOOL	rc = FALSE;
	int		scx, scy, tcx, tcy, cx, cy;
	int		r, g, b, sr, sg, sb;
	UBP		pDL, pSL, pDB, pSB;
	double	len;

	if (pDibDest != NULL && pDibDest->BitCount >= 24 && dpx >= 0 && dpx < pDibDest->width && dpy >= 0 && dpy < pDibDest->height &&
		pDibSrc  != NULL && pDibSrc ->BitCount >= 24 && spx >= 0 && spx < pDibSrc ->width && spy >= 0 && spy < pDibSrc ->height) {
		//----- Rs[rbg}bvTCYݒ -------------------------------------//
		if (dcx <= 0) dcx = pDibDest->width  - dpx;
		if (dcy <= 0) dcy = pDibDest->height - dpy;
		//----- Rs[rbg}bvTCY␳ -------------------------------------//
		if (dpx + dcx > pDibDest->width ) dcx = pDibDest->width  - dpx;
		if (dpy + dcy > pDibDest->height) dcy = pDibDest->height - dpy;
		//----- Rs[̍ősNZݒ ---------------------------------------//
		scx = pDibSrc->width  - spx;
		scy = pDibSrc->height - spy;
		//----- Rs[TCYݒ ---------------------------------------------------//
		tcx = __min(dcx, scx);
		tcy = __min(dcy, scy);
		//----- F̏OƃRs[ ---------------------------------------------------//
		r = (UB)GetRValue(rgbBase);
		g = (UB)GetGValue(rgbBase);
		b = (UB)GetBValue(rgbBase);
		pDL = pDibDest->pImage + (pDibDest->LineSize * (pDibDest->height - dpy - 1));
		pSL = pDibSrc ->pImage + (pDibSrc ->LineSize * (pDibSrc ->height - spy - 1));
		for (cy = 0; cy < tcy; cy++) {
			pDB = pDL + (pDibDest->PixelSize * dpx);
			pSB = pSL + (pDibSrc ->PixelSize * spx);
			for (cx = 0; cx < tcx; cx++) {
				sb = *(pSB + 0);
				sg = *(pSB + 1);
				sr = *(pSB + 2);
				len = sqrt(pow(r - sr, 2.0) + pow(g - sg, 2.0) + pow(b - sb, 2.0));
				if (len > distance) {
					memcpy(pDB, pSB, 3);
				}
				pDB += pDibDest->PixelSize;
				pSB += pDibSrc ->PixelSize;
			}
			pDL -= pDibDest->LineSize;
			pSL -= pDibSrc ->LineSize;
		}
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT BOOL		WINAPI AjcDibExcludedCopyV 	(PAJCDIBINFO pDibDest, const RECT *rcDest, PAJCDIBINFO pDibSrc , const POINT *ptSrc, COLORREF rgbBase, double distance)
{
	BOOL	rc = FALSE;

	if (rcDest != NULL && ptSrc != NULL) {
		rc = AjcDibExcludedCopy(pDibDest, rcDest->left, rcDest->top, rcDest->right - rcDest->left, rcDest->bottom - rcDest->top,
								pDibSrc , ptSrc ->x   , ptSrc ->y  , rgbBase, distance);
	}
	return rc;
}

//==============================================================================================================//
//	chaZNVchaZNV֕̐F͈͂IăRs[											//
//																												//
//	@F	pDibDest			- Rs[chaZNṼAhX									//
//				dpx, dpy, dcx, dcy	- Rs[`̈ʒuƃTCY												//
//				pDibSrc				- Rs[chaZNṼAhX									//
//				spx, spy, scx, scy	- Rs[`̈ʒuƃTCY												//
//				OpeNum				- I^OF͈͂̌												//
//																												//
//	߂lF	TRUE F																						//
//				FALSEFG[																					//
//==============================================================================================================//
typedef struct {
	int		ope;
	int		r, g, b;
	double	dist;
} DCS_NODE, *PDCS_NODE;
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT BOOL		WINAPI AjcDibSelectedCopy 	(PAJCDIBINFO pDibDest, int dpx, int dpy, int dcx, int dcy, PAJCDIBINFO pDibSrc , int spx, int spy, int OpeNum, ...)
{
	BOOL	rc = FALSE;
	int		scx, scy, tcx, tcy, cx, cy;
	int		sr, sg, sb;
	UBP		pDL, pSL, pDB, pSB;
	double	len;

	HAJCFQUE	hCorrect = NULL;
	HAJCFQUE	hExclude = NULL;

	int			i, ope;
	va_list 	vls;
	COLORREF	rgb;
	DCS_NODE	node;
	PDCS_NODE	pNode;
	BOOL		fCorrect, fExclude;

	if (pDibDest != NULL && pDibDest->BitCount >= 24 && dpx >= 0 && dpx < pDibDest->width && dpy >= 0 && dpy < pDibDest->height && 
		pDibSrc  != NULL && pDibSrc ->BitCount >= 24 && spx >= 0 && spx < pDibSrc ->width && spy >= 0 && spy < pDibSrc ->height && OpeNum > 0) {
		do {
			//----- FIp^̎W -----------------------------------------------//
			if ((hCorrect = AjcFQueCreate(sizeof(DCS_NODE), 0, NULL)) == NULL) break;
			if ((hExclude = AjcFQueCreate(sizeof(DCS_NODE), 0, NULL)) == NULL) break;
			va_start(vls, OpeNum);
			for (i = 0; i < OpeNum; i++) {
				ope  = (int 	)va_arg(vls, int);
				rgb  = (COLORREF)va_arg(vls, COLORREF);
				node.ope  = ope;
				node.r	  = (UB)GetRValue(rgb);
				node.g	  = (UB)GetGValue(rgb);
				node.b	  = (UB)GetBValue(rgb);
				node.dist = (double)va_arg(vls, double);
				switch (ope & AJCDIBSEL_MASK) {
					case AJCDIBSEL_CORRECT:
						if (!AjcFQueEnque(hCorrect, &node)) goto dsc_exit;
						break;

					case AJCDIBSEL_EXCLUDE:
						if (!AjcFQueEnque(hExclude, &node)) goto dsc_exit;
						break;

					default:
						goto dsc_exit;
				}
			}
			va_end	(vls);
			//----- Rs[rbg}bvTCYݒ -------------------------------------//
			if (dcx <= 0) dcx = pDibDest->width  - dpx;
			if (dcy <= 0) dcy = pDibDest->height - dpy;
			//----- Rs[rbg}bvTCY␳ -------------------------------------//
			if (dpx + dcx > pDibDest->width ) dcx = pDibDest->width  - dpx;
			if (dpy + dcy > pDibDest->height) dcy = pDibDest->height - dpy;
			//----- Rs[̍ősNZݒ ---------------------------------------//
			scx = pDibSrc->width  - spx;
			scy = pDibSrc->height - spy;
			//----- Rs[TCYݒ ---------------------------------------------------//
			tcx = __min(dcx, scx);
			tcy = __min(dcy, scy);
			//----- F̑IƃRs[ ---------------------------------------------------//
			pDL = pDibDest->pImage + (pDibDest->LineSize * (pDibDest->height - dpy - 1));
			pSL = pDibSrc ->pImage + (pDibSrc ->LineSize * (pDibSrc ->height - spy - 1));
			for (cy = 0; cy < tcy; cy++) {
				pDB = pDL + (pDibDest->PixelSize * dpx);
				pSB = pSL + (pDibSrc ->PixelSize * spx);
				for (cx = 0; cx < tcx; cx++) {
					sb = *(pSB + 0);
					sg = *(pSB + 1);
					sr = *(pSB + 2);
					// F̑I`FbN
					fCorrect = FALSE;
					if (pNode = AjcFQueTopNode(hCorrect)) {
						do {
							len = sqrt(pow(pNode->r - sr, 2.0) + pow(pNode->g - sg, 2.0) + pow(pNode->b - sb, 2.0));
							if (len <= pNode->dist) {
								ope = (pNode->ope & AJCDIBOPE_MASK);
								fCorrect = TRUE;
								break;
							}
						} while (pNode = AjcFQueNextNode(hCorrect, pNode));
					}
					//@F̏O`FbN
					fExclude = FALSE;
					if (pNode = AjcFQueTopNode(hExclude)) {
						do {
							len = sqrt(pow(pNode->r - sr, 2.0) + pow(pNode->g - sg, 2.0) + pow(pNode->b - sb, 2.0));
							if (len <= pNode->dist) {
								ope = (pNode->ope & AJCDIBOPE_MASK);
								fExclude = TRUE;
								break;
							}
						} while (pNode = AjcFQueNextNode(hExclude, pNode));
					}
					//@sNZERs[
					if (fCorrect  &&  !fExclude) {
						switch (ope) {
							case AJCDIBOPE_OR:
								*(pDB + 0) |= *(pSB + 0);
								*(pDB + 1) |= *(pSB + 1);
								*(pDB + 2) |= *(pSB + 2);
								break;
							case AJCDIBOPE_AND:
								*(pDB + 0) &= *(pSB + 0);
								*(pDB + 1) &= *(pSB + 1);
								*(pDB + 2) &= *(pSB + 2);
								break;
							case AJCDIBOPE_XOR:
								*(pDB + 0) ^= *(pSB + 0);
								*(pDB + 1) ^= *(pSB + 1);
								*(pDB + 2) ^= *(pSB + 2);
								break;
							case AJCDIBOPE_COPY:
							default:
							memcpy(pDB, pSB, 3);
						}
					}
					//	sNZ|C^XV
					pDB += pDibDest->PixelSize;
					pSB += pDibSrc ->PixelSize;
				}
				pDL -= pDibDest->LineSize;
				pSL -= pDibSrc ->LineSize;
			}
			rc = TRUE;
		} while(0);

dsc_exit:;

		//----- FIp^L[̉ ---------------------------------------------//
		if (hCorrect != NULL) AjcFQueDelete(hCorrect);
		if (hExclude != NULL) AjcFQueDelete(hExclude);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
#define AjcDibSelectedCopyV(pDibDest, rcDest, pDibSrc , ptSrc, OpeNum, ...)												\
	AjcDibSelectedCopy(pDibDest, rcDest->left, rcDest->top, rcDest->right - rcDest->left, rcDest->bottom - rcDest->top,	\
					   pDibSrc , ptSrc ->x	 , ptSrc ->y  , OpeNum, __VA_ARGS__)

//==============================================================================================================//
//	chaZNVœ̐F͈͂̃sNZJEg													//
//																												//
//	@F	pDibInfo			- chaZNṼAhX											//
//				x, y				- sNZJEg`̍ʒu									//
//				cx, cy				- sNZJEg`̃TCY										//
//				rgbBase				- sNZJEgF̃x[Xl										//
//				distance			- sNZJEgF̋											//
//																												//
//	߂lF	>=	0 F																					//
//				== -1 FG[																					//
//==============================================================================================================//
AJCEXPORT int		WINAPI AjcDibColorCount	(PAJCDIBINFO pDibInfo, int x, int y, int cx, int cy, COLORREF rgbBase, double distance)
{
	int		rc = -1;
	int		r, g, b, sr, sg, sb;
	UBP		pL, pB;
	int		i, j;
	double	len;

	if (pDibInfo != NULL && pDibInfo->BitCount >= 24 && x >= 0 && x < pDibInfo->width && y >= 0 && y < pDibInfo->height) {
		rc = 0;
		//----- `TCYݒ ---------------------------------------------------//
		if (cx <= 0) cx = pDibInfo->width  - x;
		if (cy <= 0) cy = pDibInfo->height - y;
		//----- `TCY␳ ---------------------------------------------------//
		if (x + cx > pDibInfo->width ) cx = pDibInfo->width  - x;
		if (y + cy > pDibInfo->height) cy = pDibInfo->height - y;
		//----- F̑IƃRs[ -------------------------------------------------//
		r = (UB)GetRValue(rgbBase);
		g = (UB)GetGValue(rgbBase);
		b = (UB)GetBValue(rgbBase);
		pL = pDibInfo->pImage + (pDibInfo->LineSize * (pDibInfo->height - y - 1));
		for (i = 0; i < cy; i++) {
			pB = pL + (pDibInfo->PixelSize * x);
			for (j = 0; j < cx; j++) {
				sb = *(pB + 0);
				sg = *(pB + 1);
				sr = *(pB + 2);
				len = sqrt(pow(r - sr, 2.0) + pow(g - sg, 2.0) + pow(b - sb, 2.0));
				if (len <= distance) {
					rc++;
				}
				pB += pDibInfo->PixelSize;
			}
			pL -= pDibInfo->LineSize;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT int		WINAPI AjcDibColorCountV(PAJCDIBINFO pDibInfo, const RECT *rcArea, COLORREF rgbBase, double distance)
{
	int		rc = -1;

	if (rcArea != NULL) {
		rc = AjcDibColorCount(pDibInfo, rcArea->left, rcArea->top, rcArea->right - rcArea->left, rcArea->bottom - rcArea->top, rgbBase, distance);
	}
	return rc;
}
//==============================================================================================================//
//	chaZNV̋`̈hԂiWƒwj												//
//																												//
//	@F	pDibInfo			- chaZNṼAhX											//
//				x, y				- sNZJEg`̍ʒu									//
//				cx, cy				- sNZJEg`̃TCY										//
//				rgb					- sNZJEgF̃x[Xl										//
//																												//
//	߂lF	>=	0 F																					//
//				== -1 FG[																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI	AjcDibFillRect		(PAJCDIBINFO pDibInfo, int x, int y, int cx, int cy, COLORREF rgb)
{
	int			rc = FALSE;
	UBP			pL, pB;

	if (pDibInfo != NULL && pDibInfo->BitCount >= 24 && x >= 0 && x < pDibInfo->width && y >= 0 && y < pDibInfo->height) {
		//----- `TCYݒ ---------------------------------------------------//
		if (cx <= 0) cx = pDibInfo->width  - x;
		if (cy <= 0) cy = pDibInfo->height - y;
		//----- `TCY␳ ---------------------------------------------------//
		if (x + cx > pDibInfo->width ) cx = pDibInfo->width  - x;
		if (y + cy > pDibInfo->height) cy = pDibInfo->height - y;
		//----- hԂ -------------------------------------------------------//
		pL = pDibInfo->pImage + (pDibInfo->LineSize * (pDibInfo->height - y - 1));
		if (pDibInfo->PixelSize == 4) {
			COLORREF	rev = ((rgb << 16) & 0x00FF0000) | (rgb & 0x0000FF00) | ((rgb >> 16) & 0x000000FF);
			int			i;
			for (i = 0; i < cy; i++) {
				pB = pL + (pDibInfo->PixelSize * x);
				AjcMemSet32(pB, rev, cx);
				pL -= pDibInfo->LineSize;
			}
		}
		else {
			int		r = (UB)GetRValue(rgb);
			int		g = (UB)GetGValue(rgb);
			int		b = (UB)GetBValue(rgb);
			int		i, j;
			for (i = 0; i < cy; i++) {
				pB = pL + (pDibInfo->PixelSize * x);
				for (j = 0; j < cx; j++) {
					*(pB + 0) = b;
					*(pB + 1) = g;
					*(pB + 2) = r;
					pB += pDibInfo->PixelSize;
				}
				pL -= pDibInfo->LineSize;
			}
		}
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT BOOL		WINAPI	AjcDibFillRectV		(PAJCDIBINFO pDibInfo, const RECT *pRect, COLORREF rgb)
{
	return AjcDibFillRect(pDibInfo, pRect->left, pRect->top, pRect->right - pRect->left, pRect->bottom - pRect->top, rgb);
}


//==============================================================================================================//
//	sNZ̎擾																								//
//																												//
//	@F	pDibInfo	- chaZNṼAhX													//
//				x			- C[W̃sNZʒuiO`j													//
//				y			- C[W̃Cʒu@iO`j													//
//																												//
//	߂lF	-1FsNZ̐F																				//
//				-1FG[																					//
//==============================================================================================================//
AJCEXPORT COLORREF	WINAPI AjcDibGetPixel	(PAJCDIBINFO pDibInfo, int x, int y)
{
	COLORREF			rc = -1;
	UBP					pBit;

	if (pDibInfo != NULL && x >= 0 && x < pDibInfo->width && y >= 0 && y < pDibInfo->height) {
		pBit = pDibInfo->pImage + ((pDibInfo->LineSize * (pDibInfo->height - y - 1)) + (pDibInfo->PixelSize * x));
		rc = RGB(*(pBit + 2), *(pBit + 1), *(pBit + 0));
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT COLORREF	WINAPI AjcDibGetPixelV	(PAJCDIBINFO pDibInfo, const POINT *pt)
{
	COLORREF			rc = -1;

	if (pt != NULL) {
		rc = AjcDibGetPixel	(pDibInfo, pt->x, pt->y);
	}
	return rc;
}

//==============================================================================================================//
//	sNZ̐ݒ																								//
//																												//
//	@F	pDibInfo	- chaZNṼAhX													//
//				x			- C[W̃sNZʒuiO`j													//
//				y			- C[W̃Cʒu@iO`j													//
//				rgb			- ݒ肷F																		//
//																												//
//	߂lF	TRUE  F																					//
//				FALSE FG[																					//
//==============================================================================================================//
AJCEXPORT BOOL		WINAPI AjcDibSetPixel	(PAJCDIBINFO pDibInfo, int x, int y, COLORREF rgb)
{
	COLORREF			rc = -1;
	UBP					pBit;

	if (pDibInfo != NULL && x >= 0 && x < pDibInfo->width && y >= 0 && y < pDibInfo->height) {
		pBit = pDibInfo->pImage + ((pDibInfo->LineSize * (pDibInfo->height - y - 1)) + (pDibInfo->PixelSize * x));
		*(pBit + 0) = GetBValue(rgb);
		*(pBit + 1) = GetGValue(rgb);
		*(pBit + 2) = GetRValue(rgb);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT BOOL		WINAPI AjcDibSetPixelV	(PAJCDIBINFO pDibInfo, const POINT *pt, COLORREF rgb)
{
	COLORREF			rc = -1;

	if (pt != NULL) {
		rc = AjcDibSetPixel	(pDibInfo, pt->x, pt->y, rgb);
	}
	return rc;
}
//==============================================================================================================//
//	C̐擪AhX擾																					//
//																												//
//	@F	pDibInfo	- chaZNṼAhX													//
//				y			- C[W̃Cʒu@iO`j													//
//																												//
//	߂l	F	NULLFC̐擪AhX																	//
//				NULLFG[																					//
//==============================================================================================================//
AJCEXPORT UBP		WINAPI AjcDibGetLinrPtr	(PAJCDIBINFO pDibInfo, int y)
{
	UBP			rc = NULL;

	if (pDibInfo != NULL && y >= 0 && y < pDibInfo->height) {
		rc = pDibInfo->pImage + (pDibInfo->LineSize * (pDibInfo->height - y - 1));
	}
	return rc;
}
//==============================================================================================================//
//	chaZNV̐ƃrbg}bvt@Cǂݏo														//
//																												//
//	@	F	pFilePath - rbg}bvt@C̃pX														//
//				pBuf	  - chaZNV̏i[邉obt@̃AhXisv͂mtkkj	//
//																												//
//	߂l	F	NULLFrbg}bvnh																	//
//				NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT HBITMAP WINAPI	AjcDibReadFileAndCreateA(C_BCP pFilePath, PAJCDIBINFO pBuf)
{
	HBITMAP	rc = NULL;
	int		len;
	WCP		pTmp;

	if (pFilePath != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pFilePath, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pFilePath, -1, pTmp, len);
			rc = AjcDibReadFileAndCreateW(pTmp, pBuf);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT HBITMAP WINAPI	AjcDibReadFileAndCreateW(C_WCP pFilePath, PAJCDIBINFO pBuf)
{
	HBITMAP				rc = NULL;
	UBP					pBits;
	DWORD				dwBytesRead;
	HANDLE				hFile = INVALID_HANDLE_VALUE;
	HBITMAP				hBitmap;
	BITMAPFILEHEADER	BmapFh;			//	rbg}bvt@Cwb_
	LPBITMAPINFO		pBmapIf = NULL;	//	rbg}bv
	UI					lBmapIf = 0;	//	rbg}bṽTCY
	UI					lImage	= 0;	//	C[Wf[^oCg

	do {
		if (pFilePath == NULL) break;
		//----- rbg}bvt@C I[v ------------------------------------------------------------------//
		if ((hFile = CreateFile (pFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == 
																						INVALID_HANDLE_VALUE) {
			break;
		}
		//----- rbg}bvt@Cwb_ǂݏo -------------------------------------------------------------//
		if (!ReadFile (hFile, &BmapFh, sizeof (BITMAPFILEHEADER), &dwBytesRead, NULL)) {
			break;
		}
		//----- rbg}bvt@Cwb_̓e`FbN -------------------------------------------------------//
		if (dwBytesRead != sizeof(BITMAPFILEHEADER) || BmapFh.bfType != *(WORD *)"BM") {
			break;
		}
		//----- rbg}bvǂݏo -----------------------------------------------------------------------//
		lBmapIf = BmapFh.bfOffBits - sizeof (BITMAPFILEHEADER) ;
		pBmapIf = (LPBITMAPINFO)AJCMEM(lBmapIf);
		if (pBmapIf == NULL) break;
		if (!ReadFile (hFile, pBmapIf, lBmapIf, &dwBytesRead, NULL)) {
			break;
		}
		//----- rbg}bvǂݏoTCY`FbN ---------------------------------------------------------//
		if (dwBytesRead != lBmapIf) {
			break;
		}
		//----- chardbshnm쐬 -----------------------------------------------------------------------//
		if ((hBitmap = CreateDIBSection (NULL, pBmapIf, DIB_RGB_COLORS, (void **)&pBits, NULL, 0)) == NULL) {
			break;
		}
		//----- rbg}bvC[Wǂݏo -------------------------------------------------------------------//
		lImage = BmapFh.bfSize - BmapFh.bfOffBits;
		if (!ReadFile(hFile, pBits, lImage, &dwBytesRead, NULL)) {
			DeleteObject(hBitmap);
			break;
		}
		//---- C[WǂݏoTCY`FbN ------------------------------------------------------------------//
		if (dwBytesRead != lImage) {
			DeleteObject(hBitmap);
			break;
		}
		//----- chaZNVݒ -----------------------------------------------------------------------//
		if (pBuf != NULL) {
			pBuf->hBmp = hBitmap;
			//-- rbg}bvTCY -------------//
			if (pBmapIf->bmiHeader.biSize == sizeof (BITMAPCOREHEADER)) {
				pBuf->BitCount = ((BITMAPCOREHEADER *) pBmapIf)->bcBitCount;
				pBuf->width    = ((BITMAPCOREHEADER *) pBmapIf)->bcWidth;
				pBuf->height   = ((BITMAPCOREHEADER *) pBmapIf)->bcHeight;
			}
			else {
				pBuf->BitCount = pBmapIf->bmiHeader.biBitCount;
				pBuf->width    = pBmapIf->bmiHeader.biWidth;
				pBuf->height   = pBmapIf->bmiHeader.biHeight;
			}
			pBuf->PixelSize = pBuf->BitCount / 8;
			pBuf->LineSize	= ((pBuf->width * pBuf->BitCount + 31) & ~31) >> 3;
			pBuf->pImage	= pBits;
		}
		//----- ߂lirbg}bvnhjݒ -------------------------------------------------------------//
		rc = hBitmap;
	} while(0);

	//----- \[XJ ---------------------------------------------------------------------------------------//
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);
	if (pBmapIf != NULL) free(pBmapIf); pBmapIf = NULL;

	return rc;
}
