#include	"AjcInternal.h"

//==============================================================================================================//
//	tH_\̃Rs[																						//
//																												//
//	@F	pPathFrom	- Rs[擪tH_pX̃AhX												//
//				pPathTo		- Rs[擪tH_pX̃AhX												//
//				opt			- IvVtO																	//
//				cbp 		- R[obNp^																//
//				cbNotify	- tH_Rs[ʒʒmpR[obN֐isvNULL)							//
//				cbQuery		- tH_Rs[^̕ύX̖₢킹pR[obN֐isvNULL)				//
//																												//
//	߂l	F	TRUE F																						//
//				FALSEFs																						//
//==============================================================================================================//
//	CX^X[N
typedef struct {
	BOOL		rc;							//	߂l
	BOOL		fUnicode;					//	ASCII / UNICODE 
	UI			opt;						//	IvV
	UX			cbp; 						//	R[obNp^
	union {									//	R[obN֐
		//	ASCII
		struct {
			BOOL (CALLBACK *cbNotify)(C_BCP pPathFrom , C_BCP pPathTo, EAJCCFS ntc, UX cbp);
			BCP  (CALLBACK *cbQuery )(C_BCP pPathFront,   BCP pNewDir,				UX cbp);
		} asc;
		//	UNICODE
		struct {
			BOOL (CALLBACK *cbNotify)(C_WCP pPathFrom , C_WCP pPathTo, EAJCCFS ntc, UX cbp);
			WCP  (CALLBACK *cbQuery )(C_WCP pPathFront,   WCP pNewDir,				UX cbp);
		} uni;
		//	
		struct {
			VOP		vpNotify;
			VOP		vpQuery;
		} vp;
	} u;
} CFSWK, *PCFSWK;

//	Tu֐
static	BOOL	SubCopyFolderStructExW		(PCFSWK pW, C_WCP pPathFrom, WCP pPathTo);
static	BOOL	SubMakeFolderW				(PCFSWK pW, C_WCP pPathFrom, WCP pPathTo, WCP pName);

//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCopyFolderStructA(C_BCP pPathFrom, C_BCP pPathTo, UI opt)
{
	return AjcCopyFolderStructExA(pPathFrom, pPathTo, opt, 0, NULL, NULL);

}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	BOOL	WINAPI	AjcCopyFolderStructExA(C_BCP pPathFrom, C_BCP pPathTo, UI opt, UX cbp, 
													BOOL (CALLBACK *cbNotify)(C_BCP pPathFrom , C_BCP pPathTo, EAJCCFS ntc, UX cbp),
													BCP  (CALLBACK *cbQuery )(C_BCP pPathFront,   BCP pNewDir,				UX cbp))
{
	BOOL	rc = FALSE;
	CFSWK	wrk = {0};
	WC		PathFrom[MAX_PATH];
	WC		PathTo	[MAX_PATH];
	WC		tail	[MAX_PATH];
	WC		fname	[_MAX_FNAME];
	WC		fext	[_MAX_EXT];

	if (pPathFrom != NULL && pPathTo != NULL && AjcPathIsDirectoryA(pPathFrom) && AjcPathIsDirectoryA(pPathTo)) {
		//	[N
		wrk.rc				= TRUE;
		wrk.fUnicode		= FALSE;
		wrk.opt				= opt;
		wrk.cbp				= cbp;
		wrk.u.asc.cbNotify	= cbNotify;
		wrk.u.asc.cbQuery	= cbQuery;
		//	pXChɕϊ
		MultiByteToWideChar(CP_ACP, 0, pPathFrom, -1, PathFrom, MAX_PATH);
		MultiByteToWideChar(CP_ACP, 0, pPathTo	, -1, PathTo  , MAX_PATH);
		//	Rs[tH_] 擪tH_Ƃč쐬
		if (opt & AJCFSC_MAKETOP) {
			//	Rs[̖tH_쐬
			AjcSnPrintFW(tail, MAX_PATH, L"%s", PathFrom);
			PathRemoveBackslashW(tail);
			_wsplitpath(tail, NULL, NULL, fname, fext);
			_wmakepath (tail, NULL, NULL, fname, fext);
			//	擪tH_쐬
			SubMakeFolderW(&wrk, PathFrom, PathTo, tail);
			//	擪tH_ɖǉ
			AjcPathCatW(PathTo, tail, MAX_PATH);
		}
		//	Rs[tH_pXݒ
		else {
			AjcSnPrintFW(PathTo, MAX_PATH, L"%s", PathTo);
		}
		//	tH_\쐬
		SubCopyFolderStructExW(&wrk, PathFrom, PathTo);
		rc = wrk.rc;
		//	G[ݒ
		if (wrk.rc) {
			SetLastError(ERROR_SUCCESS);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCopyFolderStructW(C_WCP pPathFrom, C_WCP pPathTo, UI opt)
{
	return AjcCopyFolderStructExW(pPathFrom, pPathTo, opt, 0, NULL, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	BOOL	WINAPI	AjcCopyFolderStructExW(C_WCP pPathFrom, C_WCP pPathTo, UI opt, UX cbp, 
												BOOL (CALLBACK *cbNotify)(C_WCP pPathFrom , C_WCP pPathTo, EAJCCFS opt, UX cbp),
												WCP  (CALLBACK *cbQuery )(C_WCP pPathFront,   WCP pNewDir,				UX cbp))
{
	BOOL	rc = FALSE;
	CFSWK	wrk = {0};
	WC		PathTo[MAX_PATH];
	WC		tail  [MAX_PATH];
	WC		fname [_MAX_FNAME];
	WC		fext  [_MAX_EXT];

	if (pPathFrom != NULL && pPathTo != NULL && AjcPathIsDirectoryW(pPathFrom) && AjcPathIsDirectoryW(pPathTo)) {
		//	[N
		wrk.rc				= TRUE;
		wrk.fUnicode		= TRUE;
		wrk.opt				= opt;
		wrk.cbp				= cbp;
		wrk.u.uni.cbNotify	= cbNotify;
		wrk.u.uni.cbQuery	= cbQuery;
		//	Rs[tH_] 擪tH_Ƃč쐬
		if (opt & AJCFSC_MAKETOP) {
			//	Rs[̖tH_쐬
			AjcSnPrintFW(tail, MAX_PATH, L"%s", pPathFrom);
			PathRemoveBackslashW(tail);
			_wsplitpath(tail, NULL, NULL, fname, fext);
			_wmakepath (tail, NULL, NULL, fname, fext);
			//	]tH_ݒ
			AjcSnPrintFW(PathTo, MAX_PATH, L"%s", pPathTo);
			//	擪tH_쐬
			SubMakeFolderW(&wrk, pPathFrom, PathTo, tail);
			//	擪tH_ɖǉ
			AjcPathCatW(PathTo, tail, MAX_PATH);
		}
		//	Rs[tH_pXݒ
		else {
			AjcSnPrintFW(PathTo, MAX_PATH, L"%s", pPathTo);
		}
		//	tH_\쐬
		SubCopyFolderStructExW(&wrk, pPathFrom, PathTo);
		rc = wrk.rc;
		//	G[ݒ
		if (wrk.rc) {
			SetLastError(ERROR_SUCCESS);
		}
	}
	return rc;
}
//----- ʃTu -----------------------------------------------------------------------------------------------//
static	BOOL	SubCopyFolderStructExW(PCFSWK pW, C_WCP pPathFrom, WCP pPathTo)
{
	HANDLE				hFind;
	WIN32_FIND_DATAW	fd;
	WC					FromTop [MAX_PATH] = {0};
	WC					FromWild[MAX_PATH] = {0};
	WC					FromFind[MAX_PATH] = {0};
	WC					ToTop	[MAX_PATH] = {0};
	WC					ToFind	[MAX_PATH] = {0};

	if (pW->rc) {
		if (pPathFrom != NULL && pPathTo != NULL && AjcPathIsDirectoryW(pPathFrom) && AjcPathIsDirectoryW(pPathTo)) {
			AjcSnPrintFW(FromTop , MAX_PATH, L"%s", pPathFrom);
			AjcSnPrintFW(FromWild, MAX_PATH, L"%s", pPathFrom);
			AjcPathCatW (FromWild, L"*.*", MAX_PATH);
			AjcSnPrintFW(ToTop	 , MAX_PATH, L"%s", pPathTo	);
			if ((hFind = FindFirstFileW(FromWild, &fd)) != INVALID_HANDLE_VALUE) {
				do {
					//	pX̓fBNgEE
					if ((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) &&
								wcscmp(fd.cFileName, L".") != 0 && wcscmp(fd.cFileName, L"..") != 0) {
						// Rs[fBNgݒ
						AjcSnPrintFW(FromFind, MAX_PATH, L"%s", FromTop);
						AjcPathCatW (FromFind, fd.cFileName, MAX_PATH);
						// Rs[fBNgݒ
						AjcSnPrintFW(ToFind, MAX_PATH, L"%s", ToTop);
						//	fBNg쐬
						SubMakeFolderW(pW, FromFind, ToFind, fd.cFileName);
						// ̊KwցiċAj
						AjcPathCatW(ToFind, fd.cFileName, MAX_PATH);
						SubCopyFolderStructExW(pW, FromFind, ToFind);
					}
				} while (pW->rc && FindNextFileW(hFind, &fd));
				FindClose(hFind);
			}
		}
	}
	return pW->rc;
}
//	tH_쐬
static	BOOL	SubMakeFolderW(PCFSWK pW, C_WCP pPathFrom, WCP pPathTo, WCP pName)
{
	WC		ToFind	[MAX_PATH];
	WC		ToDir	[MAX_PATH];

	if (pW->rc) {
		do {
			//	Rs[fBNgύX̖₢킹
			AjcSnPrintFW(ToDir, MAX_PATH, L"%s", pName);
			if (pW->u.vp.vpQuery != NULL) {
				//	R[obN(UNICODE)
				if (pW->fUnicode) {
					WCP		pDir;
					WC		PathTo[MAX_PATH * 2 + 1] = {0};
					UI		stl;
					//	dŁAuRs[pXvƁuRs[pXv쐬
					MAjcStrCpy(PathTo, MAX_PATH, pPathTo);
					stl = (UI)wcslen(PathTo);
					MAjcStrCpy(&PathTo[stl + 1], MAX_PATH, pPathFrom);
					//	R[obN
					if ((pDir = pW->u.uni.cbQuery(PathTo, ToDir, pW->cbp)) != NULL) {
						if (pDir != ToDir) {
							AjcSnPrintFW(ToDir, MAX_PATH, L"%s", pDir);
						}
						//	ύX̂Ԃ
						AjcSnPrintFW(pName, MAX_PATH, L"%s", ToDir);
					}
					else ToDir[0] = 0;
				}
				//	R[obN(ASCII)
				else {
					BCP		pDir;
					BC		PathTo[MAX_PATH * 2 + 1] = {0};
					BC		to	 [MAX_PATH];
					UI		stl;
					//	oCgɕϊ
					WideCharToMultiByte(CP_ACP, 0, pPathTo, -1, PathTo, MAX_PATH, NULL, NULL);	//	Rs[pX
					WideCharToMultiByte(CP_ACP, 0, ToDir  , -1, to	  , MAX_PATH, NULL, NULL);	//	VtH_
					//	dŁAuRs[pXvƁuRs[pXv쐬
					stl = (UI)strlen(PathTo);
					WideCharToMultiByte(CP_ACP, 0, pPathFrom, -1, &PathTo[stl + 1], MAX_PATH, NULL, NULL);	//	Rs[pX
					//	R[obN
					if ((pDir = pW->u.asc.cbQuery(PathTo, to, pW->cbp)) != NULL) {
						if (pDir == to) MultiByteToWideChar(CP_ACP, 0, to  , -1, ToDir, MAX_PATH);
						else			MultiByteToWideChar(CP_ACP, 0, pDir, -1, ToDir, MAX_PATH);
						//	ύX̂Ԃ
						AjcSnPrintFW(pName, MAX_PATH, L"%s", ToDir);
					}
					else ToDir[0] = 0;
				}
			}
			//	fBNg쐬ꍇEE
			if (ToDir[0] != 0) {
				// Rs[fBNgݒ
				AjcSnPrintFW(ToFind, MAX_PATH, L"%s", pPathTo);
				AjcPathCatW (ToFind, ToDir			, MAX_PATH);
				//	pX݂ȂꍇAVȃfBNg쐬
				if (!PathFileExistsW(ToFind)) {
					// Rs[fBNg쐬
					BOOL rsu = (CreateDirectoryExW(pPathFrom, ToFind, NULL) != 0);
					//	fBNg쐬Ȃ΁Aʒm
					if (rsu) {
						AJCFTIMES ftm;
						if (pW->u.vp.vpNotify != NULL) {
							//	fBNg쐬ʒmiUNICODEj
							if (pW->fUnicode) {
								if (!pW->u.uni.cbNotify(pPathFrom, ToFind, AJCCFS_SUCCESS, pW->cbp)) {
									pW->rc = FALSE;
									break;
								}
							}
							//	fBNg쐬ʒmiASCIIj
							else {
								BC	from[MAX_PATH];
								BC	to	[MAX_PATH];
								WideCharToMultiByte(CP_ACP, 0, pPathFrom, -1, from, MAX_PATH, NULL, NULL);
								WideCharToMultiByte(CP_ACP, 0, ToFind	, -1, to  , MAX_PATH, NULL, NULL);
								if (!pW->u.asc.cbNotify(from, to, AJCCFS_SUCCESS, pW->cbp)) {
									pW->rc	= FALSE;
									break;
								}
							}
						}
						//	fBNg̃^CX^vRs[ɍ킹
						if (pW->opt & (AJCFSC_SAMETIME | AJCFSC_FORCETIME)) {
							if (AjcGetFileTimeW(pPathFrom, &ftm, NULL, FALSE)) {
								AjcSetFileTimeW(ToFind	 , &ftm, FALSE);
							}
						}
					}
					//	fBNg쐬sȂ΁Asʒm
					else {
						//	sʒm
						if (pW->u.vp.vpNotify != NULL) {
							//	sʒmiUNICODEj
							if (pW->fUnicode) {
								pW->u.uni.cbNotify(pPathFrom, ToFind, AJCCFS_SUCCESS, pW->cbp);
							}
							//	sʒmiASCIIj
							else {
								BC	from[MAX_PATH];
								BC	to	[MAX_PATH];
								WideCharToMultiByte(CP_ACP, 0, pPathFrom, -1, from, MAX_PATH, NULL, NULL);
								WideCharToMultiByte(CP_ACP, 0, ToFind	, -1, to  , MAX_PATH, NULL, NULL);
								pW->u.asc.cbNotify(from, to, AJCCFS_SUCCESS, pW->cbp);
							}
						}
						//	߂lG[
						pW->rc = FALSE;
					}
				}
				//	ɃpX݂ꍇEE
				else {
					//	tH_ĂG[ƂȂꍇ
					if (pW->opt & AJCFSC_ALLOWEXIST) {
						//	upXvʒm
						if (pW->u.vp.vpNotify != NULL) {
							if (pW->fUnicode) {
								if (!pW->u.uni.cbNotify(pPathFrom, ToFind, AJCCFS_EXIST, pW->cbp)) {
									pW->rc	= FALSE;
									break;
								}
							}
							else {
								BC	from[MAX_PATH];
								BC	to	[MAX_PATH];
								WideCharToMultiByte(CP_ACP, 0, pPathFrom, -1, from, MAX_PATH, NULL, NULL);
								WideCharToMultiByte(CP_ACP, 0, ToFind	, -1, to  , MAX_PATH, NULL, NULL);
								if (!pW->u.asc.cbNotify(from, to, AJCCFS_EXIST, pW->cbp)) {
									pW->rc	= FALSE;
									break;
								}
							}
						}
						//	pXtH_Ȃ΁A^CX^vݒ
						if (AjcPathIsDirectory(ToFind)) {
							AJCFTIMES ftm;
							//	fBNg̃^CX^vRs[ɍ킹
							if (pW->opt & AJCFSC_FORCETIME) {
								if (AjcGetFileTimeW(pPathFrom, &ftm, NULL, FALSE)) {
									AjcSetFileTimeW(ToFind	 , &ftm, FALSE);
								}
							}
						}
						//	pXtH_ȊOȂ΃G[
						else {
							pW->rc = FALSE;
						}
					}
					//	tH_ꍇG[Ƃꍇ
					else {
						pW->rc = FALSE;
					}
				}
			}
		} while(0);
	}
	return pW->rc;
}

//==============================================================================================================//
//	tH_t@CRs[																					//
//																												//
//	@F	pPathFrom	  - Rs[tH_pX{ChJ[h̃AhX								//
//				pPathTo		  - Rs[擪tH_pX̃AhX												//
//				pWildCard	  - Rs[t@C̃ChJ[hiNULLw莞́A"*.*"j					//
//				opt			  - IvV(AJCCPF_XXXXX)														//
//				cbp			  - R[obNp^															//
//				cbNotify	  - t@CRs[ʒʒmpR[obN֐isvNULL)							//
//				cbQuery		  - t@CRs[^̕ύX̖₢킹pR[obN֐isvNULL)			//
//																												//
//	߂l	F	TRUE F																						//
//				FALSEFs																						//
//==============================================================================================================//
//	[N
typedef struct {
	UX		cbp;
	BOOL (CALLBACK *cbNotify)(C_BCP pFileFrom, C_BCP pFileTo  , EAJCCFS ntc , UX cbp);
	BCP  (CALLBACK *cbQuery )(C_BCP pFileFrom, C_BCP pFileTo, BCP pFileName, UIP pAtt, UX cbp);
} CPFSWRK, *PCPFSWRK;

static	BOOL CALLBACK cbCpfsNotify(C_WCP pFileFrom, C_WCP pFileTo  , EAJCCFS ntc , UX cbp);
static	WCP  CALLBACK cbCpfsQuery (C_WCP pFileFrom, C_WCP pFileTo, WCP pFileName, UIP pAtt, UX cbp);

//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcCopyFilesA(C_BCP pPathFrom, C_BCP pPathTo, C_BCP pWildCard, UI opt)
{
	return AjcCopyFilesExA(pPathFrom, pPathTo, pWildCard, opt, 0, NULL, NULL, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	BOOL	WINAPI AjcCopyFilesExA(C_BCP pPathFrom, C_BCP pPathTo, C_BCP pWildCard, UI opt, UX cbp,
											BOOL (CALLBACK *cbNotify)(C_BCP pFileFrom, C_BCP pFileTo  , EAJCCFS ntc , UX cbp),
											BCP  (CALLBACK *cbQuery )(C_BCP pFileFrom, C_BCP pFileTo, BCP pFileName, UIP pAtt, UX cbp),
											BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp))
{
	BOOL				rc	 = FALSE;
	CPFSWRK				wrk  = {0};
	BOOL				fCan = FALSE;
	WC					PathFrom[MAX_PATH];
	WC					PathTo 	[MAX_PATH];
	WC					WildCard[MAX_PATH];

	if (pPathFrom != NULL && pPathTo != NULL) {
		//	[N
		wrk.cbp			= cbp;
		wrk.cbNotify	= cbNotify;
		wrk.cbQuery		= cbQuery;
		//	Ch
		MultiByteToWideChar(CP_ACP, 0, pPathFrom, -1, PathFrom, MAX_PATH);
		MultiByteToWideChar(CP_ACP, 0, pPathTo	, -1, PathTo  , MAX_PATH);
		//	ChJ[hw肠
		if (pWildCard != NULL) {
			MultiByteToWideChar(CP_ACP, 0, pWildCard, -1, WildCard, MAX_PATH);
			//	t@CQRs[
			cbp = (UX)&wrk;
			rc = AjcCopyFilesExW(PathFrom, PathTo, WildCard, opt, cbp, cbCpfsNotify, cbCpfsQuery, cbProgress);
		}
		//	ChJ[hwȂ
		else {
			//	t@CQRs[
			cbp = (UX)&wrk;
			rc = AjcCopyFilesExW(PathFrom, PathTo, NULL    , opt, cbp, cbCpfsNotify, cbCpfsQuery, cbProgress);
		}
	}
	return rc;
}
//- - - R[obN(cbNotify) - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	BOOL CALLBACK cbCpfsNotify(C_WCP pFileFrom, C_WCP pFileTo  , EAJCCFS ntc , UX cbp)
{
	BOOL		rc;
	PCPFSWRK	p = (PCPFSWRK)cbp;
	BC			FileFrom[MAX_PATH];
	BC			FileTo	[MAX_PATH];

	if (p->cbNotify != NULL) {
		WideCharToMultiByte(CP_ACP, 0, pFileFrom, -1, FileFrom, MAX_PATH, NULL, NULL);
		WideCharToMultiByte(CP_ACP, 0, pFileTo	, -1, FileTo  , MAX_PATH, NULL, NULL);
		rc = p->cbNotify(FileFrom, FileTo, ntc, p->cbp);
	}
	return rc;
}
//- - - R[obN(cbQueryy) - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	WCP CALLBACK cbCpfsQuery(C_WCP pFileFrom, C_WCP pFileTo, WCP pFileName, UIP pAtt, UX cbp)
{
	WCP			rc = pFileName;
	BCP			ret;
	PCPFSWRK	p = (PCPFSWRK)cbp;
	BC			FileFrom[MAX_PATH];
	BC			FileTo	[MAX_PATH];
	BC			FileName[MAX_PATH];

	if (p->cbQuery != NULL) {
		WideCharToMultiByte(CP_ACP, 0, pFileFrom, -1, FileFrom, MAX_PATH, NULL, NULL);
		WideCharToMultiByte(CP_ACP, 0, pFileTo	, -1, FileTo  , MAX_PATH, NULL, NULL);
		WideCharToMultiByte(CP_ACP, 0, pFileName, -1, FileName, MAX_PATH, NULL, NULL);
		if (ret = p->cbQuery(FileFrom, FileTo, FileName, pAtt, p->cbp)) {
			MultiByteToWideChar(CP_ACP, 0, FileName, -1, pFileName, MAX_PATH);
		}
		else rc = NULL;
	}
	return rc;
}

//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcCopyFilesExW	(C_WCP pPathFrom, C_WCP pPathTo, C_WCP pWildCard, UI opt, UX cbp,
								BOOL (CALLBACK *cbNotify)(C_WCP pFileFrom, C_WCP pFileTo  , EAJCCFS ntc , UX cbp),
								WCP  (CALLBACK *cbQuery )(C_WCP pFileFrom, C_WCP pFileTo, WCP pFileName, UIP pAtt, UX cbp),
								BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp))
{
	BOOL				rc	 = FALSE;
	BOOL				fCan = FALSE;
	HANDLE				hFind;
	WIN32_FIND_DATAW	fd;
	WC					WildPath[MAX_PATH];		//	pX{ChJ[h
	WC					src 	[MAX_PATH];		//	Rs[t@CpX
	WC					dst 	[MAX_PATH];		//	Rs[t@CpX
	WC					fname	[MAX_PATH];		//	Rs[t@C


	if (pPathFrom != NULL && pPathTo != NULL) {
		rc = TRUE;
		AjcSnPrintFW(WildPath, MAX_PATH, L"%s", pPathFrom);
		AjcPathCatW(WildPath, L"*.*"   , MAX_PATH);
		if ((hFind = FindFirstFileW(WildPath, &fd)) != INVALID_HANDLE_VALUE) {
			do {
				// t@CȂ΃Rs[
				if (!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
					//	ChJ[h`FbN
					if (pWildCard == NULL ||
						(!(opt & AJCCPF_WILDEXC) &&  AjcPathMatchSpecW(fd.cFileName, pWildCard)) ||
						( (opt & AJCCPF_WILDEXC) && !AjcPathMatchSpecW(fd.cFileName, pWildCard))) {
						UI	attSrc, attDst;
						//	Rs[t@CpXݒ
						AjcSnPrintFW(src, MAX_PATH, L"%s", pPathFrom);	AjcPathCatW(src, fd.cFileName, MAX_PATH);
						//	Rs[t@CpXݒ
						AjcSnPrintFW(dst, MAX_PATH, L"%s", pPathTo	);	AjcPathCatW(dst, fd.cFileName, MAX_PATH);
						//	Rs[t@Cݒ
						attSrc = GetFileAttributesW(src);
						attDst = attSrc;
						//	Rs[t@Cݒ
						AjcSnPrintFW(fname, MAX_PATH, L"%s", fd.cFileName);
						//	t@CRs[ہ^t@CύX₢킹
						if (cbQuery != NULL) {
							WCP		pFile;
							if ((pFile = cbQuery(src, dst, fname, &attDst, cbp)) != NULL) {
								if (pFile != fname) {
									AjcSnPrintFW(fname, MAX_PATH, L"%s", pFile);
								}
							}
							else fname[0] = 0;
						}
						if (fname[0] != 0) {
							//	Rs[t@CpXĐݒ
							AjcSnPrintFW(dst, MAX_PATH, L"%s", pPathTo);
							AjcPathCatW (dst, fname, MAX_PATH);
							//	t@C㏑^Rs[t@CȂ΃Rs[s
							if ((opt & AJCCPF_CREATEALWAYS) || !AjcPathExistsW(dst)) {
								BOOL	rsu;
								UI		attTmp;
								//	t@C㏑Ȃ΁Aȃt@C
								if (opt & AJCCPF_CREATEALWAYS) {
									if ((attTmp = GetFileAttributesW(dst)) != INVALID_FILE_ATTRIBUTES) {
										SetFileAttributesW(dst, attTmp & ~(FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_SYSTEM));
									}
								}
								//	t@CRs[
								if (rsu = AjcCopyFileExW(src, dst, opt, &fCan, cbp, cbProgress)) {
									//	t@Cݒ
									if (attSrc != INVALID_FILE_ATTRIBUTES && attSrc != attDst) {
										SetFileAttributesW(dst, attDst);
									}
								}
								//	t@CRs[LZȂΏI
								if (fCan) {
									rc = FALSE;
									break;
								}
								//	ʒʒm
								if (rsu) {
									if (cbNotify != NULL) {
										if (!cbNotify(src, dst, AJCCFS_SUCCESS, cbp)) break;
									}
								}
								else {
									rc = FALSE;
									if (cbNotify != NULL) {
										if (!cbNotify(src, dst, AJCCFS_FAILURE, cbp)) break;
									}
								}
							}
							//	t@C㏑ȂRs[t@CLȂ΃Rs[Ȃ|ʒm
							else {
								if (cbNotify != NULL) {
									if (!cbNotify(src, dst, AJCCFS_EXIST, cbp)) break;
								}
							}
						}
					}
				}
			} while (FindNextFileW(hFind, &fd));
			FindClose(hFind);
		}
	}
	return rc;
}
//==============================================================================================================//
//	t@CRs[																								//
//																												//
//	@	F	pFrom			- Rs[t@CpXւ̃|C^											//
//				pTo				- Rs[t@CpXւ̃|C^											//
//				fCreateAlways	- t@Cɑ݂ꍇ̓iTRUE:㏑CFALSE:Rs[Ȃj			//
//				pfCancel		- ~tOe_obt@|C^isvNULLj					//
//				cbp				- R[obNp^															//
//				cbProgress		- t@CRs[󋵒ʒmpR[obN֐										//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCopyFileA(C_BCP pFrom, C_BCP pTo, BOOL fCreateAlways, UX cbp, BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp))
{
	return	AjcCopyFileExA(pFrom,pTo, fCreateAlways, NULL, cbp, cbProgress);
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCopyFileExA(C_BCP pFrom, C_BCP pTo, BOOL fCreateAlways, BOOL *pfCancel, UX cbp, BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp))
{
	BOOL	rc = FALSE;
	WC		PathFrom[MAX_PATH] = {0};
	WC		PathTo	[MAX_PATH] = {0};

	if (pFrom != NULL && pTo != NULL) {
		AjcByteCharToWideChar(pFrom, PathFrom, MAX_PATH);
		AjcByteCharToWideChar(pTo  , PathTo  , MAX_PATH);
		rc = AjcCopyFileW(PathFrom, PathTo, fCreateAlways, cbp, cbProgress);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCopyFileW(C_WCP pFrom, C_WCP pTo, BOOL fCreateAlways, UX cbp, BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp))
{
	return	AjcCopyFileExW(pFrom,pTo, fCreateAlways, NULL, cbp, cbProgress);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	BOOL	WINAPI	AjcCopyFileExW(C_WCP pFrom, C_WCP pTo, BOOL fCreateAlways, BOOL *pfCancel, UX cbp, BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp))
{
	BOOL		rc		= FALSE;
	HANDLE		hInp	= INVALID_HANDLE_VALUE;
	HANDLE		hOut	= INVALID_HANDLE_VALUE;
	UL			att		= 0;
	UL			RBytes	= 0;
	UL			WBytes	= 0;
	ULL			size	= 0;
	UL			count	= 0;
	FILETIME	ftCreate	= {0};
	FILETIME	ftLastAcc	= {0};
	FILETIME	ftLastWrt	= {0};
	WC			pathTo[MAX_PATH] = {0};
	UB			buf[4096];

	if (pFrom != NULL && pTo != NULL) {
		do {
			//	LZtONA[
			if (pfCancel != NULL) {
				*pfCancel = FALSE;
			}
			//	Rs[t@C݃`FbN
			if (!AjcPathIsFile(pFrom  )) {
				SetLastError(ERROR_FILE_NOT_FOUND);
				break;
			}
			//	Rs[pXfBNgȂ΁At@Ct
			MAjcStrCpy(pathTo, MAX_PATH, pTo);
			if (AjcPathIsDirectory(pTo)) {
				UT	fname	[_MAX_FNAME];
				UT	fext	[_MAX_EXT];
				UT	FileName[MAX_PATH];
				MAjcSplitPath(pFrom   , NULL, NULL, fname, fext);
				MAjcMakePath (FileName, NULL, NULL, fname, fext);
				AjcPathCat(pathTo, FileName, MAX_PATH);
			}
			//	Rs[t@C݃`FbN
			if (AjcPathIsFile(pathTo )) {
				//	uɑ݂ꍇ㏑vȂ΃t@C폜
				if (fCreateAlways) {
					SetFileAttributesW(pathTo, FILE_ATTRIBUTE_NORMAL);
					DeleteFile(pathTo);
				}
				//	uɑ݂ꍇRs[ȂvȂ΁AI
				else {
					SetLastError(ERROR_ALREADY_EXISTS);
					break;
				}
			}
			//	t@CTCY擾
			if ((size = AjcGetFileSize(pFrom)) == -1) break;
			//	t@C擾
			if ((att  = GetFileAttributesW(pFrom)) == INVALID_FILE_ATTRIBUTES) break;
			//	t@CI[v
			if ((hInp = CreateFileW(pFrom , GENERIC_READ , FILE_SHARE_READ , NULL, OPEN_EXISTING, 0	, NULL )) == INVALID_HANDLE_VALUE) break;
			if ((hOut = CreateFileW(pathTo, GENERIC_WRITE, 0 			   , NULL, CREATE_ALWAYS, att, NULL)) == INVALID_HANDLE_VALUE) break;
			//	t@CRs[
			while (ReadFile(hInp, buf, sizeof buf, &RBytes, NULL) && RBytes != 0) {
				//	t@C
				if (WriteFile(hOut, buf, RBytes, &WBytes, NULL) == 0 || RBytes != WBytes) {
					goto cf_exit;
				}
				count += WBytes;
				//	R[obN
				if (cbProgress != NULL) {
					if (!cbProgress(size, count, cbp)) {
						if (pfCancel != NULL) {
							*pfCancel = TRUE;
						}
						goto cf_exit;
					}
				}
			}
			//	^CX^vݒ
			if (!GetFileTime(hInp, &ftCreate, &ftLastAcc, &ftLastWrt)) break;
			if (!SetFileTime(hOut, &ftCreate, &ftLastAcc, &ftLastWrt)) break;
			//	߂lnj
			SetLastError(ERROR_SUCCESS);
			rc = TRUE;
		} while(0);
	}
cf_exit:;
	//	t@CN[Y
	if (hInp != INVALID_HANDLE_VALUE) CloseHandle(hInp);
	if (hOut != INVALID_HANDLE_VALUE) CloseHandle(hOut);

	return rc;
}
//==============================================================================================================//
//	tH_폜																								//
//																												//
//	@F	pPath		- 폜tH_pX̃AhX													//
//				cbp 		- R[obNp^																//
//				cbNotify	- 폜tH_^t@CʒmR[obN֐isvNULL)				//
//																												//
//	߂l	F	TRUE F																						//
//				FALSEFs																						//
//==============================================================================================================//
//	[N
typedef struct {
	UX		cbp;
	BOOL (CALLBACK *cbNotify)(C_BCP pPathRemoved, UI ntc, UX cbp);
} RMVFWRK, *PRMVFWRK;

static	BOOL CALLBACK cbRmvfNotify(C_WCP pPathRemoved, UI ntc, UX cbp);

//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRemoveFolderA(C_BCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_BCP pPathRemoved, UI ntc, UX cbp))
{
	BOOL	rc	 = FALSE;
	RMVFWRK	wrk;
	WC		Path[MAX_PATH];

	if (pPath != NULL && AjcPathIsDirectoryA(pPath)) {
		wrk.cbp 	 = cbp;
		wrk.cbNotify = cbNotify;
		MultiByteToWideChar(CP_ACP, 0, pPath, -1, Path, MAX_PATH);
		rc = AjcRemoveFolderW(Path, (UX)&wrk, cbRmvfNotify);
	}
	return rc;
}
//- - - - R[obN(cbNotify) - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	BOOL CALLBACK cbRmvfNotify(C_WCP pPathRemoved, UI ntc, UX cbp)
{
	BOOL		rc;
	PRMVFWRK	p = (PRMVFWRK)cbp;
	BC			PathRemoved[MAX_PATH];

	if (p->cbNotify != NULL) {
		WideCharToMultiByte(CP_ACP, 0, pPathRemoved, -1, PathRemoved, MAX_PATH, NULL, NULL);
		rc = p->cbNotify(PathRemoved, ntc, p->cbp);
	}
	return rc;
}

//----- Ch ---------------------------------------------------------------------------------------------//
static	VO			SubRemoveFolderW(C_WCP pPath, BOOL *rc, BOOL *fEnd, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP pPathRemoved, UI ntc, UX cbp));

AJCEXPORT	BOOL	WINAPI	AjcRemoveFolderW(C_WCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP pPathRemoved, UI ntc, UX cbp))
{
	BOOL	rc	 = FALSE;
	BOOL	fEnd = FALSE;

	if (pPath != NULL && AjcPathIsDirectoryW(pPath)) {
		rc = TRUE;
		SubRemoveFolderW(pPath, &rc, &fEnd, cbp, cbNotify);
	}
	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	VO			SubRemoveFolderW(C_WCP pPath, BOOL *rc, BOOL *fEnd, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP pPathRemoved, UI ntc, UX cbp))
{
	HANDLE				hFind;
	WIN32_FIND_DATAW	fd;
	int					att;
	BOOL				rsu;
	WC					PathTop [MAX_PATH];
	WC					PathWild[MAX_PATH];
	WC					PathFind[MAX_PATH];

	if (!(*fEnd)) {
		AjcSnPrintFW(PathTop , MAX_PATH, L"%s", pPath);
		AjcSnPrintFW(PathWild, MAX_PATH, L"%s", pPath);
		AjcPathCatW(PathWild, L"*.*", MAX_PATH);
		if ((hFind = FindFirstFileW(PathWild, &fd)) != INVALID_HANDLE_VALUE) {
			do {
				if(wcscmp(fd.cFileName, L".") != 0 && wcscmp(fd.cFileName, L"..") != 0) {
					AjcSnPrintFW(PathFind, MAX_PATH, L"%s", PathTop);
					AjcPathCatW (PathFind, fd.cFileName, MAX_PATH);
					//	ȑ
					if ((att = GetFileAttributesW(PathFind)) != -1) {
						SetFileAttributesW(PathFind, att & ~(FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_SYSTEM));
					}
					// fBNg
					if (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
						//	ʂ̊Kw
						SubRemoveFolderW(PathFind, rc, fEnd, cbp, cbNotify);
					}
					//	t@C
					else {
						//	t@C폜
						rsu = DeleteFileW(PathFind);
						//	R[obN
						if (cbNotify != NULL) {
							*fEnd = !cbNotify(PathFind, rsu ? AJCRMV_FILE_OK : AJCRMV_FILE_ERR, cbp);
						}
						//	߂lݒ(TRUE:OK, FALSE:ERR)
						*rc &= (rsu != 0);
					}
				}
			} while (!(*fEnd) && FindNextFileW(hFind, &fd));
			FindClose(hFind);
		}
		//	fBNg폜
		rsu = RemoveDirectoryW(pPath);
		//	R[obN
		if (cbNotify != NULL) {
			*fEnd = !cbNotify(pPath, rsu ? AJCRMV_DIR_OK : AJCRMV_DIR_ERR, cbp);
		}
		//	߂lݒ(TRUE:OK, FALSE:ERR)
		*rc &= (rsu != 0);
	}
}

//==============================================================================================================//
//	tH_̑St@CƃfBNg폜																	//
//																												//
//	@F	pPath		- 폜tH_pX̃AhX													//
//				cbNotify	- 폜tH_^t@CʒmR[obN֐isvNULL)				//
//																												//
//	߂l	F	TRUE F																						//
//				FALSEFs																						//
//==============================================================================================================//
//	[N
typedef struct {
	UX		cbp;
	BOOL (CALLBACK *cbNotify)(C_BCP pPathRemoved, UI ntc, UX cbp);
} CLNFWRK, *PCLNFWRK;

static	BOOL CALLBACK cbClnfNotify(C_WCP path, UI ntc, UX cbp);

//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCleanFolderA(C_BCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_BCP path, UI ntc, UX cbp))
{
	BOOL	rc	 = FALSE;
	CLNFWRK	wrk;
	WC		Path[MAX_PATH];

	if (pPath != NULL && AjcPathIsDirectoryA(pPath)) {
		wrk.cbp 	 = cbp;
		wrk.cbNotify = cbNotify;
		MultiByteToWideChar(CP_ACP, 0, pPath, -1, Path, MAX_PATH);
		rc = AjcCleanFolderW(Path, (UX)&wrk, cbClnfNotify);
	}
	return rc;
}
//- - - - R[obN(cbNotify) - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	BOOL CALLBACK cbClnfNotify(C_WCP pPathRemoved, UI ntc, UX cbp)
{
	BOOL		rc = TRUE;
	PCLNFWRK	p = (PCLNFWRK)cbp;
	BC			PathRemoved[MAX_PATH];

	if (p->cbNotify != NULL) {
		WideCharToMultiByte(CP_ACP, 0, pPathRemoved, -1, PathRemoved, MAX_PATH, NULL, NULL);
		rc = p->cbNotify(PathRemoved, ntc, p->cbp);
	}
	return rc;
}

//----- Ch ---------------------------------------------------------------------------------------------//
static		VO		SubCleanFolderW(C_WCP pPath, BOOL *rc, BOOL *fEnd, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP path, UI ntc, UX cbp));

AJCEXPORT	BOOL	WINAPI	AjcCleanFolderW(C_WCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP path, UI ntc, UX cbp))
{
	BOOL	rc	 = FALSE;
	BOOL	fEnd = FALSE;

	if (pPath != NULL && AjcPathIsDirectoryW(pPath)) {
		rc = TRUE;
		SubCleanFolderW(pPath, &rc, &fEnd, cbp, cbNotify);
	}
	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static		VO		SubCleanFolderW(C_WCP pPath, BOOL *rc, BOOL *fEnd, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP path, UI ntc, UX cbp))
{
	HANDLE				hFind;
	WIN32_FIND_DATAW	fd;
	int					att;
	BOOL				rsu;
	WC					PathTop [MAX_PATH];
	WC					PathWild[MAX_PATH];
	WC					PathFind[MAX_PATH];

	if (!(*fEnd)) {
		AjcSnPrintFW(PathTop , MAX_PATH, L"%s", pPath);
		AjcSnPrintFW(PathWild, MAX_PATH, L"%s", pPath);
		AjcPathCatW (PathWild, L"*.*", MAX_PATH);
		if ((hFind = FindFirstFileW(PathWild, &fd)) != INVALID_HANDLE_VALUE) {
			do {
				if(wcscmp(fd.cFileName, L".") != 0 && wcscmp(fd.cFileName, L"..") != 0) {
					AjcSnPrintFW(PathFind, MAX_PATH, L"%s", PathTop);
					AjcPathCatW (PathFind, fd.cFileName, MAX_PATH);
					//	ȑ
					if ((att = GetFileAttributesW(PathFind)) != -1) {
						SetFileAttributesW(PathFind, att & ~(FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_SYSTEM));
					}
					// fBNg
					if (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
						SubRemoveFolderW(PathFind, rc, fEnd, cbp, cbNotify);
					}
					//	t@C
					else {
						//	t@C폜
						rsu = DeleteFileW(PathFind);
						//	R[obN
						if (cbNotify != NULL) {
							*fEnd = !cbNotify(PathFind, rsu ? AJCRMV_FILE_OK : AJCRMV_FILE_ERR, cbp);
						}
						//	߂lݒ(TRUE:OK, FALSE:ERR)
						*rc &= (rsu != 0);
					}
				}
			} while (FindNextFileW(hFind, &fd));
			FindClose(hFind);
		}
	}
}
//==============================================================================================================//
//	t@CQ̓ˍXg쐬																				//
//																												//
//	@	F	pParh1	- pXւ̃|C^																	//
//				pPath2	- ChJ[hiw莞̓Z~R(;)ŋ؂CNULLw莞ׂ͂ĈvƂj	//
//				opt		- IvV																			//
//				cbp		- R[obNp^																	//
//				cbNtc	- t@CʒmpR[obN֐isvNULL)											//
//																												//
//	߂l	F	NULL - 																					//
//				NULL - s																					//
//==============================================================================================================//
//	`ukm[hioCgj
typedef struct {
	struct {
		BOOL		fValid;					//	LtO
		AJCFMLHD	hd;						//	ʃwb_
		C_BCP		pDrv;					//	hCu(ex. "d:")
		C_BCP		pTop;					//	tH_pXi擪pXj
		C_BCP		pSub;					//	tH_pXi㑱pXj
		C_BCP		pFName;					//	t@C
		C_BCP		pFExt;					//	t@Cgq
	} s[2];
} AJCFMLNODEA, *PAJCFMLNODEA;
typedef const AJCFMLNODEA *PCAJCFMLNODEA;

//	`ukm[hiChj
typedef struct {
	struct {
		BOOL		fValid;					//	LtO
		AJCFMLHD	hd;						//	ʃwb_
		C_WCP		pDrv;					//	hCu(ex. "d:")
		C_WCP		pTop;					//	tH_pXi擪pXj
		C_WCP		pSub;					//	tH_pXi㑱pXj
		C_WCP		pFName;					//	t@C
		C_WCP		pFExt;					//	t@Cgq
	} s[2];
} AJCFMLNODEW, *PAJCFMLNODEW;
typedef const AJCFMLNODEW *PCAJCFMLNODEW;

//	CX^X[N
typedef struct {
	int			err;						//	G[R[h
	WC			TopPath[2][MAX_PATH];		//	Q̐擪pX
	HAJCAVL		hAvl;						//	`uknh
	HAJCSPL		hSpl;						//	roknh
	BOOL		fUnicode;					//	ASCII / UNICODE 
	UI			opt;						//	IvV(AJCFML_XXXXX)
	UX			cbp;						//	R[obNp^
	union {									//	R[obN֐
		//	ASCII
		struct {
			BOOL (CALLBACK *cbQuery)(UI id, C_BCP pPath, UI att, BOOL *pfDiscard, UX cbp);
			BOOL (CALLBACK *cbEnum )(AJCFMLITEMA item[2], UX cbp);
		} asc;
		//	UNICODE
		struct {
			BOOL (CALLBACK *cbQuery)(UI id, C_WCP pPath, UI att, BOOL *pfDiscard, UX cbp);
			BOOL (CALLBACK *cbEnum )(AJCFMLITEMW item[2], UX cbp);
		} uni;
		//	
		struct {
			VOP		vpQuery;
			VOP		vpEnum;
		} vp;
	} u;
} AJCFML, *PAJCFML;
typedef const AJCFML *PCAJCFML;

static	BOOL SubEnumFilesMatchingList(PAJCFML pW);

//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	int WINAPI AjcEnumFilesMatchingListA(C_BCP pPath1, C_BCP pPath2, UI opt, UX cbp, BOOL (CALLBACK *cbQuery)(UI id, C_BCP pPath, UI att, BOOL *pfDiscard, UX cbp),
																							 BOOL (CALLBACK *cbEnum)(AJCFMLITEMA item[2], UX cbp))
{
	int			rc = 0;
	PAJCFML		pW = NULL;

	if (pPath1 != NULL || pPath2 != NULL) {
		if (pW = (PAJCFML)AJCMEM(sizeof(AJCFML))) {
			memset(pW, 0, sizeof(AJCFML));
			do {
				//	UNICODEʐݒ
				pW->fUnicode = FALSE;
				//	Q̃pXݒ
				if (pPath1 != NULL) {MultiByteToWideChar(CP_ACP, 0, pPath1, -1, pW->TopPath[0], MAX_PATH);}
				if (pPath2 != NULL) {MultiByteToWideChar(CP_ACP, 0, pPath2, -1, pW->TopPath[1], MAX_PATH);}
				//	IvVݒ
				pW->opt = opt;
				//	R[obNݒ
				pW->cbp = cbp;
				pW->u.asc.cbQuery = cbQuery;
				pW->u.asc.cbEnum  = cbEnum;
				//	t@CQ̓ˍXg쐬
				SubEnumFilesMatchingList(pW);
			} while(0);
			//	߂lݒ
			if (pW->err == AJCFMLERR_OK) rc = AjcAvlGetCount(pW->hAvl);
			else						 rc = pW->err;
			//	\[XJ
			if (pW->hAvl != NULL) {AjcAvlDelete(pW->hAvl); pW->hAvl = NULL;}
			if (pW->hSpl != NULL) {AjcSplDelete(pW->hSpl); pW->hSpl = NULL;}
			free(pW);
		}
	}
	else {
		rc = AJCFMLERR_NULL;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	int WINAPI AjcEnumFilesMatchingListW(C_WCP pPath1, C_WCP pPath2, UI opt, UX cbp, BOOL (CALLBACK *cbQuery)(UI id, C_WCP pPath, UI att, BOOL *pfDiscard, UX cbp),
																							 BOOL (CALLBACK *cbEnum)(AJCFMLITEMW item[2], UX cbp))
{
	int			rc = FALSE;
	PAJCFML		pW = NULL;

	if (pPath1 != NULL || pPath2 != NULL) {
		if (pW = (PAJCFML)AJCMEM(sizeof(AJCFML))) {
			memset(pW, 0, sizeof(AJCFML));
			do {
				//	UNICODEʐݒ
				pW->fUnicode = TRUE;
				//	Q̃pXݒ
				if (pPath1 != NULL) {MAjcStrCpyW(pW->TopPath[0], MAX_PATH, pPath1);}
				if (pPath2 != NULL) {MAjcStrCpyW(pW->TopPath[1], MAX_PATH, pPath2);}
				//	IvVݒ
				pW->opt = opt;
				//	R[obNݒ
				pW->cbp 	= cbp;
				pW->u.uni.cbQuery = cbQuery;
				pW->u.uni.cbEnum  = cbEnum;
				//	t@CQ̓ˍXg쐬
				SubEnumFilesMatchingList(pW);
			} while(0);
			//	߂lݒ
			if (pW->err == AJCFMLERR_OK) rc = AjcAvlGetCount(pW->hAvl);
			else						 rc = pW->err;
			//	\[XJ
			if (pW->hAvl != NULL) {AjcAvlDelete(pW->hAvl); pW->hAvl = NULL;}
			if (pW->hSpl != NULL) {AjcSplDelete(pW->hSpl); pW->hSpl = NULL;}
			free(pW);
		}
	}
	else {
		rc = AJCFMLERR_NULL;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	ʃTu																									//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL			SubFmlFindDeep(PAJCFML pW, UI ix, WCP pFind);
static	C_WCP			SubFmlSetNode (PAJCFML pW, UI ix, C_WCP pPath, PWIN32_FIND_DATAW pfd, PAJCFMLNODEW pNode);
static	int  CALLBACK	cbCbfComp(UX key1, UX key2, UX cbp);
static	BOOL CALLBACK	cbFmlNtcAvlNode(UX key, VOP pNodeData, UI len, UI nest, UX cbp);

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	BOOL SubEnumFilesMatchingList(PAJCFML pW)
{
	BOOL		rc = FALSE;
	UI			ix;
	WC			CurDir[MAX_PATH];

	//	G[R[hZbg
	pW->err = AJCFMLERR_OK;

	do {
		//	pX𐳋K
		for (ix = 0; ix < 2; ix++) {
			if (pW->TopPath[ix][0] != 0) {
				//	΃pX̏ꍇ́AJgfBNg̑΂Ƃ
				if (PathIsRelativeW(pW->TopPath[ix])) {
					GetCurrentDirectoryW(AJCTSIZE(CurDir), CurDir);
					AjcPathCatW(CurDir, pW->TopPath[ix], AJCTSIZE(CurDir));
					PathCanonicalizeW(pW->TopPath[ix], CurDir);
				}
				//	΃pX̏ꍇ́ApX𐳋K
				else {
					WC	temp[MAX_PATH];
					MAjcStrCpyW(temp, MAX_PATH, pW->TopPath[ix]);
					PathCanonicalizeW(pW->TopPath[ix], temp);
				}
			}
		}
		//	pX`FbN
		if (pW->TopPath[0][0] != 0 && !AjcPathIsDirectoryW(pW->TopPath[0])) {pW->err = AJCFMLERR_PATH1; break;}
		if (pW->TopPath[1][0] != 0 && !AjcPathIsDirectoryW(pW->TopPath[1])) {pW->err = AJCFMLERR_PATH2; break;}
		//	`ukCrokCX^X
		if ((pW->hAvl = AjcAvlCreate ((UX)pW, cbCbfComp, NULL)) == NULL) {pW->err = AJCFMLERR_MEM; break;}
		if ((pW->hSpl = AjcSplCreateW(AJCCMP_IGNORE_WIDTH)	  ) == NULL) {pW->err = AJCFMLERR_MEM; break;}
		//	t@CXg쐬
		for (ix = 0; ix < 2; ix++) {
			if (pW->TopPath[ix][0] != 0) {
				SubFmlFindDeep(pW, ix, pW->TopPath[ix]);
			}
			if (pW->err != AJCFMLERR_OK) break;
		}
	} while(0);

	//	˂Xg̗
	if (pW->u.vp.vpEnum != NULL && pW->err == AJCFMLERR_OK) {
		AjcAvlEnumNodes(pW->hAvl, cbFmlNtcAvlNode, FALSE);
	}
	//	߂lݒ
	if (pW->err == AJCFMLERR_OK) rc = TRUE;
	else						 rc = FALSE;

	return rc;
}
//- - - TufBNg - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	BOOL	SubFmlFindDeep(PAJCFML pW, UI ix, WCP pFind)
{
	HANDLE				hFind = INVALID_HANDLE_VALUE;
	C_WCP				pTail = NULL;
	WIN32_FIND_DATAW	fd;
	WC					wild[MAX_PATH];
	WC					find[MAX_PATH];
	AJCFMLNODEW			node  = {0};
	PAJCFMLNODEW		pNode = NULL;

	MAjcStrCpyW(wild, MAX_PATH, pFind);
	AjcPathCatW(wild, L"*.*", MAX_PATH);
	if ((hFind = FindFirstFileW(wild, &fd)) != INVALID_HANDLE_VALUE) {
		do {
			if (wcscmp(fd.cFileName, L".") != 0 && wcscmp(fd.cFileName, L"..") != 0) {
				BOOL	fDiscard = FALSE;
				//	pXݒ
				MAjcStrCpyW(find, MAX_PATH, pFind);
				AjcPathCatW(find, fd.cFileName, MAX_PATH);
				//	t@CCfBNgI
				if ((!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && !(pW->opt & AJCFML_NOFILE)) ||
					( (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && !(pW->opt & AJCFML_NODIR ))) {
					//	R[obN
					if (pW->u.vp.vpQuery != NULL) {
						//	UNICODE
						if (pW->fUnicode) {
							if (!pW->u.uni.cbQuery(ix, find, fd.dwFileAttributes, &fDiscard, pW->cbp)) {
								pW->err = AJCFMLERR_STOP_BY_USER;
							}
						}
						//	ASCII
						else {
							BC	findA[MAX_PATH];
							WideCharToMultiByte(CP_ACP, 0, find, -1, findA, MAX_PATH, NULL, NULL);
							if (!pW->u.asc.cbQuery(ix, findA, fd.dwFileAttributes, &fDiscard, pW->cbp)) {
								pW->err = AJCFMLERR_STOP_BY_USER;
							}
						}
					}
					//	m[ho^iL[  m[hf[^̃AhXj
					if (!fDiscard) {
						//	m[h쐬
						if ((pTail = SubFmlSetNode(pW, ix, find, &fd, &node)) == NULL) {pW->err = AJCFMLERR_MEM; break;}
						//	m[hꍇAm[hf[^}[W
						if (pNode = (PAJCFMLNODEW)AjcAvlGetNodePtr(pW->hAvl, (UX)&node, NULL)) {
							memcpy(&pNode->s[ix], &node.s[ix], sizeof node.s[0]);
						}
						//	m[hꍇAm[hf[^o^
						else {
							if (AjcAvlInsDataNode(pW->hAvl, &node, sizeof node) == 0) {pW->err = AJCFMLERR_MEM; break;}
						}
					}
				}
				//	TufBNg
				if (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
					SubFmlFindDeep(pW, ix, find);
					if (pW->err != AJCFMLERR_OK) break;
				}
			}
		} while (FindNextFileW(hFind, &fd) && pW->err == AJCFMLERR_OK);
		FindClose(hFind);
	}
	return !pW->err;
}
//- - - m[hݒ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	C_WCP	SubFmlSetNode(PAJCFML pW, UI ix, C_WCP pPath, PWIN32_FIND_DATAW pfd, PAJCFMLNODEW pNode)
{
	C_WCP	rc	  = NULL;
	int		stl;
	C_WCP	pTail = NULL;
	WC		front[MAX_PATH	] = {0};
	WC		drv  [_MAX_DRIVE] = {0};
	WC		dir  [_MAX_DIR	] = {0};
	WC		fname[_MAX_FNAME] = {0};
	WC		fext [_MAX_EXT	] = {0};

	if (pW->err == AJCFMLERR_OK) {
		do {
			SYSTEMTIME	st;
			union {
				struct {UL l, h;} s;
				ULL				  ull;
			} u;
			//	m[hNA[
			memset(pNode, 0, sizeof(AJCFMLNODEW));
			//	LtOݒ
			pNode->s[ix].fValid = TRUE;
			//	t@C^Cݒ
			FileTimeToSystemTime(&pfd->ftLastWriteTime, &st);
			pNode->s[ix].hd.utc = AjcSysTimeToTime1970(&st);
			//	t@Cݒ
			pNode->s[ix].hd.att = pfd->dwFileAttributes;
			//	t@CTCYݒ
			u.s.l = pfd->nFileSizeLow;
			u.s.h = pfd->nFileSizeHigh;
			pNode->s[ix].hd.size = u.ull;
			//	擪pXAhCuƑOfBNgݒ
			MAjcStrCpyW(front, MAX_PATH, pW->TopPath[ix]);
			PathAddBackslashW(front);	// fBNgpX擾邽߂ɁAu\vƂ
			MAjcSplitPathW(front, drv, dir, NULL, NULL);
			if ((pNode->s[ix].pDrv	 = AjcSplRegistW(pW->hSpl, drv	)) == NULL) {pW->err = AJCFMLERR_MEM; break;}
			if ((pNode->s[ix].pTop	 = AjcSplRegistW(pW->hSpl, dir	)) == NULL) {pW->err = AJCFMLERR_MEM; break;}
			//	㑱pXA㕔fBNgƃt@Cݒ
			stl = (int)wcslen(pW->TopPath[ix]);
			pTail = pPath + stl;
			if (*pTail == L'\\') pTail++;
			MAjcSplitPathW(pTail, NULL, dir, fname, fext);
			if ((pNode->s[ix].pSub	 = AjcSplRegistW(pW->hSpl, dir	)) == NULL) {pW->err = AJCFMLERR_MEM; break;}
			if ((pNode->s[ix].pFName = AjcSplRegistW(pW->hSpl, fname)) == NULL) {pW->err = AJCFMLERR_MEM; break;}
			if ((pNode->s[ix].pFExt  = AjcSplRegistW(pW->hSpl, fext )) == NULL) {pW->err = AJCFMLERR_MEM; break;}
			//	߂lnj
			rc = pTail;
		} while(0);
	}
	return rc;
}
//- - - m[h召r - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	int CALLBACK	cbCbfComp(UX key1, UX key2, UX cbp)
{
	int				rc		= 0;
	int				ix		= 0;
	PAJCFMLNODEW	pNode1	= (PAJCFMLNODEW)key1;
	PAJCFMLNODEW	pNode2	= (PAJCFMLNODEW)key2;
	WC				path1[MAX_PATH];
	WC				path2[MAX_PATH];

	//	key1̌㕔pXݒ
	ix = pNode1->s[0].fValid ? 0 : 1;
	MAjcMakePathW(path1, NULL, pNode1->s[ix].pSub, pNode1->s[ix].pFName, pNode1->s[ix].pFExt);
	//	key2̌㕔pXݒ
	ix = pNode2->s[0].fValid ? 0 : 1;
	MAjcMakePathW(path2, NULL, pNode2->s[ix].pSub, pNode2->s[ix].pFName, pNode2->s[ix].pFExt);

	rc = wcsicmp(path1, path2);

	return rc;
}
//----- `uk񋓃R[obN ---------------------------------------------------------------------------------//
static BOOL CALLBACK cbFmlNtcAvlNode(UX key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	BOOL		rc	   = TRUE;
	PAJCFML		pW	   = (PAJCFML)cbp;
	PAJCFMLNODEW pNode = (PAJCFMLNODEW)pNodeData;
	UI			ix;
	union {
		AJCFMLITEMW	itemW[2];
		AJCFMLITEMA	itemA[2];
	} u;

	memset(&u, 0, sizeof u);

	for (ix = 0; ix < 2; ix++) {
		//	UNICODE
		if (pW->fUnicode) {
			WC			tail[MAX_PATH];
			if (u.itemW[ix].fValid = pNode->s[ix].fValid) {
				memcpy(&u.itemW[ix].hd, &pNode->s[ix].hd, sizeof(AJCFMLHD));
				MAjcMakePathW(tail, NULL, pNode->s[ix].pSub, pNode->s[ix].pFName, pNode->s[ix].pFExt);
				MAjcStrCpyW(u.itemW[ix].path, MAX_PATH, pW->TopPath[ix]);
				AjcPathCatW(u.itemW[ix].path, tail, MAX_PATH);
				MAjcMakePathW(u.itemW[ix].name, NULL, NULL, pNode->s[ix].pFName, pNode->s[ix].pFExt);
				MAjcStrCpyW(u.itemW[ix].tail, MAX_PATH, tail);
			}
		}
		//	ASCII
		else {
			BC			tail [MAX_PATH];
			BC			sub  [MAX_PATH];
			BC			fname[MAX_PATH];
			BC			fext [MAX_PATH];
			if (u.itemA[ix].fValid = pNode->s[ix].fValid) {
				memcpy(&u.itemA[ix].hd, &pNode->s[ix].hd, sizeof(AJCFMLHD));
				WideCharToMultiByte(CP_ACP, 0, pNode->s[ix].pSub  , -1, sub  , MAX_PATH, NULL, NULL);
				WideCharToMultiByte(CP_ACP, 0, pNode->s[ix].pFName, -1, fname, MAX_PATH, NULL, NULL);
				WideCharToMultiByte(CP_ACP, 0, pNode->s[ix].pFExt , -1, fext , MAX_PATH, NULL, NULL);
				MAjcMakePathA(tail, NULL, sub, fname, fext);
				WideCharToMultiByte(CP_ACP, 0, pW->TopPath[ix], -1, u.itemA[ix].path, MAX_PATH, NULL, NULL);
				AjcPathCatA(u.itemA[ix].path, tail, MAX_PATH);
				MAjcMakePathA(u.itemA[ix].name, NULL, NULL, fname, fext);
				MAjcStrCpyA(u.itemA[ix].tail, MAX_PATH, tail);
			}
		}
	}
	//	ˍXg̃R[obN
	if (pW->u.vp.vpEnum != NULL) {
		if (pW->fUnicode) rc = pW->u.uni.cbEnum(u.itemW, pW->cbp);
		else			  rc = pW->u.asc.cbEnum(u.itemA, pW->cbp);
	}
	return rc;
}
//==============================================================================================================//
//	fBNg\̍쐬																						//
//																												//
//	@	F	pParh					- fBNgpX													//
//				lpSecurityAttributes	- SECURITY_ATTRIBUTES\̂ւ̃|C^[								//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcCreateDirectoryStructA(C_BCP pPath)
{
	return AjcCreateDirectoryStructExA(pPath, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	BOOL	WINAPI AjcCreateDirectoryStructExA(C_BCP pPath, LPSECURITY_ATTRIBUTES lpSecurityAttributes)
{
	BOOL	rc = FALSE;
	WC		path[MAX_PATH];

	if (MultiByteToWideChar(CP_ACP, 0, pPath, -1, path, MAX_PATH) != 0) {
		rc = AjcCreateDirectoryStructExW(path, lpSecurityAttributes);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcCreateDirectoryStructW(C_WCP pPath)
{
	return AjcCreateDirectoryStructExW(pPath, NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	BOOL	WINAPI AjcCreateDirectoryStructExW(C_WCP pPath, LPSECURITY_ATTRIBUTES lpSecurityAttributes)
{
	BOOL	rc = FALSE;
	WCP		p;
	int		stl;
	WC		relp[MAX_PATH	 ] = {0};
	WC		absp[MAX_PATH + 1] = {0};
	WC		path[MAX_PATH	 ] = {0};

	if (pPath != NULL) {
		rc = TRUE;
		//	΃pX̏ꍇ́AJgfBNg̑΂Ƃ
		if (PathIsRelative(pPath)) {
			GetCurrentDirectory(MAX_PATH, relp);
			AjcPathCat (relp, pPath, MAX_PATH);
			PathCanonicalize(absp, relp);
		}
		//	΃pX̏ꍇ́ApX𐳋K
		else {
			PathCanonicalize(absp, pPath);
		}

		//	pX𑽏d
		PathRemoveBackslash(absp);
		for (p = absp; *p != 0; p++) {
			if (*p == L'\\') *p = 0;
		}

		//	pXč\AfBNg쐬
		wcscpy_s(path, MAX_PATH, absp);
		p = &absp[wcslen(absp) + 1];
		while (*p != 0) {
			//	pXڂPǉ
			stl = (int)wcslen(p);
			AjcPathCat(path, p, MAX_PATH);
			p += (stl + 1);
			//	fBNgȊÕpX݂ꍇ́AG[
			if (AjcPathExists(path)) {
				if (!AjcPathIsDirectory(path)) {
					rc = FALSE;
					break;
				}
			}
			//	pX݂Ȃ΁AfBNg쐬
			else {
				if (!CreateDirectory(path, lpSecurityAttributes)) {
					rc = FALSE;
					break;
				}
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	pXChJ[h̎wɈv邩`FbN															//
//																												//
//	@	F	pParh	- pXւ̃|C^																	//
//				pWild	- ChJ[hiw莞̓Z~R(;)ŋ؂CNULLw莞ׂ͂ĈvƂj	//
//																												//
//	߂l	F	TRUE  - v																					//
//				FALSE - sv																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathMatchSpecA(C_BCP pPath, C_BCP pWild)
{
	BOOL	rc = FALSE;
	int		i;
	C_BCP	p  = pWild;
	BC		wild[MAX_PATH];

	if (pPath != NULL && pWild != NULL) {
		while (*p != 0) {
			//	ChJ[hPݒ
			for (i = 0; i < MAX_PATH - 1 && *p != 0 && *p != ';' && *p != '/'; i++, p ++) {
				wild[i] = *p;
			}
			wild[i] = 0;
			//	[󔒏
			AjcStrTrimA(wild, wild, MAX_PATH);
			//	󕶎ȊOȂ΁AChJ[h`FbN
			if (wild[0] != 0) {
				if (PathMatchSpecA(pPath, wild)) {
					rc = TRUE;
					break;
				}
				else {
					BC	fname[_MAX_FNAME];
					BC	fext [_MAX_EXT];
					BC	name [MAX_PATH];
					MAjcSplitPathA(pPath, NULL, NULL, fname, fext);
					MAjcMakePathA (name , NULL, NULL, fname, fext);
					if (stricmp(name, wild) == 0) {
						rc = TRUE;
						break;
					}
				}
			}
			//	MAX_PATHȏ̒Ȃ΁AZ~R(;)ȊOXLbv
			while (*p != ';' && *p != '/' && *p != 0) {
				p++;
			}
			//	Z~RXLbv
			while (*p == ';' || *p == '/') {
				p++;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathMatchSpecW(C_WCP pPath, C_WCP pWild)
{
	BOOL	rc = FALSE;
	int		i;
	C_WCP	p  = pWild;
	WC		wild[MAX_PATH];

	if (pPath != NULL && pWild != NULL) {
		while (*p != 0) {
			//	ChJ[hPݒ
			for (i = 0; i < MAX_PATH - 1 && *p != 0 && *p != L';' && *p != L'/'; i++, p ++) {
				wild[i] = *p;
			}
			wild[i] = 0;
			//	[󔒏
			AjcStrTrimW(wild, wild, MAX_PATH);
			//	󕶎ȊOȂ΁AChJ[h`FbN
			if (wild[0] != 0) {
				if (PathMatchSpecW(pPath, wild)) {
					rc = TRUE;
					break;
				}
				else {
					WC	fname[_MAX_FNAME];
					WC	fext [_MAX_EXT];
					WC	name [MAX_PATH];
					MAjcSplitPathW(pPath, NULL, NULL, fname, fext);
					MAjcMakePathW (name , NULL, NULL, fname, fext);
					if (wcsicmp(name, wild) == 0) {
						rc = TRUE;
						break;
					}
				}
			}
			//	MAX_PATHȏ̒Ȃ΁AZ~R(;)ȊOXLbv
			while (*p != L';' && *p != L'/' && *p != 0) {
				p++;
			}
			//	Z~RXLbv
			while (*p == L';' || *p == L'/') {
				p++;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	pXw蕶܂ނ`FbN																		//
//																												//
//	@	F	pPath	- pXւ̃|C^																	//
//				pStr	- `FbN镶(w莞̓Z~R(;)ŋ؂CNULLw莞ׂ͂ĈvƂ)	//
//																												//
//	߂l	F	TRUE  - v																					//
//				FALSE - sv																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathMatchStrA(C_BCP pPath, C_BCP pStr)
{
	BOOL	rc = FALSE;
	int		i;
	C_BCP	p  = pStr;
	BC		str[MAX_PATH];

	if (pPath != NULL && pStr != NULL) {
		while (*p != 0) {
			//	Pݒ
			for (i = 0; i < MAX_PATH - 1 && *p != 0 && *p != ';' && *p != '/'; i++, p++) {
				str[i] = *p;
			}
			str[i] = 0;
			//	[󔒏
			AjcStrTrimA(str, str, MAX_PATH);
			//	󕶎ȊOȂ΁AO`FbN
			if (str[0] != 0) {
				if (AjcStrIStrA(pPath, str)) {
					rc = TRUE;
					break;
				}
			}
			//	MAX_PATHȏ̒Ȃ΁AZ~R(;)ȊOXLbv
			while (*p != ';' && *p != '/' && *p != 0) {
				p++;
			}
			//	Z~RXLbv
			while (*p == ';' || *p == '/') {
				p++;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathMatchStrW(C_WCP pPath, C_WCP pStr)
{
	BOOL	rc = FALSE;
	int		i;
	C_WCP	p  = pStr;
	WC		str[MAX_PATH];

	if (pPath != NULL && pStr != NULL) {
		while (*p != 0) {
			//	Pݒ
			for (i = 0; i < MAX_PATH - 1 && *p != 0 && *p != L';' && *p != L'/'; i++, p++) {
				str[i] = *p;
			}
			str[i] = 0;
			//	[󔒏
			AjcStrTrimW(str, str, MAX_PATH);
			//	󕶎ȊOȂ΁A񂪊܂܂邩`FbN
			if (str[0] != 0) {
				if (AjcStrIStrW(pPath, str)) {
					rc = TRUE;
					break;
				}
			}
			//	MAX_PATHȏ̒Ȃ΁AZ~R(;)ȊOXLbv
			while (*p != L';' && *p != L'/' && *p != 0) {
				p++;
			}
			//	Z~RXLbv
			while (*p == ';' || *p == L'/') {
				p++;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	pX̖u\v`FbN																				//
//																												//
//	@	F	pParh	- pXւ̃|C^																	//
//																												//
//	߂l	F	TRUE  - pX̖́u\vł																	//
//				FALSE - pX̖́u\vȊO																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcIsPathBackslashA(C_BCP pPath)
{
	BOOL	rc = FALSE;
	int		stl;

	if (pPath != NULL) {
		stl = (int)strlen(pPath);
		if (stl != 0 && (stl >= 2 && mbsbtype(pPath, stl - 1) != _MBC_TRAIL) && pPath[stl -1] == '\\') {
			rc = TRUE;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcIsPathBackslashW(C_WCP pPath)
{
	BOOL	rc = FALSE;
	int		stl;

	if (pPath != NULL) {
		stl = (int)wcslen(pPath);
		if (stl != 0 && pPath[stl - 1] == L'\\') {
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	pX̖u\voru/v`FbN																		//
//																												//
//	@	F	pParh	- pXւ̃|C^																	//
//																												//
//	߂l	F	TRUE  - pX̖́u\voru/vł															//
//				FALSE - pX̖́u\voru/vȊO															//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcIsPathBackslashExA(C_BCP pPath)
{
	BOOL	rc = FALSE;
	int		stl;

	if (pPath != NULL) {
		stl = (int)strlen(pPath);
		if (stl != 0 && (stl >= 2 && mbsbtype(pPath, stl - 1) != _MBC_TRAIL) && (pPath[stl -1] == '\\' || pPath[stl -1] == '/')) {
			rc = TRUE;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcIsPathBackslashExW(C_WCP pPath)
{
	BOOL	rc = FALSE;
	int		stl;

	if (pPath != NULL) {
		stl = (int)wcslen(pPath);
		if (stl == 0 && (pPath[stl - 1] == L'\\' || pPath[stl - 1] == L'/')) {
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	Q̃pX̌iQ̊̕ԂɁAKP́uv}ꂽ쐬j						//
//																												//
//	@	F	pTop  - pXt镶̃AhX														//
//				pTail - t镶̃AhX																//
//				lBuf  - pXt镶obt@̑												//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathCatA(BCP pTop, C_BCP pTail, int lBuf)
{
	BOOL	rc = FALSE;
	BC		cTop, cTail;
	int		lTop;
	int		lTail;

	if (pTop != NULL && pTail != NULL) {
		lTop  = (int)strlen(pTop);
		lTail = (int)strlen(pTail);
		if (lTop == 0 || (lTop >= 2 && mbsbtype(pTop, lTop - 1) == _MBC_TRAIL)) cTop = 0;
		else																	cTop = pTop[lTop - 1];
		cTail = pTail[0];
		if		((cTop == '\\' || cTop == '/')	&&	(cTail == '\\' || cTail == '/')) {
			if (lTop + lTail <= lBuf) {
				strcat(pTop, pTail + 1);
				rc = TRUE;
			}
		}
		else if ((cTop == '\\' || cTop == '/')	||	(cTail == '\\' || cTail == '/')) {
			if (lTop + lTail <	lBuf) {
				strcat(pTop, pTail);
				rc = TRUE;
			}
		}
		else {
			if (lTop + lTail < lBuf - 1) {
				strcat(pTop, "\\");
				strcat(pTop, pTail);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathCatW(WCP pTop, C_WCP pTail, int lBuf)
{
	BOOL	rc = FALSE;
	UW		cTop, cTail;
	int		lTop;
	int		lTail;

	if (pTop != NULL && pTail != NULL) {
		lTop  = (int)wcslen(pTop);
		lTail = (int)wcslen(pTail);
		if (lTop == 0) cTop = 0;
		else		   cTop  = pTop[lTop - 1];
		cTail = pTail[0];
		if		((cTop == L'\\' || cTop == L'/')  &&  (cTail == L'\\' || cTail == L'/')) {
			if (lTop + lTail <= lBuf) {
				wcscat(pTop, pTail + 1);
				rc = TRUE;
			}
		}
		else if ((cTop == L'\\' || cTop == L'/')  ||  (cTail == L'\\' || cTail == L'/')) {
			if (lTop + lTail <	lBuf) {
				wcscat(pTop, pTail);
				rc = TRUE;
			}
		}
		else {
			if (lTop + lTail < lBuf - 1) {
				wcscat(pTop, L"\\");
				wcscat(pTop, pTail);
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Q̃pX̔ri񖖔́uv폜Ĕrj														//
//																												//
//	@	F	pPath1 - pXt镶̃AhX														//
//				pPath2 - t镶̃AhX																//
//																												//
//	߂l	F	OF 																					//
//				OFpath1 < path2																				//
//				OFpath1 > path2																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcPathCmpA(C_BCP pPath1, C_BCP pPath2)
{
	BOOL	rc = 0;
	BC		path1[MAX_PATH];
	BC		path2[MAX_PATH];

	if (pPath1 != NULL && pPath2 != NULL) {
		//	PATH1̖́uv
		AjcSnPrintFA(path1, MAX_PATH, "%s", pPath1);
		PathRemoveBackslashA(path1);

		//	PATH2̖́uv
		AjcSnPrintFA(path2, MAX_PATH, "%s", pPath2);
		PathRemoveBackslashA(path2);

		rc = mbsicmp(path1, path2);
	}
	else if (pPath1 == NULL) {
		rc = -1;
	}
	else {
		rc = 1;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcPathCmpW(C_WCP pPath1, C_WCP pPath2)
{
	BOOL	rc = 0;
	WC		path1[MAX_PATH];
	WC		path2[MAX_PATH];

	if (pPath1 != NULL && pPath2 != NULL) {
		//	PATH1̖́uv
		AjcSnPrintFW(path1, MAX_PATH, L"%s", pPath1);
		PathRemoveBackslashW(path1);

		//	PATH2̖́uv
		AjcSnPrintFW(path2, MAX_PATH, L"%s", pPath2);
		PathRemoveBackslashW(path2);

		rc = wcsicmp(path1, path2);
	}
	else if (pPath1 == NULL) {
		rc = -1;
	}
	else {
		rc = 1;
	}
	return rc;
}

//==============================================================================================================//
//	pX݂邩`FbN																				//
//																												//
//	@	F	pParh	- pXւ̃|C^																	//
//																												//
//	߂l	F	TRUE  - pX݂͑																			//
//				FALSE - pX݂͑Ȃ																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathExistsA(C_BCP pPath)
{
	BOOL	rc = FALSE;

	if (pPath != NULL) {
		rc = PathFileExistsA(pPath);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathExistsW(C_WCP pPath)
{
	BOOL	rc = FALSE;

	if (pPath != NULL) {
		rc = PathFileExistsW(pPath);
	}
	return rc;
}

//==============================================================================================================//
//	pXfBNg`FbN																			//
//																												//
//	@	F	pParh	- pXւ̃|C^																	//
//																												//
//	߂l	F	TRUE  - pX̓fBNgł																//
//				FALSE - pX̓fBNgȊO																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathIsDirectoryA(C_BCP pPath)
{
	BOOL	rc = FALSE;

	if (pPath != NULL) {
		rc = PathIsDirectoryA(pPath);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathIsDirectoryW(C_WCP pPath)
{
	BOOL	rc = FALSE;

	if (pPath != NULL) {
		rc = PathIsDirectoryW(pPath);
	}
	return rc;
}

//==============================================================================================================//
//	̃fBNg`FbN																				//
//																												//
//	@	F	pParh	- fBNgpXւ̃|C^														//
//				cbp		- R[obNp^																	//
//				cbQuery	- R[obN֐isvNULL)														//
//																												//
//	߂l	F	TRUE  - pX͋̃fBNgł															//
//				FALSE - pX͋̃fBNgȊO																//
//==============================================================================================================//
static		VO		SubIsEmptyDirW(C_WCP pPath, BOOL *rc, BOOL *pfEnd, UX cbp, BOOL (CALLBACK *cbQuery)(C_WCP pPath, UI att, BOOL *pfIgnore, UX cbp));

//----- oCg ---------------------------------------------------------------------------------------------//
typedef struct {
	UX		cbp;
	BOOL (CALLBACK *cbQuery)(C_BCP pPath, UI att, BOOL *pfIgnore, UX cbp);
} IsEmpPrm, *PIsEmpPrm;

static	BOOL	CALLBACK cbIsEmpQuery(C_WCP pPath, UI att, BOOL *pfIgnore, UX cbp);
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	BOOL	WINAPI	AjcPathIsEmptyDirectoryA(C_BCP pPath, UX cbp, BOOL (CALLBACK *cbQuery)(C_BCP pPath, UI att, BOOL *pfIgnore, UX cbp))
{
	BOOL		rc = FALSE;
	WC			pathW[MAX_PATH];
	IsEmpPrm	prm;

	if (pPath != NULL) {
		prm.cbp 	= cbp;
		prm.cbQuery = cbQuery;
		AjcByteCharToWideChar(pPath, pathW, MAX_PATH);
		rc = AjcPathIsEmptyDirectoryW(pathW, (UX)&prm, cbIsEmpQuery);
	}
	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	BOOL	CALLBACK cbIsEmpQuery(C_WCP pPath, UI att, BOOL *pfIgnore, UX cbp)
{
	BOOL		rc = TRUE;
	PIsEmpPrm	p = (PIsEmpPrm)cbp;
	BC			path[MAX_PATH];

	WideCharToMultiByte(CP_ACP, 0, pPath, -1, path, MAX_PATH, NULL, NULL);
	if (p->cbQuery != NULL) {
		rc = p->cbQuery(path, att, pfIgnore, p->cbp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathIsEmptyDirectoryW(C_WCP pPath, UX cbp, BOOL (CALLBACK *cbQuery)(C_WCP pPath, UI att, BOOL *pfIgnore, UX cbp))
{
	BOOL	rc	 = FALSE;
	BOOL	fEnd = FALSE;

	if (pPath != NULL && AjcPathIsDirectoryW(pPath)) {
		rc	 = TRUE;
		fEnd = FALSE;
		SubIsEmptyDirW(pPath, &rc, &fEnd, cbp, cbQuery);
	}
	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static		VO		SubIsEmptyDirW(C_WCP pPath, BOOL *rc, BOOL *pfEnd, UX cbp, BOOL (CALLBACK *cbQuery)(C_WCP pPath, UI att, BOOL *pfIgnore, UX cbp))
{
	HANDLE				hFind;
	WIN32_FIND_DATAW	fd;
	BOOL				fIgnore = FALSE;
	WC					PathTop [MAX_PATH];
	WC					PathWild[MAX_PATH];
	WC					PathFind[MAX_PATH];

	if (!(*pfEnd)) {
		AjcSnPrintFW(PathTop , MAX_PATH, L"%s", pPath);
		AjcSnPrintFW(PathWild, MAX_PATH, L"%s", pPath);
		AjcPathCatW (PathWild, L"*.*", MAX_PATH);
		if ((hFind = FindFirstFileW(PathWild, &fd)) != INVALID_HANDLE_VALUE) {
			do {
				if(wcscmp(fd.cFileName, L".") != 0 && wcscmp(fd.cFileName, L"..") != 0) {
					AjcSnPrintFW(PathFind, MAX_PATH, L"%s", PathTop);
					AjcPathCatW (PathFind, fd.cFileName, MAX_PATH);
					//	OtONA[
					fIgnore = FALSE;
					//	R[obN
					if (cbQuery != NULL) {
						*pfEnd = !cbQuery(PathFind, fd.dwFileAttributes, &fIgnore, cbp);
					}
					//	~̏ꍇA߂lFALSEifBNgȊOjݒ
					if (*pfEnd) {
						*rc = FALSE;
					}
					//	p̏ꍇEEE
					else if (!fIgnore) {	//	ȂH
						//	fBNgȂ΁ATufBNg
						if (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
							SubIsEmptyDirW(PathFind, rc, pfEnd, cbp, cbQuery);
						}
						//	t@CȂ΁A߂lFALSEifBNgȊOjݒ肵AI
						else {
							*rc    = FALSE;		//	߂lFALSEifBNgȊOj
							*pfEnd = TRUE;		//	I
						}
					}
				}
			} while (!(*pfEnd) && FindNextFileW(hFind, &fd));
			FindClose(hFind);
		}
	}
}
//==============================================================================================================//
//	pXt@C`FbN																				//
//																												//
//	@	F	pParh	- pXւ̃|C^																	//
//																												//
//	߂l	F	TRUE  - pX̓t@Cł																	//
//				FALSE - pX̓t@CȊO																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathIsFileA(C_BCP pPath)
{
	BOOL	rc = FALSE;

	if (pPath != NULL) {
		rc = (PathFileExistsA(pPath) && !PathIsDirectoryA(pPath));
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPathIsFileW(C_WCP pPath)
{
	BOOL	rc = FALSE;

	if (pPath != NULL) {
		rc = (PathFileExistsW(pPath) && !PathIsDirectoryW(pPath));
	}
	return rc;
}

//==============================================================================================================//
//	t@CTCY擾																							//
//																												//
//	@	F	pPath	- t@C̃pX																		//
//																												//
//	߂l	F	-1 - t@CTCY																			//
//				-1 - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	ULL	WINAPI	AjcGetFileSizeA(C_BCP pPath)
{
	ULL		rc = -1;
	struct _stati64 st;

	if (pPath != NULL) {
		if (_stati64(pPath, &st) == 0 && !(st.st_mode & _S_IFDIR)) {
			rc = st.st_size;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	ULL	WINAPI	AjcGetFileSizeW(C_WCP pPath)
{
	ULL		rc = -1;
	struct _stati64 st;

	if (pPath != NULL) {
		if (_wstati64(pPath, &st) == 0 && !(st.st_mode & _S_IFDIR)) {
			rc = st.st_size;
		}
	}
	return rc;
}
//==============================================================================================================//
//	t@C^C擾																							//
//																												//
//	@	F	pPath	- t@C̃pX																		//
//																												//
//	߂l	F	-1 - t@C^C																			//
//				-1 - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcGetFileTime1970A(C_BCP pPath)
{
	UL		rc = -1;
	struct _stati64 st;

	if (pPath != NULL) {
		if (_stati64(pPath, &st) == 0 && !(st.st_mode & _S_IFDIR)) {
			if (st.st_mtime <= 0xFFFFFFFE) {
				rc = (UI)st.st_mtime;
			}
			else {
				rc = 0xFFFFFFFE;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcGetFileTime1970W(C_WCP pPath)
{
	UL		rc = -1;
	struct _stati64 st;

	if (pPath != NULL) {
		if (_wstati64(pPath, &st) == 0 && !(st.st_mode & _S_IFDIR)) {
			if (st.st_mtime <= 0xFFFFFFFE) {
				rc = (UI)st.st_mtime;
			}
			else {
				rc = 0xFFFFFFFE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	t@Cr																								//
//																												//
//	@	F	pFile1, pFile2	- rQ̃t@CpX													//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - sv^G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcFileCompareA(C_BCP pFile1, C_BCP pFile2)
{
	BOOL	rc = TRUE;
	HANDLE	hF1 = INVALID_HANDLE_VALUE;
	HANDLE	hF2 = INVALID_HANDLE_VALUE;
	UL		bytes1;
	UL		bytes2;
	UB		buf1[2048];
	UB		buf2[2048];

	do {
		if ((hF1 = CreateFileA(pFile1, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE) {rc = FALSE; break;}
		if ((hF2 = CreateFileA(pFile2, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE) {rc = FALSE; break;}

		if (!ReadFile(hF1, buf1, sizeof buf1, &bytes1, NULL)) {rc = FALSE; break;}
		if (!ReadFile(hF2, buf2, sizeof buf2, &bytes2, NULL)) {rc = FALSE; break;}
		while (bytes1 == bytes2 && bytes1 != 0) {
			if (memcmp(buf1, buf2, bytes1) != 0) {
				rc = FALSE;
				break;
			}
			if (!ReadFile(hF1, buf1, sizeof buf1, &bytes1, NULL)) {rc = FALSE; break;}
			if (!ReadFile(hF2, buf2, sizeof buf2, &bytes2, NULL)) {rc = FALSE; break;}
		}
		if (bytes1 != bytes2) rc = FALSE;
	} while(0);

	if (hF1 != INVALID_HANDLE_VALUE) CloseHandle(hF1);
	if (hF2 != INVALID_HANDLE_VALUE) CloseHandle(hF2);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcFileCompareW(C_WCP pFile1, C_WCP pFile2)
{
	BOOL	rc = TRUE;
	HANDLE	hF1 = INVALID_HANDLE_VALUE;
	HANDLE	hF2 = INVALID_HANDLE_VALUE;
	UL		bytes1;
	UL		bytes2;
	UB		buf1[2048];
	UB		buf2[2048];

	do {
		if ((hF1 = CreateFileW(pFile1, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE) {rc = FALSE; break;}
		if ((hF2 = CreateFileW(pFile2, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE) {rc = FALSE; break;}

		if (!ReadFile(hF1, buf1, sizeof buf1, &bytes1, NULL)) {rc = FALSE; break;}
		if (!ReadFile(hF2, buf2, sizeof buf2, &bytes2, NULL)) {rc = FALSE; break;}
		while (bytes1 == bytes2 && bytes1 != 0) {
			if (memcmp(buf1, buf2, bytes1) != 0) {
				rc = FALSE;
				break;
			}
			if (!ReadFile(hF1, buf1, sizeof buf1, &bytes1, NULL)) {rc = FALSE; break;}
			if (!ReadFile(hF2, buf2, sizeof buf2, &bytes2, NULL)) {rc = FALSE; break;}
		}
		if (bytes1 != bytes2) rc = FALSE;
	} while(0);

	if (hF1 != INVALID_HANDLE_VALUE) CloseHandle(hF1);
	if (hF2 != INVALID_HANDLE_VALUE) CloseHandle(hF2);

	return rc;
}
//==============================================================================================================//
//	t@C^fBNg̃^CX^v擾																	//
//																												//
//	@	F	pPath		- t@C^fBNg̃pX													//
//				pFTimes		- 擾^CX^viʎZji[obt@isvNULLj					//
//				pSTimes		- 擾^CX^viji[obt@isvNULLj					//
//				fLocalTime	- TRUE	: [J^CŎ擾														//
//							  FALSE : tsbŎ擾																//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : G[																					//
//==============================================================================================================//
static	BOOL	SubGetTimeStamp(HANDLE hFile, PAJCFTIMES pFTimes, PAJCSTIMES pSTimes, BOOL fLocalTime);
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcGetFileTimeA(C_BCP pPath, PAJCFTIMES pFTimes, PAJCSTIMES pSTimes, BOOL fLocalTime)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;

	if (pPath != NULL) {
		if ((hFile = CreateFileA(pPath,
								 GENERIC_READ,
								 FILE_SHARE_READ,
								 NULL,
								 OPEN_EXISTING,
								 AjcPathIsDirectoryA(pPath) ? FILE_FLAG_BACKUP_SEMANTICS : FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			rc = SubGetTimeStamp(hFile, pFTimes, pSTimes, fLocalTime);
			CloseHandle(hFile);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcGetFileTimeW(C_WCP pPath, PAJCFTIMES pFTimes, PAJCSTIMES pSTimes, BOOL fLocalTime)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;

	if (pPath != NULL) {
		if ((hFile = CreateFileW(pPath,
								 GENERIC_READ,
								 FILE_SHARE_READ,
								 NULL,
								 OPEN_EXISTING,
								 AjcPathIsDirectoryW(pPath) ? FILE_FLAG_BACKUP_SEMANTICS : FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			rc = SubGetTimeStamp(hFile, pFTimes, pSTimes, fLocalTime);
			CloseHandle(hFile);
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubGetTimeStamp(HANDLE hFile, PAJCFTIMES pFTimes, PAJCSTIMES pSTimes, BOOL fLocalTime)
{
	BOOL	rc = FALSE;
	AJCUFT	lfmk, lfac, lfup;		//	t@C^Ci[J^Cj
	AJCUFT	sfmk, sfac, sfup;		//	t@C^Citsbj

	//	^CX^v擾
	if (GetFileTime(hFile, &sfmk.ft, &sfac.ft, &sfup.ft)) {
		//	[J^C擾
		if (fLocalTime) {
			//	[J^C֕ϊ
			FileTimeToLocalFileTime(&sfmk.ft, &lfmk.ft);
			FileTimeToLocalFileTime(&sfac.ft, &lfac.ft);
			FileTimeToLocalFileTime(&sfup.ft, &lfup.ft);
			//	߂([JʎZ)ݒ
			if (pFTimes != NULL) {
				pFTimes->mk.v = lfmk.v;
				pFTimes->ac.v = lfac.v;
				pFTimes->up.v = lfup.v;
			}
			//	߂([J)ݒ
			if (pSTimes != NULL) {
				FileTimeToSystemTime(&lfmk.ft, &pSTimes->mk);
				FileTimeToSystemTime(&lfac.ft, &pSTimes->ac);
				FileTimeToSystemTime(&lfup.ft, &pSTimes->up);
			}
		}
		//	tsb擾
		else {
			//	߂(tsbʎZ)ݒ
			if (pFTimes != NULL) {
				pFTimes->mk.v = sfmk.v;
				pFTimes->ac.v = sfac.v;
				pFTimes->up.v = sfup.v;
			}
			//	߂(tsb)ݒ
			if (pSTimes != NULL) {
				FileTimeToSystemTime(&sfmk.ft, &pSTimes->mk);
				FileTimeToSystemTime(&sfac.ft, &pSTimes->ac);
				FileTimeToSystemTime(&sfup.ft, &pSTimes->up);
			}
		}
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	t@C^fBNg̃^CX^vݒiʎZŐݒj												//
//																												//
//	@	F	pPath		- t@C^fBNg̃pX													//
//				pFTimes		- ݒ肷^CX^viʎZj												//
//				fLocalTime	- TRUE	: [J^CŐݒ														//
//							  FALSE : tsbŐݒ																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
static	BOOL	SubSetTimeStamp(HANDLE hFile, PCAJCFTIMES pFTimes, BOOL fLocalTime);
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeA(C_BCP pPath, PCAJCFTIMES pFTimes, BOOL fLocalTime)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;

	if (pPath != NULL && pFTimes != NULL) {
		if ((hFile = CreateFileA(pPath,
								 GENERIC_WRITE,
								 FILE_SHARE_WRITE,
								 NULL,
								 OPEN_EXISTING,
								 AjcPathIsDirectoryA(pPath) ? FILE_FLAG_BACKUP_SEMANTICS : FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			rc = SubSetTimeStamp(hFile, pFTimes, fLocalTime);
			CloseHandle(hFile);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeW(C_WCP pPath, PCAJCFTIMES pFTimes, BOOL fLocalTime)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;

	if (pPath != NULL) {
		if ((hFile = CreateFileW(pPath,
								 GENERIC_WRITE,
								 FILE_SHARE_WRITE,
								 NULL,
								 OPEN_EXISTING,
								 AjcPathIsDirectoryW(pPath) ? FILE_FLAG_BACKUP_SEMANTICS : FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			rc = SubSetTimeStamp(hFile, pFTimes, fLocalTime);
			CloseHandle(hFile);
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubSetTimeStamp(HANDLE hFile, PCAJCFTIMES pFTimes, BOOL fLocalTime)
{
	BOOL	rc = FALSE;
	AJCUFT	sfmk, sfac, sfup;		//	ݒt@C^Citsbj
	AJCUFT	gfmk, gfac, gfup;		//	擾t@C^Citsbj

	if (fLocalTime) {
		//	[J^Ctsbϊ
		LocalFileTimeToFileTime(&pFTimes->mk.ft, &sfmk.ft);
		LocalFileTimeToFileTime(&pFTimes->ac.ft, &sfac.ft);
		LocalFileTimeToFileTime(&pFTimes->up.ft, &sfup.ft);
		//	t@C^Cݒ
		if (SetFileTime(hFile, &sfmk.ft, &sfac.ft, &sfup.ft)) {
			//	ɐݒ肳ꂽ`FbN
			if (GetFileTime(hFile, &gfmk.ft, &gfac.ft, &gfup.ft)) {
				if (memcmp(&sfup, &gfup, sizeof sfup) == 0) {
					rc = TRUE;
				}
			}
		}
	}
	else {
		//	t@C^Cݒ
		if (SetFileTime(hFile, &pFTimes->mk.ft, &pFTimes->ac.ft, &pFTimes->up.ft)) {
			//	ɐݒ肳ꂽ`FbN
			if (GetFileTime(hFile, &gfmk.ft, &gfac.ft, &gfup.ft)) {
				if (memcmp(&sfup, &gfup, sizeof sfup) == 0) {
					rc = TRUE;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	t@C^fBNg̃^CX^vݒiŐݒj													//
//																												//
//	@	F	pPath		- t@C^fBNg̃pX													//
//				pSTime		- ݒ肷^CX^vij													//
//				fLocalTime	- TRUE	: [J^CŐݒ														//
//							  FALSE : tsbŐݒ																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
static	BOOL	SubSetTimeStampBySysTime(HANDLE hFile, LPSYSTEMTIME pSTime, BOOL fLocalTime);
static	VO		SubAdjustUru(LPSYSTEMTIME pSTime);
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeBySysTimeA(C_BCP pPath, LPSYSTEMTIME pSTime, BOOL fLocalTime)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;

	if (pPath != NULL && pSTime != NULL) {
		if ((hFile = CreateFileA(pPath,
								 GENERIC_READ | GENERIC_WRITE,
								 FILE_SHARE_READ | FILE_SHARE_WRITE,
								 NULL,
								 OPEN_EXISTING,
								 AjcPathIsDirectoryA(pPath) ? FILE_FLAG_BACKUP_SEMANTICS : FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			rc = SubSetTimeStampBySysTime(hFile, pSTime, fLocalTime);
			CloseHandle(hFile);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeBySysTimeW(C_WCP pPath, LPSYSTEMTIME pSTime, BOOL fLocalTime)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;

	if (pPath != NULL && pSTime != NULL) {
		if ((hFile = CreateFileW(pPath,
								 GENERIC_READ | GENERIC_WRITE,
								 FILE_SHARE_READ | FILE_SHARE_WRITE,
								 NULL,
								 OPEN_EXISTING,
								 AjcPathIsDirectoryW(pPath) ? FILE_FLAG_BACKUP_SEMANTICS : FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			rc = SubSetTimeStampBySysTime(hFile, pSTime, fLocalTime);
			CloseHandle(hFile);
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubSetTimeStampBySysTime(HANDLE hFile, LPSYSTEMTIME pSTime, BOOL fLocalTime)
{
	BOOL		rc = FALSE;
	AJCSTIMES	stm;					//	t@C̃^CX^v
	AJCSTIMES	dtm;					//	ݒ肷^CX^v
	AJCFTIMES	ftm;					//	t@C^Ciwlj
	AJCFTIMES	utc;					//	t@C^Citsbj
	AJCFTIMES	ugt;					//	擾t@C^Citsbj

	do {
		if (!SubGetTimeStamp(hFile, NULL, &stm, fLocalTime)) break;
		//	ݒ肷Rs[
		memcpy(&dtm.mk, pSTime, sizeof dtm.mk);
		memcpy(&dtm.ac, pSTime, sizeof dtm.ac);
		memcpy(&dtm.up, pSTime, sizeof dtm.up);
		//	ݒ쐬i-1̍ڂ͌t@C̒l̗pj
		if (pSTime->wYear		  == 0xFFFF) {dtm.mk.wYear		   = stm.mk.wYear;		   dtm.ac.wYear 		= stm.ac.wYear; 		dtm.up.wYear		 = stm.up.wYear;		}
		if (pSTime->wMonth		  == 0xFFFF) {dtm.mk.wMonth 	   = stm.mk.wMonth; 	   dtm.ac.wMonth		= stm.ac.wMonth;		dtm.up.wMonth		 = stm.up.wMonth;		}
		if (pSTime->wDay		  == 0xFFFF) {dtm.mk.wDay		   = stm.mk.wDay;		   dtm.ac.wDay			= stm.ac.wDay;			dtm.up.wDay 		 = stm.up.wDay; 		}
		if (pSTime->wHour		  == 0xFFFF) {dtm.mk.wHour		   = stm.mk.wHour;		   dtm.ac.wHour 		= stm.ac.wHour; 		dtm.up.wHour		 = stm.up.wHour;		}
		if (pSTime->wMinute 	  == 0xFFFF) {dtm.mk.wMinute	   = stm.mk.wMinute;	   dtm.ac.wMinute		= stm.ac.wMinute;		dtm.up.wMinute		 = stm.up.wMinute;		}
		if (pSTime->wSecond 	  == 0xFFFF) {dtm.mk.wSecond	   = stm.mk.wSecond;	   dtm.ac.wSecond		= stm.ac.wSecond;		dtm.up.wSecond		 = stm.up.wSecond;		}
		if (pSTime->wMilliseconds == 0xFFFF) {dtm.mk.wMilliseconds = stm.mk.wMilliseconds; dtm.ac.wMilliseconds = stm.ac.wMilliseconds; dtm.up.wMilliseconds = stm.up.wMilliseconds;}
		//	邤NȊȌꍇAQQX  QQW
		SubAdjustUru(&dtm.mk);
		SubAdjustUru(&dtm.ac);
		SubAdjustUru(&dtm.up);
		//	\̂t@C^Cɕϊ
		if (!SystemTimeToFileTime(&dtm.mk, &ftm.mk.ft)) break;
		if (!SystemTimeToFileTime(&dtm.ac, &ftm.ac.ft)) break;
		if (!SystemTimeToFileTime(&dtm.up, &ftm.up.ft)) break;
		//	t@C^Ctsbɕϊ
		if (fLocalTime) {
			if (!LocalFileTimeToFileTime(&ftm.mk.ft, &utc.mk.ft)) break;
			if (!LocalFileTimeToFileTime(&ftm.ac.ft, &utc.ac.ft)) break;
			if (!LocalFileTimeToFileTime(&ftm.up.ft, &utc.up.ft)) break;
		}
		else {
			memcpy(&utc, &ftm, sizeof utc);
		}
		//	t@C^C̖␳
		if (utc.ac.v < utc.mk.v) utc.ac.v = utc.mk.v;	//	ANZX  쐬 Ȃ΁AANZX  쐬
		if (utc.up.v < utc.mk.v) utc.up.v = utc.mk.v;	//	XV  쐬 Ȃ΁AXV  쐬
		if (utc.ac.v < utc.up.v) utc.ac.v = utc.up.v;	//	ANZX  XV Ȃ΁AANZX  XV
		//	t@C^Cݒ
		if (!SetFileTime(hFile, &utc.mk.ft, &utc.ac.ft, &utc.up.ft)) break;
		//	ɐݒ肳ꂽ`FbN
		if (!GetFileTime(hFile, &ugt.mk.ft, &ugt.ac.ft, &ugt.up.ft)) break;
		if (utc.up.v != ugt.up.v) break;
		//	߂l
		rc = TRUE;
	} while (0);
	return rc;
}
//----- 邤NȊȌꍇAQQX  QQW -----------------------------------------------------------//
static	VO	SubAdjustUru(LPSYSTEMTIME pSTime)
{
	if (!((pSTime->wYear % 4) == 0 && ((pSTime->wYear % 100) != 0 || (pSTime->wYear % 400) == 0))) {
		if (pSTime->wMonth == 2 && pSTime->wDay == 29) pSTime->wDay = 28;
	}
}
//==============================================================================================================//
//	Q̃pXꂩ`FbN																				//
//																												//
//	@	F	pBase			- x[XpXiNULL̏ꍇ̓JgfBNgj								//
//				pRel1, pRel2	- Q̃t@C^fBNg̃pX											//
//																												//
//	߂l	F	NULL	- viۂ̃pXւ̃|C^j														//
//				NULL	- sv																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_BCP	WINAPI	AjcIsSamePathA(C_BCP pBase, C_BCP pRel1, C_BCP pRel2)
{
		BCP		rc = NULL;
		int		stl;
		BC		szBase[MAX_PATH]	 = {0};
		BC		szRel1[MAX_PATH * 2] = {0};
		BC		szRel2[MAX_PATH * 2] = {0};
static	BC		szAbs1[MAX_PATH * 2] = {0};
		BC		szAbs2[MAX_PATH * 2] = {0};

	if (pRel1 != NULL && pRel2 != NULL) {
		memset(szAbs1, 0, sizeof(szAbs1));
		//	Q̃pXޔ
		AjcSnPrintFA(szRel1, AJCTSIZE(szRel1), "%s", pRel1);
		AjcSnPrintFA(szRel2, AJCTSIZE(szRel2), "%s", pRel2);
		//	Q̃pX̖u\v킹
		stl = (int)strlen(pRel1);
		if (stl >= 1 && szRel1[stl - 1] == '\\') AjcPathCatA		 (szRel2, "", AJCTSIZE(szRel2));
		else									 PathRemoveBackslashA(szRel2);
		do {
			//	x[XpXݒ
			if (pBase != NULL) AjcSnPrintFA(szBase, AJCTSIZE(szBase), "%s", pBase);
			else			   GetCurrentDirectoryA(AJCTSIZE(szBase), szBase);
			//	΃pXP쐬
			if (PathCombineA(szAbs1, szBase, szRel1) == NULL) {
				break;
			}
			//	΃pXQ쐬
			if (PathCombineA(szAbs2, szBase, szRel2) == NULL) {
				break;
			}
			//	r
			if (stricmp(szAbs1, szAbs2) == 0) {
				rc = szAbs1;
			}
		} while(0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_WCP	WINAPI	AjcIsSamePathW(C_WCP pBase, C_WCP pRel1, C_WCP pRel2)
{
		WCP		rc = NULL;
		int		stl;
		WC		szBase[MAX_PATH]	 = {0};
		WC		szRel1[MAX_PATH * 2] = {0};
		WC		szRel2[MAX_PATH * 2] = {0};
static	WC		szAbs1[MAX_PATH * 2] = {0};
		WC		szAbs2[MAX_PATH * 2] = {0};

	if (pRel1 != NULL && pRel2 != NULL) {
		memset(szAbs1, 0, sizeof(szAbs1));
		//	Q̃pXޔ
		AjcSnPrintFW(szRel1, AJCTSIZE(szRel1), L"%s", pRel1);
		AjcSnPrintFW(szRel2, AJCTSIZE(szRel2), L"%s", pRel2);
		//	Q̃pX̖u\v킹
		stl = (int)wcslen(pRel1);
		if (stl >= 1 && szRel1[stl - 1] == L'\\') AjcPathCatW		  (szRel2, L"", AJCTSIZE(szRel2));
		else									  PathRemoveBackslashW(szRel2);
		do {
			//	x[XpXݒ
			if (pBase != NULL) AjcSnPrintFW(szBase, AJCTSIZE(szBase), L"%s", pBase);
			else			   GetCurrentDirectoryW(AJCTSIZE(szBase), szBase);
			//	΃pXP쐬
			if (PathCombineW(szAbs1, szBase, szRel1) == NULL) {
				break;
			}
			//	΃pXQ쐬
			if (PathCombineW(szAbs2, szBase, szRel2) == NULL) {
				break;
			}
			//	r
			if (wcsicmp(szAbs1, szAbs2) == 0) {
				rc = szAbs1;
			}
		} while(0);
	}
	return rc;
}
//==============================================================================================================//
//	Q̃pXŁAЕTupXł邩`FbN															//
//																												//
//	@	F	pBase		- x[XpXiNULL / ΃pXjv													//
//				pUpperPath	- ʃpX							ipBase=NULL͐΃pXj						//
//				pUnderPath	- ʃpX`FbNtH_pXipBase=NULL͐΃pXj						//
//																												//
//	߂l	F	TRUE	- ʃpX͏ʃpX̃TupXłipX܂ށj									//
//				FALSE	- ʃpX͏ʃpX̃TutpXłȂ													//
//				-1		- G[i΃pXłȂꍇ܂ށj													//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcIsUnderPathA(C_BCP pBase, C_BCP pUpperPath, C_BCP pUnderPath)
{
	BOOL	rc = -1;
	int		stlUpper;
	int		stlUnder;
	BC		szUpper[MAX_PATH];
	BC		szUnder[MAX_PATH];

	if (pUpperPath != NULL && pUnderPath != NULL) {
		do {
			//	pX𐳋K
			if (PathCombineA(szUpper, pBase, pUpperPath) == NULL) break;
			if (PathCombineA(szUnder, pBase, pUnderPath) == NULL) break;
			//	ʃpX̖́u\v폜
			PathRemoveBackslashA(szUpper);
			//	pX̕񒷐ݒ
			stlUpper = (int)strlen(szUpper);
			stlUnder = (int)strlen(szUnder);
			//	ʃpXZ΁Ad`FbN
			if (stlUpper <= stlUnder) {
				//	pX̐擪vʃpX̎'\'/0ȂΏd
				if (strnicmp(szUpper, szUnder, stlUpper) == 0 && (szUnder[stlUpper] == '\\' || szUnder[stlUpper] == 0)) {
					rc = TRUE;
				}
				//	pX̐擪svȂ΁AdȂ
				else {
					rc = FALSE;
				}
			}
			//	ʃpXZꍇ́AdȂ
			else {
				rc = FALSE;
			}
		} while(0);
	}

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcIsUnderPathW(C_WCP pBase, C_WCP pUpperPath, C_WCP pUnderPath)
{
	BOOL	rc = -1;
	int		stlUpper;
	int		stlUnder;
	WC		szUpper[MAX_PATH];
	WC		szUnder[MAX_PATH];

	if (pUpperPath != NULL && pUnderPath != NULL) {
		do {
			//	pX𐳋K
			if (PathCombineW(szUpper, pBase, pUpperPath) == NULL) break;
			if (PathCombineW(szUnder, pBase, pUnderPath) == NULL) break;
			//	ʃpX̖́u\v폜
			PathRemoveBackslashW(szUpper);
			//	pX̕񒷐ݒ
			stlUpper = (int)wcslen(szUpper);
			stlUnder = (int)wcslen(szUnder);
			//	ʃpXZ΁Ad`FbN
			if (stlUpper <= stlUnder) {
				//	pX̐擪vʃpX̎'\'/0ȂΏd
				if (wcsnicmp(szUpper, szUnder, stlUpper) == 0 && (szUnder[stlUpper] == L'\\' || szUnder[stlUpper] == 0)) {
					rc = TRUE;
				}
				//	pX̐擪svȂ΁AdȂ
				else {
					rc = FALSE;
				}
			}
			//	ʃpXZꍇ́AdȂ
			else {
				rc = FALSE;
			}
		} while(0);
	}

	return rc;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpT|[gR[h																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
typedef struct {
	UX	cbp;
	BOOL (CALLBACK *cbEnum )(BOOL fValid1, UI utc1, UI att1, ULL size1, C_WCP pPath1, C_WCP pName1, C_WCP pTail1,
							 BOOL fValid2, UI utc2, UI att2, ULL size2, C_WCP pPath2, C_WCP pName2, C_WCP pTail2, UX cbp);
} FMLPARAM, *PFMLPARAM;

//	R[obN
static	BOOL	CALLBACK cbFmlEnum(AJCFMLITEMW item[2], UX cbp)
{
	BOOL		rc = TRUE;
	PFMLPARAM	p  = (PFMLPARAM)cbp;

	if (p->cbEnum != NULL) {
		rc = p->cbEnum(item[0].fValid, item[0].hd.utc, item[0].hd.att, item[0].hd.size, item[0].path, item[0].name, item[0].tail,
					   item[1].fValid, item[1].hd.utc, item[1].hd.att, item[1].hd.size, item[1].path, item[1].name, item[1].tail, cbp);
	}
	return rc;
}
//	`oh
AJCEXPORT	BOOL	WINAPI	AjcEnumFileMatchingListMsil(C_WCP pPath1, C_WCP pPath2, UI opt, UX cbp, 
					BOOL (CALLBACK *cbQuery)(UI id, C_WCP pPath, UI att, BOOL *fDiscard, UX cbp),
					BOOL (CALLBACK *cbEnum )(BOOL fValid1, UI utc1, UI att1, ULL size1, C_WCP pPath1, C_WCP pName1, C_WCP pTail1,
											 BOOL fValid2, UI utc2, UI att2, ULL size2, C_WCP pPath2, C_WCP pName2, C_WCP pTail2, UX cbp))
{
	BOOL		rc = FALSE;
	FMLPARAM	prm;
	prm.cbp 	= cbp;
	prm.cbEnum	= cbEnum;

	rc = AjcEnumFilesMatchingListW(pPath1, pPath2, opt, (UX)&prm, cbQuery, cbFmlEnum);

	return rc;
}


