#include	"AjcInternal.h"

//==============================================================================================================//
//	C[Wf[^ǂݏo																						//
//																												//
//	@	F	pImgInfo	- C[Wi[obt@̃AhX											//
//				szFileName	- C[Wt@CEpX															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcImgFuncReadA(PAJC_IMGINFO pImgInfo, C_BCP pFilePath)
{
	BOOL	rc = FALSE;
	int		len;
	WCP		pTmp;

	if (pFilePath != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pFilePath, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pFilePath, -1, pTmp, len);
			rc = AjcImgFuncReadW(pImgInfo, pTmp);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcImgFuncReadW(PAJC_IMGINFO pImgInfo, C_WCP pFilePath)
{
	BOOL	rc = FALSE;
	WC		ext[_MAX_EXT];

	if (pImgInfo != NULL && pFilePath != NULL) {
		//----- C[WNA[ ---------------------------------------------------------------------------//
		memset(pImgInfo, 0, sizeof(AJC_IMGINFO));
		//----- C[Wt@Cgqo ---------------------------------------------------------------------//
		_wsplitpath(pFilePath, NULL, NULL, NULL, ext);

		//----- C[Wt@Cǂݏo -----------------------------------------------------------------------//
		if (wcsicmp(ext, L".bmp") == 0) {
			pImgInfo->hBmp = AjcCreateDibFromFile(pFilePath, (UIP)&pImgInfo->width, (UIP)&pImgInfo->height, NULL, NULL);
			rc = pImgInfo->fValid = (pImgInfo->hBmp != NULL);
		}
		if (wcsicmp(ext, L".bmp") != 0	||	rc == FALSE)	 {
			IShellImageDataFactory	*pShellImageDataFactory = NULL;
			IShellImageData			*pShellImageData		= NULL;
			SIZE					sz;
			do {
				if (CoCreateInstance(CLSID_ShellImageDataFactory, NULL, CLSCTX_INPROC_SERVER, IID_PPV_ARGS(&pShellImageDataFactory)) != S_OK) break;
				if (pShellImageDataFactory->CreateImageFromFile(pFilePath, (IShellImageData **)&pShellImageData)					 != S_OK) break;
				if (pShellImageData->Decode(SHIMGDEC_DEFAULT, 0, 0) 																 != S_OK) break;
				if (pShellImageData->GetSize(&sz)																					 != S_OK) break;
				pImgInfo->hFactory = pShellImageDataFactory;
				pImgInfo->hImg	   = pShellImageData;
				pImgInfo->width    = sz.cx;
				pImgInfo->height   = sz.cy;
				pImgInfo->fValid   = TRUE;
				rc				   = TRUE;
			} while(0);
			//	G[IShellImageDataFactory
			if (!rc && pImgInfo->hFactory != NULL) {
				((IShellImageDataFactory*)pImgInfo->hFactory)->Release();
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	C[W`																								//
//																												//
//	@	F	hdc			- `悷foCXEReLXgi`j											//
//				pImgInfo	- C[W̃AhX		i`挳j											//
//				pSrc		- `挳̒`̈																//
//				hdc			- `̂cb																		//
//				pDst		- `̒`̈																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcImgFuncDraw(PAJC_IMGINFO pImgInfo, LPRECT pSrc, HDC hdc, LPRECT pDst)
{
	BOOL	rc = FALSE;
	HDC		hmd;

	if (pImgInfo != NULL && pSrc != NULL && hdc != NULL && pDst != NULL) {
		if (pImgInfo->fValid) {
			if		(pImgInfo->hBmp != NULL) {
				hmd = CreateCompatibleDC(hdc);
				SelectObject(hmd, pImgInfo->hBmp);
				StretchBlt(hdc, pDst->left, pDst->top, pDst->right - pDst->left , pDst->bottom - pDst->top,
						   hmd, pSrc->left, pSrc->top, pSrc->right - pSrc->left , pSrc->bottom - pSrc->top, SRCCOPY);
				DeleteDC(hmd);
				rc = TRUE;
			}
			else if (pImgInfo->hImg != NULL) {
				IShellImageData	*pShellImageData = (IShellImageData *)pImgInfo->hImg;
				if (pShellImageData->Draw(hdc, pDst, pSrc) == S_OK) {
					rc = TRUE;
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	C[Wf[^																							//
//																												//
//	@	F	pImgInfo	- C[W̃AhX															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	 BOOL	WINAPI	AjcImgFuncRelease(PAJC_IMGINFO pImgInfo)
{
	BOOL	rc = FALSE;

	if (pImgInfo != NULL) {
		if (pImgInfo->fValid) {
			if (pImgInfo->hBmp != NULL) {
				DeleteObject(pImgInfo->hBmp);
				pImgInfo->hBmp = NULL;
				rc = TRUE;
			}
			else if (pImgInfo->hFactory != NULL) {
				IShellImageDataFactory	*pShellImageDataFactory = (IShellImageDataFactory *)pImgInfo->hFactory;
				pShellImageDataFactory->Release();
				pImgInfo->hFactory = NULL;
				pImgInfo->hImg	   = NULL;
				rc = TRUE;
			}
			pImgInfo->fValid = FALSE;
		}
	}
	return rc;
}

