#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	hmht@CANZX																						//
//																												//
//**************************************************************************************************************//
//--------------------------------------------------------------------------------------------------------------//
//	Ɨ̈																									//
//--------------------------------------------------------------------------------------------------------------//
//	oCif[^i[fBNgpX
static	BC		BinDataDirA[MAX_PATH] = {0};
static	WC		BinDataDirW[MAX_PATH] = {0};

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
extern	BCP		SubProfileGenerateBinFileA(BOOL fVolatile, C_BCP pTail, BC full[MAX_PATH], C_BCP pBinDir);
extern	WCP		SubProfileGenerateBinFileW(BOOL fVolatile, C_WCP pTail, UW full[MAX_PATH], C_WCP pBinDir);

extern	BOOL	SubProfileDeleteBinFileA(C_BCP pTail, C_BCP pBinDir);
extern	BOOL	SubProfileDeleteBinFileW(C_WCP pTail, C_WCP pBinDir);


static	BOOL	CreateIniFileA(C_BCP pIniFile);
static	BOOL	CreateIniFileW(C_WCP pIniFile);

//==============================================================================================================//
//	oCif[^i[fBNgpXݒ																		//
//																												//
//	@	F	pBinDir	   - oCif[^i[fBNgpXiNULL̏ꍇ́Aۑj						//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcSetIniBinDirA(C_BCP pBinDir)
{
	if (pBinDir != NULL && *pBinDir != 0) {
		AjcSnPrintFA(BinDataDirA, MAX_PATH, "%s", pBinDir);
		AjcPathCatA(BinDataDirA, "", MAX_PATH);
		BinDataDirA[MAX_PATH - 1] = 0;
	}
	else {
		AjcGetAppPathA(BinDataDirA, MAX_PATH);
	}
	MultiByteToWideChar(CP_ACP, 0, BinDataDirA, -1, BinDataDirW, MAX_PATH);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcSetIniBinDirW(C_WCP pBinDir)
{
	if (pBinDir != NULL && *pBinDir != 0) {
		AjcSnPrintFW(BinDataDirW, MAX_PATH, L"%s", pBinDir);
		AjcPathCatW(BinDataDirW, L"", MAX_PATH);
		BinDataDirW[MAX_PATH - 1] = 0;
	}
	else {
		AjcGetAppPathW(BinDataDirW, MAX_PATH);
	}
	WideCharToMultiByte(CP_ACP, 0, BinDataDirW, -1, BinDataDirA, MAX_PATH, NULL, NULL);
}
//==============================================================================================================//
//	oCif[^i[fBNgpX擾																		//
//																												//
//	@	F	pBuf	- oCif[^i[fBNgpXi[obt@̃AhX						//
//				lBuf	- oCif[^i[fBNgpXi[obt@̕							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcGetIniBinDirA(BCP pBuf, UI lBuf)
{
	if (pBuf != NULL  &&  lBuf > 0) {
		AjcSnPrintFA(pBuf, lBuf, "%s", BinDataDirA);
	}
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcGetIniBinDirW(WCP pBuf, UI lBuf)
{
	if (pBuf != NULL  &&  lBuf > 0) {
		AjcSnPrintFW(pBuf, lBuf, L"%s", BinDataDirW);
	}
}

//==============================================================================================================//
//	hmht@Cǂݏoilj																				//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				defValue	- ftHgl																		//
//																												//
//	߂lF	hmht@CǂݏoYL[l^ftHgl											//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
#define	M_GSGETPROFILEN_A(_T1_, _T2_, _BS_, _CV_)																\
AJCEXPORT _T1_ 	WINAPI AjcGetIniFile##_T2_##A(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, _T1_ defValue)	\
{	_T1_	rc = defValue;																						\
	BOOL	fHex;																								\
	BCP		p;																									\
	BC	buf[_BS_];																								\
	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {												\
		GetPrivateProfileStringA(pSecName, pKeyName, "$$UNDEF$$", buf, _BS_, pIniFile);							\
		if (mbscmp(buf, "$$UNDEF$$") == 0) {																	\
			rc = defValue;																						\
		}																										\
		else {																									\
			for (p=buf; MAjcIsBlankA(*p); p++);																	\
			fHex = (strnicmp(p, "0x", 2) == 0);																	\
			rc = (_T1_)_CV_;																					\
		}																										\
	}																											\
	return rc;																									\
}
M_GSGETPROFILEN_A(UI	, UInt,  32, fHex ? AjcHexToUIA(p) : AjcDecToUIA(p))
M_GSGETPROFILEN_A(SI	, SInt,  32, fHex ? AjcHexToUIA(p) : atoi(p))
M_GSGETPROFILEN_A(UI	, Hex ,  32, fHex ? AjcHexToUIA(p) : AjcDecToUIA(p))
M_GSGETPROFILEN_A(double, Real, 512, AjcAscToRealA(p))
M_GSGETPROFILEN_A(ULL	, UI64,  64, fHex ? AjcHexToULLA(p) : AjcDecToULLA(p))
M_GSGETPROFILEN_A(SLL	, SI64,  64, fHex ? AjcHexToULLA(p) : _atoi64(p))
M_GSGETPROFILEN_A(ULL	, H64 ,  64, fHex ? AjcHexToULLA(p) : AjcDecToULLA(p))

//----- Chp -------------------------------------------------------------------------------------------//
#define	M_GSGETPROFILEN_W(_T1_, _T2_, _BS_, _CV_)																\
AJCEXPORT _T1_ 	WINAPI AjcGetIniFile##_T2_##W(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, _T1_ defValue)	\
{	_T1_	rc = defValue;																						\
	BOOL	fHex;																								\
	WCP		p;																									\
	WC	buf[_BS_];																								\
	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {												\
		GetPrivateProfileStringW(pSecName, pKeyName, L"$$UNDEF$$", buf, _BS_, pIniFile);						\
		if (wcscmp(buf, L"$$UNDEF$$") == 0) {																	\
			rc = defValue;																						\
		}																										\
		else {																									\
			for (p=buf; iswspace(*p); p++);																		\
			fHex = (wcsnicmp(buf, L"0x", 2) == 0);																\
			rc = (_T1_)_CV_;																					\
		}																										\
	}																											\
	return rc;																									\
}
M_GSGETPROFILEN_W(UI	, UInt,  32, fHex ? AjcHexToUIW(p) : AjcDecToUIW(p))
M_GSGETPROFILEN_W(SI	, SInt,  32, fHex ? AjcHexToUIW(p) : _wtoi(p))
M_GSGETPROFILEN_W(UI	, Hex ,  32, fHex ? AjcHexToUIW(p) : AjcDecToUIW(p))
M_GSGETPROFILEN_W(double, Real, 512, AjcAscToRealW(p))
M_GSGETPROFILEN_W(ULL	, UI64,  64, fHex ? AjcHexToULLW(p) : AjcDecToULLW(p))
M_GSGETPROFILEN_W(SLL	, SI64,  64, fHex ? AjcHexToULLW(p) : _wtoi64(p))
M_GSGETPROFILEN_W(ULL	, H64 ,  64, fHex ? AjcHexToULLW(p) : AjcDecToULLW(p))

//==============================================================================================================//
//	hmht@Cǂݏoizj																			//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				pArray		- ǂݏoli[鐮z̃AhX											//
//				lArray		- z̗vfTCYiPCQCS or Wj											//
//				nArray		- z̗vf																	//
//																												//
//	߂lF	hmht@Cǂݏoľ														//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetIniFileArrA(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, VOP pArray, UI lArray, UI nArray)
{
	UI		rc = 0;
	UI		lTmpIniFile, lTmpSecName, lTmpKeyName;
	WCP		pTmpIniFile;
	WCP		pTmpSecName;
	WCP		pTmpKeyName;

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {
		pTmpIniFile	= AjcTAllocW(lTmpIniFile = MultiByteToWideChar(CP_ACP, 0, pIniFile, -1, NULL, 0));
		pTmpSecName	= AjcTAllocW(lTmpSecName = MultiByteToWideChar(CP_ACP, 0, pSecName, -1, NULL, 0));
		pTmpKeyName	= AjcTAllocW(lTmpKeyName = MultiByteToWideChar(CP_ACP, 0, pKeyName, -1, NULL, 0));
		if (pTmpIniFile && pTmpSecName && pTmpKeyName) {
			MultiByteToWideChar(CP_ACP, 0, pIniFile, -1, pTmpIniFile, lTmpIniFile);
			MultiByteToWideChar(CP_ACP, 0, pSecName, -1, pTmpSecName, lTmpSecName);
			MultiByteToWideChar(CP_ACP, 0, pKeyName, -1, pTmpKeyName, lTmpKeyName);
			rc = AjcGetIniFileArrW(pTmpIniFile, pTmpSecName, pTmpKeyName, pArray, lArray, nArray);
		}

		if (pTmpIniFile) AjcTFree(pTmpIniFile);
		if (pTmpSecName) AjcTFree(pTmpSecName);
		if (pTmpKeyName) AjcTFree(pTmpKeyName);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetIniFileArrW(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, VOP pArray, UI lArray, UI nArray)
{
	UI		rc = 0, n = 0;
	UI		lBuf;
	WCP		pBuf, pTxt;
	union {
		VOP		pVO;
		UBP		pUB;
		WCP		pUW;
		ULP		pUL;
		ULLP	pULL;
	} u;

	if (pIniFile  &&  pSecName	&&	pKeyName  &&  pArray  &&  (lArray == 1 || lArray == 2 || lArray == 4 || lArray == 8)) {
		lBuf = (((lArray * 2) + 1) * nArray) + 1;
		if (pBuf = AjcTAllocW(lBuf)) {
			*pBuf = 0;
			GetPrivateProfileStringW(pSecName, pKeyName, L"", pBuf, lBuf, pIniFile);
			for (pTxt = pBuf; MAjcIsBlankW(*pTxt); pTxt++);
			u.pVO = pArray;
			while (*pTxt  &&  n < nArray) {
				n++;
				switch (lArray) {
					case 1: *u.pUB++  = (UB)AjcHexToUIW (pTxt); break;
					case 2: *u.pUW++  = (UW)AjcHexToUIW (pTxt); break;
					case 4: *u.pUL++  = 	AjcHexToUIW (pTxt); break;
					case 8: *u.pULL++ = 	AjcHexToULLW(pTxt); break;
				}
				while (*pTxt != L',' && *pTxt != 0) pTxt++;
				if (*pTxt == L',') pTxt++;
				while (*pTxt == L' ' || *pTxt == L'\t') pTxt++;
			}
			rc = n;
			free(pBuf);
		}
	}

	return rc;
}
//==============================================================================================================//
//	hmht@Cǂݏoij																			//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				pDefStr		- ftHgl																		//
//				pBuf		- ǂݏoi[obt@̃AhX										//
//				lBuf		- ǂݏoi[obt@̕										//
//																												//
//	߂lF	ǂݏoL[l̕																		//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetIniFileStrA(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, C_BCP pDefStr, BCP pBuf, UI lBuf)
{
	UI		rc = 0;

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL && pDefStr != NULL && pBuf != NULL && lBuf > 0) {
		rc = GetPrivateProfileStringA(pSecName, pKeyName, pDefStr, pBuf, lBuf, pIniFile);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetIniFileStrW(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, C_WCP pDefStr, WCP pBuf, UI lBuf)
{
	UI		rc = 0;

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL && pDefStr != NULL && pBuf != NULL && lBuf > 0) {
		rc = GetPrivateProfileStringW(pSecName, pKeyName, pDefStr, pBuf, lBuf, pIniFile);
	}
	return rc;
}
//==============================================================================================================//
//	hmht@CǂݏoioCif[^j																	//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				pBuf		- ǂݏooCif[^i[obt@̃AhXioCg擾NULL)	//
//				lBuf		- ǂݏooCif[^i[obt@̃oCg								//
//																												//
//	߂lF	ǂݏof[^̃oCgiG[͂Oj														//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetIniFileBinA(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, VOP pBuf, UI lBuf)
{
	return AjcGetIniFileBinExA(pIniFile, pSecName, pKeyName, pBuf, lBuf, BinDataDirA);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetIniFileBinW(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, VOP pBuf, UI lBuf)
{
	return AjcGetIniFileBinExW(pIniFile, pSecName, pKeyName, pBuf, lBuf, BinDataDirW);
}
//==============================================================================================================//
//	hmht@CǂݏoioCif[^CoCif[^tH_wj										//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				pBuf		- ǂݏooCif[^i[obt@̃AhXioCg擾NULL)	//
//				lBuf		- ǂݏooCif[^i[obt@̃oCg								//
//				pBinDir		- oCif[^tH_															//
//																												//
//	߂lF	ǂݏof[^̃oCgiG[͂Oj														//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetIniFileBinExA(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, VOP pBuf, UI lBuf, C_BCP pBinDir)
{
	UI		rc = 0;
	UI		len;
	HANDLE	hFile;
	BC		tail[MAX_PATH];
	BC		path[MAX_PATH];

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {
		if (AjcGetIniFileStrA(pIniFile, pSecName, pKeyName, "", tail, MAX_PATH) != 0) {
			if (SubProfileGenerateBinFileA(0, tail, path, pBinDir) != NULL) {
				if ((hFile = CreateFileA(path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
					if (pBuf != NULL) {
						ReadFile(hFile, pBuf, lBuf, &rc, NULL);
					}
					else {
						if ((len = GetFileSize(hFile, NULL)) != 0xFFFFFFFF) {
							rc = len;
						}
					}
					CloseHandle(hFile);
				}
			}
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetIniFileBinExW(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, VOP pBuf, UI lBuf, C_WCP pBinDir)
{
	UI		rc = 0;
	UI		len;
	HANDLE	hFile;
	UW		tail[MAX_PATH];
	UW		path[MAX_PATH];

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {
		if (AjcGetIniFileStrW(pIniFile, pSecName, pKeyName, L"", tail, MAX_PATH) != 0) {
			if (SubProfileGenerateBinFileW(0, tail, path, pBinDir) != NULL) {
				if ((hFile = CreateFileW(path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
					if (pBuf != NULL) {
						ReadFile(hFile, pBuf, lBuf, &rc, NULL);
					}
					else {
						if ((len = GetFileSize(hFile, NULL)) != 0xFFFFFFFF) {
							rc = len;
						}
					}
					CloseHandle(hFile);
				}
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	hmht@C݁ilj																				//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				Value		- ݒl																		//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
#define	M_GSPUTPROFILEN_A(_T1_, _T2_, _BS_, _CV_)																\
AJCEXPORT BOOL WINAPI AjcPutIniFile##_T2_##A(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, _T1_ Value)		\
{																												\
	BOOL	rc = FALSE;																							\
	BC		buf[_BS_];																							\
	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {												\
		CreateIniFileA(pIniFile);																				\
		AjcSnPrintFA(buf, _BS_, _CV_, Value);																	\
		rc = WritePrivateProfileStringA(pSecName, pKeyName, buf, pIniFile);										\
	}																											\
	return rc;																									\
}
M_GSPUTPROFILEN_A(UI	, UInt,  32, "%u"  )
M_GSPUTPROFILEN_A(SI	, SInt,  32, "%d"  )
M_GSPUTPROFILEN_A(UI	, Hex ,  32, "0x%X")
M_GSPUTPROFILEN_A(double, Real, 512, "%.20G"  )
M_GSPUTPROFILEN_A(ULL	, UI64,  64, "%I64u"  )
M_GSPUTPROFILEN_A(SLL	, SI64,  64, "%I64d"  )
M_GSPUTPROFILEN_A(ULL	, H64 ,  64, "0x%I64X")

//----- Chp -------------------------------------------------------------------------------------------//
#define	M_GSPUTPROFILEN_W(_T1_, _T2_, _BS_, _CV_)																\
AJCEXPORT BOOL WINAPI AjcPutIniFile##_T2_##W(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, _T1_ Value)		\
{																												\
	BOOL	rc = FALSE;																							\
	WC		buf[_BS_];																							\
	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {												\
		CreateIniFileW(pIniFile);																				\
		AjcSnPrintFW(buf, _BS_, _CV_, Value);																	\
		rc = WritePrivateProfileStringW(pSecName, pKeyName, buf, pIniFile);										\
	}																											\
	return rc;																									\
}
M_GSPUTPROFILEN_W(UI	, UInt,  32, L"%u"	)
M_GSPUTPROFILEN_W(SI	, SInt,  32, L"%d"	)
M_GSPUTPROFILEN_W(UI	, Hex ,  32, L"0x%X")
M_GSPUTPROFILEN_W(double, Real, 512, L"%.20G"  )
M_GSPUTPROFILEN_W(ULL	, UI64,  64, L"%I64u"  )
M_GSPUTPROFILEN_W(SLL	, SI64,  64, L"%I64d"  )
M_GSPUTPROFILEN_W(ULL	, H64 ,  64, L"0x%I64X")

//==============================================================================================================//
//	hmht@C݁izj																			//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				pArray		- ݒli[ꂽz̃AhX											//
//				lArray		- z̗vfTCYiPCQ or Sj												//
//				nArray		- z̗vf																	//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutIniFileArrA(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, VOP pArray, UI lArray, UI nArray)
{
	BOOL	rc = FALSE;
	UI		lTmpIniFile, lTmpSecName, lTmpKeyName;
	WCP		pTmpIniFile = NULL;
	WCP		pTmpSecName	= NULL;
	WCP		pTmpKeyName	= NULL;

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {
		pTmpIniFile	= AjcTAllocW(lTmpIniFile = MultiByteToWideChar(CP_ACP, 0, pIniFile, -1, NULL, 0));
		pTmpSecName	= AjcTAllocW(lTmpSecName = MultiByteToWideChar(CP_ACP, 0, pSecName, -1, NULL, 0));
		pTmpKeyName	= AjcTAllocW(lTmpKeyName = MultiByteToWideChar(CP_ACP, 0, pKeyName, -1, NULL, 0));
		if (pTmpIniFile && pTmpSecName && pTmpKeyName) {
			MultiByteToWideChar(CP_ACP, 0, pIniFile, -1, pTmpIniFile, lTmpIniFile);
			MultiByteToWideChar(CP_ACP, 0, pSecName, -1, pTmpSecName, lTmpSecName);
			MultiByteToWideChar(CP_ACP, 0, pKeyName, -1, pTmpKeyName, lTmpKeyName);
			rc = AjcPutIniFileArrW(pTmpIniFile, pTmpSecName, pTmpKeyName, pArray, lArray, nArray);
		}

		if (pTmpIniFile) AjcTFree(pTmpIniFile);
		if (pTmpSecName) AjcTFree(pTmpSecName);
		if (pTmpKeyName) AjcTFree(pTmpKeyName);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutIniFileArrW(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, VOP pArray, UI lArray, UI nArray)
{
	BOOL	rc = FALSE;
	UI		lBuf, i;
	WCP		pBuf, pTxt;
	union {
		VOP		pVO;
		UBP		pUB;
		UWP		pUW;
		ULP		pUL;
		ULLP	pULL;
	} u;

	if (pIniFile  &&  pSecName	&&	pKeyName  &&  pArray  &&  (lArray == 1 || lArray == 2 || lArray == 4 || lArray == 8)) {
		CreateIniFileW(pIniFile);
		lBuf = (((lArray * 2) + 1) * nArray) + 1;
		if (pBuf = AjcTAllocW(lBuf)) {
			pTxt = pBuf;
			u.pVO = pArray;
			for (i = 0; i < nArray; i++) {
				switch (lArray) {
					case 1: _itow  (*u.pUB++ , pTxt, 16); break;
					case 2: _itow  (*u.pUW++ , pTxt, 16); break;
					case 4: _itow  (*u.pUL++ , pTxt, 16); break;
					case 8: _i64tow(*u.pULL++, pTxt, 16); break;
				}
				while (*pTxt != 0) pTxt++;
				if (i + 1 < nArray) *pTxt++ = L',';
			}
			WritePrivateProfileStringW(pSecName, pKeyName, pBuf, pIniFile);
			free(pBuf);
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	hmht@C݁ij																			//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				pStr		- ޕ̃AhX															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutIniFileStrA(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, C_BCP pStr)
{
	BOOL	rc = FALSE;

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL && pStr != NULL) {
		CreateIniFileA(pIniFile);
		rc = WritePrivateProfileStringA(pSecName, pKeyName, pStr, pIniFile);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutIniFileStrW(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, C_WCP pStr)
{
	BOOL	rc = FALSE;

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL && pStr != NULL) {
		CreateIniFileW(pIniFile);
		rc = WritePrivateProfileStringW(pSecName, pKeyName, pStr, pIniFile);
	}
	return rc;
}

//==============================================================================================================//
//	hmht@C݁ioCif[^j																	//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				pDat		- ރoCif[^̃AhX													//
//				lDat		- ރoCif[^̃oCg													//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutIniFileBinA(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, C_VOP pDat, UI lDat)
{
	return AjcPutIniFileBinExA(pIniFile, pSecName, pKeyName, pDat, lDat, BinDataDirA);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutIniFileBinW(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, C_VOP pDat, UI lDat)
{
	return AjcPutIniFileBinExW(pIniFile, pSecName, pKeyName, pDat, lDat, BinDataDirW);
}
//==============================================================================================================//
//	hmht@C݁ioCif[^CoCif[^tH_wj										//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhX																	//
//				pDat		- ރoCif[^̃AhX													//
//				lDat		- ރoCif[^̃oCg													//
//				pBinDir		- oCif[^tH_															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutIniFileBinExA(C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, C_VOP pDat, UI lDat, C_BCP pBinDir)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;
	UL		bytes;
	BCP		pTail;
	BC		tail[MAX_PATH];
	BC		path[MAX_PATH];

	do {
		//----- NULL`FbN -----------------------------------------------------------------------------------//
		if (pIniFile == NULL) break;
		if (pSecName == NULL) break;
		if (pKeyName == NULL) break;
		if (pDat	 == NULL) break;
		//----- INIt@CꍇAanlŏ ----------------------------------------------------------//
		CreateIniFileA(pIniFile);
		//----- oCit@Cݒ -------------------------------------------------------------------------//
		if (AjcGetIniFileStrA(pIniFile, pSecName, pKeyName, "", tail, MAX_PATH) != 0) {				//	L[H
			SubProfileDeleteBinFileA(tail, pBinDir);												//		oCit@C폜
			if ((pTail = SubProfileGenerateBinFileA(FALSE, tail, path, pBinDir)) == NULL) break;	//		oCit@C
		}
		else {																						//	L[H
			if ((pTail = SubProfileGenerateBinFileA(FALSE, NULL, path, pBinDir)) == NULL) break;	//		oCit@C
			if (!AjcPutIniFileStrA(pIniFile, pSecName, pKeyName, pTail)) break;						//		L[쐬
		}
		//----- oCit@C -----------------------------------------------------------------------//
		hFile = CreateFileA(path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile != INVALID_HANDLE_VALUE) {
			WriteFile(hFile, pDat, lDat, &bytes, NULL);
			CloseHandle(hFile);
			if (bytes == lDat) {
				rc = TRUE;
			}
			else {
				DeleteFileA(path);
			}
		}
		if (rc == FALSE) {
			AjcDelIniKeyA(pIniFile, pSecName, pKeyName);
		}
	} while(0);

	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutIniFileBinExW(C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, C_VOP pDat, UI lDat, C_WCP pBinDir)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;
	UL		bytes;
	WCP		pTail;
	WC		tail[MAX_PATH];
	WC		path[MAX_PATH];

	do {
		//----- NULL`FbN -----------------------------------------------------------------------------------//
		if (pIniFile == NULL) break;
		if (pSecName == NULL) break;
		if (pKeyName == NULL) break;
		if (pDat	 == NULL) break;
		//----- INIt@CꍇAanlŏ ----------------------------------------------------------//
		CreateIniFileW(pIniFile);
		//----- oCit@Cݒ -------------------------------------------------------------------------//
		if (AjcGetIniFileStrW(pIniFile, pSecName, pKeyName, L"", tail, MAX_PATH) != 0) {			//	L[H
			SubProfileDeleteBinFileW(tail, pBinDir);												//		oCit@C폜
			if ((pTail = SubProfileGenerateBinFileW(FALSE, tail, path, pBinDir)) == NULL) break;	//		oCit@C
		}
		else {																						//	L[H
			if ((pTail = SubProfileGenerateBinFileW(FALSE, NULL, path, pBinDir)) == NULL) break;	//		oCit@C
			if (!AjcPutIniFileStrW(pIniFile, pSecName, pKeyName, pTail)) break;						//		L[쐬
		}
		//----- oCit@C -----------------------------------------------------------------------//
		hFile = CreateFileW(path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile != INVALID_HANDLE_VALUE) {
			WriteFile(hFile, pDat, lDat, &bytes, NULL);
			CloseHandle(hFile);
			if (bytes == lDat) {
				rc = TRUE;
			}
			else {
				DeleteFileW(path);
			}
		}
		if (rc == FALSE) {
			AjcDelIniKeyW(pIniFile, pSecName, pKeyName);
		}
	} while(0);

	return rc;
}
//==============================================================================================================//
//	hmht@CEZNV폜																				//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcDelIniSectA	  (C_BCP pIniFile, C_BCP pSecName)
{
	return AjcDelIniSectExA(pIniFile, pSecName, BinDataDirA);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcDelIniSectW	  (C_WCP pIniFile, C_WCP pSecName)
{
	return AjcDelIniSectExW(pIniFile, pSecName, BinDataDirW);
}
//==============================================================================================================//
//	hmht@CEZNV폜ioCif[^tH_wj												//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pBinDir		- oCif[^tH_															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcDelIniSectExA  (C_BCP pIniFile, C_BCP pSecName, C_BCP pBinDir)
{
	BOOL	rc = FALSE;
	UI		len = 4096;
	BCP		pTop, pCur, pNxt, pStr;

	if (pIniFile != NULL && pSecName != NULL) {
		//----- ZNṼoCit@C폜 -------------------------//
		pTop = pNxt = (BCP)AJCMEM(len);
		while (pNxt != NULL && GetPrivateProfileSectionA(pSecName, pTop, len, pIniFile) == len - 2) {
			len *= 2;
			if (pNxt = realloc(pTop, len)) {
				pTop = pNxt;
			}
		}
		if (pTop != NULL) {
			pCur = pTop;
			while (*pCur != 0) {
				pNxt = pCur + (strlen(pCur) + 1);
				if (mbstok(pCur, "=")) {
					pStr = pCur + (strlen(pCur) + 1);
					if (mbsstr(pStr, "\\Ajr")) {
						SubProfileDeleteBinFileA(pStr, pBinDir);
					}
				}
				pCur = pNxt;
			}
			free(pTop);
		}

		//----- ZNV폜 ---------------------------------------------//
		rc = WritePrivateProfileStringA(pSecName, NULL, NULL, pIniFile);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcDelIniSectExW  (C_WCP pIniFile, C_WCP pSecName, C_WCP pBinDir)
{
	BOOL	rc = FALSE;
	UI		len = 8192;
	WCP		pTop, pCur, pNxt, pStr;

	if (pIniFile != NULL && pSecName != NULL) {
		//----- ZNṼoCit@C폜 -------------------------//
		pTop = pNxt = (WCP)AJCMEM(len);
		while (pNxt != NULL && GetPrivateProfileSectionW(pSecName, pTop, (len / 2), pIniFile) == len / 2 - 2) {
			len *= 2;
			if (pNxt = realloc(pTop, len)) {
				pTop = pNxt;
			}
		}
		if (pTop != NULL) {
			pCur = pTop;
			while (*pCur != 0) {
				pNxt = pCur + (wcslen(pCur) + 1);
				if (AjcStrTokW(pCur, L"=")) {
					pStr = pCur + (wcslen(pCur) + 1);
					if (wcsstr(pStr, L"\\Ajr")) {
						SubProfileDeleteBinFileW(pStr, pBinDir);
					}
				}
				pCur = pNxt;
			}
			free(pTop);
		}

		//----- ZNV폜 ---------------------------------------------//
		rc = WritePrivateProfileStringW(pSecName, NULL, NULL, pIniFile);
	}
	return rc;
}
//==============================================================================================================//
//	hmht@CEL[폜																					//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcDelIniKeyA	  (C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName)
{
	return AjcDelIniKeyExA(pIniFile, pSecName, pKeyName, BinDataDirA);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcDelIniKeyW	  (C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName)
{
	return AjcDelIniKeyExW(pIniFile, pSecName, pKeyName, BinDataDirW);
}
//==============================================================================================================//
//	hmht@CEL[폜ioCif[^tH_wj														//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				pBinDir		- oCif[^tH_															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcDelIniKeyExA	  (C_BCP pIniFile, C_BCP pSecName, C_BCP pKeyName, C_BCP pBinDir)
{
	BOOL	rc = FALSE;
	BC		tail[MAX_PATH];

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {
		//----- oCit@C폜 -----//
		AjcGetIniFileStrA(pIniFile, pSecName, pKeyName, "", tail, MAX_PATH);
		SubProfileDeleteBinFileA(tail, pBinDir);

		//----- L[폜 -----------------//
		rc = WritePrivateProfileStringA(pSecName, pKeyName, NULL, pIniFile);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcDelIniKeyExW	  (C_WCP pIniFile, C_WCP pSecName, C_WCP pKeyName, C_WCP pBinDir)
{
	BOOL	rc = FALSE;
	UW		tail[MAX_PATH];

	if (pIniFile != NULL && pSecName != NULL && pKeyName != NULL) {
		//----- oCit@C폜 -----//
		AjcGetIniFileStrW(pIniFile, pSecName, pKeyName, L"", tail, MAX_PATH);
		SubProfileDeleteBinFileW(tail, pBinDir);

		//----- L[폜 -----------------//
		rc = WritePrivateProfileStringW(pSecName, pKeyName, NULL, pIniFile);
	}
	return rc;
}

//==============================================================================================================//
//	hmht@CEZNVW																			//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				cbp			- R[obNp^																//
//				cb			- ZNVʒmR[obN֐isvNULL)								//
//																												//
//	߂lF	WZNV̌																		//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcEnumIniSectA	  (C_BCP pIniFile, UX cbp, BOOL (CALLBACK *cb)(C_BCP pSect, UX cbp))
{
	int		rc	 = 0;
	BCP		pBuf = NULL;
	BCP		p;

	if (AjcPathExistsA(pIniFile)) {
		if (pBuf = (BCP)AJCMEM(32768)) {
			GetPrivateProfileSectionNamesA(pBuf, 32768, pIniFile);
			for (p = pBuf; *p != 0; p += (strlen(p) + 1)) {
				rc++;
				if (cb != NULL) {
					if (!cb(p, cbp)) {
						break;
					}
				}
			}
			free(pBuf);
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcEnumIniSectW	  (C_WCP pIniFile, UX cbp, BOOL (CALLBACK *cb)(C_WCP pSect, UX cbp))
{
	int		rc	 = 0;
	WCP		pBuf = NULL;
	WCP		p;

	if (AjcPathExistsW(pIniFile)) {
		if (pBuf = (WCP)AJCMEM(32768 * 2)) {
			GetPrivateProfileSectionNamesW(pBuf, 32768, pIniFile);
			for (p = pBuf; *p != 0; p += (wcslen(p) + 1)) {
				rc++;
				if (cb != NULL) {
					if (!cb(p, cbp)) {
						break;
					}
				}
			}
			free(pBuf);
		}
	}
	return rc;
}
//==============================================================================================================//
//	hmht@CEL[W																					//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//				pSecName	- ZNṼAhX															//
//				cbp			- R[obNp^																//
//				cb			- L[ʒmR[obN֐isvNULL)										//
//																												//
//	߂lF	WZNV̌																		//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcEnumIniKeyA	  (C_BCP pIniFile, C_BCP pSecName, UX cbp, BOOL (CALLBACK *cb)(C_BCP pKey, C_BCP pVal, UX cbp))
{
	int		rc	 = 0;
	BCP		pBuf = NULL;
	BCP		p, pNxt, pKey, pVal;

	if (AjcPathExistsA(pIniFile) && pSecName != NULL) {
		if (pBuf = (BCP)AJCMEM(65536)) {
			GetPrivateProfileSectionA(pSecName, pBuf, 65536, pIniFile);
			for (p = pBuf; *p != 0; p = pNxt) {
				pNxt = p + (strlen(p) + 1);
				rc++;
				if (cb != NULL) {
					pKey = mbstok(p   , "=" );
					pVal = mbstok(NULL, "\0");
					if (!cb(pKey, (pVal ? pVal : ""), cbp)) {
						break;
					}
				}
			}
			free(pBuf);
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI	AjcEnumIniKeyW	  (C_WCP pIniFile, C_WCP pSecName, UX cbp, BOOL (CALLBACK *cb)(C_WCP pKey, C_WCP pVal, UX cbp))
{
	int		rc	 = 0;
	WCP		pBuf = NULL;
	WCP		p, pNxt, pKey, pVal;

	if (AjcPathExistsW(pIniFile) && pSecName != NULL) {
		if (pBuf = (WCP)AJCMEM(65536 * 2)) {
			GetPrivateProfileSectionW(pSecName, pBuf, 65536, pIniFile);
			for (p = pBuf; *p != 0; p = pNxt) {
				pNxt = p + (wcslen(p) + 1);
				rc++;
				if (cb != NULL) {
					pKey = AjcStrTokW(p   , L"=" );
					pVal = AjcStrTokW(NULL, L"\0");
					if (!cb(pKey, (pVal ? pVal : L""), cbp)) {
						break;
					}
				}
			}
			free(pBuf);
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	hmhꍇAanlŏ																			//
//																												//
//	@F	pIniFile	- hmht@C̃AhX														//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//--------------------------------------------------------------------------------------------------------------//
static	const UB u16bom[2] = {0xFF, 0xFE};
//----- oCg ---------------------------------------------------------------------------------------------//
static	BOOL	CreateIniFileA(C_BCP pIniFile)
{
	BOOL	rc		= FALSE;
	HANDLE	hFile	= INVALID_HANDLE_VALUE;
	UL		bytes	= 0;

	if (!AjcPathExistsA(pIniFile)) {
		if ((hFile = CreateFileA(pIniFile,
								 GENERIC_WRITE,
								 FILE_SHARE_WRITE,
								 NULL,
								 CREATE_NEW,
								 FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			if (WriteFile(hFile, u16bom, sizeof(u16bom), &bytes, NULL) != 0 && bytes == sizeof(u16bom)) {
				rc = TRUE;
			}
			CloseHandle(hFile);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	BOOL	CreateIniFileW(C_WCP pIniFile)
{
	BOOL	rc		= FALSE;
	HANDLE	hFile	= INVALID_HANDLE_VALUE;
	UL		bytes	= 0;

	if (!AjcPathExistsW(pIniFile)) {
		if ((hFile = CreateFileW(pIniFile,
								 GENERIC_WRITE,
								 FILE_SHARE_WRITE,
								 NULL,
								 CREATE_NEW,
								 FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
			if (WriteFile(hFile, u16bom, sizeof(u16bom), &bytes, NULL) != 0 && bytes == sizeof(u16bom)) {
				rc = TRUE;
			}
			CloseHandle(hFile);
		}
	}
	return rc;
}
//==============================================================================================================//
//	INIt@Ctse|PUɕύX																				//
//																												//
//	@	F	pPath	- ϊ鏉t@C̃pX															//
//				fMkBkup	- IWit@CobNAbv|̃tO										//
//																												//
//	߂l	F	TRUE  - iINIt@CȂCUNICODEt@C܂ށj										//
//				FALSE - s																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcIniFileToUnicodeA(C_BCP pIniFile, BOOL fMkBkup)
{
	BOOL	rc = FALSE;

	if (pIniFile != NULL) {
		UI		len;
		WCP		pTmp = NULL;
		len = MultiByteToWideChar(CP_ACP, 0, pIniFile, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAllocW(len))) {
			MultiByteToWideChar(CP_ACP, 0, pIniFile, -1, pTmp, len);
			rc = AjcIniFileToUnicodeW(pTmp, fMkBkup);
		}
		if (pTmp != NULL) free(pTmp);
	}
	else {
		rc = AjcIniFileToUnicodeW(NULL, fMkBkup);
	}

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	AjcIniFileToUnicodeW(C_WCP pIniFile, BOOL fMkBkup)
{
	BOOL		rc = FALSE;
	HAJCFILE	hInp = NULL;
	HAJCFILE	hOut = NULL;
	EAJCTEC		tec;
	WC			bkup[MAX_PATH] = {0};
	WC			drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], fext[_MAX_EXT];
	WC			buf[1024];

	//	INIt@Cw薳Ȃ΁AKINIt@CpXƂ
	if (pIniFile != NULL) {
		//	t@CGR[h擾
		if (hInp = AjcFOpen(pIniFile, AJCTEC_AUTO)) {
			tec = AjcFGetTec(hInp);
			AjcFClose(hInp);
			//	UTF-16ȊOȂΕϊ
			if (tec != AJCTEC_UTF_16LE) {
				//	obNAbvݒ
				if (fMkBkup) {
					_wsplitpath(pIniFile, drv, dir, fname, fext);
					AjcPathCat(dir, L"bkup", AJCTSIZE(dir));
					_wmakepath (bkup, drv, dir, NULL, NULL);
					CreateDirectory(bkup, NULL);
					wcscat_s(fname, _MAX_FNAME, L"_bkup");
					_wmakepath (bkup, drv, dir, fname, fext);
				}
				else {
					GetTempPath(MAX_PATH, bkup);
					AjcPathCat(bkup, fname, MAX_PATH);
					wcscat_s  (bkup, MAX_PATH, fext );
				}
				//	IWit@CRs[
				rc = (CopyFile(pIniFile, bkup, FALSE) != 0);
				//	tse|PU֕ϊ
				if (rc) {
					//	o̓t@CiUNICODEt@Cj쐬
					if (hOut = AjcFCreate(pIniFile, AJCTEC_UTF_16LE, TRUE)) {
						//	̓t@CiIWit@CjI[v
						if (hInp = AjcFOpen(bkup, AJCTEC_AUTO)) {
							//	UTF-16֕ϊRs[
							while (rc && AjcFGetS(hInp, buf, AJCTSIZE(buf))) {
								rc = AjcFPutS(hOut, buf, -1);
							}
							AjcFClose(hInp);
						}
						AjcFClose(hOut);
					}
				}
			}
			else rc = TRUE;		//	t@C͊UTF-16łI
		}
		else rc = TRUE;			//	t@Civt@CݎUTF-16ō쐬̂łnjj
	}
	return rc;
}

