#include	"AjcInternal.h"

//--------------------------------------------------------------------------------------------------------------//
//	 																										//
//--------------------------------------------------------------------------------------------------------------//
#define		SDIC_SIZE	8192			//	XChTCYioCgj										//

//--------------------------------------------------------------------------------------------------------------//
//	qnl萔																									//
//--------------------------------------------------------------------------------------------------------------//
//----- e̓e[u -------------------------------------------------------------------------------------//
//									  1   2   3   4   5   6   7   8   9   10  11  12							//
static	const UB	 DaysTable[13] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

//----- rbgXg[o}XN -----------------------------------------------------------------------------//
static const UW		 BitMsk16[17] = {	0x0000,
									0x8000, 0xC000, 0xE000, 0xF000,
									0xF800, 0xFC00, 0xFE00, 0xFF00,
									0xFF80, 0xFFC0, 0xFFE0, 0xFFF0,
									0xFFF8, 0xFFFC, 0xFFFE, 0xFFFF,
};
//----- Piϊe[u -----------------------------------------------------------------------------------//
static	const UB	 NCodeTable[256] = {
//		   00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F 10 11 12 13 14 15 16 17 18 19 1A 1B 1C 1D 1E 1F
/* 00 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 20 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 40 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 60 */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/* 80 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ,1, 1, 1,
/* A0 */	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ,1, 1, 1,
/* C0 */	2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 ,2, 2, 2,
/* E0 */	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 6 ,6, 7, 8
};
//--------------------------------------------------------------------------------------------------------------//
//	rbgVtg@}N																						//
//--------------------------------------------------------------------------------------------------------------//
#define		SHL(_X_, _N_)	if (sizeof(int) >= 4) {								\
								_X_.ul <<= (_N_);								\
							}													\
							else {												\
								switch ((_N_) >> 3) {							\
									case 1: _X_.ub.h  = _X_.ub.mh;				\
											_X_.ub.mh = _X_.ub.ml;				\
											_X_.ub.ml = _X_.ub.l;				\
											_X_.ub.l  = 0;			break;		\
									case 2: _X_.uw.h  = _X_.uw.l;				\
											_X_.uw.l  = 0;			break;		\
									case 3: _X_.ub.h  = _X_.ub.l;				\
											_X_.ub.mh = 0;						\
											_X_.uw.l  = 0;			break;		\
									case 4: _X_.ul	  = 0;			break;		\
								}												\
								_X_.ul <<= ((_N_) & 7);							\
							}


//--------------------------------------------------------------------------------------------------------------//
//	ɃANZXG[R[h																					//
//--------------------------------------------------------------------------------------------------------------//
__declspec(thread) static	AJCLZHERR	LastErr = 0;	//	ɃANZXG[R[h

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	UI	SubFind(HAJCLZH pW);
static	AJCLZHERR	ReadHuff(HAJCLZH pW, UBP pBuf, UI len, UIP pBytes);
static	AJCLZHERR	ReadNude(HAJCLZH pW, UBP pBuf, UI len, UIP pBytes);
static	AJCLZHERR	InitDecodeInfo(HAJCLZH pW);

static	UB			GetByte   (HAJCLZH pW);
static	VO			SetBytePos(HAJCLZH pW);
static	UI			GetNCode  (HAJCLZH pW);
static	UI			HuffDecode(HAJCLZH pW, PAJCLZHTBL pTbl);
static	UI			BltToCtb  (PAJCLZHTBL pTbl);
static	VO			SortCtb   (PAJCLZHTBL pTbl);
static	PAJCLZHCTB	SearchCtb(UI bptn, PAJCLZHTBL pTbl);

static	UW		PeekBits(HAJCLZH pW, UI n);
static	VO		SkipBits(HAJCLZH pW, UI n);
static	UW		GetBNum (HAJCLZH pW, UI n);

static	UI		ReadHeaderInfo(HAJCLZH pW);
static	VO		ReadH0		  (HAJCLZH pW, UBP s);
static	VO		ReadH1		  (HAJCLZH pW, UBP s);
static	VO		ReadH2		  (HAJCLZH pW, UBP s);
static	UI		ReadHEx 	  (HAJCLZH pW);
static	UW		GetWord 	  (HAJCLZH pW);
static	VO		GetString	  (HAJCLZH pW, UI stl, BCP pBuf, UI bfl);
static	UW		StrWord   (BCP pStr);
static	UL		StrLong   (BCP pStr);
static	VO		SplitPath(C_BCP pPath, BC pDir[MAX_PATH], BC pFile[MAX_PATH]);
static	BOOL	CmpDirName(C_BCP pDirName, C_BCP pWildDir, BOOL fSubDir);
static	BOOL	CmpWildStr(C_BCP pPath, C_BCP pWild);
static	UL		DosTimeToFileTime(UL DosTime);

//==============================================================================================================//
//	ɓ̃t@Cij																				//
//																												//
//	@	F	pW		   - p[Nobt@̃AhX														//
//				pWild	   - ChJ[h																	//
//				flag	   - wtOiAJCLZHFLG_XXXXXj													//
//				xp		   - R[obNp^																//
//				cbRead	   - Xg[͗pR[obN֐̃AhX											//
//				cbSeek	   - oCgʒuݒpR[obN֐̃AhX											//
//																												//
//	߂l	F	mtkkFikygfR[hnhj														//
//				mtkkFt@CȂ^G[																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCLZH		WINAPI	AjcLzhFindFirstA(C_BCP pWild, UI flag, UX xp,
												UI (CALLBACK *cbRead)(UX xp, VOP pBuf, UI len),
												VO (CALLBACK *cbSeek)(UX xp, UL ofs))
{
	HAJCLZH	pW = NULL;

	LastErr = AJCLZHERR_OK;

	if (pWild != NULL && cbRead != NULL && cbSeek != NULL) {
		if (pW = (HAJCLZH)AJCMEM(sizeof(AJCLZH))) {
			memset(pW, 0, sizeof *pW);							//	CX^X[NNA[
			pW->mode   = AJCLZHMODE_SEARCH;						//	ɓt@C[h
			pW->flg    = (flag & AJCLZHF_MSK_FIND);				//	tO
			pW->cbRead = cbRead;								//	R[obN֐ݒ
			pW->cbSeek = cbSeek;								//	E
			pW->xp	   = xp;									//	R[obNp^
			//	wfBNgCChXybNݒ
			SplitPath(pWild, pW->WildDir, pW->WildSpec);
			//	t@C
			if ((LastErr = SubFind(pW)) != AJCLZHERR_OK) {		//	t@Cs
				free(pW);
				pW = NULL;
			}
		}
		else LastErr = 	AJCLZHERR_MEMORY;
	}
	else LastErr = AJCLZHERR_NULLPTR;

	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCLZH		WINAPI	AjcLzhFindFirstW(C_WCP pWild, UI flag, UX xp,
												UI (CALLBACK *cbRead)(UX xp, VOP pBuf, UI len),
												VO (CALLBACK *cbSeek)(UX xp, UL ofs))
{
	HAJCLZH	pW = NULL;
	UI		len;
	BCP		pTmp = NULL;

	if (pWild != NULL) {
		len = WideCharToMultiByte(CP_ACP, 0, pWild, -1, NULL, 0, NULL, NULL);
		if (len != 0 && (pTmp = (UBP)AJCMEM(len))) {
			WideCharToMultiByte(CP_ACP, 0, pWild, -1, pTmp, len, NULL, NULL);
			pW = AjcLzhFindFirstA(pTmp, flag, xp, cbRead, cbSeek);
		}
		else LastErr = 	AJCLZHERR_MEMORY;

		if (pTmp != NULL) free(pTmp);
	}
	else LastErr = AJCLZHERR_NULLPTR;

	return pW;
}
//==============================================================================================================//
//	ɓ̃t@CiQڈȍ~j																			//
//																												//
//	@	F	pW	  - p[Nobt@̃AhX															//
//																												//
//	߂l	F	TRUE FdneȊO																				//
//				FALSEFdne^G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcLzhFindNext (HAJCLZH pW)
{
	if (pW->mode == AJCLZHMODE_SEARCH) {		//	ɓt@C[hH
		pW->ofs += pW->BlkSize;					//		̃wb_ʒuݒ
		LastErr = SubFind(pW);					//		t@C
	}
	else {										//	ɓt@C[hȊOH
		LastErr = AJCLZHERR_INVALIDMODE;		//		G[R[hݒ
	}

	return (LastErr == AJCLZHERR_OK);
}
//--------------------------------------------------------------------------------------------------------------//
static	UI	SubFind(HAJCLZH pW)
{
	UI		rsu;

	LastErr = AJCLZHERR_NOTFOUND;

	SetBytePos(pW);																		//	̃wb_ʒuֈړ
	rsu = ReadHeaderInfo(pW);
	while (rsu == 0) {																	//	̃wb_E̊ԃ[v
		if (((pW->Sig == '0' || pW->Sig == '5') && !(pW->flg & AJCLZHF_NOSRH_FILE)) ||	//		t@C && t@Cw薳 or
			((pW->Sig == 'd') && (pW->flg & AJCLZHF_SRH_DIR))) {						//		chq && chqw肠H
			if (CmpDirName(pW->DirName, pW->WildDir, (pW->flg & AJCLZHF_SUBDIR)) &&		//			ChJ[ĥchqv &&
				CmpWildStr(pW->PathName, pW->WildSpec)) {								//			ChJ[hvH
				LastErr = AJCLZHERR_OK;													//				G[R[hnj
				break;																	//				I
			}
		}
		pW->ofs += pW->BlkSize;															//			̃wb_ʒuݒ
		SetBytePos(pW);																	//			̃wb_ʒuֈړ
		rsu = ReadHeaderInfo(pW);														//			wb_ǂݏo
	}
	if (rsu != 0xFFFF)																	//	dneȊOH
		LastErr = (AJCLZHERR)rsu;														//		G[R[hݒ

	return LastErr;
}
//==============================================================================================================//
//	ɓt@C̃I[v																					//
//																												//
//	@	F	pW		  - fR[hCX^X[ÑAhX												//
//				pFilePath - ɓ̃t@CpX																//
//				flag	  - wtOiAJCLZHFLG_XXXXXj													//
//				xp		  - R[obNp^																//
//				cbRead	  - Xg[͗pR[obN֐̃AhX											//
//				cbSeek	  - oCgʒuݒpR[obN֐̃AhX											//
//																												//
//	߂l	F	mtkkFkygfR[hnh																//
//				mtkkFG[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCLZH		WINAPI	AjcLzhOpenA(C_BCP pFilePath, UI flag, UX xp,
											 UI (CALLBACK *cbRead)(UX xp, VOP pBuf, UI len),
											 VO (CALLBACK *cbSeek)(UX xp, UL ofs))
{
	HAJCLZH		pW;

	LastErr = AJCLZHERR_OK;

	if (pFilePath != NULL && cbRead != NULL && cbSeek != NULL) {
		if (pW = (HAJCLZH)AJCMEM(sizeof(AJCLZH))) {
			//	CX^X
			memset(pW, 0, sizeof *pW);											//	fR[hCX^XNA[
			pW->mode = AJCLZHMODE_READ;											//	ɓt@Cǂݏo[h
			pW->flg    = (flag & AJCLZHF_MSK_OPEN);								//	tO
			pW->cbRead = cbRead;												//	Xg[͗pR[obN
			pW->cbSeek = cbSeek;												//	oCgʒuݒpR[obN
			pW->xp	   = xp;													//	R[obNp^

			//	obt@AhX
			pW->pDicTop		= pW->pDic = (UBP		)calloc(SDIC_SIZE	, 1);	//	XCh
			pW->BLen.pBlt	= (UBP		 )calloc(					  19, 1);	//	rbge[u
			pW->BLen.pCtb	= (PAJCLZHCTB)calloc(sizeof(AJCLZHCTB) *  19, 1);	//	E
			pW->Deco.pBlt	= (UBP		 )calloc(					 510, 1);	//	fR[he[u
			pW->Deco.pCtb	= (PAJCLZHCTB)calloc(sizeof(AJCLZHCTB) * 510, 1);	//	E
			pW->Dist.pBlt	= (UBP		 )calloc(					  15, 1);	//	fBX^Xe[u
			pW->Dist.pCtb	= (PAJCLZHCTB)calloc(sizeof(AJCLZHCTB) *  15, 1);	//	E

			if (pW->pDicTop && pW->BLen.pBlt && pW->BLen.pCtb && pW->Deco.pBlt && pW->Deco.pCtb && pW->Dist.pBlt && pW->Dist.pCtb) {
				//	wfBNgCChJ[hݒ
				SplitPath(pFilePath, pW->WildDir, pW->WildSpec);
				//	t@C
				if ((LastErr = SubFind(pW)) != AJCLZHERR_OK) {
					AjcLzhClose(pW); pW = NULL;
				}
			}
			else {
				AjcLzhClose(pW); pW = NULL;
				LastErr = AJCLZHERR_MEMORY;
			}
		}
		else LastErr = AJCLZHERR_MEMORY;
	}
	else LastErr = AJCLZHERR_NULLPTR;

	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCLZH		WINAPI	AjcLzhOpenW(C_WCP pFilePath, UI flag, UX xp,
											 UI (CALLBACK *cbRead)(UX xp, VOP pBuf, UI len),
											 VO (CALLBACK *cbSeek)(UX xp, UL ofs))
{
	HAJCLZH	pW = NULL;
	UI		len;
	BCP		pTmp = NULL;

	if (pFilePath != NULL) {
		len = WideCharToMultiByte(CP_ACP, 0, pFilePath, -1, NULL, 0, NULL, NULL);
		if (len != 0 && (pTmp = (BCP)AJCMEM(len))) {
			WideCharToMultiByte(CP_ACP, 0, pFilePath, -1, pTmp, len, NULL, NULL);
			pW = AjcLzhOpenA(pTmp, flag, xp, cbRead, cbSeek);
		}
		else LastErr = 	AJCLZHERR_MEMORY;

		if (pTmp != NULL) free(pTmp);
	}
	else LastErr = AJCLZHERR_NULLPTR;

	return pW;
}
//==============================================================================================================//
//	ɓt@C̓ǂݏoifR[hj																		//
//																												//
//	@	F	pBuf   - ǂݏoi𓀂jf[^i[obt@̃AhX								//
//				len    - ǂݏoi𓀂jf[^̃oCg													//
//																												//
//	߂l	F	ۂɓǂݏooCgiOFdne^G[j													//
//==============================================================================================================//

#define	LR_SET_DIC(_X_)		*pW->pDic++ = (UB)(_X_);		\
							if (++pW->xDic >= SDIC_SIZE) {	\
								pW->pDic  = pW->pDicTop;	\
								pW->xDic = 0;				\
							}

#define	LR_SET_BUF(_X_)		*pBuf++ = (UB)_X_;

//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcLzhRead		(HAJCLZH pW, UBP pBuf, UI len)
{
	UI		rc;
	UI		bytes = 0;

	if (pBuf != NULL) {
		if (pW->mode == AJCLZHMODE_READ) {

			if (pW->Sig == '5') LastErr = ReadHuff(pW, pBuf, len, &bytes);	//	"-lh5-"
			else				LastErr = ReadNude(pW, pBuf, len, &bytes);	//	"-lh0-"

			if (LastErr == AJCLZHERR_OK) {
				rc = bytes;
			}
			else {
				rc = 0;
			}
		}
		else {
			LastErr = AJCLZHERR_INVALIDMODE;
			rc = 0;
		}
	}
	else {
		LastErr = AJCLZHERR_NULLPTR;
		rc = 0;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	VOl`"-lh5-" : kR[h̕Eǂݏo															//
//--------------------------------------------------------------------------------------------------------------//
static	AJCLZHERR	ReadHuff(HAJCLZH pW, UBP pBuf, UI len, UIP pBytes)
{
	AJCLZHERR	rc	= AJCLZHERR_OK;
	UI			cnt = 0;
	UI			bl, code, dist;

	while (cnt < len && pW->FileCnt < pW->FileSize) {					//	Ǐoޖ^̧ٻ޵ް܂ٰ
		if (pW->MatchLen == 0) {										//		v񏈗ȊOH
			if (pW->BlkCodes == 0) {									//			ckR[hȂH
				rc = InitDecodeInfo(pW);								//				fR[h
				if (rc != 0) break;										//				G[ȂΏI
			}
			if (pW->Deco.nCtb == 1) {									//			Pp^[H
				code = pW->Deco.pCtb[0].code;							//				R[hݒ
			}
			else {														//			p^[H
				code = HuffDecode(pW, &pW->Deco);						//				fR[h
			}
			if (code < 256) {											//			PꕶH
				LR_SET_BUF(code)										//				obt@ɕݒ
				LR_SET_DIC(code)										//				ײގɕݒ	
				cnt++;													//				ǏoލXV
				pW->FileCnt++;											//				t@CTCYXV
			}
			else {														//			vH
				pW->MatchLen = code - 256 + 3;							//				v񒷎Zo
				bl = HuffDecode(pW, &pW->Dist);							//				rbgfR[h
				if (bl == 0) {											//				rbgOH
					dist = 1;											//					P
				}
				else {													//				rbg/OH
					dist = GetBNum(pW, bl - 1) + (1 << (bl - 1)) + 1;	//					Zo
				}
				if (dist <= pW->xDic) {									//				ṽAhXݒ
					pW->pMatch = pW->pDic - dist;						//				E
					pW->xMatch = pW->xDic - dist;						//				E
				}														//				E
				else {													//				E
					pW->xMatch = ((pW->xDic - dist) & (SDIC_SIZE - 1));	//				E
					pW->pMatch = pW->pDicTop + pW->xMatch;				//				E
				}
			}
			pW->BlkCodes--;												//			kR[hZ
		}
		else {															//		v񏈗H
			code = *pW->pMatch++;										//			ײގ當擾
			if (++pW->xMatch >= SDIC_SIZE) {							//			ײގAhXXV
				pW->pMatch = pW->pDicTop;								//			E
				pW->xMatch = 0;											//			E
			}
			LR_SET_BUF(code)											//			obt@ɕݒ
			LR_SET_DIC(code)											//			ײގɕݒ
			cnt++;														//			ǏoTCYXV
			pW->FileCnt++;												//			t@CTCYXV
			pW->MatchLen--;												//			v񒷌Z
		}
	}
	*pBytes = cnt;														//	߂(ۂɓǂݏooCgj

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	VOl`"-lh0-" : 񈳏kR[h̓ǂݏo																//
//--------------------------------------------------------------------------------------------------------------//
static	AJCLZHERR	ReadNude(HAJCLZH pW, UBP pBuf, UI len, UIP pBytes)
{
	UI	cnt = 0;

	while (cnt < len && pW->FileCnt < pW->FileSize) {		//	Ǐoޖ^̧ٻ޵ް܂ٰ
		*pBuf++ = (UB)GetByte(pW);							//		obt@Ƀt@Cf[^ݒ
		cnt++;												//		ǂݏoTCYXV
		pW->FileCnt++;										//		t@CTCYXV
	}
	*pBytes = cnt;											//	߂(ۂɓǂݏooCgj

	return AJCLZHERR_OK;
}
//==============================================================================================================//
//	ɓt@C̃N[Y																					//
//																												//
//	@	F	pW	   - kygfR[hnh																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO		WINAPI	AjcLzhClose	(HAJCLZH pW)
{
	LastErr = AJCLZHERR_OK;

	if (pW != NULL) {
		//	obt@
		if (pW->pDicTop		!= NULL) free(pW->pDicTop	);		//	XCh
		if (pW->BLen.pBlt	!= NULL) free(pW->BLen.pBlt	);		//	rbge[u
		if (pW->BLen.pCtb	!= NULL) free(pW->BLen.pCtb	);		//	E
		if (pW->Deco.pBlt	!= NULL) free(pW->Deco.pBlt	);		//	fR[he[u
		if (pW->Deco.pCtb	!= NULL) free(pW->Deco.pCtb	);		//	E
		if (pW->Dist.pBlt	!= NULL) free(pW->Dist.pBlt	);		//	fBX^Xe[u
		if (pW->Dist.pCtb	!= NULL) free(pW->Dist.pCtb	);		//	E
		free(pW);
	}
}
//==============================================================================================================//
//	t@C̎擾																							//
//																												//
//	@	F	pW	   - kygfR[hnh																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcLzhGetFileInfoA(HAJCLZH pW, PAJCLZHFILEINFOA pInfo)
{
	BOOL	rc;

	if (pW->mode == AJCLZHMODE_SEARCH  ||  pW->mode == AJCLZHMODE_READ) {
		pInfo->HuffSize		= pW->HuffSize;			//	kf[^TCY
		pInfo->FileSize		= pW->FileSize;			//	t@CTCY
		pInfo->FileTime		= pW->FileTime;			//	t@C^Ci1970-01-01, 00:00:00̒ʎZbj
		pInfo->fLocalTime	= pW->fLocalTime;		//	TRUE:[J^CDFALSE:tsb
		pInfo->crc			= pW->crc;				//	bqb
		pInfo->dmy			= 0;					//	Filler
		AjcSnPrintFA(pInfo->szPathName, MAX_PATH, "%s", pW->PathName); // t@CpX(ex. "temp\sample.txt")
		AjcSnPrintFA(pInfo->szDirName , MAX_PATH, "%s", pW->DirName ); // fBNg(ex. "temp\"          )
		AjcSnPrintFA(pInfo->szFileName, MAX_PATH, "%s", pW->FileName); // t@C	(ex. "sample"		  )
		pInfo->fDir			= (pW->Sig == 'd');
		LastErr = AJCLZHERR_OK;
		rc = TRUE;
	}
	else {
		LastErr = AJCLZHERR_INVALIDMODE;
		rc = FALSE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcLzhGetFileInfoW(HAJCLZH pW, PAJCLZHFILEINFOW pInfo)
{
	BOOL	rc;

	if (pW->mode == AJCLZHMODE_SEARCH  ||  pW->mode == AJCLZHMODE_READ) {
		pInfo->HuffSize		= pW->HuffSize;			//	kf[^TCY
		pInfo->FileSize		= pW->FileSize;			//	t@CTCY
		pInfo->FileTime		= pW->FileTime;			//	t@C^Ci1970-01-01, 00:00:00̒ʎZbj
		pInfo->fLocalTime	= pW->fLocalTime;		//	TRUE:[J^CDFALSE:tsb
		pInfo->crc			= pW->crc;				//	bqb
		pInfo->dmy			= 0;					//	Filler
		MultiByteToWideChar(CP_ACP, 0, pW->DirName , -1, pInfo->szDirName , MAX_PATH);	//	t@CpX
		MultiByteToWideChar(CP_ACP, 0, pW->PathName, -1, pInfo->szPathName, MAX_PATH);	//	fBNg
		MultiByteToWideChar(CP_ACP, 0, pW->FileName, -1, pInfo->szFileName, MAX_PATH);	//	t@C
		pInfo->fDir			= (pW->Sig == 'd');
		LastErr = AJCLZHERR_OK;
		rc = TRUE;
	}
	else {
		LastErr = AJCLZHERR_INVALIDMODE;
		rc = FALSE;
	}
	return rc;
}
//==============================================================================================================//
//	G[R[h擾																							//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	Ō̃t@NVs̃G[R[h														//
//==============================================================================================================//
AJCEXPORT	AJCLZHERR	WINAPI	AjcLzhGetLastError(VO)
{
	return LastErr;
}
//--------------------------------------------------------------------------------------------------------------//
//	fR[hiR[h\̓́j																				//
//																												//
//	@	F	pW	- CX^X̃AhX																	//
//																												//
//	߂l	F	O - nj																						//
//				O - G[																					//
//--------------------------------------------------------------------------------------------------------------//
static	AJCLZHERR	InitDecodeInfo(HAJCLZH pW)
{
	AJCLZHERR	rc = AJCLZHERR_OK;
	UI			i, bl, z, n, code;
	PAJCLZHTBL	pTbl;

	//----- ubNTCY ---------------------------------------------------------------------------------//
	pW->BlkCodes = GetBNum(pW, 16);

	//----- rbg̃rbge[u ---------------------------------------------------------------------//
	pTbl = &pW->BLen;												//	e[uAhXݒ
	pTbl->nBlt	= GetBNum(pW, 5);									//	e[uGg[h
	if (pTbl->nBlt > 19) {rc = AJCLZHERR_BLEN_OVER19; goto idi_ret;}//	QOȏȂ΃G[
	if (pTbl->nBlt == 0) {											//	GgOH
		i = GetBNum(pW, 5);											//		ỸR[hl[h
		if (i > 19) {rc = AJCLZHERR_BLEN_OVER19; goto idi_ret;}		//		QOȏȂ΃G[
		memset(pTbl->pBlt, 0, i);									//		e[uNA[
		pTbl->pBlt[i] = 1;											//		ỸR[hɂPrbg蓖
		pTbl->MaxBl   = 1;											//		őrbgP
		pTbl->nBlt	  = i + 1;										//		Le[uGgݒ
	}
	else {															//	GgOH
		pTbl->MaxBl = 0;											//		őrbgNA[
		for (i=0; i < pTbl->nBlt;) {								//		SGg[v
			bl = GetNCode(pW);										//			Pg擾
			if (bl > 16) {rc = bl; goto idi_ret;}					//			PVȏȂ΃G[
			pTbl->pBlt[i++] = (UB)bl;								//			rbge[uGgݒ
			if (bl > pTbl->MaxBl) pTbl->MaxBl = bl;					//			őrbgXV
			if (i == 3) {											//			R`U͓ʂɂǑ
				z = GetBNum(pW, 2);									//			E
				while (z--) pTbl->pBlt[i++] = 0;					//			E
			}
		}
	}
	//----- rbge[upR[h\쐬 -----------------------------------------------------------------//
	pTbl->nCtb = BltToCtb(pTbl);
	if (pTbl->nCtb > 19) {rc = pTbl->nCtb; goto idi_ret;}
	SortCtb(pTbl);

	//----- rbge[u -------------------------------------------------------------------------------//
	pTbl = &pW->Deco;																//	e[uAhXݒ
	pTbl->MaxBl = 0;																//	őrbgNA[
	pTbl->nBlt	= GetBNum(pW, 9);													//	Gg[h
	if (pTbl->nBlt > 510) {rc = AJCLZHERR_BLEN_OVER510; goto idi_ret;}				//	TPPȏȂ΃G[
	if (pTbl->nBlt == 0) {															//	GgOH
		i = GetBNum(pW, 9);															//		ỸR[hl[h
		if (i > 510) {rc = AJCLZHERR_BLEN_OVER510; goto idi_ret;}					//		TPPȏȂ΃G[
		memset(pTbl->pBlt, 0, i);													//		e[uNA[
		pTbl->pBlt[i] = 1;															//		Y̺ނɂPޯĊ
		pTbl->MaxBl   = 1;															//		őrbgP
		pTbl->nBlt	  = i + 1;														//		Lðشؐݒ
	}
	else {																			//	GgOH
		pTbl->MaxBl = 0;															//		őޯĒNA[
		for (i=0; i<pTbl->nBlt;) {													//		SGg[v
			switch (code = HuffDecode(pW, &pW->BLen)) {
				case 0:																//			OFYGgO
					pTbl->pBlt[i++] = 0;
					break;
				case 1:																//			PFSrbg{R
					n = GetBNum(pW, 4) + 3;											//			@@GgO
					if ((i + n) > 510) {rc = AJCLZHERR_BLEN_OVER510; goto idi_ret;}
					memset(&pTbl->pBlt[i], 0, n);
					i += n;	
					break;
				case 2:																//			QF9ޯĐ+20
					n = GetBNum(pW, 9) + 20;										//			@@GgO
					if ((i + n) > 510) {rc = AJCLZHERR_BLEN_OVER510; goto idi_ret;}
					memset(&pTbl->pBlt[i], 0, n);
					i += n;
					break;
				default:															//			̑F
					if ((code - 2) > pTbl->MaxBl) pTbl->MaxBl = (code - 2);			//			@@ޒlݒ
					if (pTbl->MaxBl == 2308) {
						int x = 10;
					}
					pTbl->pBlt[i++] = (UB)(code - 2);
					break;
			}
		}
	}
	//----- R[hpR[h\쐬 ---------------------------------------------------------------------------//
	pTbl->nCtb = BltToCtb(pTbl);
	if (pTbl->nCtb > 510) {rc = pTbl->nCtb; goto idi_ret;}
	SortCtb(pTbl);

	//----- fBX^XErbge[u -----------------------------------------------------------------//
	pTbl = &pW->Dist;												//	e[uAhXݒ
	pTbl->nBlt	= GetBNum(pW, 4);									//	e[uGg[h
	if (pTbl->nBlt == 0) {											//	GgOH
		i = GetBNum(pW, 4);											//		ỸR[hl[h
		memset(pTbl->pBlt, 0, i);									//		e[uNA[
		pTbl->pBlt[i] = 1;											//		ỸR[hɂPrbg蓖
		pTbl->MaxBl   = 1;											//		őrbgP
		pTbl->nBlt	  = i + 1;										//		Le[uGgݒ
	}
	else {															//	GgOH
		pTbl->MaxBl = 0;											//		őޯĒNA[
		for (i=0; i < pTbl->nBlt;) {								//		SGg[v
			bl = GetNCode(pW);										//			Pg擾
			if (bl > 16) {rc = bl; goto idi_ret;}					//			PVȏȂ΃G[
			pTbl->pBlt[i++] = (UB)bl;								//			rbge[uGgݒ
			if (bl > pTbl->MaxBl) pTbl->MaxBl = bl;					//			őrbgXV
		}
	}
	//----- fBX^XER[h\쐬 -------------------------------------------------------------------------//
	pTbl->nCtb = BltToCtb(pTbl);
	if (pTbl->nCtb > 510) {rc = pTbl->nCtb; goto idi_ret;}
	SortCtb(pTbl);

idi_ret:;

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	ɂPoCg																						//
//																												//
//	@	F	pW	- CX^X[ÑAhX																//
//																												//
//	߂l	F	͂l																						//
//--------------------------------------------------------------------------------------------------------------//
static	UB			GetByte   (HAJCLZH pW)
{
	if (pW->dl <= pW->ix) {
		if ((pW->dl = pW->cbRead(pW->xp, pW->RBuf, AJCLZHINPBUFSIZE)) == 0) {
			pW->flg |= AJCLZHF_EOF;
		}
		pW->ix = 0;
	}
	return *(pW->RBuf + pW->ix++);
}
//--------------------------------------------------------------------------------------------------------------//
//	ɂ̓̓oCgʒuݒ																					//
//																												//
//	@	F	pW	- CX^X[ÑAhX																//
//																												//
//	߂l	F	͂l																						//
//--------------------------------------------------------------------------------------------------------------//
static	VO			SetBytePos(HAJCLZH pW)
{
	pW->cbSeek(pW->xp, pW->ofs);
	pW->dl = pW->ix = 0;
	pW->flg &= ~AJCLZHF_EOF;
}
//--------------------------------------------------------------------------------------------------------------//
//	Pi擾																								//
//																												//
//	@	F	pW	- fR[hCX^X̃AhX															//
//																												//
//	߂l	F	O`PU - rbgXg[\Pil														//
//				̑	 - G[																				//
//--------------------------------------------------------------------------------------------------------------//
static	UI	GetNCode(HAJCLZH pW)
{
	UI				rc, n;
	AJCLZHUNIWORD	ex;

	rc = GetBNum(pW, 3);
	if (rc == 7) {
		ex.uw = PeekBits(pW, 10);

		if (ex.ub.h == 0xFF)
			n = (8 + NCodeTable[ex.ub.l]);
		else
			n = NCodeTable[ex.ub.h];

		rc += n;
		SkipBits(pW, n + 1);

		if (rc > 16) {
			rc = AJCLZHERR_UNARYCODE_OUTOFRANGE;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	nt}EfR[h																							//
//																												//
//	@	F	pW	- fR[hCX^X̃AhX															//
//																												//
//	߂l	F	rbgXg[likrârbgɐݒj													//
//--------------------------------------------------------------------------------------------------------------//
static	UI	HuffDecode(HAJCLZH pW, PAJCLZHTBL pTbl)
{
	UI			bptn = PeekBits(pW, pTbl->MaxBl);
	PAJCLZHCTB	pCtb;

	pCtb = SearchCtb(bptn, pTbl);
	SkipBits(pW, pCtb->bl);

	return pCtb->code;
}
//--------------------------------------------------------------------------------------------------------------//
//	rbge[uAR[h\𐶐																	//
//																												//
//	@	F	pBlt - rbge[ũAhX																//
//				max  - őrbg																				//
//				pTbl - R[h\̃AhX																		//
//																												//
//	߂l	F	1`510 - R[h\̗LGg																//
//				̑ - G[																					//
//--------------------------------------------------------------------------------------------------------------//
static	UI		BltToCtb(PAJCLZHTBL pTbl)
{
	UW			frq[17], wgt[17], spt[17];
	UW			ptn, w;
	UI			i, j, bl;
	UI			MaxBl = pTbl->MaxBl;
	UBP			pBlt = pTbl->pBlt;
	PAJCLZHCTB	pCtb = pTbl->pCtb;

	memset(frq, 0, sizeof frq);

	//----- rbg̕pxZo ----------//
	for (i=0; i < pTbl->nBlt; i++) {
		bl = pBlt[i];
		if (bl <= 16) {
			if (bl != 0) frq[bl]++;
		}
		else {
			return AJCLZHERR_ILLEGAL_BITLEN;
		}
	}
	//----- R[h\쐬 ------------------//
	ptn = 0; w = (1 << (MaxBl - 1));
	for (i = 1; i <= MaxBl; i++) {
		spt[i] = ptn;
		wgt[i] = w;
		ptn += (w * frq[i]);
		w >>= 1;
	}
	for (i=j=0; i<pTbl->nBlt; i++) {
		bl = pBlt[i];
		if (bl != 0) {
			ptn = spt[bl];
			pCtb[j].bl	 = bl;
			pCtb[j].bptn = (ptn << (16 - (MaxBl)));
			pCtb[j].code = i;
			j++;
			spt[bl] += wgt[bl];
		}
	}
	pTbl->nCtb = j;

	return j;
}
//--------------------------------------------------------------------------------------------------------------//
//	R[h\\[g																								//
//																												//
//	@	F	pTbl - R[h\̃AhX																		//
//				n	 - R[h\̃Gg																		//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SortCtb(PAJCLZHTBL pTbl)
{
	UI			i, j, k;
	UI			nCtb = pTbl->nCtb;
	PAJCLZHCTB	pCtb = pTbl->pCtb;
	AJCLZHCTB	x;

	if (nCtb >= 2) {
		nCtb--;
		k = nCtb / 2;
		do {
			i = k;
			memcpy(&x, pCtb + i, sizeof(AJCLZHCTB));
			while ((j = 2 * i + 1) <= nCtb) {
				if (j < nCtb && pCtb[j].bptn < pCtb[j+1].bptn) j++;
				if (x.bptn >= pCtb[j].bptn) break;
				memcpy(pCtb + i, pCtb + j, sizeof(AJCLZHCTB));
				i = j;
			}
			memcpy(pCtb + i, &x, sizeof(AJCLZHCTB));
		} while (k-- != 0);

		while (nCtb > 0) {
			memcpy(&x, pCtb + nCtb	, sizeof(AJCLZHCTB));
			memcpy(pCtb + nCtb, pCtb, sizeof(AJCLZHCTB));
			nCtb--;
			i = 0;
			while ((j = 2 * i + 1) <= nCtb) {
				if (j < nCtb && pCtb[j].bptn < pCtb[j+1].bptn) j++;
				if (x.bptn >= pCtb[j].bptn) break;
				memcpy(pCtb + i, pCtb + j, sizeof(AJCLZHCTB));
				i = j;
			}
			memcpy(pCtb + i, &x, sizeof(AJCLZHCTB));
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	R[h\																								//
//																												//
//	@	F	bptn - rbgp^[																	//
//				pTbl - R[h̃AhX																			//
//				n	 - R[h\̃Gg																		//
//																												//
//	߂l	F	Ye[uGg̃AhX																	//
//--------------------------------------------------------------------------------------------------------------//
static	PAJCLZHCTB	SearchCtb(UI bptn, PAJCLZHTBL pTbl)
{
	PAJCLZHCTB	pCtb  = pTbl->pCtb;
	UI			l = 0;
	UI			r = pTbl->nCtb;
	UI			m, sft;
	UW			msk;

	while (l < r) {
		m = ((l + r) >> 1);
		if (pCtb[m].bptn < bptn) l = m + 1;
		else					 r = m;
	}
	if		(l == pTbl->nCtb) --l;
	else if (l != 0) {
		msk = BitMsk16[pCtb[l-1].bl];
		sft = pCtb[l].bl - pCtb[l-1].bl;
		if ((((UW)bptn & msk) >> sft) == ((pCtb[l-1].bptn & msk) >> sft)) l--;
	}
	return &pCtb[l];
}
//--------------------------------------------------------------------------------------------------------------//
//	rbgXg[QƁirbgXg[̐擪rbg`j												//
//																												//
//	@	F	pW	- fR[hCX^X̃AhX															//
//				n	- rbgiO`PUj																		//
//																												//
//	߂l	F	rbgXg[lilrârbgɐݒj													//
//--------------------------------------------------------------------------------------------------------------//
static	UW	PeekBits(HAJCLZH pW, UI n)
{
	AJCLZHUNIWORD	c;

	for (; pW->rem < n; pW->rem += 8) {						//		wrbgȏƂȂ܂
		c.uw = GetByte(pW);									//		ɃXg[ǂݏo
		c.uw <<= (8 - (pW->rem & 7));						//		E
		switch (pW->rem >> 3) {								//		E
			case 0:	pW->u.uw.h	|= c.uw;	break;			//		E
			case 1:	pW->u.ub.mh |= c.ub.h;					//		E
					pW->u.ub.ml |= c.ub.l;	break;			//		E
			case 2: pW->u.uw.l	|= c.uw;	break;			//		E
	}	}
	return (UW)(pW->u.uw.h & BitMsk16[n]);					//		߂ll߂̃rbgp^[
}

//--------------------------------------------------------------------------------------------------------------//
//	rbgXg[ji擪̂rbgjj															//
//																												//
//	@	F	pW	- fR[hCX^X̃AhX															//
//				n	- rbgiO`QSj																		//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SkipBits(HAJCLZH pW, UI n)
{
	SHL(pW->u, n);					//	lraj															//
	pW->rem -= n;					//	LrbgZ														//
}

//--------------------------------------------------------------------------------------------------------------//
//	rbgXg[擾irbgXg[\liEl̃rbgo^[j擾j								//
//																												//
//	@	F	pW	- fR[hCX^X̃AhX															//
//				n	- rbgiO`QSj																		//
//																												//
//	߂l	F	rbgXg[likrârbgɐݒj													//
//--------------------------------------------------------------------------------------------------------------//
static	UW	GetBNum(HAJCLZH pW, UI n)
{
	AJCLZHUNIWORD	u;
	UI		sft = 16 - n;

	u.uw = PeekBits(pW, n);
	if (sft >= 8) {
		u.ub.l = u.ub.h;
		u.ub.h = 0;
		sft -= 8;
	}
	u.uw >>= sft;

	SHL(pW->u, n);					//	lraj	
	pW->rem -= n;					//	LrbgZ

	return u.uw;
}
//--------------------------------------------------------------------------------------------------------------//
//	wb_ǂݏo																							//
//																												//
//	@	F	pW	- CX^Xwb_̃AhX																//
//																												//
//	߂l	F	O  F																					//
//				0xFFFFFEOF																						//
//				̑FG[																					//
//--------------------------------------------------------------------------------------------------------------//
static	UI	ReadHeaderInfo(HAJCLZH pW)
{
	UI		i, rc = 0;
	UB		s[21];

	if (!(pW->flg & AJCLZHF_EOF)) {
		for (i=0; i<21; i++) { 										//	擪QPoCgǂݏo
			s[i] = GetByte(pW);
			if (pW->flg & AJCLZHF_EOF) break;
		}
		if (!(pW->flg & AJCLZHF_EOF)) {
			if (memcmp(&s[2], "-lh0-", 5) == 0 ||					//	lh0 or lh5 or lhd H
				memcmp(&s[2], "-lh5-", 5) == 0 ||					//	E
				memcmp(&s[2], "-lhd-", 5) == 0) {					//	E
				pW->Sig = s[5];										//	VOl`('0' / '5' / 'd')ݒ
				pW->Lvl = s[20];									//		x(0 / 1 / 2)ݒ
				switch (s[20]) {
					case 0:	ReadH0(pW, s);					break;	//		xOwb_ǂݏo
					case 1:	ReadH1(pW, s);					break;	//		xPwb_ǂݏo
					case 2:	ReadH2(pW, s);					break;	//		xQwb_ǂݏo
					default: rc = AJCLZHERR_ILLEGAL_HDLVL;	break;	//		xԍG[
				}
			}
			else {													//	VOl`sH
				rc = AJCLZHERR_ILLEGAL_FORMAT;						//		G[
			}
		}
		else {
			rc = 0xFFFF;
		}
	}
	else {
		rc = 0xFFFF;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	kg`xOwb_ǂݏo																			//
//																												//
//	@	F	pW	- CX^Xwb_̃AhX																//
//				s	- wb_̐擪iQPoCgj̃AhX													//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	ReadH0(HAJCLZH pW, UBP s)
{
	UB		stl;

	pW->HeadSize	 = s[0];									//	wb_TCYǂݏo
	pW->CheckSum	 = s[1];									//	`FbNTǂݏo
	pW->HuffSize	 = StrLong(s + 7);							//	kf[^TCYǂݏo
	pW->FileSize	 = StrLong(s + 11);							//	t@CTCYǂݏo
	pW->FileTime	 = DosTimeToFileTime(StrLong(s + 15));		//	t@C^Cǂݏo
	pW->fLocalTime	 = TRUE;									//	tOu[J^Cv
	pW->FileAttr	 = s[19];									//	t@Cǂݏo
	stl = GetByte(pW);											//	stl = t@C̒
	GetString(pW, stl, pW->PathName,							//	t@Cǂݏo
		(UI)(AJCLZHNAMEBUFSIZE - strlen(pW->PathName)));		//	E
	pW->crc 		 = GetWord(pW);								//	bqbǂݏo

	pW->BlkSize = pW->HeadSize + pW->HuffSize + 2;				//	ubNTCYݒ

	SplitPath(pW->PathName, pW->DirName, pW->FileName);
}
//--------------------------------------------------------------------------------------------------------------//
//	kg`xPwb_ǂݏo																			//
//																												//
//	@	F	pW	- CX^Xwb_̃AhX																//
//				s	- wb_̐擪iQPoCgj̃AhX													//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	ReadH1(HAJCLZH pW, UBP s)
{
	UW		stl, exl;

	pW->HeadSize	 = s[0];									//	wb_TCYǂݏo
	pW->CheckSum	 = s[1];									//	`FbNTǂݏo
	pW->HuffSize	 = StrLong(s + 7);							//	kf[^TCYǂݏo
	pW->FileSize	 = StrLong(s + 11);							//	t@CTCYǂݏo
	pW->FileTime	 = DosTimeToFileTime(StrLong(s + 15));		//	t@C^Cǂݏo
	pW->fLocalTime	 = TRUE;									//	tOu[J^Cv
	stl = GetByte(pW);											//	stl = t@C̒
	GetString(pW, stl, pW->PathName, AJCLZHNAMEBUFSIZE);		//	t@Cǂݏo
	pW->crc 		 = GetWord(pW);								//	bqbǂݏo
	pW->os	= GetByte(pW);										//	nrʓǂݏo

	exl = ReadHEx(pW);											//	gwb_ǂݏo

	pW->BlkSize = pW->HeadSize + pW->HuffSize + 2;				//	ubNTCYݒ

	SplitPath(pW->PathName, pW->DirName, pW->FileName);
}
//--------------------------------------------------------------------------------------------------------------//
//	kg`xQwb_ǂݏo																			//
//																												//
//	@	F	pW	- CX^Xwb_̃AhX																//
//				s	- wb_̐擪iQPoCgj̃AhX													//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	ReadH2(HAJCLZH pW, UBP s)
{
	UI		exl;

	pW->HeadSize	 = StrWord(s + 0);							//	wb_TCYǂݏo
	pW->HuffSize	 = StrLong(s + 7);							//	kf[^TCYǂݏo
	pW->FileSize	 = StrLong(s + 11);							//	t@CTCYǂݏo
	pW->FileTime	 = StrLong(s + 15);							//	t@C^Cǂݏo
	pW->fLocalTime	 = FALSE;									//	tOuEWv
	pW->crc 		 = GetWord(pW);								//	bqbǂݏo
	pW->os			 = GetByte(pW);								//	nrʓǂݏo

	memset(pW->PathName, 0, AJCLZHNAMEBUFSIZE);					//	t@CNA[
	exl = ReadHEx(pW);											//	gwb_ǂݏo

	pW->BlkSize = pW->HeadSize + pW->HuffSize;					//	ubNTCYݒ

	SplitPath(pW->PathName, pW->DirName, pW->FileName);
}
//--------------------------------------------------------------------------------------------------------------//
//	kg`gwb_ǂݏo																				//
//																												//
//	@	F	pW	- CX^Xwb_̃AhX																//
//				s	- wb_̐擪iQPoCgj̃AhX													//
//																												//
//	߂l	F	gwb_̑oCg																			//
//--------------------------------------------------------------------------------------------------------------//
static	UI	ReadHEx(HAJCLZH pW)
{
	UI		rc = 2;
	UI		i;
	UI		len, stl, exl;
	UB		id;

	for (i=0; i < 16 && (exl = GetWord(pW)) != 0; i++) {								//	gwb_ԃ[v
		if (exl > 3) {
			stl = exl - 3;																//	@stl=gf[^TCY
			id = GetByte(pW);															//	@hcǂݏo
			switch (id) {
				case 0:																	//	@OFbqbǂݏo
					pW->crcEx = GetWord(pW);
					break;

				case 1:																	//	@PFt@Cǂݏo
					len = (UI)strlen(pW->PathName);										//		len = DIR
					GetString(pW, stl, &pW->PathName[len], AJCLZHNAMEBUFSIZE - len);	//		DIŖٖ̌Ǐo
					break;
				case 2:																	//	@QFchqǂݏo
					len = (UI)(strlen(pW->PathName) + 1);								//		len = ̧ٖ
					memmove(&pW->PathName[AJCLZHNAMEBUFSIZE - len],						//		̧ٖ㕔ֈړ
							 pW->PathName, len);										//		E
					GetString(pW, stl, pW->PathName, AJCLZHNAMEBUFSIZE - len);			//		DIRǂݏo
					strcat(pW->PathName, &pW->PathName[AJCLZHNAMEBUFSIZE - len]);		//		̧ٖA
					break;
				default:																//	@Fǂݔ΂
					GetString(pW, stl, NULL 	   , 0						);
					break;
			}
			rc += exl;																	//	@gwb_TCYXV
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	ɃXg[烏[hǂݏo																		//
//																												//
//	@	F	pW	- CX^Xwb_̃AhX																//
//																												//
//	߂l	F	ǂݏo[hl																				//
//--------------------------------------------------------------------------------------------------------------//
static	UW	GetWord(HAJCLZH pW)
{
	AJCLZHUNIWORD	u;

	u.ub.l = GetByte(pW);
	u.ub.h = GetByte(pW);

	return u.uw;
}
//--------------------------------------------------------------------------------------------------------------//
//	ɃXg[當ǂݏo																		//
//																												//
//	@	F	pW	 - CX^Xwb_̃AhX																//
//				stl  - ̃oCg																		//
//				pBuf - i[obt@̃AhX														//
//				bfl  - i[obt@̃oCg														//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	GetString(HAJCLZH pW, UI stl, BCP pBuf, UI bfl)
{
	UI	i = 0;
	BC	c;

	if (bfl) {
		for (; i < bfl-1 && i < stl; i++) {
			c = GetByte(pW);
			if (c == 0xFF) *pBuf++ = '\\';
			else		   *pBuf++ = c;
		}
		*pBuf = 0;
	}
	for (; i < stl; i++) {
		GetByte(pW);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	oCgXg[烏[hǂݏo																		//
//																												//
//	@	F	pW	- CX^Xwb_̃AhX																//
//																												//
//	߂l	F	ǂݏo[hl																				//
//--------------------------------------------------------------------------------------------------------------//
static	UW	StrWord(UBP pStr)
{
	AJCLZHUNIWORD	u;

	u.ub.l = *pStr++;
	u.ub.h = *pStr;

	return u.uw;
}
//--------------------------------------------------------------------------------------------------------------//
//	oCgXg[烍O[hǂݏo																//
//																												//
//	@	F	pW	- CX^Xwb_̃AhX																//
//																												//
//	߂l	F	ǂݏoO[hl																		//
//--------------------------------------------------------------------------------------------------------------//
static	UL	StrLong(UBP pStr)
{
	AJCLZHUNILONG	u;

	u.ub.l	= *pStr++;
	u.ub.ml = *pStr++;
	u.ub.mh = *pStr++;
	u.ub.h	= *pStr;

	return u.ul;
}
//--------------------------------------------------------------------------------------------------------------//
//	pX																									//
//																												//
//	@	F	pPath - pX̃AhX																//
//				pDir  - fBNgi[obt@̃AhX												//
//				pFile - t@C{gqi[obt@̃AhX											//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - obt@I[o[																		//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SplitPath(C_BCP pPath, BC pDir[MAX_PATH], BC pFile[MAX_PATH])
{
	BC		fname[_MAX_FNAME], fext[_MAX_EXT];

	_splitpath(pPath, NULL, pDir, fname, fext);
	_makepath (pFile, NULL, NULL, fname, fext);
}

//--------------------------------------------------------------------------------------------------------------//
//	fBNgpXr																						//
//																												//
//	@	F	pDirName  - fBNgpX																	//
//				pWildDir  - ChJ[h̃fBNg													//
//				fSubDir   - TufBNgtO															//
//																												//
//	߂l	F	TRUE Fv																						//
//				FALSEFsv																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CmpDirName(C_BCP pDirName, C_BCP pWildDir, BOOL fSubDir)
{
	BOOL	rc = FALSE;
	int		i, len1, len2;
	BC		d1[MAX_PATH];
	BC		d2[MAX_PATH];

	//	pXRs[
	AjcSnPrintFA(d1, AJCTSIZE(d1), "%s", pDirName);
	AjcSnPrintFA(d2, AJCTSIZE(d2), "%s", pWildDir);

	//	d1 : '\' -> '/' ϊ
	for (i = 0; d1[i] != 0; i++) {
		if (d1[i] == '\\') d1[i] = '/';
	}
	//	d2 : '\' -> '/' ϊ
	for (i = 0; d2[i] != 0; i++) {
		if (d2[i] == '\\') d2[i] = '/';
	}

	len1 = (int)strlen(d1);
	len2 = (int)strlen(d2);

	//	TufBNgꍇ́A擪̂ݔr
	if (fSubDir) {
		if (len1 >= len2) {
			rc = (memicmp(d1, d2, len2) == 0);
		}
	}
	//	TufBNgȂꍇ́AŜr
	else {
		if (len1 == len2) {
			rc = (mbsicmp(d1, d2) == 0);
		}
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	ChJ[hr																							//
//																												//
//	@	F	pPath  - pX																					//
//				pWild  - ChJ[h																			//
//																												//
//	߂l	F	TRUE Fv																						//
//				FALSEFsv																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CmpWildStr(C_BCP pPath, C_BCP pWild)
{
	BOOL	rc = TRUE;
	BC		path[MAX_PATH];
	BC		fname[_MAX_FNAME], fext[_MAX_EXT];
	BC		file[MAX_PATH];

	//	pXRs['\'폜
	AjcSnPrintFA(path, AJCTSIZE(path), "%s", pPath);
	PathRemoveBackslashA(path);
	//	t@C^fBNgv`FbN
	_splitpath(path, NULL, NULL, fname, fext);
	_makepath (file, NULL, NULL, fname, fext);
	if (mbsicmp(file, pWild) != 0) {
		//	ChJ[hEqbg`FbN
		rc = PathMatchSpecA(path, pWild);
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	cnr^Ct@C^Ci1970-01-01 00:00:00̒ʎZbjɕϊ										//
//																												//
//	@	F	DosTime - cnr^C																			//
//																												//
//	߂l	F	t@C^Ci1970-01-01 00:00:00̒ʎZbj												//
//--------------------------------------------------------------------------------------------------------------//
#define		ISURU(Y)	(((Y % 4) == 0 && (Y % 100) != 0) || (Y % 400) == 0)

static	UL	DosTimeToFileTime(UL DosTime)
{
	UL	ftime = 0;
	UI	m, year, month, day, hour, minute, second;

	year   = (UI)(( DosTime >> 25) + 1980);
	month  = (UI)(((DosTime >> 21) & 0x0F));
	day    = (UI)(((DosTime >> 16) & 0x1F));
	hour   = (UI)(((DosTime >> 11) & 0x1F));
	minute = (UI)(((DosTime >>	5) & 0x3F));
	second = (UI)(((DosTime >>	0) & 0x1F) * 2);

	ftime += (((((UL)year - (UL)1970) * (UL)365) + (((UL)year - (UL)1969) / (UL)4)) * (UL)86400);
	if (year > 2100) 
		ftime -= (UL)86400;
	for (m=1; m < month; m++) 
		ftime += ((DaysTable[m] + (m==2 ? ISURU(year) : 0)) * (UL)86400);
	ftime += ((UL)day - (UL)1) * (UL)86400;
	ftime += ((UL)hour * (UL)3600);
	ftime += ((UL)minute * (UL)60);
	ftime += second;

	return ftime;
}
