//
//	AcsMacro.c - }No^AWJ
//
#include	"AjcInternal.h"
#include	"AjcPp.h"

#define		SYL_VA_ARGS		"__VA_ARGS__"

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static PAJCPPCTKNNODE MacExpWithArg	(HAJCPPC pW, PAJCPPCTKNNODE *ppBfr, PAJCPPCTKNNODE pTkn, PPPCMACARGS pMac);
static PAJCPPCTKNNODE MacExpNoArg  	(HAJCPPC pW, PAJCPPCTKNNODE *ppBfr, PAJCPPCTKNNODE pTkn, PPPCMACNODE pMac);
static BCP			  NumStr		(HAJCPPC pW, int n);

//--------------------------------------------------------------------------------------------------------------//
//	L[̔rR[obN																						//
//--------------------------------------------------------------------------------------------------------------//
static int CALLBACK cbAvlComp(UX key1, UX key2, UX cbp)
{
	HAJCPPC pW = (HAJCPPC)cbp;

	return(mbscmp((C_BCP)key1, (C_BCP)key2));
}
//--------------------------------------------------------------------------------------------------------------//
//	IuWFNg폜̃R[obN																			//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbAvlRemove(UX key, C_VOP pNode, UI len, UI nest, UX cbp)
{
	HAJCPPC			pW = (HAJCPPC)cbp;
	PCPPCMACARGS 	pN = (PCPPCMACARGS)pNode;
	PAJCPPCTKNNODE	pT = pN->pTknBody;

	//----- }N ---------------------------//
	if (pN->pMacName != NULL) PpcMemFree(pW, pN->pMacName);
	//----- }Nm[h ---------------------//
	PpcTknFree(pW, pN->pTknName);
	//----- }N{fB -----------------------//
	while (pT != NULL) {
		pT = PpcRelCurAndGetNextToken(pW, pT);
	}
	//----- Xg -----------------------//
	if (pN->fWithArg && pN->hVQueArg != NULL) {
		AjcVQueDelete(pN->hVQueArg);
	}
}

//==============================================================================================================//
//	ݒ																									//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	NULLFAVLnh																				//
//				NULLFG[																					//
//==============================================================================================================//
HAJCAVL	PpcMacInit(HAJCPPC pW)
{

	if (pW->hAvlMac == NULL) {
		pW->hAvlMac = AjcAvlCreate((UX)pW, cbAvlComp, cbAvlRemove);

		if (pW->hAvlMac == NULL) {
			pW->fMemErr = TRUE;
			PPC_ERR(AJCPPC_ERROR_MEMALLOC, 0, 0, 0);
		}
	}
	else {
		AjcAvlDelAllNodes(pW->hAvlMac);
	}
	return pW->hAvlMac;
}
//==============================================================================================================//
//	I																									//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
VO		PpcMacEnd(HAJCPPC pW)
{
	if (pW->hAvlMac != NULL) {
		AjcAvlDelete(pW->hAvlMac);
		pW->hAvlMac = NULL;
	}
}
//==============================================================================================================//
//	}No^																									//
//																												//
//	@	F	pTkn	 - }N`g[NEXg[̃AhXi擪g[N̓}Nj					//
//				fWithArg - TRUE:t}NCFALSE:Ȃ}N												//
//				pos		 - 擪u#v̌ʒu																	//
//																												//
//	߂l	F	TRUE FOK																						//
//				FALSEFG[																					//
//																												//
//	l	F	{֐spTknŎw肵g[NXg[͉Ȃł							//
//==============================================================================================================//
BOOL	PpcMacRegist(HAJCPPC pW, PAJCPPCTKNNODE pTkn, BOOL fWithArg, UI pos)
{
	BOOL	rc = FALSE;
	BCP		pFile = pTkn->pFile;
	UI		lno   = pTkn->lno;

	if (pW->hAvlMac != NULL) {
		//----- t}N ---------------------------------------------------------------------------------//
		if (fWithArg) {
			PPCMACARGS		n_new;
			PPPCMACARGS		p_reg;
			PAJCPPCTKNNODE	pC		 = pTkn;
			UI				stl;
			BCP				pLastArg = "";
			BOOL			fErr	 = FALSE;

			do {
				//----- m[h -----------------------------------------//
				memset(&n_new, 0, sizeof n_new);
				//----- 擪u#v̌ʒuݒ --------------------------------//
				n_new.pos = pos;
				//----- }Nݒ -----------------------------------------//
				n_new.fWithArg = TRUE;
				stl = (UI)strlen(pTkn->pSyl) + 1;
				n_new.pMacName = PpcMemAlloc(pW, stl);
				if (n_new.pMacName == NULL) {
					fErr = pW->fStop = TRUE;
					break;
				}
				strcpy(n_new.pMacName, pTkn->pSyl);
				//----- }Ng[NEm[h|C^ݒ -----------------//
				n_new.pTknName = pTkn;
				//----- }N̎̃g[N|C^ݒ -------------------//
				if ((pC = pC->pNxt) == NULL) break;
				//----- '('`FbN ------------------------------------------//
				if (pC->tkn != EAJCTK_DLM_LSPART) {
					PPC_ERR(AJCPPC_MACERR_NEED_LP, pC->pFile, pC->lno, n_new.pMacName);
					fErr = TRUE;
					break;
				}
				//----- '(' ̎̃g[N|C^ݒ -----------------------//
				if ((pC = PpcRelCurAndGetNextToken(pW, pC)) == NULL) break;
				//----- Xg쐬 -------------------------------------//
				if ((n_new.hVQueArg = AjcVQueCreate(0, NULL)) == NULL) break;
				while (pC != NULL && pC->tkn != EAJCTK_DLM_RSPART) {
					//----- 啶ޔ -----------------------------------//
					pLastArg = pC->pSyl;
					//----- ό`FbN -------------------------------//
					if (pC->tkn == EAJCTK_DLM_VARG) {
						pC->tkn 	 = EAJCTK_USR_NAME;
						pC->pSyl	 = PpcNStrRegist(pW, SYL_VA_ARGS);
						if (pC->pSyl == NULL) {
							fErr = pW->fStop = TRUE; 
							break;
						}
						n_new.fVaArgs = TRUE;
					}
					//----- V{ȊOȂ΃G[ -----------------//
					if (!AJCTKIS_SYMBOL(pC->tkn)) break;
					//----- Xgǉ ---------------------------------//
					stl = (UI)strlen(pC->pSyl) + 1;
					if (!AjcVQueEnque(n_new.hVQueArg, pC->pSyl, stl)) {
						fErr = pW->fStop = TRUE;
						break;
					}
					//----- XǧXV ---------------------------//
					n_new.nTmpArg++;
					//----- ̎̃g[N|C^ݒ -----------------//
					if ((pC = PpcRelCurAndGetNextToken(pW, pC)) == NULL) break;
					//----- ',' or ')' `FbN ------------------------------//
					if		(pC->tkn == EAJCTK_DLM_COMMA && !n_new.fVaArgs) {		// ',' && ό(...)H
						//----- ','̎̃g[N|C^ݒ ----------------//
						if ((pC = PpcRelCurAndGetNextToken(pW, pC)) == NULL) break;
					}
					else if (pC->tkn == EAJCTK_DLM_RSPART) {						// ')' H
						// [v𔲂ă}N{fBݒ //
						break;
					}
					else {	  														// ','	')' ȊOH
						if (n_new.fVaArgs) {
							PPC_ERR(AJCPPC_MACERR_NEED_RP, pC->pFile, pC->lno, pLastArg);
							fErr = TRUE;
						}
						else {
							PPC_ERR(AJCPPC_MACERR_NEED_RP_C, pC->pFile, pC->lno, pLastArg);
							fErr = TRUE;
						}
						break;
					}
				}
			} while(0);
			//----- }N{fBݒC}No^ -----------------------------//
			if (!fErr && pC != NULL && pC->tkn == EAJCTK_DLM_RSPART) {	//	ŌオE ')' ?
				//----- Eʂ̎̃g[N|C^ݒ ---------------------//
				pC = PpcRelCurAndGetNextToken(pW, pC);
				//----- }N{fBݒ -------------------------------------//
				n_new.pTknBody = pC;
				//----- }No^ -------------------------------------------//
				p_reg = AjcAvlGetNodePtr(pW->hAvlMac, (UX)n_new.pMacName, NULL);
				if (rc = (p_reg == NULL)) {
					if (rc = AjcAvlInsNode(pW->hAvlMac, (UX)n_new.pMacName, &n_new, sizeof(n_new))) {
					//	AjcTrace("Registered MACRO() %s\n", n_new.pMacName);
					}
					else {
						pW->fMemErr = TRUE;
						pW->fStop = TRUE;
						PPC_ERR(AJCPPC_ERROR_MEMALLOC, 0, 0, 0);
					}
				}
				else {
					if (!PpcCompTokenStream(pW, p_reg->pTknBody, n_new.pTknBody)) {
						PPC_ERR(AJCPPC_MACERR_MULTDEF, pFile, lno, n_new.pMacName);
					}
					cbAvlRemove((UX)n_new.pMacName, &n_new, sizeof n_new, 0, 0);
				}
			}
			//----- \[X --------------------------------------------//
			else {
				//----- }N{fBEg[N --------//
				while (pC != NULL) {
					pC = PpcRelCurAndGetNextToken(pW, pC);
				}
				//----- }Nm[h --------------------//
				if (n_new.pMacName != NULL) PpcMemFree(pW, n_new.pMacName);
				if (n_new.hVQueArg != NULL) AjcVQueDelete(n_new.hVQueArg);
			}
			//----- o^e\ifobOj ---------------------------------//
		}
		//----- Ȃ}N ---------------------------------------------------------------------------------//
		else {
			PPCMACNODE		n_new;
			PPPCMACARGS		p_reg;
			PAJCPPCTKNNODE	pC = pTkn;
			UI				stl;

			//----- m[hNA[ ---------------------------------------//
			memset(&n_new, 0, sizeof n_new);
			//----- }Nݒ -----------------------------------------//
			n_new.fWithArg = FALSE;
			stl = (UI)strlen(pTkn->pSyl) + 1;
			n_new.pMacName = PpcMemAlloc(pW, stl);
			//----- }Ng[NEm[h|C^ݒ -----------------//
			n_new.pTknName = pTkn;

			if (n_new.pMacName != NULL) {
				strcpy(n_new.pMacName, pTkn->pSyl);
				//----- }N̎̃g[N|C^ݒ -------------------//
				pC = pC->pNxt;
				//----- }N{fBݒ -------------------------------------//
				n_new.pTknBody = pC;
				//----- }No^ -------------------------------------------//
				p_reg = AjcAvlGetNodePtr(pW->hAvlMac, (UX)n_new.pMacName, NULL);
				if (rc = (p_reg == NULL)) {
					if (rc = AjcAvlInsNode(pW->hAvlMac, (UX)n_new.pMacName, &n_new, sizeof(n_new))) {
					}
					else {
						pW->fMemErr = TRUE;
						pW->fStop	= TRUE;
						PPC_ERR(AJCPPC_ERROR_MEMALLOC, 0, 0, 0);
					}
				}
				else {
					if (!PpcCompTokenStream(pW,  p_reg->pTknBody, n_new.pTknBody)) {
						PPC_ERR(AJCPPC_MACERR_MULTDEF, pFile, lno, n_new.pMacName);
					}
					cbAvlRemove((UX)n_new.pMacName, &n_new, sizeof n_new, 0, 0);
				}
			}
			else pW->fStop = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	}No^																								//
//																												//
//	@	F	pName	  - }ÑAhX																	//
//																												//
//	߂l	F	TRUE FOK																						//
//				FALSEFG[																					//
//==============================================================================================================//
BOOL		PpcMacUnRegist(HAJCPPC pW, C_BCP pName)
{
	BOOL	rc = FALSE;

	if (pW->hAvlMac != NULL) {
		rc = AjcAvlDelNode(pW->hAvlMac, (UX)pName);
	}
	return rc;
}
//==============================================================================================================//
//	}Nm[h擾i}No^`FbNj																	//
//																												//
//	@	F	pName	  - }ÑAhX																	//
//																												//
//	߂l	F	NULLFo^ρi}Nm[h̃AhXj													//
//				NULLFo^																					//
//==============================================================================================================//
VOP		PpcMacGetNode(HAJCPPC pW, C_BCP pName)
{
	VOP		rc = NULL;

	if (pW->hAvlMac != NULL) {
		rc = AjcAvlGetNodePtr(pW->hAvlMac, (UX)pName, NULL);
	}
	return rc;
}
//==============================================================================================================//
//	擪V{̃}NWJidWJj																		//
//																												//
//	擪V{}NłꍇAY}NQƂWJ`Œu܂BidWJj					//
//																												//
//	@	F	ppBfr - Õg[N擪g[Nւ̃|C^̃AhX									//
//																												//
//	߂l	F	TRUE : }NWJρi}NQƕWJ`ŒuCug[N1ꍇ܂ށj//
//				FALSE: }NWJ																				//
//==============================================================================================================//
BOOL	PpcMacExpand(HAJCPPC pW, PAJCPPCTKNNODE *ppBfr)
{
	BOOL			rc		  = FALSE;
	VOP				pMacNode  = NULL;
	PAJCPPCTKNNODE 	pTkn;
	AJCPPCTKNNODE	TknRef;

	if (*ppBfr != NULL) {
		pTkn = *ppBfr;
		if (pTkn->mexp <= PPCMAX_MEXP_NEST) {
			//	}NQƐ擪g[Nޔ
			memcpy(&TknRef, pTkn, sizeof(AJCPPCTKNNODE));
			while (pTkn != NULL && AJCTKIS_SYMBOL(pTkn->tkn) && (pMacNode = PpcMacGetNode(pW, pTkn->pSyl))) {
				//	~`FbN
				if (pW->fStop) break;
				//	t}NŁÃg[N '(' ȊOȂ΁AWJȂi֐}ŇĂяoł͂Ȃj
				if (((PPPCMACNODE)pMacNode)->fWithArg && (pTkn->pNxt == NULL || pTkn->pNxt->tkn != EAJCTK_DLM_LSPART)) break;
				//	}NWJ
				if (pTkn->mexp <= PPCMAX_MEXP_NEST) {
					//	}NWJ
					if (((PPPCMACNODE)pMacNode)->fWithArg) {
						pTkn = MacExpWithArg(pW, ppBfr, pTkn, (PPPCMACARGS)pMacNode);
					}
					else {
						pTkn = MacExpNoArg	(pW, ppBfr, pTkn, (PPPCMACNODE)pMacNode);
					}
					//	}NQƒʒm
					PPC_NTC(AJCPPC_NTC_MACREF, (UX)&TknRef, (UX)pMacNode, 0);
					//	߂l}NWJ
					rc = TRUE;
				}
				else {
					PPC_ERR(AJCPPC_MACERR_NEST_OVER, (UX)pTkn->pFile, (UX)pTkn->lno, (UX)(((PPPCMACNODE)pMacNode)->pMacName));
					break;
				}
			}
		}
		else {
			PPC_ERR(AJCPPC_MACERR_NEST_OVER, (UX)pTkn->pFile, (UX)pTkn->lno, (UX)"");
		}
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	t}N̓WJ																						//
//																												//
//	@	F	ppBfr - }NQƕ擪g[Nւ̃|C^̃AhX											//
//				pTkn  - }NQƕ擪g[ÑAhX														//
//				pMac  - }N`m[h̃AhX																//
//																												//
//	߂l	F	NULL : }NWJg[NiWJ`̐擪m[hAhXj									//
//				NULL : }NWJg[NȂ																	//
//--------------------------------------------------------------------------------------------------------------//
//--- Ǝ̑ΉXg ---//
typedef struct {
	BCP			pTmpArg;
	PAJCPPCTKNNODE	pRelArg;
} MEW_LIST, *PMEW_LIST;
typedef const MEW_LIST *PCMEW_LIST;

static	int		SrhTmpArg(HAJCPPC pW, C_BCP pSyl, PCMEW_LIST pArr, int n);

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static PAJCPPCTKNNODE MacExpWithArg(HAJCPPC pW, PAJCPPCTKNNODE *ppBfr, PAJCPPCTKNNODE pTkn, PPPCMACARGS pMac)
{
	PMEW_LIST		pALArr		 = NULL;					//	Xgz̃AhX
	PAJCPPCTKNNODE	pALTkn		 = NULL;					//	ɑ΂g[NXg
	BCP				pFile		 = pTkn->pFile;				//	t@CpXݒ
	UW				lno 		 = pTkn->lno;				//	sԍl}N̍sԍ
	UI				pos			 = pTkn->pos;				//	g[N̈ʒui^uXebvSj
	UB				inst		 = pTkn->inst;				//	#includẽlXgx
	UB				incf		 = pTkn->incf;				//	#include
	UB				mexp		 = pTkn->mexp + 1;			//	}NWJlXgx
	BCP				pMacName	 = pTkn->pSyl;				//	}N
	BCP				pStr		 = NULL;					//	ҏW[N
	BOOL			fVaArg		 = FALSE;					//	ό}NEtO
	UI				nTmpArg		 = pMac->nTmpArg;			//	̌
	UI				nValArg		 = 0;						//	LȈ̌iόꍇ͉|Pj
	PAJCPPCTKNNODE	pCur;									//	g[N|C^E[N
	PAJCPPCTKNNODE	pBfr;									//	g[N|C^ޔ[N
	PAJCPPCTKNNODE	pArg		 = NULL;					//	g[N|C^
	PAJCPPCTKNNODE	pBdy		 = NULL;					//	}N{fBg[N|C^
	PAJCPPCTKNNODE	pExpTop		 = NULL;					//	}NWJg[N̐擪|C^
	PAJCPPCTKNNODE	pExp		 = NULL;					//	}NWJg[N|C^
	PAJCPPCTKNNODE	pSvNxt;									//	}NQƕ̒̃g[NAhXiꍇNULLj
	int				nest 		= 0;						//	ʂ̃lXgJE^
	UB				flg			= 0;						//	}NQƂ̖iEʁj̃tO
	UI				i, stl;

	//----------------------------------------------------------------------------------------------------------//
	//	Ǝ̑ΉXge[umۂAݒ													//
	//----------------------------------------------------------------------------------------------------------//
	i = 0;
	pALArr = PpcMemAlloc(pW, sizeof(MEW_LIST) * pMac->nTmpArg);
	if (pALArr != NULL) {
		if (pStr = AjcVQueTopNode(pMac->hVQueArg, NULL)) {
			do {
				pALArr[i].pTmpArg = pStr;
				i++;
			} while(i < pMac->nTmpArg && (pStr = AjcVQueNextNode(pMac->hVQueArg, pStr, NULL)));
		}
		//----------------------------------------------------------------------------------------------------------//
		//	{}NQƕAe[uɎݒ												//
		//----------------------------------------------------------------------------------------------------------//
		pCur = PpcRelCurAndGetNextToken(pW, pTkn);						//	}NXLbv
		if (pCur != NULL && pCur->tkn == EAJCTK_DLM_LSPART) {			//	̃g[N͍ '('
			if ((pCur = PpcRelCurAndGetNextToken(pW, pCur)) != NULL) {	//	'('XLbvCg[NLH
				nest	= 0;
				nValArg = 0;
				pALTkn	= pCur;
				while (pCur != NULL && pCur->tkn != EAJCTK_DLM_RSPART && nest >= 0) {
					if (pW->fStop) break;
					//----- g[NXgݒ ---------------------//
					if (pCur->tkn != EAJCTK_DLM_COMMA && pCur->tkn != EAJCTK_DLM_RSPART) {
						//----- όtOݒ ---------------------//
						fVaArg = (pMac->fVaArgs && mbscmp(pALArr[nValArg].pTmpArg, SYL_VA_ARGS) == 0);
						//----- ̐擪g[NAhXݒ ---------//
						pALTkn = pCur;
						//----- ̏I[ -------------------------//
						nest = 0;
						pBfr = pCur;
						do {
							//----- lXgJE^ݒ -------------------//
							if		(pCur->tkn == EAJCTK_DLM_LSPART) {
								nest++;
							}
							else if (pCur->tkn == EAJCTK_DLM_RSPART) {
								nest--;
							}
							//----- ̃g[Nݒ ---------------------//
							pBfr = pCur;
							pCur = pCur->pNxt;
						} while (pCur != NULL && 
								 !(nest == 0  && ((!fVaArg && pCur->tkn == EAJCTK_DLM_COMMA) || pCur->tkn == EAJCTK_DLM_RSPART)));
						//----- g[NXg̏I[ݒ -----------//
						if (pBfr != NULL) {
							pBfr->pNxt = NULL;
						}
						//----- Xgݒ -------------------------//
						if (nValArg < pMac->nTmpArg) {		//	̌͈͓H
							pALArr[nValArg].pRelArg = pALTkn;
						}
						else {								//	I[o[
							PpcRelTokenStream(pW, pALTkn);
						}
					}
					else {	// H
						// g[N|C^=NULL
					}
					//----- LȈ̌XV -------------------------//
					nValArg++;
					//----- J}(,)XLbv ----------------------------//
					if (pCur != NULL && pCur->tkn == EAJCTK_DLM_COMMA) {
						pCur = PpcRelCurAndGetNextToken(pW, pCur);
						//----- J}̒オEʂȂ΁ALȈiǰXV --//
						if (pCur != NULL && pCur->tkn == EAJCTK_DLM_RSPART) {
							nValArg++;
						}
					}
				}
				//----- EʃXLbv -----------------------------------//
				if (pCur != NULL && pCur->tkn == EAJCTK_DLM_RSPART) {
					//	Eʂ̃tOޔ
					flg = pCur->flg;
					//	EʃXLbv
					pCur = PpcRelCurAndGetNextToken(pW, pCur);
				}
			}
		}
		//----- }NQƕ̎̃g[NAhXݒ -------------------//
		pSvNxt = pCur;

		//----- ̌G[`FbN -------------------------------//
		if (pMac->fVaArgs) {		//	ό(...)H
			if (nValArg < pMac->nTmpArg - 1) {
				PPC_ERR(AJCPPC_MACERR_ARG_LACK, pFile, lno, pMacName);
			}
		}
		else {						//	ό(...)ȂH
			if (nValArg != pMac->nTmpArg) {
				if (nValArg < pMac->nTmpArg) {
					PPC_ERR(AJCPPC_MACERR_ARG_LACK, pFile, lno, pMacName);
				}
				else {
					PPC_ERR(AJCPPC_MACERR_ARG_OVER, pFile, lno, pMacName);
				}
			}
		}

		//----------------------------------------------------------------------------------------------------------//
		//	}NWJ																								//
		//----------------------------------------------------------------------------------------------------------//
		pExp = NULL;
		if ((pBdy = pMac->pTknBody) != NULL) {
			while (pBdy != NULL) {
				if (pW->fStop) break;	//	~
				if (AJCTKIS_SYMBOL(pBdy->tkn)) {									//	V{
					//----- g[N -------------------//
					if ((i = SrhTmpArg(pW, pBdy->pSyl, pALArr, nTmpArg)) != -1) {	//		ƈvH
						if (pALArr[i].pRelArg != NULL) {							//			LH
							//----- Rs[ ---------//
							pArg = pALArr[i].pRelArg;
							while (pArg != NULL) {
								if (pW->fStop) break;	//	~
								lno = __max(lno, pArg->lno);
								if (pExpTop == NULL) pExp = pExpTop = PpcTknAlloc(pW);
								else				 pExp = PpcAllocAndLinkNextToken(pW, pExp);
								if (pExp != NULL) {
									pExp->pFile  = pFile;
									pExp->lno	 = lno;
									pExp->pSyl	 = pArg->pSyl;
									pExp->tkn	 = pArg->tkn;
									pExp->kndPP  = AJCPPC_PPK_TOKEN;
									pExp->pos	 = pos;
									pExp->ppIf	 = 0;
									pExp->flg	 = pArg->flg;
									pExp->inst	 = inst;
									pExp->incf	 = incf;
									pExp->mexp	 = mexp;
									pArg = pArg->pNxt;
								}
								else {
									pW->fStop = TRUE;
								}
							}
						}
					}
					else {															//		ȊOH
						//----- {fBg[NRs[ -----//
						if (pExpTop == NULL) pExp = pExpTop = PpcTknAlloc(pW);
						else				 pExp = PpcAllocAndLinkNextToken(pW, pExp);
						if (pExp != NULL) {
							pExp->pFile  = pFile;
							pExp->lno	 = lno;
							pExp->pSyl	 = pBdy->pSyl;
							pExp->tkn	 = pBdy->tkn;
							pExp->kndPP  = AJCPPC_PPK_TOKEN;
							pExp->pos	 = pos;
							pExp->ppIf	 = 0;
							pExp->flg	 = (pBdy->flg & (AJCTKF_NXTSPC | AJCTKF_WIDECHAR));
							pExp->inst	 = inst;
							pExp->incf	 = incf;
							pExp->mexp	 = mexp;
						}
						else pW->fStop = TRUE;
					}
				}
				else if (pBdy->tkn == EAJCTK_DLM_SHARP 	&&							// '#'					&&
						 pBdy->pNxt != NULL				&&							//	̃g[NL	&&
						(i = SrhTmpArg(pW, pBdy->pNxt->pSyl, pALArr, nTmpArg)) != -1) {	//	̃g[N͉
					//----- '#' XLbv -------------------//
					pBdy = pBdy->pNxt;
					//----- g[N -------------//
					pArg = pArg = pALArr[i].pRelArg;
					if (pArg != NULL) {	// H
						lno  = __max(lno, pArg->lno);
						//	񒷎Zo
						stl = 0;
						pArg = pALArr[i].pRelArg;
						while (pArg != NULL) {
							stl += (UI)strlen(pArg->pSyl);
							pArg = pArg->pNxt;
						}
						//	񐶐
						pStr = PpcMemAlloc(pW, stl + 3);
						if (pStr != NULL) {
							strcpy(pStr, "\"");
							pArg = pALArr[i].pRelArg;
							while (pArg != NULL) {
								strcat(pStr, pArg->pSyl);
								pArg = pArg->pNxt;
							}
							strcat(pStr, "\"");
						}
						else pW->fStop = TRUE;
					}
					else {				//	ȂH
						pStr = PpcMemAlloc(pW, 3);
						if (pStr != NULL) {
							strcpy(pStr, "\"\"");
						}
						else pW->fStop = TRUE;
					}
					//	g[N
					pArg = pALArr[i].pRelArg;
					if (pExpTop == NULL) pExp = pExpTop = PpcTknAlloc(pW);
					else				 pExp = PpcAllocAndLinkNextToken(pW, pExp);
					if (pExp != NULL && pStr != NULL) {
						pExp->pFile  = pFile;
						pExp->lno	 = lno;
						pExp->pSyl	 = PpcNStrRegist(pW, pStr);
						if (pExp->pSyl == NULL) {pW->fStop = TRUE; break;}
						pExp->tkn	 = EAJCTK_STR_QUOTE;
						pExp->kndPP  = AJCPPC_PPK_TOKEN;
						pExp->pos	 = pos;
						pExp->ppIf	 = 0;
						pExp->flg	 = 0;
						pExp->inst	 = inst;
						pExp->incf	 = incf;
						pExp->mexp	 = mexp;
					}
					else pW->fStop = TRUE;
					//	
					PpcMemFree(pW, pStr);
				}
				else if (pBdy->tkn == EAJCTK_DLM_SHARP2	&&							//	'##'				&&
						 pBdy->pNxt != NULL) {										//	̃g[NL
					//----- '##' XLbv ------------------//
					pBdy = pBdy->pNxt;
					if ((i = SrhTmpArg(pW, pBdy->pSyl, pALArr, nTmpArg)) != -1) {	//		H
						//----- g[NA -------------//
						//	啶񒷎Zo
						pArg = pALArr[i].pRelArg;
						if (pArg != NULL) {	//	H
							stl = (UI)strlen(pExp->pSyl) + (UI)strlen(pArg->pSyl);
							//	VȌ啶񐶐
							pStr = PpcMemAlloc(pW, stl + 1);
							if (pStr != NULL) {
								strcpy(pStr, pExp->pSyl);
								strcat(pStr, pArg->pSyl);
								pExp->pSyl = PpcNStrRegist(pW, pStr);
								if (pExp->pSyl == NULL) {pW->fStop = TRUE; break;}
								//	㑱̎
								pArg = pArg->pNxt;
								while (pArg != NULL) {
									if (pW->fStop) break;	//	~
									if (pExpTop == NULL) pExp = pExpTop = PpcTknAlloc(pW);
									else				 pExp = PpcAllocAndLinkNextToken(pW, pExp);
									if (pExp != NULL) {
										pExp->pFile  = pFile;
										pExp->lno	 = lno;
										pExp->pSyl	 = pArg->pSyl;
										pExp->tkn	 = pArg->tkn;
										pExp->kndPP  = AJCPPC_PPK_TOKEN;
										pExp->pos	 = pos;
										pExp->ppIf	 = 0;
										pExp->flg	 = pArg->flg;
										pExp->inst	 = inst;
										pExp->incf	 = incf;
										pExp->mexp	 = mexp;
									}
									else pW->fStop = TRUE;
								}
								//	啶
								PpcMemFree(pW, pStr);
							}
							else pW->fStop = TRUE;
						}
					}
					else {															//		ȊOH
						//	啶񒷎Zo
						stl = (UI)strlen(pExp->pSyl) + (UI)strlen(pBdy->pSyl);
						//	VȌ啶񐶐
						pStr = PpcMemAlloc(pW, stl + 1);
						if (pStr != NULL) {
							strcpy(pStr, pExp->pSyl);
							strcat(pStr, pBdy->pSyl);
							pExp->pSyl = PpcNStrRegist(pW, pStr);
							if (pExp->pSyl == NULL) {pW->fStop = TRUE; break;}
							pExp->mexp = mexp;
							//	啶
							PpcMemFree(pW, pStr);
						}
						else pW->fStop = TRUE;
					}
				}
				else if (pBdy->tkn == EAJCTK_DLM_COMMA 	&&						//	J}(,) 						&&
						 pMac->fVaArgs 					&&						//	ό(...)t}N			&&
						 pBdy->pNxt != NULL 			&&						//	̃g[NL					&&
						 mbscmp(pBdy->pNxt->pSyl, SYL_VA_ARGS) == 0 &&			//	̃g[Ńu__VA_ARGS__v	&&
						 nValArg < pMac->nTmpArg) {								//	̌̌iw薳j
					//----- J}XLbv ---------------//
					pBdy = pBdy->pNxt;
				}
				else {															//	̑
					//----- {fBg[NRs[ ---------//
					if (pExpTop == NULL) pExp = pExpTop = PpcTknAlloc(pW);
					else				 pExp = PpcAllocAndLinkNextToken(pW, pExp);
					if (pExp != NULL) {
						pExp->pFile  = pFile;
						pExp->lno	 = lno;
						pExp->pSyl	 = pBdy->pSyl;
						pExp->tkn	 = pBdy->tkn;
						pExp->kndPP  = AJCPPC_PPK_TOKEN;
						pExp->pos	 = pos;
						pExp->ppIf	 = 0;
						pExp->flg	 = (pBdy->flg & (AJCTKF_NXTSPC | AJCTKF_WIDECHAR));
						pExp->inst	 = inst;
						pExp->incf	 = incf;
						pExp->mexp	 = mexp;
					}
					else pW->fStop = TRUE;
				}
				//----- ̃}N{fB|C^ݒ -------------//
				if (pBdy != NULL) {
					pBdy = pBdy->pNxt;
				}
			}
		}

		//----- }NWJ̃}N ----------------------//
		if (!pW->fStop) {
			VOP				pNaMac 	 = NULL;
			PAJCPPCTKNNODE	pNaExp	 = pExpTop;
			PAJCPPCTKNNODE	*ppNaBfr = &pExpTop;

			//	}NWJ
			//
			//	i}NWJ̃}N̈}NłꍇÄ}NɓWJKviubΉjj
			//
			while (pNaExp != NULL) {
				pNaMac = NULL;
				while (pNaExp != NULL && !(AJCTKIS_SYMBOL(pNaExp->tkn) && (pNaMac = PpcMacGetNode(pW, pNaExp->pSyl)) != NULL)) {
					ppNaBfr = &(pNaExp->pNxt);
					pNaExp	=	pNaExp->pNxt;
				}
				if (pNaExp != NULL && pNaMac != NULL) {
					//	t}NŁÃg[N '(' ȊOȂ΁AWJȂi֐}ŇĂяoł͂Ȃj
					if (((PPPCMACNODE)pNaMac)->fWithArg && (pNaExp->pNxt == NULL || pNaExp->pNxt->tkn != EAJCTK_DLM_LSPART)) {
						//	̃g[NXLbv
						ppNaBfr = &(pNaExp->pNxt);
						pNaExp	=	pNaExp->pNxt;
					}
					//	}NÃg[N '(' ȂΓWJ
					else {
						if (pNaExp->mexp < PPCMAX_MEXP_NEST) {
							if (((PPPCMACNODE)pNaMac)->fWithArg) {
								pNaExp = MacExpWithArg(pW, ppNaBfr, pNaExp, (PPPCMACARGS)pNaMac);
							}
							else {
								pNaExp = MacExpNoArg  (pW, ppNaBfr, pNaExp, (PPPCMACNODE)pNaMac);
							}
						}
						else {
							//	}NWJlXgI[o[
							PPC_ERR(AJCPPC_MACERR_NEST_OVER, (UX)pNaExp->pFile, (UX)pNaExp->lno, (UX)(((PPPCMACNODE)pNaMac)->pMacName));
							//	̃}NXLbviWJȂj
							ppNaBfr = &(pNaExp->pNxt);
							pNaExp	=	pNaExp->pNxt;
						}
					}
				}
			}
		}
		//----- }NWJ̑OA -------------//
		if (pExpTop != NULL) {				//	}NWJLH
			//	擪A
			*ppBfr	   = pExpTop;
			//	defined
			PpcDefExp(pW, ppBfr, *ppBfr);
			//	g[Nݒ
			pExp = pExpTop;
			while(pExp != NULL && pExp->pNxt != NULL) {
				pExp = pExp->pNxt;
			}
			//	A
			pExp->pNxt = pSvNxt;
			//	g[N̎̋󔒗LtOݒi}NQƂ̃g[NƓɂj
			pExp->flg |= (flg & AJCTKF_NXTSPC);
		}
		else {								//	}NWJȂH
			*ppBfr	= pSvNxt;
			pExpTop = pSvNxt;
		}
		//----------------------------------------------------------------------------------------------------------//
		//	Xg																							//
		//----------------------------------------------------------------------------------------------------------//
		for (i = 0; i < pMac->nTmpArg; i++) {
			PpcRelTokenStream(pW, pALArr[i].pRelArg);
		}
		PpcMemFree(pW, pALArr);
	}
	else pW->fStop = TRUE;

	return pExpTop;
}
//----- `FbN -----------------------------------------------------------------------------------------//
static	int		SrhTmpArg(HAJCPPC pW, C_BCP pSyl, PCMEW_LIST pArr, int n)
{
	int		rc = -1;
	int		i;

	for (i = 0; i < n; i++) {
		if (mbscmp(pArr[i].pTmpArg, pSyl) == 0) {
			rc = i;
			break;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	}N̓WJ																						//
//																												//
//	@	F	ppBfr - Õg[N猻g[Ni}Njւ̃|C^̃AhX							//
//				pTkn  - g[Ni}Nj̃AhX														//
//				pMac  - }N{fB`m[h̃AhX														//
//																												//
//	߂l	F	NULL : }NWJg[NiWJ`̐擪m[hAhXj									//
//				NULL : }NWJg[NȂ																	//
//--------------------------------------------------------------------------------------------------------------//
static PAJCPPCTKNNODE MacExpNoArg  (HAJCPPC pW, PAJCPPCTKNNODE *ppBfr, PAJCPPCTKNNODE pTkn, PPPCMACNODE pMac)
{
	PAJCPPCTKNNODE	pBdy	= pMac->pTknBody;
	PAJCPPCTKNNODE	pExp	= NULL;
	PAJCPPCTKNNODE	pExpTop = NULL;
	PAJCPPCTKNNODE	pSvNxt	= NULL;
	UB				mexp	= pTkn->mexp + 1;	//	}NWJlXgx
	UB				flg 	= 0;

	//----- }NQƃg[ÑtOޔ -------------------//
	if (*ppBfr != NULL) flg = (*ppBfr)->flg;
	//----- }NQƂ̎g[NAhXޔ ---------------//
	pSvNxt = pTkn->pNxt;
	//----- }N{fBEg[N} ---------------------//
	while (pBdy != NULL) {
		if (pExp == NULL) pExp = pExpTop = PpcTknAlloc(pW);
		else			  pExp = PpcAllocAndLinkNextToken(pW, pExp);
		if (pExp != NULL) {
			//----- {fBEg[NRs[ ----//
			pExp->pNxt	 = NULL;
			pExp->pFile  = pTkn->pFile;
			pExp->lno	 = pTkn->lno;
			pExp->pSyl	 = pBdy->pSyl;
			pExp->tkn	 = pBdy->tkn;
			pExp->kndPP  = AJCPPC_PPK_TOKEN;
			pExp->pos	 = pTkn->pos;
			pExp->ppIf	 = 0;
			pExp->flg	 = (pBdy->flg & (AJCTKF_NXTSPC | AJCTKF_WIDECHAR));
			pExp->inst	 = pTkn->inst;
			pExp->incf	 = pTkn->incf;
			pExp->mexp	 = mexp;
		}
		else pW->fStop = TRUE;
		//----- ̃{fBEg[N ------//
		pBdy = pBdy->pNxt;
	}

	//----- }NWJ̑OA --------//
	if (pExp != NULL) {				//	}NWJLH
		//	擪A
		*ppBfr	   = pExpTop;
		//	defined
		PpcDefExp(pW, ppBfr, *ppBfr);
		//	g[Nݒ
		pExp = pExpTop;
		while(pExp != NULL && pExp->pNxt != NULL) {
			pExp = pExp->pNxt;
		}
		//	A
		pExp->pNxt = pSvNxt;
		//	g[N̎̋󔒗LtOݒi}NQƂ̃g[NƓɂj
		pExp->flg |= (flg & AJCTKF_NXTSPC);
	}
	else {							//	}NWJȂH
		*ppBfr	= pSvNxt;
		pExpTop = pSvNxt;
	}

	//----- }NQƃg[Nm[h폜 ---------------------//
	PpcTknFree(pW, pTkn);

	return pExpTop;
}
//--------------------------------------------------------------------------------------------------------------//
//	Ԃ\񐶐																						//
//																												//
//	@	F	 		- Ԃ̒l																				//
//																												//
//	߂l	F	TRUE : 																						//
//				FALSE: WJG[																			//
//--------------------------------------------------------------------------------------------------------------//
static	BCP		NumStr(HAJCPPC pW, int n)
{
	static	BC		txt[32];

	if (AjcGetLangId() == AJCLID_JPN) {
		AjcSnPrintFA(txt, AJCTSIZE(txt), "%dԖ", n);
	}
	else {
		switch (n) {
			case 1:		strcpy(txt, "1st");	break;
			case 2:		strcpy(txt, "2nd");	break;
			case 3:		strcpy(txt, "3rd");	break;
			default:	AjcSnPrintFA(txt, AJCTSIZE(txt), "%dth", n); break;
		}
	}
	return txt;
}
