//
//	AjcPpMain.c - 吧
//
#include	"AjcInternal.h"
#include	"AjcPp.h"
#include	<time.h>


//--------------------------------------------------------------------------------------------------------------//
//	o^IuWFNg																							//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	PAJCPPCTKNNODE	pTknGen;				//	g[NXg[ij
	PAJCPPCTKNNODE	pTknNoGen;				//	g[NXg[i񐶐CuAJCPPC_FLG_GENALLvw莞ɍ쐬
} TKNSTREAMS, *PTKNSTREAMS;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO				RegistAnsiMacro			(HAJCPPC pW);
static	PAJCPPCTKNNODE	GetTokenOrPreProStream	(HAJCPPC pW, HAJCTK hCtk, C_BCP pFilePath, EAJCTKCODE *pfPpTkn, UIP pNum);
static	VO				GenerateToken			(HAJCPPC pW);
static	PAJCPPCTKNNODE	GenPreProNode			(HAJCPPC pW, PAJCPPCTKNNODE pTop, UI knd);
static	PAJCPPCTKNNODE	GenDefineNode			(HAJCPPC pW, PAJCPPCTKNNODE pTop);

static	VO				PrePro_define			(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);
static	VO				PrePro_undef			(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);
static	UB				PrePro_include			(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);
static	BOOL			PrePro_ifdef			(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);
static	BOOL			PrePro_ifndef			(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);
static	BOOL			PrePro_if				(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);
static	BOOL			PrePro_elif				(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);
static	BOOL			PrePro_else				(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);
static	UI				PrePro_endif			(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);
static	VO				PrePro_others			(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num);

static	VO				Generate_InIf			(HAJCPPC pW);
static	VO				Generate_InElse			(HAJCPPC pW);
static	VO				SkipTo_elif_else_endif	(HAJCPPC pW);
static	VO				SkipTo_endif			(HAJCPPC pW);

static	BOOL CALLBACK 	cbCtkOptSym				(BCP pBuf, UI lBuf, UX xp);
static	BOOL CALLBACK 	cbCtkFile  				(BCP pBuf, UI lBuf, UX xp);

static	BOOL			SearchIncFile			(HAJCPPC pW, C_BCP fname, BCP path, int len);
static	BOOL CALLBACK 	cbASearchIncFile		(UI nest, BCP pPath, BCP pName, UI attrib, UI wtime, UX cbp);

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pBasePath		- #includẽx[XpX	isvNULL)									//
//				pIncPath		- #includepXQ			isvNULL)									//
//				pOptSym			- IvVEV{Q		isvNULL)									//
//				cbp				- R[obNp^															//
//				cbNtc			- CxgʒmpR[obN֐isvNULL)									//
//				cbErr	  	 	- G[ʒmpR[obN֐	isvNULL)									//
//																												//
//	߂l	F	NULL : iCX^Xnhj															//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	HAJCPPC		WINAPI	AjcPpcCreate(	C_BCP 		 pBasePath,
												PAJCLBXITEMA pIncPath,
												PAJCLBXITEMA pOptSym,
												UX			 cbp,
												VO (CALLBACK *cbNtc)(AJCPPCNOTIFY ntc, UX p1, UX p2, UX p3, UX cbp),
												VO (CALLBACK *cbErr)(AJCPPCERROR  err, UX p1, UX p2, UX p3, UX cbp))
{
	HAJCPPC		pW = NULL;
	BOOL		fErr = FALSE;
	BC			relp[MAX_PATH * 2];

	if (pW = AJCMEM(sizeof(AJCPPC))) {
		memset(pW, 0, sizeof(AJCPPC));
		do {
			//----- CX^Xhcݒ ------------------------------------------//
			pW->InstID = INST_ID_PP;
			//----- R[obNݒ ----------------------------------------------//
			pW->cbp   = cbp;
			pW->cbNtc = cbNtc;
			pW->cbErr = cbErr;
			//----- Ǘpnh --------------------------------------------//
			if (PpcIStrInit(pW) == NULL) {fErr = TRUE; break;}		//	v[i召ʂȂj
			if (PpcNStrInit(pW) == NULL) {fErr = TRUE; break;}		//	v[i召ʂj
			//----- IvVtOݒ ------------------------------------------//
			pW->OptFlag  = AJCPPC_FLG_AUTO_SEARCH | AJCPPC_FLG_ONCE;
			//----- eLXgt@CGR[hݒ --------------------------------//
			pW->InpTec = AJCTEC_MBC;
			pW->OutTec = AJCTEC_MBC;
			pW->fBOM   = FALSE;
			pW->InpActTec = (EAJCTEC)-1;
			pW->InpActBOM = 		 -1;
			//----- Includet@Cpx[XpXݒ ---------------------------//
			if (pBasePath != NULL && *pBasePath != 0)	{
				//	΃pX̏ꍇ́AJgfBNg̑΂Ƃ
				if (PathIsRelativeA(pBasePath)) {
					GetCurrentDirectoryA(AJCTSIZE(relp), relp);
					AjcPathCatA		    (relp, pBasePath, AJCTSIZE(relp));
					PathCanonicalizeA(pW->BasePath, relp);
				}
				//	΃pX̏ꍇ́ApX𐳋K
				else {
					PathCanonicalizeA(pW->BasePath, pBasePath);
				}
			}
			//----- CN[hpXQޔiRs[j-------------------------------//
			if (pIncPath != NULL) {
				PAJCLBXITEMA	p = pIncPath;
				PAJCLBXITEMA	q = NULL;
				UI				n = 0;
				UI				lTxt;

				while (p->pStr != NULL) {
					n++;
					p++;
				}
				if (pW->pIncArr = AJCMEM(sizeof(AJCLBXITEMA) * (n + 1))) {
					memset(pW->pIncArr, 0, sizeof(AJCLBXITEMA) * (n + 1));
					p = pIncPath;
					q = pW->pIncArr;
					while (p->pStr != NULL) {
						lTxt = (UI)strlen(p->pStr);
						if (q->pStr = AjcTAllocA(lTxt + 1)) {
							strcpy(q->pStr, p->pStr);
							q->data = p->data;
						}
						else {
							fErr = TRUE;
							goto apca_exit;
						}
						p++;
						q++;
					}
				}
			}
			//----- IvVV{QޔiRs[j-----------------------------//
			if (pOptSym != NULL) {
				PAJCLBXITEMA	p = pOptSym;
				PAJCLBXITEMA	q = NULL;
				UI				n = 0;
				UI				lTxt;

				while (p->pStr != NULL) {
					n++;
					p++;
				}
				if (pW->pOptArr = AJCMEM(sizeof(AJCLBXITEMA) * (n + 1))) {
					memset(pW->pOptArr, 0, sizeof(AJCLBXITEMA) * (n + 1));
					p = pOptSym;
					q = pW->pOptArr;
					while (p->pStr != NULL) {
						lTxt = (UI)strlen(p->pStr);
						if (q->pStr = AjcTAllocA(lTxt + 1)) {
							strcpy(q->pStr, p->pStr);
						}
						else {
							fErr = TRUE;
							goto apca_exit;
						}
						p++;
						q++;
					}
				}
			}
		} while(0);

apca_exit:;

		//----- G[Ȃ΃\[X ------------------------------------------//
		if (fErr) {
			AjcPpcDelete(pW);
			pW = NULL;
		}
	}

	return pW;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcPpcDelete	(HAJCPPC pW)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		//	RpCIuWFNg 
		AjcPpcReleaseObject(pW);

		//	Ǘpnh
		PpcIStrEnd(pW);
		PpcNStrEnd(pW);
		PpcMacEnd (pW);
		PpcIncEnd (pW);
		//	CN[hpXQ
		if (pW->pIncArr != NULL) {
			PAJCLBXITEMA	p = pW->pIncArr;
			while (p->pStr != NULL) {
				free(p->pStr);
				p++;
			}
			free(pW->pIncArr);
		}
		//	IvVV{Q
		if (pW->pOptArr != NULL) {
			PAJCLBXITEMA	p = pW->pOptArr;
			while (p->pStr != NULL) {
				free(p->pStr);
				p++;
			}
			free(pW->pOptArr);
		}
		//	CX^X[N
		free(pW);
		//	߂lnj
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	IvVtOݒ																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//				flag		- IvVtO(AJCPPC_FLG_XXXXX)												//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcPpcSetOption(HAJCPPC pW, UI opt)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		pW->OptFlag = opt;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	IvVtO擾																						//
//																												//
//	@	F	pW			- CX^Xnh																//
//																												//
//	߂l	F	IvVtO(AJCPPC_FLG_XXXXX)																//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcPpcGetOption(HAJCPPC pW)
{
	UI		rc = AJCPPC_FLG_NONE;
	if (IS_PP_INST(pW)) {
		rc = pW->OptFlag;
	}
	return rc;
}
//==============================================================================================================//
//	vvZXERpC																					//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pSrcPath	- \[XvOpX																//
//																												//
//	߂l	F	AJCPPCR_OK : nj																				//
//				AJCPPCR_OK : g[NP^G[														//
//==============================================================================================================//
AJCEXPORT	AJCPPCRESULT	WINAPI	AjcPpcCompile(	HAJCPPC pW, C_BCP pSrcPath)
{
	AJCPPCRESULT	rc	= AJCPPCR_PARAM;
	PAJCPPCINCNEST	pTi = NULL;
	EAJCTKCODE		tkn;
	PAJCPPCTKNNODE	pTop;
	BCP				pObjPath = NULL;
	UI				num;
	BOOL			fNoFile = FALSE;
	BC				fname[_MAX_FNAME], fext[_MAX_EXT];
	BC				SrcPath[MAX_PATH];
	BC				relp[MAX_PATH * 2];

	if (IS_PP_INST(pW)) {
		if (pSrcPath != NULL && *pSrcPath != 0 ) {
			do {
				//	ÕvRpCIuWFNg
				AjcPpcReleaseObject(pW);

				//	[N
				pTi						= &pW->TblInc[0];
				pW->incf				= AJCPPC_INCF_NO;
				pW->IxInc				= 0;
				memset(&pW->TblInc, 0, sizeof pW->TblInc);

				pW->pOptSymText			= NULL;		//	IvVV{ւ̃|C^
				pW->pTknTop 			= NULL;		//	擪g[Nm[hAhX
				pW->pTknLas 			= NULL;		//	ŏIg[Nm[hAhX
				pW->ppMacBfr 			= NULL;		//	}NWJσg[Nm[h|C^̃AhX
				pW->pNoGTop				= NULL;		//	擪g[Nm[hAhXi񐶐̃g[Nj
				pW->pNoGLas				= NULL;		//	ŏIg[Nm[hAhXi񐶐̃g[Nj
				pW->fMemErr				= FALSE;	//	G[tO
				pW->fStop				= FALSE;	//	͒~tO
				pW->pSrhPath			= NULL;		//	t@CpX

				//	#if`#endiflXg񏉊
				pTi->IxIF = 0;
				memset(pTi->TblIF, 0, sizeof pTi->TblIF);
				pTi->TblIF[0].knd = AJCPPC_IFK_NONE;
				pTi->TblIF[0].act = AJCPPC_IFA_GEN_NORMAL;

				//	Ǘpnh
				if (PpcMacInit (pW) == NULL) break;			//	}N`
				if (PpcIncInit (pW) == NULL) break;			//	CN[h
				//	\[Xt@CpXݒ
				//	΃pX̏ꍇ́Ax[XpX̑΂Ƃ
				if (PathIsRelativeA(pSrcPath)) {
					AjcSnPrintFA(relp, AJCTSIZE(relp), "%s", pW->BasePath);
					AjcPathCatA (relp, pSrcPath, AJCTSIZE(relp));
					PathCanonicalizeA(SrcPath, relp);
				}
				//	΃pX̏ꍇ́ApX𐳋K
				else {
					PathCanonicalizeA(SrcPath, pSrcPath);
				}
				//	\[Xt@CEI[v	
				if ((pTi->fh = AjcFOpenA(SrcPath, pW->InpTec)) == NULL) {
					fNoFile = TRUE;
					PPC_ERR(AJCPPC_ERROR_SRC_OPEN, SrcPath, 0, 0);
					break;
				}
				//	\[Xt@C̎ۂ̃GR[hCanlݒ
				pW->InpActTec = AjcFGetTec(pTi->fh);
				pW->InpActBOM = AjcFGetBOM(pTi->fh);
				//	\[Xt@C̃GR[hʒm
				PPC_NTC(AJCPPC_NTC_SRCTEC, SrcPath, pW->InpActTec, pW->InpActBOM);
				//	啪CX^X
				pTi->hCtk = PpcCtkCreate(pW, cbCtkFile);
				if (pTi->hCtk == NULL) {pW->fStop = TRUE; break;}
				//	#includelXge[ui擪GgɃ\[Xt@Cݒj
				pTi->pPath = PpcIStrRegist(pW, SrcPath);
				if (pTi->pPath == NULL) {pW->fStop = TRUE; break;}
				_splitpath(SrcPath	, NULL, NULL, fname, fext);
				_makepath (pTi->file, NULL, NULL, fname, fext);
				pTi->lno = 0;
				//	Öْ`σ}No^
				RegistAnsiMacro(pW);
				//	IvVV{o^
				if (pW->pOptArr != NULL) {
					PAJCLBXITEMA pos = pW->pOptArr;
					HAJCTK		hctk;
					while (pos->pStr != NULL) {
						if (pW->fStop) break;	//	~
						pW->pOptSymText = pos->pStr;
						if (hctk = PpcCtkCreate(pW, cbCtkOptSym)) {
							if (pTop = GetTokenOrPreProStream(pW, hctk, "<OptionSymbol>", &tkn, &num)) {
								if (tkn == EAJCTK_RSV_DEFINE) PrePro_define(pW, hctk, pTop, num);
								else						  PrePro_others(pW, hctk, pTop, num);
							}
							AjcCtkDelete(hctk);
						}
						else pW->fStop = TRUE;
						pos++;
					}
				}
				if (pW->fStop) break;

				//	g[NXg[
				GenerateToken(pW);

			} while(0);
		}

		//	ct@CC\[X
		while (pW->IxInc >= 0) {
			pTi = &pW->TblInc[pW->IxInc];
			if (pTi->fh != NULL) {
				AjcFClose(pTi->fh);
				pTi->fh = NULL;
			}
			if (pTi->hCtk != NULL) {
				AjcCtkDelete(pTi->hCtk);
				pTi->hCtk = NULL;
			}
			pW->IxInc--;
		}

		//	߂lݒ
		if		(fNoFile			) rc = AJCPPCR_NOFILE;
		else if (pW->fMemErr		) rc = AJCPPCR_MEMERR;
		else if (pW->fStop			) rc = AJCPPCR_STOP;
		else if (pW->pTknTop == NULL) rc = AJCPPCR_NOTOKEN;
		else						  rc = AJCPPCR_OK;
	}
	return rc;
}
//==============================================================================================================//
//	vRpCσIuWFNg̎擾																			//
//																												//
//	@	ppNoGen	- 񐶐̃g[NXg[̐擪AhXi[obt@̃AhXisvNULLj	//
//																												//
//	߂l	F	NULL : ̃g[NXg[̐擪AhX												//
//				NULL : g[NP^G[															//
//==============================================================================================================//
AJCEXPORT	PAJCPPCTKNNODE	WINAPI	AjcPpcGetObject			(HAJCPPC pW, PAJCPPCTKNNODE *ppNoGen)
{
	PAJCPPCTKNNODE	rc = NULL;

	if (IS_PP_INST(pW)) {
		if (ppNoGen != NULL) *ppNoGen = pW->pNoGTop;
		rc = pW->pTknTop;
	}
	return rc;
}
//==============================================================================================================//
//	vRpCσIuWFNg̉																			//
//																												//
//	@		Ȃ																							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL			WINAPI	AjcPpcReleaseObject		(HAJCPPC pW)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		//	̃g[NXg[
		if (pW->pTknTop != NULL) {PpcRelTokenStream(pW, pW->pTknTop); pW->pTknTop = pW->pTknLas = NULL;}
		//	񐶐̃g[NXg[
		if (pW->pNoGTop != NULL) {PpcRelTokenStream(pW, pW->pNoGTop); pW->pNoGTop = pW->pNoGLas = NULL;}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	}N̗																								//
//																												//
//	@		cbp			 - R[obNp^																//
//				cbNtcMacName - }NʒmpR[obN֐isvNULL)									//
//																												//
//	߂l	F	}Ň																					//
//==============================================================================================================//
typedef struct {
	UX			cbp;
	BOOL (CALLBACK *cb)(PCAJCPPCMACINFO pMacInfo, UX cbp);
} CBP_ENUM_MACRO, *PCBP_ENUM_MACRO;
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CALLBACK cbPpcEnumMacro(UX key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	BOOL			rc 		 = TRUE;
	PCBP_ENUM_MACRO	p		 = (PCBP_ENUM_MACRO)cbp;
	PPPCMACARGS		pMacNode = (PPPCMACARGS)pNodeData;
	AJCPPCMACINFO	mi;

	if (p->cb != NULL) {
		memset(&mi, 0, sizeof mi);
		mi.fWithArg		= pMacNode->fWithArg;			//	t}NEtOiFALSE:CTRUE:j
		mi.pMacName		= pMacNode->pMacName;			//	}Nւ̃|C^
		mi.pTknName		= pMacNode->pTknName;			//	}NEg[Nm[hւ̃|C^
		mi.pTknBody		= pMacNode->pTknBody;			//	}N{fBEg[Nm[hւ̃|C^
		mi.pos			= pMacNode->pos;				//	擪u#v̌ʒu
		if (pMacNode->fWithArg) {						//	t}NH
			mi.fVaArgs		= pMacNode->fVaArgs;		//		ό}NtO
			mi.nTmpArg		= pMacNode->nTmpArg;		//		̌
			mi.hVQueArg		= pMacNode->hVQueArg;		//		}NXg
		}
		rc = p->cb(&mi, p->cbp);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcPpcEnumMacro	(HAJCPPC pW, UX cbp, BOOL (CALLBACK *cbNtcMacName)(PCAJCPPCMACINFO pMacInfo, UX cbp))
{
	UI				rc = 0;
	CBP_ENUM_MACRO	prm;

	if (IS_PP_INST(pW)) {
		if (pW->hAvlMac != NULL) {
			prm.cbp   = cbp;
			prm.cb	  = cbNtcMacName;
			rc = AjcAvlEnumNodesEx(pW->hAvlMac, (UX)&cbp, cbPpcEnumMacro, FALSE);
		}
	}
	return rc;
}
//==============================================================================================================//
//	}N`̎擾																							//
//																												//
//	@		pMacName	- }N																			//
//				pMacInfo	- }N`i[obt@isvNULL)									//
//																												//
//	߂l	F	TRUE   : nj																					//
//				FALSE  : }NȂ																	//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcPpcGetMacroInfo			(HAJCPPC pW, C_BCP pMacName, PAJCPPCMACINFO pMacInfo)
{
	BOOL			rc		 = FALSE;
	PPPCMACARGS		pMacNode = NULL;

	if (IS_PP_INST(pW)) {
		if (pMacNode = (PPPCMACARGS)PpcMacGetNode(pW, pMacName)) {
			if (pMacInfo != NULL) {
				memset(pMacInfo, 0, sizeof(AJCPPCMACINFO));
				pMacInfo->fWithArg		= pMacNode->fWithArg;			//	t}NEtOiFALSE:CTRUE:j
				pMacInfo->pMacName		= pMacNode->pMacName;			//	}Nւ̃|C^
				pMacInfo->pTknName		= pMacNode->pTknName;			//	}NEg[Nm[hւ̃|C^
				pMacInfo->pTknBody		= pMacNode->pTknBody;			//	}N{fBEg[Nm[hւ̃|C^
				pMacInfo->pos			= pMacNode->pos;				//	擪u#v̌ʒu
				if (pMacNode->fWithArg) {								//	t}NH
					pMacInfo->fVaArgs		= pMacNode->fVaArgs;		//		ό}NtO
					pMacInfo->nTmpArg		= pMacNode->nTmpArg;		//		̌
					pMacInfo->hVQueArg		= pMacNode->hVQueArg;		//		}NXg
				}
			}
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	vRpC~																							//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI		AjcPpcStop(HAJCPPC pW)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		pW->fStop = TRUE;
		rc = TRUE;
	}
	return rc;
}


//==============================================================================================================//
//	g[NXg[̃t@Co																			//
//																												//
//	@	F	pOut	- o̓t@CpX																		//
//				fExpInc	- TRUE : CN[heWJ													//
//						  FALSE: #includê܂܎ciCN[he͓WJȂj					//
//				CommOutOfkndPP - Rgo͂vvZXw肷iAJCPPC_PPK_XXXXXj					//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	̃g[NXg[ƁA񐶐̃g[NXg[}[W										//
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	VO	SubMerge(HAJCPPC pW)
{
	PAJCPPCTKNNODE	pTknCur;					//	  ̃m[h|C^
	PAJCPPCTKNNODE	pTknBfr;					//	 V 	  ̂PÕm[h|C^
	PAJCPPCTKNNODE	pNoGCur;					//	񐶐̃m[h|C^
	PAJCPPCTKNNODE	pNoGBfr;					//	 V 	  ̂PÕm[h|C^
	PAJCPPCTKNNODE	pSvCurNxt, pSvNoGBfr;
	UI				seq;

	//	Gg\ifobOpj
	#ifdef _DEBUG
//	{	int				i;
//		PAJCPPCTKNNODE	p;
//		AjcTrace("----- TokenEntries ----------------------\n");
//		for (p = pW->pTknTop, i = 0; p != NULL; p = p->pNxt, i++);
//		AjcTrace("Tkn : %d entries\n", i);
//		for (p = pW->pNoGTop, i = 0; p != NULL; p = p->pNxt, i++);
//		AjcTrace("NoG : %d entries\n", i);
//	}
	#endif
	//	Gg\ifobOpj
	#ifdef _DEBUG
//	{	int				i;
//		PAJCPPCTKNNODE	p;
//		AjcTrace("----- Generate entries ----------------------\n");
//		for (p = pW->pTknTop, i = 1; p != NULL; p = p->pNxt, i++) {
//			AjcTrace("seq=%4d : ppIf = %04X, syl = '%s'\n", p->seq, p->ppIf, p->pSyl);
//		}
//	}
	#endif
	//	񐶐Gg\ifobOpj
	#ifdef _DEBUG
//	{	int				i;
//		PAJCPPCTKNNODE	p;
//		AjcTrace("----- No generate entries -------------------\n");
//		for (p = pW->pNoGTop, i = 1; p != NULL; p = p->pNxt, i++) {
//			AjcTrace("seq=%4d : ppIf = %04X, syl = '%s'\n", p->seq, p->ppIf, p->pSyl);
//		}
//	}
	#endif

	pTknCur = pW->pTknTop;
	pNoGCur = pW->pNoGTop;
	pTknBfr = pNoGBfr = NULL;

	while (pNoGCur != NULL) {
		//	̖֎c̔񐶐ǉ
		if (pTknCur == NULL) {
			if (pTknBfr == NULL) pW->pTknTop   = pNoGCur;
			else				 pTknBfr->pNxt = pNoGCur;
			pNoGCur = NULL;
		}
		//	̓r֑}
		else {
			//	̂Q̂rdpݒ
			if (pTknCur->pNxt == NULL) seq = 0x7FFFFFFF;
			else					   seq = pTknCur->pNxt->seq;
			//	}ʒuȂ΁A񐶐}
			if (pNoGCur->seq > pTknCur->seq && pNoGCur->seq < seq) {
				//	񐶐̒O|C^ޔ
				pSvNoGBfr = pNoGBfr;
				//	̎̃m[h|C^ޔ
				pSvCurNxt = pTknCur->pNxt;
				//	}ʒu֔񐶐̐擪A
				pTknCur->pNxt = pNoGCur;
				//	}͈͏I[ݒ
				while (pNoGCur != NULL && pNoGCur->seq < seq) {
					pNoGBfr = pNoGCur;
					pNoGCur = pNoGCur->pNxt;
				}
				//	}I[֐̎m[hݒ
				pNoGBfr->pNxt = pSvCurNxt;
				//	̌_|C^ݒ
				pTknBfr = pNoGBfr;
				pTknCur = pTknBfr->pNxt;
				//	}i񐶐j̒O|C^
				pNoGBfr = pSvNoGBfr;
				if (pNoGBfr == NULL) pW->pNoGTop   = pNoGCur;
				else				 pNoGBfr->pNxt = pNoGCur;
			}
			//	}ʒułȂ΁A|C^XV
			else {
				pTknBfr = pTknCur;
				pTknCur = pTknCur->pNxt;
			}
		}
	}
	//	I[|C^ݒ
	pTknCur   = pW->pTknTop;
	while (pTknCur != NULL) {
		pW->pTknLas = pTknCur;
		pTknCur 	= pTknCur->pNxt;
	}
	//	񐶐ݒ
	pW->pNoGLas = pW->pNoGLas = NULL;

	//	}[WGg\ifobOpj
	#ifdef _DEBUG
//	{	int				i;
//		PAJCPPCTKNNODE	p;
//		AjcTrace("----- Marge entries ----------------------\n");
//		for (p = pW->pTknTop, i = 1; p != NULL; p = p->pNxt, i++) {
//			AjcTrace("seq=%4d : ppIf = %04X, syl = '%s'\n", p->seq, p->ppIf, p->pSyl);
//		}
//	}
	#endif

}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	̃g[NXg[ƁA񐶐̃g[NXg[𕪗									//
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	VO	SubSeparate(HAJCPPC pW)
{
	PAJCPPCTKNNODE	pTknCur = pW->pTknTop;
	PAJCPPCTKNNODE	pNoGCur = pW->pNoGTop;
	PAJCPPCTKNNODE	pTknBfr = NULL;
	PAJCPPCTKNNODE	pSvNxt	= NULL;

	pW->pNoGTop = pW->pNoGLas = NULL;

	while (pTknCur != NULL) {
		//	񐶐̃m[ho
		if (pTknCur->ppIf == AJCPPIF_NO_GEN) {
			do {
				//	񐶐m[hO
				if (pTknBfr == NULL) pW->pTknTop   = pTknCur->pNxt;
				else				 pTknBfr->pNxt = pTknCur->pNxt;
				//	m[h|C^ޔ
				pSvNxt = pTknCur->pNxt;
				//	񐶐L[XV
				if (pW->pNoGTop == NULL) {
					pTknCur->pNxt = NULL;
					pW->pNoGTop   = pTknCur;
					pW->pNoGLas   = pTknCur;
				}
				//	񐶐L[2ڈȍ~XV
				else {
					pTknCur->pNxt	  = NULL;
					pW->pNoGLas->pNxt = pTknCur;
					pW->pNoGLas 	  = pTknCur;
				}
				//	m[h|C^ݒ
				pTknCur = pSvNxt;
			} while (pTknCur != NULL && pTknCur->ppIf == AJCPPIF_NO_GEN);
		}
		//	̃m[ho
		else {
			//	|C^XV
			pTknBfr 	= pTknCur;
			pTknCur 	= pTknCur->pNxt;
		}
	}

	//	Gg\ifobOpj
	#ifdef _DEBUG
//	{	int				i;
//		PAJCPPCTKNNODE	p;
//		AjcTrace("----- TokenEntries ----------------------\n");
//		for (p = pW->pTknTop, i = 0; p != NULL; p = p->pNxt, i++);
//		AjcTrace("Tkn : %d entries\n", i);
//		for (p = pW->pNoGTop, i = 0; p != NULL; p = p->pNxt, i++);
//		AjcTrace("NoG : %d entries\n", i);
//	}
	#endif

}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	sói "/* IncNest; MacNest; FileName; LineNo */ " j												//
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	VO	WriteLineTopInfo(HAJCPPC pW, PAJCPPCTKNNODE pCur)
{
	UI		stl;
	BC		fname[_MAX_FNAME], fext[_MAX_EXT];
	BC		name[MAX_PATH];

	_splitpath(pCur->pFile, NULL, NULL, fname, fext);					//	t@C쐬
	_makepath (name 	  , NULL, NULL, fname, fext);					//	E
	stl = (UI)strlen(name);												//	t@Cݒ
	AjcFPrintFA(pW->fhTsoOut, "/*%2d; %2d; %s;%*s %5d; */ ",			//	lXgCt@CCsԍ\
			pCur->inst, pCur->mexp, name, pW->TsoMaxFName - stl, "", pCur->inst == 0 ? pW->TsoNst0Lno : pCur->lno);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	o 	isȂ΁Asɗ]tj																//
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	UI	WriteSyl(HAJCPPC pW, PAJCPPCTKNNODE pCur)
{
	UI		rc = 0;		//	߂lo͌
	UI		i;

	if (pW->fTsoTop) {																				//	sH
		AjcFPrintFA(pW->fhTsoOut, "    ");															//		"    " o
		for (i = 0; i < pCur->pos; i++) {AjcFPrintFA(pW->fhTsoOut, " "); rc++;}						//		擪ʒu
	}
	AjcFPrintFA(pW->fhTsoOut, "%s", pCur->pSyl); rc += (UI)strlen(pCur->pSyl);						//	o
	pW->fTsoTop = FALSE;																			//	usȊOv

	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	Rgo ( sȂ΁As "//" t )															//
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	UI	WriteLineComment(HAJCPPC pW, PAJCPPCTKNNODE pCur)
{
	UI		rc = 0;		//	߂lo͌
	UI		i;

	if (pW->fTsoTop) {																				//	sH
		if (pCur->ppIf == AJCPPIF_NO_GEN) AjcFPrintFA(pW->fhTsoOut, "//- ");						//		"//" o
		else							  AjcFPrintFA(pW->fhTsoOut, "//  ");
		for (i = 0; i < pCur->pos; i++) {AjcFPrintFA(pW->fhTsoOut, " "); rc++;}						//		擪ʒu
	}
	AjcFPrintFA(pW->fhTsoOut, "%s", pCur->pSyl); rc += (UI)strlen(pCur->pSyl);						//	Rgo

	if (pCur->kndPP & (AJCPPC_PPK_ALLIF | AJCPPC_PPK_ELSE)) {										//	#if, #elsif, #ifdef, #ifndef, #else 茋ʕ\
		for (i = rc; i < 32; i++) AjcFPrintFA(pW->fhTsoOut, " ");									//		\ʒu
		if		(pCur->ppIf == AJCPPIF_UNCOND) AjcFPrintFA(pW->fhTsoOut, "  // --> During FALSE cond.");
		else if (pCur->ppIf) 				   AjcFPrintFA(pW->fhTsoOut, "  // --> TRUE");
		else								   AjcFPrintFA(pW->fhTsoOut, "  // --> FALSE");
	}
	else if (pCur->kndPP & AJCPPC_PPK_ENDIF) {														//	#endif ɑΉ #ifdef.#ifndef/#if ̍sԍ\
		if (pCur->lno > pCur->ppIf) {
			for (i = rc; i < 32; i++) AjcFPrintFA(pW->fhTsoOut, " ");								//		\ʒu
			if (pCur->ppIf != 0) AjcFPrintFA(pW->fhTsoOut, "  // --> %d" 			, pCur->lno - pCur->ppIf);
			else				 AjcFPrintFA(pW->fhTsoOut, "  // --> ??? (Before %d)", pCur->lno - 65530 	);
		}
	}

	pW->fTsoTop = FALSE;																			//	usȊOv

	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	}N`o																							//
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	UI	SubMacStreamOut(HAJCPPC pW, PAJCPPCTKNNODE pMacTop, BOOL fExpInc, BOOL fComment)
{
	UI				rc	   = 0;
	PAJCPPCTKNNODE	pCur   = NULL;			//	}N`̐擪g[N
	UI				svLno  = pMacTop->lno;	//	sԍޔ
	UI				col    = 0;				//	ʒu
	UI				MaxCol = 0;				//	ő包ʒu
	UI				stl;

	if (pMacTop != NULL) {
		//	ő包ʒuݒ
		pCur = pMacTop->pNxt;
		while (pCur != NULL && pCur->kndPP == AJCPPC_PPK_DEFCONT && !pW->fStop) {
			stl = (UI)strlen(pCur->pSyl);
			MaxCol = __max(MaxCol, pCur->pos + stl + 2);
			pCur = pCur->pNxt;
		}
		MaxCol = __min(MaxCol, 132);
		//	}Nʃm[h(AJCPPC_PPK_DEFINE)XLbv
		pCur = pMacTop->pNxt;
		//	}N`m[h(AJCPPC_PPK_DEFCONT)o
		while (pCur != NULL && pCur->kndPP == AJCPPC_PPK_DEFCONT && !pW->fStop) {
			//	sԍقȂꍇAs
			if (svLno != pCur->lno) {
				//	so
				if (fComment) {													//	RgH
					for (; col < MaxCol; col++) AjcFPrintFA(pW->fhTsoOut, " ");	//		sʒu
					AjcFPrintFA(pW->fhTsoOut, " \\ //\n");						//		"\ //" ós
				}
				else {															//	RgH
					AjcFPrintFA(pW->fhTsoOut, " \\\n");							//		"\"    ós
				}
				//	CN[hWJ[hȂ΁Aso
				if (fExpInc) {													//	CN[heWJH
					WriteLineTopInfo(pW, pCur);									//		so
				}
				//	lXgO\[X̍sԍݒ
				if (pCur->inst == 0) {											//	lXgOi\[Xt@CjH
					pW->TsoNst0Lno = pCur->lno + 1;								//		lXgOsԍݒ
				}
				col = 0;
				pW->fTsoTop = TRUE;												//	usv
				rc++;															//	o͍sXV
			}
			//	sȂ΁As󔒂ƌo
			if (pW->fTsoTop) {
					if (fComment) col = WriteLineComment(pW, pCur);				//	'//' + 啶óiRgj
					else		  col = WriteSyl		(pW, pCur);				//	啶o		 iRgj
			}
			//	sȊOȂ΁Ao
			else {
				AjcFPrintFA(pW->fhTsoOut, "%s", pCur->pSyl); col += (UI)strlen(pCur->pSyl);
			}
			//	咼̋󔒏o
			if (PpcNeedSpace(pCur)) {
				AjcFPrintFA(pW->fhTsoOut, " "); col++;
			}
			//	sԍޔ
			svLno = pCur->lno;
			//	g[N|C^XV
			pCur = pCur->pNxt;
		}
		//	s
		AjcFPrintFA(pW->fhTsoOut, " \n");
		pW->fTsoTop = TRUE;
		rc++;
	}
	return rc;		//	߂l}N`̍s
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	CN[he WJ̃t@Co																		//
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	VO	SubToFile_ExpInc  (HAJCPPC pW, UI CommOutOfkndPP)
{
	PAJCPPCTKNNODE	pTkn  = pW->pTknTop;
	PAJCPPCTKNNODE	pCur  = pW->pTknTop;
	PAJCPPCTKNNODE	pBfr  = NULL;
	BCP				pFCur = "";
	UI				lno   = 1;
	UI				sv_lno = -1;

	//	lXgO̍sԍi\[Xt@C̍sԍj
	pW->TsoNst0Lno = 1;
	//	ߏo
	AjcFPrintFA(pW->fhTsoOut, "/* \"%s\" */\n", pTkn != NULL ? pTkn->pFile : "");
	AjcFPrintFA(pW->fhTsoOut, "/* Include-Nest; Macro-Nest; SourceFile; LineNumber; */\n");

	//	vRpC\[Xt@Co
	while (pCur != NULL && !pW->fStop) {
		//	Vȍsit@C^sԍقȂjȂ΁As
		if (mbscmp(pCur->pFile, pFCur) != 0  ||  pCur->lno != sv_lno) {					//	t@C^sԍقȂH
			//	sȊOȂΉs
			if (!pW->fTsoTop) {															//		sȊOH
				AjcFPrintFA(pW->fhTsoOut, "\n");										//			s
				pW->fTsoTop = TRUE;														//			s̎|tOZbg
			}
			//	so͂AlXgO\[X̍s킹
			if (pCur->inst == 0) {														//		lXgOi\[Xt@CjH
				while (pW->TsoNst0Lno < pCur->lno) {									//			_~[̉so
					AJCPPCTKNNODE	cur;												//			E
					memcpy(&cur, pCur, sizeof cur);										//			E
					cur.mexp = 0;														//			E
					WriteLineTopInfo(pW, &cur);											//			E
					AjcFPrintFA(pW->fhTsoOut, "\n");									//			E
					pW->TsoNst0Lno++;													//			lXgOi\[Xt@Cj̍sԍXV
				}
			}
			WriteLineTopInfo(pW, pCur);													//		so
			if (pCur->inst == 0) {														//		lXgOi\[Xt@CjH
				pW->TsoNst0Lno = pCur->lno + 1;											//			lXgOsԍݒ
			}
			pW->fTsoTop = TRUE;															//		usv
			pFCur		= pCur->pFile;													//		t@Cޔ
			sv_lno		= pCur->lno;
		}
		//	ʏ̃g[No
		if (pCur->kndPP == AJCPPC_PPK_TOKEN) {											//	ʏ̃g[NH
			if (pW->fTsoTop) {															//		sH
				if (pCur->ppIf != AJCPPIF_NO_GEN) WriteSyl		  (pW, pCur);			//			啶o			  ij
				else					  		  WriteLineComment(pW, pCur);			//			啶sRgói񐶐j
			}
			else {																		//		sȊOH
				if (PpcNeedSpace(pBfr)) {												//			󔒑}vH
					AjcFPrintFA(pW->fhTsoOut, " ");										//				󔒏o
				}
				if (pCur->ppIf != AJCPPIF_NO_GEN) WriteSyl		  (pW, pCur);			//			啶o			  ij
				else							  WriteLineComment(pW, pCur);			//			啶sRgói񐶐j
			}
		}
		//	vvZXói#defineȊÕvvZX͑ŜPsŏo͂j
		else {																			//	vvZXH
			if (pCur->kndPP == AJCPPC_PPK_OTHERS) {										//		#pragmaH
				WriteSyl(pW, pCur);														//			#pragmat@C֏o
				pW->fTsoTop = FALSE;
			}
			else if (pCur->kndPP == AJCPPC_PPK_INCLUDE) {								//		#includeH
				int		i, rc;
				rc = WriteLineComment(pW, pCur);										//			vvZXRgo
				if (pCur->incf & AJCPPC_INCF_DUP) {
					for (i = rc; i <= 32; i++) AjcFPrintFA(pW->fhTsoOut, " ");			//				\ʒu
					AjcFPrintFA(pW->fhTsoOut, " // Already included.");					//				Already included.
				}
			}
			else if (pCur->kndPP == AJCPPC_PPK_DEFINE) {								//		#defineH
				UI	MacLines = SubMacStreamOut(pW, pCur, TRUE, 							//			}N`o
											CommOutOfkndPP & AJCPPC_PPK_DEFINE);		//			E
			}
			else if (pCur->kndPP & CommOutOfkndPP) {									//		Rgo͂vvZX(#undef, #if`#endif)H
				WriteLineComment(pW, pCur);												//			vvZXRgo
			}
			else {																		//		̂܂܏o͂vZX(#undef, #if`#endif)H
				WriteSyl(pW, pCur);														//			vvZX̂܂܏o
			}
		}
		pBfr = pCur;																	//	Õg[Nݒ
		pCur = pCur->pNxt;																//	݂̃g[NXV
		//	}N`XLbv
		while (pCur != NULL && pCur->kndPP == AJCPPC_PPK_DEFCONT) {
			pBfr = pCur;
			pCur = pCur->pNxt;
		}

		PPC_NTC(AJCPPC_NTC_OUTLOOP, 0, 0, 0);											//	g[NXg[t@C֏o̓[vʒm
	}
	AjcFPrintFA(pW->fhTsoOut, "\n");
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//	CN[he WJ̃t@Co																		//
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
static	VO	SubToFile_NoExpInc(HAJCPPC pW, UI CommOutOfkndPP)
{
	PAJCPPCTKNNODE	pTkn  = pW->pTknTop;
	PAJCPPCTKNNODE	pCur  = pW->pTknTop;
	PAJCPPCTKNNODE	pBfr  = NULL;
	BCP				pFCur = "";
	UI				lno   = 1;
	UI				sv_lno = -1;

	//	vRpC\[Xt@Co
	while (pCur != NULL && !pW->fStop) {
		//	Vȍsit@C^sԍقȂjȂ΁As
		if (mbscmp(pCur->pFile, pFCur) != 0  ||  pCur->lno != sv_lno) {					//	t@C^sԍقȂH
			//	ssÃ\[Xƍsԍ킹
			if (pCur->inst == 0) {														//		INCLUDE lXgOi\[XjH
				while (lno < pCur->lno) {												//				s킹
					AjcFPrintFA(pW->fhTsoOut, "\n"); lno++;								//				E
				}
			}
			pW->fTsoTop = TRUE;															//		usv
			pFCur		= pCur->pFile;													//		t@Cޔ
			sv_lno		= pCur->lno;													//		sԍޔ
		}
		//	ʏ̃g[No
		if (pCur->kndPP == AJCPPC_PPK_TOKEN) {											//	ʏ̃g[NH
			if (pCur->inst == 0) {														//		INCLUDE lXgOi\[XjH
				if (pW->fTsoTop) {														//			sH
					if (pCur->ppIf != AJCPPIF_NO_GEN) WriteSyl		  (pW, pCur);		//			啶o			  ij
					else							  WriteLineComment(pW, pCur);		//			啶sRgói񐶐j
				}
				else {																	//			sȊOH
					if (PpcNeedSpace(pBfr)) {											//				󔒑}vH
						AjcFPrintFA(pW->fhTsoOut, " ");									//					󔒏o
					}
					if (pCur->ppIf != AJCPPIF_NO_GEN) WriteSyl		  (pW, pCur);		//			啶o			  ij
					else					  		  WriteLineComment(pW, pCur);		//			啶sRgói񐶐j
				}
			}
		}
		//	vvZXói#defineȊÕvvZX͑ŜPsŏo͂j
		else {																			//	vvZXH
			if (pCur->inst == 0) {														//		INCLUDE lXgOi\[XjH
				if (pCur->kndPP == AJCPPC_PPK_OTHERS) {									//			#pragmaH
						WriteSyl(pW, pCur);												//					#pragmat@C֏o
						pW->fTsoTop = FALSE;
				}
				else if (pCur->kndPP == AJCPPC_PPK_INCLUDE) {							//			#includeH
						int		i, rc;
						rc = WriteSyl(pW, pCur);										//					t@Cցu#includevo
						if (pCur->incf & AJCPPC_INCF_DUP) {
							for (i = rc; i < 32; i++) AjcFPrintFA(pW->fhTsoOut, " ");	//				\ʒu
							AjcFPrintFA(pW->fhTsoOut, " // Already included.");		
						}
				}
				else if (pCur->kndPP == AJCPPC_PPK_DEFINE) {							//			#defineH
					UI	MacLines = SubMacStreamOut(pW, pCur, FALSE,						//				}N`o
											CommOutOfkndPP & AJCPPC_PPK_DEFINE);		//				E
					lno += MacLines;													//				sԍXV
				}
				else if (pCur->kndPP & CommOutOfkndPP) {								//			Rgo͂vvZX(#undef, #if`#endif)H
					WriteLineComment(pW, pCur);											//				vvZXRgo
				}
				else {																	//			̂܂܏o͂vZX(#undef, #if`#endif)H
					WriteSyl(pW, pCur);													//				vvZX̂܂܏o
					pW->fTsoTop = FALSE;												//				sȊO̎|tOZbg
				}
			}
		}
		pBfr = pCur;																	//	Õg[Nݒ
		pCur = pCur->pNxt;																//	݂̃g[NXV
		//	}N`XLbv
		while (pCur != NULL && pCur->kndPP == AJCPPC_PPK_DEFCONT) {
			pBfr = pCur;
			pCur = pCur->pNxt;
		}

		PPC_NTC(AJCPPC_NTC_OUTLOOP, 0, 0, 0);											//	g[NXg[t@C֏o̓[vʒm
	}
	AjcFPrintFA(pW->fhTsoOut, "\n");
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcPpcTokenStreamToFile(HAJCPPC pW, C_BCP pOut, BOOL fExpInc, UI CommOutOfkndPP)
{
	BOOL			rc	  = FALSE;
	PAJCPPCTKNNODE	pCur  = NULL;
	UI				stl;
	BC				fname[_MAX_FNAME], fext[_MAX_EXT];
	BC				name   [MAX_PATH];
	BC				OutPath[MAX_PATH];
	BC				relp   [MAX_PATH * 2];

	if (IS_PP_INST(pW)) {
		//	LȃtÔ݂Ƃ
		CommOutOfkndPP &= AJCPPC_PPK_ALL;

		//	pW->fStop = FALSE;

		//	o̓t@CpXݒ
		//	΃pX̏ꍇ́Ax[XpX̑΂Ƃ
		if (PathIsRelativeA(pOut)) {
			AjcSnPrintFA(relp, AJCTSIZE(relp), "%s", pW->BasePath);
			AjcPathCatA (relp, pOut, AJCTSIZE(relp));
			PathCanonicalizeA(OutPath, relp);
		}
		//	΃pX̏ꍇ́ApX𐳋K
		else {
			PathCanonicalizeA(OutPath, pOut);
		}

		if (pW->fhTsoOut = AjcFCreateA(OutPath, pW->OutTec, pW->fBOM)) {
			//	񐶐o͂ꍇAg[NXg[ƁA񐶐g[NXg[}[W
			if (pW->OptFlag & AJCPPC_FLG_GENALL) {
				SubMerge(pW);
			}
			//	t@C̍ő咷Zo
			pCur = pW->pTknTop;
			while (pCur != NULL) {
				_splitpath(pCur->pFile, NULL, NULL, fname, fext);
				_makepath (name 	  , NULL, NULL, fname, fext);
				stl 			= (UI)strlen(name);
				pW->TsoMaxFName = __max(pW->TsoMaxFName, stl);
				pCur			= pCur->pNxt;
			}

			//	vRpCσ\[Xt@Co
			if (fExpInc) {
				SubToFile_ExpInc  (pW, CommOutOfkndPP);
			}
			else {
				SubToFile_NoExpInc(pW, CommOutOfkndPP);
			}
			//	o̓t@CN[Y
			AjcFClose(pW->fhTsoOut);

			//	񐶐o͂ꍇAg[NXg[ƁA񐶐g[NXg[𕪗
			if (pW->OptFlag & AJCPPC_FLG_GENALL) {
				SubSeparate(pW);
			}
			//	t@Co͏Iʒm
			PPC_NTC(AJCPPC_NTC_OUTLOOP, 1, 0, 0);
			//	߂lnj
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	g[NXg[t@Co͂ۂ̃eLXgGR[hݒ												//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				tec		- ̓eLXgGR[h																//
//																												//
//	߂lF	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcPpcSetTecAtTokenStreamToFile(HAJCPPC pW, EAJCTEC tec, BOOL fBOM)
{
	BOOL		rc = FALSE;

	if (IS_PP_INST(pW)) {
		if (MAJCTEC_VALID(tec)) {
			pW->OutTec = tec;
			rc		   = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	\[Xt@CGR[hݒ																				//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				tec		- eLXgGR[h																	//
//																												//
//	߂lF	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT BOOL	 WINAPI	AjcPpcSetTextEncode(HAJCPPC pW, EAJCTEC tec)
{
	BOOL		rc = FALSE;

	if (IS_PP_INST(pW)) {
		if (MAJCTEC_VALID(tec)) {
			pW->InpTec = tec;
			rc		   = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	\[Xt@CGR[h擾																				//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				pTec	- \[Xt@C̃eLXgGR[hi[obt@̃AhX	isvNULLj	//
//				pfBOM	- \[Xt@CBOMo̓tOi[obt@̃AhX			isvNULLj	//
//																												//
//	߂lF	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT BOOL	 WINAPI	AjcPpcGetTextEncode(HAJCPPC pW, PEAJCTEC pTec, BOOL *pfBOM)
{
	BOOL	rc = FALSE;

	if (IS_PP_INST(pW)) {
		if (pTec  != NULL) *pTec  = pW->InpActTec;
		if (pfBOM != NULL) *pfBOM = pW->InpActBOM;
		rc = TRUE;
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	Öْ`}No^																							//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO		RegistAnsiMacro(HAJCPPC pW)
{
	time_t 			t;
	EAJCTKCODE		tkn;
	UI				num;
	PAJCPPCTKNNODE	pTop;
	HAJCTK			hctk;
	BC				ts[32], dt[32], tm[32];
	BC				mac[64];

	time(&t);
	// TIMESTAMP ݒ
	AjcSnPrintFA(ts, AJCTSIZE(ts), "%s", ctime(&t));
	mbstok(ts, "\n");
	// DATE ݒ
	memset(dt, ' ', sizeof dt);
	memcpy(&dt[ 0], &ts[ 4], 7);
	memcpy(&dt[ 7], &ts[20], 4);
	dt[11] = 0;
	// TIME ݒ
	_strtime(tm);

	// __DATE_
	AjcSnPrintFA(mac, AJCTSIZE(mac), "__DATE__=\"%s\"", dt);
	pW->pOptSymText = mac;
	if (hctk = PpcCtkCreate(pW, cbCtkOptSym)) {
		pTop = GetTokenOrPreProStream(pW, hctk, "<ANSI-C>", &tkn, &num);
		PrePro_define(pW, hctk, pTop, num);
		AjcCtkDelete(hctk);
	}
	// __TIMESTAMP__
	AjcSnPrintFA(mac, AJCTSIZE(mac), "__TIMESTAMP__=\"%s\"", ts);
	pW->pOptSymText = mac;
	if (hctk = PpcCtkCreate(pW, cbCtkOptSym)) {
		pTop = GetTokenOrPreProStream(pW, hctk, "<ANSI-C>", &tkn, &num);
		PrePro_define(pW, hctk, pTop, num);
		AjcCtkDelete(hctk);
	}
	// __TIME__
	AjcSnPrintFA(mac, AJCTSIZE(mac), "__TIME__=\"%s\"", tm);
	pW->pOptSymText = mac;
	if (hctk = PpcCtkCreate(pW, cbCtkOptSym)) {
		pTop = GetTokenOrPreProStream(pW, hctk, "<ANSI-C>", &tkn, &num);
		PrePro_define(pW, hctk, pTop, num);
		AjcCtkDelete(hctk);
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	g[NXg[																						//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	GenerateToken(HAJCPPC pW)
{
	UI				seq = 0;
	PAJCPPCINCNEST	pTI = NULL;
	EAJCTKCODE		TknKnd;
	PAJCPPCTKNNODE	pTkn, pCur;
	UI				num;
	BC				fname[_MAX_FNAME], fext[_MAX_EXT];
	BC				txt[MAX_PATH + 2];

	if (!pW->fStop) {
		while (pW->IxInc >= 0) {
			if (pW->fStop) break;	//	~
			pTI = &pW->TblInc[pW->IxInc];
			if ((pTkn = GetTokenOrPreProStream(pW, pTI->hCtk, pTI->pPath, &TknKnd, &num)) != NULL) {
				//----- t@CCsԍʒm -----------------------------------------------------------------//
				PPC_NTC(AJCPPC_NTC_FILE_LNO, pTI->file, pTI->lno, pW->IxInc);

				if (TknKnd == 0) {										//	ʏ̒Pg[NivvZXȊOjH
					if (pTI->TblIF[pTI->IxIF].act & AJCPPC_IFA_GEN) {	//		ԁH
						//----- ANSIÖك}N -------------------------------------------------------------//
						if (pTkn->tkn == EAJCTK_USR_NAME) {				//			[UH
							if		(mbscmp(pTkn->pSyl, "__FILE__") == 0) {				//u__FILE__vH
								pTkn->tkn  = EAJCTK_STR_QUOTE;
								_splitpath(pTkn->pFile, NULL, NULL, fname, fext);
								txt[0] = '"';
								_makepath (&txt[1]	  , NULL, NULL, fname, fext);
								strcat(txt, "\"");
								pTkn->pSyl = PpcNStrRegist(pW, txt);
								if (pTkn->pSyl == NULL) pW->fStop = TRUE;
							}
							else if (mbscmp(pTkn->pSyl, "__LINE__") == 0) {				//u__LINE__v
								pTkn->tkn  = EAJCTK_VAL_DECIMAL;
								AjcSnPrintFA(txt, AJCTSIZE(txt), "%d", pTkn->lno);
								pTkn->pSyl = PpcNStrRegist(pW, txt);
								if (pTkn->pSyl == NULL) pW->fStop = TRUE;
							}
						}
						//----- g[N|C^ݒ -----------------------------------------------------------//
						if (pTkn->pSyl != NULL) {						//					|C^ݒnjH
							//	g[N𖖔փN
							if (pW->pTknTop == NULL) {
								pW->pTknTop  = pTkn;
								pW->pTknLas  = pTkn;
								pCur		 = pTkn;
								pW->ppMacBfr = &pW->pTknTop;
							}
							else {
								pCur->pNxt	 = pTkn;
								pW->pTknLas  = pTkn;
								pCur		 = pCur->pNxt;
							}
						}
						else {											//					|C^ݒ莸sH
							PpcTknFree(pW, pTkn);						//						g[Nj
						}
					}
					else {												//				񐶐ԁH
						//	񐶐t@CóH
						if (pW->OptFlag & AJCPPC_FLG_GENALL) {
							pTkn->seq = seq++;
							//	g[NEm[h񐶐Xg[֒ǉi񐶐́Aɒʏ̃g[NXg[Ƃj
							if (pW->pNoGTop == NULL) pW->pNoGTop = pW->pNoGLas = pTkn;
							else			   pW->pNoGLas = pW->pNoGLas->pNxt = pTkn;
							pTkn->ppIf = AJCPPIF_NO_GEN;	//	񐶐}[N
						}
						//	񐶐̓t@Co͂Ȃ
						else {
							//	g[NEm[h
							PpcTknFree(pW, pTkn);
						}
					}
				}
				else {											//	vvZXEg[NXg[H
					//----- vvZXm[hǉ -----------------------------------------------------------//
					{	PAJCPPCTKNNODE	pPre = NULL;
						//----- #if`#endif, #pragma ͐ԂɊ֌WȂvvZXm[hǉ --------------//
						switch (TknKnd) {
							case EAJCTK_RSV_DEFINE:		break;
							case EAJCTK_RSV_UNDEF:		break;
							case EAJCTK_RSV_INCLUDE:	break;
							case EAJCTK_RSV_IFDEF:		pPre = GenPreProNode(pW, pTkn, AJCPPC_PPK_IFDEF	);	break;
							case EAJCTK_RSV_IFNDEF:		pPre = GenPreProNode(pW, pTkn, AJCPPC_PPK_IFNDEF);	break;
							case EAJCTK_RSV_IF:			pPre = GenPreProNode(pW, pTkn, AJCPPC_PPK_IF	);	break;
							case EAJCTK_RSV_ELIF:		pPre = GenPreProNode(pW, pTkn, AJCPPC_PPK_ELIF	);	break;
							case EAJCTK_RSV_ELSE:		pPre = GenPreProNode(pW, pTkn, AJCPPC_PPK_ELSE	);	break;
							case EAJCTK_RSV_ENDIF:		pPre = GenPreProNode(pW, pTkn, AJCPPC_PPK_ENDIF	);	break;
							default:					break;
						}
						//----- #if`#endif, #pragma ȊO͐Ԏ̂݃vvZXm[hǉ --------------//
						if (pTI->TblIF[pTI->IxIF].act & AJCPPC_IFA_GEN) {	//		ԁH
							switch (TknKnd) {
								case EAJCTK_RSV_DEFINE:		pPre = GenDefineNode(pW, pTkn);						break;
								case EAJCTK_RSV_UNDEF:		pPre = GenPreProNode(pW, pTkn, AJCPPC_PPK_UNDEF	);	break;
								case EAJCTK_RSV_INCLUDE:	pPre = GenPreProNode(pW, pTkn, AJCPPC_PPK_INCLUDE);	break;
								case EAJCTK_RSV_IFDEF:		break;
								case EAJCTK_RSV_IFNDEF:		break;
								case EAJCTK_RSV_IF:			break;
								case EAJCTK_RSV_ELIF:		break;
								case EAJCTK_RSV_ELSE:		break;
								case EAJCTK_RSV_ENDIF:		break;
								default:					pPre = GenPreProNode(pW, pTkn, AJCPPC_PPK_OTHERS);	break;
							}
						}
						//----- g[N|C^ݒ --------------------------//
						if (pPre != NULL) {		//	vvZXm[hH
							if (pW->pTknTop == NULL) {
								pW->pTknTop  = pCur = pPre;
								pW->ppMacBfr = &pW->pTknTop;
							}
							else {
								pCur->pNxt = pPre;
								pCur	   = pCur->pNxt;
							}
						}
						//----- ܂ŁiÕ}NWJ`ovvZX̒Oj̃}NWJ ---------//
						if (!pW->fStop) {
							PAJCPPCTKNNODE *ppBfr = NULL;
							PAJCPPCTKNNODE	pMExp = NULL;
							if (pW->ppMacBfr != NULL) {
								//	擪m[hޔ
								ppBfr = pW->ppMacBfr;
								//	}NWJ
								while (*pW->ppMacBfr != NULL) {
									if (pW->fStop) break;	//	~
									if (((*pW->ppMacBfr)->flg & AJCTKF_PREPRO) || !PpcMacExpand(pW, pW->ppMacBfr)) {
										pW->ppMacBfr = &((*pW->ppMacBfr)->pNxt);
									}
								}
								//	ŏIg[N|C^ݒ
								if ((pCur = pW->pTknTop) != NULL) {
									if (*pW->ppMacBfr != NULL) pCur = *pW->ppMacBfr;
									while (pCur->pNxt != NULL) {
										pCur = pCur->pNxt;
									}
									pW->pTknLas  = pCur;
									pW->ppMacBfr = &(pCur->pNxt);
								}
								//	m[hԍt^
								pMExp = *ppBfr;
								while (pMExp != NULL) {
									pMExp->seq = seq++;
									pMExp = pMExp->pNxt;
								}
							}
						}
						//----- vvZX̏ ---------------------------------------------------------------//
						if (pW->pTknLas != NULL) {
							if (pTI->TblIF[pTI->IxIF].act & AJCPPC_IFA_GEN) {	//		ԁH
								switch (TknKnd) {
									case EAJCTK_RSV_DEFINE:							PrePro_define	(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_UNDEF:							PrePro_undef	(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_INCLUDE:	pCur->incf		  =	PrePro_include	(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_IFDEF:		pW->pTknLas->ppIf = PrePro_ifdef	(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_IFNDEF:		pW->pTknLas->ppIf = PrePro_ifndef	(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_IF:			pW->pTknLas->ppIf = PrePro_if		(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_ELIF:		pW->pTknLas->ppIf = PrePro_elif		(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_ELSE:		pW->pTknLas->ppIf = PrePro_else		(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_ENDIF:		pW->pTknLas->ppIf = PrePro_endif	(pW, pTI->hCtk, pTkn, num);		break;
									default:										PrePro_others	(pW, pTI->hCtk, pTkn, num);		break;
								}
							}
							else {												//		񐶐ԁH
								switch (TknKnd) {
									default:				//	#pragmȃ̃vvZX
									case EAJCTK_RSV_DEFINE:	//	PpcRelTokenStream(pW, pTkn);	break;
									case EAJCTK_RSV_UNDEF:	//	PpcRelTokenStream(pW, pTkn);	break;
									case EAJCTK_RSV_INCLUDE://	PpcRelTokenStream(pW, pTkn);	break;
										//	񐶐t@CóH
										if (pW->OptFlag & AJCPPC_FLG_GENALL) {
											//	񐶐́Aɒʏ̃g[NXg[Ƃ
											while (pTkn != NULL) {
												//	SEQt^
												pTkn->seq = seq++;
												//	IncludelXgt^
												pTkn->inst = pW->IxInc;
												//	vvZX̃g[NXg[񐶐Xg[֒ǉ
												if (pW->pNoGTop == NULL) pW->pNoGTop = pW->pNoGLas = pTkn;
												else			   pW->pNoGLas = pW->pNoGLas->pNxt = pTkn;
												pTkn->ppIf = AJCPPIF_NO_GEN;	//	񐶐}[N
												pTkn = pTkn->pNxt;
											}
										}
										//	񐶐̓t@Co͂Ȃ
										else {
											//	vvZX̃g[NXg[
											PpcRelTokenStream(pW, pTkn);
										}
										break;

									case EAJCTK_RSV_IFDEF:		pW->pTknLas->ppIf = PrePro_ifdef	(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_IFNDEF:		pW->pTknLas->ppIf = PrePro_ifndef	(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_IF:			pW->pTknLas->ppIf = PrePro_if		(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_ELIF:		pW->pTknLas->ppIf = PrePro_elif		(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_ELSE:		pW->pTknLas->ppIf = PrePro_else		(pW, pTI->hCtk, pTkn, num);		break;
									case EAJCTK_RSV_ENDIF:		pW->pTknLas->ppIf = PrePro_endif	(pW, pTI->hCtk, pTkn, num);		break;
								//	default:										PrePro_others	(pW, pTI->hCtk, pTkn, num);		break;
								}
							}
						}
					}
				}
			}
			else {	// EOF?
				AjcFClose	(pTI->fh  );  pTI->fh	= NULL;
				AjcCtkDelete(pTI->hCtk);  pTI->hCtk = NULL;
				//----- #if`#endif lXg`FbN ---------//
				if (pTI->IxIF != 0) {
					PPC_ERR(AJCPPC_ERROR_COND_NOTCLS, pTI->pPath, 1, 0);
				}
				//----- IncludelXgZ ------------------//
				pW->IxInc--;
				if (pW->IxInc >= 0) {
					pTI = &pW->TblInc[pW->IxInc];
				}
				else  {
					pTI = NULL;
				}
			}
		}
		//----- iŌɌovvZXȍ~j̃}NWJ ---------------------------------------//
		if (!pW->fStop && pW->ppMacBfr != NULL) {
			PAJCPPCTKNNODE *ppMExp = NULL;		//	}NWJ̃m[hWJm[hւ̃|C^̃AhX
			PAJCPPCTKNNODE   pMExp = NULL;		//	WJm[h|C^
			//	擪m[hޔ
			ppMExp = pW->ppMacBfr;
			//	}NWJ
			while (*pW->ppMacBfr != NULL) {
				if (pW->fStop) break;
				PpcMacExpand(pW, pW->ppMacBfr);
				if (*pW->ppMacBfr == NULL) break;
				pW->ppMacBfr = &((*pW->ppMacBfr)->pNxt);
			}
			//	ŏIg[N|C^ݒ
			if ((pCur = pW->pTknTop) != NULL) {
				while (pCur->pNxt != NULL) {
					pCur = pCur->pNxt;
				}
				pW->pTknLas  = pCur;
			}
			//	WJm[hȍ~Ƀm[hԍt^
			pMExp = *ppMExp;
			while (pMExp != NULL) {
				pMExp->seq = seq++;
				pMExp = pMExp->pNxt;
			}
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZX(#defineȊO)m[ho																	//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	PAJCPPCTKNNODE	GenPreProNode(HAJCPPC pW, PAJCPPCTKNNODE pTop, UI knd)
{
	PAJCPPCTKNNODE	pNode = NULL;
	PAJCPPCINCNEST	pTi   = &pW->TblInc[pW->IxInc];
	PAJCPPCTKNNODE	pCur, pBfr;
	PAJCPPCTKNNODE	pC	, pB  ;
	UI				ix = 0;
	UI				stl;
	UI				lOrg = 0, lPre= 0, lTxt = 0;
	BCP				pOrg = NULL;		//	}NWJǑeLXg
	BCP				pPre = NULL;		//	vvZX̐擪iex. "#pragma "j
	BCP				pTxt = NULL;		//	vvZXWJeLXg

	//----- RpCIvVV{ʒm(#if, #elif, #ifdef or #ifndef ̂) -------------------------------//
	if (knd == AJCPPC_PPK_IF || knd == AJCPPC_PPK_ELIF || knd == AJCPPC_PPK_IFDEF || knd == AJCPPC_PPK_IFNDEF) {
		if (pTop != NULL) {	
			PAJCPPCTKNNODE p = pTop;
			while (p != NULL) {
				if (p->tkn == EAJCTK_USR_NAME) {
					PPC_NTC(AJCPPC_NTC_OPTSYM, (UX)p, 0, 0);
				}
				p = p->pNxt;
			}
		}
	}

	//----- }NWJǑeLXgRg`Őݒ(#if, #elif ̂) ------------------------------------//
	if (knd == AJCPPC_PPK_IF || knd == AJCPPC_PPK_ELIF) {
		//	eLXgݒ
		pCur = pTop;
		pBfr = NULL;
		lOrg = 0;
		while (pCur != NULL) {
			//	󔒕Z
			if (PpcNeedSpace(pBfr)) {
				lOrg++;
			}
			//	eLXgZ
			lOrg += (UI)strlen(pCur->pSyl);
			//	g[N|C^XV
			pBfr = pCur;
			pCur = pCur->pNxt;
		}
		lOrg += 16;		//	" /* ("  ") */" 
		lOrg++;			//	
		//	eLXgݒ
		if (pOrg = (BCP)PpcMemAlloc(pW, lOrg)) {
			pCur = pTop;
			pBfr = NULL;
			//	eLXgCfNX
			ix = 0;
			//	RgJnǉ
			strcpy(&pOrg[ix], " /* (");
			ix += 5;
			//	eLXgݒ
			while (pCur != NULL) {
				//	󔒑}
				if (PpcNeedSpace(pBfr)) {
					pOrg[ix++] = ' ';
				}
				//	eLXg}
				stl = (UI)strlen(pCur->pSyl);
				strcpy(&pOrg[ix], pCur->pSyl);
				ix += stl;
				//	g[N|C^XV
				pBfr = pCur;
				pCur = pCur->pNxt;
			}
			//	RgI[ǉ
			strcpy(&pOrg[ix], ") */");
			ix += 4;
			//	eLXgI[
			pOrg[ix] = 0;
		}
	}

	//----- vvZX̐擪̒ݒ -------------------------------------------------------------------//
	pCur = pTop;
	lPre  = 0;
	if (pCur != NULL && pCur->pSyl != NULL) {lPre  = (UI)strlen(pCur->pSyl); pCur = pCur->pNxt;}
	if (pCur != NULL && pCur->pSyl != NULL) {lPre += (UI)strlen(pCur->pSyl);				   }
	lPre += 2;	//	󔒂ƏI[
	if (pPre = (BCP)PpcMemAlloc(pW, lPre)) {
		//----- vvZX̐擪 ---------------------------------------------------------------------//
		//	}NWJ̓sApCur = <pre-process-name> Ŏ~߂Ă
		pCur = pTop;
		pBfr = NULL;
		ix	 = 0;
		if (pCur != NULL && pCur->pSyl != NULL) {stl = (UI)strlen(pCur->pSyl); strcpy(&pPre[ix], pCur->pSyl); ix += stl; pCur = pCur->pNxt;}	//	#
		if (pCur != NULL && pCur->pSyl != NULL) {stl = (UI)strlen(pCur->pSyl); strcpy(&pPre[ix], pCur->pSyl); ix += stl; 				   }	//	preprocess symbol
	//	pPre[ix++] = ' ';																														//	' '
		pPre[ix  ] = 0;
		//----- }NWJi#include, #if, #elif, #pragmaj---------------------------------------------------//
		if (pCur != NULL && ((knd == AJCPPC_PPK_INCLUDE && pCur->pNxt != NULL && pCur->pNxt->tkn != EAJCTK_DLM_LO) ||	//	#include̎ '<' ȊO or
							  knd == AJCPPC_PPK_IF || knd == AJCPPC_PPK_ELIF || knd == AJCPPC_PPK_OTHERS)) {			//	#if, #elif or others(#pragma, #error)
			PAJCPPCTKNNODE	pExp;
			PAJCPPCTKNNODE	*ppBfr = &pCur->pNxt;
			//	'defined(XXX)'̉
			PpcDefExp(pW, ppBfr, pCur->pNxt);
			//	<pre-process-name>̎ȍ~}NWJ
			while (*ppBfr != NULL) {
				PpcMacExpand(pW, ppBfr);
				if (*ppBfr == NULL) break;
				ppBfr = &((*ppBfr)->pNxt);
			}
			//	}NWJg[NɁuvvZXv}[N
			pExp = pCur;
			while (pExp != NULL) {
				pExp->flg |= AJCTKF_PREPRO;
				pExp = pExp->pNxt;
			}
			//	pCur = <pre-process-name> XLbv
			pBfr = pCur;
			pCur = pCur->pNxt;
		}
		//----- #if, #elif, #pragmaȊȌꍇApCur = <pre-process-name> XLbv-------------------------//
		else if (pCur != NULL) {
			//	pCur = <pre-process-name> XLbv
			pBfr = pCur;
			pCur = pCur->pNxt;
		}
		//----- vvZXeLXgZo ---------------------------------------------------------------------//
		lTxt = (UI)strlen(pPre) + lOrg;
		pC = pCur;
		pB = pBfr;
		while (pC != NULL) {
			//	󔒕Z
			if (PpcNeedSpace(pB)) {
				lTxt++;
			}
			//	eLXgZ
			stl = (UI)strlen(pC->pSyl);
			lTxt += stl;
			//	|C^XV
			pB = pC;
			pC = pC->pNxt;
		}
		lTxt++;
		//----- vvZXeLXgm -----------------------------------------------------------------//
		if (pTxt = (BCP)PpcMemAlloc(pW, lTxt)) {
			//----- vvZXeLXg쐬 -------------------------------------------------------------------//
			strcpy(pTxt, pPre);
			ix = (UI)strlen(pTxt);
			while (pCur != NULL) {
				//	󔒑}
				if (PpcNeedSpace(pBfr)) {
					pTxt[ix++] = ' ';
				}
				//	eLXgRs[
				stl = (UI)strlen(pCur->pSyl);
				strcpy(&pTxt[ix], pCur->pSyl);
				ix += stl;
				//	|C^XV
				pBfr = pCur;
				pCur = pCur->pNxt;
			}
			//----- }NWJǑeLXgǉ(#if, #elif̂) ---------------------------------------------//
			if (pOrg != NULL) {
				stl = (UI)strlen(pOrg);
				strcpy(&pTxt[ix], pOrg);
				ix += stl;
			}
			//	eLXgI[
			pTxt[ix] = 0;
			//----- vvZXm[hǉ ---------------------------------------------------------------//
			if (pNode = PpcTknAlloc(pW)) {
				pNode->pFile  = PpcIStrRegist(pW, pTop->pFile);
				pNode->pSyl   = PpcNStrRegist(pW, pTxt);
				pNode->tkn	  = EAJCTK_PREPRO;
				pNode->kndPP  = (UW)knd;
				pNode->lno	  = pTop->lno;
				pNode->pos	  = pTop->pos;
				pNode->ppIf	  = 0;
				pNode->flg	  = 0;
				pNode->inst   = pW->IxInc;
				pNode->incf	  = pTop->incf;
				pNode->mexp   = pTop->mexp;
				//	t@C^ o^sȂ΃m[hj
				if (pNode->pFile == NULL || pNode->pSyl == NULL) {
					PpcTknFree(pW, pNode);
					pNode = NULL;
					pW->fStop = TRUE;
				}
			}
			PpcMemFree(pW, pTxt);
		}
		PpcMemFree(pW, pPre);
	}
	else pW->fStop = TRUE;

	//----- }NWJOeLXg ----------------------------//
	if (pOrg != NULL) {
		free(pOrg);
	}

	return pNode;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZX(#define)m[ho																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	PAJCPPCTKNNODE	GenDefineNode(HAJCPPC pW, PAJCPPCTKNNODE pTop)
{
	PAJCPPCTKNNODE	pNode = NULL;
	PAJCPPCTKNNODE	pCur  = NULL;
	PAJCPPCTKNNODE	pNew  = NULL;
	PAJCPPCTKNNODE	pBfr  = NULL;
	BOOL			fErr = FALSE;

	//----- pCur = }Ng[Nm[h ----------------------------------------------------------------------//
	pCur = pTop;
	pCur = pCur->pNxt;	//	'#' 	 XLbv
	pCur = pCur->pNxt;	//	'define' XLbv
	//----- #definevvZXm[hǉ --------------------------------------------------------------------//
	if (pNode = PpcTknAlloc(pW)) {
		pNode->pFile  = PpcIStrRegist(pW, pTop->pFile);
		pNode->pSyl   = PpcNStrRegist(pW, pCur->pSyl);		//	pSyl = "}N"
		pNode->tkn	  = EAJCTK_PREPRO;
		pNode->kndPP  = AJCPPC_PPK_DEFINE;
		pNode->lno	  = pTop->lno;
		pNode->pos	  = pTop->pos;
		pNode->ppIf	  = 0;
		pNode->flg	  = 0;
		pNode->inst   = pW->IxInc;
		pNode->incf	  = pTop->incf;
		pNode->mexp   = pTop->mexp;
		//	pNxtȍ~Ƀ}N`̃Rs[A
		pCur = pTop;
		pBfr = NULL;
		while (pCur != NULL) {
			if (pNew = PpcTknAlloc(pW)) {
				memcpy(pNew, pCur, sizeof(AJCPPCTKNNODE));
				pNew->kndPP  = AJCPPC_PPK_DEFCONT;
				if (pBfr == NULL) {
					pNode->pNxt = pNew;
				}
				else {
					pBfr->pNxt	= pNew;
				}
			}
			else {
				fErr = TRUE;
				break;
			}
			pBfr = pNew;
			pCur = pCur->pNxt;
		}
		//	m[h쐬sȂ΃m[hj
		if (fErr || pNode->pFile == NULL || pNode->pSyl == NULL) {
			PpcRelTokenStream(pW, pNode);
			pNode = NULL;
			pW->fStop = TRUE;
		}
	}
	return pNode;
}

//--------------------------------------------------------------------------------------------------------------//
//	g[Nm[h^vvZX̃g[NXg[擾														//
//																												//
//	@	F	hCtk		- 啪CX^XEnh													//
//				pFilePath	- t@CpX̃AhX															//
//				pfPpTkn		- g[Nm[h^vvZX̃g[NXg[̎ʂi[obt@AhX//
//								O - Pg[Nm[hivvZXłȂj								//
//								O - vvZX̎(EAJCTK_DEFINE, EAJCTK_IF ... )						//
//				pNum		- g[Ňi[obt@̃AhX								//
//																												//
//	߂l	F	NULL : 擪g[NEm[hAhX															//
//				NULL : g[NI[																			//
//--------------------------------------------------------------------------------------------------------------//
static	PAJCPPCTKNNODE	GetTokenOrPreProStream(HAJCPPC pW, HAJCTK hCtk, C_BCP pFilePath, EAJCTKCODE *pfPpTkn, UIP pNum)
{
	PAJCPPCTKNNODE	pTop = NULL;
	PAJCPPCTKNNODE	pCur = NULL;
	EAJCTKCODE		PpTkn;
	UI				flg;
	UI				n = 0;
	BOOL			rsu;
	BC				syl[1024];

	if (AjcCtkGetTokenA(hCtk, syl, AJCTSIZE(syl))) {
		flg = AJCTK_FLAG(hCtk);
		PPC_NTC(AJCPPC_NTC_TOKEN, AJCTK_TOKEN(hCtk), syl, 0);
		//----- vvZX̃g[NEXg[ ---------------------//
		if ((flg & (AJCTKF_PREPRO | AJCTKF_PPTOP)) == (AJCTKF_PREPRO | AJCTKF_PPTOP)) {
			//----- g[N -----------------------------------//
			n = 1;
			//----- ̃vvZXEg[Nʐݒ ---------------------//
			PpTkn = AJCTK_TOKEN(hCtk);
			//----- 擪g[Nm[h ---------------------------------//
			pTop = pCur = PpcTknAlloc(pW);
			if (pTop != NULL) {
				if (PpcSetTokenNode(pW, pTop, pFilePath, hCtk, syl)) {
					//----- ̃g[Nʐݒ -----------------------------------//
					AjcCtkPeekTokenA(hCtk, syl, AJCTSIZE(syl));
					flg = AJCTK_FLAG(hCtk);
					while ((flg & AJCTKF_PREPRO) && !(flg & AJCTKF_PPTOP)) {
						if (pW->fStop) break;
						//----- ̃g[N擾 -----------------------------------//
						AjcCtkGetTokenA(hCtk, syl, AJCTSIZE(syl));
						PPC_NTC(AJCPPC_NTC_TOKEN, AJCTK_TOKEN(hCtk), syl, 0);
						//----- ̃g[NEXg[𐶐A ---------------//
						pCur = PpcAllocAndLinkNextToken(pW, pCur);
						if (pW->IxInc == 0) rsu = PpcSetTokenNode	  (pW, pCur, pFilePath, hCtk, syl);
						else				rsu = PpcSetTokenNodeByInc(pW, pCur, pFilePath, hCtk, syl, pW->IxInc, pW->incf);
						if (rsu) {
							//----- g[NXV -----------------------------//
							n++;
							//----- vvZXEg[Nʐݒ -----------------//
							if (n == 2) {
								PpTkn = AJCTK_TOKEN(hCtk);
							}
							//----- ̃g[Nʐݒ ---------------------------//
							AjcCtkPeekTokenA(hCtk,  syl, AJCTSIZE(syl));
							flg = AJCTK_FLAG(hCtk);
						}
						else pW->fStop = TRUE;
					}
				}
				else pW->fStop = TRUE;
			}
			else pW->fStop = TRUE;
			//----- vvZX̃g[NXg[̎|AtOݒ -----//
			if (pfPpTkn != NULL) *pfPpTkn = PpTkn;
		}
		//----- Pg[N -------------------------------------------//
		else {
			//----- g[Nm[h -------------------------------------//
			pTop = PpcTknAlloc(pW);
			if (pTop != NULL) {
				if (pW->IxInc == 0) rsu = PpcSetTokenNode	  (pW, pTop, pFilePath, hCtk, syl);
				else				rsu = PpcSetTokenNodeByInc(pW, pTop, pFilePath, hCtk, syl, pW->IxInc, pW->incf);
				if (rsu) {
					//----- Pg[N̎|AtOݒ -----------------------//
					if (pfPpTkn != NULL) *pfPpTkn = 0;
					//----- g[NP ---------------------------------//
					n = 1;
				}
				else pW->fStop = TRUE;
			}
			else pW->fStop = TRUE;
		}
	}
	//----- g[Ňݒ -------------------------------------//
	if (pNum != NULL) *pNum = n;

	return pTop;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXi#define)																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		PrePro_define	(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	PAJCPPCTKNNODE	pCur  = pTop;
	BCP				pFile = pTop->pFile;
	UI				lno   = pTop->lno;
	UI				pos   = pTop->pos;

	if (num >= 3) {
		pCur = PpcRelCurAndGetNextToken(pW, pCur);			//	'#'		XLbv
		pCur = PpcRelCurAndGetNextToken(pW, pCur);			//	'define'XLbv
		if (pCur->flg & AJCTKF_MACNAME) {
			if (PpcMacRegist(pW, pCur, pCur->flg & AJCTKF_MACWITHARG, pos)) {
				//	}N`ʒm
				PPPCMACNODE pMacNode = (PPPCMACNODE)PpcMacGetNode(pW, pCur->pSyl);
				if (pMacNode != NULL) {
					PPC_NTC(AJCPPC_NTC_MACDEF, (UX)pCur, (UX)pMacNode, 0);
				}
			}
		}
		else {
			PPC_ERR(AJCPPC_MACERR_INV_NAME, pFile, lno, 0);
			PpcRelTokenStream(pW, pTop);
		}
	}
	else {
		PPC_ERR(AJCPPC_MACERR_NO_NAME, pFile, lno, 0);
		PpcRelTokenStream(pW, pTop);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXi#undef)																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		PrePro_undef	(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	PAJCPPCTKNNODE	pCur  = pTop;
	BCP				pFile = pTop->pFile;
	UI				lno   = pTop->lno;

	if (num == 3) {
		pCur = PpcRelCurAndGetNextToken(pW, pCur);		//	'#'		XLbv
		pCur = PpcRelCurAndGetNextToken(pW, pCur);		//	'undef'	XLbv
		PpcMacUnRegist(pW, pCur->pSyl);					//	}N`i}N݂ȂꍇAɃG[ƂȂj
		PpcRelTokenStream(pW, pCur);					//	㑱g[N
	}
	else if (num <= 2) {
		PPC_ERR(AJCPPC_MACERR_NO_NAME, pFile, lno, 0);
		PpcRelTokenStream(pW, pTop);
	}
	else {
		PPC_ERR(AJCPPC_MACERR_INV_NAME, pFile, lno, 0);
		PpcRelTokenStream(pW, pTop);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXi#include)																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	UB		PrePro_include	(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	UB				rc		= pTop->incf;
	PAJCPPCINCNEST	pTi		= &pW->TblInc[pW->IxInc];
	PAJCPPCTKNNODE	pCur	= pTop;
	BCP				pFile	= pTop->pFile;
	UI				lno 	= pTop->lno;
	BOOL 			fExist	= FALSE;
	PAJCLBXITEMA	pInc	= NULL;
	BC				drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], fext[_MAX_EXT];
	BC				IncName[MAX_PATH];
	BC				relp[MAX_PATH * 2];
	BC				path[MAX_PATH];

	do {
		pW->incf = AJCPPC_INCF_NO;
		if ((pCur = PpcRelCurAndGetNextToken(pW, pCur)) == NULL) break;		//	'#'			XLbv
		if ((pCur = PpcRelCurAndGetNextToken(pW, pCur)) == NULL) {			//	'include'	XLbv
			PPC_ERR(AJCPPC_INCERR_NO_FILE, pFile, lno, 0);
			break;
		}
		//----- #include "XXXXX.h" -----------------------------------------------------------------------------//
		if		(pCur->tkn == EAJCTK_STR_QUOTE) {
			pW->incf |= AJCPPC_INCF_LCL;
			//----- t@Cݒ -------------------------------------------------------//
			AjcSnPrintFA(IncName, MAX_PATH, "%s", pCur->pSyl + 1);
			mbstok(IncName, "\"");
			//----- tH_ -------------------------------------------------------//
			_splitpath(pTi->pPath, drv, dir, NULL, NULL);
			_makepath  (path 	, drv, dir, NULL, NULL);
			AjcPathCatA(path, IncName, MAX_PATH);
			fExist = PathFileExistsA(path);
		}
		//----- #include <XXXXX.h> -----------------------------------------------------------------------------//
		else if (pCur->tkn == EAJCTK_DLM_LO   ) {
			pW->incf |= AJCPPC_INCF_GBL;
			//----- '<' `FbN --------------------------------------------------------//
			if ((pCur = PpcRelCurAndGetNextToken(pW, pCur)) == NULL) {		//	'<'	XLbv
				PPC_ERR(AJCPPC_INCERR_NO_FILE, pFile, lno, 0);
				break;
			}
			//----- t@Cݒ -------------------------------------------------------//
			{	UI	ix, stl;
				ix = 0;
				while (pCur != NULL && pCur->tkn != EAJCTK_DLM_HI) {
					stl = (UI)strlen(pCur->pSyl);
					if (ix + stl + 1 < MAX_PATH) {
						strcpy(&IncName[ix], pCur->pSyl);
						ix += stl;
					}
					pCur = PpcRelCurAndGetNextToken(pW, pCur);
				}
			}
			//----- '>' `FbN ---------------------------------------------------------//
			if (pCur == NULL || pCur->tkn != EAJCTK_DLM_HI) {
				PPC_ERR(AJCPPC_INCERR_NOTCLS, pFile, lno, 0);
				break;
			}
		}
		//----- #include Lq~X ------------------------------------------------------------------------------//
		else {
			PPC_ERR(AJCPPC_INCERR_INV_FILE, pFile, lno, 0);
			break;
		}
		//----- CN[ht@Cǂݍݍς݃`FbN -------------------------------------------------------//
		if ((pW->OptFlag & AJCPPC_FLG_ONCE) && PpcIncIsRegist(pW, IncName)) {	// ONCE and ǂݍݍς݁H
			//u#includev́u"t@C"vg[NɑdCN[h̎|AtOZbg
			pW->incf |= AJCPPC_INCF_DUP;
			break;
		}
		//----- CN[ht@Co^ ---------------------------------------------------------------------//
		if (pW->hAvlInc != NULL) {
			if (PpcIncRegist(pW, IncName) == NULL) {
				pW->fStop = TRUE;
				break;
			}
		}
		//----- ŗDIncludepX --------------------------------------------------------------------------//
		if (pW->pIncArr != NULL) {
			BC	temp_path[MAX_PATH];
			for (pInc = pW->pIncArr; pInc->pStr != NULL; pInc++) {
				if (pInc->data == AJCPP_INC_TOPPRIORITY) {
					//----- CN[hEfBNgݒ ---------------------//
					if (PathIsRelativeA(pInc->pStr)) {
						AjcSnPrintFA(relp, AJCTSIZE(relp), "%s", pW->BasePath);
						AjcPathCatA (relp, pInc->pStr, AJCTSIZE(relp));
						PathCanonicalizeA(temp_path, relp);
					}
					else {
						PathCanonicalizeA(temp_path, pInc->pStr);
					}
					//----- CN[ht@C̑݃`FbN -----------------//
					AjcPathCatA(temp_path, IncName, AJCTSIZE(temp_path));
					if (fExist = PathFileExistsA(temp_path)) {
						strcpy(path, temp_path);
						break;
					}
				}
			}
		}
		//----- IncludepX --------------------------------------------------------------------------------//
		if (!fExist) {
			if (pW->pIncArr != NULL) {
				for (pInc = pW->pIncArr; pInc->pStr != NULL && !fExist; pInc++) {
					//----- CN[hEfBNgݒ ---------------------//
					if (PathIsRelativeA(pInc->pStr)) {
						AjcSnPrintFA(relp, AJCTSIZE(relp), "%s", pW->BasePath);
						AjcPathCatA (relp, pInc->pStr, AJCTSIZE(relp));
						PathCanonicalizeA(path, relp);
					}
					else {
						PathCanonicalizeA(path, pInc->pStr);
					}
					//----- CN[ht@C̑݃`FbN -----------------//
					if (pW->OptFlag & AJCPPC_FLG_AUTO_SEARCH) {
						if (fExist = SearchIncFile(pW, IncName, path, AJCTSIZE(path))) break;
					}
					else {
						AjcPathCatA(path, IncName, AJCTSIZE(path));
						if (fExist = PathFileExistsA(path)) break;
					}
				}
			}
			if (!fExist) {
				//----- CN[hEfBNgݒ -------------------------//
				AjcSnPrintFA(path, AJCTSIZE(path), "%s", pW->BasePath);
				//----- CN[ht@C̑݃`FbN ---------------------//
				if (pW->OptFlag & AJCPPC_FLG_AUTO_SEARCH) {
					fExist = SearchIncFile(pW, IncName, path, AJCTSIZE(path));
				}
				else {
					AjcPathCatA(path, IncName, AJCTSIZE(path));
					fExist = PathFileExistsA(path);
				}
			}
		}
		//----- Includet@CAlXge[uXV ----------------------------------------------//
		if (fExist) {
			//----- lXge[uXV -----------------------------------------------//
			if (pW->IxInc < AJCPPC_MAX_INC_NEST - 1) {
				pW->IxInc++;
				pTi = &pW->TblInc[pW->IxInc];
				do {
					//----- CN[ht@CEI[v -------------------------------//
					if ((pTi->fh = AjcFOpenA(path, pW->InpTec)) == NULL) {
						PPC_ERR(AJCPPC_ERROR_INC_OPEN, pFile, lno, path);
						pW->IxInc--;
						pTi = &pW->TblInc[pW->IxInc];
						break;
					}
					//----- 啪CX^X -------------------------------------//
					pTi->hCtk = PpcCtkCreate(pW, cbCtkFile);
					if (pTi->hCtk == NULL) {pW->fStop = TRUE; break;}
					//----- #includelXge[uGgɃCN[ht@Cݒ -//
					pTi->pPath = PpcIStrRegist(pW, path);
					_splitpath(path    , NULL, NULL, fname, fext);
					_makepath (pTi->file, NULL, NULL, fname, fext);
					pTi->lno = 0;
					//----- #if`#endif lXg񏉊 ---------------------------------//
					pTi->IxIF = 0;
					memset(pTi->TblIF, 0, sizeof pTi->TblIF);
					pTi->TblIF[0].knd = AJCPPC_IFK_NONE;
					pTi->TblIF[0].act = AJCPPC_IFA_GEN_NORMAL;
				} while(0);
			}
			else {
				PPC_ERR(AJCPPC_INCERR_NEST_OVER, pFile, lno, 0);
				break;
			}
		}
		//----- Includet@CȂꍇ --------------------------------------------------------------//
		else {
			PPC_ERR(AJCPPC_INCERR_NOT_FOUND, pFile, lno, IncName);
			break;
		}
	} while(0);
	//----- ̃g[N -----------------------------------------------------------------------------//
	PpcRelTokenStream(pW, pCur);

	return pW->incf;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXi#ifdef)																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL		PrePro_ifdef	(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	BOOL			rc	   = FALSE;		//	߂liRpC̐^Ulj
	PAJCPPCINCNEST	pTi    = &pW->TblInc[pW->IxInc];
	PAJCPPCTKNNODE	pCur   = pTop;
	BCP				pFile  = pTop->pFile;
	UI				lno    = pTop->lno;
	AJCPPCIFACT		CurAct = pTi->TblIF[pTi->IxIF].act;

	pCur = PpcRelCurAndGetNextToken(pW, pCur);							//	'#'		XLbv
	pCur = PpcRelCurAndGetNextToken(pW, pCur);							//	'ifdef'	XLbv

	if (pTi->IxIF < AJCPPC_MAX_IF_NEST - 1) {							//	elXg͈͓H
		pTi->IxIF++;													//		lXgZ
		pTi->TblIF[pTi->IxIF].knd = AJCPPC_IFK_IFDEF;					//		ooʐݒ
		pTi->TblIF[pTi->IxIF].lno = lno;								//		iΉj#ifdef, #ifndef, #if ̍sԍ
		if (CurAct & AJCPPC_IFA_GEN) {									//		H
			if (pCur != NULL && AJCTKIS_SYMBOL(pCur->tkn)) {			//			V{H
				if (PpcMacGetNode(pW, pCur->pSyl) != NULL) {			//				V{`ρH
					pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_GEN_IN_IF;	//					uhei^jɂ鐶ԁv
					rc = TRUE;											//					߂l^
				}
				else {													//				V{`H
					pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_BY_IF;	//					uheiUjɂXLbvԁv
				}
			}
			else {														//		V{ȊOH
				PPC_ERR(AJCPPC_ERROR_NO_SYMBOL, pFile, lno, 0);
				pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_BY_IF;		//			uheiUjɂXLbvԁv
			}
		}
		else {															//		XLbvH
			pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_ALL;			//			uXLbvԁiʂ̏Ujv
			rc = AJCPPIF_UNCOND;
		}
	}
	else {
		PPC_ERR(AJCPPC_ERROR_COND_DEEP, pFile, lno, 0);
	}
	//----- ̃g[N -----------------------------------------------------------------------------//
	PpcRelTokenStream(pW, pCur);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXi#ifndef)																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL		PrePro_ifndef	(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	BOOL			rc	 	= FALSE;		//	߂liRpC̐^Ulj
	PAJCPPCINCNEST	pTi		= &pW->TblInc[pW->IxInc];
	PAJCPPCTKNNODE	pCur	= pTop;
	BCP				pFile	= pTop->pFile;
	UI				lno 	= pTop->lno;
	AJCPPCIFACT		CurAct	= pTi->TblIF[pTi->IxIF].act;

	pCur = PpcRelCurAndGetNextToken(pW, pCur);							//	'#' 	 XLbv
	pCur = PpcRelCurAndGetNextToken(pW, pCur);							//	'ifndef' XLbv

	if (pTi->IxIF < AJCPPC_MAX_IF_NEST - 1) {							//	elXg͈͓H
		pTi->IxIF++;													//		lXgZ
		pTi->TblIF[pTi->IxIF].knd = AJCPPC_IFK_IFNDEF;					//		ooʐݒ
		pTi->TblIF[pTi->IxIF].lno = lno;								//		iΉj#ifdef, #ifndef, #if ̍sԍ
		if (CurAct & AJCPPC_IFA_GEN) {									//		H
			if (pCur != NULL && AJCTKIS_SYMBOL(pCur->tkn)) {			//			V{H
				if (PpcMacGetNode(pW, pCur->pSyl) == NULL) {			//				V{`H
					pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_GEN_IN_IF;	//					uhei^jɂ鐶ԁv
					rc = TRUE;											//					߂l^
				}
				else {													//				V{`ρH
					pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_BY_IF;	//					uheiUjɂXLbvԁv
				}
			}
			else {														//		V{ȊOH
				PPC_ERR(AJCPPC_ERROR_NO_SYMBOL, pFile, lno, 0);
				pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_BY_IF;		//			uheiUjɂXLbvԁv
			}
		}
		else {															//		XLbvH
			pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_ALL;			//			uXLbvԁiʂ̏Ujv
			rc = AJCPPIF_UNCOND;										//			 ߂luUv
		}
	}
	else {
		PPC_ERR(AJCPPC_ERROR_COND_DEEP, pFile, lno, 0);
	}
	//----- ̃g[N -----------------------------------------------------------------------------//
	PpcRelTokenStream(pW, pCur);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXi#if)																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	PrePro_if		(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	BOOL			rc	   = FALSE;		//	߂liRpC̐^Ulj
	PAJCPPCINCNEST	pTi    = &pW->TblInc[pW->IxInc];
	PAJCPPCTKNNODE	pCur   = pTop;
	BCP				pFile  = pTop->pFile;
	UI				lno    = pTop->lno;
	AJCPPCIFACT		CurAct = pTi->TblIF[pTi->IxIF].act;
	int				n	   = 0;

	pCur = PpcRelCurAndGetNextToken(pW, pCur);							//	'#' XLbv
	pCur = PpcRelCurAndGetNextToken(pW, pCur);							//	'if' XLbv

	if (pTi->IxIF < AJCPPC_MAX_IF_NEST - 1) {							//	elXg͈͓H
		pTi->IxIF++;													//		lXgZ
		pTi->TblIF[pTi->IxIF].knd = AJCPPC_IFK_IF;						//		ooʐݒ
		pTi->TblIF[pTi->IxIF].lno = lno;								//		iΉj#ifdef, #ifndef, #if ̍sԍ
		if (CurAct & AJCPPC_IFA_GEN) {									//		H
			if (pCur != NULL && PpcFormulaExpression(pW, pCur, &n) == AJCPPC_ERROR_OK) {
																		//			ȉZH
				if (n != 0) {											//				TRUEH
					pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_GEN_IN_IF;	//					uhei^jɂ鐶ԁv
					rc = TRUE;											//					߂l^
				}
				else {													//				FALSEH
					pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_BY_IF;	//					uheiUjɂXLbvԁv
				}
			}
			else {														//			sȉZH
				pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_BY_IF;		//				uheiUjɂXLbvԁv
			}
		}
		else {															//		XLbvH
			pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_ALL;			//			uXLbvԁiʂ̏Ujv
			rc = AJCPPIF_UNCOND;										//			 ߂luUv
		}
	}
	else {
		PPC_ERR(AJCPPC_ERROR_COND_DEEP, pFile, lno, 0);
	}
	//----- ̃g[N -----------------------------------------------------------------------------//
	PpcRelTokenStream(pW, pCur);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXi#elif)																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	PrePro_elif		(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	BOOL			rc	   = FALSE;		//	߂liRpC̐^Ulj
	PAJCPPCINCNEST	pTi    = &pW->TblInc[pW->IxInc];
	PAJCPPCTKNNODE	pCur   = pTop;
	BCP				pFile  = pTop->pFile;
	UI				lno    = pTop->lno;
	AJCPPCIFKIND	CurKnd = pTi->TblIF[pTi->IxIF].knd;
	AJCPPCIFACT		CurAct = pTi->TblIF[pTi->IxIF].act;
	int				n	   = 0;

	pCur = PpcRelCurAndGetNextToken(pW, pCur);								//	'#' XLbv
	pCur = PpcRelCurAndGetNextToken(pW, pCur);								//	'elif' XLbv

	if (pTi->IxIF > 0) {													//	lXgH
		if (CurKnd >= AJCPPC_IFK_IFDEF && CurKnd <= AJCPPC_IFK_ELIF) {		//		uifdef / ifndef / if / elifvɂlXgH
			pTi->TblIF[pTi->IxIF].knd = AJCPPC_IFK_ELIF;					//			ooʐݒ
			if (CurAct & AJCPPC_IFA_GEN) {									//			H
				pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_ENDIF;			//				udmche܂ŃXLbvԁv
			}
			else if (CurAct == AJCPPC_IFA_SKIP_BY_IF) {						//			heiUjɂXLbv
				if (pCur != NULL && PpcFormulaExpression(pW, pCur, &n) == AJCPPC_ERROR_OK) {
																			//				ȉZH
					if (n != 0) {											//					TRUEH
						pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_GEN_IN_IF;	//						uhei^jɂ鐶ԁv
						rc = TRUE;											//						߂l^
					}
					else {													//					FALSEH
						pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_BY_IF;	//						uheiUjɂXLbvԁv
					}
				}
				else {														//				sȉZH
					pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_BY_IF;		//					uheiUjɂXLbvԁv
				}
			}
			else  {															//			dmche܂ŃXLbv^LbvH
				if (pTi->IxIF > 0 && (pTi->TblIF[pTi->IxIF - 1].act & AJCPPC_IFA_SKIP)) {
					rc = AJCPPIF_UNCOND;									//				߂luUv
				}
			}
		}
		else {																//		uELSEvɂlXgH
			PPC_ERR(AJCPPC_ERROR_ELIF_IN_ELSE, pFile, lno, 0);
		}
	}
	else {																	//	lXgȂH
		PPC_ERR(AJCPPC_ERROR_NOT_IN_IF, pFile, lno, 0);
	}
	//----- ̃g[N -----------------------------------------------------------------------------//
	PpcRelTokenStream(pW, pCur);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXi#else)																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	PrePro_else		(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	BOOL			rc		= FALSE;		//	߂liRpC̐^Ulj
	PAJCPPCINCNEST	pTi		= &pW->TblInc[pW->IxInc];
	PAJCPPCTKNNODE	pCur	= pTop;
	BCP				pFile	= pTop->pFile;
	UI				lno 	= pTop->lno;
	AJCPPCIFKIND	CurKnd	= pTi->TblIF[pTi->IxIF].knd;
	AJCPPCIFACT		CurAct	= pTi->TblIF[pTi->IxIF].act;

	if (pTi->IxIF > 0) {													//	lXgH
		if (CurKnd >= AJCPPC_IFK_IFDEF && CurKnd <= AJCPPC_IFK_ELIF) {		//		uifdef / ifndef / if / elifvɂlXgH
			pTi->TblIF[pTi->IxIF].knd = AJCPPC_IFK_ELSE;					//			ooʐݒ
			if		(CurAct == AJCPPC_IFA_GEN_IN_IF) {						//			hei^jɂ鐶ԁH
				pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_SKIP_ENDIF;			//				udmche܂ŃXLbvԁv
			}
			else if (CurAct == AJCPPC_IFA_SKIP_BY_IF) {						//			heiUjɂXLbvԁH
				pTi->TblIF[pTi->IxIF].act = AJCPPC_IFA_GEN_IN_ELSE;			//				udkrdɂ鐶ԁv
				rc = TRUE;													//				߂l^
			}
			else {															//			dmche܂ŃXLbv^LbvH
				if (pTi->IxIF > 0 && (pTi->TblIF[pTi->IxIF - 1].act & AJCPPC_IFA_SKIP)) {
					rc = AJCPPIF_UNCOND;									//				߂luUv
				}
			}
		}
		else {																//		uELSEvɂlXgH
			PPC_ERR(AJCPPC_ERROR_ELSE_IN_ELSE, pFile, lno, 0);
		}
	}
	else {																	//	lXgȂH
		PPC_ERR(AJCPPC_ERROR_NOT_IN_IF, pFile, lno, 0);
	}
	//----- g[NXg[ -----------------------------------------------------------------------------//
	PpcRelTokenStream(pW, pCur);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXi#endif)																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	UI		PrePro_endif	(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	UI				rc		= 0;		//	߂liΉ #ifdef.#ifndef/#if ܂ł̑΍sԍC63335𒴂ꍇ0j
	PAJCPPCINCNEST	pTi		= &pW->TblInc[pW->IxInc];
	PAJCPPCTKNNODE	pCur	= pTop;
	BCP				pFile	= pTop->pFile;
	UI				lno 	= pTop->lno;
	AJCPPCIFACT		CurAct	= pTi->TblIF[pTi->IxIF].act;

	if (pTi->IxIF > 0) {												//	lXgH
		if ((pTop->lno - pTi->TblIF[pTi->IxIF].lno) > 65530) {			//		RpCs͈̓I[o[H
			rc = 0;														//			߂lO
		}
		else {															//		̑ijH
			rc = pTop->lno - pTi->TblIF[pTi->IxIF].lno;					//			߂liΉ #ifdef.#ifndef/#if ܂ł̑΍sԍj
		}
		pTi->TblIF[pTi->IxIF].knd = 0;									//		lXge[uGgNA[
		pTi->TblIF[pTi->IxIF].act = 0;									//		E
		pTi->TblIF[pTi->IxIF].lno = 0;									//		E
		pTi->IxIF--;													//		lXgZ
	}
	else {
		PPC_ERR(AJCPPC_ERROR_NOT_IN_IF, pFile, lno, 0);
	}
	//----- g[NXg[ -----------------------------------------------------------------------------//
	PpcRelTokenStream(pW, pCur);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXȋ)																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO		PrePro_others	(HAJCPPC pW, HAJCTK hCtk, PAJCPPCTKNNODE pTop, UI num)
{
	PAJCPPCINCNEST	pTi = &pW->TblInc[pW->IxInc];

	//----- g[NXg[ -----------------------------------------------------------------------------//
	PpcRelTokenStream(pW, pTop);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXiIF̃g[N)																	//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	Generate_InIf(HAJCPPC pW)
{
	PAJCPPCINCNEST	pTi = &pW->TblInc[pW->IxInc];
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXiELSẼg[N)																	//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	Generate_InElse(HAJCPPC pW)
{
	PAJCPPCINCNEST	pTi = &pW->TblInc[pW->IxInc];
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXiELIF / ELSE / ENDIF)܂ŃXLbv															//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SkipTo_elif_else_endif(HAJCPPC pW)
{
	PAJCPPCINCNEST	pTi = &pW->TblInc[pW->IxInc];
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vvZXiENDIF)܂ŃXLbv																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SkipTo_endif(HAJCPPC pW)
{
	PAJCPPCINCNEST	pTi = &pW->TblInc[pW->IxInc];
}
//--------------------------------------------------------------------------------------------------------------//
//	IvVV{͂̎啪pR[obN																//
//																												//
//	@	F	pBuf		- eLXgi[obt@̃AhX													//
//				pFilePath	- eLXgi[obt@̕														//
//				xp			- R[obNp^iCX^X[Nj										//
//																												//
//	߂l	F	TRUE  : LȃeLXgݒ肵																//
//				FALSE : eLXgI[																			//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbCtkOptSym(BCP pBuf, UI lBuf, UX xp)
{
	HAJCPPC			pW	= (HAJCPPC)xp;
	PAJCPPCINCNEST	pTi = &pW->TblInc[pW->IxInc];
	BOOL			rc;
	UI				stl;
	BCP				p1, p2, pTmp;

	if (pW->pOptSymText != NULL) {
		stl = (UI)strlen(pW->pOptSymText);
		pTmp = PpcMemAlloc(pW, stl + 1);
		if (pTmp != NULL) {
			strcpy(pTmp, pW->pOptSymText);
			p1 = mbstok(pTmp, "=");
			p2 = mbstok(NULL, "\0");
			if (p1 != NULL) {
				if (p2 == NULL) AjcSnPrintFA(pBuf, lBuf, "#define %s"   , p1    );
				else			AjcSnPrintFA(pBuf, lBuf, "#define %s %s", p1, p2);
			}
			free(pTmp);
			pW->pOptSymText = NULL;
			rc = TRUE;
		}
		else pW->fStop = TRUE;
	}
	else {
		rc = FALSE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	\[Xt@C啪pR[obN																		//
//																												//
//	@	F	pBuf		- eLXgi[obt@̃AhX													//
//				pFilePath	- eLXgi[obt@̕														//
//				xp			- R[obNp^iCX^X[Nj										//
//																												//
//	߂l	F	TRUE  : LȃeLXgݒ肵																//
//				FALSE : eLXgI[																			//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbCtkFile(BCP pBuf, UI lBuf, UX xp)
{
	VOP				rc;
	HAJCPPC			pW	= (HAJCPPC)xp;
	PAJCPPCINCNEST	pTi = &pW->TblInc[pW->IxInc];

	pTi->lno++;
	if ((rc = AjcFGetSA(pTi->fh, pBuf, lBuf)) != NULL) {
	//	SsSetText(pBuf, pTi->lno);
	}

	return (rc != NULL);
}


//--------------------------------------------------------------------------------------------------------------//
//	CN[ht@C																					//
//																												//
//	@	F	pFName	- CN[ht@C̃AhX														//
//				pPath	- fBNgpXiꍇ͓Yt@CpXݒ肳j				//
//				len		- pathobt@̃TCY															//
//																												//
//	߂l	F	TRUE : Yt@C																	//
//				FALSE: Yt@C͌Ȃ																//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SearchIncFile(HAJCPPC pW, C_BCP pFName, BCP pPath, int len)
{
	BOOL		rc = FALSE;				//	߂l
	BC			drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], fext[_MAX_EXT];

	PPC_NTC(AJCPPC_NTC_SRH_START, pFName, pPath, 0);									//	Jnʒm
	pW->pSrhPath = pPath;																//	pXݒobt@AhXޔ

	if (PathIsRelativeA(pFName)) {														//	CN[ht@C͑΃pXH
		AjcSetNtcSearchingDir(TRUE);													//		t@CAfBNgʒm
		if (strchr(pPath, '*') == NULL && strchr(pPath, '?') == NULL) {					//		fBNgpXɃChJ[hH
			//	pXƃt@Cč\iu"d:\incpath", "sys/types.h"vu"d:\incpath\sys", "types.h"vj
			BC		iPath[MAX_PATH];
			BC		iName[MAX_PATH];
			_splitpath(pFName, drv, dir, fname, fext);
			AjcSnPrintFA(iPath, MAX_PATH, "%s", pPath);
			AjcPathCatA(iPath, dir, MAX_PATH);
			_makepath (iName, NULL, NULL, fname, fext);
			//	CN[ht@C
			pW->rcSrhInc = FALSE;
			AjcSearchFilesA(iPath, iName, TRUE , (UX)pW, cbASearchIncFile);				//			CN[ht@C
			rc = pW->rcSrhInc;
		}
		else {																			//		fBNgpXɃChJ[hLH
			UX	fh;
			struct _finddata_t fd;
			BC		SrhDir[MAX_PATH];
			//	ChJ[h̑SfBNgɂăCN[ht@C
			if (fh = _findfirst(pPath, &fd)) {
				do {
					if (fd.attrib & _A_SUBDIR) {
						if (mbscmp(fd.name, ".") != 0 && mbscmp(fd.name, "..") != 0) {
							//	CN[ht@CpXݒ
							_splitpath(pPath , drv, dir, NULL, NULL);	//	ChJ[h
							_makepath (SrhDir, drv, dir, NULL, NULL);	//	E
							AjcPathCatA(SrhDir, fd.name, MAX_PATH);		//	fBNgt
							pW->rcSrhInc = FALSE;
							AjcSearchFilesA(SrhDir, pFName, TRUE , (UX)pW, cbASearchIncFile);
							rc = pW->rcSrhInc;
							if (rc) break;
						}
					}
				} while (_findnext(fh, &fd) != -1 && !pW->fStop);
				_findclose(fh);
			}
		}
	}
	else {																				//	CN[ht@C͐΃pXH
		if (AjcPathIsFileA(pFName)) {													//		pX̓t@CH
			AjcSnPrintFA(pW->pSrhPath, MAX_PATH, "%s", pFName);							//			CN[ht@C̃pXݒ
			rc = TRUE;
		}
	}
	PPC_NTC(AJCPPC_NTC_SRH_END, pFName, rc, 0);											//	Iʒm

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	CN[ht@C̃R[obN																		//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbASearchIncFile(UI nest, BCP pPath, BCP pName, UI attrib, UI wtime, UX cbp)
{
	BOOL	rc = TRUE;
	HAJCPPC	pW = (HAJCPPC)cbp;

	if (nest != -1) {											//	t@C^fBNgʒmHif 
		if (!(attrib & _A_SUBDIR)) {							//		fBNgȊOH
			AjcSnPrintFA(pW->pSrhPath, MAX_PATH, "%s", pPath);	//			CN[ht@C̃pXݒ
			pW->rcSrhInc = TRUE;								//			CN[ht@Cʐݒ
			rc		     = FALSE;								//			߂lI
		}
		else {
			rc = !pW->fStop;									//		߂l(TRUE:pCFALSE:~)
		}
	}
	else {														//	̃fBNgʒmH
		PPC_NTC(AJCPPC_NTC_SRH_DIR, pPath, 0, 0);				//		̃pXʒm
		rc = !pW->fStop;										//		߂l(TRUE:pCFALSE:~)
	}

	return rc;
}

