#include	"AjcInternal.h"

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO			SubInitPrn		 (HAJCPRN pW);
static	BOOL		SubPrnSelect(HAJCPRN pW, PAJCPRN_INFO pInfo, PAJCPRN_OPT pOpt, HWND hWndOwner);

static	BOOL		CreDcAndSetPrinterInfo	(HAJCPRN pW, PAJCPRN_MARGIN pmmMrg);
static	BOOL		SubSetPrinterInfo		(HAJCPRN pW, PAJCPRN_MARGIN pmmMrg, HDC hdc, LPDEVMODE pDevMode);

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	hWndOwner	- I[i[EChnh															//
//				cbp			- R[obNp^																//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT HAJCPRN WINAPI AjcPrnCreateA(VO)
{
	HAJCPRN	pW;

	if ((pW = (HAJCPRN)AJCMEM(sizeof(AJCPRN))) != NULL) {
		memset(pW, 0, sizeof(AJCPRN));
		SubInitPrn(pW);
		pW->fUnicode = FALSE;
	}

	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT HAJCPRN WINAPI AjcPrnCreateW(VO)
{
	HAJCPRN	pW;

	if ((pW = (HAJCPRN)AJCMEM(sizeof(AJCPRN))) != NULL) {
		memset(pW, 0, sizeof(AJCPRN));
		SubInitPrn(pW);
		pW->fUnicode = TRUE;
	}

	return pW;
}
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubInitPrn(HAJCPRN pW)
{
	AJCPRN_MARGIN	mrg;

	//----- ftHgv^ݒ ---------------------------------------------------------//
	memset(&mrg, 0, sizeof mrg);
	SubPrnSelect(pW, NULL, NULL, NULL);

}
//==============================================================================================================//
//	R[obNp^ݒ																					//
//																												//
//	@	F	pW					- CX^Xnh														//
//				cbp					- R[obNp^														//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL			WINAPI	AjcPrnSetCallbackParam(HAJCPRN pW, UX cbp)
{
	BOOL	rc = FALSE;

	if (pW != NULL) {
		pW->cbp = cbp;
	}
	return rc;
}

//==============================================================================================================//
//	y[WJnR[obNݒ																				//
//																												//
//	@	F	pW					- CX^Xnh														//
//				cbQueryPage			- y[WJnʒmR[obN֐									//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL			WINAPI	AjcPrnSetCallbackQueryPage(HAJCPRN pW, 
								BOOL (CALLBACK *cbQueryPage)(PCAJCPRN_INFO pPrnInfo, PAJCPRN_PGINFO pPageInfo, UX cbp))
{
	BOOL	rc = FALSE;

	if (pW != NULL) {
		pW->cbQueryPage = cbQueryPage;
	}
	return rc;
}
//==============================================================================================================//
//	chaZNVErbg}bvɂ`R[obNݒ													//
//																												//
//	@	F	pW					- CX^Xnh														//
//				cbDrawByPrinterDC	- chaZNVErbg}bvɂ`R[obN֐					//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcPrnSetCallbackByDibSect(HAJCPRN pW,
						 		BOOL (CALLBACK *cbDrawByDibSectDC)(HDC hdc, PCAJCPRN_INFO pPrnInfo, PCAJCDIBINFO pDibInfo, UX cbp))
{
	BOOL	rc = FALSE;

	if (pW != NULL) {
		pW->cbDrawPrn = NULL;
		pW->cbDrawDib = cbDrawByDibSectDC;
	}
	return rc;
}
//==============================================================================================================//
//	v^cbɂ`R[obNݒ																		//
//																												//
//	@	F	pW					- CX^Xnh														//
//				cbDrawByPrinterDC	- v^cbɂ`R[obN֐									//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcPrnSetCallbackByPrinter(HAJCPRN pW,
								 BOOL (CALLBACK *cbDrawByPrinterDC)(HDC hdc, PCAJCPRN_INFO pPrnInfo, UX cbp))
{
	BOOL	rc = FALSE;

	if (pW != NULL) {
		pW->cbDrawPrn = cbDrawByPrinterDC;
		pW->cbDrawDib = NULL;
	}
	return rc;
}

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO		WINAPI	AjcPrnDelete	(HAJCPRN pW)
{
	if (pW != NULL) {
		if (pW->pdg.hDevMode  != NULL) GlobalFree(pW->pdg.hDevMode);
		if (pW->pdg.hDevNames != NULL) GlobalFree(pW->pdg.hDevNames);
		free(pW);
	}
}

//==============================================================================================================//
//	v^̑I																								//
//																												//
//	@	F	pW		 			- CX^Xnh														//
//				pInfo				- v^i[obt@̃AhX									//
//				Flag				- IvVtO															//
//				hWndOwner			- I[i[EChnh													//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - I^G[																			//
//==============================================================================================================//
//	ECh[N
typedef struct {
	ULL				Flags;								//	IvVtO
	RECT			rcCbo;								//	R{{bNXiv^j̋`
	HWND			hGrpPageInfo;						//	y[W͈̓O[v{bNX
	HWND			hGrpCopies;							//	O[v{bNX
} WKWNDSRH, *PWKWNDSRH;
//	tbN֐
static	UINT_PTR CALLBACK cbPrintHook(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
//--------------------------------------------------------------------------------------------------------------//
//	v^̑I_CAO
AJCEXPORT	BOOL	WINAPI	AjcPrnSelectDlg(HAJCPRN pW, PAJCPRN_INFO pInfo, UI Flag, HWND hWndOwner)
{
	AJCPRN_OPT	opt;
	memset(&opt, 0, sizeof opt);
	opt.Flags = PD_PRINTSETUP | (Flag & PD_NONETWORKBUTTON);
	return SubPrnSelect(pW, pInfo, &opt, hWndOwner);
}
//--------------------------------------------------------------------------------------------------------------//
//	_CAO
AJCEXPORT	BOOL	WINAPI	AjcPrnPrintDlg (HAJCPRN pW, PAJCPRN_INFO pInfo, PAJCPRN_OPT pOpt, HWND hWndOwner)
{
	return SubPrnSelect(pW, pInfo, pOpt, hWndOwner);
}
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubPrnSelect(HAJCPRN pW, PAJCPRN_INFO pInfo, PAJCPRN_OPT pOpt, HWND hWndOwner)
{
	BOOL			rc	= FALSE;
	AJCPRN_MARGIN	mrg;
	WKWNDSRH		wk;

	//----- Ȍ -------------------------------------//
	//	͕svI
	//	PRINTDLG\͈̂ێ܂܂ƂB
	//	hDevModehDevNames̒l͕ωAVXeōĊ蓖Ă͗l
//	if (pW->pdg.hDevMode  != NULL) GlobalFree(pW->pdg.hDevMode);
//	if (pW->pdg.hDevNames != NULL) GlobalFree(pW->pdg.hDevNames);
//	memset(&pW->pdg, 0, sizeof pW->pdg);

	//----- PRINTDLG ---------------------------------------//
	pW->pdg.lStructSize   = sizeof(PRINTDLG);
	pW->pdg.hwndOwner	  = hWndOwner;
	if (pOpt == NULL) {
		pW->pdg.Flags = PD_RETURNDEFAULT;
	}
	else {
		pW->pdg.Flags			= (UL)pOpt->Flags;
		pW->pdg.nCopies			= pOpt->nCopies;
		pW->pdg.nFromPage		= pOpt->nFromPage;
		pW->pdg.nToPage			= pOpt->nToPage;
		pW->pdg.nMinPage		= pOpt->nMinPage;
		pW->pdg.nMaxPage		= pOpt->nMaxPage;
		//	R[obNݒ
		if (pOpt->Flags & (AJCPRNF_DISABLECOPIES | AJCPRNF_DISABLEPAGEINFO)) {
			memset(&wk, 0, sizeof wk);
			wk.Flags = pOpt->Flags;
			pW->pdg.Flags |= PD_ENABLEPRINTHOOK;
			pW->pdg.lCustData = (UX)&wk;
			pW->pdg.lpfnPrintHook = cbPrintHook;
		}
	}

	if (PrintDlg(&pW->pdg)) {
		//	ݒ肳ꂽIvVlԂ
		if (pOpt != NULL) {
			pOpt->Flags			= (pOpt->Flags & 0xFFFFFFFF00000000ULL) | ((ULL)pW->pdg.Flags & 0x00000000FFFFFFFFULL);
			pOpt->nCopies		= pW->pdg.nCopies;
			pOpt->nFromPage		= pW->pdg.nFromPage;
			pOpt->nToPage		= pW->pdg.nToPage;
			pOpt->nMinPage		= pW->pdg.nMinPage;
			pOpt->nMaxPage		= pW->pdg.nMaxPage;
		}
		//	v^Ct@Co͎wtOݒ
		if (pW->pdg.hDevNames != NULL) {
			LPDEVNAMES pdn = (LPDEVNAMES)GlobalLock(pW->pdg.hDevNames);
			WCP		   pName = (WCP)pdn;
			//	v^ݒ
			pName += pdn->wDeviceOffset;
			AjcSnPrintF(pW->NameW, AJCPRN_MAX_PRNNAME, L"%s", pName);
			WideCharToMultiByte(CP_ACP, 0, pW->NameW, -1, pW->NameA, AJCPRN_MAX_PRNNAME, NULL, NULL);
			//	t@Co̓tOݒ
			if (pOpt != NULL) {
				pName = (WCP)pdn;
				pName += pdn->wOutputOffset;
				if (wcsicmp(pName, L"FILE:") == 0) pOpt->Flags |=  AJCPRNF_OUTPUTTOFILE;
				else							   pOpt->Flags &= ~AJCPRNF_OUTPUTTOFILE;
			}
			GlobalUnlock(pW->pdg.hDevNames);
		}
		else if (pW->pdg.hDevMode != NULL) {
			LPDEVMODE pdm = (LPDEVMODE)GlobalLock(pW->pdg.hDevMode);
			AjcSnPrintF(pW->NameW, AJCPRN_MAX_PRNNAME, L"%s", pdm->dmDeviceName);
			WideCharToMultiByte(CP_ACP, 0, pW->NameW, -1, pW->NameA, AJCPRN_MAX_PRNNAME, NULL, NULL);
			GlobalUnlock(pW->pdg.hDevMode);
		}
		//---- v^Zo -----------------------------------------//
		memcpy(&mrg, &pW->pi.MrgIf.mm, sizeof(AJCPRN_MARGIN));
		CreDcAndSetPrinterInfo(pW, &mrg);
		//----- v^i[ ----------------------------------------//
		if (pInfo != NULL) {
			memcpy(pInfo, &pW->pi, sizeof(AJCPRN_INFO));
		}
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	R{{bNXiv^j
static	BOOL CALLBACK cbEnumChildSrhCbo(HWND hw, LPARAM lParam)
{
	BOOL		rc	= TRUE;
	PWKWNDSRH	pWk = (PWKWNDSRH)lParam;
	WC			txt[256];

	GetClassName(hw, txt, AJCTSIZE(txt));
	if (wcsicmp(txt, L"ComboBox") == 0 || wcsicmp(txt, L"SysListView32") == 0) {
		GetWindowRect(hw, &pWk->rcCbo);
		rc = FALSE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	͈́CO[v
static	BOOL CALLBACK cbEnumChildSrhGrp(HWND hw, LPARAM lParam)
{
	BOOL		rc	= TRUE;
	PWKWNDSRH	pWk = (PWKWNDSRH)lParam;
	int			sty;
	RECT		rect;
	WC			txt[256];

	GetClassName(hw, txt, AJCTSIZE(txt));
	if (wcsicmp(txt, L"Button") == 0) {
		GetWindowRect(hw, &rect);
		sty = (int)MAjcGetWindowLong(hw, GWL_STYLE);
		if ((sty & WS_GROUP) && ((sty & BS_TYPEMASK) == BS_GROUPBOX) && rect.top > pWk->rcCbo.top) {
			GetWindowText(hw, txt, AJCTSIZE(txt));
			if (rect.left <= pWk->rcCbo.left) pWk->hGrpPageInfo = hw;
			else							  pWk->hGrpCopies	= hw;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	UINT_PTR CALLBACK cbPrintHook(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	PWKWNDSRH		pWk;

	if (msg == WM_INITDIALOG) {
		LPPRINTDLG	p = (LPPRINTDLG)lParam;
		pWk = (PWKWNDSRH)p->lCustData;
		//	R{{bNXiv^j
		EnumChildWindows(hDlg, cbEnumChildSrhCbo, (UX)pWk);
		//	͈̓O[vCO[v̌
		EnumChildWindows(hDlg, cbEnumChildSrhGrp, (UX)pWk);
		//	͈̓O[v
		if ((pWk->Flags & AJCPRNF_DISABLEPAGEINFO) && (pWk->hGrpPageInfo != NULL)) {
			AjcEnableGroup(pWk->hGrpPageInfo, FALSE, FALSE);
		}
		//	O[v
		if ((pWk->Flags & AJCPRNF_DISABLECOPIES  ) && (pWk->hGrpCopies	 != NULL)) {
			AjcEnableGroup(pWk->hGrpCopies	, FALSE, FALSE);
		}
	}
	return 0;
}
//==============================================================================================================//
//	Jn																									//
//																												//
//	@	F	pW		 			- CX^Xnh														//
//				fOutputToFile		- t@Co̓tO														//
//																												//
//	߂l	F	O - nj																						//
//				O - G[																					//
//==============================================================================================================//
AJCEXPORT	int		WINAPI	AjcPrnStart	(HAJCPRN pW, BOOL fOutputToFile)
{
	int					rc	 = 0;				//	߂l
	HDC					hdcPrn = NULL;			//	v^cb
	HDC					hdcMem = NULL;			//	chaZNVpcb
	LPDEVMODE			pDevMode = NULL;		//	v^foCX
	BOOL				fExit = FALSE;			//	ItO
	BOOL				fStartDoc = FALSE;		//	StartDoc()sσtO
	BOOL				fOriChanged = FALSE;	//	̌ύXtO
	BOOL				fMrgChanged = FALSE;	//	]TCYύXtO
	DOCINFO				di;						//	cnbhmen
	HBITMAP				hBmp = NULL;			//	chaZNVrbg}bvnh
	HBITMAP				hBmpSv = NULL;
	AJCPRN_PGINFO 		DefPg;					//	ftHg̃y[W
	AJCPRN_PGINFO 		NtcPg;					//	ʒmy[W
	RECT				r;
	WC					path [MAX_PATH];		//	vOpX
	WC					fname[MAX_PATH];		//	vOihLgj

	//----- tOݒ -----------------------//
	pW->fPrintBusy = TRUE;

	//----- hLgݒ ---------------------//
	GetModuleFileName(NULL, path, MAX_PATH);
	_wsplitpath(path, NULL, NULL, fname, NULL);
	//----- DOCINFOݒ ----------------------------//
	memset(&di, 0, sizeof di);
	di.cbSize	   = sizeof(DOCINFO);
	di.lpszDocName = fname;
	if (fOutputToFile) di.lpszOutput = L"FILE:";
	else			   di.lpszOutput = NULL;

	do {
		//----- DEVMODE\̎擾 -------------------------//
		if (pW->pdg.hDevMode != NULL) pDevMode = (LPDEVMODE)GlobalLock(pW->pdg.hDevMode);
		else						  pDevMode = NULL;
		//----- v^cb --------------------------//
		if ((hdcPrn = CreateDC(NULL, pW->NameW, NULL, pDevMode)) == NULL) {
			rc = GetLastError();
			break;
		}
		//----- y[W񏉊 --------------------------//
		memcpy(&DefPg.mmMrg, &pW->pi.MrgIf.mm, sizeof DefPg.mmMrg);
		DefPg.orientation = pW->pi.Orientation;
		//----- v^ݒ --------------------------//
		SubSetPrinterInfo(pW, &DefPg.mmMrg, hdcPrn, pDevMode);
		//----- chapcb --------------------------//
		if (pW->cbDrawDib != NULL) {
			if ((hdcMem = CreateCompatibleDC(NULL)			   ) == NULL) {
				rc = GetLastError();
				break;
			}
		}
		//----- Jn ----------------------------------//
		if (StartDoc(hdcPrn, &di) <= 0)   {
			rc = GetLastError();
			break;
		}
		//	StartDoc()sσtO
		fStartDoc = TRUE;

		fExit = FALSE;
		while (!fExit) {
			fMrgChanged = FALSE;
			fOriChanged = FALSE;
			//----- y[WJnʒm ----------------//
			memcpy(&NtcPg, &DefPg, sizeof NtcPg);
			if (pW->cbQueryPage != NULL) {
				if (pW->cbQueryPage(&pW->pi, &NtcPg, pW->cbp) == FALSE) {
					break;
				}
			}
			//---- ]TCYύXtOݒ -----------//
			if (memcmp(&DefPg.mmMrg, &NtcPg.mmMrg, sizeof DefPg.mmMrg) != 0) {
				fMrgChanged = TRUE;
			}
			//---- p̌ύXtOݒ -----------//
			if ((DefPg.orientation == AJCPRN_ORIENT_PORTRAIT  && NtcPg.orientation == AJCPRN_ORIENT_LANDSCAPE) ||
				(DefPg.orientation == AJCPRN_ORIENT_LANDSCAPE && NtcPg.orientation == AJCPRN_ORIENT_PORTRAIT )) {
				fOriChanged = TRUE;
			}
			//----- ]Čݒ --------------//
			if (fMrgChanged || fOriChanged) {
				if (fOriChanged) {
					if (pDevMode != NULL && (pDevMode->dmFields & DM_ORIENTATION)) {
						//	UAI
						EndDoc(hdcPrn);
						fStartDoc = FALSE;
						//	v^cb
						DeleteDC(hdcPrn);
						//	c[hݒ
						pDevMode->dmOrientation = NtcPg.orientation;
						//	v^cb
						if ((hdcPrn = CreateDC(NULL, pW->NameW, NULL, pDevMode)) == NULL) {
							rc = GetLastError();
							break;
						}
						//	ĊJ
						if (StartDoc(hdcPrn, &di) <= 0)   {
							rc = GetLastError();
							break;
						}
						//	StartDoc()sσtO
						fStartDoc = TRUE;
					}
				}
				//----- v^ݒ --------------//
				SubSetPrinterInfo(pW, &NtcPg.mmMrg, hdcPrn, pDevMode);
				//---- y[WftHgύX -------//
				memcpy(&DefPg, &NtcPg, sizeof DefPg);
			}
			//----- v^`NA[ --------------------//
			r.left = r.top = 0; r.right = pW->pi.cxPage, r.bottom = pW->pi.cyPage;
			FillRect(hdcPrn, &r, (HBRUSH)GetStockObject(WHITE_BRUSH));
			//----- chaZNV --------------//
			if (pW->cbDrawDib != NULL) {
				if (hBmp == NULL || fMrgChanged || fOriChanged) {
					if (hBmp != NULL) DeleteObject(SelectObject(hdcMem, hBmpSv));
					if ((hBmp = AjcDibCreate(pW->pi.cx, pW->pi.cy, 32, &pW->dib)) == NULL) {
						rc = GetLastError();
						break;
					}
					hBmpSv = (HBITMAP)SelectObject(hdcMem, hBmp);
				}
				//--- chaZNVNA[ --------//
				r.left = r.top = 0; r.right = pW->pi.cx, r.bottom = pW->pi.cy;
				FillRect(hdcMem, &r, (HBRUSH)GetStockObject(WHITE_BRUSH));
			}
			//----- y[WJn --------------------//
			if (StartPage(hdcPrn) <= 0) {
				rc = GetLastError();
				break;
			}
			do {
				//----- v^cbɂy[Wʒm --//
				if (pW->cbDrawPrn) {
					BOOL	rsu;
					//	R[obN
					rsu = pW->cbDrawPrn(hdcPrn, &pW->pi, pW->cbp);
					if (rsu == FALSE) {
						fExit = TRUE;
						break;
					}
				}
				//----- cha|cbɂy[Wʒm --//
				else if (pW->cbDrawDib) {
					BOOL	rsu;
					//	R[obN
					rsu = pW->cbDrawDib(hdcMem, &pW->pi, &pW->dib, pW->cbp);
					//	chav^փC[W]
					BitBlt(hdcPrn, pW->pi.x, pW->pi.y, pW->pi.cx, pW->pi.cy, hdcMem, 0, 0, SRCCOPY);
					if (rsu == FALSE) {
						fExit = TRUE;
						break;
					}
				}
				//----- R[obNȂ΁AI -----//
				else break;
			} while(0);
			//----- y[WI -------------------//
			if (EndPage(hdcPrn) <= 0) {
				rc = GetLastError();
				break;
			}
		}
		//	I
		if (fStartDoc) EndDoc(hdcPrn);
	} while(0);

	//	\[X
	if (hdcPrn 	 != NULL) {DeleteDC(hdcPrn);		hdcPrn	 = NULL;}
	if (hdcMem	 != NULL) {DeleteDC(hdcMem);		hdcMem	 = NULL;}
	if (hBmp	 != NULL) {DeleteObject(hBmp);		hBmp	 = NULL;}
	if (pDevMode != NULL) {GlobalUnlock(pDevMode);	pDevMode = NULL;}

	//----- tO -----------------------//
	pW->fPrintBusy = FALSE;

	#ifdef _DEBUG
		if (rc != 0) {
			WC		ErrTxt[256];
			AjcGetLastErrorText(rc, ErrTxt, AJCTSIZE(ErrTxt));
			MessageBox(NULL, ErrTxt, L"s", MB_ICONERROR);
		}
	#endif

	return rc;
}

//==============================================================================================================//
//	]TCYݒ																								//
//																												//
//	@	F	pW		 			- CX^Xnh														//
//				pmmMargin			- ]TCY[mm]ւ̃|C^											//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL			WINAPI	AjcPrnSetMargin	(HAJCPRN pW, PAJCPRN_MARGIN pmmMargin)
{
	BOOL	rc = FALSE;

	if (pW != NULL && !pW->fPrintBusy) {
		rc = CreDcAndSetPrinterInfo(pW, pmmMargin);
	}
	return rc;
}
//==============================================================================================================//
//	v^擾																							//
//																												//
//	@	F	pW		 			- CX^Xnh														//
//				pBuf				- v^i[obt@̃AhX									//
//																												//
//	߂l	F	mtkk - njiv^ւ̃|C^j														//
//				mtkk - G[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_BCP				WINAPI	AjcPrnGetInfoA	(HAJCPRN pW, PAJCPRN_INFO pBuf)
{
	C_BCP		rc = NULL;

	if (pW != NULL) {
		if (pBuf != NULL) {
			memcpy(pBuf, &pW->pi, sizeof(AJCPRN_INFO));
		}
		rc = pW->NameA;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_WCP				WINAPI	AjcPrnGetInfoW	(HAJCPRN pW, PAJCPRN_INFO pBuf)
{
	C_WCP		rc = NULL;

	if (pW != NULL) {
		if (pBuf != NULL) {
			memcpy(pBuf, &pW->pi, sizeof(AJCPRN_INFO));
		}
		rc = pW->NameW;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	v^cb쐬ƃv^ݒ																			//
//																												//
//	@	F	pW		 	- CX^Xnh																//
//				pName		- v^foCX																//
//				pmmMrg		- ㉺E̗][mm]i͈͊Ȍꍇ͂̃obt@̒lCNULL͍Œ]j	//
//				hdc			- v^cb																		//
//				pDevMode	- foCX																		//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CreDcAndSetPrinterInfo(HAJCPRN pW, PAJCPRN_MARGIN pmmMrg)
{
	BOOL		rc = FALSE;
	HDC			hdc = NULL;
	LPDEVMODE	pDevMode;

	//----- DEVMODE\̎擾 -------------------------//
	if (pW->pdg.hDevMode != NULL) pDevMode = (LPDEVMODE)GlobalLock(pW->pdg.hDevMode);
	else						  pDevMode = NULL;

	//----- v^cb --------------------------//
	hdc = CreateDC(NULL, pW->NameW, NULL, pDevMode);

	//----- v^ݒ --------------------------//
	if (hdc != NULL) {
		rc = SubSetPrinterInfo(pW, pmmMrg, hdc, pDevMode);
	}

	//----- \[X ------------------------------//
	if (hdc 		 	 != NULL) {DeleteDC(hdc);}
	if (pW->pdg.hDevMode != NULL) {GlobalUnlock(pW->pdg.hDevMode);}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	v^ݒ																							//
//																												//
//	@	F	pW		 	- CX^Xnh																//
//				pName		- v^foCX																//
//				pmmMrg		- ㉺E̗][mm]i͈͊Ȍꍇ͂̃obt@̒lCNULL͍Œ]j	//
//				hdc			- v^cb																		//
//				pDevMode	- foCX																		//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubSetPrinterInfo(HAJCPRN pW, PAJCPRN_MARGIN pmmMrg, HDC hdc, LPDEVMODE pDevMode)
{
	BOOL			rc = FALSE;
	int				mmMinX, mmMaxX;
	int				mmMinY, mmMaxY;

	if (hdc != NULL) {
		//----- v^ --------------------//
		pW->pi.cxFull		= GetDeviceCaps(hdc, PHYSICALWIDTH	);			//	]܂߂`sNZ
		pW->pi.cyFull		= GetDeviceCaps(hdc, PHYSICALHEIGHT );			//	E
		pW->pi.OffsetX		= GetDeviceCaps(hdc, PHYSICALOFFSETX);			//	Es\̃sNZ
		pW->pi.OffsetY		= GetDeviceCaps(hdc, PHYSICALOFFSETY);			//	㉺s\̃sNZ
		pW->pi.FactorX		= GetDeviceCaps(hdc, SCALINGFACTORX );			//	v^̐̔{
		pW->pi.FactorY		= GetDeviceCaps(hdc, SCALINGFACTORY );			//	v^̐̔{
		pW->pi.LogPixelsX	= GetDeviceCaps(hdc, LOGPIXELSX 	);			//	PC`̉sNZ
		pW->pi.LogPixelsY	= GetDeviceCaps(hdc, LOGPIXELSY 	);			//	PC`̏csNZ
		if (pDevMode != NULL) pW->pi.Orientation = pDevMode->dmOrientation;	//	cu^u
		else				  pW->pi.Orientation = AJCPRN_ORIENT_UNKOWN;
		//	󎚉\̈TCYݒ
		pW->pi.cxPage = pW->pi.cxFull - (pW->pi.OffsetX * 2);				//	󎚉\ȃsNZ
		pW->pi.cyPage = pW->pi.cyFull - (pW->pi.OffsetY * 2);				//	E

		//----- ŏ][pixels] --------------//
		pW->pi.MrgIf.pxMin.l = 0;
		pW->pi.MrgIf.pxMin.r = 0;
		pW->pi.MrgIf.pxMin.u = 0;
		pW->pi.MrgIf.pxMin.d = 0;

		//----- ŏ][mm] ------------------//
		mmMinX		  = (int)ceil((double)pW->pi.OffsetX * 25.4 / (double)pW->pi.LogPixelsX);
		mmMinY		  = (int)ceil((double)pW->pi.OffsetX * 25.4 / (double)pW->pi.LogPixelsX);
		pW->pi.MrgIf.mmMin.l = mmMinX;
		pW->pi.MrgIf.mmMin.r = mmMinX;
		pW->pi.MrgIf.mmMin.u = mmMinY;
		pW->pi.MrgIf.mmMin.d = mmMinY;

		//----- ő][pixels] --------------//
		pW->pi.MrgIf.pxMax.l = pW->pi.cxPage * 40 / 100;
		pW->pi.MrgIf.pxMax.r = pW->pi.cxPage * 40 / 100;
		pW->pi.MrgIf.pxMax.u = pW->pi.cyPage * 40 / 100;
		pW->pi.MrgIf.pxMax.d = pW->pi.cyPage * 40 / 100;

		//----- ő][mm] ------------------//
		mmMaxX		  = (int)((double)(pW->pi.cxPage * 40 / 100) * 25.4 / (double)pW->pi.LogPixelsX);
		mmMaxY		  = (int)((double)(pW->pi.cyPage * 40 / 100) * 25.4 / (double)pW->pi.LogPixelsX);
		pW->pi.MrgIf.mmMax.l = mmMaxX;
		pW->pi.MrgIf.mmMax.r = mmMaxX;
		pW->pi.MrgIf.mmMax.u = mmMaxY;
		pW->pi.MrgIf.mmMax.d = mmMaxY;

		//----- w][mm]͈͓ɒ ----//
		if (pmmMrg != NULL) {
			memcpy(&pW->pi.MrgIf.mm, pmmMrg, sizeof(AJCPRN_MARGIN));
			pW->pi.MrgIf.mm.l	 = __max(pW->pi.MrgIf.mm.l, mmMinX);	  pW->pi.MrgIf.mm.l = __min(pW->pi.MrgIf.mm.l, mmMaxX);
			pW->pi.MrgIf.mm.r	 = __max(pW->pi.MrgIf.mm.r, mmMinX);	  pW->pi.MrgIf.mm.r = __min(pW->pi.MrgIf.mm.r, mmMaxX);
			pW->pi.MrgIf.mm.u	 = __max(pW->pi.MrgIf.mm.u, mmMinY);	  pW->pi.MrgIf.mm.u = __min(pW->pi.MrgIf.mm.u, mmMaxY);
			pW->pi.MrgIf.mm.d	 = __max(pW->pi.MrgIf.mm.d, mmMinY);	  pW->pi.MrgIf.mm.d = __min(pW->pi.MrgIf.mm.d, mmMaxY);
			memcpy(pmmMrg, &pW->pi.MrgIf.mm, sizeof(AJCPRN_MARGIN));
		}
		//----- ]w薳͍Œl ----//
		else {
			pW->pi.MrgIf.mm.l	 = mmMinX;
			pW->pi.MrgIf.mm.r	 = mmMinX;
			pW->pi.MrgIf.mm.u	 = mmMinY;
			pW->pi.MrgIf.mm.d	 = mmMinY;
		}

		//----- ]sNZ ------------------//
		memset(&pW->pi.MrgIf.px, 0, sizeof pW->pi.MrgIf.px);
		if (pmmMrg != NULL) {
			pW->pi.MrgIf.px.l = (int)((double)pmmMrg->l * ((double)pW->pi.LogPixelsX / 25.4));
			pW->pi.MrgIf.px.r = (int)((double)pmmMrg->r * ((double)pW->pi.LogPixelsX / 25.4));
			pW->pi.MrgIf.px.u = (int)((double)pmmMrg->u * ((double)pW->pi.LogPixelsY / 25.4));
			pW->pi.MrgIf.px.d = (int)((double)pmmMrg->d * ((double)pW->pi.LogPixelsY / 25.4));
		}
		//	ŏlȉJbg
		pW->pi.MrgIf.px.l = __max(pW->pi.MrgIf.px.l, pW->pi.MrgIf.pxMin.l);
		pW->pi.MrgIf.px.r = __max(pW->pi.MrgIf.px.r, pW->pi.MrgIf.pxMin.r);
		pW->pi.MrgIf.px.u = __max(pW->pi.MrgIf.px.u, pW->pi.MrgIf.pxMin.u);
		pW->pi.MrgIf.px.d = __max(pW->pi.MrgIf.px.d, pW->pi.MrgIf.pxMin.d);
		//	őlȏJbg
		pW->pi.MrgIf.px.l = __min(pW->pi.MrgIf.px.l, pW->pi.MrgIf.pxMax.l);
		pW->pi.MrgIf.px.r = __min(pW->pi.MrgIf.px.r, pW->pi.MrgIf.pxMax.r);
		pW->pi.MrgIf.px.u = __min(pW->pi.MrgIf.px.u, pW->pi.MrgIf.pxMax.u);
		pW->pi.MrgIf.px.d = __min(pW->pi.MrgIf.px.d, pW->pi.MrgIf.pxMax.d);
		//	ItZbgZ
		pW->pi.MrgIf.px.l = (pW->pi.MrgIf.px.l > pW->pi.OffsetX ? pW->pi.MrgIf.px.l - pW->pi.OffsetX : 0);
		pW->pi.MrgIf.px.r = (pW->pi.MrgIf.px.r > pW->pi.OffsetX ? pW->pi.MrgIf.px.r - pW->pi.OffsetX : 0);
		pW->pi.MrgIf.px.u = (pW->pi.MrgIf.px.u > pW->pi.OffsetY ? pW->pi.MrgIf.px.u - pW->pi.OffsetY : 0);
		pW->pi.MrgIf.px.d = (pW->pi.MrgIf.px.d > pW->pi.OffsetY ? pW->pi.MrgIf.px.d - pW->pi.OffsetY : 0);

		//----- ]`ʒuC ------//
		pW->pi.x	= pW->pi.MrgIf.px.l;
		pW->pi.y	= pW->pi.MrgIf.px.u;
		pW->pi.cx	= pW->pi.cxPage - (pW->pi.MrgIf.px.l + pW->pi.MrgIf.px.r);
		pW->pi.cy	= pW->pi.cyPage - (pW->pi.MrgIf.px.u + pW->pi.MrgIf.px.d);

		//----- v^ݒς݃tO ------//
		pW->fpi = TRUE;

		rc = TRUE;
	}
	return rc;
}
