#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	Œ蒷L[i`Xgj																					//
//																												//
//**************************************************************************************************************//


#define	INST_ID			0x92654196
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)


//==============================================================================================================//
//	`XgiŒ蒷f[^j																				//
//==============================================================================================================//
//--------------------------------------------------------------------------------------------------------------//
//	}N																									//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCFQUE_ENTER		if (pW->fMultiThread) EnterCriticalSection(&pW->cs);
#define		AJCFQUE_LEAVE		if (pW->fMultiThread) LeaveCriticalSection(&pW->cs);

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	DatSize  - m[hf[^TCYioCgj														//
//				cbp 	 - R[obNp^																	//
//				cbRemove - m[hʒmpR[obNisv͂mtkkj										//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
AJCEXPORT HAJCFQUE	WINAPI	AjcFQueCreate(UI DatSize, UX cbp, VO (CALLBACK *cbRemove)(VOP pDat, UX cbp))
{
	HAJCFQUE  pW;

	if ((pW = (HAJCFQUE)AJCMEM(sizeof(AJCFQUE))) != NULL) {
		memset(pW, 0, sizeof *pW);
		pW->InstID	= INST_ID;
		pW->pTop	= NULL;
		pW->pLas	= NULL;
		pW->num		= 0;
		pW->len 	= DatSize;
		pW->cbp 	= cbp;
		pW->cbRemove= cbRemove;
	}

	return pW;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI	AjcFQueDelete(HAJCFQUE pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AjcFQuePurge(pW);
		if (pW->fMultiThread) {
			DeleteCriticalSection(&pW->cs);
		}
		free(pW);
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	}`Xbh̋^֎~																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				fEnable - FALSE : }`Xbh֎~															//
//						  TRUE	: }`Xbh															//
//																												//
//	߂l	F	Ő^֎~																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcFQueEnableMultiThread(HAJCFQUE pW, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		rc = pW->fMultiThread;
		if (fEnable) {
			if (!pW->fMultiThread) {
				InitializeCriticalSection(&pW->cs);
				pW->fMultiThread = TRUE;
			}
		}
		else {
			if (pW->fMultiThread) {
				pW->fMultiThread = FALSE;
				DeleteCriticalSection(&pW->cs);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	փm[hǉ																							//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - ֑}m[hf[^̃AhX														//
//																												//
//	߂l	F	TRUE  / NULL - ǉm[h̃AhX														//
//				FALSE / NULL - G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcFQueEnque	(HAJCFQUE pW, C_VOP pDat)
{
	return (AjcFQueEnqueEx(pW, pDat) != NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	VOP		WINAPI	AjcFQueEnqueEx	(HAJCFQUE pW, C_VOP pDat)
{
	VOP			rc = NULL;
	PAJCFQNODE	pNew;

	if (IS_MY_INST(pW) && pDat != NULL) {
		AJCFQUE_ENTER
		if ((pNew = (PAJCFQNODE)AJCMEM(sizeof(AJCFQNODE) + pW->len)) != NULL) {	//	ubN蓖āCH
			pNew->pNxt = 0;														//		Vakj
			memcpy(pNew + 1, pDat, pW->len);									//		E
			if (pW->pLas == NULL) {												//		L[COH
				pW->pTop = pW->pLas = pNew;										//			VakjL[CO
			}
			else {																//		ǉL[COH
				pW->pLas->pNxt = pNew;											//			Vakj𖖔փL[CO
				pW->pLas	   = pNew;											//			E
			}
			pW->num++;															//		m[hXV
			rc = pNew + 1;														//		߂lnj
		}
		else {																	//	ubN蓖āCsH
			rc = NULL;															//		߂lG[
		}
		AJCFQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	擪փm[h}																							//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pDat - 擪֑}m[hf[^̃AhX														//
//																												//
//	߂l	F	TRUE  / NULL - ǉm[h̃AhX														//
//				FALSE / NULL - G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcFQueEnqTop	(HAJCFQUE pW, C_VOP pDat)
{
	return (AjcFQueEnqTopEx(pW, pDat) != NULL);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	VOP		WINAPI	AjcFQueEnqTopEx	(HAJCFQUE pW, C_VOP pDat)
{
	VOP			rc = NULL;
	PAJCFQNODE	pNew;

	if (IS_MY_INST(pW) && pDat != NULL) {
		AJCFQUE_ENTER
		if ((pNew = (PAJCFQNODE)AJCMEM(sizeof(AJCFQNODE) + pW->len)) != NULL) {		//	ubN蓖āCH
			memcpy(pNew + 1, pDat, pW->len);									//		E
			if (pW->pTop == NULL) {												//		L[COH
				pNew->pNxt = NULL;												//			VakjL[CO
				pW->pTop = pW->pLas = pNew;										//			E
			}
			else {																//		ǉL[COH
				pNew->pNxt = pW->pTop;											//			Vakj擪փL[CO
				pW->pTop   = pNew;												//			E
			}
			pW->num++;															//		m[hXV
			rc = pNew + 1;														//		߂lnj
		}
		else {																	//	ubN蓖āCsH
			rc = NULL;															//		߂lG[
		}
		AJCFQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	擪m[ho																						//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pBuf - om[h̃f[^i[obt@̃AhXisv͂mtkkj					//
//																												//
//	߂l	F	OFom[hf[^̃oCg															//
//				OFm[hȂ																				//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcFQueDeque	(HAJCFQUE pW, VOP pBuf)
{
	UI			rc = 0;
	PAJCFQNODE	pCur;

	if (IS_MY_INST(pW)) {
		AJCFQUE_ENTER
		if ((pCur = pW->pTop) != NULL) {							//	m[hH
			if ((pW->pTop = pCur->pNxt) == NULL) {					//		擪m[hOC̃m[hȂH
				pW->pLas = NULL;									//			Xg|C^mtkk
			}
			if (pBuf != NULL) memcpy(pBuf, (pCur + 1), pW->len);	//		obt@փm[hf[^Rs[
			rc = pW->len;											//		߂lm[hf[^TCY
			free(pCur);												//		Om[hJ
			pW->num--;												//		m[hZ
		}
		else {														//	m[hȂH
			rc = 0;													//		߂lm[hȂ
		}
		AJCFQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[h																							//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//				xp		  - R[obNp^																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL	  WINAPI	AjcFQuePurge(HAJCFQUE pW)
{
	BOOL		rc = FALSE;
	PAJCFQNODE	pCur, svp;

	if (IS_MY_INST(pW)) {
		AJCFQUE_ENTER
		pCur = pW->pTop;									//	擪akjAhXݒ
		while (pCur) {										//	Sakj[v
			if (pW->cbRemove) {								//		ʒmR[obNH
				pW->cbRemove(pCur + 1, pW->cbp);			//			R[obN
			}
			svp = pCur;										//		akjAhXޔ
			pCur = pCur->pNxt;								//		̂akjAhXݒ
			free(svp);										//		akjJ
		}
		pW->pTop = pW->pLas = NULL;							//	L[`FC|C^
		pW->num = 0;										//	m[hO
		AJCFQUE_LEAVE
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	݂̃m[h𓾂																						//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//																												//
//	߂l	F	݂̃m[h																					//
//==============================================================================================================//
AJCEXPORT	UI	  WINAPI	AjcFQueGetCount	(HAJCFQUE pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AJCFQUE_ENTER
		rc = pW->num;
		AJCFQUE_LEAVE
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI	  WINAPI	AjcFQueNumber	(HAJCFQUE pW)
{
	return AjcFQueGetCount(pW);
}

//==============================================================================================================//
//	Q̂krs\A																					//
//																												//
//	@	F	pW 	 - CX^Xnh																		//
//				pSrc - Akrs̃nhîkrs͋ɂȂ܂j										//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcFQueMerge	(HAJCFQUE pW, HAJCFQUE pSrc)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && IS_MY_INST(pSrc)) {
		AJCFQUE_ENTER
		if (pSrc->fMultiThread) EnterCriticalSection(&pSrc->cs);
		if (pW->pLas == 0) {				//	AɃm[hȂH
			pW->pTop = pSrc->pTop;			//		A`FCAAփRs[
			pW->pLas = pSrc->pLas;			//		E
			pW->num  = pSrc->num;			//		E
		}
		else if (pSrc->num) {				//	AɃm[h & Am[hH
			pW->pLas->pNxt = pSrc->pTop;	//		A`FCAA̖֒ǉ
			pW->pLas	   = pSrc->pLas;	//		E
			pW->num += pSrc->num;			//		E
		}
		pSrc->pTop = NULL;					//	A`FCZbg
		pSrc->pLas = NULL;					//	E
		pSrc->num  = 0;						//	E
		if (pSrc->fMultiThread) LeaveCriticalSection(&pSrc->cs);
		AJCFQUE_LEAVE
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	擪m[hf[^̃AhX𓾂																			//
//																												//
//	@	F	pW 	   - CX^Xnh																	//
//																												//
//	߂l	F	mtkkF擪m[hf[^̃AhX															//
//				mtkkFm[hȂ																			//
//==============================================================================================================//
AJCEXPORT	VOP   WINAPI	AjcFQueTopNode	(HAJCFQUE pW)
{
	VOP		rc = NULL;

	if (IS_MY_INST(pW)) {
		AJCFQUE_ENTER
		if (pW->pTop != NULL) {				//	擪m[hH
			rc = pW->pTop + 1;				//		߂l擪m[h̃f[^AhX
		}
		else {								//	擪m[hȂi󃊃Xgj
			rc = NULL;						//		߂lmtkk
		}
		AJCFQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	̃m[hf[^̃AhX𓾂																			//
//																												//
//	@	F	pW 	   - CX^Xnh																	//
//																												//
//	߂l	F	mtkkF̃m[hf[^̃AhX															//
//				mtkkFm[hȂ																			//
//==============================================================================================================//
AJCEXPORT	VOP   WINAPI	AjcFQueNextNode	(HAJCFQUE pW, C_VOP pCurrentNode)
{
	VOP			rc = NULL;
	PAJCFQNODE	pNode;

	if (IS_MY_INST(pW)) {
		AJCFQUE_ENTER
		if (pCurrentNode) {						//	m[hH
			pNode = (PAJCFQNODE)pCurrentNode;	//		m[h̃m[h擪AhXݒ
			pNode--;							//		E
			if (pNode = pNode->pNxt) {			//		m[hH
				rc = pNode + 1;					//			߂lm[h̃f[^AhX
			}
			else {								//		m[hȂH
				rc = NULL;						//			߂lmtkk
			}
		}
		else {									//	m[hȂH
			rc = NULL;							//		߂lmtkk
		}
		AJCFQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z񐶐																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pNum		- zvfi[obt@̃AhX											//
//																												//
//	߂l	F	NULL : Sm[hւ̃|C^z̐擪AhX													//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT PCAJCFQUEPTR WINAPI AjcFQueCreatePtrArr (HAJCFQUE pW, UIP pNum)
{
	PAJCFQUEPTR	rc	  = NULL;
	PAJCFQUEPTR pArr  = NULL;
	VOP			pNode = NULL;
	UI			ix	  = 0;

	if (IS_MY_INST(pW)) {
		AJCFQUE_ENTER
		if (pArr  =  (PAJCFQUEPTR)AJCMEM(sizeof(AJCFQUEPTR) * (pW->num + 1))) {
			memset(pArr, 0, sizeof(AJCFQUEPTR) * (pW->num + 1));
			if (pNode = AjcFQueTopNode(pW)) {
				do {
					pArr[ix].pNode = pNode;
					ix++;
				} while (pNode = AjcFQueNextNode(pW, pNode));
			}
			if (pNum != NULL) *pNum = ix;
			rc = pArr;
		}
		AJCFQUE_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z																				//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				pArr		 - Sm[hւ̃|C^z̐擪AhX											//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO	 		 WINAPI AjcFQueReleasePtrArr(HAJCFQUE pW, PCAJCFQUEPTR pArr)
{
	if (IS_MY_INST(pW)) {
		AJCFQUE_ENTER
		if (pArr != NULL) free((VOP)pArr);
		AJCFQUE_LEAVE
	}
}
