#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	WXgANZX																							//
//																												//
//**************************************************************************************************************//
extern	BCP		SubProfileGenerateBinFileA(BOOL fVolatile, C_BCP pTail, BC full[MAX_PATH], C_BCP pBinDir);
extern	WCP		SubProfileGenerateBinFileW(BOOL fVolatile, C_WCP pTail, WC full[MAX_PATH], C_WCP pBinDir);

extern	BOOL	SubProfileDeleteBinFileA(C_BCP pTail, C_BCP pBinDir);
extern	BOOL	SubProfileDeleteBinFileW(C_WCP pTail, C_WCP pBinDir);

//--------------------------------------------------------------------------------------------------------------//
//	Ɨ̈																									//
//--------------------------------------------------------------------------------------------------------------//
//	oCif[^i[fBNgpX
static	BC		BinDataDirA[MAX_PATH] = {0};
static	WC		BinDataDirW[MAX_PATH] = {0};

static	WC		SvPath[AJCMAX_REGPATH] = {0};
static	REGSAM	SvAccess = 0;
static	HKEY	hKeyTop  = HKEY_CURRENT_USER;
static	HKEY	hRegKey  = NULL;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	HKEY	SubOpenKeyA  (C_BCP pPath, C_BCP pSec, REGSAM acc);
static	HKEY	SubOpenKeyW  (C_WCP pPath, C_WCP pSec, REGSAM acc);

static	HKEY	SubOpenTempKeyA(C_BCP pPath, C_BCP pSec, REGSAM acc);
static	HKEY	SubOpenTempKeyW(C_WCP pPath, C_WCP pSec, REGSAM acc);

static	HKEY	SubCreateKeyA(C_BCP pPath, C_BCP pSec, REGSAM acc, BOOL fVolatile);
static	HKEY	SubCreateKeyW(C_WCP pPath, C_WCP pSec, REGSAM acc, BOOL fVolatile);

static	BCP		SearchPathItemA(BCP pStr, C_BCP path);
static	WCP		SearchPathItemW(WCP pStr, C_WCP path);

static	VO		AdjustSemiCollonA(BCP pStr);
static	VO		AdjustSemiCollonW(WCP pStr);

static	VO		ValidateToEnvironment(VO);

//==============================================================================================================//
//	WXgEgbvL[ݒ																					//
//																												//
//	@F	hKey		- [gEWXgEL[nh													//
//																												//
//	߂lF	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO		WINAPI	AjcSetRegTopKey(HKEY hKey)
{
	AjcCloseRegFile();
	hKeyTop = hKey;

}
//==============================================================================================================//
//	WXgEgbvL[擾																					//
//																												//
//	@F	Ȃ																							//
//																												//
//	߂lF	[gEWXgEL[nh																//
//==============================================================================================================//
AJCEXPORT HKEY	 WINAPI	AjcGetRegTopKey(VO)
{
	return hKeyTop;
}
//==============================================================================================================//
//	oCif[^i[fBNgpXݒ																		//
//																												//
//	@	F	pBinDir	   - oCif[^i[fBNgpXiNULL̏ꍇ́Aۑj						//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcSetRegBinDirA(C_BCP pBinDir)
{
	if (pBinDir != NULL && *pBinDir != 0) {
		AjcSnPrintFA(BinDataDirA, MAX_PATH, "%s", pBinDir);
		AjcPathCatA(BinDataDirA, "", MAX_PATH);
		BinDataDirA[MAX_PATH - 1] = 0;
	}
	else {
		AjcGetAppPathA(BinDataDirA, MAX_PATH);
	}
	MultiByteToWideChar(CP_ACP, 0, BinDataDirA, -1, BinDataDirW, MAX_PATH);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcSetRegBinDirW(C_WCP pBinDir)
{
	if (pBinDir != NULL && *pBinDir != 0) {
		AjcSnPrintFW(BinDataDirW, MAX_PATH, L"%s", pBinDir);
		AjcPathCatW(BinDataDirW, L"", MAX_PATH);
		BinDataDirW[MAX_PATH - 1] = 0;
		
	}
	else {
		AjcGetAppPathW(BinDataDirW, MAX_PATH);
	}
	WideCharToMultiByte(CP_ACP, 0, BinDataDirW, -1, BinDataDirA, MAX_PATH, NULL, NULL);
}
//==============================================================================================================//
//	oCif[^i[fBNgpX擾																		//
//																												//
//	@	F	pBuf	- oCif[^i[fBNgpXi[obt@̃AhX						//
//				lBuf	- oCif[^i[fBNgpXi[obt@̕							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcGetRegBinDirA(BCP pBuf, UI lBuf)
{
	if (pBuf != NULL  &&  lBuf > 0) {
		AjcSnPrintFA(pBuf, lBuf, "%s", BinDataDirA);
	}
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcGetRegBinDirW(WCP pBuf, UI lBuf)
{
	if (pBuf != NULL  &&  lBuf > 0) {
		AjcSnPrintFW(pBuf, lBuf, L"%s", BinDataDirW);
	}
}

//==============================================================================================================//
//	WXgt@Cǂݏoilj																			//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				defValue	- ftHgl																		//
//																												//
//	߂lF	WXgt@CǂݏoYL[l^ftHgl										//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
#define	M_GSGETPROFILEN_A(_T1_, _T2_, _CV_)																		\
AJCEXPORT _T1_ 	WINAPI AjcGetRegFile##_T2_##A(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, _T1_ defValue)		\
{	_T1_	rc = defValue;																						\
	HKEY	hKey;																								\
	UL		bytes = sizeof(_T1_);																				\
	UL		type  = _CV_;																						\
	hKey = SubOpenKeyA(pPath, pSecName, KEY_READ);																\
	if (hKey != NULL) {																							\
		_T1_	n;																								\
		if (RegQueryValueExA(hKey, pKeyName, NULL, &type, (LPBYTE)&n, &bytes) == ERROR_SUCCESS) {				\
			rc = n;																								\
		}																										\
	}																											\
	return rc;																									\
}
M_GSGETPROFILEN_A(UI	, UInt, REG_DWORD)
M_GSGETPROFILEN_A(SI	, SInt, REG_DWORD)
M_GSGETPROFILEN_A(UI	, Hex , REG_DWORD)
M_GSGETPROFILEN_A(double, Real, REG_BINARY)
M_GSGETPROFILEN_A(ULL	, UI64, REG_BINARY)
M_GSGETPROFILEN_A(SLL	, SI64, REG_BINARY)
M_GSGETPROFILEN_A(ULL	, H64 , REG_BINARY)

//----- Chp -------------------------------------------------------------------------------------------//
#define	M_GSGETPROFILEN_W(_T1_, _T2_, _CV_)																		\
AJCEXPORT _T1_ 	WINAPI AjcGetRegFile##_T2_##W(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, _T1_ defValue)		\
{	_T1_	rc = defValue;																						\
	HKEY	hKey;																								\
	UL		bytes = sizeof(_T1_);																				\
	UL		type  = _CV_;																						\
	hKey = SubOpenKeyW(pPath, pSecName, KEY_READ);																\
	if (hKey != NULL) {																							\
		_T1_	n;																								\
		if (RegQueryValueExW(hKey, pKeyName, NULL, &type, (LPBYTE)&n, &bytes) == ERROR_SUCCESS) {				\
			rc = n;																								\
		}																										\
	}																											\
	return rc;																									\
}
M_GSGETPROFILEN_W(UI	, UInt, REG_DWORD)
M_GSGETPROFILEN_W(SI	, SInt, REG_DWORD)
M_GSGETPROFILEN_W(UI	, Hex , REG_DWORD)
M_GSGETPROFILEN_W(double, Real, REG_BINARY)
M_GSGETPROFILEN_W(ULL	, UI64, REG_BINARY)
M_GSGETPROFILEN_W(SLL	, SI64, REG_BINARY)
M_GSGETPROFILEN_W(ULL	, H64 , REG_BINARY)

//==============================================================================================================//
//	WXgt@Cǂݏoizj																		//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				pArray		- ǂݏoli[鐮z̃AhX											//
//				lArray		- z̗vfTCYiPCQCS or Wj											//
//				nArray		- z̗vf																	//
//																												//
//	߂lF	WXgt@Cǂݏoľ													//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileArrA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, VOP pArray, UI lArray, UI nArray)
{
	UI		rc = 0;
	HKEY	hKey;
	UL		bytes = lArray * nArray;
	UL		type  = REG_BINARY;

	if (pArray != NULL) {
		hKey = SubOpenKeyA(pPath, pSecName, KEY_READ);
		if (hKey != NULL && RegQueryValueExA(hKey, pKeyName, NULL, &type, pArray, &bytes) == ERROR_SUCCESS &&
			type == REG_BINARY) {
			rc = bytes / lArray;
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileArrW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, VOP pArray, UI lArray, UI nArray)
{
	UI		rc = 0;
	HKEY	hKey;
	UL		bytes = lArray * nArray;
	UL		type  = REG_BINARY;

	if (pArray != NULL) {
		hKey = SubOpenKeyW(pPath, pSecName, KEY_READ);
		if (hKey != NULL && RegQueryValueExW(hKey, pKeyName, NULL, &type, pArray, &bytes) == ERROR_SUCCESS &&
			type == REG_BINARY) {
			rc = bytes / lArray;
		}
	}
	return rc;
}
//==============================================================================================================//
//	WXgt@Cǂݏoij																		//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				pDefStr		- ftHgl																		//
//				pBuf		- ǂݏoi[obt@̃AhX										//
//				lBuf		- ǂݏoi[obt@̃oCg^								//
//																												//
//	߂lF	ǂݏoL[l̕ioCg^j													//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileStrA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, C_BCP pDefStr, BCP pBuf, UI lBuf)
{
	UI		rc = 0;
	HKEY	hKey;
	UL		bytes = lBuf;
	UL		type  = REG_SZ;

	if (pDefStr != NULL) {
		hKey = SubOpenKeyA(pPath, pSecName, KEY_READ);
		if (hKey != NULL && RegQueryValueExA(hKey, pKeyName, NULL, &type, pBuf, &bytes) == ERROR_SUCCESS &&
			type == REG_SZ) {
			rc = (UI)strlen(pBuf);
		}
		else {
			strncpy(pBuf, pDefStr, lBuf);
			pBuf[lBuf - 1] = 0;
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileStrW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, C_WCP pDefStr, WCP pBuf, UI lBuf)
{
	UI		rc = 0;
	HKEY	hKey;
	UL		bytes = lBuf * 2;
	UL		type  = REG_SZ;

	if (pDefStr != NULL) {
		hKey = SubOpenKeyW(pPath, pSecName, KEY_READ);
		if (hKey != NULL && RegQueryValueExW(hKey, pKeyName, NULL, &type, (BCP)pBuf, &bytes) == ERROR_SUCCESS &&
			type == REG_SZ) {
			rc = (UI)wcslen(pBuf);
		}
		else {
			wcsncpy(pBuf, pDefStr, lBuf);
			pBuf[lBuf - 1] = 0;
		}
	}
	return rc;
}
//==============================================================================================================//
//	WXgt@CǂݏoiWJj																	//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				pDefStr		- ftHgl																		//
//				pBuf		- ǂݏoi[obt@̃AhX										//
//				lBuf		- ǂݏoi[obt@̃oCg^								//
//																												//
//	߂lF	ǂݏoL[l̕ioCg^j													//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileExpA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, C_BCP pDefStr, BCP pBuf, UI lBuf)
{
	UI		rc = 0;
	HKEY	hKey;
	UL		bytes = lBuf;
	UL		type  = REG_EXPAND_SZ;

	if (pDefStr != NULL) {
		hKey = SubOpenKeyA(pPath, pSecName, KEY_READ);
		if (hKey != NULL && RegQueryValueExA(hKey, pKeyName, NULL, &type, pBuf, &bytes) == ERROR_SUCCESS &&
			type == REG_EXPAND_SZ) {
			rc = (UI)strlen(pBuf);
		}
		else {
			strncpy(pBuf, pDefStr, lBuf);
			pBuf[lBuf - 1] = 0;
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileExpW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, C_WCP pDefStr, WCP pBuf, UI lBuf)
{
	UI		rc = 0;
	HKEY	hKey;
	UL		bytes = lBuf * 2;
	UL		type  = REG_EXPAND_SZ;

	if (pDefStr != NULL) {
		hKey = SubOpenKeyW(pPath, pSecName, KEY_READ);
		if (hKey != NULL && RegQueryValueExW(hKey, pKeyName, NULL, &type, (BCP)pBuf, &bytes) == ERROR_SUCCESS &&
			type == REG_EXPAND_SZ) {
			rc = (UI)wcslen(pBuf);
		}
		else {
			wcsncpy(pBuf, pDefStr, lBuf);
			pBuf[lBuf - 1] = 0;
		}
	}
	return rc;
}
//==============================================================================================================//
//	WXgt@CǂݏoioCif[^j																//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				pBuf		- ǂݏooCif[^i[obt@̃AhXioCg擾NULL)	//
//				lBuf		- ǂݏooCif[^i[obt@̃oCg								//
//																												//
//	߂lF	ǂݏof[^̃oCgiG[͂Oj														//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileBinA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, VOP pBuf, UI lBuf)
{
	return AjcGetRegFileBinExA(pPath, pSecName, pKeyName, pBuf, lBuf, BinDataDirA);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileBinW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, VOP pBuf, UI lBuf)
{
	return AjcGetRegFileBinExW(pPath, pSecName, pKeyName, pBuf, lBuf, BinDataDirW);
}
//==============================================================================================================//
//	WXgt@CǂݏoioCif[^CoCif[^tH_wj									//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				pBuf		- ǂݏooCif[^i[obt@̃AhXioCg擾NULL)	//
//				lBuf		- ǂݏooCif[^i[obt@̃oCg								//
//				pBinDir		- oCif[^tH_															//
//																												//
//	߂lF	ǂݏof[^̃oCgiG[͂Oj														//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileBinExA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, VOP pBuf, UI lBuf, C_BCP pBinDir)
{
	UI		rc = 0;
	UI		len;
	HANDLE	hFile;
	BC		tail[MAX_PATH];
	BC		path[MAX_PATH];

	if (AjcGetRegFileStrA(pPath, pSecName, pKeyName, "", tail, MAX_PATH) != 0) {
		if (SubProfileGenerateBinFileA(0, tail, path, pBinDir) != NULL) {
			if ((hFile = CreateFileA(path, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
				if (pBuf != NULL) {
					ReadFile(hFile, pBuf, lBuf, &rc, NULL);
				}
				else {
					if ((len = GetFileSize(hFile, NULL)) != 0xFFFFFFFF) {
						rc = len;
					}
				}
				CloseHandle(hFile);
			}
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetRegFileBinExW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, VOP pBuf, UI lBuf, C_WCP pBinDir)
{
	UI		rc = 0;
	UI		len;
	HANDLE	hFile;
	WC		tail[MAX_PATH];
	WC		path[MAX_PATH];

	if (AjcGetRegFileStrW(pPath, pSecName, pKeyName, L"", tail, MAX_PATH) != 0) {
		if (SubProfileGenerateBinFileW(0, tail, path, pBinDir) != NULL) {
			if ((hFile = CreateFileW(path, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
				if (pBuf != NULL) {
					ReadFile(hFile, pBuf, lBuf, &rc, NULL);
				}
				else {
					if ((len = GetFileSize(hFile, NULL)) != 0xFFFFFFFF) {
						rc = len;
					}
				}
				CloseHandle(hFile);
			}
		}
	}
	return rc;
}


//==============================================================================================================//
//	WXgt@C݁ilj																			//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				fVolatile	- FALSE:PvL^CTRUE:ꎞL^														//
//				Value		- ݒl																		//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
#define	M_GSPUTPROFILEN_A(_T1_, _T2_, _CV_)																				\
AJCEXPORT BOOL WINAPI AjcPutRegFile##_T2_##A(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, BOOL fVolatile, _T1_ Value)	\
{																														\
	BOOL	rc = FALSE;																									\
	HKEY	hKey;																										\
	if (hKey = SubCreateKeyA(pPath, pSecName, KEY_ALL_ACCESS, fVolatile)) {												\
		rc = (RegSetValueExA(hKey, pKeyName, 0, _CV_, (LPBYTE)&Value, sizeof(_T1_)) == ERROR_SUCCESS);					\
	}																													\
	return rc;																											\
}
M_GSPUTPROFILEN_A(UI	, UInt, REG_DWORD )
M_GSPUTPROFILEN_A(SI	, SInt, REG_DWORD )
M_GSPUTPROFILEN_A(UI	, Hex , REG_DWORD )
M_GSPUTPROFILEN_A(double, Real, REG_BINARY)
M_GSPUTPROFILEN_A(ULL	, UI64, REG_BINARY)
M_GSPUTPROFILEN_A(SLL	, SI64, REG_BINARY)
M_GSPUTPROFILEN_A(ULL	, H64 , REG_BINARY)

//----- Chp -------------------------------------------------------------------------------------------//
#define	M_GSPUTPROFILEN_W(_T1_, _T2_, _CV_)																				\
AJCEXPORT BOOL WINAPI AjcPutRegFile##_T2_##W(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, BOOL fVolatile, _T1_ Value)	\
{																														\
	BOOL	rc = FALSE;																									\
	HKEY	hKey;																										\
	if (hKey = SubCreateKeyW(pPath, pSecName, KEY_ALL_ACCESS, fVolatile)) {												\
		rc = (RegSetValueExW(hKey, pKeyName, 0, _CV_, (LPBYTE)&Value, sizeof(_T1_)) == ERROR_SUCCESS);					\
	}																													\
	return rc;																											\
}
M_GSPUTPROFILEN_W(UI	, UInt, REG_DWORD )
M_GSPUTPROFILEN_W(SI	, SInt, REG_DWORD )
M_GSPUTPROFILEN_W(UI	, Hex , REG_DWORD )
M_GSPUTPROFILEN_W(double, Real, REG_BINARY)
M_GSPUTPROFILEN_W(ULL	, UI64, REG_BINARY)
M_GSPUTPROFILEN_W(SLL	, SI64, REG_BINARY)
M_GSPUTPROFILEN_W(ULL	, H64 , REG_BINARY)

//==============================================================================================================//
//	WXgt@C݁izj																		//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				fVolatile	- FALSE:PvL^CTRUE:ꎞL^														//
//				pArray		- ݒli[ꂽz̃AhX											//
//				lArray		- z̗vfTCYiPCQ or Sj												//
//				nArray		- z̗vf																	//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileArrA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, BOOL fVolatile, VOP pArray, UI lArray, UI nArray)
{
	BOOL	rc = FALSE;
	HKEY	hKey;

	if (pArray != NULL) {
		if (hKey = SubCreateKeyA(pPath, pSecName, KEY_ALL_ACCESS, fVolatile)) {
			rc = (RegSetValueExA(hKey, pKeyName, 0, REG_BINARY, pArray, lArray * nArray) == ERROR_SUCCESS);
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileArrW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, BOOL fVolatile, VOP pArray, UI lArray, UI nArray)
{
	BOOL	rc = FALSE;
	HKEY	hKey;

	if (pArray != NULL) {
		if (hKey = SubCreateKeyW(pPath, pSecName, KEY_ALL_ACCESS, fVolatile)) {
			rc = (RegSetValueExW(hKey, pKeyName, 0, REG_BINARY, pArray, lArray * nArray) == ERROR_SUCCESS);
		}
	}
	return rc;
}

//==============================================================================================================//
//	WXgt@C݁ij																		//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				fVolatile	- FALSE:PvL^CTRUE:ꎞL^														//
//				pStr		- ޕ̃AhX															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileStrA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, BOOL fVolatile, C_BCP pStr)
{
	BOOL	rc = FALSE;
	HKEY	hKey;

	if (pStr != NULL) {
		if (hKey = SubCreateKeyA(pPath, pSecName, KEY_ALL_ACCESS, fVolatile)) {
			rc = (RegSetValueExA(hKey, pKeyName, 0, REG_SZ, pStr, (DWORD)(strlen(pStr) + 1)) == ERROR_SUCCESS);
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileStrW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, BOOL fVolatile, C_WCP pStr)
{
	BOOL	rc = FALSE;
	HKEY	hKey;

	if (pStr != NULL) {
		if (hKey = SubCreateKeyW(pPath, pSecName, KEY_ALL_ACCESS, fVolatile)) {
			rc = (RegSetValueExW(hKey, pKeyName, 0, REG_SZ, (C_BCP)pStr, (DWORD)(wcslen(pStr) + 1) * 2) == ERROR_SUCCESS);
		}
	}
	return rc;
}
//==============================================================================================================//
//	WXgt@C݁iWJj																	//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				fVolatile	- FALSE:PvL^CTRUE:ꎞL^														//
//				pStr		- ޕ̃AhX															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileExpA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, BOOL fVolatile, C_BCP pStr)
{
	BOOL	rc = FALSE;
	HKEY	hKey;

	if (pStr != NULL) {
		if (hKey = SubCreateKeyA(pPath, pSecName, KEY_ALL_ACCESS, fVolatile)) {
			rc = (RegSetValueExA(hKey, pKeyName, 0, REG_EXPAND_SZ, pStr, (DWORD)(strlen(pStr) + 1)) == ERROR_SUCCESS);
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileExpW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, BOOL fVolatile, C_WCP pStr)
{
	BOOL	rc = FALSE;
	HKEY	hKey;

	if (pStr != NULL) {
		if (hKey = SubCreateKeyW(pPath, pSecName, KEY_ALL_ACCESS, fVolatile)) {
			rc = (RegSetValueExW(hKey, pKeyName, 0, REG_EXPAND_SZ, (C_BCP)pStr, (DWORD)(wcslen(pStr) + 1) * 2) == ERROR_SUCCESS);
		}
	}
	return rc;
}
//==============================================================================================================//
//	WXgt@C݁ioCif[^j																//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				fVolatile	- FALSE:PvL^CTRUE:ꎞL^														//
//				pDat		- ރoCif[^̃AhX													//
//				lDat		- ރoCif[^̃oCg													//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileBinA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, BOOL fVolatile, C_VOP pDat, UI lDat)
{
	return AjcPutRegFileBinExA(pPath, pSecName, pKeyName, fVolatile, pDat, lDat, BinDataDirA);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileBinW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, BOOL fVolatile, C_VOP pDat, UI lDat)
{
	return AjcPutRegFileBinExW(pPath, pSecName, pKeyName, fVolatile, pDat, lDat, BinDataDirW);
}
//==============================================================================================================//
//	WXgt@C݁ioCif[^CoCif[^tH_wj									//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pKeyName	- L[̃AhXiK荀ڂ̏ꍇNULL)											//
//				fVolatile	- FALSE:PvL^CTRUE:ꎞL^														//
//				pDat		- ރoCif[^̃AhX													//
//				lDat		- ރoCif[^̃oCg													//
//				pBinDir		- oCif[^tH_															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileBinExA(C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, BOOL fVolatile, C_VOP pDat, UI lDat, C_BCP pBinDir)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;
	UL		bytes;
	BCP		pTail;
	BC		tail[MAX_PATH];
	BC		path[MAX_PATH];

	do {
		//----- NULL`FbN -----------------------------------------------------------------------------------//
		if (pDat	 == NULL) break;
		//----- oCit@Cݒ -------------------------------------------------------------------------//
		if (AjcGetRegFileStrA(pPath, pSecName, pKeyName, "", tail, MAX_PATH) != 0) {
			if ((pTail = SubProfileGenerateBinFileA(fVolatile, tail, path, pBinDir)) == NULL) break;
		}
		else {
			if ((pTail = SubProfileGenerateBinFileA(fVolatile, NULL, path, pBinDir)) == NULL) break;
			if (!AjcPutRegFileStrA(pPath, pSecName, pKeyName, fVolatile, pTail)) {
				DeleteFileA(path);
				break;
			}
		}
		//----- oCit@C -----------------------------------------------------------------------//
		hFile = CreateFileA(path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile != INVALID_HANDLE_VALUE) {
			WriteFile(hFile, pDat, lDat, &bytes, NULL);
			CloseHandle(hFile);
			if (bytes == lDat) {
				rc = TRUE;
			}
			else {
				DeleteFileA(path);
			}
		}
		if (rc == FALSE) {
			AjcDelRegKeyA(pPath, pSecName, pKeyName);
		}
	} while(0);

	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcPutRegFileBinExW(C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, BOOL fVolatile, C_VOP pDat, UI lDat, C_WCP pBinDir)
{
	BOOL	rc = FALSE;
	HANDLE	hFile;
	UL		bytes;
	WCP		pTail;
	WC		tail[MAX_PATH];
	WC		path[MAX_PATH];

	do {
		//----- NULL`FbN -----------------------------------------------------------------------------------//
		if (pDat	 == NULL) break;
		//----- oCit@Cݒ -------------------------------------------------------------------------//
		if (AjcGetRegFileStrW(pPath, pSecName, pKeyName, L"", tail, MAX_PATH) != 0) {
			if ((pTail = SubProfileGenerateBinFileW(fVolatile, tail, path, pBinDir)) == NULL) break;
		}
		else {
			if ((pTail = SubProfileGenerateBinFileW(fVolatile, NULL, path, pBinDir)) == NULL) break;
			if (!AjcPutRegFileStrW(pPath, pSecName, pKeyName, fVolatile, pTail)) {
				DeleteFileW(path);
				break;
			}
		}
		//----- oCit@C -----------------------------------------------------------------------//
		hFile = CreateFileW(path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile != INVALID_HANDLE_VALUE) {
			WriteFile(hFile, pDat, lDat, &bytes, NULL);
			CloseHandle(hFile);
			if (bytes == lDat) {
				rc = TRUE;
			}
			else {
				DeleteFileW(path);
			}
		}
		if (rc == FALSE) {
			AjcDelRegKeyW(pPath, pSecName, pKeyName);
		}
	} while(0);

	return rc;
}

//==============================================================================================================//
//	WXgZNV폜																					//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcDelRegSectA	  (C_BCP pPath, C_BCP pSecName)
{
	return AjcDelRegSectExA(pPath, pSecName, BinDataDirA);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcDelRegSectW	  (C_WCP pPath, C_WCP pSecName)
{
	return AjcDelRegSectExW(pPath, pSecName, BinDataDirW);
}
//==============================================================================================================//
//	WXgZNV폜ioCif[^tH_wj														//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pBinDir		- oCif[^tH_															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcDelRegSectExA	  (C_BCP pPath, C_BCP pSecName, C_BCP pBinDir)
{
	BOOL	rc = FALSE;
	HKEY	hKey;
	UI		ix;
	UL		lName, lTail;
	BC		name[AJCMAX_REGPATH];
	BC		tail[MAX_PATH];

	//----- L[̑SĂ̒lƃoCit@C폜 ---------------------------------------------------------//
	if (hKey = SubOpenKeyA(pPath, pSecName, KEY_ALL_ACCESS)) {
		ix = 0;
		lName = AJCMAX_REGPATH; lTail = MAX_PATH;
		while(RegEnumValueA(hKey, ix, name, &lName, NULL, NULL, tail, &lTail) == ERROR_SUCCESS) {
			if (RegDeleteValueA(hKey, name) == ERROR_SUCCESS) {
				if (mbsstr(tail, "\\Ajr")) {
					SubProfileDeleteBinFileA(tail, pBinDir);
				}
			}
			else ix++;
			lName = AJCMAX_REGPATH; lTail = MAX_PATH;
		}
		AjcCloseRegFile();
	}
	//----- L[폜 ---------------------------------------------------------------------------------------//
	if (RegOpenKeyExA(hKeyTop, pPath, 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS) {
		rc = (RegDeleteKeyA(hKey, pSecName) != ERROR_SUCCESS);
		RegCloseKey(hKey);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcDelRegSectExW	  (C_WCP pPath, C_WCP pSecName, C_WCP pBinDir)
{
	BOOL	rc = FALSE;
	HKEY	hKey;
	UI		ix;
	UL		lName, lTail;
	UW		name[AJCMAX_REGPATH];
	UW		tail[MAX_PATH];

	//----- L[̑SĂ̒lƃoCit@C폜 ---------------------------------------------------------//
	if (hKey = SubOpenKeyW(pPath, pSecName, KEY_ALL_ACCESS)) {
		ix = 0;
		lName = AJCMAX_REGPATH; lTail = MAX_PATH;
		while(RegEnumValueW(hKey, ix, name, &lName, NULL, NULL, (VOP)tail, &lTail) == ERROR_SUCCESS) {
			if (RegDeleteValueW(hKey, name) == ERROR_SUCCESS) {
				if (wcsstr(tail, L"\\Ajr")) {
					SubProfileDeleteBinFileW(tail, pBinDir);
				}
			}
			else ix++;
			lName = AJCMAX_REGPATH; lTail = MAX_PATH;
		}
		AjcCloseRegFile();
	}
	//----- L[폜 ---------------------------------------------------------------------------------------//
	if (RegOpenKeyExW(hKeyTop, pPath, 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS) {
		rc = (RegDeleteKeyW(hKey, pSecName) != ERROR_SUCCESS);
		RegCloseKey(hKey);
	}
	return rc;
}

//==============================================================================================================//
//	WXgL[폜																							//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcDelRegKeyA	  (C_BCP pPath, C_BCP pSecName, C_BCP pKeyName)
{
	return AjcDelRegKeyExA(pPath, pSecName, pKeyName, BinDataDirA);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcDelRegKeyW	  (C_WCP pPath, C_WCP pSecName, C_WCP pKeyName)
{
	return AjcDelRegKeyExW(pPath, pSecName, pKeyName, BinDataDirW);
}
//==============================================================================================================//
//	WXgL[폜ioCif[^tH_wj															//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				pBinDir		- oCif[^tH_															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcDelRegKeyExA	  (C_BCP pPath, C_BCP pSecName, C_BCP pKeyName, C_BCP pBinDir)
{
	BOOL	rc = FALSE;
	HKEY	hKey;
	BC		tail[MAX_PATH];

	if (pKeyName != NULL) {
		//----- oCit@C폜 -----//
		if (AjcGetRegFileStrA(pPath, pSecName, pKeyName, "", tail, MAX_PATH) != 0) {
			SubProfileDeleteBinFileA(tail, pBinDir);
		}
		//----- L[폜 -----------------//
		if ((hKey = SubOpenKeyA(pPath, pSecName, KEY_ALL_ACCESS)) != NULL) {
			rc = (RegDeleteValueA(hKey, pKeyName) == ERROR_SUCCESS);
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcDelRegKeyExW	  (C_WCP pPath, C_WCP pSecName, C_WCP pKeyName, C_WCP pBinDir)
{
	BOOL	rc = FALSE;
	HKEY	hKey;
	UW		tail[MAX_PATH];

	if (pKeyName != NULL) {
		//----- oCit@C폜 -----//
		if (AjcGetRegFileStrW(pPath, pSecName, pKeyName, L"", tail, MAX_PATH) != 0) {
			SubProfileDeleteBinFileW(tail, pBinDir);
		}
		//----- L[폜 -----------------//
		if ((hKey = SubOpenKeyW(pPath, pSecName, KEY_ALL_ACCESS)) != NULL) {
			rc = (RegDeleteValueW(hKey, pKeyName) == ERROR_SUCCESS);
		}
	}
	return rc;
}

//==============================================================================================================//
//	WXgt@C擾																					//
//																												//
//	@F	pBuf		- ݃I[ṽWXgpXi[obt@̃AhX						//
//				lBuf		- ݃I[ṽWXgpXi[obt@̃oCg^				//
//																												//
//	߂lF	NULLF@WXgL[nh																//
//				NULLF@WXgL[͖I[v															//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT HKEY	 WINAPI AjcGetRegFileInfoA(BCP pBuf, int lBuf)
{
	HKEY	hKey = NULL;

	if (hRegKey) {
		hKey = hRegKey;
		if (pBuf != NULL && lBuf != 0) {
			WideCharToMultiByte(CP_ACP, 0, SvPath, -1, pBuf, lBuf, NULL, NULL);
		}
	}
	else {
		hKey = NULL;
		if (pBuf != NULL && lBuf != 0) {
			*pBuf = 0;
		}
	}
	return hKey;
}

//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT HKEY	 WINAPI AjcGetRegFileInfoW(WCP pBuf, int lBuf)
{
	HKEY	hKey = NULL;

	if (hRegKey) {
		hKey = hRegKey;
		if (pBuf != NULL && lBuf != 0) {
			wcsncpy(pBuf, SvPath, lBuf - 1);
			pBuf[lBuf - 1] = 0;
		}
	}
	else {
		hKey = NULL;
		if (pBuf != NULL && lBuf != 0) {
			*pBuf = 0;
		}
	}
	return hKey;
}
//==============================================================================================================//
//	WXgt@CN[Y																					//
//																												//
//	@F	Ȃ																							//
//																												//
//	߂lF	Ȃ																							//
//==============================================================================================================//
AJCEXPORT VO	 WINAPI AjcCloseRegFile(VO)
{
	if (hRegKey) {
		//	WXgL[N[Y
		RegCloseKey(hRegKey);
		hRegKey  = NULL;
		SvAccess = 0;
		memset(SvPath, 0, sizeof SvPath);
	}
}
//==============================================================================================================//
//	WXgZNVW																					//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				cbp			- R[obNp^																//
//				cb			- ZNVʒmR[obN֐isvNULL)								//
//																												//
//	߂lF	WZNV̌																		//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI AjcEnumRegSectA 	(C_BCP pPath, UX cbp, BOOL (CALLBACK *cb)(C_BCP pSect, UX cbp))
{
	int			rc = 0;
	HKEY		hKey;
	UI			ix, lSubKeyBuf;
	FILETIME	ft;
	BC			SubKeyName[512];
	LSTATUS		rsu;

	if ((hKey = SubOpenTempKeyA(pPath, NULL, KEY_READ)) != NULL) {
		ix = 0;
		lSubKeyBuf = AJCTSIZE(SubKeyName);
		while ((rsu = RegEnumKeyExA(hKey, ix, SubKeyName, &lSubKeyBuf, NULL, NULL, NULL, &ft)) != ERROR_NO_MORE_ITEMS) {
			if (rsu == ERROR_SUCCESS) {
				rc++;
				if (cb != NULL) {
					if (!cb(SubKeyName, cbp)) {
						break;
					}
				}
				ix++;
			}
			lSubKeyBuf = AJCTSIZE(SubKeyName);
		}
		RegCloseKey(hKey);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI AjcEnumRegSectW 	(C_WCP pPath, UX cbp, BOOL (CALLBACK *cb)(C_WCP pSect, UX cbp))
{
	int			rc = 0;
	HKEY		hKey;
	UI			ix, lSubKeyBuf;
	FILETIME	ft;
	UW			SubKeyName[512];
	LSTATUS		rsu;

	if ((hKey = SubOpenTempKeyW(pPath, NULL, KEY_READ)) != NULL) {
		ix = 0;
		lSubKeyBuf = AJCTSIZE(SubKeyName);
		while ((rsu = RegEnumKeyExW(hKey, ix, SubKeyName, &lSubKeyBuf, NULL, NULL, NULL, &ft)) != ERROR_NO_MORE_ITEMS) {
			if (rsu == ERROR_SUCCESS) {
				rc++;
				if (cb != NULL) {
					if (!cb(SubKeyName, cbp)) {
						break;
					}
				}
				ix++;
			}
			lSubKeyBuf = AJCTSIZE(SubKeyName);
		}
		RegCloseKey(hKey);
	}
	return rc;
}
//==============================================================================================================//
//	WXgL[W																							//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSecName	- ZNṼAhX															//
//				cbp			- R[obNp^																//
//				cb			- L[ʒmR[obN֐isvNULL)										//
//																												//
//	߂lF	WWXgL[̌																	//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI AjcEnumRegKeyA	   (C_BCP pPath, C_BCP pSecName, UX cbp, BOOL (CALLBACK *cb)(C_BCP pKey, AJCREGTYPE type, UX cbp))
{
	int		rc = 0;
	HKEY	hKey;
	UI		ix, lKeyBuf, type;
	BC		KeyName[512];
	LSTATUS	rsu;

	if ((hKey = SubOpenTempKeyA(pPath, pSecName, KEY_READ)) != NULL) {
		ix = 0;
		lKeyBuf = AJCTSIZE(KeyName);
		while ((rsu = RegEnumValueA(hKey, ix, KeyName, &lKeyBuf, NULL, &type, NULL, NULL)) != ERROR_NO_MORE_ITEMS) {
			if (rsu == ERROR_SUCCESS) {
				rc++;
				if (cb != NULL) {
					if (!cb(KeyName, type, cbp)) {
						break;
					}
				}
				ix++;
			}
			lKeyBuf = AJCTSIZE(KeyName);
		}
		RegCloseKey(hKey);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI AjcEnumRegKeyW	   (C_WCP pPath, C_WCP pSecName, UX cbp, BOOL (CALLBACK *cb)(C_WCP pKey, AJCREGTYPE type, UX cbp))
{
	int		rc = 0;
	HKEY	hKey;
	UI		ix, lKeyBuf, type;
	WC		KeyName[512];
	LSTATUS	rsu;

	if ((hKey = SubOpenTempKeyW(pPath, pSecName, KEY_READ)) != NULL) {
		ix = 0;
		lKeyBuf = AJCTSIZE(KeyName);
		while ((rsu = RegEnumValueW(hKey, ix, KeyName, &lKeyBuf, NULL, &type, NULL, NULL)) != ERROR_NO_MORE_ITEMS) {
			if (rsu == ERROR_SUCCESS) {
				rc++;
				if (cb != NULL) {
					if (!cb(KeyName, type, cbp)) {
						break;
					}
				}
				ix++;
			}
			lKeyBuf = AJCTSIZE(KeyName);
		}
		RegCloseKey(hKey);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	WXgL[̃I[viWXgL[ꌳIɋpj												//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSec		- ZNṼAhX															//
//				acc			- ANZX(REG_ALL_ACCESS / REG_READ)												//
//																												//
//	߂lF	NULL - WXgL[̃nh																//
//				NULL - G[																					//
//																												//
//	@lF	ɂP̃WXgL[I[vԂƂȂB													//
//				̂P̃WXgL[N[Yɂ́AAjcCloseRegFile()s܂B						//
//--------------------------------------------------------------------------------------------------------------//
//----- oCgp -------------------------------------------------------------------------------------------//
static	HKEY	SubOpenKeyA(C_BCP pPath, C_BCP pSec, REGSAM acc)
{
	HKEY	hKey = NULL;
	int		lPathW, lSecW;
	WCP		pPathW = NULL;
	WCP		pSecW  = NULL;

	if (pPath != NULL) {
		if (pPathW = AjcTAllocW(lPathW = MultiByteToWideChar(CP_ACP, 0, pPath, -1, NULL, 0))) {
			MultiByteToWideChar(CP_ACP, 0, pPath, -1, pPathW, lPathW);
		}
	}
	else pPathW = NULL;

	if (pSec != NULL) {
		if (pSecW = AjcTAllocW(lSecW  = MultiByteToWideChar(CP_ACP, 0, pSec , -1, NULL, 0))) {
			MultiByteToWideChar(CP_ACP, 0, pSec , -1, pSecW , lSecW);
		}
	}
	else pSecW = NULL;

	hKey = SubOpenKeyW(pPathW, pSecW, acc);

	if (pPathW) AjcTFree(pPathW);
	if (pSecW ) AjcTFree(pSecW );

	return hKey;
}
//----- Chp -------------------------------------------------------------------------------------------//
static	HKEY	SubOpenKeyW(C_WCP pPath, C_WCP pSec, REGSAM acc)
{
	HKEY	hKey = NULL;
	WC		path[AJCMAX_REGPATH];

	//----- pXݒipXƃZNVj ---//
	path[0] = 0;
	if (pPath != NULL) {
		AjcSnPrintFW(path, AJCMAX_REGPATH, L"%s", pPath);
	}
	if (pSec  != NULL) {
		if (path[0] != 0) AjcPathCatW (path, pSec, AJCMAX_REGPATH);
		else			  AjcSnPrintFW(path, AJCMAX_REGPATH, L"%s", pSec);
	}

	//----- WXgL[EI[v ---------------//
	if (hRegKey != NULL  &&  wcsicmp(path, SvPath) == 0 && SvAccess == acc) {	//	L[ς, L[pX and ANZXH
		hKey = hRegKey;															//		߂lL[nh
	}
	else {																		//	L[ or قȂL[pXH
		if (hRegKey != NULL) {													//		L[ς݁H
			RegCloseKey(hRegKey);												//			L[N[Y
			hRegKey = NULL;														//			E
		}
		if (RegOpenKeyExW(hKeyTop,												//		L[EI[vCH
							path,												//		E	iTuL[j
							0,													//		E	iɂOj
							acc,												//		E	iL[NXCTuL[̏ꍇ͕svj
							&hKey) == ERROR_SUCCESS && hKey != NULL) {			//		E	inhi[obt@̃AhXj
			wcscpy(SvPath, path);												//			L[pXޔ
			SvAccess = acc;														//			ANZXޔ
			hRegKey  = hKey;													//			߂lVL[nh
		}
		else {																	//		L[EI[vsH
			memset(SvPath, 0, sizeof SvPath);									//			L[pXNA[
			SvAccess = 0;														//			ANZXNA[
			hKey	 = NULL;													//			߂ls
		}
	}
	return hKey;
}
//--------------------------------------------------------------------------------------------------------------//
//	WXgL[̃I[viWXgL[pȂj													//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSec		- ZNṼAhX															//
//				acc			- ANZX(REG_ALL_ACCESS / REG_READ)												//
//																												//
//	߂lF	NULL - WXgL[̃nh																//
//				NULL - G[																					//
//																												//
//	@lF	߂liWXgL[̃nhj́AĂяo RegCloseKey() ɂN[YKvB	//
//--------------------------------------------------------------------------------------------------------------//
//----- oCgp -------------------------------------------------------------------------------------------//
static	HKEY	SubOpenTempKeyA(C_BCP pPath, C_BCP pSec, REGSAM acc)
{
	HKEY	hKey = NULL;
	int		lPathW, lSecW;
	WCP		pPathW = NULL;
	WCP		pSecW  = NULL;

	if (pPath != NULL) {
		if (pPathW = AjcTAllocW(lPathW = MultiByteToWideChar(CP_ACP, 0, pPath, -1, NULL, 0))) {
			MultiByteToWideChar(CP_ACP, 0, pPath, -1, pPathW, lPathW);
		}
	}
	else pPathW = NULL;

	if (pSec != NULL) {
		if (pSecW = AjcTAllocW(lSecW  = MultiByteToWideChar(CP_ACP, 0, pSec , -1, NULL, 0))) {
			MultiByteToWideChar(CP_ACP, 0, pSec , -1, pSecW , lSecW);
		}
	}
	else pSecW = NULL;

	hKey = SubOpenTempKeyW(pPathW, pSecW, acc);

	if (pPathW) AjcTFree(pPathW);
	if (pSecW ) AjcTFree(pSecW );

	return hKey;
}
//----- Chp -------------------------------------------------------------------------------------------//
static	HKEY	SubOpenTempKeyW(C_WCP pPath, C_WCP pSec, REGSAM acc)
{
	HKEY	hKey = NULL;
	WC		path[AJCMAX_REGPATH];

	//----- pXݒipXƃZNVj ---//
	path[0] = 0;
	if (pPath != NULL) {
		AjcSnPrintFW(path, AJCMAX_REGPATH, L"%s", pPath);
	}
	if (pSec  != NULL) {
		if (path[0] != 0) AjcPathCatW (path, pSec, AJCMAX_REGPATH);
		else			  AjcSnPrintFW(path, AJCMAX_REGPATH, L"%s", pSec);
	}

	//----- WXgL[EI[v ---------------//
	if (RegOpenKeyExW(hKeyTop,												//		L[EI[vCH
						path,												//		E	iTuL[j
						0,													//		E	iɂOj
						acc,												//		E	iL[NXCTuL[̏ꍇ͕svj
						&hKey) == ERROR_SUCCESS && hKey != NULL) {			//		E	inhi[obt@̃AhXj
	}
	else {																	//		L[EI[vsH
		hKey	 = NULL;													//			߂ls
	}
	return hKey;
}

//--------------------------------------------------------------------------------------------------------------//
//	WXgL[̐iWXgL[ꌳIɋpj														//
//																												//
//	@F	pPath		- pX̃AhX																	//
//				pSec		- ZNṼAhX															//
//				acc			- ANZX(REG_ALL_ACCESS / REG_READ)												//
//				fVolatile	- WXgL[ꎞIȂ̂ɂ邩APvIɕۑ邩̎w					//
//								FALSE - WXgL[PvIɕۑ										//
//								TRUE  - WXgL[ꎞIɕۑiVXeEVbg_EɏŁj	//
//																												//
//	߂lF	NULL - WXgL[̃nh																//
//				NULL - G[																					//
//																												//
//	@lF	ɂP̃WXgL[I[vԂƂȂB													//
//				̂P̃WXgL[N[Yɂ́AAjcCloseRegFile()s܂B						//
//--------------------------------------------------------------------------------------------------------------//
//----- oCgp -------------------------------------------------------------------------------------------//
static	HKEY	SubCreateKeyA(C_BCP pPath, C_BCP pSec, REGSAM acc, BOOL fVolatile)
{
	HKEY	hKey = NULL;
	int		lPathW, lSecW;
	WCP		pPathW = NULL;
	WCP		pSecW  = NULL;

	if (pPath != NULL) {
		if (pPathW = AjcTAllocW(lPathW = MultiByteToWideChar(CP_ACP, 0, pPath, -1, NULL, 0))) {
			MultiByteToWideChar(CP_ACP, 0, pPath, -1, pPathW, lPathW);
		}
	}
	else pPathW = NULL;

	if (pSec != NULL) {
		if (pSecW = AjcTAllocW(lSecW  = MultiByteToWideChar(CP_ACP, 0, pSec , -1, NULL, 0))) {
			MultiByteToWideChar(CP_ACP, 0, pSec , -1, pSecW , lSecW);
		}
	}
	else pSecW = NULL;

	hKey = SubCreateKeyW(pPathW, pSecW, acc, fVolatile);

	if (pPathW) AjcTFree(pPathW);
	if (pSecW ) AjcTFree(pSecW );

	return hKey;

}
//----- Chp -------------------------------------------------------------------------------------------//
static	HKEY	SubCreateKeyW(C_WCP pPath, C_WCP pSec, REGSAM acc, BOOL fVolatile)
{
	HKEY	hKey = NULL;
	UL		dmy;
	WC		path[AJCMAX_REGPATH];

	//----- pXݒipXƃZNVj ---//
	path[0] = 0;
	if (pPath != NULL) {
		AjcSnPrintFW(path, AJCMAX_REGPATH, L"%s", pPath);
	}
	if (pSec  != NULL) {
		if (path[0] != 0) AjcPathCatW (path, pSec, AJCMAX_REGPATH);
		else			  AjcSnPrintFW(path, AJCMAX_REGPATH, L"%s", pSec);
	}

	//----- WXgL[ ---------------------//
	if (hRegKey != NULL  &&  wcsicmp(path, SvPath) == 0 && SvAccess == acc) {	//	L[ς, L[pX and ANZXH
		hKey = hRegKey;															//		߂lL[nh
	}
	else {																		//	L[ or قȂL[pXH
		//	WXgL[ςȂ΁AUN[Y
		if (hRegKey != NULL) {													//		L[ς݁H
			RegCloseKey(hRegKey);												//			L[N[Y
			hRegKey = NULL;														//			E
		}
		//	WXgL[
		if (RegCreateKeyExW(hKeyTop,											//		L[CH
				path,															//		E	iTuL[j
				0,																//		E	iɂOj
				NULL,															//		E	iL[NXCTuL[̏ꍇ͕svj
				(fVolatile ? REG_OPTION_VOLATILE : REG_OPTION_NON_VOLATILE),	//		E	iVOLATILEwj
				acc,															//		E	iL[ANZXIvVj
				NULL,															//		E	iL[̃ZLeBj
				&hKey,															//		E	inhi[obt@̃AhXj
				&dmy) == ERROR_SUCCESS && hKey != NULL) {						//		E	iR[hi[obt@̃|C^j
			wcscpy(SvPath, path);												//			L[pXޔ
			SvAccess = acc;														//			ANZXޔ
			hRegKey  = hKey;													//			߂lVL[nh
		}
		else {																	//		L[sH
			memset(SvPath, 0, sizeof SvPath);									//			L[pXNA[
			SvAccess = 0;														//			ANZXNA[
			hKey	 = NULL;													//			߂ls
		}
	}
	return hKey;
}
//==============================================================================================================//
//	oCit@Ci[ppX																			//
//																												//
//	@F	fVolatile	- WXgL[ꎞIȂ̂ɂ邩APvIɕۑ邩̎w					//
//								FALSE - WXgL[PvIɕۑ										//
//								TRUE  - WXgL[ꎞIɕۑiVXeEVbg_EɏŁj	//
//				pTail		- pX̖̃AhXiNULL̏ꍇ͎j							//
//				full		- t@CpXi[obt@̃AhX								//
//				pBinDir		- oCit@Ci[tH_pX													//
//																												//
//	߂lF	NULL - pX̖|C^													//
//				NULL - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
BCP		SubProfileGenerateBinFileA(BOOL fVolatile, C_BCP pTail, BC full[MAX_PATH], C_BCP pBinDir)
{
	BCP		rc = NULL;
	BOOL	rsu;
	int		lTop;
	BC		mod[MAX_PATH], temp[MAX_PATH];
	BC		drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME];

	do {
		//----- pX̐擪 -------------------------//
		GetModuleFileNameA(NULL, temp, MAX_PATH);
		GetFullPathNameA(mod, MAX_PATH, temp, NULL);
		_splitpath(temp, drv, dir, fname, NULL);
		if (pBinDir != NULL && *pBinDir != 0) AjcSnPrintFA(temp, MAX_PATH, "%s", pBinDir);
		else								  _makepath	  (temp, drv, dir, NULL , NULL);
		//----- 擪̒ݒ -------------------------//
		lTop = (int)strlen(temp);
		//-----  -------------------------------//
		if (pTail == NULL) {
			if (fVolatile) strncat(fname, "_TMP", _MAX_FNAME - 1);
			else		   strncat(fname, "_BIN", _MAX_FNAME - 1);
			fname[_MAX_FNAME - 1] = 0;
			if (!AjcPathCatA(temp, fname, MAX_PATH)) break;
			if (AjcPathExistsA(temp)) rsu = TRUE;
			else					  rsu = CreateDirectoryA(temp, NULL);
			//	tpX쐬
			if (rsu) {
				if (GetTempFileNameA(temp, "Ajr", 0, full) == 0) break;
			}
		}
		else {
			BC	subd[MAX_PATH];
			if (!AjcPathCatA(temp, pTail, MAX_PATH)) break;
			//	tH_쐬
			_splitpath(temp, drv, dir, fname, NULL);
			_makepath (subd, drv, dir, NULL , NULL);
			if (AjcPathExistsA(subd)) rsu = TRUE;
			else					  rsu = CreateDirectoryA(subd, NULL);
			//	tpXԂ
			if (rsu) {
				strcpy(full, temp);
			}
		}
		//----- ߂lݒ ---------------------------------//
		rc = &full[lTop];
		if (*rc == '\\') rc++;
	} while(0);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
WCP		SubProfileGenerateBinFileW(BOOL fVolatile, C_WCP pTail, WC full[MAX_PATH], C_WCP pBinDir)
{
	WCP		rc = NULL;
	BOOL	rsu;
	int		lTop;
	WC		mod[MAX_PATH], temp[MAX_PATH];
	WC		drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME];

	do {
		//----- pX̐擪 -------------------------//
		GetModuleFileNameW(NULL, mod, MAX_PATH);
		GetFullPathNameW(mod, MAX_PATH, temp, NULL);
		_wsplitpath(temp, drv, dir, fname, NULL);
		if (pBinDir != NULL && *pBinDir != 0) AjcSnPrintFW(temp, MAX_PATH, L"%s", pBinDir);
		else								  _wmakepath  (temp, drv, dir, NULL , NULL);
		//----- 擪̒ݒ -------------------------//
		lTop = (int)wcslen(temp);
		//-----  -------------------------------//
		if (pTail == NULL) {
			if (fVolatile) wcsncat(fname, L"_TMP", _MAX_FNAME - 1);
			else		   wcsncat(fname, L"_BIN", _MAX_FNAME - 1);
			fname[_MAX_FNAME - 1] = 0;
			if (!AjcPathCatW(temp, fname, MAX_PATH)) break;
			if (AjcPathExistsW(temp)) rsu = TRUE;
			else					  rsu = CreateDirectoryW(temp, NULL);
			//	tpX쐬
			if (rsu) {
				if (GetTempFileNameW(temp, L"Ajr", 0, full) == 0) break;
			}
		}
		else {
			WC subd[MAX_PATH];
			if (!AjcPathCatW(temp, pTail, MAX_PATH)) break;
			//	tH_쐬
			_wsplitpath(temp, drv, dir, fname, NULL);
			_wmakepath (subd, drv, dir, NULL , NULL);
			if (AjcPathExistsW(subd)) rsu = TRUE;
			else					  rsu = CreateDirectoryW(subd, NULL);
			//	tpXԂ
			if (rsu) {
				wcscpy(full, temp);
			}
		}
		//----- ߂lݒ ---------------------------------//
		rc = &full[lTop];
		if (*rc == '\\') rc++;
	} while(0);

	return rc;
}
//==============================================================================================================//
//	oCit@C폜iSubProfileGenerateBinFile()Őt@Ĉݍ폜j								//
//																												//
//	@F	pTail	- 폜oCit@ĆivOpX́jpX								//
//				pBinDir	- oCit@Ci[tH_pX														//
//																												//
//	߂lF	TRUE  - oCit@C폜																//
//				NULL  - SubProfileGenerateBinFile()Őt@CłȂA邢́A폜s					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
BOOL	SubProfileDeleteBinFileA(C_BCP pTail, C_BCP pBinDir)
{
	BOOL	rc = FALSE;
	int		i, len1, len2;
	BC		temp[MAX_PATH], fname1[_MAX_FNAME];
	BC		drv2[_MAX_DRIVE], dir2[_MAX_DIR], fname2[_MAX_FNAME], ext2[_MAX_EXT];

	//----- t@C擾 ---------------------------------------//
	GetModuleFileNameA(NULL, temp, MAX_PATH);
	_splitpath(temp, NULL, NULL, fname1, NULL);
	len1 = (int)strlen(fname1);

	//----- w肳ꂽpX𕪉 ------------------------------//
	_splitpath(pTail, NULL, dir2, fname2, ext2);
	PathRemoveBackslashA(dir2);
	len2 = (int)strlen(dir2);

	//----- pX̃`FbNƃt@C^tH_폜 ----------//
	if (len1 + 4 == len2 &&																// pX
		strnicmp(fname1, dir2, len1) == 0 &&											// pX̑O̓vO
		(mbsicmp(&dir2[len1], "_BIN") == 0 || mbsicmp(&dir2[len1], "_TMP") == 0) &&		// pX̌㔼"_BIN"/"_TMP"
		strlen(fname2) > 3 && strnicmp(fname2, "Ajr", 3) == 0 &&						// t@C̓"Ajr"
		mbsicmp(ext2, ".tmp") == 0) {													// gq".tmp"

		for (i=3; MAjcIsXDigitA(fname2[i]); i++);
		if (fname2[i] == 0) {
			SubProfileGenerateBinFileA(0, pTail, temp, pBinDir);
			if (rc = DeleteFileA(temp)) {
				_splitpath(temp, drv2, dir2, NULL, NULL);
				_makepath (temp, drv2, dir2, NULL, NULL);
				PathRemoveBackslashA(temp);
				RemoveDirectoryA(temp);
			}
		}
	}
	return rc;
}

//----- Ch ---------------------------------------------------------------------------------------------//
BOOL	SubProfileDeleteBinFileW(C_WCP pTail, C_WCP pBinDir)
{
	BOOL	rc = FALSE;
	int		i, len1, len2;
	WC		temp[MAX_PATH], fname1[_MAX_FNAME];
	WC		drv2[_MAX_DRIVE], dir2[_MAX_DIR], fname2[_MAX_FNAME], ext2[_MAX_EXT];

	//----- t@C擾 ---------------------------------------//
	GetModuleFileNameW(NULL, temp, MAX_PATH);
	_wsplitpath(temp, NULL, NULL, fname1, NULL);
	len1 = (int)wcslen(fname1);

	//----- w肳ꂽpX𕪉 ------------------------------//
	_wsplitpath(pTail, NULL, dir2, fname2, ext2);
	PathRemoveBackslashW(dir2);
	len2 = (int)wcslen(dir2);

	//----- pX̃`FbNƃt@C^tH_폜 ----------//
	if (len1 + 4 == len2 &&																// pX
		wcsnicmp(fname1, dir2, len1) == 0 &&											// pX̑O̓vO
		(wcsicmp(&dir2[len1], L"_BIN") == 0 || wcsicmp(&dir2[len1], L"_TMP") == 0) &&	// pX̌㔼"_BIN"/"_TMP"
		wcslen(fname2) > 3 && wcsnicmp(fname2, L"Ajr", 3) == 0 &&						// t@C̓"Ajr"
		wcsicmp(ext2, L".tmp") == 0) {													// gq".tmp"

		for (i=3; MAjcIsXDigitW(fname2[i]); i++);
		if (fname2[i] == 0) {
			SubProfileGenerateBinFileW(0, pTail, temp, pBinDir);
			if (rc = DeleteFileW(temp)) {
				_wsplitpath(temp, drv2, dir2, NULL, NULL);
				_wmakepath (temp, drv2, dir2, NULL, NULL);
				PathRemoveBackslashW(temp);
				RemoveDirectoryW(temp);
			}
		}
	}
	return rc;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	WXg ڃANZX																						//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
static	BOOL	SubEnvAddItemA	  (C_BCP pName, C_BCP pPath, BC Dlm, BOOL fFront, AJCREGTYPE type,
									UI (CALLBACK *cbEnvGet)(C_BCP pName, PAJCREGTYPE pType, BCP pBuf, UI lBuf), BOOL (CALLBACK *cbEnvPut)(C_BCP pName, AJCREGTYPE type, C_BCP pTxt));

static	BOOL	SubEnvAddItemW	  (C_WCP pName, C_WCP pPath, WC Dlm, BOOL fFront, AJCREGTYPE type,
									UI (CALLBACK *cbEnvGet)(C_WCP pName, PAJCREGTYPE pType, WCP pBuf, UI lBuf), BOOL (CALLBACK *cbEnvPut)(C_WCP pName, AJCREGTYPE type, C_WCP pTxt));

static	BOOL	SubEnvDelItemA	  (C_BCP pName, C_BCP pPath, BC Dlm, BOOL fErase,
									UI (CALLBACK *cbEnvGet)(C_BCP pName, PAJCREGTYPE pType, BCP pBuf, UI lBuf), BOOL (CALLBACK *cbEnvPut)(C_BCP pName, AJCREGTYPE type, C_BCP pTxt), BOOL (CALLBACK *cbEnvDel)(C_BCP pName));

static	BOOL	SubEnvDelItemW	  (C_WCP pName, C_WCP pPath, WC Dlm, BOOL fErase,
									UI (CALLBACK *cbEnvGet)(C_WCP pName, PAJCREGTYPE pType, WCP pBuf, UI lBuf), BOOL (CALLBACK *cbEnvPut)(C_WCP pName, AJCREGTYPE type, C_WCP pTxt), BOOL (CALLBACK *cbEnvDel)(C_WCP pName));

static	BCP		SearchItemInEnvA  (BCP pStr, C_BCP pPath, BC Dlm);
static	WCP		SearchItemInEnvW  (WCP pStr, C_WCP pPath, WC Dlm);
static	VO		AdjustSemiCollonA (BCP pStr);
static	VO		AdjustSemiCollonW (WCP pStr);

//==============================================================================================================//
//	WXgɋL^Ăl̓ǂݏo																		//
//																												//
//	@F	hTop	- gbvL[																			//
//				pPath	- WXgpX̃AhX															//
//				pKey	- L[̂̃AhXiK荀ڂ̏ꍇNULL)												//
//				pType	- ǂݏo^Cvi[obt@̃AhXisvNULL)							//
//				pBuf	- ǂݏoei[obt@̃AhX(NULL͕Kvȃobt@TCY擾)			//
//				lBuf	- ǂݏoei[obt@̃oCg(UNICODȄꍇ͕̂Q{̒lw肷)	//
//																												//
//	߂lF	O - iǂݏooCg^ǂݏoɕKvȃoCgj										//
//				O - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcRegGetA(HKEY hTop, C_BCP pPath, C_BCP pKey, PAJCREGTYPE pType, VOP pBuf, UI lBuf)
{
	UI		rc	  = 0;
	HKEY	hKey  = NULL;
	UL		bytes = (pBuf != NULL ? lBuf : 0);

	if (RegOpenKeyExA(	hTop,										//	L[EI[vCH
						pPath,										//	E	iTuL[j
						0,											//	E	iɂOj
						KEY_READ,									//	E	iANZXCTuL[̏ꍇ͕svj
						&hKey) == ERROR_SUCCESS && hKey != NULL) {	//	E	inhi[obt@̃AhXj

		if (RegQueryValueExA(hKey, pKey, NULL, (LPDWORD)pType, (LPBYTE)pBuf, &bytes) == ERROR_SUCCESS) {
			rc = bytes;
		}
		RegCloseKey(hKey);
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcRegGetW(HKEY hTop, C_WCP pPath, C_WCP pKey, PAJCREGTYPE pType, VOP pBuf, UI lBuf)
{
	UI		rc	  = 0;
	HKEY	hKey  = NULL;
	UL		bytes = (pBuf != NULL ? lBuf : 0);

	if (RegOpenKeyExW(	hTop,										//	L[EI[vCH
						pPath,										//	E	iTuL[j
						0,											//	E	iɂOj
						KEY_READ,									//	E	iANZXCTuL[̏ꍇ͕svj
						&hKey) == ERROR_SUCCESS && hKey != NULL) {	//	E	inhi[obt@̃AhXj

		if (RegQueryValueExW(hKey, pKey, NULL, (LPDWORD)pType, (LPBYTE)pBuf, &bytes) == ERROR_SUCCESS) {
			rc = bytes;
		}
		RegCloseKey(hKey);
	}
	return rc;
}
//==============================================================================================================//
//	WXg֒lݒ肷																					//
//																												//
//	@F	hTop		- gbvL[																		//
//				pPath		- WXgpX̃AhX														//
//				pKey		- L[̂̃AhXiK荀ڂ̏ꍇNULL)											//
//				type		- ϐ̃^Cv																	//
//				pDat		- ݒ肷f[^̃AhXiNULL̏ꍇ́AYϐ폜j							//
//				lDat		- ݒ肷f[^̃oCgiUNICODȄꍇ́ÂQ{̒lw肷j			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegPutA		  (HKEY hTop, C_BCP pPath, C_BCP pKey, AJCREGTYPE type, C_VOP pDat, UI lDat)
{
	BOOL	rc	 = FALSE;
	HKEY	hKey = NULL;
	UL		Disposition;

	if (pPath != NULL && pDat != NULL && lDat != 0) {
		//	WXgL[
		if (RegCreateKeyExA(hTop,												//	L[CH
							pPath,												//	E	iTuL[j
							0,													//	E	iɂOj
							NULL,												//	E	iL[NXCTuL[̏ꍇ͕svj
							REG_OPTION_NON_VOLATILE,							//	E	iVOLATILEwj
							KEY_ALL_ACCESS,										//	E	iL[ANZXIvVj
							NULL,												//	E	iL[̃ZLeBj
							&hKey,												//	E	inhi[obt@̃AhXj
							&Disposition) == ERROR_SUCCESS && hKey != NULL) {	//	E	iR[hi[obt@̃|C^j
			//	WXg
			rc = (RegSetValueExA(hKey, pKey, 0, type, (const BYTE *)pDat, lDat) == ERROR_SUCCESS);
			//	N[Y
			RegCloseKey(hKey);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegPutW		  (HKEY hTop, C_WCP pPath, C_WCP pKey, AJCREGTYPE type, C_VOP pDat, UI lDat)
{
	BOOL	rc	 = FALSE;
	HKEY	hKey = NULL;
	UL		Disposition;

	if (pPath != NULL && pDat != NULL && lDat != 0) {
		//	WXgL[
		if (RegCreateKeyExW(hTop,												//	L[CH
							pPath,												//	E	iTuL[j
							0,													//	E	iɂOj
							NULL,												//	E	iL[NXCTuL[̏ꍇ͕svj
							REG_OPTION_NON_VOLATILE,							//	E	iVOLATILEwj
							KEY_ALL_ACCESS,										//	E	iL[ANZXIvVj
							NULL,												//	E	iL[̃ZLeBj
							&hKey,												//	E	inhi[obt@̃AhXj
							&Disposition) == ERROR_SUCCESS && hKey != NULL) {	//	E	iR[hi[obt@̃|C^j
			//	WXg
			rc = (RegSetValueExW(hKey, pKey, 0, type, (const BYTE *)pDat, lDat) == ERROR_SUCCESS);
			//	N[Y
			RegCloseKey(hKey);
		}
	}
	return rc;
}
//==============================================================================================================//
//	WXg TuL[폜																						//
//																												//
//	@F	hTop		- gbvL[																		//
//				pPath		- WXgpX̃AhX														//
//				pSubKey		- TuL[																			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegDelSubKeyA	  (HKEY hTop, C_BCP pPath, C_BCP pSubKey)
{
	BOOL	rc = FALSE;
	HKEY	hKey;

	//----- TuL[폜 ---------------------------------------------------------------------------------------//
	if (RegOpenKeyExA(hTop, pPath, 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS) {
		rc = (RegDeleteKeyA(hKey, pSubKey) == ERROR_SUCCESS);
		RegCloseKey(hKey);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegDelSubKeyW	  (HKEY hTop, C_WCP pPath, C_WCP pSubKey)
{
	BOOL	rc = FALSE;
	HKEY	hKey;

	//----- TuL[폜 ---------------------------------------------------------------------------------------//
	if (RegOpenKeyExW(hTop, pPath, 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS) {
		rc = (RegDeleteKeyW(hKey, pSubKey) == ERROR_SUCCESS);
		RegCloseKey(hKey);
	}
	return rc;
}
//==============================================================================================================//
//	WXgL[폜																							//
//																												//
//	@F	hTop		- gbvL[																		//
//				pPath		- WXgpX̃AhX														//
//				pKey		- L[́iĺ̖j̃AhX													//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegDelValueA	  (HKEY hTop, C_BCP pPath, C_BCP pKey)
{
	BOOL	rc = FALSE;
	UI		err;
	HKEY	hKey;

	if ((err = RegOpenKeyExA(hTop, pPath, 0, KEY_ALL_ACCESS, &hKey)) == ERROR_SUCCESS) {
		rc = (RegDeleteValueA(hKey, pKey) == ERROR_SUCCESS);
		RegCloseKey(hKey);
	}
	else if (err == ERROR_FILE_NOT_FOUND) {
		rc = TRUE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegDelValueW	  (HKEY hTop, C_WCP pPath, C_WCP pKey)
{
	BOOL	rc = FALSE;
	UI		err;
	HKEY	hKey;

	if ((err = RegOpenKeyExW(hTop, pPath, 0, KEY_ALL_ACCESS, &hKey)) == ERROR_SUCCESS) {
		rc = (RegDeleteValueW(hKey, pKey) == ERROR_SUCCESS);
		RegCloseKey(hKey);
	}
	else if (err == ERROR_FILE_NOT_FOUND) {
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	Jg[UEWXgɋL^Ăϐ擾														//
//																												//
//	@F	pName		- ϐ̃AhX																//
//				pBuf		- ϐ̓ei[obt@̃AhXiNULL͕Kvȃobt@TCY擾j	//
//				lBuf		- ϐ̓ei[obt@̕											//
//																												//
//	߂lF	O - iǂݏoϐ̕^ǂݏoɕKvȕiNULL܂ށjj			//
//				O - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcRegEnvGetA(C_BCP pName, BCP pBuf, UI lBuf)
{
	AJCREGTYPE	type;
	return AjcRegGetA(HKEY_CURRENT_USER, AJC_REGPATH_USRENVA, pName, &type, pBuf, lBuf);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcRegEnvGetW(C_WCP pName, WCP pBuf, UI lBuf)
{
	AJCREGTYPE	type;
	return AjcRegGetW(HKEY_CURRENT_USER, AJC_REGPATH_USRENVW, pName, &type, pBuf, lBuf * 2) / 2;
}
//==============================================================================================================//
//	Jg[UEWXgɋL^Ăϐƃ^Cv擾												//
//																												//
//	@F	pName		- ϐ̃AhX																//
//				pType		- ϐ̃^Cvi[obt@̃AhXisvNULL)						//
//				pBuf		- ϐ̓ei[obt@̃AhXiNULL͕Kvȃobt@TCY擾j	//
//				lBuf		- ϐ̓ei[obt@̕											//
//																												//
//	߂lF	O - iǂݏoϐ̕^ǂݏoɕKvȕiNULL܂ށjj			//
//				O - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcRegHkCuEnvGetA(C_BCP pName, PAJCREGTYPE pType, BCP pBuf, UI lBuf)
{
	return AjcRegGetA(HKEY_CURRENT_USER, AJC_REGPATH_USRENVA, pName, pType, pBuf, lBuf);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcRegHkCuEnvGetW(C_WCP pName, PAJCREGTYPE pType, WCP pBuf, UI lBuf)
{
	return AjcRegGetW(HKEY_CURRENT_USER, AJC_REGPATH_USRENVW, pName, pType, pBuf, lBuf * 2) / 2;
}
//==============================================================================================================//
//	[J}VEWXgɋL^Ăϐƃ^Cv擾												//
//																												//
//	@F	pName		- ϐ̃AhX																//
//				pType		- ϐ̃^Cvi[obt@̃AhXisvNULL)						//
//				pBuf		- ϐ̓ei[obt@̃AhXiNULL͕Kvȃobt@TCY擾j	//
//				lBuf		- ϐ̓ei[obt@̕											//
//																												//
//	߂lF	O - iǂݏoϐ̕^ǂݏoɕKvȕiNULL܂ށjj			//
//				O - G[																					//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcRegHkLmEnvGetA(C_BCP pName, PAJCREGTYPE pType, BCP pBuf, UI lBuf)
{
	return AjcRegGetA(HKEY_LOCAL_MACHINE, AJC_REGPATH_SYSENVA, pName, pType, pBuf, lBuf);
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcRegHkLmEnvGetW(C_WCP pName, PAJCREGTYPE pType, WCP pBuf, UI lBuf)
{
	return AjcRegGetW(HKEY_LOCAL_MACHINE, AJC_REGPATH_SYSENVW, pName, pType, pBuf, lBuf * 2) / 2;
}
//==============================================================================================================//
//	Jg[UEWXg֊ϐƁA̓eݒ肷iREG_SZ^CvŒj								//
//																												//
//	@F	pName		- ϐ̃AhX																//
//				pTxt		- ϐ֐ݒ肷镶̃AhXiNULL̏ꍇ́AYϐ폜j			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegEnvPutA		  (C_BCP pName, C_BCP pTxt)
{
	BOOL	rc = FALSE;

	rc = AjcRegPutA(HKEY_CURRENT_USER, AJC_REGPATH_USRENVA, pName, AJCREG_SZ, (C_UBP)pTxt, (UI)strlen(pTxt) + 1);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegEnvPutW		  (C_WCP pName, C_WCP pTxt)
{
	BOOL	rc = FALSE;

	rc = AjcRegPutW(HKEY_CURRENT_USER, AJC_REGPATH_USRENVW, pName, AJCREG_SZ, (C_UBP)pTxt, ((UI)wcslen(pTxt) + 1) * 2);

	return rc;
}
//==============================================================================================================//
//	Jg[UEWXg֊ϐƁA̓eݒ肷i^Cvwj									//
//																												//
//	@F	pName		- ϐ̃AhX																//
//				type		- ϐ̃^Cv(REG_SZ / REG_EXPAND_SZ)											//
//				pTxt		- ϐ֐ݒ肷镶̃AhXiNULL̏ꍇ́AYϐ폜j			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvPutA		  (C_BCP pName, AJCREGTYPE type, C_BCP pTxt)
{
	BOOL	rc = FALSE;

	if (type == REG_SZ || type == REG_EXPAND_SZ) {
		rc = AjcRegPutA(HKEY_CURRENT_USER, AJC_REGPATH_USRENVA, pName, type, (C_UBP)pTxt, (UI)strlen(pTxt) + 1);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvPutW		  (C_WCP pName, AJCREGTYPE type, C_WCP pTxt)
{
	BOOL	rc = FALSE;

	if (type == REG_SZ || type == REG_EXPAND_SZ) {
		rc = AjcRegPutW(HKEY_CURRENT_USER, AJC_REGPATH_USRENVW, pName, type, (C_UBP)pTxt, ((UI)wcslen(pTxt) + 1) * 2);
	}
	return rc;
}
//==============================================================================================================//
//	[J}VEWXg֊ϐƁA̓eݒ肷													//
//																												//
//	@F	pName		- ϐ̃AhX																//
//				type		- ϐ̃^Cv(REG_SZ / REG_EXPAND_SZ)											//
//				pTxt		- ϐ֐ݒ肷镶̃AhXiNULL̏ꍇ́AYϐ폜j			//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvPutA		  (C_BCP pName, AJCREGTYPE type, C_BCP pTxt)
{
	BOOL	rc = FALSE;

	if (type == REG_SZ || type == REG_EXPAND_SZ) {
		rc = AjcRegPutA(HKEY_LOCAL_MACHINE, AJC_REGPATH_SYSENVA, pName, type, (C_UBP)pTxt, (UI)strlen(pTxt) + 1);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvPutW		  (C_WCP pName, AJCREGTYPE type, C_WCP pTxt)
{
	BOOL	rc = FALSE;

	if (type == REG_SZ || type == REG_EXPAND_SZ) {
		rc = AjcRegPutW(HKEY_LOCAL_MACHINE, AJC_REGPATH_SYSENVW, pName, type, (C_UBP)pTxt, ((UI)wcslen(pTxt) + 1) * 2);
	}
	return rc;
}
//==============================================================================================================//
//	Jg[UEWXg̃[Uϐ폜														//
//																												//
//	@	F	pName	- ϐ																			//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvDelA		  (C_BCP pName)
{
	BOOL	rc = FALSE;

	rc = AjcRegDelValueA(HKEY_CURRENT_USER, AJC_REGPATH_USRENVA, pName);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvDelW		  (C_WCP pName)
{
	BOOL	rc = FALSE;

	rc = AjcRegDelValueW(HKEY_CURRENT_USER, AJC_REGPATH_USRENVW, pName);

	return rc;
}
//==============================================================================================================//
//	[J}VEWXg̃VXeϐ폜														//
//																												//
//	@	F	pName	- ϐ																			//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvDelA		  (C_BCP pName)
{
	BOOL	rc = FALSE;

	rc = AjcRegDelValueA(HKEY_LOCAL_MACHINE, AJC_REGPATH_SYSENVA, pName);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvDelW		  (C_WCP pName)
{
	BOOL	rc = FALSE;

	rc = AjcRegDelValueW(HKEY_LOCAL_MACHINE, AJC_REGPATH_SYSENVW, pName);

	return rc;
}
//==============================================================================================================//
//	Jg[UEWXg̊ϐɎw荀ڂ݂邩`FbN										//
//																												//
//	@	F	pName	- ϐ																			//
//				pItem	- ǉ鍀ڕ																	//
//				Dlm		- ؂蕶																			//
//																												//
//	߂l	F	TRUE  - ڗL																				//
//				FALSE - ږ^G[																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvSrhItemA(C_BCP pName, C_BCP pItem, BC Dlm)
{
	BOOL		rc = FALSE;
	BCP			pBuf;
	AJCREGTYPE	r_type;
	int			len;
	BC			szDlm[2];

	if (pName != NULL && *pName != 0 && pItem != NULL  &&  *pItem != 0) {
		szDlm[0] = Dlm;
		szDlm[1] = 0;
		if (len = AjcRegHkCuEnvGetA(pName, &r_type, NULL, 0)) {
			if (pBuf = AjcTAllocA(len)) {
				AjcRegHkCuEnvGetA(pName, &r_type, pBuf, len);
				rc = (SearchItemInEnvA(pBuf, pItem, Dlm) != NULL);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvSrhItemW(C_WCP pName, C_WCP pItem, WC Dlm)
{
	BOOL		rc = FALSE;
	WCP			pBuf;
	AJCREGTYPE	r_type;
	int			len;
	WC			szDlm[2];

	if (pName != NULL && *pName != 0 && pItem != NULL  &&  *pItem != 0) {
		szDlm[0] = Dlm;
		szDlm[1] = 0;
		if (len = AjcRegHkCuEnvGetW(pName, &r_type, NULL, 0)) {
			if (pBuf = AjcTAllocW(len)) {
				AjcRegHkCuEnvGetW(pName, &r_type, pBuf, len);
				rc = (SearchItemInEnvW(pBuf, pItem, Dlm) != NULL);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Jg[UEWXg̊ϐ֍ڂǉ														//
//																												//
//	@	F	pName	- ϐ																			//
//				pItem	- ǉ鍀ڕ																	//
//				Dlm		- ؂蕶																			//
//				fFront	- TRUE	: 擪֒ǉ																	//
//						  FALSE : ֒ǉ																	//
//				type	- ϐVK쐬ꍇ̃WXg^Cv											//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvAddItemA(C_BCP pName, C_BCP pItem, BC Dlm, BOOL fFront, AJCREGTYPE type)
{
	BOOL	rc = FALSE;

	rc = SubEnvAddItemA(pName, pItem, Dlm, fFront, type, AjcRegHkCuEnvGetA, AjcRegHkCuEnvPutA);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvAddItemW(C_WCP pName, C_WCP pItem, WC Dlm, BOOL fFront, AJCREGTYPE type)
{
	BOOL	rc = FALSE;

	rc = SubEnvAddItemW(pName, pItem, Dlm, fFront, type, AjcRegHkCuEnvGetW, AjcRegHkCuEnvPutW);

	return rc;
}
//==============================================================================================================//
//	[J}VEWXg̊ϐɎw荀ڂ݂邩`FbN										//
//																												//
//	@	F	pName	- ϐ																			//
//				pItem	- ǉ鍀ڕ																	//
//				Dlm		- ؂蕶																			//
//																												//
//	߂l	F	TRUE  - ڗL																				//
//				FALSE - ږ^G[																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvSrhItemA(C_BCP pName, C_BCP pItem, BC Dlm)
{
	BOOL		rc = FALSE;
	BCP			pBuf;
	AJCREGTYPE	r_type;
	int			len;
	BC			szDlm[2];

	if (pName != NULL && *pName != 0 && pItem != NULL  &&  *pItem != 0) {
		szDlm[0] = Dlm;
		szDlm[1] = 0;
		if (len = AjcRegHkLmEnvGetA(pName, &r_type, NULL, 0)) {
			if (pBuf = AjcTAllocA(len)) {
				AjcRegHkLmEnvGetA(pName, &r_type, pBuf, len);
				rc = (SearchItemInEnvA(pBuf, pItem, Dlm) != NULL);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvSrhItemW(C_WCP pName, C_WCP pItem, WC Dlm)
{
	BOOL		rc = FALSE;
	WCP			pBuf;
	AJCREGTYPE	r_type;
	int			len;
	WC			szDlm[2];

	if (pName != NULL && *pName != 0 && pItem != NULL  &&  *pItem != 0) {
		szDlm[0] = Dlm;
		szDlm[1] = 0;
		if (len = AjcRegHkLmEnvGetW(pName, &r_type, NULL, 0)) {
			if (pBuf = AjcTAllocW(len)) {
				AjcRegHkLmEnvGetW(pName, &r_type, pBuf, len);
				rc = (SearchItemInEnvW(pBuf, pItem, Dlm) != NULL);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	[J}VEWXg̊ϐ֍ڂǉ														//
//																												//
//	@	F	pName	- ϐ																			//
//				pItem	- ǉ鍀ڕ																	//
//				Dlm		- ؂蕶																			//
//				fFront	- TRUE	: 擪֒ǉ																	//
//						  FALSE : ֒ǉ																	//
//				type	- ϐVK쐬ꍇ̃WXg^Cv											//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvAddItemA(C_BCP pName, C_BCP pItem, BC Dlm, BOOL fFront, AJCREGTYPE type)
{
	BOOL	rc = FALSE;

	rc = SubEnvAddItemA(pName, pItem, Dlm, fFront, type, AjcRegHkLmEnvGetA, AjcRegHkLmEnvPutA);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvAddItemW(C_WCP pName, C_WCP pItem, WC Dlm, BOOL fFront, AJCREGTYPE type)
{
	BOOL	rc = FALSE;

	rc = SubEnvAddItemW(pName, pItem, Dlm, fFront, type, AjcRegHkLmEnvGetW, AjcRegHkLmEnvPutW);

	return rc;
}
//==============================================================================================================//
//	Jg[UEWXgPATHϐɎw荀ڂ݂邩`FbN									//
//																												//
//	@	F	path	- pX																	//
//																												//
//	߂l	F	TRUE  - w荀ڗL																			//
//				FALSE - w荀ږ^G[																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvSrhPathItemA(C_BCP pPath)
{
	BOOL	rc = FALSE;

	rc = AjcRegHkCuEnvSrhItemA("PATH" , pPath, ';');

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvSrhPathItemW(C_WCP pPath)
{
	BOOL	rc = FALSE;

	rc = AjcRegHkCuEnvSrhItemW(L"PATH" , pPath, L';');

	return rc;
}
//==============================================================================================================//
//	Jg[UEWXgPATHϐփpXڂǉ												//
//																												//
//	@	F	path	- ǉpX																	//
//				fFront	- TRUE	: 擪֒ǉ																	//
//						  FALSE : ֒ǉ																	//
///				type	- ϐVK쐬ꍇ̃WXg^Cv											//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvAddPathItemA(C_BCP pPath, BOOL fFront, AJCREGTYPE type)
{
	BOOL	rc = FALSE;

	rc = SubEnvAddItemA("PATH" , pPath, ';' , fFront, type, AjcRegHkCuEnvGetA, AjcRegHkCuEnvPutA);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvAddPathItemW(C_WCP pPath, BOOL fFront, AJCREGTYPE type)
{
	BOOL	rc = FALSE;

	rc = SubEnvAddItemW(L"PATH", pPath, L';', fFront, type, AjcRegHkCuEnvGetW, AjcRegHkCuEnvPutW);

	return rc;
}
//==============================================================================================================//
//	[J}VEWXgPATHϐɎw荀ڂ݂邩`FbN									//
//																												//
//	@	F	path	- pX																	//
//																												//
//	߂l	F	TRUE  - w荀ڗL																			//
//				FALSE - w荀ږ^G[																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvSrhPathItemA(C_BCP pPath)
{
	BOOL	rc = FALSE;

	rc = AjcRegHkLmEnvSrhItemA("PATH" , pPath, ';');

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvSrhPathItemW(C_WCP pPath)
{
	BOOL	rc = FALSE;

	rc = AjcRegHkLmEnvSrhItemW(L"PATH" , pPath, L';');

	return rc;
}
//==============================================================================================================//
//	[J}VEWXgPATHϐփpXڂǉ												//
//																												//
//	@	F	path	- ǉpX																	//
//				fFront	- TRUE	: 擪֒ǉ																	//
//						  FALSE : ֒ǉ																	//
///				type	- ϐVK쐬ꍇ̃WXg^Cv											//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvAddPathItemA(C_BCP pPath, BOOL fFront, AJCREGTYPE type)
{
	BOOL	rc = FALSE;

	rc = SubEnvAddItemA("PATH" , pPath, ';' , fFront, type, AjcRegHkLmEnvGetA, AjcRegHkLmEnvPutA);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvAddPathItemW(C_WCP pPath, BOOL fFront, AJCREGTYPE type)
{
	BOOL	rc = FALSE;

	rc = SubEnvAddItemW(L"PATH", pPath, L';', fFront, type, AjcRegHkLmEnvGetW, AjcRegHkLmEnvPutW);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	WXg̊ϐ֍ڂǉ																		//
//																												//
//	@	F	pName	 - ϐ																			//
//				pItem	 - ǉ鍀ځij																//
//				Dlm		 - ؂蕶																			//
//				fFront	 - TRUE	: 擪֒ǉCFALSE : ֒ǉ												//
//				type	 - ϐVK쐬ꍇ̃WXg^Cv											//
//				cbEnvGet - ϐǂݏo֐																	//
//				cbEnvPut - ϐ݊֐																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	BOOL	SubEnvAddItemA(C_BCP pName, C_BCP pItem, BC Dlm, BOOL fFront, AJCREGTYPE type,
										UI	 (CALLBACK *cbEnvGet)(C_BCP pName, PAJCREGTYPE pType, BCP pBuf, UI lBuf),
										BOOL (CALLBACK *cbEnvPut)(C_BCP pName, AJCREGTYPE type, C_BCP pTxt))
{
	BOOL		rc = FALSE;
	BCP			pBuf;
	AJCREGTYPE	r_type;
	int			stl, len;
	BC			szDlm[2];

	if (pName != NULL && *pName != 0 && pItem != NULL  &&  *pItem != 0) {
		szDlm[0] = Dlm;
		szDlm[1] = 0;
		if (stl = (int)cbEnvGet(pName, &r_type, NULL, 0)) {
			stl--;	// I[Z
			len = (stl + 1) + ((int)strlen(pItem) + 1);
			if (pBuf = AjcTAllocA(len)) {
				BCP		p;
				cbEnvGet(pName, &type, pBuf, len);
				//	擪֒ǉꍇA炩ߓꍀڂ폜
				if (fFront) {
					while ((p = SearchItemInEnvA(pBuf, pItem, Dlm)) != NULL) {
						AjcRepPartStrA(pBuf, len, (UI)((UX)p - (UX)pBuf), (UI)strlen(pItem), "", -1);
					}
				}
				//	w荀ڂ΁Aڒǉ
				if (SearchItemInEnvA(pBuf, pItem, Dlm) == NULL) {
					do {
						//	擪֒ǉ
						if (fFront) {
							if (stl > 0 && pBuf[0] != Dlm) {
								if (AjcRepPartStrA(pBuf, len, 0				   , 0, pItem, -1) == NULL) break;
								if (AjcRepPartStrA(pBuf, len, (UI)strlen(pItem), 0, szDlm, -1) == NULL) break;
							}
							else {
								if (AjcRepPartStrA(pBuf, len, 0				   , 0, pItem, -1) == NULL) break;
							}
						}
						//	֒ǉ
						else {
							if (stl > 0 && pBuf[stl - 1] != Dlm) {
								if (AjcRepPartStrA(pBuf, len, stl	 , 0, szDlm , -1) == NULL) break;
								if (AjcRepPartStrA(pBuf, len, stl + 1, 0, pItem , -1) == NULL) break;
							}
							else {
								if (AjcRepPartStrA(pBuf, len, stl	 , 0, pItem , -1) == NULL) break;
							}
						}
						AdjustSemiCollonA(pBuf);
						rc = cbEnvPut(pName, type, pBuf);
					} while (0);
				}
				//	Ɏw荀ڂ݂ꍇ͂njƂ
				else rc = TRUE;
				free(pBuf);
			}
		}
		else {
			rc = cbEnvPut(pName, type, pItem);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	BOOL	SubEnvAddItemW(C_WCP pName, C_WCP pItem, WC Dlm, BOOL fFront, AJCREGTYPE type,
											UI	 (CALLBACK *cbEnvGet)(C_WCP pName, PAJCREGTYPE pType, WCP pBuf, UI lBuf),
											BOOL (CALLBACK *cbEnvPut)(C_WCP pName, AJCREGTYPE type, C_WCP pTxt))
{
	BOOL		rc = FALSE;
	WCP			pBuf;
	AJCREGTYPE	r_type;
	int			stl, len;
	WC			szDlm[2];

	if (pName != NULL && *pName != 0 && pItem != NULL  &&  *pItem != 0) {
		szDlm[0] = Dlm;
		szDlm[1] = 0;
		if (stl = (int)cbEnvGet(pName, &r_type, NULL, 0)) {
			stl--;	// I[Z
			len = (stl + 1) + ((int)wcslen(pItem) + 1);
			if (pBuf = AjcTAllocW(len)) {
				WCP		p;
				cbEnvGet(pName, &type, pBuf, len);
				//	擪֒ǉꍇA炩ߓꍀڂ폜
				if (fFront) {
					while ((p = SearchItemInEnvW(pBuf, pItem, Dlm)) != NULL) {
						AjcRepPartStrW(pBuf, len, (UI)(((UX)p - (UX)pBuf) / 2), (UI)wcslen(pItem), L"", -1);
					}
				}
				//	w荀ڂ΁Aڒǉ
				if (SearchItemInEnvW(pBuf, pItem, Dlm) == NULL) {
					do {
						//	擪֒ǉ
						if (fFront) {
							if (stl > 0 && pBuf[0] != Dlm) {
								if (AjcRepPartStrW(pBuf, len, 0				   , 0, pItem, -1) == NULL) break;
								if (AjcRepPartStrW(pBuf, len, (UI)wcslen(pItem), 0, szDlm, -1) == NULL) break;
							}
							else {
								if (AjcRepPartStrW(pBuf, len, 0				   , 0, pItem, -1) == NULL) break;
							}
						}
						//	֒ǉ
						else {
							if (stl > 0 && pBuf[stl - 1] != Dlm) {
								if (AjcRepPartStrW(pBuf, len, stl	 , 0, szDlm , -1) == NULL) break;
								if (AjcRepPartStrW(pBuf, len, stl + 1, 0, pItem , -1) == NULL) break;
							}
							else {
								if (AjcRepPartStrW(pBuf, len, stl	 , 0, pItem , -1) == NULL) break;
							}
						}
						AdjustSemiCollonW(pBuf);
						rc = cbEnvPut(pName, type, pBuf);
					} while (0);
				}
				//	Ɏw荀ڂ݂ꍇ͂njƂ
				else rc = TRUE;
				free(pBuf);
			}
		}
		else {
			rc = cbEnvPut(pName, type, pItem);
		}
	}
	return rc;
}
//==============================================================================================================//
//	Jg[UEWXg̊ϐ獀ڂ폜														//
//																												//
//	@	F	pName	- ϐ																			//
//				pItem	- 폜鍀ڕ																	//
//				Dlm		- ؂蕶																			//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvDelItemA(C_BCP pName, C_BCP pItem, BC Dlm, BOOL fErase)
{
	BOOL	rc = FALSE;

	rc = SubEnvDelItemA(pName, pItem, Dlm, fErase, AjcRegHkCuEnvGetA, AjcRegHkCuEnvPutA, AjcRegHkCuEnvDelA);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvDelItemW(C_WCP pName, C_WCP pItem, WC Dlm, BOOL fErase)
{
	BOOL	rc = FALSE;

	rc = SubEnvDelItemW(pName, pItem, Dlm, fErase, AjcRegHkCuEnvGetW, AjcRegHkCuEnvPutW, AjcRegHkCuEnvDelW);

	return rc;
}
//==============================================================================================================//
//	[J}VEWXg̊ϐ獀ڂ폜														//
//																												//
//	@	F	pName	- ϐ																			//
//				pItem	- ǉ鍀ڕ																	//
//				Dlm		- ؂蕶																			//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvDelItemA(C_BCP pName, C_BCP pItem, BC Dlm, BOOL fErase)
{
	BOOL	rc = FALSE;

	rc = SubEnvDelItemA(pName, pItem, Dlm, fErase, AjcRegHkLmEnvGetA, AjcRegHkLmEnvPutA, AjcRegHkLmEnvDelA);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvDelItemW(C_WCP pName, C_WCP pItem, WC Dlm, BOOL fErase)
{
	BOOL	rc = FALSE;

	rc = SubEnvDelItemW(pName, pItem, Dlm, fErase, AjcRegHkLmEnvGetW, AjcRegHkLmEnvPutW, AjcRegHkLmEnvDelW);

	return rc;
}

//==============================================================================================================//
//	Jg[UEWXgPATHϐpXڂ폜												//
//																												//
//	@	F	pPath	 - 폜pX																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvDelPathItemA(C_BCP pPath, BOOL fErase)
{
	BOOL	rc = FALSE;

	rc = SubEnvDelItemA("PATH" , pPath, ';' , fErase, AjcRegHkCuEnvGetA, AjcRegHkCuEnvPutA, AjcRegHkCuEnvDelA);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkCuEnvDelPathItemW(C_WCP pPath, BOOL fErase)
{
	BOOL	rc = FALSE;

	rc = SubEnvDelItemW(L"PATH", pPath, L';', fErase, AjcRegHkCuEnvGetW, AjcRegHkCuEnvPutW, AjcRegHkCuEnvDelW);

	return rc;
}
//==============================================================================================================//
//	[J}VEWXgPATHϐpXڂ폜												//
//																												//
//	@	F	pPath	 - 폜pX																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvDelPathItemA(C_BCP pPath, BOOL fErase)
{
	BOOL	rc = FALSE;

	rc = SubEnvDelItemA("PATH" , pPath, ';' , fErase, AjcRegHkLmEnvGetA, AjcRegHkLmEnvPutA, AjcRegHkLmEnvDelA);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegHkLmEnvDelPathItemW(C_WCP pPath, BOOL fErase)
{
	BOOL	rc = FALSE;

	rc = SubEnvDelItemW(L"PATH", pPath, L';', fErase, AjcRegHkLmEnvGetW, AjcRegHkLmEnvPutW, AjcRegHkLmEnvDelW);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	WXg̊ϐ獀ڂ폜																		//
//																												//
//	@	F	pName	 - ϐ																			//
//				pItem	 - 폜鍀ڕ																	//
//				Dlm		 - ؂蕶																			//
//				fErase	 - ڂȂȂꍇ̊ϐw												//
//				cbEnvGet - ϐǂݏo֐																	//
//				cbEnvPut - ϐ݊֐																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	BOOL	SubEnvDelItemA(C_BCP pName, C_BCP pItem, BC Dlm, BOOL fErase,
											UI	 (CALLBACK *cbEnvGet)(C_BCP pName, PAJCREGTYPE pType, BCP pBuf, UI lBuf),
											BOOL (CALLBACK *cbEnvPut)(C_BCP pName, AJCREGTYPE type, C_BCP pTxt),
											BOOL (CALLBACK *cbEnvDel)(C_BCP pName))
{
	BOOL		rc = FALSE;
	AJCREGTYPE	type;
	int			stl, len;
	BCP			pBuf, pTop, pEnd;

	if (pItem != NULL && *pItem != 0) {								//	LȃpXH
		if (stl = (int)cbEnvGet(pName, &type, NULL, 0)) {			//		eLXg̒(I[܂)擾CnjH
			len = stl + (int)strlen(pItem) + 1;						//			Ŝ̃eLXg̒ݒ
			if (pBuf = AjcTAllocA(len)) {							//			eLXgobt@mہCH
				memset(pBuf, 0, len);
				cbEnvGet(pName, &type, pBuf, len);					//				eLXgǂݏo
				if (pTop = SearchItemInEnvA(pBuf, pItem, Dlm)) {	//				폜鍀ڌCH
					pEnd = pTop + strlen(pItem);					//					폜pX̎̈ʒuݒ
					memmove(pTop, pEnd, strlen(pEnd) + 1);			//					폜pX
					AdjustSemiCollonA(pBuf);						//					AZ~RPɂ
					//	ϐw肠 and ږH
					if (fErase && (pBuf[0] == 0 || AjcStrSameAsAllCharA(pBuf, ' '))) {
						rc = cbEnvDel(pName);						//						ϐ폜
					}
					//	ϐwȂ or ڂH
					else {											//					󕶎ȊOiڗLjbϐۑwH
						rc = cbEnvPut(pName, type, pBuf);			//						eLXg
					}
				}
				else rc = TRUE;										//				폜鍀ڂꍇ͂njƂ
				free(pBuf);											//				eLXgobt@
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	BOOL	SubEnvDelItemW(C_WCP pName, C_WCP pItem, WC Dlm, BOOL fErase,
											UI	 (CALLBACK *cbEnvGet)(C_WCP pName, PAJCREGTYPE pType, WCP pBuf, UI lBuf),
											BOOL (CALLBACK *cbEnvPut)(C_WCP pName, AJCREGTYPE type, C_WCP pTxt),
											BOOL (CALLBACK *cbEnvDel)(C_WCP pName))
{
	BOOL		rc = FALSE;
	AJCREGTYPE	type;
	int			stl, len;
	WCP			pBuf, pTop, pEnd;

	if (pItem != NULL && *pItem != 0) {								//	LȃpXH
		if (stl = (int)cbEnvGet(pName, &type, NULL, 0)) {			//		eLXg̒(I[܂)擾CnjH
			len = stl + (int)wcslen(pItem) + 1;						//			Ŝ̃eLXg̒ݒ
			if (pBuf = AjcTAllocW(len)) {							//			eLXgobt@mہCH
				memset(pBuf, 0, len * 2);
				cbEnvGet(pName, &type, pBuf, len);					//				eLXgǂݏo
				if (pTop = SearchItemInEnvW(pBuf, pItem, Dlm)) {	//				폜鍀ڌCH
					pEnd = pTop + wcslen(pItem);					//					폜pX̎̈ʒuݒ
					memmove(pTop, pEnd, (wcslen(pEnd) + 1) * 2);	//					폜pX
					AdjustSemiCollonW(pBuf);						//					AZ~RPɂ
					//	ϐw肠 and ږH
					if (fErase && (pBuf[0] == 0 || AjcStrSameAsAllCharW(pBuf, L' '))) {
						rc = cbEnvDel(pName);						//						ϐ폜
					}
					//	ϐwȂ or ڂH
					else {											//					󕶎ȊOiڗLjbϐۑwH
						rc = cbEnvPut(pName, type, pBuf);			//						eLXg
					}
				}
				else rc = TRUE;										//				폜鍀ڂꍇ͂njƂ
				free(pBuf);											//				eLXgobt@
			}
		}
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	WXg̊ϐ؂蕶ŋ؂ꂽڂ												//
//																												//
//	@	F	pStr	- ϐ̓e																		//
//				pItem	- 镶																		//
//				Dlm		- ؂蕶																			//
//																												//
//	߂l	F	NULLFYڂ̃AhX																		//
//				NULLFڂ݂͑Ȃ																		//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	BCP		SearchItemInEnvA(BCP pStr, C_BCP pPath, BC Dlm)
{
	BCP		rc	= NULL;
	BCP		p, pBuf;
	BC		szDlm[2];

	if (pBuf = AjcTAllocA((UI)strlen(pStr) + 1)) {
		szDlm[0] = Dlm;
		szDlm[1] = 0;
		strcpy(pBuf, pStr);
		if (p = AjcStrTokExA(pBuf, szDlm, "\"")) {
			do {
				if (mbsicmp(p, pPath) == 0) {
					rc = pStr + ((UX)p - (UX)pBuf);
					break;
				}
			} while (p = AjcStrTokExA(NULL, szDlm, "\""));
		}
		free(pBuf);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	WCP		SearchItemInEnvW(WCP pStr, C_WCP pPath, WC Dlm)
{
	WCP		rc	= NULL;
	WCP		p, pBuf;
	WC		szDlm[2];

	if (pBuf = AjcTAllocW((UI)wcslen(pStr) + 1)) {
		szDlm[0] = Dlm;
		szDlm[1] = 0;
		wcscpy(pBuf, pStr);
		if (p =  AjcStrTokExW(pBuf, szDlm, L"\"")) {
			do {
				if (wcsicmp(p, pPath) == 0) {
					rc = pStr + (((UX)p - (UX)pBuf) / 2);
					break;
				}
			} while (p = AjcStrTokExW(NULL, szDlm, L"\""));
		}
		free(pBuf);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	擪Ɩ̃Z~R폜AԂ̘AZ~RPɂ܂Ƃ߂									//
//																												//
//	@	F	pStr	- PATHϐ̓e																	//
//																												//
//	߂l	F	NULLFYpXڂ̃AhX																	//
//				NULLFpXڂ݂͑Ȃ																	//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	VO		AdjustSemiCollonA(BCP pStr)
{
	int		len;
	BCP		p;

	do {
		//----- 擪̃Z~R폜 -------------------------------------//
		for (p = pStr, len = 0; *p == ';'; p++, len++);
		if (len != 0) {
			memmove(pStr, p, strlen(p) + 1);
		}
		//----- ̃Z~R폜 -------------------------------------//
		len = (int)strlen(pStr);
		for (p = pStr + (len - 1); len > 0 && *p == ';'; p--, len--);
		if (*p != ';') {
			p++;
		}
		*p = 0;
		//----- AZ~RPɂ܂Ƃ߂ -----------------------//
		while (p = mbsstr(pStr, ";;")) {
			len = 2;
			while (*(p + len) == ';') {len++;}
			memmove(p + 1, p + len, strlen(p + len) + 1);
		}
	} while(0);
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	VO		AdjustSemiCollonW(WCP pStr)
{
	int		len;
	WCP		p;

	do {
		//----- 擪̃Z~R폜 -------------------------------------//
		for (p = pStr, len = 0; *p == L';'; p++, len++);
		if (len != 0) {
			memmove(pStr, p, (wcslen(p) + 1) * 2);
		}
		//----- ̃Z~R폜 -------------------------------------//
		len = (int)wcslen(pStr);
		for (p = pStr + (len - 1); len > 0 && *p == L';'; p--, len--);
		if (*p != L';') {
			p++;
		}
		*p = 0;
		//----- AZ~RPɂ܂Ƃ߂ -----------------------//
		while (p = wcsstr(pStr, L";;")) {
			len = 2;
			while (*(p + len) == L';') {len++;}
			memmove(p + 1, p + len, (wcslen(p + len) + 1) * 2);
		}
	} while(0);
}
//==============================================================================================================//
//	ϐ̗L																							//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO	WINAPI AjcRegEnableEnvironment(VO)
{
	UX	ReturnValue = 0;
	SendMessageTimeout(HWND_BROADCAST, WM_SETTINGCHANGE, 0, (LPARAM)"Environment", SMTO_ABORTIFHUNG, 5000, &ReturnValue);
}

//==============================================================================================================//
//	WXgpX̑݃`FbN																				//
//																												//
//	@F	hTop		- gbvL[																		//
//				pPath		- WXgpX̃AhX														//
//				pErr		- G[R[hi[obt@̃AhXisvNULL)							//
//																												//
//	߂l	F	TRUE  - YpXL																			//
//				FALSE - YpX^ANZXG[															//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegIsPathExistA	  (HKEY hTop, C_BCP pPath, UIP pErr)
{
	BOOL	rc	  = FALSE;
	int		err;
	HKEY	hKey  = NULL;

	//	WXgpX I[v`FbN
	if ((err = RegOpenKeyExA(hTop,											//	L[EI[vCH
							 pPath,											//	E	iTuL[j
							 0,												//	E	iɂOj
							 KEY_READ,										//	E	iANZXCTuL[̏ꍇ͕svj
							 &hKey)) == ERROR_SUCCESS && hKey != NULL) {	//	E	inhi[obt@̃AhXj
		rc = TRUE;
		RegCloseKey(hKey);
	}
	//	G[R[hi[
	if (pErr != NULL) *pErr = err;

	return rc;
}

//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegIsPathExistW	  (HKEY hTop, C_WCP pPath, UIP pErr)
{
	BOOL	rc	  = FALSE;
	int		err;
	HKEY	hKey  = NULL;

	//	WXgpX I[v`FbN
	if ((err = RegOpenKeyExW(hTop,											//	L[EI[vCH
							 pPath,											//	E	iTuL[j
							 0,												//	E	iɂOj
							 KEY_READ,										//	E	iANZXCTuL[̏ꍇ͕svj
							 &hKey)) == ERROR_SUCCESS && hKey != NULL) {	//	E	inhi[obt@̃AhXj
		rc = TRUE;
		RegCloseKey(hKey);
	}
	//	G[R[hi[
	if (pErr != NULL) *pErr = err;

	return rc;
}
//==============================================================================================================//
//	WXgL[̑݃`FbN																				//
//																												//
//	@F	hTop		- gbvL[																		//
//				pPath		- WXgpX̃AhX														//
//				pErr		- G[R[hi[obt@̃AhXisvNULL)							//
//																												//
//	߂l	F	TRUE  - YpXL																			//
//				FALSE - YpX^ANZXG[															//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegIsKeyExistA	  (HKEY hTop, C_BCP pPath, C_BCP pKey, UIP pErr)
{
	BOOL	rc	  = FALSE;
	int		err;
	HKEY	hKey  = NULL;

	//	WXgpX I[v`FbN
	if ((err = RegOpenKeyExA(hTop,											//	L[EI[vCH
							 pPath,											//	E	iTuL[j
							 0,												//	E	iɂOj
							 KEY_READ,										//	E	iANZXCTuL[̏ꍇ͕svj
							 &hKey)) == ERROR_SUCCESS && hKey != NULL) {	//	E	inhi[obt@̃AhXj
		if ((err = RegQueryValueExA(hKey, pKey, NULL, NULL, NULL, NULL)) == ERROR_SUCCESS) {
			rc = TRUE;
		}
		RegCloseKey(hKey);
	}
	//	G[R[hi[
	if (pErr != NULL) *pErr = err;

	return rc;
}

//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcRegIsKeyExistW	  (HKEY hTop, C_WCP pPath, C_WCP pKey, UIP pErr)
{
	BOOL	rc	  = FALSE;
	int		err;
	HKEY	hKey  = NULL;

	//	WXgpX I[v`FbN
	if ((err = RegOpenKeyExW(hTop,											//	L[EI[vCH
							 pPath,											//	E	iTuL[j
							 0,												//	E	iɂOj
							 KEY_READ,										//	E	iANZXCTuL[̏ꍇ͕svj
							 &hKey)) == ERROR_SUCCESS && hKey != NULL) {	//	E	inhi[obt@̃AhXj
		if ((err = RegQueryValueExW(hKey, pKey, NULL, NULL, NULL, NULL)) == ERROR_SUCCESS) {
			rc = TRUE;
		}
		RegCloseKey(hKey);
	}
	//	G[R[hi[
	if (pErr != NULL) *pErr = err;

	return rc;
}


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpT|[gR[h																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//

//==============================================================================================================//
//	Jg[UEWXgPATHϐփpXڂǉ												//
//																												//
//	@	F	path	- ǉpX																	//
//				fFront	- TRUE	: 擪֒ǉ																	//
//						  FALSE : ֒ǉ																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcEnvAddPathItemW(C_WCP pPath, BOOL fFront)
{
	return SubEnvAddItemW(L"PATH", pPath, L';', fFront, AJCREG_EXPAND_SZ, AjcRegHkCuEnvGetW, AjcRegHkCuEnvPutW);
}
//==============================================================================================================//
//	Jg[UEWXgPATHϐpXڂ폜												//
//																												//
//	@	F	pPath	 - 폜pX																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcEnvDelPathItemW(C_WCP pPath)
{
	return SubEnvDelItemW(L"PATH", pPath, L';', FALSE, AjcRegHkCuEnvGetW, AjcRegHkCuEnvPutW, AjcRegHkCuEnvDelW);
}

