#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	WI{^Q̓																						//
//																												//
//**************************************************************************************************************//

#define	PARENTPROPNAME	L"AJCSBCRBTPARENTPROP"
#define	RBTPROPNAME		L"AJCSBCRBTRBTPROP"

//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
#define	MAX_RBT		128

typedef struct {
	HWND	hGrpBox;
	UI		idGrpBox;
	RECT	rcGrpBox;
	UI		nRbt;
	HWND	hRbt[MAX_RBT];
} WKSBCRBT, *PWKSBCRBT;
typedef const WKSBCRBT *PCWKSBCRBT;
//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC_DEF(Parent);

static	BOOL	CALLBACK	SubEnumCorrectRbt(HWND hChild, LPARAM lParam);
static	VO		SubRbtSort(PWKSBCRBT pW);
static	VO		CALLBACK cbRemoveAvl(UX key, VOP pNode, UI len, UI nest, UX cbp);

//==============================================================================================================//
//	WI{^Q																						//
//																												//
//	@F	hGrpBox		- O[v{bNX̃EChnh												//
//																												//
//	߂lF	WI{^̌																				//
//==============================================================================================================//
AJCEXPORT UI	 WINAPI	AjcSbcRadioBtns(HWND hGrpBox)
{
	UI			rc		 = 0;
	HAJCAVL		hAvl	 = NULL;
	PWKSBCRBT	pW		 = NULL;
	HWND		hParent	 = NULL;
	WNDPROC		WpParent = NULL;
	BOOL		fErr	 = TRUE;
	WKSBCRBT	buf;

	do {
		//----- EChnh`FbN -----------------------------------------------------------------------//
		if (!IsWindow(hGrpBox)) break;
		//----- eEChnhݒ -------------------------------------------------------------------------//
		if (!(hParent = GetParent(hGrpBox))) break;
		//----- CX^X[NNA[ ---------------------------------------------------------------------//
		pW = &buf;
		memset(pW, 0, sizeof(WKSBCRBT));
		//----- CX^X[N -----------------------------------------------------------------------//
		pW->hGrpBox	 = hGrpBox;
		pW->idGrpBox = (UI)MAjcGetWindowLong(hGrpBox, GWL_ID);
		GetWindowRect(hGrpBox, &pW->rcGrpBox);
		pW->nRbt	 = 0;
		//----- O[v{bNX̃WI{^nhW ---------------------------------------------------//
		EnumChildWindows(hParent, SubEnumCorrectRbt, (LPARAM)pW);
		SubRbtSort(pW);
		if (pW->nRbt == 0) break;
		//----- `uk؂eEChɊ֘At -----------------------------------------------------------------//
		if (hAvl = (HANDLE)GetProp(hParent, PARENTPROPNAME)) {	// `ukؓo^
			//----- `uk؂փCX^Xo^ -----//
			if (!AjcAvlInsNode(hAvl, (UX)hGrpBox, pW, sizeof(WKSBCRBT))) break;
		}
		else {	// `ukؖo^
			//----- `ukؐ ---------------------//
			hAvl = AjcAvlCreate(0, NULL, cbRemoveAvl);
			if (hAvl == NULL) break;
			//----- `uk؂eEChɊ֘At -- //
			if (!SetProp(hParent, PARENTPROPNAME, (HANDLE)hAvl)) break;
			//----- `uk؂փCX^Xo^ -------//
			if (!AjcAvlInsNode(hAvl, (UX)hGrpBox, pW, sizeof(WKSBCRBT))) break;
			//----- eECh̃TuNX ---------//
			if (MAjcMmpSetSubclass(Parent, hParent) == NULL) break;
		}
		//----- WI{^O[v̎|AvpeBݒ -------------------------------------------------//
		if (!SetProp(hGrpBox, SBCRADIOBTNS_GROUP_PROPNAME, (HANDLE)TRUE)) break;
		//----- G[tOƖ߂lݒ -------------------------------------------------------------------//
		fErr = FALSE;
		rc	 = pW->nRbt;
	} while(0);

	//----- G[Ȃ \[X -----//
	if (fErr) {
		free(pW);
		if (WpParent) MAjcSetWindowLong(hParent, GWLP_WNDPROC, (UX)WpParent);
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	WI{^nhWiR[obNj																	//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CALLBACK	SubEnumCorrectRbt(HWND hChild, LPARAM lParam)
{
	PWKSBCRBT	pW = (PWKSBCRBT)lParam;
	BOOL		rc = TRUE;
	UI			sty;
	RECT		rct;
	WC			cls[32];

	do {
		//----- NX擾 -------------------------//
		if (GetClassName(hChild, cls, AJCTSIZE(cls)) == 0) {
			break;
		}
		//----- NX`FbN ---------------------//
		if (wcsicmp(cls, L"BUTTON") != 0) {
			break;
		}
		//----- X^C`FbN ---------------------//
		sty = (UW)(MAjcGetWindowLong(hChild, GWL_STYLE) & BS_TYPEMASK);
		if (sty != BS_RADIOBUTTON  &&  sty != BS_AUTORADIOBUTTON) {
			break;
		}
		//----- ʒuO[v{bNX`FbN ---//
		GetWindowRect(hChild, &rct);
		if (!(rct.left	 >= pW->rcGrpBox.left	&&
			  rct.top	 >= pW->rcGrpBox.top	&&
			  rct.right	 <= pW->rcGrpBox.right	&&
			  rct.bottom <= pW->rcGrpBox.bottom)) {
			break;
		}
		//----- WI{^nho^ -------------//
		if (pW->nRbt < MAX_RBT) {
			pW->hRbt[pW->nRbt] = hChild;
			SetProp(hChild, RBTPROPNAME, pW->hGrpBox); // ٰޯ̃nho^
			pW->nRbt++;
		}
		else {
			rc = FALSE;
		}
	} while(0);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	WI{^nhяɃ\[g																		//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	int		x;
	int		y;
} SRSTBL, *PSRSTBL;
//--------------------------------------------------------------------------------------------------------------//
static	VO		SubRbtSort(PWKSBCRBT pW)
{
	UI		i, j;
	int		mrg, xMin, xMax, yMin, yMax;
	HWND	hwnd;
	RECT	r;
	SRSTBL	svTbl;
	SRSTBL	tbl[MAX_RBT];

	if (pW->nRbt >= 2) {
		//----- WI{^̈ʒue[uɐݒ ---------------------------------------------//
		for (i=0; i<pW->nRbt; i++) {
			GetWindowRect(pW->hRbt[i], &r);
			tbl[i].x = r.left;
			tbl[i].y = r.top;
		}
		//----- ʒũ}[Wݒ -------------------------------------------------------------//
		GetWindowRect(pW->hRbt[0], &r);
		mrg = (r.bottom - r.top) / 2;
		//----- }[Ẅʒu𓯈ʒuɐݒ肵Ȃ ---------------------------------------//
		for (i=0; i<pW->nRbt; i++) {
			xMin = tbl[i].x - mrg;	xMax = tbl[i].x + mrg;
			yMin = tbl[i].y - mrg;	yMax = tbl[i].y + mrg;
			for (j=0; j<pW->nRbt; j++) {
				if (tbl[j].x >= xMin  &&  tbl[j].x <= xMax) {
					tbl[j].x = tbl[i].x;
				}
				if (tbl[j].y >= yMin  &&  tbl[j].y <= yMax) {
					tbl[j].y = tbl[i].y;
				}
			}
		}
		//----- \[g -------------------------------------------------------------------------//
		for (i=0; i<pW->nRbt - 1; i++) {
			for (j=i+1; j<pW->nRbt; j++) {
				if ((tbl[i].y > tbl[j].y) || (tbl[i].y == tbl[j].y && tbl[i].x > tbl[j].x)) {
					//--- e[uւ ---//
					memcpy(&svTbl , &tbl[j], sizeof(SRSTBL));
					memcpy(&tbl[j], &tbl[i], sizeof(SRSTBL));
					memcpy(&tbl[i], &svTbl , sizeof(SRSTBL));
					//--- nhւ ---//
					hwnd		= pW->hRbt[j];
					pW->hRbt[j] = pW->hRbt[i];
					pW->hRbt[i] = hwnd;
				}
			}
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	`uk؃m[h폜ʒm																						//
//--------------------------------------------------------------------------------------------------------------//
static	VO	CALLBACK	cbRemoveAvl(UX key, C_VOP pNode, UI len, UI nest, UX cbp)
{
	PCWKSBCRBT	pW = pNode;
	UI			i;

	//----- O[v{bNXPROP --//
	RemoveProp(pW->hGrpBox, SBCRADIOBTNS_GROUP_PROPNAME);

	//----- WI{^PROPJ ------//
	for (i=0; i<pW->nRbt; i++) {
		RemoveProp(pW->hRbt[i], RBTPROPNAME);
	}
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	eEChvV[WiTuNXj																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- WM_COMMAND ---------------------------------------------------------------------------------------------//
AJC_WNDPROC(Parent, WM_COMMAND	)
{
	HAJCAVL		hAvl	= (HAJCAVL)GetProp(hwnd, PARENTPROPNAME);
	PWKSBCRBT	pW		= NULL;
	HWND		hGrpBox = NULL;
	LRESULT		rc = 0;
	UI			i;
	BOOL		fFind = FALSE;
	WKSBCRBT	buf;

	if (hAvl != NULL) {
		//----- {^nh -----------------------------//
		if (HIWORD(wParam) == BN_CLICKED) {
			if (hGrpBox = GetProp((HWND)lParam, RBTPROPNAME)) {
				if (AjcAvlGetNodeByKey(hAvl, (UX)hGrpBox, &buf, sizeof buf) != -1) {
					pW = &buf;
					if (pW->hGrpBox != NULL) {
						for (i=0; i<pW->nRbt; i++) {
							if (pW->hRbt[i] == (HWND)lParam) {
								fFind = TRUE;
								break;
							}
						}
					}
				}
			}
		}
		//----- IWiEEChvV[WĂяo -------//
		if (fFind) {
			UI id = (UI)MAjcGetWindowLong(pW->hGrpBox, GWL_ID);
			rc = MAjcMmpCallOrgWndProcEx(Parent, hwnd, WM_COMMAND, MAKELONG(id, AJCRBTN_SELECT),
														fCmdWithHdl ? (LPARAM)pW->hGrpBox : i);
		}
		else {
			rc = MAjcMmpCallOrgWndProcEx(Parent, hwnd, WM_COMMAND, wParam, lParam);
		}
	}
	return rc;
}
//----- WM_DESTROY ---------------------------------------------------------------------------------------------//
AJC_WNDPROC(Parent, WM_DESTROY	)
{
	HAJCAVL		hAvl = (HAJCAVL)GetProp(hwnd, PARENTPROPNAME);
	LRESULT		rc = 0;

	//----- IWivV[WR[ ------------------------//
	rc = MAjcMmpCallOrgWndProc(Parent);

	//----- \[XJ ----------------------------------------//
	if (hAvl != NULL) {
		AjcAvlDelete(hAvl);
		RemoveProp(hwnd, PARENTPROPNAME);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(Parent)
	AJC_WNDMAP_MSG(Parent, WM_COMMAND)
	AJC_WNDMAP_MSG(Parent, WM_DESTROY)
AJC_WNDMAP_END

//==============================================================================================================//
//	`FbNĂ郉WI{^擾																			//
//																												//
//	@F	hGrpBox		- O[v{bNX̃EChnh												//
//																												//
//	߂lF	-1 : `FbNꂢĂ郉WI{^̃CfNXiO`j										//
//				-1 : G[																					//
//==============================================================================================================//
AJCEXPORT UI	WINAPI	AjcSbcGetRbt   (HWND hGrpBox)
{
	UI			rc = -1;
	HAJCAVL		hAvl = (HAJCAVL)GetProp(GetParent(hGrpBox), PARENTPROPNAME);
	PWKSBCRBT	pW = NULL;
	UI			i;
	WKSBCRBT	buf;

	if (hAvl != NULL  &&  AjcAvlGetNodeByKey(hAvl, (UX)hGrpBox, &buf, sizeof buf) != -1) {
		pW = &buf;
		for (i = 0; i < pW->nRbt; i++) {
			if (AjcGetCtrlChk(pW->hRbt[i])) {
				rc = i;
				break;
			}
		}
	}

	return rc;
}
//==============================================================================================================//
//	WI{^`FbN																					//
//																												//
//	@F	hGrpBox		- O[v{bNX̃EChnh												//
//																												//
//	߂lF	TRUE - OK, FALSE - Error																		//
//==============================================================================================================//
AJCEXPORT BOOL	WINAPI	AjcSbcSetRbt   (HWND hGrpBox, UI ix)
{
	BOOL		rc = FALSE;
	HAJCAVL		hAvl = (HAJCAVL)GetProp(GetParent(hGrpBox), PARENTPROPNAME);
	PWKSBCRBT	pW = NULL;
	UI			i;
	WKSBCRBT	buf;

	if (hAvl != NULL  &&  AjcAvlGetNodeByKey(hAvl, (UX)hGrpBox, &buf, sizeof buf) != -1) {
		pW = &buf;
		for (i = 0; i < pW->nRbt; i++) {
			if (i == ix) AjcSetCtrlChk(pW->hRbt[i], TRUE);
			else		 AjcSetCtrlChk(pW->hRbt[i], FALSE);
		}
		rc = TRUE;
	}

	return rc;
}
//==============================================================================================================//
//	WI{^̃nh擾																					//
//																												//
//	@F	hGrpBox		- O[v{bNX̃EChnh												//
//				ix			- WI{^̃CfNXiO`j													//
//																												//
//	߂lF	NULL : `FbNꂢĂ郉WI{^̃CfNXiO`j									//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT HWND	WINAPI	AjcSbcGetRbtHandle(HWND hGrpBox, UI ix)
{
	HWND		rc = NULL;
	HAJCAVL		hAvl = (HAJCAVL)GetProp(GetParent(hGrpBox), PARENTPROPNAME);
	PWKSBCRBT	pW = NULL;
	UI			i;
	WKSBCRBT	buf;

	if (hAvl != NULL  &&  AjcAvlGetNodeByKey(hAvl, (UX)hGrpBox, &buf, sizeof buf) != -1) {
		pW = &buf;
		if (ix < pW->nRbt) {
			for (i = 0; i < pW->nRbt; i++) {
				if (i == ix) {
					rc = pW->hRbt[i];
					break;
				}
			}
		}
	}

	return rc;
}

