#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	Xg[̕																							//
//																												//
//**************************************************************************************************************//

#define	INST_ID			0x87F65A21
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//--------------------------------------------------------------------------------------------------------------//
//	}N																									//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCSSEP_ENTER		if (pW->fMultiThread) EnterCriticalSection(&pW->cs);
#define		AJCSSEP_LEAVE		if (pW->fMultiThread) LeaveCriticalSection(&pW->cs);

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	IsStartTxt (HAJCSSEP pW, BC c);
static	BOOL	IsStartEsc (HAJCSSEP pW, BC c);
static	BOOL	IsStartPkt (HAJCSSEP pW, BC c);
static	VO		SubNtcTxt  (HAJCSSEP pW);
static	VO		SubNtcEsc  (HAJCSSEP pW);
static	VO		SubNtcPkt  (HAJCSSEP pW);
static	VO		SubNtcCtrl (HAJCSSEP pW, BC c);
static	VO		SubNtcNoPkt(HAJCSSEP pW, BC c);
static	VO		SubNtcEvt  (HAJCSSEP pW, UI evt, VOP pDat, UI lDat);

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	evt 	 - CxgR[h																//
//				cbp 	 - R[obNp^																	//
//				cbEvent  - CxgʒmpR[obN															//
//																												//
//	߂l	F	mtkkFnjiCX^XnhiCX^X[NAhXjj						//
//				mtkkFG[																				//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSSEP	WINAPI	AjcSsepCreateA(UI evt, UX cbp, BOOL (CALLBACK *cbEvent)(UI evt, VOP pDat, UI lDat, UX cbp))
{
	HAJCSSEP  pW;

	if ((pW = (HAJCSSEP)AJCMEM(sizeof(AJCSSEP))) != NULL) {
		memset(pW, 0, sizeof *pW);
		pW->InstID				= INST_ID;						//	CX^Xhc
		pW->Mode 				= AJCSSEP_MD_IDLE;				//	[h

		pW->evt					= (evt & AJCSSEP_EV_ALL);		//	Cxg

		pW->fUnicode			= FALSE;						//	UNICODEtO
		pW->fDle				= FALSE;						//	ckd̒tO
		pW->TxtIncMap[CC_TAB]	= TRUE;							//	eLXgI[R[h}bv
		pW->stx					= CC_STX;						//	pPbgpR[h
		pW->etx					= CC_ETX;						//	E
		pW->dle 				= CC_DLE;						//	E

		pW->PktTimOut			= 0;							//	pPbgf[^̃^CAEglmmsn

		pW->hMbc 				= AjcMbcCreate(256, AJCMBC_SJIS);
		pW->SvMbk				= AJCMBC_SJIS;

		pW->hRng				= AjcRngCreate(&pW->RngBuf, sizeof pW->RngBuf, 4096);

		pW->fMultiThread		= FALSE;

		pW->cbp					= cbp;
		pW->cbEvent				= cbEvent;

		if (pW->hRng == NULL) {
			AjcSsepDelete(pW);
			pW = NULL;
		}
	}
	return pW;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSSEP	WINAPI	AjcSsepCreateW(UI evt, UX cbp, BOOL (CALLBACK *cbEvent)(UI evt, VOP pDat, UI lDat, UX cbp))
{
	HAJCSSEP  pW;

	if (pW = AjcSsepCreateA(evt, cbp, cbEvent)) {
		pW->fUnicode = TRUE;
	}
	return pW;
}


//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW 		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcSsepDelete(HAJCSSEP pW)
{
	if (IS_MY_INST(pW)) {
		if (pW->hMbc != NULL) AjcMbcDelete(pW->hMbc);
		if (pW->hRng != NULL) AjcRngDelete(pW->hRng);
		if (pW->fMultiThread) DeleteCriticalSection(&pW->cs);
		free(pW);
	}
}
//==============================================================================================================//
//	}`Xbh̋^֎~																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				fEnable - FALSE : }`Xbh֎~															//
//						  TRUE	: }`Xbh															//
//																												//
//	߂l	F	Ő^֎~																			//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcSsepEnableMultiThread(HAJCSSEP pW, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		rc = pW->fMultiThread;
		if (fEnable) {
			if (!pW->fMultiThread) {
				InitializeCriticalSection(&pW->cs);
				pW->fMultiThread = TRUE;
			}
		}
		else {
			if (pW->fMultiThread) {
				pW->fMultiThread = FALSE;
				DeleteCriticalSection(&pW->cs);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	f[^^																									//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				pDat	- ^f[^̃AhX																//
//				lDat	- ^f[^̃oCg																//
//																												//
//	߂l	F	ݏ̃[h																				//
//==============================================================================================================//
AJCEXPORT	AJCSSEP_MODE	WINAPI	AjcSsepPutData	(HAJCSSEP pW, C_UBP pDat, UI lDat)
{
	UI			tc;

	if (IS_MY_INST(pW) && pDat != NULL) {
		AJCSSEP_ENTER
		//----- pPbg^CAEg`FbN -----------------------------------------------------------------------//
		if (pW->Mode == AJCSSEP_MD_PKT	&&	pW->PktTimOut != 0) {
			tc = GetTickCount();
			if ((tc - pW->PktTimSrt) >= pW->PktTimOut) {
				pW->Mode = AJCSSEP_MD_IDLE;
				pW->fDle = FALSE;
				AjcRngPurge(pW->hRng);
			}
		}
		//----- Xg[ -------------------------------------------------------------------------------------//
		while (lDat--) {
			switch (pW->Mode) {
				//----- ACh -------------------------------------------------------------------------------//
				case AJCSSEP_MD_IDLE:
					if		(IsStartPkt(pW, *pDat)) {				//	ojsJnH
						pW->PktTimSrt = GetTickCount();				//		ojsMJnݒ
						pW->Mode = AJCSSEP_MD_PKT;					//		ojs[h
					}
					else if (!pW->fDle) {							//	ckdȊOH
						SubNtcNoPkt(pW, *pDat);						//		pPbgOoCgʒm
						if		(IsStartEsc(pW, *pDat)) {			//		drbJnH
							pW->Mode = AJCSSEP_MD_ESC;				//			drb[h
							AjcRngPutData(pW->hRng, pDat, 1);		//			drbR[hobt@O
						}
						else if (IsStartTxt(pW, *pDat)) {			//		swsJnH
							BC	txt[2];
							pW->Mode = AJCSSEP_MD_TXT;				//			sws[h
							txt[0] = *pDat; txt[1] = 0;				//				R[hpf[^~
							AjcMbcPutData(pW->hMbc, txt);			//				E
							if (pW->evt & AJCSSEP_EV_TXT) {			//			swsʒmvH
								AjcRngPutData(pW->hRng, pDat, 1);	//				eLXgf[^obt@O
							}
						}
						else {										//		̑
							SubNtcCtrl(pW, *pDat);					//			R[hʒm
						}
					}
					break;
				//----- eLXg[h -----------------------------------------------------------------------------//
				case AJCSSEP_MD_TXT:
					if		(IsStartPkt(pW, *pDat)) {				//	ojsJnH
						SubNtcTxt(pW);								//		swsʒm
						pW->Mode = AJCSSEP_MD_PKT;					//		ojs[h
						pW->PktTimSrt = GetTickCount();				//		ojsMJnݒ
					}
					else if (!pW->fDle) {							//	ckdȊOH
						SubNtcNoPkt(pW, *pDat);						//		pPbgOoCgʒm
						if		(IsStartEsc(pW, *pDat)) {			//		drbJnH
							SubNtcTxt(pW);							//			swsʒm
							pW->Mode = AJCSSEP_MD_ESC;				//			drb[h
							AjcRngPutData(pW->hRng, pDat, 1);		//			drbf[^obt@O
						}
						else if (iscntrl(*pDat) &&					//		swsIH
								 !pW->TxtIncMap[*pDat]) {			//		E
							SubNtcTxt(pW);							//			swsʒm
							SubNtcCtrl(pW, *pDat);					//			R[hʒm
							pW->Mode = AJCSSEP_MD_IDLE;				//			ACh
						}
						else {										//		̑H
							BC	txt[2];
							txt[0] = *pDat; txt[1] = 0;				//			R[hpf[^~
							AjcMbcPutData(pW->hMbc, txt);			//			E
							if (pW->evt & AJCSSEP_EV_TXT) {			//			swsʒmvH
								AjcRngPutData(pW->hRng, pDat, 1);	//				swsf[^obt@O
							}
						}
					}
					break;
				//----- drb[h -------------------------------------------------------------------------------//
				case AJCSSEP_MD_ESC:
					if		(IsStartPkt(pW, *pDat)) {				//	ojsJnH
						AjcRngPurge(pW->hRng);						//		drbf[^j
						pW->PktTimSrt = GetTickCount();				//		ojsMJnݒ
						pW->Mode = AJCSSEP_MD_PKT;					//		ojs[h
					}
					else if (!pW->fDle) {							//	ckdȊOH
						SubNtcNoPkt(pW, *pDat);						//		pPbgOoCgʒm
						if		(iscntrl(*pDat)) {					//		R[hH
							AjcRngPurge(pW->hRng);					//			drbf[^j
							SubNtcCtrl(pW, *pDat);					//			R[hʒm
							pW->Mode = AJCSSEP_MD_IDLE;				//			ACh
						}
						else if (isalpha(*pDat)) {					//		pH
							AjcRngPutData(pW->hRng, pDat, 1);		//			pobt@O
							SubNtcEsc(pW);							//			drbf[^ʒm
							pW->Mode = AJCSSEP_MD_IDLE;				//			ACh
						}
						else {										//		̑H
							AjcRngPutData(pW->hRng, pDat, 1);		//			drbf[^obt@O
						}
					}
					break;
				//----- ojs[h -------------------------------------------------------------------------------//
				case AJCSSEP_MD_PKT:
					if (!pW->fDle) {								//	ckdȊOH
						if (*pDat == pW->dle) {						//		ckdH
							pW->fDle = TRUE;						//			ckd
						}
						else {										//		ckdȊOH
							AjcRngPutData(pW->hRng, pDat, 1);		//			ojsf[^obt@O
						}
					}
					else {											//	ckdH
						pW->fDle = FALSE;							//		ckd
						if		(*pDat == pW->etx) {				//		dswH
							SubNtcPkt(pW);							//			ojsf[^ʒm
							pW->Mode = AJCSSEP_MD_IDLE;				//			ACh
						}
						else if (*pDat == pW->stx) {				//		rswH
							AjcRngPurge(pW->hRng);					//			ojsf[^jiojsĊJnj
							pW->PktTimSrt = GetTickCount();			//			ojsMJnݒ
						}
						else {										//		̑H
							AjcRngPutData(pW->hRng, pDat, 1);		//			ojsf[^obt@O
						}
					}
					break;
			}
			pDat++;
		}
		AJCSSEP_LEAVE
	}
	return pW->Mode;
}
//==============================================================================================================//
//	eLXg^																								//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				pTxt	- ^eLXgf[^̃AhX														//
//				lTxt	- ^eLXgf[^̕i|Pw莞͎Zoj								//
//																												//
//	߂l	F	ݏ̃[h																				//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	AJCSSEP_MODE	WINAPI	AjcSsepPutTextA	(HAJCSSEP pW, C_BCP pTxt, UI lTxt)
{
	AJCSSEP_MODE	rc;

	if (IS_MY_INST(pW) && pTxt != NULL) {
		AJCSSEP_ENTER
		lTxt = AjcStrAdjustLenA(pTxt, lTxt);
		rc = AjcSsepPutData(pW, pTxt, lTxt);
		AJCSSEP_LEAVE
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	AJCSSEP_MODE	WINAPI	AjcSsepPutTextW	(HAJCSSEP pW, C_WCP pTxt, UI lTxt)
{
	AJCSSEP_MODE	rc	 = pW->Mode;
	BCP				pTmp = NULL;
	UI				len  = 0;

	if (IS_MY_INST(pW) && pTxt != NULL) {
		lTxt = AjcStrAdjustLenW(pTxt, lTxt);
		len = WideCharToMultiByte(CP_ACP, 0, pTxt, lTxt, NULL, 0, NULL, NULL);
		if (len != 0 && (pTmp = (BCP)AJCMEM(len))) {
			WideCharToMultiByte(CP_ACP, 0, pTxt, lTxt, pTmp, len, NULL, NULL);
			rc = AjcSsepPutData(pW, pTmp, len);
		}
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	eLXgJn`FbN																						//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	IsStartTxt(HAJCSSEP pW, BC c)
{
	BOOL	rc = FALSE;

	if (!iscntrl((UB)c) || pW->TxtIncMap[c]) {
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	drbR[hJn`FbN																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	IsStartEsc(HAJCSSEP pW, UB c)
{
	BOOL	rc = FALSE;

	if (pW->evt & AJCSSEP_EV_ESC) {
		if (c == CC_ESC) {
			rc = TRUE;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	pPbgJn`FbN																						//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	IsStartPkt(HAJCSSEP pW, UB c)
{
	BOOL	rc = FALSE;

	if (pW->evt & AJCSSEP_EV_PKT) {
		if (!pW->fDle) {
			if (c == pW->dle) {
				pW->fDle = TRUE;
			}
		}
		else {
			pW->fDle = FALSE;
			if (c == pW->stx) {
				rc = TRUE;
			}
		}
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	eLXgʒm																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SubNtcTxt(HAJCSSEP pW)
{
	BCP		pTxt;
	WCP		pWcs;
	UI		len, lWcs;

	if (pW->evt & AJCSSEP_EV_TXT) {
		if (len = AjcRngGetDataSize(pW->hRng)) {
			if (pTxt = AjcTAllocA(len + 1)) {
				AjcRngGetData(pW->hRng, pTxt, len);
				pTxt[len] = 0;
				if (pW->fUnicode) {
					lWcs = MultiByteToWideChar(CP_ACP, 0, pTxt, -1, NULL, 0);
					if (pWcs = AjcTAllocW(lWcs)) {
						MultiByteToWideChar(CP_ACP, 0, pTxt, -1, pWcs, lWcs);
						SubNtcEvt(pW, AJCSSEP_EV_TXT, pWcs, lWcs - 1);
					}
					free(pTxt);
				}
				else {
					SubNtcEvt(pW, AJCSSEP_EV_TXT, pTxt, len);
				}
			}
		}
	}
	AjcRngPurge(pW->hRng);
}
//--------------------------------------------------------------------------------------------------------------//
//	drbR[hʒm																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SubNtcEsc(HAJCSSEP pW)
{
	BCP		pTxt;
	WCP		pWcs;
	UI		len, lWcs;

	if (pW->evt & AJCSSEP_EV_ESC) {
		if (len = AjcRngGetDataSize(pW->hRng)) {
			if (pTxt = AjcTAllocA(len + 1)) {
				AjcRngGetData(pW->hRng, pTxt, len);
				pTxt[len] = 0;
				if (pW->fUnicode) {
					lWcs = MultiByteToWideChar(CP_ACP, 0, pTxt, -1, NULL, 0);
					if (pWcs = AjcTAllocW(lWcs)) {
						MultiByteToWideChar(CP_ACP, 0, pTxt, -1, pWcs, lWcs);
						SubNtcEvt(pW, AJCSSEP_EV_ESC, pWcs, lWcs - 1);
					}
					free(pTxt);
				}
				else {
					SubNtcEvt(pW, AJCSSEP_EV_ESC, pTxt, len);
				}
			}
		}
	}
	AjcRngPurge(pW->hRng);
}
//--------------------------------------------------------------------------------------------------------------//
//	pPbgʒm																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SubNtcPkt(HAJCSSEP pW)
{
	VOP		pPkt;
	UI		len;

	if (pW->evt & AJCSSEP_EV_PKT) {
		len = AjcRngGetDataSize(pW->hRng);
		if (pPkt = (VOP)AJCMEM(len)) {
			AjcRngGetData(pW->hRng, pPkt, len);
			SubNtcEvt(pW, AJCSSEP_EV_PKT, pPkt, len);
		}
	}
	AjcRngPurge(pW->hRng);
}
//--------------------------------------------------------------------------------------------------------------//
//	R[hʒm																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SubNtcCtrl(HAJCSSEP pW, BC c)
{
	union {BCP pTxt; WCP pWcs;} u;

	if (pW->evt & AJCSSEP_EV_CTRL) {
		if (pW->fUnicode) {
			if (u.pWcs = AjcTAllocW(2)) {
				u.pWcs[0] = c;
				u.pWcs[1] = 0;
				SubNtcEvt(pW, AJCSSEP_EV_CTRL, u.pWcs, 1);
			}
		}
		else {
			if (u.pTxt = AjcTAllocA(2)) {
				u.pTxt[0] = c;
				u.pTxt[1] = 0;
				SubNtcEvt(pW, AJCSSEP_EV_CTRL, u.pTxt, 1);
			}
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	pPbgȊÕoCgʒm																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SubNtcNoPkt(HAJCSSEP pW, UB c)
{
	UBP		pByte;

	if (pW->evt & AJCSSEP_EV_NOPKT) {
		if (pByte = (UBP)AJCMEM(2)) {
			pByte[0] = c;
			pByte[1] = 0;
			SubNtcEvt(pW, AJCSSEP_EV_NOPKT, pByte, 1);
		}
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	[U`ooɃCxgʒm																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SubNtcEvt(HAJCSSEP pW, UI evt, VOP pDat, UI lDat)
{
	BOOL	rsu = TRUE;

	if (pW->cbEvent) {
		rsu = pW->cbEvent(evt, pDat, lDat, pW->cbp);
	}
	if (rsu && pDat != NULL) {
		free(pDat);
	}
}

//==============================================================================================================//
//	Zbg																									//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO	 		WINAPI	AjcSsepReset	(HAJCSSEP pW)
{
	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		pW->Mode = AJCSSEP_MD_IDLE;			//	ACh
		pW->fDle = FALSE;					//	sckdȂ
		pW->SvMbk = AJCMBC_SJIS;			//	S-JISR[h
		AjcMbcReset(pW->hMbc);				//	ʕR[hobt@
		AjcRngPurge(pW->hRng);			//	Oobt@ENA[
		AJCSSEP_LEAVE
	}
}
//==============================================================================================================//
//	CxgR[hݒ																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				evt		- CxgR[h																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcSsepSetEvent (HAJCSSEP pW, UI evt)
{
	AJCSSEP_ENTER

	if (IS_MY_INST(pW)) {
		pW->evt = evt;

		pW->Mode = AJCSSEP_MD_IDLE;
		pW->fDle = FALSE;
		AjcRngPurge(pW->hRng);

		AJCSSEP_LEAVE
	}
}
//==============================================================================================================//
//	CxgR[h擾																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	߂l	F	CxgR[h																			//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcSsepGetEvent (HAJCSSEP pW)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		rc = pW->evt;
		AJCSSEP_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	eLXgɊ܂߂R[hݒ																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				num		- R[ȟ																		//
//				...		- R[hQiintj																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcSsepSetIncTxt(HAJCSSEP pW, UI num, ...)
{
	UI		i;
	BC		c;
	va_list vls;

	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		va_start(vls, num);
		memset(&pW->TxtIncMap, FALSE, sizeof pW->TxtIncMap);
		for (i=0; i<num; i++) {
			c = (BC)va_arg(vls, UI);
			if (iscntrl((UB)c)) {
				pW->TxtIncMap[c] = TRUE;
			}
		}
		va_end(vls);
		AJCSSEP_LEAVE
	}
}
//==============================================================================================================//
//	pPbgR[hirswjݒ																			//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				stx		- rswR[h																			//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcSsepSetStx	(HAJCSSEP pW, UI stx)
{
	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		pW->stx = stx;
		AJCSSEP_LEAVE
	}
}
//==============================================================================================================//
//	pPbgR[hirswj擾																			//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	߂l	F	rswR[h																					//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcSsepGetStx	(HAJCSSEP pW)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		rc = pW->stx;
		AJCSSEP_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	pPbgR[hidswjݒ																			//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				etx		- dswR[h																			//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcSsepSetEtx	(HAJCSSEP pW, UI etx)
{
	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		pW->etx = etx;
		AJCSSEP_LEAVE
	}
}
//==============================================================================================================//
//	pPbgR[hidswj擾																			//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	߂l	F	dswR[h																					//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcSsepGetEtx	(HAJCSSEP pW)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		rc = pW->etx;
		AJCSSEP_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	pPbgR[hickdjݒ																			//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				dle		- ckdR[h																			//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcSsepSetDle	(HAJCSSEP pW, UI dle)
{
	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		pW->dle = dle;
		AJCSSEP_LEAVE
	}
}
//==============================================================================================================//
//	pPbgR[hickdj擾																			//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	߂l	F	ckdR[h																					//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcSsepGetDle	(HAJCSSEP pW)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		rc = pW->dle;
		AJCSSEP_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	pPbgf[^̃^CAEglݒ																			//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				time	- ^CAEglmmsn																	//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcSsepSetPktTimeOut(HAJCSSEP pW, UI time)
{
	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		pW->PktTimOut = time;
		AJCSSEP_LEAVE
	}
}
//==============================================================================================================//
//	pPbgf[^̃^CAEgl擾																			//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	߂l	F	^CAEglmmsn																			//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcSsepGetPktTimeOut(HAJCSSEP pW)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		rc = pW->PktTimOut;
		AJCSSEP_LEAVE
	}
	return rc;
}

//==============================================================================================================//
//	pPbgf[^																							//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				pDat	- pPbgf[^ɕϊoCif[^̃AhXipPbg쐬NULLłOK)		//
//				lDat	- pPbgf[^ɕϊoCif[^̃oCgipPbg쐬͂Oj				//
//				pBytes	- pPbgf[^̃oCgi[obt@̃AhX							//
//																												//
//	߂l	F	NULL : pPbgf[^̃AhX														//
//				NULL : G[																					//
//==============================================================================================================//
AJCEXPORT	VOP			WINAPI	AjcSsepMakePacket(HAJCSSEP pW, C_VOP pDat, UI lDat, UIP pBytes)
{
	UBP		pPkt;
	C_UBP	p;
	UBP		q;
	UI		i, lPkt;

	if (IS_MY_INST(pW) && (pDat != NULL || lDat == 0)) {
		AJCSSEP_ENTER
		//----- pPbgf[^C[W̃oCgZo -----------------------------//
		lPkt = 4;
		for (i=0, p=pDat; i<lDat; i++, p++) {
			if (*p == pW->dle) lPkt += 2;
			else			   lPkt++;
		}
		//----- pPbgf[^C[W ---------------------------------------//
		if (pPkt = (UBP)AJCMEM(lPkt)) {
			q = pPkt;
			*q++ = pW->dle;
			*q++ = pW->stx;
			for (i=0, p=pDat; i<lDat; i++, p++) {
				*q++ = *p;
				if (*p == pW->dle) {
					*q++ = pW->dle;
				}
			}
			*q++ = pW->dle;
			*q++ = pW->etx;

			if (pBytes != NULL) {
				*pBytes = lPkt;
			}
		}
		AJCSSEP_LEAVE
	}
	return pPkt;
}
//==============================================================================================================//
//	pPbgf[^̊J																				//
//																												//
//	@	F	pMemBlk	- AjcSsepMakePacketɂ萶pPbgf[^̃AhX								//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO			WINAPI	AjcSsepRelease(VOP pMemBlk)
{
	if (pMemBlk != NULL) {
		free(pMemBlk);
	}
}
//==============================================================================================================//
//	R[hpipjeLXg^																		//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				pTxt	- ^ipjeLXg̃AhX													//
//																												//
//	߂l	F	Ȃ																							//
//																												//
//	@ʏAR[hpf[^́A񕪗̉ߒŁAeLXg̃f[^ɂčs邪AAjcSsepPutData	//
//		AAjcSsepPutTextɂăf[^^ȂꍇAR[hpf[^{֐ɂē^				//
//==============================================================================================================//
AJCEXPORT	VO	WINAPI	AjcSsepPutMbc	(HAJCSSEP pW, C_BCP pTxt)
{
	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		AjcMbcPutData(pW->hMbc, pTxt);
		AJCSSEP_LEAVE
	}
}
//==============================================================================================================//
//	eLXg̕R[hʔ																				//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	Return		:	R[h(AJCMBC_SJIS / EUC / UTF8)													//
//==============================================================================================================//
AJCEXPORT	AJCMBCKIND	WINAPI	AjcSsepGetMbcKind(HAJCSSEP pW)
{
	AJCMBCKIND	mbk = AJCMBC_SJIS;

	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		mbk = AjcMbcCheck(pW->hMbc);
		if (mbk <= 0) {
			mbk = pW->SvMbk;
		}
		pW->SvMbk = mbk;
		AJCSSEP_LEAVE
	}
	return mbk;
}
//==============================================================================================================//
//	Ōɔ肵R[hʎ擾																			//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	Return		:	R[h(AJCMBC_SJIS / EUC / UTF8)													//
//==============================================================================================================//
AJCEXPORT	AJCMBCKIND	WINAPI	AjcSsepGetLastMbcKind(HAJCSSEP pW)
{
	AJCMBCKIND	mbk = AJCMBC_SJIS;

	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		mbk = pW->SvMbk;
		AJCSSEP_LEAVE
	}
	return mbk;
}
//==============================================================================================================//
//	R[hobt@ Zbg																				//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO	 		WINAPI	AjcSsepMbcReset	(HAJCSSEP pW)
{
	if (IS_MY_INST(pW)) {
		AJCSSEP_ENTER
		AjcMbcReset(pW->hMbc);				//	ʕR[hobt@
		AJCSSEP_LEAVE
	}
}
