#include	"AjcInternal.h"
#include	"AjcSerialComPortDef.h"
//**************************************************************************************************************//
//																												//
//	bnl|[go								|[gݒ_CAOiȈՁj								//
//																												//
//**************************************************************************************************************//
//==============================================================================================================//
//	peLXg																								//
//==============================================================================================================//
#define	TTL_HEADER		LNGSEL(L" |[gp^"			 , 	L" Port Parameter"					)
#define	TTL_PORT		LNGSEL(L" |[g"					 , 	L" Port"							)
#define	TTL_RATE		LNGSEL(L" `[g"				 , 	L" Rate"							)
#define	TTL_DATSIZ		LNGSEL(L" f[^"					 , 	L" Data Size"						)
#define	TTL_PARITY		LNGSEL(L" peB"					 , 	L" Parity"							)
#define	TTL_STPBIT		LNGSEL(L" Xgbvrbg"			 , 	L" Stop Bit"						)

#define	TTL_FLOWCTRL	LNGSEL(L"Mt["			 , 	L"TX FLOW CONTROL"					)
#define	TTL_NOFLOW		LNGSEL(L"Ȃ"						 , 	L"None"								)
#define	TTL_TXFLOW		LNGSEL(L"\tgEFA ( XON / XOFF )", 	L"Software ( XON / XOFF )"			)
#define	TTL_CTSFLOW		LNGSEL(L"n[hEFA ( CTS )"		 , 	L"Hardware ( CTS )"					)
#define	TTL_DSRFLOW		LNGSEL(L"n[hEFA ( DSR )"		 , 	L"Hardware ( DSR )"					)

#define	PTY_NONE		LNGSEL(L" Ȃ"						 , 	L" None"							)
#define	PTY_ODD			LNGSEL(L" "						 , 	L" Odd"								)
#define	PTY_EVEN		LNGSEL(L" "						 , 	L" Even"							)
#define	PTY_MARK		LNGSEL(L" }[N"					 , 	L" Mark"							)
#define	PTY_SPACE		LNGSEL(L" Xy[X"					 , 	L" Space"							)

#define	TTL_DETAIL		LNGSEL(L"ڍאݒ"					 , 	L"Detail"							)

#define	TTL_MYHOST		LNGSEL(L"Rs[^"			 ,	L"My Computer"						)
#define	TTL_RMTHOST		LNGSEL(L"Rs[^"			 ,	L"Remote Computer"					)
#define	TTL_NAME		LNGSEL(L""						 ,	L"Name"								)
#define	TTL_SLOT		LNGSEL(L"Xbg"					 ,	L"Slot"								)

#define	TTL_GRP_TXDELAY	LNGSEL(L"Mx̐"			 ,	L"Limitation of transmission speed"	)
#define	TTL_CHK_TXDELAY	LNGSEL(L"Mx𐧌"		 ,	L"Limitation of speed"				)
#define	TTL_LBL_TXDELAY	LNGSEL(L"Mx"					 ,	L"Speed"							)

#define	TTL_SERVER		LNGSEL(L"Rs[^ iT[oj",	L"Remote computer ( Server )"		)
#define	TTL_SERVNAME	LNGSEL(L"zXg /"				 ,	L"Name /"							)
#define	TTL_IPADDR		LNGSEL(L"IPAhX"				 ,	L"IP-Addr"							)
#define	TTL_PORTNO		LNGSEL(L"|[gԍ"				 ,	L"PortNo."							)


#define	TTL_OK			LNGSEL(L"nj"						 , 	L"OK"								)
#define	TTL_CANCEL		LNGSEL(L"LZ"				 , 	L"Cancel"							)

//==============================================================================================================//
//	_CAOvVW[N																					//
//==============================================================================================================//
typedef struct {
	HAJCSCP			pW;					//	rboCX^Xnh
	AJCSCP_PORTSEL	sel;				//	bnl|[g^[XbgI
	UI				port;				//	|[gԍ
	DCB				dcb;				//	cba
	BOOL			fChangeToDetail;	//	ڍאݒֈڍs
	AJCSCP_SLOTINFO	slot;				//	[Xbg
	AJCSCP_SOCKINFO	sock;				//	\Pbg
	WC				sect[64];			//	vt@CZNV
	UI				mskRbt;				//	O[WI{^̃}XN
	UI				mskGray;			//	O[ڂ̃}XN

	//---- EChʒu -----//
	BOOL			fWndPos;			//	EChʒuLtO
	POINT			ptWnd;				//	wCxʒuiXN[Wj

	//---- [N ---------------//
	POINT			ptGrp;				//	O[vڂ̍W
	UI				SvPortNo;			//	|[gI𒆂̃|[gԍޔ
} DLGPROP, *LPDLGPROP;

//==============================================================================================================//
//	X^eBbN̈																							//
//==============================================================================================================//
static	const	WC	WndProp[] = L"KWLSCP_PROP";
static			UI	lang=0;

//==============================================================================================================//
//	Tu֐																								//
//==============================================================================================================//
AJC_DLGPROC_DEF(Easy);
static	VO		DispCaption			(HWND hDlg, LPDLGPROP pdp);
static	VO		SetGray				(HWND hDlg, UI id, BOOL fGray);
static	VO		SetPortListToCBO	(HWND hDlg, UI CurrentPort);
static	VO		SetDcbToDialog		(HWND hDlg, LPDLGPROP pdp);
static	BOOL	SetDialogToDcb		(HWND hDlg, LPDLGPROP pdp);
static	VO		SetSlotToDialog		(HWND hDlg, LPDLGPROP pdp);
static	BOOL	SetDialogToSlot		(HWND hDlg, LPDLGPROP pdp);
static	VO		SetSocketToDialog	(HWND hDlg, LPDLGPROP pdp);
static	BOOL	SetDialogToSocket	(HWND hDlg, LPDLGPROP pdp);
static	VO		ShowDevName			(HWND hDlg, UI pno);

extern	BOOL	ScpCreateMySlot(HAJCSCP pW);

//==============================================================================================================//
//	_CAO{bNXɂAʐMp^ҏW																	//
//																												//
//		F	hWnd		- I[i[ECh̃EChnh												//
//				pSel		- bnl|[g^[Xbg^\PbgI									//
//				pPort		- |[gԍ^Iꂽ|[gԍ(1`255)i[obt@̃AhX			//
//				pDCB		- cbal@^ݒ肵cbali[obt@̃AhX						//
//				pfToDetail	- ڍאݒւ̈ڍstOi[obt@|C^isvNULL)					//
//				pSlot		- [Xbg																//
//				pSock		- \Pbg																		//
//				pSect		- vt@CZNV															//
//				mskRbt		- bnl|[g^[XbgI{^̃}XN									//
//				mskGray		- O[i͂󂯕tȂjڎw												//
//				pPt			- _CAO\ʒuimtkk͖j											//
//																												//
//	߂l	F	OFnj{^ŏI	Bit7 ( AJCSCPDGR_OKBUTTON	  ) - nj{^ŏI						//
//										Bit6 ( AJCSCPDGR_PORTCHANGED  ) - |[gԍύX						//
//										Bit5 ( AJCSCPDGR_DCBCHANGED   ) - cbaύX						//
//																												//
//				OFCANCEL{^ŏI																		//
//==============================================================================================================//
UI	AjcScpDlgSetParamEasy(HWND hWnd, HAJCSCP pW, PAJCSCP_PORTSEL pSel,
												UIP pPort, LPDCB pDCB, BOOL *pfToDetail,
												PAJCSCP_SLOTINFO pSlot,
												PAJCSCP_SOCKINFO pSock,
												C_WCP pSect, UI mskRbt, UI mskGray, LPPOINT pPt)
{
	UI			rc = 0;
	DLGPROP		dp;

	memset(&dp, 0, sizeof dp);										//	_CAOvVWp[Nݒ
	dp.pW		= pW;												//		SCPCX^Xnh
	dp.sel		= *pSel;											//		COM-Port / MailSlot Selection
	dp.port		= *pPort;											//		ҏWp|[gԍ
	memcpy(&dp.dcb, pDCB, sizeof dp.dcb);							//		ҏWpcba
	dp.fChangeToDetail = FALSE;										//		ڍאݒֈڍsȂ
	memcpy(&dp.slot, pSlot, sizeof(AJCSCP_SLOTINFO));				//		[Xbg
	memcpy(&dp.sock, pSock, sizeof(AJCSCP_SOCKINFO));				//		\Pbg
	if (pPt != NULL) {
		dp.fWndPos = TRUE;
		dp.ptWnd.x = pPt->x;
		dp.ptWnd.y = pPt->y;
	}
	if (pSect != NULL) {											//		vt@CZNV
		AjcSnPrintF(dp.sect, AJCTSIZE(dp.sect), L"%s", pSect);
	}
	dp.mskRbt  = mskRbt;											//		O[WI{^}XN
	dp.mskGray = mskGray;											//		O[ڃ}XN

	if (DialogBoxParam(hDllInst, MAKEINTRESOURCE(IDD_SCP_PORTPARAM),//	_CAO{bNXsCnj{^H
			hWnd, (DLGPROC)AJC_DLGPROC_NAME(Easy), (LPARAM)&dp) == IDOK) {
		rc |= AJCSCPDGR_OKBUTTON;									//		߂lFnj{^ɂI
		switch (dp.sel) {
		  case AJCSCP_SEL_COMPORT:									//		bnl|[g̐ݒ
			*pSel = AJCSCP_SEL_COMPORT;								//			bnl|[gݒ̎|Aݒ
			if (dp.port != *pPort) {								//			|[gԍύXH
				rc |= AJCSCPDGR_PORTCHANGED;						//				߂li|[gύXCWP[^jݒ
			}
			if (memcmp(&dp.dcb, pDCB, sizeof dp.dcb) != 0) {		//			cbaύXH
				rc |= AJCSCPDGR_DCBCHANGED;							//				߂licbaύXCWP[^jݒ
			}
			*pPort = dp.port;										//			ݒ|[gԍݒ
			memcpy(pDCB, &dp.dcb, sizeof *pDCB);					//			ݒcbalRs[
			if (pfToDetail != NULL) *pfToDetail = FALSE;			//			ڍאݒւ̈ڍsȂ|AtOԂ
			break;

		  case AJCSCP_SEL_MAILSLOT:									//		[Xbg̐ݒ
			if (memcmp(&dp.slot, pSlot, sizeof(AJCSCP_SLOTINFO)) != 0) {	//	[XbgύXH
				rc |= AJCSCPDGR_SLOTCHANGED;						//				߂li[XbgύXCWP[^jݒ
			}
			*pSel = AJCSCP_SEL_MAILSLOT;							//			[Xbgݒ̎|Aݒ
			memcpy(pSlot, &dp.slot, sizeof(AJCSCP_SLOTINFO));		//			[XbgRs[
			break;

		  case AJCSCP_SEL_SOCKET:									//		\Pbg̐ݒ
			if (wcsicmp(dp.sock.ServName, pSock->ServName) != 0 ||	//			\PbgύXH
				dp.sock.PortNo != pSock->PortNo) {
				rc |= AJCSCPDGR_SOCKCHANGED;						//				߂li\PbgύXCWP[^jݒ
			}
			*pSel = AJCSCP_SEL_SOCKET;								//			\Pbgݒ̎|Aݒ
			memcpy(pSock, &dp.sock, sizeof(AJCSCP_SOCKINFO));		//			\PbgRs[
			break;
		}
	}
	else {															//	LZ{^^EChN[YH
		if (pfToDetail != NULL) *pfToDetail = dp.fChangeToDetail;	//		ڍאݒւ̈ڍstOԂ
		rc = 0;														//		߂lFLZI
	}

	return rc;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- Rs[^Xbg̃I[vԕ\ ---------------------------------------------------------------//
static	VO		ShowMySlotState(HWND hDlg)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);

	if (pdp->pW->hSlot != NULL) {
		AjcSetDlgItemStr(hDlg, IDC_TXT_MYSLOT_STATE, LNGSEL(L"Rs[^EXbg̓I[v", L"My computer slot is opened."));
		AjcSetDlgItemStr(hDlg, IDC_CMD_MYSLOT_OPEN , LNGSEL(L"Rs[^XbgN[Y"	 , L"Close my computer slot."	 ));
	}
	else {
		AjcSetDlgItemStr(hDlg, IDC_TXT_MYSLOT_STATE, LNGSEL(L"Rs[^EXbg̓N[Y", L"My computer slot is closed."));
		AjcSetDlgItemStr(hDlg, IDC_CMD_MYSLOT_OPEN , LNGSEL(L"Rs[^XbgI[v"  , L"Open my computer slot."	  ));
	}
}
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Easy, WM_INITDIALOG			)
{
	LPDLGPROP	pdp;
	RECT		rcDlg, rcGrp;
	HWND		hEdit;

	pdp = (LPDLGPROP)lParam;
	SetProp(hDlg, WndProp, (HANDLE)pdp);

	//	ACRݒ
	SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcoApp);

	//	_CAO{bNX̃TCYݒ
	GetWindowRect(hDlg, &rcDlg);
	GetWindowRect(GetDlgItem(hDlg, IDC_GRP_MAILSLOT), &rcGrp);
	if (pdp->fWndPos)
		SetWindowPos(hDlg, NULL, pdp->ptWnd.x, pdp->ptWnd.y, rcGrp.left - rcDlg.left, rcDlg.bottom - rcDlg.top, 0		  );
	else
		SetWindowPos(hDlg, NULL, 0			 , 0		   , rcGrp.left - rcDlg.left, rcDlg.bottom - rcDlg.top, SWP_NOMOVE);

	//	\Pbg̃|[gԍR{{bNXŁÂݓ͉\Ƃ
	if (hEdit = AjcSbcGetEditCtrlInComboBox(GetDlgItem(hDlg, IDC_CBO_PORTNO))) {
		MAjcSetWindowLong(hEdit, GWL_STYLE, (int)MAjcGetWindowLong(hEdit, GWL_STYLE) | ES_NUMBER);
	}

	//	O[vڂ̍Wݒ
	GetClientRect(hDlg, &rcDlg);
	GetWindowRect(GetDlgItem(hDlg, IDC_GRP_COMPORT), &rcGrp);
	pdp->ptGrp.x = rcGrp.left; pdp->ptGrp.y = rcGrp.top;
	ScreenToClient(hDlg, &pdp->ptGrp);

	//	pLvVݒ
	DispCaption(hDlg, pdp);

	//	bnl|[g^[Xbg^\PbgIWI{^̑SĂO[̏ꍇbnl|[g
	if (pdp->mskRbt == (AJCSCPRBT_ComPort | AJCSCPRBT_MailSlot | AJCSCPRBT_Socket)) {
		pdp->mskRbt = AJCSCPRBT_ComPort;
	}
	//	IڂO[̏ꍇAO[ڂɕύX
	if (((pdp->mskRbt & AJCSCPRBT_ComPort ) && pdp->sel == AJCSCP_SEL_COMPORT ) ||
		((pdp->mskRbt & AJCSCPRBT_MailSlot) && pdp->sel == AJCSCP_SEL_MAILSLOT) ||
		((pdp->mskRbt & AJCSCPRBT_Socket  ) && pdp->sel == AJCSCP_SEL_SOCKET  )) {
		if		(!(pdp->mskRbt & AJCSCPRBT_ComPort )) pdp->sel = AJCSCP_SEL_COMPORT;
		else if (!(pdp->mskRbt & AJCSCPRBT_MailSlot)) pdp->sel = AJCSCP_SEL_MAILSLOT;
		else										  pdp->sel = AJCSCP_SEL_SOCKET;
	}
	//	bnl|[g^[Xbg^\PbgIWI{^O[
	AjcEnableDlgItem(hDlg, IDC_RBT_COMPORT , (pdp->mskRbt & AJCSCPRBT_ComPort ) == 0);
	AjcEnableDlgItem(hDlg, IDC_RBT_MAILSLOT, (pdp->mskRbt & AJCSCPRBT_MailSlot) == 0);
	AjcEnableDlgItem(hDlg, IDC_RBT_SOCKET  , (pdp->mskRbt & AJCSCPRBT_Socket  ) == 0);

	//	bnl|[g^[XbgIWI{^ݒ
	AjcSetDlgItemChk(hDlg, IDC_RBT_COMPORT , pdp->sel == AJCSCP_SEL_COMPORT );
	AjcSetDlgItemChk(hDlg, IDC_RBT_MAILSLOT, pdp->sel == AJCSCP_SEL_MAILSLOT);
	AjcSetDlgItemChk(hDlg, IDC_RBT_SOCKET  , pdp->sel == AJCSCP_SEL_SOCKET	);

	//	R{{bNXւbnl|[gXgݒ
	SetPortListToCBO(hDlg, pdp->port);

	//	O[ڐݒ
	SetGray(hDlg, IDC_CBO_PORT		, pdp->mskGray & AJCSCPGRY_Port);
	SetGray(hDlg, IDC_CBO_RATE		, pdp->mskGray & AJCSCPGRY_BaudRate);
	SetGray(hDlg, IDC_CBO_DATSIZ	, pdp->mskGray & AJCSCPGRY_ByteSize);
	SetGray(hDlg, IDC_CBO_PARI		, pdp->mskGray & AJCSCPGRY_Parity);
	SetGray(hDlg, IDC_CBO_STPBIT	, pdp->mskGray & AJCSCPGRY_StopBits);
	SetGray(hDlg, IDC_RBT_NOFLOW	, (pdp->mskGray & AJCSCPGRY_TxFlowControl) == AJCSCPGRY_TxFlowControl);
	SetGray(hDlg, IDC_RBT_TXFLOW	, pdp->mskGray & AJCSCPGRY_fOutX);
	SetGray(hDlg, IDC_RBT_CTSFLOW	, pdp->mskGray & AJCSCPGRY_fOutxCtsFlow);
	SetGray(hDlg, IDC_RBT_DSRFLOW	, pdp->mskGray & AJCSCPGRY_fOutxDsrFlow);
	SetGray(hDlg, IDC_CMD_DETAIL	, pdp->mskGray & AJCSCPGRY_SetDetail);

	//	W{[[gXg
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 0, (LPARAM)L"    300");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 1, (LPARAM)L"    600");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 2, (LPARAM)L"   1200");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 3, (LPARAM)L"   2400");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 4, (LPARAM)L"   4800");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 5, (LPARAM)L"   9600");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 6, (LPARAM)L"  14400");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 7, (LPARAM)L"  19200");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 8, (LPARAM)L"  38400");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING, 9, (LPARAM)L"  57600");
	SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_INSERTSTRING,10, (LPARAM)L" 115200");

	//	peBʃXg
	SendDlgItemMessage(hDlg, IDC_CBO_PARI  , CB_INSERTSTRING, 0, (LPARAM)PTY_NONE);
	SendDlgItemMessage(hDlg, IDC_CBO_PARI  , CB_INSERTSTRING, 1, (LPARAM)PTY_ODD);
	SendDlgItemMessage(hDlg, IDC_CBO_PARI  , CB_INSERTSTRING, 2, (LPARAM)PTY_EVEN);
	SendDlgItemMessage(hDlg, IDC_CBO_PARI  , CB_INSERTSTRING, 3, (LPARAM)PTY_MARK);
	SendDlgItemMessage(hDlg, IDC_CBO_PARI  , CB_INSERTSTRING, 4, (LPARAM)PTY_SPACE);

	//	f[^rbgXg
	SendDlgItemMessage(hDlg, IDC_CBO_DATSIZ, CB_INSERTSTRING, 0, (LPARAM)L" 5 bits");
	SendDlgItemMessage(hDlg, IDC_CBO_DATSIZ, CB_INSERTSTRING, 1, (LPARAM)L" 6 bits");
	SendDlgItemMessage(hDlg, IDC_CBO_DATSIZ, CB_INSERTSTRING, 2, (LPARAM)L" 7 bits");
	SendDlgItemMessage(hDlg, IDC_CBO_DATSIZ, CB_INSERTSTRING, 3, (LPARAM)L" 8 bits");

	//	XgbvrbgXg
	SendDlgItemMessage(hDlg, IDC_CBO_STPBIT, CB_INSERTSTRING, 0, (LPARAM)L" 1 bit");
	SendDlgItemMessage(hDlg, IDC_CBO_STPBIT, CB_INSERTSTRING, 1, (LPARAM)L" 2 bits");

	//	cba_CAO֔f
	SetDcbToDialog(hDlg, pdp);

	//	[XbgC\Pbg̍ڐtR{{bNXݒ
	AjcSbcComboBox(GetDlgItem(hDlg, IDC_CBO_MYSLOT	), 20, AJCTSIZE(pdp->slot.MySlotName ) - 1);
	AjcSbcComboBox(GetDlgItem(hDlg, IDC_CBO_RMTHOST ), 20, AJCTSIZE(pdp->slot.RmtHostName) - 1);
	AjcSbcComboBox(GetDlgItem(hDlg, IDC_CBO_RMTSLOT ), 20, AJCTSIZE(pdp->slot.RmtSlotName) - 1);
	AjcSbcComboBox(GetDlgItem(hDlg, IDC_CBO_SERVNAME), 20, AJCTSIZE(pdp->sock.ServName	 ) - 1);
	AjcSbcComboBox(GetDlgItem(hDlg, IDC_CBO_PORTNO	), 20, AJCMAX_PORTNAME_LENGTH		   - 1);

	//	[XbgCRs[^EXbg I[vԐݒ
	ShowMySlotState(hDlg);

	//	[XbgC\Pbg̍ڐtR{{bNX̃eLXgr@ݒ
	AjcSbcSetCompExact(GetDlgItem(hDlg, IDC_CBO_MYSLOT	), FALSE);
	AjcSbcSetCompExact(GetDlgItem(hDlg, IDC_CBO_RMTHOST ), FALSE);
	AjcSbcSetCompExact(GetDlgItem(hDlg, IDC_CBO_RMTSLOT ), FALSE);
	AjcSbcSetCompExact(GetDlgItem(hDlg, IDC_CBO_SERVNAME), FALSE);
	AjcSbcSetCompExact(GetDlgItem(hDlg, IDC_CBO_PORTNO	), FALSE);

	//	[Xbg,\Pbg̃R{{bNXڃ[h
	if (pdp->sect[0]) {
		AjcSbcLoadItems(GetDlgItem(hDlg, IDC_CBO_MYSLOT  ), pdp->sect);
		AjcSbcLoadItems(GetDlgItem(hDlg, IDC_CBO_RMTHOST ), pdp->sect);
		AjcSbcLoadItems(GetDlgItem(hDlg, IDC_CBO_RMTSLOT ), pdp->sect);
		AjcSbcLoadItems(GetDlgItem(hDlg, IDC_CBO_SERVNAME), pdp->sect);
		AjcSbcLoadItems(GetDlgItem(hDlg, IDC_CBO_PORTNO  ), pdp->sect);
	}

	//	[Xbg,\Pbg_CAO֔f
	SetSlotToDialog  (hDlg, pdp);
	SetSocketToDialog(hDlg, pdp);

	//	bnl|[g^[XbgIWI{^NbN
	SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_RBT_COMPORT, BN_CLICKED), 0);

	return TRUE;
}
//----- bnl|[gԍEWI{^ -------------------------------------------------------------------------//
AJC_DLGPROC(Easy, IDC_RBT_COMPORT		)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);

	if (HIWORD(wParam) == BN_CLICKED) {
		if		(AjcGetDlgItemChk(hDlg, IDC_RBT_COMPORT)) {
			pdp->sel = AJCSCP_SEL_COMPORT;
			AjcMoveDlgGroupToLoc(hDlg, IDC_GRP_MAILSLOT, 1000		 , 1000 	   );
			AjcMoveDlgGroupToLoc(hDlg, IDC_GRP_SOCKET  , 2000		 , 2000 	   );
			AjcMoveDlgGroupToLoc(hDlg, IDC_GRP_COMPORT , pdp->ptGrp.x, pdp->ptGrp.y);
			ShowDevName(hDlg, pdp->port);
		}
		else if (AjcGetDlgItemChk(hDlg, IDC_RBT_MAILSLOT)) {
			pdp->sel = AJCSCP_SEL_MAILSLOT;
			AjcMoveDlgGroupToLoc(hDlg, IDC_GRP_COMPORT , 3000		 , 3000 	   );
			AjcMoveDlgGroupToLoc(hDlg, IDC_GRP_SOCKET  , 4000		 , 4000 	   );
			AjcMoveDlgGroupToLoc(hDlg, IDC_GRP_MAILSLOT, pdp->ptGrp.x, pdp->ptGrp.y);
		}
		else if (AjcGetDlgItemChk(hDlg, IDC_RBT_SOCKET)) {
			pdp->sel = AJCSCP_SEL_SOCKET;
			AjcMoveDlgGroupToLoc(hDlg, IDC_GRP_COMPORT , 5000		 , 5000 	   );
			AjcMoveDlgGroupToLoc(hDlg, IDC_GRP_MAILSLOT, 6000		 , 6000 	   );
			AjcMoveDlgGroupToLoc(hDlg, IDC_GRP_SOCKET  , pdp->ptGrp.x, pdp->ptGrp.y);
		}
	}
	return TRUE;
}
//----- [XbgEWI{^ ---------------------------------------------------------------------------//
AJC_DLGPROC(Easy, IDC_RBT_MAILSLOT		)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);

	if (HIWORD(wParam) == BN_CLICKED) {
		SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_RBT_COMPORT, BN_CLICKED), 0);
	}
	return TRUE;
}
//----- \PbgEWI{^ ---------------------------------------------------------------------------------//
AJC_DLGPROC(Easy, IDC_RBT_SOCKET		)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);

	if (HIWORD(wParam) == BN_CLICKED) {
		SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_RBT_COMPORT, BN_CLICKED), 0);
	}
	return TRUE;
}
//----- |[gԍER{{bNX -----------------------------------------------------------------------------//
AJC_DLGPROC(Easy, IDC_CBO_PORT			)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);
	UI			NewPort;
	WC			ComPortName[16];

	if (pdp != NULL) {
		switch (HIWORD(wParam)) {
			case CBN_DROPDOWN:									//	Xg{bNX\Jn
				//	ȎI|[gԍ
				pdp->SvPortNo = -1;
				//	Ď^C}N
				SetTimer(hDlg, 1, 100, NULL);
				break;
			case CBN_SELCHANGE:									//	IύX
			{	WCP		p;
				//	I|[gݒ
				memset(ComPortName, 0, sizeof ComPortName);
				GetDlgItemText(hDlg, IDC_CBO_PORT, ComPortName, AJCTSIZE(ComPortName));	//		V|[gԍ擾
				p = ComPortName;														//		E
				while (!_ismbcdigit(*p) && *p != 0) p++;								//		E
				NewPort = (_wtoi(p) & 255);												//		E
				if (NewPort != pdp->port) {												//		|[gύXH
					SetDialogToDcb(hDlg, pdp);											//			޲۸ޕҏWlDCBޯ̧־
					pdp->port = NewPort;												//			V|[gԍݒ
					ShowDevName(hDlg, NewPort);											//				foCX\
				}
				break;
			}
			case CBN_CLOSEUP:									//	Xg{bNXꂽ
			case CBN_SELENDCANCEL:								//	I𒆎~
			case CBN_KILLFOCUS:									//	tH[JXr
			case CBN_SELENDOK:									//	I
				//	Ď^C}~
				KillTimer(hDlg, 1);
				break;
		}
	}
	return TRUE;
}
//----- ^C} -------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Easy, WM_TIMER		)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);
	WCP			p;
	UI			ix, NewPort;
	WC			ComPortName[16];

	if (pdp != NULL) {
		//	|[gI𒆁AA^CɃfoCX\
		if ((ix  = (int)SendMessage(GetDlgItem(hDlg, IDC_CBO_PORT), CB_GETCURSEL, 0, 0)) != CB_ERR) {
			memset(ComPortName, 0, sizeof ComPortName);
			GetDlgItemText(hDlg, IDC_CBO_PORT, ComPortName, AJCTSIZE(ComPortName));		//	|[gԍݒ
			p = ComPortName;															//	E
			while (!_ismbcdigit(*p) && *p != 0) p++;									//	E
			NewPort = (_wtoi(p) & 255);													//	E
			if (NewPort != pdp->SvPortNo) {												//	Õ|[gԍƈقȂH
				pdp->SvPortNo = NewPort;												//		I|[gԍޔ
				ShowDevName(hDlg, NewPort);												//		foCX\		
			}
		}
	}
	return TRUE;
}
//----- ڍאݒ{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Easy, IDC_CMD_DETAIL		)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);

	if (HIWORD(wParam) == BN_CLICKED) {
		//	ڍאݒւ̈ڍstOݒ
		pdp->fChangeToDetail = TRUE;
		//	_CAOI
		RemoveProp(hDlg, WndProp);
		EndDialog(hDlg, IDCANCEL);
	}
	return TRUE;
}
//----- [XbgI[v^N[Y {^ --------------------------------------------------------------//
AJC_DLGPROC(Easy, IDC_CMD_MYSLOT_OPEN	)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);

	if (HIWORD(wParam) == BN_CLICKED) {
		//	Xbg I[v^N[Y
		if (pdp->pW->hSlot != NULL) {
			AjcScpDeleteMySlot(pdp->pW);
		}
		else {
			if (!ScpCreateMySlot(pdp->pW)) {
				WC		txt[512];
				AjcSnPrintF(txt, AJCTSIZE(txt),
					LNGSEL(L"\x1B[31m [Xbg(%s)𐶐ł܂B\x1B[0m\n\n"
						   L" Rs[^ŒʐMꍇ́AXbgݒ肵Ă\n\n"
						   L"@ F@@@@@@@@@vO̐ݒ     葤̐ݒ\n"
						   L"@ @@@Xbg@F@@SLOT_A@@@@@@@@@SLOT_B\n"
						   L"@ @@@XbgF@@SLOT_B@@@@@@@@@SLOT_A\n\n"
						   L"@̃`bv\ɂ́A`bvNbN邩A\n"
						   L"@J[\OɈړĂPOb҂܂B"
						   ,
						   L"\x1B[31m Unable to generate mailslot '%s'.\x1B[0m\n\n"
						   L"* When communicating on the same computer, cross the slot names. \n\n"
						   L"  Ex.                  My-Setting          Remote-Setting\n"
						   L"    My Slot Name     -   SLOT_A              SLOT_B\n" 
						   L"    Remote Slot Name -   SLOT_B              SLOT_A\n\n"
						   L"@To turn off this chip display, click on the chip or \n"
						   L"  move the cursor out and wait 10 seconds."), pdp->pW->SlotInfo.MySlotName);
				AjcTipTextShowCenterEx(hDlg, 0, 0, txt, 10000, hDefFontFix, -1, -1, -1);
			}
		}
		//	Xbgԕ\
		ShowMySlotState(hDlg);
	}

	return TRUE;
}
//----- LZ{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Easy, IDCANCEL				)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);

	if (HIWORD(wParam) == BN_CLICKED) {
		//	_CAOI
		RemoveProp(hDlg, WndProp);
		EndDialog(hDlg, IDCANCEL);
	}
	return TRUE;
}
//----- nj{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Easy, IDOK					)
{
	LPDLGPROP	pdp = (LPDLGPROP)GetProp(hDlg, WndProp);
	BOOL		rsu = TRUE;

	if (HIWORD(wParam) == BN_CLICKED) {
		switch (pdp->sel) {
			case AJCSCP_SEL_COMPORT:
			//	pdp->port = AjcGetDlgItemCboData(hDlg, IDC_CBO_PORT, AjcGetDlgItemCboIx(hDlg, IDC_CBO_PORT));
				//	_CAOݒlbnl|[g֔f
				rsu = SetDialogToDcb(hDlg, pdp);
				break;

			case AJCSCP_SEL_MAILSLOT:
				//	_CAOݒliban֓o^j[Xbg֔f
				rsu = SetDialogToSlot(hDlg, pdp);
				//	[Xbg̃R{{bNXڃZ[u
				if (pdp->sect[0]) {
					AjcSbcSaveItems (GetDlgItem(hDlg, IDC_CBO_MYSLOT ), pdp->sect);
					AjcSbcSaveItems (GetDlgItem(hDlg, IDC_CBO_RMTHOST), pdp->sect);
					AjcSbcSaveItems (GetDlgItem(hDlg, IDC_CBO_RMTSLOT), pdp->sect);
				}
				break;

			case AJCSCP_SEL_SOCKET:
				//	_CAOݒliban֓o^j\Pbg֔f
				rsu = SetDialogToSocket(hDlg, pdp);
				//	\Pbg̃R{{bNXڃZ[u
				if (pdp->sect[0]) {
					AjcSbcSaveItems (GetDlgItem(hDlg, IDC_CBO_SERVNAME ), pdp->sect);
					AjcSbcSaveItems (GetDlgItem(hDlg, IDC_CBO_PORTNO   ), pdp->sect);
				}
				break;
		}
		//	_CAOI
		if (rsu) {
			RemoveProp(hDlg, WndProp);
			EndDialog(hDlg, IDOK);
		}
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Easy)
	AJC_DLGMAP_MSG(Easy, WM_INITDIALOG		)
	AJC_DLGMAP_MSG(Easy, WM_TIMER			)

	AJC_DLGMAP_CMD(Easy, IDC_RBT_COMPORT	)
	AJC_DLGMAP_CMD(Easy, IDC_RBT_MAILSLOT	)
	AJC_DLGMAP_CMD(Easy, IDC_RBT_SOCKET		)
	AJC_DLGMAP_CMD(Easy, IDC_CBO_PORT		)
	AJC_DLGMAP_CMD(Easy, IDC_CMD_DETAIL		)
	AJC_DLGMAP_CMD(Easy, IDC_CMD_MYSLOT_OPEN)
	AJC_DLGMAP_CMD(Easy, IDCANCEL			)
	AJC_DLGMAP_CMD(Easy, IDOK				)
AJC_DLGMAP_END


//--------------------------------------------------------------------------------------------------------------//
//	eڂ̃^Cg\																						//
//--------------------------------------------------------------------------------------------------------------//
static	VO	DispCaption(HWND hDlg, LPDLGPROP pdp)
{
	SetWindowText (hDlg, TTL_HEADER);
	SetDlgItemText(hDlg, IDC_LBL_PORT	 	, TTL_PORT	  );
	SetDlgItemText(hDlg, IDC_LBL_RATE	 	, TTL_RATE	  );
	SetDlgItemText(hDlg, IDC_LBL_DATSIZ  	, TTL_DATSIZ  );
	SetDlgItemText(hDlg, IDC_LBL_PARI	 	, TTL_PARITY  );
	SetDlgItemText(hDlg, IDC_LBL_STPBIT  	, TTL_STPBIT  );
	SetDlgItemText(hDlg, IDC_GRP_FLOWCTRL	, TTL_FLOWCTRL);
	SetDlgItemText(hDlg, IDC_RBT_NOFLOW 	, TTL_NOFLOW  );
	SetDlgItemText(hDlg, IDC_RBT_TXFLOW 	, TTL_TXFLOW  );
	SetDlgItemText(hDlg, IDC_RBT_CTSFLOW	, TTL_CTSFLOW );
	SetDlgItemText(hDlg, IDC_RBT_DSRFLOW	, TTL_DSRFLOW );
	SetDlgItemText(hDlg, IDC_CMD_DETAIL		, TTL_DETAIL  );

	SetDlgItemText(hDlg, IDC_GRP_MYCOMP  	, TTL_MYHOST  );
	SetDlgItemText(hDlg, IDC_LBL_MYHOST  	, TTL_NAME	  );
	SetDlgItemText(hDlg, IDC_LBL_MYSLOT  	, TTL_SLOT	  );
	SetDlgItemText(hDlg, IDC_GRP_RMTCOMP 	, TTL_RMTHOST );
	SetDlgItemText(hDlg, IDC_LBL_RMTHOST 	, TTL_NAME	  );
	SetDlgItemText(hDlg, IDC_LBL_RMTSLOT 	, TTL_SLOT	  );
	SetDlgItemText(hDlg, IDC_CHK_TXDELAY 	, TTL_CHK_TXDELAY);
	SetDlgItemText(hDlg, IDC_LBL_TXDELAY 	, TTL_LBL_TXDELAY);

	SetDlgItemText(hDlg, IDC_GRP_MYCOMP_SOCK, TTL_MYHOST  );
	SetDlgItemText(hDlg, IDC_LBL_MYHOST_SOCK, TTL_NAME	  );
	SetDlgItemText(hDlg, IDC_LBL_SERVNAME	, TTL_SERVNAME);
	SetDlgItemText(hDlg, IDC_LBL_IPADDR		, TTL_IPADDR  );
	SetDlgItemText(hDlg, IDC_GRP_SERVER  	, TTL_SERVER  );
	SetDlgItemText(hDlg, IDC_LBL_PORTNO 	, TTL_PORTNO  );

	SetDlgItemText(hDlg, IDOK			 	, TTL_OK	  );
	SetDlgItemText(hDlg, IDCANCEL		 	, TTL_CANCEL  );
}
//--------------------------------------------------------------------------------------------------------------//
//	w_CAOڂ̃O[																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetGray(HWND hDlg, UI id, BOOL fGray)
{
	UL	style;
	HWND	hWnd = GetDlgItem(hDlg, id);

	style = GetWindowLong(hWnd, GWL_STYLE);
	if (fGray) style |=  WS_DISABLED;
	else	   style &= ~WS_DISABLED;
	SetWindowLong(hWnd, GWL_STYLE, style);
	InvalidateRect(hWnd, NULL, FALSE);
}
//--------------------------------------------------------------------------------------------------------------//
//	R{{bNXփ|[gXgݒ																			//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetPortListToCBO(HWND hDlg, UI CurrentPort)
{
	UI		i, n, ix, pno;
	UB		PortMap[256];
	WC		ComPortName[64];

	n = AjcScpEnumSerialPorts(PortMap, 256, CurrentPort);
	ix = 0;
	pno = 0;
	for (i=0; i<n; i++) {
		pno = PortMap[i];
		AjcSnPrintF(ComPortName, AJCTSIZE(ComPortName), L" COM %u", pno);
		SendDlgItemMessage(hDlg, IDC_CBO_PORT, CB_INSERTSTRING, ix, (LPARAM)ComPortName);
		SendDlgItemMessage(hDlg, IDC_CBO_PORT, CB_SETITEMDATA , ix, (LPARAM)pno);
		ix++;
	}

	AjcSnPrintF(ComPortName, AJCTSIZE(ComPortName), L" COM %u", CurrentPort);
	SendDlgItemMessage(hDlg, IDC_CBO_PORT, CB_SELECTSTRING, -1, (WPARAM)ComPortName);
}

//--------------------------------------------------------------------------------------------------------------//
//	cbalA_CAO֔f																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetDcbToDialog(HWND hDlg, LPDLGPROP pdp)
{
	WC	txt[32];

	if (pdp->dcb.Parity > 4) pdp->dcb.Parity = 0;
	if (pdp->dcb.ByteSize < 5 || pdp->dcb.ByteSize > 8) pdp->dcb.ByteSize = 8; 
	if (pdp->dcb.StopBits > 3) pdp->dcb.StopBits = 0;

	if		(pdp->dcb.BaudRate ==	300) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  0, 0);
	else if (pdp->dcb.BaudRate ==	600) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  1, 0);
	else if (pdp->dcb.BaudRate ==  1200) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  2, 0);
	else if (pdp->dcb.BaudRate ==  2400) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  3, 0);
	else if (pdp->dcb.BaudRate ==  4800) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  4, 0);
	else if (pdp->dcb.BaudRate ==  9600) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  5, 0);
	else if (pdp->dcb.BaudRate == 14400) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  6, 0);
	else if (pdp->dcb.BaudRate == 19200) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  7, 0);
	else if (pdp->dcb.BaudRate == 38400) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  8, 0);
	else if (pdp->dcb.BaudRate == 57600) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL,  9, 0);
	else if (pdp->dcb.BaudRate ==115200) SendDlgItemMessage(hDlg, IDC_CBO_RATE, CB_SETCURSEL, 10, 0);
	else  {_itow(pdp->dcb.BaudRate, txt, 10); SetDlgItemText(hDlg, IDC_CBO_RATE, txt);}
	SendMessage(hDlg, WM_COMMAND, (CBN_EDITCHANGE << 16) | IDC_CBO_RATE, 0);

	SendDlgItemMessage(hDlg, IDC_CBO_PARI  , CB_SETCURSEL, (pdp->dcb.Parity) * pdp->dcb.fParity, 0);
	SendDlgItemMessage(hDlg, IDC_CBO_DATSIZ, CB_SETCURSEL, pdp->dcb.ByteSize - 5, 0);
	SendDlgItemMessage(hDlg, IDC_CBO_STPBIT, CB_SETCURSEL, pdp->dcb.StopBits!=0, 0);

	if (pdp->dcb.fOutX == 0 && pdp->dcb.fOutxCtsFlow == 0 && pdp->dcb.fOutxDsrFlow == 0) {
		SendDlgItemMessage(hDlg, IDC_RBT_NOFLOW  , BM_SETCHECK, TRUE , 0);
	}
	else {
		SendDlgItemMessage(hDlg, IDC_RBT_NOFLOW  , BM_SETCHECK, FALSE, 0);
	}
	SendDlgItemMessage(hDlg, IDC_RBT_TXFLOW  , BM_SETCHECK, pdp->dcb.fOutX			   != 0, 0);
	SendDlgItemMessage(hDlg, IDC_RBT_CTSFLOW , BM_SETCHECK, pdp->dcb.fOutxCtsFlow	   != 0, 0);
	SendDlgItemMessage(hDlg, IDC_RBT_DSRFLOW , BM_SETCHECK, pdp->dcb.fOutxDsrFlow	   != 0, 0);

}
//--------------------------------------------------------------------------------------------------------------//
//	_CAOŕҏWlcbaobt@֐ݒ																//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SetDialogToDcb(HWND hDlg, LPDLGPROP pdp)
{
	BOOL	rc = TRUE;
	WC		buf[16];

	GetDlgItemText(hDlg, IDC_CBO_RATE, buf, AJCTSIZE(buf));
	pdp->dcb.BaudRate = _wtoi(buf);

	switch (SendDlgItemMessage(hDlg, IDC_CBO_DATSIZ, CB_GETCURSEL, 0, 0)) {
		case 0:		pdp->dcb.ByteSize =    5;	break;
		case 1:		pdp->dcb.ByteSize =    6;	break;
		case 2:		pdp->dcb.ByteSize =    7;	break;
		default:	pdp->dcb.ByteSize =    8;	break;
	}
	switch (SendDlgItemMessage(hDlg, IDC_CBO_PARI, CB_GETCURSEL, 0, 0)) {
		case 0:		pdp->dcb.fParity = 0; pdp->dcb.Parity = 0;	break;
		case 1:		pdp->dcb.fParity = 1; pdp->dcb.Parity = 1;	break;
		case 2:		pdp->dcb.fParity = 1; pdp->dcb.Parity = 2;	break;
		case 3:		pdp->dcb.fParity = 1; pdp->dcb.Parity = 3;	break;
		default:	pdp->dcb.fParity = 1; pdp->dcb.Parity = 4;	break;
	}
	switch (SendDlgItemMessage(hDlg, IDC_CBO_STPBIT, CB_GETCURSEL, 0, 0)) {
		case 0:		pdp->dcb.StopBits = 0;	break;
		default:	pdp->dcb.StopBits = 2;	break;
	}
	pdp->dcb.fOutX		  = (SendDlgItemMessage(hDlg, IDC_RBT_TXFLOW   , BM_GETCHECK, 0, 0) != 0);
	pdp->dcb.fOutxCtsFlow = (SendDlgItemMessage(hDlg, IDC_RBT_CTSFLOW  , BM_GETCHECK, 0, 0) != 0);
	pdp->dcb.fOutxDsrFlow = (SendDlgItemMessage(hDlg, IDC_RBT_DSRFLOW  , BM_GETCHECK, 0, 0) != 0);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	[XbgA_CAO֔f																		//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetSlotToDialog(HWND hDlg, LPDLGPROP pdp)
{
	UI			len;
	int			ix;

	//	zXgݒ
	len = (AJCTSIZE(pdp->slot.MyHostName));
	GetComputerName(pdp->slot.MyHostName, &len);
	AjcSetDlgItemStr(hDlg, IDC_TXT_MYHOST, pdp->slot.MyHostName);
	//	Xbg
	if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_MYSLOT, -1, pdp->slot.MySlotName, AJCCBF_EXACT)) == -1) {
		ix = 0;
		AjcSetDlgItemCboAdd(hDlg, IDC_CBO_MYSLOT, ix, pdp->slot.MySlotName, 0);
	}
	AjcSetDlgItemCboIx(hDlg, IDC_CBO_MYSLOT, ix);
	//	zXg
	if (pdp->slot.RmtHostName[0] != 0) {
		if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_RMTHOST, -1, pdp->slot.RmtHostName, AJCCBF_EXACT)) == -1) {
			ix = 0;
			AjcSetDlgItemCboAdd(hDlg, IDC_CBO_RMTHOST, ix, pdp->slot.RmtHostName, 0);
		}
		AjcSetDlgItemCboIx(hDlg, IDC_CBO_RMTHOST, ix);
	}
	else {
		AjcSetDlgItemCboAdd(hDlg, IDC_CBO_RMTHOST, 0, L"", 0);
		AjcSetDlgItemCboIx (hDlg, IDC_CBO_RMTHOST, 0);
	}
	//	Xbg
	if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_RMTSLOT, -1, pdp->slot.RmtSlotName, AJCCBF_EXACT)) == -1) {
		ix = 0;
		AjcSetDlgItemCboAdd(hDlg, IDC_CBO_RMTSLOT, ix, pdp->slot.RmtSlotName, 0);
	}
	AjcSetDlgItemCboIx(hDlg, IDC_CBO_RMTSLOT, ix);
	//	Mx`FbN{bNX
	AjcSetDlgItemChk (hDlg, IDC_CHK_TXDELAY, pdp->slot.fTxDelay);
	//	x
	AjcSetDlgItemUInt(hDlg, IDC_INP_TXDELAY, pdp->slot.TxDelayBPS);
}
//--------------------------------------------------------------------------------------------------------------//
//	_CAOݒliban֓o^j[Xbg֔f												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SetDialogToSlot(HWND hDlg, LPDLGPROP pdp)
{
	BOOL		rc = TRUE;
	int			ix;

	//	zXgݒ
	AjcGetDlgItemStr(hDlg, IDC_TXT_MYHOST, pdp->slot.MyHostName, AJCTSIZE(pdp->slot.MyHostName));
	//	Xbg
//	memset(pdp->slot.MySlotName, 0, sizeof pdp->slot.MySlotName);
	AjcGetDlgItemStr	(hDlg, IDC_CBO_MYSLOT, pdp->slot.MySlotName, AJCTSIZE(pdp->slot.MySlotName));
	AjcSetDlgItemCboAdd (hDlg, IDC_CBO_MYSLOT,	0, pdp->slot.MySlotName, 0);
	if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_MYSLOT, -1, pdp->slot.MySlotName, AJCCBF_EXACT)) >= 0) {
		AjcSetDlgItemCboIx(hDlg, IDC_CBO_MYSLOT, ix);
	}

	//	zXg
//	memset(pdp->slot.RmtHostName, 0, sizeof pdp->slot.RmtHostName);
	AjcGetDlgItemStr	(hDlg, IDC_CBO_RMTHOST, pdp->slot.RmtHostName, AJCTSIZE(pdp->slot.RmtHostName));
	AjcSetDlgItemCboAdd (hDlg, IDC_CBO_RMTHOST,  0, pdp->slot.RmtHostName, 0);
	if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_RMTHOST, -1, pdp->slot.RmtHostName, AJCCBF_EXACT)) >= 0) {
		AjcSetDlgItemCboIx(hDlg, IDC_CBO_RMTHOST, ix);
	}
	//	Xbg
//	memset(pdp->slot.RmtSlotName, 0, sizeof pdp->slot.RmtSlotName);
	AjcGetDlgItemStr	(hDlg, IDC_CBO_RMTSLOT, pdp->slot.RmtSlotName, AJCTSIZE(pdp->slot.RmtSlotName));
	AjcSetDlgItemCboAdd (hDlg, IDC_CBO_RMTSLOT,  0, pdp->slot.RmtSlotName, 0);
	if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_RMTSLOT, -1, pdp->slot.RmtSlotName, AJCCBF_EXACT)) >= 0) {
		AjcSetDlgItemCboIx(hDlg, IDC_CBO_RMTSLOT, ix);
	}
	//	Mx`FbN{bNX
	pdp->slot.fTxDelay = AjcGetDlgItemChk(hDlg, IDC_CHK_TXDELAY);
	//	x
	pdp->slot.TxDelayBPS = AjcGetDlgItemUInt(hDlg, IDC_INP_TXDELAY);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	\PbgA_CAO֔f																			//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetSocketToDialog(HWND hDlg, LPDLGPROP pdp)
{
	int			ix;
	UI			len;
	WC			szHost[AJCMAX_HOSTNAME_LENGTH];
	WC			szPort[AJCMAX_PORTNAME_LENGTH];

	//	zXgݒ
	len = (sizeof szHost);
	GetComputerName(szHost, &len);
	AjcSetDlgItemStr(hDlg, IDC_TXT_MYHOST_SOCK, szHost);

	//	zXgiT[oj
	if (pdp->sock.ServName[0] != 0) {
		if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_SERVNAME, -1, pdp->sock.ServName, AJCCBF_EXACT)) == -1) {
			ix = 0;
			AjcSetDlgItemCboAdd(hDlg, IDC_CBO_SERVNAME, ix, pdp->sock.ServName, 0);
		}
		AjcSetDlgItemCboIx(hDlg, IDC_CBO_SERVNAME, ix);
	}
	//	|[g
	AjcSnPrintF(szPort, AJCTSIZE(szPort), L"%u", pdp->sock.PortNo);
	if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_PORTNO, -1, szPort, AJCCBF_EXACT)) == -1) {
		ix = 0;
		AjcSetDlgItemCboAdd(hDlg, IDC_CBO_PORTNO, ix, szPort, 0);
	}
	AjcSetDlgItemCboIx(hDlg, IDC_CBO_PORTNO, ix);
}
//--------------------------------------------------------------------------------------------------------------//
//	_CAOݒliban֓o^j\Pbg֔f														//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SetDialogToSocket(HWND hDlg, LPDLGPROP pdp)
{
	BOOL		rc = TRUE;
	int			ix;
	UI			pno;
	WC			szPort[AJCMAX_PORTNAME_LENGTH];

	//	zXgiT[oj
	AjcGetDlgItemStr	(hDlg, IDC_CBO_SERVNAME, pdp->sock.ServName, AJCTSIZE(pdp->sock.ServName));
	AjcSetDlgItemCboAdd (hDlg, IDC_CBO_SERVNAME,  0, pdp->sock.ServName, 0);
	if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_SERVNAME, -1, pdp->sock.ServName, AJCCBF_EXACT)) >= 0) {
		AjcSetDlgItemCboIx(hDlg, IDC_CBO_SERVNAME, ix);
	}
	//	|[g
	AjcGetDlgItemStr	(hDlg, IDC_CBO_PORTNO, szPort, AJCTSIZE(szPort));
	AjcStrTrim			(			   szPort, szPort, AJCTSIZE(szPort));
	if ((pno = _wtoi(szPort)) <= 65535) {
		if (szPort[0] != 0) {
			AjcSetDlgItemCboAdd (hDlg, IDC_CBO_PORTNO,	0, szPort, 0);
			if ((ix = AjcGetDlgItemCboFind(hDlg, IDC_CBO_PORTNO, -1, szPort, AJCCBF_EXACT)) >= 0) {
				AjcSetDlgItemCboIx(hDlg, IDC_CBO_PORTNO, ix);
				pdp->sock.PortNo = pno;
			}
		}
	}
	else {
		WC		txt[64];
		AjcSnPrintF(txt, AJCTSIZE(txt), LNGSEL(L"sȃ|[gԍ(%s)łB", L"Illegal port number(%s)."), szPort);
		MessageBox(hDlg, txt, L"Socket", MB_ICONERROR);
		rc = FALSE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	bnl|[g̃foCX\																				//
//--------------------------------------------------------------------------------------------------------------//
static	VO	ShowDevName(HWND hDlg, UI pno)
{
	WC		name[16];
	WC		dev [256];
//	WC		txt [300];

	AjcSnPrintF(name, AJCTSIZE(name), L"COM%d", pno);

	if (AjcScpGetPortDevName(name, dev, AJCTSIZE(dev))) {
	//	AjcSnPrintF(txt, AJCTSIZE(txt), L"%s : %s", name, dev);
		AjcSetDlgItemStr(hDlg, IDC_TXT_DEVNAME, dev);
	}
	else {
		AjcSetDlgItemStr(hDlg, IDC_TXT_DEVNAME, L"<No device>");
	}
}

