#include	"AjcInternal.h"
#include	"AjcSerialComPortDef.h"
//**************************************************************************************************************//
//																												//
//	bnl|[go								MXbh												//
//																												//
//**************************************************************************************************************//
static	UI _stdcall ThreadReceive(VOP pParam);
static BOOL CALLBACK cbSsepWithRxData(UI evt, VOP pvData, UI lDat, UX cbp);

//==============================================================================================================//
//																												//
//	MXbhJn																							//
//																												//
//==============================================================================================================//
BOOL	ScpStartThreadRx(HAJCSCP pW)
{
	BOOL	rc = FALSE;

	//----- Xg[CX^XiMeLXg̓oCgȂ̂ŁAAjcSsepCreateA()gpj------------//
	pW->hSsep = AjcSsepCreateA(ScpEvtToSsepEvt(pW->EvtMask), (UX)pW, cbSsepWithRxData);
	AjcSsepEnableMultiThread(pW->hSsep, TRUE);		//	}`Xbh
	AjcSsepSetPktTimeOut	(pW->hSsep, 3000);		//	pPbgM^CAEgRb
	//----- MXbhJn -----------------------------------------------------------------------------------//
	pW->fThrRecvEnd = FALSE;
	if ((pW->hThreadRx = (HANDLE)_beginthreadex(NULL,				//	ZLeB
												0,					//	X^bNTCY
												ThreadReceive,		//	Xbh֐
												(VOP)pW,			//	Xbh
												0,					//	XbhtO
												&pW->idThreadRx)	//	Xbhʎq
									) != NULL) {
		rc = TRUE;
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	|[g̎MXbh																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	UI _stdcall ThreadReceive(VOP pParam)
{
	HAJCSCP pW	= (HAJCSCP)pParam;

	DWORD		lrx, err, bytes, count;
	COMSTAT		cst;
	BOOL		rsu;
	AJCMBCKIND	mbk;				//	MeLXgR[h

	UI		cnt = 0;				//	Tick擾^C~OJE^
	ULL		ts = GetTickCount64();	//	ŌɎM
	ULL		tc;						//	Ō̎M̌oߎ[ms]

	while (!pW->fThreadEnd) {
		//	N[YԂȂ΁AŏԃEFCgi[XbgȊOj
		if (pW->PortSel != AJCSCP_SEL_MAILSLOT && pW->hPort == NULL) {
			Sleep(1);
			continue;
		}
		//	ϐ
		lrx = err = bytes = count = 0;
		rsu = FALSE;
		//----- M ---------------------------------------------------------------------------------------//
		switch (pW->PortSel) {
			case AJCSCP_SEL_COMPORT:		//	bnl|[g
				if (rsu = ScpClearCommError(pW, &err, &cst)) {
					//	őMTCYobt@TCYŐ
					lrx = __min(cst.cbInQue, AJCSCPMAX_RXSIZE);
					if (err == 0) {
						if (rsu = ScpReadFile(pW, pW->RxBin, lrx, &bytes, NULL)) {
							memcpy(&pW->RxBuf[pW->ixRxb], pW->RxBin, bytes);
							lrx = bytes;
						}
					}
					else {
						ScpNtcEvtToUser(pW, AJCSCP_EV_ERR, NULL, 0, err);
					}
				}
				break;

			case AJCSCP_SEL_MAILSLOT:		//	[Xbg
				if (rsu = ScpGetMailslotInfo(pW, NULL, &lrx, &count, NULL)) {

					//	őMTCYobt@TCYŐ
					//	iۂ́AMōő呗MTCYSQOoCgɐĂ̂ŕKvȂAS̈א
					//	@܂A[Xbg̓f[^Oł邽߁AlrxƎMłȂj
					lrx = __min(lrx, AJCSCPMAX_RXSIZE);

					if (count != 0) {
						if (rsu = ScpReadFile(pW, &pW->RxBin, lrx, &bytes, NULL)) {
							memcpy(&pW->RxBuf[pW->ixRxb], pW->RxBin, bytes);
							lrx = bytes;
						}
					}
					else {
						lrx = 0;
					}
				}
				break;

			case AJCSCP_SEL_SOCKET:			//	\Pbg
				//	\PbgCxgm
				if (WaitForSingleObject(pW->hEvtSock, 0) == WAIT_OBJECT_0) {
					WSANETWORKEVENTS nwev;
					//	VOiԐݒ
					WSAResetEvent(pW->hEvtSock);
					//	\PbgCxg
					if (WSAEnumNetworkEvents((SOCKET)pW->hPort, pW->hEvtSock, &nwev) != SOCKET_ERROR) {
						//	ڑʒm
						if (nwev.lNetworkEvents & FD_CONNECT) {
							if (nwev.iErrorCode[FD_CONNECT_BIT] == 0) {
								//	uڑԁv
								pW->fConnect = TRUE;
								//	|[gI[vʒm
								ScpNtcPortStateToUser(pW, AJCSCP_OPENED);
							}
							else {
								//	\PbgN[Y
								closesocket((SOCKET)pW->hPort);
								pW->hPort = NULL;
								pW->fConnect   = FALSE;
								pW->fSockRead  = FALSE;
								pW->fSockWrite = FALSE;
								//	|[gI[vsʒm
								ScpNtcPortStateToUser(pW, AJCSCP_OPENFAIL);
							}
						}
						//	Mʒm
						if (nwev.lNetworkEvents & FD_READ) {
							pW->fSockRead = TRUE;
							if (rsu = ScpReadFile(pW, pW->RxBin, AJCSCPMAX_RXSIZE, &bytes, NULL)) {
								memcpy(&pW->RxBuf[pW->ixRxb], pW->RxBin, bytes);
								lrx = bytes;
							}
						}
						//	ݒʒm
						if (nwev.lNetworkEvents & FD_WRITE) {
							pW->fSockWrite = TRUE;
						}
						//	ؒfʒm
						if (nwev.lNetworkEvents & FD_CLOSE) {
							//	tONA[
							pW->fConnect   = FALSE;
							pW->fSockRead  = FALSE;
							pW->fSockWrite = FALSE;
							//	|[gN[Yʒm
							ScpNtcPortStateToUser(pW, AJCSCP_CLOSED);
						}
					}
				}
				break;
		}

		//----- M쐬Mf[^LȂ΁AMʒm -----------------------------------------------//
		if (rsu && lrx != 0) {	//	MCMf[^LH
			//	R[hpf[^^
			pW->RxBuf[pW->ixRxb + bytes] = 0;
			AjcSsepPutMbc(pW->hSsep, (C_BCP)pW->RxBuf);
			//	MeLXgR[hݒ
			switch (pW->RxTxtCode) {
				default:
				case AJCSCP_TXT_SJIS:	mbk = AJCMBC_SJIS;					break;	//	Vtgihr
				case AJCSCP_TXT_EUC:	mbk = AJCMBC_EUC;					break;	//	dtb@@@
				case AJCSCP_TXT_UTF8:	mbk = AJCMBC_UTF8;					break;	//	tse|W@
				case AJCSCP_TXT_AUTO:	mbk = AjcSsepGetMbcKind(pW->hSsep);	break;	//	ʁ@
			}
			//	Xg[(O̒r}`oCgXLbvMf[^) 
			if (bytes != 0 && (pW->EvtMask & AJCSCP_EV_SSEP)) {
				AjcSsepPutData(pW->hSsep, &pW->RxBuf[pW->ixRxb], bytes);
			}
			//	I[(0x00)ݒ
			pW->RxBuf[pW->ixRxb + lrx] = 0;
			//	ۂ̃f[^ݒiO̒r}`oCgZj
			lrx += pW->ixRxb;
			//	`Nf[^Mʒm
			if (pW->EvtMask & AJCSCP_EV_RXCHUNK) {
				//----- oCi`NMʒm ---------------------------------------------------------------//
				if (pW->ChunkMode & AJCSCP_CM_BIN) {
					UBP		pBin;
					if (pBin = (UBP)AJCMEM(bytes)) {
						memcpy(pBin, &pW->RxBin, bytes);
						ScpNtcEvtToUser(pW, AJCSCP_EV_RXCHUNK, pBin, bytes, 0);
					}
					pW->ixRxb = 0;
				}
				//----- eLXg`NMʒm ---------------------------------------------------------------//
				if (pW->ChunkMode & AJCSCP_CM_TEXT) {
					UI			i;
					BCP			p;
					BOOL		fInvChunk = FALSE;

					//	rɐR[h(0x09`0x0D, 0x1BȊO)邩`FbN
					for (i = 0, p = (BCP)&pW->RxBuf[pW->ixRxb]; i < bytes && !pW->fThreadEnd; i++, p++) {
						if (MAjcIsCntrlA((UB)*p) && !MAjcIsSpaceA((UB)*p) && (UB)*p != 0x1B) {
							fInvChunk = TRUE;
							break;
						}
					}
					if (!pW->fThreadEnd) {
						//	LeLXg`FbN
						if (lrx != 0) {
							//	rɐR[h(0x09`0x0DȊO)ꍇ́As`NeLXgƂăoCî܂ܒʒm
							if (fInvChunk) {
								UBP		pBin;
								if (pBin = (UBP)AJCMEM(lrx)) {
									memcpy(pBin, pW->RxBuf, lrx);
									ScpNtcEvtToUser(pW, AJCSCP_EV_INVCHUNK, pBin, lrx, 0);
								}
								pW->ixRxb = 0;
							}
							//	ȃeLXg`Nʒm
							else {
								//	I[ݒ
								pW->RxBuf[lrx] = 0;
								//	obt@CfNXݒiOۗf[^ƐVMf[^܂߂oCgj
								pW->ixRxb = lrx;
								//	擾ƃ[Uւ̒ʒm
								if (pW->fUnicode) {
									WCP		pWcs;
									if (pWcs = AjcExtractCompletedTextW((BCP)pW->RxBuf, AJCSCPMAX_RXSIZE, (UIP)&lrx, mbk)) {
										pW->ixRxb = lrx;
										pW->RxBuf[lrx] = 0;
										ScpNtcEvtToUser(pW, AJCSCP_EV_RXCHUNK, pWcs, (UI)wcslen(pWcs), 2);
									}
								}
								else {
									BCP		pSJis;
									if (pSJis = AjcExtractCompletedTextA((BCP)pW->RxBuf, AJCSCPMAX_RXSIZE, (UIP)&lrx, mbk)) {
										pW->ixRxb = lrx;
										pW->RxBuf[lrx] = 0;
										ScpNtcEvtToUser(pW, AJCSCP_EV_RXCHUNK, pSJis, (UI)strlen(pSJis), 1);
									}
								}
							}
						}
					}
				}
			}
			//----- oCgyAɂ郏[hi14Bitjf[^M --------------------------------------------------//
			if (pW->EvtMask & AJCSCP_EV_RXWORD14) {
				PAJCSCPUNIWORD	pDat;
				UI				i;
				for (i = 0; i < bytes && !pW->fThreadEnd; i++) {
					if		(pW->BpSeq == 0 && (pW->RxBin[i] & 0x80) != 0) {
						if (pW->fBpLBFirst) pW->BpDat.s.l = pW->RxBin[i];
						else				pW->BpDat.s.h = pW->RxBin[i];
						pW->BpSeq = 1;
					}
					else if (pW->BpSeq == 1 && (pW->RxBin[i] & 0x80) == 0) {
						if (pDat = (PAJCSCPUNIWORD)AJCMEM(sizeof pW->BpDat)) {
							if (pW->fBpLBFirst) pW->BpDat.s.h = pW->RxBin[i];
							else				pW->BpDat.s.l = pW->RxBin[i];
							pDat->w = (((pW->BpDat.w >> 1) & 0x3F80) | (pW->BpDat.w & 0x7F));
							ScpNtcEvtToUser(pW, AJCSCP_EV_RXWORD14, pDat, 2, pW->fBpLBFirst);
						}
						pW->BpSeq = 0;
					}
				}
			}
			//----- pPbgOMeLXgʒmi擾ƃ[Uւ̒ʒmj----------------------------//
			if (pW->EvtMask & AJCSCP_EV_RXNOPKT) {
				if (pW->ixNpk != 0) {	//	pPbgOf[^L
					if (pW->fUnicode) {
						WCP		pWcs;
						if (pWcs = AjcExtractCompletedTextW((BCP)pW->NpBuf, AJCSCPMAX_RXSIZE, (UIP)&pW->ixNpk, mbk)) {
							pW->NpBuf[pW->ixNpk] = 0;
							ScpNtcEvtToUser(pW, AJCSCP_EV_RXNOPKT, pWcs, (UI)wcslen(pWcs), 2);
						}
					}
					else {
						BCP		pSJis;
						if (pSJis = AjcExtractCompletedTextA((BCP)pW->NpBuf, AJCSCPMAX_RXSIZE, (UIP)&pW->ixNpk, mbk)) {
							pW->NpBuf[pW->ixNpk] = 0;
							ScpNtcEvtToUser(pW, AJCSCP_EV_RXNOPKT, pSJis, (UI)strlen(pSJis), 1);
						}
					}
				}
			}
			//	uMr؂vZoNA[
			ts = GetTickCount64();	//	ŌɎM
			tc = 0;					//	Ō̎M̌oߎ
		}
		else {						//	Ms^Mf[^Ȃ?
			//	Ō̎M̌oߎԎZo
			if ((cnt++ & 255) == 0) {
				tc = GetTickCount64() - ts;
			}
			//	uMf[^v珊莞Ԍo߂ŏԃEFCg
			if (tc >= pW->MesRxTime) {
				Sleep(1);
			}
		}
	}
	pW->fThrRecvEnd = TRUE;

	return 0;
}

//--------------------------------------------------------------------------------------------------------------//
//	rrdoR[obNiAjcSsepPutData()ɂ蔭AꂽXg[f[^ʒmj						//
//																												//
//			F	evt  	- f[^(AJCSSEP_EV_XXXXX)														//
//				pvData 	- f[^̃AhX																	//
//				lDat 	- f[^̃oCg																	//
//				cbp  	- R[obNp^																	//
//																												//
//	߂l	F	TRUE  - f[^J																	//
//				FALSE - f[^JȂ																//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbSsepWithRxData(UI evt, VOP pvData, UI lDat, UX cbp)
{
	BOOL		rc = TRUE;
	HAJCSCP		pW = (HAJCSCP)cbp;
	UI			ScpEvt = SsepEvtToScpEvt(evt);	//	CxgR[hϊiSSEPSCP)
	AJCMBCKIND	mbk;							//	MeLXgR[h
	BCP			pDat =(BCP)pvData;

	switch (evt) {
		case AJCSSEP_EV_TXT:												//	eLXgf[^
			//	MeLXgR[hݒ
			switch (pW->RxTxtCode) {
				default:
				case AJCSCP_TXT_SJIS:	mbk = AJCMBC_SJIS;					break;	//	Vtgihr
				case AJCSCP_TXT_EUC:	mbk = AJCMBC_EUC;					break;	//	dtb@@@
				case AJCSCP_TXT_UTF8:	mbk = AJCMBC_UTF8;					break;	//	tse|W@
				case AJCSCP_TXT_AUTO:	mbk = AjcSsepGetMbcKind(pW->hSsep);	break;	//	ʁ@
			}
			//----- UNICODE ------------------------------------------------------------------------------------//
			if (pW->fUnicode) {
				//	 S-JIS
				if (mbk == AJCMBC_SJIS) {
					WCP		pWid;
					UI		lWid;
					lWid = MultiByteToWideChar(CP_ACP, 0, pDat, -1, NULL, 0);
					if (lWid != 0 && (pWid = (WCP)AJCMEM(lWid * 2))) {
						MultiByteToWideChar(CP_ACP, 0, pDat, -1, pWid, lWid);		//	Ch֕ϊ
						ScpNtcEvtToUser(pW, ScpEvt, pWid, (UI)wcslen(pWid), 2);		//	Chʒm
					}
				}
				//	 EUC
				else if (mbk == AJCMBC_EUC) {
					BCP		pSJis;
					WCP		pWid;
					UI		lSJis, lWid;
					lSJis = AjcEucToSJis(pDat, NULL, 0);
					if (pSJis = (BCP)AJCMEM(lSJis)) {
						AjcEucToSJis(pDat, pSJis, lSJis);
						lWid = MultiByteToWideChar(CP_ACP, 0, pSJis, -1, NULL, 0);	//	EUC->SJIS ϊ
						if (lWid != 0 && (pWid = (WCP)AJCMEM(lWid * 2))) {
							MultiByteToWideChar(CP_ACP, 0, pSJis, -1, pWid, lWid);	//	Ch֕ϊ
							ScpNtcEvtToUser(pW, ScpEvt, pWid, (UI)wcslen(pWid), 2);	//	Chʒm
						}
						free(pSJis);
					}
				}
				//	 UTF-8
				else if (mbk == AJCMBC_UTF8) {
					WCP		pWid;
					UI		lWid;
					lWid = MultiByteToWideChar(CP_UTF8, 0, pDat, -1, NULL, 0);
					if (lWid != 0 && (pWid = (WCP)AJCMEM(lWid * 2))) {
						MultiByteToWideChar(CP_UTF8, 0, pDat, -1, pWid, lWid);
						ScpNtcEvtToUser(pW, ScpEvt, pWid, (UI)wcslen(pWid), 2);		//	Chʒm
					}
				}
				rc = TRUE;															//	pDatJ
			}
			//----- }`oCg -------------------------------------------------------------------------------//
			else {
				BCP		pSJis = pDat;
				UI		lSJis = lDat;
				//	 S-JIS
				if (mbk == AJCMBC_SJIS) {
					ScpNtcEvtToUser(pW, ScpEvt, pDat, lDat, 1);				//	r|ihr̂܂ܒʒm
					rc = FALSE;												//	pDat͉Ȃ
				}
				//	 EUC
				else if (mbk == AJCMBC_EUC) {
					lSJis = AjcEucToSJis(pDat, NULL, 1);
					if (pSJis = (BCP)AJCMEM(lSJis)) {						//	ϊ\H
						AjcEucToSJis(pDat, pSJis, lSJis);					//		r|ihr֕ϊ
						lSJis = (UI)strlen(pSJis);
						ScpNtcEvtToUser(pW, ScpEvt, pSJis, lSJis, 1);			//		ϊʒm
					}
					rc = TRUE;												//	pDat͉
				}
				//	 UTF-8
				else if (mbk == AJCMBC_UTF8) {
					lSJis = AjcUtf8ToMbc(pDat, NULL, 1);					//
					if (pSJis = (BCP)AJCMEM(lSJis)) {						//	ϊ\H
						AjcUtf8ToMbc(pDat, pSJis, lSJis);					//		r|ihr֕ϊ
						lSJis = (UI)strlen(pSJis);
						ScpNtcEvtToUser(pW, ScpEvt, pSJis, lSJis, 1);			//		ϊʒm
					}
					rc = TRUE;												//	pDat͉
				}
			}
			break;

		case AJCSSEP_EV_ESC:												//	drbR[hf[^
		case AJCSSEP_EV_CTRL:												//	R[h
			if (pW->fUnicode) {												//		ChH
				WCP		pWid;
				UI		lWid;
				lWid = MultiByteToWideChar(CP_ACP, 0, pDat, -1, NULL, 0);
				if (lWid != 0 && (pWid = (WCP)AJCMEM(lWid * 2))) {
					MultiByteToWideChar(CP_ACP, 0, pDat, -1, pWid, lWid);	//			Ch֕ϊ
					ScpNtcEvtToUser(pW, ScpEvt, pWid, (UI)wcslen(pWid), 2);	//			Chʒm
				}
				rc = TRUE;													//			pDatJ
			}
			else {															//		oCgH
				ScpNtcEvtToUser(pW, ScpEvt, pDat, lDat, 1);					//			ʒmf[^̂܂ܒʒm
				rc = FALSE;													//			pDat͉Ȃ
			}
			break;

		case AJCSSEP_EV_PKT:												//	pPbgf[^
			ScpNtcEvtToUser(pW, ScpEvt, pDat, lDat, 0);						//		pPbgf[^ʒm
			rc = FALSE;														//		pDat͉Ȃ
			break;

		case AJCSSEP_EV_NOPKT:												//	pPbgOoCgf[^
			if (pW->ixNpk < AJCSCPMAX_RXSIZE) {								//		pPbgOf[^obt@Ƀf[^i[
				pW->NpBuf[pW->ixNpk++] = *pDat;
				pW->NpBuf[pW->ixNpk  ] = 0;
			}
			rc = TRUE;														//		pDat͉
			break;
	}
	return rc;
}
