#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	R\[o																							//
//																												//
//**************************************************************************************************************//
//----- Wó^WG[ -------------------------------------------------------------------------------//
typedef struct {
	BOOL		fCon;				//	R\[o͂tO
	UL			mode;				//	R\[õ͎[h
	EAJCTEC		tec;				//	C_CNgõ͎eLXgGR[h
	BOOL		fBom;				//		  V			  anlo̓tO
	HANDLE		hdl;				//		  V			  fBXNt@Cnh
	HAJCFILE	*phFile;			//		  V			  eLXgt@CANZXnhւ̃|C^
	//	萔
	FILE		*pstd;				//	萔istdout			/ stderr			j
	UL			hstd;				//	萔iSTD_OUTPUT_HANDLE / STD_ERROR_HANDLE	j
} AJCSTDINFO, *PAJCSTDINFO;

//	[hݒȂ́Aʏprintf/wprintfsׁAfCon = TRUE Ƃ
static	AJCSTDINFO	StdOutInfo = {TRUE};	//	Wo͏
static	AJCSTDINFO	StdErrInfo = {TRUE};	//	WG[

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	vZXĨR[obNiWo̓C_CNgt@C̃t@CIuWFNgf^b`j				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO CALLBACK cbStdCleanup(VOP pHandle)
{
	HAJCFILE	*phFile = (HAJCFILE*)pHandle;
	AjcFDetach(*phFile);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R\[õ͎[hݒ																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetConMode(PAJCSTDINFO pW, UL mode)
{
	if (pW->pstd != NULL) {
		if (pW->mode != mode) _setmode(_fileno(pW->pstd), pW->mode = mode);
	}
}

//==============================================================================================================//
//	Wó^WG[ [hݒ																				//
//																												//
//	@F	pSTr - o͂镶																			//
//																												//
//	߂lF	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
static	BOOL SubSetStdMode(PAJCSTDINFO pW, EAJCTEC tec, BOOL fBom)
{
	BOOL		rc	= FALSE;
	HANDLE		h	= NULL;
	UL			m	= 0;
	VOP			vop;
	union {
		ULL sz;
		struct {UL sl, sh;} s;
	} u;

	if (h = GetStdHandle(pW->hstd)) {
		//	R\[õ͎[hݒiȂj
		if (pW->fCon = (GetConsoleMode(h, &m) != 0)) {
			rc = TRUE;
		}
		//	C_CNgo͎̐ݒ
		else {
			//	 or t@CnhωH
			if (h != pW->hdl) {
				if (vop = AjcAllocInstance(sizeof(HAJCFILE), cbStdCleanup)) {
					//	ǋL̏ꍇ́Aanlo͎
					u.s.sl = GetFileSize(h, &u.s.sh);
					if (u.sz != 0) {
						fBom = FALSE;
					}
					//	t@Cnhݒ
					pW->hdl = h;
					//	eLXgt@CANZX̃A^b`
					pW->phFile = (HAJCFILE*)vop;
					if ((*pW->phFile = AjcFAttachCreated(h, tec, fBom)) == NULL) {
						AjcReleaseInstance(vop);
						pW->hdl    = NULL;
						pW->phFile = NULL;
					}
				}
			}
			//	߂lݒ
			if (pW->phFile != NULL && *pW->phFile != NULL) {
				rc = TRUE;
			}
		}
	}
	return rc;
}
//----- AjcSetStdoutModeEx -------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	 AjcSetStdoutModeEx(EAJCTEC tec, BOOL fBom)
{
	BOOL	rc = FALSE;

	if (StdOutInfo.pstd == NULL) {
		//	Wó^WG[񏉊
		StdOutInfo.pstd	= stdout;				StdErrInfo.pstd = stderr;
		StdOutInfo.hstd	= STD_OUTPUT_HANDLE;	StdErrInfo.hstd	= STD_ERROR_HANDLE;
		StdOutInfo.mode	= -1;					StdErrInfo.mode	= -1;

		//	R\[[hݒ
		rc	= SubSetStdMode(&StdOutInfo, tec, fBom);
		rc &= SubSetStdMode(&StdErrInfo, tec, fBom);
	}
	return rc;
}
//----- AjcSetStdoutMode ---------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	 AjcSetStdoutMode(VO)
{
	return AjcSetStdoutModeEx(AJCTEC_MBC, FALSE);
}
//----- AjcSetStdMode ------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI	 AjcSetStdMode(EAJCTEC tec, BOOL fBom)
{
	return AjcSetStdoutModeEx(tec, fBom);
}


//==============================================================================================================//
//	Wo͂ւPo																						//
//																												//
//	@F	c - o͂镶																				//
//																												//
//	߂lF	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcPutCA(BC c)
{
	BOOL		rc = FALSE;

	if (StdOutInfo.fCon) {
		SetConMode(&StdOutInfo, _O_TEXT);
		rc = (putchar(c) != EOF);
	}
	else {
		rc = AjcFPutCA(*StdOutInfo.phFile, c);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcPutCW(WC c)
{
	BOOL		rc = FALSE;

	if (StdOutInfo.fCon) {
		SetConMode(&StdOutInfo, _O_U8TEXT);
		rc = (putwchar(c) != WEOF);
	}
	else if (StdOutInfo.phFile) {
		rc = AjcFPutCW(*StdOutInfo.phFile,c);
	}
	return rc;
}
//==============================================================================================================//
//	Wo͂֕o																						//
//																												//
//	@F	pSTr - o͂镶																			//
//																												//
//	߂lF	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcPutSA(C_BCP pStr)
{
	BOOL		rc = FALSE;

	if (pStr != NULL) {
		if (StdOutInfo.fCon) {
			SetConMode(&StdOutInfo, _O_TEXT);
			rc = (printf("%s", pStr) >= 0);
		}
		else {
			rc = AjcFPutSA(*StdOutInfo.phFile, pStr, -1);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcPutSW(C_WCP pStr)
{
	BOOL		rc = FALSE;

	if (pStr != NULL) {
		if (StdOutInfo.fCon) {
			SetConMode(&StdOutInfo, _O_U8TEXT);
			rc = (wprintf(L"%s", pStr) >= 0);
		}
		else if (StdOutInfo.phFile) {
			rc = AjcFPutSW(*StdOutInfo.phFile, pStr, -1);
		}
	}
	return rc;
}
//==============================================================================================================//
//	Wo͂֏o																					//
//																												//
//	@F	pFmt - 																				//
//																												//
//	߂lF	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcPrintFA(C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		if (StdOutInfo.fCon) {
			SetConMode(&StdOutInfo, _O_TEXT);
			rc = (vprintf(pFmt, vls) >= 0);
		}
		else if (StdOutInfo.phFile) {
			rc = AjcFVPrintFA(*StdOutInfo.phFile, pFmt, vls);
		}
		va_end	(vls);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcPrintFW(C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		if (StdOutInfo.fCon) {
			SetConMode(&StdOutInfo, _O_U8TEXT);
			rc = (vwprintf(pFmt, vls) >= 0);
		}
		else if (StdOutInfo.phFile) {
			rc = AjcFVPrintFW(*StdOutInfo.phFile, pFmt, vls);
		}
		va_end	(vls);
	}
	return rc;
}
//==============================================================================================================//
//	WG[ւPo																						//
//																												//
//	@F	c - o͂镶																				//
//																												//
//	߂lF	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcErrPutCA(BC c)
{
	BOOL		rc = FALSE;

	if (StdErrInfo.fCon) {
		SetConMode(&StdErrInfo, _O_TEXT);
		rc = (fputc(c, stderr) != EOF);
	}
	else {
		rc = AjcFPutCA(*StdErrInfo.phFile, c);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcErrPutCW(WC c)
{
	BOOL		rc = FALSE;

	if (StdErrInfo.fCon) {
		SetConMode(&StdErrInfo, _O_U8TEXT);
		rc = (fputwc(c, stderr) != WEOF);
	}
	else if (StdErrInfo.phFile) {
		rc = AjcFPutCW(*StdErrInfo.phFile,c);
	}
	return rc;
}
//==============================================================================================================//
//	WG[֕o																						//
//																												//
//	@F	pSTr - o͂镶																			//
//																												//
//	߂lF	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcErrPutSA(C_BCP pStr)
{
	BOOL		rc = FALSE;

	if (pStr != NULL) {
		if (StdErrInfo.fCon) {
			SetConMode(&StdErrInfo, _O_TEXT);
			rc = (fprintf(stderr, "%s", pStr) >= 0);
		}
		else {
			rc = AjcFPutSA(*StdErrInfo.phFile, pStr, -1);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcErrPutSW(C_WCP pStr)
{
	BOOL		rc = FALSE;

	if (pStr != NULL) {
		if (StdErrInfo.fCon) {
			SetConMode(&StdErrInfo, _O_U8TEXT);
			rc = (fwprintf(stderr, L"%s", pStr) >= 0);
		}
		else if (StdErrInfo.phFile) {
			rc = AjcFPutSW(*StdErrInfo.phFile, pStr, -1);
		}
	}
	return rc;
}
//==============================================================================================================//
//	WG[֏o																					//
//																												//
//	@F	pFmt - 																				//
//																												//
//	߂lF	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT int	 WINAPI AjcErrPrintFA(C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		if (StdErrInfo.fCon) {
			SetConMode(&StdErrInfo, _O_TEXT);
			rc = (vfprintf(stderr, pFmt, vls) >= 0);
		}
		else if (StdErrInfo.phFile) {
			rc = AjcFVPrintFA(*StdErrInfo.phFile, pFmt, vls);
		}
		va_end	(vls);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL	 WINAPI AjcErrPrintFW(C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		if (StdErrInfo.fCon) {
			SetConMode(&StdErrInfo, _O_U8TEXT);
			rc = (vfwprintf(stderr, pFmt, vls) >= 0);
		}
		else if (StdErrInfo.phFile) {
			rc = AjcFVPrintFW(*StdErrInfo.phFile, pFmt, vls);
		}
		va_end	(vls);
	}
	return rc;
}
//==============================================================================================================//
//	֐̈ChɕϊmہiChpj											//
//																												//
//	@F	argc - ̌																				//
//				argv - ̃|C^z̃AhX																//
//																												//
//	߂lF	TRUEFnj , FALSE:Error																		//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcAllocMainArgsW(int argc, char **argv[])
{
	BOOL	rc = TRUE;
	WCP		*pWArgs;
	int		i, wl;

	if (argv != NULL) {
		if (pWArgs = (WCP*)AJCMEM(sizeof(VOP) * argc)) {
			memset(pWArgs, 0, sizeof(VOP) * argc);
			for (i=0; i<argc; i++) {
				wl = MultiByteToWideChar(CP_ACP, 0, (*argv)[i], -1, NULL, 0);
				if (!(pWArgs[i] = AjcTAlloc(wl))) {rc = FALSE; break;}
				MultiByteToWideChar(CP_ACP, 0, (*argv)[i], -1, pWArgs[i], wl);
			}
			if (rc == TRUE) {
				*argv = (VOP)pWArgs;
			}
			else {
				for (i=0; i<argc && pWArgs[i]!=NULL; i++) {
					free(pWArgs[i]);
				}
				free(pWArgs);
			}
		}
		else rc = FALSE;
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	AjcAllocMainArgs()Ŋmۂ̊JiChpj													//
//																												//
//	@F	argc - ̌																				//
//				argv - ̃|C^z̃AhX																//
//																												//
//	߂lF	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO	WINAPI AjcFreeMainArgsW(int argc, char *argv[])
{
	int		i;

	if (argv != NULL) {
		for (i=0; i<argc; i++) {
			free(argv[i]);
		}
		free(argv);
	}
}
//==============================================================================================================//
//	R\[擾																							//
//																												//
//	@F	pBufSize	- obt@TCYi[obt@̃AhXisvNULLj						//
//				pRcWnd		- ECh`i[obt@̃AhX	isvNULLj						//
//				pMaxWndSize - őEChTCYi[obt@̃AhXisvNULLj					//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcGetConsoleScreenBufferInfo(LPSIZE pBufSize, LPRECT pRcWnd, LPSIZE pMaxWndSize)
{
	BOOL	rc = FALSE;
	CONSOLE_SCREEN_BUFFER_INFO info;

	if (rc = (GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), &info) != 0)) {
		if (pBufSize != NULL) {
			pBufSize->cx = info.dwSize.X;
			pBufSize->cy = info.dwSize.Y;
		}
		if (pRcWnd != NULL) {
			pRcWnd->left   = info.srWindow.Left;
			pRcWnd->right  = info.srWindow.Right;
			pRcWnd->top	  = info.srWindow.Top;
			pRcWnd->bottom = info.srWindow.Bottom;
		}
		if (pMaxWndSize != NULL) {
			pMaxWndSize->cx = info.dwMaximumWindowSize.X;
			pMaxWndSize->cy = info.dwMaximumWindowSize.Y;
		}
	}
	return rc;
}
//==============================================================================================================//
//	R\[EChőTCY擾																			//
//																												//
//	@F	pCx - TCYiji[obt@̃AhXisvNULLj							//
//				pCy - cTCYiji[obt@̃AhXisvNULLj							//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcGetConsoleMaxWndSize(int *pCx, int *pCy)
{
	BOOL	rc = FALSE;
	CONSOLE_SCREEN_BUFFER_INFO info;

	if (rc = (GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), &info) != 0)) {
		if (pCx != NULL) *pCx = info.dwMaximumWindowSize.X;
		if (pCy != NULL) *pCy = info.dwMaximumWindowSize.Y;
	}
	return rc;
}
//==============================================================================================================//
//	R\[obt@TCYݒ																				//
//																												//
//	@F	cx - TCYij																			//
//				cy - cTCYij																			//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcSetConsoleBufSize(int cx, int cy)
{
	BOOL	rc = FALSE;
	COORD	cd;

	cd.X = cx;
	cd.Y = cy;
	rc = SetConsoleScreenBufferSize(GetStdHandle(STD_OUTPUT_HANDLE), cd);

	return rc;
}
//==============================================================================================================//
//	R\[obt@TCY擾																				//
//																												//
//	@F	pCx - i[obt@̃AhXisvNULLj										//
//				pCy - ci[obt@̃AhXisvNULLj										//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcGetConsoleBufSize(int *pCx, int *pCy)
{
	BOOL	rc = FALSE;
	SIZE	BufSize;

	if (rc = AjcGetConsoleScreenBufferInfo(&BufSize, NULL, NULL)) {
		if (pCx != NULL) *pCx = BufSize.cx;
		if (pCy != NULL) *pCy = BufSize.cy;
	}
	return rc;
}
//==============================================================================================================//
//	R\[XN[`ݒ																				//
//																												//
//	@F	left   - [ʒu																			//
//				top    - [ʒu																			//
//				right  - E[ʒu																			//
//				bottom - [ʒu																			//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcSetConsoleWndRect(int left, int top, int right, int bottom)
{
	BOOL		rc = FALSE;
	SMALL_RECT	rect;

	rect.Left	= left;
	rect.Right	= right;
	rect.Top	= top;
	rect.Bottom	= bottom;
	rc = SetConsoleWindowInfo(GetStdHandle(STD_OUTPUT_HANDLE), TRUE, &rect);

	return rc;
}
//==============================================================================================================//
//	R\[XN[`擾																				//
//																												//
//	@F	pLeft	- [ʒui[obt@̃AhX(svNULLj								//
//				pTop	- [ʒui[obt@̃AhX(svNULLj								//
//				pRight	- E[ʒui[obt@̃AhX(svNULLj								//
//				pBottom - [ʒui[obt@̃AhX(svNULLj								//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcGetConsoleWndRect(int *pLeft, int *pTop, int *pRight, int *pBottom)
{
	BOOL	rc = FALSE;
	RECT	rect;

	if (rc = AjcGetConsoleScreenBufferInfo(NULL, &rect, NULL)) {
		if (pLeft	!= NULL) *pLeft	  = rect.left;
		if (pRight	!= NULL) *pRight  = rect.right;
		if (pTop	!= NULL) *pTop	  = rect.top;
		if (pBottom != NULL) *pBottom = rect.bottom;
	}
	return rc;
}
//==============================================================================================================//
//	R\[\FݒitJ[j																			//
//																												//
//	@F	ForeColor	- OiFi|PFݒ肵Ȃj														//
//				BackColor	- wiFi|PFݒ肵Ȃj														//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcSetConsoleColor(COLORREF ForeColor, COLORREF BackColor)
{
	BOOL	rc	 = FALSE;
	HANDLE	hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	UI		fix = 0, bix = 0;
	UW		att;
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	if (ForeColor != -1 || BackColor != -1) {
		info.cbSize = sizeof(info);
		if (rc = (GetConsoleScreenBufferInfoEx(hStd, &info) != 0)) {
			if (ForeColor != -1) {
				if (info.wAttributes & FOREGROUND_INTENSITY) fix |= 0x08;
				if (info.wAttributes & FOREGROUND_RED	   ) fix |= 0x04;
				if (info.wAttributes & FOREGROUND_GREEN    ) fix |= 0x02;
				if (info.wAttributes & FOREGROUND_BLUE	   ) fix |= 0x01;
				info.ColorTable[fix] = ForeColor;
			}
			if (BackColor != -1) {
				if (info.wAttributes & BACKGROUND_INTENSITY) bix |= 0x08;
				if (info.wAttributes & BACKGROUND_RED	   ) bix |= 0x04;
				if (info.wAttributes & BACKGROUND_GREEN    ) bix |= 0x02;
				if (info.wAttributes & BACKGROUND_BLUE	   ) bix |= 0x01;
				info.ColorTable[bix] = BackColor;
			}
			info.srWindow.Bottom++;	// ݒ肷ꍇBottom+1iWindowsAPIoOj
			if (rc = (SetConsoleScreenBufferInfoEx(hStd, &info) != 0)) {
				att = 0;
				if (fix & 0x08) att |= FOREGROUND_INTENSITY;
				if (fix & 0x04) att |= FOREGROUND_RED;
				if (fix & 0x02) att |= FOREGROUND_GREEN;
				if (fix & 0x01) att |= FOREGROUND_BLUE;
				if (bix & 0x08) att |= BACKGROUND_INTENSITY;
				if (bix & 0x04) att |= BACKGROUND_RED;
				if (bix & 0x02) att |= BACKGROUND_GREEN;
				if (bix & 0x01) att |= BACKGROUND_BLUE;
				SetConsoleTextAttribute(hStd, att);
			}
		}
	}
	else {
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	R\[\F擾itJ[j																			//
//																												//
//	@F	pForeColor	- OiFi[obt@̃AhXisvNULLj								//
//				pBackColor	- wiFi[obt@̃AhXisvNULLj								//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//	OiFƔwiF
AJCEXPORT	BOOL	WINAPI AjcGetConsoleColor(LPCOLORREF pForeColor, LPCOLORREF pBackColor)
{
	BOOL	rc = FALSE;
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	info.cbSize = sizeof(info);
	if (rc = (GetConsoleScreenBufferInfoEx(GetStdHandle(STD_OUTPUT_HANDLE), &info) != 0)) {
		if (pForeColor != NULL) {
			UI	fix = 0;
			if (info.wAttributes & FOREGROUND_INTENSITY) fix |= 0x08;
			if (info.wAttributes & FOREGROUND_RED	   ) fix |= 0x04;
			if (info.wAttributes & FOREGROUND_GREEN    ) fix |= 0x02;
			if (info.wAttributes & FOREGROUND_BLUE	   ) fix |= 0x01;
			*pForeColor = info.ColorTable[fix];
		}
		if (pBackColor != NULL) {
			UI	bix = 0;
			if (info.wAttributes & BACKGROUND_INTENSITY) bix |= 0x08;
			if (info.wAttributes & BACKGROUND_RED	   ) bix |= 0x04;
			if (info.wAttributes & BACKGROUND_GREEN    ) bix |= 0x02;
			if (info.wAttributes & BACKGROUND_BLUE	   ) bix |= 0x01;
			*pBackColor = info.ColorTable[bix];
		}
	}
	return rc;
}
//	OiF
AJCEXPORT	COLORREF	WINAPI AjcGetConsoleForeColor(VO)
{
	COLORREF	rc = -1;
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	info.cbSize = sizeof(info);
	if (rc = (GetConsoleScreenBufferInfoEx(GetStdHandle(STD_OUTPUT_HANDLE), &info) != 0)) {
		UI	fix = 0;
		if (info.wAttributes & FOREGROUND_INTENSITY) fix |= 0x08;
		if (info.wAttributes & FOREGROUND_RED	   ) fix |= 0x04;
		if (info.wAttributes & FOREGROUND_GREEN    ) fix |= 0x02;
		if (info.wAttributes & FOREGROUND_BLUE	   ) fix |= 0x01;
		rc = info.ColorTable[fix];
	}
	return rc;
}
//	wiF
AJCEXPORT	COLORREF	WINAPI AjcGetConsoleBackColor(VO)
{
	COLORREF	rc = -1;
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	info.cbSize = sizeof(info);
	if (rc = (GetConsoleScreenBufferInfoEx(GetStdHandle(STD_OUTPUT_HANDLE), &info) != 0)) {
		UI	bix = 0;
		if (info.wAttributes & BACKGROUND_INTENSITY) bix |= 0x08;
		if (info.wAttributes & BACKGROUND_RED	   ) bix |= 0x04;
		if (info.wAttributes & BACKGROUND_GREEN    ) bix |= 0x02;
		if (info.wAttributes & BACKGROUND_BLUE	   ) bix |= 0x01;
		rc = info.ColorTable[bix];
	}
	return rc;
}
//==============================================================================================================//
//	R\[\FݒiPUFj																				//
//																												//
//	@F	ForeColor	- OiFi|PFݒ肵Ȃj														//
//				BackColor	- wiFi|PFݒ肵Ȃj														//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcSetConsole16Color(UI ForeColor, UI BackColor)
{
	BOOL	rc	 = FALSE;
	HANDLE	hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	UI		fix = 0, bix = 0;
	UW		att;
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	if (ForeColor != -1 || BackColor != -1) {
		info.cbSize = sizeof(info);
		if (rc = (GetConsoleScreenBufferInfoEx(hStd, &info) != 0)) {
			if (ForeColor != -1) {
				if (info.wAttributes & FOREGROUND_INTENSITY) fix |= 0x08;
				if (info.wAttributes & FOREGROUND_RED	   ) fix |= 0x04;
				if (info.wAttributes & FOREGROUND_GREEN    ) fix |= 0x02;
				if (info.wAttributes & FOREGROUND_BLUE	   ) fix |= 0x01;
				info.ColorTable[fix] = ForeColor;
			}
			if (BackColor != -1) {
				if (info.wAttributes & BACKGROUND_INTENSITY) bix |= 0x08;
				if (info.wAttributes & BACKGROUND_RED	   ) bix |= 0x04;
				if (info.wAttributes & BACKGROUND_GREEN    ) bix |= 0x02;
				if (info.wAttributes & BACKGROUND_BLUE	   ) bix |= 0x01;
				info.ColorTable[bix] = BackColor;
			}
			att = 0;
			if (fix & 0x08) att |= FOREGROUND_INTENSITY;
			if (fix & 0x04) att |= FOREGROUND_RED;
			if (fix & 0x02) att |= FOREGROUND_GREEN;
			if (fix & 0x01) att |= FOREGROUND_BLUE;
			if (bix & 0x08) att |= BACKGROUND_INTENSITY;
			if (bix & 0x04) att |= BACKGROUND_RED;
			if (bix & 0x02) att |= BACKGROUND_GREEN;
			if (bix & 0x01) att |= BACKGROUND_BLUE;

			if (SetConsoleTextAttribute(hStd, att)) {
				rc = TRUE;
			}
		}
	}
	else {
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	R\[\F擾iPUFj																				//
//																												//
//	@F	pForeColor	- OiFi[obt@̃AhXisvNULLj								//
//				pBackColor	- wiFi[obt@̃AhXisvNULLj								//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcGetConsole16Color(UIP pForeColor, UIP pBackColor)
{
	BOOL	rc = FALSE;
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	if (GetConsoleScreenBufferInfoEx(GetStdHandle(STD_OUTPUT_HANDLE), &info)) {
		if (pForeColor != NULL) {
			*pForeColor = 0;
			if (info.wAttributes & FOREGROUND_INTENSITY) *pForeColor |= 0x08;
			if (info.wAttributes & FOREGROUND_RED	   ) *pForeColor |= 0x04;
			if (info.wAttributes & FOREGROUND_GREEN    ) *pForeColor |= 0x02;
			if (info.wAttributes & FOREGROUND_BLUE	   ) *pForeColor |= 0x01;
		}
		if (pBackColor != NULL) {
			*pBackColor = 0;
			if (info.wAttributes & BACKGROUND_INTENSITY) *pBackColor |= 0x08;
			if (info.wAttributes & BACKGROUND_RED	   ) *pBackColor |= 0x04;
			if (info.wAttributes & BACKGROUND_GREEN    ) *pBackColor |= 0x02;
			if (info.wAttributes & BACKGROUND_BLUE	   ) *pBackColor |= 0x01;
		}
		rc = TRUE;
	}
	return rc;
}
//	OiF
AJCEXPORT	UI	WINAPI AjcGetConsoleFore16Color(VO)
{
	UI		rc = -1;
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	info.cbSize = sizeof(info);
	if (rc = (GetConsoleScreenBufferInfoEx(GetStdHandle(STD_OUTPUT_HANDLE), &info) != 0)) {
		UI	fix = 0;
		if (info.wAttributes & FOREGROUND_INTENSITY) fix |= 0x08;
		if (info.wAttributes & FOREGROUND_RED	   ) fix |= 0x04;
		if (info.wAttributes & FOREGROUND_GREEN    ) fix |= 0x02;
		if (info.wAttributes & FOREGROUND_BLUE	   ) fix |= 0x01;
		rc = fix;
	}
	return rc;
}
//	wiF
AJCEXPORT	UI	WINAPI AjcGetConsoleBack16Color(VO)
{
	UI		rc = -1;
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	info.cbSize = sizeof(info);
	if (rc = (GetConsoleScreenBufferInfoEx(GetStdHandle(STD_OUTPUT_HANDLE), &info) != 0)) {
		UI	bix = 0;
		if (info.wAttributes & BACKGROUND_INTENSITY) bix |= 0x08;
		if (info.wAttributes & BACKGROUND_RED	   ) bix |= 0x04;
		if (info.wAttributes & BACKGROUND_GREEN    ) bix |= 0x02;
		if (info.wAttributes & BACKGROUND_BLUE	   ) bix |= 0x01;
		rc = bix;
	}
	return rc;
}

//==============================================================================================================//
//	R\[\pbgI																					//
//																												//
//	@F	ForePalette	- OiF̃pbgԍiO`PTFpbgԍC|PFݒ肵Ȃj					//
//				BackPalette	- wiF̃pbgԍiO`PTFpbgԍC|PFݒ肵Ȃj					//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcSelConsolePalette(UI ForePalette, UI BackPalette)
{
	return AjcSetConsole16Color(ForePalette, BackPalette);
}
//==============================================================================================================//
//	R\[\pbgݒ																					//
//																												//
//	@F	Palette	- ݒ肷pbg̃AhX														//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcSetConsolePalette(const COLORREF Palette[16])
{
	BOOL	rc = FALSE;
	HANDLE	hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	if (Palette != NULL) {
		info.cbSize = sizeof(info);
		if (GetConsoleScreenBufferInfoEx(hStd, &info) != 0) {
			//	pbgRs[
			memcpy(info.ColorTable, Palette, sizeof info.ColorTable);
			//	R\[obt@ݒ
			rc = (SetConsoleScreenBufferInfoEx(hStd, &info) != 0);
		}
	}
	return rc;
}

//==============================================================================================================//
//	R\[\pbgݒipbgԍwj																//
//																												//
//	@F	ix			- ݒ肷pbg̔ԍiO`PTj												//
//				color		- pbgɔwĂF															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcSetConsolePalByIx(UI ix, COLORREF color)
{
	BOOL	rc = FALSE;
	HANDLE	hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	if (ix < 16) {
		info.cbSize = sizeof(info);
		if (GetConsoleScreenBufferInfoEx(hStd, &info) != 0) {
			//	wpbgFݒ
			info.ColorTable[ix] = color;
			//	R\[obt@ݒ
			rc = (SetConsoleScreenBufferInfoEx(hStd, &info) != 0);
		}
	}
	return rc;
}

//==============================================================================================================//
//	R\[\pbg擾																					//
//																												//
//	@F	Palette	- pbgFi[obt@̃AhXisvNULLj							//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI AjcGetConsolePalette(COLORREF Palette[16])
{
	UI		rc = -1;
	UI		fix, bix;
	HANDLE	hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	info.cbSize = sizeof(info);
	if (GetConsoleScreenBufferInfoEx(hStd, &info) != 0) {
		//	Oipbgԍݒ
		fix = 0;
		if (info.wAttributes & FOREGROUND_INTENSITY) fix |= 0x08;
		if (info.wAttributes & FOREGROUND_RED	   ) fix |= 0x04;
		if (info.wAttributes & FOREGROUND_GREEN    ) fix |= 0x02;
		if (info.wAttributes & FOREGROUND_BLUE	   ) fix |= 0x01;
		//	wipbgԍݒ
		bix = 0;
		if (info.wAttributes & BACKGROUND_INTENSITY) bix |= 0x08;
		if (info.wAttributes & BACKGROUND_RED	   ) bix |= 0x04;
		if (info.wAttributes & BACKGROUND_GREEN    ) bix |= 0x02;
		if (info.wAttributes & BACKGROUND_BLUE	   ) bix |= 0x01;
		//	pbgԍi߂lݒj
		rc = MAKELONG(fix, bix);
		//	pbgRs[
		if (Palette != NULL) {
			memcpy(Palette, info.ColorTable, sizeof info.ColorTable);
		}
	}
	return rc;
}
//==============================================================================================================//
//	R\[\pbg擾ipbgԍwj																//
//																												//
//	@F	Palette	- pbgFi[obt@̃AhXisvNULLj							//
//																												//
//	߂lF	-1  - OK																						//
//				-1  - G[																					//
//==============================================================================================================//
AJCEXPORT	COLORREF	WINAPI AjcGetConsolePalByIx(UI ix)
{
	COLORREF	rc = -1;
	HANDLE		hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	if (ix < 16) {
		info.cbSize = sizeof(info);
		if (GetConsoleScreenBufferInfoEx(hStd, &info) != 0) {
			//	pbgݒ
			rc = info.ColorTable[ix];
		}
	}
	return rc;
}
//==============================================================================================================//
//	R\[̃J[\ʒuݒ																				//
//																												//
//	@F	x	- sʒuiO`j																			//
//				y	- ʒuiO`j																			//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcSetConsoleCursor(int x, int y)
{
	BOOL	rc = FALSE;
	HANDLE	hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFOEX info;
	COORD	pos;

	if (x >= 0 && y >= 0) {
		info.cbSize = sizeof(info);
		if (GetConsoleScreenBufferInfoEx(hStd, &info) != 0) {
			if (x < info.srWindow.Right && y < info.srWindow.Bottom) {
				pos.X = x;
				pos.Y = y;
				rc = (SetConsoleCursorPosition(hStd, pos) != 0);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	R\[̃J[\ʒu擾																				//
//																												//
//	@F	pX	- sʒuiO`ji[obt@̃AhXisvNULL)									//
//				pY	- ʒuiO`ji[obt@̃AhXisvNULL)									//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI AjcGetConsoleCursor(int *pX, int *pY)
{
	BOOL	rc = FALSE;
	HANDLE	hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFOEX info;

	info.cbSize = sizeof(info);
	if (GetConsoleScreenBufferInfoEx(hStd, &info) != 0) {
		if (pX != NULL) *pX = info.dwCursorPosition.X;
		if (pY != NULL) *pY = info.dwCursorPosition.Y;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	R}hso͂t@CɃ_CNg															//
//																												//
//	@F	pCmdLine	- R}hC															//
//				pOutFile	- C_CNgo͂t@C̃pXiNULL̏ꍇ́Astdout)						//
//				msTime		- R}hsI҂ (INIFINIT:ivj											//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcSystemA(C_BCP pCmdLine, C_BCP pOutFile, UI msTime)
{
	BOOL		rc = FALSE;
	UI			len;
	WCP			pCmdLineW	= NULL;
	WCP			pOutFileW	= NULL;

	if (pCmdLine != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pCmdLine, -1, NULL, 0);
		if ((pCmdLineW = AjcTAllocW(len)) != NULL) {
			MultiByteToWideChar(CP_ACP, 0, pCmdLine, -1, pCmdLineW, len);
			if (pOutFile != NULL) {
				len = MultiByteToWideChar(CP_ACP, 0, pOutFile, -1, NULL, 0);
				if ((pOutFileW = AjcTAllocW(len)) != NULL) {
					MultiByteToWideChar(CP_ACP, 0, pOutFile, -1, pOutFileW, len);
					rc = AjcSystemW(pCmdLineW, pOutFileW, msTime);
				}
			}
			else {
				rc =  AjcSystemW(pCmdLineW, NULL, msTime);
			}
		}
	}
	if (pCmdLineW != NULL) AjcTFree(pCmdLineW);
	if (pOutFileW != NULL) AjcTFree(pOutFileW);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcSystemW(C_WCP pCmdLine, C_WCP pOutFile, UI msTime)
{
	BOOL				rc	  = FALSE;
	HANDLE				hFile = INVALID_HANDLE_VALUE;
	HANDLE				hOut  = stdout;
	SECURITY_ATTRIBUTES	sa	  = {0};
	STARTUPINFO			si	  = {0};
	PROCESS_INFORMATION	pi	  = {0};
	UI					stl;
	WCP					pCmd  = NULL;

	do {
		if (pCmdLine == NULL) break;
		//	R}hC𓮓IփRs[
		stl = (UI)wcslen(pCmdLine);
		if ((pCmd = AjcTAllocW(stl + 32)) == NULL) break;
		AjcSnPrintF(pCmd, stl + 32, L"Cmd.exe /c %s", pCmdLine);
		//	_CNgt@Cnh
		if (pOutFile != NULL) {
			sa.nLength				= sizeof(sa);
			sa.lpSecurityDescriptor = NULL;
			sa.bInheritHandle		= TRUE;	//TRUEŃnhp
			hFile = CreateFile(pOutFile, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE,&sa, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
			if (hFile == INVALID_HANDLE_VALUE) break;
			hOut = hFile;
		}
		//	Wo͂̎w
		si.cb			= sizeof(si);
		si.dwFlags		= STARTF_USESTDHANDLES;
		si.hStdInput	= stdin;
		si.hStdOutput	= hOut;
		si.hStdError	= hOut;

		//	ʂ̃vZX cmd.exe s
		if (!CreateProcess( NULL, pCmd, NULL, NULL, TRUE, CREATE_NO_WINDOW, NULL, NULL, &si, &pi)) break;
		//	NvZX̏I҂
		WaitForSingleObject( pi.hProcess, msTime);
		//	vZX̃nh
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);

		rc = TRUE;

	} while(0);

	//	t@Cnh
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);

	//	R}h
	if (pCmd != NULL) AjcMFree(pCmd);

	return rc;
}
