#include	"AjcInternal.h"


#define	INST_ID			0x2BF69CE6
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//--------------------------------------------------------------------------------------------------------------//
//	R[obNioCgCQؗpL[rCp召ʂj									//
//																												//
//	@	F	key1, key2 - rQ̃m[h̃L[ĩAhXj										//
//																												//
//	߂l	F	> 0 - key1 > key2																				//
//				= 0 - key1 = key2																				//
//				< 0 - key1 < key2																				//
//--------------------------------------------------------------------------------------------------------------//
static int CALLBACK cbAvlCompXStrA(UX key1, UX key2, UX cbp)
{
	return mbscmp((C_BCP)key1, (C_BCP)key2);
}
//--------------------------------------------------------------------------------------------------------------//
//	R[obNioCgCQؗpL[rCp召ʂȂj									//
//																												//
//	@	F	key1, key2 - rQ̃m[h̃L[ĩAhXj										//
//																												//
//	߂l	F	> 0 - key1 > key2																				//
//				= 0 - key1 = key2																				//
//				< 0 - key1 < key2																				//
//--------------------------------------------------------------------------------------------------------------//
static int CALLBACK cbAvlCompIStrA(UX key1, UX key2, UX cbp)
{
	return mbsicmp((C_BCP)key1, (C_BCP)key2);
}

//--------------------------------------------------------------------------------------------------------------//
//	R[obNioCgCQؗpL[rCꍇ̂݉p召ʂj						//
//																												//
//	@	F	key1, key2 - rQ̃m[h̃L[ĩAhXj										//
//																												//
//	߂l	F	> 0 - key1 > key2																				//
//				= 0 - key1 = key2																				//
//				< 0 - key1 < key2																				//
//--------------------------------------------------------------------------------------------------------------//
static int CALLBACK cbAvlCompMStrA(UX key1, UX key2, UX cbp)
{
	int		rc;

	if ((rc = mbsicmp((C_BCP)key1, (C_BCP)key2)) == 0) {
		rc = mbscmp((C_BCP)key1, (C_BCP)key2);
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	R[obNiChCQؗpL[rCp召ʂj									//
//																												//
//	@	F	key1, key2 - rQ̃m[h̃L[ĩAhXj										//
//																												//
//	߂l	F	> 0 - key1 > key2																				//
//				= 0 - key1 = key2																				//
//				< 0 - key1 < key2																				//
//--------------------------------------------------------------------------------------------------------------//
static int CALLBACK cbAvlCompXStrW(UX key1, UX key2, UX cbp)
{
	return wcscmp((WCP)key1, (WCP)key2);
}
//--------------------------------------------------------------------------------------------------------------//
//	R[obNiChCQؗpL[rCp召ʂȂj									//
//																												//
//	@	F	key1, key2 - rQ̃m[h̃L[ĩAhXj										//
//																												//
//	߂l	F	> 0 - key1 > key2																				//
//				= 0 - key1 = key2																				//
//				< 0 - key1 < key2																				//
//--------------------------------------------------------------------------------------------------------------//
static int CALLBACK cbAvlCompIStrW(UX key1, UX key2, UX cbp)
{
	return wcsicmp((WCP)key1, (WCP)key2);
}
//--------------------------------------------------------------------------------------------------------------//
//	R[obNiChCQؗpL[rCꍇ̂݉p召ʂj						//
//																												//
//	@	F	key1, key2 - rQ̃m[h̃L[ĩAhXj										//
//																												//
//	߂l	F	> 0 - key1 > key2																				//
//				= 0 - key1 = key2																				//
//				< 0 - key1 < key2																				//
//--------------------------------------------------------------------------------------------------------------//
static int CALLBACK cbAvlCompMStrW(UX key1, UX key2, UX cbp)
{
	int		rc;

	if ((rc = wcsicmp((WCP)key1, (WCP)key2)) == 0) {
		rc = wcscmp((WCP)key1, (WCP)key2);
	}
	return rc;
}


//==============================================================================================================//
//	v[																							//
//																												//
//	@	F	AJCSPL_CMPMODE CmpMode	-	̔r[h													//
//											EAJCSPL_CMP_NODISTINGUISH(=0)	p召ʂȂ				//
//											EAJCSPL_CMP_DISTINGUISH  (=1)		V		ʂ				//
//											EAJCSPL_CMP_MIX		  (=2)	̏ꍇ̂݉p召ʂ	//
//																												//
//	߂l	F	 NULLFnjiv[nhj															//
//				 NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSPL		WINAPI	AjcSplCreateA(EAJCCMPMODE CmpMode)
{
	HAJCSPL	pW = NULL;

	if (pW = (HAJCSPL)AJCMEM(sizeof(AJCSPL))) {
		memset(pW, 0, sizeof(AJCSPL));
		pW->InstID = INST_ID;
		if (!AjcSplSetCompModeA(pW, CmpMode)) {
			free(pW);
			pW = NULL;
		}
	}
	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSPL		WINAPI	AjcSplCreateW(EAJCCMPMODE CmpMode)
{
	HAJCSPL	pW = NULL;

	if (pW = (HAJCSPL)AJCMEM(sizeof(AJCSPL))) {
		memset(pW, 0, sizeof(AJCSPL));
		pW->InstID = INST_ID;
		if (!AjcSplSetCompModeW(pW, CmpMode)) {
			free(pW);
			pW = NULL;
		}
	}
	return pW;
}

//==============================================================================================================//
//	v[																							//
//																												//
//	@	F	pW				-	v[nh														//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcSplDelete(HAJCSPL pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pW->hAvlStr != NULL) rc = AjcAvlDelete(pW->hAvlStr);
		free(pW);
	}
	return rc;
}
//==============================================================================================================//
//	r[hݒ																								//
//																												//
//	@	F	pW		-	v[nh																//
//				CmpMode	-	̔r[h																	//
//								EAJCSPL_CMP_NODISTINGUISH(=0)	p召ʂȂ							//
//								EAJCSPL_CMP_DISTINGUISH  (=1)		V		ʂ							//
//								EAJCSPL_CMP_MIX		  (=2)	̏ꍇ̂݉p召ʂ				//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcSplSetCompModeA(HAJCSPL pW, EAJCCMPMODE CmpMode)
{
	BOOL		rc	 = FALSE;
	HAJCAVL		hAvl = NULL;

	if (IS_MY_INST(pW)) {
		if (CmpMode != AJCSPL_CMP_NODISTINGUISH && CmpMode != AJCSPL_CMP_DISTINGUISH && CmpMode != AJCSPL_CMP_MIX) {
			CmpMode = AJCSPL_CMP_MIX;
		}
		if (pW->hAvlStr != NULL && pW->CmpMode == CmpMode) {
			rc = TRUE;
		}
		else {
			switch (CmpMode) {
				case AJCSPL_CMP_NODISTINGUISH: hAvl = AjcAvlCreate(0, cbAvlCompIStrA, NULL); break;
				case AJCSPL_CMP_DISTINGUISH:   hAvl = AjcAvlCreate(0, cbAvlCompXStrA, NULL); break;
				case AJCSPL_CMP_MIX:		   hAvl = AjcAvlCreate(0, cbAvlCompMStrA, NULL); break;
			}
			if (hAvl != NULL) {
				if (pW->hAvlStr != NULL) {
					AjcAvlDelete(pW->hAvlStr);
				}
				pW->CmpMode 	 = CmpMode;
				pW->fDistinguish = (CmpMode != AJCSPL_CMP_NODISTINGUISH);
				pW->hAvlStr 	 = hAvl;
				rc = TRUE;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcSplSetCompModeW(HAJCSPL pW, EAJCCMPMODE CmpMode)
{
	BOOL		rc	 = FALSE;
	HAJCAVL		hAvl = NULL;

	if (IS_MY_INST(pW)) {
		if (CmpMode != AJCSPL_CMP_NODISTINGUISH && CmpMode != AJCSPL_CMP_DISTINGUISH && CmpMode != AJCSPL_CMP_MIX) {
			CmpMode = AJCSPL_CMP_MIX;
		}
		if (pW->hAvlStr != NULL && pW->CmpMode == CmpMode) {
			rc = TRUE;
		}
		else {
			switch (CmpMode) {
				case AJCSPL_CMP_NODISTINGUISH: hAvl = AjcAvlCreate(0, cbAvlCompIStrW, NULL); break;
				case AJCSPL_CMP_DISTINGUISH:   hAvl = AjcAvlCreate(0, cbAvlCompXStrW, NULL); break;
				case AJCSPL_CMP_MIX:		   hAvl = AjcAvlCreate(0, cbAvlCompMStrW, NULL); break;
			}
			if (hAvl != NULL) {
				if (pW->hAvlStr != NULL) {
					AjcAvlDelete(pW->hAvlStr);
				}
				pW->CmpMode 	 = CmpMode;
				pW->fDistinguish = (CmpMode != AJCSPL_CMP_NODISTINGUISH);
				pW->hAvlStr 	 = hAvl;
				rc = TRUE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	r[h擾																								//
//																												//
//	@	F	pW		-	v[nh																//
//																												//
//	߂l	F	-1 : r[h																				//
//				-1 : G[																					//
//==============================================================================================================//
AJCEXPORT	EAJCCMPMODE	WINAPI	AjcSplGetCompMode(HAJCSPL pW)
{
	EAJCCMPMODE	rc = (EAJCCMPMODE)-1;

	if (IS_MY_INST(pW)) {
		rc = pW->CmpMode;
	}
	return rc;
}

//==============================================================================================================//
//	o^																									//
//																												//
//	@	F	pW				-	v[nh														//
//				pStr			-	o^镶																//
//																												//
//	߂l	F	 NULLFnjio^̃AhXj														//
//				 NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_BCP		WINAPI	AjcSplRegistA(HAJCSPL pW, C_BCP pStr)
{
	C_BCP	rc = NULL;

	if (IS_MY_INST(pW) && pStr != NULL) {
		rc = (C_BCP)AjcAvlInsOrGetStrNodeA(pW->hAvlStr, pStr);
	}
	return	rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_WCP		WINAPI	AjcSplRegistW(HAJCSPL pW, C_WCP pStr)
{
	C_WCP	rc = NULL;

	if (IS_MY_INST(pW) && pStr != NULL) {
		rc = (C_WCP)AjcAvlInsOrGetStrNodeW(pW->hAvlStr, pStr);
	}
	return	rc;
}
//==============================================================================================================//
//	񌟍																									//
//																												//
//	@	F	pW				-	v[nh														//
//				pStr			-	镶																//
//																												//
//	߂l	F	 NULLFnji̃AhXj														//
//				 NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_BCP		WINAPI	AjcSplFindA  (HAJCSPL pW, C_BCP pStr)
{
	C_BCP	rc = NULL;

	if (IS_MY_INST(pW) && pStr != NULL) {
		rc = (C_BCP)AjcAvlGetNodePtr(pW->hAvlStr, (UX)pStr, NULL);
	}
	return	rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_WCP		WINAPI	AjcSplFindW  (HAJCSPL pW, C_WCP pStr)
{
	C_WCP	rc = NULL;

	if (IS_MY_INST(pW) && pStr != NULL) {
		rc = (C_WCP)AjcAvlGetNodePtr(pW->hAvlStr, (UX)pStr, NULL);
	}
	return	rc;
}
//==============================================================================================================//
//	v[畔܂ރm[h																//
//																												//
//	@	F	pW				-	v[nh														//
//				pPartStr		-	镔															//
//																												//
//	߂l	F	 NULLFnjim[hij̃AhXj											//
//				 NULLF܂ރm[hȂ^G[											//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
typedef struct {
	BOOL			fDistinguish;
	AJCSPL_INSTROPT	opt;
	C_BCP			pNode;
	C_BCP			pPartStr;
} CBP_PARTSTR_IN_POOLA, *PCBP_PARTSTR_IN_POOLA;
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CALLBACK cbSplPartStrInPoolA(C_BCP pStr, UX cbp)
{
	BOOL					rc	= TRUE;
	PCBP_PARTSTR_IN_POOLA	p	= (PCBP_PARTSTR_IN_POOLA)cbp;
	int						rsu = FALSE;

	//	擪v`FbN
	if (p->opt == AJCSPL_ISP_MATCHFIRST) {
		int lPart = (int)strlen(p->pPartStr);
		int	lStr  = (int)strlen(pStr);
		if (lStr >= lPart) {
			if (p->fDistinguish) rsu = (strncmp (pStr, p->pPartStr, lPart) == 0);
			else				 rsu = (strnicmp(pStr, p->pPartStr, lPart) == 0);
		}
	}
	//	ܗL`FbN
		if (p->fDistinguish) rsu = (mbsstr (pStr, p->pPartStr) != NULL);
		else				 rsu = (mbsistr(pStr, p->pPartStr) != NULL);
	//	vȂ΁A߂lݒ肵I
	if (rsu) {
		p->pNode = pStr;
		rc = FALSE;
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	C_BCP		WINAPI	AjcSplPartStrInPoolA(HAJCSPL pW, C_BCP pPartStr, AJCSPL_INSTROPT opt)
{
	C_BCP			rc = NULL;
	CBP_PARTSTR_IN_POOLA cbp;

	if (IS_MY_INST(pW) && pPartStr != NULL) {
		cbp.fDistinguish = pW->fDistinguish;
		cbp.opt 		 = opt;
		cbp.pNode		 = NULL;
		cbp.pPartStr	 = pPartStr;
		AjcSplEnumStrA(pW, (UX)&cbp, cbSplPartStrInPoolA, FALSE);
		rc = cbp.pNode;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
typedef struct {
	BOOL			fDistinguish;
	AJCSPL_INSTROPT	opt;
	C_WCP			pNode;
	C_WCP			pPartStr;
} CBP_PARTSTR_IN_POOLW, *PCBP_PARTSTR_IN_POOLW;
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CALLBACK cbSplPartStrInPoolW(C_WCP pStr, UX cbp)
{
	BOOL					rc	= TRUE;
	PCBP_PARTSTR_IN_POOLW	p	= (PCBP_PARTSTR_IN_POOLW)cbp;
	int						rsu = FALSE;

	//	擪v`FbN
	if (p->opt == AJCSPL_ISP_MATCHFIRST) {
		int lPart = (int)wcslen(p->pPartStr);
		int	lStr  = (int)wcslen(pStr);
		if (lStr >= lPart) {
			if (p->fDistinguish) rsu = (wcsncmp (pStr, p->pPartStr, lPart) == 0);
			else				 rsu = (wcsnicmp(pStr, p->pPartStr, lPart) == 0);
		}
	}
	//	ܗL`FbN
	else {
		if (p->fDistinguish) rsu = (wcsstr (pStr, p->pPartStr) != NULL);
		else				 rsu = (wcsistr(pStr, p->pPartStr) != NULL);
	}
	//	vȂ΁A߂lݒ肵I
	if (rsu) {
		p->pNode = (C_WCP)pStr;
		rc = FALSE;
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	C_WCP		WINAPI	AjcSplPartStrInPoolW(HAJCSPL pW, C_WCP pPartStr, AJCSPL_INSTROPT opt)
{
	C_WCP			rc = NULL;
	CBP_PARTSTR_IN_POOLW cbp;

	if (IS_MY_INST(pW)) {
		cbp.fDistinguish = pW->fDistinguish;
		cbp.opt 		 = opt;
		cbp.pNode		 = NULL;
		cbp.pPartStr	 = pPartStr;
		AjcSplEnumStrW(pW, (UX)&cbp, cbSplPartStrInPoolW, FALSE);
		rc = cbp.pNode;
	}
	return rc;
}
//==============================================================================================================//
//	v[̕v																			//
//																												//
//	@	F	pW		-	v[nh																//
//				pStr	-																					//
//				opt		-	IvV																		//
//								AJCSPL_ISP_MATCHFIRST : w蕶̐擪v[̂ꂩƈv	//
//								AJCSPL_ISP_INCLUDING  : w蕶񂪕v[̂ꂩ̕܂		//
//																												//
//	߂l	F	 NULLFnjim[hij̃AhXj										//
//				 NULLF͂̕܂łȂ^G[										//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
typedef struct {
	BOOL			fDistinguish;
	AJCSPL_INSTROPT	opt;
	C_BCP			pNode;
	C_BCP			pStr;
} CBP_POOLSTR_IN_STRA, *PCBP_POOLSTR_IN_STRA;
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CALLBACK cbPoolStrInStrA(C_BCP pPartStr, UX cbp)
{
	BOOL					rc	= TRUE;
	PCBP_POOLSTR_IN_STRA	p	= (PCBP_POOLSTR_IN_STRA)cbp;
	int						rsu = FALSE;

	//	擪v`FbN
	if (p->opt == AJCSPL_ISP_MATCHFIRST) {
		int lPart = (int)strlen(pPartStr);
		int	lStr  = (int)strlen(p->pStr);
		if (lStr >= lPart) {
			if (p->fDistinguish) rsu = (strncmp (p->pStr, pPartStr, lPart) == 0);
			else				 rsu = (strnicmp(p->pStr, pPartStr, lPart) == 0);
		}
	}
	//	ܗL`FbN
	else {
		if (p->fDistinguish) rsu = (mbsstr (p->pStr, pPartStr) != NULL);
		else				 rsu = (mbsistr(p->pStr, pPartStr) != NULL);
	}
	//	vȂ΁A߂lݒ肵I
	if (rsu) {
		p->pNode = (C_BCP)pPartStr;
		rc = FALSE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	C_BCP		WINAPI	AjcSplPoolStrInStrA(HAJCSPL pW, C_BCP pStr, AJCSPL_INSTROPT opt)
{
	C_BCP			rc = NULL;
	CBP_POOLSTR_IN_STRA cbp;

	if (IS_MY_INST(pW)) {
		cbp.fDistinguish = pW->fDistinguish;
		cbp.opt 		 = opt;
		cbp.pNode		 = NULL;
		cbp.pStr		 = pStr;
		AjcSplEnumStrA(pW, (UX)&cbp, cbPoolStrInStrA, FALSE);
		rc = cbp.pNode;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
typedef struct {
	BOOL			fDistinguish;
	AJCSPL_INSTROPT	opt;
	C_WCP			pNode;
	C_WCP			pStr;
} CBP_POOLSTR_IN_STRW, *PCBP_POOLSTR_IN_STRW;
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CALLBACK cbPoolStrInStrW(C_WCP pPartStr, UX cbp)
{
	BOOL					rc	= TRUE;
	PCBP_POOLSTR_IN_STRW	p	= (PCBP_POOLSTR_IN_STRW)cbp;
	int						rsu = FALSE;

	//	擪v`FbN
	if (p->opt == AJCSPL_ISP_MATCHFIRST) {
		int lPart = (int)wcslen(pPartStr);
		int	lStr  = (int)wcslen(p->pStr);
		if (lStr >= lPart) {
			if (p->fDistinguish) rsu = (wcsncmp (p->pStr, pPartStr, lPart) == 0);
			else				 rsu = (wcsnicmp(p->pStr, pPartStr, lPart) == 0);
		}
	}
	//	ܗL`FbN
	else {
		if (p->fDistinguish) rsu = (wcsstr (p->pStr, pPartStr) != NULL);
		else				 rsu = (wcsistr(p->pStr, pPartStr) != NULL);
	}
	//	vȂ΁A߂lݒ肵I
	if (rsu) {
		p->pNode = pPartStr;
		rc = FALSE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	C_WCP		WINAPI	AjcSplPoolStrInStrW(HAJCSPL pW, C_WCP pStr, AJCSPL_INSTROPT opt)
{
	C_WCP			rc = NULL;
	CBP_POOLSTR_IN_STRW cbp;

	if (IS_MY_INST(pW)) {
		cbp.fDistinguish = pW->fDistinguish;
		cbp.opt 		 = opt;
		cbp.pNode		 = NULL;
		cbp.pStr		 = pStr;
		AjcSplEnumStrW(pW, (UX)&cbp, cbPoolStrInStrW, FALSE);
		rc = cbp.pNode;
	}
	return rc;
}
//==============================================================================================================//
//	폜																									//
//																												//
//	@	F	pW				-	v[nh														//
//				pStr			-	镶																//
//																												//
//	߂l	F	 NULLFnji̃AhXj														//
//				 NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcSplRemoveA  (HAJCSPL pW, C_BCP pStr)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pStr != NULL) {
		rc = AjcAvlDelNode(pW->hAvlStr, (UX)pStr);
	}
	return	rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcSplRemoveW  (HAJCSPL pW, C_WCP pStr)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && pStr != NULL) {
		rc = AjcAvlDelNode(pW->hAvlStr, (UX)pStr);
	}
	return	rc;
}
//==============================================================================================================//
//	o^ϕ̌擾																						//
//																												//
//	@	F	pW				-	v[nh														//
//																												//
//	߂l	F	o^ϕ̌																				//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcSplGetCount (HAJCSPL pW)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		rc = AjcAvlGetCount(pW->hAvlStr);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcSplNumber (HAJCSPL pW)
{
	return AjcSplGetCount(pW);
}

//==============================================================================================================//
//	Zbgiv[̑Sm[hjj																		//
//																												//
//	@	F	pW				-	v[nh														//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcSplReset (HAJCSPL pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AjcAvlDelAllNodes(pW->hAvlStr);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	o^ςݑS擾																						//
//																												//
//	@	F	pW				-	v[nh														//
//				cbp				-	R[obNp^														//
//				cbNtcStr		-	ʒmpR[obN֐isv͂mtkkj							//
//				fDownSeq		-	ǂݏo̎wiFALSE:CTRUEF~j							//
//																												//
//	߂l	F	񐔁iG[͂OԂj																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
typedef struct {
	UX		cbp;
	BOOL (CALLBACK *cb)(C_BCP pStr, UX cbp);
} CBP_SPLENUMSTRA, *PCBP_SPLENUMSTRA;
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CALLBACK cbSplEnumStrA(UX key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	BOOL				rc = TRUE;
	PCBP_SPLENUMSTRA	p  = (PCBP_SPLENUMSTRA)cbp;
	if (p->cb != NULL) {
		rc = p->cb((C_BCP)pNodeData, p->cbp);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcSplEnumStrA(HAJCSPL pW, UX cbp, BOOL (CALLBACK *cbNtcStr)(C_BCP pStr, UX cbp), BOOL fDownSeq)
{
	UI				rc = 0;
	CBP_SPLENUMSTRA	prm;

	if (IS_MY_INST(pW)) {
		prm.cbp = cbp;
		prm.cb	= cbNtcStr;
		rc = AjcAvlEnumNodesEx(pW->hAvlStr, (UX)&prm, cbSplEnumStrA, fDownSeq);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
typedef struct {
	UX		cbp;
	BOOL (CALLBACK *cb)(C_WCP pStr, UX cbp);
} CBP_SPLENUMSTRW, *PCBP_SPLENUMSTRW;
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	CALLBACK cbSplEnumStrW(UX key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	BOOL				rc = TRUE;
	PCBP_SPLENUMSTRW	p  = (PCBP_SPLENUMSTRW)cbp;
	if (p->cb != NULL) {
		rc = p->cb((C_WCP)pNodeData, p->cbp);
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcSplEnumStrW(HAJCSPL pW, UX cbp, BOOL (CALLBACK *cbNtcStr)(C_WCP pStr, UX cbp), BOOL fDownSeq)
{
	UI				rc = 0;
	CBP_SPLENUMSTRW	prm;

	if (IS_MY_INST(pW)) {
		prm.cbp = cbp;
		prm.cb	= cbNtcStr;
		rc = AjcAvlEnumNodesEx(pW->hAvlStr, (UX)&prm, cbSplEnumStrW, fDownSeq);
	}
	return rc;
}
//==============================================================================================================//
//	`ukQ؂̃nh擾																					//
//																												//
//	@	F	pW				-	v[nh														//
//																												//
//	߂l	F	 NULLFnji`ukQ؂̃nhj															//
//				 NULLFG[																					//
//==============================================================================================================//
AJCEXPORT	HAJCAVL		WINAPI	AjcSplGetAvlHandle(HAJCSPL pW)
{
	HAJCAVL		rc = NULL;

	if (IS_MY_INST(pW)) {
		rc = pW->hAvlStr;
	}
	return rc;
}


