#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	񑀍																									//
//																												//
//**************************************************************************************************************//

//--------------------------------------------------------------------------------------------------------------//
//	r|ihrCdtbR[h͈																			//
//--------------------------------------------------------------------------------------------------------------//
//----- rihr PoCgڂ̃R[h͈ ------------------------------------------------------------------------//
#define	SJH1_L		0x81
#define	SJH1_H		0x9F
#define	SJH2_L		0xE0
#define	SJH2_H		0xFC

#define	SJH1_NUM	(SJH1_H - SJH1_L + 1)
#define	SJH2_NUM	(SJH2_H - SJH2_L + 1)
#define	SJH_NUM		(SJH1_NUM + SJH2_NUM)

//----- rihr QoCgڂ̃R[h͈ ------------------------------------------------------------------------//
#define	SJL1_L		0x40
#define	SJL1_H		0x7E
#define	SJL2_L		0x80
#define	SJL2_H		0xFC

#define	SJL1_NUM	(SJL1_H - SJL1_L + 1)
#define	SJL2_NUM	(SJL2_H - SJL2_L + 1)
#define	SJL_NUM		(SJL1_NUM + SJL2_NUM)

//----- dtb̃R[h͈ -------------------------------------------------------------------------------------//
#define	EUC_3BYTE	0x8F
#define	EUC_KANA	0x8E
#define	EUC_L		0xA1
#define	EUC_H		0xFE

#define	EUC_NUM		(EUC_H - EUC_L + 1)

//----- pJ^JĩR[h͈ -------------------------------------------------------------------------------//
#define	KANA_L		0xA1
#define	KANA_H		0xDF

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
//----- Ή͂ݕ擾 -----------------------------------------------------------------------------------//
static	BC	GetEncloseCharA(UB cl)
{
	BC	cr;

	switch (cl) {
		case '<':	cr = '>'; break;
		case '(':	cr = ')'; break;
		case '[':	cr = ']'; break;
		case '{':	cr = '}'; break;
		default:	cr = cl;  break;
	}
	return cr;
}
//--------------------------------------------------------------------------------------------------------------//
static	UW	GetEncloseCharW(UW cl)
{
	UW	cr;

	switch (cl) {
		case L'<':	cr = L'>';	break;
		case L'(':	cr = L')';	break;
		case L'[':	cr = L']';	break;
		case L'{':	cr = L'}';	break;
		case L'':	cr = L'';	break;
		case L'i':	cr = L'j';	break;
		case L'm':	cr = L'n';	break;
		case L'o':	cr = L'p';	break;
		case L'u':	cr = L'v';	break;
		case L'k':	cr = L'l';	break;
		case L's':	cr = L't';	break;
		case L'w':	cr = L'x';	break;
		case L'y':	cr = L'z';	break;
		default:	cr = cl;	break;
	}
	return cr;
}

//==============================================================================================================//
//	Function	:	r@w肵ĕriPoCgrj									//
//																												//
//	Argument	:	s1 - P̃AhX																		//
//					s2 - Q̃AhXi镔j												//
//					CmpMode - r@																	//
//																												//
//	Return		:	mtkkF̃AhX														//
//					mtkkFw肳ꂽ͌Ȃ												//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcStrCmpExA(C_BCP pStr1, C_BCP pStr2, EAJCCMPMODE CmpMode)
{
	int		rc = 0;

	switch (CmpMode) {
		default: // AJCCMP_RECOGNIZE_WIDTH
			rc = mbscmp(pStr1, pStr2);
			break;

		case AJCCMP_IGNORE_WIDTH:
			rc = mbsicmp(pStr1, pStr2);
			break;

		case AJCCMP_ALPHABETIC:
			if ((rc = mbsicmp(pStr1, pStr2)) == 0) {
				rc = mbscmp(pStr1, pStr2);
			}
			break;
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcStrCmpExW(C_WCP pStr1, C_WCP pStr2, EAJCCMPMODE CmpMode)
{
	int		rc = 0;

	switch (CmpMode) {
		default: // AJCCMP_RECOGNIZE_WIDTH
			rc = wcscmp(pStr1, pStr2);
			break;

		case AJCCMP_IGNORE_WIDTH:
			rc = wcsicmp(pStr1, pStr2);
			break;

		case AJCCMP_ALPHABETIC:
			if ((rc = wcsicmp(pStr1, pStr2)) == 0) {
				rc = wcscmp(pStr1, pStr2);
			}
			break;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	r@w肵ĕiPoCgrj								//
//																												//
//	Argument	:	s1 - P̃AhX																		//
//					s2 - Q̃AhXi镔j												//
//					fIgnoreWidth - r@(FALSE:p召ʂCTRUE:	p召ʂȂj			//
//																												//
//	Return		:	mtkkF̃AhX														//
//					mtkkFw肳ꂽ͌Ȃ												//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrStrExA(C_BCP s1, C_BCP s2, BOOL fIgnoreWidth)
{
	BCP		rc = NULL;

	if (fIgnoreWidth) rc = AjcStrIStrA(s1, s2);
	else			  rc = (BCP)strstr(s1, s2);

	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrStrExW(C_WCP s1, C_WCP s2, BOOL fIgnoreWidth)
{
	WCP		rc = NULL;

	if (fIgnoreWidth) rc = AjcStrIStrW(s1, s2);
	else			  rc = (WCP)wcsstr(s1, s2);

	return rc;
}
//==============================================================================================================//
//	Function	:	p召ʂ													//
//																												//
//	Argument	:	s1 - P̃AhX																		//
//					s2 - Q̃AhXi镔j												//
//																												//
//	Return		:	mtkkF̃AhX														//
//					mtkkFw肳ꂽ͌Ȃ												//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrIStrA(C_BCP s1, C_BCP s2)
{
	BCP		rc = NULL;
	C_BCP	p  = s1;
	int		l1;
	int		l2;
	int		n;

	if (s1 != NULL && s2 != NULL) {
		l1 = (int)strlen(s1);
		l2 = (int)strlen(s2);
		if		(l2 == 0) {
			rc = (BCP)s1;
		}
		else if (l1 >= l2) {
			n = l1 - l2;
			while (n >= 0) {
				if (strnicmp(p, s2, l2) == 0) {
					rc = (BCP)p;
					break;
				}
				p++;
				n--;
			}
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrIStrW(C_WCP s1, C_WCP s2)
{
	WCP		rc = NULL;
	C_WCP	p = s1;
	int		l1 = (int)wcslen(s1);
	int		l2 = (int)wcslen(s2);
	int		n;

	if (s1 != NULL && s2 != NULL) {
		if		(l2 == 0) {
			rc = (WCP)s1;
		}
		else if (l1 >= l2) {
			n = l1 - l2;
			while (n >= 0) {
				if (wcsnicmp(p, s2, l2) == 0) {
					rc = (WCP)p;
					break;
				}
				p++;
				n--;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	r@w肵ĕi}`oCgrj							//
//																												//
//	Argument	:	s1 - P̃AhX																		//
//					s2 - Q̃AhXi镔j												//
//					fIgnoreWidth - r@(FALSE:p召ʂCTRUE:	p召ʂȂj			//
//																												//
//	Return		:	mtkkF̃AhX														//
//					mtkkFw肳ꂽ͌Ȃ												//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcMbsStrExA(C_BCP s1, C_BCP s2, BOOL fIgnoreWidth)
{
	BCP		rc = NULL;

	if (fIgnoreWidth) rc = AjcMbsIStrA(s1, s2);
	else			  rc = (BCP)strstr(s1, s2);

	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcMbsStrExW(C_WCP s1, C_WCP s2, BOOL fIgnoreWidth)
{
	WCP		rc = NULL;

	if (fIgnoreWidth) rc = AjcStrIStrW(s1, s2);
	else			  rc = (WCP)wcsstr(s1, s2);

	return rc;
}
//==============================================================================================================//
//	Function	:	p召ʂi}`oCgpj									//
//																												//
//	Argument	:	p - P̃AhX																		//
//					q - Q̃AhX																		//
//																												//
//	Return		:	mtkkF̃AhX														//
//					mtkkFw肳ꂽ͌Ȃ												//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcMbsIStrA(C_BCP s1, C_BCP s2)
{
	BCP		rc = NULL;
	C_BCP	p  = s1;
	int		l1;
	int		l2;
	int		n;

	if (s1 != NULL && s2 != NULL) {
		l1 = (int)mbslen(s1);
		l2 = (int)mbslen(s2);
		if		(l2 == 0) {
			rc = (BCP)s1;
		}
		else if (l1 >= l2) {
			n = l1 - l2;
			while (n >= 0) {
				if (mbsnicmp(p, s2, l2) == 0) {
					rc = (BCP)p;
					break;
				}
				if (_ismbblead(*p) && _ismbbtrail(*(p + 1))) p += 2;
				else										 p++;
				n--;
			}
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcMbsIStrW(C_WCP s1, C_WCP s2)
{
	return AjcStrIStrW(s1, s2);
}
 
//==============================================================================================================//
//	̃g[N																					//
//																												//
//	@	F	pBuf - 𐶐obt@̃AhX														//
//				pDlm - 𐶐obt@̕															//
//																												//
//	߂l	F	 NULL - g[Nւ̃|C^																	//
//				 NULL - g[N																			//
//==============================================================================================================//
__declspec(thread) static BCP bpStrTokPtr = NULL;
__declspec(thread) static WCP wpStrTokPtr = NULL;

//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP	WINAPI	AjcStrTokA(BCP pStr, C_BCP pDlm)
{
	BCP		rc = NULL;

	rc = strtok_s(pStr, pDlm, &bpStrTokPtr);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrTokW(WCP pStr, C_WCP pDlm)
{
	WCP		rc = NULL;

	rc = wcstok_s(pStr, pDlm, &wpStrTokPtr);

	return rc;
}
//==============================================================================================================//
//	}`oCg̃g[N																		//
//																												//
//	@	F	pBuf - 𐶐obt@̃AhX														//
//				pDlm - 𐶐obt@̕															//
//																												//
//	߂l	F	 NULL - g[Nւ̃|C^																	//
//				 NULL - g[N																			//
//==============================================================================================================//
__declspec(thread) static UBP bpMbsTokPtr = NULL;
__declspec(thread) static WCP wpMbsTokPtr = NULL;

//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP	WINAPI	AjcMbsTokA(BCP pMbc, C_BCP pDlm)
{
	BCP		rc = NULL;

	rc = _mbstok_s((UBP)pMbc, (UBP)pDlm, &bpMbsTokPtr);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcMbsTokW(WCP pMbc, C_WCP pDlm)
{
	WCP		rc = NULL;

	rc = wcstok_s(pMbc, pDlm, &wpMbsTokPtr);

	return rc;
}
//==============================================================================================================//
//	Function	:	؂蕶ŋ؂ꂽ̎̃g[N擾											//
//																												//
//	Argument	:	pStr - g[No镶																//
//					pDlm - ؂蕶Q																			//
//					pEnc - ͂ݕQi͂ݕꍇNULL)												//
//																												//
//	Return		:	mtkkFg[ÑAhX													//
//					mtkkFg[N																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
__declspec(thread) static BCP pStrTokTopA = NULL;

AJCEXPORT	BCP		WINAPI	AjcStrTokExA(BCP pStr, C_BCP pDlm, C_BCP pEnc)
{
	BCP		rc = NULL;
	BC		ce;

	//	NULLwȂ΁AO̎̃g[NAhXݒ
	if (pStr == NULL) pStr = pStrTokTopA;

	if (pStr != NULL && *pStr != 0) {
		//	߂lg[N擪
		rc = pStr;
		//	g[Nݒ
		while (*pStr != 0) {
			//	؂蕶Ȃ΁AI[ݒ
			if (pDlm != NULL && strchr(pDlm, *pStr) != NULL) {
				*pStr++ = 0;
				break;
			}
			//	؂蕶ȊOȂ΁A^͂ݕXLbv
			else {
				//	͂ݕȂ΁A͂ݕXLbv
				if (pEnc != NULL && strchr(pEnc, *pStr) != NULL) {
					//	͂ݏI[擾
					ce = GetEncloseCharA(*pStr);
					//	͂ݕXLbv
					if (_ismbblead(*pStr) && _ismbbtrail(*(pStr + 1))) pStr += 2;
					else											   pStr += 1;
					//	͂ݕI[
					while (*pStr != ce && *pStr != 0) {
						if (_ismbblead(*pStr) && _ismbbtrail(*(pStr + 1))) pStr += 2;
						else											   pStr += 1;
					}
					//	͂ݕI[Ȃ΁A͂ݏI[XLbv
					if (*pStr == ce) {
						pStr++;
					}
					//	I[Ȃ΁AI
					else {
						break;
					}
				}
				//	͂ݕȊOȂ΁AYXLbv
				else {
					pStr++;
				}
			}
		}
		//	̃g[NAhXݒ
		if (pDlm != NULL) {
			while (*pStr != 0 && strchr(pDlm, *pStr) != NULL) {
				pStr++;
			}
		}
		pStrTokTopA = pStr;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
__declspec(thread) static WCP pStrTokTopW = NULL;

AJCEXPORT	WCP		WINAPI	AjcStrTokExW(WCP pStr, C_WCP pDlm, C_WCP pEnc)
{
	WCP		rc = NULL;
	WC		ce;

	//	NULLwȂ΁AO̎̃g[NAhXݒ
	if (pStr == NULL) pStr = pStrTokTopW;

	if (pStr != NULL && *pStr != 0) {
		//	߂lg[N擪
		rc = pStr;
		//	g[Nݒ
		while (*pStr != 0) {
			//	؂蕶Ȃ΁AI[ݒ
			if (pDlm != NULL && wcschr(pDlm, *pStr) != NULL) {
				*pStr++ = 0;
				break;
			}
			//	؂蕶ȊOȂ΁A^͂ݕXLbv
			else {
				//	͂ݕȂ΁A͂ݕXLbv
				if (pEnc != NULL && wcschr(pEnc, *pStr) != NULL) {
					//	͂ݏI[擾
					ce = GetEncloseCharW(*pStr);
					//	͂ݕXLbv
					pStr++;
					//	͂ݕI[
					while (*pStr != ce && *pStr != 0) {
						pStr++;
					}
					//	͂ݕI[Ȃ΁A͂ݏI[XLbv
					if (*pStr == ce) {
						pStr++;
					}
					//	I[Ȃ΁AI
					else {
						break;
					}
				}
				//	͂ݕȊOȂ΁AYXLbv
				else {
					pStr++;
				}
			}
		}
		//	̃g[NAhXݒ
		if (pDlm != NULL) {
			while (*pStr != 0 && wcschr(pDlm, *pStr) != NULL) {
				pStr++;
			}
		}
		pStrTokTopW = pStr;
	}
	return rc;
}
//==============================================================================================================//
//	w蕶ň͂ށi񒆂́uw蕶v '\' ̒Oɂ'\'tj							//
//																												//
//	@	F	pStr  - \[X̃AhX																	//
//				pBuf  - ͂ݕň͂񂾕i[obt@̃AhXisvNULL)				//
//						upBuf=NULLvƂꍇ́A͂ݕt̕EZos܂B					//
//				lBuf  - ͂ݕň͂񂾕i[obt@̕								//
//				c	  - ͂ޕiʓ̏ꍇ́A̕w(E)BO^͎wsBj	//
//																												//
//	߂l	F	O - OKi͂ݕt̕j													//
//				O - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcStrEncloseA(C_BCP pStr, BCP pBuf, UI lBuf, UI c)
{
	UI		rc	= TRUE;
	UI		len = 0;
	BC		cl, cr;

	if (pStr != NULL) {
		//----- ͂ݕݒ ---------------------------------------------------------------------------------------//
		cl = c;
		cr = GetEncloseCharA(cl);
		if (cl == '\\' || cl == 0) rc = FALSE;
		//----- 擪̈͂ݕݒ ---------------------------------------------------------------------------------//
		if (pBuf != NULL  &&  lBuf > 1) {
			*pBuf++ = cl;
			lBuf--;
		}
		else if (pBuf != NULL) rc = FALSE;
		len++;
		//----- ] -----------------------------------------------------------------------------------------//
		while (*pStr != 0) {
			if (_ismbblead(*pStr) && _ismbbtrail(*(pStr + 1))) {
				if (pBuf != NULL  &&  lBuf > 2) {
					memcpy(pBuf, pStr, 2);
					pBuf += 2;
					lBuf -= 2;
				}
				else if (pBuf != NULL) rc = FALSE;
				pStr += 2;
				len  += 2;
			}
			else if (*pStr == cr || *pStr == '\\') {
				if (pBuf != NULL  &&  lBuf > 2) {
					*pBuf++ = '\\';
					*pBuf++ = *pStr;
					lBuf -= 2;
				}
				else if (pBuf != NULL) rc = FALSE;
				pStr++;
				len += 2;
			}
			else {
				if (pBuf != NULL  &&  lBuf > 1) {
					*pBuf++ = *pStr;
					lBuf--;
				}
				else if (pBuf != NULL) rc = FALSE;
				pStr++;
				len++;
			}
		}
		//----- ̈͂ݕݒ ---------------------------------------------------------------------------------//
		if (pBuf != NULL  &&  lBuf > 1) {
			*pBuf++ = cr;
			lBuf--;
		}
		else if (pBuf != NULL) rc = FALSE;
		len++;
		//----- I[ݒ -------------------------------------------------------------------------------------//
		if (pBuf != NULL  &&  lBuf >= 1) {
			*pBuf = 0;
		}
		else if (pBuf != NULL) rc = FALSE;
		//----- ߂lݒ -----------------------------------------------------------------------------------------//
		if (rc != FALSE) {
			rc = len;
		}
	}
	else rc = 0;

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcStrEncloseW(C_WCP pStr, WCP pBuf, UI lBuf, UI c)
{
	BOOL	rc	= TRUE;
	int		len = 0;
	UW		cl, cr;

	if (pStr != NULL) {
		//----- ͂ݕݒ ---------------------------------------------------------------------------------------//
		cl = c;
		cr = GetEncloseCharW(cl);
		if (cl == L'\\' || cl == 0) rc = FALSE;
		//----- 擪̈͂ݕݒ ---------------------------------------------------------------------------------//
		if (pBuf != NULL  &&  lBuf > 1) {
			*pBuf++ = cl;
			lBuf--;
		}
		else if (pBuf != NULL) rc = FALSE;
		len++;
		//----- ] -----------------------------------------------------------------------------------------//
		while (*pStr != 0) {
			if (*pStr == cr  ||  *pStr == L'\\') {
				if (pBuf != NULL  &&  lBuf > 2) {
					*pBuf++ = L'\\';
					*pBuf++ = *pStr;
					lBuf -= 2;
				}
				else if (pBuf != NULL) rc = FALSE;
				pStr++;
				len += 2;
			}
			else {
				if (pBuf != NULL  &&  lBuf > 1) {
					*pBuf++ = *pStr;
					lBuf--;
				}
				else if (pBuf != NULL) rc = FALSE;
				pStr++;
				len++;
			}
		}
		//----- ̈͂ݕݒ ---------------------------------------------------------------------------------//
		if (pBuf != NULL  &&  lBuf > 1) {
			*pBuf++ = cr;
			lBuf--;
		}
		else if (pBuf != NULL) rc = FALSE;
		len++;
		//----- I[ݒ -------------------------------------------------------------------------------------//
		if (pBuf != NULL  &&  lBuf >= 1) {
			*pBuf = 0;
		}
		else if (pBuf != NULL) rc = FALSE;
		//----- ߂lݒ -----------------------------------------------------------------------------------------//
		if (rc != FALSE) {
			rc = len;
		}
	}
	else rc = 0;

	return rc;
}
//==============================================================================================================//
//	̈͂ݕ菜																					//
//																												//
//	@	F	pStr  - ͂ݕ菜̃AhX														//
//																												//
//	߂l	F	NULL - ͂ݕ̎̃̕AhX															//
//				NULL - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrStripEncloseA(BCP pStr)
{
	BCP		rc = NULL;
	BCP		pDes;
	BC		cl, cr;

	do {
		if (pStr  == NULL ) break;		//	NULL
		if (*pStr == 0	  ) break;		//	󕶎
		if (*pStr == '\\' ) break;		//	͂ݕ
		if (_ismbblead(*pStr) ) break;	//	擪͑Sp

		cl = *pStr;
		cr = GetEncloseCharA(cl);

		pDes = pStr++;
		while (*pStr != cr	&&	*pStr != 0) {
			if (_ismbblead(*pStr) && _ismbbtrail(*(pStr + 1))) {
				*pDes++ = *pStr++;
				*pDes++ = *pStr++;
			}
			else if (*pStr == '\\') {
				pStr++;
				if (*pStr != 0) {
					*pDes++ = *pStr++;
				}
			}
			else {
				*pDes++ = *pStr++;
			}
		}
		*pDes = 0;
		if (*pStr == cr) rc = pStr + 1;
		else			 rc = pStr;

	} while(0);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrStripEncloseW(WCP pStr)
{
	WCP		rc = NULL;
	WCP		pDes;
	UW		cl, cr;

	do {
		if (pStr  == NULL ) break;	//	NULL
		if (*pStr == 0	  ) break;	//	󕶎
		if (*pStr == L'\\') break;	//	͂ݕ

		cl = *pStr;
		cr = GetEncloseCharW(cl);

		pDes = pStr++;
		while (*pStr != cr	&&	*pStr != 0) {
			if (*pStr == L'\\') {
				pStr++;
				if (*pStr != 0) {
					*pDes++ = *pStr++;
				}
			}
			else {
				*pDes++ = *pStr++;
			}
		}
		*pDes = 0;
		if (*pStr == cr) rc = pStr + 1;
		else			 rc = pStr;

	} while(0);

	return rc;
}

//==============================================================================================================//
//	񐶐																								//
//																												//
//	@	F	pBuf - 𐶐obt@̃AhX														//
//				lBuf - 𐶐obt@̕															//
//				pFmt - 																				//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Erroriobt@I[o[j																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcSnPrintFA(BCP pBuf, UI lBuf, C_BCP pFmt, ...)
{
	BOOL	rc = TRUE;
	va_list vls;

	if (pBuf != NULL && lBuf != 0 && pFmt != NULL) {
		if (lBuf != 0) {
			pBuf[lBuf - 1] = 0;
			va_start(vls, pFmt);
			_vsnprintf(pBuf, lBuf, pFmt, vls);
			va_end	(vls);
			if (pBuf[lBuf - 1] != 0) {
				pBuf[lBuf - 1] = 0;
				rc = FALSE;
			}
		}
	}
	else rc = FALSE;

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcSnPrintFW(WCP pBuf, UI lBuf, C_WCP pFmt, ...)
{
	BOOL	rc = TRUE;
	va_list vls;

	if (pBuf != NULL && lBuf != 0 && pFmt != NULL) {
		if (lBuf != 0) {
			pBuf[lBuf - 1] = 0;
			va_start(vls, pFmt);
			_vsnwprintf(pBuf, lBuf, pFmt, vls);
			va_end	(vls);
			if (pBuf[lBuf - 1] != 0) {
				pBuf[lBuf - 1] = 0;
				rc = FALSE;
			}
		}
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	񐶐iva_listwj																				//
//																												//
//	@	F	pBuf - 𐶐obt@̃AhX														//
//				lBuf - 𐶐obt@̕															//
//				pFmt - 																				//
//				vls  - σp^ւ̃|C^																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Erroriobt@I[o[j																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcVSnPrintFA(BCP pBuf, UI lBuf, C_BCP pFmt, va_list vls)
{
	BOOL	rc = TRUE;

	if (pBuf != NULL && lBuf != 0 && pFmt != NULL) {
		if (lBuf != 0) {
			pBuf[lBuf - 1] = 0;
			_vsnprintf(pBuf, lBuf, pFmt, vls);
			if (pBuf[lBuf - 1] != 0) {
				pBuf[lBuf - 1] = 0;
				rc = FALSE;
			}
		}
	}
	else rc = FALSE;

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcVSnPrintFW(WCP pBuf, UI lBuf, C_WCP pFmt, va_list vls)
{
	BOOL	rc = TRUE;

	if (pBuf != NULL && lBuf != 0 && pFmt != NULL) {
		if (lBuf != 0) {
			pBuf[lBuf - 1] = 0;
			_vsnwprintf(pBuf, lBuf, pFmt, vls);
			if (pBuf[lBuf - 1] != 0) {
				pBuf[lBuf - 1] = 0;
				rc = FALSE;
			}
		}
	}
	else rc = FALSE;

	return rc;
}

//==============================================================================================================//
//	񐶐ƂPOi̐Ŏw茅ɋ؂蕶}iP[QƁj				//
//																												//
//	@	F	pBuf - 𐶐obt@̃AhX														//
//				lBuf - 𐶐obt@̕															//
//				pFmt - 																				//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Erroriobt@I[o[j																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcSnPrtSepA(BCP pBuf, UI lBuf, C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;

	va_list vls;

	if (pBuf != NULL && pFmt != NULL) {
		if (lBuf != 0) {
			pBuf[lBuf - 1] = 0;
			va_start(vls, pFmt);
			_vsnprintf(pBuf, lBuf, pFmt, vls);
			va_end	(vls);
			if (pBuf[lBuf - 1] == 0) {
				rc = AjcStrSepDecimalA(pBuf, lBuf);
			}
			else {
				pBuf[lBuf - 1] = 0;
				rc = FALSE;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcSnPrtSepW(WCP pBuf, UI lBuf, C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;

	va_list vls;

	if (pBuf != NULL && pFmt != NULL) {
		if (lBuf != 0) {
			pBuf[lBuf - 1] = 0;
			va_start(vls, pFmt);
			_vsnwprintf(pBuf, lBuf, pFmt, vls);
			va_end	(vls);
			if (pBuf[lBuf - 1] == 0) {
				rc = AjcStrSepDecimalW(pBuf, lBuf);
			}
			else {
				pBuf[lBuf - 1] = 0;
				rc = FALSE;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	POi̐Ŏw茅ɋ؂蕶}iP[QƁj								//
//																												//
//	@	F	pStr - ؂蕶}POĩAhX												//
//				lBuf - ؂蕶}POiobt@̕											//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Erroriobt@I[o[j																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrSepDecimalA(BCP pStr, UI lBuf)
{
	BOOL	rc = FALSE;
	BC		cSep[64];
	BC		nSep[64];

	if (pStr != NULL) {
		do {
			if (GetLocaleInfoA(LOCALE_USER_DEFAULT, LOCALE_SLIST	, cSep, sizeof cSep) == 0) break;
			if (GetLocaleInfoA(LOCALE_USER_DEFAULT, LOCALE_SGROUPING, nSep, sizeof nSep) == 0) break;
			rc = AjcStrAnySepDecimalA(pStr, lBuf, cSep[0], atoi(nSep));
		} while(0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrSepDecimalW(WCP pStr, UI lBuf)
{
	BOOL	rc = FALSE;
	WC		cSep[64];
	WC		nSep[64];

	if (pStr != NULL) {
		do {
			if (GetLocaleInfoW(LOCALE_USER_DEFAULT, LOCALE_SLIST	, cSep, sizeof cSep / 2) == 0) break;
			if (GetLocaleInfoW(LOCALE_USER_DEFAULT, LOCALE_SGROUPING, nSep, sizeof nSep / 2) == 0) break;
			rc = AjcStrAnySepDecimalW(pStr, lBuf, cSep[0], _wtoi(nSep));
		} while(0);
	}
	return rc;
}
//==============================================================================================================//
//	POi̐Ŏw茅ɋ؂蕶}													//
//																												//
//	@	F	pStr - ؂蕶}POĩAhX												//
//				lBuf - ؂蕶}POiobt@̕											//
//				cSep - ؂蕶																				//
//				nSep - ؂茅iȌꍇ́A؂蕶}Ȃj											//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Erroriobt@I[o[j																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrAnySepDecimalA(BCP pStr, UI lBuf, UI cSep, UI nSep)
{
	BOOL	rc = TRUE;
	BCP		pBuf = pStr;
	UI		lStr;
	int		len, six, eix, mod;

	if (pStr != NULL && lBuf != 0) {
		do {
			//----- ؂茅Ȍꍇ́AIƂ -----------------------------------------------------//
			if (nSep == 0) break;
			//----- 񒷂ƁACfNXݒ -----------------------------------------------------------//
			lStr = (UI)strlen(pStr);
			six  = 0;
			eix  = lStr + 1;
			//----- 擪Xy[XXLbv -----------------------------------------------------------------------//
			while (MAjcIsBlankA(*pStr)) {
				pStr++; six++;
			}
			//----- XLbv -------------------------------------------------------------------------------//
			if (*pStr == '+' || *pStr == '-') {
				pStr++; six++;
			}
			//----- Zo -----------------------------------------------------------------------------//
			for (len = 0; _ismbcdigit(pStr[len]); len++);
			//----- ꍇ́AIƂ ---------------------------------------------------------//
			if (len == 0) break;
			//----- 擪XLbv -----------------------------------------------------------------------------//
			pStr++; six++; len--;
			//----- ŏ̋؂蕶}ʒu܂ŃXLbv -------------------------------------------------------//
			mod = (len % nSep);
			pStr += mod;
			six  += mod;
			len  -= mod;
			//----- obt@I[o[`FbN -------------------------------------------------------------------//
			if (lStr + (len / nSep) >= lBuf) {
				rc = FALSE;
				break;
			}
			//----- ؂蕶} -----------------------------------------------------------------------------//
			while (len > 0) {
				memmove(&pBuf[six + 1], &pBuf[six], eix - six);
				pBuf[six] = cSep;
				lStr++;
				six  += (nSep + 1);
				eix++;
				len  -= nSep;
			}
		} while(0);
	}
	else rc = FALSE;

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrAnySepDecimalW(WCP pStr, UI lBuf, UI cSep, UI nSep)
{
	BOOL	rc = TRUE;
	WCP		pBuf = pStr;
	UI		lStr;
	int		len, six, eix, mod;

	if (pStr != NULL && lBuf != 0) {
		do {
			//----- ؂茅Ȍꍇ́AIƂ -----------------------------------------------------//
			if (nSep == 0) break;
			//----- 񒷂ƁACfNXݒ -----------------------------------------------------------//
			lStr = (UI)wcslen(pStr);
			six  = 0;
			eix  = lStr + 1;
			//----- 擪Xy[XXLbv -----------------------------------------------------------------------//
			while (MAjcIsBlankW(*pStr)) {
				pStr++; six++;
			}
			//----- XLbv -------------------------------------------------------------------------------//
			if (*pStr == L'+' || *pStr == L'-') {
				pStr++; six++;
			}
			//----- Zo -----------------------------------------------------------------------------//
			for (len = 0; MAjcAscIsDigitW(pStr[len]); len++);
			//----- ꍇ́AIƂ ---------------------------------------------------------//
			if (len == 0) break;
			//----- 擪XLbv -----------------------------------------------------------------------------//
			pStr++; six++; len--;
			//----- ŏ̋؂蕶}ʒu܂ŃXLbv -------------------------------------------------------//
			mod = (len % nSep);
			pStr += mod;
			six  += mod;
			len  -= mod;
			//----- obt@I[o[`FbN -------------------------------------------------------------------//
			if (lStr + (len / nSep) >= lBuf) {
				rc = FALSE;
				break;
			}
			//----- ؂蕶} -----------------------------------------------------------------------------//
			while (len > 0) {
				memmove(&pBuf[six + 1], &pBuf[six], (eix - six) * 2);
				pBuf[six] = cSep;
				lStr++;
				six  += (nSep + 1);
				eix++;
				len  -= nSep;
			}
		} while(0);
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	POi̐؂蕶폜iP[QƁj											//
//																												//
//	@	F	pStr - ؂蕶폜POĩAhX												//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcStrRmvSepCharA(BCP pStr)
{
	BC		cSep[64];

	if (pStr != NULL) {
		if (GetLocaleInfoA(LOCALE_USER_DEFAULT, LOCALE_SLIST, cSep, sizeof cSep) != 0) {
			AjcStrAnyRmvSepCharA(pStr, cSep[0]);
		}
	}
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcStrRmvSepCharW(WCP pStr)
{
	WC		cSep[64];

	if (pStr != NULL) {
		if (GetLocaleInfoW(LOCALE_USER_DEFAULT, LOCALE_SLIST, cSep, sizeof cSep / 2) != 0) {
			AjcStrAnyRmvSepCharW(pStr, cSep[0]);
		}
	}
}
//==============================================================================================================//
//	POi̐؂蕶폜																//
//																												//
//	@	F	pStr - ؂蕶폜POĩAhX												//
//				cSep - ؂蕶																				//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcStrAnyRmvSepCharA(BCP pStr, UI cSep)
{
	BCP		pBuf = pStr;
	int		six, eix;

	if (pStr != NULL) {
		//----- 񒷂ƁACfNXݒ -----------------------------------------------------------//
		six  = 0;
		eix  = (UI)strlen(pStr) + 1;
		//----- 擪Xy[XXLbv -----------------------------------------------------------------------//
		while (MAjcIsBlankA((UB)*pStr)) {
			pStr++; six++;
		}
		//----- XLbv -------------------------------------------------------------------------------//
		if (*pStr == '+' || *pStr == '-') {
			pStr++; six++;
		}
		//----- ؂蕶폜 -----------------------------------------------------------------------------//
		while (_ismbcdigit((UB)*pStr) || *pStr == cSep) {
			if (_ismbcdigit(*pStr)) {
				pStr++;
				six++;
			}
			else {
				memmove(&pBuf[six], &pBuf[six + 1], eix - six);
				eix--;
			}
		}
	}
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcStrAnyRmvSepCharW(WCP pStr, UI cSep)
{
	WCP		pBuf = pStr;
	int		six, eix;

	if (pStr != NULL) {
		//----- 񒷂ƁACfNXݒ -----------------------------------------------------------//
		six  = 0;
		eix  = (UI)wcslen(pStr) + 1;
		//----- 擪Xy[XXLbv -----------------------------------------------------------------------//
		while (MAjcIsBlankW(*pStr)) {
			pStr++; six++;
		}
		//----- XLbv -------------------------------------------------------------------------------//
		if (*pStr == '+' || *pStr == '-') {
			pStr++; six++;
		}
		//----- ؂蕶폜 -----------------------------------------------------------------------------//
		while (MAjcAscIsDigitW(*pStr) || *pStr == cSep) {
			if (MAjcAscIsDigitW(*pStr)) {
				pStr++;
				six++;
			}
			else {
				memmove(&pBuf[six], &pBuf[six + 1], (eix - six - 1) * sizeof(UW));
				eix--;
			}
		}
	}
}
//==============================================================================================================//
//	d񁨕|C^z񐶐																			//
//																												//
//	@	F	pStr - d̃AhX																		//
//				pnArr- z̗vfi[obt@̃AhX													//
//																												//
//	߂l	F	NULL - |C^z̃AhX													//
//				NULL - Ȃ^s																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP	*	WINAPI	AjcMStrMakeArrayA(BCP pStr, UIP pnArr)
{
	BCP		*pArr = NULL;
	BCP		*p;
	UI		n;
	UI		i = 0;

	if (pStr != NULL) {
		n = AjcMStrCountA(pStr);
		if (pArr = p = (BCP*)AJCMEM((n + 1) * sizeof(BCP))) {
			for (i=0; i<n && pStr!=NULL; i++) {
				*p++ = pStr;
				pStr = AjcMStrNextPtrA(pStr);
			}
			*p = NULL;
		}
		if (pnArr != NULL) *pnArr = i;
	}
	return pArr;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP	*	WINAPI	AjcMStrMakeArrayW(WCP pStr, UIP pnArr)
{
	WCP		*pArr = NULL;
	WCP		*p;
	UI		n;
	UI		i = 0;

	if (pStr != NULL) {
		n = AjcMStrCountW(pStr);
		if (pArr = p = (WCP*)AJCMEM((n + 1) * sizeof(WCP))) {
			for (i=0; i<n && pStr!=NULL; i++) {
				*p++ = pStr;
				pStr = AjcMStrNextPtrW(pStr);
			}
			*p = NULL;
		}
		if (pnArr != NULL) *pnArr = i;
	}
	return pArr;
}
//==============================================================================================================//
//	d񒆂̕|C^zJ																		//
//																												//
//	@	F	pArr - |C^z̃AhX																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO		WINAPI	AjcMStrReleaseArray(VOP pArr)
{
	if (pArr != NULL) {
		free(pArr);
	}
}

//==============================================================================================================//
//	d񒆂̕E擾																				//
//																												//
//	@	F	pStr - d̃AhX																		//
//																												//
//	߂l	F																							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcMStrCountA(C_BCP pStr)
{
	UI		rc = 0;
	UI		len;

	if (pStr != NULL && *pStr != 0) {
		do {
			len = (UI)strlen(pStr) + 1;
			rc++;
			pStr += len;
		} while (*pStr != 0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcMStrCountW(C_WCP pStr)
{
	UI		rc = 0;
	UI		len;

	if (pStr != NULL && *pStr != 0) {
		do {
			len = (UI)wcslen(pStr) + 1;
			rc++;
			pStr += len;
		} while (*pStr != 0);
	}
	return rc;
}
//==============================================================================================================//
//	d̑擾																					//
//																												//
//	@	F	pStr - d̃AhX																		//
//																												//
//	߂l	F	iI[܂ށj																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcMStrTotalSizeA(C_BCP pStr)
{
	UI		rc = 1;
	UI		len;

	if (pStr != NULL && *pStr != 0) {
		do {
			len = (UI)strlen(pStr) + 1;
			rc	 += len;
			pStr += len;
		} while (*pStr != 0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcMStrTotalSizeW(C_WCP pStr)
{
	UI		rc = 1;
	UI		len;

	if (pStr != NULL && *pStr != 0) {
		do {
			len = (UI)wcslen(pStr) + 1;
			rc	 += len;
			pStr += len;
		} while (*pStr != 0);
	}
	return rc;
}
//==============================================================================================================//
//	d̎̕|C^擾																			//
//																												//
//	@	F	pStr - d̃AhX																		//
//																												//
//	߂l	F	NULL - ̃̕AhX																	//
//				NULL - d̏I[o																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcMStrNextPtrA(BCP pStr)
{
	BCP		pNxt = NULL;

	if (pStr != NULL && *pStr != 0) {
		pNxt = pStr + (strlen(pStr) + 1);
		if (*pNxt == 0) {
			pNxt = NULL;
		}
	}
	return pNxt;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcMStrNextPtrW(WCP pStr)
{
	WCP		pNxt = NULL;

	if (pStr != NULL && *pStr != 0) {
		pNxt = pStr + (wcslen(pStr) + 1);
		if (*pNxt == 0) {
			pNxt = NULL;
		}
	}
	return pNxt;
}
//==============================================================================================================//
//	Function	:	P̕𕶎Qɒu														//
//																												//
//	Argument	:	pStr1 - P̃AhX																	//
//					lBuf1 - Pi[Ăobt@̃oCg^									//
//					loc   - P̃̕oCgʒu^ʒu										//
//					len   - P̃̕oCg^											//
//					pStr2 - Q̃AhX																	//
//					lStr2 - Q̒ioCg^C|Pw莞͎Zoj							//
//																												//
//	Return		:	mtkkFnjiuꂽP̃AhXj											//
//					mtkkFp^G[i͒u܂j									//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcRepPartStrA(BCP pStr1, UI lBuf, UI loc, UI len, C_BCP pStr2, UI lStr2)
{
	BCP		rc = NULL;
	UI		lStr1;
	BCP		p;

	do {
		//----- p^`FbNiPj------//
		if (lBuf  == 0	 ) break;
		if (pStr1 == NULL) break;
		if (pStr2 == NULL) break;
		//----- P̒Zo ---------//
		for (p=pStr1, lStr1=0; lStr1 < lBuf && *p != 0; lStr1++, p++);
		if (*p != 0) break;
		//----- Q̒Zo ---------//
		lStr2 = AjcStrAdjustLenA(pStr2, lStr2);
		//----- p^`FbNiQj------//
		if ((loc + len) > lStr1) break;
		if (len < lStr2) {
			if ((lStr1 + (lStr2 - len)) > (lBuf - 1)) break;
		}
		//----- u -------------//
		if		(len > lStr2) {
			memmove((pStr1 + (loc + lStr2)), pStr1 + (loc + len), lStr1 - (loc + len) + 1);
		}
		else if (len < lStr2) {
			memmove(pStr1 + (loc + len + (lStr2 - len)), pStr1 + (loc + len), lStr1 - (loc + len) + 1);
		}
		memcpy(pStr1 + loc, pStr2, lStr2);
		rc = pStr1;
	} while(0);

	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcRepPartStrW(WCP pStr1, UI lBuf, UI loc, UI len, C_WCP pStr2, UI lStr2)
{
	WCP		rc = NULL;
	UI		lStr1;
	WCP		p;

	do {
		//----- p^`FbNiPj------//
		if (lBuf  == 0	 ) break;
		if (pStr1 == NULL) break;
		if (pStr2 == NULL) break;
		//----- P̒Zo ---------//
		for (p=pStr1, lStr1=0; lStr1 < lBuf && *p != 0; lStr1++, p++);
		if (*p != 0) break;
		//----- Q̒␳ ---------//
		lStr2 = AjcStrAdjustLenW(pStr2, lStr2);
		//----- p^`FbNiQj------//
		if ((loc + len) > lStr1) break;
		if (len < lStr2) {
			if ((lStr1 + (lStr2 - len)) > (lBuf - 1)) break;
		}
		//----- u -------------//
		if		(len > lStr2) {
			memmove((pStr1 + (loc + lStr2)), pStr1 + (loc + len), (lStr1 - (loc + len) + 1) * 2);
		}
		else if (len < lStr2) {
			memmove(pStr1 + (loc + len + (lStr2 - len)), pStr1 + (loc + len), (lStr1 - (loc + len) + 1) * 2);
		}
		memcpy(pStr1 + loc, pStr2, (lStr2) * 2);
		rc = pStr1;
	} while(0);

	return rc;
}
//==============================================================================================================//
//	Function	:	Rs[																				//
//																												//
//	Argument	:	pBuf - Rs[̃AhX																//
//					lBuf - Rs[obt@̃oCg^												//
//					pStr - Rs[镶̃AhX															//
//																												//
//	Return		:	 NULL : Rs[敶̃AhX( = pBuf )												//
//					 NULL : ̒obt@𒴂Ă^k|C^									//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrCpyA(BCP pBuf, UI lBuf, C_BCP pStr)
{
	BCP		rc = NULL;

	if (pBuf != NULL && pStr != NULL && strlen(pStr) < lBuf) {
		strcpy(pBuf, pStr);
		rc = pBuf;
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrCpyW(WCP pBuf, UI lBuf, C_WCP pStr)
{
	WCP		rc = NULL;

	if (pBuf != NULL && pStr != NULL && wcslen(pStr) < lBuf) {
		wcscpy(pBuf, pStr);
		rc = pBuf;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	őRs[w肵ĕRs[														//
//																												//
//	Argument	:	pBuf - Rs[̃AhX																//
//					lBuf - Rs[obt@̃oCg^												//
//					pStr - Rs[镶̃AhX															//
//					count- Rs[ő啶																	//
//																												//
//	Return		:	 NULL : Rs[敶̃AhX( = pBuf )												//
//					 NULL : ̒obt@𒴂Ă^k|C^									//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrNCpyA(BCP pBuf, UI lBuf, C_BCP pStr, UI n)
{
	BCP		rc = NULL;
	C_BCP	p;
	UI		svl,len;

	if (pBuf != NULL && pStr != NULL) {
		//	Rs[oCgZo
		for (p = pStr, svl = len = 0; *p != 0 && len < n; ) {
			svl = len;
			if (_ismbblead(*p) && *(p + 1) != 0) len += 2;
			else								 len += 1;
		}
		if (len > n) len = svl;
		//	w蕶Rs[
		if (len < lBuf) {
			memcpy(pBuf, pStr, len);
			pBuf[len] = 0;
			rc = pBuf;
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrNCpyW(WCP pBuf, UI lBuf, C_WCP pStr, UI n)
{
	WCP		rc = NULL;
	UI		stl,len;

	if (pBuf != NULL && pStr != NULL) {
		//	Rs[Zo
		stl = (UI)wcslen(pStr);
		len = __min(n, stl);
		//	w蕶Rs[
		if (len < lBuf) {
			wcsncpy(pBuf, pStr, len);
			rc = pBuf;
		}
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	̖ɕǉ																	//
//																												//
//	Argument	:	pStr1 - P̃AhX																	//
//					lBuf1 - Pi[Ăobt@̃oCg^									//
//					pStr2 - Q̃AhX																	//
//																												//
//	Return		:	mtkkFnjipStr1j																	//
//					mtkkFp^G[i͒u܂j									//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrCatA(BCP pStr1, UI lBuf, C_BCP pStr2)
{
	BCP		rc = NULL;

	if (pStr1 != NULL && pStr2 != NULL && (strlen(pStr1) + strlen(pStr2)) < lBuf) {
		strcat(pStr1, pStr2);
		rc = pStr1;
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrCatW(WCP pStr1, UI lBuf, C_WCP pStr2)
{
	WCP		rc = NULL;

	if (pStr1 != NULL && pStr2 != NULL && (wcslen(pStr1) + wcslen(pStr2)) < lBuf) {
		wcscat(pStr1, pStr2);
		rc = pStr1;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	O󔒂																				//
//																												//
//	Argument	:	pStr - 󔒂镶̃AhX														//
//					pBuf - 󔒂i[obt@̃AhX										//
//					lBuf - obt@̃oCg^															//
//																												//
//	Return		:	̃̕AhX(=pBuf)																//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrLTrimA(BCP pStr, BCP pBuf, UI lBuf)
{
	UI		ix = 0;
	UI		len;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0) {
		//--- O󔒃XLbv -------------------------------//
		while (pStr[ix] != 0) {
			if		(pStr[ix] == 0x20						 ) ix++;
			else if (pStr[ix] == 0x81 && pStr[ix + 1] == 0x40) ix += 2;
			else break;
		}
		//--- 󔒂obt@Ɋi[ -----------//
		len = (UI)strlen(&pStr[ix]) + 1;
		len = __min(len, lBuf);
		memmove(pBuf, &pStr[ix], len);
		pBuf[lBuf - 1] = 0;
	}
	return pBuf;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrLTrimW(WCP pStr, WCP pBuf, UI lBuf)
{
	UI		ix = 0;
	UI		len;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0) {
		//--- O󔒃XLbv -------------------------------//
		while (pStr[ix] != 0) {
			if (pStr[ix] == L' ' || pStr[ix] == L'@') ix++;
			else break;
		}
		//--- 󔒂obt@Ɋi[ -----------//
		len = (UI)wcslen(&pStr[ix]) + 1;
		len = __min(len, lBuf);
		memmove(pBuf, &pStr[ix], len * 2);
		pBuf[lBuf - 1] = 0;
	}
	return pBuf;
}

//==============================================================================================================//
//	Function	:	㕔̋󔒂																			//
//																												//
//	Argument	:	pStr - 󔒂镶̃AhX														//
//					pBuf - 󔒂i[obt@̃AhX										//
//					lBuf - obt@̃oCg^															//
//																												//
//	Return		:	̃̕AhX(=pBuf)																//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrRTrimA(BCP pStr, BCP pBuf, UI lBuf)
{
	UI		ix	= 0;
	UI		len = 0;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0) {
		//--- 㕔󔒂̐擪ʒu -------------------------//
		while (pStr[ix] != 0) {
			if (_ismbblead(pStr[ix]) && _ismbbtrail(pStr[ix + 1])) {
				if (pStr[ix] != 0x81 || pStr[ix + 1] != 0x40) {
					len = ix + 2;
				}
				ix += 2;
			}
			else {
				if (pStr[ix] != 0x20) {
					len = ix + 1;
				}
				ix++;
			}
		}
		//--- 󔒂obt@Ɋi[ -----------//
		len = __min(len, lBuf - 1);
		memmove(pBuf, pStr, len);
		pBuf[len] = 0;
	}
	return pBuf;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrRTrimW(WCP pStr, WCP pBuf, UI lBuf)
{
	UI		ix	= 0;
	UI		len = 0;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0) {
		//--- 㕔󔒂̐擪ʒu -------------------------//
		while (pStr[ix] != 0) {
			if (pStr[ix] != L' ' && pStr[ix] != L'@') {
				len = ix + 1;
			}
			ix++;
		}
		//--- 󔒂obt@Ɋi[ -----------//
		len = __min(len, lBuf - 1);
		memmove(pBuf, pStr, len * 2);
		pBuf[len] = 0;
	}
	return pBuf;
}

//==============================================================================================================//
//	Function	:	[̋󔒂																			//
//																												//
//	Argument	:	pStr - 󔒂镶̃AhX														//
//					pBuf - 󔒂i[obt@̃AhXipStrƏdj						//
//					lBuf - obt@̃oCg^															//
//																												//
//	Return		:	̃̕AhX(=pBuf)																//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrTrimA (BCP pStr, BCP pBuf, UI lBuf)
{
	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0) {
		AjcStrLTrimA(pStr, pBuf, lBuf);
		AjcStrRTrimA(pBuf, pBuf, lBuf);
	}
	return pBuf;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrTrimW (WCP pStr, WCP pBuf, UI lBuf)
{
	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0) {
		AjcStrLTrimW(pStr, pBuf, lBuf);
		AjcStrRTrimW(pBuf, pBuf, lBuf);
	}
	return pBuf;
}
//==============================================================================================================//
//	Function	:	O̕svȕQ																	//
//																												//
//	Argument	:	pStr   - 镶̃AhX														//
//					pBuf   - i[obt@̃AhXipStrƏdj					//
//					lBuf   - obt@̃oCg^															//
//					pChars - 镶̏WiŎwj													//
//																												//
//	Return		:	̃̕AhX(=pBuf)																//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrLTrimExA(BCP pStr, BCP pBuf, UI lBuf, C_BCP pChars)
{
	UI		ix = 0;
	UI		len;
	UI		c;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0 && pChars != NULL && *pChars != 0) {
		//--- OQXLbv -------------------------------//
		while (pStr[ix] != 0) {
			if (_ismbblead(pStr[ix]) &&  _ismbbtrail(pStr[ix + 1])) {
				c = ((pStr[ix] << 8) & 0xFF00) | ((pStr[ix + 1]) & 0x00FF);
				if (mbschr(pChars, c) != NULL) ix += 2;
				else						   break;
			}
			else {
				c = (UB)pStr[ix];
				if (mbschr(pChars, c) != NULL) ix++;
				else						   break;
			}
		}
		//--- obt@Ɋi[ -----------//
		len = (UI)strlen(&pStr[ix]) + 1;
		len = __min(len, lBuf);
		memmove(pBuf, &pStr[ix], len);
		pBuf[lBuf - 1] = 0;
	}
	return pBuf;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrLTrimExW(WCP pStr, WCP pBuf, UI lBuf, C_WCP pChars)
{
	UI		ix = 0;
	UI		len;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0 && pChars != NULL && *pChars != 0) {
		//--- OQXLbv -----------------------------//
		while (pStr[ix] != 0) {
			if (wcschr(pChars, pStr[ix])) ix++;
			else break;
		}
		//--- obt@Ɋi[ -----------//
		len = (UI)wcslen(&pStr[ix]) + 1;
		len = __min(len, lBuf);
		memmove(pBuf, &pStr[ix], len * 2);
		pBuf[lBuf - 1] = 0;
	}
	return pBuf;
}

//==============================================================================================================//
//	Function	:	㕔̕svȕQ																	//
//																												//
//	Argument	:	pStr   - 󔒂镶̃AhX														//
//					pBuf   - 󔒂i[obt@̃AhX									//
//					lBuf   - obt@̃oCg^															//
//					pChars - 镶̏WiŎwj													//
//																												//
//	Return		:	̃̕AhX(=pBuf)																//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrRTrimExA(BCP pStr, BCP pBuf, UI lBuf, C_BCP pChars)
{
	UI		ix	= 0;
	UI		len = 0;
	UI		c;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0 && pChars != NULL && *pChars != 0) {
		//--- 㕔svQ̐擪ʒu -------------------//
		while (pStr[ix] != 0) {
			if (_ismbblead(pStr[ix]) && _ismbbtrail(pStr[ix + 1])) {
				c = ((pStr[ix] << 8) & 0xFF00) | ((pStr[ix + 1]) & 0x00FF);
				if (mbschr(pChars, c) == NULL) {
					len = ix + 2;
				}
				ix += 2;
			}
			else {
				c = (UB)pStr[ix];
				if (!mbschr(pChars, c)) {
					len = ix + 1;
				}
				ix++;
			}
		}
		//--- svQobt@Ɋi[ -----//
		len = __min(len, lBuf - 1);
		memmove(pBuf, pStr, len);
		pBuf[len] = 0;
	}
	return pBuf;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrRTrimExW(WCP pStr, WCP pBuf, UI lBuf, C_WCP pChars)
{
	UI		ix	= 0;
	UI		len = 0;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0 && pChars != NULL && *pChars != 0) {
		//--- 㕔svQ̐擪ʒu -------------------//
		while (pStr[ix] != 0) {
			if (wcschr(pChars, pStr[ix]) == NULL) {
				len = ix + 1;
			}
			ix++;
		}
		//--- svQobt@Ɋi[ -----//
		len = __min(len, lBuf - 1);
		memmove(pBuf, pStr, len * 2);
		pBuf[len] = 0;
	}
	return pBuf;
}

//==============================================================================================================//
//	Function	:	[̕svȕQ																	//
//																												//
//	Argument	:	pStr   - 󔒂镶̃AhX														//
//					pBuf   - 󔒂i[obt@̃AhX									//
//					lBuf   - obt@̃oCg^															//
//					pChars - 镶̏WiŎwj													//
//																												//
//	Return		:	̃̕AhX(=pBuf)																//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrTrimExA (BCP pStr, BCP pBuf, UI lBuf, C_BCP pChars)
{
	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0 && pChars != NULL && *pChars != 0) {
		AjcStrLTrimExA(pStr, pBuf, lBuf, pChars);
		AjcStrRTrimExA(pBuf, pBuf, lBuf, pChars);
	}
	return pBuf;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrTrimExW (WCP pStr, WCP pBuf, UI lBuf, C_WCP pChars)
{
	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0 && pChars != NULL && *pChars != 0) {
		AjcStrLTrimExW(pStr, pBuf, lBuf, pChars);
		AjcStrRTrimExW(pBuf, pBuf, lBuf, pChars);
	}
	return pBuf;
}
//==============================================================================================================//
//	擪Ɩ̕svQ폜AԂ̘AQw蕶ɒu								//
//																												//
//	@	F	pStr	- `ÕAhX																//
//				pBuf	- `i[obt@̃AhX											//
//				lBuf	- obt@̃oCg^															//
//				pChars	- QiŎwj																//
//				pRepStr	- uς镶																		//
//																												//
//	߂l	F	`̃AhXipBuf)																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcStrShapingA(BCP pStr, BCP pBuf, UI lBuf, C_BCP pChars, C_BCP pRepStr)
{
	int		len 	= 0;
	int		ix		= 0;
	int		ixTop	= 0;
	UI		c;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0 && pChars != NULL && *pChars != 0 && pRepStr != NULL) {
		//----- pBufɕRs[ ---------------------------------------//
		if (pStr != pBuf) {
			AjcSnPrintFA(pBuf, lBuf, "%s", pStr);
		}
		//----- O̕Q폜 -----------------------------------------//
		AjcStrTrimExA(pBuf, pBuf, lBuf, pChars);
		//----- AQPɂ܂Ƃ߂ ---------------------------//
		while (pBuf[ix] != 0) {
			//	擪`FbN
			if (_ismbblead(pBuf[ix]) && _ismbbtrail(pBuf[ix + 1])) {
				c = ((pBuf[ix] << 8) & 0xFF00) | ((pBuf[ix + 1]) & 0x00FF);
				if (mbschr((UBP)pChars, c) != NULL) {
					len   = 2;
					ixTop = ix;
				}
				ix	 += 2;
			}
			else {
				c = (UB)pBuf[ix];
				if (mbschr(pChars, c) != NULL) {
					ixTop = ix;
					len   = 1;
				}
				ix++;
			}
			//	擪I[Au
			if (len != 0) {
				while (pBuf[ix] != 0) {
					if (_ismbblead(pBuf[ix]) && _ismbbtrail(pBuf[ix + 1])) {
						c = ((pBuf[ix] << 8) & 0xFF00) | ((pBuf[ix + 1]) & 0x00FF);
						if (mbschr((UBP)pChars, c) != NULL) {
							len += 2;
							ix	+= 2;
						}
						else break;
					}
					else {
						c = (UB)pBuf[ix];
						if (mbschr(pChars, c)) {
							len++;
							ix++;
						}
						else break;
					}
				}
				AjcRepPartStrA(pBuf, lBuf, ixTop, len, pRepStr, -1);
				ixTop = 0;
				len   = 0;
			}
		}
	}
	return pBuf;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcStrShapingW(WCP pStr, WCP pBuf, UI lBuf, C_WCP pChars, C_WCP pRepStr)
{
	int		len 	= 0;
	int		ix		= 0;
	int		ixTop	= 0;

	if (pStr != NULL  &&  pBuf != NULL	&&	lBuf > 0 && pChars != NULL && *pChars != 0 && pRepStr != NULL) {
		//----- pBufɕRs[ ---------------------------------------//
		if (pStr != pBuf) {
			AjcSnPrintFW(pBuf, lBuf, L"%s", pStr);
		}
		//----- O̕Q폜 -----------------------------------------//
		AjcStrTrimExW(pBuf, pBuf, lBuf, pChars);
		//----- AQPɂ܂Ƃ߂ ---------------------------//
		while (pBuf[ix] != 0) {
			//	擪`FbN
			if (wcschr(pChars, pBuf[ix]) != NULL) {
				ixTop = ix;
				len   = 1;
			}
			ix++;
			if (len != 0) {
				//	擪I[Au
				while (pBuf[ix] != 0) {
					if (wcschr(pChars, pBuf[ix]) != NULL) {
						len++;
						ix++;
					}
					else break;
				}
				AjcRepPartStrW(pBuf, lBuf, ixTop, len, pRepStr, -1);
				ixTop = 0;
				len   = 0;
			}
		}
	}
	return pBuf;
}
//==============================================================================================================//
//	Function	:	񒆂ESCV[PX																//
//																												//
//	Argument	:	pStr - ESCV[PX镶̃AhX												//
//					pBuf - ESCV[PXi[obtÃAhX							//
//					lBuf - ESCV[PXi[obtÃoCg^					//
//																												//
//	Return		:	ESCV[PXi[obt@̃AhXi=pBufj							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP	WINAPI	AjcRemoveEscInStrA(C_BCP pStr, BCP pBuf, UI lBuf)
{
	BCP		rc	= pBuf;
	UI		len = 0;

	if (pBuf != NULL && lBuf != 0) {
		while (*pStr != 0 && len + 1 < lBuf) {
			//	ESCV[PXXLbv
			if (*pStr == '\x1B') {
				pStr++;
				do {
					if (_ismbblead(*pStr) && _ismbbtrail(*(pStr + 1))) pStr += 2;
					else											   pStr++;
				} while (*pStr != 0 && !MAjcAscIsAlphaA(*pStr));
				if (*pStr != 0 && MAjcAscIsAlphaA(*pStr)) {
					pStr++;
				}
			}
			//	eLXgi[
			if (*pStr != 0) {
				if (_ismbblead(*pStr) && _ismbbtrail(*(pStr + 1))) {
					if (len + 2 < lBuf) {
						*pBuf++ = *pStr++;
						*pBuf++ = *pStr++;
					}
					len  += 2;
				}
				else {
					*pBuf++ = *pStr++;
					len++;
				}
			}
		}
		*pBuf = 0;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcRemoveEscInStrW(C_WCP pStr, WCP pBuf, UI lBuf)
{
	WCP		rc	= pBuf;
	UI		len = 0;

	if (pBuf != NULL && lBuf != 0) {
		while (*pStr != 0 && len + 1 < lBuf) {
			//	ESCV[PXXLbv
			if (*pStr == L'\x1B') {
				pStr++;
				do {
					pStr++;
				} while (*pStr != 0 && !MAjcAscIsAlphaW(*pStr));
				if (*pStr != 0 && MAjcAscIsAlphaW(*pStr)) {
					pStr++;
				}
			}
			//	eLXgi[
			if (*pStr != 0) {
				*pBuf++ = *pStr++;
				len++;
			}
		}
		*pBuf = 0;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	}`oCg(Vtgihr)̎擾													//
//																												//
//	Argument	:	pTop - r|ihr̃AhXiI[(0x00)͕svj									//
//					ix	 - }`oCg`FbNAr|ihr񒆂̃oCgʒuiO`j				//
//					pBuf - }`oCgi[obt@̃AhX											//
//																												//
//	Return		:	TRUE  - nj																				//
//					FALSE - G[																				//
//																												//
//	@l		:	pBufɂ͈ȉ̏񂪐ݒ肳B															//
//						pBuf->len : uixv̈ʒũoCgAoCg̍\vfł邱Ƃ				//
//						pBuf->ix  : oCg̃CfNXiO ` |Pj									//
//						Ⴆ΁AupBuf->len=2v, upBuf->ix=0vłꍇAQoCĝPoCgڂӖ	//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcStrChkMbcPart (C_BCP pTop, UI ix, PAJCMBCINFO pBuf)
{
	BOOL	rc = FALSE;

	if (pTop != NULL && *pTop != 0 && pBuf != NULL) {
		switch (mbsbtype(pTop, ix)) {
			default:
			case _MBC_SINGLE:	pBuf->len = 1; pBuf->ix = 0; break;
			case _MBC_LEAD:		pBuf->len = 2; pBuf->ix = 0; break;
			case _MBC_TRAIL:	pBuf->len = 2; pBuf->ix = 1; break;
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	tse|W̎擾																	//
//																												//
//	Argument	:	pTop - tse|W̃AhXiI[(0x00)͕svj									//
//					ix	 - }`oCg`FbNAtse|W񒆂̃oCgʒuiO`j				//
//					pBuf - }`oCgi[obt@̃AhX											//
//																												//
//	Return		:	TRUE  - nj																				//
//					FALSE - G[																				//
//																												//
//	@l		:	pBufɂ͈ȉ̏񂪐ݒ肳B															//
//						pBuf->len : uixv̈ʒũoCgAoCg̍\vfł邱Ƃ				//
//						pBuf->ix  : oCg̃CfNXiO ` |Pj									//
//						Ⴆ΁AupBuf->len=2v, upBuf->ix=0vłꍇAQoCĝPoCgڂӖ	//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcStrChkUtf8Part(C_BCP pTop, UI ix, PAJCMBCINFO pBuf)
{
	BOOL	rc = FALSE;
	int		bix;
	UI		fix = 0;
	UI		mbc = 0;
	UB		hNib;

	if (pTop != NULL && pBuf != NULL) {
		//--- }`oCg񏉊ioCgj --//
		pBuf->len = 1;
		pBuf->ix  = 0;

		//--- ASCII^}`oCg擪 --//
		for (bix = ix; bix >= 0; bix--) {
			hNib = (UB)(pTop[bix] & 0xF0);

			if		((UB)pTop[bix] <= 0x7F						   ) {fix = bix; mbc = 1; break;}
			else if (hNib == 0xC0 || hNib == 0xD0				   ) {fix = bix; mbc = 2; break;}
			else if (hNib == 0xE0								   ) {fix = bix; mbc = 3; break;}
			else if ((UB)pTop[bix] >= 0xF0 && (UB)pTop[bix] <= 0xF7) {fix = bix; mbc = 4; break;}
			else if ((UB)pTop[bix] >= 0xF8 && (UB)pTop[bix] <= 0xFB) {fix = bix; mbc = 5; break;}
			else if ((UB)pTop[bix] >= 0xFC && (UB)pTop[bix] <= 0xFD) {fix = bix; mbc = 6; break;}
		}
		//--- }`oCgǏ] -------------------//
		while (fix <= ix) {
			hNib = (pTop[fix] & 0xF0);

			if		((UB)pTop[fix] <= 0x7F					   ) {		//	PoCgH
				if		(fix + 0 == ix) {pBuf->len = 1; pBuf->ix = 0; rc = TRUE; break;}
				fix++;
			}
			else if (hNib == 0xC0 || hNib == 0xD0		   ) {			//	QoCgH
				if		(fix + 0 == ix) {pBuf->len = 2; pBuf->ix = 0; rc = TRUE; break;}
				if		(fix + 1 == ix) {pBuf->len = 2; pBuf->ix = 1; rc = TRUE; break;}
				fix += 2;
			}
			else if (hNib == 0xE0						   ) {			//	RoCgH
				if		(fix + 0 == ix) {pBuf->len = 3; pBuf->ix = 0; rc = TRUE; break;}
				if		(fix + 1 == ix) {pBuf->len = 3; pBuf->ix = 1; rc = TRUE; break;}
				if		(fix + 2 == ix) {pBuf->len = 3; pBuf->ix = 2; rc = TRUE; break;}
				fix += 3;
			}
			else if ((UB)pTop[fix] >= 0xF0 && (UB)pTop[fix] <= 0xF7) {	//	SoCgH
				if		(fix + 0 == ix) {pBuf->len = 4; pBuf->ix = 0; rc = TRUE; break;}
				if		(fix + 1 == ix) {pBuf->len = 4; pBuf->ix = 1; rc = TRUE; break;}
				if		(fix + 2 == ix) {pBuf->len = 4; pBuf->ix = 2; rc = TRUE; break;}
				if		(fix + 3 == ix) {pBuf->len = 4; pBuf->ix = 3; rc = TRUE; break;}
				fix += 4;
			}
			else if ((UB)pTop[fix] >= 0xF8 && (UB)pTop[fix] <= 0xFB) {	//	ToCgH
				if		(fix + 0 == ix) {pBuf->len = 5; pBuf->ix = 0; rc = TRUE; break;}
				if		(fix + 1 == ix) {pBuf->len = 5; pBuf->ix = 1; rc = TRUE; break;}
				if		(fix + 2 == ix) {pBuf->len = 5; pBuf->ix = 2; rc = TRUE; break;}
				if		(fix + 3 == ix) {pBuf->len = 5; pBuf->ix = 3; rc = TRUE; break;}
				if		(fix + 4 == ix) {pBuf->len = 5; pBuf->ix = 4; rc = TRUE; break;}
				fix += 5;
			}
			else if ((UB)pTop[fix] >= 0xFC && (UB)pTop[fix] <= 0xFD) {	//	UoCgH
				if		(fix + 0 == ix) {pBuf->len = 6; pBuf->ix = 0; rc = TRUE; break;}
				if		(fix + 1 == ix) {pBuf->len = 6; pBuf->ix = 1; rc = TRUE; break;}
				if		(fix + 2 == ix) {pBuf->len = 6; pBuf->ix = 2; rc = TRUE; break;}
				if		(fix + 3 == ix) {pBuf->len = 6; pBuf->ix = 3; rc = TRUE; break;}
				if		(fix + 4 == ix) {pBuf->len = 6; pBuf->ix = 4; rc = TRUE; break;}
				if		(fix + 5 == ix) {pBuf->len = 6; pBuf->ix = 5; rc = TRUE; break;}
				fix += 6;
			}
			else {
				fix++;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	{dtb̎擾																//
//												iI[(0x00)͕svj										//
//	Argument	:	pTop - dtb̃AhX																//
//					ix	 - }`oCg`FbNAdtb񒆂̃oCgʒuiO`j					//
//					pBuf - }`oCgi[obt@̃AhX											//
//																												//
//	Return		:	TRUE  - nj																				//
//					FALSE - G[																				//
//																												//
//	@l		:	pBufɂ͈ȉ̏񂪐ݒ肳B															//
//						pBuf->len : uixv̈ʒũoCgAoCg̍\vfł邱Ƃ				//
//						pBuf->ix  : oCg̃CfNXiO ` |Pj									//
//						Ⴆ΁AupBuf->len=2v, upBuf->ix=0vłꍇAQoCĝPoCgڂӖ	//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcStrChkEucPart (C_BCP pTop, UI ix, PAJCMBCINFO pBuf)
{
	BOOL	rc = FALSE;
	int		bix;
	UI		fix = 0;

	if (pTop != NULL && pBuf != NULL) {
		//--- }`oCg񏉊ioCgj --//
		pBuf->len = 1;
		pBuf->ix  = 0;

		//--- ASCII -------------------------//
		for (bix = ix; bix >= 0; bix--) {
			if ((UB)pTop[bix] <= 0x7F) {
				fix = bix;
				break;
			}
		}
		//--- }`oCgǏ] ------------------------//
		while (fix <= ix) {
			if		(((UB)pTop[fix] >= 0xA1 && (UB)pTop[fix] <= 0xFE) || pTop[fix] == 0x8E) {	//	QoCg
				if		(fix + 0 == ix) {pBuf->len = 2; pBuf->ix = 0; break;}
				else if (fix + 1 == ix) {pBuf->len = 2; pBuf->ix = 1; break;}
				fix += 2;
			}
			else if ((UB)pTop[fix] == 0x8F) {													//	RoCg
				if		(fix + 0 == ix) {pBuf->len = 3; pBuf->ix = 0; break;}
				else if (fix + 1 == ix) {pBuf->len = 3; pBuf->ix = 1; break;}
				else if (fix + 2 == ix) {pBuf->len = 3; pBuf->ix = 2; break;}
				fix += 3;
			}
			else {																				//	PoCgiLȊOj
				if		(fix + 0 == ix) {pBuf->len = 1; pBuf->ix = 0; break;}
				fix++;
			}
		}
		//--- ߂lݒ ----------------------------------//
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	}`oCg(Vtgihr)̃oCg擾												//
//																												//
//	Argument	:	pTop - r|ihr̐擪AhX															//
//					len	 - r|ihr̃oCgipTop疖܂ł̃oCgC|Pw莞͎Zoj		//
//																												//
//	Return		:	P`Q	- }`oCg(Vtgihr)̃oCg											//
//					O		- G[isj																//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcStrChkMbcLen (C_BCP pTop, UI len)
{
	UI		rc = 0;

	if (pTop != NULL && *pTop != 0) {
		len = AjcStrAdjustLenA(pTop, len);
		if (len >= 1) {
			if (MAjcIsLeadA(*pTop)) {		//	QoCgH
				if (len >= 2 && MAjcIsTrailA(*(pTop + 1))) rc = 2;
			} 
			else {							//	PoCgH
				rc = 1;
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	}`oCg(tse|W)̃oCg擾													//
//																												//
//	Argument	:	pTop - tse|W̐擪AhX															//
//					len	 - tse|W̃oCgipTop疖܂ł̃oCgC|Pw莞͎Zoj		//
//																												//
//	Return		:	P`U	- }`oCg(tse|W)̃oCg											//
//					O		- G[isj																//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcStrChkUtf8Len (C_BCP pTop, UI len)
{
	UI		rc = 0;
	UI		hNib;
	BC		c;

	if (pTop != NULL && *pTop != 0) {
		len = AjcStrAdjustLenA(pTop, len);
		if (len >= 1) {
			c = *pTop;
			hNib = (c & 0xF0);									//	ʃjulݒ
			if		(hNib == 0xC0 || hNib == 0xD0) {			//	QoCgH
				if (len >= 2) rc = 2;
			}
			else if (hNib == 0xE0				   ) {			//	RoCgH
				if (len >= 3) rc = 3;
			}
			else if (c >= 0xF0 && c <= 0xF7 	   ) {			//	SoCgH
				if (len >= 4) rc = 4;
			}
			else if (c >= 0xF8 && c <= 0xFB 	   ) {			//	ToCgH
				if (len >= 5) rc = 5;
			}
			else if (c >= 0xFC && c <= 0xFD 	   ) {			//	UoCgH
				if (len >= 6) rc = 6;
			}
			else {												//	̑iPoCgj
				rc = 1;
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	}`oCg(dtb)̃oCg擾														//
//																												//
//	Argument	:	pTop - dtb̐擪AhX																//
//					len	 - dtb̃oCgipTop疖܂ł̃oCgC|Pw莞͎Zoj			//
//																												//
//	Return		:	P`R	- }`oCg(Vtgihr)̃oCg											//
//					O		- G[isj																//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcStrChkEucLen (C_BCP pTop, UI len)
{
	UI		rc = 0;
	BC		c;

	if (pTop != NULL && *pTop != 0) {
		len = AjcStrAdjustLenA(pTop, len);
		if (len >= 1) {
			c = (UB)*pTop;
			if		((c >= 0xA1 && c <= 0xFE) || c == 0x8E) {		//	QoCg
				if (len >= 2) rc = 2;
			}
			else if (c == 0x8F) {									//	RoCg
				if (len >= 3) rc = 3;

			}
			else {													//	PoCgiLȊOj
				rc = 1;
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	ChigGfBAj̃[h擾												//
//																												//
//	Argument	:	pTop - Ch̐擪AhX																//
//					len	 - Ch̕ipTop疖܂ł̕C|Pw莞͎Zoj				//
//																												//
//	Return		:	P`Q	- ChigGfBAj̃[h										//
//					O		- G[isj																//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcStrChkU16LeLen (C_WCP pTop, UI len)
{
	UI		rc = 0;

	if (pTop != NULL && *pTop != 0) {
		len = AjcStrAdjustLenW(pTop, len);
		if (len >= 1) {
			if (MAjcIsLeadW(*pTop)) {								//	ʃTQ[gH
				if (len >= 2 && MAjcIsTrailW(*(pTop + 1))) rc = 2;
			}
			else {													//	TQ[gH
				rc = 1;
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	ChirbOGfBAj̃[h擾												//
//																												//
//	Argument	:	pTop - Ch̐擪AhX																//
//					len	 - Ch̕ipTop疖܂ł̕C|Pw莞͎Zoj				//
//																												//
//	Return		:	P`Q	- ChirbOGfBAj̃[h										//
//					O		- G[isj																//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcStrChkU16BeLen (C_WCP pTop, UI len)
{
	UI		rc = 0;

	if (pTop != NULL && *pTop != 0) {
		len = AjcStrAdjustLenW(pTop, len);
		if (len >= 1) {
			if (MAjcIsLeadW((WC)AjcExcWord((*pTop)))) {				//	ʃTQ[gH
				if (len >= 2 && MAjcIsTrailW((WC)AjcExcWord((*(pTop + 1))))) rc = 2;
			}
			else {													//	TQ[gH
				rc = 1;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	񒷕␳																				//
//																												//
//	Argument	:	pTxt - ̃AhX																		//
//					len	 - Ch̃oCgipTop疖܂ł̕C|Pw莞͎Zoj				//
//																												//
//	Return		:	P`Q	- ChirbOGfBAj̃[h										//
//					O		- G[isj																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcStrAdjustLenA(C_BCP pTxt, UI len)
{
	UI		rc = 0;

	if (pTxt != NULL) {
		if (len == -1) rc = (UI)strlen (pTxt);
		else		   rc = (UI)strnlen(pTxt, len);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcStrAdjustLenW(C_WCP pTxt, UI len)
{
	UI		rc = 0;

	if (pTxt != NULL) {
		if (len == -1) rc = (UI)wcslen (pTxt);
		else		   rc = (UI)wcsnlen(pTxt, len);
	}
	return rc;
}

/*==============================================================================================================*/
/*	Function	:	tse|W  }`oCgiVtgihrjϊ										*/
/*																												*/
/*	Argument	:	pUtf8  - ϊUTF-8R[h̃AhX												*/
/*					pMbc   - ϊ}`oCg(Vtgihr)i[obt@̃AhX(svNULL)	*/
/*					lMbc   - ϊ}`oCg(Vtgihr)i[obt@̃oCg(sv͂O)	*/
/*																												*/
/*	Return		:	ϊɕKvȃobt@TCYiI[(0x00)܂ށj										*/
/*																												*/
/*	@pMbc=NULL Ƃꍇ́AϊɕKvȃobt@TCYԂ܂B											*/
/*	@o̓obt@TCYꍇłA߂l͂njԂ܂B											*/
/*		̏ꍇA߂l̓obt@ɏo͂oCgł͂ȂAϊɕKvȃoCgԂ܂B					*/
/*==============================================================================================================*/
AJCEXPORT	int		WINAPI	AjcUtf8ToMbc(C_BCP pUtf8, BCP pMbc, UI lMbc)
{
	return AjcUtf8ToMbcEx(pUtf8, -1, pMbc, lMbc);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	int		WINAPI	AjcUtf8ToMbcEx(C_BCP pUtf8, UI lUtf8, BCP pMbc, UI lMbc)
{
	int		lBuf = 0;
	UI		lWid;
	WCP		pWid;

	if (pUtf8 != NULL) {
		//----- anlXLbv ---------------------------------------------------//
		if (strlen(pUtf8) >= 3 && memcmp(pUtf8, "\xEF\xBB\xBF", 3) == 0) {
			pUtf8 += 3;
		}
		//----- ϊ -------------------------------------------------------//
		lWid = MultiByteToWideChar(CP_UTF8, 0, pUtf8, lUtf8, NULL, 0);
		if (pWid = (WCP)AJCMEM(lWid * 2)) {
			MultiByteToWideChar(CP_UTF8, 0, pUtf8, lUtf8, pWid, lWid);
			lBuf = WideCharToMultiByte(CP_ACP, 0, pWid, lWid, NULL, 0, NULL, NULL);
			if (pMbc != NULL && lMbc != 0) {
				WideCharToMultiByte(CP_ACP, 0, pWid, lWid, pMbc, lMbc, NULL, NULL);
			}
			free(pWid);
		}
	}
	return lBuf;
}
/*==============================================================================================================*/
/*	Function	:	}`oCgiVtgihrj  tseWϊ											*/
/*																												*/
/*	Argument	:	pMbc   - }`oCgiVtgihrjR[h̃AhX									*/
/*					pUtf8  - ϊtse|Wi[obt@̃AhXisv͂mtkkj			*/
/*					lUtf8  - ϊtse|Wi[obt@̃oCgisv͂Oj					*/
/*																												*/
/*	Return		:	ϊɕKvȃobt@TCYiI[(0x00)܂ށj										*/
/*																												*/
/*	@pUtf8=NULL Ƃꍇ́AϊɕKvȃobt@TCYԂ܂B											*/
/*	@o̓obt@TCYꍇłA߂l͂njԂ܂B											*/
/*		̏ꍇA߂l̓obt@ɏo͂oCgł͂ȂAϊɕKvȃoCgԂ܂B					*/
/*==============================================================================================================*/
AJCEXPORT	int		WINAPI	AjcMbcToUtf8(C_BCP pMbc, BCP pUtf8, UI lUtf8)
{
	return AjcMbcToUtf8Ex(pMbc, -1, pUtf8, lUtf8);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	int		WINAPI	AjcMbcToUtf8Ex(C_BCP pMbc, UI lMbc, BCP pUtf8, UI lUtf8)
{
	int		lBuf = 0;
	UI		lWid;
	WCP		pWid;

	if (pMbc != NULL) {
		lWid = MultiByteToWideChar(CP_ACP, 0, pMbc, lMbc, NULL, 0);
		if (pWid = (WCP)AJCMEM(lWid * 2)) {
			MultiByteToWideChar(CP_ACP, 0, pMbc, lMbc, pWid, lWid);
			lBuf = WideCharToMultiByte(CP_UTF8, 0, pWid, lWid, NULL, 0, NULL, NULL);
			if (pUtf8 != NULL && lUtf8 != 0) {
				WideCharToMultiByte(CP_UTF8, 0, pWid, lWid, pUtf8, lUtf8, NULL, NULL);
			}
			free(pWid);
		}
	}
	return lBuf;
}
/*==============================================================================================================*/
/*	Function	:	{dtb  Vtgihrϊ														*/
/*																												*/
/*	Argument	:	pEuc   - ϊdtbR[h̃AhX												*/
/*					pSJis  - ϊVtgihri[obt@̃AhXisv͂mtkkj			*/
/*					lSJis  - ϊVtgihri[obt@̃oCgisv͂Oj				*/
/*																												*/
/*	Return		:	ϊɕKvȃobt@TCYiI[(0x00)܂ށj										*/
/*																												*/
/*	@pSJis=NULL Ƃꍇ́AϊɕKvȃobt@TCYԂ܂B											*/
/*	@o̓obt@TCYꍇłA߂l͂njԂ܂B											*/
/*		̏ꍇA߂l̓obt@ɏo͂oCgł͂ȂAϊɕKvȃoCgԂ܂B					*/
/*==============================================================================================================*/

#define	SET_SJBUF(_C_)	if (lSJis >= 1) {	\
							*pSJis++ = _C_;	\
							lSJis--;		\
						}					\
						rc++
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	int		WINAPI	AjcEucToSJis(C_BCP pEuc , BCP pSJis, UI lSJis)
{
	return AjcEucToSJisEx(pEuc, -1, pSJis, lSJis);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	int		WINAPI	AjcEucToSJisEx(C_BCP pEuc , UI lEuc, BCP pSJis, UI lSJis)
{
	int		rc	= 0;
	UI		n;
	UB		h, l;

	if (pEuc != NULL) {

		if (lEuc  == -1  ) {rc = 1;}													/*	I[tȂΏI[*/
		lEuc = AjcStrAdjustLenA(pEuc, lEuc);											/*	EUC񒷕␳						*/
		if (pSJis == NULL) {lSJis = 0;}													/*	oޯ̧ȂAޯ̧=0Ƃ	*/

		while (*pEuc != 0 && lEuc >= 1) {												/*	͂dtbR[hf[^[v		*/
			h = *pEuc;																	/*		ʃoCg					*/
			if (lEuc >= 2) l = *(pEuc + 1);												/*		ʃoCg					*/
			else		   l = 0;														/*		E								*/
			if		(h <= 0x7E) {														/*		`rbhhR[hH				*/
				SET_SJBUF(h);															/*			o̓f[^̓f[^		*/
				pEuc++;																	/*			̓f[^|C^XV		*/
				lEuc--;																	/*			c͕񒷍XV			*/
			}
			else if (h == EUC_KANA && l >= KANA_L && l <= KANA_H) {						/*		J^JiH						*/
				SET_SJBUF(l);															/*			o̓f[^ʃoCg		*/
				pEuc += 2;																/*			̓f[^|C^XV		*/
				lEuc -= 2;																/*			c͕񒷍XV			*/
			}
			else if (h >= EUC_L && h <= EUC_H && l >= EUC_L && l <= EUC_H) {			/*		SpR[hH					*/
				n = ((h - EUC_L) * EUC_NUM) + (l - EUC_L);								/*			R[hԍZo				*/
				if (n < (SJH1_NUM * SJL_NUM)) {											/*			SJIS=81`9F͈͓H		*/
					SET_SJBUF((BC)(SJH1_L + (n / (SJL_NUM))));							/*				o͏ʃoCgݒ		*/
				}
				else {																	/*			SJIS=E0`FC͈͓H		*/
					SET_SJBUF((BC)(SJH2_L + (n / (SJL_NUM) - SJH1_NUM)));				/*				o͏ʃoCgݒ		*/
				}
				n %= SJL_NUM;															/*			ʃoCg̃R[hԍZo*/
				if (n < SJL1_NUM) {														/*			SJIS=40`7E͈͓H		*/
					SET_SJBUF((BC)(SJL1_L + n));										/*				o͉ʃoCgݒ		*/
				}
				else {																	/*			SJIS=80`FC͈͓H		*/
					SET_SJBUF((BC)(SJL1_L + n + 1));									/*				o͉ʃoCgݒ		*/
				}
				pEuc += 2;																/*			̓f[^|C^XV		*/
				lEuc -= 2;																/*			c͕񒷍XV			*/
			}
			else {																		/*		sȂdtbR[hH			*/
				SET_SJBUF('?');															/*			iXLbvj			*/
				pEuc++;																	/*			̓f[^|C^XV		*/
				lEuc--;																	/*			c͕񒷍XV			*/
			}
		}

		if (lSJis >= 1) {																/*	o̓obt@ɋ󂠂H				*/
			*pSJis = 0;																	/*		I[ݒ					*/
			lSJis--;																	/*		o̓obt@TCYZ			*/
		}
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	Vtgihr  {dtbϊ														*/
/*																												*/
/*	Argument	:	pSJis  - ϊVtgihrR[h̃AhX											*/
/*					pEuc   - ϊdtbi[obt@̃AhXisv͂mtkkj				*/
/*					lEuc   - ϊdtbi[obt@̃oCgisv͂Oj						*/
/*																												*/
/*	Return		:	ϊɕKvȃobt@TCYiI[(0x00)܂ށj										*/
/*																												*/
/*	@pEuc=NULL Ƃꍇ́AϊɕKvȃobt@TCYԂ܂B											*/
/*	@o̓obt@TCYꍇłA߂l͂njԂ܂B											*/
/*		̏ꍇA߂l̓obt@ɏo͂oCgł͂ȂAϊɕKvȃoCgԂ܂B					*/
/*==============================================================================================================*/

#define	SET_EUBUF(_C_)	if (lEuc >= 1) {	\
							*pEuc++ = _C_;	\
							lEuc--;			\
						}					\
						rc++
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	int		WINAPI	AjcSJisToEuc(C_BCP pSJis, BCP pEuc , UI lEuc )
{
	return AjcSJisToEucEx(pSJis, -1, pEuc, lEuc);
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJCEXPORT	int		WINAPI	AjcSJisToEucEx(C_BCP pSJis, UI lSJis, BCP pEuc , UI lEuc )
{
	int		rc	= 0;
	UI		n;
	UB		h, l;

	if (pSJis != NULL) {

		if (lSJis == -1  ) {rc = 1;}													/*	I[tȂΏI[*/
		lSJis = AjcStrAdjustLenA(pSJis, lSJis);											/*	SJIS񒷕␳					*/
		if (pEuc  == NULL) {lEuc = 0;}													/*	oޯ̧ȂAޯ̧=0Ƃ	*/

		while (*pSJis != 0 && lSJis >= 1) {												/*	ͼJISR[hf[^[v		*/
			h = (UB)*pSJis;																/*		ʃoCg					*/
			if (lSJis >= 2) l = (UB)*(pSJis + 1);										/*		ʃoCg					*/
			else			l = 0;														/*		E								*/
			if		(h <= 0x7E) {														/*		`rbhhR[hH				*/
				SET_EUBUF(h);															/*			o̓f[^̓f[^		*/
				pSJis++;																/*			̓f[^|C^XV		*/
				lSJis--;																/*			c͕񒷍XV			*/
			}
			else if (h >= KANA_L && h <= KANA_H) {										/*		J^JiH						*/
				SET_EUBUF(EUC_KANA);													/*			o͏ʃoCgݒ			*/
				SET_EUBUF(h);															/*			o̓f[^ʃoCg		*/
				pSJis++;																/*			̓f[^|C^XV		*/
				lSJis--;																/*			c͕񒷍XV			*/
			}
			else if (((h >= SJH1_L && h <= SJH1_H) || (h >= SJH2_L && h <= SJH2_H)) &&	/*		SpR[hH					*/
					 ((l >= SJL1_L && l <= SJL1_H) || (l >= SJL2_L && l <= SJL2_H))) {	/*		E								*/
				if (h < 0xF0) {															/*			ϊ\R[hH			*/
					if (h <= SJH1_H) n	= ( 		   h - SJH1_L ) * SJL_NUM;			/*				R[hԍZo			*/
					else			 n	= (SJH1_NUM + (h - SJH2_L)) * SJL_NUM;			/*				E						*/
					if (l <= SJL1_H) n +=			  (l - SJL1_L);						/*				E						*/
					else			 n += (SJL1_NUM + (l - SJL2_L));					/*				E						*/
					SET_EUBUF((BC)(EUC_L + (n / EUC_NUM)));								/*				o͏ʃoCgݒ		*/
					SET_EUBUF((BC)(EUC_L + (n % EUC_NUM)));								/*				o͉ʃoCgݒ		*/
				}
				else {																	/*			ϊs\R[hH			*/
					SET_EUBUF(EUC_H);													/*				FEFEݒ				*/
					SET_EUBUF(EUC_H);													/*				E						*/
				}
				pSJis += 2;																/*			̓f[^|C^XV		*/
				lSJis -= 2;																/*			c͕񒷍XV			*/
			}
			else {																		/*		sȼJISR[hH			*/
				SET_EUBUF('?');															/*			iXLbvj			*/
				pSJis++;																/*			̓f[^|C^XV		*/
				lSJis--;																/*			c͕񒷍XV			*/
			}
		}

		if (lEuc >= 1) {																/*	o̓obt@ɋ󂠂H				*/
			*pEuc = 0;																	/*		I[ݒ					*/
			lEuc--;																		/*		o̓obt@TCYZ			*/
		}
	}
	return rc;
}

/*==============================================================================================================*/
/*	Function	:	̃R[h`FbN																		*/
/*																												*/
/*	Argument	:	pStr  - R[h`FbN镶̃AhX												*/
/*																												*/
/*	Return		:	-1F̃R[hʁiAJCMBC_SJIS / _EUC / _UTF8)										*/
/*					-1Fʕs\																				*/
/*==============================================================================================================*/
AJCEXPORT	AJCMBCKIND		WINAPI	AjcStrChkCode(C_BCP pStr)
{
	AJCMBCKIND	rc = -1;
	int			i;
	int			MaxPer = 0;
	struct	{int per; AJCMBCKIND k;} s[4];

	memset(s, 0, sizeof s);

	if (pStr != NULL && strlen(pStr) >= 8) {
		s[0].per = AjcStrIsSJis(pStr);	s[0].k = AJCMBC_SJIS;
		s[1].per = AjcStrIsEuc (pStr);	s[1].k = AJCMBC_EUC;
		s[2].per = AjcStrIsUtf8(pStr);	s[2].k = AJCMBC_UTF8;
		for (i = 0; i < 4; i++) {
			if (s[i].per > MaxPer) {
				MaxPer = s[i].per;
				rc	   = s[i].k;
			}
		}
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	̃R[h`FbNigŁj															*/
/*																												*/
/*	Argument	:	pStr  - R[h`FbN镶̃AhX												*/
/*					lStr  - R[h`FbN镶̃oCgi-1Fj									*/
/*																												*/
/*	Return		:	-1F̃R[hʁiAJCMBC_SJIS / _EUC / _UTF8)										*/
/*					-1Fʕs\																				*/
/*==============================================================================================================*/
AJCEXPORT	EAJCTEC		WINAPI	AjcStrChkCodeEx(C_BCP pStr, UI lStr)
{
	EAJCTEC rc	 = (EAJCTEC)-1;
	BCP		pBuf = NULL;
	int		perSJis = 0;
	int		perEuc	= 0;
	int		perUtf8 = 0;
	int		lpi 	= 0;

	if (pStr != NULL && lStr >= 8) {
		do {
			//	UNICODE`FbN
			//		UTF-16LE
			lpi = IS_TEXT_UNICODE_CONTROLS;
			IsTextUnicode(pStr, lStr, &lpi);
			if (lpi == IS_TEXT_UNICODE_CONTROLS) {
				rc = AJCTEC_UTF_16LE;
				break;
			}
			//		UTF-16BE
			lpi = IS_TEXT_UNICODE_REVERSE_CONTROLS;
			IsTextUnicode(pStr, lStr, &lpi);
			if (lpi == IS_TEXT_UNICODE_REVERSE_CONTROLS) {
				rc = AJCTEC_UTF_16BE;
				break;
			}
			//	MBC(SJIS), EUC-J or UTF-8 `FbN
			perSJis = AjcStrIsSJisEx(pStr, lStr);
			perEuc	= AjcStrIsEucEx (pStr, lStr);
			perUtf8 = AjcStrIsUtf8Ex(pStr, lStr);
			if		(perUtf8 > perSJis &&  perUtf8 > perEuc ) {
				rc = AJCTEC_UTF_8;
			}
			else if (perEuc  > perSJis &&  perEuc  > perUtf8) {
				rc = AJCTEC_EUC_J;
			}
			else {
				rc = AJCTEC_MBC;
			}
		} while(0);
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	ihr`FbN																		*/
/*																												*/
/*	Argument	:	pStr  - JISR[hł邩`FbN镶̃AhX										*/
/*																												*/
/*	Return		:	JISR[hłm[%]																		*/
/*==============================================================================================================*/
AJCEXPORT	int		WINAPI	AjcStrIsJis (C_BCP pStr)
{
	int		rc = 0;

	if (pStr != NULL) {
		if (mbsstr(pStr, "\x1B\x28\x42") != NULL	||		//	ASCII			\x1B(B	ASCIIJn
			mbsstr(pStr, "\x1B\x28\x4A") != NULL	||		//	JIS[}		\x1B(J	JIS[}̊Jn
			mbsstr(pStr, "\x1B\x28\x49") != NULL	||		//	JISJi		\x1B(I	pJ^Ji̊Jn
			mbsstr(pStr, "\x1B\x24\x40") != NULL	||		//	JIS		\x1B$@	̊Jn(JIS JIS C 6226-1978)
			mbsstr(pStr, "\x1B\x24\x42") != NULL	||		//	VJIS		\x1B$B	̊Jn(VJIS JIS X 0208-1983 / 1990)
			mbsstr(pStr, "\x1B\x26\x40") != NULL	||		//	VJIS		\x1B&@	̊Jn(VJIS JIS X 0208-1990)
			mbsstr(pStr, "\x1B\x24\x44")) {					//	JIS⏕		\x1B$D	
			rc = 100;
		}
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	r|ihr`FbN																	*/
/*																												*/
/*	Argument	:	pStr  - S-JISR[hł邩`FbN镶̃AhX										*/
/*					lStr  - ̒i-1Fj															*/
/*																												*/
/*	Return		:	S-JISR[hłm[%]																	*/
/*==============================================================================================================*/
AJCEXPORT	int		WINAPI	AjcStrIsSJis(C_BCP pStr)
{
	return AjcStrIsSJisEx(pStr, -1);
}
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT	int		WINAPI	AjcStrIsSJisEx(C_BCP pStr, UI lStr)
{
	int		rc	= 0;
	UI		len = 0;
	C_UBP	p, q;

	if (pStr != NULL) {
		if (lStr == -1) {
			lStr = (UI)strlen(pStr);
		}
		if (lStr > 0) {
			p = (C_UBP)pStr;
			while (len < lStr && *p != 0) {
				q = p + 1;
				if ((len + 1 < lStr) && _ismbblead(*p) && _ismbbtrail(*q)) {	//	S-JIS}`oCg
					if ((*p >= EUC_L && *p <= EUC_H) && (*q >= EUC_L && *q <= EUC_H)) {		//	dtbƏdH
						p += 2; len += 2;
						rc += 3;
					}
					else if ((*p >= 0x80 && *p <= 0xBF) && (*q >= 0x80 && *q <= 0xBF)) {	//	UTF-8ƏdH
						p += 2;	len += 2;
						rc += 3;
					}
					else {																	//	dȂ
						p += 2;	len += 2;
						rc += 4;
					}
				}
				else if (*p >= KANA_L && *p <= KANA_H) {				//	Ji
					p++;	len++;
					rc += 1;
				}
				else if (*p >= 0x00 && *p <= 0x7F) {					//	ASCII
					p++;	len++;
					rc += 1;
				}
				else {													//	̑
					p++;	len++;
				}
			}
			if (len != 0) {
				rc = (int)((ULL)rc * 100 / ((ULL)len * 2));
			}
			else rc = 0;
		}
		else rc = 0;
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	dtb`FbN																		*/
/*																												*/
/*	Argument	:	pStr  - dtbR[hł邩`FbN镶̃AhX									*/
/*					lStr  - ̒i-1Fj															*/
/*																												*/
/*	Return		:	dtbR[hłm[%]																	*/
/*==============================================================================================================*/
AJCEXPORT	int		WINAPI	AjcStrIsEuc (C_BCP pStr)
{
	return AjcStrIsEucEx (pStr, -1);
}
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT	int		WINAPI	AjcStrIsEucEx (C_BCP pStr, UI lStr)
{
	int		rc	= 0;
	UI		len = 0;
	UI		i;
	C_UBP	p, q;

	if (pStr != NULL) {
		if (lStr == -1) {
			lStr = (UI)strlen(pStr);
		}
		if (lStr > 0 && lStr < 0x7FFFFFFF) {
			p = (C_UBP)pStr;
			while (len < lStr && *p != 0) {
				q = p + 1;
				if (len + 1 < lStr && *p == EUC_KANA && (*q >= KANA_L && *q <= KANA_H)) {
					p += 2;	len += 2;
					rc += 4;
				}
				else if (len + 2 < lStr && *p == EUC_3BYTE) {
					p++;	len++;
					for (i = 0; i < 2 && *p >= 0x80 && *p <= 0xBF && *p != 0; i++, p++, len++);
					if (i >= 2) rc += 6;
				}
				else if (len + 2 < lStr && (*p >= EUC_L && *p <= EUC_H) && (*q >= EUC_L && *q <= EUC_H)) {
					if		(_ismbblead(*p) && _ismbbtrail(*q)) {							//	MBC(SJIS)ƏdH
						p += 2;	len += 2;
						rc += 3;
					}
					else if ((*p >= 0x80 && *p <= 0xBF) && (*q >= 0x80 && *q <= 0xBF)) {	//	UTF-8ƏdH
						p += 2;	len += 2;
						rc += 3;
					}
					else {																	//	MBC(SJIS)^UTF-8ƏdȂH
						p += 2;	len += 2;
						rc += 4;
					}
				}
				else if (*p >= 0x00 && *p <= 0x7F) {
					p++;	len++;
					rc += 1;
				}
				else {
					p++;	len++;
				}
			}
			if (len != 0) {
				rc = (int)((ULL)rc * 100 / ((ULL)len * 2));
			}
			else rc = 0;
		}
		else rc = 0;
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	tse|W`FbN																	*/
/*																												*/
/*	Argument	:	pStr  - tse|WR[hł邩`FbN镶̃AhX								*/
/*																												*/
/*	Return		:	tse|WR[hłm[%]																*/
/*==============================================================================================================*/
AJCEXPORT	int		WINAPI	AjcStrIsUtf8(C_BCP pStr)
{
	return AjcStrIsUtf8Ex(pStr, -1);
}
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT	int		WINAPI	AjcStrIsUtf8Ex(C_BCP pStr, UI lStr)
{
	int		rc = 0;
	UI		len = 0;
	C_UBP	p;

	if (pStr != NULL) {
		if (lStr == -1) {
			lStr = (UI)strlen(pStr);
		}
		if (lStr > 0 && lStr < 0x7FFFFFFF) {
			if (lStr >= 3 && memcmp(pStr, "\xEF\xBB\xBF", 3) == 0) {		//	BOM
				rc = 100;
			}
			else {
				p = (C_UBP)pStr;
				while (len < lStr && *p != 0) {
					UB		b4 = (UB)(*p & 0xF0);
					UB		b6 = (UB)(*p & 0xFC);
					UI		i;

					if		(b6 == 0xFC) {
						p++;	len++;
						for (i = 0; i < 5 && len < lStr && *p >= 0x80 && *p <= 0xBF && *p != 0; i++, p++, len++);
						if (i >= 5) rc += 12;
					}
					else if (b6 == 0xF8) {
						p++;	len++;
						for (i = 0; i < 4 && len < lStr && *p >= 0x80 && *p <= 0xBF && *p != 0; i++, p++, len++);
						if (i >= 4) rc += 10;
					}
					else if (b6 == 0xF0) {
						p++;	len++;
						for (i = 0; i < 3 && len < lStr && *p >= 0x80 && *p <= 0xBF && *p != 0; i++, p++, len++);
						if (i >= 3) rc += 8;
					}
					else if (b4 == 0xE0) {
						p++;	len++;
						for (i = 0; i < 2 && len < lStr && *p >= 0x80 && *p <= 0xBF && *p != 0; i++, p++, len++);
						if (i >= 2) rc += 6;
					}
					else if (b4 == 0xC0 || b4 == 0xD0) {
						p++;	len++;
						for (i = 0; i < 1 && len < lStr && *p >= 0x80 && *p <= 0xBF && *p != 0; i++, p++, len++);
						if (i >= 1) rc += 4;
					}
					else if (*p >= 0x00 && *p <= 0x7F) {
						p++;	len++;
						rc += 1;
					}
					else {
						p++;	len++;
					}
				}
				if (len != 0) {
					rc = (int)((ULL)rc * 100 / ((ULL)len * 2));
				}
				else rc = 0;
			}
		}
		else rc = 0;
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	R[h`FbNiCX^Xj														*/
/*																												*/
/*	Argument	:	BufSize  - R[h`FbNpobt@̃TCYiPU`POQSj							*/
/*					DefCode	 - ftHgR[h																*/
/*																												*/
/*	Return		:	NULLFnjiCX^Xnhj														*/
/*					NULLFG[																				*/
/*==============================================================================================================*/
AJCEXPORT	HAJCMBC		WINAPI	AjcMbcCreate (UI BufSize, AJCMBCKIND DefCode)
{
	HAJCMBC		pW = NULL;

	if (pW = (HAJCMBC)AJCMEM(sizeof(AJCMBC))) {
		memset(pW, 0, sizeof(AJCMBC));
		pW->MbcDef	= DefCode;
		pW->BufSize	= __max(BufSize    , AJCMIN_MBCBUF);
		pW->BufSize	= __min(pW->BufSize, AJCMAX_MBCBUF);
		AjcMbcReset(pW);
	}
	return pW;
}
/*==============================================================================================================*/
/*	Function	:	R[h`FbNiZbgj																*/
/*																												*/
/*	Argument	:	pW		- CX^Xnh																*/
/*																												*/
/*	Return		:	TRUE - OK, FALSE - Error																	*/
/*==============================================================================================================*/
AJCEXPORT	BOOL		WINAPI	AjcMbcReset  (HAJCMBC pW)
{
	BOOL	rc = FALSE;

	if (pW != NULL) {
		pW->MbcKind	= pW->MbcDef;
		pW->MbcIx		= 0;
		memset(pW->MbcBuf, 0, sizeof pW->MbcBuf);
		rc = TRUE;
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	R[h`FbNif[^^j														*/
/*																												*/
/*	Argument	:	pW		- CX^Xnh																*/
/*					pStr	- ^镶̃AhX															*/
/*																												*/
/*	Return		:	TRUE - OK, FALSE - Error																	*/
/*==============================================================================================================*/
AJCEXPORT	BOOL		WINAPI	AjcMbcPutData(HAJCMBC pW, C_BCP pStr)
{
	BOOL	rc = FALSE;
	UI		i, stl;

	if (pW != NULL && pStr != NULL) {
		//--- obt@֑Sp~ -------//
		stl = (UI)strlen(pStr);
		for (i = 0; i < stl; i++) {
		//	BC	prev, cmin;
		//	prev = (pW->MbcIx != 0) ? pW->MbcBuf[pW->MbcIx - 1] : pW->MbcBuf[pW->BufSize -1];
		//	if (_ismbblead(prev)) cmin = 0x40;
		//	else				  cmin = 0x80;
		//	if (pStr[i] >= cmin) {
				pW->MbcBuf[pW->MbcIx] = pStr[i];
				pW->MbcIx = ((pW->MbcIx + 1) % pW->BufSize);
		//	}
		}
		//--- ߂lnj -------------------//
		rc = TRUE;
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	R[h`FbNi`FbNj																*/
/*																												*/
/*	Argument	:	pW		- CX^Xnh																*/
/*																												*/
/*	Return		:	OFnjiR[hʁj																*/
/*					OFG[iʕs\j																	*/
/*==============================================================================================================*/
AJCEXPORT	AJCMBCKIND	WINAPI	AjcMbcCheck  (HAJCMBC pW)
{
	AJCMBCKIND	rc = 0;

	if (pW != NULL) {
		rc = AjcStrChkCode(pW->MbcBuf);
	}
	return rc;
}
/*==============================================================================================================*/
/*	Function	:	R[h`FbNiCX^Xj														*/
/*																												*/
/*	Argument	:	pW		- CX^Xnh																*/
/*																												*/
/*	Return		:	OFnjiR[hʁj																*/
/*					OFG[																				*/
/*==============================================================================================================*/
AJCEXPORT	VO			WINAPI	AjcMbcDelete (HAJCMBC pW)
{
	if (pW != NULL) {
		free(pW);
	}
}
//==============================================================================================================//
//	pXƃt@C𔽑΂ɂ쐬iex. "d:\sub1\x.txt" --> "x.txt;d:\sub1\"j					//
//																												//
//	@	F	pPath - t@CpX̃AhX																//
//				pBuf  - ΂ɂpXi[obt@̃AhX									//
//				lBuf  - ΂ɂpXi[obt@̕									//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrCnvRevPathA(BCP pPath, BCP pBuf, int lBuf)
{
	BOOL	rc = FALSE;
	BC		drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], fext[_MAX_EXT];

	if (pPath != NULL && pBuf != NULL && lBuf > 0) {
		_splitpath(pPath, drv, dir, fname, fext);
		AjcSnPrintFA(pBuf, lBuf, "%s%s;%s%s", fname, fext, drv, dir);
		rc = TRUE;
	}

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrCnvRevPathW(WCP pPath, WCP pBuf, int lBuf)
{
	BOOL	rc = FALSE;
	UW		drv[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], fext[_MAX_EXT];

	if (pPath != NULL && pBuf != NULL && lBuf > 0) {
		_wsplitpath(pPath, drv, dir, fname, fext);
		AjcSnPrintFW(pBuf, lBuf, L"%s%s;%s%s", fname, fext, drv, dir);
		rc = TRUE;
	}

	return rc;
}
//==============================================================================================================//
//	pXƃt@C𔽑΂ɂpXɖ߂																//
//																												//
//	@	F	pRev  - ΂ɂpX																		//
//				pBuf  - ɖ߂pXi[obt@̃AhX										//
//				lBuf  - ɖ߂pXi[obt@̕										//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrRetRevPathA(BCP pRev, BCP pBuf, int lBuf)
{
	BOOL	rc = FALSE;
	BCP		pTop, p;

	if (pRev != NULL && pBuf != NULL && lBuf > 0) {
		if (pTop = (BCP)AJCMEM(strlen(pRev) + 1)) {
			strcpy(pTop, pRev);
			//----- pXݒ ------------------------------------------------//
			 if (p = mbsstr(pTop, ";")) {
				p++;
				while (*p != 0	&&	lBuf > 1) {
					*pBuf++ = *p++;
					lBuf--;
				}
			}
			//----- t@Cݒ ------------------------------------------//
			p = pTop;
			while (*p != ';'  &&  *p != 0  &&  lBuf > 1) {
				*pBuf++ = *p++;
				lBuf--;
			}
			//----- I[ݒ ------------------------------------------//
			*pBuf = 0;
			//----- ꎞobt@ ----------------------------------------//
			free(pTop);
			//----- ߂l= ---------------------------------------------//
			rc = TRUE;
		}
	}

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrRetRevPathW(WCP pRev, WCP pBuf, int lBuf)
{
	BOOL	rc = FALSE;
	WCP		pTop, p;

	if (pRev != NULL && pBuf != NULL && lBuf > 0) {
		if (pTop = (WCP)AJCMEM((wcslen(pRev) + 1) * 2)) {
			wcscpy(pTop, pRev);
			//----- pXݒ ------------------------------------------------//
			 if (p = wcsstr(pTop, L";")) {
				p++;
				while (*p != 0	&&	lBuf > 1) {
					*pBuf++ = *p++;
					lBuf--;
				}
			}
			//----- t@Cݒ ------------------------------------------//
			p = pTop;
			while (*p != L';'  &&  *p != 0	&&	lBuf > 1) {
				*pBuf++ = *p++;
				lBuf--;
			}
			//----- I[ݒ ------------------------------------------//
			*pBuf = 0;
			//----- ꎞobt@ ----------------------------------------//
			free(pTop);
			//----- ߂l= ---------------------------------------------//
			rc = TRUE;
		}
	}

	return rc;
}
//==============================================================================================================//
//	񂪑Sēꕶō\Ă邩`FbN																//
//																												//
//	@	F	pPath - t@CpX̃AhX																//
//				pStr  - `FbN镶̃AhX															//
//				c	  - `FbN镶																		//
//																												//
//	߂l	F	TRUE  - ͑SĎw肳ꂽō\Ă												//
//				FALSE - 񒆂Ɏw肳ꂽȊO܂܂Ăi󕶎܂ށj							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrSameAsAllCharA(C_BCP pStr, BC c)
{
	BOOL	rc = FALSE;

	if (pStr != NULL && *pStr != 0) {
		while (*pStr == c && *pStr != 0) {
			pStr++;
		}
		rc = (*pStr == 0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcStrSameAsAllCharW(C_WCP pStr, WC c)
{
	BOOL	rc = FALSE;

	if (pStr != NULL && *pStr != 0) {
		while (*pStr == c && *pStr != 0) {
			pStr++;
		}
		rc = (*pStr == 0);
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	ȂPOi񁨐lϊ															//
//																												//
//	Argument	:	pStr  - lɕϊ镄ȂPOĩAhX										//
//																												//
//	Return		:	ϊl																				//
//==============================================================================================================//
//----- oCgPOipithmsj------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcDecToUIA(C_BCP pStr)
{
	ULL		rc = 0;

	while (MAjcIsBlankA((UB)*pStr)) pStr++;

	while (_ismbcdigit((UB)*pStr)) {
		rc *= 10;
		rc += (*pStr & 15);
		if (rc > UINT_MAX) {
			rc = UINT_MAX;
			break;
		}
		pStr++;
	}
	return (UI)rc;
}
//----- oCgPOipitknmf knmfj-------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcDecToULLA(C_BCP pStr)
{
	ULL		rc = 0;

	while (MAjcIsBlankA((UB)*pStr)) pStr++;

	while (_ismbcdigit((UB)*pStr)) {
		rc *= 10;
		rc += (*pStr & 15);
		pStr++;
	}
	return rc;
}
//----- ChPOipithmsj------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcDecToUIW(C_WCP pStr)
{
	ULL		rc = 0;

	while (MAjcIsBlankW(*pStr)) pStr++;

	while (MAjcAscIsDigitW(*pStr)) {
		rc *= 10;
		rc += (*pStr & 15);
		if (rc > UINT_MAX) {
			rc = UINT_MAX;
			break;
		}
		pStr++;
	}
	return (UI)rc;
}
//----- ChPOipitknmf knmfj-------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcDecToULLW(C_WCP pStr)
{
	ULL		rc = 0;

	while (MAjcIsBlankW(*pStr)) pStr++;

	while (MAjcAscIsDigitW(*pStr)) {
		rc *= 10;
		rc += (*pStr & 15);
		pStr++;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	PU^Wi񁨐lϊ																//
//																												//
//	Argument	:	pStr  - lɕϊPUi^WĩAhX										//
//																												//
//	Return		:	ϊl																				//
//==============================================================================================================//
//----- oCgPUipihmsj--------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcHexToUIA(C_BCP pStr)
{
	UI		rc = 0;

	while (MAjcIsBlankA((UB)*pStr)) pStr++;

	if (*pStr == '0' && (*(pStr + 1) | 0x20) == 'x') {
		pStr += 2;
	}

	while (MAjcIsXDigit((UB)*pStr)) {
		rc <<= 4;
		if (_ismbcdigit(*pStr)) rc |= ( *pStr & 15);
		else					rc |= ((*pStr & 15) + 9);
		pStr++;
	}
	return rc;
}
//----- oCgPUipiknmf knmfj---------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcHexToULLA(C_BCP pStr)
{
	ULL		rc = 0;

	while (MAjcIsBlankA((UB)*pStr)) pStr++;

	if (*pStr == '0' && (*(pStr + 1) | 0x20) == 'x') {
		pStr += 2;
	}

	while (MAjcIsXDigit((UB)*pStr)) {
		rc <<= (ULL)4;
		if (_ismbcdigit(*pStr)) rc |= ( *pStr & 15);
		else					rc |= ((*pStr & 15) + 9);
		pStr++;
	}
	return rc;
}
//----- oCgWipihmsj----------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcOctToUIA(C_BCP pStr)
{
	UI		rc = 0;

	while (MAjcIsBlankA((UB)*pStr)) pStr++;

	while (*pStr >= '0' && *pStr <= '7') {
		rc <<= 3;
		rc |= ( *pStr & 15);
		pStr++;
	}
	return rc;
}
//----- oCgWipiknmf knmfj-----------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcOctToULLA(C_BCP pStr)
{
	ULL		rc = 0;

	while (MAjcIsBlankA((UB)*pStr)) pStr++;

	while (*pStr >= '0' && *pStr <= '7') {
		rc <<= 3;
		rc |= ( *pStr & 15);
		pStr++;
	}
	return rc;
}

//----- ChPUipihmsj--------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcHexToUIW(C_WCP pStr)
{
	UI		rc = 0;

	while (MAjcIsBlankW(*pStr)) pStr++;

	if (*pStr == L'0' && (*(pStr + 1) | 0x20) == L'x') {
		pStr += 2;
	}

	while (MAjcAscIsXDigitW(*pStr)) {
		rc <<= 4;
		if (MAjcAscIsDigitW(*pStr)) rc |= ( *pStr & 15);
		else						rc |= ((*pStr & 15) + 9);
		pStr++;
	}
	return rc;
}
//----- ChPUipiknmf knmfj---------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcHexToULLW(C_WCP pStr)
{
	ULL		rc = 0;

	while (MAjcIsBlankW(*pStr)) pStr++;

	if (*pStr == L'0' && (*(pStr + 1) | 0x20) == L'x') {
		pStr += 2;
	}

	while (MAjcAscIsXDigitW(*pStr)) {
		rc <<= 4;
		if (MAjcAscIsDigitW(*pStr)) rc |= ( *pStr & 15);
		else						rc |= ((*pStr & 15) + 9);
		pStr++;
	}
	return rc;
}

//----- ChWipihmsj----------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcOctToUIW(C_WCP pStr)
{
	UI		rc = 0;

	while (MAjcIsBlankW(*pStr)) pStr++;

	while (*pStr >= L'0' && *pStr <= L'7') {
		rc <<= 3;
		rc |= ( *pStr & 15);
		pStr++;
	}
	return rc;
}
//----- ChWipiknmf knmfj-----------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcOctToULLW(C_WCP pStr)
{
	ULL		rc = 0;

	while (MAjcIsBlankW(*pStr)) pStr++;

	while (*pStr >= L'0' && *pStr <= L'7') {
		rc <<= 3;
		rc |= ( *pStr & 15);
		pStr++;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	PO^PUi񁨐lϊiPO^PUi͎ʁj									//
//																												//
//	Argument	:	pStr  - lɕϊPO^PUĩAhXi擪'0x'̏ꍇ͂PUij			//
//																												//
//	Return		:	ϊl																				//
//==============================================================================================================//
//----- oCgpihmsj--------------------------------------------------------------------------------//
AJCEXPORT	SI		WINAPI	AjcAscToIntA(C_BCP pStr)
{
	UI		rc = 0;

	while (MAjcIsBlankA((UB)*pStr)) pStr++;

	if (*pStr == '0' && (*(pStr + 1) | 0x20) == 'x') {
		rc = AjcHexToUIA(pStr);
	}
	else {
		rc = atoi(pStr);
	}

	return rc;
}
//----- oCgpiknmf knmfj---------------------------------------------------------------------//
AJCEXPORT	SLL		WINAPI	AjcAscToLIntA(C_BCP pStr)
{
	ULL		rc = 0;

	while (MAjcIsBlankA((UB)*pStr)) pStr++;

	if (*pStr == '0' && (*(pStr + 1) | 0x20) == 'x') {
		rc = AjcHexToULLA(pStr);
	}
	else {
		rc = _atoi64(pStr);
	}

	return rc;
}
//----- Chpihmsj--------------------------------------------------------------------------------//
AJCEXPORT	SI		WINAPI	AjcAscToIntW(C_WCP pStr)
{
	UI		rc = 0;

	while (MAjcIsBlankW(*pStr)) pStr++;

	if (*pStr == L'0' && (*(pStr + 1) | 0x20) == L'x') {
		rc = AjcHexToUIW(pStr);
	}
	else {
		rc = _wtoi(pStr);
	}

	return rc;
}
//----- Chpiknmf knmfj---------------------------------------------------------------------//
AJCEXPORT	SLL		WINAPI	AjcAscToLIntW(C_WCP pStr)
{
	ULL		rc = 0;
	BC		tmp[64];

	while (MAjcIsBlankW(*pStr)) pStr++;

	if (*pStr == L'0' && (*(pStr + 1) | 0x20) == L'x') {
		rc = AjcHexToULLW(pStr);
	}
	else {
		WideCharToMultiByte(CP_ACP, 0, pStr, -1, tmp, 64, NULL, NULL);
		tmp[63] = 0;
		rc = _atoi64(tmp);
	}

	return rc;
}
//==============================================================================================================//
//	Function	:	񁨐lϊ																		//
//																												//
//	Argument	:	pStr  - lɕϊ̃AhX													//
//																												//
//	Return		:	ϊlij																		//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	double	WINAPI	AjcAscToRealA(C_BCP pStr)
{
	double	rc = 0.0;

	if (pStr != NULL) {
		while (MAjcIsBlankA(*pStr)) pStr++;

		if (strnicmp(pStr, "0x", 2) == 0) {
			rc = (double)AjcAscToLIntA(pStr);
		}
		else {
			rc = atof(pStr);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	double	WINAPI	AjcAscToRealW(C_WCP pStr)
{
	double	rc = 0.0;

	if (pStr != NULL) {
		while (MAjcIsBlankW(*pStr)) pStr++;

		if (wcsnicmp(pStr, L"0x", 2) == 0) {
			rc = (double)AjcAscToLIntW(pStr);
		}
		else {
			rc = _wtof(pStr);
		}
	}
	return rc;
}


//==============================================================================================================//
//	w蕶ŋ؂ꂽ̐l𓾂																		//
//																												//
//	@	F	pStr - ؂ꂽlQ̃AhX															//
//				sep	 - ؂蕶																				//
//				pTyp - ľƃ^Cv\̃AhXii:int, l:long long, f:doublej					//
//				...	 - 擾li[obt@̃AhXQinumŎw肵j							//
//																												//
//	߂l	F	擾ľ																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcGetSepNumbersA(C_BCP pStr, BC sep, C_BCP pTyp, ...)
{
	UI		rc = 0;
	union {UBP bp; UWP wp; UIP ip; ULLP lp; double *fp; VOP vp;} u;
	va_list vls;

	if (pStr != NULL && pTyp != NULL) {
		va_start(vls, pTyp);
		while (MAjcIsBlankA(*pStr)) pStr++;
		while (*pTyp != 0 && *pStr != 0) {
			u.vp = (VOP)va_arg(vls, VOP);
			if (*pStr != sep && u.vp != NULL) {
				switch (*pTyp) {
					case 'b': case 'B': *u.bp = (UB)AjcAscToIntA (pStr);	rc++; break;
					case 'w': case 'W': *u.wp = (UW)AjcAscToIntA (pStr);	rc++; break;
					case 'i': case 'I':	*u.ip =		AjcAscToIntA (pStr);	rc++; break;
					case 'l': case 'L':	*u.lp =		AjcAscToLIntA(pStr);	rc++; break;
					case 'f': case 'F':	*u.fp =		AjcAscToRealA(pStr);	rc++; break;
				}
			}
			pTyp++;
			while (*pStr != sep && *pStr != 0) pStr++;
			if (*pStr == sep) pStr++;
			while (MAjcIsBlankA(*pStr)) pStr++;
		}
		va_end(vls);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcGetSepNumbersW(C_WCP pStr, WC sep, C_WCP pTyp, ...)
{
	UI		rc = 0;
	union {UBP bp; UWP wp; UIP ip; ULLP lp; double *fp; VOP vp;} u;
	va_list vls;

	if (pStr != NULL && pTyp != NULL) {
		va_start(vls, pTyp);
		while (MAjcIsBlankW(*pStr)) pStr++;
		while (*pTyp != 0 && *pStr != 0) {
			u.vp = (VOP)va_arg(vls, VOP);
			if (*pStr != sep && u.vp != NULL) {
				switch (*pTyp) {
					case L'b': case L'B': *u.bp = (UB)AjcAscToIntW (pStr);	rc++; break;
					case L'w': case L'W': *u.wp = (UW)AjcAscToIntW (pStr);	rc++; break;
					case L'i': case L'I': *u.ip =	  AjcAscToIntW (pStr);	rc++; break;
					case L'l': case L'L': *u.lp =	  AjcAscToLIntW(pStr);	rc++; break;
					case L'f': case L'F': *u.fp =	  AjcAscToRealW(pStr);	rc++; break;
				}
			}
			pTyp++;
			while (*pStr != sep && *pStr != 0) pStr++;
			if (*pStr == sep) pStr++;
			while (MAjcIsBlankW(*pStr)) pStr++;
		}
		va_end(vls);
	}
	return rc;
}
//==============================================================================================================//
//	ړɑp^擾																					//
//																												//
//	@	F	pParam	- p^																		//
//				pPrefix	- p^ړ																		//
//				pVal	- p^ړɑ񂪕\li[obt@		isvNULLj		//
//				pBuf	- p^ړɑi[obt@̃AhX		isvNULLj		//
//				pBuf	- p^ړɑi[obt@̃oCg^						//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - sip^̐擪̓p^ړƈvȂj								//
//																												//
//	Ex.		AjcHexStrToUBA("/P123", "/P", &val, buf, sizeof buf); --> val=123, buf = "123"						//
//==============================================================================================================//
//----- oCgp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcGetAfterPrefixA(C_BCP pParam, C_BCP pPrefix, UIP pVal, BCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;
	UI		lParam, lPrefix;

	if (pParam != NULL && pPrefix != NULL) {
		lParam	= (UI)strlen(pParam);
		lPrefix = (UI)strlen(pPrefix);
		if (lParam >= lPrefix) {
			if (strnicmp(pParam, pPrefix, lPrefix) == 0) {	// oCgƂĂ strnicmp gpimbsnicmp͕sj
				if (pVal != NULL) {
					*pVal = AjcAscToIntA(pParam + lPrefix);
				}
				if (pBuf != NULL && lBuf > 0) {
					UI len = lParam - lPrefix + 1;
					len = __min(len, lBuf);
					strncpy(pBuf, pParam + lPrefix, len);
					pBuf[lBuf - 1] = 0;
				}
				rc = TRUE;
			}
		}
	}
	return rc;
}
//----- Chp -------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcGetAfterPrefixW(C_WCP pParam, C_WCP pPrefix, UIP pVal, WCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;
	UI		lParam, lPrefix;

	if (pParam != NULL && pPrefix != NULL) {
		lParam	= (UI)wcslen(pParam);
		lPrefix = (UI)wcslen(pPrefix);
		if (lParam >= lPrefix) {
			if (wcsnicmp(pParam, pPrefix, lPrefix) == 0) {
				if (pVal != NULL) {
					*pVal = AjcAscToIntW(pParam + lPrefix);
				}
				if (pBuf != NULL && lBuf > 0) {
					UI len = lParam - lPrefix + 1;
					len = __min(len, lBuf);
					wcsncpy(pBuf, pParam + lPrefix, len);
					pBuf[lBuf - 1] = 0;
				}
				rc = TRUE;
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	PUi񂪕\l𓾂																//
//																												//
//	Argument	:	pRec - PUi̐擪AhX															//
//					nLen - PUi̕																	//
//					pVal - PUi񂪕\li[obt@̃AhX									//
//																												//
//	Return		:	TRUE Fnj																					//
//					FALSEFG[i'0'`'F'ȊO݂̕j												//
//==============================================================================================================//
//----- oCgpi -> BYTEj--------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcHexStrToUBA(C_BCP pRec, UI nLen, UB *pVal)
{
	BOOL	rc = TRUE;

	if (pRec != NULL && pVal != NULL) {
		*pVal = 0;
		while (MAjcIsXDigitA((UB)*pRec) && nLen) {
			*pVal = ((*pVal) << 4) | (_ismbcdigit((UB)*pRec) ? (*pRec & 15) : (*pRec & 15) + 9);
			pRec++;
			nLen--;
		}
		if (nLen != 0) {
			rc = FALSE;
		}
	}
	else rc = FALSE;

	return rc;
}
//----- oCgpi -> WORDj--------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcHexStrToUWA(C_BCP pRec, UI nLen, UW *pVal)
{
	BOOL	rc = TRUE;

	if (pRec != NULL && pVal != NULL) {
		*pVal = 0;
		while (MAjcIsXDigitA((UB)*pRec) && nLen) {
			*pVal = ((*pVal) << 4) | (_ismbcdigit((UB)*pRec) ? (*pRec & 15) : (*pRec & 15) + 9);
			pRec++;
			nLen--;
		}
		if (nLen != 0) {
			rc = FALSE;
		}
	}
	else rc = FALSE;

	return rc;
}
//----- oCgpi -> UINTj--------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcHexStrToUIA(C_BCP pRec, UI nLen, UI *pVal)
{
	BOOL	rc = TRUE;

	if (pRec != NULL && pVal != NULL) {
		*pVal = 0;
		while (MAjcIsXDigitA((UB)*pRec) && nLen) {
			*pVal = ((*pVal) << 4) | (_ismbcdigit((UB)*pRec) ? (*pRec & 15) : (*pRec & 15) + 9);
			pRec++;
			nLen--;
		}
		if (nLen != 0) {
			rc = FALSE;
		}
	}
	else rc = FALSE;

	return rc;
}
//----- oCgpi -> LONG LONGj---------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcHexStrToULLA(C_BCP pRec, UI nLen, ULL *pVal)
{
	BOOL	rc = TRUE;

	if (pRec != NULL && pVal != NULL) {
		*pVal = 0;
		while (MAjcIsXDigitA((UB)*pRec) && nLen) {
			*pVal = ((*pVal) << 4) | (_ismbcdigit((UB)*pRec) ? (*pRec & 15) : (*pRec & 15) + 9);
			pRec++;
			nLen--;
		}
		if (nLen != 0) {
			rc = FALSE;
		}
	}
	else rc = FALSE;

	return rc;
}
//----- Chp ( -> BYTE)---------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcHexStrToUBW(C_WCP pRec, UI nLen, UB *pVal)
{
	BOOL	rc = TRUE;

	if (pRec != NULL && pVal != NULL) {
		*pVal = 0;
		while (MAjcAscIsXDigitW(*pRec) && nLen) {
			*pVal = ((*pVal) << 4) | (MAjcAscIsDigitW(*pRec) ? (*pRec & 15) : (*pRec & 15) + 9);
			pRec++;
			nLen--;
		}
		if (nLen != 0) {
			rc = FALSE;
		}
	}
	else rc = FALSE;

	return rc;
}

//----- Chp ( -> WORD)---------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcHexStrToUWW(C_WCP pRec, UI nLen, UW *pVal)
{
	BOOL	rc = TRUE;

	if (pRec != NULL && pVal != NULL) {
		*pVal = 0;
		while (MAjcAscIsXDigitW(*pRec) && nLen) {
			*pVal = ((*pVal) << 4) | (MAjcAscIsDigitW(*pRec) ? (*pRec & 15) : (*pRec & 15) + 9);
			pRec++;
			nLen--;
		}
		if (nLen != 0) {
			rc = FALSE;
		}
	}
	else rc = FALSE;

	return rc;
}

//----- Chp ( -> UINT)---------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcHexStrToUIW(C_WCP pRec, UI nLen, UI *pVal)
{
	BOOL	rc = TRUE;

	if (pRec != NULL && pVal != NULL) {
		*pVal = 0;
		while (MAjcAscIsXDigitW(*pRec) && nLen) {
			*pVal = ((*pVal) << 4) | (MAjcAscIsDigitW(*pRec) ? (*pRec & 15) : (*pRec & 15) + 9);
			pRec++;
			nLen--;
		}
		if (nLen != 0) {
			rc = FALSE;
		}
	}
	else rc = FALSE;

	return rc;
}
//----- Chp ( -> LONG LONG) ---------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcHexStrToULLW(C_WCP pRec, UI nLen, ULL *pVal)
{
	BOOL	rc = TRUE;

	if (pRec != NULL && pVal != NULL) {
		*pVal = 0;
		while (MAjcAscIsXDigitW(*pRec) && nLen) {
			*pVal = ((*pVal) << 4) | (MAjcAscIsDigitW(*pRec) ? (*pRec & 15) : (*pRec & 15) + 9);
			pRec++;
			nLen--;
		}
		if (nLen != 0) {
			rc = FALSE;
		}
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	Function	:	}`oCgfȂ悤Ƀ}`oCgeLXg𒊏o									//
//																												//
//	Argument	:	pBuf - }`oCgobt@AhX													//
//					lBuf - }`oCgobt@̃oCg													//
//					pIx  - obt@̗Lȃf[^BYTE(obt@̋̈̐擪Index)ϐ̃AhX	//
//					mbk  - }`oCg̕R[hiAJCMBC_SJIS / AJCMBC_EUC / AJCMBC_UTF8j				//
//																												//
//	Return		:	 NULL - }`oCgfȂ悤ɁAeLXg̃AhXiIȃj	//
//					 NULL  - eLXgȂ^G[														//
//==============================================================================================================//
static	VOP		SubExtractCompletedText (BCP pBuf, UI lBuf, UIP pIx, AJCMBCKIND mbk, BOOL fUnicode);
//----- oCgԂ -------------------------------------------------------------------------------------//
AJCEXPORT	BCP  WINAPI	AjcExtractCompletedTextA(BCP pBuf, UI lBuf, UIP pIx, AJCMBCKIND mbk)
{
	return (BCP)SubExtractCompletedText(pBuf, lBuf, pIx, mbk, FALSE);
}
//----- ChԂ -------------------------------------------------------------------------------------//
AJCEXPORT	WCP  WINAPI	AjcExtractCompletedTextW(BCP pBuf, UI lBuf, UIP pIx, AJCMBCKIND mbk)
{
	return (WCP)SubExtractCompletedText(pBuf, lBuf, pIx, mbk, TRUE);
}
//----- ʃTu -----------------------------------------------------------------------------------------------//
static	VOP		SubExtractCompletedText (BCP pBuf, UI lBuf, UIP pIx, AJCMBCKIND mbk, BOOL fUnicode)
{
	BCP			rc = NULL;
	BCP			p;
	UI			i;
	AJCMBCINFO	mbi;		//	}`oCg͏
	UI			lrx;		//	obt@̗LȃeLXg
	UI			len;		//	[ȃoCgeLXg
	UI			lHalf;		//	[}`oCg
	BC			txtHalf[8];	//	[}`oCgeLXg

	if (pBuf != NULL && lBuf != 0 && pIx != NULL && *pIx != 0 && (mbk == AJCMBC_SJIS || mbk == AJCMBC_EUC || mbk == AJCMBC_UTF8)) {
		//	CfNXobt@Ő
		if (*pIx > lBuf) *pIx = lBuf;
		//	obt@LoCgݒ
		lrx = *pIx;
		//	Lȃf[^TCYݒif[^ '\0' 邩`FbNj
		for (i = 0, p = pBuf; i < lrx && *p != 0; i++, p++);
		//	Lȃf[^ꍇEEE
		if (i != 0) {
			lrx = i;
			//	I[ݒ
			pBuf[lrx] = 0;
			//	LȃeLXgoCgݒ
			switch (mbk) {
				default:
				case AJCMBC_SJIS:	AjcStrChkMbcPart (pBuf, lrx - 1, &mbi);	break;	//	Vtgihr
				case AJCMBC_EUC:	AjcStrChkEucPart (pBuf, lrx - 1, &mbi);	break;	//	dtb@@@
				case AJCMBC_UTF8:	AjcStrChkUtf8Part(pBuf, lrx - 1, &mbi);	break;	//	tse|W@
			}
			//	[oCgݒ
			lHalf = (mbi.ix + 1) % mbi.len;
			//	LȃeLXgݒ
			if (lHalf != 0) len = lrx - (mbi.ix + 1);	//	[̏ꍇ́A[oCgZ
			else			len = lrx;					//	[Ȃ̏ꍇ́AŜLeLXg
			//	̔[}`oCgޔ
			memcpy(txtHalf, &pBuf[len], lHalf);
			txtHalf[lHalf] = 0;
			//	LeLXg̕I[ݒ
			pBuf[len] = 0;
			//	eLXgݒ
			if (len > 0) {
				//----- UNICODE --------------------------------------------------------//
				if (fUnicode) {		//	UNICODEH
					//	 S-JIS	iS-JIS -> UNICODE ϊĒʒmj
					if (mbk == AJCMBC_SJIS) {
						WCP		pWcs;
						UI		lWcs;
						lWcs = MultiByteToWideChar(CP_ACP, 0, pBuf, len, NULL, 0);
						if (pWcs = (WCP)AJCMEM((lWcs + 1) * 2)) {
							MultiByteToWideChar(CP_ACP, 0, pBuf, len, pWcs, lWcs);
							pWcs[lWcs] = 0;
							rc = (VOP)pWcs;
						}
					}
					//	 EUC iEUC -> UNICODE ϊĒʒmj
					else if (mbk == AJCMBC_EUC) {
						BCP		pSJis;
						WCP		pWcs;
						UI		lSJis, lWcs;
						lSJis = AjcEucToSJis(pBuf, NULL, 0);
						if (pSJis = (BCP)AJCMEM(lSJis)) {
							AjcEucToSJis(pBuf, pSJis, lSJis);
							lWcs = MultiByteToWideChar(CP_ACP, 0, pSJis, -1, NULL, 0);
							if (pWcs = (WCP)AJCMEM(lWcs * 2)) {
								MultiByteToWideChar(CP_ACP, 0, pSJis, -1, pWcs, lWcs);
								rc = (VOP)pWcs;
							}
							free(pSJis);
						}
					}
					//	 UTF-8 iUTF-8 -> UNICODE ϊĒʒmj
					else if (mbk == AJCMBC_UTF8) {
						WCP		pWcs;
						UI		lWcs;
						lWcs = MultiByteToWideChar(CP_UTF8, 0, pBuf, -1, NULL, 0);
						if (pWcs = (WCP)AJCMEM(lWcs * 2)) {
							MultiByteToWideChar(CP_UTF8, 0, pBuf, -1, pWcs, lWcs + 1);
							rc = (VOP)pWcs;
						}
					}
				}
				//----- }`oCg -----------------------------------------------//
				else {					//	}`oCgH
					//	 S-JIS iS-JIŜ܂ܒʒmj
					if (mbk == AJCMBC_SJIS) {
						BCP		pSJis;
						if (pSJis = (BCP)AJCMEM(len + 1)) {
							memcpy(pSJis, pBuf, len);
							pSJis[len] = 0;
							rc = (VOP)pSJis;
						}
					}
					//	 EUC iEUC -> S-JIS ϊĒʒmj
					else if (mbk == AJCMBC_EUC) {
						BCP		pSJis;
						UI		lSJis;
						lSJis = AjcEucToSJis(pBuf, NULL, 0);
						if (pSJis = (BCP)AJCMEM(lSJis)) {
							AjcEucToSJis(pBuf, pSJis, lSJis);
							rc = (VOP)pSJis;
						}
					}
					//	 UTF-8 (UTF-8 -> S-JIS ϊĒʒmj
					else if (mbk == AJCMBC_UTF8) {
						BCP		pSJis;
						UI		lSJis;
						lSJis = AjcUtf8ToMbc(pBuf, NULL, 0);
						if (pSJis = (BCP)AJCMEM(lSJis)) {
							AjcUtf8ToMbc(pBuf, pSJis, lSJis);
							rc = (VOP)pSJis;
						}
					}
				}
			}
			//	̒r}`oCg擪ɐݒ
			memcpy(pBuf, txtHalf, lHalf);
			pBuf[lHalf] = 0;
			//	߂liobt@̗LoCgjݒ
			*pIx = lHalf;
		}
		//	Lȃf[^ꍇi擪 '\0' jEEE
		else {
			*pIx = 0;
		}
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	b\LoCi																//
//																												//
//	Argument	:	pTxt - b\L̃AhX															//
//					pBuf - oCii[obt@̃AhX										//
//					lBuf - oCii[obt@̃oCg^								//
//																												//
//	Return		:	oCi̒																	//
//==============================================================================================================//
#define	CSTB_SETBUF(X)		if (pBuf != NULL) {*pBuf++ = X;}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcCLangStrToBinA(C_BCP pTxt, BCP pBuf, UI lBuf)
{
	UI		len = 0;

	if (pTxt != NULL) {
		while (*pTxt != 0 && ((pBuf == NULL) || (pBuf != NULL && len < lBuf - 1))) {
			if (*pTxt == '\\') {
				pTxt++;
				if		(*pTxt == 'a')	{CSTB_SETBUF('\a');		len++; pTxt++;}
				else if (*pTxt == 'b')	{CSTB_SETBUF('\b');		len++; pTxt++;}
				else if (*pTxt == 'e')	{CSTB_SETBUF('\x1B');	len++; pTxt++;}		//	u\ev͖{`ohƎ̃GXP[v
				else if (*pTxt == 'f')	{CSTB_SETBUF('\f');		len++; pTxt++;}
				else if (*pTxt == 'n')	{CSTB_SETBUF('\n');		len++; pTxt++;}
				else if (*pTxt == 'r')	{CSTB_SETBUF('\r');		len++; pTxt++;}
				else if (*pTxt == 't')	{CSTB_SETBUF('\t');		len++; pTxt++;}
				else if (*pTxt == 'v')	{CSTB_SETBUF('\v');		len++; pTxt++;}
				else if (*pTxt == '\\') {CSTB_SETBUF('\\');		len++; pTxt++;}
				else if (*pTxt == '?')	{CSTB_SETBUF('?');		len++; pTxt++;}
				else if (*pTxt == '\'') {CSTB_SETBUF('\'');		len++; pTxt++;}
				else if (*pTxt == '"')  {CSTB_SETBUF('"');		len++; pTxt++;}
				else if (*pTxt == 'x')	{
					pTxt++;
					if (MAjcIsXDigitA(*pTxt)) {
						CSTB_SETBUF((BC)AjcHexToUIA(pTxt));
						len++;
						while (MAjcIsXDigitA(*pTxt)) {
							pTxt++;
						}
					}
				}
				else if (*pTxt >= '0' && *pTxt <= '7') {
					CSTB_SETBUF((BC)AjcOctToUIA(pTxt));
					len++;
					while (*pTxt >= '0' && *pTxt <= '7') {
						pTxt++;
					}
				}
			}
			else {
				CSTB_SETBUF(*pTxt); pTxt++;
				len++;
			}
		}
		CSTB_SETBUF(0);
	}
	return len;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcCLangStrToBinW(C_WCP pTxt, WCP pBuf, UI lBuf)
{
	UI		len = 0;

	if (pTxt != NULL) {
		while (*pTxt != 0 && ((pBuf == NULL) || (pBuf != NULL && len < lBuf - 1))) {
			if (*pTxt == L'\\') {
				pTxt++;
				if		(*pTxt == L'a')  {CSTB_SETBUF(L'\a');	len++; pTxt++;}
				else if (*pTxt == L'b')  {CSTB_SETBUF(L'\b');	len++; pTxt++;}
				else if (*pTxt == L'e')  {CSTB_SETBUF(L'\x1B');	len++; pTxt++;}		//	u\ev͖{`ohƎ̃GXP[v
				else if (*pTxt == L'f')  {CSTB_SETBUF(L'\f');	len++; pTxt++;}
				else if (*pTxt == L'n')  {CSTB_SETBUF(L'\n');	len++; pTxt++;}
				else if (*pTxt == L'r')  {CSTB_SETBUF(L'\r');	len++; pTxt++;}
				else if (*pTxt == L't')  {CSTB_SETBUF(L'\t');	len++; pTxt++;}
				else if (*pTxt == L'v')  {CSTB_SETBUF(L'\v');	len++; pTxt++;}
				else if (*pTxt == L'\\') {CSTB_SETBUF(L'\\');	len++; pTxt++;}
				else if (*pTxt == L'?')  {CSTB_SETBUF(L'?');	len++; pTxt++;}
				else if (*pTxt == L'\'') {CSTB_SETBUF(L'\'');	len++; pTxt++;}
				else if (*pTxt == L'"')  {CSTB_SETBUF(L'"');	len++; pTxt++;}
				else if (*pTxt == L'x')  {
					pTxt++;
					if (MAjcIsXDigitW(*pTxt)) {
						CSTB_SETBUF((WC)AjcHexToUIW(pTxt));
						len++;
						while (MAjcIsXDigitW(*pTxt)) {
							pTxt++;
						}
					}
				}
				else if (*pTxt >= '0' && *pTxt <= '7') {
					CSTB_SETBUF((WC)AjcOctToUIW(pTxt));
					len++;
					while (*pTxt >= '0' && *pTxt <= '7') {
						pTxt++;
					}
				}
			}
			else {
				CSTB_SETBUF(*pTxt); pTxt++;
				len++;
			}
		}
		CSTB_SETBUF(0);
	}
	return len;
}
//==============================================================================================================//
//	Function	:	oCib\Lɕϊ														//
//																												//
//	Argument	:	pTxt - oCĩAhX															//
//					pBuf - b\Li[obt@̃AhX											//
//					lBuf - b\Li[obt@̃oCg^									//
//																												//
//	Return		:	b\L̒																		//
//==============================================================================================================//
#define		MAbcSetStrA(STR) {	stl = (UI)strlen(STR); 						\
								if (pBuf != NULL) {							\
									if (len + stl < lBuf) {					\
										strcpy(pBuf, STR);					\
										pBuf += stl;						\
										len  += stl;						\
									} 										\
									else break;								\
								}											\
								else {										\
									len += stl;								\
								}											\
							 }

#define		MAbcSetStrW(STR) {	stl = (UI)wcslen(STR); 						\
								if (pBuf != NULL) {							\
									if (len + stl < lBuf) {					\
										wcscpy(pBuf, STR);					\
										pBuf += stl;						\
										len  += stl;						\
									} 										\
									else break;								\
								}											\
								else {										\
									len += stl;								\
								}											\
							 }
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcBinToCLangStrA(C_BCP pTxt, BCP pBuf, UI lBuf)
{
	UI		len = 0;
	UI		stl;

	if (pTxt != NULL) {
		while (*pTxt != 0 && ((pBuf == NULL) || (pBuf != NULL && len < lBuf - 1))) {
			if		(*pTxt == '\a'	) {MAbcSetStrA("\\a");	pTxt++;}
			else if (*pTxt == '\b'	) {MAbcSetStrA("\\b");	pTxt++;}
		//	else if (*pTxt == '\x1B') {MAbcSetStrA("\\e");	pTxt++;}
			else if (*pTxt == '\f'	) {MAbcSetStrA("\\f");	pTxt++;}
			else if (*pTxt == '\n'	) {MAbcSetStrA("\\n");	pTxt++;}
			else if (*pTxt == '\r'	) {MAbcSetStrA("\\r");	pTxt++;}
			else if (*pTxt == '\t'	) {MAbcSetStrA("\\t");	pTxt++;}
			else if (*pTxt == '\v'	) {MAbcSetStrA("\\v");	pTxt++;}
			else if (*pTxt == '\\'	) {MAbcSetStrA("\\\\"); pTxt++;}
			else if (*pTxt == '?'	) {MAbcSetStrA("\\?");	pTxt++;}
			else if (*pTxt == '\''	) {MAbcSetStrA("\\'");	pTxt++;}
			else if (*pTxt == '"'   ) {MAbcSetStrA("\\\""); pTxt++;}
			else if ((*pTxt > 0 && *pTxt < 0x20) || *pTxt == 0x7F) {
				BC	txt[8];
				AjcSnPrintFA(txt, 8, "\\x%02x", (UB)*pTxt);
				MAbcSetStrA(txt);
				pTxt++;
			}
			else {
				if (pBuf != NULL) *pBuf++ = *pTxt;
				pTxt++;
				len++;
			}
		}
		if (pBuf != NULL) *pBuf = 0;
	}
	return len;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcBinToCLangStrW(C_WCP pTxt, WCP pBuf, UI lBuf)
{
	UI		len = 0;
	UI		stl;

	if (pTxt != NULL) {
		while (*pTxt != 0 && ((pBuf == NULL) || (pBuf != NULL && len < lBuf - 1))) {
			if		(*pTxt == L'\a'  ) {MAbcSetStrW(L"\\a");  pTxt++;}
			else if (*pTxt == L'\b'  ) {MAbcSetStrW(L"\\b");  pTxt++;}
		//	else if (*pTxt == L'\x1B') {MAbcSetStrW(L"\\e");  pTxt++;}
			else if (*pTxt == L'\f'  ) {MAbcSetStrW(L"\\f");  pTxt++;}
			else if (*pTxt == L'\n'  ) {MAbcSetStrW(L"\\n");  pTxt++;}
			else if (*pTxt == L'\r'  ) {MAbcSetStrW(L"\\r");  pTxt++;}
			else if (*pTxt == L'\t'  ) {MAbcSetStrW(L"\\t");  pTxt++;}
			else if (*pTxt == L'\v'  ) {MAbcSetStrW(L"\\v");  pTxt++;}
			else if (*pTxt == L'\\'  ) {MAbcSetStrW(L"\\\\"); pTxt++;}
			else if (*pTxt == L'?'	 ) {MAbcSetStrW(L"\\?");  pTxt++;}
			else if (*pTxt == L'\''  ) {MAbcSetStrW(L"\\'");  pTxt++;}
			else if (*pTxt == L'"'   ) {MAbcSetStrW(L"\\\""); pTxt++;}
			else if ((*pTxt > 0 && *pTxt < 0x20) || *pTxt == 0x7F) {
				WC	txt[8];
				AjcSnPrintFW(txt, 8, L"\\x%04x", (UW)*pTxt);
				MAbcSetStrW(txt);
				pTxt++;
			}
			else {
				if (pBuf != NULL) *pBuf++ = *pTxt;
				pTxt++;
				len++;
			}
		}
		if (pBuf != NULL) *pBuf = 0;
	}
	return len;
}
//==============================================================================================================//
//	eLXg̕\擾܂iSp͂QƂ܂j													//
//																												//
//	@F	pText		- \ZoeLXg̃AhX												//
//																												//
//	߂lF	\																						//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI AjcTextLenA(C_BCP pText)
{
	return (UI)strlen(pText);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI AjcTextLenW(C_WCP pText)
{
	UI		rc = 0;

	if (pText != NULL) {
		while (*pText != 0) {
			if (AjcIsBigCharW(pText)) rc += 2;
			else					  rc += 1;
			if (MAjcIsLeadW(*pText)) pText += 2;
			else					 pText++;
		}
	}
	return rc;
}

//==============================================================================================================//
//	̑Sp^p`FbN																					//
//																												//
//	@F	pTxt	- ̑Sp^p`FbN镶iP`Qj										//
//																												//
//	߂lF	TRUE  - Sp																					//
//				FALSE - p																					//
//==============================================================================================================//
extern	const UI  EastAsianWidthTableSize;
extern	const UB EastAsianWidthTable[];
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcIsBigCharA(const BC txt[2])
{
	BOOL	rc = FALSE;

	if (txt != NULL && txt[0] != 0) {
		rc = (_ismbblead(txt[0]) != 0 && _ismbbtrail(txt[1]) != 0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI AjcIsBigCharW(const WC txt[2])
{
	BOOL	rc = FALSE;
	UI		upt;
	int		ix;
	UB		msk;
	WC		c1, c2;

	if (txt != NULL && txt[0] != 0) {
		c1 = txt[0];
		c2 = txt[1];
		if (MAjcIsLeadW(c1) && MAjcIsTrailW(c2)) {
			upt = ((((UI)c1 & 0x03C0) + 0x0040) << 10)	|	//	uuuuu................
				  ((((UI)c1 & 0x003F)		  ) << 10)	|	//	.....xxxxxx..........
				  ((((UI)c2 & 0x03FF)		  ) 	 );		//	...........yyyyyyyyyy
		}
		else {
			upt = c1;
		}

		if (upt < (EastAsianWidthTableSize * 8)) {
			ix	= (upt / 8);
			msk = (UB)(0x01 << (upt % 8));
			rc = ((EastAsianWidthTable[ix] & msk) != 0);
		}
	}
	return rc;
}

//==============================================================================================================//
//	UNICODER[h|CgZo																					//
//																												//
//	@F	pTxt	- R[h|CgZo镶iP`Qj											//
//																												//
//	߂lF	TRUE  - Sp																					//
//				FALSE - p																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcTextToCodePointA(const BC txt[2])
{
	UI		rc = 0;
	BC		bc[2] = {0, 0};
	WC		wc[2] = {0, 0};
	BC		c1, c2;

	if (txt != NULL && txt[0] != 0) {
		c1 = txt[0];
		c2 = txt[1];
		if ((_ismbblead(c1) != 0 && _ismbbtrail(c2) != 0)) {
			bc[0] = c1;
			bc[1] = c2;
			MultiByteToWideChar(CP_ACP, 0, bc, 2, wc, 2);
		}
		else {
			bc[0] = c1;
			bc[1] = 0;
			MultiByteToWideChar(CP_ACP, 0, bc, 1, wc, 2);
		}
		rc = AjcTextToCodePointW(wc);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI	WINAPI	AjcTextToCodePointW(const WC txt[2])
{
	UI		rc = 0;
	WC		c1, c2;

	if (txt != NULL && txt[0] != 0) {
		c1 = txt[0];
		c2 = txt[1];
		if (MAjcIsLeadW(c1) && MAjcIsTrailW(c2)) {
			rc = ((((UI)c1 & 0x03C0) + 0x0040) << 10)  |	//	uuuuu................
				 ((((UI)c1 & 0x003F)		 ) << 10)  |	//	.....xxxxxx..........
				 ((((UI)c2 & 0x03FF)		 )		);		//	...........yyyyyyyyyy
		}
		else {
			rc = c1;
		}
	}
	return rc;
}
//==============================================================================================================//
//	UNICODER[h|Cg ϊ																			//
//																												//
//	@F	cp			- R[h|Cg																	//
//				pTxt		- i[obt@̃AhXiQj									//
//																												//
//	߂lF	1 or 2	- ̃oCg^																//
//				0		- G[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcCodePointToTextA(UI cp, BC txt[2])
{
	UI		rc = 0;
	WC		wc[2];
	UI		len;

	if ((len = AjcCodePointToTextW(cp, wc)) != 0) {
		memset(txt, 0, 2);
		rc = WideCharToMultiByte(CP_ACP, 0, wc, len, txt, 2, NULL, NULL);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcCodePointToTextW(UI cp, WC txt[2])
{
	UI	rc = 0;

	if (txt != NULL && (cp & 0xFFE00000) == 0) {
		if ((cp & 0xFFFF0000) == 0) {
			txt[0] = (WC)cp;
			txt[1] = 0;
			rc = 1;
		}
		else {
			cp -= 0x00010000;
			txt[0] = (cp >> 10)   + 0xD800;
			txt[1] = (cp & 0x3FF) + 0xDC00;
			rc = 2;
		}
	}
	return rc;
}
//==============================================================================================================//
//	tHg𕶎																						//
//																												//
//	@F	pLf			- tHg̃AhX															//
//				pTxt		- i[obt@̃AhXisvNULL)									//
//				lTxt		- i[obt@̕													//
//				fKey		- TRUE: ɃL[(FN=, LF=)܂߂												//
//																												//
//	߂lF	OF񉻂̂ɕKvȕiI[(\0)܂												//
//				OFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcLogFontToTextA(const LOGFONTA *pLf, BCP pTxt, UI lTxt, BOOL fKey)
{
	UI		rc		 = 0;
	BC		txt[512] = {0};

	if (pLf != NULL) {
		if (fKey) {
			AjcSnPrintFA(txt, 512, "FN=%s,LF=%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d",
									  pLf->lfFaceName,	pLf->lfHeight,
														pLf->lfWidth,
														pLf->lfEscapement,
														pLf->lfOrientation,
														pLf->lfWeight,
														pLf->lfItalic,
														pLf->lfUnderline,
														pLf->lfStrikeOut,
														pLf->lfCharSet,
														pLf->lfOutPrecision,
														pLf->lfClipPrecision,
														pLf->lfQuality,
														pLf->lfPitchAndFamily
			);
		}
		else {
			AjcSnPrintFA(txt, 512, "%s,%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d",
									  pLf->lfFaceName,	pLf->lfHeight,
														pLf->lfWidth,
														pLf->lfEscapement,
														pLf->lfOrientation,
														pLf->lfWeight,
														pLf->lfItalic,
														pLf->lfUnderline,
														pLf->lfStrikeOut,
														pLf->lfCharSet,
														pLf->lfOutPrecision,
														pLf->lfClipPrecision,
														pLf->lfQuality,
														pLf->lfPitchAndFamily
			);
		}
		if (pTxt != NULL && lTxt != 0) {
			AjcSnPrintFA(pTxt, lTxt, "%s", txt);
		}
		rc = (UI)strlen(txt) + 1;
	}
	return	rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcLogFontToTextW(const LOGFONTW *pLf, WCP pTxt, UI lTxt, BOOL fKey)
{
	UI		rc		 = 0;
	WC		txt[512] = {0};

	if (pLf != NULL) {
		if (fKey) {
			AjcSnPrintFW(txt, 512, L"FN=%s, LF=%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d;",
									  pLf->lfFaceName,	pLf->lfHeight,
														pLf->lfWidth,
														pLf->lfEscapement,
														pLf->lfOrientation,
														pLf->lfWeight,
														pLf->lfItalic,
														pLf->lfUnderline,
														pLf->lfStrikeOut,
														pLf->lfCharSet,
														pLf->lfOutPrecision,
														pLf->lfClipPrecision,
														pLf->lfQuality,
														pLf->lfPitchAndFamily
			);
		}
		else {
			AjcSnPrintFW(txt, 512, L"%s, %d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d/%d;",
									  pLf->lfFaceName,	pLf->lfHeight,
														pLf->lfWidth,
														pLf->lfEscapement,
														pLf->lfOrientation,
														pLf->lfWeight,
														pLf->lfItalic,
														pLf->lfUnderline,
														pLf->lfStrikeOut,
														pLf->lfCharSet,
														pLf->lfOutPrecision,
														pLf->lfClipPrecision,
														pLf->lfQuality,
														pLf->lfPitchAndFamily
			);
		}
		if (pTxt != NULL && lTxt != 0) {
			AjcSnPrintFW(pTxt, lTxt, L"%s", txt);
		}
		rc = (UI)wcslen(txt) + 1;
	}
	return	rc;
}
//==============================================================================================================//
//	񂩂tHg쐬																				//
//																												//
//	@F	pTxt		- tHg\															//
//				pLf			- tHgi[obt@̃AhX											//
//																												//
//	߂lF	TRUE F																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTextToLogFontA(C_BCP pTxt, LPLOGFONTA pLf)
{
	BOOL	rc	 = FALSE;
	UI		i;
	C_BCP	p;

	if (pTxt != NULL && pLf != NULL) {
		//	L[(FN= / LF=)teLXg
		if ((p = strstr(pTxt, "FN=")) || (p = strstr(pTxt, "LF="))) {
			memset(pLf, 0, sizeof(LOGFONTA));
			//	tF[Xݒ
			if (p = strstr(pTxt, "FN=")) {
				for (i = 0, p+= 3; i < AJCTSIZE(pLf->lfFaceName) - 1 && *p != ',' && *p != 0; i++, p++) {
					pLf->lfFaceName[i] = *p;
				}
			}
			//	tHgݒ
			if (p = strstr(pTxt, "LF=")) {
				p += 3;
				AjcGetSepNumbersA(p, '/', "iiiiibbbbbbbb",	&pLf->lfHeight			,
															&pLf->lfWidth			,
															&pLf->lfEscapement		,
															&pLf->lfOrientation		,
															&pLf->lfWeight			,
															&pLf->lfItalic			,
															&pLf->lfUnderline		,
															&pLf->lfStrikeOut		,
															&pLf->lfCharSet			,
															&pLf->lfOutPrecision	,
															&pLf->lfClipPrecision	,
															&pLf->lfQuality			,
															&pLf->lfPitchAndFamily);
			}
		}
		//	L[(FN= / LF=)eLXg
		else {
			memset(pLf, 0, sizeof(LOGFONTA));
			//	tF[Xݒ
			for (i = 0, p = pTxt; i < AJCTSIZE(pLf->lfFaceName) - 1 && *p != ',' && *p != 0; i++, p++) {
				pLf->lfFaceName[i] = *p;
			}
			//	󔒂ƃJ}(,)XLbv
			while (*p == ',' || *p == ' ') {
				p++;
			}
			//	tHgݒ
			if (*p != 0) {
				AjcGetSepNumbersA(p, '/', "iiiiibbbbbbbb",	&pLf->lfHeight			,
															&pLf->lfWidth			,
															&pLf->lfEscapement		,
															&pLf->lfOrientation		,
															&pLf->lfWeight			,
															&pLf->lfItalic			,
															&pLf->lfUnderline		,
															&pLf->lfStrikeOut		,
															&pLf->lfCharSet			,
															&pLf->lfOutPrecision	,
															&pLf->lfClipPrecision	,
															&pLf->lfQuality			,
															&pLf->lfPitchAndFamily);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTextToLogFontW(C_WCP pTxt, LPLOGFONTW pLf)
{
	BOOL	rc	 = FALSE;
	UI		i;
	C_WCP	p;

	if (pTxt != NULL && pLf != NULL) {
		//	L[(FN= / LF=)teLXg
		if ((p = wcsstr(pTxt, L"FN=")) || (p = wcsstr(pTxt, L"LF="))) {
			memset(pLf, 0, sizeof(LOGFONTW));
			//	tF[Xݒ
			if (p = wcsstr(pTxt, L"FN=")) {
				for (i = 0, p+= 3; i < AJCTSIZE(pLf->lfFaceName) - 1 && *p != L',' && *p != 0; i++, p++) {
					pLf->lfFaceName[i] = *p;
				}
			}
			//	tHgݒ
			if (p = wcsstr(pTxt, L"LF=")) {
				p += 3;
				AjcGetSepNumbersW(p, '/', L"iiiiibbbbbbbb",	&pLf->lfHeight			,
															&pLf->lfWidth			,
															&pLf->lfEscapement		,
															&pLf->lfOrientation		,
															&pLf->lfWeight			,
															&pLf->lfItalic			,
															&pLf->lfUnderline		,
															&pLf->lfStrikeOut		,
															&pLf->lfCharSet			,
															&pLf->lfOutPrecision	,
															&pLf->lfClipPrecision	,
															&pLf->lfQuality			,
															&pLf->lfPitchAndFamily);
			}
		}
		//	L[(FN= / LF=)eLXg
		else {
			memset(pLf, 0, sizeof(LOGFONTW));
			//	tF[Xݒ
			for (i = 0, p = pTxt; i < AJCTSIZE(pLf->lfFaceName) - 1 && *p != L',' && *p != 0; i++, p++) {
				pLf->lfFaceName[i] = *p;
			}
			//	󔒂ƃJ}(,)XLbv
			while (*p == L',' || *p == L' ') {
				p++;
			}
			//	tHgݒ
			if (*p != 0) {
				AjcGetSepNumbersW(p, '/', L"iiiiibbbbbbbb",	&pLf->lfHeight			,
															&pLf->lfWidth			,
															&pLf->lfEscapement		,
															&pLf->lfOrientation		,
															&pLf->lfWeight			,
															&pLf->lfItalic			,
															&pLf->lfUnderline		,
															&pLf->lfStrikeOut		,
															&pLf->lfCharSet			,
															&pLf->lfOutPrecision	,
															&pLf->lfClipPrecision	,
															&pLf->lfQuality			,
															&pLf->lfPitchAndFamily);
			}
		}
	}
	return rc;
}
