#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	eLXg`																								//
//																												//
//**************************************************************************************************************//

#define	INST_ID			0x624490B1
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)


//--------------------------------------------------------------------------------------------------------------//
//	tHgύXtO																							//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCCFBE_NORMAL			0x00
#define		AJCCFBE_BOLD			0x01
#define		AJCCFBE_ITALIC			0x02
#define		AJCCFBE_ULINE			0x04
#define		AJCCFBE_BOLD_ITALIC		(AJCCFBE_BOLD	| AJCCFBE_ITALIC )
#define		AJCCFBE_BOLD_ULINE		(AJCCFBE_BOLD	| AJCCFBE_ULINE  )
#define		AJCCFBE_ITALIC_ULINE	(AJCCFBE_ITALIC | AJCCFBE_ULINE  )
#define		AJCCFBE_ALL				(AJCCFBE_BOLD	| AJCCFBE_ITALIC | AJCCFBE_ULINE)

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ChangeFontoToHdc	(HAJCTXO pW);
static	VO		ResetToDefaultColor	(HAJCTXO pW);

//==============================================================================================================//
//	CX^X̐																							//
//																												//
//	@	F	hdc		- foCXReLXgEnh														//
//				left 	- [`Jnʒu																		//
//				top		- [`Jnʒu																		//
//				defLsp 	- ftHg̍sԃXy[XiFsNZCF̂mj					//
//																												//
//	߂l	F	NULL - njiCX^Xnhj															//
//				NULL - G[																					//
//==============================================================================================================//
AJCEXPORT	HAJCTXO		WINAPI	AjcTxoCreate		(HDC hdc, int left, int top, int defLsp)
{
	HAJCTXO		pW = NULL;
	LOGFONT		lf;
	TEXTMETRIC	tm;

	if ((pW = (HAJCTXO)AJCMEM(sizeof(AJCTXO))) != NULL) {
		memset(pW, 0, sizeof *pW);
		pW->InstID			= INST_ID;
		pW->hdc				= hdc;
		pW->xLeft			= left;
		pW->yTop			= top;
		pW->Align			= AJCTXOALIGN_LEFT;
		pW->Palette[0]		= RGB(	 0,   0,   0);
		pW->Palette[1]		= RGB( 255,   0,   0);
		pW->Palette[2]		= RGB(	 0, 255,   0);
		pW->Palette[3]		= RGB( 255, 255,   0);
		pW->Palette[4]		= RGB(	 0,   0, 255);
		pW->Palette[5]		= RGB( 255,   0, 255);
		pW->Palette[6]		= RGB(	 0, 255, 255);
		pW->Palette[7]		= RGB( 255, 255, 255);

		//	`ʒu
		pW->x = 0;
		pW->y = 0;

		//	N̂cbޔ
		if ((pW->hFontOrg = SelectObject(pW->hdc, GetStockObject(SYSTEM_FONT))) != NULL) {
			SelectObject(pW->hdc, pW->hFontOrg);
			pW->BkModeOrg	= GetBkMode   (pW->hdc);
			pW->BkColorOrg	= GetBkColor  (pW->hdc);
			pW->TxtColorOrg	= GetTextColor(pW->hdc);

			//	̍Cݒ
			GetTextMetrics(hdc, &tm);
			pW->cxChar = tm.tmAveCharWidth;
			pW->cyChar = tm.tmHeight;
			//	DΎݒ
			GetObject(pW->hFontOrg, sizeof lf, &lf);
			pW->fFont |= (lf.lfWeight == FW_BOLD) ? AJCCFBE_BOLD   : 0;
			pW->fFont |= (lf.lfItalic == TRUE	) ? AJCCFBE_ITALIC : 0;
			//	^uXebvݒ
			pW->TabStep = pW->cxChar * 4;
			//	sԃXy[Xݒ
			if (defLsp >= 0) pW->LspDef = defLsp;
			else			 pW->LspDef = abs(pW->cyChar * defLsp / 100);
			pW->Lsp = pW->LspDef;

			//	FCwiF̃ftHgl
			pW->TxtColorDef = RGB(0, 0, 0);		//	
			pW->BkColorDef	= -1;				//	

			//	`FZbg
			ResetToDefaultColor(pW);
		}
		else {
			free(pW);
			pW = NULL;
		}
	}
	return pW;
}
//==============================================================================================================//
//	CX^X̏																							//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				fRestore - cbtO																		//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTxoDelete		(HAJCTXO pW, BOOL fRestore)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		//	N̂cb
		if (fRestore) {
			SelectObject(pW->hdc, pW->hFontOrg	 );
			SetTextColor(pW->hdc, pW->TxtColorOrg);
			SetBkColor	(pW->hdc, pW->BkColorOrg );
			SetBkMode	(pW->hdc, pW->BkModeOrg  );
		}
		//	tHgIuWFNgj
		if (pW->hFontN	 != NULL) {DeleteObject(pW->hFontN	); pW->hFontN	= NULL;}
		if (pW->hFontB	 != NULL) {DeleteObject(pW->hFontB	); pW->hFontB	= NULL;}
		if (pW->hFontI	 != NULL) {DeleteObject(pW->hFontI	); pW->hFontI	= NULL;}
		if (pW->hFontU	 != NULL) {DeleteObject(pW->hFontU	); pW->hFontU	= NULL;}
		if (pW->hFontBI  != NULL) {DeleteObject(pW->hFontBI ); pW->hFontBI	= NULL;}
		if (pW->hFontBU  != NULL) {DeleteObject(pW->hFontBU ); pW->hFontBU	= NULL;}
		if (pW->hFontIU  != NULL) {DeleteObject(pW->hFontIU ); pW->hFontIU	= NULL;}
		if (pW->hFontBIU != NULL) {DeleteObject(pW->hFontBIU); pW->hFontBIU = NULL;}

		free(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	cb`̃rbg}bvTCYݒ																			//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				cx, cy	 - cb`Xy[Xirbg}bvj̃TCY												//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTxoSetDcBmpSize		(HAJCTXO pW, int cx, int cy)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->szBmp.cx = cx;
		pW->szBmp.cy = cy;
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	lߐݒ																								//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				Align	 - lߎwiAJCTXOALIGN_{LEFT/CENTER/RIGHT/TAB_RIGHT)j							//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL			WINAPI	AjcTxoSetAlign(HAJCTXO pW, AJCTXOALIGN Align)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (Align == AJCTXOALIGN_LEFT || Align == AJCTXOALIGN_CENTER || Align == AJCTXOALIGN_RIGHT || Align == AJCTXOALIGN_TAB_RIGHT) {
			pW->Align = Align;
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	lߎ擾																								//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	AJCTXOALIGN	WINAPI	AjcTxoGetAlign(HAJCTXO pW)
{
	AJCTXOALIGN	rc = (AJCTXOALIGN)0;

	if (IS_MY_INST(pW)) {
		rc = pW->Align;
	}
	return rc;
}

//==============================================================================================================//
//	`ʒuݒ																								//
//																												//
//	@	F	pW			- CX^Xnh																//
//				x, y, pPt	- `sNZʒu																	//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- wCxw ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoLocate		(HAJCTXO pW, int x, int y)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->x = x;
		pW->y = y;
		rc = TRUE;
	}
	return rc;
}
//----- onhmsw -----------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoSetPos		(HAJCTXO pW, LPPOINT pPt)
{
	BOOL	rc = FALSE;

	if (pPt != NULL) {
		rc = AjcTxoLocate(pW, pPt->x, pPt->y);
	}
	return rc;
}
//==============================================================================================================//
//	`ʒu擾																								//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				pPt		- `sNZʒui[obt@̃AhX											//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTxoGetPos		(HAJCTXO pW, LPPOINT pPt)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pPt != NULL) {
			pPt->x = pW->x;
			pPt->y = pW->y;
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				pFmt	- eLXgւ̃|C^																//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFA		(HAJCTXO pW, C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	BC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnprintf(buf, 1024, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcTxoTextOutA(pW, buf);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFW		(HAJCTXO pW, C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	WC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnwprintf(buf, 1024, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcTxoTextOutW(pW, buf);
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`i`ʒuwj																			//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				x, y	- `ʒu																				//
//				pFmt	- eLXgւ̃|C^																//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFExA		(HAJCTXO pW, int x, int y, C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	BC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnprintf(buf, 1024, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcTxoTextOutExA(pW, x, y, buf);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFExW		(HAJCTXO pW, int x, int y, C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	WC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnwprintf(buf, 1024, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcTxoTextOutExW(pW, x, y, buf);
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`i`ʒuwj																			//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				x, y	- `ʒu																				//
//				pFmt	- eLXgւ̃|C^																//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFExExA		(HAJCTXO pW, int x, int y, int cx, C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	BC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnprintf(buf, 1024, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcTxoTextOutExExA(pW, x, y, cx, buf);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFExExW		(HAJCTXO pW, int x, int y, int cx, C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	WC		buf[2048];

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnwprintf(buf, 1024, pFmt, vls);
		buf[2047] = 0;
		va_end	(vls);
		rc = AjcTxoTextOutExExW(pW, x, y, cx, buf);
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`																								//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				pText	- `eLXgւ̃|C^																//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutA		(HAJCTXO pW, C_BCP pText)
{
	BOOL	rc = FALSE;
	POINT	pt;

	if (IS_MY_INST(pW)) {
		AjcTxoGetPos(pW, &pt);
		rc = AjcTxoTextOutExA(pW, pt.x, pt.y, pText);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutW		(HAJCTXO pW, C_WCP pText)
{
	BOOL	rc = FALSE;
	POINT	pt;

	if (IS_MY_INST(pW)) {
		AjcTxoGetPos(pW, &pt);
		rc = AjcTxoTextOutExW(pW, pt.x, pt.y, pText);
	}
	return rc;
}
//==============================================================================================================//
//	eLXg`i`ʒuwj																				//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				x, y	- `ʒu																				//
//				pText	- `eLXgւ̃|C^																//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutExA	(HAJCTXO pW, int x, int y, C_BCP pText)
{
	return AjcTxoTextOutExExA(pW, x, y, 0, pText);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutExW	(HAJCTXO pW,  int x, int y, C_WCP pText)
{
	return AjcTxoTextOutExExW(pW, x, y, 0, pText);
}
//==============================================================================================================//
//	eLXg`i`ʒuCeLXg`̕wj															//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				x, y	- `ʒu																				//
//				pText	- `eLXgւ̃|C^																//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutExExA	(HAJCTXO pW, int x, int y, int cx, C_BCP pText)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmp;

	if (IS_MY_INST(pW) && pText != NULL) {
		len = AjcByteCharToWideChar(pText, NULL, 0);
		if (pTmp = AjcTAllocW(len)) {
			AjcByteCharToWideChar(pText, pTmp, len);
			rc = AjcTxoTextOutExExW(pW, x, y, cx, pTmp);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutExExW	(HAJCTXO pW,  int x, int y, int cx, C_WCP pText)
{
	BOOL	rc = FALSE;
	C_WCP	pS, pE;						//	eLXg|C^
	SIZE	szFrame;					//	`g̃sNZTCY
	int		cxTxt, cyTxt;				//	eLXg`̃TCY
	UI		stl;
	int		left, temp;
	int		rem, add;
	int		nLine = 0;					//	eLXg̍s
	UIP		pPixL = NULL;				//	es̃sNZ
	int		ixL   = 0;					//	sCfNX
	int		xOfs  = 0;					//	^Elߎ̃ItZbg
	BOOL	fTabRightDone  = FALSE;		//	s`aȍ~Elߍς݃tO
	BOOL	fRightOrCenter = FALSE;		//	wE^wtO

	if (IS_MY_INST(pW) && pText != NULL) {
		do {
			//	eLXg̍sݒ
			if ((nLine = AjcTxoGetLineCountW(pW, pText)) == 0) break;
			//	es̃sNZobt@m
			if ((pPixL = AJCMEM(sizeof(UI) * nLine)) == NULL) break;
			//	es̃sNZƃeLXg̋`TCYݒ
			AjcTxoGetExtent2W(pW, pText, &szFrame, pPixL, nLine);
			//	`̕wlɕύX
			if (cx != 0) {
				szFrame.cx = cx;
			}
			//	E^^wɂA`ʒu␳
			if (pW->szBmp.cx != 0 && pW->szBmp.cy != 0 &&
			   ((x >= AJCTXO_CORNER_MIN && x <= AJCTXO_CORNER_MAX) || (y >= AJCTXO_CORNER_MIN && y <= AJCTXO_CORNER_MAX))) {
				//	eLXg`̃TCYݒ
				cxTxt = pW->szBmp.cx - pW->xLeft;
				cyTxt = pW->szBmp.cy - pW->yTop;
				//	wEw莞̈ʒu␳
				if	   (x >= AJCTXO_RIGHT_MIN && x <= AJCTXO_RIGHT_MAX) {
					x = (cxTxt - szFrame.cx) + (x - AJCTXO_RIGHT);
					fRightOrCenter = TRUE;
				}
				//	ww莞̈ʒu␳
				else if (x >= AJCTXO_CENTER_MIN && x <= AJCTXO_CENTER_MAX) {
					x = ((cxTxt - szFrame.cx) / 2) + (x - AJCTXO_CENTER);
					fRightOrCenter = TRUE;
				}
				//	xw莞̈ʒu␳
				if		(y >= AJCTXO_BOTTOM_MIN && y <= AJCTXO_BOTTOM_MAX) {
					y = (cyTxt - szFrame.cy) + (y - AJCTXO_BOTTOM);
				}
				//	xw莞̈ʒu␳
				else if (y >= AJCTXO_CENTER_MIN && y <= AJCTXO_CENTER_MAX) {
					y = ((cyTxt - szFrame.cy) / 2) + (y - AJCTXO_CENTER);
				}
			}
			//	s[ʒuݒ
			left = temp = x;
			//	eLXg|C^
			pS = pE = pText;
			//	l߂ɂwItZbgݒ
			switch (pW->Align) {
				default:
				case AJCTXOALIGN_LEFT:		xOfs = 0;								break;
				case AJCTXOALIGN_CENTER:	xOfs = ((szFrame.cx - pPixL[ixL]) / 2);	break;
				case AJCTXOALIGN_RIGHT:		xOfs =	(szFrame.cx - pPixL[ixL]);		break;
				case AJCTXOALIGN_TAB_RIGHT:	xOfs = 0;								break;
			}

			//	s`aȍ~Elߍς݃tONA[
			fTabRightDone = FALSE;

			while (*pS != 0) {
				//	䕶
				pE	= pS;
				stl = 0;
				while (*pE != 0 && !MAjcIsCntrl(*pE)) {
						pE++;
						stl++;	//	񒷍XV
				}
				//	䕶O܂ł̕`
				if (stl != 0) {
					SIZE	sz;
					//	`
					TextOutW(pW->hdc, pW->xLeft + x + xOfs, pW->yTop + y, pS, stl);
					//	sNZZoAwʒuXV
					GetTextExtentPoint32W(pW->hdc, pS, stl, &sz);
					x	+= sz.cx;
				}
				//	䕶ANV
				if (*pE != 0 && MAjcIsCntrl(*pE)) {
					switch (*pE) {
						case L'\x1B':								//	 '\x1B' : drbɂcbݒ
							pE = AjcTxoEscOutW(pW, pE);
							break;

						case L'\t':									//	 '\t'   : ^u
								//	l
								if (pW->Align == AJCTXOALIGN_LEFT) {
									//	^uXebv and E[^w薳H
									if (pW->TabStep > 0 && !fRightOrCenter) {
										//	wʒuXViϕj
										rem = (x % pW->TabStep);
										if (rem == 0) add =  pW->TabStep;
										else		  add = (pW->TabStep - rem);
										if (add < pW->cxChar) add += pW->TabStep;
										x += add;
									}
									//	^uXebv or E[^w肠H
									else {
										//	wʒuXViŒ蕝j
										x	+= abs(pW->TabStep);
									}
								}
								//	s`aȍ~El߁H
								else if (pW->Align == AJCTXOALIGN_TAB_RIGHT) {
									//	esłPx^u
									if (!fTabRightDone) {
										fTabRightDone = TRUE;
										//	wʒuXV
										x += abs(pW->TabStep);
										//	wEl߈ʒuɐݒ
										add = (szFrame.cx - pPixL[ixL]);
										x	+= add;
									}
								}
								//	̑i킹^El߁jH
								else {
										//	wʒuXViŒ蕝j
										x	+= abs(pW->TabStep);
								}
								//	'\t' XLbv
								pE++;
								break;

						case L'\r':									//	 '\r'   : wʒuA
								//	lߎ̂ݕA
								if (pW->Align == AJCTXOALIGN_LEFT) {
									//	Awʒuݒ
									temp = x = 0;
								}
								//	'\r' XLbv
								pE++;
								break;

						case L'\n':									//	 '\n'   : s
								//	sCfNXXV
								ixL++;
								//	w擪ʒuݒ
								x = temp;
								//	l߂ɂwItZbgݒ
								switch (pW->Align) {
									default:
									case AJCTXOALIGN_LEFT:		xOfs = 0;								break;
									case AJCTXOALIGN_CENTER:	xOfs = ((szFrame.cx - pPixL[ixL]) / 2);	break;
									case AJCTXOALIGN_RIGHT:		xOfs =	(szFrame.cx - pPixL[ixL]);		break;
									case AJCTXOALIGN_TAB_RIGHT:	xOfs = 0;								break;
								}
								//	s`aȍ~Elߍς݃tONA[
								fTabRightDone = FALSE;
								//	w擪ʒu
								temp = left;
								//	sʒuXV
								y += (pW->cyChar + pW->Lsp);
								//	sԃXy[XZbg
								pW->Lsp = pW->LspDef;
								//	'\n' XLbv
								pE++;
								break;

						case L'\f':									//	 '\f'   : PsNZi߂
								//	PsNZi߂
								x++;
								//	'\f' XLbv
								pE++;
								break;

						case L'\a':									//	 '\f'   : POsNZi߂
								//	PsNZi߂
								x += 10;
								//	'\f' XLbv
								pE++;
								break;

						default:
								//	䕶XLbv
								pE++;
								break;
					}
				}
				//	̕擪ݒ
				pS = pE;
			}
			//	`ʒuޔ
			pW->x = x;
			pW->y = y;

			rc = TRUE;
		} while(0);

		//	es̃sNZobt@
		if (pPixL != NULL) free(pPixL);
	}
	return rc;
}
//==============================================================================================================//
//	drb`																									//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				fRestore - cbtO																		//
//																												//
//	߂l	F	NULL - ESCV[PX̒̃AhX															//
//				NULL - ESC[ ȊO																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcTxoEscOutA		(HAJCTXO pW, C_BCP pEsc)
{
	BCP		rc = NULL;
	UI		lEsc = 0;
	C_BCP	pS	 = pEsc;
	C_BCP	pE;
	UI		len;
	WCP		pTmp;

	if (IS_MY_INST(pW)) {
		if (*pS == '\x1B') {
			do {
				//	'\x1B' XLbv
				pS++; lEsc++;
				//	drbipj
				pE = pS;
				while (*pE != 0 && !MAjcAscIsAlphaW(*pE)) {
					pE++; lEsc++;
				}
				//	drbipjXLbv
				if (MAjcAscIsAlphaW(*pE)) {
					pE++; lEsc++;
				}
				//	P̂drb̒ݒ
				pS = pE;
			} while (*pS == '\x1B');
			//	߂ldrb̒
			rc = (BCP)pS;
			//	drbUNICODEɕϊdrb`
			len = MultiByteToWideChar(CP_ACP, 0, pEsc, lEsc, NULL, 0);
			if (pTmp = AjcTAllocW(len + 1)) {
				AjcByteCharToWideChar(pEsc, pTmp, len);
				pTmp[len - 1] = 0;
				AjcTxoEscOutW(pW, pTmp);
				free(pTmp);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcTxoEscOutW		(HAJCTXO pW, C_WCP pEsc)
{
	WCP		rc = NULL;
	C_WCP	pS = pEsc;
	C_WCP	pE;

	if (IS_MY_INST(pW)) {
		if (*pS == L'\x1B') {
			do {
				//	'\x1B' XLbv
				pS++;
				//	drbipj
				pE = pS;
				while (*pE != 0 && !MAjcAscIsAlphaW(*pE)) {
					pE++;
				}
				//	ESC[EEE
				if (*pS == L'[') {
					//	'[' XLbv
					pS++;
					//	drb
					if		(*pE == L'T') {							//	 drbV[PX = T - {[hݒ
						pW->fFont |= AJCCFBE_BOLD;
						ChangeFontoToHdc(pW);
						pW->NestBold++;
					}
					else if 	 (*pE == L't') {					//	 drbV[PX = t - {[h
						if (pW->NestBold >= 1) {
							if (--pW->NestBold == 0) {
								pW->fFont &= ~AJCCFBE_BOLD;
								ChangeFontoToHdc(pW);
							}
						}
					}
					else if 	 (*pE == L'I') {					//	 drbV[PX = I - C^bNݒ
						pW->fFont |= AJCCFBE_ITALIC;
						ChangeFontoToHdc(pW);
						pW->NestItalic++;
					}
					else if 	 (*pE == L'i') {					//	 drbV[PX = i - C^bN
						if (pW->NestItalic >= 1) {
							if (--pW->NestItalic == 0) {
								pW->fFont &= ~AJCCFBE_ITALIC;
								ChangeFontoToHdc(pW);
							}
						}
					}
					else if 	 (*pE == L'U') {					//	 drbV[PX = U - A_[Cݒ
						pW->fFont |= AJCCFBE_ULINE;
						ChangeFontoToHdc(pW);
						pW->NestULine++;
					}
					else if 	 (*pE == L'u') {					//	 drbV[PX = u - A_[C
						if (pW->NestULine >= 1) {
							if (--pW->NestULine == 0) {
								pW->fFont &= ~AJCCFBE_ULINE;
								ChangeFontoToHdc(pW);
							}
						}
					}
					else if 	 (*pE == L'N') {					//	 drbV[PX = N - {[hƃC^bN
						pW->fFont &= ~(AJCCFBE_BOLD | AJCCFBE_ITALIC | AJCCFBE_ULINE);
						ChangeFontoToHdc(pW);
						//	ΎAAlXgJE^NA[
						pW->NestBold = pW->NestItalic = pW->NestULine = 0;
					}
					else if 	 (*pE == L'L') {					//	 drbV[PX = L - sԃXy[X
						if (*pS == L'L') {							//		EESC[L
							pW->Lsp = pW->LspDef;
						}
						else {										//		EESC[nnnL
							int	n = _wtoi(pS);
							pW->Lsp = pW->cyChar * n / 100;
						}
					}
					else if (*pE == L'm') {							//	 drbV[PX = 'm' 
						while (MAjcAscIsDigitW(*pS)) {
							//	w萔lݒ
							int n = _wtoi(pS);
							//	0		: FCwiFCtHg Zbg
							if		(n == 0) {
								//	`FZbg
								ResetToDefaultColor(pW);
								//	tHgZbg
								pW->fFont = AJCCFBE_NORMAL;
								ChangeFontoToHdc(pW);
								//	ΎAAlXgJE^NA[
								pW->NestBold = pW->NestItalic = pW->NestULine = 0;
								//	(0)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							//	1		: {[hijݒ
							else if (n == 1) {
								pW->fFont |= AJCCFBE_BOLD;
								ChangeFontoToHdc(pW);
								pW->NestBold++;
								//	(1)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							//	3		: C^bNiΎjݒ
							else if (n == 3) {
								pW->fFont |= AJCCFBE_ITALIC;
								ChangeFontoToHdc(pW);
								pW->NestItalic++;
								//	(3)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							//	4		: A_[Cijݒ
							else if (n == 4) {
								pW->fFont |= AJCCFBE_ULINE;
								ChangeFontoToHdc(pW);
								pW->NestULine++;
								//	(4)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							//	9		: FCwiF Zbg
							else if (n == 9) {
								SetBkMode	(pW->hdc, TRANSPARENT );
								SetTextColor(pW->hdc, pW->TxtColorDef);
								//	(9)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							//	30 - 37 : Fݒ
							else if (n >= 30 && n <= 37) {
								SetTextColor(pW->hdc, pW->Palette[n - 30]);
								//	(30 - 37)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							//	38		: Fqfaw
							else if (n == 38) {
								COLORREF rgb;
								//	(38) ';' XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
								if (*pS == L';') {
									pS++;
									n = _wtoi(pS);
									if (n == 2) {
										//	(2) ';' XLbv
										while (MAjcAscIsDigitW(*pS)) pS++;
										if (*pS == L';') {
											WCP		p;
											pS++;
											if ((p = AjcTxoGetRgbByTextW(pS, &rgb)) != NULL) {
												pS = p;
												SetTextColor(pW->hdc, rgb);
											}
										}
									}
								}
							}
							//	39		: FZbg
							else if (n == 39) {
								SetTextColor(pW->hdc, pW->TxtColorDef);
								//	(39)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							//	40 - 47 : wiFݒ
							else if (n >= 40 && n <= 47) {
								SetBkMode (pW->hdc, OPAQUE);
								SetBkColor(pW->hdc, pW->Palette[n - 40]);
								//	(40 - 47)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							//	48		: wiFqfaw
							else if (n == 48) {
								COLORREF rgb;
								//	(48) ';' XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
								if (*pS == L';') {
									pS++;
									n = _wtoi(pS);
									if (n == 2) {
										//	(2) ';' XLbv
										while (MAjcAscIsDigitW(*pS)) pS++;
										if (*pS == L';') {
											WCP		p;
											pS++;
											if ((p = AjcTxoGetRgbByText(pS, &rgb)) != NULL) {
												pS = p;
												SetBkMode (pW->hdc, OPAQUE);
												SetBkColor(pW->hdc, rgb);
											}
										}
									}
								}
							}
							//	49		: wiFZbgij
							else if (n == 49) {
								SetBkMode (pW->hdc, TRANSPARENT);
								//	(49)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							else {
								//	(??)XLbv
								while (MAjcAscIsDigitW(*pS)) pS++;
							}
							//	Z~R(;)XLbv
							if (*pS == L';') pS++;
						}
					}
					//	drbipjXLbv
					if (*pE != 0) {
						pE++;
					}
				}
				//	P̂drb̒ݒ
				pS = pE;
			} while (*pS == L'\x1B');
			//	drb̒Ԃ
			rc = (WCP)pS;
		}
	}
	return rc;
}

//==============================================================================================================//
//	̍s擾																							//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pText	 - eLXgւ̃|C^																	//
//																												//
//	߂l	F	0 - njisj																				//
//				0 - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetLineCountA		(HAJCTXO pW, C_BCP pText)
{
	UI		rc = 0;
	C_BCP	p;

	if (IS_MY_INST(pW) && pText != NULL) {
		rc = 1;
		p  = pText;
		while (*p != 0) {
			if (*p == '\n') {
				rc++;
			}
			p++;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetLineCountW		(HAJCTXO pW, C_WCP pText)
{
	UI		rc = 0;
	C_WCP	p;

	if (IS_MY_INST(pW) && pText != NULL) {
		rc = 1;
		p  = pText;
		while (*p != 0) {
			if (*p == L'\n') {
				rc++;
			}
			p++;
		}
	}
	return rc;
}
//==============================================================================================================//
//	`̋`TCY擾																					//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pText	 - eLXgւ̃|C^																	//
//				pSize	 - eLXg̕`TCYi[obt@ւ̃|C^isvNULLj					//
//																												//
//	߂l	F	0 - njisj																				//
//				0 - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetExtentA		(HAJCTXO pW, C_BCP pText, LPSIZE pSize)
{
	return AjcTxoGetExtentExA(pW, 0, 0, pText, pSize);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetExtentW		(HAJCTXO pW, C_WCP pText, LPSIZE pSize)
{
	return AjcTxoGetExtentExW(pW, 0, 0, pText, pSize);
}
//==============================================================================================================//
//	`̋`TCY擾																					//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pText	 - eLXgւ̃|C^																	//
//				pSize	 - eLXg̕`TCYi[obt@ւ̃|C^isvNULLj					//
//																												//
//	߂l	F	0 - njisj																				//
//				0 - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetExtent2A		(HAJCTXO pW, C_BCP pText, LPSIZE pSize, UI LinePixs[], UI nLine)
{
	return AjcTxoGetExtent2ExA(pW, 0, 0, pText, pSize, LinePixs, nLine);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetExtent2W		(HAJCTXO pW, C_WCP pText, LPSIZE pSize, UI LinePixs[], UI nLine)
{
	return AjcTxoGetExtent2ExW(pW, 0, 0, pText, pSize, LinePixs, nLine);
}
//==============================================================================================================//
//	`̋`TCY擾is`aΉj																	//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				x, y	 - `ʒu																				//
//				pText	 - eLXgւ̃|C^																	//
//				pSize	 - eLXg̕`TCYi[obt@ւ̃|C^isvNULLj					//
//																												//
//	߂l	F	0 - njisj																				//
//				0 - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetExtentExA		(HAJCTXO pW, int x, int y, C_BCP pText, LPSIZE pSize)
{
	return AjcTxoGetExtent2ExA(pW, x, y, pText, pSize, NULL, 0);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetExtentExW		(HAJCTXO pW, int x, int y, C_WCP pText, LPSIZE pSize)
{
	return AjcTxoGetExtent2ExW(pW, x, y, pText, pSize, NULL, 0);
}
//==============================================================================================================//
//	`̋`TCY擾is`aΉCes̕`sNZ擾j											//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				x, y	 - `ʒu																				//
//				pText	 - eLXgւ̃|C^																	//
//				pSize	 - eLXg̕`TCYi[obt@ւ̃|C^isvNULLj					//
//				LinePixs - es̃sNZi[zobt@̃AhX										//
//				nLine	 - es̃sNZi[zobt@̗vf										//
//																												//
//	߂l	F	0 - njisj																				//
//				0 - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetExtent2ExA		(HAJCTXO pW, int x, int y, C_BCP pText, LPSIZE pSize, UI LinePixs[], UI nLine)
{
	BOOL	rc = FALSE;
	UI		len;
	WCP		pTmp;

	if (IS_MY_INST(pW)) {
		len = AjcByteCharToWideChar(pText, NULL, 0);
		if (pTmp = AjcTAllocW(len)) {
			AjcByteCharToWideChar(pText, pTmp, len);
			rc = AjcTxoGetExtent2ExW(pW, x, y, pTmp, pSize, LinePixs, nLine);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoGetExtent2ExW		(HAJCTXO pW, int x, int y, C_WCP pText, LPSIZE pSize, UI LinePixs[], UI nLine)
{
	UI			rc = 0;
	SIZE		sz;						//	GNXegTCY
	C_WCP		pS, pE;					//	GNXegZo̐擪Ɩ
	int			pix    = 0;				//	̕TCYZo[N
	int			stl;					//	GNXegZo̕
	int			lines  = 0;				//	s
	int			width  = 0;				//	sNZ
	int			height = 0;				//	csNZ
	int			left, temp;
	int			rem, add;
	HFONT		hFontSv;				//	tHgޔ
	UI			BkModeSv;				//	wi[hޔ
	COLORREF	BkColorSv;				//	wiFޔ
	COLORREF	TxtColorSv;				//	Fޔ
	UI			fFontSv;				//	tHgtOޔ
	int			LspSv;					//	sԃXy[Xޔ
	UI			ixLine = 0;				//	sCfNX
	BOOL		fTabRightDone  = FALSE;	//	TABȍ~Elߍς݃tO
	BOOL		fRightOrCenter = FALSE;	//	wE^wtO

	if (IS_MY_INST(pW)) {
		//	es̃sNZobt@NA[
		if (LinePixs != NULL && ixLine < nLine) {
			memset(LinePixs, 0, sizeof(UI) * nLine);
		}
		//	cbޔ
		hFontSv	= (HFONT)SelectObject(pW->hdc, GetStockObject(SYSTEM_FONT));
		SelectObject(pW->hdc, (HGDIOBJ)hFontSv);
		BkModeSv	= GetBkMode   (pW->hdc);
		BkColorSv	= GetBkColor  (pW->hdc);
		TxtColorSv	= GetTextColor(pW->hdc);
		//	ޔ
		fFontSv	= pW->fFont;
		LspSv	= pW->Lsp;

		//	wEw莞AtOݒ
		if	   (x >= AJCTXO_RIGHT_MIN && x <= AJCTXO_RIGHT_MAX) {
			fRightOrCenter = TRUE;
		}
		//	ww莞AtOݒ
		else if (x >= AJCTXO_CENTER_MIN && x <= AJCTXO_CENTER_MAX) {
			fRightOrCenter = TRUE;
		}

		//	sA
		lines  = 1;
		height = pW->cyChar;

		//	s[ʒuݒ
		left = temp = x;
		//	eLXg|C^
		pS = pE = pText;

		//	s`aȍ~Elߍς݃tONA[
		fTabRightDone = FALSE;

		while (*pS != 0) {
			//	䕶
			pE	= pS;
			stl = 0;
			while (*pE != 0 && !MAjcIsCntrl(*pE)) {
					pE++;
					stl++;	//	񒷍XV
			}
			//	䕶O̕܂ł̃sNZ
			if (stl != 0) {
				//	wʒuCsNZXV
				GetTextExtentPoint32W(pW->hdc, pS, stl, &sz);
				x	+= sz.cx;
				pix += sz.cx;
			}
			//	䕶ANV
			if (*pE != 0 && MAjcIsCntrl(*pE)) {
				switch (*pE) {
					case L'\x1B':								//	 '\x1B' : drbɂcbݒ
						pE = AjcTxoEscOutW(pW, pE);
						break;

					case L'\t':									//	 '\t'   : ^u
						//	l
						if (pW->Align == AJCTXOALIGN_LEFT) {
							//	^uXebv and E[^w薳H
							if (pW->TabStep > 0  && !fRightOrCenter) {
								//	wʒuXViϕj
								rem = (x % pW->TabStep);
								if (rem == 0) add = pW->TabStep;
								else		  add = pW->TabStep - rem;
								if (add < pW->cxChar) add += pW->TabStep;
								x	+= add;
								pix += add;
							}
							//	^uXebv or E[^w肠H
							else {
								//	wʒuXViŒ蕝j
								add = abs(pW->TabStep);
								x	+= add;
								pix += add;
							}
						}
						//	s`aȍ~El߁H
						else if (pW->Align == AJCTXOALIGN_TAB_RIGHT) {
							//	esłPx^u
							if (!fTabRightDone) {
								fTabRightDone = TRUE;
								//	wʒuXV
								add = abs(pW->TabStep);
								x	+= add;
								pix += add;
							}
						}
						//	̑i킹^El߁jH
						else {
							//	wʒuXViŒ蕝j
							add = abs(pW->TabStep);
							x	+= add;
							pix += add;
						}
						//	'\t' XLbv
						pE++;
						break;

					case L'\r':									//	 '\r'   : wʒuA
						//	lߎ̂ݕA
						if (pW->Align == AJCTXOALIGN_LEFT) {
							//	ő啝XV
							width = __max(width, pix);
							pix   = 0;
							//	Awʒuݒ
							temp = x = 0;
						}
						//	'\r' XLbv
						pE++;
						break;

					case L'\n':									//	 '\n'   : s
						//	es̃sNZi[
						if (LinePixs != NULL && ixLine < nLine) {
							LinePixs[ixLine] = pix;
							ixLine++;
						}
						//	ő啝XV
						width = __max(width, pix);
						pix   = 0;
						//	XV
						height += (pW->cyChar + pW->Lsp);
						//	sXV
						lines++;
						//	s`aȍ~Elߍς݃tONA[
						fTabRightDone = FALSE;
						//	w擪ʒuݒ
						x = temp;
						//	w擪ʒu
						temp = left;
						//	sʒuXV
						y += (pW->cyChar + pW->Lsp);
						//	sԃXy[XZbg
						pW->Lsp = pW->LspDef;
						//	'\n' XLbv
						pE++;
						break;

					default:
						//	䕶XLbv
						pE++;
						break;
				}
			}
			//	̕擪ݒ
			pS = pE;
		}
		//	es̃sNZi[
		if (LinePixs != NULL && ixLine < nLine) {
			LinePixs[ixLine] = pix;
			ixLine++;
		}
		//	ő啝XV
		width = __max(width, pix);
		pix   = 0;
		//	
		pW->fFont = fFontSv;
		pW->Lsp   = LspSv;
		//	cb
		SelectObject(pW->hdc, hFontSv	);
		SetTextColor(pW->hdc, TxtColorSv);
		SetBkColor	(pW->hdc, BkColorSv );
		SetBkMode	(pW->hdc, BkModeSv	);

		//	߂ݒ
		if (pSize != NULL) {
			pSize->cx = width;
			pSize->cy = height;
		}
		//	߂ls
		rc = lines;
	}
	return rc;
}

//==============================================================================================================//
//	pbg̐ݒ																								//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				fRestore - cbtO																		//
//																												//
//	߂l	F	 NULL  - njiqfa\̒̃AhX												//
//				 NULL  - G[																				//
//==============================================================================================================//
//----- SFݒ -----------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoSetPalette	(HAJCTXO pW, COLORREF rgb[8])
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (rgb != NULL) {
			memcpy(pW->Palette, rgb, sizeof(COLORREF) * 8);
			rc = TRUE;
		}
	}
	return rc;
}
//----- PFݒ -----------------------------------------------------------------------------------------------//
AJCEXPORT	COLORREF	WINAPI	AjcTxoSetPaletteItem(HAJCTXO pW, int ix, COLORREF rgb)
{
	COLORREF	rc = (COLORREF)-1;

	if (IS_MY_INST(pW)) {
		if (ix >= 0 && ix <= 7) {
			rc = pW->Palette[ix];
			pW->Palette[ix] = rgb;
		}
	}
	return rc;
}
//==============================================================================================================//
//	pbg̎擾																								//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				fRestore - cbtO																		//
//																												//
//	߂l	F	 NULL  - njiqfa\̒̃AhX												//
//				 NULL  - G[																				//
//==============================================================================================================//
//----- SFݒ -----------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcTxoGetPalette	(HAJCTXO pW, COLORREF rgb[8])
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (rgb != NULL) {
			memcpy(rgb, pW->Palette, sizeof(COLORREF) * 8);
			rc = TRUE;
		}
	}
	return rc;
}
//----- PFݒ -----------------------------------------------------------------------------------------------//
AJCEXPORT	COLORREF	WINAPI	AjcTxoGetPaletteItem(HAJCTXO pW, int ix)
{
	COLORREF	rc = (COLORREF)-1;

	if (IS_MY_INST(pW)) {
		if (ix >= 0 && ix <= 7) {
			rc = pW->Palette[ix];
		}
	}
	return rc;
}
//==============================================================================================================//
//	eLXg̃ftHgFݒ																					//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				defColor - eLXg̃ftHgF																//
//																												//
//	߂l	F	 -1FÕeLXg̃ftHgF																//
//				 -1FG[																					//
//==============================================================================================================//
AJCEXPORT	COLORREF	WINAPI	AjcTxoSetDefTextColor(HAJCTXO pW, COLORREF defColor)
{
	COLORREF	rc = (COLORREF)-1;

	if (IS_MY_INST(pW)) {
		rc = pW->TxtColorDef;
		pW->TxtColorDef = defColor;
		//	`FZbg
		ResetToDefaultColor(pW);
	}
	return rc;
}
//==============================================================================================================//
//	wĩftHgFݒ																						//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				defColor - eLXgwiftHgFi|PFj												//
//																												//
//	߂l	F	 -1FÕeLXgwiftHgF															//
//				 -1FG[																					//
//==============================================================================================================//
AJCEXPORT	COLORREF	WINAPI	AjcTxoSetDefBkColor(HAJCTXO pW, COLORREF defColor)
{
	COLORREF	rc = (COLORREF)-1;

	if (IS_MY_INST(pW)) {
		rc = pW->BkColorDef;
		pW->BkColorDef = defColor;
		//	`FZbg
		ResetToDefaultColor(pW);
	}
	return rc;
}
//==============================================================================================================//
//	TCY擾																								//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pSize	 - TCYi[obt@ւ̃|C^												//
//																												//
//	߂l	F	TRUE F																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcTxoGetCharSize	 (HAJCTXO pW, LPSIZE pSize)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pSize != NULL) {
			pSize->cx = pW->cxChar;
			pSize->cy = pW->cyChar;
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	sԃXy[X擾																							//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//																												//
//	߂l	F	-1 FisԃXy[Xj																		//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcTxoGetLineSpace	 (HAJCTXO pW)
{
	UI	rc = -1;

	if (IS_MY_INST(pW)) {
		rc = pW->LspDef;
	}
	return rc;
}
//==============================================================================================================//
//	sԃXy[Xݒ																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				defLsp 	- ftHg̍sԃXy[XiFsNZCF̂mj					//
//																												//
//	߂l	F	-1 FisԃXy[Xj																		//
//				-1 FG[																					//
//==============================================================================================================//
AJCEXPORT	UI			WINAPI	AjcTxoSetLineSpace	 (HAJCTXO pW, int defLsp)
{
	UI	rc = -1;

	if (IS_MY_INST(pW)) {
		rc = pW->LspDef;
		if (defLsp >= 0) pW->LspDef = defLsp;
		else			 pW->LspDef = abs(pW->cyChar * defLsp / 100);
		pW->Lsp = pW->LspDef;
	}
	return rc;
}

//==============================================================================================================//
//	^uXebv擾																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				defLsp 	- ftHg̍sԃXy[XiFsNZCF̂mj					//
//																												//
//	߂l	F	O Fi^uXebvj																		//
//				OFG[																					//
//==============================================================================================================//
AJCEXPORT	int			WINAPI	AjcTxoGetTabStep	 (HAJCTXO pW)
{
	int	rc = 0;

	if (IS_MY_INST(pW)) {
		rc = pW->TabStep;
	}
	return rc;
}
//==============================================================================================================//
//	^uXebvݒ																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				TabStep	- ^uXebvisNZCFϕCFŒ蕝j								//
//																												//
//	߂l	F	O FiÕ^uXebvj																//
//				OFG[																					//
//==============================================================================================================//
AJCEXPORT	int			WINAPI	AjcTxoSetTabStep	 (HAJCTXO pW, int TabStep)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		if (TabStep != 0) {
			rc			= pW->TabStep;
			pW->TabStep = TabStep;
		}
	}
	return rc;
}
//==============================================================================================================//
//	wi[h擾																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	O FiAJCTXO_{TRANSPARENT/OPAQUE}j														//
//				OFG[																					//
//==============================================================================================================//
AJCEXPORT	AJCTXOBKMODE	WINAPI	AjcTxoGetBkMode	 (HAJCTXO pW)
{
	AJCTXOBKMODE	rc = (AJCTXOBKMODE)0;

	if (IS_MY_INST(pW)) {
		rc = (AJCTXOBKMODE)GetBkMode(pW->hdc);
	}
	return rc;
}
//==============================================================================================================//
//	wi[hݒ																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				BkMode	- wi[hiAJCTXO_{TRANSPARENT/OPAQUE}j											//
//																												//
//	߂l	F	O Fiwi[hj																	//
//				O FG[																					//
//==============================================================================================================//
AJCEXPORT	AJCTXOBKMODE	WINAPI	AjcTxoSetBkMode	 (HAJCTXO pW, AJCTXOBKMODE BkMode)
{
	AJCTXOBKMODE	rc = (AJCTXOBKMODE)0;

	if (IS_MY_INST(pW)) {
		if (BkMode == AJCTXO_TRANSPARENT || BkMode == AJCTXO_OPAQUE) {
			rc = (AJCTXOBKMODE)SetBkMode(pW->hdc, (int)BkMode);
		}
	}
	return rc;
}

//==============================================================================================================//
//	drb̗																							//
//																												//
//	@	F	pEsc	 - CX^Xnh																	//
//				fRestore - cbtO																		//
//																												//
//	߂l	F	odrb̐																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoEnumEscA	(C_BCP pText, UX cbp, BOOL (CALLBACK *cbNtcEsc)(C_BCP pEsc, UI lEsc, BC cLast, UX cbp))
{
	UI		rc = 0;
	UI		lEsc;
	C_BCP	pEsc, pS;

	if (pText != NULL) {
		pS = pText;
		while (*pS != 0) {
			//	drbȂ΁Adrb
			if (*pS == '\x1B') {
				pEsc = pS;
				//	drbXV
				rc++;
				//	drb
				lEsc = 0;
				//	"\x1B" XLbv
				lEsc++;
				pS++;
				//	drbipj
				while (*pS != 0 && !MAjcAscIsAlphaA(*pS)) {
					lEsc++;
					pS++;
				}
				//	pȂ΂drbʒm
				if (MAjcAscIsAlphaA(*pS)) {
					//	p܂߂drbݒ
					lEsc++;
					//	drbʒm
					if (cbNtcEsc != NULL) {
						if (!cbNtcEsc(pEsc, lEsc, *pS, cbp)) {
							break;
						}
					}
					//	pXLbv
					pS++;
				}
			}
			//	drbȊOȂ΁A|C^XV
			else {
				pS++;
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcTxoEnumEscW	(C_WCP pText, UX cbp, BOOL (CALLBACK *cbNtcEsc)(C_WCP pEsc, UI lEsc, WC cLast, UX cbp))
{
	UI		rc = 0;
	UI		lEsc;
	C_WCP	pEsc, pS;

	if (pText != NULL) {
		pS = pText;
		while (*pS != 0) {
			//	drbȂ΁Adrb
			if (*pS == L'\x1B') {
				pEsc = pS;
				//	drbXV
				rc++;
				//	drb
				lEsc = 0;
				//	"\x1B" XLbv
				lEsc++;
				pS++;
				//	drbipj
				while (*pS != 0 && !MAjcAscIsAlphaW(*pS)) {
					lEsc++;
					pS++;
				}
				//	pȂ΂drbʒm
				if (MAjcAscIsAlphaW(*pS)) {
					//	p܂߂drbݒ
					lEsc++;
					//	drbʒm
					if (cbNtcEsc != NULL) {
						if (!cbNtcEsc(pEsc, lEsc, *pS, cbp)) {
							break;
						}
					}
					//	pXLbv
					pS++;
				}
			}
			//	drbȊOȂ΁A|C^XV
			else {
				pS++;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	qfa\̉																						//
//																												//
//	@	F	pText	 - qfa\("r;g;b")ւ̃|C^												//
//				pBuf	 - qfali[obt@̃AhX													//
//																												//
//	߂l	F	 NULL  - njiqfa\̒̃AhXj												//
//				 NULL  - G[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcTxoGetRgbByTextA	(C_BCP pText, COLORREF *pBuf)
{
	BCP			rc = NULL;
	C_BCP		pS = pText;
	UI			i;

	union {
		UI					 arr[3];
		struct {UI r, g, b;} s;
	} u;

	if (pText != NULL) {
		//	R̐ir;g;bj擾
		for (i = 0; i < 3; i++) {
			//	擾
			if (MAjcAscIsDigitA(*pS)) {
				u.arr[i] = atoi(pS);
			}
			else {
				u.arr[i] = 0;
			}
			//	XLbv
			while (MAjcAscIsDigitA(*pS)) pS++;
			//	(b)ȊOȂ΃Z~R(;)XLbv
			if (i < 2) {
				if (*pS == ';') {
					pS++;
				}
				else break;	//	Z~R(;)ꍇ̓G[
			}
		}
		//	qfaݒ
		if (i == 3) {
			if (pBuf != NULL) {
				*pBuf = RGB(u.s.r, u.s.g, u.s.b);
			}
			rc = (BCP)pS;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcTxoGetRgbByTextW	(C_WCP pText, COLORREF *pBuf)
{
	WCP			rc = NULL;
	C_WCP		pS = pText;
	UI			i;

	union {
		UI					 arr[3];
		struct {UI r, g, b;} s;
	} u;

	if (pText != NULL) {
		//	R̐ir;g;bj擾
		for (i = 0; i < 3; i++) {
			//	擾
			if (MAjcAscIsDigitW(*pS)) {
				u.arr[i] = _wtoi(pS);
			}
			else {
				u.arr[i] = 0;
			}
			//	XLbv
			while (MAjcAscIsDigitW(*pS)) pS++;
			//	(b)ȊOȂ΃Z~R(;)XLbv
			if (i < 2) {
				if (*pS == L';') {
					pS++;
				}
				else break;	//	Z~R(;)ꍇ̓G[
			}
		}
		//	qfaݒ
		if (i == 3) {
			if (pBuf != NULL) {
				*pBuf = RGB(u.s.r, u.s.g, u.s.b);
			}
			rc = (WCP)pS;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	tHgύX																								//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ChangeFontoToHdc(HAJCTXO pW)
{
	LOGFONT		lf;

	switch (pW->fFont) {
		case AJCCFBE_NORMAL:		//	m[}
			if (pW->hFontN == NULL) {
				if (GetObject((HGDIOBJ)pW->hFontOrg, sizeof lf, (VOP)&lf)) {
					lf.lfWeight    = FW_DONTCARE;
					lf.lfItalic    = FALSE;
					lf.lfUnderline = FALSE;
					pW->hFontN = CreateFontIndirect(&lf);
				}
			}
			if (pW->hFontN != NULL) {
				SelectObject(pW->hdc, pW->hFontN);
			}
			break;

		case AJCCFBE_BOLD:			//	{[h
			if (pW->hFontB == NULL) {
				if (GetObject((HGDIOBJ)pW->hFontOrg, sizeof lf, (VOP)&lf)) {
					lf.lfWeight    = FW_BOLD;
					lf.lfItalic    = FALSE;
					lf.lfUnderline = FALSE;
					pW->hFontB = CreateFontIndirect(&lf);
				}
			}
			if (pW->hFontB != NULL) {
				SelectObject(pW->hdc, pW->hFontB);
			}
			break;

		case AJCCFBE_ITALIC:		//	C^bN
			if (pW->hFontI == NULL) {
				if (GetObject((HGDIOBJ)pW->hFontOrg, sizeof lf, (VOP)&lf)) {
					lf.lfWeight    = FW_DONTCARE;
					lf.lfItalic    = TRUE;
					lf.lfUnderline = FALSE;
					pW->hFontI = CreateFontIndirect(&lf);
				}
			}
			if (pW->hFontI != NULL) {
				SelectObject(pW->hdc, pW->hFontI);
			}
			break;

		case AJCCFBE_ULINE:			//	A_[C
			if (pW->hFontU == NULL) {
				if (GetObject((HGDIOBJ)pW->hFontOrg, sizeof lf, (VOP)&lf)) {
					lf.lfWeight    = FW_DONTCARE;
					lf.lfItalic    = FALSE;
					lf.lfUnderline = TRUE;
					pW->hFontU = CreateFontIndirect(&lf);
				}
			}
			if (pW->hFontU != NULL) {
				SelectObject(pW->hdc, pW->hFontU);
			}
			break;

		case AJCCFBE_BOLD_ITALIC:	//	{[h{C^bN
			if (pW->hFontBI == NULL) {
				if (GetObject((HGDIOBJ)pW->hFontOrg, sizeof lf, (VOP)&lf)) {
					lf.lfWeight    = FW_BOLD;
					lf.lfItalic    = TRUE;
					lf.lfUnderline = FALSE;
					pW->hFontBI = CreateFontIndirect(&lf);
				}
			}
			if (pW->hFontBI != NULL) {
				SelectObject(pW->hdc, pW->hFontBI);
			}
			break;

		case AJCCFBE_BOLD_ULINE:	//	{[h{A_[C
			if (pW->hFontBU == NULL) {
				if (GetObject((HGDIOBJ)pW->hFontOrg, sizeof lf, (VOP)&lf)) {
					lf.lfWeight    = FW_BOLD;
					lf.lfItalic    = FALSE;
					lf.lfUnderline = TRUE;
					pW->hFontBU = CreateFontIndirect(&lf);
				}
			}
			if (pW->hFontBU != NULL) {
				SelectObject(pW->hdc, pW->hFontBU);
			}
			break;

		case AJCCFBE_ITALIC_ULINE:	//	C^bN{A_[C
			if (pW->hFontIU == NULL) {
				if (GetObject((HGDIOBJ)pW->hFontOrg, sizeof lf, (VOP)&lf)) {
					lf.lfWeight    = FW_DONTCARE;
					lf.lfItalic    = TRUE;
					lf.lfUnderline = TRUE;
					pW->hFontIU = CreateFontIndirect(&lf);
				}
			}
			if (pW->hFontIU != NULL) {
				SelectObject(pW->hdc, pW->hFontIU);
			}
			break;

		case AJCCFBE_ALL:			//	{[h{C^bN{A_[C
			if (pW->hFontBIU == NULL) {
				if (GetObject((HGDIOBJ)pW->hFontOrg, sizeof lf, (VOP)&lf)) {
					lf.lfWeight    = FW_BOLD;
					lf.lfItalic    = TRUE;
					lf.lfUnderline = TRUE;
					pW->hFontBIU = CreateFontIndirect(&lf);
				}
			}
			if (pW->hFontBIU != NULL) {
				SelectObject(pW->hdc, pW->hFontBIU);
			}
			break;
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	`FZbg																								//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	ResetToDefaultColor(HAJCTXO pW)
{
	//	eLXgFZbg
	SetTextColor(pW->hdc, pW->TxtColorDef);
	//	wiFZbg
	if (pW->BkColorDef == -1) {
		SetBkMode(pW->hdc, TRANSPARENT);
	}
	else {
		SetBkMode(pW->hdc, OPAQUE);
		SetBkColor(pW->hdc, pW->BkColorDef);
	}
}

