#include	"AjcInternal.h"

static	LARGE_INTEGER	nFreq = {0};

//==============================================================================================================//
//	Nݒ																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
BOOL	AjcTimeMeasureInit(VO)
{
	BOOL	rc = FALSE;

	QueryPerformanceFrequency(&nFreq);

	return TRUE;
}
//==============================================================================================================//
//	I㏈																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
VO		AjcTimeMeasureEnd (VO)
{
	//	NOP
}



//==============================================================================================================//
//	ԌvJn																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
static	ULL				msSrtTime;
static	LARGE_INTEGER	nBefore, nAfter;
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcTimeMeasureStart(VO)
{
	if (nFreq.QuadPart != 0) {
		QueryPerformanceCounter(&nBefore);
	}
	else {
		msSrtTime = timeGetTime();
	}
	return nFreq.QuadPart;
}
//==============================================================================================================//
//	Ԍv																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	v [us] iAjcMesTimeStart()/AjcMesTimeInterval()šoߎԁj						//
//==============================================================================================================//
AJCEXPORT	ULL	WINAPI	AjcTimeMeasureInterval(VO)
{
	ULL		ct, rc = 0;

	if (nFreq.QuadPart != 0) {
		QueryPerformanceCounter(&nAfter);
		rc = (nAfter.QuadPart - nBefore.QuadPart) * (ULL)1000000 / nFreq.QuadPart;
		nBefore.QuadPart = nAfter.QuadPart;
	}
	else {
		ct = timeGetTime();
		rc = (ULL)(ct - msSrtTime) * (ULL)1000;
		msSrtTime = ct;
	}
	return rc;
}
//==============================================================================================================//
//	oߎԌv																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	v [us] iAjcMesTimeStart()/AjcMesTimeInterval()šoߎԁj						//
//==============================================================================================================//
AJCEXPORT	ULL	WINAPI	AjcTimeMeasureElapse(VO)
{
	ULL		rc = 0;

	if (nFreq.QuadPart != 0) {
		QueryPerformanceCounter(&nAfter);
		rc = (nAfter.QuadPart - nBefore.QuadPart) * (ULL)1000000 / nFreq.QuadPart;
	}
	else {
		rc = (ULL)(timeGetTime() - msSrtTime) * (ULL)1000;
	}
	return rc;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - // 
AJCEXPORT	ULL	WINAPI	AjcTimeMeasureStop(VO)
{
	return AjcTimeMeasureElapse();
}
//==============================================================================================================//
//	}`CX^XpEԌvIuWFNg																//
//																												//
//	@	F	pFreq - vgi[obt@̃AhX(svNULL)									//
//																												//
//	߂l	F	NULL:CX^Xnh																		//
//				NULL:G[iԌvsj																	//
//==============================================================================================================//
AJCEXPORT	HAJCMESTIME	WINAPI	AjcMesTimeCreate(ULLP pFreq)
{
	HAJCMESTIME		pW = NULL;

	if (pW = (HAJCMESTIME)AJCMEM(sizeof(AJCMESTIME))) {
		memset(pW, 0, sizeof(AJCMESTIME));
		if (nFreq.QuadPart != 0) {
			QueryPerformanceCounter(&pW->Before);
		}
		else {
			pW->msSTime = timeGetTime();
		}
		if (pFreq != NULL) {
			*pFreq = nFreq.QuadPart;
		}
	}
	return pW;
}
//==============================================================================================================//
//	}`CX^XpEԌvIuWFNg																//
//																												//
//	@	F	pW - CX^Xnh																		//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	VO	WINAPI	AjcMesTimeDelete(HAJCMESTIME pW)
{
	if (pW != NULL) {
		free(pW);
	}
}
//==============================================================================================================//
//	}`CX^XpEԌv																			//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	v [us] iAjcMesTimeCreate/AjcMesTimeInterval()šoߎԁj						//
//==============================================================================================================//
AJCEXPORT	ULL	WINAPI	AjcMesTimeInterval(HAJCMESTIME pW)
{
	ULL		ct, rc = 0;

	if (pW != NULL) {
		if (nFreq.QuadPart != 0) {
			QueryPerformanceCounter(&pW->After);
			rc = (pW->After.QuadPart - pW->Before.QuadPart) * (ULL)1000000 / nFreq.QuadPart;
			pW->Before.QuadPart = pW->After.QuadPart;
		}
		else {
			ct = timeGetTime();
			rc = (ULL)(ct - pW->msSTime) * (ULL)1000;
			pW->msSTime = ct;
		}
	}
	return rc;
}
//==============================================================================================================//
//	}`CX^XpEoߎԌv																			//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	v [us] iAjcMesTimeCreate/AjcMesTimeInterval()šoߎԁj						//
//==============================================================================================================//
AJCEXPORT	ULL	WINAPI	AjcMesTimeElapse(HAJCMESTIME pW)
{
	ULL		ct, rc = 0;

	if (pW != NULL) {
		if (nFreq.QuadPart != 0) {
			QueryPerformanceCounter(&pW->After);
			rc = (pW->After.QuadPart - pW->Before.QuadPart) * (ULL)1000000 / nFreq.QuadPart;
		}
		else {
			ct = timeGetTime();
			rc = (ULL)(ct - pW->msSTime) * (ULL)1000;
		}
	}
	return rc;
}
