#include	"AjcInternal.h"
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	Rg[̉i																						//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//

#define	PATT_PROP_NAME	L"_AJC_CONTROL_PERMATT"

#define	NO_TXT_STR		L"?AjcNoText?"

//--------------------------------------------------------------------------------------------------------------//
//	EChƃf[^̊֘At																				//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	UI		dat;					//	֘Atf[^
	WC		str[256];				//	֘At镶
} WNDDATA, *PWNDDATA;

MAJCAVLPTR(WDNODE, PWNDDATA);

//	EChf[^֘Atp`uk
static		HAJCAVL		hAvlWndData = NULL;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SetWndData(HWND hwnd, HWND hGrp, UI data, C_WCP pSect);
static	C_WCP	GetWndData(HWND hwnd, HWND hGrp, UIP pDat);

//==============================================================================================================//
//	Nݒ																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
BOOL	AjcWndItemPermInit(VO)
{
	BOOL	rc = FALSE;

	//	EChf[^֘Atp`uk
	if (hAvlWndData = AjcAvlCreate (0, NULL, NULL)) {
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	I㏈																								//
//																												//
//	@	F	Ȃ																							//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - G[																					//
//==============================================================================================================//
VO		AjcWndItemPermEnd (VO)
{
	//	EChf[^֘Atp`ukj
	if (hAvlWndData != NULL) {
		AjcAvlDelete(hAvlWndData);
		hAvlWndData = NULL;
	}
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	Rg[̉i																						//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//==============================================================================================================//
//	Rg[̉iݒ^																				//
//																												//
//	@F	hwnd	  - Rg[̃EChnh														//
//				att		  - iiOFj															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSetPermAtt	(HWND hctrl,	   UI att)
{
	BOOL	rc = FALSE;

	if (IsWindow(hctrl)) {
		if (att & AJCCTL_PSEL_DELETE) {
			rc = (RemoveProp(hctrl, PATT_PROP_NAME) != NULL);
		}
		else {
			rc = SetProp(hctrl, PATT_PROP_NAME, (HANDLE)((UX)att));
		}
	}
	return rc;
}
//==============================================================================================================//
//	O[v{bNXSRg[̉iݒ^															//
//																												//
//	@F	hwnd	  - Rg[̃EChnh														//
//				att		  - iiOFj															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
typedef struct {
	HWND	hw;
	RECT	r;
	UI		att;
	BOOL	rc;
} CSPAPARAM, *PCSPAPARAM;

//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbCspaEnum(HWND hwnd, LPARAM lParam)
{
	PCSPAPARAM	p = (PCSPAPARAM)lParam;
	RECT		rct;

	GetWindowRect(hwnd, &rct);
	if (hwnd != p->hw && rct.left >= p->r.left && rct.top >= p->r.top && rct.right <= p->r.right && rct.bottom <= p->r.bottom) {
		if (!AjcCtrlSetPermAtt(hwnd, p->att)) {
			p->rc = FALSE;
		}
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSetPermAttGrp(HWND hwnd, UI att)
{
	BOOL		rc = FALSE;
	CSPAPARAM	prm;
	HWND		hParent;

	if (IsWindow(hwnd)	&&	(hParent = GetParent(hwnd)) != NULL) {
		prm.hw = hwnd;
		GetWindowRect(hwnd, &prm.r);
		prm.att = att;
		prm.rc	= TRUE;
		EnumChildWindows(hParent, cbCspaEnum, (LPARAM)&prm);
		rc = prm.rc;
	}
	return rc;
}

//==============================================================================================================//
//	SRg[̉i																					//
//																												//
//	@F	hwnd	  - Rg[̐eEChnh													//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT 	BOOL	WINAPI	AjcDelAllCtrlPermAtt(HWND hwnd)
{
	BOOL	rc = FALSE;

	if (IsWindow(hwnd)) {
		hwnd = GetWindow(hwnd, GW_CHILD);
		while (hwnd) {
			if (GetProp(hwnd, PATT_PROP_NAME) != NULL) {
				RemoveProp(hwnd, PATT_PROP_NAME);
			}
			hwnd = GetWindow(hwnd, GW_HWNDNEXT);
		}
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	EChSRg[̉iǂݏo																//
//																												//
//	@F	hwnd	- Rg[̐eEChnh														//
//				pSect	- vt@CZNṼAhX													//
//				act		- Rg[̑I𓮍w															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcLoadAllControlSettingsA(HWND hwnd, C_BCP pSect, UI act)
{
	return AjcLoadGrpControlSettingsA(hwnd, NULL, pSect, act);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcLoadAllControlSettingsW(HWND hwnd, C_WCP pSect, UI act)
{
	return AjcLoadGrpControlSettingsW(hwnd, NULL, pSect, act);
}
//==============================================================================================================//
//	O[v{bNXSRg[̉iǂݏo														//
//																												//
//	@F	hwnd	- Rg[̐eEChnh														//
//				hGrp	- O[v{bNX̃EChnh													//
//				pSect	- vt@CZNṼAhX													//
//				act		- Rg[̑I𓮍w															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcLoadGrpControlSettingsA(HWND hwnd, HWND hGrp, C_BCP pSect, UI act)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	do {
		if (pSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
			if (len != 0 && (pTmp = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			}
			else break;
			rc = AjcLoadGrpControlSettingsW(hwnd, hGrp, pTmp, act);
		}
	} while(0);

	if (pTmp != NULL) AjcTFree(pTmp);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcLoadGrpControlSettingsW(HWND hwnd, HWND hGrp, C_WCP pSect, UI act)
{
	BOOL	rc = TRUE;
	BOOL	rsu;
	UI		att = 0;
	HWND	hParent = hwnd;
	WC		cls[MAX_PATH];
	WC		key[256];
	RECT	r, rG;

	if (IsWindow(hwnd) && pSect != NULL && SetWndData(hwnd, hGrp, act, pSect)) {
		//----- O[v{bNX̋`ݒ ---------------------------------------------------------------------//
		if (IsWindow(hGrp)) {
			GetWindowRect(hGrp, &rG);
		}
		else hGrp = NULL;
		//----- ECh̑SqECh[viAjrCtlXXXXXiĺCVT100C^C`[gjǂݏoj--------//
		hwnd = GetWindow(hParent, GW_CHILD);
		while (hwnd) {
			//	ECh̋`擾AO[v`FbN
			if (hGrp) {
				GetWindowRect(hwnd, &r);
			}
			if (hGrp == NULL || (r.left >= rG.left && r.top >= rG.top && r.right <= rG.right && r.bottom <= rG.bottom)) {
				//	ECh̉i擾
				att = (UI)((UX)GetProp(hwnd, PATT_PROP_NAME));
				do {
					//	iڂ珜ORg[ȊOi and uORg[v}[NĂ΃XLbv
					if ((act & AJCCTL_SELACT_CHKEXCLUDE) && (att & AJCCTL_PSEL_EXCLUDE)) break;
					//	iڂɊ܂߂Rg[݂̂ΏۂƂ and uiڂɊ܂߂v}[NĂȂ΃XLbv
					if ((act & AJCCTL_SELACT_CHKINCLUDE) && !(att & AJCCTL_PSEL_INCLUDE)) break;
					//	NXݒ
					wcscpy(cls, L"?CUnKnown?");
					GetClassName(hwnd, cls, AJCTSIZE(cls));
					//	AjcCtrlListBox
					if		(wcsicmp(cls, L"AjcCtrlListBox"	) == 0) {
						AjcSnPrintF(key, AJCTSIZE(key), L"Lbx_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
						if (!(rsu = AjcLbxLoadPermInfo(hwnd, pSect, key))) {
							rc = FALSE;
						}
					}
					//	AjcCtrlInpValue
					else if (wcsicmp(cls, L"AjcCtrlInpVal"	) == 0) {
						AjcSnPrintF(key, AJCTSIZE(key), L"Inp_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
						if (!(rsu = AjcIvLoadPermInfo(hwnd, pSect, key, (att & AJCCTL_PSEL_NONTC) == 0 && 
																		((act & AJCCTL_SELACT_NTCINP) || (att & AJCCTL_PSEL_NTC))))) {
							rc = FALSE;
						}
					}
					//	AjcCtrlVT100
					else if (wcsicmp(cls, L"AjcCtrlVT100"	) == 0) {
						AjcSnPrintF(key, AJCTSIZE(key), L"Vth_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
						if (!(rsu = AjcVthLoadPermInfoEx(hwnd, pSect, key, AJCVTH_PERM_FONT))) {
							rc = FALSE;
						}
					}
					//	AjcCtrlTimeChart
					else if (wcsicmp(cls, L"AjcCtrlTmChart"	) == 0) {
						AjcSnPrintF(key, AJCTSIZE(key), L"Tch_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
						if (!(rsu = AjcTchLoadPermInfoEx(hwnd, pSect, key, AJCTCH_PERM_FILTER))) {
							rc = FALSE;
						}
					}
				} while(0);
			}
			hwnd = GetWindow(hwnd, GW_HWNDNEXT);
		}

		//----- ECh̑SqECh[viR{{bNX(ComboBox)CXg{bNX(ListBox) ǂݏoj----//
		hwnd = GetWindow(hParent, GW_CHILD);
		while (hwnd) {
			//	ECh̋`擾AO[v`FbN
			if (hGrp) {
				GetWindowRect(hwnd, &r);
			}
			if (hGrp == NULL || (r.left >= rG.left && r.top >= rG.top && r.right <= rG.right && r.bottom <= rG.bottom)) {
				//	ECh̉i擾
				att = (UI)((UX)GetProp(hwnd, PATT_PROP_NAME));
				do {
					//	iڂ珜ORg[ȊOi and uORg[v}[NĂ΃XLbv
					if ((act & AJCCTL_SELACT_CHKEXCLUDE) && (att & AJCCTL_PSEL_EXCLUDE)) break;
					//	iڂɊ܂߂Rg[݂̂ΏۂƂ	   and uiڂɊ܂߂v}[NĂȂ΃XLbv
					if ((act & AJCCTL_SELACT_CHKINCLUDE) && !(att & AJCCTL_PSEL_INCLUDE)) break;
					//	NXݒ
					wcscpy(cls, L"?CUnKnown?");
					GetClassName(hwnd, cls, AJCTSIZE(cls));
					//	R{{bNX
					if		(wcsicmp(cls, L"ComboBox") == 0) {
						UI	sel;
						sel = (att & AJCCTL_PSEL_MASK);
						if (rsu = AjcCtrlLoadComboBox(hwnd, pSect, sel, (att & AJCCTL_PSEL_NONTC) == 0 &&
																		((act & AJCCTL_SELACT_NTCCBO) || (att & AJCCTL_PSEL_NTC)))) {
							//	NOP
						}
						else rc = FALSE;
					}
					//	Xg{bNX
					else if (wcsicmp(cls, L"ListBox") == 0) {
						UI	sel = att & AJCCTL_PSEL_MASK;
						if (rsu = AjcCtrlLoadListBox(hwnd, pSect, sel)) {
							//	NOP
						}
						else rc = FALSE;
					}
				} while(0);
			}
			hwnd = GetWindow(hwnd, GW_HWNDNEXT);
		}
		//----- ECh̑SqECh[vieLXg{bNXC`FbN{bNXCWI{^ ǂݏoj-----//
		hwnd = GetWindow(hParent, GW_CHILD);
		while (hwnd) {
			//	ECh̋`擾AO[v`FbN
			if (hGrp) {
				GetWindowRect(hwnd, &r);
			}
			if (hGrp == NULL || (r.left >= rG.left && r.top >= rG.top && r.right <= rG.right && r.bottom <= rG.bottom)) {
				att = (UI)((UX)GetProp(hwnd, PATT_PROP_NAME));
				do {
					//	iڂ珜ORg[ȊOi and uORg[v}[NĂ΃XLbv
					if ((act & AJCCTL_SELACT_CHKEXCLUDE) && (att & AJCCTL_PSEL_EXCLUDE)) break;
					//	iڂɊ܂߂Rg[݂̂ΏۂƂ	   and uiڂɊ܂߂v}[NĂȂ΃XLbv
					if ((act & AJCCTL_SELACT_CHKINCLUDE) && !(att & AJCCTL_PSEL_INCLUDE)) break;
					//	NXݒ
					wcscpy(cls, L"?CUnKnown?");
					GetClassName(hwnd, cls, AJCTSIZE(cls));
					//	GfBbgRg[
					if		(wcsicmp(cls, L"Edit"			) == 0) {
						//	eLXgf[^[h
						if (att & AJCCTL_PSEL_INCRDONLY) rsu = AjcCtrlLoadTextBoxEx(hwnd, pSect, FALSE);
						else							 rsu = AjcCtrlLoadTextBoxEx(hwnd, pSect, TRUE );
						//	G[ȂΖ߂lݒ
						if (!rsu) rc = FALSE;
					}
					//	{^Rg[
					else if (wcsicmp(cls, L"Button"			) == 0) {
						UI	sty, typ;
						sty = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
						typ = (sty & BS_TYPEMASK);
						//	WI{^̃`FbNԃ[h
						if		((typ == BS_RADIOBUTTON || typ == BS_AUTORADIOBUTTON)) {
							rc = AjcCtrlLoadChkBox(hwnd, pSect, (att & AJCCTL_PSEL_NONTC) == 0 && 
																((act & AJCCTL_SELACT_NTCRBT) || (att & AJCCTL_PSEL_NTC)));
						}
						//	`FbN{bNX̃`FbNԃ[h
						else if (typ == BS_CHECKBOX || typ == BS_AUTOCHECKBOX || typ == BS_3STATE || typ == BS_AUTO3STATE) {
							rc = AjcCtrlLoadChkBox(hwnd, pSect, (att & AJCCTL_PSEL_NONTC) == 0 && 
																((act & AJCCTL_SELACT_NTCCHK) || (att & AJCCTL_PSEL_NTC)));
						}
					}
				} while(0);
			}
			hwnd = GetWindow(hwnd, GW_HWNDNEXT);
		}
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	EChSRg[̉i񏑂																//
//																												//
//	@F	hwnd	- Rg[̐eEChnh														//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT 	BOOL	WINAPI	AjcSaveAllControlSettings(HWND hwnd)
{
	return AjcSaveGrpControlSettings(hwnd, NULL);
}
//==============================================================================================================//
//	EChSRg[̉i񏑂݁igj														//
//																												//
//	@F	hwnd	- Rg[̐eEChnh														//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcSaveAllControlSettingsExA(HWND hwnd, C_BCP pSect, UI act)
{
	return AjcSaveGrpControlSettingsExA(hwnd, NULL, pSect, act);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcSaveAllControlSettingsExW(HWND hwnd, C_WCP pSect, UI act)
{
	return AjcSaveGrpControlSettingsExW(hwnd, NULL, pSect, act);
}
//==============================================================================================================//
//	O[v{bNXSRg[̉i񏑂														//
//																												//
//	@F	hwnd	- Rg[̐eEChnh														//
//				hGrp	- O[v{bNX̃EChnh													//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT 	BOOL	WINAPI	AjcSaveGrpControlSettings(HWND hwnd, HWND hGrp)
{
	return AjcSaveGrpControlSettingsExW(hwnd, hGrp, NULL, AJCCTL_SELACT_BYLOAD);
}
//==============================================================================================================//
//	O[v{bNXSRg[̉i񏑂݁igj												//
//																												//
//	@F	hwnd	- Rg[̐eEChnh														//
//				hGrp	- O[v{bNX̃EChnh													//
//				pSect	- vt@CZNṼAhX													//
//				act		- Rg[̑I𓮍w															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcSaveGrpControlSettingsExA(HWND hwnd, HWND hGrp, C_BCP pSect, UI act)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	do {
		if (pSect != NULL) {
			len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
			if (len != 0 && (pTmp = AjcTAlloc(len))) {
				MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			}
			else break;
			rc = AjcSaveGrpControlSettingsExW(hwnd, hGrp, pTmp, act);
		}
	} while(0);

	if (pTmp != NULL) AjcTFree(pTmp);

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcSaveGrpControlSettingsExW(HWND hwnd, HWND hGrp, C_WCP pSect, UI act)
{
	BOOL	rc = TRUE;
	BOOL	rsu;
	UI		att = 0;
	HWND	hParent = hwnd;
	WC		cls[MAX_PATH];
	WC		key[256];
	RECT	r, rG;

	if (IsWindow(hwnd)) {
		//----- ZNVANVp^ݒ -----------------------------------------------------------//
		C_WCP	s;
		UI		a;
		s = GetWndData(hwnd, hGrp, &a);
		if (pSect == NULL			  ) pSect = s;
		if (act & AJCCTL_SELACT_BYLOAD) act   = a;
		//----- i񏑂 -----------------------------------------------------------------------------//
		if (pSect != NULL) {
			//----- O[v{bNX̋`ݒ ---------------------------------------------------------------------//
			if (IsWindow(hGrp)) {
				GetWindowRect(hGrp, &rG);
			}
			else hGrp = NULL;
			//----- ECh̑SqECh[v -----------------------------------------------------------------//
			hwnd = GetWindow(hwnd, GW_CHILD);
			while (hwnd) {
				//	ECh̋`擾AO[v`FbN
				if (hGrp) {
					GetWindowRect(hwnd, &r);
				}
				if (hGrp == NULL || (r.left >= rG.left && r.top >= rG.top && r.right <= rG.right && r.bottom <= rG.bottom)) {
					//	ECh̉i擾
					att = (UI)((UX)GetProp(hwnd, PATT_PROP_NAME));
					do {
						//	iڂ珜ORg[ȊOi and uORg[v}[NĂ΃XLbv
						if ((act & AJCCTL_SELACT_CHKEXCLUDE) && (att & AJCCTL_PSEL_EXCLUDE)) break;
						//	iڂɊ܂߂Rg[݂̂ΏۂƂ	   and uiڂɊ܂߂v}[NĂȂ΃XLbv
						if ((act & AJCCTL_SELACT_CHKINCLUDE) && !(att & AJCCTL_PSEL_INCLUDE)) break;
						//	NXݒ
						wcscpy(cls, L"?CUnKnown?");
						GetClassName(hwnd, cls, AJCTSIZE(cls));
						//	GfBbgRg[
						if		(wcsicmp(cls, L"Edit"			) == 0) {
							if (att & AJCCTL_PSEL_INCRDONLY) rsu = AjcCtrlSaveTextBoxEx(hwnd, pSect, FALSE);
							else							 rsu = AjcCtrlSaveTextBoxEx(hwnd, pSect, TRUE );
							if (!rsu) rc = FALSE;
						}
						//	{^Rg[
						else if (wcsicmp(cls, L"Button"			) == 0) {
							if (!(rsu = AjcCtrlSaveChkBox(hwnd, pSect))) {
								rc = FALSE;
							}
						}
						//	R{{bNX
						else if (wcsicmp(cls, L"ComboBox"		) == 0) {
							UI	sel;
							sel = (att & AJCCTL_PSEL_MASK);	
							if (!(rsu = AjcCtrlSaveComboBox(hwnd, pSect, sel))) {
								rc = FALSE;
							}
						}
						//	Xg{bNX
						else if (wcsicmp(cls, L"ListBox"			) == 0) {
							if (!(rsu = AjcCtrlSaveListBox(hwnd, pSect, att))) {
								rc = FALSE;
							}
						}
						//	AjcCtrlListBox
						else if (wcsicmp(cls, L"AjcCtrlListBox"	) == 0) {
							AjcSnPrintF(key, AJCTSIZE(key), L"Lbx_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
							if (!(rsu = AjcLbxSavePermInfoEx(hwnd, pSect, key))) {
								rc = FALSE;
							}
						}
						//	AjcCtrlInpValue
						else if (wcsicmp(cls, L"AjcCtrlInpVal"	) == 0) {
							AjcSnPrintF(key, AJCTSIZE(key), L"Inp_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
							if (!(rsu = AjcIvSavePermInfoEx(hwnd, pSect, key))) {
								rc = FALSE;
							}
						}
						//	AjcCtrlVT100
						else if (wcsicmp(cls, L"AjcCtrlVT100"	) == 0) {
							AjcSnPrintF(key, AJCTSIZE(key), L"Vth_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
							if (!(rsu = AjcVthSavePermInfoEx(hwnd, pSect, key, AJCVTH_PERM_FONT))) {
								rc = FALSE;
							}
						}
						//	AjcCtrlTimeChart
						else if (wcsicmp(cls, L"AjcCtrlTmChart"	) == 0) {
							AjcSnPrintF(key, AJCTSIZE(key), L"Tch_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
							if (!(rsu = AjcTchSavePermInfoEx(hwnd, pSect, key, AJCTCH_PERM_FILTER))) {
								rc = FALSE;
							}
						}
					} while(0);
				}
				hwnd = GetWindow(hwnd, GW_HWNDNEXT);
			}
		}
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	eLXg{bNX[h																						//
//																												//
//	@F	hwnd		- Xg{bNX̃EChnh													//
//				pSect		- vt@CZNṼAhX												//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadTextBoxA(HWND hwnd, C_BCP pSect)
{
	BOOL	rc = FALSE;
	AjcCtrlLoadTextBoxExA(hwnd, pSect, TRUE);
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadTextBoxW(HWND hwnd, C_WCP pSect)
{
	BOOL	rc = FALSE;
	AjcCtrlLoadTextBoxExW(hwnd, pSect, TRUE);
	return rc;
}
//==============================================================================================================//
//	eLXg{bNX[higj																				//
//																												//
//	@F	hwnd		- Xg{bNX̃EChnh													//
//				pSect		- vt@CZNṼAhX												//
//				fExcRdOnly	- TRUE:ǂݏopO															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadTextBoxExA(HWND hwnd, C_BCP pSect, BOOL fExcRdOnly)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
	if (len != 0 && (pTmp = AjcTAlloc(len))) {
		MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
		rc = AjcCtrlLoadTextBoxExW(hwnd, pTmp, fExcRdOnly);
		free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadTextBoxExW(HWND hwnd, C_WCP pSect, BOOL fExcRdOnly)
{
	BOOL	rc	 = TRUE;
	UI		sty  = 0;
	WC		cls[256];
	WC		sec[256];
	WC		key[256];
	WC		txt[4096];

	if (IsWindow(hwnd) && pSect != NULL) {
		do {
			//	NX`FbN
			wcscpy(cls, L"?CUnKnown?");
			GetClassName(hwnd, cls, AJCTSIZE(cls));
			if (wcsicmp(cls, L"Edit") != 0) {rc = FALSE; break;}
			//	X^C擾
			sty = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
			//	ǂݏopO`FbN
			if (fExcRdOnly && (sty & ES_READONLY)) break;
			//	vt@CZNVݒ
			AjcSnPrintFW(sec, AJCTSIZE(sec), L"%s", pSect);
			//	vt@CL[ݒ
			AjcSnPrintF(key, AJCTSIZE(key), L"Edt_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
			//	eLXgǂݏoRg[֐ݒ
			AjcGetCtrlStr(hwnd, txt, AJCTSIZE(txt));
			AjcGetProfileStr(sec, key, txt, txt, AJCTSIZE(txt));
			AjcSetCtrlStr(hwnd, txt);
		} while(0);
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	eLXg{bNXZ[u																						//
//																												//
//	@F	hwnd	- Xg{bNX̃EChnh														//
//				pSect	- vt@CZNṼAhX													//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveTextBoxA(HWND hwnd, C_BCP pSect)
{
	BOOL	rc = FALSE;
	rc = AjcCtrlSaveTextBoxExA(hwnd, pSect, TRUE);
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveTextBoxW(HWND hwnd, C_WCP pSect)
{
	BOOL	rc = FALSE;
	rc = AjcCtrlSaveTextBoxExW(hwnd, pSect, TRUE);
	return rc;
}
//==============================================================================================================//
//	eLXg{bNXZ[uigj																				//
//																												//
//	@F	hwnd	- Xg{bNX̃EChnh														//
//				pSect	- vt@CZNṼAhX													//
//				fExcRdOnly	- TRUE:ǂݏopO															//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveTextBoxExA(HWND hwnd, C_BCP pSect, BOOL fExcRdOnly)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	if (pSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			rc = AjcCtrlSaveTextBoxExW(hwnd, pTmp, fExcRdOnly);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveTextBoxExW(HWND hwnd, C_WCP pSect, BOOL fExcRdOnly)
{
	BOOL	rc	 = TRUE;
	UI		sty  = 0;
	UI		len  = 0;
	WCP		pTxt = NULL;
	WC		cls[256];
	WC		sec[256];
	WC		key[256];

	if (IsWindow(hwnd) && pSect != NULL) {
		do {
			//	NX`FbN
			wcscpy(cls, L"?CUnKnown?");
			GetClassName(hwnd, cls, AJCTSIZE(cls));
			if (wcsicmp(cls, L"Edit") != 0) {rc = FALSE; break;}
			//	X^C擾
			sty = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
			//	vt@CZNVݒ
			AjcSnPrintFW(sec, AJCTSIZE(sec), L"%s", pSect);
			//	vt@CL[ݒ
			AjcSnPrintF(key, AJCTSIZE(key), L"Edt_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
			//	ǂݏop`FbN
			if (fExcRdOnly && (sty & ES_READONLY)) {
				//	L[폜
				AjcDelProfileKey(sec, key);
			}
			else {
				//	eLXg
				len = AjcGetCtrlStrLen(hwnd);
				if (pTxt = AjcTAlloc(len + 1)) {
					AjcGetCtrlStr(hwnd, pTxt, len + 1);
					pTxt[len] = 0;
					AjcPutProfileStr(sec, key, pTxt);
					free(pTxt);
				}
				else rc = FALSE;
			}
		} while(0);
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	`FbN{bNX^WI{^[h																		//
//																												//
//	@F	hwnd	- Xg{bNX̃EChnh														//
//				pSect	- vt@CZNṼAhX													//
//				fNtc	- CxgʒmtO																	//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadChkBoxA(HWND hwnd, C_BCP pSect, BOOL fNtc)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	if (pSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			rc = AjcCtrlLoadChkBoxW(hwnd, pTmp, fNtc);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadChkBoxW(HWND hwnd, C_WCP pSect, BOOL fNtc)
{
	BOOL	rc	 = TRUE;
	UI		sty  = 0;
	UI		typ  = 0;
	UI		len  = 0;
	UI		val;
	WCP		pTxt = NULL;
	WC		cls[256];
	WC		sec[256];
	WC		key[256];

	if (IsWindow(hwnd) && pSect != NULL) {
		do {
			//	NX`FbN
			wcscpy(cls, L"?CUnKnown?");
			GetClassName(hwnd, cls, AJCTSIZE(cls));
			if (wcsicmp(cls, L"Button") != 0) {rc = FALSE; break;}
			//	X^Ci`FbN{bNX^WI{^`FbNj`FbN
			sty = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
			typ = (sty & BS_TYPEMASK);
			if (typ != BS_CHECKBOX			&&
				typ != BS_AUTOCHECKBOX		&&
				typ != BS_RADIOBUTTON		&&
				typ != BS_3STATE			&&
				typ != BS_AUTO3STATE		&&
				typ != BS_AUTORADIOBUTTON) {
				rc = FALSE;
				break;
			}
			//	vt@CZNVݒ
			AjcSnPrintFW(sec, AJCTSIZE(sec), L"%s", pSect);
			//	vt@CL[ݒ
			if (typ == BS_RADIOBUTTON || typ == BS_AUTORADIOBUTTON) {
				AjcSnPrintF(key, AJCTSIZE(key), L"Rbt_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
			}
			else {
				AjcSnPrintF(key, AJCTSIZE(key), L"Chk_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
			}
			//	ݒlǂݏoRg[֐ݒ
			val = AjcGetProfileUInt(sec, key, AjcGetCtrlChk(hwnd));
			AjcSetCtrlChk(hwnd, val);
			//	Cxg
			if (fNtc) {
				HWND	hParent = GetParent(hwnd);
				UI		id		= (UI)MAjcGetWindowLong(hwnd, GWL_ID);
				//	WI{^̒ʒm
				if		((typ == BS_RADIOBUTTON || typ == BS_AUTORADIOBUTTON)) {
					if (val) {
						SendMessage(hParent, WM_COMMAND, MAKELONG(id, BN_CLICKED), (LPARAM)hwnd);
					}
				}
				//	`FbN{bNX̒ʒm
				else if (typ == BS_CHECKBOX || typ == BS_AUTOCHECKBOX || typ == BS_3STATE || typ == BS_AUTO3STATE) {
					SendMessage(hParent, WM_COMMAND, MAKELONG(id, BN_CLICKED), (LPARAM)hwnd);
				}
				//	WI{^C`FbN{bNXȊO
				else {
					rc = FALSE;
				}
			}
		} while(0);
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	`FbN{bNX^WI{^Z[u																		//
//																												//
//	@F	hwnd	- Xg{bNX̃EChnh														//
//				pSect	- vt@CZNṼAhX													//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveChkBoxA(HWND hwnd, C_BCP pSect)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	if (pSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			rc = AjcCtrlSaveChkBoxW(hwnd, pTmp);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveChkBoxW(HWND hwnd, C_WCP pSect)
{
	BOOL	rc	 = TRUE;
	UI		sty  = 0;
	UI		typ  = 0;
	UI		len  = 0;
	WCP		pTxt = NULL;
	WC		cls[256];
	WC		sec[256];
	WC		key[256];

	if (IsWindow(hwnd) && pSect != NULL) {
		do {
			//	NX`FbN
			wcscpy(cls, L"?CUnKnown?");
			GetClassName(hwnd, cls, AJCTSIZE(cls));
			if (wcsicmp(cls, L"Button") != 0) {rc = FALSE; break;}
			//	X^Ci`FbN{bNX^WI{^`FbNj`FbN
			sty = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
			typ = (sty & BS_TYPEMASK);
			if (typ != BS_CHECKBOX			&&
				typ != BS_AUTOCHECKBOX		&&
				typ != BS_RADIOBUTTON		&&
				typ != BS_3STATE			&&
				typ != BS_AUTO3STATE		&&
				typ != BS_AUTORADIOBUTTON) {
				rc = FALSE;
				break;
			}
			//	vt@CZNVݒ
			AjcSnPrintFW(sec, AJCTSIZE(sec), L"%s", pSect);
			//	vt@CL[ݒ
			if (typ == BS_RADIOBUTTON || typ == BS_AUTORADIOBUTTON) {
				AjcSnPrintF(key, AJCTSIZE(key), L"Rbt_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
			}
			else {
				AjcSnPrintF(key, AJCTSIZE(key), L"Chk_%06u", (UI)MAjcGetWindowLong(hwnd, GWL_ID));
			}
			//	ݒl
			AjcPutProfileUInt(sec, key, AjcGetCtrlChk(hwnd));
		} while(0);
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	R{{bNX[h																						//
//																												//
//	@F	hwnd	- Xg{bNX̃EChnh														//
//				pSect	- vt@CZNṼAhX													//
//				sel 	- iڂ̎wiAJCCTL_PSEL_INC{DATA/TEXT} | EXC{SEL/TEXT/EDIT}j					//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - ComboboxRg[ȊO																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadComboBoxA(HWND hwnd, C_BCP pSect, UI sel, BOOL fNtc)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	if (pSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			rc = AjcCtrlLoadComboBoxW(hwnd, pTmp, sel, fNtc);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadComboBoxW(HWND hwnd, C_WCP pSect, UI sel, BOOL fNtc)
{
	BOOL	rc	  = TRUE;		//	߂l
	HWND	hEdit = NULL;		//	GfBbgRg[nh
	int		nList = 0;			//	Xgڐ
	UI		id	  = 0;			//	Rg[hc;
	int		ix	  = 0;			//	XgCfNX
	UI		sty   = 0;			//	Rg[X^C
	UI		lmd   = 0;			//	Xg{bNX^CviDROPDOWNLIST / DROPDOWN / SIMPLEj
	UI		len   = 0;				//	XgڃeLXg;
	WCP		pTxt = NULL;		//	eLXgobt@|C^
	UI		lTxt; 				//	eLXgobt@
	UI		lNoTxtStr = (UI)wcslen(NO_TXT_STR);
	UI		MaxLen = 0;			//	őeLXgiI[͊܂܂Ȃj
	WC		cls[256];			//	NX
	WC		sec[256];			//	ZNV
	WC		key[256];			//	L[

	if (IsWindow(hwnd) && pSect != NULL) {
		do {
			//	NX`FbN
			wcscpy(cls, L"?CUnKnown?");
			GetClassName(hwnd, cls, AJCTSIZE(cls));
			if (wcsicmp(cls, L"Combobox") != 0) {rc = FALSE; break;}
			//	Rg[hc
			id = (UI)MAjcGetWindowLong(hwnd, GWL_ID);
			//	X^C擾
			sty = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
			//	vt@CZNVݒ
			AjcSnPrintFW(sec, AJCTSIZE(sec), L"%s", pSect);
			//----- őeLXgǂݏoobt@蓖 -------------//
			AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_MaxLen", id);
			MaxLen = AjcGetProfileUInt(sec, key, 0);
			lTxt   = __max(MaxLen, lNoTxtStr) + 1;
			if ((pTxt = AjcTAlloc(lTxt)) == NULL) {rc = FALSE; break;}
			//----- Xgǂݏo ---------------------------------------//
			lmd = (sty & CBS_DROPDOWNLIST);
			if (((lmd == CBS_DROPDOWN || lmd == CBS_SIMPLE) && !(sel & AJCCTL_PSEL_EXCLIST)) ||		//	hbv_E^Vv and XgڌQOȂ or
				((lmd == CBS_DROPDOWNLIST				  ) &&	(sel & AJCCTL_PSEL_INCLIST))) {		//	hbv_EXg	 and XgڌQ܂߂	  or
				//	ڐǂݏo
				AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_Cnt", id);
				nList = AjcGetProfileUInt(sec, key, -1);
				if (nList != -1) {
					//	XgNA[
					SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
					//	XgeLXgǂݏo
					*pTxt = 0;
					for (ix = 0; ix < nList; ix++) {
						//	vt@CL[ݒ
						AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_%06u", id, ix);
						//	vt@C烊XgeLXgǂݏo
						AjcGetProfileStr(sec, key, NO_TXT_STR, pTxt, lTxt);
						if (wcscmp(pTxt, NO_TXT_STR) != 0) {
							UI	ins;
							WCP	pD = NULL;
							WCP	pT = NULL;
							if (pD = AjcStrTokW(pTxt, L"," )) {
								pT = AjcStrTokW(NULL, L"\0");
							}
							if (pD != NULL && pT != NULL) {
								if ((ins = (UI)SendMessage(hwnd, CB_INSERTSTRING, -1, (LPARAM)pT)) != CB_ERR) {
									if (sel & AJCCTL_PSEL_INCDATA) {
										SendMessage(hwnd, CB_SETITEMDATA, ins, (UX)AjcHexToULL(pD));
									}
								}
							}
						}
					}
				}
			}
			//----- Iԓǂݏo -------------------------------------//
			if (!(sel & AJCCTL_PSEL_EXCSEL)) {
				//	vt@CL[ݒ
				AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_Idx", id);
				//	vt@CCfNXlǂݏoăRg[ɐݒ
				SendMessage(hwnd, CB_SETCURSEL, AjcGetProfileSInt(sec, key, -1), 0);
			}
			else {
				//	IԐݒ
				SendMessage(hwnd, CB_SETCURSEL, -1, 0);
			}
			//----- eLXg{bNXǂݏo -----------------------------//
			//	eLXg{bNX && eLXg{bNXOȂH
			if ((hEdit = AjcSbcGetEditCtrlInComboBox(hwnd)) && !(sel & AJCCTL_PSEL_EXCEDIT)) {
				//	vt@CL[ݒ
				AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_Txt", id);
				//	vt@CeLXgǂݏo
				AjcGetProfileStr(sec, key, NO_TXT_STR, pTxt, lTxt);
				if (wcscmp(pTxt, NO_TXT_STR) != 0) {
					AjcSetCtrlStr(hEdit, pTxt);
				}
			}
			//----- Cxgʒm -----------------------------------------//
			if (fNtc) {
				ix = (UI)SendMessage(hwnd, CB_GETCURSEL, 0, 0);
				if (ix >= 0) {
					HWND	hParent = GetParent(hwnd);
					UI		id	= (UI)MAjcGetWindowLong(hwnd, GWL_ID);
					SendMessage(hParent, WM_COMMAND, MAKELONG(id, CBN_SELENDOK), (LPARAM)hwnd);
				}
			}
		} while(0);
	}
	else rc = FALSE;

	//	eLXgobt@
	if (pTxt != NULL) free(pTxt);

	return rc;
}
//==============================================================================================================//
//	R{{bNXZ[u																						//
//																												//
//	@F	hwnd	- Xg{bNX̃EChnh														//
//				pSect	- vt@CZNṼAhX													//
//				sel 	- iڂ̎wiAJCCTL_PSEL_EEEj												//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - ComboboxRg[ȊO																//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveComboBoxA(HWND hwnd, C_BCP pSect, UI sel)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	if (pSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			rc = AjcCtrlSaveComboBoxW(hwnd, pTmp, sel);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveComboBoxW(HWND hwnd, C_WCP pSect, UI sel)
{
	BOOL	rc	   = TRUE;		//	߂l
	HWND	hEdit  = NULL;		//	GfBbgRg[nh
	UI		nList  = 0;			//	Xgڐ
	UI		id	   = 0;			//	Rg[hc
	UI		ix	   = 0;			//	XgCfNX
	UI		sty    = 0;			//	Rg[X^C
	UI		lmd    = 0;			//	Xg{bNX^CviDROPDOWNLIST / DROPDOWN / SIMPLEj
	UI		len    = 0;			//	XgڃeLXg
	WCP		pTxt   = NULL;		//	eLXgobt@|C^
	UI		lTxt;				//	eLXgobt@
	UI		lNoTxtStr = (UI)wcslen(NO_TXT_STR);
	UI		MaxLen = 0;			//	őeLXgiI[͊܂܂Ȃj
	UI		OldMax = 0;			//		V		  iO̒lj
	WC		cls[256];			//	NX
	WC		sec[256];			//	ZNV
	WC		key[256];			//	L[

	if (IsWindow(hwnd) && pSect != NULL) {
		do {
			//	NX`FbN
			wcscpy(cls, L"?CUnKnown?");
			GetClassName(hwnd, cls, AJCTSIZE(cls));
			if (wcsicmp(cls, L"Combobox") != 0) {rc = FALSE; break;}
			//	Rg[hc
			id = (UI)MAjcGetWindowLong(hwnd, GWL_ID);
			//	X^C擾
			sty = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
			//	vt@CZNVݒ
			AjcSnPrintFW(sec, AJCTSIZE(sec), L"%s", pSect);
			//----- O̍őeLXgǂݏo -------------------------//
			AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_MaxLen", id);
			OldMax = AjcGetProfileUInt(sec, key, 0);
			//----- Xgڐݒ -------------------------------------//
			nList = (UI)SendMessage(hwnd, CB_GETCOUNT, 0, 0);
			if (nList == CB_ERR) {rc = FALSE; break;}
			//----- Xg ---------------------------------------//
			lmd = (sty & CBS_DROPDOWNLIST);
			if (((lmd == CBS_DROPDOWN || lmd == CBS_SIMPLE) && !(sel & AJCCTL_PSEL_EXCLIST)) ||		//	hbv_E^Vv and XgڌQOȂ or
				((lmd == CBS_DROPDOWNLIST				  ) &&	(sel & AJCCTL_PSEL_INCLIST))) {		//	hbv_EXg	 and XgڌQ܂߂	  or
				//	Xg
				for (ix = 0; ix < nList; ix++) {
					//	vt@CL[ݒ
					AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_%06u", id, ix);
					//	vt@CփXgeLXg
					if ((len = (UI)SendMessage(hwnd, CB_GETLBTEXTLEN, ix, 0)) != CB_ERR) {
						lTxt = len + 19 + 1;			//	19 : DATAƃJ}(,)Z(f[^ 0x + 1616i)
						if (pTxt = AjcTAlloc(lTxt)) {
							UI	stl = 0;
							MaxLen	= __max(MaxLen, len + 19);
							if (sel & AJCCTL_PSEL_INCDATA) AjcSnPrintF(pTxt, lTxt, L"0x%016llX,", (ULL)SendMessage(hwnd, CB_GETITEMDATA, ix, 0));
							else						   AjcSnPrintF(pTxt, lTxt, L"0x%016llX,", (ULL)0);
							stl = (UI)wcslen(pTxt);
							SendMessage(hwnd, CB_GETLBTEXT, ix, (LPARAM)(pTxt + stl));
							AjcPutProfileStr(sec, key, pTxt);
							free(pTxt);
						}
						else rc = FALSE;
					}
				}
				//	Xgڐ
				AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_Cnt", id);
				AjcPutProfileUInt(sec, key, nList);
			}
			else {
				//	XgڐL[폜
				AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_Cnt", id);
				AjcDelProfileKey(sec, key);
			}
			//----- 㑱̎cXgڍ폜 -----------------------------//
			lTxt = __max(OldMax, lNoTxtStr) + 1;
			if (pTxt = AjcTAlloc(lTxt)) {
				//	̃Xgړǂݏo
				AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_%06u", id, ix);
				AjcGetProfileStr(sec, key, NO_TXT_STR, pTxt, lTxt);
				while (wcscmp(pTxt, NO_TXT_STR) != 0) {
					//	L[ڍ폜
					AjcDelProfileKey(sec, key);
					//	̃Xgړǂݏo
					ix++;
					AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_%06u", id, ix);
					AjcGetProfileStr(sec, key, NO_TXT_STR, pTxt, lTxt);
				}
				free(pTxt);
			}
			//----- Iԏ -------------------------------------//
			//	vt@CL[ݒ
			AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_Idx", id);
			if (!(sel & AJCCTL_PSEL_EXCSEL)) {
				//	CfNXlǂݏoăvt@C֏
				AjcPutProfileSInt(sec, key, (SI)SendMessage(hwnd, CB_GETCURSEL, 0, 0));
			}
			else {
				//	L[ڍ폜
				AjcDelProfileKey(sec, key);
			}
			//----- eLXg{bNX -----------------------------//
			//	vt@CL[ݒ
			AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_Txt", id);
			//	eLXg{bNX && eLXg{bNXOȂH
			if ((hEdit = AjcSbcGetEditCtrlInComboBox(hwnd)) && !(sel & AJCCTL_PSEL_EXCEDIT)) {
				//	eLXgǂݏoăvt@Cɏ
				len = AjcGetCtrlStrLen(hEdit);
				lTxt = len + 1;
				if (pTxt = AjcTAlloc(lTxt)) {
					MaxLen = __max(MaxLen, len);
					//	GfBbgeLXg
					AjcGetCtrlStr(hwnd, pTxt, lTxt);
					AjcPutProfileStr(sec, key, pTxt);
					free(pTxt);
				}
				else rc = FALSE;
			}
			//	eLXg{bNXȂ || eLXg{bNXOH
			else {
				//	L[ڍ폜
				AjcDelProfileKey(sec, key);
			}
			//----- őeLXg -------------------------------//
			AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_MaxLen", id);
			AjcPutProfileUInt(sec, key, MaxLen);
			
		} while(0);
	}
	else rc = FALSE;

	return rc;
}
//==============================================================================================================//
//	Z[uς݃R{{bNXf[^邩`FbN																//
//																												//
//	@F	hwnd	- Xg{bNX̃EChnh														//
//				pSect	- vt@CZNṼAhX													//
//																												//
//	߂lF	TRUE  - Z[uς݃R{{bNXf[^L														//
//				FALSE - Z[uς݃R{{bNXf[^Ȃ														//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlIsComboBoxSavedA(HWND hwnd, C_BCP pSect)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	if (pSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			rc = AjcCtrlIsComboBoxSavedW(hwnd, pTmp);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlIsComboBoxSavedW(HWND hwnd, C_WCP pSect)
{
	BOOL	rc	   = FALSE;		//	߂l
	UI		id	   = 0;			//	Rg[hc
	WC		cls[256];			//	NX
	WC		sec[256];			//	ZNV
	WC		key[256];			//	L[

	if (IsWindow(hwnd) && pSect != NULL) {
		do {
			//	NX`FbN
			wcscpy(cls, L"?CUnKnown?");
			GetClassName(hwnd, cls, AJCTSIZE(cls));
			if (wcsicmp(cls, L"Combobox") != 0) {rc = FALSE; break;}
			//	Rg[hc
			id = (UI)MAjcGetWindowLong(hwnd, GWL_ID);
			//	vt@CZNVݒ
			AjcSnPrintFW(sec, AJCTSIZE(sec), L"%s", pSect);
			//	őeLXgǂݏo
			AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_MaxLen", id);
			if (AjcGetProfileUInt(sec, key, -1) != -1) {
				rc = TRUE;
			}
		} while(0);
	}
	return rc;
}
//==============================================================================================================//
//	Xg{bNX[h																						//
//																												//
//	@F	hwnd	- Xg{bNX̃EChnh														//
//				pSect	- vt@CZNṼAhX													//
//				sel 	- iڂ̎wiAJCCTL_PSEL_EEEj												//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - ListboxRg[ȊO																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadListBoxA(HWND hwnd, C_BCP pSect, UI sel)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	if (pSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			rc = AjcCtrlLoadListBoxW(hwnd, pTmp, sel);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlLoadListBoxW(HWND hwnd, C_WCP pSect, UI sel)
{
	BOOL	rc	   = TRUE;		//	߂l
	HWND	hEdit  = NULL;		//	GfBbgRg[nh
	UI		nList  = 0;			//	Xgڐ
	UI		id	   = 0;			//	Rg[hc
	UI		ix	   = 0;			//	XgCfNX
	UI		sty    = 0;			//	Rg[X^C
	UI		len    = 0;			//	XgڃeLXg
	WCP		pTxt   = NULL;		//	eLXgobt@|C^
	UI		lTxt;
	UI		lNoTxtStr = (UI)wcslen(NO_TXT_STR);
	UI		MaxLen = 0;			//	őeLXgiI[͊܂܂Ȃj
	WC		cls[256];			//	NX
	WC		sec[256];			//	ZNV
	WC		key[256];			//	L[

	if (IsWindow(hwnd) && pSect != NULL) {
		do {
			//	NX`FbN
			wcscpy(cls, L"?CUnKnown?");
			GetClassName(hwnd, cls, AJCTSIZE(cls));
			if (wcsicmp(cls, L"Listbox") != 0) {rc = FALSE; break;}
			//	Rg[hc
			id = (UI)MAjcGetWindowLong(hwnd, GWL_ID);
			//	X^C擾
			sty = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
			//	vt@CZNVݒ
			AjcSnPrintFW(sec, AJCTSIZE(sec), L"%s", pSect);
			//----- őeLXgǂݏoobt@蓖 -------------//
			AjcSnPrintF(key, AJCTSIZE(key), L"Lst_%06u_MaxLen", id);
			MaxLen = AjcGetProfileUInt(sec, key, 0);
			lTxt   = __max(MaxLen, lNoTxtStr) + 1;
			if ((pTxt = AjcTAlloc(lTxt)) == NULL) {rc = FALSE; break;}
			//----- ڐǂݏo ---------------------------------------//
			AjcSnPrintF(key, AJCTSIZE(key), L"Lst_%06u_Cnt", id);
			nList = AjcGetProfileUInt(sec, key, -1);
			if (nList == -1) break;
			//----- XgNA[ ---------------------------------------//
			SendMessage(hwnd, LB_RESETCONTENT, 0, 0);
			//----- XgeLXgǂݏo -------------------------------//
			*pTxt = 0;
			for (ix = 0; ix < nList; ix++) {
				//	vt@CL[ݒ
				AjcSnPrintF(key, AJCTSIZE(key), L"Lst_%06u_%06u", id, ix);
				//	vt@C烊XgeLXgǂݏo
				AjcGetProfileStr(sec, key, NO_TXT_STR, pTxt, lTxt);
				if (wcscmp(pTxt, NO_TXT_STR) != 0) {
					WCP		pS = NULL;
					WCP		pD = NULL;
					WCP		pT = NULL;
					if (pS = AjcStrTokW(pTxt , L",")) {
						if (pD = AjcStrTokW(NULL, L",")) {
							pT = AjcStrTokW(NULL, L"\0");
						}
					}
					if (pS != NULL && pD != NULL && pT != NULL) {
						UI	ins;
						ins = (UI)SendMessage(hwnd, LB_INSERTSTRING, -1, (LPARAM)pT);
						if (*pS == '1' && !(sel & AJCCTL_PSEL_EXCSEL)) {
							if (sty & LBS_MULTIPLESEL) SendMessage(hwnd, LB_SETSEL	 , TRUE, ins);
							else					   SendMessage(hwnd, LB_SETCURSEL, ins , 0	);
						}
						if (sel & AJCCTL_PSEL_INCDATA) {
							SendMessage(hwnd, LB_SETITEMDATA, ins, (UX)AjcHexToULL(pD));
						}
					}
				}
			}
		} while(0);
	}
	else rc = FALSE;

	//	eLXgobt@
	if (pTxt != NULL) free(pTxt);

	return rc;
}
//==============================================================================================================//
//	Xg{bNXZ[u																						//
//																												//
//	@F	hwnd	- Xg{bNX̃EChnh														//
//				pSect	- vt@CZNṼAhX													//
//				sel 	- iڂ̎wiAJCCTL_PSEL_EEEj												//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - ListboxRg[ȊO																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveListBoxA(HWND hwnd, C_BCP pSect, UI sel)
{
	BOOL	rc	 = FALSE;
	UI		len  = 0;
	WCP		pTmp = NULL;

	if (pSect != NULL) {
		len = MultiByteToWideChar(CP_ACP, 0, pSect, -1, NULL, 0);
		if (len != 0 && (pTmp = AjcTAlloc(len))) {
			MultiByteToWideChar(CP_ACP, 0, pSect, -1, pTmp, len);
			rc = AjcCtrlSaveListBoxW(hwnd, pTmp, sel);
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT 	BOOL	WINAPI	AjcCtrlSaveListBoxW(HWND hwnd, C_WCP pSect, UI sel)
{
	BOOL	rc	   = TRUE;		//	߂l
	HWND	hEdit  = NULL;		//	GfBbgRg[nh
	UI		nList  = 0;			//	Xgڐ
	UI		id	   = 0;			//	Rg[hc
	UI		ix	   = 0;			//	XgCfNX
	UI		sty    = 0;			//	Rg[X^C
	UI		len    = 0;			//	XgڃeLXg
	WCP		pTxt   = NULL;		//	eLXgobt@|C^
	UI		lTxt;				//	eLXgobt@
	UI		lNoTxtStr = (UI)wcslen(NO_TXT_STR);
	UI		MaxLen = 0;			//	őeLXgiI[͊܂܂Ȃj
	UI		OldMax = 0;			//		V		  iO̒lj
	WC		cls[256];			//	NX
	WC		sec[256];			//	ZNV
	WC		key[256];			//	L[

	if (IsWindow(hwnd) && pSect != NULL) {
		do {
			//	NX`FbN
			wcscpy(cls, L"?CUnKnown?");
			GetClassName(hwnd, cls, AJCTSIZE(cls));
			if (wcsicmp(cls, L"Listbox") != 0) {rc = FALSE; break;}
			//	ComboboxRg[ȂΖ߂l=TRUE
			rc = TRUE;
			//	Rg[hc
			id = (UI)MAjcGetWindowLong(hwnd, GWL_ID);
			//	X^C擾
			sty = (UI)MAjcGetWindowLong(hwnd, GWL_STYLE);
			//	vt@CZNVݒ
			AjcSnPrintFW(sec, AJCTSIZE(sec), L"%s", pSect);
			//----- O̍őeLXgǂݏo -------------------------//
			AjcSnPrintF(key, AJCTSIZE(key), L"Cbo_%06u_MaxLen", id);
			OldMax = AjcGetProfileUInt(sec, key, 0);
			//----- Xgڐ ---------------------------------//
			nList = (UI)SendMessage(hwnd, LB_GETCOUNT, 0, 0);
			if (nList == LB_ERR) {rc = FALSE; break;}
			AjcSnPrintF(key, AJCTSIZE(key), L"Lst_%06u_Cnt", id);
			AjcPutProfileUInt(sec, key, nList);
			//----- Xg ---------------------------------------//
			for (ix = 0; ix < nList; ix++) {
				//	vt@CL[ݒ
				AjcSnPrintF(key, AJCTSIZE(key), L"Lst_%06u_%06u", id, ix);
				//	vt@C֑IԂƃXgeLXg
				if ((len = (UI)SendMessage(hwnd, LB_GETTEXTLEN, ix, 0)) != LB_ERR) {
					lTxt = len + 21 + 1;			//	21 : DATAƕteLXg(I(S,)Af[^(18)ƃJ}(,)Z(f[^ 0x+1616i)
					if (pTxt = AjcTAlloc(lTxt)) {
						UI	stl;
						//	őeLXgXV
						MaxLen = __max(MaxLen, (len + 21));
						//	IԐݒ
						if (!(sel & AJCCTL_PSEL_EXCSEL)) {
							if (SendMessage(hwnd, LB_GETSEL, ix, 0) != 0) wcscpy(pTxt, L"1,");
							else										  wcscpy(pTxt, L"0,");
						}
						else wcscpy(pTxt, L"0,");
						//	f[^lݒ
						if (sel & AJCCTL_PSEL_INCDATA) AjcSnPrintF(pTxt + 2, lTxt - 2, L"0x%016llX,", (ULL)SendMessage(hwnd, LB_GETITEMDATA, ix, 0));
						else						   AjcSnPrintF(pTxt + 2, lTxt - 2, L"0x%016llX,", (ULL)0);
						//	eLXgǂݏo
						stl = (UI)wcslen(pTxt);
						SendMessage(hwnd, LB_GETTEXT, ix, (LPARAM)(pTxt + stl));
						//	vt@C
						AjcPutProfileStr(sec, key, pTxt);
						free(pTxt);
					}
					else rc = FALSE;
				}
			}
			//----- 㑱̎cXgڍ폜 -----------------------------//
			lTxt = __max(OldMax, lNoTxtStr) + 1;
			if (pTxt = AjcTAlloc(lTxt)) {
				//	̃Xgړǂݏo
				AjcSnPrintF(key, AJCTSIZE(key), L"Lst_%06u_%06u", id, ix);
				AjcGetProfileStr(sec, key, NO_TXT_STR, pTxt, lTxt);
				while (wcscmp(pTxt, NO_TXT_STR) != 0) {
					//	L[ڍ폜
					AjcDelProfileKey(sec, key);
					//	̃Xgړǂݏo
					ix++;
					AjcSnPrintF(key, AJCTSIZE(key) , L"Lst_%06u_%06u", id, ix);
					AjcGetProfileStr(sec, key, NO_TXT_STR, pTxt, lTxt);
				}
				free(pTxt);
			}
			//----- őeLXg -------------------------------//
			AjcSnPrintF(key, AJCTSIZE(key), L"Lst_%06u_MaxLen", id);
			AjcPutProfileUInt(sec, key, MaxLen);
		} while(0);
	}
	else rc = FALSE;

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	EChf[^̊֘Atf[^ݒif[^ƃZNV̊֘Atj									//
//																												//
//	@F	hwnd	- EChnh																		//
//				hGrp	- O[v{bNXnh																//
//				data	- EChɊ֘At鐮f[^														//
//				pSect	- EChɊ֘At镶f[^														//
//																												//
//	߂lF	TRUE  - OK																						//
//				FALSE - Error																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SetWndData(HWND hwnd, HWND hGrp, UI data, C_WCP pSect)
{
	BOOL		rc = FALSE;
	WNDDATA		wd;
	PCWDNODE	pArr = NULL;
	PCWDNODE	p	 = NULL;
	HWND		hTrg;

	//	XAȃECh̃m[hj
	if ((AjcAvlGetCount(hAvlWndData) & 31) == 31) {
		if (pArr = (PCWDNODE)AjcAvlCreatePtrArr(hAvlWndData, NULL, FALSE)) {
			for (p = pArr; p != NULL; p++) {
				if (!IsWindow((HWND)p->key)) {
					AjcAvlDelNode(hAvlWndData, p->key);
				}
			}
			AjcAvlReleasePtrArr (hAvlWndData, (PCAJCAVLPTR)pArr);
		}
	}
	//	֘AtEChnhݒ
	if (IsWindow(hGrp)) hTrg = hGrp;
	else				hTrg = hwnd;
	//	֘Atf[^ݒ
	if (IsWindow(hTrg) && pSect != NULL) {
		wd.dat = data;
		AjcSnPrintF(wd.str, AJCTSIZE(wd.str), L"%s", pSect);
		rc = AjcAvlInsOrRepNode(hAvlWndData, (UX)hTrg, (C_VOP)&wd, (sizeof wd.dat) + (UI)wcslen(wd.str) * 2 + 2);
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	EChf[^̊֘Atf[^擾if[^ƃZNV̊֘Atj									//
//																												//
//	@F	hwnd	- EChnh																		//
//				hGrp	- O[v{bNXnh																//
//				pDat	- EChɊ֘Atf[^i[obt@̃AhX							//
//																												//
//	߂lF	 NULL - OK(EChf[^Ɋ֘Atꂽ̃AhX)									//
//				 NULL - Error																					//
//--------------------------------------------------------------------------------------------------------------//
static	C_WCP	GetWndData(HWND hwnd, HWND hGrp, UIP pDat)
{
	C_WCP		pSect = NULL;
	PWNDDATA	pWd = NULL;
	HWND		hTrg;

	//	֘AtEChnhݒ
	if (IsWindow(hGrp)) hTrg = hGrp;
	else				hTrg = hwnd;
	//	֘Atf[^擾
	if (IsWindow(hTrg)) {
		if (pWd = (PWNDDATA)AjcAvlGetNodePtr(hAvlWndData, (UX)hTrg, NULL)) {
			if (pDat != NULL) *pDat = pWd->dat;
			pSect = pWd->str;
		}
	}
	else {
		AjcAvlDelNode(hAvlWndData, (UX)hTrg);
	}
	return pSect;
}
