#ifndef		AJCXYMODEML_H_
#define		AJCXYMODEML_H_
/****************************************************************************************************************/

/*--------------------------------------------------------------------------------------------------------------*/
/*	}N																									*/
/*--------------------------------------------------------------------------------------------------------------*/
#define		ISXYP_OK(_P_)	(_P_ == AJCXYP_XMODEM_SUM || _P_ == AJCXYP_XMODEM_CRC || _P_ == AJCXYP_XMODEM_1K ||	\
							 _P_ == AJCXYP_YMODEM_STD || _P_ == AJCXYP_YMODEM_G)

#define		IS_XMODEM		(pW->knd & AJCXYP_XMODEM)
#define		IS_YMODEM		(pW->knd & AJCXYP_YMODEM)

/*--------------------------------------------------------------------------------------------------------------*/
/*	ԃR[h																									*/
/*--------------------------------------------------------------------------------------------------------------*/
enum {
	AJCSTC_STS_IDLE				,		/*	 0FACh													*/

	AJCSTC_STS_TX_RCVREQ		,		/*	 1FMviNAK / C / GjM҂									*/
	AJCSTC_STS_TX_ACKATT		,		/*	 2FR[hɑ΂`bjM҂ixlncdlj				*/
	AJCSTC_STS_TX_RCVDRQ		,		/*	 3FںޑḾAMviNAK / C / GjM҂				*/
	AJCSTC_STS_TX_ACKDAT		,		/*	 4Ff[^R[hɑ΂`bjM҂							*/
	AJCSTC_STS_TX_ACKEOT		,		/*	 5Fdnsɑ΂`bjM܂									*/
	AJCSTC_STS_TX_ACKNUL		,		/*	 6F󑮐R[hɑ΂`bjM҂ixlncdlj			*/
	AJCSTC_STS_TX_SNDYMG		,		/*	 7FSt@Cf[^M҂ixlncdl|fj				*/

	AJCSTC_STS_RX_SNDREQ		,		/*	 8FMviNAK / C / Gjo									*/
	AJCSTC_STS_RX_SNDDRQ		,		/*	 9FںގḾAMviNAK / C / Gjo				*/
	AJCSTC_STS_RX_RCVDAT		,		/*	10Ff[^R[hM҂											*/

	XYS_NUM								/*	Ԑ																*/
};

#define	ISXYM_TX	(AjcStcGetCurrentState(pW->hStc) >= AJCSTC_STS_TX_RCVREQ  &&  AjcStcGetCurrentState(pW->hStc) <= AJCSTC_STS_TX_ACKNUL)
#define	ISYMG_TX	(AjcStcGetCurrentState(pW->hStc) == AJCSTC_STS_TX_SNDYMG                                                             )
#define	ISXYM_RX	(AjcStcGetCurrentState(pW->hStc) >= AJCSTC_STS_RX_SNDREQ  &&  AjcStcGetCurrentState(pW->hStc) <= AJCSTC_STS_RX_RCVDAT)

/*--------------------------------------------------------------------------------------------------------------*/
/*	CxgR[h																								*/
/*--------------------------------------------------------------------------------------------------------------*/
enum {
	XYE_REQ_TXSRT				,		/*	 0 : t@CMJnv											*/
	XYE_REQ_RXSRT				,		/*	 1 : t@CMJnv											*/
	XYE_REQ_STOP				,		/*	 2 : ]~v													*/
	XYE_RXREQ					,		/*	 3 : Mvim`j^bjM										*/
	XYE_RXREQ_YG				,		/*	 4 : MvifjM												*/
	XYE_RXNAK					,		/*	 5 : m`jM														*/
	XYE_RXACK_XM				,		/*	 6 : `bjMiwlncdlj										*/
	XYE_RXACK_YM				,		/*	 7 : `bjMixlncdlj										*/
	XYE_RXEOT_XM				,		/*	 8 : dnsMiwlncdlj										*/
	XYE_RXEOT_YM				,		/*	 9 : dnsMixlncdlj										*/
	XYE_RXCAN					,		/*	10 : b`mM														*/
	XYE_RXREC_OK_XM				,		/*	11 : f[^R[hMinjCwlncdlj						*/
	XYE_RXREC_OK_YM				,		/*	12 : f[^R[hMinjCxlncdlj						*/
	XYE_RXREC_NUL				,		/*	13 : kwb_MinjCxlncdl^xlncdl|fj			*/
	XYE_RXREC_BF				,		/*	14 : f[^R[hMiaeCxlncdl|fȊOEEPORNOj*/
	XYE_RXREC_NG				,		/*	15 : f[^R[hMimfCxlncdl|fȊOj				*/
	XYE_RXREC_NG_YG				,		/*	16 : f[^R[hMimfCxlncdl|fj					*/
	XYE_TXEND					,		/*	17 : Mixlncdl|fj									*/
	XYE_FI_VALID_XM				,		/*	18 : Lȃt@C擾iwlncdlj							*/
	XYE_FI_VALID_YM				,		/*	19 : Lȃt@C擾ixlncdlj							*/
	XYE_FI_VALID_YG				,		/*	20 : Lȃt@C擾ixlncdl|fj						*/
	XYE_FI_NULL_XM				,		/*	21 : ̃t@C擾iwlncdlj							*/
	XYE_FI_NULL_YM				,		/*	22 : ̃t@C擾ixlncdlj							*/
	XYE_FI_NULL_YG				,		/*	23 : ̃t@C擾ixlncdl|fj						*/
	XYE_FDATA					,		/*	24 : Lȃt@Cf[^擾										*/
	XYE_EOF						,		/*	25 : t@CI[o												*/
	XYE_TIMOUT_0				,		/*	26 : ^CAEg  iOj											*/
	XYE_TIMOUT_0_YG				,		/*	27 : ^CAEg  iOCxlncdlQfj							*/
	XYE_RTYOUT_0				,		/*	28 : gCAEgiOj											*/
	XYE_TIMOUT_1				,		/*	29 : ^CAEg  iPj											*/
	XYE_TIMOUT_1_YG				,		/*	30 : ^CAEg  iPCxlncdlQfj							*/
	XYE_RTYOUT_1				,		/*	31 : gCAEgiPj											*/

	XYE_NUM								/*	Cxg															*/
};

/*--------------------------------------------------------------------------------------------------------------*/
/*	^C}hc																									*/
/*--------------------------------------------------------------------------------------------------------------*/
enum {									/*	M^C}														*/
	XYTIM_WAIREQ				,		/*	 0 : MviNAK / C / GjM҂^C}							*/
	XYTIM_WAIACK				,		/*	 1 : `bjM҂^C}											*/
	XYTIM_TX2					,		/*	 2 : |																*/
	XYTIM_TX3							/*	 3 : |																*/
};

enum {									/*	 M^C}														*/
	XYTIM_REQCYC				,		/*	 0 : MviNAK / C / Gjo^C}							*/
	XYTIM_WAIREC				,		/*	 1 : R[hM҂^C}											*/
	XYTIM_RX2					,		/*	 2 : |																*/
	XYTIM_RX3							/*	 3 : |																*/
};

#define	XYTIM_NUM	4

/*--------------------------------------------------------------------------------------------------------------*/
/*	vZbgt@NV																					*/
/*--------------------------------------------------------------------------------------------------------------*/
enum {
	AJCSTC_PF_TX_REQ		,		/*	 0: MviNAK/C/GjM												*/
	AJCSTC_PF_TX_ACK		,		/*	 1: `bjMioj											*/
	AJCSTC_PF_TX_ACKNYG		,		/*	 2: `bjMixlncdl|fȊȌꍇ̂݁j						*/
	AJCSTC_PF_TX_NAK		,		/*	 3: m`jM															*/
	AJCSTC_PF_TX_EOT		,		/*	 4: dnsM															*/
	AJCSTC_PF_TX_CAN		,		/*	 5: b`mM															*/
	AJCSTC_PF_TX_ATT		,		/*	 6: R[hM													*/
	AJCSTC_PF_TX_REC		,		/*	 7: f[^R[hM													*/
	AJCSTC_PF_TX_FILE		,		/*	 8: St@Cf[^Mixlncdl|fj							*/
	AJCSTC_PF_TX_RTY		,		/*	 9: R[hđ														*/

	AJCSTC_PF_GET_FILE		,		/*	10: t@C擾													*/
	AJCSTC_PF_GET_DATA		,		/*	11: t@Cf[^擾													*/

	AJCSTC_PF_INI_RNO		,		/*	12: R[hԍ													*/
	AJCSTC_PF_UPD_RNO		,		/*	13: R[hԍXV													*/

	AJCSTC_PF_N_FINFO		,		/*	14: t@Cʒm													*/
	AJCSTC_PF_N_TXREC		,		/*	15: PR[hMʒm												*/
	AJCSTC_PF_N_RXREC		,		/*	16: PR[hMʒm													*/
	AJCSTC_PF_N_RETRY		,		/*	17: m`jɂđʒm											*/
	AJCSTC_PF_N_EOF			,		/*	18: dneʒm															*/

	AJCSTC_PF_N_END			,		/*	19: t@C]ʒm												*/
	AJCSTC_PF_N_RX_CAN		,		/*	20: t@C]~ʒmib`mMj									*/
	AJCSTC_PF_N_USRSTP		,		/*	21: t@C]~ʒmi[U̒~vj						*/
	AJCSTC_PF_N_TIMOUT		,		/*	22: t@C]~ʒmi^CAEgj								*/
	AJCSTC_PF_N_ABORT				/*	23: t@C]~ʒmȋj										*/
};

/*--------------------------------------------------------------------------------------------------------------*/
/*	ԑJڃe[u																							*/
/*--------------------------------------------------------------------------------------------------------------*/
extern	const AJCSTC_STSACT	XymStsTbl [ XYS_NUM ];
extern	const AJCSTC_EVT_NF	XymEvtTbl [ XYE_NUM ] [ XYS_NUM ];

/****************************************************************************************************************/
#endif
