#include	<AjxCpp.h>

using namespace AjxControl;


//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNiL[rj																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	int CALLBACK cbComp(UX key1, UX key2, UX cbp)
{
	CAjxAvl*	p = (CAjxAvl*)cbp;
	return p->OnKeyComp(key1, key2);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNim[h폜ʒmj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbRemove(UX key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	CAjxAvl*	p = (CAjxAvl*)cbp;
	if (!p->m_fDestruct) {
		p->OnNtcRemove(key, pNodeData, len, nest);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNim[hǂݏoʒmj																			//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbNtcNode (UX key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	CAjxAvl*	p = (CAjxAvl*)cbp;
	return p->OnNtcNode(key, pNodeData, len, nest);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxAvl::CAjxAvl() 
{
	m_fDestruct = FALSE;
	if ((m_hAvl = AjcAvlCreate ((UX)this, cbComp, cbRemove)) == NULL) {
		throw std::runtime_error("AVL cannot creation.");
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxAvl::~CAjxAvl()
{
	if (m_hAvl != NULL) {
		m_fDestruct = TRUE;
		AjcAvlDelete(m_hAvl);
		m_hAvl = NULL;
	}
}

//	}`Xbh̋^֎~
BOOL	CAjxAvl::EnableMultiThread	(BOOL fEnable)
{
	return AjcAvlEnableMultiThread(m_hAvl, fEnable);
}
//----- m[hANZX ---------------------------------------------------------------------------------//
//	m[h}
BOOL	CAjxAvl::InsNode			(UX key, C_VOP pNodeData, UI len)
{
	return AjcAvlInsNode(m_hAvl, key, pNodeData, len);
}
//	m[h擾
int		CAjxAvl::GetNode			(UX key, VOP	 pBuf,		UI lBuf)
{
	return AjcAvlGetNode(m_hAvl, key, pBuf, lBuf);
}
//	m[hAhX擾
VOP		CAjxAvl::GetNodePtr			(UX	key, UIP pLen)
{
	return AjcAvlGetNodePtr(m_hAvl, key, pLen);
}
VOP		CAjxAvl::GetNodePtr			(UX	key)
{
	return AjcAvlGetNodePtr(m_hAvl, key, NULL);
}
//	m[hu
BOOL	CAjxAvl::RepNode			(UX key, C_VOP pNodeData, UI len)
{
	return AjcAvlRepNode(m_hAvl, key, pNodeData, len);
}
//	m[h}^u
BOOL	CAjxAvl::InsOrRepNode		(UX key, C_VOP pNodeData, UI len)
{
	return AjcAvlInsOrRepNode(m_hAvl, key, pNodeData, len);
}
//	m[h폜
BOOL	CAjxAvl::DelNode			(UX key)
{
	return AjcAvlDelNode(m_hAvl, key);
}
//	Sm[h폜
BOOL	CAjxAvl::DelAllNodes		()
{
	return AjcAvlDelAllNodes(m_hAvl);
}

//----- m[hANZX ---------------------------------------------------------------------------//
//	m[h}(ASCII)
UX		CAjxAvl::InsStrNode			(C_BCP pStr)
{
	return AjcAvlInsStrNodeA(m_hAvl, pStr);
}
//	m[h}(UNICODE)
UX		CAjxAvl::InsStrNode			(C_WCP pStr)
{
	return AjcAvlInsStrNodeW(m_hAvl, pStr);
}

//	m[h擾(ASCII)
UX		CAjxAvl::GetStrNode			(C_BCP pStr)
{
	return AjcAvlGetStrNodeA(m_hAvl, pStr);
}
//	m[h擾(UNICODE)
UX		CAjxAvl::GetStrNode			(C_WCP pStr)
{
	return AjcAvlGetStrNodeW(m_hAvl, pStr);
}
//	m[h}^擾(ASCII)
UX		CAjxAvl::InsOrGetStrNode	(C_BCP pStr)
{
	return AjcAvlInsOrGetStrNodeA(m_hAvl, pStr);
}
//	m[h}^擾(UNICODE)
UX		CAjxAvl::InsOrGetStrNode	(C_WCP pStr)
{
	return AjcAvlInsOrGetStrNodeW(m_hAvl, pStr);
}
//	m[h폜(ASCII)
UX		CAjxAvl::DelStrNode			(C_BCP pStr)
{
	return AjcAvlDelStrNodeA(m_hAvl, pStr);
}
//	m[h폜(UNICODE)
UX		CAjxAvl::DelStrNode			(C_WCP pStr)
{
	return AjcAvlDelStrNodeW(m_hAvl, pStr);
}

//----- ̑ -----------------------------------------------------------------------------------------//
//	m[h擾
UI		CAjxAvl::GetCount			()
{
	return AjcAvlGetCount(m_hAvl);
}
//	Sm[h̃V[PVȓǂݏo
UI		CAjxAvl::EnumNodes			(BOOL fDownSeq)
{
	return AjcAvlEnumNodesEx(m_hAvl, (UX)this, cbNtcNode, fDownSeq);
}
//	Sm[hւ̃|C^z񐶐
PCAJCAVLPTR	CAjxAvl::CreatePtrArr	(UIP pNum, BOOL fDownSeq)
{
	return AjcAvlCreatePtrArr(m_hAvl, pNum, fDownSeq);
}
//	Sm[hւ̃|C^z
BOOL		CAjxAvl::ReleasePtrArr	(PCAJCAVLPTR pArr)
{
	return AjcAvlReleasePtrArr(m_hAvl, pArr);
}

//----- z֐ ---------------------------------------------------------------------------------------//
//	L[̔r
int		CAjxAvl::OnKeyComp			(UX key1, UX key2)
{
	int		rc = 0;

	if		(key1 < key2) rc = -1;
	else if (key1 > key2) rc =	1;

	return rc;
}
//	m[h폜ʒm
VO		CAjxAvl::OnNtcRemove		(UX key, VOP pNodeData, UI len, UI nest)
{
}
//	m[hǂݏoʒm
BOOL	CAjxAvl::OnNtcNode			(UX key, VOP pNodeData, UI len, UI nest)
{
	return FALSE;
}
