#include	<AjxCpp.h>

using namespace AjxControl;

//==============================================================================================================//
//																												//
//	tQ؁iL[j																					//
//																												//
//==============================================================================================================//
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNim[h폜ʒmj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static VO CALLBACK cbRemoveA(C_BCP key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	CAjxAvs*	p = (CAjxAvs*)cbp;
	if (!p->m_fDestruct) {
		p->OnNtcRemove(key, pNodeData, len, nest);
	}
}
//----- Ch ---------------------------------------------------------------------------------------------//
static VO CALLBACK cbRemoveW(C_WCP key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	CAjxAvs*	p = (CAjxAvs*)cbp;
	if (!p->m_fDestruct) {
		p->OnNtcRemove(key, pNodeData, len, nest);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNim[hǂݏoʒmj																			//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbNtcNodeA (C_BCP key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	CAjxAvs*	p = (CAjxAvs*)cbp;
	return p->OnNtcNode(key, pNodeData, len, nest);
}
//----- Ch ---------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbNtcNodeW (C_WCP key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	CAjxAvs*	p = (CAjxAvs*)cbp;
	return p->OnNtcNode(key, pNodeData, len, nest);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxAvs::CAjxAvs(BOOL fUnicode) 
{
	m_fDestruct = FALSE;

	if (m_fUnicode = fUnicode) m_hAvs = AjcAvsCreateW (AJCCMP_ALPHABETIC, (UX)this, cbRemoveW);
	else					   m_hAvs = AjcAvsCreateA (AJCCMP_ALPHABETIC, (UX)this, cbRemoveA);

	if (m_hAvs == NULL) {
		throw std::runtime_error("AVS cannot creation.");
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxAvs::~CAjxAvs()
{
	if (m_hAvs != NULL) {
		m_fDestruct = TRUE;
		AjcAvsDelete(m_hAvs);
		m_hAvs = NULL;
	}
}

//	}`Xbh̋^֎~
BOOL	CAjxAvs::EnableMultiThread	(BOOL fEnable)
{
	return AjcAvsEnableMultiThread(m_hAvs, fEnable);
}
//----- m[hANZX -----------------------------------------------------------------------------------------//
//	m[h}(ASCII)
BOOL	CAjxAvs::InsNode			(C_BCP key, C_VOP pNodeData, UI len)
{
	return AjcAvsInsNodeA(m_hAvs, key, pNodeData, len);
}
//	m[h}(UNICODE)
BOOL	CAjxAvs::InsNode			(C_WCP key, C_VOP pNodeData, UI len)
{
	return AjcAvsInsNodeW(m_hAvs, key, pNodeData, len);
}


//	m[h擾(ASCII)
int		CAjxAvs::GetNode			(C_BCP key, VOP   pBuf,	  UI lBuf)
{
	return AjcAvsGetNodeA(m_hAvs, key, pBuf, lBuf);
}
//	m[h擾(UNICODE)
int		CAjxAvs::GetNode			(C_WCP key, VOP   pBuf,	  UI lBuf)
{
	return AjcAvsGetNodeW(m_hAvs, key, pBuf, lBuf);
}


//	m[hAhX擾(ASCII)
VOP		CAjxAvs::GetNodePtr			(C_BCP	key, UIP pLen)
{
	return AjcAvsGetNodePtrA(m_hAvs, key, pLen);
}
//	m[hAhX擾(UNICODE)
VOP		CAjxAvs::GetNodePtr			(C_WCP	key, UIP pLen)
{
	return AjcAvsGetNodePtrW(m_hAvs, key, pLen);
}


//	m[hu(ASCII)
BOOL	CAjxAvs::RepNode			(C_BCP key, C_VOP pNodeData, UI len)
{
	return AjcAvsRepNodeA(m_hAvs, key, pNodeData, len);
}
//	m[hu(UNICODE)
BOOL	CAjxAvs::RepNode			(C_WCP key, C_VOP pNodeData, UI len)
{
	return AjcAvsRepNodeW(m_hAvs, key, pNodeData, len);
}


//	m[h}^u(ASCII)
BOOL	CAjxAvs::InsOrRepNode		(C_BCP key, C_VOP pNodeData, UI len)
{
	return AjcAvsInsOrRepNodeA(m_hAvs, key, pNodeData, len);
}
//	m[h}^u(UNICODE)
BOOL	CAjxAvs::InsOrRepNode		(C_WCP key, C_VOP pNodeData, UI len)
{
	return AjcAvsInsOrRepNodeW(m_hAvs, key, pNodeData, len);
}


//	m[h폜(ASCII)
BOOL	CAjxAvs::DelNode			(C_BCP key)
{
	return AjcAvsDelNodeA(m_hAvs, key);
}
//	m[h폜(UNICODE)
BOOL	CAjxAvs::DelNode			(C_WCP key)
{
	return AjcAvsDelNodeW(m_hAvs, key);
}


//	Sm[h폜
BOOL	CAjxAvs::DelAllNodes		()
{
	return AjcAvsDelAllNodes(m_hAvs);
}

//----- ̑ -------------------------------------------------------------------------------------------------//
//	m[h擾
UI		CAjxAvs::GetCount			()
{
	return AjcAvsGetCount(m_hAvs);
}
//	Sm[h̃V[PVȓǂݏo
UI		CAjxAvs::EnumNodes			(BOOL fDownSeq)
{
	UI		rc = 0;
	if (m_fUnicode) rc = AjcAvsEnumNodesExW(m_hAvs, (UX)this, cbNtcNodeW, fDownSeq);
	else			rc = AjcAvsEnumNodesExA(m_hAvs, (UX)this, cbNtcNodeA, fDownSeq);
	return rc;
}

//	Sm[hւ̃|C^z񐶐(ASCII)
BOOL	CAjxAvs::CreatePtrArr	(PCAJCAVSPTRA *ppArr, UIP pNum, BOOL fDownSeq)
{
	return ((ppArr != NULL) && ((*ppArr = AjcAvsCreatePtrArrA(m_hAvs, pNum, fDownSeq)) != NULL));
}
//	Sm[hւ̃|C^z񐶐(UNICODE)
BOOL	CAjxAvs::CreatePtrArr	(PCAJCAVSPTRW *ppArr, UIP pNum, BOOL fDownSeq)
{
	return ((ppArr != NULL) && ((*ppArr = AjcAvsCreatePtrArrW(m_hAvs, pNum, fDownSeq)) != NULL));
}


//	Sm[hւ̃|C^z(ASCII)
BOOL		CAjxAvs::ReleasePtrArr	(PCAJCAVSPTRA pArr)
{
	return AjcAvsReleasePtrArrA(m_hAvs, pArr);
}
//	Sm[hւ̃|C^z(UNICODE)
BOOL		CAjxAvs::ReleasePtrArr	(PCAJCAVSPTRW pArr)
{
	return AjcAvsReleasePtrArrW(m_hAvs, pArr);
}

//----- z֐ -----------------------------------------------------------------------------------------------//
//	m[h폜ʒm(ASCII)
VO	 CAjxAvs::OnNtcRemove	(C_BCP key, VOP pNodeData, UI len, UI nest)
{
}
//	m[h폜ʒm(UNICODE)
VO	 CAjxAvs::OnNtcRemove	(C_WCP key, VOP pNodeData, UI len, UI nest)
{
}


//	m[hǂݏoʒm(ASCII)
BOOL CAjxAvs::OnNtcNode		(C_BCP key, VOP pNodeData, UI len, UI nest)
{
	return FALSE;
}
//	m[hǂݏoʒm(UNICODE)
BOOL CAjxAvs::OnNtcNode		(C_WCP key, VOP pNodeData, UI len, UI nest)
{
	return FALSE;
}
