#include	<AjxCpp.h>

using namespace AjxControl;


//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNiCxgʒmj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO CALLBACK cbNtc(AJCPPCNOTIFY ntc, UX p1, UX p2, UX p3, UX cbp)
{
	CAjxPpc*	p = (CAjxPpc*)cbp;
	switch (ntc) {
		//	ꂩ̃CxgƂʒm
		case AJCPPC_NTC_ANYEVT:		p->OnNtcAnyEvt		((AJCPPCNOTIFY)p1);							break;
		//	t@CCsԍʒm
		case AJCPPC_NTC_FILE_LNO:	p->OnNtcFileLno		((C_BCP)p1, (UI)p2, (UI)p3);				break;
		//	CN[ht@CJnʒm
		case AJCPPC_NTC_SRH_START:	p->OnNtcSrhStart	((C_BCP)p1, (C_BCP)p2);						break;
		//	CN[ht@C̃tH_ʒm
		case AJCPPC_NTC_SRH_DIR:	p->OnNtcSrhDir		((C_BCP)p1);								break;
		//	CN[ht@CIʒm
		case AJCPPC_NTC_SRH_END:	p->OnNtcSrhEnd		((C_BCP)p1, (BOOL)p2);						break;
		//	vvZXpIvVV{ʒm
		case AJCPPC_NTC_OPTSYM:		p->OnNtcOptSym		((PCAJCPPCTKNNODE)p1);						break;
		//	}N`ʒm
		case AJCPPC_NTC_MACDEF:		p->OnNtcMacDef		((PCAJCPPCTKNNODE)p1, (PCAJCPPCMACINFO)p2);	break;
		//	}NQƒʒm
		case AJCPPC_NTC_MACREF:		p->OnNtcMacRef		((PCAJCPPCTKNNODE)p1, (PCAJCPPCMACINFO)p2);	break;
		//	g[NXg[t@C֏o͒ʒm
		case AJCPPC_NTC_OUTLOOP:	p->OnNtcOutLoop		();											break;
		//	\[Xt@C̃eLXgGR[hʒm
		case AJCPPC_NTC_SRCTEC:		p->OnNtcSrcTec		((C_BCP)p1, (EAJCTEC)p2, (BOOL)p3);			break;
		//	g[Nʒm
		case AJCPPC_NTC_TOKEN:		p->OnNtcToken		((EAJCTKCODE)p1, (C_BCP)p2);				break;
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNiG[ʒmj																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbErr(AJCPPCERROR err, UX p1, UX p2, UX p3, UX cbp)
{
	BC		ErrTxt[256];

	CAjxPpc*	p = (CAjxPpc*)cbp;
	AjcSnPrintF(ErrTxt, sizeof ErrTxt, "%s", AjcPpcGetErrMsgText(err, p1, p2, p3));
	p->OnNtcError(err, (C_BCP)p1, (UI)p2, (C_BCP)ErrTxt);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNi}N񋓁j																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbNtcMacInfo (PCAJCPPCMACINFO pMacInfo, UX cbp)
{
	CAjxPpc*	p = (CAjxPpc*)cbp;
	return p->OnNtcMacInfo(pMacInfo);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxPpc::CAjxPpc() 
{
	m_hPpc = NULL;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxPpc::~CAjxPpc()
{
	if (m_hPpc != NULL) {
		AjcPpcDelete(m_hPpc);
		m_hPpc = NULL;
	}
}

//----- o֐ ---------------------------------------------------------------------------------------------//
//	vRpCs
AJCPPCRESULT	CAjxPpc::PreCompile(	C_BCP pSrcPath	,
							EAJCTEC			tecSrc		,
							C_BCP			pBasePath	,
							PAJCLBXITEMA	pIncPath	,
							PAJCLBXITEMA	pOptSym		,
							UI				opt			)
{
	AJCPPCRESULT	rc = AJCPPCR_PARAM;
	//	σCX^Xj
	if (m_hPpc != NULL) {
		AjcPpcDelete(m_hPpc);
	}
	do {
		//	oobCX^X
		if ((m_hPpc = AjcPpcCreate(pBasePath, pIncPath, pOptSym, (UX)this, cbNtc, cbErr)) == NULL)	break;
		if (!AjcPpcSetOption	(m_hPpc, opt    ))													break;
		if (!AjcPpcSetTextEncode(m_hPpc, tecSrc ))													break;
		rc = AjcPpcCompile      (m_hPpc, pSrcPath);
	} while(0);
	return rc;
}
//	vRpCσIuWFNg̎擾
PAJCPPCTKNNODE CAjxPpc::GetObject 	(PAJCPPCTKNNODE *ppNoGen)
{
	return AjcPpcGetObject(m_hPpc, ppNoGen);
}
//	vRpC~
BOOL	CAjxPpc::Stop				()
{
	return AjcPpcStop(m_hPpc);
}
//	}N擾
BOOL	CAjxPpc::GetMacroInfo		(C_BCP pMacName, PAJCPPCMACINFO pMacInfo)
{
	return AjcPpcGetMacroInfo(m_hPpc, pMacName, pMacInfo);
}
//	}N
UI		CAjxPpc::EnumMacro()
{
	return AjcPpcEnumMacro(m_hPpc, (UX)this, cbNtcMacInfo);
}
//	t@Co
BOOL	CAjxPpc::TokenStreamToFile	(C_BCP pOutPath,
							 EAJCTEC tecOut,
							 BOOL	 bomOut,
							 BOOL	 fExpInc,
							 UI CommOutOfkndPP)
{
	BOOL	rc = FALSE;
	if (AjcPpcSetTecAtTokenStreamToFile(m_hPpc, tecOut, bomOut)) {
		rc = AjcPpcTokenStreamToFile(m_hPpc, pOutPath, fExpInc, CommOutOfkndPP);
	}
	return rc;
}

//----- z֐ -----------------------------------------------------------------------------------------------//
VO		CAjxPpc::OnNtcAnyEvt	(AJCPPCNOTIFY evt)										{}				//	ꂩ̃Cxg
VO		CAjxPpc::OnNtcFileLno	(C_BCP pFile, UI lno, UI nest)							{}				//	t@CCsԍʒm
VO		CAjxPpc::OnNtcSrhStart	(C_BCP pIncFile, C_BCP pDirPath)						{}				//	CN[ht@CJnʒm
VO		CAjxPpc::OnNtcSrhDir	(				 C_BCP pDirPath)						{}				//	CN[ht@C̃tH_ʒm
VO		CAjxPpc::OnNtcSrhEnd	(C_BCP pIncFile, BOOL fFind)							{}				//	CN[ht@CIʒm
VO		CAjxPpc::OnNtcOptSym	(PCAJCPPCTKNNODE pTkn)									{}				//	vvZXpIvVV{ʒm
VO		CAjxPpc::OnNtcMacDef	(PCAJCPPCTKNNODE pTkn, PCAJCPPCMACINFO pMac)			{}				//	}N`ʒm
VO		CAjxPpc::OnNtcMacRef	(PCAJCPPCTKNNODE pTkn, PCAJCPPCMACINFO pMac)			{}				//	}NQƒʒm
VO		CAjxPpc::OnNtcOutLoop	(VO)													{}				//	g[NXg[t@C֏o̓[v
VO		CAjxPpc::OnNtcSrcTec	(C_BCP pFilePath, EAJCTEC tec, BOOL fBom)				{}				//	\[Xt@C̃GR[hʒm
VO		CAjxPpc::OnNtcToken		(EAJCTKCODE tkn, C_BCP pTkn)							{}				//	g[Nʒm
VO		CAjxPpc::OnNtcError		(AJCPPCERROR err, C_BCP pFile, UI lno, C_BCP pErrTxt)	{}				//	G[ʒm
BOOL	CAjxPpc::OnNtcMacInfo	(PCAJCPPCMACINFO pMacInfo)								{return FALSE;}	//	}N񋓒ʒm
