#include	<AjxCpp.h>

using namespace AjxControl;


//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNiy[WJnʒmj																			//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbQueryPage(PCAJCPRN_INFO pPrnInfo, PAJCPRN_PGINFO pPageInfo, UX cbp)
{
	CAjxPrn*	p = (CAjxPrn*)cbp;
	return p->OnQueryPage(pPrnInfo, pPageInfo);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNichaZNVErbg}bvɂ`R[obNj										//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbDrawByDibSectDC(HDC hdc, PCAJCPRN_INFO pPrnInfo, PCAJCDIBINFO pDibInfo, UX cbp)
{
	CAjxPrn*	p = (CAjxPrn*)cbp;
	return p->OnDrawByDibSectDC(hdc, pPrnInfo, pDibInfo);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNiv^cbɂ`R[obNj															//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbDrawByPrinterDC(HDC hdc, PCAJCPRN_INFO pPrnInfo, UX cbp)
{
	CAjxPrn*	p = (CAjxPrn*)cbp;
	return p->OnDrawByPrinterDC(hdc, pPrnInfo);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxPrn::CAjxPrn(BOOL fUnicode) 
{
	m_fUnicode	= fUnicode;
	m_hWndOwner = NULL;

	//	CX^X
	if (m_hPrn == NULL) {
		if (m_fUnicode) m_hPrn = AjcPrnCreateW();
		else 			m_hPrn = AjcPrnCreateA();
	}
	//	G[`FbN
	if (m_hPrn != NULL) {
		//	R[obNݒ
		AjcPrnSetCallbackParam	  (m_hPrn, (UX)this);
		AjcPrnSetCallbackQueryPage(m_hPrn, cbQueryPage);
	}
	else {
		throw std::runtime_error("PRN cannot creation.");
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxPrn::~CAjxPrn()
{
	if (m_hPrn != NULL) {
		AjcPrnDelete(m_hPrn);
		m_hPrn = NULL;
	}
}

//----- o֐ ---------------------------------------------------------------------------------------------//
//	]TCYݒ
BOOL	CAjxPrn::SetMargin	(PAJCPRN_MARGIN pmmMargin)
{
	return AjcPrnSetMargin(m_hPrn, pmmMargin);
}
//	v^̑I_CAO\
BOOL	CAjxPrn::SelectDialog(PAJCPRN_INFO pInfo, UI Flag, HWND hWndOwner)
{
	return AjcPrnSelectDlg(m_hPrn, pInfo, Flag, hWndOwner);
}
//	_CAO\
BOOL	CAjxPrn::PrintDialog (PAJCPRN_INFO pInfo, PAJCPRN_OPT pOpt, HWND hWndOwner)
{
	return AjcPrnPrintDlg(m_hPrn, pInfo, pOpt, hWndOwner);
}
//	Jn
int		CAjxPrn::Start		(BOOL fUseDib, BOOL fOutputToFile)
{
	if (fUseDib) AjcPrnSetCallbackByDibSect(m_hPrn, cbDrawByDibSectDC);
	else		 AjcPrnSetCallbackByPrinter(m_hPrn, cbDrawByPrinterDC);

	return AjcPrnStart(m_hPrn, fOutputToFile);
}
//	v^ݒ擾(ASCII)
VO		CAjxPrn::GetInfo	(PAJCPRN_INFO pBuf, BCP pPrnName, UI lPrnName)
{
	strcpy_s(pPrnName, lPrnName, AjcPrnGetInfoA(m_hPrn, pBuf));
}
//	v^ݒ擾(UNICODE)
VO		CAjxPrn::GetInfo	(PAJCPRN_INFO pBuf, WCP pPrnName, UI lPrnName)
{
	wcscpy_s(pPrnName, lPrnName, AjcPrnGetInfoW(m_hPrn, pBuf));
}
//----- z֐ -----------------------------------------------------------------------------------------------//
//	y[WJnʒm
BOOL	CAjxPrn::OnQueryPage			(PCAJCPRN_INFO pPrnInfo, PAJCPRN_PGINFO pPageInfo)
{
	return FALSE;
}
//	chaZNVErbg}bvɂ`
BOOL	CAjxPrn::OnDrawByDibSectDC	(HDC hdc, PCAJCPRN_INFO pPrnInfo, PCAJCDIBINFO pDibInfo)
{
	return FALSE;
}
//	v^cbɂ`
BOOL	CAjxPrn::OnDrawByPrinterDC	(HDC hdc, PCAJCPRN_INFO pPrnInfo)
{
	return FALSE;
}
