#include	<AjxCpp.h>

using namespace AjxControl;


//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNim[h폜ʒmj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static VO CALLBACK cbRemove(VOP pNodeData, UI len, UX cbp)
{
	CAjxQue*	p = (CAjxQue*)cbp;
	if (!p->m_fDestruct) {
		p->OnNtcRemove(pNodeData, len);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxQue::CAjxQue() 
{
	m_DefSize   = 0;
	m_fDestruct = FALSE;
	if ((m_hQue = AjcVQueCreate ((UX)this, cbRemove)) == NULL) {
		throw std::runtime_error("QUE cannot creation.");
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxQue::~CAjxQue()
{
	if (m_hQue != NULL) {
		m_fDestruct = TRUE;
		AjcVQueDelete(m_hQue);
		m_hQue = NULL;
	}
}
//----- o֐ ---------------------------------------------------------------------------------------------//
//	m[hf[^̋KoCgݒ
VO				CAjxQue::SetDefSize(UI DefSize)
{
	m_DefSize = DefSize;
}
//	m[hf[^̋KoCg擾
UI				CAjxQue::GetDefSize()
{
	return m_DefSize;
}
//	m[h𖖔֒ǉ
VOP				CAjxQue::Enque	(C_VOP pDat, UI lDat)
{
	if (lDat == -1) lDat = m_DefSize;
	return AjcVQueEnqueEx(m_hQue, pDat, lDat);
}
//	m[h擪֑}
VOP				CAjxQue::EnqTop(C_VOP pDat, UI lDat)
{
	if (lDat == -1) lDat = m_DefSize;
	return AjcVQueEnqTopEx(m_hQue, pDat, lDat);
}
//	擪m[ho
UI				CAjxQue::Deque(VOP pBuf, UI lBuf)
{
	if (lBuf == -1) lBuf = m_DefSize;
	return AjcVQueDequeEx(m_hQue, pBuf, lBuf);
}
//	Sm[h
BOOL			CAjxQue::Purge	()
{
	return AjcVQuePurge(m_hQue);
}
//	m[ȟ擾
UI				CAjxQue::GetCount()
{
	return AjcVQueGetCount(m_hQue);
}
//	Q̃Xg}[W
BOOL			CAjxQue::Merge	(CAjxQue* pSrc)
{
	return AjcVQueMerge(m_hQue, pSrc->m_hQue);
}
//	擪m[hAhX擾
VOP				CAjxQue::TopNode	(UIP pBytes)
{
	return AjcVQueTopNode(m_hQue, pBytes);
}
//	̃m[hAhX擾
VOP				CAjxQue::NextNode(C_VOP pCurrentNode, UIP pBytes)
{
	return AjcVQueNextNode(m_hQue, pCurrentNode, pBytes);
}
//	Sm[hւ̃|C^z񐶐
PCAJCVQUEPTR	CAjxQue::CreatePtrArr (UIP pNum)
{
	return AjcVQueCreatePtrArr(m_hQue, pNum);
}
//	Sm[hւ̃|C^z
VO	 			CAjxQue::ReleasePtrArr(PCAJCVQUEPTR pArr)
{
	return AjcVQueReleasePtrArr(m_hQue, pArr);
}
//	}`Xbh̋^֎~
BOOL			CAjxQue::EnableMultiThread	(BOOL fEnable)
{
	return AjcVQueEnableMultiThread(m_hQue, fEnable);
}
//----- z֐ -----------------------------------------------------------------------------------------------//
//	m[h폜ʒm
VO		CAjxQue::OnNtcRemove		(VOP pNodeData, UI len)
{
}
