#include	<AjxCpp.h>
using namespace AjxControl;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	VAʐM																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//

#define	WM_SCPEVENT	(WM_APP + 10)

extern	HINSTANCE	hDllInst;
static	ATOM		atmClass	= 0;

AJC_WNDPROC_DEF(ScpEvtWndProc);
static	VO	SubCallVirtualFunc(CAjxScp* p, WPARAM wParam, LPARAM lParam);

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Nݒ																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
BOOL	IniScp(VO)
{
	BOOL		rc = FALSE;
	WNDCLASSA	wc = {0};

	wc.style		 = 0;								wc.hCursor		 = LoadCursor(NULL, IDC_ARROW); 
	wc.lpfnWndProc	 = AJC_WNDPROC_NAME(ScpEvtWndProc);	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.cbWndExtra	 = sizeof(VOP);						wc.lpszClassName = "CAjxScpEvtWnd";
	wc.hInstance	 = hDllInst;
	if ((atmClass = RegisterClassA(&wc)) != 0) {
		rc = TRUE;
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	I㏈																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
VO		EndScp(VO)
{
	if (atmClass != 0) {
		UnregisterClassA((BCP)atmClass, hDllInst);
		atmClass = 0;
	}
}



using namespace AjxControl;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxScp::CAjxScp() 
{
	m_hScp		= NULL;				//	rboCX^Xhnh
	m_Atom		= 0;				//	CxgʒmpNXnh
	m_hWndEvt	= NULL;				//	CxgʒmpECh
	m_fUnicode	= 0;				//	UNICODEtO

	//	CxgMp_~[ECh
	if ((m_hWndEvt = CreateWindowA( "CAjxScpEvtWnd", 								// window class
									"",												// window caption
									WS_OVERLAPPEDWINDOW,							// window style
									0, 0, 0, 0, 									// position, size
									NULL, NULL, hDllInst, (VOP)this)) != NULL) {	// parent, menu, instance, param
		ShowWindow(m_hWndEvt, SW_HIDE);
	}
	else throw std::runtime_error("SCP event window cannot creation.");
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxScp::~CAjxScp()
{
	if (m_hScp	  != NULL) {AjcScpDelete(m_hScp);		m_hScp	  = NULL;}
	if (m_hWndEvt != NULL) {DestroyWindow(m_hWndEvt);	m_hWndEvt = NULL;}
}

//----- o֐ ---------------------------------------------------------------------------------------------//
//	ݒ(ASCII)
BOOL	CAjxScp::Init	(C_BCP pSect, AJCSCP_CHUNKMODE ChunkMode, BOOL fUseWaitEvent, BOOL fCreateMySlot, C_BCP pMySlot, C_BCP pRmtHost, C_BCP pRmtSlot)
{
	BOOL	rc = FALSE;

	//	UNICODEʃtOݒ
	m_fUnicode = FALSE;

	//	ςrboCX^X
	if (m_hScp != NULL) {
		AjcScpDelete(m_hScp);
	}
	//	rboCX^X
	if ((m_hScp = AjcScpCreateExA(pSect, fCreateMySlot, pMySlot, pRmtHost, pRmtSlot)) != NULL) {
		if (fUseWaitEvent) rc = AjcScpSetMode(m_hScp, NULL	   , 0			, ChunkMode);
		else			   rc = AjcScpSetMode(m_hScp, m_hWndEvt, WM_SCPEVENT, ChunkMode);
	}
	return rc;
}
//	ݒ(UNICODE)
BOOL	CAjxScp::Init	(C_WCP pSect, AJCSCP_CHUNKMODE ChunkMode, BOOL fUseWaitEvent, BOOL fCreateMySlot, C_WCP pMySlot, C_WCP pRmtHost, C_WCP pRmtSlot)
{
	BOOL	rc = FALSE;

	//	UNICODEʃtOݒ
	m_fUnicode = TRUE;

	//	ςrboCX^X
	if (m_hScp != NULL) {
		AjcScpDelete(m_hScp);
	}
	//	rboCX^X
	if ((m_hScp = AjcScpCreateExW(pSect, fCreateMySlot, pMySlot, pRmtHost, pRmtSlot)) != NULL) {
		if (fUseWaitEvent) rc = AjcScpSetMode(m_hScp, NULL	   , 0			, ChunkMode);
		else			   rc = AjcScpSetMode(m_hScp, m_hWndEvt, WM_SCPEVENT, ChunkMode);
	}
	return rc;
}

//	|[gI[vibnl|[gj
BOOL				CAjxScp::Open						(UI Port, UI Rate, UI DataBits, UI Parity, UI StopBit)
{
	return AjcScpOpen(m_hScp, Port, Rate, DataBits, Parity, StopBit);;
}
//	|[gI[vibnl|[gCDCB, TIMEOUTwj
BOOL				CAjxScp::Open						(UI Port, LPDCB pDcb, LPCOMMTIMEOUTS pTmo)
{
	return AjcScpOpenEx(m_hScp, Port, pDcb, pTmo);
}
//	|[gI[vi[XbgCASCIIj
BOOL				CAjxScp::Open						(C_BCP pRmtHost, C_BCP pRmtSlot)
{
	return AjcScpOpenSlotA(m_hScp, pRmtHost, pRmtSlot);
}
//	|[gI[vi[XbgCUNICODEj
BOOL				CAjxScp::Open						(C_WCP pRmtHost, C_WCP pRmtSlot)
{
	return AjcScpOpenSlotW(m_hScp, pRmtHost, pRmtSlot);
}
//	|[gI[vi\PbgCASCIIj
BOOL				CAjxScp::Open						(C_BCP pServ, UI PortNo)
{
	return AjcScpOpenSockA(m_hScp, pServ, PortNo);
}
//	|[gI[vi\PbgCUNICODEj
BOOL				CAjxScp::Open						(C_WCP pServ, UI PortNo)
{
	return AjcScpOpenSockW(m_hScp, pServ, PortNo);
}
//	|[gI[viIϒʐM\[Xj
BOOL				CAjxScp::Open						()
{
	return AjcScpOpenDefault(m_hScp);;
}
//	|[gI[viʐM\[XIj
BOOL				CAjxScp::Open						(AJCSCP_PORTSEL sel)
{
	return AjcScpOpenSelect(m_hScp, sel);
}
//	|[gN[Y
BOOL				CAjxScp::Close						()
{
	return AjcScpClose(m_hScp);
}
//	ݒ肳ĂʐM|[gʎ擾
UI					CAjxScp::GetSelectedPort			()
{
	return AjcScpGetSelectedPort(m_hScp);
}
//	|[gI[vԎ擾
UI					CAjxScp::IsOpened					()
{
	return AjcScpIsOpened(m_hScp);
}
//	PM(ASCII)
BOOL				CAjxScp::SendChar					(BC code)
{
	return AjcScpSendCharA(m_hScp, code);
}
//	PM(UNICODE)
BOOL				CAjxScp::SendChar					(WC code)
{
	return AjcScpSendCharW(m_hScp, code);
}
//	oCgyAɂ郏[hi14Bitjf[^M (Low byte first)
BOOL				CAjxScp::SendWord14LF				(UI data)
{
	return AjcScpSendWord14LF(m_hScp, data);
}
//	oCgyAɂ郏[hi14Bitjf[^M (High byte first)
BOOL				CAjxScp::SendWord14HF				(UI data)
{
	return AjcScpSendWord14HF(m_hScp, data);
}
//	PSrbg[hf[^ioCgyAjM̃oCgݒ
BOOL				CAjxScp::SetByteSeqRxWord14			(BOOL fLowByteFirst)
{
	return AjcScpSetByteSeqRxWord14(m_hScp, fLowByteFirst);
}
//	PSrbg[hf[^ioCgyAjM̃oCg擾
BOOL				CAjxScp::GetByteSeqRxWord14			()
{
	return AjcScpGetByteSeqRxWord14 (m_hScp);
}
//	eLXgf[^M(ASCII)
BOOL				CAjxScp::SendText					(C_BCP pTxt, UI lTxt)
{
	return AjcScpSendTextA(m_hScp, pTxt, lTxt);
}
//	eLXgf[^M(UNICODE)
BOOL				CAjxScp::SendText					(C_WCP pTxt, UI lTxt)
{
	return AjcScpSendTextW(m_hScp, pTxt, lTxt);
}
//	eLXgf[^M(ASCII)
BOOL				CAjxScp::SendTextF					(C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	BC		txt[2048] = {0};

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnprintf_s(txt, 2048, pFmt, vls);
		txt[2047] = 0;
		va_end	(vls);
		rc = AjcScpSendTextA(m_hScp, txt, -1);
	}
	return rc;
}
//	eLXgf[^M(UNICODE)
BOOL				CAjxScp::SendTextF					(C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	WC		txt[2048] = {0};

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnwprintf_s(txt, 2048, pFmt, vls);
		va_end	(vls);
		rc = AjcScpSendTextW(m_hScp, txt, -1);
	}
	return rc;
}
//	oCif[^M
BOOL				CAjxScp::SendBinData				(C_VOP pDat, UI lDat)
{
	return AjcScpSendBinData(m_hScp, pDat, lDat);
}
//	pPbgf[^M
UI					CAjxScp::SendPacket					(C_VOP pPkt, UI lPkt)
{
	return AjcScpSendPacket(m_hScp, pPkt, lPkt);
}
//	u[NMo^~
BOOL				CAjxScp::SendBreak					(BOOL fBreak)
{
	return AjcScpSendBreak(m_hScp, fBreak);
}
//	Cxg}XNݒ
BOOL				CAjxScp::SetEvtMask					(UI Mask)
{
	return AjcScpSetEvtMask(m_hScp, Mask);
}
//	Cxg}XN擾
UI					CAjxScp::GetEvtMask					()
{
	return AjcScpGetEvtMask(m_hScp);
}
//	csqMݒ
BOOL				CAjxScp::SetDTR						(BOOL fActive)
{
	return AjcScpSetDTR(m_hScp, fActive);
}
//	qsrMݒ
BOOL				CAjxScp::SetRTS						(BOOL fActive)
{
	return AjcScpSetRTS(m_hScp, fActive);
}
//	MԎ擾
UI					CAjxScp::GetSigState				()
{
	return AjcScpGetSigState(m_hScp);
}
//	M҂f[^oCg擾
ULL					CAjxScp::GetTxBytes					()
{
	return AjcScpGetTxBytes(m_hScp);
}
//	SMσf[^j
BOOL				CAjxScp::PurgeRecvData				()
{
	return AjcScpPurgeRecvData(m_hScp);
}
//	SM҂f[^j
BOOL				CAjxScp::PurgeSendData				()
{
	return AjcScpPurgeSendData(m_hScp);
}
//	SMf[^j
BOOL				CAjxScp::PurgeAllData				()
{
	return AjcScpPurgeAllData(m_hScp);
}
//	cbaƃ^CAEgݒ
BOOL				CAjxScp::SetParam					(const DCB *pDcb, const COMMTIMEOUTS *pTmo)
{
	return AjcScpSetParam(m_hScp, pDcb, pTmo);
}
//	cbaƃ^CAEg擾
UI					CAjxScp::GetParam					(LPDCB pDcb, LPCOMMTIMEOUTS pTmo)
{
	return AjcScpGetParam(m_hScp, pDcb, pTmo);
}
//	Cxg҂
BOOL				CAjxScp::WaitEvent					(UI msTime)
{
	BOOL	rc = FALSE;
	WPARAM	wParam;
	LPARAM	lParam;
	if (rc = AjcScpWaitEvent(m_hScp, &wParam, &lParam, msTime)) {
		SubCallVirtualFunc(this, wParam, lParam);
	}
	return rc;
}
//	pPbgt[Fׂ̐R[hݒ
BOOL				CAjxScp::SetPktCtrlCode				(UI stx, UI etx, UI dle)
{
	return AjcScpSetPktCtrlCode(m_hScp, stx, etx, dle);
}
//	pPbgt[Fׂ̐R[h擾
BOOL				CAjxScp::GetPktCtrlCode				(UIP pStx, UIP pEtx, UIP pDle)
{
	return AjcScpGetPktCtrlCode(m_hScp, pStx, pEtx, pDle);
}
//	pPbgt[M^CAEglݒ
BOOL				CAjxScp::SetPktTimeout				(UI msTime)
{
	return AjcScpSetPktTimeout(m_hScp, msTime);
}
//	pPbgt[M^CAEgl擾
BOOL				CAjxScp::GetPktTimeout				(UIP pMsTime)
{
	return AjcScpGetPktTimeout(m_hScp, pMsTime);
}
//	ʐMp^ݒ_CAOɂbnl|[g ̑I^֎~
BOOL				CAjxScp::EnableComPortSelection		(BOOL fEnableComPort)
{
	return AjcScpEnableComPortSelection(m_hScp, fEnableComPort);
}
//	ʐMp^ݒ_CAOɂ郁[Xbg̑I^֎~
BOOL				CAjxScp::EnableMailslotSelection	(BOOL fEnableMailSlot)
{
	return AjcScpEnableMailslotSelection(m_hScp, fEnableMailSlot);
}
//	ʐMp^ݒ_CAOɂ\PbgʐM ̑I^֎~
BOOL				CAjxScp::EnableSocketSelection		(BOOL fEnableSocket)
{
	return AjcScpEnableSocketSelection(m_hScp, fEnableSocket);
}
//	bnl|[gA[XbgCу\PbgʐM̑I^֎~
BOOL				CAjxScp::EnablePortSelection		(BOOL fEnableComPort, BOOL fEnableMailSlot, BOOL fEnableSocket)
{
	return AjcScpEnablePortSelectionEx(m_hScp, fEnableComPort, fEnableMailSlot, fEnableSocket);
}
//	_CAOɂʐMp^ݒ
UI					CAjxScp::DlgParamEasy				(HWND hWndOwner)
{
	return AjcScpDlgParamEasy (m_hScp, hWndOwner);
}
//	_CAOɂʐMp^ݒiEChʒuwj
UI					CAjxScp::DlgParamEasy				(HWND hWndOwner, int x, int y)
{
	return AjcScpDlgParamEasyEx(m_hScp, hWndOwner, x, y);
}
//	_CAOɂbnl|[gʐMp^ڍאݒ
UI					CAjxScp::DlgParamDetail				(HWND hWndOwner)
{
	return AjcScpDlgParamDetail(m_hScp, hWndOwner);
}
//	_CAOɂbnl|[gʐMp^ڍאݒiEChʒuwj
UI					CAjxScp::DlgParamDetailEx			(HWND hWndOwner, int x, int y)
{
	return AjcScpDlgParamDetailEx(m_hScp, hWndOwner, x, y);
}
//	|[gpX̎擾(ASCII)
VO					CAjxScp::GetPortPathName			(BCP *pPathName)
{
	if (pPathName != NULL) {
		*pPathName = AjcScpGetPortPathNameA(m_hScp);
	}
}
//	|[gpX̎擾(UNICODE)
VO					CAjxScp::GetPortPathName			(WCP *pPathName)
{
	if (pPathName != NULL) {
		*pPathName = AjcScpGetPortPathNameW(m_hScp);
	}
}
//	|[g̎擾(ASCII)
VO					CAjxScp::GetPortName				(BCP *pName)
{
	if (pName != NULL) {
		*pName = AjcScpGetPortNameA(m_hScp);
	}
}
//	|[g̎擾(UNICODE)
VO					CAjxScp::GetPortName				(WCP *pName)
{
	if (pName != NULL) {
		*pName = AjcScpGetPortNameW(m_hScp);
	}
}
//	`Nf[^̒ʒm[hݒ
BOOL				CAjxScp::SetChunkMode				(AJCSCP_CHUNKMODE ChunkMode)
{
	return AjcScpSetChunkMode(m_hScp, ChunkMode);
}
//	`Nf[^̒ʒm[h擾
AJCSCP_CHUNKMODE	CAjxScp::GetChunkMode				()
{
	return AjcScpGetChunkMode(m_hScp);
}
//	MeLXg̕R[hʐݒ
BOOL				CAjxScp::SetRxTextCode				(AJCSCP_TEXTCODE code)
{
	return AjcScpSetRxTextCode(m_hScp, code);
}
//	MeLXg̕R[hʎ擾
AJCSCP_TEXTCODE		CAjxScp::GetRxTextCode				()
{
	return AjcScpGetRxTextCode(m_hScp);
}
//	MeLXg̕R[hʐݒ
BOOL				CAjxScp::SetTxTextCode				(AJCSCP_TEXTCODE code)
{
	return AjcScpSetTxTextCode(m_hScp, code);
}
//	MeLXg̕R[hʎ擾
AJCSCP_TEXTCODE		CAjxScp::GetTxTextCode				()
{
	return AjcScpGetTxTextCode(m_hScp);
}
//	ۂ̎MeLXg̕R[hʎ擾
AJCSCP_TEXTCODE		CAjxScp::GetActualRxTextCode		()
{
	return AjcScpGetActualRxTextCode(m_hScp);
}
//	ۂ̑MeLXg̕R[hʎ擾
AJCSCP_TEXTCODE		CAjxScp::GetActualTxTextCode		()
{
	return AjcScpGetActualTxTextCode(m_hScp);
}
//	[Xbg
BOOL				CAjxScp::CreateMySlot				()
{
	return AjcScpCreateMySlot(m_hScp);
}
//	[Xbg
BOOL				CAjxScp::DeleteMySlot				()
{
	return AjcScpDeleteMySlot(m_hScp);
}
//	[XbgԎ擾
BOOL				CAjxScp::MySlotIsCreated			()
{
	return AjcScpMySlotIsCreated(m_hScp);
}
//	[Xbg̃pX擾(ASCII)
VO					CAjxScp::GetMySlotPathName			(BCP *pPathName)
{
	if (pPathName != NULL) {
		*pPathName = AjcScpGetMySlotPathNameA(m_hScp);
	}
}
//	[Xbg̃pX擾(UNICODE)
VO					CAjxScp::GetMySlotPathName			(WCP *pPathName)
{
	if (pPathName != NULL) {
		*pPathName = AjcScpGetMySlotPathNameW(m_hScp);
	}
}
//	Rs[^擾(ASCII)
BOOL				CAjxScp::GetMyComputerName			(BC pBuf[AJCMAX_HOSTNAME_LENGTH])
{
	return AjcScpGetMyComputerNameA(m_hScp, pBuf);
}
//	Rs[^擾(UNICODE)
BOOL				CAjxScp::GetMyComputerName			(WC pBuf[AJCMAX_HOSTNAME_LENGTH])
{
	return AjcScpGetMyComputerNameW(m_hScp, pBuf);
}
//	[Xbgݒ(ASCII)
BOOL				CAjxScp::SetMailSlotNames			(C_BCP pMySlot, C_BCP pRmyHost, C_BCP pRmtSlot)
{
	return AjcScpSetMailSlotNamesA(m_hScp, pMySlot, pRmyHost, pRmtSlot);
}
//	[Xbgݒ(UNICODE)
BOOL				CAjxScp::SetMailSlotNames			(C_WCP pMySlot, C_WCP pRmyHost, C_WCP pRmtSlot)
{
	return AjcScpSetMailSlotNamesW(m_hScp, pMySlot, pRmyHost, pRmtSlot);
}
//	[Xbg擾(ASCII)
BOOL				CAjxScp::GetMailSlotNames			(BC pMySlot[64], BC pRmyHost[AJCMAX_HOSTNAME_LENGTH], BC pRmtSlot[64])
{
	return AjcScpGetMailSlotNamesA(m_hScp, pMySlot, pRmyHost, pRmtSlot);
}
//	[Xbg擾(UNICODE)
BOOL				CAjxScp::GetMailSlotNames			(WC pMySlot[64], WC pRmyHost[AJCMAX_HOSTNAME_LENGTH], WC pRmtSlot[64])
{
	return AjcScpGetMailSlotNamesW(m_hScp, pMySlot, pRmyHost, pRmtSlot);
}
//	[XbgMx̐ݒ
BOOL				CAjxScp::SetTxSpeedLimit			(BOOL flag, UI bps)
{
	return AjcScpSetTxSpeedLimit(m_hScp, flag, bps);
}
//	[XbgMx̎擾
BOOL				CAjxScp::GetTxSpeedLimit			(UIP pBps)
{
	return AjcScpGetTxSpeedLimit(m_hScp, pBps);
}


//----- z֐ -----------------------------------------------------------------------------------------------//
//	|[gԒʒm(ASCII)
VO	CAjxScp::OnNtcPortState	(C_BCP pPortName, UI Param)
{
}
//	|[gԒʒm(UNICODE)
VO	CAjxScp::OnNtcPortState	(C_WCP pPortName, UI Param)
{
}
//	eLXg`NMʒm(ASCII)
VO	CAjxScp::OnNtcRxTextChunk(C_BCP pText)
{
}
//	eLXg`NMʒm(UNICODE)
VO	CAjxScp::OnNtcRxTextChunk(C_WCP pText)
{
}
//	oCi`NMʒm
VO	CAjxScp::OnNtcRxBinChunk(C_VOP pData, UI Bytes)
{
}
//	eLXgMʒm(ASCII)
VO	CAjxScp::OnNtcRxText	(C_BCP pText)
{
}
//	eLXgMʒm(UNICODE)
VO	CAjxScp::OnNtcRxText	(C_WCP pText)
{
}
//	drbV[PXMʒm(ASCII)
VO	CAjxScp::OnNtcRxEsc		(C_BCP pData)
{
}
//	drbV[PXMʒm(UNICODE)
VO	CAjxScp::OnNtcRxEsc		(C_WCP pData)
{
}
//	R[hMʒm
VO	CAjxScp::OnNtcRxCtrl	(UI Ctrl)
{
}
//	pPbgMʒm
VO	CAjxScp::OnNtcRxPkt		(C_VOP pData, UI Bytes)
{
}
//	Mʒm
VO	CAjxScp::OnNtcTxEmpty	()
{
}
//	pPbgOf[^Mʒm
VO	CAjxScp::OnNtcRxNoPkt	(C_BCP pText)
{
}
//	pPbgOf[^Mʒm
VO	CAjxScp::OnNtcRxNoPkt	(C_WCP pText)
{
}
//	seLXg`NMʒm
VO	CAjxScp::OnNtcInvChunk	(C_VOP pData, UI lData)
{
}
//	ʐMG[ʒm
VO	CAjxScp::OnNtcErr		(UI param)
{
}
//	BREAKoʒm
VO	CAjxScp::OnNtcBreak		()
{
}
//	RINGωʒm
VO	CAjxScp::OnNtcRing		(UI param)
{
}
//	RLSDωʒm
VO	CAjxScp::OnNtcRlsd		(UI param)
{
}
//	DSR ωʒm
VO	CAjxScp::OnNtcDsr		(UI param)
{
}
//	CTS ωʒm
VO	CAjxScp::OnNtcCts		(UI param)
{
}
//	oCgyAɂ郏[h(14Bit)Mʒm
VO	CAjxScp::OnNtcRxWord14	(UW data)
{
}

//----- X^eBbN֐ ---------------------------------------------------------------------------------------//
//	bnl|[g̗
UI					CAjxScp::EnumSerialPorts			(UBP pMap, UI lMap, UI CurrentPort)
{
	return AjcScpEnumSerialPorts(pMap, lMap, CurrentPort);;
}
//	bnl|[g̃foCX擾(ASCII)
int					CAjxScp::GetPortDevName				(C_BCP pPortName, BCP pBuf, UI lBuf)
{
	return AjcScpGetPortDevNameA(pPortName, pBuf, lBuf);
}
//	bnl|[g̃foCX擾(UNICODE)
int					CAjxScp::GetPortDevName				(C_WCP pPortName, WCP pBuf, UI lBuf)
{
	return AjcScpGetPortDevNameW(pPortName, pBuf, lBuf);
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	rboCxgpEChvV[W																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- WM_CREATE ----------------------------------------------------------------------------------------------//
AJC_WNDPROC(ScpEvtWndProc, WM_CREATE 	)
{
	CAjxScp* p = (CAjxScp*)(((LPCREATESTRUCT)lParam)->lpCreateParams);

	MAjcSetWindowLong(hwnd, 0, (UX)p);

	return TRUE;
}
//----- WM_DESTROY ---------------------------------------------------------------------------------------------//
AJC_WNDPROC(ScpEvtWndProc, WM_DESTROY	)
{
	CAjxScp* p = (CAjxScp*)MAjcGetWindowLong(hwnd, 0);
	return 0;
}
//----- WM_SCPEVENT --------------------------------------------------------------------------------------------//
AJC_WNDPROC(ScpEvtWndProc, WM_SCPEVENT	)
{
	CAjxScp* p = (CAjxScp*)MAjcGetWindowLong(hwnd, 0);
	SubCallVirtualFunc(p, wParam, lParam);
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(ScpEvtWndProc)
	AJC_WNDMAP_MSG(ScpEvtWndProc, WM_CREATE	)
	AJC_WNDMAP_MSG(ScpEvtWndProc, WM_DESTROY )
	AJC_WNDMAP_MSG(ScpEvtWndProc, WM_SCPEVENT)
AJC_WNDMAP_END

//----- Cxgʒmiz֐R[j--------------------------------------------------------------------------//
static	VO	SubCallVirtualFunc(CAjxScp* p, WPARAM wParam, LPARAM lParam)
{
	union	{VOP vop; BCP bcp; WCP wcp; UBP ubp; UWP uwp;} u;
	UI		len, param;

	AjcScpGetEventData(p->m_hScp, lParam, &u.vop, &len, &param);

	//----- |[gԒʒm -------------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_PORTSTATE) != 0) {
		if (p->m_fUnicode) p->OnNtcPortState(u.wcp, param);
		else			   p->OnNtcPortState(u.bcp, param);
	}
	//----- `Nf[^Mʒm ioCij-----------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RXCHUNK  ) != 0  &&  param == 0) {
		p->OnNtcRxBinChunk(u.vop, len);
	}
	//----- `Nf[^MʒmieLXgj------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RXCHUNK  ) != 0  &&  param != 0) {
		if (p->m_fUnicode) p->OnNtcRxTextChunk(u.wcp);
		else			   p->OnNtcRxTextChunk(u.bcp);
	}
	//----- eLXgMʒm -----------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RXTEXT   ) != 0) {
		if (p->m_fUnicode) p->OnNtcRxText(u.wcp);
		else			   p->OnNtcRxText(u.bcp);
	}
	//----- drbR[hMʒm -------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RXESC	  ) != 0) {
		if (p->m_fUnicode) p->OnNtcRxEsc(u.wcp);
		else			   p->OnNtcRxEsc(u.bcp);
	}
	//----- R[hMʒm ---------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RXCTRL   ) != 0) {
		p->OnNtcRxCtrl(*u.bcp);
	}
	//----- pPbgf[^Mʒm -----------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RXPKT	  ) != 0) {
		p->OnNtcRxPkt(u.vop, len);
	}
	//----- M -------------------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_TXEMPTY  ) != 0) {
		p->OnNtcTxEmpty();
	}
	//----- pPbgOeLXgM -----------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RXNOPKT  ) != 0) {
		if (p->m_fUnicode) p->OnNtcRxNoPkt(u.wcp);
		else			   p->OnNtcRxNoPkt(u.bcp);
	}
	//----- s`NeLXgM ---------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_INVCHUNK) != 0) {
		p->OnNtcInvChunk(u.vop, len);
	}
	//----- G[ʒm -----------------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_ERR	  ) != 0) {
		p->OnNtcErr(param);
	}
	//----- RINGωʒm ---------------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RING	  ) != 0) {
		p->OnNtcRing(param);
	}
	//----- RLSDωʒm ---------------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RLSD	  ) != 0) {
		p->OnNtcRlsd(param);
	}
	//----- DSRωʒm ----------------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_DSR	  ) != 0) {
		p->OnNtcDsr(param);
	}
	//----- CTSωʒm ----------------------------------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_CTS	  ) != 0) {
		p->OnNtcCts(param);
	}
	//----- oCgyAɂ郏[h(14Bitl)M ----------------------------------------------------------------//
	if		((wParam & AJCSCP_EV_RXWORD14 ) != 0) {
		p->OnNtcRxWord14(*u.uwp);
	}

	AjcScpRelEventData(p->m_hScp, lParam);

}
