#include	<AjxCpp.h>
using namespace AjxControl;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	\PbgʐMiNCAgj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//

#define	WM_SCTEVENT	(WM_APP + 10)

extern	HINSTANCE	hDllInst;
static	ATOM		atmClass	= 0;

AJC_WNDPROC_DEF(SctEvtWndProc);
static	VO	SubCallVirtualFunc(CAjxSct* p, WPARAM wParam, LPARAM lParam);

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Nݒ																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
BOOL	IniSct(VO)
{
	BOOL		rc = FALSE;
	WNDCLASSA	wc = {0};

	wc.style		 = 0;								wc.hCursor		 = LoadCursor(NULL, IDC_ARROW); 
	wc.lpfnWndProc	 = AJC_WNDPROC_NAME(SctEvtWndProc);	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.cbWndExtra	 = sizeof(VOP);						wc.lpszClassName = "CAjxSctEvtWnd";
	wc.hInstance	 = hDllInst;
	if ((atmClass = RegisterClassA(&wc)) != 0) {
		rc = TRUE;
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	I㏈																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
VO		EndSct(VO)
{
	if (atmClass != 0) {
		UnregisterClassA((BCP)atmClass, hDllInst);
		atmClass = 0;
	}
}



using namespace AjxControl;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxSct::CAjxSct() 
{
	m_hSct		= NULL;				//	rboCX^Xhnh
	m_Atom		= 0;				//	CxgʒmpNXnh
	m_hWndEvt	= NULL;				//	CxgʒmpECh
	m_fUnicode	= 0;				//	UNICODEtO

	//	CxgMp_~[ECh
	if ((m_hWndEvt = CreateWindowA( "CAjxSctEvtWnd", 								// window class
									"",												// window caption
									WS_OVERLAPPEDWINDOW,							// window style
									0, 0, 0, 0, 									// position, size
									NULL, NULL, hDllInst, (VOP)this)) != NULL) {	// parent, menu, instance, param
		ShowWindow(m_hWndEvt, SW_HIDE);
		//	rbsCX^X
		if ((m_hSct = AjcSctCreate()) == NULL) {
			throw std::runtime_error("SCT instance cannot creation.");
		}
	}
	else throw std::runtime_error("SCT event window cannot creation.");
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxSct::~CAjxSct()
{
	if (m_hSct	  != NULL) {AjcSctDelete(m_hSct);		m_hSct	  = NULL;}
	if (m_hWndEvt != NULL) {DestroyWindow(m_hWndEvt);	m_hWndEvt = NULL;}
}

//----- o֐ ---------------------------------------------------------------------------------------------//
//	ڑ(ASCII)
BOOL	CAjxSct::Connect(C_BCP pServ, C_BCP pPort, int AddressFamily, BOOL fUseWaitEvent)
{
	BOOL	rc = FALSE;

	//	UNICODEʃtOݒ
	m_fUnicode = FALSE;

	if (fUseWaitEvent) rc = AjcSctConnectA(m_hSct, pServ, pPort, AddressFamily, NULL	  , 0		  );
	else			   rc = AjcSctConnectA(m_hSct, pServ, pPort, AddressFamily, m_hWndEvt, WM_SCTEVENT);

	return rc;
}
//	ڑ(UNICODE)
BOOL	CAjxSct::Connect(C_WCP pServ, C_WCP pPort, int AddressFamily, BOOL fUseWaitEvent)
{
	BOOL	rc = FALSE;

	//	UNICODEʃtOݒ
	m_fUnicode = TRUE;

	if (fUseWaitEvent) rc = AjcSctConnectW(m_hSct, pServ, pPort, AddressFamily, NULL	  , 0		  );
	else			   rc = AjcSctConnectW(m_hSct, pServ, pPort, AddressFamily, m_hWndEvt, WM_SCTEVENT);

	return rc;
}
//	ؒf
BOOL				CAjxSct::Disconnect		(UI msTimeout)
{
	return AjcSctDisconnectEx(m_hSct, msTimeout);
}
//	Ԏ擾
AJCSCT_STATE		CAjxSct::GetState		()
{
	return AjcSctGetState(m_hSct);
}
//	`Nf[^̎M[hݒ
BOOL				CAjxSct::SetChunkMode	(AJCSCT_CHUNKMODE ChunkMode)
{
	return AjcSctSetChunkMode(m_hSct, ChunkMode);
}
//	`Nf[^̎M[h擾
AJCSCT_CHUNKMODE	CAjxSct::GetChunkMode	()
{
	return AjcSctGetChunkMode(m_hSct);
}
//	Cxg}XNݒ
BOOL				CAjxSct::SetEvtMask		(UI EvtMsk)
{
	return AjcSctSetEvtMask(m_hSct, EvtMsk);
}
//	Cxg}XN擾
UI		 			CAjxSct::GetEvtMask		()
{
	return AjcSctGetEvtMask(m_hSct);
}
//	MeLXg̕R[hݒ
BOOL				CAjxSct::SetRxTextCode	(AJCSCT_TEXTCODE code)
{
	return AjcSctSetRxTextCode(m_hSct, code);
}
//	MeLXg̕R[h擾
AJCSCT_TEXTCODE		CAjxSct::GetRxTextCode	()
{
	return AjcSctGetRxTextCode(m_hSct);
}
//	MeLXg̕R[hݒ
BOOL				CAjxSct::SetTxTextCode	(AJCSCT_TEXTCODE code)
{
	return AjcSctSetTxTextCode(m_hSct, code);
}
//	MeLXg̕R[h擾
AJCSCT_TEXTCODE		CAjxSct::GetTxTextCode	()
{
	return AjcSctGetTxTextCode(m_hSct);
}
//	ۂ̎MeLXg̕R[h擾
AJCSCT_TEXTCODE		CAjxSct::GetActualRxTextCode()
{
	return AjcSctGetActualRxTextCode(m_hSct);
}
//	ۂ̑MeLXg̕R[h擾
AJCSCT_TEXTCODE		CAjxSct::GetActualTxTextCode()
{
	return AjcSctGetActualTxTextCode(m_hSct);
}
//	Cxg҂
BOOL				CAjxSct::WaitEvent		(UI msTime)
{
	BOOL	rc = FALSE;
	WPARAM	wParam;
	LPARAM	lParam;
	if (rc = AjcSctWaitEvent(m_hSct, &wParam, &lParam, msTime)) {
		SubCallVirtualFunc(this, wParam, lParam);
	}
	return rc;
}
//	pPbgt[Fׂ̐R[hݒ
BOOL				CAjxSct::SetPktCtrlCode	(UI stx, UI etx, UI dle)
{
	return AjcSctSetPktCtrlCode(m_hSct, stx, etx, dle);
}
//	pPbgt[Fׂ̐R[h擾
BOOL				CAjxSct::GetPktCtrlCode	(UIP pStx, UIP pEtx, UIP pDle)
{
	return AjcSctGetPktCtrlCode(m_hSct, pStx, pEtx, pDle);
}
//	pPbgt[M^CAEglݒ
BOOL				CAjxSct::SetPktTimeout	(UI msTime)
{
	return AjcSctSetPktTimeout(m_hSct, msTime);
}
//	pPbgt[M^CAEgl擾
BOOL				CAjxSct::GetPktTimeout	(UIP pMsTime)
{
	return AjcSctGetPktTimeout(m_hSct, pMsTime);
}
//	PM(ASCII)
BOOL				CAjxSct::SendChar		(BC code)
{
	return AjcSctSendCharA(m_hSct, code);
}
//	PM(UNICODE)
BOOL				CAjxSct::SendChar		(WC code)
{
	return AjcSctSendCharW(m_hSct, code);
}
//	eLXgf[^M(ASCII)
BOOL				CAjxSct::SendText		(C_BCP pTxt, UI lTxt)
{
	return AjcSctSendTextA(m_hSct, pTxt, lTxt);
}
//	eLXgf[^M(UNICODE)
BOOL				CAjxSct::SendText		(C_WCP pTxt, UI lTxt)
{
	return AjcSctSendTextW(m_hSct, pTxt, lTxt);
}
//	eLXgM(ASCII)
BOOL				CAjxSct::SendTextF		(C_BCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	BC		txt[2048] = {0};

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnprintf_s(txt, 2048, pFmt, vls);
		txt[2047] = 0;
		va_end	(vls);
		rc = AjcSctSendTextA(m_hSct, txt, -1);
	}
	return rc;
}
//	eLXgM(UNICODE)
BOOL				CAjxSct::SendTextF		(C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;
	WC		txt[2048] = {0};

	if (pFmt != NULL) {
		va_start(vls, pFmt);
		_vsnwprintf_s(txt, 2048, pFmt, vls);
		va_end	(vls);
		rc = AjcSctSendTextW(m_hSct, txt, -1);
	}
	return rc;
}
//	oCif[^M
BOOL				CAjxSct::SendBinData	(C_VOP pDat, UI lDat)
{
	return AjcSctSendBinData(m_hSct, pDat, lDat);
}
//	pPbgf[^M
UI					CAjxSct::SendPacket		(C_VOP pPkt, UI lPkt)
{
	return AjcSctSendPacket(m_hSct, pPkt, lPkt);
}
//	SMσf[^j
BOOL				CAjxSct::PurgeRecvData	()
{
	return AjcSctPurgeRecvData(m_hSct);
}
//	SM҂f[^j
BOOL				CAjxSct::PurgeSendData	()
{
	return AjcSctPurgeSendData(m_hSct);
}
//	SMf[^j
BOOL				CAjxSct::PurgeAllData	()
{
	return AjcSctPurgeAllData(m_hSct);
}

//----- z֐ -----------------------------------------------------------------------------------------------//
//	ڑʒm
VO	CAjxSct::OnNtcConnect		()
{
}
//	ؒfʒm
VO	CAjxSct::OnNtcDisconnect	()
{
}
//	eLXg`NMʒm(ASCII)
VO	CAjxSct::OnNtcRxTextChunk	(C_BCP pText)
{
}
//	eLXg`NMʒm(UNICODE)
VO	CAjxSct::OnNtcRxTextChunk	(C_WCP pText)
{
}
//	oCi`NMʒm
VO	CAjxSct::OnNtcRxBinChunk	(C_VOP pData, UI Bytes)
{
}
//	eLXgMʒm(ASCII)
VO	CAjxSct::OnNtcRxText		(C_BCP pText)
{
}
//	eLXgMʒm(UNICODE)
VO	CAjxSct::OnNtcRxText		(C_WCP pText)
{
}
//	drbV[PXMʒm(ASCII)
VO	CAjxSct::OnNtcRxEsc			(C_BCP pData)
{
}
//	drbV[PXMʒm(UNICODE)
VO	CAjxSct::OnNtcRxEsc			(C_WCP pData)
{
}
//	R[hMʒm
VO	CAjxSct::OnNtcRxCtrl		(UI Ctrl)
{
}
//	pPbgMʒm
VO	CAjxSct::OnNtcRxPkt			(C_VOP pData, UI Bytes)
{
}
//	Mʒm
VO	CAjxSct::OnNtcTxEmpty		()
{
}
//	pPbgOf[^Mʒm(ASCII)
VO	CAjxSct::OnNtcRxNoPkt		(C_BCP pText)
{
}
//	pPbgOf[^Mʒm(UNICODE)
VO	CAjxSct::OnNtcRxNoPkt		(C_WCP pText)
{
}
//	seLXg`NMʒm
VO	CAjxSct::OnNtcInvChunk		(C_VOP pData, UI lData)
{
}
//	ڑsʒm
VO	CAjxSct::OnNtcCnErr			(UI param)
{
}
//	MG[ʒm
VO	CAjxSct::OnNtcRxErr			(UI param)
{
}
//	MG[ʒm
VO	CAjxSct::OnNtcTxErr			(UI param)
{
}
//	G[ʒm
VO	CAjxSct::OnNtcErr			(UI param)
{
}


//--------------------------------------------------------------------------------------------------------------//
//																												//
//	rbsCxgpEChvV[W																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- WM_CREATE ----------------------------------------------------------------------------------------------//
AJC_WNDPROC(SctEvtWndProc, WM_CREATE 	)
{
	CAjxSct* p = (CAjxSct*)(((LPCREATESTRUCT)lParam)->lpCreateParams);

	MAjcSetWindowLong(hwnd, 0, (UX)p);

	return TRUE;
}
//----- WM_DESTROY ---------------------------------------------------------------------------------------------//
AJC_WNDPROC(SctEvtWndProc, WM_DESTROY	)
{
	CAjxSct* p = (CAjxSct*)MAjcGetWindowLong(hwnd, 0);
	return 0;
}
//----- WM_SCTEVENT --------------------------------------------------------------------------------------------//
AJC_WNDPROC(SctEvtWndProc, WM_SCTEVENT	)
{
	CAjxSct* p = (CAjxSct*)MAjcGetWindowLong(hwnd, 0);
	SubCallVirtualFunc(p, wParam, lParam);
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(SctEvtWndProc)
	AJC_WNDMAP_MSG(SctEvtWndProc, WM_CREATE	)
	AJC_WNDMAP_MSG(SctEvtWndProc, WM_DESTROY )
	AJC_WNDMAP_MSG(SctEvtWndProc, WM_SCTEVENT)
AJC_WNDMAP_END

//----- Cxgʒmiz֐R[j--------------------------------------------------------------------------//
static	VO	SubCallVirtualFunc(CAjxSct* p, WPARAM wParam, LPARAM lParam)
{
	union	{VOP vop; BCP bcp; WCP wcp; UBP ubp; UWP uwp;} u;
	UI		len, param;

	AjcSctGetEventData(p->m_hSct, lParam, &u.vop, &len, &param);

	//----- ڑʒm -------------------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_CONNECT		) != 0) {
		p->OnNtcConnect();
	}
	//----- ؒfʒm -------------------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_DISCONNECT	) != 0) {
		p->OnNtcDisconnect();
	}
	//----- `Nf[^MʒmioCij------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_RXCHUNK		) != 0	&&	param == 0) {
		p->OnNtcRxBinChunk(u.vop, len);
	}
	//----- `Nf[^MʒmieLXgj------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_RXCHUNK		) != 0	&&	param != 0) {
		if (p->m_fUnicode) p->OnNtcRxTextChunk(u.wcp);
		else			   p->OnNtcRxTextChunk(u.bcp);
	}
	//----- eLXgf[^ʒm ---------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_RXTEXT		) != 0) {
		if (p->m_fUnicode) p->OnNtcRxText(u.wcp);
		else			   p->OnNtcRxText(u.bcp);
	}
	//----- drbR[hf[^ʒm -----------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_RXESC		) != 0) {
		if (p->m_fUnicode) p->OnNtcRxEsc(u.wcp);
		else			   p->OnNtcRxEsc(u.bcp);
	}
	//----- 	R[hʒm ---------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_RXCTRL		) != 0) {
		p->OnNtcRxCtrl(*u.bcp);
	}
	//----- pPbgf[^ʒm ---------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_RXPKT		) != 0) {
		p->OnNtcRxPkt(u.vop, len);
	}
	//----- Mʒm ---------------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_TXEMPTY		) != 0) {
		p->OnNtcTxEmpty();
	}
	//----- pPbgOeLXg ---------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_RXNOPKT		) != 0) {
		if (p->m_fUnicode) p->OnNtcRxNoPkt(u.wcp);
		else			   p->OnNtcRxNoPkt(u.bcp);
	}
	//----- s`NeLXgMʒm -----------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_INVCHUNK	) != 0) {
		p->OnNtcInvChunk(u.vop, len);
	}
	//----- ڑsʒm ---------------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_CNFAIL		) != 0) {
		p->OnNtcCnErr(param);
	}
	//----- MG[ʒm -------------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_RXERR		) != 0) {
		p->OnNtcRxErr(param);
	}
	//----- MG[ʒm -------------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_TXERR		) != 0) {
		p->OnNtcTxErr(param);
	}
	//----- ̑̃G[ʒm ---------------------------------------------------------------------------------//
	if ((wParam & AJCSCT_EV_ERR			) != 0) {
		p->OnNtcErr(param);
	}

	AjcSctRelEventData(p->m_hSct, lParam);
}
