#include	<AjxCpp.h>

using namespace AjxControl;

//==============================================================================================================//
//																												//
//	AjxSplA(ASCII)NX																						//
//																												//
//==============================================================================================================//
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNi񋓕ʒmj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbNtcStrA(C_BCP pStr, UX cbp)
{
	CAjxSpl*	p = (CAjxSpl*)cbp;
	return p->OnNtcStr(pStr);
}
//----- Ch ---------------------------------------------------------------------------------------------//
static BOOL CALLBACK cbNtcStrW(C_WCP pStr, UX cbp)
{
	CAjxSpl*	p = (CAjxSpl*)cbp;
	return p->OnNtcStr(pStr);
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxSpl::CAjxSpl(BOOL fUnicode) 
{
	if (m_fUnicode = fUnicode) m_hSpl = AjcSplCreateW(AJCCMP_ALPHABETIC);
	else					   m_hSpl = AjcSplCreateA(AJCCMP_ALPHABETIC);

	if (m_hSpl == NULL) {
		throw std::runtime_error("SPL cannot creation.");
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxSpl::~CAjxSpl()
{
	if (m_hSpl != NULL) {
		AjcSplDelete(m_hSpl);
		m_hSpl = NULL;
	}
}

//	r[hݒ
BOOL		CAjxSpl::SetCompMode	(EAJCCMPMODE CmpMode)
{
	return	AjcSplSetCompMode(m_hSpl, CmpMode);
}
//	r[h擾
EAJCCMPMODE	CAjxSpl::GetCompMode	()
{
	return	AjcSplGetCompMode(m_hSpl);
}


//	v[֕o^(ASCII)
C_BCP		CAjxSpl::Regist		(C_BCP pStr)
{
	return	AjcSplRegistA(m_hSpl, pStr);
}
//	v[֕o^(UNICODE)
C_WCP		CAjxSpl::Regist		(C_WCP pStr)
{
	return	AjcSplRegistW(m_hSpl, pStr);
}


//	v[當(ASCII)
C_BCP		CAjxSpl::Find			(C_BCP pStr)
{
	return	AjcSplFindA(m_hSpl, pStr);
}
//	v[當(UNICODE)
C_WCP		CAjxSpl::Find			(C_WCP pStr)
{
	return	AjcSplFindW(m_hSpl, pStr);
}


//	viv[w蕔񂪈vm[hj(ASCII)
C_BCP		CAjxSpl::PartStrInPool	(C_BCP pPartStr, AJCSPL_INSTROPT opt)
{
	return	AjcSplPartStrInPoolA(m_hSpl, pPartStr, opt);
}
//	viv[w蕔񂪈vm[hj(UNICODE)
C_WCP		CAjxSpl::PartStrInPool	(C_WCP pPartStr, AJCSPL_INSTROPT opt)
{
	return	AjcSplPartStrInPoolW(m_hSpl, pPartStr, opt);
}


//	viw蕶񂪕v[̕ƈv邩`FbNj(ASCII)
C_BCP		CAjxSpl::PoolStrInStr	(C_BCP pStr    , AJCSPL_INSTROPT opt)
{
	return	AjcSplPoolStrInStrA(m_hSpl, pStr, opt);
}
//	viw蕶񂪕v[̕ƈv邩`FbNj(UNICODE)
C_WCP		CAjxSpl::PoolStrInStr	(C_WCP pStr    , AJCSPL_INSTROPT opt)
{
	return	AjcSplPoolStrInStrW(m_hSpl, pStr, opt);
}


//	v[當폜(ASCII)
BOOL		CAjxSpl::Remove		(C_BCP pStr)
{
	return	AjcSplRemoveA(m_hSpl, pStr);
}
//	v[當폜(UNICODE)
BOOL		CAjxSpl::Remove		(C_WCP pStr)
{
	return	AjcSplRemoveW(m_hSpl, pStr);
}


//	o^ϕ񐔎擾
UI			CAjxSpl::GetCount		()
{
	return	AjcSplGetCount(m_hSpl);
}
//	v[Zbg
BOOL		CAjxSpl::Reset			()
{
	return	AjcSplReset(m_hSpl);
}
//	o^ςݑS̎擾()
UI			CAjxSpl::EnumStr		(BOOL fDownSeq)
{
	UI		rc = 0;
	if (m_fUnicode) rc = AjcSplEnumStrW(m_hSpl, (UX)this, cbNtcStrW, fDownSeq);
	else			rc = AjcSplEnumStrA(m_hSpl, (UX)this, cbNtcStrA, fDownSeq);
	return rc;
}
//	`ukQ؂̃nh擾
HAJCAVL		CAjxSpl::GetAvlHandle()
{
	return	AjcSplGetAvlHandle(m_hSpl);
}

//----- z֐ -----------------------------------------------------------------------------------------------//
//	񋓕ʒm(ASCII)
BOOL		CAjxSpl::OnNtcStr	(C_BCP pStr)
{
	return FALSE;
}
//	񋓕ʒm(UNICODE)
BOOL		CAjxSpl::OnNtcStr	(C_WCP pStr)
{
	return FALSE;
}

