#include	<AjxCpp.h>
using namespace AjxControl;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	\PbgʐMiT[oj  T[o																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//

extern	HINSTANCE	hDllInst;
static	ATOM		atmClass	= 0;

#define	WM_SSVEVENT	(WM_APP + 10)

AJC_WNDPROC_DEF(SsvEvtWndProc);
static	VO	SubCallVirtualFunc(CAjxSsvSvr* pSsvSvr, WPARAM wParam, LPARAM lParam);

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Nݒ																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
BOOL	IniSsv(VO)
{
	BOOL		rc = FALSE;
	WNDCLASSA	wc = {0};

	wc.style		 = 0;								wc.hCursor		 = LoadCursor(NULL, IDC_ARROW); 
	wc.lpfnWndProc	 = AJC_WNDPROC_NAME(SsvEvtWndProc);	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.cbWndExtra	 = sizeof(VOP);						wc.lpszClassName = "CAjxSsvEvtWnd";
	wc.hInstance	 = hDllInst;
	if ((atmClass = RegisterClassA(&wc)) != 0) {
		rc = TRUE;
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	I㏈																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
VO		EndSsv(VO)
{
	if (atmClass != 0) {
		UnregisterClassA((BCP)atmClass, hDllInst);
		atmClass = 0;
	}
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	`ukm[hf[^																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	CAjxSsvCli*		pCli;		//	NCAgNX|C^
} AVLNODE, *PAVLNODE;
typedef const AVLNODE *PCAVLNODE;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	R[obNiڑ̑SNCAg񋓁j																	//
//																												//
//--------------------------------------------------------------------------------------------------------------//
BOOL  CALLBACK cbNtcClients (HAJCSSVCLI hCli, UX cbp)
{
	BOOL	rc = FALSE;
	CAjxSsvSvr* pSsvSvr = (CAjxSsvSvr*)cbp;
	PAVLNODE	pNode	= (PAVLNODE)AjcAvlGetNodePtr(pSsvSvr->GetAvl(), (UX)hCli, NULL);
	return pSsvSvr->OnNtcClients(hCli, pNode->pCli);
}

using namespace AjxControl;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxSsvSvr::CAjxSsvSvr() 
{
	m_hSsv		= NULL;				//	rruCX^Xhnh
	m_Atom		= 0;				//	CxgʒmpNXnh
	m_hWndEvt	= NULL;				//	CxgʒmpECh
	m_fUnicode	= 0;				//	UNICODEtO

	//	CxgMp_~[ECh
	if ((m_hWndEvt = CreateWindowA( "CAjxSsvEvtWnd", 								// window class
									"",												// window caption
									WS_OVERLAPPEDWINDOW,							// window style
									0, 0, 0, 0, 									// position, size
									NULL, NULL, hDllInst, (VOP)this)) != NULL) {	// parent, menu, instance, param
		ShowWindow(m_hWndEvt, SW_HIDE);
		//	NCAgNXi[p`uk
		if ((m_hAvl = AjcAvlCreate((UX)this, NULL, NULL)) == NULL) {
			throw std::runtime_error("SSV - AVL cannot creation.");
		}
	}
	else throw std::runtime_error("SSV event window cannot creation.");
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxSsvSvr::~CAjxSsvSvr()
{
	if (m_hAvl	  != NULL) {AjcAvlDelete(m_hAvl);		m_hAvl	  = NULL;}
	if (m_hSsv	  != NULL) {AjcSsvDelete(m_hSsv);		m_hSsv	  = NULL;}
	if (m_hWndEvt != NULL) {DestroyWindow(m_hWndEvt);	m_hWndEvt = NULL;}
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	Tu֐																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//	`uknh擾
HAJCAVL		CAjxSsvSvr::GetAvl()
{
	return m_hAvl;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	o֐iT[oj																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//	T[oJn(ASCII)
BOOL	CAjxSsvSvr::Start	(C_BCP pPort, UI MaxClients, BOOL fUseWaitEvent, int AddressFamily)
{
	BOOL	rc = FALSE;

	//	UNICODEʃtOݒ
	m_fUnicode = FALSE;

	//	őNCAg␳
	m_MaxClients = __max(MaxClients, 1);

	//	CfNXߗp}bve[u
	UI	len = ((m_MaxClients / 32) + ((m_MaxClients % 32) != 0)) * sizeof(UI);
	if (m_pMap = (UIP)malloc(len)) {
		memset(m_pMap, 0, len);
		//	ςrruCX^X
		if (m_hSsv != NULL) {
			AjcSsvDelete(m_hSsv);
		}
		//	rruCX^X
		if ((m_hSsv = AjcSsvCreate()) != NULL) {
			if (fUseWaitEvent) rc = AjcSsvStartA(m_hSsv, pPort, AddressFamily, m_MaxClients, NULL	  , 0		   );
			else			   rc = AjcSsvStartA(m_hSsv, pPort, AddressFamily, m_MaxClients, m_hWndEvt, WM_SSVEVENT);
		}
	}
	else throw std::runtime_error("SSV index-map-table cannot creation.");

	return rc;
}
//	T[oJn(UNICODE)
BOOL	CAjxSsvSvr::Start	(C_WCP pPort,  UI MaxClients, BOOL fUseWaitEvent,int AddressFamily)
{
	BOOL	rc = FALSE;

	//	UNICODEʃtOݒ
	m_fUnicode = TRUE;

	//	őNCAg␳
	m_MaxClients = __max(MaxClients, 1);

	//	CfNXߗp}bve[u
	UI	len = ((m_MaxClients / 32) + ((m_MaxClients % 32) != 0)) * sizeof(UI);
	if (m_pMap = (UIP)malloc(len)) {
		memset(m_pMap, 0, len);
		//	ςrruCX^X
		if (m_hSsv != NULL) {
			AjcSsvDelete(m_hSsv);
		}
		//	rruCX^X
		if ((m_hSsv = AjcSsvCreate()) != NULL) {
			if (fUseWaitEvent) rc = AjcSsvStartW(m_hSsv, pPort, AddressFamily, m_MaxClients, NULL	  , 0		   );
			else			   rc = AjcSsvStartW(m_hSsv, pPort, AddressFamily, m_MaxClients, m_hWndEvt, WM_SSVEVENT);
		}
	}
	else throw std::runtime_error("SSV index-map-table cannot creation.");

	return rc;
}
//	T[o~
BOOL	CAjxSsvSvr::Stop			()
{
	//	CfNXߗp}bve[u
	if (m_pMap != NULL) {
		free(m_pMap);
	}
	return AjcSsvStop(m_hSsv, 10000);
}
//	IvV̐ݒ
BOOL	CAjxSsvSvr::SetOpt			(AJCSSV_SERVOPT opt)
{
	return AjcSsvSetOpt(m_hSsv, opt);
}
//	IvV̎擾
AJCSSV_SERVOPT	CAjxSsvSvr::GetOpt			()
{
	return AjcSsvGetOpt(m_hSsv);
}
//	`Nf[^̒ʒm[hݒ
BOOL	CAjxSsvSvr::SetChunkMode	(AJCSSV_CHUNKMODE ChunkMode)
{
	return AjcSsvSetChunkMode(m_hSsv, ChunkMode);
}
//	`Nf[^̒ʒm[h擾
AJCSSV_CHUNKMODE	CAjxSsvSvr::GetChunkMode	()
{
	return AjcSsvGetChunkMode(m_hSsv);
}
//	Cxg}XNݒ
BOOL	CAjxSsvSvr::SetEvtMask		(UI EvtMsk)
{
	return AjcSsvSetEvtMask(m_hSsv, EvtMsk);
}
//	Cxg}XN擾
UI		CAjxSsvSvr::GetEvtMask		()
{
	return AjcSsvGetEvtMask(m_hSsv);
}
//	MeLXg̕R[hݒ
BOOL	CAjxSsvSvr::SetRxTextCode	(AJCSSV_TEXTCODE code)
{
	return AjcSsvSetRxTextCode(m_hSsv, code);
}
//	MeLXg̕R[h擾
AJCSSV_TEXTCODE	CAjxSsvSvr::GetRxTextCode	()
{
	return AjcSsvGetRxTextCode(m_hSsv);
}
//	MeLXg̕R[hݒ
BOOL	CAjxSsvSvr::SetTxTextCode	(AJCSSV_TEXTCODE code)
{
	return AjcSsvSetTxTextCode(m_hSsv, code);
}
//	MeLXg̕R[h擾
AJCSSV_TEXTCODE	CAjxSsvSvr::GetTxTextCode	()
{
	return AjcSsvGetTxTextCode(m_hSsv);
}
//	Cxg҂
BOOL	CAjxSsvSvr::WaitEvent		(UI msTime)
{
	BOOL	rc = FALSE;
	WPARAM	wParam;
	LPARAM	lParam;
	if (rc = AjcSsvWaitEvent(m_hSsv, &wParam, &lParam, msTime)) {
		SubCallVirtualFunc(this, wParam, lParam);
	}
	return rc;
}
//	pPbgt[Fׂ̐R[hݒ
BOOL	CAjxSsvSvr::SetPktCtrlCode	(UI stx, UI etx, UI dle)
{
	return AjcSsvSetPktCtrlCode(m_hSsv, stx, etx, dle);
}
//	pPbgt[Fׂ̐R[h擾
BOOL	CAjxSsvSvr::GetPktCtrlCode	(UIP pStx, UIP pEtx, UIP pDle)
{
	return AjcSsvGetPktCtrlCode(m_hSsv, pStx, pEtx, pDle);
}
//	pPbgt[M^CAEglݒ
BOOL	CAjxSsvSvr::SetPktTimeout	(UI msTime)
{
	return AjcSsvSetPktTimeout(m_hSsv, msTime);
}
//	pPbgt[M^CAEgl擾
BOOL	CAjxSsvSvr::GetPktTimeout	(UIP pMsTime)
{
	return AjcSsvGetPktTimeout(m_hSsv, pMsTime);
}
//	ڑς̃NCAg擾
UI		CAjxSsvSvr::GetClientCount	()
{
	return AjcSsvGetClientCount(m_hSsv);
}
//	ʎZڑ񐔎擾
UI		CAjxSsvSvr::GetConnectCount	()
{
	return AjcSsvGetConnectCount(m_hSsv);
}
//	ڑς̑SNCAg
UI		CAjxSsvSvr::EnumClients		()
{
	UI		rc = 0;
	rc = AjcSsvEnumClients(m_hSsv, (UX)this, cbNtcClients);
	return rc;
}
//	NCAgɃf[^֘At
BOOL	CAjxSsvSvr::SetClientData	(HAJCSSVCLI hCli, UX data)
{
	return AjcSsvSetClientData		(hCli, data);
}
//	NCAgɊ֘Atf[^擾
UX		CAjxSsvSvr::GetClientData	(HAJCSSVCLI hCli)
{
	UX		rc = 0;
	AjcSsvGetClientData(hCli, &rc);
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	z֐iT[oj																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- T[oJnʒm -----------------------------------------------------------------------------------------//
VO		CAjxSsvSvr::OnNtcStart				()
{
}
//----- T[o~ʒm -----------------------------------------------------------------------------------------//
VO		CAjxSsvSvr::OnNtcStop				()
{
}
//----- G[ʒm ---------------------------------------------------------------------------------------------//
VO		CAjxSsvSvr::OnNtcError				(UI err)
{
}
//----- NCAg ---------------------------------------------------------------------------------------//
BOOL	CAjxSsvSvr::OnNtcClients			(HAJCSSVCLI hCli, CAjxSsvCli* pCli)
{
	return FALSE;	//	񋓒~
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	z֐iNCAgj																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//	NCAgڑʒm
CAjxSsvCli*	CAjxSsvSvr::OnNtcConnect	(HAJCSSVCLI hCli)
{
	return NULL;
}
//	NCAgؒfʒm
VO	CAjxSsvSvr::OnNtcDisconnect	(HAJCSSVCLI hCli, CAjxSsvCli* pCli)
{
}
//	eLXg`NMʒm(ASCII)
VO	CAjxSsvSvr::OnNtcRxTextChunk(HAJCSSVCLI hCli, C_BCP pText)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxTextChunk(pText);
	}
}
//	eLXg`NMʒm(UNICODE)
VO	CAjxSsvSvr::OnNtcRxTextChunk(HAJCSSVCLI hCli, C_WCP pText)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxTextChunk(pText);
	}
}
//	oCi`NMʒm
VO	CAjxSsvSvr::OnNtcRxBinChunk	(HAJCSSVCLI hCli, C_VOP pData, UI Bytes)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxBinChunk(pData, Bytes);
	}
}
//	eLXgMʒm(ASCII)
VO	CAjxSsvSvr::OnNtcRxText		(HAJCSSVCLI hCli, C_BCP pText)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxText(pText);
	}
}
//	eLXgMʒm(UNICODE)
VO	CAjxSsvSvr::OnNtcRxText		(HAJCSSVCLI hCli, C_WCP pText)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxText(pText);
	}
}
//	drbV[PXMʒm(ASCII)
VO	CAjxSsvSvr::OnNtcRxEsc		(HAJCSSVCLI hCli, C_BCP pText)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxEsc(pText);
	}
}
//	drbV[PXMʒm(UNICODE)
VO	CAjxSsvSvr::OnNtcRxEsc		(HAJCSSVCLI hCli, C_WCP pText)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxEsc(pText);
	}
}
//	R[hMʒm
VO	CAjxSsvSvr::OnNtcRxCtrl		(HAJCSSVCLI hCli, UI Ctrl)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxCtrl(Ctrl);
	}
}
//	pPbgMʒm
VO	CAjxSsvSvr::OnNtcRxPkt		(HAJCSSVCLI hCli, C_VOP pData, UI Bytes)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxPkt(pData, Bytes);
	}
}
//	Mʒm
VO	CAjxSsvSvr::OnNtcTxEmpty	(HAJCSSVCLI hCli)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcTxEmpty();
	}
}
//	pPbgOf[^Mʒm
VO	CAjxSsvSvr::OnNtcRxNoPkt	(HAJCSSVCLI hCli, C_BCP pText)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxNoPkt(pText);
	}
}
//	pPbgOf[^Mʒm
VO	CAjxSsvSvr::OnNtcRxNoPkt	(HAJCSSVCLI hCli, C_WCP pText)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxNoPkt(pText);
	}
}
//	seLXg`NMʒm
VO	CAjxSsvSvr::OnNtcInvChunk	(HAJCSSVCLI hCli, C_VOP pData, UI lData)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcInvChunk(pData, lData);
	}
}
//	MG[ʒm
VO	CAjxSsvSvr::OnNtcRxError	(HAJCSSVCLI hCli, UI error)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcRxError(error);
	}
}
//	MG[ʒm
VO	CAjxSsvSvr::OnNtcTxError	(HAJCSSVCLI hCli, UI error)
{
	PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(m_hAvl, (UX)hCli, NULL);
	if (pNode != NULL && pNode->pCli != NULL) {
		pNode->pCli->OnNtcTxError(error);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	rruCxgpEChvV[W																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- WM_CREATE ----------------------------------------------------------------------------------------------//
AJC_WNDPROC(SsvEvtWndProc, WM_CREATE 	)
{
	CAjxSsvSvr* pSsvSvr = (CAjxSsvSvr*)(((LPCREATESTRUCT)lParam)->lpCreateParams);

	MAjcSetWindowLong(hwnd, 0, (UX)pSsvSvr);

	return TRUE;
}
//----- WM_DESTROY ---------------------------------------------------------------------------------------------//
AJC_WNDPROC(SsvEvtWndProc, WM_DESTROY	)
{
	CAjxSsvSvr* pSsvSvr = (CAjxSsvSvr*)MAjcGetWindowLong(hwnd, 0);
	return 0;
}
//----- WM_SSVEVENT --------------------------------------------------------------------------------------------//
AJC_WNDPROC(SsvEvtWndProc, WM_SSVEVENT	)
{
	CAjxSsvSvr* pSsvSvr = (CAjxSsvSvr*)MAjcGetWindowLong(hwnd, 0);
	SubCallVirtualFunc(pSsvSvr, wParam, lParam);
	return 0;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(SsvEvtWndProc)
	AJC_WNDMAP_MSG(SsvEvtWndProc, WM_CREATE	)
	AJC_WNDMAP_MSG(SsvEvtWndProc, WM_DESTROY )
	AJC_WNDMAP_MSG(SsvEvtWndProc, WM_SSVEVENT)
AJC_WNDMAP_END

//----- Cxgʒmiz֐R[j--------------------------------------------------------------------------//
static	VO	SubCallVirtualFunc(CAjxSsvSvr* pSsvSvr, WPARAM wParam, LPARAM lParam)
{
	union	{VOP vop; BCP bcp; WCP wcp; UBP ubp; UWP uwp;} u;
	UI		len, param;
	UI		SeqNo;

	AjcSsvGetEventData(pSsvSvr->m_hSsv, lParam, &u.vop, &len, &param);

	//----------------------------------------------------------------------------------------------------------//
	//	T[o Cxg																							//
	//----------------------------------------------------------------------------------------------------------//
	//	T[oJnʒm
	if		((wParam & AJCSSV_EV_START) != 0) {
		pSsvSvr->OnNtcStart();
	}
	//	T[o~ʒm
	else if ((wParam & AJCSSV_EV_STOP) != 0) {
		pSsvSvr->OnNtcStop();
	}
	//	G[ʒm
	else if ((wParam & AJCSSV_EV_ERR) != 0) {
		pSsvSvr->OnNtcError(param);
	}
	else {
		//------------------------------------------------------------------------------------------------------//
		//	NCAg Cxg																				//
		//------------------------------------------------------------------------------------------------------//
		HAJCSSVCLI	hCli = NULL;
		if (SeqNo = AjcSsvGetClient(pSsvSvr->m_hSsv, lParam, &hCli)) {	//	NCAgnh擾
			//	NCAgڑʒm
			if ((wParam & AJCSSV_EV_CONNECT) != 0) {
				//	NCAgڑʒm
				CAjxSsvCli* pCli = pSsvSvr->OnNtcConnect(hCli);
				//	NCAgo^
				AVLNODE	node = {NULL};
				node.pCli = pCli;
				AjcAvlInsNode(pSsvSvr->GetAvl(), (UX)hCli, (C_VOP)&node, sizeof node);
				//	NCAgNX֐ڑʒm
				if (pCli != NULL) {
					pCli->OnNtcConnect();
				}
			}
			//	NCAgؒfʒm
			if	((wParam & AJCSSV_EV_DISCONNECT) != 0) {
				//	NCAgNX|C^擾
				CAjxSsvCli* pCli  = NULL;
				PAVLNODE	pNode = (PAVLNODE)AjcAvlGetNodePtr(pSsvSvr->GetAvl(), (UX)hCli, NULL);
				if (pNode != NULL) {
					pCli = pNode->pCli;
					//	NCAgNX֐ؒfʒm
					if (pCli != NULL) {
						pCli->OnNtcDisconnect();
					}
				}
				//	NCAgؒfʒm
				pSsvSvr->OnNtcDisconnect(hCli, pCli);
				//	`uk瓖YNCAgm[h폜
				AjcAvlDelNode(pSsvSvr->GetAvl(), (UX)hCli);
			}
			//	`Nf[^Mʒm
			else if ((wParam & AJCSSV_EV_RXCHUNK) != 0) {
				if		(param == 0) pSsvSvr->OnNtcRxBinChunk (hCli, u.vop, len);
				else if (param == 1) pSsvSvr->OnNtcRxTextChunk(hCli, u.bcp);
				else				 pSsvSvr->OnNtcRxTextChunk(hCli, u.wcp);
			}
			//	eLXgf[^ʒm
			else if ((wParam & AJCSSV_EV_RXTEXT	) != 0) {
				if (param == 1) pSsvSvr->OnNtcRxText(hCli, u.bcp);
				else			pSsvSvr->OnNtcRxText(hCli, u.wcp);
			}
			//	drbR[hf[^ʒm
			else if ((wParam & AJCSSV_EV_RXESC	) != 0) {
				if (param == 1) pSsvSvr->OnNtcRxEsc(hCli, u.bcp);
				else			pSsvSvr->OnNtcRxEsc(hCli, u.wcp);
			}
			//	pPbgf[^ʒm
			else if ((wParam & AJCSSV_EV_RXPKT	) != 0) {
				pSsvSvr->OnNtcRxBinChunk (hCli, u.vop, len);
			}
			//	R[hʒm
			else if ((wParam & AJCSSV_EV_RXCTRL	) != 0) {
				if (param == 1) pSsvSvr->OnNtcRxCtrl(hCli, (UI)*u.bcp);
				else			pSsvSvr->OnNtcRxCtrl(hCli, (UI)*u.wcp);
			}
			//	pPbgOeLXg
			else if ((wParam & AJCSSV_EV_RXNOPKT) != 0) {
				if (param == 1) pSsvSvr->OnNtcRxNoPkt(hCli, u.bcp);
				else			pSsvSvr->OnNtcRxNoPkt(hCli, u.wcp);
			}
			//	s`NeLXgMʒm
			else if ((wParam & AJCSSV_EV_INVCHUNK) != 0) {
				pSsvSvr->OnNtcInvChunk(hCli, u.vop, len);
			}
			//	Mʒm
			else if ((wParam & AJCSSV_EV_TXEMPTY) != 0) {
				pSsvSvr->OnNtcTxEmpty(hCli);
			}
			//	MG[ʒm
			else if ((wParam & AJCSSV_EV_RXERR	) != 0) {
				pSsvSvr->OnNtcRxError(hCli, param);
			}
			//	MG[ʒm
			else if ((wParam & AJCSSV_EV_TXERR	) != 0) {
				pSsvSvr->OnNtcTxError(hCli, param);
			}
		}
	}

	AjcSsvRelEventData(pSsvSvr->m_hSsv, lParam);
}
