#include	<AjxCpp.h>

using namespace AjxControl;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	`bveLXg	X^eBbN Rg[																	//
//																												//
//--------------------------------------------------------------------------------------------------------------//

//--- AjcTipCtl.h ---//

//----- }`Xbh̋^֎~
BOOL			SAjxTip::EnableMultiThread(BOOL fEnable)
{
	return	AjcTipTextEnableMultiThread	(fEnable);
}

//----- c[`bv\ʒu[h̐ݒ
AJCTIP_POSMODE	SAjxTip::SetTipPosMode (AJCTIP_POSMODE PosMode)
{
	return	AjcTipTextSetTipPosMode		(PosMode);
}

//----- c[`bv̊֘At(ASCII)
BOOL	 		SAjxTip::Add(HWND hCtrl, C_BCP pTxt, int msDelay, int msShow, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextAddExA			(hCtrl, pTxt, msDelay, msShow, hFont, TextColor, BackGround, BorderColor);
}
//----- c[`bv̊֘At(UNICODE)
BOOL	 		SAjxTip::Add(HWND hCtrl, C_WCP pTxt, int msDelay, int msShow, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextAddExW			(hCtrl, pTxt, msDelay, msShow, hFont, TextColor, BackGround, BorderColor);
}

//----- c[`bv\̐ݒ
BOOL	 		SAjxTip::SetShowAlways(HWND hCtrl, BOOL fShowAlways)
{
	return	AjcTipTextSetShowAlways		(hCtrl, fShowAlways);
}
//----- c[`bv\̎擾
BOOL	 		SAjxTip::GetShowAlways(HWND hCtrl)
{
	return	AjcTipTextGetShowAlways		(hCtrl);
}

//----- Sc[`bv\̐ݒ
VO				SAjxTip::SetShowForActive(BOOL fShowForActive)
{
	return	AjcTipTextSetShowForActive	(fShowForActive);
}
//----- Sc[`bv\̎擾
BOOL	 		SAjxTip::GetShowForActive(VO)
{
	return	AjcTipTextGetShowForActive	();
}
//----- `bveLXg̕\^֎~ݒ
BOOL			SAjxTip::Enable			(HWND hCtrl, BOOL fEnable)
{
	return	AjcTipTextEnable(hCtrl, fEnable);
}
//----- `bveLXg̕\^֎~Ԏ擾
BOOL			SAjxTip::GetEnableState	(HWND hCtrl)
{
	return AjcTipTextGetEnableState(hCtrl);
}
//----- SẴ`bveLXg̕\^֎~ݒ
VO				SAjxTip::EnableAll		 (BOOL fEnable)
{
	 AjcTipTextEnableAll(fEnable);
}
//----- SẴ`bveLXg̕\^֎~Ԏ擾
BOOL			SAjxTip::GetEnableAllState(VO)
{
	return AjcTipTextGetEnableAllState();
}
//----- ̃c[`bv̊֘At
BOOL	 		SAjxTip::Remove(HWND hCtrl)
{
	return	AjcTipTextRemove			(hCtrl);
}

//----- SẴc[`bv̊֘At
BOOL	 		SAjxTip::Remove()
{
	return	AjcTipTextRemoveAll			();
}

//----- c[`bv̊֘At擾(ASCII)
UI	 			SAjxTip::GetInfo(HWND hCtrl, PAJCTIPINFO pInfoBuf, BCP pTxtBuf, UI lTxtBuf)
{
	return	AjcTipTextGetInfoA			(hCtrl, pInfoBuf, pTxtBuf, lTxtBuf);
}
//----- c[`bv̊֘At擾(UNICODE)
UI	 			SAjxTip::GetInfo(HWND hCtrl, PAJCTIPINFO pInfoBuf, WCP pTxtBuf, UI lTxtBuf)
{
	return	AjcTipTextGetInfoW			(hCtrl, pInfoBuf, pTxtBuf, lTxtBuf);
}

//----- TuNX̒ʒmݒ
BOOL			SAjxTip::SetNtcSubclass(HWND hCtrl, HWND hNtc, UI msg, UX lParam)
{
	return	AjcTipTextSetNtcSubclass	(hCtrl, hNtc, msg, lParam);
}
//----- TuNX̒ʒm
BOOL			SAjxTip::ClrNtcSubclass(HWND hCtrl)
{
	return	AjcTipTextClrNtcSubclass	(hCtrl);
}

//----- Rg[ԈړP\Ԑݒ
VO	 			SAjxTip::SetWindowTime(int msTime)
{
	return	AjcTipTextSetWindowTime		(msTime);
}
//----- Rg[ԈړP\Ԏ擾
int	 			SAjxTip::GetWindowTime()
{
	return	AjcTipTextGetWindowTime		();
}

//----- ftHg̕\xԂ̐ݒ
VO	 			SAjxTip::SetDefMsDelay(int msDelay)
{
	return	AjcTipTextSetDefMsDelay		(msDelay);
}
//----- ftHg̕\xԂ̎擾
int	 			SAjxTip::GetDefMsDelay(VO)
{
	return	AjcTipTextGetDefMsDelay		();
}


//--- AjcTipTxt.h ---//

//----- c[`bv̕\(ASCII)
BOOL	 	SAjxTip::Show(int x, int y, C_BCP pTxt, int msTime, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextShowExA			(x, y, 0, 0, pTxt, msTime, hFont, TextColor, BackGround, BorderColor);
}
BOOL	 	SAjxTip::Show(int x, int y, int minWidth, int height, C_BCP pTxt, int msTime, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextShowExA			(x, y, minWidth, height, pTxt, msTime, hFont, TextColor, BackGround, BorderColor);
}
//----- c[`bv̕\(UNICODE)
BOOL	 	SAjxTip::Show(int x, int y, C_WCP pTxt, int msTime, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextShowExW			(x, y, 0, 0, pTxt, msTime, hFont, TextColor, BackGround, BorderColor);
}
BOOL	 	SAjxTip::Show(int x, int y, int minWidth, int height, C_WCP pTxt, int msTime, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextShowExW			(x, y, minWidth, height, pTxt, msTime, hFont, TextColor, BackGround, BorderColor);
}

//----- c[`bvEChɕ\(ASCII)
BOOL	 	SAjxTip::ShowCenter(HWND hwnd,							 C_BCP pTxt, int msTime, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextShowCenterExA		(hwnd, 0, 0, pTxt, msTime, hFont, TextColor, BackGround, BorderColor);
}
BOOL	 	SAjxTip::ShowCenter(HWND hwnd, int minWidth, int height, C_BCP pTxt, int msTime, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextShowCenterExA		(hwnd, minWidth, height, pTxt, msTime, hFont, TextColor, BackGround, BorderColor);
}
//----- c[`bvEChɕ\(UNICODE)
BOOL	 	SAjxTip::ShowCenter(HWND hwnd,							 C_WCP pTxt, int msTime, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextShowCenterExW		(hwnd, 0, 0, pTxt, msTime, hFont, TextColor, BackGround, BorderColor);
}

BOOL	 	SAjxTip::ShowCenter(HWND hwnd, int minWidth, int height, C_WCP pTxt, int msTime, HFONT hFont, COLORREF TextColor, COLORREF BackGround, COLORREF BorderColor)
{
	return	AjcTipTextShowCenterExW		(hwnd, minWidth, height, pTxt, msTime, hFont, TextColor, BackGround, BorderColor);
}

//----- c[`bv̕\TCY擾(ASCII)
BOOL	 	SAjxTip::GetSize(int w, int h, C_BCP pTxt, HFONT hFont, BOOL fBorder, LPSIZE pBuf)
{
	return	AjcTipTextGetSizeA			(w, h, pTxt, hFont, fBorder, pBuf);
}
//----- c[`bv̕\TCY擾(UNICODE)
BOOL	 	SAjxTip::GetSize(int w, int h, C_WCP pTxt, HFONT hFont, BOOL fBorder, LPSIZE pBuf)
{
	return	AjcTipTextGetSizeW			(w, h, pTxt, hFont, fBorder, pBuf);
}

//----- c[`bvEChړ
VO	 		SAjxTip::Move(int x, int y)
{
	return	AjcTipTextMove				(x, y);
}

//----- }EXJ[\c[`bvEChֈړ
VO	 		SAjxTip::MoveCursor()
{
	return	AjcTipTextMoveCursor(AJCTIP_CM_CENT);
}
VO	 		SAjxTip::MoveCursor(AJCTIP_CURMOVE cm)
{
	return	AjcTipTextMoveCursor		(cm);
}

//----- c[`bv\
VO	 		SAjxTip::Hide()
{
	return	AjcTipTextHide				();
}

//----- c[`bvECh̋`擾
BOOL	 	SAjxTip::GetRect(LPRECT pRect)
{
	return	AjcTipTextGetRect			(pRect);
}

//----- pbgF̐ݒ
BOOL	 	SAjxTip::SetPalette(int ix, COLORREF color)
{
	return	AjcTipTextSetPalette		(ix, color);
}
//----- pbgF̎擾
COLORREF	SAjxTip::GetPalette(int ix)
{
	return	AjcTipTextGetPalette		(ix);
}

//----- ftHg̃eLXg\Fݒ
VO	 		SAjxTip::SetDefTextColor  (COLORREF color)
{
	return	AjcTipTextSetDefTextColor	(color);
}
//----- ftHg̃eLXg\F擾
COLORREF	SAjxTip::GetDefTextColor  ()
{
	return	AjcTipTextGetDefTextColor	();
}

//----- ftHg̊Og\Fݒ
VO	 		SAjxTip::SetDefBorderColor(COLORREF color)
{
	return	AjcTipTextSetDefBorderColor	(color);
}
//----- ftHg̊Og\F擾
COLORREF	SAjxTip::GetDefBorderColor()
{
	return	AjcTipTextGetDefBorderColor	();
}

//----- ftHg̔wi\Fݒ
VO	 		SAjxTip::SetDefBkColor	  (COLORREF color)
{
	return	AjcTipTextSetDefBkColor		(color);
}
//----- ftHg̔wi\F擾
COLORREF	SAjxTip::GetDefBkColor	  ()
{
	return	AjcTipTextGetDefBkColor		();
}

//----- ftHgtHg̐ݒ
VO	 		SAjxTip::SetDefFont		  (HFONT hFont)
{
	return	AjcTipTextSetDefFont	(hFont);
}
//----- ftHgtHg̎擾
HFONT	 	SAjxTip::GetDefFont		  ()
{
	return	AjcTipTextGetDefFont		();
}

//----- ftHg̕\Ԃ̐ݒ
VO	 		SAjxTip::SetDefMsShow	  (int msShow)
{
	return	AjcTipTextSetDefMsShow	(msShow);
}
//----- ftHg̕\Ԃ̎擾
int	 		SAjxTip::GetDefMsShow	  ()
{
	return	AjcTipTextGetDefMsShow	();
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	󋵈ˑ`bveLXg	Rg[ 																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//

//--------------------------------------------------------------------------------------------------------------//
//	R[obNiJ[\ʒu`FbNj																		//
//--------------------------------------------------------------------------------------------------------------//
static	int CALLBACK cbChkCursor(HWND hCtrl, LPPOINT ptClient, UX cbp)
{
	CAjxTip*	p = (CAjxTip*)cbp;
	return p->OnChkCursor(hCtrl, ptClient);
}
//--------------------------------------------------------------------------------------------------------------//
//	R[obNi`bveLXg擾vj																		//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	C_BCP CALLBACK cbGetTextA(HWND hCtrl, BCP pBuf, UI lBuf, UX cbp)
{
	CAjxTip*	p = (CAjxTip*)cbp;
	p->OnNeedText(hCtrl, pBuf, lBuf);
	return pBuf;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	C_WCP CALLBACK cbGetTextW(HWND hCtrl, WCP pBuf, UI lBuf, UX cbp)
{
	CAjxTip*	p = (CAjxTip*)cbp;
	p->OnNeedText(hCtrl, pBuf, lBuf);
	return pBuf;
}


//	RXgN^
CAjxTip::CAjxTip(BOOL fUnicode)
{
	m_fUnicode = fUnicode;
}
//	fXgN^
CAjxTip::~CAjxTip()
{
}
//	A^b`iRg[nh[j
VO		CAjxTip::Attach(HWND hCtrl)
{
	m_hCtrl = hCtrl;
	if (m_fUnicode) {	//	UNICODE
		AjcTipTextAddW		  (hCtrl, L"");
		AjcTipTextSetCallBackW(hCtrl, (UX)this, cbChkCursor, cbGetTextW);
	}
	else {				//	ASCII
		AjcTipTextAddA		  (hCtrl, "");
		AjcTipTextSetCallBackA(hCtrl, (UX)this, cbChkCursor, cbGetTextA);
	}
}
//	J[\ʒu`FbN
BOOL	CAjxTip::OnChkCursor(HWND hCtrl, LPPOINT ptClient)
{
	return TRUE;
}
//	c[`bveLXg擾v(ASCII)
VO		CAjxTip::OnNeedText (HWND hCtrl, BCP pBuf, UI lBuf)
{
	*pBuf = 0;
}
//	c[`bveLXg擾v(UNICODE)
VO		CAjxTip::OnNeedText (HWND hCtrl, WCP pBuf, UI lBuf)
{
	*pBuf = 0;
}

