#include	<AjxCpp.h>

#define	PROP_NAME_PARENT	"_AjcVthSubClassed_"
#define	PROP_NAME_CTRL		"_AjcVthWndProp_"

using namespace AjxControl;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	eECh̃TuNXEvV[W																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDPROC(SBC_VTH, WM_COMMAND			)
{
	CAjxVth*	p = (CAjxVth*)::GetPropA((HWND)lParam, PROP_NAME_CTRL);

	if (p != NULL) {
		HWND	hCtrl = (HWND)lParam;
		switch (HIWORD(wParam)) {
			case AJCVTHN_DBLCLK:		p->OnNtcDblClk	(AjcVthGetNtcDblClk (hCtrl) 						  ); break;	//	_uNbNʒm
			case AJCVTHN_KEYIN:			p->OnNtcKeyIn	(AjcVthGetNtcKey	(hCtrl), AjcVthGetNtcKeyRep(hCtrl)); break;	//	L[͒ʒm
			case AJCVTHN_VKEYIN: 		p->OnNtcVKeyIn	(AjcVthGetNtcKey	(hCtrl), AjcVthGetNtcKeyRep(hCtrl)); break;	//	gL[ʒm
			case AJCVTHN_VKEYOUT:		p->OnNtcVKeyOut	(AjcVthGetNtcKey	(hCtrl) 						  ); break;	//	gL[ʒm
			case AJCVTHN_DROPFILE:		p->OnNtcDropFile(AjcVthGetNtcFiles	(hCtrl) 						  ); break;	//	t@Chbvʒm
			case AJCVTHN_DROPDIR:		p->OnNtcDropDir	(AjcVthGetNtcDirs	(hCtrl) 						  ); break;	//	tH_hbvʒm
			case AJCVTHN_CHARINFO:		p->OnNtcCharInfo(AjcVthGetNtcCyLine (hCtrl) 						  ); break;	//	ωʒm
			case AJCVTHN_HSCROLL:		p->OnNtcHScroll	(AjcVthGetNtcLeft	(hCtrl) 						  ); break;	//	XN[ʒm
			case AJCVTHN_VSCROLL:		p->OnNtcVScroll	(AjcVthGetNtcTop	(hCtrl) 						  ); break;	//	cXN[ʒm
			case AJCVTHN_RCLICK:		p->OnNtcRClick	(AjcVthGetNtcRClk	(hCtrl) 						  ); break;	//	ENbNʒm
			case AJCVTHN_CLEAR:			p->OnNtcClear	(													  ); break;	//	ʃNA[ʒm
		}
	}
	return MAjcMmpCallOrgWndProc(SBC_VTH);
}
//----- WM_DESTROY ---------------------------------------------------------------------------------------------//
AJC_WNDPROC(SBC_VTH, WM_DESTROY			)
{
	//	eECh̃vpeB
	if (::GetPropA(hwnd, PROP_NAME_PARENT) != NULL) {
		::RemovePropA(hwnd, PROP_NAME_PARENT);
	}
	return MAjcMmpCallOrgWndProc(SBC_VTH);
}
//--------------------------------------------------------------------------------------------------------------//
AJC_WNDMAP_DEF(SBC_VTH)
	AJC_WNDMAP_MSG(SBC_VTH, WM_COMMAND	   )
	AJC_WNDMAP_MSG(SBC_VTH, WM_DESTROY	   )
AJC_WNDMAP_END

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxVth::CAjxVth(BOOL fUnicode)
{
	m_fUnicode = fUnicode;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxVth::~CAjxVth()
{
	//	Rg[ECh̃vpeB폜
	if (::GetPropA(m_hCtrl, PROP_NAME_CTRL) != NULL) ::RemovePropA(m_hCtrl, PROP_NAME_CTRL);
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	o֐																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- vpeBݒ -----------------------------------------------------------------------------------------//
BOOL		CAjxVth::SetProp 			(PCAJCVTHPROP pProp)
{
	return AjcVthSetProp		(m_hCtrl, pProp);
}
//----- vpeB擾 -----------------------------------------------------------------------------------------//
BOOL		CAjxVth::GetProp 			(PAJCVTHPROP  pBuf )
{
	return AjcVthGetProp		(m_hCtrl, pBuf);
}
//----- uq`lɃtBbgEChTCY擾 ---------------------------------------------------------------//
BOOL		CAjxVth::GetVramFitSize		(UIP pWidth, UIP pHeight)
{
	return AjcVthGetVramFitSize	(m_hCtrl, pWidth, pHeight);
}

//----- P`(ASCII) --------------------------------------------------------------------------------------//
BOOL		CAjxVth::PutChar			(BC c)
{
	return AjcVthPutCharA		(m_hCtrl, c);
}
//----- P`(UNICODE) ------------------------------------------------------------------------------------//
BOOL		CAjxVth::PutChar			(WC c)
{
	return AjcVthPutCharW		(m_hCtrl, c);
}

//----- }`oCgR[hʂăeLXg`(ASCII) ------------------------------------------------//
BOOL		CAjxVth::PutTextAuto		(C_BCP pTxt, UI lTxt)
{
	return AjcVthPutTextAuto	(m_hCtrl, pTxt, lTxt);
}
//----- {dtbR[heLXg`					(ASCII) ------------------------------------------------//
BOOL		CAjxVth::PutTextEUC			(C_BCP pTxt, UI lTxt)
{
	return AjcVthPutTextEUC		(m_hCtrl, pTxt, lTxt);
}
//----- tse|WR[heLXg`					(ASCII) ------------------------------------------------//
BOOL		CAjxVth::PutTextUTF8		(C_BCP pTxt, UI lTxt)
{
	return AjcVthPutTextUTF8	(m_hCtrl, pTxt, lTxt);
}

//----- eLXg`(ASCII) ------------------------------------------------------------------------------------//
BOOL		CAjxVth::PutText			(C_BCP pTxt, UI lTxt)
{
	return AjcVthPutTextA		(m_hCtrl, pTxt, lTxt);
}
//----- eLXg`(UNICODE) ----------------------------------------------------------------------------------//
BOOL		CAjxVth::PutText			(C_WCP pTxt, UI lTxt)
{
	return AjcVthPutTextW		(m_hCtrl, pTxt, lTxt);
}

//----- eLXg`(ASCII) --------------------------------------------------------------------------------//
BOOL		CAjxVth::PrintF 			(C_BCP pFmt, ...)
{
	va_list 	 vls;
	BC			 txt[1024] = {0};

	va_start(vls, pFmt);
	AjcVSnPrintFA(txt, 1024, pFmt, vls);
	txt[1023] = 0;
	va_end	(vls);

	return AjcVthPutTextA		(m_hCtrl, txt, -1);
}
//----- eLXg`(UNICODE) ------------------------------------------------------------------------------//
BOOL		CAjxVth::PrintF 			(C_WCP pFmt, ...)
{
	va_list 	 vls;
	WC			 txt[1024] = {0};

	va_start(vls, pFmt);
	AjcVSnPrintFW(txt, 1024, pFmt, vls);
	txt[1023] = 0;
	va_end	(vls);

	return AjcVthPutTextW		(m_hCtrl, txt, -1);
}

//----- ^CX^v` -------------------------------------------------------------------------------------//
BOOL		CAjxVth::TimeStamp			()
{
	return AjcVthTimeStamp		(m_hCtrl);
}
//----- oCif[^̂PUi_v` -----------------------------------------------------------------------//
BOOL		CAjxVth::HexDump 			(C_VOP pDat, UI lDat)
{
	return AjcVthHexDump		(m_hCtrl, pDat, lDat);
}

//----- J[\ʒuݒ ---------------------------------------------------------------------------------------//
BOOL		CAjxVth::Locate				(UI line, UI col)
{
	return AjcVthLocate			(m_hCtrl, line, col);
}
//----- eLXg`ppbgݒ -----------------------------------------------------------------------------//
BOOL		CAjxVth::SetColor			(UI PaletteNo)
{
	return AjcVthSetColor		(m_hCtrl, PaletteNo);
}
//----- wi`ppbgݒ -----------------------------------------------------------------------------//
BOOL		CAjxVth::SetBkColor			(UI PaletteNo)
{
	return AjcVthSetBkColor		(m_hCtrl, PaletteNo);
}
//----- pbg̐FR[hݒ ---------------------------------------------------------------------------------//
BOOL		CAjxVth::SetPalette			(UI PaletteNo, COLORREF rgb)
{
	return AjcVthSetPalette		(m_hCtrl, PaletteNo, rgb);
}

//----- J[\ʒu擾 ---------------------------------------------------------------------------------------//
UI			CAjxVth::GetCursorPos		(UIP pLine, UIP pCol)
{
	return AjcVthGetCursorPos	(m_hCtrl, pLine, pCol);
}
//----- eLXg`ppbgԍ擾 -------------------------------------------------------------------------//
UI			CAjxVth::GetColor			()
{
	return AjcVthGetColor		(m_hCtrl);
}
//----- wi`ppbgԍ擾 -------------------------------------------------------------------------//
UI			CAjxVth::GetBkColor			()
{
	return AjcVthGetBkColor		(m_hCtrl);
}
//----- pbg̐FR[h擾 ---------------------------------------------------------------------------------//
COLORREF	CAjxVth::GetPalette			(UI PaletteNo)
{
	return AjcVthGetPalette		(m_hCtrl, PaletteNo);
}

//----- eLXgI -------------------------------------------------------------------------------------//
BOOL		CAjxVth::Select				(UI slp, UI scp, UI elp, UI ecp)
{
	return AjcVthSelect			(m_hCtrl, slp, scp, elp, ecp);
}
//----- SẴeLXgI -----------------------------------------------------------------------------------//
BOOL		CAjxVth::SelectAll			()
{
	return AjcVthSelectAll		(m_hCtrl);
}
//----- IeLXgNbv{[hփRs[ -------------------------------------------------------------------//
BOOL		CAjxVth::CopyText			()
{
	return AjcVthCopyText		(m_hCtrl);
}
//----- _CAOɂtHg̐ݒ -------------------------------------------------------------------------//
BOOL		CAjxVth::SetFont 			()
{
	return AjcVthSetFont		(m_hCtrl);
}
//----- Lbg\^\ ---------------------------------------------------------------------------------//
BOOL		CAjxVth::ShowCaret			(BOOL fShow)
{
	return AjcVthShowCaret		(m_hCtrl, fShow);
}
//----- SeLXgNA[ -------------------------------------------------------------------------------------//
BOOL		CAjxVth::Clear				()
{
	return AjcVthClear			(m_hCtrl);
}
//----- SeLXgNA[ -------------------------------------------------------------------------------------//
BOOL		CAjxVth::ClearAllText		()
{
	return AjcVthClearAllText	(m_hCtrl);
}

//----- hbvꂽt@C擾(ASCII) --------------------------------------------------------------------//
BOOL		CAjxVth::GetDroppedFile		(BC buf[MAX_PATH])
{
	return AjcVthGetDroppedFileA(m_hCtrl, buf);
}
//----- hbvꂽt@C擾(UNICODE) ------------------------------------------------------------------//
BOOL 		CAjxVth::GetDroppedFile		(WC buf[MAX_PATH])
{
	return AjcVthGetDroppedFileW(m_hCtrl, buf);
}

//----- hbvꂽfBNg擾(ASCII) ----------------------------------------------------------------//
BOOL		CAjxVth::GetDroppedDir		(BC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	return AjcVthGetDroppedDirExA	(m_hCtrl, buf, fTailIsDelimiter);
}
//----- hbvꂽfBNg擾(UNICODE) --------------------------------------------------------------//
BOOL		CAjxVth::GetDroppedDir		(WC buf[MAX_PATH], BOOL fTailIsDelimiter)
{
	return AjcVthGetDroppedDirExW	(m_hCtrl, buf, fTailIsDelimiter);
}

//----- vt@CvpeBlǏo(ASCII) --------------------------------------------------------------//
BOOL		CAjxVth::LoadProp			(C_BCP pProfileSect, PCAJCVTHPROPA pDefProp)
{
	return AjcVthLoadPropA		(m_hCtrl, pProfileSect, pDefProp);
}
//----- vt@CvpeBlǏo(UNICODE) ------------------------------------------------------------//
BOOL		CAjxVth::LoadProp			(C_WCP pProfileSect, PCAJCVTHPROPW pDefProp)
{
	return AjcVthLoadPropW		(m_hCtrl, pProfileSect, pDefProp);
}
//----- vt@CփvpeB(ASCII) ----------------------------------------------------------------//
BOOL		CAjxVth::SaveProp			(C_BCP pProfileSect)
{
	return AjcVthSavePropA		(m_hCtrl, pProfileSect);
}
//----- vt@CփvpeB(UNICODE) --------------------------------------------------------------//
BOOL		CAjxVth::SaveProp			(C_WCP pProfileSect)
{
	return AjcVthSavePropW		(m_hCtrl, pProfileSect);
}

//----- ݒ̓ǂݏo(ASCII) ------------------------------------------------------------------------------//
BOOL		CAjxVth::LoadPermInfo		(C_BCP pProfileSect, C_BCP pKeyPrefix, UI PermItem)
{
	return AjcVthLoadPermInfoExA(m_hCtrl, pProfileSect, pKeyPrefix, PermItem);
}
//----- ݒ̓ǂݏo(UNICODE) ----------------------------------------------------------------------------//
BOOL		CAjxVth::LoadPermInfo		(C_WCP pProfileSect, C_WCP pKeyPrefix, UI PermItem)
{
	return AjcVthLoadPermInfoExW(m_hCtrl, pProfileSect, pKeyPrefix, PermItem);
}

//----- ݒ̏ -------------------------------------------------------------------------------------//
BOOL		CAjxVth::SavePermInfo		()
{
	return AjcVthSavePermInfo	(m_hCtrl);
}

//----- ENbNɂ|bvAbvj[̋^֎~ -------------------------------------------------------//
BOOL		CAjxVth::EnablePopupMenu	(BOOL fEnable)
{
	return AjcVthEnablePopupMenu(m_hCtrl, fEnable);
}
//----- ENbNʒmݒ -------------------------------------------------------------------------------------//
BOOL		CAjxVth::SetNtcRClk	   		(BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp)
{
	return AjcVthSetNtcRClk		(m_hCtrl, fNtcRClk, MsgRBDown, MsgRBUp);
}

//----- eLXg̎擾(ASCII) ----------------------------------------------------------------------------------//
UI			CAjxVth::GetText			(BCP pBuf, UI lBuf)	
{
	return AjcVthGetTextA		(m_hCtrl, pBuf, lBuf);
}
//----- eLXg̎擾(UNICODE) --------------------------------------------------------------------------------//
UI			CAjxVth::GetText			(WCP pBuf, UI lBuf)
{
	return AjcVthGetTextW		(m_hCtrl, pBuf, lBuf);
}

//----- IĂeLXg̎擾(ASCII) --------------------------------------------------------------------//
UI			CAjxVth::GetSelectedText	(BCP pBuf, UI lBuf)
{
	return AjcVthGetSelectedTextA(m_hCtrl, pBuf, lBuf);
}
//----- IĂeLXg̎擾(UNICODE) ------------------------------------------------------------------//
UI			CAjxVth::GetSelectedText	(WCP pBuf, UI lBuf)
{
	return AjcVthGetSelectedTextW(m_hCtrl, pBuf, lBuf);
}

//----- _uNbNsʒũeLXg擾(ASCII) ----------------------------------------------------------//
UI			CAjxVth::GetDblClickedLine	(BCP pBuf, UI lBuf)
{
	return AjcVthGetDblClickedLineA(m_hCtrl, pBuf, lBuf);
}
//----- _uNbNsʒũeLXg擾(UNICODE) --------------------------------------------------------//
UI			CAjxVth::GetDblClickedLine	(WCP pBuf, UI lBuf)
{
	return AjcVthGetDblClickedLineW(m_hCtrl, pBuf, lBuf);
}

//----- _uNbNsʒũeLXg擾(ASCII) ----------------------------------------------------------//
UI			CAjxVth::GetDblClickedLine	(BCP pBuf, UI lBuf, UIP pLine, UIP pCol)
{
	return AjcVthGetDblClickedLineExA(m_hCtrl, pBuf, lBuf, pLine, pCol);
}
//----- _uNbNsʒũeLXg擾(UNICODE) --------------------------------------------------------//
UI			CAjxVth::GetDblClickedLine	(WCP pBuf, UI lBuf, UIP pLine, UIP pCol)
{
	return AjcVthGetDblClickedLineExW(m_hCtrl, pBuf, lBuf, pLine, pCol);
}

//----- c[`bv̐ݒ(ASCII) ------------------------------------------------------------------------------//
BOOL		CAjxVth::SetTipText			(C_BCP pTxt)
{
	return AjcVthSetTipTextA	(m_hCtrl, pTxt);
}
//----- c[`bv̐ݒ(UNICODE) ----------------------------------------------------------------------------//
BOOL		CAjxVth::SetTipText			(C_WCP pTxt)
{
	return AjcVthSetTipTextW	(m_hCtrl, pTxt);
}

//----- c[`bv̎擾(ASCII) ------------------------------------------------------------------------------//
BOOL		CAjxVth::GetTipText			(BCP pBuf, UI lBuf)
{
	return AjcVthGetTipTextA	(m_hCtrl, pBuf, lBuf);
}
//----- c[`bv̎擾(UNICODE) ----------------------------------------------------------------------------//
BOOL		CAjxVth::GetTipText			(WCP pBuf, UI lBuf)
{
	return AjcVthGetTipTextW	(m_hCtrl, pBuf, lBuf);
}

//----- c[`bv\̐ݒ -----------------------------------------------------------------------------//
BOOL		CAjxVth::SetTipShowAlways	(BOOL fShowAlways)
{
	return AjcVthSetTipShowAlways(m_hCtrl, fShowAlways);
}
//----- c[`bv\̎擾 -----------------------------------------------------------------------------//
BOOL		CAjxVth::GetTipShowAlways	()
{
	return AjcVthGetTipShowAlways(m_hCtrl);
}
//----- tHg̐ݒ(ASCII) ------------------------------------------------------------------------------//
BOOL		CAjxVth::SetFontInfo			(const LOGFONTA *pLogFont)
{
	return AjcVthSetFontInfoA(m_hCtrl, pLogFont, -1);
}
//----- tHg̐ݒ(ASCIICsԃXy[X) ----------------------------------------------------------------//
BOOL		CAjxVth::SetFontInfo			(const LOGFONTA *pLogFont, UI LSpace)
{
	return AjcVthSetFontInfoA(m_hCtrl, pLogFont, LSpace);
}

//----- tHg̐ݒ(UNICODE) ----------------------------------------------------------------------------//
BOOL		CAjxVth::SetFontInfo			(const LOGFONTW *pLogFont)
{
	return AjcVthSetFontInfoW(m_hCtrl, pLogFont, -1);
}
//----- tHg̐ݒ(UNICODECsԃXy[X) --------------------------------------------------------------//
BOOL		CAjxVth::SetFontInfo			(const LOGFONTW *pLogFont, UI LSpace)
{
	return AjcVthSetFontInfoW(m_hCtrl, pLogFont, LSpace);
}

//----- tHg̎擾(ASCII) ------------------------------------------------------------------------------//
UI			CAjxVth::GetFontInfo			(LPLOGFONTA *pBuf)
{
	UI		rc = 0;
	UI		lsp;
	if (lsp = AjcVthGetFontInfoA(m_hCtrl, pBuf, &lsp)) {
		rc = lsp;
	}
	return rc;
}
//----- tHg̎擾(UNICODE) ----------------------------------------------------------------------------//
UI			CAjxVth::GetFontInfo			(LPLOGFONTW *pBuf)
{
	UI		rc = 0;
	UI		lsp;
	if (lsp = AjcVthGetFontInfoW(m_hCtrl, pBuf, &lsp)) {
		rc = lsp;
	}
	return rc;
}

//----- TCY^s̍擾 -------------------------------------------------------------------------------//
BOOL		CAjxVth::GetCharInfo 		(UIP pCx, UIP pCy, UIP pLy)
{
	return AjcVthGetCharInfo	(m_hCtrl, pCx, pCy, pLy);
}
//----- EChɕ\\ȍs̎擾 -------------------------------------------------------------------------//
UI			CAjxVth::GetLinesPerWindow	()
{
	return AjcVthGetLinesPerWindow(m_hCtrl);
}
//----- obt@Ɋi[ĂLȍs̎擾 ---------------------------------------------------------------//
UI			CAjxVth::GetValidLines		()
{
	return AjcVthGetValidLines	(m_hCtrl);
}
//----- ECh擪s̈ʒu擾iO`j -----------------------------------------------------------------------//
UI			CAjxVth::GetIxOfWndTopLine	()
{
	return AjcVthGetIxOfWndTopLine(m_hCtrl);
}

//----- ^Cg̐ݒ(ASCII) ----------------------------------------------------------------------------//
BOOL		CAjxVth::SetTitleText		(C_BCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont)
{
	return AjcVthSetTitleTextA	(m_hCtrl, pTitleText, TextColor, BackColor, hFont);
}
//----- ^Cg̐ݒ(UNICODE) --------------------------------------------------------------------------//
BOOL		CAjxVth::SetTitleText		(C_WCP pTitleText, COLORREF TextColor, COLORREF BackColor, HFONT hFont)
{
	return AjcVthSetTitleTextW	(m_hCtrl, pTitleText, TextColor, BackColor, hFont);
}

//----- eLXgt@C֏(ASCII) --------------------------------------------------------------------//
BOOL		CAjxVth::SaveTextToFile		(C_BCP pPath, BOOL fAllText, EAJCTEC tec, BOOL fBom)
{
	return AjcVthSaveTextToFileA(m_hCtrl, pPath, fAllText, tec, fBom);
}
//----- eLXgt@C֏(UNICODE) ------------------------------------------------------------------//
BOOL		CAjxVth::SaveTextToFile		(C_WCP pPath, BOOL fAllText, EAJCTEC tec, BOOL fBom)
{
	return AjcVthSaveTextToFileW(m_hCtrl, pPath, fAllText, tec, fBom);
}

//----- eLXggslkt@C֏(ASCII) ------------------------------------------------------------//
BOOL		CAjxVth::SaveHtmlToFile		(C_BCP pPath, BOOL fAllText, UI FontSize)
{
	return AjcVthSaveHtmlToFileA(m_hCtrl, pPath, fAllText, FontSize);
}
//----- eLXggslkt@C֏(UNICODE) ----------------------------------------------------------//
BOOL		CAjxVth::SaveHtmlToFile		(C_WCP pPath, BOOL fAllText, UI FontSize)
{
	return AjcVthSaveHtmlToFileW(m_hCtrl, pPath, fAllText, FontSize);
}

//----- drbV[PXtSeLXgt@C֏(ASCII) --------------------------------------------//
BOOL		CAjxVth::SaveAllTextWithEsc	(C_BCP pPath, EAJCTEC tec, BOOL fBom)
{
	return AjcVthSaveAllTextWithEscA	(m_hCtrl, pPath, tec, fBom);
}
//----- drbV[PXtSeLXgt@C֏(UNICODE) ------------------------------------------//
BOOL		CAjxVth::SaveAllTextWithEsc	(C_WCP pPath, EAJCTEC tec, BOOL fBom)
{
	return AjcVthSaveAllTextWithEscW	(m_hCtrl, pPath, tec, fBom);
}

//----- obt@Ɋi[Ăs̎擾 ---------------------------------------------------------------------//
UI			CAjxVth::GetLineCount		()
{
	return AjcVthGetLineCount	(m_hCtrl);
}

//----- J[\ʒu̍sԍƌʒu擾(ASCII) ----------------------------------------------------------------//
BOOL		CAjxVth::GetCursorPosInfo	(UIP pLine, UIP pCol)
{
	BOOL	rc = FALSE;
	rc = AjcVthGetCursorPosInfo(m_hCtrl, pLine, pCol);
	return rc;
}
//----- wsʒu̍seLXg擾(ASCII) ----------------------------------------------------------------------//
UI			CAjxVth::GetLineText		(UI pos, BCP pBuf, UI lBuf)
{
	return AjcVthGetLineTextA	(m_hCtrl, pos, pBuf, lBuf);
}
//----- wsʒu̍seLXg擾(UNICODE) --------------------------------------------------------------------//
UI			CAjxVth::GetLineText		(UI pos, WCP pBuf, UI lBuf)
{
	return AjcVthGetLineTextW	(m_hCtrl, pos, pBuf, lBuf);
}

//----- cXN[ʒu̎擾 ---------------------------------------------------------------------------------//
UI			CAjxVth::GetVScrollPos		()
{
	return AjcVthGetVScrollPos	(m_hCtrl);
}
//----- XN[ʒu̎擾 ---------------------------------------------------------------------------------//
UI			CAjxVth::GetHScrollPos		()
{
	return AjcVthGetHScrollPos	(m_hCtrl);
}

//----- cXN[ʒu̐ݒ ---------------------------------------------------------------------------------//
BOOL		CAjxVth::SetVScrollPos		(UI pos)
{
	return AjcVthSetVScrollPos	(m_hCtrl, pos);
}
//----- XN[ʒu̐ݒ ---------------------------------------------------------------------------------//
BOOL		CAjxVth::SetHScrollPos		(UI pos)
{
	return AjcVthSetHScrollPos	(m_hCtrl, pos);
}

//----- \EChTCYisCj擾 -----------------------------------------------------------------//
BOOL		CAjxVth::GetWindowSize		(LPSIZE pSize)
{
	return AjcVthGetWindowSize	(m_hCtrl, pSize);
}

//----- ̌(ASCII) --------------------------------------------------------------------------------//
UI			CAjxVth::SearchBelow		(C_BCP pStr, BC delimiter)
{
	return AjcVthSearchBelowA	(m_hCtrl, pStr, delimiter);
}
//----- ̌(UNICODE) ------------------------------------------------------------------------------//
UI			CAjxVth::SearchBelow		(C_WCP pStr, WC delimiter)
{
	return AjcVthSearchBelowW	(m_hCtrl, pStr, delimiter);
}

//----- ̑O(ASCII) --------------------------------------------------------------------------------//
UI			CAjxVth::SearchAbove		(C_BCP pStr, BC delimiter)
{
	return AjcVthSearchAboveA	(m_hCtrl, pStr, delimiter);
}
//----- ̑O(UNICODE) ------------------------------------------------------------------------------//
UI			CAjxVth::SearchAbove		(C_WCP pStr, WC delimiter)
{
	return AjcVthSearchAboveW	(m_hCtrl, pStr, delimiter);
}

//----- ʕ\̒~^ĊJ -----------------------------------------------------------------------------------//
BOOL		CAjxVth::Pause				(BOOL fPause)
{
	return AjcVthPause			(m_hCtrl, fPause);
}

//----- s̐ݒ|bvAbvj[Ɋ܂߂邩ۂ̐ݒ -----------------------------------------------//
BOOL		CAjxVth::SetLFActInPopupMenu(BOOL flag)
{
	return AjcVthSetLFActInPopupMenu(m_hCtrl, flag);
}
//----- s̐ݒ|bvAbvj[Ɋ܂߂邩ۂ̎擾 -----------------------------------------------//
BOOL		CAjxVth::GetLFActInPopupMenu()
{
	return AjcVthGetLFActInPopupMenu(m_hCtrl);
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	z֐																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- A^b`@----------------------------------------------------------------------------------------------//
VO		CAjxVth::Attach		(HWND hWnd)					//	nh֘At
{
	HWND	hParent;
	BC		cname[256];

	m_hCtrl   = NULL;

	if (::IsWindow(hWnd)) {
		::GetClassNameA(hWnd, cname, sizeof cname);
		if (::strcmp(cname, "AjcCtrlVT100") == 0) {
			//	[N
			m_hCtrl = hWnd;
			hParent = ::GetParent(hWnd);
			//	Rg[ this |C^֘At
			::SetPropA(m_hCtrl, PROP_NAME_CTRL, (HANDLE)this);
			//	eEChTuNXidTuNX}~j
			if (::GetPropA(hParent, PROP_NAME_PARENT) == NULL) {
				MAjcMmpSetSubclass(SBC_VTH, hParent);
				::SetPropA(hParent, PROP_NAME_PARENT, (HANDLE)this);
			}
		}
		else throw std::runtime_error("VTH cannot be generated due to an invalid window class.");
	}
	else throw std::runtime_error("VTH cannot be generated due to an invalid window handle.");
}
//----- _uNbNʒm -------------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcDblClk	(UI flag)
{
}
//----- L[͒ʒm -------------------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcKeyIn		(UI key, UI rep)
{
}
//----- gL[ʒm ---------------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcVKeyIn	(UI key, UI rep)
{
}
//----- gL[ʒm ---------------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcVKeyOut	(UI key)
{
}
//----- t@Chbvʒm -----------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcDropFile	(UI 			nFiles )
{
}
//----- fBNghbvʒm -------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcDropDir	(UI 			nDirs  )
{
}
//----- TCY̕ωʒm -------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcCharInfo	(UI				heught )
{
}
//----- XN[ʒm ---------------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcHScroll	(UI				left   )
{
}
//----- cXN[ʒm ---------------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcVScroll	(UI				top    )
{
}
//----- ENbNʒm -----------------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcRClick	(PCAJCVTHRCLK	pRClk  )
{
}
//----- ʃNA[ʒm ---------------------------------------------------------------------------------------//
VO	CAjxVth::OnNtcClear				()
{
}
