//
//	SW_AvsTreeC.c
//
#include	<AjrCstXX.h>
#include	<stdio.h>
#include	<conio.h>
#include	<time.h>
#include	<tchar.h>

//----- [N -------------------------------------------------------------------------------------------------//
static	HAJCAVS 	hAvs = NULL;

//----- m[hf[^` ---------------------------------------------------------------------------------------//
typedef struct {
	UTP 	pTimStr;			//	q[v̎ւ̃|C^
} NODEDATA, *PNODEDATA;

//----- m[h폜̃R[obN֐ -------------------------------------------------------------------------//
static	VO	 CALLBACK cbRemove(C_UTP pKey, VOP pData, UI len, UI nest, UX cbp)
{
	AjcPrintF(TEXT("Deleted   - key='%s', len=%d, nest=%d, data='%s'\n"), pKey, len, nest, ((PNODEDATA)pData)->pTimStr);
	AjcTFree(((PNODEDATA)pData)->pTimStr);
}
//----- Sm[h擾iSm[hvgjpR[obN֐ -----------------------------------------------------//
static BOOL CALLBACK cbPrintNode(C_UTP pKey, VOP pData, UI len, UI nest, UX cbp)
{
	PAJCAVLNODE pNode = ((PAJCAVLNODE)pData) - 1;

	AjcPrintF(TEXT("%-26s:%*s, %d\n"), ((PNODEDATA)pData)->pTimStr, nest * 6, pKey, pNode->bal);
	return TRUE;
}
//----- ݎ񐶐iݎi[AIւ̃|C^Ԃj----------------------------//
static	UTP		GetTimeStr(VO)
{
	UTP			rc;
	SYSTEMTIME	st;
	UI			len;
	UT			szTim[64];

	GetLocalTime(&st);
	AjcSnPrintF(szTim, AJCTSIZE(szTim), TEXT("%02d:%02d:%02d.%03d"), st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
	len = (UI)_tcslen(szTim) + 1;
	MAjcStrCpy(rc = AjcTAlloc(len), len, szTim);
	return rc;
}
//----- ͒ʒm -----------------------------------------------------------------------------------------//
static VO CALLBACK cbNtcArgs(int argc, UT *argv[], C_UTP pTxt, UX cbp)
{
	NODEDATA	Node;

	//	̓eLXg\
	AjcPrintF(TEXT("%s\n"), pTxt);
	//	R}hs
	if (argc >= 1) {
		//	m[h}
		if		(_tcsicmp(argv[0], TEXT("I")) == 0) {
			if (argc == 2) {
				Node.pTimStr = GetTimeStr();
				if (!AjcAvsInsNode(hAvs, argv[1], &Node, sizeof Node)) {
					if (Node.pTimStr != NULL) AjcTFree(Node.pTimStr); Node.pTimStr = NULL;
					AjcPrintF(TEXT("m[h̑}s܂B\n"));
				}
			}
			else AjcPrintF(TEXT("*** Invalid parameter.\n"));
		}
		//	m[hu
		else if (_tcsicmp(argv[0], TEXT("R")) == 0) {
			if (argc == 2) {
				Node.pTimStr = GetTimeStr();
				if (!AjcAvsRepNode(hAvs, argv[1], &Node, sizeof Node)) {
					if (Node.pTimStr != NULL) AjcTFree(Node.pTimStr); Node.pTimStr = NULL;
					AjcPrintF(TEXT("m[h̒us܂B\n"));
				}
			}
			else AjcPrintF(TEXT("*** Invalid parameter.\n"));
		}
		//	m[h̑}^u
		else if (_tcsicmp(argv[0], TEXT("X")) == 0) {
			if (argc == 2) {
				Node.pTimStr = GetTimeStr();
				if (!AjcAvsInsOrRepNode(hAvs, argv[1], &Node, sizeof Node)) {
					if (Node.pTimStr != NULL) AjcTFree(Node.pTimStr); Node.pTimStr = NULL;
					AjcPrintF(TEXT("m[h̑}^us܂B\n"));
				}
			}
			else AjcPrintF(TEXT("*** Invalid parameter.\n"));
		}
		//	m[h폜
		else if (_tcsicmp(argv[0], TEXT("D"))  == 0) {
			if (argc == 2) {
				if (!AjcAvsDelNode(hAvs, argv[1])) {
					AjcPrintF(TEXT("m[h̍폜s܂B\n"));
				}
			}
			else AjcPrintF(TEXT("*** Invalid parameter.\n"));
		}
		//	Sm[hj
		else if (_tcsicmp(argv[0], TEXT("A"))  == 0) {
			if (!AjcAvsDelAllNodes(hAvs)) {
				AjcPrintF(TEXT("Sm[h̍폜s܂B\n"));
			}
		}
		//	Sm[h\
		else if (_tcsicmp(argv[0], TEXT("P"))  == 0) {
			AjcAvsEnumNodes(hAvs, cbPrintNode, TRUE);
		}
		//	̑
		else {
			AjcPrintF(TEXT("*** Invalid command.\n"));
		}
	}
}
//----- R\[Inh -----------------------------------------------------------------------------//
static BOOL CALLBACK cbConApExit(DWORD CtrlType)
{
	//	`ukCX^X
	if (hAvs != NULL) {
		AjcAvsDelete(hAvs);
		hAvs = NULL;
	}
	return FALSE;	//	FALSE : ̃nhR[
}
//==============================================================================================================//
int  AjcMain(int argc, UTP argv[])
{
	NODEDATA	Node;

	AjcSetStdoutMode();

	//----- R\[Inhݒ ---------------------------------------------------------------------//
	SetConsoleCtrlHandler(cbConApExit, TRUE);

	//----- CX^X -----------------------------------------------------------------------------------//
	hAvs = AjcAvsCreate(AJCCMP_ALPHABETIC, 0, cbRemove);

	//	R}hj[
	AjcPrintF(TEXT("\n ȉ̃R}h͂ĂB\n\n"));
	AjcPrintF(TEXT("  I   SSSSS  : m[h}, key=\"SSSSS\"\n"));
	AjcPrintF(TEXT("  R   SSSSS  : m[hu, key=\"SSSSS\"\n"));
	AjcPrintF(TEXT("  X   SSSSS  : m[h̑}^u, key=\"SSSSS\"\n"));
	AjcPrintF(TEXT("  D   SSSSS  : m[h폜, key=\"SSSSS\"\n"));
	AjcPrintF(TEXT("  A          : Sm[hj\n"));
	AjcPrintF(TEXT("  P          : Sm[h\\n"));
	AjcPrintF(TEXT("  <ESC>L[  : I\n"));
	AjcPrintF(TEXT("\n"));

	//----- m[ho^^\ -------------------------------------------------------------------------------//
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited AAA"));	AjcAvsInsNode(hAvs, TEXT("AAA"), &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited BBB"));	AjcAvsInsNode(hAvs, TEXT("BBB"), &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited CCC"));	AjcAvsInsNode(hAvs, TEXT("CCC"), &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited DDD"));	AjcAvsInsNode(hAvs, TEXT("DDD"), &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited EEE"));	AjcAvsInsNode(hAvs, TEXT("EEE"), &Node, sizeof Node);
	Node.pTimStr = AjcTAlloc(16); MAjcStrCpy(Node.pTimStr, 16, TEXT("Pre-Inited FFF"));	AjcAvsInsNode(hAvs, TEXT("FFF"), &Node, sizeof Node);
	AjcAvsEnumNodes(hAvs, cbPrintNode, TRUE);

	//----- R}h ---------------------------------------------------------------------------------------//
	AjcPrintF(TEXT("Input(%2d) : "), AjcAvsGetCount(hAvs));
	while (AjcConInputByNtc(0, cbNtcArgs)) {
		AjcPrintF(TEXT("Input(%2d) : "), AjcAvsGetCount(hAvs));
	}
	if (hAvs != NULL) {
		AjcAvsDelete(hAvs);
		hAvs = NULL;
	}

	return 0;
}


