//
//	S_DIBSect2.c
//
#include	<AjrCstXX.h>
#include	<tchar.h>
#include	<math.h>
#include	"resource.h"

#define ID_BLUE 	0
#define ID_RED		1
#define ID_BLACK	7

#define RGB_BLACK	RGB(  0,   0,	0)
#define RGB_WHITE	RGB(255, 255, 255)
#define RGB_BLUE	RGB(  0,   0, 255)

//--------------------------------------------------------------------------------------------------------------//
//	|CgEm[h																							//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	AJC2DVEC	c;		//	S
	double		r;		//	a
} NODE, *PNODE;

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst		= NULL; 		//	vÕCX^Xnh
static	HWND			hDlgMain	= NULL; 		//	_CAOEnh
static	HWND			hCtrlG2d	= NULL; 		//	QcOtBbNRg[Enh
static	HWND			hCtrlPic	= NULL; 		//	sN`Rg[Enh
static	HBITMAP 		hBmpG2d 	= NULL; 		//	QcOtBbNRs[chãrbg}bvEnh
static	HBITMAP 		hBmpBlue	= NULL; 		//	ޔRs[chãrbg}bvnh
static	AJCDIBINFO		DibG2d; 					//	QcOtBbNRs[chȁ
static	AJCDIBINFO		DibBlue;					//	ޔRs[chȁ
static	HAJCFQUE		hFQueNode	= NULL; 		//	|CgEm[h~ςL[̃nh

static	BOOL			fDrawing	= FALSE;		//	`揈tO
static	BOOL			fStop		= FALSE;		//	`揈E~tO
static	BOOL			fQuit		= FALSE;		//	vOItO

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);
static	VO	DoEvent(VO);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;

	hInst = hInstance;

	//----- CE_CAOI[v -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DLGMAIN), NULL, AJC_DLGPROC_NAME(Main));
	ShowWindow(hDlgMain, SW_SHOW);

	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 		)
{
	RECT		r;
	int 		w, h;

	hDlgMain = hDlg;
	hCtrlG2d = GetDlgItem(hDlg, IDC_G2D);
	hCtrlPic = GetDlgItem(hDlg, IDC_PIC);

	//----- Qc[hݒ --------------------------//
	AjcG2dInit(hCtrlG2d, -1.0, -1.0, +1.0, +1.0, AJC3DGS_2DMODE);
	//----- _CAOڂ̏ ------------------//
	AjcSetDlgItemUInt(hDlg, IDC_INP_POINTS	,  20);
	AjcSetDlgItemUInt(hDlg, IDC_INP_INTERVAL, 100);
	AjcSetDlgItemUInt(hDlg, IDC_INP_SEED	,	1);
	AjcSetDlgItemReal(hDlg, IDC_INP_RAD_LO	, 0.10, 2);
	AjcSetDlgItemReal(hDlg, IDC_INP_RAD_HI	, 0.16, 2);
	//----- _CAOڂ̐ݒl[h ------------//
	AjcLoadAllControlSettings (hDlg, TEXT("Values"), AJCCTL_SELACT_ALL);
	//----- EChTCYݒ ----------------------//
	GetWindowRect(hCtrlG2d, &r);
	w = r.right - r.left;
	h = r.bottom - r.top;
	SetWindowPos(hCtrlPic, NULL, 0, 0, w, h, SWP_NOMOVE);
	//----- chaZNV --------------------//
	hBmpG2d  = AjcDibCreate(w, h, 24, &DibG2d );
	hBmpBlue = AjcDibCreate(w, h, 24, &DibBlue);
	AjcDibClear(&DibBlue, RGB_WHITE);
	//----- sN`\ ----------------------------//
	SendDlgItemMessage(hDlg, IDC_PIC, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hBmpBlue);
	//----- m[hL[ ------------------------//
	hFQueNode = AjcFQueCreate(sizeof(NODE), 0, NULL);

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY			)
{
	//----- m[hL[ ------------------------//
	AjcFQueDelete(hFQueNode);
	//----- DIBitmap폜 ----------------------------//
	DeleteObject(hBmpG2d );
	DeleteObject(hBmpBlue);
	//----- _CAOڂ̐ݒlZ[u ------------//
	AjcSaveAllControlSettings(hDlg);
	//----- vOI --------------------------//
	PostQuitMessage(0);
	return TRUE;
}
//----- _̐ -------------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_INP_POINTS		)
{
	return TRUE;
}
//----- á͈iŏj----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_INP_RAD_LO		)
{
	double	lo, hi;

	if (HIWORD(wParam) == AJCIVN_REALVALUE) {
		lo = *((double *)lParam);
		hi = AjcGetDlgItemReal(hDlg, IDC_INP_RAD_HI);
		if (lo > hi) {
			AjcSetDlgItemReal(hDlg, IDC_INP_RAD_HI, lo, 2);
		}
	}
	return TRUE;
}
//----- á͈iőj----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_INP_RAD_HI		)
{
	double	lo, hi;

	if (HIWORD(wParam) == AJCIVN_REALVALUE) {
		hi = *((double *)lParam);
		lo = AjcGetDlgItemReal(hDlg, IDC_INP_RAD_LO);
		if (lo > hi) {
			AjcSetDlgItemReal(hDlg, IDC_INP_RAD_LO, hi, 2);
		}
	}
	return TRUE;
}
//----- rsno{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STOP			)
{
	fStop = TRUE;
	return TRUE;
}
//----- rs`qs{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_START 		)
{
	int 	nPoint = AjcGetDlgItemSInt(hDlg, IDC_INP_POINTS);
	double	rlo   = AjcGetDlgItemReal(hDlg, IDC_INP_RAD_LO);
	double	rhi   = AjcGetDlgItemReal(hDlg, IDC_INP_RAD_HI);
	double	rw	  = rhi - rlo;

	int 		i;
	NODE		node;
	PNODE		p1, p2, p3;
	AJC2DVEC	v;
	double		dist, dup;
	HBITMAP 	hBmp;

	//----- tO ------------------------------------//
	fDrawing = TRUE;
	fStop	 = FALSE;
	//----- nj{^Crsno{^L ----------//
	EnableWindow(GetDlgItem(hDlg, IDC_CMD_START), FALSE);
	EnableWindow(GetDlgItem(hDlg, IDC_CMD_STOP ), TRUE );
	//----- nݒ ------------------------------------//
	srand(AjcGetDlgItemUInt(hDlg, IDC_INP_SEED));
	//----- |CgEm[h쐬 ----------------------------//
	AjcFQuePurge(hFQueNode);
	for (i = 0; i < nPoint; i++) {
		double xlo, xhi, xw, ylo, yhi, yw;
		node.r = rlo + (rw * (double)rand() / (double)RAND_MAX);
		xlo = ylo = -1.0 + node.r;
		xhi = yhi = +1.0 - node.r;
		xw = xhi - xlo;
		yw = yhi - ylo;
		node.c.x = xlo + (xw * (double)rand() / (double)RAND_MAX);
		node.c.y = ylo + (yw * (double)rand() / (double)RAND_MAX);
		AjcFQueEnque(hFQueNode, &node);
	}
	//----- rbg}bviڐjݒ ------------------//
	AjcG2dClearAll(hCtrlG2d);
	UpdateWindow(hCtrlG2d);
	AjcDibClear(&DibBlue, RGB_WHITE);
	hBmp = AjcG2dGetBitmap(hCtrlG2d);
	AjcDibCopyBitmap  (&DibG2d , 0, 0, 0, 0, hBmp, 0, 0, 0, 0, SRCCOPY);
	AjcDibExcludedCopy(&DibBlue, 0, 0, 0, 0, &DibG2d, 0, 0, RGB_WHITE, 0.0);
	SendDlgItemMessage(hDlgMain, IDC_PIC, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hBmpBlue);
	DeleteObject(hBmp);
	//----- Q̉~`悵AdœhԂ ------//
	for (p1 = AjcFQueTopNode(hFQueNode); p1 != NULL; p1 = AjcFQueNextNode(hFQueNode, p1)) {
		for (p2 = AjcFQueNextNode(hFQueNode, p1); p2 != NULL; p2 = AjcFQueNextNode(hFQueNode, p2)) {
			//	ʃNA[
			AjcG2dClearAll(hCtrlG2d);
			//	Q̉~`
			AjcG2dEllipse(hCtrlG2d, ID_BLACK, p1->c.x, p1->c.y, p1->r, p1->r);
			AjcG2dEllipse(hCtrlG2d, ID_BLACK, p2->c.x, p2->c.y, p2->r, p2->r);
			//	dœhԂA̂ݑޔ --//
			dist = sqrt(pow(p1->c.x - p2->c.x, 2.0) + pow(p1->c.y - p2->c.y, 2.0));
			if (dist < (p1->r + p2->r)) {
				dup = (p1->r + p2->r) - dist;
				v.x = ((p2->c.x - p1->c.x) / dist) * (p1->r - (dup / 2.0));
				v.y = ((p2->c.y - p1->c.y) / dist) * (p1->r - (dup / 2.0));
				AjcG2dFillB(hCtrlG2d, ID_BLUE, ID_BLACK, p1->c.x + v.x, p1->c.y + v.y);
				UpdateWindow(hCtrlG2d);
				Sleep(AjcGetDlgItemSInt(hDlg, IDC_INP_INTERVAL));
				//	hԂɓ_݂邩`FbN
				for (p3 = AjcFQueTopNode(hFQueNode); p3 != NULL; p3 = AjcFQueNextNode(hFQueNode, p3)) {
					if (AjcG2dGetPixel(hCtrlG2d, p3->c.x, p3->c.y) == RGB_BLUE) {
						break;
					}
				}
				//	hԂɓ_݂Ȃ΁AFhԂޔ
				if (p3 == NULL) {
					hBmp = AjcG2dGetBitmap(hCtrlG2d);
					AjcDibCopyBitmap   (&DibG2d , 0, 0, 0, 0, hBmp, 0, 0, 0, 0, SRCCOPY);
					AjcDibCorrectedCopy(&DibBlue, 0, 0, 0, 0, &DibG2d, 0, 0, RGB_BLUE, 0.0);
					DeleteObject(hBmp);
					//	sN`iFW󋵁j\
					SendDlgItemMessage(hDlgMain, IDC_PIC, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hBmpBlue);
				}
			}
			DoEvent();
			if (fStop) break;
		}
		if (fStop) break;
	}
	//----- ̊\ --------------------------------//
	AjcSetDlgItemReal(hDlg, IDC_TXT_RATIO, (double)AjcDibColorCount(&DibBlue, 0, 0, 0, 0, RGB_BLUE, 0.0) /
										   (double)(DibBlue.width * DibBlue.height) * 100.0, 2);
	//----- ~ƒS|Cgĕ`悵sN`փRs[ ------//
	AjcG2dClearAll(hCtrlG2d);
	for (p1 = AjcFQueTopNode(hFQueNode); p1 != NULL; p1 = AjcFQueNextNode(hFQueNode, p1)) {
		AjcG2dEllipse(hCtrlG2d, ID_BLACK, p1->c.x, p1->c.y, p1->r, p1->r);
		AjcG2dPixel  (hCtrlG2d, ID_BLACK, p1->c.x, p1->c.y, 2);
	}
	UpdateWindow(hCtrlG2d);
	hBmp = AjcG2dGetBitmap(hCtrlG2d);
	AjcDibCopyBitmap   (&DibG2d , 0, 0, 0, 0, hBmp, 0, 0, 0, 0, SRCCOPY);
	AjcDibCorrectedCopy(&DibBlue, 0, 0, 0, 0, &DibG2d, 0, 0, RGB_BLACK, 0.0);
	DeleteObject(hBmp);
	SendDlgItemMessage(hDlgMain, IDC_PIC, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hBmpBlue);
	//----- nj{^LCrsno{^ ----------//
	EnableWindow(GetDlgItem(hDlg, IDC_CMD_START), TRUE );
	EnableWindow(GetDlgItem(hDlg, IDC_CMD_STOP ), FALSE);
	//----- tOZbg ----------------------------------//
	fDrawing = FALSE;
	fStop	 = FALSE;
	//----- vOI ------------------------------//
	if (fQuit) {
		fQuit = FALSE;
		DestroyWindow(hDlg);
	}

	return TRUE;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL				)
{
	if (fDrawing) fStop = fQuit = TRUE;
	else		  DestroyWindow(hDlg);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG )
	AJC_DLGMAP_MSG(Main, WM_DESTROY    )

	AJC_DLGMAP_CMD(Main, IDC_INP_POINTS)
	AJC_DLGMAP_CMD(Main, IDC_INP_RAD_LO)
	AJC_DLGMAP_CMD(Main, IDC_INP_RAD_HI)
	AJC_DLGMAP_CMD(Main, IDC_CMD_STOP  )
	AJC_DLGMAP_CMD(Main, IDC_CMD_START )
	AJC_DLGMAP_CMD(Main, IDCANCEL	   )
AJC_DLGMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	WindowsCxg 																						//
//--------------------------------------------------------------------------------------------------------------//
static	VO	DoEvent(VO)
{
	MSG 	msg;

	if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}
}
