//
//	SW_PrintText.c
//
#include	<AjrCstXX.h>
#include	<Shlwapi.h>
#include	<io.h>
#include	<tchar.h>
#include	<sys/stat.h>
#include	"resource.h"
#pragma comment(lib, "shlwapi.lib")

#define		PICL	300

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;							//	ckkCX^Xnh
static	HWND			hDlgMain;						//	_CAO{bNXnh
static	HAJCFILE		hFile = NULL;					//	eLXgt@Cnh
static	HAJCPRN 		hPrn;							//	CX^X
static	BOOL			fPrintContinue	= TRUE; 		//	ptO
static	HFONT			hFont = NULL;					//	tHgIuWFNg
static	AJCPRN_INFO		PrnInfo;						//	v^
static	BOOL			fFileOut = FALSE;				//	t@C֏o̓tO


//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);

static	BOOL CALLBACK cbQueryPage(PCAJCPRN_INFO pPrnInfo, PAJCPRN_PGINFO pPageInfo, UX cbp);
static	BOOL CALLBACK cbDrawByDibSectDC(HDC hdc, PCAJCPRN_INFO pPrnInfo, PCAJCDIBINFO pDibInfo, UX cbp);
static	BOOL CALLBACK cbDrawByPrinterDC(HDC hdc, PCAJCPRN_INFO pPrnInfo, UX cbp);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;

	hInst = hInstance;

	//----- CE_CAOI[v -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, AJC_DLGPROC_NAME(Main));
	ShowWindow(hDlgMain, SW_SHOW);

	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	AJCPRN_MARGIN	mrg;
	LOGFONT 		lf;

	hDlgMain = hDlg;

	//----- CX^X --------------------------//
	hPrn = AjcPrnCreate();
	//----- y[WJnR[obNݒ ----------------//
	AjcPrnSetCallbackQueryPage(hPrn, cbQueryPage);
	//----- v^\ --------------------------------//
	AjcSetDlgItemStr(hDlg, IDC_LBL_PRNAME, AjcPrnGetInfo(hPrn, &PrnInfo));
	//----- eLXgt@C͂Ńhbv\Ƃ ----//
	AjcEnableDlgItemToDrop (hDlg, IDC_TXT_FILE, AJCDROP_FILE);
	//----- WI{^ ----------------------------//
	AjcSetDlgItemChk(hDlg, IDC_RBT_DIB_DC, TRUE);
	//----- ݒl[h ----------------------------------//
	AjcLoadAllControlSettings(hDlg, TEXT("Settings"), AJCCTL_SELACT_ALL | AJCCTL_SELACT_NTCALL);
	//----- ]ݒ --------------------------------------//
	mrg.u = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_U);
	mrg.d = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_D);
	mrg.l = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_L);
	mrg.r = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_R);
	AjcPrnSetMargin(hPrn, &mrg);
	//----- tHg ----------------------------------//
	lf.lfHeight		 = 80;			lf.lfStrikeOut		= 0;
	lf.lfWidth		 = 0;			lf.lfCharSet		= DEFAULT_CHARSET;
	lf.lfEscapement	 = 0;			lf.lfOutPrecision	= OUT_STROKE_PRECIS;
	lf.lfOrientation = 0;			lf.lfClipPrecision	= CLIP_STROKE_PRECIS;
	lf.lfWeight		 = FW_NORMAL;	lf.lfQuality		= DRAFT_QUALITY;
	lf.lfItalic		 = 0;			lf.lfPitchAndFamily	= FF_MODERN | VARIABLE_PITCH;
	lf.lfUnderline	 = 0;			MAjcStrCpy(lf.lfFaceName, AJCTSIZE(lf.lfFaceName), TEXT("Arial Unicode MS"));
	hFont = CreateFontIndirect(&lf);

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	//----- ݒlZ[u ----------------------------------//
	AjcSaveAllControlSettings(hDlg);
	//----- \[X ----------------------------------//
	AjcPrnDelete(hPrn);
	DeleteObject(hFont);
	//----- vOI --------------------------------//
	PostQuitMessage(0);

	return TRUE;
}
//----- WM_COMMAND ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_COMMAND		)
{
	int 	cmd = LOWORD(wParam);

	if (cmd == IDC_INP_SPC_U || cmd == IDC_INP_SPC_D || cmd == IDC_INP_SPC_L || cmd == IDC_INP_SPC_R) {
		if (HIWORD(wParam) == AJCIVN_INTVALUE) {
			AJCPRN_MARGIN	mrg;
			mrg.u = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_U);
			mrg.d = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_D);
			mrg.l = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_L);
			mrg.r = AjcGetDlgItemUInt(hDlg, IDC_INP_SPC_R);
			AjcPrnSetMargin(hPrn, &mrg);
		}
	}
	return TRUE;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//----- v^̐ݒ{^ -----------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SETPRN	)
{
	if (AjcPrnSelectDlg(hPrn, &PrnInfo, 0, hDlg)) {
		//	v^\
		AjcSetDlgItemStr(hDlg, IDC_LBL_PRNAME, AjcPrnGetInfo(hPrn, NULL));
	}
	return TRUE;
}
//----- Jn{^ ----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_START		)
{
	AJCPRN_OPT	opt = {0};
	UT			path[MAX_PATH];

	if (HIWORD(wParam) == BN_CLICKED) {
		AjcGetDlgItemStr(hDlg, IDC_TXT_FILE, path, MAX_PATH);
		if (hFile = AjcFOpen(path, AJCTEC_AUTO)) {
			opt.Flags = (
				AJCPRNF_DISABLECOPIES		|	//	uv𖳌
				AJCPRNF_DISABLEPAGEINFO		|	//	ú͈v𖳌ɂ
			//	AJCPRNF_ALLPAGES			|	//	uׂāvIԂɂ
			//	AJCPRNF_SELECTION			|	//	uIvIԂɂ
			//	AJCPRNF_NOSELECTION			|	//	uIv𖳌Ԃɂ
			//	AJCPRNF_PAGENUMS			|	//	uy[WwvIԂɂ
			//	AJCPRNF_NOPAGENUMS			|	//	uy[Wwv𖳌Ԃɂ
			//	AJCPRNF_NOWARNING			|	//	̃v^ȂꍇɌxbZ[W\
			//	AJCPRNF_PRINTTOFILE			|	//	ut@C֏óv`FbN
			//	AJCPRNF_DISABLEPRINTTOFILE	|	//	ut@C֏óv𖳌
			//	AJCPRNF_HIDEPRINTTOFILE		|	//	t@C֏óv\
			//	AJCPRNF_USEDEVMODECOPIES	|	//	AvŁuPʂňvT|[gł邱Ƃw
				0);
			opt.nCopies 	= 1;				//	Rs[
			opt.nFromPage	= 1;				//	Jny[W
			opt.nToPage		= 1;				//	Iy[W
			opt.nMinPage	= 1;				//	y[W͈͂̍ŏl
			opt.nMaxPage	= 10;				//	y[W͈͂̍ŏl
			if (AjcPrnPrintDlg(hPrn, NULL, &opt, hDlg)) {
				//--- v^\ ------------//
				AjcSetDlgItemStr(hDlg, IDC_LBL_PRNAME, AjcPrnGetInfo(hPrn, NULL));
				//--- ptO ------//
				fPrintContinue = TRUE;
				//--- ~{^̂ݗL ------//
				AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_ALL ), FALSE, FALSE);
				EnableWindow  (GetDlgItem(hDlg, IDC_CMD_STOP), TRUE);
				//--- Jn ------------------//
				AjcPrnStart (hPrn, (opt.Flags & AJCPRNF_OUTPUTTOFILE) != 0);
				//--- O[ԉ -----------//
				AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_ALL ), TRUE, TRUE);
				EnableWindow  (GetDlgItem(hDlg, IDC_CMD_STOP), FALSE);
			}
			//--- t@CN[Y ---------//
			AjcFClose(hFile); hFile = NULL;
		}
		else {
			MessageBox(hDlg, TEXT("t@CI[vł܂"), TEXT("SW_PrintText"), MB_ICONERROR);
		}
	}
	return TRUE;
}
//----- ~{^ ----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STOP		)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		//--- O[ԉ -----------//
		AjcEnableGroup(GetDlgItem(hDlg, IDC_GRP_ALL ), TRUE, TRUE);
		EnableWindow  (GetDlgItem(hDlg, IDC_CMD_STOP), FALSE);
		//--- I̎|Aݒ -------//
		fPrintContinue = FALSE;
	}
	return TRUE;
}
//----- eLXgt@Cݒ{^ -------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_FILE		)
{
	UT		path[MAX_PATH];

	if (HIWORD(wParam) == BN_CLICKED) {
		AjcGetDlgItemStr(hDlg, IDC_TXT_FILE, path, AJCTSIZE(path));
		if (AjcGetOpenFile(hDlg, TEXT("C[Wt@Cݒ"), TEXT("Text File (*.txt)/*.txt/All Files (*.*)/*.*"),
																					TEXT("txt"), path, MAX_PATH)) {
			AjcSetDlgItemStr(hDlg, IDC_TXT_FILE, path);
		}
	}
	return TRUE;
}
//----- WI{^iv^cb֒ڕ`j------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_RBT_PRT_DC	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		if (AjcGetDlgItemChk(hDlg, IDC_RBT_PRT_DC)) AjcPrnSetCallbackByPrinter(hPrn, cbDrawByPrinterDC);
		else										AjcPrnSetCallbackByDibSect(hPrn, cbDrawByDibSectDC);
	}
	return TRUE;
}
//----- WI{^ichaZNVĕ`j------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_RBT_DIB_DC	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		if (AjcGetDlgItemChk(hDlg, IDC_RBT_PRT_DC)) AjcPrnSetCallbackByPrinter(hPrn, cbDrawByPrinterDC);
		else										AjcPrnSetCallbackByDibSect(hPrn, cbDrawByDibSectDC);
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG		)
	AJC_DLGMAP_MSG(Main, WM_DESTROY 		)
	AJC_DLGMAP_MSG(Main, WM_COMMAND 		)
	AJC_DLGMAP_CMD(Main, IDCANCEL			)
	AJC_DLGMAP_CMD(Main, IDC_CMD_SETPRN 	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_START		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_STOP		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_FILE		)
	AJC_DLGMAP_CMD(Main, IDC_RBT_PRT_DC		)
	AJC_DLGMAP_CMD(Main, IDC_RBT_DIB_DC		)
AJC_DLGMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	R[obNiy[WJnj																				//
//																												//
//	@	F	hdc 		- chaZNVrbg}bv̂cb												//
//				pPrnInfo	- v^ւ̃|C^															//
//				pPgInfo		- y[Wւ̃|C^															//
//				cbp 		- R[obNp^																//
//																												//
//	߂l	F	TRUE  - p																				//
//				FALSE - Iĩy[WɏIj													//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbQueryPage(PCAJCPRN_INFO pPrnInfo, PAJCPRN_PGINFO pPgInfo, UX cbp)
{
	BOOL	rc = FALSE;

	AjcDoEvent();														//	~{^`FbN
	rc = fPrintContinue;												//	E

	return !AjcFEof(hFile);
}
//--------------------------------------------------------------------------------------------------------------//
//	R[obNicha֕`j																				//
//																												//
//	@	F	hdc 		- chaZNVrbg}bv̂cb												//
//				pPi	- v^ւ̃|C^																	//
//				pDi	- chaZNVւ̃|C^															//
//				cbp 		- R[obNp^																//
//																												//
//	߂l	F	TRUE  - p																				//
//				FALSE - Iĩy[WɏIj													//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbDrawByDibSectDC(HDC hdc, PCAJCPRN_INFO pPi, PCAJCDIBINFO pDi, UX cbp)
{
	BOOL		rc;
	int 		CxChar, CyChar;
	int 		y, i, nLine;
	HFONT		hFontSv;
	TEXTMETRIC	tm;
	UT			buf[512];

	AjcDoEvent();																//	~{^`FbN
	rc = fPrintContinue;														//	E

	//	eLXgC[W`
	hFontSv = (HFONT)SelectObject(hdc, hFont);									//	tHgݒ
	GetTextMetrics(hdc, &tm);													//	eLXg擾
	CxChar = __max(1, tm.tmAveCharWidth);										//	tHgTCYݒ
	CyChar = __max(1, tm.tmHeight + tm.tmExternalLeading);						//	E
	nLine = pDi->height / CyChar;												//	\sݒ
	for (i = 0, y = 0; i < nLine && AjcFGetS(hFile, buf, AJCTSIZE(buf)); i++) {	//	\s[v
		MAjcStrTok(buf, TEXT("\x0A")); 											//			s
		TextOut(hdc, 0, y, buf, (int)MAjcStrLen(buf)); 							//			eLXg`
		y += CyChar;															//			X^ʒuXV
	}
	SelectObject(hdc, hFontSv);

	//	Og`
	{
		HBRUSH hBru = (HBRUSH)SelectObject(hdc, GetStockObject(NULL_BRUSH));
		HPEN   hPen = (HPEN  )SelectObject(hdc, CreatePen(PS_SOLID, 5, RGB(0, 0, 0)));
		Rectangle(hdc, 0, 0, pDi->width, pDi->height);
		SelectObject(hdc, hBru);
		DeleteObject(SelectObject(hdc, hPen));
	}
	return fPrintContinue;		//	FALSE:ICTRUEFp
}
//--------------------------------------------------------------------------------------------------------------//
//	R[obNiv^cb֕`j																			//
//																												//
//	@	F	hdc 		- v^̂cb																	//
//				pPi			- v^ւ̃|C^															//
//				cbp 		- R[obNp^																//
//																												//
//	߂l	F	TRUE  - p																				//
//				FALSE - Iĩy[WɏIj													//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbDrawByPrinterDC(HDC hdc, PCAJCPRN_INFO pPi, UX cbp)
{
	BOOL		rc = FALSE;
	int 		CxChar, CyChar;
	int 		y, i, nLine;
	HFONT		hFontSv;
	TEXTMETRIC	tm;
	UT			buf[512];

	AjcDoEvent();																		//	~{^`FbN
	rc = fPrintContinue;																//	E

	//	eLXgC[W`
	hFontSv = (HFONT)SelectObject(hdc, hFont);											//	tHgݒ
	GetTextMetrics(hdc, &tm);															//	eLXg擾
	CxChar = __max(1, tm.tmAveCharWidth);												//	tHgTCYݒ
	CyChar = __max(1, tm.tmHeight + tm.tmExternalLeading);								//	E
	nLine = pPi->cy / CyChar;															//	\sݒ
	for (i = 0, y = pPi->y; i < nLine && AjcFGetS(hFile, buf, AJCTSIZE(buf)); i++) {	//	\s[v
		MAjcStrTok(buf, TEXT("\x0A")); 													//			s
		TextOut(hdc, pPi->x, y, buf, (int)MAjcStrLen(buf)); 							//			eLXg`
		y += CyChar;																	//			X^ʒuXV
	}
	SelectObject(hdc, hFontSv);

	//	Og`
	{
		HBRUSH hBru = (HBRUSH)SelectObject(hdc, GetStockObject(NULL_BRUSH));
		HPEN   hPen = (HPEN  )SelectObject(hdc, CreatePen(PS_SOLID, 5, RGB(0, 0, 0)));
		Rectangle(hdc, pPi->x, pPi->y, pPi->x + pPi->cx, pPi->y + pPi->cy);
		SelectObject(hdc, hBru);
		DeleteObject(SelectObject(hdc, hPen));
	}
	return fPrintContinue;		//	FALSE:ICTRUEFp
}
