//
//	SW_SerialComPort1.c
//

#define AJCSOCKSERV_H_
#define AJCSOCKCLIENT_H_
#include	<AjrCstXX.h>
#include	<tchar.h>
#include	"resource.h"

#define WM_SCPEVENT 	(WM_USER + 100)
#define	MAX_TXTBOX_LEN	128

//--------------------------------------------------------------------------------------------------------------//
//	c[`bv																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	int		id;
	C_UTP	pTxt;
} TIPTBL, *PTIPTBL;
typedef const TIPTBL *PCTIPTBL;

static const TIPTBL TipTbl[] = {
	{IDC_TXT_SNDTEXT	, TEXT("b\L̃eLXgݒ肵ĂBiex. ABC\\nj")									},
	{IDC_VTH_TXTCHUNK	, TEXT("A^CɎMf[^eLXgf[^Ƃĕ\܂B\n")
						  TEXT("oCg̏ꍇ́A܂Ŏ̃A^CMf[^҂܂B")			},
	{IDC_VTH_BINCHUNK	, TEXT("A^CɎMf[^oCif[^Ƃĕ\܂B")							},
	{IDC_VTH_INVCHUNK	, TEXT("A^CɎMeLXgf[^ɕsȐR[h܂܂ꍇ́A\n")
						  TEXT("eLXg`Nł͂ȂAs`NeLXgƂăoCi\܂B\n")
						  TEXT("sȐR[hƂ́ATAB(0x09)`CR(0x0D)ȊO̐R[hӖ܂B")					},
	{IDC_VTH_TEXT		, TEXT("MXg[琧R[hiTABȊOjŋ؂ꂽeLXgf[^𔲂oĕ\܂B\n")
						  TEXT("\x1B[34mɃt@ChbvƁAt@C̓eoCif[^ƂđM܂B")	},
	{IDC_VTH_CTRL		, TEXT("MXg[琧R[hiTABȊOj𔲂oĕ\܂B")							},
	{IDC_VTH_ESC		, TEXT("MXg[AdrbV[PXi0x1B`pj𔲂ĕ\܂B")			},
	{IDC_VTH_PKT		, TEXT("MpPbgf[^iDLEESTX`DLEEETX ŃThCb`ꂽf[^joCi\܂B")},
	{IDC_VTH_NOPKT		, TEXT("A^CɎMf[^̃pPbgf[^iDLEESTX`DLEEETXjȊO̕eLXgƂĕ\܂B\n")
						  TEXT("oCg̏ꍇ́A܂Ŏ̃A^CMf[^҂܂B")}
};

#define	MAX_TIPTBL	(sizeof TipTbl / sizeof TipTbl[0])

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
HINSTANCE		hInst;							//	ckkCX^Xnh
HWND			hDlgMain;						//	_CAO{bNXnh

HAJCSCP 		hScp;
HWND			hWndVthTxtChu;
HWND			hWndVthBinChu;
HWND			hWndVthText;
HWND			hWndVthCtrl;
HWND			hWndVthEsc;
HWND			hWndVthPkt;
HWND			hWndVthInvChu;
HWND			hWndVthPkt;
HWND			hWndVthNoPkt;
HWND			hWndVthLog;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);

static	VO		SubSendFile(HWND hDlg, C_UTP pFName);
static	VO		ShowSignalState(UI sig);
static	VO		ShowOnOpened(VO);
static	VO		ShowOnClosed(VO);
static	VO		ShowPortName(C_UTP pPortName);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;

	hInst = hInstance;

	//----- CE_CAOI[v -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DLGMAIN), NULL, AJC_DLGPROC_NAME(Main));
	ShowWindow(hDlgMain, SW_SHOW);

	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}

	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	_CAOEvV[W																					//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	int		i;

	hDlgMain		= hDlg;
	hWndVthTxtChu	= GetDlgItem(hDlg, IDC_VTH_TXTCHUNK	);
	hWndVthBinChu	= GetDlgItem(hDlg, IDC_VTH_BINCHUNK	);
	hWndVthText		= GetDlgItem(hDlg, IDC_VTH_TEXT		);
	hWndVthCtrl		= GetDlgItem(hDlg, IDC_VTH_CTRL		);
	hWndVthEsc		= GetDlgItem(hDlg, IDC_VTH_ESC		);
	hWndVthInvChu	= GetDlgItem(hDlg, IDC_VTH_INVCHUNK	);
	hWndVthPkt		= GetDlgItem(hDlg, IDC_VTH_PKT		);
	hWndVthNoPkt	= GetDlgItem(hDlg, IDC_VTH_NOPKT	);
	hWndVthLog		= GetDlgItem(hDlg, IDC_VTH_EVTLOG	);

	//----- EChʒu[h ----------------------//
	AjcLoadWndPos(hDlg, NULL);
	//----- WI{^̃O[v ----------------//
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_RXTEC));
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_TXTEC));
	//----- _CAOڂ̏ ------------------//
	AjcSetDlgItemStr (hDlg, IDC_TXT_SNDTEXT  , TEXT("s`ԍ1-2-3\\n"));
	AjcSetDlgItemStr (hDlg, IDC_TXT_SNDESC	 , TEXT("[31m" 				 ));
	AjcSetDlgItemStr (hDlg, IDC_TXT_SNDBIN	 , TEXT("00 01 02" 			 ));
	AjcSetDlgItemStr (hDlg, IDC_TXT_SNDPKT	 , TEXT("10 11 12" 			 ));
	AjcSetDlgItemStr (hDlg, IDC_TXT_SNDWORD14, TEXT("100"					 ));
	AjcSetDlgItemChk (hDlg, IDC_CHK_RTS	 	 , TRUE);
	AjcSetDlgItemChk (hDlg, IDC_CHK_DTR	 	 , TRUE);
	AjcSetDlgItemUInt(hDlg, IDC_GRP_RXTEC	 , 0	);
	AjcSetDlgItemUInt(hDlg, IDC_GRP_TXTEC	 , 0	);
	//----- eLXg{bNXݒ ------------------//
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SNDTEXT, MAX_TXTBOX_LEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SNDESC , MAX_TXTBOX_LEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SNDBIN , MAX_TXTBOX_LEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SNDPKT , MAX_TXTBOX_LEN - 1);
	//----- c[`bvݒ ------------------------//
	for (i = 0; i < MAX_TIPTBL; i++) {
		AjcTipTextAdd(GetDlgItem(hDlg, TipTbl[i].id), TipTbl[i].pTxt);
	}
	//----- rboZbgAbv ----------------------//
	hScp = AjcScpCreateEx(TEXT("ComPort"), TRUE, NULL, NULL, NULL); //	rboCX^X
	AjcScpSetMode(hScp, hDlg, WM_SCPEVENT, AJCSCP_CM_BOTH);			//	[hݒ
	AjcScpSetRxTextCode(hScp, AJCSCP_TXT_AUTO);						//	MeLXgR[h
	AjcScpSetTxTextCode(hScp, AJCSCP_TXT_AUTO);						//	MeLXgR[hMƓ
	AjcScpSetEvtMask(hScp,	0 | 									//	Cxg}XNݒ
							AJCSCP_EV_PORTSTATE |					//		|[gԒʒm
							AJCSCP_EV_RXCHUNK	|					//		`Nf[^Mʒm
							AJCSCP_EV_RXTEXT	|					//		eLXgMʒm
							AJCSCP_EV_RXESC 	|					//		drbR[hMʒm
							AJCSCP_EV_RXCTRL	|					//		R[hMʒm
							AJCSCP_EV_RXPKT 	|					//		pPbgf[^Mʒm
							AJCSCP_EV_RXNOPKT	|					//		pPbgOf[^Mʒm
							AJCSCP_EV_TXEMPTY	|					//		M
							AJCSCP_EV_RING		|					//		RINGωʒm
							AJCSCP_EV_ERR		|					//		G[ʒm
							AJCSCP_EV_RLSD		|					//		RLSDωʒm
							AJCSCP_EV_DSR		|					//		DSRωʒm
							AJCSCP_EV_CTS		|					//		CTSωʒm
							AJCSCP_EV_RXWORD14	|					//		oCgyAɂ郏[hi14Bitjf[^M
							AJCSCP_EV_INVCHUNK	|					//		s`NeLXgMʒm
	0);
	//----- |[g\ ----------------------------//
	ShowPortName(AjcScpGetPortName(hScp));
	//----- O[\ --------------------------//
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_SETSIG, FALSE, FALSE);
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_SIGSTS, FALSE, FALSE);
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_SEND  , FALSE, FALSE);
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_RECV  , FALSE, FALSE);
	AjcScpOpenDefault(hScp);
	//----- _CAOڂ̃[h ------------------//
	AjcLoadAllControlSettings (hDlg, TEXT("DlgSetting"), AJCOPT3(AJCCTL_SELACT_, ALL, NTCCHK, NTCRBT));

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_DESTROY		)
{
	//----- EChʒuZ[u ----------------------------//
	AjcSaveWndPos(hDlg, NULL);
	//----- _CAOڂ̃Z[u ------------------------//
	AjcSaveAllControlSettings(hDlg);

	AjcScpDelete(hScp); 		//	rboCX^X
	PostQuitMessage(0);
	return TRUE;
}
//----- rblCxgʒm -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_SCPEVENT		)
{
	UI		time = GetTickCount();
	UI		len, param;
	UT		txt[256];
	union {UBP pBin; UWP pWord; UTP pTxt; VOP vp;} u;

	AjcScpGetEventData(hScp, lParam, &u.vp, &len, &param);				//	Cxgf[^擾
	if(wParam & AJCSCP_EV_PORTSTATE) {									//	|[gԒʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: PORTSTATE len=%5d, param=%d "), time, len, param);
		ShowPortName(u.pTxt);
		switch (param) {
			case AJCSCP_CLOSED: ShowOnClosed(); 						//		EN[Y
				AjcSetDlgItemStr(hDlg, IDC_LBL_PORTSTATE, TEXT("Closed"));
				AjcVthPrintF(hWndVthLog, TEXT("(%s closed)\n" ), u.pTxt);
				break;
			case AJCSCP_OPENED: ShowOnOpened();							//		EI[v
				AjcSetDlgItemStr(hDlg, IDC_LBL_PORTSTATE, TEXT("Opened"));
				AjcVthPrintF(hWndVthLog, TEXT("(%s opened)\n" ), u.pTxt);
				AjcScpSetRTS(hScp, AjcGetDlgItemChk(hDlg, IDC_CHK_RTS));
				AjcScpSetDTR(hScp, AjcGetDlgItemChk(hDlg, IDC_CHK_DTR));
				break;
			case AJCSCP_OPENFAIL:										//		EI[vs
				AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("(%s open falure)\n"),u.pTxt);
				AjcVthPrintF(hWndVthLog, txt);
				MessageBox(hDlg, txt, TEXT("SW_SerialComPort1"), MB_ICONERROR);
				break;
			default:
				AjcVthPutText(hWndVthLog, TEXT("\n"), -1);
				break;
		}
	}
	if(wParam & AJCSCP_EV_RXCHUNK ) {									//	`Nf[^Mʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: RXCHUNK   len=%5d, param=0x%08X\n"), time, len, param);
		//	oCi`N
		if (param == 0) {
			AjcVthHexDump(hWndVthBinChu, (C_VOP)u.pBin, len);
			AjcVthPrintF (hWndVthBinChu, TEXT("\n"));
		}
		//	eLXg`N
		else {
			AjcVthPutText(hWndVthTxtChu, u.pTxt, -1);
		}
	}
	if (wParam & AJCSCP_EV_RXTEXT ) {									//	eLXgMʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: RXTEXT    len=%5d, param=0x%08X\n"), time, len, param);
		AjcVthPrintF(hWndVthText, TEXT("%s\n"), u.pTxt);				//		eLXgf[^\
	}
	if (wParam & AJCSCP_EV_RXESC  ) {									//	drbR[hMʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: RXESC     len=%5d, param=0x%08X\n"), time, len, param);
		AjcVthPrintF(hWndVthEsc, TEXT("\\x1B%s\n"), u.pTxt + 1);			//		drbf[^\
	}
	if (wParam & AJCSCP_EV_RXCTRL ) {									//	R[hMʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: RXCTRL    len=%5d, param=0x%08X, data=%02X\n"), time, len, param, *u.pBin);
		AjcVthPrintF(hWndVthCtrl, TEXT("%02X\n"), *u.pTxt);				//		R[h\
	}
	if (wParam & AJCSCP_EV_RXPKT  ) {									//	pPbgf[^Mʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: RXPKT     len=%5d, param=0x%08X\n"), time, len, param);
		AjcVthHexDump(hWndVthPkt, (C_VOP)u.pBin, len);
		AjcVthPrintF (hWndVthPkt, TEXT("\n"));
	}
	if (wParam & AJCSCP_EV_TXEMPTY) {									//	Mʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: TXEMPTY   len=%5d, param=0x%08X\n"), time, len, param);
	}
	if (wParam & AJCSCP_EV_RXNOPKT) { 									//	pPbgOeLXgMʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: RXNOPKT   len=%5d, param=0x%08X\n"), time, len, param);
		AjcVthPutText(hWndVthNoPkt, u.pTxt, -1);						//		pPbgOeLXg\
	}
	if (wParam & AJCSCP_EV_INVCHUNK) { 									//	seLXg`Nʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: INVCHUNK  len=%5d, param=0x%08X\n"), time, len, param);
		AjcVthHexDump(hWndVthInvChu, (C_VOP)u.pBin, len);
		AjcVthPrintF (hWndVthInvChu, TEXT("\n"));
	}
	if (wParam & AJCSCP_EV_ERR	  ) {									//	G[ʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: ERR       len=%5d, param=0x%08X\n"), time, len, param);
	}
	if (wParam & AJCSCP_EV_RING   ) {									//	RINGωʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: RING      len=%5d, param=0x%08X\n"), time, len, param);
		ShowSignalState(LOWORD(param));
	}
	if (wParam & AJCSCP_EV_RLSD   ) {									//	RLSDωʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: RLSD      len=%5d, param=0x%08X\n"), time, len, param);
		ShowSignalState(LOWORD(param));
	}
	if (wParam & AJCSCP_EV_DSR	  ) {									//	DSRωʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: DSR       len=%5d, param=0x%08X\n"), time, len, param);
		ShowSignalState(LOWORD(param));
	}
	if (wParam & AJCSCP_EV_CTS	  ) {									//	CTSωʒm
		AjcVthPrintF(hWndVthLog, TEXT("%9d: CTS       len=%5d, param=0x%08X\n"), time, len, param);
		ShowSignalState(LOWORD(param));
	}
	if (wParam & AJCSCP_EV_RXWORD14) {									//	oCgyAɂ郏[hi14Bitjf[^M
		RECT	r;
		UT		txt[64];
		AjcVthPrintF(hWndVthLog, TEXT("%9d: WORD14    len=%5d, param=0x%08X(%d)\n"), time, len, *u.pWord, *u.pWord);
		GetWindowRect(GetDlgItem(hDlg, IDC_LBL_SNDWORD14), &r);
		AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("PSrbgf[^i %d (0x%04X) jM܂"), *u.pWord, *u.pWord);
		AjcTipTextShow(r.left, r.top, txt, -1, NULL);
	}
	AjcScpRelEventData(hScp, lParam);									//	Cxgf[^J

	return TRUE;
}
//----- EChN[Y ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//----- eLXgM{^ -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SNDTEXT	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		UT	txt[MAX_TXTBOX_LEN];
		UT	snd[MAX_TXTBOX_LEN];
		AjcGetDlgItemStr(hDlg, IDC_TXT_SNDTEXT, txt, AJCTSIZE(txt));
		AjcCLangStrToBin(txt, snd, AJCTSIZE(snd));
		AjcScpSendText(hScp, snd, -1);
	}
	return TRUE;
}
//----- drbM{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SNDESC	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		UT	txt[MAX_TXTBOX_LEN];
		AjcGetDlgItemStr(hDlg, IDC_TXT_SNDESC, txt, AJCTSIZE(txt));
		AjcScpSendChar(hScp, 0x1B);
		AjcScpSendText(hScp, txt, -1);
	}
	return TRUE;
}
//----- oCiM{^ -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SNDBIN	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		UI	ix;
		UTP	p;
		UT	txt[MAX_TXTBOX_LEN];
		UB	bin[MAX_TXTBOX_LEN];
		ix = 0;
		AjcGetDlgItemStr(hDlg, IDC_TXT_SNDBIN, txt, AJCTSIZE(txt));
		if (p = MAjcStrTok(txt, TEXT(" "))) {
			do {
				if (AjcHexStrToUB(p, 2, &bin[ix])) {
					ix++;
				}
			} while (p = MAjcStrTok(NULL, TEXT(" ")));
		}
		if (ix != 0) {
			AjcScpSendBinData(hScp, bin, ix);
		}
	}
	return TRUE;
}
//----- pPbgM{^ -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SNDPKT	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		UI	ix;
		UTP	p;
		UT	txt[MAX_TXTBOX_LEN];
		UB	bin[MAX_TXTBOX_LEN];
		ix = 0;
		AjcGetDlgItemStr(hDlg, IDC_TXT_SNDPKT, txt, AJCTSIZE(txt));
		if (p = MAjcStrTok(txt, TEXT(" "))) {
			do {
				if (AjcHexStrToUB(p, 2, &bin[ix])) {
					ix++;
				}
			} while (p = MAjcStrTok(NULL, TEXT(" ")));
		}
		if (ix != 0) {
			AjcScpSendPacket(hScp, bin, ix);
		}
	}
	return TRUE;
}
//----- PSrbglM{^ ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_SNDWORD14	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		UI	val = AjcGetDlgItemUInt(hDlg, IDC_TXT_SNDWORD14);
		AjcScpSendWord14LF(hScp, val);
	}
	return TRUE;
}
//----- csq`FbN{bNX ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CHK_DTR		)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		AjcScpSetDTR(hScp, AjcGetDlgItemChk(hDlg, IDC_CHK_DTR));
	}
	return TRUE;
}
//----- qsr`FbN{bNX ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CHK_RTS		)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		AjcScpSetRTS(hScp, AjcGetDlgItemChk(hDlg, IDC_CHK_RTS));
	}
	return TRUE;
}
//----- I[v^N[Y {^ ------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_OPEN		)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		if (AjcScpIsOpened(hScp)) {
			AjcScpClose(hScp);
		}
		else {
			AjcScpOpenDefault(hScp);
		}
	}
	return TRUE;
}
//----- ȈՐݒ{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_EASY		)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		AjcScpDlgParamEasy(hScp, hDlg);
	}
	return TRUE;
}
//----- ڍאݒ{^ -----------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_DETAIL	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		AjcScpDlgParamDetail(hScp, hDlg);
	}
	return TRUE;
}
//----- MeLXgGR[h ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_GRP_RXTEC		)
{
	if (HIWORD(wParam) == AJCRBTN_SELECT) {
		//	MeLXgGR[hݒ
		switch (lParam) {
			case 0: AjcScpSetRxTextCode(hScp, AJCSCP_TXT_SJIS);	break;
			case 1: AjcScpSetRxTextCode(hScp, AJCSCP_TXT_UTF8);	break;
			case 2: AjcScpSetRxTextCode(hScp, AJCSCP_TXT_EUC );	break;
			case 3: AjcScpSetRxTextCode(hScp, AJCSCP_TXT_AUTO);	break;
		}
		//	MeLXgGR[hݒiMGR[h AUTO ̏ꍇAMGR[hƓƂ邽߁j
		SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_GRP_TXTEC, AJCRBTN_SELECT), AjcGetDlgItemUInt(hDlg, IDC_GRP_TXTEC));
	}
	return TRUE;
}
//----- MeLXgGR[h ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_GRP_TXTEC		)
{
	if (HIWORD(wParam) == AJCRBTN_SELECT) {
		//	MeLXgGR[hݒ
		switch (lParam) {
			case 0: AjcScpSetTxTextCode(hScp, AJCSCP_TXT_SJIS);	break;
			case 1: AjcScpSetTxTextCode(hScp, AJCSCP_TXT_UTF8);	break;
			case 2: AjcScpSetTxTextCode(hScp, AJCSCP_TXT_EUC );	break;
			case 3: AjcScpSetTxTextCode(hScp, AJCSCP_TXT_AUTO);	break;
		}
	}
	return TRUE;
}
//----- SăNA[{^ -------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_CLRALL	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		AjcVthClear(hWndVthTxtChu	);
		AjcVthClear(hWndVthBinChu	);
		AjcVthClear(hWndVthText		);
		AjcVthClear(hWndVthCtrl		);
		AjcVthClear(hWndVthEsc		);
		AjcVthClear(hWndVthInvChu	);
		AjcVthClear(hWndVthPkt		);
		AjcVthClear(hWndVthNoPkt	);
	}
	return TRUE;
}
//----- usgieLXgj̒ʒm ---------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_VTH_TEXT	)
{
	if (HIWORD(wParam) == AJCVTHN_DROPFILE) {		//	t@Chbv
		UI		i, nFile = (UI)lParam;
		HANDLE	hFile;
		UL		bytes;
		UT		path[MAX_PATH];
		UB		buf[2014];
		for (i = 0; i < nFile; i++) {
			AjcVthGetDroppedFile(hWndVthText, path);
			if ((hFile = CreateFile(path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE) {
				while (ReadFile(hFile, buf, sizeof buf, &bytes, NULL) && bytes != 0) {
					AjcScpSendBinData(hScp, buf, bytes);
				}
				CloseHandle(hFile);
			}
		}
	}
	return TRUE;
}

//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG		)
	AJC_DLGMAP_MSG(Main, WM_DESTROY 		)
	AJC_DLGMAP_MSG(Main, WM_SCPEVENT		)
	AJC_DLGMAP_CMD(Main, IDCANCEL			)
	AJC_DLGMAP_CMD(Main, IDC_CMD_SNDTEXT	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_SNDESC		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_SNDBIN		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_SNDPKT		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_SNDWORD14	)
	AJC_DLGMAP_CMD(Main, IDC_CHK_DTR		)
	AJC_DLGMAP_CMD(Main, IDC_CHK_RTS		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_OPEN		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_EASY		)
	AJC_DLGMAP_CMD(Main, IDC_CMD_DETAIL 	)
	AJC_DLGMAP_CMD(Main, IDC_GRP_RXTEC	 	)
	AJC_DLGMAP_CMD(Main, IDC_GRP_TXTEC	 	)
	AJC_DLGMAP_CMD(Main, IDC_CMD_CLRALL 	)
	AJC_DLGMAP_CMD(Main, IDC_VTH_TEXT	 	)
AJC_DLGMAP_END

//--------------------------------------------------------------------------------------------------------------//
//	t@CM																								//
//--------------------------------------------------------------------------------------------------------------//
VO		SubSendFile(HWND hDlg, C_UTP pFName)
{
	HANDLE	fh;
	UL		bytes;
	UT		path[MAX_PATH];
	UT		buf[1024];

	AjcGetAppPath(path, MAX_PATH);
	MAjcStrCat(path, MAX_PATH, pFName);
	fh = CreateFile(path, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (fh != INVALID_HANDLE_VALUE) {
		while (ReadFile(fh, buf, AJCTSIZE(buf), &bytes, NULL) && bytes != 0) {
			AjcScpSendBinData(hScp, buf, bytes);
		}
		CloseHandle(fh);
	}
	else {
		UT		txt[512];
		AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("'%s' open falure!"), path);
		MessageBox(hDlgMain, txt, TEXT("Error"), MB_ICONERROR);
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	Mԕ\																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO	ShowSignalState(UI sig)
{
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_DSR , (sig & AJCSCP_DSR ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_CTS , (sig & AJCSCP_CTS ) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_RING, (sig & AJCSCP_RING) != 0);
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_RLSD, (sig & AJCSCP_RLSD) != 0);
}

//--------------------------------------------------------------------------------------------------------------//
//	|[gI[v̕\																						//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowOnOpened(VO)
{
	UT	txt[64];

	AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("SW_SerialComPort1 ( %s )"), AjcScpGetPortPathName(hScp));
	SetWindowText(hDlgMain, txt);										//	ECh^Cg
	AjcSetDlgItemStr(hDlgMain, IDC_CMD_OPEN, TEXT("PORT CLOSE"));		//	{^tF[X
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_SETSIG, TRUE, TRUE);			//	Mݒ`FbN{bNXL
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_SIGSTS, TRUE, TRUE);			//	Mԕ\L
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_SEND, TRUE, TRUE);				//	M\L
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_RECV, TRUE, TRUE);				//	M\L
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_DTR , TRUE); 					//	csqݒnm
	AjcSetDlgItemChk(hDlgMain, IDC_CHK_RTS , TRUE); 					//	qsrݒnm
	ShowSignalState(AjcScpGetSigState(hScp));							//	Mԕ\
}
//--------------------------------------------------------------------------------------------------------------//
//	|[gN[Y̕\																						//
//--------------------------------------------------------------------------------------------------------------//
static	VO		ShowOnClosed(VO)
{
	SetWindowText(hDlgMain, TEXT("SW_SerialComPort1 ( Disconnect )"));	//	ECh^Cg
	AjcSetDlgItemStr(hDlgMain, IDC_CMD_OPEN, TEXT("PORT OPEN"));		//	{^tF[X
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_SETSIG, FALSE, FALSE);			//	Mݒ`FbN{bNX
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_SIGSTS, FALSE, FALSE);			//	Mԕ\
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_SEND, FALSE, FALSE);			//	M\
	AjcEnableDlgGroup(hDlgMain, IDC_GRP_RECV, FALSE, FALSE);			//	M\
}
//--------------------------------------------------------------------------------------------------------------//
//	|[g\																								//
//--------------------------------------------------------------------------------------------------------------//
static VO ShowPortName(C_UTP pPortName)
{
	UT		DevName [128];

	AjcSetDlgItemStr(hDlgMain, IDC_LBL_PORTNAME, pPortName);
	if (AjcScpGetPortDevName(pPortName, DevName, AJCTSIZE(DevName))) {
		UT		txt[128];
		AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("(%s)"), DevName);
		AjcSetDlgItemStr(hDlgMain, IDC_LBL_DEVNAME, txt);
	}
	else {
		AjcSetDlgItemStr(hDlgMain, IDC_LBL_DEVNAME, TEXT(""));
	}
}
