//
//	SW_SockServer1.c
//
#define AJCSERIALCOMPORT_H_
#include	<AjrCstXX.h>
#include	"resource.h"

#define	WM_SSVEVENT	(WM_APP + 100)
#define	MAX_TXTBOX_LEN	128

//--------------------------------------------------------------------------------------------------------------//
//	c[`bv																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	int		id;
	C_UTP	pTxt;
} TIPTBL, *PTIPTBL;
typedef const TIPTBL *PCTIPTBL;

static const TIPTBL TipTbl[] = {
	{IDC_TXT_SNDTEXT	, TEXT("b\L̃eLXgݒ肵ĂBiex. ABC\\nj")									},
	{IDC_VTH_TXTCHUNK	, TEXT("A^CɎMf[^eLXgf[^Ƃĕ\܂B\n")
						  TEXT("oCg̏ꍇ́A܂Ŏ̃A^CMf[^҂܂B")			},
	{IDC_VTH_BINCHUNK	, TEXT("A^CɎMf[^oCif[^Ƃĕ\܂B")							},
	{IDC_VTH_INVCHUNK	, TEXT("A^CɎMeLXgf[^ɕsȐR[h܂܂ꍇ́A\n")
						  TEXT("eLXg`Nł͂ȂAs`NeLXgƂăoCi\܂B\n")
						  TEXT("sȐR[hƂ́ATAB(0x09)`CR(0x0D)ȊO̐R[hӖ܂B")					},
	{IDC_VTH_TEXT		, TEXT("MXg[琧R[hiTABȊOjŋ؂ꂽeLXgf[^𔲂oĕ\܂B\n")
						  TEXT("\x1B[34mɃt@ChbvƁAt@C̓eoCif[^ƂđM܂B")	},
	{IDC_VTH_CTRL		, TEXT("MXg[琧R[hiTABȊOj𔲂oĕ\܂B")							},
	{IDC_VTH_ESC		, TEXT("MXg[AdrbV[PXi0x1B`pj𔲂ĕ\܂B")			},
	{IDC_VTH_PKT		, TEXT("MpPbgf[^iDLEESTX`DLEEETX ŃThCb`ꂽf[^joCi\܂B")},
	{IDC_VTH_NOPKT		, TEXT("A^CɎMf[^̃pPbgf[^iDLEESTX`DLEEETXjȊO̕eLXgƂĕ\܂B\n")
						  TEXT("oCg̏ꍇ́A܂Ŏ̃A^CMf[^҂܂B")}
};

#define	MAX_TIPTBL	(sizeof TipTbl / sizeof TipTbl[0])

//--------------------------------------------------------------------------------------------------------------//
//	[N																										//
//--------------------------------------------------------------------------------------------------------------//
static	HINSTANCE		hInst;							//	ckkCX^Xnh
static	HWND			hDlgMain;						//	_CAO{bNXnh
static	HWND			hLbxClients;
static	HAJCSSV 		hSsv;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGPROC_DEF(Main);
AJC_DLGPROC_DEF(Client);
static	VO	SetRxTextCode(HWND hDlg);
static	VO	SetTxTextCode(HWND hDlg);

//==============================================================================================================//
//																												//
//	W i n M a i n																								//
//																												//
//==============================================================================================================//
int WINAPI AjcWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, UTP szCmdLine, int iCmdShow)
{
	MSG 	msg;

	//----- CE_CAOI[v -----------------//
	hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, AJC_DLGPROC_NAME(Main));
	//----- _CAO\ -----------------------------//
	ShowWindow(hDlgMain, SW_SHOW);
	//----- bZ[W[v ---------------------------//
	while (GetMessage(&msg, NULL, 0, 0)) {
		do {
			if (IsDialogMessage(hDlgMain, &msg)) break;
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		} while (0);
	}
	return (int)msg.wParam ;
}
//==============================================================================================================//
//																												//
//	C _CAOEvV[W																				//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_INITDIALOG 	)
{
	UL		lHost;
	UT		szHost[128];
	UT		txt[256];

	hDlgMain		= hDlg;
	hLbxClients		= GetDlgItem(hDlg, IDC_LBX_CLIENTS);

	//	EChʒu[h
	AjcLoadWndPos(hDlg, NULL);
	//	WI{^̃O[v
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_RXTEC));
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_TXTEC));
	//	ECh^Cg\
	lHost = AJCTSIZE(szHost);
	GetComputerName(szHost, &lHost);
	AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("SW_SockServer1 ( %s : 14238 )"), szHost);
	SetWindowText(hDlg, txt);
	//	zXg\
	AjcSetDlgItemStr(hDlg, IDC_LBL_MYNAME, szHost);
	//	_CAOڂ̏
	AjcSetDlgItemUInt(hDlg, IDC_TXT_PORTNO 	 , 14238);
	AjcSetDlgItemUInt(hDlg, IDC_TXT_MAXCLIENT, 10	);
	AjcSetDlgItemChk (hDlg, IDC_RBT_RXSJIS	 , TRUE	);
	AjcSetDlgItemChk (hDlg, IDC_RBT_RXUTF8	 , FALSE);
	AjcSetDlgItemChk (hDlg, IDC_RBT_RXEUC	 , FALSE);
	AjcSetDlgItemChk (hDlg, IDC_RBT_RXAUTO	 , FALSE);
	AjcSetDlgItemChk (hDlg, IDC_RBT_TXSJIS	 , TRUE	);
	AjcSetDlgItemChk (hDlg, IDC_RBT_TXUTF8	 , FALSE);
	AjcSetDlgItemChk (hDlg, IDC_RBT_TXEUC	 , FALSE);
	AjcSetDlgItemChk (hDlg, IDC_RBT_TXAUTO	 , FALSE);
	AjcSetDlgItemUInt(hDlg, IDC_GRP_RXTEC	 , 0	);
	AjcSetDlgItemUInt(hDlg, IDC_GRP_TXTEC	 , 0	);
	//	\PbgT[o CX^X
	hSsv = AjcSsvCreate();
	//	MeLXgR[hݒ
	SetRxTextCode(hDlg);
	SetTxTextCode(hDlg);
	//	`N[hݒ
	AjcSsvSetChunkMode(hSsv, AJCSSV_CM_BOTH);
	//	_CAOڂ̃[h
	AjcLoadAllControlSettings (hDlg, TEXT("DlgSetting"), AJCOPT3(AJCCTL_SELACT_, ALL, NTCCHK, NTCRBT));

	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
//	NCAgE_CAO N[Y
static BOOL CALLBACK cbDisconnect(HAJCSSVCLI hCli, UX cbp)
{
	HWND	hDlgCli;
	if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
		DestroyWindow(hDlgCli);
	}
	return TRUE;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
AJC_DLGPROC(Main, WM_DESTROY		)
{
	//	EChʒuZ[u
	AjcSaveWndPos(hDlg, NULL);
	//	SNCAg_CAO N[Y
	AjcSsvEnumClients(hSsv, 0, cbDisconnect);
	//	_CAOڂ̃Z[u
	AjcSaveAllControlSettings(hDlg);
	//	\PbgT[o CX^X
	AjcSsvDelete(hSsv);

	PostQuitMessage(0);
	return TRUE;
}
//----- WM_COMMAND ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_COMMAND	 	)
{
	int		id = LOWORD(wParam);
	if (HIWORD(wParam) == BN_CLICKED) {
		if		(id >= IDC_RBT_RXSJIS && id <= IDC_RBT_RXAUTO) SetRxTextCode(hDlg);
		else if (id >= IDC_RBT_TXSJIS && id <= IDC_RBT_TXAUTO) SetRxTextCode(hDlg);
	}
	return TRUE;
}
//----- \Pbg(TCP/IP)Cxg -------------------------------------------------------------------------------//
AJC_DLGPROC(Main, WM_SSVEVENT		)
{
	UI		time = GetTickCount();
	UI		len, param;
	union {UTP pTxt; BCP pBcp; UBP pBin; VOP pVop;} u;
	HAJCSSVCLI	hCli = NULL;
	UI			ThreadId = 0;
	UT			szIpAddr[256] = {0};
	HWND		hDlgCli;
	HWND		hLog, hVth;

	//	Cxgf[^擾
	AjcSsvGetEventData(hSsv, lParam, &u.pVop, &len, &param);
	//	NCAg擾ANCAĝhoAhXݒ
	if (AjcSsvGetClient   (hSsv, lParam, &hCli)) {
		ThreadId = AjcSsvGetThreadId(hCli);
		AjcSsvGetIpAddrStr(hCli, szIpAddr, AJCTSIZE(szIpAddr));
	}

	switch (wParam) {
		case AJCSSV_EV_START:									//T[oJnʒm
			//	T[oJn^I{^LύX
			AjcEnableDlgItem(hDlgMain, IDC_CMD_START, FALSE);
			AjcEnableDlgItem(hDlgMain, IDC_CMD_STOP , TRUE );
			//	Rg[̖
			AjcEnableDlgItem(hDlg, IDC_TXT_PORTNO	, FALSE);
			AjcEnableDlgItem(hDlg, IDC_TXT_MAXCLIENT, FALSE);
			AjcEnableDlgGroup(hDlg, IDC_GRP_RXTEC	, FALSE, FALSE);
			AjcEnableDlgGroup(hDlg, IDC_GRP_TXTEC	, FALSE, FALSE);
			break;

		case AJCSSV_EV_STOP:									//T[o~ʒm
			//	T[oJn^I{^LύX
			AjcEnableDlgItem(hDlgMain, IDC_CMD_START, TRUE );
			AjcEnableDlgItem(hDlgMain, IDC_CMD_STOP , FALSE);
			//	Rg[̗L
			AjcEnableDlgItem(hDlg, IDC_TXT_PORTNO	, TRUE);
			AjcEnableDlgItem(hDlg, IDC_TXT_MAXCLIENT, TRUE);
			AjcEnableDlgGroup(hDlg, IDC_GRP_RXTEC	, TRUE, TRUE);
			AjcEnableDlgGroup(hDlg, IDC_GRP_TXTEC	, TRUE, TRUE);
			break;

		case AJCSSV_EV_CONNECT:									//ڑʒm
		{	int		ix;
			UT		txt[256];
			//	NCAgp_CAO
			hDlgCli = CreateDialogParam(hInst, MAKEINTRESOURCE(IDD_CLIENT), NULL, AJC_DLGPROC_NAME(Client), (LPARAM)hCli);
			AjcSnPrintF(txt, AJCTSIZE(txt), TEXT("NCAgEChiIP-Address = %s, Thread-ID = 0x%08Xj"), szIpAddr, ThreadId);
			SetWindowText(hDlgCli, txt);
			ShowWindow(hDlgCli, SW_SHOW);
			//	NCAgɃ_CAO֘At
			AjcSsvSetClientData(hCli, (UX)hDlgCli);
			//	Xg{bNXɃNCAgo^
			ix = AjcLbxAddString(hLbxClients, szIpAddr);
			AjcLbxSetItemData(hLbxClients, ix, (UX)hCli);
			break;
		}
		case AJCSSV_EV_DISCONNECT:								//ؒfʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				int		ix;
				//	NCAg_CAO
				DestroyWindow(hDlgCli);
				//	Xg{bNXNCAg폜
				if ((ix = AjcLbxFindString(hLbxClients, -1, szIpAddr)) >= 0) {
					AjcLbxDeleteString(hLbxClients, ix);
				}
			}
			break;

		case AJCSSV_EV_RXCHUNK:									//`Nf[^Mʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				AjcVthPrintF(hLog, TEXT("%9d: RXCHUNK   len=%5d, param=0x%08X\n"), time, len, param);
				//	oCi`N
				if (param == 0) {
					hVth = GetDlgItem(hDlgCli, IDC_VTH_BINCHUNK);
					AjcVthHexDump(hVth, (C_VOP)u.pBin, len);
					AjcVthPrintF (hVth, TEXT("\n"));
				}
				//	eLXg`N
				else {
					hVth = GetDlgItem(hDlgCli, IDC_VTH_TXTCHUNK);
					AjcVthPutText(hVth, u.pTxt, -1);
				}
			}
			break;

		case AJCSSV_EV_RXTEXT:									//eLXgf[^ʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				hVth = GetDlgItem(hDlgCli, IDC_VTH_TEXT);
				AjcVthPrintF(hLog, TEXT("%9d: RXTEXT    len=%5d, param=0x%08X\n"), time, len, param);
				AjcVthPrintF(hVth, TEXT("%s\n"), u.pTxt);
			}
			break;

		case AJCSSV_EV_RXESC:									//drbf[^ʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				hVth = GetDlgItem(hDlgCli, IDC_VTH_ESC);
				AjcVthPrintF(hLog, TEXT("%9d: RXESC     len=%5d, param=0x%08X\n"), time, len, param);
				AjcVthPrintF(hVth, TEXT("\\x1B%s\n"), u.pTxt + 1);
			}
			break;

		case AJCSSV_EV_RXCTRL:									//R[hʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				hVth = GetDlgItem(hDlgCli, IDC_VTH_CTRL);
				AjcVthPrintF(hLog, TEXT("%9d: RXCTRL    len=%5d, param=0x%08X, data=%02X\n"), time, len, param, *u.pBin);
				AjcVthPrintF(hVth, TEXT("%02X\n"), *u.pTxt);
			}
			break;

		case AJCSSV_EV_RXPKT:									//pPbgf[^ʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				hVth = GetDlgItem(hDlgCli, IDC_VTH_PKT);
				AjcVthPrintF (hLog, TEXT("%9d: RXPKT     len=%5d, param=0x%08X\n"), time, len, param);
				AjcVthHexDump(hVth, (C_VOP)u.pBin, len);
				AjcVthPrintF (hVth, TEXT("\n"));
			}
			break;

		case AJCSSV_EV_TXEMPTY:									//Mʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				AjcVthPrintF(hLog, TEXT("%9d: TXEMPTY   len=%5d, param=0x%08X\n"), time, len, param);
			}
			break;

		case AJCSSV_EV_RXNOPKT:									//pPbgOeLXgf[^
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				hVth = GetDlgItem(hDlgCli, IDC_VTH_NOPKT);
				AjcVthPrintF (hLog, TEXT("%9d: RXNOPKT   len=%5d, param=0x%08X\n"), time, len, param);
				AjcVthPutText(hVth, u.pTxt, -1);
			}
			break;

		case AJCSSV_EV_INVCHUNK:								//s`NeLXgMʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				hVth = GetDlgItem(hDlgCli, IDC_VTH_INVCHUNK);
				AjcVthPrintF (hLog, TEXT("%9d: INVCHUNK  len=%5d, param=0x%08X\n"), time, len, param);
				AjcVthHexDump(hVth, (C_VOP)u.pBin, len);
				AjcVthPrintF (hVth, TEXT("\n"));
			}
			break;

		case AJCSSV_EV_RXERR:									//MG[ʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				AjcVthPrintF(hLog, TEXT("%9d: RXERR     len=%5d, param=0x%08X\n"), time, len, param);
			}
			break;

		case AJCSSV_EV_TXERR:									//MG[ʒm
			if (AjcSsvGetClientData(hCli, (UXP)&hDlgCli)){
				hLog = GetDlgItem(hDlgCli, IDC_VTH_EVTLOG);
				AjcVthPrintF(hLog, TEXT("%9d: TXERR     len=%5d, param=0x%08X\n"), time, len, param);
			}
			break;

		case AJCSSV_EV_ERR:										//̑̃G[ʒm
			hLog = GetDlgItem(hDlgMain, IDC_VTH_ERROR);
			AjcVthPrintF(hLog, TEXT("%9d: ERR       len=%5d, param=0x%08X\n"), time, len, param);
			break;

	}

	//	Cxgf[^J
	AjcSsvRelEventData(hSsv, lParam);
			
	return TRUE;
}
//----- T[oJn{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_START		)
{
	UI		MaxClient;
	UT		szPort[64];	

	if (HIWORD(wParam) == BN_CLICKED) {
		AjcGetDlgItemStr (hDlg, IDC_TXT_PORTNO, szPort, AJCTSIZE(szPort));
		MaxClient = AjcGetDlgItemUInt(hDlg, IDC_TXT_MAXCLIENT);
		AjcSsvStart(hSsv, szPort, AF_INET, MaxClient, hDlg, WM_SSVEVENT);
	}
	return TRUE;
}
//----- T[o~{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_CMD_STOP		)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		AjcSsvStop(hSsv, 10000);
	}
	return TRUE;
}
//----- MeLXgGR[h ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_GRP_RXTEC		)
{
	if (HIWORD(wParam) == AJCRBTN_SELECT) {
		//	MeLXgGR[hݒ
		switch (lParam) {
			case 0: AjcSsvSetRxTextCode(hSsv, AJCSSV_TXT_SJIS);	break;
			case 1: AjcSsvSetRxTextCode(hSsv, AJCSSV_TXT_UTF8);	break;
			case 2: AjcSsvSetRxTextCode(hSsv, AJCSSV_TXT_EUC );	break;
			case 3: AjcSsvSetRxTextCode(hSsv, AJCSSV_TXT_AUTO);	break;
		}
		//	MeLXgGR[hݒiMGR[h AUTO ̏ꍇAMGR[hƓƂ邽߁j
		SendMessage(hDlg, WM_COMMAND, MAKELONG(IDC_GRP_TXTEC, AJCRBTN_SELECT), AjcGetDlgItemUInt(hDlg, IDC_GRP_TXTEC));
	}
	return TRUE;
}
//----- MeLXgGR[h ---------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDC_GRP_TXTEC		)
{
	if (HIWORD(wParam) == AJCRBTN_SELECT) {
		//	MeLXgGR[hݒ
		switch (lParam) {
			case 0: AjcSsvSetTxTextCode(hSsv, AJCSSV_TXT_SJIS);	break;
			case 1: AjcSsvSetTxTextCode(hSsv, AJCSSV_TXT_UTF8);	break;
			case 2: AjcSsvSetTxTextCode(hSsv, AJCSSV_TXT_EUC );	break;
			case 3: AjcSsvSetTxTextCode(hSsv, AJCSSV_TXT_AUTO);	break;
		}
	}
	return TRUE;
}
//----- LZ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Main, IDCANCEL			)
{
	DestroyWindow(hDlg);
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Main)
	AJC_DLGMAP_MSG(Main, WM_INITDIALOG	   )
	AJC_DLGMAP_MSG(Main, WM_DESTROY 	   )
	AJC_DLGMAP_MSG(Main, WM_COMMAND 	   )
	AJC_DLGMAP_MSG(Main, WM_SSVEVENT 	   )

	AJC_DLGMAP_CMD(Main, IDC_CMD_START	   )
	AJC_DLGMAP_CMD(Main, IDC_CMD_STOP	   )
	AJC_DLGMAP_CMD(Main, IDC_GRP_RXTEC	   )
	AJC_DLGMAP_CMD(Main, IDC_GRP_TXTEC	   )
	AJC_DLGMAP_CMD(Main, IDCANCEL		   )
AJC_DLGMAP_END
//==============================================================================================================//
//																												//
//	NCAg _CAOEvV[W																		//
//																												//
//==============================================================================================================//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Client, WM_INITDIALOG 	)
{
	HAJCSSVCLI	hCli = (HAJCSSVCLI)lParam;
	UI			i;
	UT			szIpAddr[256];
	UT			sect[256];
	//	_CAOɃNCAgnh֘At
	SetProp(hDlg, TEXT("ClientHandle"), (HANDLE)lParam);
	//	hoAhX擾
	AjcSsvGetIpAddrStr(hCli, szIpAddr, AJCTSIZE(szIpAddr));
	//	EChʒu[h
	AjcSnPrintF(sect, AJCTSIZE(sect), TEXT("WndPos_%s"), szIpAddr);
	AjcLoadWndPos(hDlg, sect);
	//	 ݒl[h
	AjcSnPrintF(sect, AJCTSIZE(sect), TEXT("Settings_%s"), szIpAddr);
	AjcLoadAllControlSettings(hDlg, sect, AJCCTL_SELACT_ALL);
	//	eLXg{bNXݒ
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SNDTEXT, MAX_TXTBOX_LEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SNDESC , MAX_TXTBOX_LEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SNDBIN , MAX_TXTBOX_LEN - 1);
	AjcSetDlgItemEdtLimit(hDlg, IDC_TXT_SNDPKT , MAX_TXTBOX_LEN - 1);
	//----- c[`bvݒ ------------------------//
	for (i = 0; i < MAX_TIPTBL; i++) {
		AjcTipTextAdd(GetDlgItem(hDlg, TipTbl[i].id), TipTbl[i].pTxt);
	}
	return TRUE;
}
//----- EChj -------------------------------------------------------------------------------------------//
AJC_DLGPROC(Client, WM_DESTROY		)
{
	HAJCSSVCLI	hCli = (HAJCSSVCLI)GetProp(hDlg, TEXT("ClientHandle"));
	UT			szIpAddr[256];
	UT			sect[256];
	//	hoAhX擾
	AjcSsvGetIpAddrStr(hCli, szIpAddr, AJCTSIZE(szIpAddr));
	//	EChʒuZ[u
	AjcSnPrintF(sect, AJCTSIZE(sect), TEXT("WndPos_%s"), szIpAddr);
	AjcSaveWndPos(hDlg, sect);
	//	 ݒlZ[u
	AjcSnPrintF(sect, AJCTSIZE(sect), TEXT("Settings_%s"), szIpAddr);
	AjcSaveAllControlSettings(hDlg);
	return TRUE;
}
//----- eLXgM{^ -------------------------------------------------------------------------------------//
AJC_DLGPROC(Client, IDC_CMD_SNDTEXT			)
{
	HAJCSSVCLI	hCli = (HAJCSSVCLI)GetProp(hDlg, TEXT("ClientHandle"));
	UT			txt[MAX_TXTBOX_LEN];
	UT			snd[MAX_TXTBOX_LEN];
	AjcGetDlgItemStr(hDlg, IDC_TXT_SNDTEXT, txt, AJCTSIZE(txt));
	AjcCLangStrToBin(txt, snd, AJCTSIZE(snd));
	AjcSsvSendText(hCli, snd, -1);
	return TRUE;
}
//----- drbM{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(Client, IDC_CMD_SNDESC			)
{
	HAJCSSVCLI	hCli = (HAJCSSVCLI)GetProp(hDlg, TEXT("ClientHandle"));
	UT			txt[MAX_TXTBOX_LEN];
	AjcGetDlgItemStr(hDlg, IDC_TXT_SNDESC, txt, AJCTSIZE(txt));
	AjcSsvSendChar(hCli, 0x1B);
	AjcSsvSendText(hCli, txt, -1);
	return TRUE;
}
//----- oCiM{^ -------------------------------------------------------------------------------------//
AJC_DLGPROC(Client, IDC_CMD_SNDBIN			)
{
	HAJCSSVCLI	hCli = (HAJCSSVCLI)GetProp(hDlg, TEXT("ClientHandle"));
	UI	ix;
	UTP	p;
	UT	txt[MAX_TXTBOX_LEN];
	UB	bin[MAX_TXTBOX_LEN];
	ix = 0;
	AjcGetDlgItemStr(hDlg, IDC_TXT_SNDBIN, txt, AJCTSIZE(txt));
	if (p = MAjcStrTok(txt, TEXT(" "))) {
		do {
			if (AjcHexStrToUB(p, 2, &bin[ix])) {
				ix++;
			}
		} while (p = MAjcStrTok(NULL, TEXT(" ")));
	}
	if (ix != 0) {
		AjcSsvSendBinData(hCli, bin, ix);
	}
	return TRUE;
}
//----- pPbgM{^ -------------------------------------------------------------------------------------//
AJC_DLGPROC(Client, IDC_CMD_SNDPKT			)
{
	HAJCSSVCLI	hCli = (HAJCSSVCLI)GetProp(hDlg, TEXT("ClientHandle"));
	UI	ix;
	UTP	p;
	UT	txt[MAX_TXTBOX_LEN];
	UB	bin[MAX_TXTBOX_LEN];
	ix = 0;
	AjcGetDlgItemStr(hDlg, IDC_TXT_SNDPKT, txt, AJCTSIZE(txt));
	if (p = MAjcStrTok(txt, TEXT(" "))) {
		do {
			if (AjcHexStrToUB(p, 2, &bin[ix])) {
				ix++;
			}
		} while (p = MAjcStrTok(NULL, TEXT(" ")));
	}
	if (ix != 0) {
		AjcSsvSendPacket(hCli, bin, ix);
	}
	return TRUE;
}
//----- ؒf{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Client, IDC_CMD_DISC			)
{
	HAJCSSVCLI	hCli = (HAJCSSVCLI)GetProp(hDlg, TEXT("ClientHandle"));
	AjcSsvDisconnect(hCli);
	return TRUE;
}
//----- LZ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(Client, IDCANCEL			)
{
	HAJCSSVCLI	hCli = (HAJCSSVCLI)GetProp(hDlg, TEXT("ClientHandle"));
	//	NCAgؒf
	AjcSsvDisconnect(hCli);
	//	_CAON[Y
	DestroyWindow(hDlg);
	return TRUE;
}
//----- SăNA[{^ -------------------------------------------------------------------------------------//
AJC_DLGPROC(Client, IDC_CMD_CLRALL	)
{
	if (HIWORD(wParam) == BN_CLICKED) {
		AjcVthClear(GetDlgItem(hDlg, IDC_VTH_TXTCHUNK));
		AjcVthClear(GetDlgItem(hDlg, IDC_VTH_BINCHUNK));
		AjcVthClear(GetDlgItem(hDlg, IDC_VTH_TEXT	 ));
		AjcVthClear(GetDlgItem(hDlg, IDC_VTH_CTRL	 ));
		AjcVthClear(GetDlgItem(hDlg, IDC_VTH_ESC	 ));
		AjcVthClear(GetDlgItem(hDlg, IDC_VTH_INVCHUNK));
		AjcVthClear(GetDlgItem(hDlg, IDC_VTH_PKT	 ));
		AjcVthClear(GetDlgItem(hDlg, IDC_VTH_NOPKT	 ));
	}
	return TRUE;
}
//----- usgieLXgj̒ʒm ---------------------------------------------------------------------------//
AJC_DLGPROC(Client, IDC_VTH_TEXT	)
{
	HAJCSSVCLI	hCli = (HAJCSSVCLI)GetProp(hDlg, TEXT("ClientHandle"));

	if (HIWORD(wParam) == AJCVTHN_DROPFILE) {		//	t@Chbv
		UI		i, nFile = (UI)lParam;
		HANDLE	hFile;
		UL		bytes;
		UT		path[MAX_PATH];
		UB		buf[2014];
		HWND	hVth = GetDlgItem(hDlg, IDC_VTH_TEXT);

		for (i = 0; i < nFile; i++) {
			AjcVthGetDroppedFile(hVth, path);
			if ((hFile = CreateFile(path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE) {
				while (ReadFile(hFile, buf, sizeof buf, &bytes, NULL) && bytes != 0) {
					AjcSsvSendBinData(hCli, buf, bytes);
				}
				CloseHandle(hFile);
			}
		}
	}
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(Client)
	AJC_DLGMAP_MSG(Client, WM_INITDIALOG	)
	AJC_DLGMAP_MSG(Client, WM_DESTROY		)

	AJC_DLGMAP_CMD(Client, IDC_CMD_SNDTEXT	)
	AJC_DLGMAP_CMD(Client, IDC_CMD_SNDESC	)
	AJC_DLGMAP_CMD(Client, IDC_CMD_SNDBIN	)
	AJC_DLGMAP_CMD(Client, IDC_CMD_SNDPKT	)
	AJC_DLGMAP_CMD(Client, IDC_CMD_DISC		)
	AJC_DLGMAP_CMD(Client, IDC_CMD_CLRALL	)
	AJC_DLGMAP_CMD(Client, IDCANCEL			)
	AJC_DLGMAP_CMD(Client, IDC_VTH_TEXT		)
AJC_DLGMAP_END
//--------------------------------------------------------------------------------------------------------------//
//	MeLXgGR[hݒ																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetRxTextCode(HWND hDlg)
{
	if		(AjcGetDlgItemChk(hDlg, IDC_RBT_RXSJIS)) AjcSsvSetRxTextCode(hSsv, AJCSSV_TXT_SJIS);
	else if (AjcGetDlgItemChk(hDlg, IDC_RBT_RXUTF8)) AjcSsvSetRxTextCode(hSsv, AJCSSV_TXT_UTF8);
	else if (AjcGetDlgItemChk(hDlg, IDC_RBT_RXEUC )) AjcSsvSetRxTextCode(hSsv, AJCSSV_TXT_EUC );
	else											 AjcSsvSetRxTextCode(hSsv, AJCSSV_TXT_AUTO);
}
//--------------------------------------------------------------------------------------------------------------//
//	MeLXgGR[hݒ																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetTxTextCode(HWND hDlg)
{
	if		(AjcGetDlgItemChk(hDlg, IDC_RBT_TXSJIS)) AjcSsvSetTxTextCode(hSsv, AJCSSV_TXT_SJIS);
	else if (AjcGetDlgItemChk(hDlg, IDC_RBT_TXUTF8)) AjcSsvSetTxTextCode(hSsv, AJCSSV_TXT_UTF8);
	else if (AjcGetDlgItemChk(hDlg, IDC_RBT_TXEUC )) AjcSsvSetTxTextCode(hSsv, AJCSSV_TXT_EUC );
	else											 AjcSsvSetTxTextCode(hSsv, AJCSSV_TXT_AUTO);
}
