//
//	SW_VMbxC.c
//
#include	<AjrCstXX.h>
#include	<process.h>
#include	<tchar.h>

//----- [f[^ ---------------------------------------------------------------------------------------//
typedef enum {
	CMD_STR = 1 ,			//	ʒm
	CMD_END 				//	I
} CMDCODE;

//----- [f[^` ---------------------------------------------------------------------------------------//
typedef struct {
	CMDCODE 	cmd;		//	[f[^
	UTP 		pStr2;		//	Qւ̃|C^
	UT			Str1[64];	//	P
} MAILDATA, *PMAILDATA;


//==============================================================================================================//
//																												//
//	[f[^쐬																							//
//																												//
//==============================================================================================================//
static	UI		MakeMailData(PMAILDATA pBuf, CMDCODE cmd, C_UTP pStr1, C_UTP pStr2)
{
	UI	lStr1 = (UI)MAjcStrLen(pStr1) + 1;
	UI	lStr2 = (UI)MAjcStrLen(pStr2) + 1;

	pBuf->cmd	= cmd;
	MAjcStrCpy(pBuf->Str1, AJCTSIZE(pBuf->Str1), pStr1);
	pBuf->pStr2 = AjcTAlloc(lStr2);
	MAjcStrCpy(pBuf->pStr2, lStr2, pStr2);

	return sizeof(MAILDATA) - sizeof pBuf->Str1 + (lStr1 * sizeof(UT));
}
//==============================================================================================================//
//																												//
//	j[f[^ʒmpR[obN֐																		//
//																												//
//==============================================================================================================//
static	VO	CALLBACK	cbRemove(VOP pD, UI lDat, UX cbp)
{
	PMAILDATA	pDat = (PMAILDATA)pD;
	AjcPrintF(TEXT("Removed: len=%3d, %s %s\n"), lDat, pDat->Str1, pDat->pStr2);
	AjcTFree(pDat->pStr2);
}
//==============================================================================================================//
//																												//
//	TuXbh																								//
//																												//
//==============================================================================================================//
static	VO		SubThread(VOP param)
{
	HAJCVMBX	hVMbx = (HAJCVMBX)param;
	UI			lDat;
	MAILDATA	MailData;

	//----- PbŕCXbhɒʒmiRj-----------//
	lDat = MakeMailData(&MailData, CMD_STR, TEXT("Apple is" ), TEXT("fruit"    ));
	AjcVMbxEnque(hVMbx, &MailData, lDat);
	Sleep(1000);
	lDat = MakeMailData(&MailData, CMD_STR, TEXT("Dog is"	), TEXT("animal"   ));
	AjcVMbxEnque(hVMbx, &MailData, lDat);
	Sleep(1000);
	lDat = MakeMailData(&MailData, CMD_STR, TEXT("Flower is"), TEXT("beautiful"));
	AjcVMbxEnque(hVMbx, &MailData, lDat);
	Sleep(1000);
	//----- CXbhɏIʒm ------------------------------//
	lDat = MakeMailData(&MailData, CMD_END, TEXT("The"), TEXT("End"));
	AjcVMbxEnque(hVMbx, &MailData, lDat);
	//----- ]ȃf[^ʒm ----------------------------------------//
	lDat = MakeMailData(&MailData, CMD_STR, TEXT("Remained"), TEXT("Data 1"));
	AjcVMbxEnque(hVMbx, &MailData, lDat);
	lDat = MakeMailData(&MailData, CMD_STR, TEXT("Remained"), TEXT("Data 2"));
	AjcVMbxEnque(hVMbx, &MailData, lDat);
	//----- TuXbhI ----------------------------------------//
	_endthread();
}

//==============================================================================================================//
//																												//
//	m a i n 																									//
//																												//
//==============================================================================================================//
int 	AjcMain(int argc, UTP argv[])
{
	HAJCVMBX	hVMbx;
	MAILDATA	MailData;
	UI			lDat;
	BOOL		fEnd = FALSE;

	AjcSetStdoutMode();

	//----- [{bNXECX^X ------------------------//
	hVMbx = AjcVMbxCreate(0, cbRemove);
	//----- TuXbh ----------------------------------------//
	_beginthread(SubThread, 0, hVMbx);
	Sleep(1);
	//----- TuXbh̒ʒm҂[v ------------------------//
	MailData.cmd = 0;
	while (!fEnd) {
		memset(&MailData, 0, sizeof MailData);
		if ((lDat = AjcVMbxDequeEx(hVMbx, &MailData, sizeof MailData, 300)) != -1) {	// TuXbh̒ʒmH
			switch (MailData.cmd) {
				case CMD_STR:												//		 ʒm
					AjcPrintF(TEXT("String : len=%3d, %s %s\n"), lDat, MailData.Str1, MailData.pStr2);
					AjcTFree(MailData.pStr2);
					break;

				case CMD_END:												//		 Iʒm
					AjcPrintF(TEXT("Exit   : len=%3d, %s %s\n"), lDat, MailData.Str1, MailData.pStr2);
					AjcTFree(MailData.pStr2);
					fEnd = TRUE;
					break;
			}
		}
		else {																//	^CAEgH
			AjcPrintF(TEXT("Timeout!\n"));
		}
	}
	Sleep(100);

	//----- c[f[^j ------------------------------------//
	AjcVMbxPurge(hVMbx);

	//----- [{bNXECX^X ------------------------//
	AjcVMbxDelete(hVMbx);

	getchar();
	return	0;
}

