//
//	Sil_SerialComPort1
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using CAjrCustCtrl;

namespace Sil_SerialComPort1
{
	public partial class Form1 : Form
	{
		bool m_FirstText = true;

		public Form1()
		{
			InitializeComponent();
		}
		//----- Nݒ ------------------------------------------------//
		private void Form1_Load(object sender, EventArgs e)
		{
			this.Text = this.Text + (IntPtr.Size == 4 ? " (WIN32)" : " (WIN64)");
			//	TCYύX֎~
			this.FormBorderStyle = FormBorderStyle.FixedSingle;
			//	c[`bvݒ
			SAjrTip.Add(txtSndBin  , "oCif[^iQ̂PUi󔒂ŋ؂ājݒ肵Ă");
			SAjrTip.Add(txtSndPkt  , "pPbgf[^iQ̂PUi󔒂ŋ؂ājݒ肵Ă");
			SAjrTip.Add(vthTxtChunk, "A^CɎMf[^eLXgf[^Ƃĕ\܂B\n" +
									 "oCg̏ꍇ́A܂Ŏ̃A^CMf[^҂܂B");
			SAjrTip.Add(vthBinChunk, "A^CɎMf[^oCif[^Ƃĕ\܂B");
			SAjrTip.Add(vthInv	   , "A^CɎMeLXgf[^ɕsȐR[h܂܂ꍇ́A\n" +
									 "eLXg`Nł͂ȂAs`NeLXgƂăoCi\܂B\n" +
									 "sȐR[hƂ́ATAB(0x09)`CR(0x0D)ȊO̐R[hӖ܂B");
			SAjrTip.Add(vthPkt	   , "MpPbgf[^iDLEESTX`DLEEETX ŃThCb`ꂽf[^joCi\܂B");
			SAjrTip.Add(vthNoPkt   , "A^CɎMf[^̃pPbgf[^iDLEESTX`DLEEETXjȊO̕eLXgƂĕ\܂B\n" +
									 "oCg̏ꍇ́A܂Ŏ̃A^CMf[^҂܂B");
			SAjrTip.Add(vthTxt	   , "MXg[琧R[hiTABȊOjŋ؂ꂽeLXgf[^𔲂oĕ\܂B\n" +
									 "Ƀt@ChbvƁAt@C̓eoCiM܂B");
			SAjrTip.Add(vthCtrl    , "MXg[琧R[hiTABȊOj𔲂oĕ\܂B");
			SAjrTip.Add(vthEsc	   , "MXg[AdrbV[PXi0x1B`pj𔲂ĕ\܂B");
			//	EChʒu[h
			SAjrReg.LoadWndPos(this);
			//	ݒl[h
			SAjrReg.LoadAllCtrls(this);
			//	rbo
			scp.Init();
			//	|[g\
			ShowPortName(scp.GetPortName());
			//	Mo
			scp.SetRTS(chkRTS.Checked);
			scp.SetDTR(chkDTR.Checked);
			//	eLXgGR[hݒ
			 SetTextEncode();
		}
		//----- tH[I --------------------------------------------------//
		private void Form1_FormClosed(object sender, FormClosedEventArgs e)
		{
			//	EChʒuZ[u
			SAjrReg.SaveWndPos(this);
			//	ݒlZ[u
			SAjrReg.SaveAllCtrls(this);
		}
		//----- p^ݒ{^ --------------------------------------------//
		private void btnSetParam_Click_1(object sender, EventArgs e)
		{
			scp.SetParamByDialog(this.Handle);
		}
		//----- |[g I[v^N[Y@{^ -----------------------------//
		private void btnOpenClose_Click(object sender, EventArgs e)
		{
			if (scp.IsOpened) {
				scp.Close();
			}
			else {
				scp.Open();
			}
		}
		//----- eLXgM{^ --------------------------------------------//
		private void btnSndTxt_Click_1(object sender, EventArgs e)
		{
			scp.SendText(txtSndTxt.Text + "\n");
		}
		//----- drbM{^ ----------------------------------------------//
		private void btnSndEsc_Click(object sender, EventArgs e)
		{
			scp.SendText("\x1B" + txtSndEsc.Text);
		}
		//----- oCiM{^ --------------------------------------------//
		private void btnSndBin_Click(object sender, EventArgs e)
		{
			string[] arr = txtSndBin.Text.Split(' ');
			int 	n = 0;
			//	LȐZo
			for  (int i = 0; i < arr.Length; i++) {
				if (IsByteHexa(arr[i])) n++;
			}
			if (n != 0) {
				//		MoCi쐬
				Byte[] BArr = new Byte[n];

				int 	ix = 0;
				for  (int i = 0; i < arr.Length; i++) {
					if (IsByteHexa(arr[i])) {BArr[ix++] = Convert.ToByte(arr[i], 16);}
				}
				if (ix != 0) {
					scp.SendBinary(BArr);
				}
			}
		}
		//----- pPbgM{^ ---------------------------------------------//
		private void btnSndPkt_Click(object sender, EventArgs e)
		{
			string[] arr = txtSndPkt.Text.Split(' ');
			int 	n = 0;
			//	LȐZo
			for  (int i = 0; i < arr.Length; i++) {
				if (IsByteHexa(arr[i])) n++;
			}
			if (n != 0) {
				//		MoCi쐬
				Byte[] BArr = new Byte[n];

				int 	ix = 0;
				for  (int i = 0; i < arr.Length; i++) {
					if (IsByteHexa(arr[i])) {BArr[ix++] = Convert.ToByte(arr[i], 16);}
				}
				if (ix != 0) {
					scp.SendPacket(BArr);
				}
			}
		}
		//	PSrbglM{^
		private void btnSnd14_Click(object sender, EventArgs e)
		{
			scp.SendWord14LF(inp14Bit.IntValue);
		}
		//	SăNA[{^
		private void btnClearAll_Click(object sender, EventArgs e)
		{
			vthTxtChunk.Purge();
			vthBinChunk.Purge();
			vthTxt	   .Purge();
			vthCtrl    .Purge();
			vthEsc	   .Purge();
			vthInv	   .Purge();
			vthPkt	   .Purge();
			vthNoPkt   .Purge();
		}
		//----- qsrMo -------------------------------------------------//
		private void chkRTS_CheckedChanged(object sender, EventArgs e)
		{
			scp.SetRTS(chkRTS.Checked);
		}
		//----- csqMo -------------------------------------------------//
		private void chkDTR_CheckedChanged(object sender, EventArgs e)
		{
			scp.SetDTR(chkDTR.Checked);
		}
		//----------------------------------------------------------------------//
		//	rboCxgʒm													//
		//----------------------------------------------------------------------//
		//----- |[gԒʒm -------------------------------------------------//
		private void scp_OnPortState(object sender, ScpArgPortState e)
		{
			ShowPortName(e.name);
			if (e.state == EScpPortState.Opened) {
				lblPortState.Text = "Opened";
				btnOpenClose.Text = "Close";
				scp.SetRTS(chkRTS.Checked);
				scp.SetDTR(chkDTR.Checked);
				chkCTS.Checked	= scp.GetCTS();
				chkDSR.Checked	= scp.GetDSR();
				chkRLSD.Checked = scp.GetRLSD();
				chkRING.Checked = scp.GetRING();
				ShowPortName(e.name);
			}
			else if (e.state == EScpPortState.Closed) {
				lblPortState.Text = "Closed";
				btnOpenClose.Text = "Open";
			}
			else if (e.state == EScpPortState.OpenFailure) {
				SAjrTip.ShowCenter(this, "\x1B[31m" + "Port(" + e.name + ") Open failure");
			}
			else if (e.state == EScpPortState.MySlotFail) {
				SAjrTip.ShowCenter(this, "\x1B[31m" + "MySlot(" + e.name + ") Creation failure");
			}
		}
		//----- oCi`Nf[^Mʒm ---------------------------------//
		unsafe private void scp_OnRxChunkBin(object sender, ScpArgRxChunkBin e)
		{
			vthBinChunk.PrintHexDump(e.bin);
			vthBinChunk.PutText("\n");
		}
		//----- s`NeLXgMʒm -----------------------------------//
		private void scp_OnRxInvChunk(object sender, ScpArgRxInvChunk e)
		{
			vthInv.PrintHexDump(e.bin);
			vthInv.PutText("\n");
		}
		//----- eLXg`NMʒm ---------------------------------------//
		private void scp_OnRxChunkTxt(object sender, ScpArgRxChunkTxt e)
		{
			vthTxtChunk.PutText(e.text);
		}
		//----- eLXgMʒm -----------------------------------------------//
		private void scp_OnRxText(object sender, ScpArgRxText e)
		{
			if (m_FirstText) {
				vthTxt.Purge();
				m_FirstText = false;
			}
			vthTxt.PutText(e.text + "\n");
		}
		//----- drbf[^Mʒm -------------------------------------------//
		private void scp_OnRxEsc(object sender, ScpArgRxEsc e)
		{
			vthEsc.PutText("\\x1B" + e.esc.Substring(1));
			vthEsc.PutText("\n");
		}
		//----- R[hMʒm ---------------------------------------------//
		private void scp_OnRxCtrl(object sender, ScpArgRxCtrl e)
		{
			int c = (int)e.ctrl;
			vthCtrl.PutFormat("0x{0:X2}\n", c);
		}
		//----- pPbgf[^Mʒm -----------------------------------------//
		private void scp_OnRxPacket(object sender, ScpArgRxPacket e)
		{
			if (e.bin != null) {
				vthPkt.PrintHexDump(e.bin);
				vthPkt.PutText("\n");
			}
		}
		//----- pPbgOeLXgMʒm -------------------------------------//
		private void scp_OnRxNoPkt(object sender, ScpArgRxNoPkt e)
		{
			vthNoPkt.PutText(e.text);
		}
		//----- PSrbglMʒm -------------------------------------------//
		private void scp_OnRxWord14(object sender, ScpArgRxWord14 e)
		{
			if (chkView14.Checked) {
				Point pt = chkView14.ClientRectangle.Location;
				pt =  chkView14.PointToScreen(pt);
				SAjrTip.Show(pt.X +  chkView14.Size.Width + 5, pt.Y - 4, "14Bit value is received : " + e.data.ToString() +
																		" (0x" + e.data.ToString("X4") + ")");
			}
		}
		//----- bsrMωʒm ---------------------------------------------//
		private void scp_OnNtcCTS(object sender, ScpArgNtcCTS e)
		{
			chkCTS.Checked	= e.cts;
			chkDSR.Checked	= e.dsr;
			chkRLSD.Checked = e.rlsd;
			chkRING.Checked = e.ring;
		}
		//----- crqMωʒm ---------------------------------------------//
		private void scp_OnNtcDSR(object sender, ScpArgNtcDSR e)
		{
			chkCTS.Checked = e.cts;
			chkDSR.Checked = e.dsr;
			chkRLSD.Checked = e.rlsd;
			chkRING.Checked = e.ring;
		}
		//----- qkrcMωʒm -------------------------------------------//
		private void scp_OnNtcRLSD(object sender, ScpArgNtcRLSD e)
		{
			chkCTS.Checked = e.cts;
			chkDSR.Checked = e.dsr;
			chkRLSD.Checked = e.rlsd;
			chkRING.Checked = e.ring;
		}
		//----- qhmfMωʒm -------------------------------------------//
		private void scp_OnNtcRING(object sender, ScpArgNtcRING e)
		{
			chkCTS.Checked = e.cts;
			chkDSR.Checked = e.dsr;
			chkRLSD.Checked = e.rlsd;
			chkRING.Checked = e.ring;
		}
		//----- eLXg\EChɃt@Chbv -------------------------//
		private void vthTxt_OnFileDrop(object sender, VthArgFileDrop e)
		{
			for (int i = 0; i < e.n; i++) {
				string path = vthTxt.GetDroppedFile();
				byte[] buf = new byte[1024];
				long   FileSize;
				int    ReadSize;
				FileStream fs = new FileStream(path, FileMode.Open, FileAccess.Read);
				FileSize = fs.Length;
				while (FileSize >= 1024) {
					ReadSize = fs.Read(buf, 0, 1024);
					FileSize -= ReadSize;
					scp.SendBinary(buf);
				}
				if (FileSize > 0) {
					buf = new byte[FileSize];
					fs.Read(buf, 0, (int)FileSize);
					scp.SendBinary(buf);
				}
				fs.Dispose();
			}
		}
		//----- |[g\ ---------------------------------------------------//
		private bool ShowPortName(string name)
		{
			bool	rc = false;
			lblPortName.Text = name;
			string pn = scp.GetPortDevName(name);
			if (pn != "") {
				lblDevName.Text  = "(" + pn + ")";
			}
			else {
				lblDevName.Text  = "";
			}
			return rc;
		}
		//----- PUi`FbN -------------------------------------------//
		private bool IsByteHexa(string s)
		{
			bool	rc = false;
			do {
				 if (string.IsNullOrEmpty(s)) break;
				 if (s.Length != 2) break;
				 if (!Uri.IsHexDigit(s[0])) break;
				 if (!Uri.IsHexDigit(s[1])) break;
				 rc = true;
			 } while (false);
			return rc;
		}
		//----- MeLXgGR[hݒ胉WI{^ -------------------------//
		private void rbtRxSJis_CheckedChanged(object sender, EventArgs e) {SetTextEncode();}
		private void rbtRxUTF8_CheckedChanged(object sender, EventArgs e) {SetTextEncode();}
		private void rbtRxEuc_CheckedChanged (object sender, EventArgs e) {SetTextEncode();}
		private void rbtRxAuto_CheckedChanged(object sender, EventArgs e) {SetTextEncode();}
		//----- MeLXgGR[hݒ胉WI{^ -------------------------//
		private void rbtTxSJis_CheckedChanged(object sender, EventArgs e) {SetTextEncode();}
		private void rbtTxUTF8_CheckedChanged(object sender, EventArgs e) {SetTextEncode();}
		private void rbtTxEuc_CheckedChanged (object sender, EventArgs e) {SetTextEncode();}
		private void rbtTxAuto_CheckedChanged(object sender, EventArgs e) {SetTextEncode();}
		//	eLXgGR[hݒ
		private void SetTextEncode()
		{
			if		(rbtRxSJis.Checked) scp.RxTextCode = EScpRxTextCode.SJIS;
			else if (rbtRxUTF8.Checked) scp.RxTextCode = EScpRxTextCode.UTF8;
			else if (rbtRxEuc .Checked) scp.RxTextCode = EScpRxTextCode.EUC;
			else if (rbtRxAuto.Checked) scp.RxTextCode = EScpRxTextCode.AUTO;

			if		(rbtTxSJis.Checked) scp.TxTextCode = EScpTxTextCode.SJIS;
			else if (rbtTxUTF8.Checked) scp.TxTextCode = EScpTxTextCode.UTF8;
			else if (rbtTxEuc .Checked) scp.TxTextCode = EScpTxTextCode.EUC;
			else if (rbtTxAuto.Checked) scp.TxTextCode = EScpTxTextCode.SJIS;

		}
	}
}
