//
//	Sil_TimeChart1
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CAjrCustCtrl;

namespace Sil_TimeChart1
{
	public partial class Form1 : Form
	{
		double	m_Theta = 0.0;
		bool	m_fStop = true;

		public Form1()
		{
			InitializeComponent();
		}
		//----- Nݒ ---------------------------------------//
		private void Form1_Load(object sender, EventArgs e)
		{
			this.Text = this.Text + (IntPtr.Size == 4 ? " (WIN32)" : " (WIN64)");
			//----- tH[̏cTCYύX֎~ -----------------------//
			int width  = this.Width;
			int height = this.Height;
			this.MinimumSize = new Size(width, height);
			this.MaximumSize = new Size(1900 , height);
			//----- ^CgeLXgݒ -----------------------------//
            tch1.SetTitleText(" Op֐ ", Color.Blue, Color.Aqua, 
												new Font("MS UI Gothic", 9, FontStyle.Bold | FontStyle.Italic));
			tch2.SetTitleText(" ʍW ", Color.Blue, Color.Aqua,
                                                new Font("MS UI Gothic", 9, FontStyle.Bold | FontStyle.Italic));
            //----- ߃eLXg` ---------------------------------//
            tch1.TextOut(Txo.Center, 3, "\x1B[30mSin \x1B[31mCos \x1B[32mTan");
            tch2.TextOut(Txo.Center, 3, "\x1B[30mw \x1B[31mx \x1B[32my");
            //----- ݒl[h -------------------------------------//
			SAjrReg.LoadAllCtrls(this);
		}
		//----- I㏈ -----------------------------------------//
		private void Form1_FormClosed(object sender, FormClosedEventArgs e)
		{
			//	ݒlZ[u
			SAjrReg.SaveAllCtrls(this);
		}
		//----- ^C}Cxg ---------------------------------------//
		private void tim_Tick(object sender, EventArgs e)
		{
			if (!m_fStop) {
				//	f[^^i^C`[gPj
				double s = SAjrMath.Sin(m_Theta);
				double c = SAjrMath.Cos(m_Theta);
				double t = SAjrMath.Tan(m_Theta);
				t = Math.Min(t,  2.0);
				t = Math.Max(t, -2.0);
				tch1.PutData(s, c, t);
				m_Theta += 1.0;
                //  O\
                vth1.PutText(string.Format("x={0,5:f2}, y={1,5:f2} z={2,5:f2}\n", s, c, t));
				//	f[^^i^C`[gQj
				AJC3DVEC	v = spd.Calc();
				tch2.PutData(v.x, v.y, v.z);
                //  O\
                vth2.PutText(string.Format("x={0,5:f2}, y={1,5:f2} z={2,5:f2}\n", v.x, v.y, v.z));
			}
		}
		//----- ^C`[g1EXN[ʒm ----------------------//
		private void tch1_OnNtcScrollPos(object sender, TchArgNtcScrollPos e)
		{
			if (m_fStop) {
				tch2.SetScrollPos(e.pos);
			}
		}
		//----- ^C`[g1EWωʒm ----------------------//
		private void tch1_OnRangeChanged(object sender, TchArgRangeChanged e)
		{
			SAjrTip.ShowCenter(tch1, "Wݒ肳܂B");
		}
		//----- ^C`[g1EENbNʒm ----------------------//
		private void tch1_OnRClick(object sender, TchArgRClick e)
		{
			SAjrTip.ShowCenter(tch1, (e.ctrl ? "CTRL + " : "") + (e.shift ? "SHIFT + " : "") +
									 "ENbN (x = " + e.x.ToString() + ", y = " + e.y.ToString() + ")");
		}
		//----- ^C`[g1EfBNghbvʒm ------------//
		private void tch1_OnDirDrop(object sender, TchArgDirDrop e)
		{
			string text = "fBNghbv܂B";
			for (int i = 0; i < e.n; i++) {
				text = text + "\n  " + tch1.GetDroppedDir();
			}
			SAjrTip.ShowCenter(tch1, text);
		}
		//----- ^C`[g1Et@Chbvʒm ----------------//
		private void tch1_OnFileDrop(object sender, TchArgFileDrop e)
		{
			string text = "t@Chbv܂B";
			for (int i = 0; i < e.n; i++) {
				text = text + "\n  " + tch1.GetDroppedFile();
			}
			SAjrTip.ShowCenter(tch1, text);
		}
		//----- ^C`[gQEXN[ʒm ---------------------//
		private void tch2_OnNtcScrollPos(object sender, TchArgNtcScrollPos e)
		{
			if (m_fStop) {
				tch1.SetScrollPos(e.pos);
			}
		}
		//----- ^C`[gQEWωʒm ---------------------//
		private void tch2_OnRangeChanged(object sender, TchArgRangeChanged e)
		{
			SAjrTip.ShowCenter(tch2, "Wݒ肳܂B");
		}
		//----- ^C`[gQEENbNʒm ---------------------//
		private void tch2_OnRClick(object sender, TchArgRClick e)
		{
			SAjrTip.ShowCenter(tch2, "ENbN (x = " + e.x.ToString() + ", y = " + e.y.ToString() + ")");
		}
		//----- ^C`[gQEfBNghbvʒm -----------//
		private void tch2_OnDirDrop(object sender, TchArgDirDrop e)
		{
			string text = "fBNghbv܂B";
			for (int i = 0; i < e.n; i++) {
				text = text + "\n  " + tch2.GetDroppedDir();
			}
			SAjrTip.ShowCenter(tch2, text);
		}
		//----- ^C`[gQEt@Chbvʒm ---------------//
		private void tch2_OnFileDrop(object sender, TchArgFileDrop e)
		{
			string text = "t@Chbv܂B";
			for (int i = 0; i < e.n; i++) {
				text = text + "\n  " + tch2.GetDroppedFile();
			}
			SAjrTip.ShowCenter(tch2, text);
		}
		//----- vbgJn^~{^ -----------------------------//
		private void btnStart_Click(object sender, EventArgs e)
		{
			if (m_fStop) {
				tch1.Start();
				tch2.Start();
				tim.Enabled = true;
				m_fStop 	= false;
				btnStart.Text = "vbg~";
			}
			else {
				tch1.Stop();
				tch2.Stop();
				tim.Enabled = false;
				m_fStop 	= true;
				btnStart.Text = "vbgJn";
			}
		}
		//----- vbgύXʒm ---------------------------------//
		private void cAjrInpValue1_OnNtcIntValue(object sender, IvArgNtcIntValue e)
		{
			tim.Interval = e.value;
		}
		//----- Enable {^ ----------------------------------------//
		private void btnEnable_Click(object sender, EventArgs e)
		{
			tch1.Enabled = true;
			tch2.Enabled = true;
		}
		//----- Disable {^ ---------------------------------------//
		private void btnDisable_Click(object sender, EventArgs e)
		{
			tch1.Enabled = false;
			tch2.Enabled = false;
		}
		//----- X^Cݒ`FbN{bNXQ -----------------------//
		private void chkShowBorder_CheckedChanged	 (object sender, EventArgs e) {tch1.ShowBorder	   = chkShowBorder	  .Checked;}
		private void chkShowFilter_CheckedChanged	 (object sender, EventArgs e) {tch1.ShowFilter	   = chkShowFilter	  .Checked;}
		private void chkShowScaleLine_CheckedChanged (object sender, EventArgs e) {tch1.ShowScaleLine  = chkShowScaleLine .Checked;}
		private void chkShowScaleValue_CheckedChanged(object sender, EventArgs e) {tch1.ShowScaleValue = chkShowScaleValue.Checked;}
		//----- f[^ڂ̕\Fݒ{^Q -----------------------//
		private void btnColor0_Click(object sender, EventArgs e) {SetItemColor(0);}
		private void btnColor1_Click(object sender, EventArgs e) {SetItemColor(1);}
		private void btnColor2_Click(object sender, EventArgs e) {SetItemColor(2);}
		//----- f[^ڂ̕\Fݒ -------------------------------//
		private void SetItemColor(int id)
		{
			ColorDialog cd = new ColorDialog();
			cd.Color = tch1.GetItemColor(id);
			if (cd.ShowDialog() == DialogResult.OK)
			{
				tch1.SetItemColor(id, cd.Color);
			}
		}
	}
}
