//
//	SP_AVL.cpp
//
#include	<AjxCpp.h>
#include	<tchar.h>
using namespace AjxControl;

//	m[hf[^`
typedef struct {
	UTP 	pTimStr;			//	q[v̎ւ̃|C^
} NODEDATA, *PNODEDATA;

//----- CAjxAvl, CAjxCon ̔hNX --------------------------------------------------------------------------//
class CAjxAvlEx : public CAjxAvl, public CAjxCon
{
private:
	NODEDATA	m_Node;
public:
	//	RXgN^im[ho^j
	CAjxAvlEx()
	{
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited  50")); InsNode( 50, &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited  60")); InsNode( 60, &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited  70")); InsNode( 70, &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited  80")); InsNode( 80, &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited  90")); InsNode( 90, &m_Node, sizeof m_Node);
		_tcscpy_s((m_Node.pTimStr = AjcTAlloc(16)), 16, TEXT("Pre-Inited 100")); InsNode(100, &m_Node, sizeof m_Node);
	}
	//	fXgN^
	~CAjxAvlEx()
	{
		//	fXgNg OnNtcRemove() 𔭐ɂ DelAllNodes() \bhs܂
		DelAllNodes();
	}
	//	m[h폜ʒm
	VO OnNtcRemove (UX key, VOP pNodeData, UI len, UI nest) override
	{
		SAjxCon::PrintF(TEXT("m[h폜܂ - key=%4u, len=%d, nest=%d, data='%s'\n"), (UI)key, len, nest, ((PNODEDATA)pNodeData)->pTimStr);
		AjcTFree(((PNODEDATA)pNodeData)->pTimStr);
	}

	//	m[h񋓒ʒm
	BOOL OnNtcNode	(UX key, VOP pNodeData, UI len, UI nest) override
	{
		PAJCAVLNODE pNode = ((PAJCAVLNODE)pNodeData) - 1;
		SAjxCon::PrintF(TEXT("%-26s:%*u, %d\n"), ((PNODEDATA)pNodeData)->pTimStr, nest * 6, (UI)key, pNode->bal);
		return TRUE;
	}
	//	̓eLXgʒm(ASCII)
	VO		OnNtcStr(int argc, UT *argv[], C_UTP pTxt) override
	{
		//	̓eLXg\
		SAjxCon::PrintF(TEXT("%s\n"), pTxt);
		//	R}hs
		if (argc >= 1) {
			//	m[h}
			if		(_tcsicmp(argv[0], TEXT("I")) == 0) {
				if (argc == 2) {
					if (!InsNode(_ttoi(argv[1]), &(m_Node.pTimStr = GetTimeStr()), sizeof m_Node)) {
						if (m_Node.pTimStr != NULL) AjcTFree(m_Node.pTimStr); m_Node.pTimStr = NULL;
						SAjxCon::PrintF(TEXT("m[h̑}s܂B\n"));
					}
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	m[hu
			else if (_tcsicmp(argv[0], TEXT("R")) == 0) {
				if (argc == 2) {
					if (!RepNode(_ttoi(argv[1]), &(m_Node.pTimStr = GetTimeStr()), sizeof m_Node)) {
						if (m_Node.pTimStr != NULL) AjcTFree(m_Node.pTimStr); m_Node.pTimStr = NULL;
						SAjxCon::PrintF(TEXT("m[h̒us܂B\n"));
					}
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	m[h̑}^u
			else if (_tcsicmp(argv[0], TEXT("X")) == 0) {
				if (argc == 2) {
					if (!InsOrRepNode(_ttoi(argv[1]), &(m_Node.pTimStr = GetTimeStr()), sizeof m_Node)) {
						if (m_Node.pTimStr != NULL) AjcTFree(m_Node.pTimStr); m_Node.pTimStr = NULL;
						SAjxCon::PrintF(TEXT("m[h̑}^us܂B\n"));
					}
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	m[h폜
			else if (_tcsicmp(argv[0], TEXT("D"))  == 0) {
				if (argc == 2) {
					if (!DelNode(_ttoi(argv[1]))) {
						SAjxCon::PrintF(TEXT("m[h̍폜s܂B\n"));
					}
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	Sm[hj
			else if (_tcsicmp(argv[0], TEXT("A"))  == 0) {
				if (!DelAllNodes()) {
					SAjxCon::PrintF(TEXT("Sm[h̍폜s܂B\n"));
				}
			}
			//	Sm[h\
			else if (_tcsicmp(argv[0], TEXT("P"))  == 0) {
				EnumNodes(TRUE);
			}
			//	̑
			else {
				SAjxCon::PrintF(TEXT("*** Invalid command.\n"));
			}
		}
	}

private:
	//	ݎ񐶐iݎi[AIւ̃|C^Ԃj
	UTP		GetTimeStr()
	{
		UTP			rc;
		SYSTEMTIME	st;
		UI			len;
		UT			szTim[64];

		GetLocalTime(&st);
		AjcSnPrintF(szTim, AJCTSIZE(szTim), TEXT("%02d:%02d:%02d.%03d"), st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
		len = (UI)_tcslen(szTim) + 1;
		MAjcStrCpy(rc = AjcTAlloc(len), len, szTim);
		return rc;
	}
};

//----- m a i n ------------------------------------------------------------------------------------------------//
int AjcMain()
{
	CAjxAvlEx avl;

	SAjxCon::SetStdMode();

	//	R}hj[
	SAjxCon::PrintF(TEXT("\n ȉ̃R}h͂ĂB\n\n"));
	SAjxCon::PrintF(TEXT("  I   nnn     : m[h}, key=nnn\n"));
	SAjxCon::PrintF(TEXT("  R   nnn     : m[hu, key=nnn\n"));
	SAjxCon::PrintF(TEXT("  X   nnn     : m[h̑}^u, key=nnn\n"));
	SAjxCon::PrintF(TEXT("  D   nnn     : m[h폜, key=nnn\n"));
	SAjxCon::PrintF(TEXT("  A           : Sm[hj\n"));
	SAjxCon::PrintF(TEXT("  P           : Sm[h\"));
	SAjxCon::PrintF(TEXT("  <ESC>L[   : I\n"));
	SAjxCon::PrintF(TEXT("\n"));

	//	m[h\
	avl.EnumNodes(TRUE);
	//	R}h͂j[s
	SAjxCon::PrintF(TEXT("Input(%3u) - "), avl.GetCount());
	while (avl.Input(TEXT(""))) {
		SAjxCon::PrintF(TEXT("Input(%3u) - "), avl.GetCount());
	}
	return 0;
}
