//
//	SP_HSO.c
//
#include	<AjxCpp.h>
#include	<tchar.h>
using namespace AjxControl;

//----- e[uizj ---------------------------------------------------------------------------------------//
typedef struct {
	UTP		pName;		//	O
	UI		birth;		//	aN
} TBL, *PTBL;
typedef const TBL *PCTBL;

static	TBL		tbl[] = {
	{TEXT("Y"	), 700},
	{TEXT("Y"	), 600},
	{TEXT("YY"), 800},
	{TEXT("P"), 500},
	{TEXT("ږ"	), 150},
};

#define	MAX_TBL	((sizeof tbl) / (sizeof tbl[0]))

//----- CAjxHso ̌pNX -----------------------------------------------------------------------------------//
class CAjxHsoEx : public CAjxHso
{
public:
	int OnComp(C_VOP pElm1, C_VOP pElm2, BOOL *pStop) override {
		PCTBL	p1 = (PCTBL)pElm1;
		PCTBL	p2 = (PCTBL)pElm2;
		return (p1->birth - p2->birth);
	}
};

CAjxHsoEx	hso;

//==============================================================================================================//
int  AjcMain(int argc, UTP argv[])
{
	SAjxCon::SetStdMode();

	//	e[u\[g
	hso.Sort(tbl, MAX_TBL, sizeof tbl[0]);
	//	\[gσe[u\
	for (int i = 0; i < MAX_TBL; i++) {
		SAjxCon::PrintF(TEXT(" Birth = %4d, Name = %s\n"), tbl[i].birth, tbl[i].pName);
	}

	SAjxCon::PrintF(TEXT("\nHit Enter Key!!"));
	getchar();

	return 0;
}

