//
//	SP_QUEX.cpp
//
#include	<AjxCpp.h>
#include	<tchar.h>

using namespace AjxControl;

static const UTP IniTxt[] = {TEXT("200"), TEXT("300"), TEXT("400")};

//	m[hf[^
typedef struct {
	UTP		pStr;
} NODE, *PNODE;


class CAjxXQueEx : public CAjxXQue, public CAjxCon
{
public:
	//	RXgN^im[h̃ftHgTCYݒj
	CAjxXQueEx() {
		SetDefSize(sizeof(NODE));
	}
	//	fXgN^
	~CAjxXQueEx()
	{
		//	fXgNg OnNtcRemove() 𔭐ɂ Purge() \bhs܂
		Purge();
	}
	//	m[hʒm
	VO OnNtcRemove	(VOP pNodeData, UI len) override
	{
		PNODE	pNode = (PNODE)pNodeData;
		SAjxCon::PrintF(TEXT(" m[h폜 %p -> %p : %s, len = %d\n"), pNode, pNode->pStr, pNode->pStr, len);
		AjcTFree(pNode->pStr);
	}
	//	̓eLXgʒm(ASCII)
	VO		OnNtcStr(int argc, UT *argv[], C_UTP pTxt)
	{
		UI		bytes, len, seq;
		NODE	node;
		PNODE	pNode;

		//	̓eLXg\
		SAjxCon::PrintF(TEXT("%s\n"), pTxt);
		if (argc >= 1) {
			//	f[^m[h𖖔ɑ}
			if		(_tcsicmp(argv[0], TEXT("Q")) == 0) {
				if (argc == 2) {
					node.pStr = AjcTAlloc(len = (UI)_tcslen(argv[1]) + 1);
					_tcscpy_s(node.pStr, len, argv[1]); 
					Enque(&node);
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	f[^m[h擪ɑ}
			else if (_tcsicmp(argv[0], TEXT("QT")) == 0) {
				if (argc == 2) {
					node.pStr = AjcTAlloc(len = (UI)_tcslen(argv[1]) + 1);
					_tcscpy_s(node.pStr, len, argv[1]); 
					EnqTop(&node);
				}
				else SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	m[hf[^ꗗ\ij
			else if (_tcsicmp(argv[0], TEXT("L")) == 0) {
				seq = 0;
				if (pNode = (PNODE)TopNode(&bytes)) {
					do {
						SAjxCon::PrintF(TEXT("%2d - %p -> %p : %s\n"), seq++, pNode, pNode->pStr, pNode->pStr);
					} while(pNode = (PNODE)NextNode(pNode, &bytes));
				}
			}
			//	m[hf[^ꗗ\i~j
			else if (_tcsicmp(argv[0], TEXT("LD")) == 0) {
				seq = GetCount()- 1;
				if (pNode = (PNODE)LastNode(&bytes)) {
					do {
						SAjxCon::PrintF(TEXT("%2d - %p -> %p : %s\n"), seq++, pNode, pNode->pStr, pNode->pStr);
					} while(pNode = (PNODE)PrevNode(pNode, &bytes));
				}
			}
			//	nnnԖڂ̃m[h폜
			else if (_tcsicmp(argv[0], TEXT("R"))  == 0) {
				if (argc == 2 && (pNode = (PNODE)GetNodeAddr(_ttoi(argv[1])))) Remove(pNode);
				else														   SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));
			}
			//	nnnԖڂ̃m[h̒O^Ƀm[h}
			else if (_tcsicmp(argv[0], TEXT("I"))  == 0) {
				node.pStr = AjcTAlloc(len = (UI)_tcslen(argv[1]) + 1);
				_tcscpy_s(node.pStr, len, argv[1]); 
				if		(argc == 3 && (pNode = (PNODE)GetNodeAddr(_ttoi(argv[2])))) Insert(&node, (UI)sizeof node, pNode);
				else if (argc == 2												  ) Insert(&node, (UI)sizeof node, NULL);
				else  {AjcTFree(node.pStr); SAjxCon::PrintF(TEXT("*** Invalid parameter.\n"));}
			}
			//	Sm[hoĕ\
			else if (_tcsicmp(argv[0], TEXT("G"))  == 0) {
				seq = 0;
				while ((Deque(&node, sizeof node)) != -1) {
					SAjxCon::PrintF(TEXT("%2d - %p : %s\n"), seq++, node.pStr, node.pStr);
				}
			}
			//	Sm[hj
			else if (_tcsicmp(argv[0], TEXT("A"))  == 0) {
				Purge();
			}
			//	m[hwb_̃_v\
			else if (_tcsicmp(argv[0], TEXT("DMP"))  == 0) {
				seq = 0;
				if (pNode = (PNODE)TopNode(&bytes)) {
					do {
						PAJCXQNODE pH = ((PAJCXQNODE)pNode) - 1;
						SAjxCon::PrintF(TEXT("%2d - %p : id = %08X, prev = %p, next = %p, ")
										TEXT("len = %d, dat = %p -> %p : %s\n"),
										seq++, pH, pH->id, pH->pBfr, pH->pNxt, pH->len, pNode, pNode->pStr, pNode->pStr);
					} while(pNode = (PNODE)NextNode(pNode, &bytes));
				}
			}
			//	̑
			else {
				SAjxCon::PrintF(TEXT("*** Invalid command.\n"));
			}
		}
	}
	//	m[hAhX擾
	VOP		GetNodeAddr(UI ix)
	{
		VOP			rc = NULL;
		UI			n;
		MAJCXQUEPTR(PTRARR, UTP)
		PPTRARR pArr = (PPTRARR)CreatePtrArr(&n);
		if (ix < n) {
			rc = (VOP)pArr[ix].pNode;
		}
		ReleasePtrArr((PCAJCXQUEPTR)pArr);
		return rc;
	}
};

int AjcMain()
{
	CAjxXQueEx	que;

	SAjxCon::SetStdMode();
	SAjxCon::SetBufSize(128, 64);
	SAjxCon::SetWndRect(0, 0, 127, 30);

	//	R}hj[
	SAjxCon::PrintF(TEXT("\n ȉ̃R}h͂ĂB\n\n"));
	SAjxCon::PrintF(TEXT("  Q   <>     : f[^m[h𖖔ɑ}\n"));
	SAjxCon::PrintF(TEXT("  QT  <>     : f[^m[h擪ɑ}\n"));
	SAjxCon::PrintF(TEXT("  L                : m[hf[^ꗗ\ij\n"));
	SAjxCon::PrintF(TEXT("  LD               : m[hf[^ꗗ\i~j\n"));
	SAjxCon::PrintF(TEXT("  R    nnn         : nnn(0`)Ԗڂ̃m[h폜\n"));
	SAjxCon::PrintF(TEXT("  I   <> nnn : nnn(0`)Ԗڂ̃m[h̒Oɕf[^m[h}\n"));
	SAjxCon::PrintF(TEXT("  I   <>     : f[^m[h𖖔ɑ}\n"));
	SAjxCon::PrintF(TEXT("  G                : Sm[hoĕ\\n"));
	SAjxCon::PrintF(TEXT("  A                : Sm[hj\n"));
	SAjxCon::PrintF(TEXT("  DMP              : m[hwb_̃_v\\n"));
	SAjxCon::PrintF(TEXT("  <ESC>L[        : I\n"));
	SAjxCon::PrintF(TEXT("\n"));

	//	R}h͂j[s
	SAjxCon::PrintF(TEXT("Input(%3u) - "), que.GetCount());
	while (que.Input(TEXT(""))) {
		SAjxCon::PrintF(TEXT("Input(%3u) - "), que.GetCount());
	}

	return 0;
}
