//
//	SP_SSV2.cpp
//
#include	<AjxCpp.h>
#include	<stdio.h>
#include	<conio.h>
#include	<time.h>
#include	<tchar.h>
using namespace AjxControl;

//----- [N -------------------------------------------------------------------------------------------------//
static	BOOL	fServEnd = FALSE;		//	T[o~tO

//----- X̃NCAgNXiCAjxSsvCli̔hNXj -------------------------------------------------//
class CAjxSsvCliEx : public CAjxSsvCli {
	HAJCSSVCLI	m_hCli;
	UI			m_line;
	ULL			m_Bytes;
	UI			m_SeqNo;
public:
	//	RXgN^
	CAjxSsvCliEx(HAJCSSVCLI hCli = NULL)	{
		CAjxSsvCli::SetCliHandle(m_hCli = hCli);
		m_line =  0;
		m_Bytes = 0;
		m_SeqNo = GetSeqNo();
	}
	//	NCAgڑʒm
	VO	OnNtcConnect	()	override {
		UT	szAddr[128];
		GetIpAddrStr(szAddr, 128);
		SAjxCon::PrintF(TEXT("- %-16s : ڑ܂B\n"), szAddr);
	}
	//	NCAgؒfʒm
	VO	OnNtcDisconnect	()		override {
		UT	szAddr[128];
		GetIpAddrStr(szAddr, 128);
		SAjxCon::PrintF(TEXT("- %-16s : ؒf܂B\n"), szAddr);
	}
	//	oCi`NMʒm
	VO	OnNtcRxBinChunk	(C_VOP pData, UI Bytes)		override {
		SendBinData(pData, Bytes); // ̂܂ܕԐM
	}
};
//----- T[oNXiCAjxSsvSvr̔hNXj -------------------------------------------------------------//
class CAjxSsvEx : public CAjxSsvSvr {
public:
	//----- T[oCxg ---------------------------------------------------------------------//
	//	T[oJnʒm
	VO		OnNtcStart				()			override {
		SAjxCon::PrintF(TEXT("- T[oJn܂B\n"));
	}
	//	T[o~ʒm
	VO		OnNtcStop				()			override {
		SAjxCon::PrintF(TEXT("- T[o~܂B\n"));
		fServEnd = TRUE;
	}
	//	G[ʒm
	VO		OnNtcError				(UI err)	override {
		SAjxCon::PrintF(TEXT("*** G[(%d) ***\n"), err);
	}
	//	NCAg񋓒ʒm
	BOOL		OnNtcClients	(HAJCSSVCLI hCli, CAjxSsvCli* pCli)
	{
		pCli->Disconnect();
		return TRUE;  // TRUE:񋓌p
	}
	//----- NCAgCxg ---------------------------------------------------------------//
	//	NCAgڑʒm
	CAjxSsvCli*	OnNtcConnect	(HAJCSSVCLI hCli)						override {
		//	NCAgNX
		CAjxSsvCliEx* pCli = new CAjxSsvCliEx(hCli);
		return pCli;
	}
	//	NCAgؒfʒm
	VO			OnNtcDisconnect	(HAJCSSVCLI hCli, CAjxSsvCli* pCli)		override {
		//	NCAgNX
		delete (CAjxSsvCliEx*)pCli;
	}
};
static	CAjxSsvEx	ssv;

//==============================================================================================================//
int  AjcMain(int argc, UTP argv[])
{
	SAjxCon::SetStdMode();

	//	KChbZ[W\
	DWORD	bytes;
	UT		szHostName[256];
	bytes = (sizeof szHostName);
	GetComputerName(szHostName, &bytes);
	SAjxCon::PrintF(TEXT("TCP/IP GR[ET[o@\s܂B(%s:14238)\n")
					TEXT("NCAgMf[^̂܂ܕԐM܂B\n")
					TEXT("NCAg͂Q܂Őڑł܂B")
					TEXT("ꂩ̃L[ƏI܂B\n\n"), szHostName);

	//	T[oJn
	ssv.Start	(TEXT("14238"), 2);
	ssv.SetEvtMask(AJCSSV_EV_GENERAL | AJCSSV_EV_RXCHUNK | AJCSSV_EV_ERR);
	ssv.SetChunkMode(AJCSSV_CM_BIN);

	//	T[o~܂ŃCxg҂[v
	BOOL	fStop = FALSE;
	while (!fServEnd) {
		//	ꂩ̃L[ŃT[o~
		if (_kbhit() && !fStop) {
			ssv.EnumClients();	//	NCAg񋓁iڑ̃NCAgؒfj
								//	͓̏ɎsȂĂnjłiT[o~őSNCAg͐ؒf܂j

			ssv.Stop();			//	T[o~
			fStop = TRUE;
		}
		//	Cxg҂(100ms)
		ssv.WaitEvent(100);
	}

	SAjxCon::PrintF(TEXT("Hit Enter Key!!"));
	while (_kbhit()) _getch();
	getchar();

	return 0;
}

