//
//	SP_XYM.cpp
//
#include	<AjxCpp.h>
#include	<tchar.h>
#include	<direct.h>
#include	<conio.h>
using namespace AjxControl;

//----- CAjxXym, CAjxScp, CAjxCon ̔hNX ------------------------------------------------------------------//
class CAjxXymEx : public CAjxXym, public CAjxScp, public CAjxCon
{
	AJCXYMPROTOCOL			m_Protocol;				//	ʐMvgR
	BOOL					m_fBusy;				//	t@C]tO
	HANDLE					m_hFile;				//	t@Cnh
	SX						m_hFind;				//	t@Cnh
	BOOL					m_fFindFirst;			//	t@CtO
	struct _tfinddata64_t	m_FindData;				//	t@C
	BOOL					m_fReceiving;			//	t@CMtO
	ULL						m_RxBytes;				//	t@CMTCYicMoCgj
	ULL						m_TxBytes;				//	t@CMTCYicMoCgj
	UT						m_Path[MAX_PATH];		//	Mt@C^fBNg
	UT						m_drv[_MAX_DRIVE];		//	hCu
	UT						m_dir[_MAX_DIR];		//	fBNgpX

	//----- t@C]I҂ -----------------------------------------------//
	VO	WaitForEnd() {
		m_fBusy = TRUE;
		while (m_fBusy) {
			//	I`FbNiESCL[̓`FbNj
			if (_kbhit()) {
				int c = _getch();
				if (c == 0x1B) Stop();
			}
			//	rboCxg҂
			WaitEvent(100);
			//	VXebZ[W
			AjcDoEvent();
		}
	}

public:
	//	RXgN^
	CAjxXymEx()
	{
		m_Protocol	 = AJCXYP_XMODEM_SUM;
		m_fBusy 	 = FALSE;
		m_hFile 	 = NULL;
		m_hFind 	 = -1;
		m_fFindFirst = TRUE;
		//	rbo
		Init(TEXT("MyScpSect"), AJCSCP_CM_BIN);
		SetEvtMask(AJCSCP_EV_PORTSTATE | AJCSCP_EV_RXCHUNK | AJCSCP_EV_TXEMPTY);
	}
	//----- t@CM -------------------------------------------------------//
	VO	SendFile()
	{
		m_fReceiving = FALSE;
		m_fFindFirst = TRUE;
		if (TxStart(m_Protocol)) {
			WaitForEnd();
		}
	}
	//----- t@CM -------------------------------------------------------//
	VO	RecvFile()
	{
		m_fReceiving = TRUE;
		if (RxStart(m_Protocol)) {
			WaitForEnd();
		}
	}
	//----- Mt@C -----------------------------------------------//
	VO	SubWrite(VOP pDat, ULL len) {
		UL	bytes;
		if (m_hFile != INVALID_HANDLE_VALUE) {
			if (m_RxBytes > len) {WriteFile(m_hFile, pDat, (UI)len		, &bytes, NULL); m_RxBytes -= len;}
			else				 {WriteFile(m_hFile, pDat, (UI)m_RxBytes, &bytes, NULL); m_RxBytes	= 0;  }
		}
	}
	//----- XYM Override -------------------------------------------------------//
	//	Cxgʒm
	VO	OnNotice (UI knd, UX Param				)	override {
		PCAJCXYMFILEINFO pfi;
		UT		path[MAX_PATH];
		//	CxgANV
		switch (knd) {
			//	Mt@Cʒmit@CMj
			case AJCXYN_RXFILEINFO:		pfi = (PCAJCXYMFILEINFO)Param;
										MAjcMakePath(path, m_drv, m_dir, pfi->pFName, NULL);
										SAjxCon::PrintF(TEXT("File receive '%s'\n"), path);
										m_RxBytes = pfi->size;
										if ((m_hFile = CreateFile(path, GENERIC_WRITE, 0, NULL,
											CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
											SAjxCon::PrintF(TEXT("File creation failure <%s>\n"), path);
										}
										break;
			//	PR[hM
			case AJCXYN_TXREC:			SAjxCon::PrintF(TEXT("."));
										break;
			//	PR[hMiPQWoCgR[hj
			case AJCXYN_RXREC_128:		SAjxCon::PrintF(TEXT(".")); SubWrite((VO*)Param, 128);
										break;
			//	PR[hMiPjaR[hj
			case AJCXYN_RXREC_1K:		SAjxCon::PrintF(TEXT(".")); SubWrite((VO*)Param, 1024);
										break;
			//	đ
			case AJCXYN_RETRY:			SAjxCon::PrintF(TEXT("R"));
										break;
			//	dneʒm
			case AJCXYN_EOF:			SAjxCon::PrintF(TEXT("E\n"));
										if (m_hFile != INVALID_HANDLE_VALUE) {
											CloseHandle(m_hFile); 
											m_hFile = INVALID_HANDLE_VALUE;
										}
										break;
			//	ʐMvgRύXʒm
			case AJCXYN_PROTOCOL:		SAjxCon::PrintF(TEXT("Protocol change.\n"));
										break;
			//	t@C]
			case AJCXYN_COMPLETE:		SAjxCon::PrintF(TEXT("Complete.\n"));
										break;
			//	t@C]~ib`mM			j
			case AJCXYN_RX_CAN:			SAjxCon::PrintF(TEXT("Stop by Received CAN\n"));
										break;
			//	t@C]~i[U̒~v	j
			case AJCXYN_USERSTOP:		SAjxCon::PrintF(TEXT("Stop by user\n"));
										break;
			//	t@C]~i^CAEg			j
			case AJCXYN_TIMEOUT:		SAjxCon::PrintF(TEXT("Stop by Timeout\n"));
										break;
		}
		//	]I
		if ((knd & AJCXYN_END) != 0) {
			if (m_hFind != -1				   ) {_findclose (m_hFind);	m_hFind = -1;				   }
			if (m_hFile != INVALID_HANDLE_VALUE) {CloseHandle(m_hFile);	m_hFile = INVALID_HANDLE_VALUE;}
			m_fBusy = FALSE;
		}
	}
	//	t@C擾vit@CMj
	VO	OnGetFile(PAJCXYMFILEINFO pBuf			)	override {
		BOOL	fEndOfFind	= FALSE;
		//----- XMODEM ̏ꍇAwt@CI[v -----------------------------//
		if (m_Protocol & AJCXYP_XMODEM) {
			m_hFind  = -1;
			//	Mt@CI[v
			if ((m_hFile = CreateFile(m_Path, GENERIC_READ, FILE_SHARE_READ, NULL,
									OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
				//	Mt@CTCYݒ
				m_TxBytes = AjcGetFileSize(m_Path);
				//	t@Cݒ
				pBuf->pFName = m_Path;
				pBuf->size	 = AjcGetFileSize	 (m_Path);
				pBuf->time	 = AjcGetFileTime1970(m_Path);
				SAjxCon::PrintF(TEXT("File transfer <%s>\n"), m_Path);
			}
			else {
				SAjxCon::PrintF(TEXT("File open failure <%s>\n"), m_Path);
			}
		}
		//----- YMODEM ̏ꍇAfBNg̃t@C ---------------------//
		else {
			//	Õt@CN[Y
			if (m_hFile != INVALID_HANDLE_VALUE) {
				CloseHandle(m_hFile);
				m_hFile = INVALID_HANDLE_VALUE;
			}
			//	̑Mt@Cݒ
			while (!fEndOfFind	&&	m_hFile == INVALID_HANDLE_VALUE) {
				//	̃t@C
				do {
					UT wild[MAX_PATH];
					MAjcMakePath(wild, m_drv, m_dir, TEXT("*"), TEXT(".*"));
					if (m_fFindFirst) {if ((m_hFind = _tfindfirst64(wild, &m_FindData)) == -1) fEndOfFind = TRUE;}
					else			  {if (_tfindnext64(m_hFind, &m_FindData)				   == -1) fEndOfFind = TRUE;}
					m_fFindFirst = FALSE;
				} while (!fEndOfFind && (m_FindData.attrib & (_A_HIDDEN | _A_SUBDIR | _A_SYSTEM)));
				//	t@Cf[^^dneݒ
				if (!fEndOfFind) {
					//	Mt@CTCYݒ
					m_TxBytes = m_FindData.size;
					//	Mt@CI[v
					UT		path[MAX_PATH];
					MAjcMakePath(path, m_drv, m_dir, m_FindData.name, NULL);
					if ((m_hFile = CreateFile(path, GENERIC_READ, FILE_SHARE_READ, NULL,
											OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE) {
						//	t@Cݒ
						pBuf->pFName = m_FindData.name;
						pBuf->size	 = m_FindData.size;
						pBuf->time	 = (UL)(m_FindData.time_write);
						SAjxCon::PrintF(TEXT("File transfer <%s>\n"), path);
					}
					else {
						SAjxCon::PrintF(TEXT("File open failure <%s>\n"), path);
					}
				}
				else {
					//	t@CI
					_findclose(m_hFind);
					m_hFind = -1;
					//	EOFݒ
					pBuf->pFName = NULL;
				}
			}
		}
	}
	//	t@Cf[^擾vit@CMj
	VO	OnGetData(VOP pBuf, UI lBuf, UIP pBytes	)	override {
		ReadFile(m_hFile, pBuf, lBuf, (ULP)pBytes, NULL);
		if (m_TxBytes >= *pBytes) m_TxBytes -= *pBytes;
		else					  m_TxBytes  = 0;
	}
	//	f[^ovit@CMj
	VO	OnSend	 (C_VOP pTxD, UI lTxD			)	override {
		SendBinData(pTxD, lTxD);
	}
	//----- SCP Override -------------------------------------------------------//
	//	|[gԒʒm
	VO	OnNtcPortState	(C_BCP pPortName, UI Param)	override {
	}
	//	oCi`NMʒm
	VO	OnNtcRxBinChunk	(C_VOP pData, UI Bytes)		override {
		UBP	p = (UBP)pData;
		while (Bytes--) {
			PutRxChar(*p++);
		}
	}
	//	Mʒm
	VO	OnNtcTxEmpty	()							override {
		//	YMODEM-G ̏ꍇAMʒm
		if (m_Protocol == AJCXYP_YMODEM_G && !m_fReceiving && m_TxBytes == 0) {
			TxEnd();
		}
	}
	//----- R}hp^ʒm -----------------------------------------------//
	VO	OnNtcStr(int argc, UT *argv[], C_UTP pTxt) override {
		SAjxCon::PrintF(TEXT("Input = '%s'\n\n"), pTxt);
		if		(argc == 1) {
			if		(_tcsicmp(argv[0], TEXT("XS")) == 0) {m_Protocol = AJCXYP_XMODEM_SUM;}
			else if (_tcsicmp(argv[0], TEXT("XC")) == 0) {m_Protocol = AJCXYP_XMODEM_CRC;}
			else if (_tcsicmp(argv[0], TEXT("X1")) == 0) {m_Protocol = AJCXYP_XMODEM_1K; }
			else if (_tcsicmp(argv[0], TEXT("YM")) == 0) {m_Protocol = AJCXYP_YMODEM_STD;}
			else if (_tcsicmp(argv[0], TEXT("YG")) == 0) {m_Protocol = AJCXYP_YMODEM_G;  }
			else  SAjxCon::PrintF(TEXT(" *** Invalid directory '%s'.\n"), argv[0]);
		}
		else if (argc == 2) {
			if (((m_Protocol &AJCXYP_XMODEM) && AjcPathIsFile	  (argv[1])) ||
				((m_Protocol &AJCXYP_YMODEM) && AjcPathIsDirectory(argv[1]))) {
				//	pXݒ
				_tcscpy_s(m_Path, AJCTSIZE(m_Path), argv[1]);
				if (m_Protocol &AJCXYP_YMODEM) {
					AjcPathCat(m_Path, TEXT(""), AJCTSIZE(m_Path));
					MAjcSplitPath(m_Path, m_drv, m_dir, NULL, NULL);
				}
				//	R}hs
				if		(_tcsicmp(argv[0], TEXT("TX")) == 0) {SendFile();}
				else if (_tcsicmp(argv[0], TEXT("RX")) == 0) {RecvFile();}
				else SAjxCon::PrintF(TEXT(" *** Invalid parameter '%s'.\n"), argv[0]);
			}
			else SAjxCon::PrintF(TEXT(" *** Invalid directory '%s'.\n"), argv[1]);
		}
		else SAjxCon::PrintF(TEXT(" *** missing number of parameters.\n"));
	}
};

CAjxXymEx	xym_scp;

//----- m a i n ------------------------------------------------------------------------------------------------//
int AjcMain(int argc, UTP argv[])
{
	SAjxCon::SetStdMode();

	//	|[gp^ݒ
	UT WndTxt[256];
	GetConsoleTitle(WndTxt, 256);
	xym_scp.DlgParamEasy(FindWindow(NULL, WndTxt));
	//	|[gI[v
	xym_scp.Open();

	if (xym_scp.IsOpened()) {
		//R}h̓[v
		do {
			SAjxCon::PrintF(TEXT("\n"));
			SAjxCon::PrintF(TEXT(" XS ------------- ʐMvgRݒ(XMODEM(SUM))\n"));
			SAjxCon::PrintF(TEXT(" XC ------------- ʐMvgRݒ( V   (CRC))\n"));
			SAjxCon::PrintF(TEXT(" X1 ------------- ʐMvgRݒ( V   (1KB))\n"));
			SAjxCon::PrintF(TEXT(" YM ------------- ʐMvgRݒ(YMODEM)\n"	  ));
			SAjxCon::PrintF(TEXT(" YG ------------- ʐMvgRݒ(YMODEM-G)\n"	  ));
			SAjxCon::PrintF(TEXT(" TX <FilePath> -- t@CM  (XMODEM)\n"));
			SAjxCon::PrintF(TEXT(" RX <FilePath> -- t@CM  (XMODEM)\n"));
			SAjxCon::PrintF(TEXT(" TX <DirPath> --- <DirPath>̑St@CM      (YMODEM)\n"));
			SAjxCon::PrintF(TEXT(" RX <DirPath> --- Mt@C<DirPath>Ɋi[(YMODEM)\n"));
			SAjxCon::PrintF(TEXT(" ESCL[ŏI\n"));
		} while (xym_scp.Input(TEXT("")));
	}
	else {
		SAjxCon::PrintF(TEXT(" |[gI[vł܂B\n"));
		SAjxCon::PrintF(TEXT(" Hit Enter Key!!\n"));
		getchar();
	}

	return 0;
}
