#ifndef	AJCAVLTREE_H_
#define	AJCAVLTREE_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
		#define	AjcAvlInsStrNode		AjcAvlInsStrNodeW
		#define	AjcAvlGetStrNode		AjcAvlGetStrNodeW
		#define	AjcAvlRepStrNode		AjcAvlRepStrNodeW
		#define	AjcAvlInsOrGetStrNode	AjcAvlInsOrGetStrNodeW
		#define	AjcAvlInsOrRepStrNode	AjcAvlInsOrRepStrNodeW
		#define	AjcAvlDelStrNode		AjcAvlDelStrNodeW
#else
		#define	AjcAvlInsStrNode		AjcAvlInsStrNodeA
		#define	AjcAvlGetStrNode		AjcAvlGetStrNodeA
		#define	AjcAvlRepStrNode		AjcAvlRepStrNodeA
		#define	AjcAvlInsOrGetStrNode	AjcAvlInsOrGetStrNodeA
		#define	AjcAvlInsOrRepStrNode	AjcAvlInsOrRepStrNodeA
		#define	AjcAvlDelStrNode		AjcAvlDelStrNodeA
#endif
/*--------------------------------------------------------------------------------------------------------------*/
/*	m[hwb_`																							*/
/*--------------------------------------------------------------------------------------------------------------*/
typedef struct _AJCAVLNODE {
	struct _AJCAVLNODE	*l, *r;				//	Em[hւ̃|C^
	UX					key;				//	L[
	SW					bal;				//	oXWi -2 ` +2 )
	UW					len;				//	m[hf[^̃oCg
} AJCAVLNODE, *PAJCAVLNODE;

//--------------------------------------------------------------------------------------------------------------//
//	|C^zGg̍\̒`}N																		//
//--------------------------------------------------------------------------------------------------------------//
#define		MAJCAVLPTR(ST, PT)										\
typedef struct {													\
	UX		key;					/*	L[				*/		\
	PT		pNode;					/*	m[hւ̃|C^	*/		\
	UI		len;					/*	m[h̃oCg	*/		\
} ST, *P##ST;														\
typedef const ST *PC##ST;

MAJCAVLPTR(AJCAVLPTR, VOP)

/*--------------------------------------------------------------------------------------------------------------*/
/*	CX^X[N																							*/
/*--------------------------------------------------------------------------------------------------------------*/
typedef struct _AJCAVL {
	UI					InstID;				//	CX^Xʂhc
	PAJCAVLNODE			pRoot;				//	[gm[hւ̃|C^
	UI					NodeCount;			//	o^m[hJE^

	BOOL				fMultiThread;		//	rtO
	CRITICAL_SECTION	cs;					//	NeBJZNVEIuWFNg

	PAJCAVLNODE			w_pNode;			//	[Nim[h|C^j
	UX					w_key;				//	  V  iL[lj
	C_VOP				w_pData;			//	  V  im[hf[^|C^j
	UI					w_len;				//	  V  im[hf[^TCYj
	BOOL				w_rsu;				//	  V  iʃR[hj
	UI					w_nest;				//	  V  ilXgi؂̍jj
	BOOL				w_cont;				//	  V  if[^ʒmR[obNstOj
	UX					w_cbp;				//	  V  iSm[hʒmpR[obNp^j
	PAJCAVLNODE			q, s, w;			//	m[h|C^[N
	int					b;					//	oXlޔ[N
	BOOL  (CALLBACK *w_cb)(UX key, VOP pNodeData, UI len, UI nest, UX cbp);

	UX					cbp;				//	R[obNp^
	int   (CALLBACK *cbComp   )(UX key1, UX key2, UX cbp);
	VO	  (CALLBACK *cbNtcDel )(UX key, VOP pNodeData, UI len, UI nest, UX cbp);
} AJCAVL, *HAJCAVL;

//----- m[hf[^ʒmpR[obN^Cv -------------------------------------------------------------------//
typedef	BOOL (CALLBACK *AJCAVL_CBNTC)(UX key, VOP pNodeData, UI len, UI nest, UX cbp);

/*--------------------------------------------------------------------------------------------------------------*/
/*	vg^Cv																								*/
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT	HAJCAVL	WINAPI	AjcAvlCreate(	UX		cbp,
											int   (CALLBACK *cbComp  )(UX key1, UX key2, UX cbp),
											VO	  (CALLBACK *cbRemove)(UX key, VOP pNodeData, UI len, UI nest, UX cbp));

AJCEXPORT	BOOL	WINAPI	AjcAvlDelete			(HAJCAVL hAvl);
AJCEXPORT	BOOL	WINAPI	AjcAvlEnableMultiThread	(HAJCAVL hAvl, BOOL fEnable);
AJCEXPORT	BOOL	WINAPI	AjcAvlSetCbp			(HAJCAVL hAvl, UX cbp);

//	m[hANZX
AJCEXPORT	BOOL	WINAPI	AjcAvlInsNode			(HAJCAVL hAvl, UX key, C_VOP pNodeData, UI len);
AJCEXPORT	UX		WINAPI	AjcAvlInsDataNode		(HAJCAVL hAvl,		   C_VOP pNodeData, UI len);
AJCEXPORT	int		WINAPI	AjcAvlGetNode			(HAJCAVL hAvl, UX key, VOP	 pBuf,		UI lBuf);
#define	AjcAvlGetNodeByKey	AjcAvlGetNode
AJCEXPORT	VOP		WINAPI	AjcAvlGetNodePtr		(HAJCAVL hAvl, UX	key, UIP pLen);
AJCEXPORT	UX		WINAPI	AjcAvlGetNodeKey		(HAJCAVL hAvl, C_VOP pNode);
AJCEXPORT	int		WINAPI	AjcAvlGetTopNode		(HAJCAVL hAvl, UXP pKey, VOP pBuf, UI lBuf);
AJCEXPORT	int		WINAPI	AjcAvlGetLastNode		(HAJCAVL hAvl, UXP pKey, VOP pBuf, UI lBuf);
AJCEXPORT	BOOL	WINAPI	AjcAvlRepNode			(HAJCAVL hAvl, UX key, C_VOP pNodeData, UI len);
AJCEXPORT	BOOL	WINAPI	AjcAvlInsOrRepNode		(HAJCAVL hAvl, UX key, C_VOP pNodeData, UI len);
AJCEXPORT	BOOL	WINAPI	AjcAvlDelNode			(HAJCAVL hAvl, UX key);
AJCEXPORT	BOOL	WINAPI	AjcAvlDelAllNodes		(HAJCAVL hAvl);

//	m[hANZX
AJCEXPORT	UX		WINAPI AjcAvlInsStrNodeA		(HAJCAVL hAvl, C_BCP pStr);
AJCEXPORT	UX		WINAPI AjcAvlInsStrNodeW		(HAJCAVL hAvl, C_WCP pStr);

AJCEXPORT	UX		WINAPI AjcAvlGetStrNodeA		(HAJCAVL hAvl, C_BCP pStr);
AJCEXPORT	UX		WINAPI AjcAvlGetStrNodeW		(HAJCAVL hAvl, C_WCP pStr);

AJCEXPORT	UX		WINAPI AjcAvlInsOrGetStrNodeA	(HAJCAVL hAvl, C_BCP pStr);
AJCEXPORT	UX		WINAPI AjcAvlInsOrGetStrNodeW	(HAJCAVL hAvl, C_WCP pStr);

AJCEXPORT	UX		WINAPI AjcAvlDelStrNodeA		(HAJCAVL hAvl, C_BCP pStr);
AJCEXPORT	UX		WINAPI AjcAvlDelStrNodeW		(HAJCAVL hAvl, C_WCP pStr);

//	̑
AJCEXPORT	UI		WINAPI	AjcAvlGetCount	  (HAJCAVL hAvl);
AJCEXPORT	UI		WINAPI	AjcAvlNumber	  (HAJCAVL hAvl);

AJCEXPORT	UI		WINAPI	AjcAvlEnumNodes   (HAJCAVL hAvl,		 AJCAVL_CBNTC cbNtcNodeData, BOOL fDownSeq);
AJCEXPORT	UI		WINAPI	AjcAvlEnumNodesEx (HAJCAVL hAvl, UX cbp, AJCAVL_CBNTC cbNtcNodeData, BOOL fDownSeq);

AJCEXPORT	PCAJCAVLPTR	WINAPI	AjcAvlCreatePtrArr (HAJCAVL hAvl, UIP pNum, BOOL fDownSeq);
AJCEXPORT	BOOL		WINAPI	AjcAvlReleasePtrArr(HAJCAVL hAvl, PCAJCAVLPTR pArr);


/****************************************************************************************************************/
#endif
