#ifndef	AJCBITMAP_H_
#define	AJCBITMAP_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcWriteBitmapToFile			AjcWriteBitmapToFileW
	#define	AjcCreateDibFromFile			AjcCreateDibFromFileW
#else
	#define	AjcWriteBitmapToFile			AjcWriteBitmapToFileA
	#define	AjcCreateDibFromFile			AjcCreateDibFromFileA
#endif
/*--------------------------------------------------------------------------------------------------------------*/
/*	rbg}bv																							*/
/*--------------------------------------------------------------------------------------------------------------*/
typedef union {
	DWORD				size;		//	\̂̃TCY
	BITMAPCOREHEADER	bc;			//	OS2X^C̃rbg}bv	, size = sizeof(BITMAPCOREHEADER) = 12
	BITMAPINFOHEADER	bi;			//	Windows̊grbg}bv	, size = sizeof(BITMAPINFOHEADER) = 40
	BITMAPV4HEADER		v4;			//	o[WSwb_(Win95/NT`)	, size = sizeof(BITMAPV4HEADER)	  = 108
#if (WINVER >= 0x0500)
	BITMAPV5HEADER		v5;			//	o[WTwb_(Win98/2K`)	, size = sizeof(BITMAPV5HEADER)	  = 124
#endif
	UB					dmy[256];
} AJCBITMAPINFO, *PAJCBITMAPINFO;


/*--------------------------------------------------------------------------------------------------------------*/
/*	vg^Cv																								*/
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT	BOOL	WINAPI	AjcChangeBitmapColor(HBITMAP hBmp, COLORREF before, COLORREF after);

AJCEXPORT	BOOL  	WINAPI	AjcSetBitmapToClipboard	(HBITMAP hBitmap);
AJCEXPORT	HBITMAP	WINAPI	AjcGetBitmapFromClipboard(VO);

AJCEXPORT	BOOL	WINAPI	AjcWriteBitmapToFileA	(HBITMAP hBitmap, C_BCP pFilePath);
AJCEXPORT	BOOL	WINAPI	AjcWriteBitmapToFileW	(HBITMAP hBitmap, C_WCP pFilePath);

AJCEXPORT	HBITMAP WINAPI	AjcCreateDibFromFileA(C_BCP pFilePath, UIP pWidth, UIP pHeight, PAJCBITMAPINFO pBmpInfo, VOP *ppImage);
AJCEXPORT	HBITMAP WINAPI	AjcCreateDibFromFileW(C_WCP pFilePath, UIP pWidth, UIP pHeight, PAJCBITMAPINFO pBmpInfo, VOP *ppImage);

AJCEXPORT	UI		WINAPI	AjcGetBitmapSize(HBITMAP hBitmap, LPSIZE pSize);
AJCEXPORT	BOOL	WINAPI	AjcGetIconSize  (HICON   hIcon  , LPSIZE pSize);


/****************************************************************************************************************/
#endif
