#ifndef	AJCCTOKEN_H_
#define	AJCCTOKEN_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//	@\tO																									//
//--------------------------------------------------------------------------------------------------------------//
//	Bit 7 - 0
#define	AJCTKFLG_CPLUSPLUS			0x00000001		//	b{{̃g[N܂߂
#define	AJCTKFLG_INCSPACE			0x00000002		//	󔒁^s^Rgg[NɊ܂߂
#define	AJCTKFLG_INCSYM_DOLLAR		0x00000004		//	V{̉pƂăh}[N($)܂߂
#define	AJCTKFLG_INCSYM_ATMARK		0x00000008		//	V{̉pƂăAbg}[N(@)܂߂	
#define	AJCTKFLG_INCSYM_MBSTR		0x00000010		//	V{̉pƂă}`oCg܂߂
#define	AJCTKFLG_APOST_NOESC		0x00000020		//	A|XgtB(')ň͂܂ꂽ́AGXP[X(\)FȂ
#define	AJCTKFLG_DOTSYMBOL			0x00000040		//	V{{Dot(.){P̃V{Ƃ݂Ȃ(Ex. P3.12)
#define	AJCTKFLG_ASMHEX				0x00000080		//	AZuL@16iiH, ex 0FFH)

//	Bit 31-24
#define	AJCTKFLG_LBF_1K				0x01000000		//	eLXgt@Cs̓ǂݏoobt@TCY QKB
#define	AJCTKFLG_LBF_2K				0x02000000		//			V								   SKB
#define	AJCTKFLG_LBF_4K				0x04000000		//			V								   WKB
#define	AJCTKFLG_LBF_8K				0x08000000		//			V								   16KB
#define	AJCTKFLG_LBF_16K			0x10000000		//			V								   32KB
#define	AJCTKFLG_LBF_32K			0x20000000		//			V								   64KB
#define	AJCTKFLG_LBF_64K			0x40000000		//			V								  128KB
#define	AJCTKFLG_LBF_128K			0x80000000		//			V								  256KB
#define	AJCTKFLG_LBF_MASK			0xFF000000

//--------------------------------------------------------------------------------------------------------------//
//	G[R[h																								//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTKERR_OK				 		0			//	nj
#define	AJCTKERR_NULLPTR				0x8000		//	mtkk|C^w肳ꂽ
#define	AJCTKERR_ZEROSIZE				0x4000		//	obt@TCY[
#define	AJCTKERR_MEMALLOC				0x2000		//	蓖Ďs
#define	AJCTKERR_INVALID_OCTALNUMBER	0x1000		//	sȂWi
#define	AJCTKERR_INVALID_HEXADECIMAL	0x0800		//	sȂPUi
#define	AJCTKERR_INVALID_REALNUMBER		0x0400		//	sȎ\
#define	AJCTKERR_INVALID_SUFFIX			0x0200		//	sȃTtBbNX
#define	AJCTKERR_INVALID_DELIMITER		0x0100		//	sȃf~^
#define	AJCTKERR_LFINSTR				0x0080		//	񒆂ɉs܂܂Ă
#define	AJCTKERR_BUFOVER				0x0040		//	g[Nobt@I[o[
#define	AJCTKERR_EOFINCOMMENT			0x0020		//	Rgɂdneoit@CŃRgĂȂj

//--------------------------------------------------------------------------------------------------------------//
//	g[NʃR[h																							//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTKKND_USRSYM		0x0100					//	[UV{
#define	AJCTKKND_RSVSYM		0x0200					//	\
#define	AJCTKKND_VALUE		0x0400					//	l萔
#define	AJCTKKND_STRING		0x0800					//	
#define	AJCTKKND_PATHNAME	0x1000					//	t@CpXi#includê)
#define	AJCTKKND_DELIMIT	0x2000					//	f~^
#define	AJCTKKND_SPACE		0x4000					//	󔒁^s^Rg^spLij
#define	AJCTKKND_NEXT		0x8000					//	[U`p
//--------------------------------------------------------------------------------------------------------------//
//	g[Nʃ}N																							//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTKIS_USRSYM(TKN)		(((TKN) & AJCTKKND_USRSYM)	!= 0)	//	[UV{
#define	AJCTKIS_RSVSYM(TKN)		(((TKN) & AJCTKKND_RSVSYM)	!= 0)	//	\
#define	AJCTKIS_VALUE(TKN)		(((TKN) & AJCTKKND_VALUE)	!= 0)	//	l萔
#define	AJCTKIS_STRING(TKN)		(((TKN) & AJCTKKND_STRING)	!= 0)	//	
#define	AJCTKIS_PATHNAME(TKN)	(((TKN) & AJCTKKND_PATHNAME)!= 0)	//	t@CpXi#includê)
#define	AJCTKIS_DELIMIT(TKN)	(((TKN) & AJCTKKND_DELIMIT)	!= 0)	//	f~^

#define	AJCTKIS_SYMBOL(TKN)	(((TKN) & (AJCTKKND_RSVSYM | AJCTKKND_USRSYM)) != 0)
#define	AJCTKIS_VALSYM(TKN)	(((TKN) & (AJCTKKND_RSVSYM | AJCTKKND_USRSYM | AJCTKKND_VALUE)) != 0)

#define	AJCTKIS_SPACE(TKN)	(((TKN) & AJCTKKND_SPACE) != 0)		//	󔒁^s^Rg^spLij

//--------------------------------------------------------------------------------------------------------------//
//	g[NR[h																								//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	EAJCTK_EOF			= 0					,	//	End Of File
	EAJCTK_PREPRO							,	//	vvZXivRpC@\pj

	EAJCTK_USR_NAME		= AJCTKKND_USRSYM	,	//	[U`

	EAJCTK_RSV_ASM		= AJCTKKND_RSVSYM	,	//	asm
	EAJCTK_RSV_AUTO							,	//	auto
	EAJCTK_RSV_BREAK						,	//	break
	EAJCTK_RSV_CASE							,	//	case
	EAJCTK_RSV_CATCH						,	//	catch		iC++j
	EAJCTK_RSV_CHAR							,	//	char
	EAJCTK_RSV_CLASS						,	//	class		iC++j
	EAJCTK_RSV_CONST						,	//	const
	EAJCTK_RSV_CONCAST						,	//	const_cast	iC++j
	EAJCTK_RSV_CONTINUE						,	//	continue
	EAJCTK_RSV_DEFAULT						,	//	default
	EAJCTK_RSV_DEFINE						,	//	define		(vvZbTj
	EAJCTK_RSV_DEFINED						,	//	defined		(vvZbTj
	EAJCTK_RSV_DELETE						,	//	delete		iC++j
	EAJCTK_RSV_DO							,	//	do
	EAJCTK_RSV_DOUBLE						,	//	double
	EAJCTK_RSV_DYNCAST						,	//	dynamic_castiC++j
	EAJCTK_RSV_ELIF							,	//	elif		(vvZbTj
	EAJCTK_RSV_ELSE							,	//	else		(vvZbTpj
	EAJCTK_RSV_ENDIF						,	//	endif		(vvZbTj
	EAJCTK_RSV_ENUM							,	//	enum
	EAJCTK_RSV_EXTERN						,	//	extern
	EAJCTK_RSV_FLOAT						,	//	float
	EAJCTK_RSV_FOR							,	//	for
	EAJCTK_RSV_FRIEND						,	//	friend		iC++j
	EAJCTK_RSV_GOTO							,	//	goto
	EAJCTK_RSV_IF							,	//	if			(vvZbTpj
	EAJCTK_RSV_IFDEF						,	//	ifdef		(vvZbTj
	EAJCTK_RSV_IFNDEF						,	//	ifndef		(vvZbTj
	EAJCTK_RSV_INCLUDE						,	//	include		(vvZbTj
	EAJCTK_RSV_INLINE						,	//	inline
	EAJCTK_RSV_INT							,	//	int
	EAJCTK_RSV_LONG							,	//	long
	EAJCTK_RSV_NEW							,	//	new			iC++j
	EAJCTK_RSV_OPERATOR						,	//	operator	iC++j
	EAJCTK_RSV_PRAGMA						,	//	pragma		(vvZbTj
	EAJCTK_RSV_PRIVATE						,	//	private		iC++j
	EAJCTK_RSV_PROTECTED					,	//	protected	iC++j
	EAJCTK_RSV_PUBLIC						,	//	public		iC++j
	EAJCTK_RSV_REGISTER						,	//	register
	EAJCTK_RSV_REICAST						,	//	reinterpret_castiC++j
	EAJCTK_RSV_RETURN						,	//	return
	EAJCTK_RSV_SHORT						,	//	short
	EAJCTK_RSV_SIGNED						,	//	signed
	EAJCTK_RSV_SIZEOF						,	//	sizeof
	EAJCTK_RSV_STATIC						,	//	static
	EAJCTK_RSV_STACAST						,	//	static_cast	iC++j
	EAJCTK_RSV_STRUCT						,	//	struct
	EAJCTK_RSV_SWITCH						,	//	switch
	EAJCTK_RSV_TEMPLATE						,	//	template	iC++j
	EAJCTK_RSV_THIS							,	//	this		iC++j
	EAJCTK_RSV_THROW						,	//	tnrow		iC++j
	EAJCTK_RSV_TRY							,	//	try			iC++j
	EAJCTK_RSV_TYPEDEF						,	//	typedef
	EAJCTK_RSV_UNDEF						,	//	undef
	EAJCTK_RSV_UNION						,	//	union
	EAJCTK_RSV_UNSIGNED						,	//	unsigned
	EAJCTK_RSV_VIRTUAL						,	//	virtual		iC++j
	EAJCTK_RSV_VOID							,	//	void
	EAJCTK_RSV_VOLATILE						,	//	volatile
	EAJCTK_RSV_WCHAR_T						,	//	wchar_t
	EAJCTK_RSV_WHILE						,	//	while

	EAJCTK_CIP_FUNCTION						,	//	bhopF'function'


	EAJCTK_VAL_DECIMAL	= AJCTKKND_VALUE	,	//	nnn	
	EAJCTK_VAL_HEXA							,	//	0xhhh
	EAJCTK_VAL_OCTAL						,	//	0nnn
	EAJCTK_VAL_REAL							,	//	nn.mm / nnnE[+-]mm
	EAJCTK_VAL_INVALID						,	//	sSȐl\iG[j

	EAJCTK_VAL_HEXA_H						,	//	hhhHiAZuL@j

	EAJCTK_CIP_INTEGER						,	//	bhopFl萔ij
	EAJCTK_CIP_REAL							,	//	bhopFl萔ij


	EAJCTK_STR_QUOTE	= AJCTKKND_STRING	,	//	"..."
	EAJCTK_STR_APOST						,	//	'...'
	EAJCTK_STR_NEXT							,	//	̑̕萔

	EAJCTK_CIP_STRING						,	//	bhopF


	EAJCTK_PATHNAME		= AJCTKKND_PATHNAME	,	//	#includẽwb_t@CpX

	EAJCTK_DLM_LSPART	= AJCTKKND_DELIMIT	,	//	(
	EAJCTK_DLM_LMPART						,	//	{
	EAJCTK_DLM_LLPART						,	//	[
	EAJCTK_DLM_RSPART						,	//	)
	EAJCTK_DLM_RMPART						,	//	}
	EAJCTK_DLM_RLPART						,	//	]

	EAJCTK_DLM_SCOPE						,	//	::		(C++)
	EAJCTK_DLM_IDDOT						,	//	.*		(C++)
	EAJCTK_DLM_IDARROW						,	//	->*		(C++)

	EAJCTK_DLM_LAND							,	//	&&
	EAJCTK_DLM_LOR							,	//	||

	EAJCTK_DLM_ARROW						,	//	->
	EAJCTK_DLM_QUEST						,	//	?
	EAJCTK_DLM_COLON						,	//	:
	EAJCTK_DLM_SEMICOL						,	//	;
	EAJCTK_DLM_COMMA						,	//	,
	EAJCTK_DLM_VARG							,	//	...	
	EAJCTK_DLM_DOT							,	//	.

	EAJCTK_DLM_SHREQ						,	//	>>=	
	EAJCTK_DLM_SHLEQ						,	//	<<=	
	EAJCTK_DLM_SHR							,	//	>>
	EAJCTK_DLM_SHL							,	//	<<

	EAJCTK_DLM_EQEQ							,	//	==
	EAJCTK_DLM_NOTEQ						,	//	!=
	EAJCTK_DLM_LOEQ							,	//	<=
	EAJCTK_DLM_HIEQ							,	//	>=
	EAJCTK_DLM_LO							,	//	<
	EAJCTK_DLM_HI							,	//	>

	EAJCTK_DLM_PLUSEQ						,	//	+=
	EAJCTK_DLM_MINUSEQ						,	//	-=
	EAJCTK_DLM_MULTEQ						,	//	*=
	EAJCTK_DLM_DIVEQ						,	//	/=
	EAJCTK_DLM_MODEQ						,	//	%=
	EAJCTK_DLM_ANDEQ						,	//	&=
	EAJCTK_DLM_OREQ							,	//	|=
	EAJCTK_DLM_XOREQ						,	//	^=

	EAJCTK_DLM_SHARP2						,	//	##
	EAJCTK_DLM_PLUS2						,	//	++
	EAJCTK_DLM_MINUS2						,	//	--

	EAJCTK_DLM_SHARP						,	//	#
	EAJCTK_DLM_PLUS							,	//	+
	EAJCTK_DLM_MINUS						,	//	-
	EAJCTK_DLM_MULT							,	//	*
	EAJCTK_DLM_DIV							,	//	/
	EAJCTK_DLM_MOD							,	//	%
	EAJCTK_DLM_AND							,	//	&
	EAJCTK_DLM_OR							,	//	|
	EAJCTK_DLM_XOR							,	//	^
	EAJCTK_DLM_EQ							,	//	=
	EAJCTK_DLM_NOT							,	//	~
	EAJCTK_DLM_LNOT							,	//	!
	EAJCTK_DLM_UNKNOWN						,	//	`̃f~^
	EAJCTK_DLM_NEXT							,	//	̑̃f~^

	EAJCTK_SPACE		= AJCTKKND_SPACE	,	//	󔒁^^u
	EAJCTK_EOL								,	//	s
	EAJCTK_COMMENT							,	//	Rgi^EEE^j
	EAJCTK_LINECOMMENT						,	//	Rgi^^EEEj
	EAJCTK_LINECONT							,	//	spLij
	EAJCTK_NEXTSPACE						,	//	̑̋

} EAJCTKCODE, *LPEAJCTKCODE;

#define	EAJCTK_INVALID		((EAJCTKCODE)-1)

#define	EAJCTK_RSV_MINCODE	EAJCTK_RSV_ASM
#define	EAJCTK_RSV_MAXCODE	EAJCTK_RSV_WHILE

#define	EAJCTK_DLM_MINCODE	EAJCTK_DLM_LSPART
#define	EAJCTK_DLM_MAXCODE	EAJCTK_DLM_LNOT

//--------------------------------------------------------------------------------------------------------------//
//	l萔̃TtBbNXER[h																				//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	EAJCTKSUF_NONE	=	0	,		//	TtBbNXȂ
	EAJCTKSUF_L				,		//	L
	EAJCTKSUF_UL			,		//	UL / LU
	EAJCTKSUF_LL			,		//	LL
	EAJCTKSUF_ULL			,		//	ULL
	EAJCTKSUF_FLOAT			,		//	F
	EAJCTKSUF_DOUBLE		,		//	D
	EAJCTKSUF_LDOUBLE				//	L
} EAJCTKSUF, *LPEAJCTKSUF;

//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTKMAX_PPHIST		16

typedef struct {
	UI			InstID;						//	CX^Xʂhc
	EAJCTKCODE	tkn;						//	g[NR[h
	EAJCTKSUF	suffix;						//	l萔̃TtBbNXER[h
	UI			ctkf;						//	tO
	UI			flag;						//	b{{\^󔒔FtO
	UI			err;						//	G[R[h
	UI			lno;						//	sԍ
	UI			loc;						//	g[ÑoCgʒu
	UI			len;						//	g[ÑoCg
	UI			lLineBuf;					//	sobt@TCYioCgj
	WCP			pLineBuf;					//	sobt@
	WCP			pLine;						//	s|C^
	UX			xp;							//	R[obNp^
	union {
		BOOL	(CALLBACK *cbCtkA)(BCP pBuf, UI lBuf, UX xp);
		BOOL	(CALLBACK *cbCtkW)(WCP pBuf, UI lBuf, UX xp);
	} u;
	//----- vvZX -----//
	UI			PpHistIx;					//	vvZX̃g[NJE^
	EAJCTKCODE	PpHist[AJCTKMAX_PPHIST];	//	vvZX̐擪g[Ni''͊܂܂Ȃj

	BOOL		fUnicode;

} AJCTK, *HAJCTK;

//----- ctkf ---------------------------------------------------------------------------------------------------//
//----- tO -------//
#define	AJCTKF_EOF				0x80000000					//	End of file
#define	AJCTKF_TOL				0x40000000					//	stO
#define	AJCTKF_LCONT			0x20000000					//	spLijotO
#define	AJCTKF_INCOMMENT		0x10000000					//	Rgi^...^jtO	
#define	AJCTKF_PATHNAME			0x08000000					//	#includẽt@CpX
#define	AJCTKF_ISLASTPEEK		0x04000000					//	Ouoddjvł邱ƂtO
#define	AJCTKF_SRHMACARGTOP		0x02000000					//	}N擪 '(' 
#define	AJCTKF_SRHMACARGEND		0x01000000					//	}NI[ ')' 
#define	AJCTKF_FINDMACARGEND	0x00800000					//	}NI[ ')' o
#define	AJCTKF_SRHMACBODY		0x00400000					//	}N{fB
//----- [UʒmtO -----//
#define	AJCTKF_PREPRO				0x0080					//	vvZX
#define	AJCTKF_PPTOP				0x0040					//	vvZX̐擪g[Nij
#define	AJCTKF_MACNAME				0x0020					//	}N
#define	AJCTKF_MACWITHARG			0x0010					//	t̃}N
#define	AJCTKF_MACARG				0x0008					//	}N' ( EEE ) '
#define	AJCTKF_MACBODY				0x0004					//	}N{fB
#define	AJCTKF_NXTSPC				0x0002					//	g[N̎ɋ󔒂tO
#define	AJCTKF_WIDECHAR				0x0001					//	ChiL'X' / L"XXX"jtO

//	[UʒmtÕ}XN
#define	AJCTKF_USER		(AJCTKF_PREPRO | AJCTKF_PPTOP | AJCTKF_MACNAME | AJCTKF_MACWITHARG | AJCTKF_MACARG | AJCTKF_MACBODY | AJCTKF_NXTSPC | AJCTKF_WIDECHAR)

//	vvZX or Ch
#define	AJCTKF_PPORWC	(AJCTKF_PREPRO | AJCTKF_PPTOP | AJCTKF_MACNAME | AJCTKF_MACWITHARG | AJCTKF_MACARG | AJCTKF_MACBODY |				  AJCTKF_WIDECHAR)

//----- 擾}N -----------------------------------------------------------------------------------------//
#define	AJCTK_TOKEN(H)		((H)->tkn)
#define	AJCTK_SUFFIX(H)		((H)->suffix)
#define	AJCTK_FLAG(H)		((H)->ctkf & AJCTKF_USER)
#define	AJCTK_LINE(H)		((H)->lno)
#define	AJCTK_LOC(H)		AjcCtkGetTokenLocation(H)
#define	AJCTK_POS(H, N)		AjcCtkGetTokenPosition(H, N)
#define	AJCTK_ERROR(H)		((H)->err)

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
#ifdef	UNICODE
	#define	PCBAJCTK					PCBAJCTKW
	#define	AjcCtkCreate				AjcCtkCreateW
	#define	AjcCtkSetCallBack			AjcCtkSetCallBackW
	#define	AjcCtkInit					AjcCtkInitW
	#define	AjcCtkGetToken				AjcCtkGetTokenW
	#define	AjcCtkPeekToken				AjcCtkPeekTokenW
	#define	AjcCtkGetTokenString		AjcCtkGetTokenStringW
	#define	AjcCtkGetTokenLocation		AjcCtkGetTokenLocationW
	#define	AjcCtkGetTokenPosition		AjcCtkGetTokenPositionW
#else
	#define	PCBAJCTK					PCBAJCTKA
	#define	AjcCtkCreate				AjcCtkCreateA
	#define	AjcCtkSetCallBack			AjcCtkSetCallBackA
	#define	AjcCtkInit					AjcCtkInitA
	#define	AjcCtkGetToken				AjcCtkGetTokenA
	#define	AjcCtkPeekToken				AjcCtkPeekTokenA
	#define	AjcCtkGetTokenString		AjcCtkGetTokenStringA
	#define	AjcCtkGetTokenLocation		AjcCtkGetTokenLocationA
	#define	AjcCtkGetTokenPosition		AjcCtkGetTokenPositionA
#endif

typedef	BOOL (CALLBACK *PCBAJCTKA)(BCP pBuf, UI lBuf, UX cbp);
typedef	BOOL (CALLBACK *PCBAJCTKW)(WCP pBuf, UI lBuf, UX cbp);

AJCEXPORT	HAJCTK	WINAPI	AjcCtkCreateA	(UI flag, PCBAJCTKA cbGetLine, UX cbp);
AJCEXPORT	HAJCTK	WINAPI	AjcCtkCreateW	(UI flag, PCBAJCTKW cbGetLine, UX cbp);

AJCEXPORT	BOOL	WINAPI	AjcCtkReset		(HAJCTK hCtk);

AJCEXPORT	BOOL	WINAPI	AjcCtkSetCallBackA(HAJCTK hCtk, PCBAJCTKA cbGetLine, UX cbp);
AJCEXPORT	BOOL	WINAPI	AjcCtkSetCallBackW(HAJCTK hCtk, PCBAJCTKW cbGetLine, UX cbp);

AJCEXPORT	BOOL	WINAPI	AjcCtkSetCallBackParam	 (HAJCTK pW, UX cbp);

AJCEXPORT	BOOL	WINAPI	AjcCtkDelete	(HAJCTK hCtk);

AJCEXPORT	BOOL	WINAPI	AjcCtkSetFlag	(HAJCTK hCtk, UI flag);
AJCEXPORT	UI		WINAPI	AjcCtkGetFlag	(HAJCTK hCtk);

AJCEXPORT	BOOL	WINAPI	AjcCtkGetTokenA (HAJCTK hCtk, BCP pStrBuf, UI lStrBuf);
AJCEXPORT	BOOL	WINAPI	AjcCtkGetTokenW (HAJCTK hCtk, WCP pStrBuf, UI lStrBuf);

AJCEXPORT	BOOL	WINAPI	AjcCtkPeekTokenA(HAJCTK hCtk, BCP pStrBuf, UI lStrBuf);
AJCEXPORT	BOOL	WINAPI	AjcCtkPeekTokenW(HAJCTK hCtk, WCP pStrBuf, UI lStrBuf);

AJCEXPORT	C_BCP	WINAPI	AjcCtkGetTokenStringA(EAJCTKCODE tkn);
AJCEXPORT	C_WCP	WINAPI	AjcCtkGetTokenStringW(EAJCTKCODE tkn);

AJCEXPORT	UI		WINAPI	AjcCtkGetTokenLocationA(HAJCTK hCtk);
AJCEXPORT	UI		WINAPI	AjcCtkGetTokenLocationW(HAJCTK hCtk);

AJCEXPORT	UI		WINAPI	AjcCtkGetTokenPositionA(HAJCTK hCtk, UI TabStep);
AJCEXPORT	UI		WINAPI	AjcCtkGetTokenPositionW(HAJCTK hCtk, UI TabStep);

AJCEXPORT	HAJCTK	WINAPI	AjcCtkGetReplicatedHandle(HAJCTK hCtk);


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpT|[gR[h																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
AJCEXPORT	EAJCTKCODE	WINAPI	AjcCtkGetCurToken		(HAJCTK pW);
AJCEXPORT	EAJCTKSUF	WINAPI	AjcCtkGetCurSuffix		(HAJCTK pW);
AJCEXPORT	UI			WINAPI	AjcCtkGetCurFlag		(HAJCTK pW);
AJCEXPORT	UI			WINAPI	AjcCtkGetCurLineNumber	(HAJCTK pW);
AJCEXPORT	UI			WINAPI	AjcCtkGetCurPosition	(HAJCTK pW, UI TabWidth);
AJCEXPORT	UI			WINAPI	AjcCtkGetCurError		(HAJCTK pW);

AJCEXPORT	BOOL		WINAPI	AjcCtkIsUsrSym			(EAJCTKCODE tkn);
AJCEXPORT	BOOL		WINAPI	AjcCtkIsRsvSym			(EAJCTKCODE tkn);
AJCEXPORT	BOOL		WINAPI	AjcCtkIsValue			(EAJCTKCODE tkn);
AJCEXPORT	BOOL		WINAPI	AjcCtkIsString			(EAJCTKCODE tkn);
AJCEXPORT	BOOL		WINAPI	AjcCtkIsPathName		(EAJCTKCODE tkn);
AJCEXPORT	BOOL		WINAPI	AjcCtkIsDelimit			(EAJCTKCODE tkn);

AJCEXPORT	BOOL		WINAPI	AjcCtkIsSymbol			(EAJCTKCODE tkn);
AJCEXPORT	BOOL		WINAPI	AjcCtkIsValSym			(EAJCTKCODE tkn);
AJCEXPORT	BOOL		WINAPI	AjcCtkIsSpace			(EAJCTKCODE tkn);

/****************************************************************************************************************/
#endif
