#ifndef	AJCFILEDIR_H_
#define	AJCFILEDIR_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcCopyFolderStruct				AjcCopyFolderStructW
	#define	AjcCopyFolderStructEx			AjcCopyFolderStructExW
	#define	AjcCopyFiles					AjcCopyFilesW
	#define	AjcCopyFilesEx					AjcCopyFilesExW
	#define	AjcRemoveFolder					AjcRemoveFolderW
	#define	AjcCleanFolder					AjcCleanFolderW
	#define	AjcEnumFilesMatchingList		AjcEnumFilesMatchingListW
	#define	AjcCreateDirectoryStruct		AjcCreateDirectoryStructW
	#define	AjcCreateDirectoryStructEx		AjcCreateDirectoryStructExW
	#define	AjcCopyFile						AjcCopyFileW
	#define	AjcCopyFileEx					AjcCopyFileExW
	#define	AjcPathMatchSpec				AjcPathMatchSpecW
	#define	AjcPathMatchStr					AjcPathMatchStrW
	#define	AjcIsPathBackslash				AjcIsPathBackslashW
	#define	AjcIsPathBackslashEx			AjcIsPathBackslashExW
	#define	AjcPathCat						AjcPathCatW
	#define	AjcPathCmp						AjcPathCmpW
	#define	AjcPathExists					AjcPathExistsW
	#define	AjcPathIsDirectory				AjcPathIsDirectoryW
	#define	AjcPathIsEmptyDirectory			AjcPathIsEmptyDirectoryW
	#define	AjcPathIsFile					AjcPathIsFileW
	#define	AjcGetFileSize					AjcGetFileSizeW
	#define	AjcGetFileTime1970				AjcGetFileTime1970W
	#define	AjcFileCompare					AjcFileCompareW
	#define	AjcGetFileTime					AjcGetFileTimeW
	#define	AjcSetFileTime					AjcSetFileTimeW
	#define	AjcSetFileTimeBySysTime			AjcSetFileTimeBySysTimeW
	#define	AjcIsSamePath					AjcIsSamePathW
	#define	AjcIsUnderPath					AjcIsUnderPathW

	#define	AJCFMLITEM						AJCFMLITEMW
	#define	PAJCFMLITEM						PAJCFMLITEMW
	#define	PCAJCFMLITEM					PCAJCFMLITEMW
#else
	#define	AjcCopyFolderStruct				AjcCopyFolderStructA
	#define	AjcCopyFolderStructEx			AjcCopyFolderStructExA
	#define	AjcCopyFiles					AjcCopyFilesA
	#define	AjcCopyFilesEx					AjcCopyFilesExA
	#define	AjcRemoveFolder					AjcRemoveFolderA
	#define	AjcCleanFolder					AjcCleanFolderA
	#define	AjcEnumFilesMatchingList		AjcEnumFilesMatchingListA
	#define	AjcCreateDirectoryStruct		AjcCreateDirectoryStructA
	#define	AjcCreateDirectoryStructEx		AjcCreateDirectoryStructExA
	#define	AjcCopyFile						AjcCopyFileA
	#define	AjcCopyFileEx					AjcCopyFileExA
	#define	AjcPathMatchSpec				AjcPathMatchSpecA
	#define	AjcPathMatchStr					AjcPathMatchStrA
	#define	AjcIsPathBackslash				AjcIsPathBackslashA
	#define	AjcIsPathBackslashEx			AjcIsPathBackslashExA
	#define	AjcPathCat						AjcPathCatA
	#define	AjcPathCmp						AjcPathCmpA
	#define	AjcPathExists					AjcPathExistsA
	#define	AjcPathIsDirectory				AjcPathIsDirectoryA
	#define	AjcPathIsEmptyDirectory			AjcPathIsEmptyDirectoryA
	#define	AjcPathIsFile					AjcPathIsFileA
	#define	AjcGetFileSize					AjcGetFileSizeA
	#define	AjcGetFileTime1970				AjcGetFileTime1970A
	#define	AjcFileCompare					AjcFileCompareA
	#define	AjcGetFileTime					AjcGetFileTimeA
	#define	AjcSetFileTime					AjcSetFileTimeA
	#define	AjcSetFileTimeBySysTime			AjcSetFileTimeBySysTimeA
	#define	AjcIsSamePath					AjcIsSamePathA
	#define	AjcIsUnderPath					AjcIsUnderPathA

	#define	AJCFMLITEM						AJCFMLITEMA
	#define	PAJCFMLITEM						PAJCFMLITEMA
	#define	PCAJCFMLITEM					PCAJCFMLITEMA
#endif

//--------------------------------------------------------------------------------------------------------------//
//	AjcCopyFolderStruct()/AjcCopyFiles()̒ʒmR[h															//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCCFS_SUCCESS		= 0	,		//	fBNg쐬 
	AJCCFS_FAILURE			,		//	fBNg쐬 s
	AJCCFS_EXIST			,		//	ɓpX݂
} EAJCCFS, *PEAJCCFS;

//--------------------------------------------------------------------------------------------------------------//
//	t@C^C	i1601NE莞 (UTC)  12:00 AM o߂ 100 imbԊu̐\ 64 rbglj	//
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	FILETIME  	ft;
	ULL			v;
} AJCUFT, *PAJCUFT;
typedef const AJCUFT *PCAJCUFT;

//	t@C^CQiʎZj
typedef struct {
	AJCUFT	mk;				//	쐬
	AJCUFT	ac;				//	ANZX
	AJCUFT	up;				//	XV
} AJCFTIMES, *PAJCFTIMES;
typedef const AJCFTIMES *PCAJCFTIMES;

//	t@C^CQiVXe^C`j
typedef struct {
	SYSTEMTIME	mk;			//	쐬
	SYSTEMTIME	ac;			//	ANZX
	SYSTEMTIME	up;			//	XV
} AJCSTIMES, *PAJCSTIMES;
typedef const AJCSTIMES *PCAJCSTIMES;

//	tH_\Rs[(AjcCopyFolderStruct[Ex])̃IvV
#define	AJCFSC_NONE			0				//	IvV
#define	AJCFSC_SAMETIME		0x01			//	VK쐬tH_̃^CX^vRs[Ɠɂ
#define	AJCFSC_FORCETIME	0x02			//	VK쐬tH_ƊtH_̃^CX^vRs[Ɠɂ
#define	AJCFSC_MAKETOP		0x10			//	]tH_̓]̐擪tH_Ƃč쐬
#define	AJCFSC_ALLOWEXIST	0x20			//	tH_݂ĂG[ƂȂ

//	tH_t@CRs[(AjcCopyFiles[Ex])̃IvV
#define	AJCCPF_NONE			0				//	IvV
#define	AJCCPF_CREATEALWAYS	0x01			//	Ƀt@C݂ꍇA㏑
#define	AJCCPF_WILDEXC		0x02			//	ChJ[hɈvt@CO

//	tH_폜(AjcRemoveFolderEx)̒ʒmR[h
#define	AJCRMV_FILE			0x00			//	t@C̍폜
#define	AJCRMV_DIR			0x01			//	tH_̍폜
#define	AJCRMV_ERR			0x80			//	G[tO

#define	AJCRMV_FILE_OK		(AJCRMV_FILE)
#define	AJCRMV_FILE_ERR		(AJCRMV_FILE | AJCRMV_ERR)
#define	AJCRMV_DIR_OK		(AJCRMV_DIR )
#define	AJCRMV_DIR_ERR		(AJCRMV_DIR  | AJCRMV_ERR)

//--------------------------------------------------------------------------------------------------------------//
//	t@CˍXgXg 																					//
//--------------------------------------------------------------------------------------------------------------//
//	G[R[h
#define	AJCFMLERR_OK			0			//	
#define	AJCFMLERR_NULL			-1			//	pXPCQ NULL
#define	AJCFMLERR_PATH1			-2			//	pXP݂Ȃ
#define	AJCFMLERR_PATH2			-3			//	pXQ݂Ȃ
#define	AJCFMLERR_SYSAPI		-4			//	VXe`ohG[
#define	AJCFMLERR_MEM			-5			//	G[
#define	AJCFMLERR_STOP_BY_USER	-9			//	R[obN璆~w

//	optiIvVj
#define	AJCFML_BOTH				0			//	}b`OXgɃt@CƃfBNg܂߂
#define	AJCFML_NOFILE			0x01		//	}b`OXgɃt@C܂߂Ȃ
#define	AJCFML_NODIR			0x02		//	}b`OXgɃfBNg܂߂Ȃ

//	wb_
typedef	struct {
	UI		utc;							//	t@CE^CX^vitsbj
	UI		att;							//	t@C
	ULL		size;							//	t@CTCY
} AJCFMLHD, *PAJCFMLHD;

//----- oCg ---------------------------------------------------------------------------------------------//
//	񋓏
typedef struct {
	BOOL		fValid;						//	LtO
	AJCFMLHD	hd;							//	ʃwb_
	BC			path[MAX_PATH];				//	t@C^fBNgpX
	BC			name[MAX_PATH];				//	t@CƊgqifBNg̏ꍇ́ApXځj
	BC			tail[MAX_PATH];				//	pX̌㕔iw肵 pPath1/pPath2 ̌㑱j
} AJCFMLITEMA, *PAJCFMLITEMA;
typedef const AJCFMLITEMA *PCAJCFMLITEMA;

//----- Ch ---------------------------------------------------------------------------------------------//
//	񋓏
typedef struct {
	BOOL		fValid;						//	LtO
	AJCFMLHD	hd;							//	ʃwb_
	WC			path[MAX_PATH];				//	t@CpX
	WC			name[MAX_PATH];				//	t@CƊgqifBNg̏ꍇ́ApXځj
	WC			tail[MAX_PATH];				//	pX̌㕔iw肵 pPath1/pPath2 ̌㑱j
} AJCFMLITEMW, *PAJCFMLITEMW;
typedef const AJCFMLITEMW *PCAJCFMLITEMW;

/*--------------------------------------------------------------------------------------------------------------*/
/*	vg^Cv																								*/
/*--------------------------------------------------------------------------------------------------------------*/
AJCEXPORT	BOOL	WINAPI AjcCopyFolderStructA(C_BCP pPathFrom, C_BCP pPathTo, UI opt);
AJCEXPORT	BOOL	WINAPI AjcCopyFolderStructW(C_WCP pPathFrom, C_WCP pPathTo, UI opt);


AJCEXPORT	BOOL	WINAPI	AjcCopyFolderStructExA(C_BCP pPathFrom, C_BCP pPathTo, UI opt, UX cbp, 
													BOOL (CALLBACK *cbNotify)(C_BCP pPathFrom , C_BCP pPathTo, EAJCCFS ntc, UX cbp),
													BCP  (CALLBACK *cbQuery )(C_BCP pPathFront,   BCP pNewDir,				UX cbp));
AJCEXPORT	BOOL	WINAPI	AjcCopyFolderStructExW(C_WCP pPathFrom, C_WCP pPathTo, UI opt, UX cbp, 
													BOOL (CALLBACK *cbNotify)(C_WCP pPathFrom , C_WCP pPathTo, EAJCCFS ntc, UX cbp),
													WCP  (CALLBACK *cbQuery )(C_WCP pPathFront,   WCP pNewDir,				UX cbp));


AJCEXPORT	BOOL	WINAPI AjcCopyFilesA(C_BCP pPathFrom, C_BCP pPathTo, C_BCP pWildCard, UI opt);
AJCEXPORT	BOOL	WINAPI AjcCopyFilesW(C_WCP pPathFrom, C_WCP pPathTo, C_WCP pWildCard, UI opt);

AJCEXPORT	BOOL	WINAPI AjcCopyFilesExA(C_BCP pPathFrom, C_BCP pPathTo, C_BCP pWildCard, UI opt, UX cbp,
											BOOL (CALLBACK *cbNotify  )(C_BCP pFileFrom, C_BCP pFileTo, EAJCCFS ntc, UX cbp),
											BCP  (CALLBACK *cbQuery   )(C_BCP pFileFrom, C_BCP pFileTo, BCP pFileName, UIP pAtt, UX cbp),
											BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp));
AJCEXPORT	BOOL	WINAPI AjcCopyFilesExW(C_WCP pPathFrom, C_WCP pPathTo, C_WCP pWildCard, UI opt, UX cbp,
											BOOL (CALLBACK *cbNotify  )(C_WCP pFileFrom, C_WCP pFileTo, EAJCCFS ntc , UX cbp),
											WCP  (CALLBACK *cbQuery   )(C_WCP pFileFrom, C_WCP pFileTo, WCP pFileName, UIP pAtt, UX cbp),
											BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp));

AJCEXPORT	BOOL	WINAPI	AjcCopyFileA(C_BCP pFrom, C_BCP pTo, BOOL fCreateAlways, UX cbp, BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp));
AJCEXPORT	BOOL	WINAPI	AjcCopyFileW(C_WCP pFrom, C_WCP pTo, BOOL fCreateAlways, UX cbp, BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp));

AJCEXPORT	BOOL	WINAPI	AjcCopyFileExA(C_BCP pFrom, C_BCP pTo, BOOL fCreateAlways, BOOL *pfCancel, UX cbp, BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp));
AJCEXPORT	BOOL	WINAPI	AjcCopyFileExW(C_WCP pFrom, C_WCP pTo, BOOL fCreateAlways, BOOL *pfCancel, UX cbp, BOOL (CALLBACK *cbProgress)(ULL FileSize, ULL Copied, UX cbp));

AJCEXPORT	BOOL	WINAPI AjcRemoveFolderA(C_BCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_BCP pPathRemoved, UI ntc, UX cbp));
AJCEXPORT	BOOL	WINAPI AjcRemoveFolderW(C_WCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP pPathRemoved, UI ntc, UX cbp));

AJCEXPORT	BOOL	WINAPI AjcCleanFolderA(C_BCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_BCP pPathRemoved, UI ntc, UX cbp));
AJCEXPORT	BOOL	WINAPI AjcCleanFolderW(C_WCP pPath, UX cbp, BOOL (CALLBACK *cbNotify)(C_WCP pPathRemoved, UI ntc, UX cbp));

AJCEXPORT	int		WINAPI AjcEnumFilesMatchingListA(C_BCP pPath1, C_BCP pPath2, UI opt, UX cbp, BOOL (CALLBACK *cbQuery)(UI id, C_BCP pPath, UI att, BOOL *pfDiscard, UX cbp),
																						 		 BOOL (CALLBACK *cbEnum )(AJCFMLITEMA item[2], UX cbp));
AJCEXPORT	int		WINAPI AjcEnumFilesMatchingListW(C_WCP pPath1, C_WCP pPath2, UI opt, UX cbp, BOOL (CALLBACK *cbQuery)(UI id, C_WCP pPath, UI att, BOOL *pfDiscard, UX cbp),
																						 		 BOOL (CALLBACK *cbEnum )(AJCFMLITEMW item[2], UX cbp));

AJCEXPORT	BOOL	WINAPI AjcCreateDirectoryStructA(C_BCP pPath);
AJCEXPORT	BOOL	WINAPI AjcCreateDirectoryStructW(C_WCP pPath);

AJCEXPORT	BOOL	WINAPI AjcCreateDirectoryStructExA(C_BCP pPath, LPSECURITY_ATTRIBUTES lpSecurityAttributes);
AJCEXPORT	BOOL	WINAPI AjcCreateDirectoryStructExW(C_WCP pPath, LPSECURITY_ATTRIBUTES lpSecurityAttributes);

AJCEXPORT	BOOL	WINAPI	AjcPathMatchSpecA(C_BCP pPath, C_BCP pWild);
AJCEXPORT	BOOL	WINAPI	AjcPathMatchSpecW(C_WCP pPath, C_WCP pWild);

AJCEXPORT	BOOL	WINAPI	AjcPathMatchStrA(C_BCP pPath, C_BCP pStr);
AJCEXPORT	BOOL	WINAPI	AjcPathMatchStrW(C_WCP pPath, C_WCP pStr);

AJCEXPORT	BOOL	WINAPI	AjcIsPathBackslashA(C_BCP pPath);
AJCEXPORT	BOOL	WINAPI	AjcIsPathBackslashW(C_WCP pPath);

AJCEXPORT	BOOL	WINAPI	AjcIsPathBackslashExA(C_BCP pPath);
AJCEXPORT	BOOL	WINAPI	AjcIsPathBackslashExW(C_WCP pPath);

AJCEXPORT	BOOL	WINAPI	AjcPathCatA(BCP pTop, C_BCP pTail, int lBuf);
AJCEXPORT	BOOL	WINAPI	AjcPathCatW(WCP pTop, C_WCP pTail, int lBuf);

AJCEXPORT	int		WINAPI	AjcPathCmpA(C_BCP pPath1, C_BCP pPath2);
AJCEXPORT	int		WINAPI	AjcPathCmpW(C_WCP pPath1, C_WCP pPath2);

AJCEXPORT	BOOL	WINAPI	AjcPathExistsA(C_BCP pPath);
AJCEXPORT	BOOL	WINAPI	AjcPathExistsW(C_WCP pPath);

AJCEXPORT	BOOL	WINAPI	AjcPathIsDirectoryA(C_BCP pPath);
AJCEXPORT	BOOL	WINAPI	AjcPathIsDirectoryW(C_WCP pPath);

AJCEXPORT	BOOL	WINAPI	AjcPathIsEmptyDirectoryA(C_BCP pPath, UX cbp, BOOL (CALLBACK *cbQuery)(C_BCP pPath, UI att, BOOL *pfDiscard, UX cbp));
AJCEXPORT	BOOL	WINAPI	AjcPathIsEmptyDirectoryW(C_WCP pPath, UX cbp, BOOL (CALLBACK *cbQuery)(C_WCP pPath, UI att, BOOL *pfDiscard, UX cbp));

AJCEXPORT	BOOL	WINAPI	AjcPathIsFileA(C_BCP pPath);
AJCEXPORT	BOOL	WINAPI	AjcPathIsFileW(C_WCP pPath);

AJCEXPORT	ULL		WINAPI	AjcGetFileSizeA(C_BCP pPath);
AJCEXPORT	ULL		WINAPI	AjcGetFileSizeW(C_WCP pPath);

AJCEXPORT	UI		WINAPI	AjcGetFileTime1970A(C_BCP pPath);
AJCEXPORT	UI		WINAPI	AjcGetFileTime1970W(C_WCP pPath);

AJCEXPORT	BOOL	WINAPI	AjcFileCompareA(C_BCP pFile1, C_BCP pFile2);
AJCEXPORT	BOOL	WINAPI	AjcFileCompareW(C_WCP pFile1, C_WCP pFile2);

AJCEXPORT	BOOL	WINAPI	AjcGetFileTimeA(C_BCP pPath, PAJCFTIMES pFTimes, PAJCSTIMES pSTimes, BOOL fLocalTime);
AJCEXPORT	BOOL	WINAPI	AjcGetFileTimeW(C_WCP pPath, PAJCFTIMES pFTimes, PAJCSTIMES pSTimes, BOOL fLocalTime);

AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeA(C_BCP pPath, PCAJCFTIMES pFTimes, BOOL fLocalTime);
AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeW(C_WCP pPath, PCAJCFTIMES pFTimes, BOOL fLocalTime);

AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeBySysTimeA(C_BCP pPath, LPSYSTEMTIME pSTimes, BOOL fLocalTime);
AJCEXPORT	BOOL	WINAPI	AjcSetFileTimeBySysTimeW(C_WCP pPath, LPSYSTEMTIME pSTimes, BOOL fLocalTime);

AJCEXPORT	C_BCP	WINAPI	AjcIsSamePathA(C_BCP pBase, C_BCP pPath1, C_BCP pPath2);
AJCEXPORT	C_WCP	WINAPI	AjcIsSamePathW(C_WCP pBase, C_WCP pPath1, C_WCP pPath2);

AJCEXPORT	BOOL	WINAPI	AjcIsUnderPathA(C_BCP pBase, C_BCP pUpperPath, C_BCP pUnderPath);
AJCEXPORT	BOOL	WINAPI	AjcIsUnderPathW(C_WCP pBase, C_WCP pUpperPath, C_WCP pUnderPath);

//----- lrhkpT|[gR[h -------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcEnumFileMatchingListMsil(C_WCP pPath1, C_WCP pPath2, UI opt, UX cbp, 
					BOOL (CALLBACK *cbQuery)(UI id, C_WCP pPath, UI att, BOOL *fDiscard, UX cbp),
					BOOL (CALLBACK *cbEnum )(BOOL fValid1, UI utc1, UI att1, ULL size1, C_WCP pPath1, C_WCP pName1, C_WCP pTail1,
											 BOOL fValid2, UI utc2, UI att2, ULL size2, C_WCP pPath2, C_WCP pName2, C_WCP pTail2, UX cbp));

/****************************************************************************************************************/
#endif
