#ifndef	AJCLZHDECODE_H_
#define	AJCLZHDECODE_H_
//**************************************************************************************************************//

//--------------------------------------------------------------------------------------------------------------//
//	G[R[h																								//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCLZHERR_OK					= 0			,	//	nj
	AJCLZHERR_UNARYCODE_OUTOFRANGE	= 0x7F00	,	//	PiK͈͊O
	AJCLZHERR_ILLEGAL_BITLEN					,	//	srbg
	AJCLZHERR_BLEN_OVER19						,	//	rbg̃rbge[ũGgPXI[o[
	AJCLZHERR_BLEN_OVER510						,	//	rbge[ũGgTPOI[o[
	AJCLZHERR_ILLEGAL_FORMAT					,	//	wb_̓esi"-lh0-" , "-lh5-" , "-lhd-" ȊOj
	AJCLZHERR_ILLEGAL_HDLVL						,	//	wb_̓esiwb_xO`QȊOj
	AJCLZHERR_NOTFOUND							,	//	t@CȂ
	AJCLZHERR_MEMORY							,	//	s
	AJCLZHERR_INVALIDMODE						,	//	s[h
	AJCLZHERR_NULLPTR							,	//	NULL|C^

	AJCLZHERR_NUM
} AJCLZHERR, *PAJCLZHERR;
//--------------------------------------------------------------------------------------------------------------//
//	CX^X																								//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCLZHINPBUFSIZE	128				//	̓obt@TCYioCgj
#define		AJCLZHNAMEBUFSIZE	MAX_PATH		//	́ipXCt@Cj̃obt@TCYioCgj

//----- [h(mode) ---------------------------------------------------------------------------------------//
typedef enum {
	AJCLZHMODE_SEARCH	 =	1		,			//	ɓt@C[h
	AJCLZHMODE_READ								//	ɓt@Cǂݏo[h
} AJCLZHMODE;

//----- tO(flg) ----------------------------------------------------------------------------------------//
//	wtO
#define	AJCLZHF_SUBDIR	 	0x01			//	TufBNg
#define	AJCLZHF_SRH_DIR		0x02			//	fBNg
#define	AJCLZHF_NOSRH_FILE	0x04			//	t@C

#define	AJCLZHF_DIRONLY	(AJCLZHF_SUBDIR | AJCLZHF_SRH_DIR | AJCLZHF_NOSRH_FILE)

//	dneCWP[^
#define	AJCLZHF_EOF		 	0x80			//	Ƀt@ĈdnetO

//	}XNl
#define	AJCLZHF_MSK_FIND	(AJCLZHF_SUBDIR | AJCLZHF_SRH_DIR | AJCLZHF_NOSRH_FILE)
#define	AJCLZHF_MSK_OPEN	(AJCLZHF_SUBDIR)


//--------------------------------------------------------------------------------------------------------------//
typedef struct {								//	R[he[uGg
	UW		bl;									//		rbg
	UW		bptn;								//		rbgp^[
	UW		code;								//		R[h
} AJCLZHCTB, *PAJCLZHCTB;
//--------------------------------------------------------------------------------------------------------------//
typedef struct {								//	rbge[u^R[he[u
	UI			MaxBl;							//		őrbg
	UBP			pBlt; UI nBlt;					//		rbge[uiAhXCGgj
	PAJCLZHCTB	pCtb; UI nCtb;					//		fR[he[uiAhXCGgj
} AJCLZHTBL, *PAJCLZHTBL;

//----- [hjI -------------------------------------------------------------------------------------//
typedef	union	{
	struct	{SB  l, h;}	sb;
	struct	{UB  l, h;}	ub;
	SW					sw;
	UW					uw;
} AJCLZHUNIWORD;

//----- O[hjI -------------------------------------------------------------------------------//
typedef	union	{
	struct	{SB  l, ml, mh, h;}	sb;
	struct	{UB  l, ml, mh, h;}	ub;
	struct	{SW  l, h;}			sw;
	struct	{UW  l, h;}			uw;
	SL							sl;
	UL							ul;
} AJCLZHUNILONG;
//--------------------------------------------------------------------------------------------------------------//
typedef	struct	{

	AJCLZHMODE		mode;						//	[h
	UI				flg;						//	wtOCɃt@ĈdneCWP[^

	//----- Xg[͊Ǘ -----------------------------------------------------------------------------//
	UI		dl;												//	obt@̗Lf[^oCg					//
	UI		ix;												//	obt@CfNX								//
	UB		RBuf[AJCLZHINPBUFSIZE];							//	t@Cǂݏoobt@						//
	UX		xp;												//	R[obNp^							//
	UI		(CALLBACK *cbRead)(UX xp, VOP pBuf, UI len);	//	͗pR[obN֐							//
	VO		(CALLBACK *cbSeek)(UX xp, UL ofs);				//	oCgʒuݒpR[obN֐				//

	//----- t@Cp[N -------------------------------------------------------------------------------//
	BC		WildDir [MAX_PATH];					//	ChJ[h̃pX
	BC		WildSpec[MAX_PATH];					//	ChJ[h
	UL		ofs;								//	ɓ݂̌̃oCgʒu
	UL		BlkSize;							//	wb_{kf[^̃TCY
	UW 		crc;								//	bqb
	UW		crcEx;								//	gwb_̂bqb
	UB		Sig;								//	VOl`('0' / '5' / 'd')
	UB		Lvl;								//	wb_xiO/P/Qj
	UB		os;									//	nr
	UB		CheckSum;							//	`FbNT
	UB		FileAttr;							//	t@C
	UB		filler1[3];							//	|
	UI		HeadSize;							//	wb_TCY

	BC		PathName[MAX_PATH];					//	pX
	UB		fLocalTime;							//	FALSE=UTC, TRUE=Local Time
	UB		filler2[3];							//	|
	UL		HuffSize;							//	kf[^TCY
	UL		FileSize;							//	t@CTCY
	UL		FileCnt;							//	fR[hς݃oCg
	UL		FileTime;							//	t@C^C
	BC		DirName [MAX_PATH];					//	fBNg
	BC		FileName[MAX_PATH];					//	t@C{gq

	//----- fR[hp[N -----------------------------------------------------------------------------------//
	UW		BlkCodes;							//	Ykۯ̃R[h(fR[hR[hA
												//	AAv񒷂\A2`3R[h͂PƂĐj
	AJCLZHUNILONG	u;							//	rbgXg[RQrbgobt@
	UI			rem;							//	cLrbg
	AJCLZHTBL	BLen;							//	rbge[u
	AJCLZHTBL	Deco;							//	fR[he[u
	AJCLZHTBL	Dist;							//	fBX^Xe[u
	UBP			pDicTop;						//	XCh̐擪AhX
	UBP			pDic;							//	XCh|C^
	UI			xDic;							//	pDicʒũXChItZbgl
	UI			MatchLen;						//	voCg
	UBP			pMatch;							//	vւ̃|C^
	UI			xMatch;							//	pMatchʒũXChItZbgl
} AJCLZH, *HAJCLZH;

//--------------------------------------------------------------------------------------------------------------//
//	ʏ																								//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
typedef struct {
	UL		HuffSize;							//	kf[^TCY
	UL		FileSize;							//	t@CTCY
	UL		FileTime;							//	t@C^Ci1970-01-01, 00:00:00̒ʎZbj
	BOOL	fLocalTime;							//	TRUE:[J^CDFALSE:tsb
	UW		crc;								//	bqb
	UW		dmy;								//	_~[
	BC		szPathName[MAX_PATH];				//	t@CpXւ̃|C^iex. "temp\sample.txt" j
	BC		szDirName [MAX_PATH];				//	fBNgւ̃|C^iex. "temp\"           j
	BC		szFileName[MAX_PATH];				//	t@Cւ̃|C^	  iex. "sample.txt"	  j
	BOOL	fDir;								//	fBNgł邱ƂtO
} AJCLZHFILEINFOA, *PAJCLZHFILEINFOA;

//----- Ch ---------------------------------------------------------------------------------------------//
typedef struct {
	UL		HuffSize;							//	kf[^TCY
	UL		FileSize;							//	t@CTCY
	UL		FileTime;							//	t@C^Ci1970-01-01, 00:00:00̒ʎZbj
	BOOL	fLocalTime;							//	TRUE:[J^CDFALSE:tsb
	UW		crc;								//	bqb
	UW		dmy;								//	_~[
	WC		szPathName[MAX_PATH];				//	t@CpXւ̃|C^iex. "temp\sample.txt" j
	WC		szDirName [MAX_PATH];				//	fBNgւ̃|C^iex. "temp\"           j
	WC		szFileName[MAX_PATH];				//	t@Cւ̃|C^	  iex. "sample"		  j
	WC		szExtName [MAX_PATH];				//	gqւ̃|C^	  iex. "txt"			  j
	BOOL	fDir;								//	fBNgł邱ƂtO
} AJCLZHFILEINFOW, *PAJCLZHFILEINFOW;


//--------------------------------------------------------------------------------------------------------------//
//	tmhbncd^`rbhh																					//
//--------------------------------------------------------------------------------------------------------------//
#ifdef	UNICODE
	#define	AJCLZHFILEINFO		AJCLZHFILEINFOW
	#define	PAJCLZHFILEINFO		PAJCLZHFILEINFOW
	#define	AjcLzhFindFirst		AjcLzhFindFirstW
	#define	AjcLzhOpen			AjcLzhOpenW
	#define	AjcLzhGetFileInfo	AjcLzhGetFileInfoW
#else
	#define	AJCLZHFILEINFO		AJCLZHFILEINFOA
	#define	PAJCLZHFILEINFO		PAJCLZHFILEINFOA
	#define	AjcLzhFindFirst		AjcLzhFindFirstA
	#define	AjcLzhOpen			AjcLzhOpenA
	#define	AjcLzhGetFileInfo	AjcLzhGetFileInfoA
#endif

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCLZH		WINAPI	AjcLzhFindFirstA(C_BCP pWild, UI flag, UX xp,
												UI (CALLBACK *cbRead)(UX xp, VOP pBuf, UI len),
												VO (CALLBACK *cbSeek)(UX xp, UL ofs));

AJCEXPORT	HAJCLZH		WINAPI	AjcLzhFindFirstW(C_WCP pWild, UI flag, UX xp,
												UI (CALLBACK *cbRead)(UX xp, VOP pBuf, UI len),
												VO (CALLBACK *cbSeek)(UX xp, UL ofs));

AJCEXPORT	BOOL		WINAPI	AjcLzhFindNext (HAJCLZH hLzh);

AJCEXPORT	HAJCLZH		WINAPI	AjcLzhOpenA(C_BCP pFilePath, UI flag, UX xp,
											 UI (CALLBACK *cbRead)(UX xp, VOP pBuf, UI len),
											 VO (CALLBACK *cbSeek)(UX xp, UL ofs));

AJCEXPORT	HAJCLZH		WINAPI	AjcLzhOpenW(C_WCP pFilePath, UI flag, UX xp,
											 UI (CALLBACK *cbRead)(UX xp, VOP pBuf, UI len),
											 VO (CALLBACK *cbSeek)(UX xp, UL ofs));

AJCEXPORT	UI			WINAPI	AjcLzhRead		(HAJCLZH hLzh, VOP pBuf, UI len);

AJCEXPORT	VO			WINAPI	AjcLzhClose	(HAJCLZH hLzh);

AJCEXPORT	BOOL		WINAPI	AjcLzhGetFileInfoA(HAJCLZH hLzh, PAJCLZHFILEINFOA);
AJCEXPORT	BOOL		WINAPI	AjcLzhGetFileInfoW(HAJCLZH hLzh, PAJCLZHFILEINFOW);

AJCEXPORT	AJCLZHERR	WINAPI	AjcLzhGetLastError(VO);

//**************************************************************************************************************//
#endif
