#ifndef	AJCMAIN_H_
#define	AJCMAIN_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																										//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCLID_ENG	= 0	,
	AJCLID_JPN	= 0x411
} AJCLANGID;

#define		AJCLNGSEL(JPN, ENG)	((AjcGetLangId() == AJCLID_JPN) ? JPN : ENG)

//--------------------------------------------------------------------------------------------------------------//
//	o[W\̃\[X																				//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCVER_BMAP		= 1	,		//	rbg}bv
	AJCVER_ICON		= 2	,		//	ACR
} AJCVER_RESKND;

//--------------------------------------------------------------------------------------------------------------//
//	MAjcInit()̖߂l																							//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCINIT_OK		= 0	,		//	
	AJCINIT_FAILURE		,		//	si\[Xsj
} AJCINIT_RESULT;

//--------------------------------------------------------------------------------------------------------------//
//	c[`bv̍ő咷																					//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCMAX_TIPSIZE		128

//--------------------------------------------------------------------------------------------------------------//
//	s																									//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCTRIAL_DAYS	64

//--------------------------------------------------------------------------------------------------------------//
//	ėp}N																									//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCTSIZE(_TEXT_)	(sizeof _TEXT_ / sizeof _TEXT_[0])		//	eLXgoCg^
#define		AJCSZARR(_ARR_)		(sizeof _ARR_  / sizeof _ARR_[0] )		//	zGgTCY

/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define		AjcSetAppName				AjcSetAppNameW

	#define		AjcTAlloc					AjcTAllocW
	#define		AjcGetVerStr				AjcGetVerStrW
	#define		AjcGetVersion				AjcGetVersionW
	#define		AjcGetVerInRes				AjcGetVerInResW

	#define		AjcGetMyPath				AjcGetMyPathW
	#define		AjcAdjustSemiCollon			AjcAdjustSemiCollonW
	#define		AjcAjrAppVersionDialog		AjcAjrAppVersionDialogW
	#define		AjcAjrAppVersionDialogEx	AjcAjrAppVersionDialogExW
	//	g[X
	#define		AjcTrace					AjcTraceW

#else

	#define		AjcSetAppName				AjcSetAppNameA

	#define		AjcTAlloc					AjcTAllocA
	#define		AjcGetVerStr				AjcGetVerStrA
	#define		AjcGetVersion				AjcGetVersionA
	#define		AjcGetVerInRes				AjcGetVerInResA
	#define		AjcGetMyPath				AjcGetMyPathA
	#define		AjcAdjustSemiCollon			AjcAdjustSemiCollonA
	#define		AjcAjrAppVersionDialog		AjcAjrAppVersionDialogA
	#define		AjcAjrAppVersionDialogEx	AjcAjrAppVersionDialogExA
	//	g[X
	#define		AjcTrace					AjcTraceA

#endif
//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HFONT		WINAPI	AjcGetDefFontFix(int FontHeight);
AJCEXPORT	HFONT		WINAPI	AjcGetDefFontVar(int FontHeight);


AJCEXPORT	HINSTANCE	WINAPI	AjcGetDllInstance(void);

AJCEXPORT	AJCINIT_RESULT	WINAPI	AjcInit(UL dmy1, UL dmy2);
AJCEXPORT	VO				WINAPI	AjcSetCmdWithHdl(BOOL fWithHandle);

AJCEXPORT	VO			WINAPI	AjcSetAppNameA(C_BCP pName);
AJCEXPORT	VO			WINAPI	AjcSetAppNameW(C_WCP pName);

AJCEXPORT	VO			WINAPI	AjcSetAppIcon(HICON hIcon);

AJCEXPORT	VO			WINAPI	AjcChangeIconToMsil(VO);

AJCEXPORT	VO			WINAPI	AjcSetLangId	 (AJCLANGID Lid);
AJCEXPORT	AJCLANGID	WINAPI	AjcGetLangId	 (VO);

typedef	VO (CALLBACK *CBCLEANUP)(VOP pHandle);
AJCEXPORT	VOP			WINAPI	AjcAllocInstance(int size, CBCLEANUP cbCleanup);
AJCEXPORT	VO			WINAPI	AjcReleaseInstance(VOP pHandle);


//----- eLXgE蓖 -------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcTAllocA(UI TextLength);
AJCEXPORT	WCP		WINAPI	AjcTAllocW(UI TextLength);
AJCEXPORT	VO		WINAPI	AjcTFree(VOP pTxt);

//----- o[W擾 -----------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcGetVerStrA(VO);
AJCEXPORT	WCP		WINAPI	AjcGetVerStrW(VO);

AJCEXPORT	VO		WINAPI	AjcGetVersionA(BCP pBuf, int lBuf);
AJCEXPORT	VO		WINAPI	AjcGetVersionW(WCP pBuf, int lBuf);

AJCEXPORT	UI	WINAPI	AjcGetVerInResA(HINSTANCE hInst, BCP pVerBuf, int lVerBuf);
AJCEXPORT	UI	WINAPI	AjcGetVerInResW(HINSTANCE hInst, WCP pVerBuf, int lVerBuf);

//----- ahmpXChmbpX擾 ---------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcGetMyPathA(BCP pBinPath, int lBinPath, BCP pIncPath, int lIncPath);
AJCEXPORT	VO		WINAPI	AjcGetMyPathW(WCP pBinPath, int lBinPath, WCP pIncPath, int lIncPath);

//----- 擪Ɩ̃Z~R폜AԂ̘AZ~RPɂ܂Ƃ߂ -------------------------------//
AJCEXPORT	VO	WINAPI	AjcAdjustSemiCollonA(BCP pStr);
AJCEXPORT	VO	WINAPI	AjcAdjustSemiCollonW(WCP pStr);

//----- ANZXiPEEK) ----------------------------------------------------------------------------------//
AJCEXPORT	UB		WINAPI	AjcMemPeekUB (C_UBP  pMem);
AJCEXPORT	UW		WINAPI	AjcMemPeekUW (C_UWP  pMem);
AJCEXPORT	UI		WINAPI	AjcMemPeekUL (C_UIP  pMem);
AJCEXPORT	ULL		WINAPI	AjcMemPeekULL(C_ULLP pMem);

AJCEXPORT	SB		WINAPI	AjcMemPeekSB (C_UBP  pMem);
AJCEXPORT	SW		WINAPI	AjcMemPeekSW (C_UWP  pMem);
AJCEXPORT	SI		WINAPI	AjcMemPeekSL (C_UIP  pMem);
AJCEXPORT	SLL		WINAPI	AjcMemPeekSLL(C_ULLP pMem);

//----- Rs[ -------------------------------------------------------------------------------------------//
AJCEXPORT	VOP		WINAPI	AjcMemCopy(VOP pDest, C_VOP pSrc, int len);

//----- Ch -----------------------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcWStrLen(C_WCP pStr);

//----- ChRs[ -------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcWStrCopy(WCP pDest, C_WCP pSrc, int lDest);

//----- oCgChϊ -----------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcByteCharToWideChar(C_BCP pSrc, WCP pDest, int lDest);

//----- ChoCgϊ -----------------------------------------------------------------------------//
AJCEXPORT	int		WINAPI	AjcWideCharToByteChar(C_WCP pSrc, BCP pDest, int lDest);

//----- W̃XebvlZoiJj------------------------------------------------------------------//
AJCEXPORT	double	WINAPI	AjcCalcRangeStep(double RangWidth, double MinDiv, double MaxDiv, UIP pDigit, UIP pPrec);

//----- o[W\_CAO -------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcAjrAppVersionDialogA  (HWND hOwner, C_BCP pVerStr, HBITMAP hBmp , int SrtYY, C_BCP pWndTtl, C_BCP pSubTtl, C_BCP pCpyRgt);
AJCEXPORT	VO		WINAPI	AjcAjrAppVersionDialogW  (HWND hOwner, C_WCP pVerStr, HBITMAP hBmp , int SrtYY, C_WCP pWndTtl, C_WCP pSubTtl, C_WCP pCpyRgt);

AJCEXPORT	VO		WINAPI	AjcAjrAppVersionDialogExA(HWND hOwner, C_BCP pVerStr, UX hBmpOrIcon, int SrtYY, C_BCP pWndTtl, C_BCP pSubTtl, C_BCP pCpyRgt, AJCVER_RESKND knd);
AJCEXPORT	VO		WINAPI	AjcAjrAppVersionDialogExW(HWND hOwner, C_WCP pVerStr, UX hBmpOrIcon, int SrtYY, C_WCP pWndTtl, C_WCP pSubTtl, C_WCP pCpyRgt, AJCVER_RESKND knd);

//----- g[XiIDȄo̓ECh֏ój-----------------------------------------------------------------//
AJCEXPORT	VO		WINAPI AjcTraceA(C_BCP pFmt, ...);
AJCEXPORT	VO		WINAPI AjcTraceW(C_WCP pFmt, ...);





//----- lrhkpT|[gR[h -------------------------------------------------------------------------------//
AJCEXPORT	VO		WINAPI	AjcMsilEncDblBrktW(C_WCP pFmt, WCP pBuf);
AJCEXPORT	VO		WINAPI	AjcMsilEncBrktW(C_WCP pStr, WCP pBuf);
AJCEXPORT	VO		WINAPI	AjcMsilRcvBrktW(C_WCP pStr, WCP pBuf);
AJCEXPORT	int		WINAPI	AjcMsilGetFormatItemW(C_WCP pFmt, WCP pBuf);
AJCEXPORT	VO		WINAPI	AjcMsilFormatIxToZeroW(C_WCP pFmt, WCP pBuf);
AJCEXPORT	VO		WINAPI	AjcPtrToStringW(C_WCP pStr, WCP pBuf, UI len);
AJCEXPORT	int		WINAPI	AjcPtrToStrLenW(C_WCP pStr);



/****************************************************************************************************************/
#endif
