#ifndef	AJCMSGMAP_H_
#define	AJCMSGMAP_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define		AjcMmpInitTbl		AjcMmpInitTblW
	#define		AJC_WNDMAP_DEF		AJC_WNDMAP_DEFW
	#define		AJC_DLGMAP_DEF		AJC_DLGMAP_DEFW
#else
	#define		AjcMmpInitTbl		AjcMmpInitTblA
	#define		AJC_WNDMAP_DEF		AJC_WNDMAP_DEFA
	#define		AJC_DLGMAP_DEF		AJC_DLGMAP_DEFA
#endif
//--------------------------------------------------------------------------------------------------------------//
//	}N																										//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCMSGTYPE_END	0
#define	AJCMSGTYPE_MSG	1
#define	AJCMSGTYPE_CMD	2
#define	AJCMSGTYPE_NTC	3

//--------------------------------------------------------------------------------------------------------------//
//	bZ[W}bv e[u																					//
//--------------------------------------------------------------------------------------------------------------//
//----- ʏp ---------------------------------------------------------------------------------------------//
typedef struct _AJCMSGTBL {
	UI		MsgType;													//	bZ[W^CviAJCMSGTYPE_XXXj
	UI		msg;														//	EChbZ[W
	int		cmd;														//	R}hiRg[hcj
	LRESULT	(*func)(HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam);	//	ANV֐
	C_VOP	pRwm;														//	AviRegisterWindowMessage()pj
	struct _AJCMSGTBL *pNxt;											//	̃Gg|C^
} AJCMSGTBL, *PAJCMSGTBL;
//----- oCg`p ---------------------------------------------------------------------------------------//
typedef struct _AJCMSGTBLA {
	UI		MsgType;													//	bZ[W^CviAJCMSGTYPE_XXXj
	UI		msg;														//	EChbZ[W
	int		cmd;														//	R}hiRg[hcj
	LRESULT	(*func)(HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam);	//	ANV֐
	C_BCP	pRwm;														//	AviRegisterWindowMessage()pj
	struct _AJCMSGTBLA *pNxt;											//	̃Gg|C^
} AJCMSGTBLA, *PAJCMSGTBLA;
//----- Ch`p ---------------------------------------------------------------------------------------//
typedef struct _AJCMSGTBLW {
	UI		MsgType;													//	bZ[W^CviAJCMSGTYPE_XXXj
	UI		msg;														//	EChbZ[W
	int		cmd;														//	R}hiRg[hcj
	LRESULT	(*func)(HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam);	//	ANV֐
	C_WCP	pRwm;														//	AviRegisterWindowMessage()pj
	struct _AJCMSGTBLW *pNxt;											//	̃Gg|C^
} AJCMSGTBLW, *PAJCMSGTBLW;

//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	PAJCMSGTBL	pMsg;
	PAJCMSGTBL	pCmd;
	PAJCMSGTBL	pNtc;
	PAJCMSGTBL	pWmCmd;
	PAJCMSGTBL	pWmNtc;
} AJCMSGCHAINPTR, *PAJCMSGCHAINPTR;
//--------------------------------------------------------------------------------------------------------------//
#define	AJC_WNDPROC_NAME(NAME)	((WNDPROC)AjcWnd##NAME##Proc)
#define	AJC_DLGPROC_NAME(NAME)	((DLGPROC)AjcDlg##NAME##Proc)

#define	AJC_WNDPROC_DEF(NAME)	static	LRESULT CALLBACK AjcWnd##NAME##Proc(HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam)

#define	AJC_DLGPROC_DEF(NAME)	static	LRESULT CALLBACK AjcDlg##NAME##Proc(HWND hDlg, UI msg, WPARAM wParam, LPARAM lParam)

//--------------------------------------------------------------------------------------------------------------//
//	TuNX																							//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	C_BCP		pName;		//	vV[W̖OiAJC_WNDMAP_DEF(name)Ŏw肵́j
	WNDPROC		wpNew;		//	TuNXVEChvV[W
	WNDPROC		wpOld;		//	TuNXǑEChvV[W
	WNDPROC		wpRet;		//	ۂɎs錳EChvV[W
} AJCSBCINFO, *PAJCSBCINFO;
typedef const AJCSBCINFO *PCAJCSBCINFO;


//----------------------------------------------------------------------------------------------------------------------------------//
//	AJC_WNDMAP_DEFiEChbZ[W}bv`Jnj																				//
//----------------------------------------------------------------------------------------------------------------------------------//
//----- oCg -----------------------------------------------------------------------------------------------------------------//
#define	AJC_WNDMAP_DEFA(NAME) 																										\
extern	AJCMSGTBLA		AjcWndMsgTbl_##NAME[];										/*	bZ[We[u						*/	\
static	BOOL			AjcWndMsgFirst_##NAME  = TRUE;								/*	tO								*/	\
static	AJCMSGCHAINPTR	AjcWndMsgChain_##NAME  = {NULL, NULL, NULL, NULL, NULL};	/*	ebZ[W`FCe[u擪|C^*/	\
AJC_WNDPROC_DEF(NAME) {																/*	EChvV[WEGg|Cg	*/	\
	LRESULT rc;																		/*	EChvV[W̖߂l			*/	\
	if (AjcWndMsgFirst_##NAME) {													/*	H									*/	\
		AjcWndMsgFirst_##NAME = FALSE;												/*		tO						*/	\
		AjcMmpInitTblA((PAJCMSGTBL)AjcWndMsgTbl_##NAME, &AjcWndMsgChain_##NAME);	/*			bZ[We[u		*/	\
	}																				/*			E								*/	\
	rc = AjcMmpWndMsgHandle(&AjcWndMsgChain_##NAME, hwnd, msg, wParam, lParam,		/*			bZ[Wnhs			*/	\
											 AJC_WNDPROC_NAME(NAME), #NAME);		/*			E								*/	\
	if		(msg == WM_CREATE ) AjcDgcSubclassEx(hwnd, RGB(255,255,255));			/*			vmcJ[ݒ				*/	\
	else if (msg == WM_DESTROY) AjcMmpDelSubclass(hwnd, #NAME);						/*			TuNX폜				*/	\
	return rc;																		/*			߂							*/	\
}																					/*											*/	\
static	AJCMSGTBLA	AjcWndMsgTbl_##NAME[] = {										/*			bZ[We[uJn			*/
//----- Ch -----------------------------------------------------------------------------------------------------------------//
#define	AJC_WNDMAP_DEFW(NAME) 																										\
extern	AJCMSGTBLW		AjcWndMsgTbl_##NAME[];										/*	bZ[We[u						*/	\
static	BOOL			AjcWndMsgFirst_##NAME  = TRUE;								/*	tO								*/	\
static	AJCMSGCHAINPTR	AjcWndMsgChain_##NAME  = {NULL, NULL, NULL, NULL, NULL};	/*	ebZ[W`FCe[u擪|C^*/	\
AJC_WNDPROC_DEF(NAME) {																/*	EChvV[WEGg|Cg	*/	\
	LRESULT rc;																		/*	EChvV[W̖߂l			*/	\
	if (AjcWndMsgFirst_##NAME) {													/*	H									*/	\
		AjcWndMsgFirst_##NAME = FALSE;												/*		tO						*/	\
		AjcMmpInitTblW((PAJCMSGTBL)AjcWndMsgTbl_##NAME, &AjcWndMsgChain_##NAME);	/*			bZ[We[u		*/	\
	}																				/*			E								*/	\
	rc = AjcMmpWndMsgHandle(&AjcWndMsgChain_##NAME, hwnd, msg, wParam, lParam,		/*			bZ[Wnhs			*/	\
											 AJC_WNDPROC_NAME(NAME), #NAME);		/*			E								*/	\
	if		(msg == WM_CREATE ) AjcDgcSubclassEx(hwnd, RGB(255,255,255));			/*			vmcJ[ݒ				*/	\
	else if (msg == WM_DESTROY) AjcMmpDelSubclass(hwnd, #NAME);						/*			TuNX폜				*/	\
	return rc;																		/*			߂							*/	\
}																					/*											*/	\
static	AJCMSGTBLW	AjcWndMsgTbl_##NAME[] = {										/*			bZ[We[uJn			*/
//----------------------------------------------------------------------------------------------------------------------------------//
//	AJC_DLGMAP_DEFi_CAObZ[W}bv`Jnj																			//
//----------------------------------------------------------------------------------------------------------------------------------//
//----- oCg -----------------------------------------------------------------------------------------------------------------//
#define	AJC_DLGMAP_DEFA(NAME) 																										\
extern	AJCMSGTBLA		AjcDlgMsgTbl_##NAME[];										/*	bZ[We[u						*/	\
static	BOOL			AjcDlgMsgFirst_##NAME  = TRUE;								/*	tO								*/	\
static	AJCMSGCHAINPTR	AjcDlgMsgChain_##NAME  = {NULL, NULL, NULL, NULL, NULL};	/*	ebZ[W`FCe[u擪|C^*/	\
AJC_DLGPROC_DEF(NAME) {																/*	EChvV[WEGg|Cg	*/	\
	LRESULT rc;																		/*	EChvV[W̖߂l			*/	\
	if (AjcDlgMsgFirst_##NAME) {													/*	H									*/	\
		AjcDlgMsgFirst_##NAME = FALSE;												/*		tO						*/	\
		AjcMmpInitTblA((PAJCMSGTBL)AjcDlgMsgTbl_##NAME, &AjcDlgMsgChain_##NAME);	/*			bZ[We[u		*/	\
	}																				/*			E								*/	\
	rc = AjcMmpDlgMsgHandle(&AjcDlgMsgChain_##NAME, hDlg, msg, wParam, lParam);		/*			bZ[Wnhs			*/	\
	if		(msg == WM_INITDIALOG) AjcDgcSubclassEx(hDlg, RGB(255,255,255));		/*			vmcJ[ݒ				*/	\
	return rc;																		/*			߂							*/	\
}																					/*											*/	\
static	AJCMSGTBLA	AjcDlgMsgTbl_##NAME[] = {										/*			bZ[We[uJn			*/
//----- Ch -----------------------------------------------------------------------------------------------------------------//
#define	AJC_DLGMAP_DEFW(NAME) 																										\
extern	AJCMSGTBLW		AjcDlgMsgTbl_##NAME[];										/*	bZ[We[u						*/	\
static	BOOL			AjcDlgMsgFirst_##NAME  = TRUE;								/*	tO								*/	\
static	AJCMSGCHAINPTR	AjcDlgMsgChain_##NAME  = {NULL, NULL, NULL, NULL, NULL};	/*	ebZ[W`FCe[u擪|C^*/	\
AJC_DLGPROC_DEF(NAME) {																/*	EChvV[WEGg|Cg	*/	\
	LRESULT rc;																		/*	EChvV[W̖߂l			*/	\
	if (AjcDlgMsgFirst_##NAME) {													/*	H									*/	\
		AjcDlgMsgFirst_##NAME = FALSE;												/*		tO						*/	\
		AjcMmpInitTblW((PAJCMSGTBL)AjcDlgMsgTbl_##NAME, &AjcDlgMsgChain_##NAME);	/*			bZ[We[u		*/	\
	}																				/*			E								*/	\
	rc = AjcMmpDlgMsgHandle(&AjcDlgMsgChain_##NAME, hDlg, msg, wParam, lParam);		/*			bZ[Wnhs			*/	\
	if		(msg == WM_INITDIALOG) AjcDgcSubclassEx(hDlg, RGB(255,255,255));		/*			vmcJ[ݒ				*/	\
	return rc;																		/*			߂							*/	\
}																					/*											*/	\
static	AJCMSGTBLW	AjcDlgMsgTbl_##NAME[] = {										/*			bZ[We[uJn			*/
//--------------------------------------------------------------------------------------------------------------//
//											 MsgType		 msg		 cmd  func					pRwm  pNxt
#define		AJC_WNDMAP_MSG(NAME, MSG)		{AJCMSGTYPE_MSG, MSG	   , 0	, AjcWnd##NAME##_##MSG, NULL, NULL},
#define		AJC_WNDMAP_RWM(NAME, MSG, APP)	{AJCMSGTYPE_MSG, 0		   , 0	, AjcWnd##NAME##_##MSG, APP , NULL},
#define		AJC_WNDMAP_CMD(NAME, CMD)		{AJCMSGTYPE_CMD, WM_COMMAND, CMD, AjcWnd##NAME##_##CMD, NULL, NULL},
#define		AJC_WNDMAP_NTC(NAME, CMD)		{AJCMSGTYPE_NTC, WM_NOTIFY , CMD, AjcWnd##NAME##_##CMD, NULL, NULL},

#define		AJC_DLGMAP_MSG(NAME, MSG)		{AJCMSGTYPE_MSG, MSG	   , 0	, AjcDlg##NAME##_##MSG, NULL, NULL},
#define		AJC_DLGMAP_RWM(NAME, MSG, APP)	{AJCMSGTYPE_MSG, 0		   , 0	, AjcDlg##NAME##_##MSG, APP , NULL},
#define		AJC_DLGMAP_CMD(NAME, CMD)		{AJCMSGTYPE_CMD, WM_COMMAND, CMD, AjcDlg##NAME##_##CMD, NULL, NULL},
#define		AJC_DLGMAP_NTC(NAME, CMD)		{AJCMSGTYPE_NTC, WM_NOTIFY , CMD, AjcDlg##NAME##_##CMD, NULL, NULL},

#define		AJCM_CTLCOLOR_ANY_STR			TEXT("_AJCM_CTLCOLOR_ANY_")
#define		AJC_WNDMAP_DGC(NAME, MSG)		AJC_WNDMAP_RWM(NAME, MSG, AJCM_CTLCOLOR_ANY_STR)
#define		AJC_DLGMAP_DGC(NAME, MSG)		AJC_DLGMAP_RWM(NAME, MSG, AJCM_CTLCOLOR_ANY_STR)

#define		AJCM_CTLCOLOR_BTN_STR			TEXT("_AJCM_CTLCOLOR_BTN_")
#define		AJC_WNDMAP_DGB(NAME, MSG)		AJC_WNDMAP_RWM(NAME, MSG, AJCM_CTLCOLOR_BTN_STR)
#define		AJC_DLGMAP_DGB(NAME, MSG)		AJC_DLGMAP_RWM(NAME, MSG, AJCM_CTLCOLOR_BTN_STR)

//--------------------------------------------------------------------------------------------------------------//
#define		AJC_WNDMAP_END	{AJCMSGTYPE_END}};
#define		AJC_DLGMAP_END	{AJCMSGTYPE_END}};
//--------------------------------------------------------------------------------------------------------------//
#define		AJC_WNDPROC(NAME, MSG)	static	LRESULT AjcWnd##NAME##_##MSG(HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam)
#define		AJC_DLGPROC(NAME, MSG)	static	LRESULT AjcDlg##NAME##_##MSG(HWND hDlg, UI msg, WPARAM wParam, LPARAM lParam)

//----- TuNXݒ}N -----------------------------------------------------------------------------------//
#define		MAjcMmpSetSubclass(NAME, _HWND_)	AjcMmpSetSubclass(_HWND_, #NAME, AJC_WNDPROC_NAME(NAME))

//----- TuNX}N -----------------------------------------------------------------------------------//
#define		MAjcMmpClrSubclass(NAME, _HWND_)	AjcMmpClrSubclass(_HWND_, #NAME)

//----- ftHgEChvV[WuDefWindowProc()vɕύX ----------------------------------------------//
#define		MAjcMmpSetDefWndProc(NAME, _HWND_)	AjcMmpSetDefWndProcEx(_HWND_, #NAME, DefWindowProc)

//----- IWiEChvV[WĂяo}N -----------------------------------------------------------//
#define		MAjcMmpCallOrgWndProc(NAME)					AjcMmpCallOrgWndProc(hwnd, #NAME, msg, wParam, lParam)
#define		MAjcMmpCallOrgWndProcEx(NAME, H, M, W, L)	AjcMmpCallOrgWndProc(H	 , #NAME, M  , W	 , L	 )

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	VO		CALLBACK AjcMmpInitTbl	(PAJCMSGTBL pMsgTbl, PAJCMSGCHAINPTR pChain);
AJCEXPORT	LRESULT	CALLBACK AjcMmpWndMsgHandle(PAJCMSGCHAINPTR pChain, HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam, WNDPROC MyProc, C_BCP pName);
AJCEXPORT	LRESULT	CALLBACK AjcMmpDlgMsgHandle(PAJCMSGCHAINPTR pChain, HWND hDlg, UI msg, WPARAM wParam, LPARAM lParam);

#ifdef AJCOLDSUBCLASS
AJCEXPORT	BOOL	CALLBACK AjcMmpSetDefWndProc (HWND hwnd, WNDPROC DefWndProc);
AJCEXPORT	WNDPROC	CALLBACK AjcMmpGetDefWndProc (HWND hwnd);
AJCEXPORT	LRESULT	CALLBACK AjcMmpCallDefWndProc(HWND hwnd, UI msg, WPARAM wParam, LPARAM lParam);
#endif

AJCEXPORT	WNDPROC	CALLBACK AjcMmpSetSubclass	  (HWND hwnd, C_BCP pName, WNDPROC NewProc);
AJCEXPORT	BOOL	CALLBACK AjcMmpClrSubclass	  (HWND hwnd, C_BCP pName);
AJCEXPORT	BOOL 	CALLBACK AjcMmpDelSubclass	  (HWND hwnd, C_BCP pName);
AJCEXPORT	UI		CALLBACK AjcMmpGetSubclassInfo(HWND hwnd, AJCSBCINFO buf[], UI nBuf);
AJCEXPORT	BOOL	CALLBACK AjcMmpSetDefWndProcEx(HWND hwnd, C_BCP pName, WNDPROC DefWndProc);
AJCEXPORT	WNDPROC	CALLBACK AjcMmpGetDefWndProcEx(HWND hwnd, C_BCP pName);
AJCEXPORT	LRESULT	CALLBACK AjcMmpCallOrgWndProc (HWND hwnd, C_BCP pName, UI msg, WPARAM wParam, LPARAM lParam);

/****************************************************************************************************************/
#endif
