#ifndef	AJCCTRLPRINTER_H_
#define	AJCCTRLPRINTER_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define		AjcPrnCreate		AjcPrnCreateW
	#define		AjcPrnGetInfo		AjcPrnGetInfoW
#else
	#define		AjcPrnCreate		AjcPrnCreateA
	#define		AjcPrnGetInfo		AjcPrnGetInfoA
#endif

//--------------------------------------------------------------------------------------------------------------//
//	p̌																									//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCPRN_ORIENT_UNKOWN	= 0 					,	//	s
	AJCPRN_ORIENT_PORTRAIT	= DMORIENT_PORTRAIT		,	//	c
	AJCPRN_ORIENT_LANDSCAPE	= DMORIENT_LANDSCAPE	,	//	
} AJCPRN_ORIENT;

//--------------------------------------------------------------------------------------------------------------//
//	]TCY																									//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	int		l;		//	[]
	int		r;		//	E[]
	int		u;		//	[]
	int		d;		//	[]
} AJCPRN_MARGIN, *PAJCPRN_MARGIN;
typedef const AJCPRN_MARGIN *PCAJCPRN_MARGIN;

//--------------------------------------------------------------------------------------------------------------//
//	]																									//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	AJCPRN_MARGIN	mm, mmMin, mmMax;
	AJCPRN_MARGIN	px, pxMin, pxMax;
} AJCPRN_MRGINFO, *PAJCPRN_MRGINFO;
typedef const AJCPRN_MRGINFO *PCAJCPRN_MRGINFO;

//--------------------------------------------------------------------------------------------------------------//
//	v^																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	//----- v^ -----------//
	int					x , y;					//	]`捶ʒu
	int					cx, cy;					//	]`sNZ
	AJCPRN_MRGINFO		MrgIf;					//	]
	//----- v^ -----------//
	int					cxFull, cyFull;			//	pTCỸsNZ
	int					cxPage, cyPage;			//	󎚉\̈̃sNZ
	int					OffsetX;				//	Es\̃sNZ
	int					OffsetY;				//	㉺s\̃sNZ
	int					FactorX;				//	v^̐̔{
	int					FactorY;				//	v^̐̔{
	int					LogPixelsX;				//	PC`̉sNZ
	int					LogPixelsY;				//	PC`̏csNZ
	AJCPRN_ORIENT		Orientation;			//	AJCPRN_ORIENT_PORTRAIT(c) / AJCPRN_ORIENT_LANDSCAPE()
} AJCPRN_INFO, *PAJCPRN_INFO;
typedef const AJCPRN_INFO *PCAJCPRN_INFO;

//--------------------------------------------------------------------------------------------------------------//
//	y[W																									//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	AJCPRN_MARGIN	mmMrg;
	AJCPRN_ORIENT	orientation;
}  AJCPRN_PGINFO, *PAJCPRN_PGINFO;
typedef const AJCPRN_PGINFO *PCAJCPRN_PGINFO;

//--------------------------------------------------------------------------------------------------------------//
//	IvV																								//
//--------------------------------------------------------------------------------------------------------------//
//	IvVtO
#define	AJCPRNF_OUTPUTTOFILE				0x0100000000ULL				  // t@C֏o͂`FbNꂽ
#define	AJCPRNF_DISABLECOPIES				0x0200000000ULL				  // uvuPʂňv𖳌
#define	AJCPRNF_DISABLEPAGEINFO				0x0400000000ULL				  // uy[Ẃ͈v𖳌ɂ

#define	AJCPRNF_ALLPAGES					PD_ALLPAGES 				  // [ׂ]WI {^ŏɑIĂ邱Ƃ̃tO
#define	AJCPRNF_SELECTION					PD_SELECTION				  // ̃tOݒ肷ƁAuIvWI{^I܂B
#define	AJCPRNF_PAGENUMS					PD_PAGENUMS 				  // ̃tOݒ肷ƁA[y[Ww]WI {^I܂B
#define	AJCPRNF_NOSELECTION 				PD_NOSELECTION				  // [I] WI {^𖳌ɂ܂B
#define	AJCPRNF_NOPAGENUMS					PD_NOPAGENUMS				  // [y[Ww]WI {^Ɗ֘AtĂGfBbg Rg[𖳌ɂ܂B
#define	AJCPRNF_COLLATE 					PD_COLLATE					  // ̃tOݒ肷ƁA[ƍ] `FbN {bNXIɂȂ܂B
#define	AJCPRNF_PRINTTOFILE 				PD_PRINTTOFILE				  // ̃tOݒ肷ƁA[t@C֏o] `FbN {bNXIɂȂ܂B
#define	AJCPRNF_NOWARNING					PD_NOWARNING				  // ̃v^ȂꍇɌxbZ[W\Ȃ悤ɂ܂B
#define	AJCPRNF_USEDEVMODECOPIES			PD_USEDEVMODECOPIES 		  // ̃tÓAAvP[ṼRs[ƏƍT|[g邩ǂ܂B-
#define	AJCPRNF_USEDEVMODECOPIESANDCOLLATE	PD_USEDEVMODECOPIESANDCOLLATE // AvP[ṼRs[ƏƍT|[gĂȂƂɂ́A͂ɂ̃tOݒ肵܂B
#define	AJCPRNF_DISABLEPRINTTOFILE			PD_DISABLEPRINTTOFILE		  // [t@C֏o] `FbN {bNX𖳌ɂ܂B
#define	AJCPRNF_HIDEPRINTTOFILE 			PD_HIDEPRINTTOFILE			  // [t@C֏o] `FbN {bNX\ɂ܂B
#define	AJCPRNF_NONETWORKBUTTON 			PD_NONETWORKBUTTON			  // [lbg[N] {^\܂͖ɂ܂B

#define	AJCPRNF_CURRENTPAGE 				PD_CURRENTPAGE				  // [݂̃y[W]IԂɂ܂
#define	AJCPRNF_NOCURRENTPAGE				PD_NOCURRENTPAGE			  // [݂̃y[W]𖳌Ԃɂ܂

//	߂l
//#define	AJCPRNRC_CANCEL 	PD_RESULT_CANCEL		//	0:LZ{^
//#define	AJCPRNRC_PRINT		PD_RESULT_PRINT			//	1:{^
//#define	AJCPRNRC_APPLY		PD_RESULT_APPLY			//	2:Kp{^

#define	AJCPRNMAX_PGRANGES	2				//	őy[WW

typedef struct {
	ULL		Flags;							//	IvVtO
	UI		nCopies;						//	Rs[
	UI		nFromPage;						//	Jny[W
	UI		nToPage;						//	Iy[W
	UI		nMinPage;						//	y[W͈͂̍ŏl
	UI		nMaxPage;						//	y[W͈͂̍ől
} AJCPRN_OPT, *PAJCPRN_OPT;
typedef const AJCPRN_OPT *PCAJCPRN_OPT;


//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCPRN_MAX_PRNNAME	1024

typedef struct {
	BOOL			fUnicode;							//	ChtO
	BOOL			fPrintBusy;							//	tO
	BOOL			fpi;								//	v^ݒς݃tO
	AJCPRN_INFO		pi;									//	v^
	PRINTDLG		pdg;								//	_CAO\
	AJCDIBINFO		dib;								//	chaZNV
	BC				NameA[AJCPRN_MAX_PRNNAME];			//	v^ioCgj
	WC				NameW[AJCPRN_MAX_PRNNAME];			//	v^iChj
	UX				cbp;								//	R[obNp^
	BOOL (CALLBACK *cbQueryPage)(PCAJCPRN_INFO pPrnInfo, PAJCPRN_PGINFO pPageInfo, UX cbp);			//	y[WJnʒm
	BOOL (CALLBACK *cbDrawPrn  )(HDC hdc, PCAJCPRN_INFO pPrnInfo, UX cbp);							//	v^cbɂ`
	BOOL (CALLBACK *cbDrawDib  )(HDC hdc, PCAJCPRN_INFO pPrnInfo, PCAJCDIBINFO pDibInfo, UX cbp);	//	chaZNVɂ`
} AJCPRN, *HAJCPRN;

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCPRN			WINAPI	AjcPrnCreateA	(VO);
AJCEXPORT	HAJCPRN			WINAPI	AjcPrnCreateW	(VO);

AJCEXPORT	BOOL			WINAPI	AjcPrnSetMargin	(HAJCPRN hPrn, PAJCPRN_MARGIN pmmMargin);

AJCEXPORT	BOOL			WINAPI	AjcPrnSetCallbackParam(HAJCPRN hPrn, UX cbp);
AJCEXPORT	BOOL			WINAPI	AjcPrnSetCallbackQueryPage(HAJCPRN hPrn, BOOL (CALLBACK *cbQueryPage	  )(PCAJCPRN_INFO pPrnInfo, PAJCPRN_PGINFO pPgInfo, UX cbp));
AJCEXPORT	BOOL			WINAPI	AjcPrnSetCallbackByDibSect(HAJCPRN hPrn, BOOL (CALLBACK *cbDrawByDibSectDC)(HDC hdc, PCAJCPRN_INFO pPrnInfo, PCAJCDIBINFO pDibInfo, UX cbp));
AJCEXPORT	BOOL			WINAPI	AjcPrnSetCallbackByPrinter(HAJCPRN hPrn, BOOL (CALLBACK *cbDrawByPrinterDC)(HDC hdc, PCAJCPRN_INFO pPrnInfo, UX cbp));

AJCEXPORT	VO				WINAPI	AjcPrnDelete	(HAJCPRN hPrn);
AJCEXPORT	BOOL			WINAPI	AjcPrnSelectDlg	(HAJCPRN hPrn, PAJCPRN_INFO pInfo, UI		   Flag, HWND hWndOwner);
AJCEXPORT	BOOL			WINAPI	AjcPrnPrintDlg	(HAJCPRN hPrn, PAJCPRN_INFO pInfo, PAJCPRN_OPT pOpt, HWND hWndOwner);
AJCEXPORT	int				WINAPI	AjcPrnStart		(HAJCPRN hPrn, BOOL fOutputToFile);

AJCEXPORT	C_BCP			WINAPI	AjcPrnGetInfoA	(HAJCPRN hPrn, PAJCPRN_INFO pBuf);
AJCEXPORT	C_WCP			WINAPI	AjcPrnGetInfoW	(HAJCPRN hPrn, PAJCPRN_INFO pBuf);


/****************************************************************************************************************/
#endif
