#ifndef	AJCSERIALCOMPORT_H_
#define	AJCSERIALCOMPORT_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcScpCreate				AjcScpCreateW
	#define	AjcScpCreatePf				AjcScpCreatePfW
	#define	AjcScpCreateSlot			AjcScpCreateSlotW
	#define	AjcScpCreateEx				AjcScpCreateExW
	#define	AjcScpCreateSlotEx			AjcScpCreateSlotExW
	#define	AjcScpOpenSlot				AjcScpOpenSlotW
	#define	AjcScpOpenSock				AjcScpOpenSockW
	#define	AjcScpSendChar				AjcScpSendCharW
	#define	AjcScpSendText				AjcScpSendTextW
	#define	AjcScpSendTextF				AjcScpSendTextFW
	#define	AjcScpGetPortPathName		AjcScpGetPortPathNameW
	#define	AjcScpGetPortName			AjcScpGetPortNameW
	#define	AjcScpGetPortDevName		AjcScpGetPortDevNameW
	#define	AjcScpGetMySlotPathName		AjcScpGetMySlotPathNameW
	#define	AjcScpGetMyComputerName		AjcScpGetMyComputerNameW
	#define	AjcScpSetMailSlotNames		AjcScpSetMailSlotNamesW
	#define	AjcScpGetMailSlotNames		AjcScpGetMailSlotNamesW
	#define	AjcScpLoadParamFromProfile	AjcScpLoadParamFromProfileW
	#define	AjcScpSaveParamToProfile	AjcScpSaveParamToProfileW
#else
	#define	AjcScpCreate				AjcScpCreateA
	#define	AjcScpCreatePf				AjcScpCreatePfA
	#define	AjcScpCreateSlot			AjcScpCreateSlotA
	#define	AjcScpCreateEx				AjcScpCreateExA
	#define	AjcScpCreateSlotEx			AjcScpCreateSlotExA
	#define	AjcScpOpenSlot				AjcScpOpenSlotA
	#define	AjcScpOpenSock				AjcScpOpenSockA
	#define	AjcScpSendChar				AjcScpSendCharA
	#define	AjcScpSendText				AjcScpSendTextA
	#define	AjcScpSendTextF				AjcScpSendTextFA
	#define	AjcScpGetPortPathName		AjcScpGetPortPathNameA
	#define	AjcScpGetPortName			AjcScpGetPortNameA
	#define	AjcScpGetPortDevName		AjcScpGetPortDevNameA
	#define	AjcScpGetMySlotPathName		AjcScpGetMySlotPathNameA
	#define	AjcScpGetMyComputerName		AjcScpGetMyComputerNameA
	#define	AjcScpSetMailSlotNames		AjcScpSetMailSlotNamesA
	#define	AjcScpGetMailSlotNames		AjcScpGetMailSlotNamesA
	#define	AjcScpLoadParamFromProfile	AjcScpLoadParamFromProfileA
	#define	AjcScpSaveParamToProfile	AjcScpSaveParamToProfileA
#endif


//--------------------------------------------------------------------------------------------------------------//
//	Mf[^TCY																							//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCSCPMAX_TXSIZE_COMPORT	2048
#define		AJCSCPMAX_RXSIZE			2048

#define		AJCSCPMAX_TXSIZE_MAILSLOT	420
#define		AJCSCPMAX_TXSIZE_SOCKET		1024

//--------------------------------------------------------------------------------------------------------------//
//	|[gI																								//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCSCP_SEL_COMPORT	= 0,
	AJCSCP_SEL_MAILSLOT	= 1,
	AJCSCP_SEL_SOCKET	= 2,
} AJCSCP_PORTSEL, *PAJCSCP_PORTSEL;

//--------------------------------------------------------------------------------------------------------------//
//	CxgR[h																								//
//--------------------------------------------------------------------------------------------------------------//
						//	HIWORD(wParam)		e
#define	AJCSCP_EV_PORTSTATE	0x8000			//	|[gԒʒm
#define	AJCSCP_EV_RXCHUNK	0x4000			//	`Nf[^Mʒm
#define	AJCSCP_EV_RXTEXT	0x2000			//	eLXgMʒm
#define	AJCSCP_EV_RXESC		0x1000			//	drbR[hMʒm
#define	AJCSCP_EV_RXCTRL	0x0800			//	R[hMʒm
#define	AJCSCP_EV_RXPKT		0x0400			//	pPbgf[^Mʒm
#define	AJCSCP_EV_TXEMPTY	0x0200			//	M
#define	AJCSCP_EV_RXNOPKT	0x0100			//	pPbgOf[^

#define	AJCSCP_EV_ERR		0x0080			//	G[ʒm
#define	AJCSCP_EV_RING		0x0020			//	RINGωʒm
#define	AJCSCP_EV_RLSD		0x0010			//	RLSDωʒm
#define	AJCSCP_EV_DSR		0x0008			//	DSRωʒm
#define	AJCSCP_EV_CTS		0x0004			//	CTSωʒm

#define	AJCSCP_EV_RXWORD14	0x0002			//	oCgyAɂ郏[hi14Bitjf[^M

#define	AJCSCP_EV_INVCHUNK	0x0001			//	s`NeLXgMʒm


//#define	AJCSCP_EV_RXFLAG	0x0002			//	tOoCgMʒm
//#define	AJCSCP_EV_RXCHAR	0x0001			//	PoCgMʒm

#define	AJCSCP_EV_SSEP				(AJCSCP_EV_RXTEXT | AJCSCP_EV_RXESC | AJCSCP_EV_RXCTRL | AJCSCP_EV_RXPKT)
#define	AJCSCP_EV_DEFAULT_EVT		(AJCSCP_EV_SSEP | AJCSCP_EV_DSR | AJCSCP_EV_CTS)
#define	AJCSCP_EV_DEFAULT_POST		(AJCSCP_EV_PORTSTATE | AJCSCP_EV_DEFAULT_EVT)


//--------------------------------------------------------------------------------------------------------------//
//	|[g(AJCSCP_EV_PORTSTATẼp^)																	//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCSCP_CLOSED		0				//	N[Y
#define		AJCSCP_OPENED		1				//	I[v
#define		AJCSCP_OPENFAIL		2				//	I[vs
#define		AJCSCP_PORTCHG		3				//	ʐM\[Xω
#define		AJCSCP_MYSLOTFAIL	4				//	[Xbgs
#define		AJCSCP_TXFAILURE	5				//	Ms

#define		AJCSCP_PORTNO		AJCSCP_PORTCHG	//	|[gԍω

//--------------------------------------------------------------------------------------------------------------//
//	M																									//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCSCP_FIRST	0x8000			//	tO
#define		AJCSCP_CTS		MS_CTS_ON		//	bsrM
#define		AJCSCP_DSR		MS_DSR_ON		//	crqM
#define		AJCSCP_RING		MS_RING_ON		//	qhmfM
#define		AJCSCP_RLSD		MS_RLSD_ON		//	qkrcM

//--------------------------------------------------------------------------------------------------------------//
//	ʐMG[R[h																							//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCSCP_CE_RXOVER	CE_RXOVER	//	0x0001
#define		AJCSCP_CE_OVERRUN	CE_OVERRUN	//	0x0002
#define		AJCSCP_CE_RXPARITY	CE_RXPARITY	//	0x0004
#define		AJCSCP_CE_FRAME		CE_FRAME	//	0x0008
#define		AJCSCP_CE_BREAK		CE_BREAK	//	0x0010
#define		AJCSCP_CE_TXFULL	CE_TXFULL	//	0x0100
#define		AJCSCP_CE_PTO		CE_PTO		//	0x0200
#define		AJCSCP_CE_IOE		CE_IOE		//	0x0400
#define		AJCSCP_CE_DNS		CE_DNS		//	0x0800
#define		AJCSCP_CE_OOP		CE_OOP		//	0x1000
#define		AJCSCP_CE_MODE		CE_MODE		//	0x8000

#define		AJCSCP_CE_RXERR		0x10000		//	MG[i[Xbg^\Pbgj
#define		AJCSCP_CE_TXERR		0x20000		//	MG[i[Xbg^\Pbgj

//--------------------------------------------------------------------------------------------------------------//
//	TCP/IP AhXXg[W																				//
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	struct sockaddr_in		sain;
	struct sockaddr_in6		sain6;
	struct sockaddr_storage storage;
} AJCSCPSAIN, *PAJCSCPSAIN;
typedef const AJCSCPSAIN *PCAJCSCPSAIN;

//--------------------------------------------------------------------------------------------------------------//
//	Cxgnh																							//
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	struct {HANDLE Comm, Recv, TxEnd, Cmd, Exit, TmSlt;} s;
	HANDLE	arr[5];
} AJCSCP_HEVENT;

//--------------------------------------------------------------------------------------------------------------//
//	`NEf[^Eʒm[h																				//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCSCP_CM_BIN	=	0x01	,			//	Bit0 : oCi`N
	AJCSCP_CM_TEXT	=	0x02	,			//	Bit1 : eLXg`N
	AJCSCP_CM_BOTH	=	0x03	,			//	
} AJCSCP_CHUNKMODE;

//--------------------------------------------------------------------------------------------------------------//
//	eLXgER[h																							//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCSCP_TXT_SJIS	=	AJCMBC_SJIS	,		//	Vtgihr(=1)
	AJCSCP_TXT_EUC	=	AJCMBC_EUC	,		//	dtb@@@(=2)
	AJCSCP_TXT_UTF8	=	AJCMBC_UTF8	,		//	tse|W@)=3)
	AJCSCP_TXT_AUTO	=	9	,				//	ʁ@@
} AJCSCP_TEXTCODE;

//--------------------------------------------------------------------------------------------------------------//
//	zXgCXbgC|[g̍ő咷																		//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCMAX_HOSTNAME_LENGTH		64
#define	AJCMAX_SLOTNAME_LENGTH		64
#define	AJCMAX_PORTNAME_LENGTH		64


//--------------------------------------------------------------------------------------------------------------//
//	Xbg																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	WC		MyHostName [AJCMAX_HOSTNAME_LENGTH];		//	Rs[^
	WC		MySlotName [AJCMAX_SLOTNAME_LENGTH];		//	[Xbg
	WC		RmtHostName[AJCMAX_HOSTNAME_LENGTH];		//	Rs[^
	WC		RmtSlotName[AJCMAX_SLOTNAME_LENGTH];		//	胁[Xbg
	BOOL	fTxDelay;									//	MxtO
	UI		TxDelayBPS;									//	Mx[Bytes / sec]
} AJCSCP_SLOTINFO, *PAJCSCP_SLOTINFO;

//--------------------------------------------------------------------------------------------------------------//
//	\Pbg																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	WC		ServName[AJCMAX_HOSTNAME_LENGTH];			//	T[oiRs[^j^IPAhX
	UW		PortNo;										//	|[gԍ
	UW		Filler;
} AJCSCP_SOCKINFO, *PAJCSCP_SOCKINFO;

//----- [hjI -------------------------------------------------------------------------------------//
typedef	union	{
	struct	{UB  l, h;}	s;
	UW					w;
} AJCSCPUNIWORD, *PAJCSCPUNIWORD;

//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
typedef  struct {
	//----- CX^Xhc ---------------------------------------------------//
	UI					InstID;
	//----- vt@CZNV ---------------------------------------------//
	WC					ProfileSect[64];
	//----- bnl^XbgI -------------------------------------------//
	AJCSCP_PORTSEL		PortSel;
	//----- bnl|[g ---------------------------------------------------//
	UI					PortNo;				//	bnl|[gԍiP`QTTj
	DCB					CommDcb;			//	cba
	COMMTIMEOUTS		CommTmo;			//	^CAEg

	HANDLE				hPort;				//	bnl|[g^[Xbgnh^\Pbgnh
	BOOL				fTxBusy;			//	MtO
	UI					GpiState;			//	͐M(CTS, DSR, RING, RLSD)

	//----- [Xbg -------------------------------------------------//
	HANDLE				hSlot;				//	Xbgnh
	AJCSCP_SLOTINFO		SlotInfo;			//	[Xbg
	WC					MySlotPath[MAX_PATH];

	UI						MaxMsgSize;		//	P̃bZ[W̍őTCYiOFCӁj
	UI						ReadTimeout;	//	ǂݎ^CAEg[ms]
	SECURITY_DESCRIPTOR		secDesc;		//	ZLeBLqq
	LPSECURITY_ATTRIBUTES	pSecAttr;		//	ZLeC(secAttr)ւ̃|C^(gpNULL)

	BOOL				fTxSlotOpened;		//	MXbgI[vς݃tO
											//	[Xbg̏ꍇAMXbg𖢎wŃI[vꍇ
											//	ۂɂ͑M|[gI[vȂihPort=NULLłjA
											//	I[vs|ÃtOZbgB

	//----- \Pbg -------------------------------------------------------//
	BOOL				fConnect;			//	ڑ
	BOOL				fSockRead;			//	\PbgM\tO
	BOOL				fSockWrite;			//	\PbgM\tO
	HANDLE				hEvtSock;			//	\PbgCxg
	AJCSCP_SOCKINFO		SockInfo;			//	T[oC|[gԍ

	//----- eLXg -------------------------------------------------------//
	BOOL				fUnicode;			//	UNICODEtO
	AJCSCP_CHUNKMODE	ChunkMode;			//	`Nf[^ʒm[h
	AJCSCP_TEXTCODE		RxTxtCode;			//	MeLXgR[h
	AJCSCP_TEXTCODE		TxTxtCode;			//	MeLXgR[h
	BC					SvSndA, dmy1;		//	eLXgM̑SpPoCgڑޔobt@
	WC					SvSndW;				//	eLXgM̃TQ[gPڑޔobt@

	//----- Xg[CX^Xnh ---------------------------------//
	HAJCSSEP			hSsep;

	//----- Cxg}XN -----------------------------------------------------//
	UI					EvtMask;

	//----- XbhnhCXbhhc -------------------------------------//
	HANDLE				hThreadRx;
	HANDLE				hThreadTx;
	HANDLE				hThreadObs;

	UL					idThreadRx;
	UL					idThreadTx;
	UL					idThreadObs;

	//----- XbhԒʐMp[{bNX -------------------------------------//
	HAJCVMBX			hVMbxTxD;			//	Mf[^E[{bNXnh
	HAJCFMBX			hFMbxNtc;			//	[U`oւ̃Cxgʒmp[{bNXnh

	//----- [U`oւ̃Cxgʒm -------------------------------------//
	HWND				hWndNtc;			//	[U`oւ̃CxgʒmpEChnh
	UI					MsgNtc;				//	[U`oւ̃CxgʒmpEChbZ[W

	//----- bnl|[gANZXrpNeBJZNV ---------------//
	CRITICAL_SECTION	CsCommApi;			//	VXe`ohr
	CRITICAL_SECTION 	CsTxDelay;			//	MxiTxDelayBytesCountCTxDelayTickCountjr

	//----- Xbh ---------------------------------------------------//
	BOOL				fThreadEnd;			//	XbhIwtO
	BOOL				fThrSendEnd;		//	MXbhItO
	BOOL				fThrRecvEnd;		//	MXbhItO
	BOOL				fThrSObsEnd;		//	MĎXbhItO

	//----- |[gݒ_CAO ------------------------------------------//
	UI					mskRbt;				//	bnl|[g^[XbgIWI{^̃}XN(0:C1:֎~j
	UI					mskGray;			//	_CAOڂ̃}XN

	//----- |[g̍쐬[N ----------------------------------------------//
	union {
		BC		BStr[AJCMAX_HOSTNAME_LENGTH + 128];
		WC		WStr[AJCMAX_HOSTNAME_LENGTH + 128];
	} PortName;

	//----- Mobt@ ------------------------------------------------------//
	UI				ixRxb;							//	Mobt@󕔕̃CfNXiO̔[}`oCgj
	UB				RxBuf[AJCSCPMAX_RXSIZE + 8];	//	MeLXgf[^obt@if[^{r}`oCg(1`5)j{I[(0x00)j
	UB				RxBin[AJCSCPMAX_RXSIZE];		//	MoCif[^obt@

	//----- pPbgOeLXgMobt@ ------------------------------------//
	UI				ixNpk;							//	pPbgOobt@󕔕̃CfNXiO̔[}`oCgj
	BC				NpBuf[AJCSCPMAX_RXSIZE + 8];	//	pPbgOobt@if[^{r}`oCg(1`5)j{I[(0x00)j

	//----- M~F ------------------------------------------------//
	ULL		MesTxTime;								//	M~F[ms]
	ULL		MesRxTime;								//	M~F[ms]

	//----- Mxi[Xbg̑Mxj --------------------//
	BOOL	fTxDelay;								//	MxtO
	UI		TxDelayBPS;								//	Mx[Bytes / sec]
	ULL		TxDelayBytesCount;						//	MxpoCgJE^
	ULL		TxDelayTickCount;						//	MxpEoߎ[us]

	HAJCMESTIME	hMesTxDelay;						//	ԌvIuWFNgnh

	//----- oCgyAM --------------------------------------------//
	BOOL	fBpLBFirst;								//	0: High Byte First1 : Low Byte First
	BOOL	BpSeq;									//	MoCgJE^iO`Pj
	AJCSCPUNIWORD	BpDat;							//	Mf[^(14Bit)obt@

	//----- MSILT|[gp ----------------------------------------------------//
	HWND	hWndForMsil;							//	MSILp_~[EChnh

} AJCSCP, *HAJCSCP;


//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreateA(VO);
AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreateW(VO);

AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreatePfA(C_BCP pSect);
AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreatePfW(C_WCP pSect);

AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreateSlotA(C_BCP pSect, BOOL fCreateMySlot, C_BCP pMySlot, C_BCP pRmtHost, C_BCP pRmtSlot);
AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreateSlotW(C_WCP pSect, BOOL fCreateMySlot, C_WCP pMySlot, C_WCP pRmtHost, C_WCP pRmtSlot);

AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreateExA  (C_BCP pSect, BOOL fCreateMySlot, C_BCP pMySlot, C_BCP pRmtHost, C_BCP pRmtSlot);	//	񐄏iAjcScpCreateSlotAƓj
AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreateExW  (C_WCP pSect, BOOL fCreateMySlot, C_WCP pMySlot, C_WCP pRmtHost, C_WCP pRmtSlot);	//	񐄏iAjcScpCreateSlotWƓj

AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreateSlotExA(C_BCP pSect, BOOL fCreateMySlot, C_BCP pMySlot, C_BCP pRmtHost, C_BCP pRmtSlot, UI nMaxMessageSize, UI lReadTimeout, LPSECURITY_ATTRIBUTES lpSecurityAttributes);
AJCEXPORT	HAJCSCP			 WINAPI	AjcScpCreateSlotExW(C_WCP pSect, BOOL fCreateMySlot, C_WCP pMySlot, C_WCP pRmtHost, C_WCP pRmtSlot, UI nMaxMessageSize, UI lReadTimeout, LPSECURITY_ATTRIBUTES lpSecurityAttributes);

AJCEXPORT	BOOL			 WINAPI		AjcScpDelete				(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetMode				(HAJCSCP hScp, HWND hWndNtc, UI WndMsgNtc, AJCSCP_CHUNKMODE ChunkMode);
AJCEXPORT	BOOL			 WINAPI		AjcScpOpen					(HAJCSCP hScp, UI Port, UI Rate, UI DataBits, UI Parity, UI StopBit);
AJCEXPORT	BOOL			 WINAPI		AjcScpOpenEx				(HAJCSCP hScp, UI Port, LPDCB pDcb, LPCOMMTIMEOUTS pTmo);

AJCEXPORT	BOOL			 WINAPI		AjcScpOpenSlotA				(HAJCSCP hScp, C_BCP pRmtHost, C_BCP pRmtSlot);
AJCEXPORT	BOOL			 WINAPI		AjcScpOpenSlotW				(HAJCSCP hScp, C_WCP pRmtHost, C_WCP pRmtSlot);

AJCEXPORT	BOOL			 WINAPI		AjcScpOpenSockA				(HAJCSCP hScp, C_BCP pServ, UI PortNo);
AJCEXPORT	BOOL			 WINAPI		AjcScpOpenSockW				(HAJCSCP hScp, C_WCP pServ, UI PortNo);

AJCEXPORT	BOOL			 WINAPI		AjcScpOpenDefault			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpOpenSelect			(HAJCSCP hScp, AJCSCP_PORTSEL sel);
AJCEXPORT	BOOL			 WINAPI		AjcScpClose					(HAJCSCP hScp);
AJCEXPORT	UI				 WINAPI		AjcScpGetSelectedPort		(HAJCSCP hScp);
AJCEXPORT	UI				 WINAPI		AjcScpIsOpened				(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpIsTxOpened			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpIsRxOpened			(HAJCSCP hScp);

AJCEXPORT	BOOL			 WINAPI		AjcScpSendCharA				(HAJCSCP hScp, BC code);
AJCEXPORT	BOOL			 WINAPI		AjcScpSendCharW				(HAJCSCP hScp, WC code);

AJCEXPORT	BOOL			 WINAPI		AjcScpSendWord14LF			(HAJCSCP hScp, UI data);
AJCEXPORT	BOOL			 WINAPI		AjcScpSendWord14HF			(HAJCSCP hScp, UI data);

AJCEXPORT	BOOL			 WINAPI		AjcScpSetByteSeqRxWord14	(HAJCSCP hScp, BOOL fLowByteFirst);
AJCEXPORT	BOOL			 WINAPI		AjcScpGetByteSeqRxWord14	(HAJCSCP hScp);

AJCEXPORT	BOOL			 WINAPI		AjcScpSendTextA				(HAJCSCP hScp, C_BCP pTxt, UI lTxt);
AJCEXPORT	BOOL			 WINAPI		AjcScpSendTextW				(HAJCSCP hScp, C_WCP pTxt, UI lTxt);

AJCEXPORT	BOOL			 WINAPI		AjcScpSendTextFA			(HAJCSCP hScp, C_BCP pFmt, ...);
AJCEXPORT	BOOL			 WINAPI		AjcScpSendTextFW			(HAJCSCP hScp, C_WCP pFmt, ...);

AJCEXPORT	BOOL			 WINAPI		AjcScpSendBinData			(HAJCSCP hScp, C_VOP pDat, UI lDat);
AJCEXPORT	UI				 WINAPI		AjcScpSendPacket			(HAJCSCP hScp, C_VOP pPkt, UI lPkt);
AJCEXPORT	BOOL			 WINAPI		AjcScpSendBreak				(HAJCSCP hScp, BOOL fBreak);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetEvtMask			(HAJCSCP hScp, UI Mask);
AJCEXPORT	UI				 WINAPI		AjcScpGetEvtMask			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetDTR				(HAJCSCP hScp, BOOL fActive);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetRTS				(HAJCSCP hScp, BOOL fActive);
AJCEXPORT	UI				 WINAPI		AjcScpGetSigState			(HAJCSCP hScp);
AJCEXPORT	ULL				 WINAPI		AjcScpGetTxBytes			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpPurgeRecvData			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpPurgeSendData			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpPurgeAllData			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetParam				(HAJCSCP hScp, const DCB *pDcb, const COMMTIMEOUTS *pTmo);
AJCEXPORT	UI				 WINAPI		AjcScpGetParam				(HAJCSCP hScp, LPDCB pDcb, LPCOMMTIMEOUTS pTmo);
AJCEXPORT	BOOL			 WINAPI		AjcScpWaitEvent				(HAJCSCP hScp, WPARAM *pwParam, LPARAM *plParam, UI msTime);
AJCEXPORT	BOOL			 WINAPI		AjcScpGetEventData			(HAJCSCP hScp, LPARAM lParam, VOP *ppDat, UIP plDat, UIP pParam);
AJCEXPORT	BOOL			 WINAPI		AjcScpRelEventData			(HAJCSCP hScp, LPARAM lParam);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetPktCtrlCode		(HAJCSCP hScp, UI stx, UI etx, UI dle);
AJCEXPORT	BOOL			 WINAPI		AjcScpGetPktCtrlCode		(HAJCSCP hScp, UIP pStx, UIP pEtx, UIP pDle);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetPktTimeout			(HAJCSCP hScp, UI msTime);
AJCEXPORT	BOOL			 WINAPI		AjcScpGetPktTimeout			(HAJCSCP hScp, UIP pMsTime);
AJCEXPORT	BOOL			 WINAPI		AjcScpEnableComPortSelection(HAJCSCP hScp, BOOL fEnableComPort);
AJCEXPORT	BOOL			 WINAPI		AjcScpEnableMailslotSelection(HAJCSCP hScp, BOOL fEnableMailSlot);
AJCEXPORT	BOOL			 WINAPI		AjcScpEnableSocketSelection	(HAJCSCP hScp, BOOL fEnableSocket);
AJCEXPORT	BOOL			 WINAPI		AjcScpEnablePortSelection	(HAJCSCP hScp, BOOL fEnableComPort, BOOL fEnableMailSlot);
AJCEXPORT	BOOL			 WINAPI		AjcScpEnablePortSelectionEx	(HAJCSCP hScp, BOOL fEnableComPort, BOOL fEnableMailSlot, BOOL fEnableSocket);
AJCEXPORT	UI				 WINAPI		AjcScpDlgParamEasy			(HAJCSCP hScp, HWND hWndOwner);
AJCEXPORT	UI				 WINAPI		AjcScpDlgParamEasyEx		(HAJCSCP hScp, HWND hWndOwner, int x, int y);
AJCEXPORT	UI				 WINAPI		AjcScpDlgParamDetail		(HAJCSCP hScp, HWND hWndOwner);
AJCEXPORT	UI				 WINAPI		AjcScpDlgParamDetailEx		(HAJCSCP hScp, HWND hWndOwner, int x, int y);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetDialogGrayMask		(HAJCSCP hScp, UI mskGray);
AJCEXPORT	VO				 WINAPI		AjcScpGetDefaultParam		(LPDCB pDcb, LPCOMMTIMEOUTS pTmo);
AJCEXPORT	HAJCSSEP		 WINAPI		AjcScpGetSsepHandle			(HAJCSCP hScp);
AJCEXPORT	UI				 WINAPI		AjcScpEnumSerialPorts		(UBP pMap, UI lMap, UI CurrentPort);

AJCEXPORT	BCP				 WINAPI		AjcScpGetPortPathNameA		(HAJCSCP hScp);
AJCEXPORT	WCP				 WINAPI		AjcScpGetPortPathNameW		(HAJCSCP hScp);

AJCEXPORT	BCP				 WINAPI		AjcScpGetPortNameA			(HAJCSCP hScp);
AJCEXPORT	WCP				 WINAPI		AjcScpGetPortNameW			(HAJCSCP hScp);

AJCEXPORT	int				 WINAPI		AjcScpGetPortDevNameA		(C_BCP pPortName, BCP pBuf, UI lBuf);
AJCEXPORT	int				 WINAPI		AjcScpGetPortDevNameW		(C_WCP pPortName, WCP pBuf, UI lBuf);


AJCEXPORT	BOOL			 WINAPI		AjcScpSetChunkMode			(HAJCSCP hScp, AJCSCP_CHUNKMODE ChunkMode);
AJCEXPORT	AJCSCP_CHUNKMODE WINAPI		AjcScpGetChunkMode			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetRxTextCode			(HAJCSCP hScp, AJCSCP_TEXTCODE code);
AJCEXPORT	AJCSCP_TEXTCODE	 WINAPI		AjcScpGetRxTextCode			(HAJCSCP hScp);
AJCEXPORT	AJCSCP_TEXTCODE	 WINAPI		AjcScpGetActualRxTextCode	(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetTxTextCode			(HAJCSCP hScp, AJCSCP_TEXTCODE code);
AJCEXPORT	AJCSCP_TEXTCODE	 WINAPI		AjcScpGetTxTextCode			(HAJCSCP hScp);
AJCEXPORT	AJCSCP_TEXTCODE	 WINAPI		AjcScpGetActualTxTextCode	(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpCreateMySlot			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpCreateMySlotEx		(HAJCSCP hScp, UI nMaxMessageSize, UI lReadTimeout, LPSECURITY_ATTRIBUTES lpSecurityAttributes);
AJCEXPORT	BOOL			 WINAPI		AjcScpDeleteMySlot			(HAJCSCP hScp);
AJCEXPORT	BOOL			 WINAPI		AjcScpMySlotIsCreated		(HAJCSCP hScp);

AJCEXPORT	BCP				 WINAPI		AjcScpGetMySlotPathNameA	(HAJCSCP hScp);
AJCEXPORT	WCP				 WINAPI		AjcScpGetMySlotPathNameW	(HAJCSCP hScp);

AJCEXPORT	BOOL			 WINAPI		AjcScpGetMyComputerNameA	(HAJCSCP hScp, BC pBuf[AJCMAX_HOSTNAME_LENGTH]);
AJCEXPORT	BOOL			 WINAPI		AjcScpGetMyComputerNameW	(HAJCSCP hScp, WC pBuf[AJCMAX_HOSTNAME_LENGTH]);

AJCEXPORT	BOOL			 WINAPI		AjcScpSetMailSlotNamesA		(HAJCSCP hScp, C_BCP pMySlot, C_BCP pRmyHost, C_BCP pRmtSlot);
AJCEXPORT	BOOL			 WINAPI		AjcScpSetMailSlotNamesW		(HAJCSCP hScp, C_WCP pMySlot, C_WCP pRmyHost, C_WCP pRmtSlot);

AJCEXPORT	BOOL			 WINAPI		AjcScpGetMailSlotNamesA		(HAJCSCP hScp, BC pMySlot[64], BC pRmyHost[AJCMAX_HOSTNAME_LENGTH], BC pRmtSlot[64]);
AJCEXPORT	BOOL			 WINAPI		AjcScpGetMailSlotNamesW		(HAJCSCP hScp, WC pMySlot[64], WC pRmyHost[AJCMAX_HOSTNAME_LENGTH], WC pRmtSlot[64]);

AJCEXPORT	BOOL			 WINAPI		AjcScpSetTxSpeedLimit		(HAJCSCP hScp, BOOL flag, UI bps);
AJCEXPORT	BOOL			 WINAPI		AjcScpGetTxSpeedLimit		(HAJCSCP hScp, UIP pBps);

AJCEXPORT	ULL				 WINAPI		AjcScpSetRecognizeTxStopTime(HAJCSCP hScp, UI msTime);
AJCEXPORT	ULL				 WINAPI		AjcScpSetRecognizeRxStopTime(HAJCSCP hScp, UI msTime);


//	J`oh
AJCEXPORT	BOOL			 WINAPI		AjcScpLoadParamFromProfileA	(HAJCSCP hScp, C_BCP pSect);
AJCEXPORT	BOOL			 WINAPI		AjcScpLoadParamFromProfileW	(HAJCSCP hScp, C_WCP pSect);

AJCEXPORT	BOOL			 WINAPI		AjcScpSaveParamToProfileA	(HAJCSCP hScp, C_BCP pSect);
AJCEXPORT	BOOL			 WINAPI		AjcScpSaveParamToProfileW	(HAJCSCP hScp, C_WCP pSect);

//==============================================================================================================//
//	_CAO{bNX̃O[ځiScpDlgSetParam... mskGray j										//
//==============================================================================================================//
//	mskRbt
#define		AJCSCPRBT_ComPort						0x00000040
#define		AJCSCPRBT_MailSlot						0x00000020
#define		AJCSCPRBT_Socket						0x00000010

//	mskGray
#define		AJCSCPGRY_Port							0x80000000
#define		AJCSCPGRY_BaudRate						0x40000000
#define		AJCSCPGRY_ByteSize						0x20000000
#define		AJCSCPGRY_StopBits						0x10000000

#define		AJCSCPGRY_fParity						0x08000000
#define		AJCSCPGRY_Parity						0x04000000
#define		AJCSCPGRY_Paritys						(AJCSCPGRY_fParity |		\
													 AJCSCPGRY_Parity)

#define		AJCSCPGRY_fOutX							0x02000000
#define		AJCSCPGRY_fOutxCtsFlow					0x01000000
#define		AJCSCPGRY_fOutxDsrFlow					0x00800000
#define		AJCSCPGRY_TxFlowControl					(AJCSCPGRY_fOutX		|	\
													 AJCSCPGRY_fOutxCtsFlow |	\
													 AJCSCPGRY_fOutxDsrFlow)

#define		AJCSCPGRY_fInX							0x00400000
#define		AJCSCPGRY_XoffLim						0x00200000
#define		AJCSCPGRY_XonLim						0x00100000
#define		AJCSCPGRY_fTXContinueOnXoff				0x00080000
#define		AJCSCPGRY_RxFlowControl					(AJCSCPGRY_fInX		|			\
													 AJCSCPGRY_XoffLim	|			\
													 AJCSCPGRY_XonLim	|			\
													 AJCSCPGRY_fTXContinueOnXoff)

#define		AJCSCPGRY_DtrControl					0x00040000
#define		AJCSCPGRY_RtsControl					0x00020000

#define		AJCSCPGRY_fBinary						0x00010000
#define		AJCSCPGRY_fDsrSensitivity				0x00008000
#define		AJCSCPGRY_fErrorChar					0x00004000
#define		AJCSCPGRY_fNull							0x00002000
#define		AJCSCPGRY_fAbortOnError					0x00001000
#define		AJCSCPGRY_Flags							(AJCSCPGRY_fBinary		   |	\
													 AJCSCPGRY_fDsrSensitivity |	\
													 AJCSCPGRY_fErrorChar	   |	\
													 AJCSCPGRY_fNull		   |	\
													 AJCSCPGRY_fAbortOnError)

#define		AJCSCPGRY_XonChar						0x00000800
#define		AJCSCPGRY_XoffChar						0x00000400
#define		AJCSCPGRY_ErrorChar						0x00000200
#define		AJCSCPGRY_EofChar						0x00000100
#define		AJCSCPGRY_EvtChar						0x00000080
#define		AJCSCPGRY_Characters					(AJCSCPGRY_XonChar	 |	\
													 AJCSCPGRY_XoffChar	 |	\
													 AJCSCPGRY_ErrorChar |	\
													 AJCSCPGRY_EofChar	 |	\
													 AJCSCPGRY_EvtChar)

#define		AJCSCPGRY_ReadIntervalTimeout			0x00000040
#define		AJCSCPGRY_ReadTotalTimeoutMultiplier	0x00000020
#define		AJCSCPGRY_ReadTotalTimeoutConstant		0x00000010
#define		AJCSCPGRY_WriteTotalTimeoutMultiplier	0x00000008
#define		AJCSCPGRY_WriteTotalTimeoutConstant		0x00000004
#define		AJCSCPGRY_Timeouts						(AJCSCPGRY_ReadIntervalTimeout		   |	\
													 AJCSCPGRY_ReadTotalTimeoutMultiplier  |	\
													 AJCSCPGRY_ReadTotalTimeoutConstant	   |	\
													 AJCSCPGRY_WriteTotalTimeoutMultiplier |	\
													 AJCSCPGRY_WriteTotalTimeoutConstant)

#define		AJCSCPGRY_SetDetail						0x00000002


//==============================================================================================================//
//	_CAO{bNXɂύXꂽ(ScpDlgSetParamEasy/Detail̖߂lj									//
//==============================================================================================================//
#define	AJCSCPDGR_PORTCHANGED	0x00000040		//	|[gύX
#define	AJCSCPDGR_DCBCHANGED	0x00000020		//	cbaύX
#define	AJCSCPDGR_TMOCHANGED	0x00000010		//	^C}ύX
#define	AJCSCPDGR_SELCHANGED	0x00000008		//	bnl|[g^[Xbg̑IύX
#define	AJCSCPDGR_SLOTCHANGED	0x00000004		//	[XbgύX
#define	AJCSCPDGR_SOCKCHANGED	0x00000002		//	\PbgύX
#define	AJCSCPDGR_OKBUTTON		0x00000001		//	nj{^ɂI
#define	AJCSCPDGR_CHANED	(AJCSCPDGR_PORTCHANGED | AJCSCPDGR_DCBCHANGED | AJCSCPDGR_TMOCHANGED | AJCSCPDGR_SELCHANGED | AJCSCPDGR_SLOTCHANGED)


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpT|[gR[h																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//----- Rg[ECh -------------------------------------------------------------------------------//
AJCEXPORT HAJCSCP WINAPI AjcScpCreateForMSIL(	VO (CALLBACK *cbPortState )(int state, C_WCP pPortName),
												VO (CALLBACK *cbRxChunkTxt)(C_WCP text),
												VO (CALLBACK *cbRxChunkBin)(C_VOP pData, int lData),
												VO (CALLBACK *cbRxText	  )(C_WCP text),
												VO (CALLBACK *cbRxEsc	  )(C_WCP esc),
												VO (CALLBACK *cbRxCtrl	  )(int   ctrl),
												VO (CALLBACK *cbRxPacket  )(C_VOP pData, int lData),
												VO (CALLBACK *cbTxEmpty   )(VO),
												VO (CALLBACK *cbRxNoPkt   )(C_WCP text),
												VO (CALLBACK *cbRxWord14  )(int   data),
												VO (CALLBACK *cbRxInvChunk)(C_VOP pData, int lData),
												VO (CALLBACK *cbError	  )(int err),
												VO (CALLBACK *cbNtcRING   )(BOOL cts, BOOL dsr, BOOL rlsd, BOOL ring),
												VO (CALLBACK *cbNtcRLSD   )(BOOL cts, BOOL dsr, BOOL rlsd, BOOL ring),
												VO (CALLBACK *cbNtcDSR	  )(BOOL cts, BOOL dsr, BOOL rlsd, BOOL ring),
												VO (CALLBACK *cbNtcCTS	  )(BOOL cts, BOOL dsr, BOOL rlsd, BOOL ring));
//----- XbgiG[mňÖٓIɐj------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpCreateMySlotForMSIL(HAJCSCP hScp);
//----- [hݒ ---------------------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpSetModeForMSIL(HAJCSCP hScp, BOOL fEventMode);
//----- |[g擾 -------------------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpGetPortNameForMSIL(HAJCSCP hScp, WCP pBuf, int lBuf);
//----- |[gpX擾 ---------------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpGetPortPathNameForMSIL(HAJCSCP hScp, WCP pBuf, int lBuf);
//----- XbgpX擾 -----------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpGetMySlotPathNameForMSIL(HAJCSCP hScp, WCP pBuf, int lBuf);
//----- I -----------------------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpDeleteForMSIL(HAJCSCP hScp);
//----- vt@CZNVݒ^擾 ---------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpSetProfileSectForMSIL(HAJCSCP hScp, C_WCP pProfileSect);
AJCEXPORT VO WINAPI AjcScpGetProfileSectForMSIL(HAJCSCP hScp,	WCP pProfileSect, int lProfileSect);
//----- Xbgݒ^擾 ---------------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpSetMySlotForMSIL(HAJCSCP hScp, C_WCP pMySlot);
AJCEXPORT VO WINAPI AjcScpGetMySlotForMSIL(HAJCSCP hScp,   WCP pMySlot, int lMySlot);
//----- [gzXgݒ^擾 -----------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpSetRmtHostForMSIL(HAJCSCP hScp, C_WCP pRmtHost);
AJCEXPORT VO WINAPI AjcScpGetRmtHostForMSIL(HAJCSCP hScp,	WCP pRmtHost, int lRmtHost);
//----- [gXbgݒ^擾 ---------------------------------------------------------------------------//
AJCEXPORT VO WINAPI AjcScpSetRmtSlotForMSIL(HAJCSCP hScp, C_WCP pRmtSlot);
AJCEXPORT VO WINAPI AjcScpGetRmtSlotForMSIL(HAJCSCP hScp,	WCP pRmtSlot, int lRmtSlot);


/****************************************************************************************************************/
#endif
