#ifndef	AJCSTRPOOL_H_
#define	AJCSTRPOOL_H_
/****************************************************************************************************************/

/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcSplCreate		AjcSplCreateW
	#define	AjcSplSetCompMode	AjcSplSetCompModeW
	#define	AjcSplRegist		AjcSplRegistW
	#define	AjcSplFind			AjcSplFindW
	#define	AjcSplRemove		AjcSplRemoveW
	#define	AjcSplEnumStr		AjcSplEnumStrW
	#define	AjcSplPartStrInPool	AjcSplPartStrInPoolW
	#define	AjcSplPoolStrInStr	AjcSplPoolStrInStrW
#else
	#define	AjcSplCreate		AjcSplCreateA
	#define	AjcSplSetCompMode	AjcSplSetCompModeA
	#define	AjcSplRegist		AjcSplRegistA
	#define	AjcSplFind			AjcSplFindA
	#define	AjcSplRemove		AjcSplRemoveA
	#define	AjcSplEnumStr		AjcSplEnumStrA
	#define	AjcSplPartStrInPool	AjcSplPartStrInPoolA
	#define	AjcSplPoolStrInStr	AjcSplPoolStrInStrA
#endif
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	rp^																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
#define	AJCSPL_CMP_DISTINGUISH		AJCCMP_RECOGNIZE_WIDTH		//	p召ʂ
#define	AJCSPL_CMP_NODISTINGUISH	AJCCMP_IGNORE_WIDTH			//	p召ʂȂ
#define	AJCSPL_CMP_MIX				AJCCMP_ALPHABETIC			//	̏ꍇ̂݉p召ʂ

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	񌟍p^																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCSPL_ISP_MATCHFIRST = 1	,		//	擪ƈv
	AJCSPL_ISP_INCLUDING		,		//	܂
} AJCSPL_INSTROPT;

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	CX^X[N																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	UI				InstID;				//	CX^Xʂhc
	EAJCCMPMODE		CmpMode;			//	̔r@
	BOOL			fDistinguish;		//	p啶C̋ʁiTRUE:ʂCFALSEFʂȂj
	HAJCAVL			hAvlStr;			//	v[pQ
} AJCSPL, *HAJCSPL;

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCSPL			WINAPI	AjcSplCreateA(EAJCCMPMODE CmpMode);
AJCEXPORT	HAJCSPL			WINAPI	AjcSplCreateW(EAJCCMPMODE CmpMode);

AJCEXPORT	BOOL			WINAPI	AjcSplDelete (HAJCSPL hSpl);

AJCEXPORT	BOOL			WINAPI	AjcSplSetCompModeA(HAJCSPL hSpl, EAJCCMPMODE CmpMode);
AJCEXPORT	BOOL			WINAPI	AjcSplSetCompModeW(HAJCSPL hSpl, EAJCCMPMODE CmpMode);

AJCEXPORT	EAJCCMPMODE		WINAPI	AjcSplGetCompMode(HAJCSPL hSpl);

AJCEXPORT	C_BCP			WINAPI	AjcSplRegistA(HAJCSPL hSpl, C_BCP pStr);
AJCEXPORT	C_WCP			WINAPI	AjcSplRegistW(HAJCSPL hSpl, C_WCP pStr);

AJCEXPORT	C_BCP			WINAPI	AjcSplFindA  (HAJCSPL hSpl, C_BCP pStr);
AJCEXPORT	C_WCP			WINAPI	AjcSplFindW  (HAJCSPL hSpl, C_WCP pStr);

AJCEXPORT	C_BCP			WINAPI	AjcSplPartStrInPoolA(HAJCSPL hSpl, C_BCP pPartStr, AJCSPL_INSTROPT opt);
AJCEXPORT	C_WCP			WINAPI	AjcSplPartStrInPoolW(HAJCSPL hSpl, C_WCP pPartStr, AJCSPL_INSTROPT opt);

AJCEXPORT	C_BCP			WINAPI	AjcSplPoolStrInStrA(HAJCSPL hSpl, C_BCP pStr, AJCSPL_INSTROPT opt);
AJCEXPORT	C_WCP			WINAPI	AjcSplPoolStrInStrW(HAJCSPL hSpl, C_WCP pStr, AJCSPL_INSTROPT opt);

AJCEXPORT	BOOL			WINAPI	AjcSplRemoveA(HAJCSPL hSpl, C_BCP pStr);
AJCEXPORT	BOOL			WINAPI	AjcSplRemoveW(HAJCSPL hSpl, C_WCP pStr);

AJCEXPORT	UI				WINAPI	AjcSplGetCount(HAJCSPL hSpl);
AJCEXPORT	UI				WINAPI	AjcSplNumber  (HAJCSPL hSpl);

AJCEXPORT	BOOL			WINAPI	AjcSplReset  (HAJCSPL hSpl);

AJCEXPORT	UI				WINAPI	AjcSplEnumStrA(HAJCSPL hSpl, UX cbp, BOOL (CALLBACK *cbNtcStr)(C_BCP pStr, UX cbp), BOOL fDownSeq);
AJCEXPORT	UI				WINAPI	AjcSplEnumStrW(HAJCSPL hSpl, UX cbp, BOOL (CALLBACK *cbNtcStr)(C_WCP pStr, UX cbp), BOOL fDownSeq);

AJCEXPORT	HAJCAVL			WINAPI	AjcSplGetAvlHandle(HAJCSPL hSpl);

/****************************************************************************************************************/
#endif
