#ifndef	AJCTEXTOUT_H_
#define	AJCTEXTOUT_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcTxoPrintF		AjcTxoPrintFW
	#define	AjcTxoPrintFEx		AjcTxoPrintFExW
	#define	AjcTxoPrintFExEx	AjcTxoPrintFExExW
	#define	AjcTxoTextOut		AjcTxoTextOutW
	#define	AjcTxoTextOutEx		AjcTxoTextOutExW
	#define	AjcTxoTextOutExEx	AjcTxoTextOutExExW
	#define	AjcTxoEscOut		AjcTxoEscOutW
	#define	AjcTxoGetLineCount	AjcTxoGetLineCountW
	#define	AjcTxoGetExtent		AjcTxoGetExtentW
	#define	AjcTxoGetExtentEx	AjcTxoGetExtentExW
	#define	AjcTxoGetExtent2	AjcTxoGetExtent2W
	#define	AjcTxoGetExtent2Ex	AjcTxoGetExtent2ExW
	#define	AjcTxoEnumEsc		AjcTxoEnumEscW
	#define	AjcTxoGetRgbByText	AjcTxoGetRgbByTextW
#else
	#define	AjcTxoPrintF		AjcTxoPrintFA
	#define	AjcTxoPrintFEx		AjcTxoPrintFExA
	#define	AjcTxoPrintFExEx	AjcTxoPrintFExExA
	#define	AjcTxoTextOut		AjcTxoTextOutA
	#define	AjcTxoTextOutEx		AjcTxoTextOutExA
	#define	AjcTxoTextOutExEx	AjcTxoTextOutExExA
	#define	AjcTxoEscOut		AjcTxoEscOutA
	#define	AjcTxoGetLineCount	AjcTxoGetLineCountA
	#define	AjcTxoGetExtent		AjcTxoGetExtentA
	#define	AjcTxoGetExtentEx	AjcTxoGetExtentExA
	#define	AjcTxoGetExtent2	AjcTxoGetExtent2A
	#define	AjcTxoGetExtent2Ex	AjcTxoGetExtent2ExA
	#define	AjcTxoEnumEsc		AjcTxoEnumEscA
	#define	AjcTxoGetRgbByText	AjcTxoGetRgbByTextA
#endif
//--------------------------------------------------------------------------------------------------------------//
//	R[i[wl																								//
//--------------------------------------------------------------------------------------------------------------//
#define		AJCTXO_CORNER_MIN	0x1FFF0000				//	Sŏl
#define		AJCTXO_CORNER_MAX	0x1FFFFFFF				//	Sől
//	E
#define		AJCTXO_RIGHT_MIN	0x1FFF0000				//	ŏl
#define		AJCTXO_RIGHT_MAX	0x1FFF3FFF				//	ől
#define		AJCTXO_RIGHT		0x1FFF2000				//	l
//	
#define		AJCTXO_BOTTOM_MIN	0x1FFF4000				//	ŏl
#define		AJCTXO_BOTTOM_MAX	0x1FFF7FFF				//	ől
#define		AJCTXO_BOTTOM		0x1FFF6000				//	l
//	
#define		AJCTXO_CENTER_MIN	0x1FFF8000				//	ŏl
#define		AJCTXO_CENTER_MAX	0x1FFFBFFF				//	ől
#define		AJCTXO_CENTER		0x1FFFA000				//	l

//--------------------------------------------------------------------------------------------------------------//
//	l																									//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCTXOALIGN_LEFT		= 1, 		//	l
	AJCTXOALIGN_CENTER		= 2, 		//	킹
	AJCTXOALIGN_RIGHT		= 3, 		//	El
	AJCTXOALIGN_TAB_RIGHT	= 4,		//	l߂łs`aȍ~El
} AJCTXOALIGN, *PAJCTXOALIGN;

//--------------------------------------------------------------------------------------------------------------//
//	wi[h																								//
//--------------------------------------------------------------------------------------------------------------//
typedef enum {
	AJCTXO_TRANSPARENT	=	TRANSPARENT,	//	
	AJCTXO_OPAQUE		=	OPAQUE,			//	s
} AJCTXOBKMODE, *PAJCTXOBKMODE;


//--------------------------------------------------------------------------------------------------------------//
//	CX^X[N																							//
//--------------------------------------------------------------------------------------------------------------//
typedef  struct {
	UI					InstID;				//	CX^Xʂhc
	HDC					hdc;				//	cbnh
	SIZE				szBmp;				//	cb`Xy[X̃TCYirbg}bvTCYj
	int					xLeft;				//	w[ʒui'\r'ɂ镜Aʒuj
	int					yTop;				//	x[ʒu
	int					x, y;				//	`sNZʒu
	int					TabStep;			//	^uXebvmsNZn
	int					cxChar;				//	̕	msNZn
	int					cyChar;				//	̍	msNZn
	int					Lsp;				//	sԃXy[XmsNZn
	AJCTXOALIGN			Align;				//	񐮗il߁A킹AEl߁CTABȍ~El߁j
	int					NestItalic;			//	Ύ̃lXg
	int					NestBold;			//	̃lXg
	int					NestULine;			//	̃lXg
	COLORREF			Palette[8];			//	pbg
	//----- N̂cb -----------------------------------------------------------------------------------//
	HFONT				hFontOrg;			//	IWitHg
	UI					BkModeOrg;			//	IWiwi[h
	COLORREF			BkColorOrg;			//	IWiwiF
	COLORREF			TxtColorOrg;		//	IWiF
	//----- ftHg -------------------------------------------------------------------------------------//
	UI					LspDef;				//	sԃXy[X
	COLORREF			TxtColorDef;		//	eLXgF
	COLORREF			BkColorDef;			//	wiFi-1Fj
	//----- tHgύX -----------------------------------------------------------------------------------//
	UI					fFont;				//	tHgύXtO
	HFONT				hFontN;				//	m[}tHg
	HFONT				hFontB;				//	{[h
	HFONT				hFontI;				//	C^bN
	HFONT				hFontU;				//	A_[C
	HFONT				hFontBI;			//	{[h   { C^bN
	HFONT				hFontBU;			//	{[h   { A_[C
	HFONT				hFontIU;			//	C^bN { A_[C
	HFONT				hFontBIU;			//	{[h   { C^bN { A_[C
} AJCTXO, *HAJCTXO;

//--------------------------------------------------------------------------------------------------------------//
//	vg^Cv																								//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCTXO		WINAPI	AjcTxoCreate		(HDC hdc, int left, int top, int defLsp);
AJCEXPORT	BOOL		WINAPI	AjcTxoDelete		(HAJCTXO hTxo, BOOL fRestore);

AJCEXPORT	BOOL		WINAPI	AjcTxoSetDcBmpSize	(HAJCTXO hTxo, int cx, int cy);

AJCEXPORT	BOOL		WINAPI	AjcTxoSetAlign		(HAJCTXO hTxo, AJCTXOALIGN Align);
AJCEXPORT	AJCTXOALIGN	WINAPI	AjcTxoGetAlign		(HAJCTXO hTxo);

AJCEXPORT	BOOL		WINAPI	AjcTxoLocate		(HAJCTXO hTxo, int x, int y);

AJCEXPORT	BOOL		WINAPI	AjcTxoSetPos		(HAJCTXO hTxo, LPPOINT pPt);
AJCEXPORT	BOOL		WINAPI	AjcTxoGetPos		(HAJCTXO hTxo, LPPOINT pPt);

AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFA		(HAJCTXO hTxo, C_BCP pFmt, ...);
AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFW		(HAJCTXO hTxo, C_WCP pFmt, ...);

AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFExA		(HAJCTXO hTxo, int x, int y, C_BCP pFmt, ...);
AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFExW		(HAJCTXO hTxo, int x, int y, C_WCP pFmt, ...);

AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFExExA	(HAJCTXO hTxo, int x, int y, int cx, C_BCP pFmt, ...);
AJCEXPORT	BOOL		WINAPI	AjcTxoPrintFExExW	(HAJCTXO hTxo, int x, int y, int cx, C_WCP pFmt, ...);

AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutA		(HAJCTXO hTxo, C_BCP pText);
AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutW		(HAJCTXO hTxo, C_WCP pText);

AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutExA	(HAJCTXO hTxo, int x, int y, C_BCP pText);
AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutExW	(HAJCTXO hTxo, int x, int y, C_WCP pText);

AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutExExA	(HAJCTXO hTxo, int x, int y, int cx, C_BCP pText);
AJCEXPORT	BOOL		WINAPI	AjcTxoTextOutExExW	(HAJCTXO hTxo, int x, int y, int cx, C_WCP pText);

AJCEXPORT	BCP			WINAPI	AjcTxoEscOutA		(HAJCTXO hTxo, C_BCP pEsc);
AJCEXPORT	WCP			WINAPI	AjcTxoEscOutW		(HAJCTXO hTxo, C_WCP pEsc);

AJCEXPORT	UI			WINAPI	AjcTxoGetLineCountA	(HAJCTXO hTxo, C_BCP pText);
AJCEXPORT	UI			WINAPI	AjcTxoGetLineCountW	(HAJCTXO hTxo, C_WCP pText);

AJCEXPORT	UI			WINAPI	AjcTxoGetExtentA	(HAJCTXO hTxo, C_BCP pText, LPSIZE pSize);
AJCEXPORT	UI			WINAPI	AjcTxoGetExtentW	(HAJCTXO hTxo, C_WCP pText, LPSIZE pSize);

AJCEXPORT	UI			WINAPI	AjcTxoGetExtentExA	(HAJCTXO hTxo, int x, int y, C_BCP pText, LPSIZE pSize);
AJCEXPORT	UI			WINAPI	AjcTxoGetExtentExW	(HAJCTXO hTxo, int x, int y, C_WCP pText, LPSIZE pSize);

AJCEXPORT	UI			WINAPI	AjcTxoGetExtent2A	(HAJCTXO pW, C_BCP pText, LPSIZE pSize, UI LinePixs[], UI nLine);
AJCEXPORT	UI			WINAPI	AjcTxoGetExtent2W	(HAJCTXO pW, C_WCP pText, LPSIZE pSize, UI LinePixs[], UI nLine);

AJCEXPORT	UI			WINAPI	AjcTxoGetExtent2ExA	(HAJCTXO pW, int x, int y, C_BCP pText, LPSIZE pSize, UI LinePixs[], UI nLine);
AJCEXPORT	UI			WINAPI	AjcTxoGetExtent2ExW	(HAJCTXO pW, int x, int y, C_WCP pText, LPSIZE pSize, UI LinePixs[], UI nLine);

AJCEXPORT	BOOL		WINAPI	AjcTxoSetPalette	(HAJCTXO hTxo, COLORREF rgb[8]);
AJCEXPORT	COLORREF	WINAPI	AjcTxoSetPaletteItem(HAJCTXO hTxo, int ix, COLORREF rgb);

AJCEXPORT	BOOL		WINAPI	AjcTxoGetPalette	 (HAJCTXO hTxo, COLORREF rgb[8]);
AJCEXPORT	COLORREF	WINAPI	AjcTxoGetPaletteItem (HAJCTXO hTxo, int ix);

AJCEXPORT	COLORREF	WINAPI	AjcTxoSetDefTextColor(HAJCTXO hTxo, COLORREF defColor);

AJCEXPORT	COLORREF	WINAPI	AjcTxoSetDefBkColor  (HAJCTXO hTxo, COLORREF defColor);

AJCEXPORT	BOOL		WINAPI	AjcTxoGetCharSize	 (HAJCTXO hTxo, LPSIZE pSize);

AJCEXPORT	UI			WINAPI	AjcTxoGetLineSpace	 (HAJCTXO hTxo);
AJCEXPORT	UI			WINAPI	AjcTxoSetLineSpace	 (HAJCTXO hTxo, int LineSpace);

AJCEXPORT	int			WINAPI	AjcTxoGetTabStep	 (HAJCTXO hTxo);
AJCEXPORT	int			WINAPI	AjcTxoSetTabStep	 (HAJCTXO hTxo, int TabStep);

AJCEXPORT	AJCTXOBKMODE WINAPI	AjcTxoGetBkMode	 (HAJCTXO pW);
AJCEXPORT	AJCTXOBKMODE WINAPI	AjcTxoSetBkMode	 (HAJCTXO pW, AJCTXOBKMODE BkMode);

AJCEXPORT	UI			WINAPI	AjcTxoEnumEscA(C_BCP pText, UX cbp, BOOL (CALLBACK *cbNtcEsc)(C_BCP pEsc, UI lEsc, BC cLast, UX cbp));
AJCEXPORT	UI			WINAPI	AjcTxoEnumEscW(C_WCP pText, UX cbp, BOOL (CALLBACK *cbNtcEsc)(C_WCP pEsc, UI lEsc, WC cLast, UX cbp));

AJCEXPORT	BCP			WINAPI	AjcTxoGetRgbByTextA	(C_BCP pText, COLORREF *pBuf);
AJCEXPORT	WCP			WINAPI	AjcTxoGetRgbByTextW	(C_WCP pText, COLORREF *pBuf);

/****************************************************************************************************************/
#endif
