#ifndef	AJRCTL32_H_
#define	AJRCTL32_H_
/***************************************************************************************************************/

#if _MSC_VER < 1400   // VS2005ȑO
  #define	WINVER			0x0500
  #define	_WIN32_WINNT	0x0500
#endif

#include	<WinSock2.h>
#include	<ws2tcpip.h>
#include	<wspiapi.h>
#define WIN32_LEAN_AND_MEAN

#include	<windows.h>
#include	<CommCtrl.h>

/*----- #pragma pack(n) --------------------*/
#ifdef _WIN64
	#pragma pack(8)
#else
	#pragma pack(4)
#endif

/*----- KV{(AJTCTLXX)` ---------*/
#ifndef AJRCTLXX
	#ifdef _WIN64
		#define	AJRCTL64
	#else
		#define	AJRCTL32
	#endif
	#define	AJRCTLXX
#endif

/*----- Cu(AjrCstXX.dll)荞 ---*/
#ifndef AJC_NOLIB
	#ifdef _WIN64
		#pragma comment(lib, "AjrCst64.lib")
	#else
		#pragma comment(lib, "AjrCst32.lib")
	#endif
#endif

#include	<stdlib.h>
#include	<stdio.h>
#include	<io.h>
#include	<mbctype.h>
#include	<mbstring.h>

#include	"AjcDef.h"
#include	"AjcVerNo.h"
#include	"AjcAvlTree.h"
#include	"AjcStrPool.h"
#include	"AjcAvsTree.h"
#include	"AjcTextFile.h"
#include	"AjcTimeMeasure.h"
#include	"AjcGeneral.h"
#include	"AjcString.h"
#include	"AjcMain.h"
#include	"AjcIniFile.h"
#include	"AjcRegFile.h"
#include	"AjcDlgItem.h"
#include	"AjcWndItem.h"
#include	"AjcStdIo.h"
#include	"AjcMsgMap.h"
#include	"AjcRingBuf.h"
#include	"AjcCRC.h"
#include	"AjcCheckSum.h"
#include	"AjcHexData.h"
#include	"AjcQueF.h"
#include	"AjcQueV.h"
#include	"AjcQueX.h"
#include	"AjcMbxF.h"
#include	"AjcMbxV.h"
#include	"AjcGetFileDir.h"
#include	"AjcCToken.h"
#include	"AjcStateCtrl.h"
#include	"Ajc3dVec.h"
#include	"AjcSepStream.h"
#include	"AjcCtrlTimeChart.h"
#include	"AjcCtrl3dGraphic.h"
#include	"AjcCtrlInpVal.h"
#include	"AjcCtrlVT100.h"
#include	"AjcCtrlLogFile.h"
#include	"AjcCtrlBarGraph.h"
#include	"AjcCtrlTextEdit.h"
#include	"AjcSerialComPort.h"
#include	"AjcSbcComboBox.h"
#include	"AjcSbcRadioBtns.h"
#include	"AjcImgFunc.h"
#include	"AjcLzhDecode.h"
#include	"AjcDibSect.h"
#include	"AjcXYModem.h"
#include	"AjcPrinter.h"
#include	"AjcCtrlListBox.h"
#include	"AjcTipTxt.h"
#include	"AjcTipCtl.h"
#include	"AjcVmg.h"
#include	"AjcCip.h"
#include	"AjcFFT.h"
#include	"AjcPopupMenu.h"
#include	"AjcFileSearch.h"
#include	"AjcDateAndTime.h"
#include	"AjcFileDir.h"
#include	"AjcWndSupport.h"
#include	"AjcMonitorInfo.h"
#include	"AjcBitmap.h"
#include	"AjcSpline.h"
#include	"AjcStrPool.h"
#include	"AjcAvlTree.h"
#include	"AjcAvsTree.h"
#include	"AjcPrePro.h"
#include	"AjcHeapSort.h"
#include	"AjcMAlloc.h"
#include	"AjcProcessMem.h"
#include	"AjcSockServer.h"
#include	"AjcSockClient.h"
#include	"AjcTimeMesView.h"
#include	"AjcSphereData.h"
#include	"AjcProfile.h"
#include	"AjcFontDlg.h"
#include	"AjcTextOut.h"
#include	"AjcDlgColor.h"

#pragma pack()

//--------------------------------------------------------------------------------------------------------------//
//	Cu}N																						//
//--------------------------------------------------------------------------------------------------------------//
#define	MAjcInit()		AjcInit(AJC_CTRL_K, AJC_CTRL_V)


/***************************************************************************************************************/
#endif
