#ifndef	AJXG3D_H_
#define	AJXG3D_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RcOtBbN Rg[																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxG3d {
	public:
		HWND	m_hCtrl;				//	Rg[̃EChnh

		CAjxG3d();						//	RXgN^
		~CAjxG3d();						//	fXgN^

		//----- Rct@NV -----------------------------------------------------------------------------//
		BOOL	Init				(double x1, double y1, double z1, double x2, double y2, double z2, UI style = AJC3DGS_3DMODE);	//	RcOt[h
		BOOL	Init				(PCAJC3DVEC pLo, PAJC3DVEC pHi, PAJC3DVEC pRot, UI style = AJC3DGS_3DMODE);						//	RcOt[hixNgwj
		BOOL	SetPlane			(AJCG3DAXIS_DIR HoriAxis, AJCG3DAXIS_DIR VertAxis);								//	ʕ\
		BOOL	SetProp				(PCAJC3DGPROP pProp);															//	vpeBݒ
		BOOL	GetProp				(PAJC3DGPROP  pBuf);															//	vpeB擾
		BOOL	AdjustRange			();																				//	W
		BOOL	SetRange			(double x1, double y1, double z1, double x2, double y2, double z2);				//	ẽWݒ
		BOOL	SetCenter			(double xc, double yc, double zc);												//	e̒Sʒuݒ
		BOOL	SetWidth			(double xr, double yr, double zr);												//	e̕iajݒ
		BOOL	SetSameRangeWidth	();																				//	ẽW𓯂ɂ
		BOOL	SetFixedAspect		(BOOL fFixed);																	//	Wݒ肳ꂽ̈̃AXyNgݒ肷

		BOOL	SetColor			(UI id, COLORREF rgbP, COLORREF rgbN);											//	\Fݒ
		BOOL	SetPlotNumber		(UI id, UI PlotNumber);															//	vbgf[^ݒ
		BOOL	SetPlotSize			(UI id, UI PixelSize, UI PixelSizeE);											//	vbgf[^̃sNZTCYݒ

		BOOL	PutPlotData			(UI id, double x, double y, double z);											//	vbgf[^^
		BOOL	PutPlotData			(UI id, PCAJC3DVEC pPoint);														//	vbgf[^^ixNgwj

		BOOL	Pixel				(UI id, double x , double y , double z , UI PixelSize = 2);						//	sNZ`
		BOOL	Pixel				(UI id, PCAJC3DVEC pPoint, UI PixelSize = 2);									//	sNZ`ixNgwj

		BOOL	Line				(UI id, double x1, double y1, double z1, double x2, double y2, double z2);		//	C`
		BOOL	Line				(UI id, PCAJC3DVEC p1, PCAJC3DVEC p2);											//	C`ixNgwj

		BOOL	MoveTo				(UI id, double x, double y, double z);											//	C^̎n_ݒ
		BOOL	MoveTo				(UI id, PCAJC3DVEC ps);															//	C^̎n_ݒixNgwj

		BOOL	LineTo				(UI id, double x, double y, double z);											//	C̏I_ݒ肵C`
		BOOL	LineTo				(UI id, PCAJC3DVEC pe);															//	C̏I_ݒ肵C`ixNgwj

		BOOL	Arrow				(UI id, double x1, double y1, double z1, double x2, double y2, double z2);		//	`
		BOOL	Arrow				(UI id, PCAJC3DVEC p1, PCAJC3DVEC p2);											//	`ixNgwj

		BOOL	ArrowTo				(UI id, double x, double y, double z);											//	C̏I_ݒ肵`
		BOOL	ArrowTo				(UI id, PCAJC3DVEC pe);															//	C̏I_ݒ肵`ixNgwj

		BOOL	Triangle			(UI id, double x1, double y1, double z1, double x2, double y2, double z2, double x3, double y3, double z3);	//	Op``
		BOOL	Triangle			(UI id, PCAJC3DVEC p1, PCAJC3DVEC p2, PCAJC3DVEC p3);														//	Op``ixNgwj

		BOOL	Square				(UI id, double x1, double y1, double z1, double x2, double y2, double z2, double x3, double y3, double z3, double x4, double y4, double z4);	//	lp``
		BOOL	Square				(UI id, PCAJC3DVEC p1, PCAJC3DVEC p2, PCAJC3DVEC p3, PCAJC3DVEC p4);																			//	lp``ixNgwj

		BOOL	Cube				(UI id, double xc, double yc, double zc, double xr, double yr, double zr, UI division = 8);					//	́^̕`
		BOOL	Cube				(UI id, PCAJC3DVEC pCent, double xr, double yr, double zr, UI division = 8);								//	́^̕`ixNgwj

		BOOL	Sphere				(UI id, double xc, double yc, double zc, double xr, double yr, double zr, UI slice = 12, UI stack = 12);	//	^ȋ`
		BOOL	Sphere				(UI id, PCAJC3DVEC pCent, double rx, double ry, double rz, UI slice = 12, UI stack = 12);					//	^ȋ`ixNgwj

		BOOL	DefPlane			(UI id, double xc, double yc, double zc, double xv, double yv, double zv, double xo, double yo, double zo);	//	RcԏɔCӂ̕ʂ`
		BOOL	DefPlane			(UI id, PCAJC3DLVEC pLVec, PCAJC3DVEC pVOrg);																//	RcԏɔCӂ̕ʂ`ixNgwj

		BOOL	SetAngle			(double rtx, double rty, double rtz);											//	_ݒ
		BOOL	SetAngleXY			();																				//	_w|xʂɐݒ
		BOOL	SetAngleXZ			();																				//	_w|yʂɐݒ
		BOOL	SetAngleYZ			();																				//	_x|yʂɐݒ
		BOOL	SetAngle3D			();																				//	_RcC[Wɐݒ

		HBITMAP	GetBitmap			();																				//	rbg}bv擾

		BOOL	LoadProp			(C_BCP pProfileSect =  "G3dProp", PCAJC3DGPROP pDefProp = NULL);				//	vt@CvpeBlǏo(ASCII)
		BOOL	LoadProp 			(C_WCP pProfileSect = L"G3dProp", PCAJC3DGPROP pDefProp = NULL);				//	vt@CvpeBlǏo(UNICODE)

		BOOL	SaveProp 			(C_BCP pProfileSect =  "G3dProp");												//	vt@CփvpeBl(ASCII)
		BOOL	SaveProp 			(C_WCP pProfileSect = L"G3dProp");												//	vt@CփvpeBl(UNICODE)

		BOOL	LoadPropEx			(C_BCP pProfileSect =  "G3dProp", PCAJC3DGPROP pDefProp = NULL);				//	vt@Cڍ׃vpeBlǏo(ASCII)
		BOOL	LoadPropEx			(C_WCP pProfileSect = L"G3dProp", PCAJC3DGPROP pDefProp = NULL);				//	vt@Cڍ׃vpeBlǏo(UNICODE)

		BOOL	SavePropEx			(C_BCP pProfileSect =  "G3dProp");												//	vt@C֏ڍ׃vpeBl(ASCII)
		BOOL	SavePropEx			(C_WCP pProfileSect = L"G3dProp");												//	vt@C֏ڍ׃vpeBl(UNICODE)

		HFONT	SetTextFont			(HFONT hFont);																	//	eLXg`tHgݒ

		UI		TextOut				(int x, int y, C_BCP pTxt);														//	eLXg`isNZʒuwj(ASCII)
		UI		TextOut				(int x, int y, C_WCP pTxt);														//	eLXg`isNZʒuwj(UNICODE)

		UI		PrintF				(int x, int y, C_BCP pFmt, ...);												//	eLXg`isNZʒuwj(ASCII)	
		UI		PrintF				(int x, int y, C_WCP pFmt, ...);												//	eLXg`isNZʒuwj(UNICODE)

		UI		TextOutV			(AJCG3DTXOMD md, PCAJC3DVEC pV, C_BCP pTxt);									//	eLXg`iRcWwj(ASCII)
		UI		TextOutV			(AJCG3DTXOMD md, PCAJC3DVEC pV, C_WCP pTxt);									//	eLXg`iRcWwj(UNICODE)

		UI		PrintFV				(AJCG3DTXOMD md, PCAJC3DVEC pV, C_BCP pFmt, ...);								//	eLXg`iRcWwj(ASCII)	
		UI		PrintFV				(AJCG3DTXOMD md, PCAJC3DVEC pV, C_WCP pFmt, ...);								//	eLXg`iRcWwj(UNICODE)

		UI		GetText				(UI key, BCP pBuf, UI lBuf);													//	`eLXg擾(ASCII)	
		UI		GetText				(UI key, WCP pBuf, UI lBuf);													//	`eLXg擾(UNICODE)

		BOOL	ClearShape			(UI id);																		//	}``f[^NA[
		BOOL	ClearShape			();																				//	S}``f[^NA[
		BOOL	ClearPlot			(UI id);																		//	vbgf[^NA[
		BOOL	ClearPlot			();																				//	Svbgf[^NA[
		BOOL	ClearText			(UI key);																		//	`eLXg폜
		BOOL	ClearText			();																				//	SĂ̕`eLXg폜


		//----- ʕ`t@NViQc^Rcʁj -------------------------------------------------------//
		BOOL	Pixel 				(UI id, double x, double y, UI PixelSize);										//	ʂɃsNZ`
		BOOL	Pixel 				(UI id, PCAJC2DVEC pPoint, UI PixelSize);										//	ʂɃsNZ`ixNgwj

		BOOL	Line				(UI id, double x1, double y1, double x2, double y2);							//	ʂɃC`
		BOOL	Line				(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2);											//	ʂɃC`ixNgwj

		BOOL	MoveTo				(UI id, double x, double y);													//	ʂɕ`悷郉C^̎n_ݒ
		BOOL	MoveTo				(UI id, PCAJC2DVEC ps);															//	ʂɕ`悷郉C^̎n_ݒixNgwj

		BOOL	LineTo				(UI id, double x, double y);													//	I_w肵ʂɃC`
		BOOL	LineTo				(UI id, PCAJC2DVEC pe);															//	I_w肵ʂɃC`ixNgwj

		BOOL	Arrow				(UI id, double x1, double y1, double x2, double y2);							//	ʂɖ`
		BOOL	Arrow				(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2);											//	ʂɖ`ixNgwj

		BOOL	ArrowTo				(UI id, double x, double y);													//	I_w肵ʂɖ`
		BOOL	ArrowTo				(UI id, PCAJC2DVEC pe);															//	I_w肵ʂɖ`ixNgwj

		BOOL	Triangle			(UI id, double x1, double y1, double x2, double y2, double x3, double y3);		//	ʂɎOp``
		BOOL	Triangle			(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2, PCAJC2DVEC p3);							//	ʂɎOp``ixNgwj

		BOOL	Square				(UI id, double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4);	//	ʂɎlp``
		BOOL	Square				(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2, PCAJC2DVEC p3, PCAJC2DVEC p4);								//	ʂɎlp``ixNgwj

		BOOL	Rectangle			(UI id, double x1, double y1, double x2, double y2);												//	ʂɒ``
		BOOL	Rectangle			(UI id, PCAJC2DVEC p1, PCAJC2DVEC p2);																//	ʂɒ``ixNgwj

		BOOL	Ellipse				(UI id, double xc, double yc, double rx, double ry);												//	ʂɉ~^ȉ~`
		BOOL	Ellipse				(UI id, PCAJC2DVEC pCent, double rx, double ry);													//	ʂɉ~^ȉ~`ixNgwj

		BOOL	Star				(UI id, double xc, double yc, double r1, double r2=0.0, UI nVtx=5, double rot= 0.0, BOOL fInLine= FALSE); //	ʂɐ``
		BOOL	Star				(UI id, PCAJC2DVEC pCent    , double r1, double r2=0.0, UI nVtx=5, double rot= 0.0, BOOL fInLine= FALSE); //	ʂɐ``ixNgwj

		//----- Qc^Rcʃt@NV -------------------------------------------------------------------//
		BOOL	EnablePopupMenu		(BOOL fEnable);																	//	ENbNɂ|bvAbvj[̋^֎~
		BOOL	SetNtcRClk			(BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp);										//	ENbNʒmݒ

		BOOL	SetTipText			(C_BCP pTxt);																	//	c[`bv̐ݒ(ASCII)
		BOOL	SetTipText			(C_WCP pTxt);																	//	c[`bv̐ݒ(UNICODE)

		UI		GetTipText			(BCP pBuf, UI lBuf);															//	c[`bv̎擾(ASCII)
		UI		GetTipText			(WCP pBuf, UI lBuf);															//	c[`bv̎擾(UNICODE)

		BOOL	SetChkBoxTipText	(UI n, C_BCP pTxt);																//	tB^E`FbN{bNXEc[`bv̐ݒ(ASCII)
		BOOL	SetChkBoxTipText	(UI n, C_WCP pTxt);																//	tB^E`FbN{bNXEc[`bv̐ݒ(UNICODE)

		UI		GetChkBoxTipText	(UI n, BCP pBuf, UI lBuf);														//	tB^E`FbN{bNXEc[`bv̎擾(ASCII)
		UI		GetChkBoxTipText	(UI n, WCP pBuf, UI lBuf);														//	tB^E`FbN{bNXEc[`bv̎擾(UNICODE)

		BOOL	SetTipShowAlways	(BOOL fShowAlways);																//	c[`bv\̐ݒ
		BOOL	GetTipShowAlways	();																				//	c[`bv\̎擾

		BOOL	SetChkBoxTipShowAlways(UI n, BOOL fShowAlways);														//	tB^E`FbN{bNXEc[`bv̐ݒ
		BOOL	GetChkBoxTipShowAlways(UI n);																		//	tB^E`FbN{bNXEc[`bv̎擾

		BOOL	SetTipShowAlwaysAll	(BOOL fShowAlways);																//	Sc[`bv\̐ݒ

		BOOL	SetFilter 			(UI n, BOOL state);																//	tB^̐ݒ
		BOOL	GetFilter 			(UI n);																			//	tB^̎擾

		BOOL	GetDroppedFile		(BC buf[MAX_PATH]);																//	hbvꂽt@C擾(ASCII)
		BOOL	GetDroppedFile 		(WC buf[MAX_PATH]);																//	hbvꂽt@C擾(UNICODE)

		BOOL	GetDroppedDir		(BC buf[MAX_PATH], BOOL fTailIsDelimiter = TRUE);								//	hbvꂽfBNg擾(ASCII)
		BOOL	GetDroppedDir		(WC buf[MAX_PATH], BOOL fTailIsDelimiter = TRUE);								//	hbvꂽfBNg擾(UNICODE)

		BOOL	SetTitleText		(C_BCP pTitleText, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1, HFONT hFont = NULL);	//	^Cg̐ݒ(ASCII)
		BOOL	SetTitleText		(C_WCP pTitleText, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1, HFONT hFont = NULL);	//	^Cg̐ݒ(UNICODE)

		BOOL	Pause				(BOOL fPause);																	//	ʕ\̒~^ĊJ

		BOOL	EnableMesDraw		(BOOL fEnable);																	//	`掞Ԍv̋^֎~

		//----- z֐ ---------------------------------------------------------------------------------------//
		virtual	VO		Attach					(HWND hWnd);				//	nh֘At

		virtual	VO		OnNtcRotTheta(PCAJC3DVEC pVec);						//	_pxʒm
		virtual	VO		OnNtcPlotList(PCAJC3DGPLOTLIST pList);				//	vbgXgʒm
		virtual	VO		OnNtcClear	 (int Factor);							//	f[^NA[ʒm
		virtual	VO		OnNtcDblClk  ();									//	_uNbNʒm
		virtual	VO		OnNtcDropFile(UI n);								//	t@Chbvʒm
		virtual	VO		OnNtcDropDir (UI n);								//	tH_hbvʒm
		virtual	VO		OnNtcRClick  (PCAJC3DGRCLK pRClk);					//	ENbNʒm
	};
}
/****************************************************************************************************************/
#endif
