#ifndef	AJXLBX_H_
#define	AJXLBX_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	gXg{bNX Rg[																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxLbx {
	public:
		HWND	m_hCtrl;				//	Rg[̃EChnh
		BOOL	m_fUnicode;				//	UNICODEtO

		#ifdef UNICODE
			CAjxLbx(BOOL fUnicode = TRUE);		//	RXgN^(UNICODE)
		#else
			CAjxLbx(BOOL fUnicode = FALSE);		//	RXgN^(ASCII)
		#endif
		~CAjxLbx();								//	fXgN^

		//----- o֐ -------------------------------------------------------------------------------------//
		UI				GetAllItems		(PAJCLBXITEMA *pArr);						//	SXg{bNXڃf[^̔z擾(ASCII)
		UI				GetAllItems		(PAJCLBXITEMW *pArr);						//	SXg{bNXڃf[^̔z擾(UNICODE)

		VO				RelAllItems		(VOP pAllItemBuf);							//	擾SXg{bNXڂ̔z

		UI				GetSelectedItems(PAJCLBXITEMA *pArr);						//	SIڂ̔z擾(ASCII)
		UI				GetSelectedItems(PAJCLBXITEMW *pArr);						//	SIڂ̔z擾(UNICODE)

		VO				RelSelectedItems(VOP pSelectedItemBuf);						//	擾Iڂ̔z

		BOOL			LoadItems		(C_BCP pSect, C_BCP pKeyPrefix =  "Lbx");	//	vt@CSXg{bNXڂ̓Ǐo(ASCII)
		BOOL			LoadItems		(C_WCP pSect, C_WCP pKeyPrefix = L"Lbx");	//	vt@CSXg{bNXڂ̓Ǐo(UNICODE)

		BOOL			SaveItems		(C_BCP pSect, C_BCP pKeyPrefix =  "Lbx");	//	vt@C֑SXg{bNXڂ̏(ASCII)
		BOOL			SaveItems		(C_WCP pSect, C_WCP pKeyPrefix = L"Lbx");	//	vt@C֑SXg{bNXڂ̏(UNICODE)

		BOOL			SetTipText		(C_BCP pTxt);								//	c[`bv̐ݒ(ASCII)
		BOOL			SetTipText		(C_WCP pTxt);								//	c[`bv̐ݒ(UNICODE)

		BOOL			GetTipText		(BCP pBuf, UI lBuf);						//	c[`bv̎擾(ASCII)
		BOOL			GetTipText		(WCP pBuf, UI lBuf);						//	c[`bv̎擾(UNICODE)

		BOOL			SetTipShowAlways(BOOL fShowAlways);							//	c[`bv\̐ݒ
		BOOL			GetTipShowAlways();											//	c[`bv\̎擾



		int				AddString		(C_BCP pStr);								//	Xg{bNXڂ̒ǉ(ASCII)
		int				AddString		(C_WCP pStr);								//	Xg{bNXڂ̒ǉ(UNICODE)

		int				InsertString	(UI ix, C_BCP pStr);						//	Xg{bNXڂ̑}(ASCII)
		int				InsertString	(UI ix, C_WCP pStr);						//	Xg{bNXڂ̑}(UNICODE)

		int				DeleteString	(UI ix);									//	Xg{bNXڂ̍폜

		int				FindString		(UI ix, C_BCP pStr);						//	Xg{bNXڂ̌(ASCII)
		int				FindString		(UI ix, C_WCP pStr);						//	Xg{bNXڂ̌(UNICODE)

		int	 			GetCount		();											//	Xg{bNXڂ̍ڐ擾

		int				GetCurSel		();											//	IĂ郊Xg{bNXڂ̃CfNX擾
		BOOL			GetSel			(UI ix);									//	Xg{bNXڂ̑IԎ擾
		int				GetSelCount		();											//	IĂ郊Xg{bNXڂ̌擾

		BOOL			GetText			(UI ix, BCP pBuf, UI lBuf);					//	Xg{bNXڂ̎擾(ASCII)
		BOOL			GetText			(UI ix, WCP pBuf, UI lBuf);					//	Xg{bNXڂ̎擾(UNICODE)

		int				GetTextLen		(UI ix);									//	Xg{bNXڂ̕񒷎擾

		BOOL			ResetContent	();											//	SXg{bNXڂ̏

		int				SelectString	(UI ix, C_BCP pStr);						//	Xg{bNXڂ̑I(ASCII)
		int				SelectString	(UI ix, C_WCP pStr);						//	Xg{bNXڂ̑I(UNICODE)

		BOOL			SetCount		(UI count);									//	Xg{bNXڐ̐ݒ
		BOOL			SetCurSel		(UI ix);									//	Xg{bNXڂ̑I
		BOOL			SetSel			(UI ix, BOOL fSelect);						//	Xg{bNXڂ̑I^IԐݒ

		BOOL			SetItemData		(UI ix, UX data);							//	Xg{bNXڂɊ֘Atꂽl̐ݒ
		UX				GetItemData		(UI ix);									//	Xg{bNXڂɊ֘Atꂽl̎擾

		BOOL			SetBasePath		(C_BCP pBasePath);							//	΃AhXϊ̃x[XfBNgpXݒ(ASCII)
		BOOL			SetBasePath		(C_WCP pBasePath);							//	΃AhXϊ̃x[XfBNgpXݒ(UNICODE)

		BOOL			SetNtcRClk		(BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp);	//	ENbNʒmݒ

		BOOL			SetFileFilter	(C_BCP pFilter, C_BCP pDefExt);				//	t@CĨtB^CftHggq̐ݒ(ASCII)
		BOOL			SetFileFilter	(C_WCP pFilter, C_WCP pDefExt);				//	t@CĨtB^CftHggq̐ݒ(UBICODE)

		BOOL			GetDroppedFile	(BC buf[MAX_PATH]);							//	hbvꂽt@C̃pX擾(ASCII)
		BOOL			GetDroppedFile	(WC buf[MAX_PATH]);							//	hbvꂽt@C̃pX擾(UNICODE)

		BOOL			GetDroppedDir	(BC buf[MAX_PATH], BOOL fTailIsDelimiter = TRUE);	//	hbvꂽfBNg̃pX擾(ASCII)
		BOOL			GetDroppedDir	(WC buf[MAX_PATH], BOOL fTailIsDelimiter = TRUE);	//	hbvꂽfBNg̃pX擾(UNICODE)

		BOOL			GetRemovedItem	(BCP pBuf, UI lBuf);						//	폜ꂽڂ̕擾(ASCII)
		BOOL			GetRemovedItem	(WCP pBuf, UI lBuf);						//	폜ꂽڂ̕擾(UNICODE)

		//----- z֐ ---------------------------------------------------------------------------------------//
		virtual	VO		Attach					(HWND hWnd);				//	nh֘At
		virtual	VO		OnNtcDblClk				();							//	_uNbNʒm
		virtual	VO		OnNtcSelCancel			();							//	ILZʒm
		virtual	VO		OnNtcSelChange			();							//	IύXʒm
		virtual	VO		OnNtcSetFocus			();							//	tH[JX擾ʒm
		virtual	VO		OnNtcKillFocus			();							//	tH[JXrʒm
		virtual	VO		OnNtcRClick				(PAJCLBXRCLK pRClk);		//	ENbNʒm
		virtual	VO		OnNtcRemoved			(UI n);						//	ڍ폜ʒm
		virtual	VO		OnNtcDropDir			(UI n);						//	fBNghbvʒm
		virtual	VO		OnNtcDropFile			(UI n);						//	t@Cbvʒm
		virtual	VO		OnNtcErrSpace			();							//	sʒm
	};
}
/****************************************************************************************************************/
#endif
