#ifndef	AJXSCP_H_
#define	AJXSCP_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	VAʐM																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	NX`																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxScp {
		ATOM	m_Atom;					//	CxgʒmpNXnh
		HWND	m_hWndEvt;				//	CxgʒmpECh

	public:
		HAJCSCP	m_hScp;					//	rboCX^Xhnh
		BOOL	m_fUnicode;				//	UNICODEtO

		CAjxScp();						//	RXgN^
		~CAjxScp();						//	fXgN^

		//----- o֐ -------------------------------------------------------------------------------------//
		//	ݒ
		#ifdef _CONSOLE
			BOOL	Init	(C_BCP pSect, AJCSCP_CHUNKMODE ChunkMode = AJCSCP_CM_BIN, BOOL fUseWaitEvent = TRUE , BOOL fCreateMySlot = TRUE, C_BCP pMySlot =  "MySlot", C_BCP pRmtHost =  "", C_BCP pRmtSlot =	"RmtSlot");	//	(ASCII)
			BOOL	Init	(C_WCP pSect, AJCSCP_CHUNKMODE ChunkMode = AJCSCP_CM_BIN, BOOL fUseWaitEvent = TRUE , BOOL fCreateMySlot = TRUE, C_WCP pMySlot = L"MySlot", C_WCP pRmtHost = L"", C_WCP pRmtSlot = L"RmtSlot");	//	(UNICODE)
		#else
			BOOL	Init	(C_BCP pSect, AJCSCP_CHUNKMODE ChunkMode = AJCSCP_CM_BIN, BOOL fUseWaitEvent = FALSE, BOOL fCreateMySlot = TRUE, C_BCP pMySlot =  "MySlot", C_BCP pRmtHost =  "", C_BCP pRmtSlot =	"RmtSlot");	//	(ASCII)
			BOOL	Init	(C_WCP pSect, AJCSCP_CHUNKMODE ChunkMode = AJCSCP_CM_BIN, BOOL fUseWaitEvent = FALSE, BOOL fCreateMySlot = TRUE, C_WCP pMySlot = L"MySlot", C_WCP pRmtHost = L"", C_WCP pRmtSlot = L"RmtSlot");	//	(UNICODE)
		#endif

		BOOL				Open					(UI Port, UI Rate = 115200, UI DataBits = 8, UI Parity = 'N', UI StopBit = 1);	//	|[gI[vibnl|[gj
		BOOL				Open					(UI Port, LPDCB pDcb, LPCOMMTIMEOUTS pTmo = NULL);						//	|[gI[vibnl|[gCDCB, TIMEOUTwj

		BOOL				Open					(C_BCP pRmtHost, C_BCP pRmtSlot);										//	|[gI[vi[XbgCASCIIj
		BOOL				Open					(C_WCP pRmtHost, C_WCP pRmtSlot);										//	|[gI[vi[XbgCUNICODEj

		BOOL				Open					(C_BCP pServ, UI PortNo);												//	|[gI[vi\PbgCASCIIj
		BOOL				Open					(C_WCP pServ, UI PortNo);												//	|[gI[vi\PbgCUNICODEj

		BOOL				Open					();																		//	|[gI[viIϒʐM\[Xj
		BOOL				Open					(AJCSCP_PORTSEL sel);													//	|[gI[viʐM\[XIj

		BOOL				Close					();																		//	|[gN[Y
		UI					GetSelectedPort			();																		//	ݒ肳ĂʐM|[gʎ擾
		UI					IsOpened				();																		//	|[gI[vԎ擾

		BOOL				SendChar				(BC code);																//	PM(ASCII)
		BOOL				SendChar				(WC code);																//	PM(UNICODE)

		BOOL				SendWord14LF			(UI data);																//	oCgyAɂ郏[hi14Bitjf[^M (Low byte first)
		BOOL				SendWord14HF			(UI data);																//	oCgyAɂ郏[hi14Bitjf[^M (High byte first)

		BOOL				SetByteSeqRxWord14		(BOOL fLowByteFirst);													//	PSrbg[hf[^ioCgyAjM̃oCgݒ
		BOOL				GetByteSeqRxWord14		();																		//	PSrbg[hf[^ioCgyAjM̃oCg擾

		BOOL				SendText				(C_BCP pTxt, UI lTxt = -1);												//	eLXgf[^M(ASCII)
		BOOL				SendText				(C_WCP pTxt, UI lTxt = -1);												//	eLXgf[^M(UNICODE)

		BOOL				SendTextF				(C_BCP pFmt, ...);														//	eLXgf[^M(ASCII)
		BOOL				SendTextF				(C_WCP pFmt, ...);														//	eLXgf[^M(UNICODE)

		BOOL				SendBinData				(C_VOP pDat, UI lDat);													//	oCif[^M
		UI					SendPacket				(C_VOP pPkt, UI lPkt);													//	pPbgf[^M
		BOOL				SendBreak				(BOOL fBreak);															//	u[NMo^~
		BOOL				SetEvtMask				(UI Mask);																//	Cxg}XNݒ
		UI					GetEvtMask				();																		//	Cxg}XN擾
		BOOL				SetDTR					(BOOL fActive);															//	csqMݒ
		BOOL				SetRTS					(BOOL fActive);															//	qsrMݒ
		UI					GetSigState				();																		//	MԎ擾
		ULL					GetTxBytes				();																		//	M҂f[^oCg擾
		BOOL				PurgeRecvData			();																		//	SMσf[^j
		BOOL				PurgeSendData			();																		//	SM҂f[^j
		BOOL				PurgeAllData			();																		//	SMf[^j
		BOOL				SetParam				(const DCB *pDcb = NULL, const COMMTIMEOUTS *pTmo = NULL);				//	cbaƃ^CAEgݒ
		UI					GetParam				(LPDCB pDcb = NULL, LPCOMMTIMEOUTS pTmo = NULL);						//	cbaƃ^CAEg擾
		BOOL				WaitEvent				(UI msTime);							//	Cxg҂
		BOOL				SetPktCtrlCode			(UI stx = 0, UI etx = 0, UI dle = 0);									//	pPbgt[Fׂ̐R[hݒ
		BOOL				GetPktCtrlCode			(UIP pStx = NULL, UIP pEtx = NULL, UIP pDle = NULL);					//	pPbgt[Fׂ̐R[h擾
		BOOL				SetPktTimeout			(UI msTime);															//	pPbgt[M^CAEglݒ
		BOOL				GetPktTimeout			(UIP pMsTime);															//	pPbgt[M^CAEgl擾
		BOOL				EnableComPortSelection	(BOOL fEnableComPort);													//	ʐMp^ݒ_CAOɂbnl|[g ̑I^֎~
		BOOL				EnableMailslotSelection	(BOOL fEnableMailSlot);													//	ʐMp^ݒ_CAOɂ郁[Xbg̑I^֎~
		BOOL				EnableSocketSelection	(BOOL fEnableSocket);													//	ʐMp^ݒ_CAOɂ\PbgʐM ̑I^֎~
		BOOL				EnablePortSelection		(BOOL fEnableComPort, BOOL fEnableMailSlot, BOOL fEnableSocket);		//	bnl|[gA[XbgCу\PbgʐM̑I^֎~
		UI					DlgParamEasy			(HWND hWndOwner);														//	_CAOɂʐMp^ݒ
		UI					DlgParamEasy			(HWND hWndOwner, int x, int y);											//	_CAOɂʐMp^ݒiEChʒuwj
		UI					DlgParamDetail			(HWND hWndOwner);														//	_CAOɂbnl|[gʐMp^ڍאݒ
		UI					DlgParamDetailEx		(HWND hWndOwner, int x, int y);											//	_CAOɂbnl|[gʐMp^ڍאݒiEChʒuwj

		VO					GetPortPathName			(BCP *pPathName);														//	|[gpX̎擾(ASCII)
		VO					GetPortPathName			(WCP *pPathName);														//	|[gpX̎擾(UNICODE)

		VO					GetPortName				(BCP *pName);															//	|[g̎擾(ASCII)
		VO					GetPortName				(WCP *pName);															//	|[g̎擾(UNICODE)

		BOOL				SetChunkMode			(AJCSCP_CHUNKMODE ChunkMode);											//	`Nf[^̒ʒm[hݒ
		AJCSCP_CHUNKMODE	GetChunkMode			();																		//	`Nf[^̒ʒm[h擾

		BOOL				SetRxTextCode			(AJCSCP_TEXTCODE code);													//	MeLXg̕R[hʐݒ
		AJCSCP_TEXTCODE		GetRxTextCode			();																		//	MeLXg̕R[hʎ擾

		BOOL				SetTxTextCode			(AJCSCP_TEXTCODE code);													//	MeLXg̕R[hʐݒ
		AJCSCP_TEXTCODE		GetTxTextCode			();																		//	MeLXg̕R[hʎ擾

		AJCSCP_TEXTCODE		GetActualRxTextCode		();																		//	ۂ̎MeLXg̕R[hʎ擾
		AJCSCP_TEXTCODE		GetActualTxTextCode		();																		//	ۂ̑MeLXg̕R[hʎ擾

		BOOL				CreateMySlot			();																		//	[Xbg
		BOOL				DeleteMySlot			();																		//	[Xbg
		BOOL				MySlotIsCreated			();																		//	[XbgԎ擾

		VO					GetMySlotPathName		(BCP *pPathName);														//	[Xbg̃pX擾(ASCII)
		VO					GetMySlotPathName		(WCP *pPathName);														//	[Xbg̃pX擾(UNICODE)

		BOOL				GetMyComputerName		(BC pBuf[AJCMAX_HOSTNAME_LENGTH]);										//	Rs[^擾(ASCII)
		BOOL				GetMyComputerName		(WC pBuf[AJCMAX_HOSTNAME_LENGTH]);										//	Rs[^擾(UNICODE)

		BOOL				SetMailSlotNames		(C_BCP pMySlot, C_BCP pRmyHost, C_BCP pRmtSlot);						//	[Xbgݒ(ASCII)
		BOOL				SetMailSlotNames		(C_WCP pMySlot, C_WCP pRmyHost, C_WCP pRmtSlot);						//	[Xbgݒ(UNICODE)

		BOOL				GetMailSlotNames		(BC pMySlot[64], BC pRmyHost[AJCMAX_HOSTNAME_LENGTH], BC pRmtSlot[64]);	//	[Xbg擾(ASCII)
		BOOL				GetMailSlotNames		(WC pMySlot[64], WC pRmyHost[AJCMAX_HOSTNAME_LENGTH], WC pRmtSlot[64]);	//	[Xbg擾(UNICODE)

		BOOL				SetTxSpeedLimit			(BOOL flag, UI bps);													//	[XbgMx̐ݒ
		BOOL				GetTxSpeedLimit			(UIP pBps);																//	[XbgMx̎擾

		//----- z֐ ---------------------------------------------------------------------------------------//
		virtual VO	OnNtcPortState	(C_BCP pPortName, UI Param);				//	|[gԒʒm(ASCII)
		virtual VO	OnNtcPortState	(C_WCP pPortName, UI Param);				//	|[gԒʒm(UNICODE)

		virtual VO	OnNtcRxTextChunk(C_BCP pText);								//	eLXg`NMʒm(ASCII)
		virtual VO	OnNtcRxTextChunk(C_WCP pText);								//	eLXg`NMʒm(UNICODE)

		virtual VO	OnNtcRxBinChunk	(C_VOP pData, UI Bytes);					//	oCi`NMʒm

		virtual VO	OnNtcRxText		(C_BCP pText);								//	eLXgMʒm(ASCII)
		virtual VO	OnNtcRxText		(C_WCP pText);								//	eLXgMʒm(UNICODE)

		virtual VO	OnNtcRxEsc		(C_BCP pData);								//	drbV[PXMʒm(ASCII)
		virtual VO	OnNtcRxEsc		(C_WCP pData);								//	drbV[PXMʒm(UNICODE)

		virtual VO	OnNtcRxCtrl		(UI Ctrl);									//	R[hMʒm
		virtual VO	OnNtcRxPkt		(C_VOP pData, UI Bytes);					//	pPbgMʒm
		virtual VO	OnNtcTxEmpty	();											//	Mʒm

		virtual VO	OnNtcRxNoPkt	(C_BCP pText);								//	pPbgOf[^Mʒm
		virtual VO	OnNtcRxNoPkt	(C_WCP pText);								//	pPbgOf[^Mʒm

		virtual VO	OnNtcInvChunk	(C_VOP pData, UI lData);					//	seLXg`NMʒm

		virtual VO	OnNtcErr		(UI param);									//	ʐMG[ʒm
		virtual VO	OnNtcBreak		();											//	BREAKoʒm
		virtual VO	OnNtcRing		(UI param);									//	RINGωʒm
		virtual VO	OnNtcRlsd		(UI param);									//	RLSDωʒm
		virtual VO	OnNtcDsr		(UI param);									//	DSR ωʒm
		virtual VO	OnNtcCts		(UI param);									//	CTS ωʒm

		virtual VO	OnNtcRxWord14	(UW data);									//	oCgyAɂ郏[h(14Bit)Mʒm

		//----- X^eBbN֐ -------------------------------------------------------------------------------//
		static UI			EnumSerialPorts			(UBP pMap, UI lMap, UI CurrentPort);	//	bnl|[g̗
		static int			GetPortDevName			(C_BCP pPortName, BCP pBuf, UI lBuf);	//	bnl|[g̃foCX擾(ASCII)
		static int			GetPortDevName			(C_WCP pPortName, WCP pBuf, UI lBuf);	//	bnl|[g̃foCX擾(UNICODE)


	};
}
/****************************************************************************************************************/
#endif
