#ifndef	AJXTCH_H_
#define	AJXTCH_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	^C`[g Rg[																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxTch {
	public:
		HWND	m_hCtrl;				//	Rg[̃EChnh

		CAjxTch();						//	RXgN^
		~CAjxTch();						//	fXgN^

		BOOL	Stop					();														//	~
		BOOL	Start					();														//	Jn
		BOOL	Purge					();														//	NA[

		BOOL	PutData					(double dat[]);											//	f[^ݒ
		BOOL	PutData					(double d0						);
		BOOL	PutData					(double d0, double d1			);
		BOOL	PutData					(double d0, double d1, double d2);

		BOOL	PutData					(int	dat[]);											//	f[^ݒ
		BOOL	PutData					(int d0 			   );
		BOOL	PutData					(int d0, int d1 	   );
		BOOL	PutData					(int d0, int d1, int d2);

		BOOL	ShowBorder				(BOOL fShow, COLORREF rgb);								//	Og\
		BOOL	ShowFilter				(BOOL fShow);											//	tB^\
		BOOL	ShowScale 				(BOOL fLine, BOOL fValue);								//	XP[\

		BOOL	GetProp					(PAJCTCPROP	pBuf);										//	vpeB擾
		BOOL	SetProp					(PCAJCTCPROP pProp);									//	vpeBݒ

		BOOL	GetRange				(double *low, double *high);							//	W擾
		BOOL	GetRange				(int	*low, int	*high);								//	W擾
		BOOL	SetRange				(double	low, double  high);								//	Wݒ
		BOOL	SetRange				(int 	low, int	 high);								//	Wݒ
		BOOL	AdjustRange				();														//	W
		BOOL	SetBufSize				(int n);												//	obt@TCYݒ
		BOOL	SetItemNumber			(int n);												//	f[^ڐݒ
		BOOL	SetAveNumber			(int n);												//	ωݒ
		BOOL	SetTimeScale			(int n);												//	^CXP[ݒ

		HBITMAP	GetBitmap 				();														//	rbg}bv擾

		BOOL	LoadPermInfo			(C_BCP pProfileSect =  "TchPerm_*", C_BCP pKeyPrefix =	"Tch", UI PermItem = AJCTCH_PERM_FILTER);	//	vt@CiǂݏoiASCIIj
		BOOL	LoadPermInfo			(C_WCP pProfileSect = L"TchPerm_*", C_WCP pKeyPrefix = L"Tch", UI PermItem = AJCTCH_PERM_FILTER);	//	vt@CiǂݏoiUNICODEj

		BOOL	SavePermInfo			();														//	vt@C։i񏑂

		BOOL	LoadProp 				(C_BCP pProfileSect = "TchPerm_*", PCAJCTCPROP pDefProp = NULL);	//	vt@CvpeBǂݏo(ASCII)
		BOOL	LoadProp 				(C_WCP pProfileSect = L"TchPerm_*", PCAJCTCPROP pDefProp = NULL);	//	vt@CvpeBǂݏo(UNICODE)

		BOOL	SaveProp 				(C_BCP pProfileSect =  "TchProp");									//	vt@CփvpeB(ASCII)
		BOOL	SaveProp 				(C_WCP pProfileSect = L"TchProp");									//	vt@CփvpeB(UNICODE)

		BOOL	LoadPropEx				(C_BCP pProfileSect =  "TchProp", PCAJCTCPROP pDefProp = NULL);		//	vt@CvpeBCtB^ݒCEChX^Cǂݏo(ASCII)
		BOOL	LoadPropEx				(C_WCP pProfileSect = L"TchProp*", PCAJCTCPROP pDefProp = NULL);	//	vt@CvpeBCtB^ݒCEChX^Cǂݏo(UNICODE)

		BOOL	SavePropEx				(C_BCP pProfileSect =  "TchProp");									//	vt@CփvpeBCtB^ݒCEChX^C(ASCII)
		BOOL	SavePropEx				(C_WCP pProfileSect = L"TchProp");									//	vt@CփvpeBCtB^ݒCEChX^C(UNICODE)

		BOOL	EnablePopupMenu			(BOOL fEnable);											//	ENbNɂ|bvAbvj[̋^֎~

		BOOL	SetNtcRClk				(BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp);				//	ENbNʒmݒ

		BOOL	SetTipText				(C_BCP pTxt);											//	c[`bvEeLXgݒ(ASCII)
		BOOL	SetTipText				(C_WCP pTxt);											//	c[`bvEeLXgݒ(UNICODE)

		BOOL	GetTipText				(BCP pBuf, UI lBuf);									//	c[`bvEeLXg擾(ASCII)
		BOOL	GetTipText				(WCP pBuf, UI lBuf);									//	c[`bvEeLXg擾(UNICODE)

		BOOL	SetTipShowAlways		(BOOL fShowAlways);										//	c[`bvEeLXg\ݒ
		BOOL	GetTipShowAlways();																//	c[`bvEeLXg\擾	

		BOOL	SetChkBoxTipShowAlways	(UI n, BOOL fShowAlways);								//	tBB^i`FbN{bNXj̃c[`bvEeLXg\ݒ
		BOOL	GetChkBoxTipShowAlways	(UI n);													//	tBB^i`FbN{bNXj̃c[`bvEeLXg\擾

		BOOL	SetTipShowAlwaysAll		(BOOL fShowAlways);										//	SẴc[`bvEeLXg\ݒ

		BOOL	SetChkBoxTipText		(UI n, C_BCP pTxt);										//	tBB^i`FbN{bNXj̃c[`bvEeLXgݒ(ASCII)
		BOOL	SetChkBoxTipText		(UI n, C_WCP pTxt);										//	tBB^i`FbN{bNXj̃c[`bvEeLXgݒ(UNICODE)

		BOOL	GetChkBoxTipText		(UI n, BCP pBuf, UI lBuf);								//	tBB^i`FbN{bNXj̃c[`bvEeLXg擾(ASCII)
		BOOL	GetChkBoxTipText		(UI n, WCP pBuf, UI lBuf);								//	tBB^i`FbN{bNXj̃c[`bvEeLXg擾(UNICODE)

		BOOL	SetMaxLineDist			(double MaxLineDist);									//	ő匋ݒ
		double	GetMaxLineDist			();														//	ő匋擾

		int		GetScrollPos			();														//	XN[ʒu̎擾
		BOOL	SetScrollPos			(int pos);												//	XN[ʒu̐ݒ

		BOOL	SetFilter 				(UI n, BOOL state);										//	tB^̐ݒ
		BOOL	GetFilter 				(UI n);													//	tB^̎擾

		BOOL	SetHLineAtt				(UI id, COLORREF color, int width = 1, int style = AJCTCH_DASH);	//	i̐ݒj
		BOOL	SetHLinePos				(UI id, double pos);												//	i`ʒu̐ݒj
		BOOL	EnableHLine				(UI id, BOOL fEnable);												//	i`̋^֎~j

		BOOL	SetVLine				(COLORREF color, int width = 1, int style = AJCTCH_DASH);			//	c`iŌɊi[f[^̈ʒuɏc`悷j	
		BOOL	EnableVLine				(BOOL fEnable);														//	c`̋^֎~

		BOOL	SetPoint				(int r);												//	vbg_`iŌɊi[f[^̈ʒuɃvbg_i~j`悷j
		BOOL	EnablePoint				(BOOL fEnable);											//	vbg_`̋^֎~

		BOOL	GetDroppedFile			(BC buf[MAX_PATH]);										//	hbvꂽt@C擾(ASCII)
		BOOL	GetDroppedFile			(WC buf[MAX_PATH]);										//	hbvꂽt@C擾(UNICODE)

		BOOL	GetDroppedDir			(BC buf[MAX_PATH], BOOL fTailIsDelimiter = TRUE);		//	hbvꂽfBNg擾íuvtwtj(ASCII)
		BOOL	GetDroppedDir			(WC buf[MAX_PATH], BOOL fTailIsDelimiter = TRUE);		//	hbvꂽfBNg擾íuvtwt, UNICODEj

		BOOL	SetTitleText			(C_BCP pTitleText, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1, HFONT hFont = NULL);	//	^Cg̐ݒ(ASCII)
		BOOL	SetTitleText			(C_WCP pTitleText, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1, HFONT hFont = NULL);	//	^Cg̐ݒ(UNICODE)

		BOOL	SetIpInfo				(PCAJCTCIPINFO pInfo);									//	g`ԕ\̐ݒ
		BOOL	GetIpInfo				(PAJCTCIPINFO  pBuf );									//	g`ԕ\̎擾

		BOOL	Pause					(BOOL fPause);											//	\̒~^ĊJ

		BOOL	EnableMesDraw			(BOOL fEnable);											//	`掞Ԍv̋^֎~

		BOOL	MesPeriShow				(BOOL fShow);											//	vbgv\^\̐ݒ
		BOOL	MesPeriReset			();														//	vbgv񃊃Zbg

		HFONT	SetTextFont				(HFONT hFont);											//	eLXg`tHgݒ

		UI		TextOut					(int x, int y, C_BCP pTxt);								//	eLXg`isNZʒuwj(ASCII)
		UI		TextOut					(int x, int y, C_WCP pTxt);								//	eLXg`isNZʒuwj(UNICODE)

		UI		PrintF					(int x, int y, C_BCP pFmt, ...);						//	eLXg`isNZʒuwj(ASCII)	
		UI		PrintF					(int x, int y, C_WCP pFmt, ...);						//	eLXg`isNZʒuwj(UNICODE)

		UI		GetText					(UI key, BCP pBuf, UI lBuf);							//	`eLXg擾(ASCII)	
		UI		GetText					(UI key, WCP pBuf, UI lBuf);							//	`eLXg擾(UNICODE)

		BOOL	ClearText				(UI key);												//	`eLXg폜
		BOOL	ClearText				();														//	SĂ̕`eLXg폜

		BOOL	Clear					();														//	SẴf[^ƕ`eLXg폜

		//----- z֐ ---------------------------------------------------------------------------------------//
		virtual	VO	Attach			(HWND hWnd);												//	nh֘At

		virtual	VO	OnNtcRange		(PCAJCTC_NTC_RANGE pRange);									//	Wωʒm
		virtual	VO	OnNtcScrPos		(UI 			   ScrPos);									//	XN[ʒuωʒm
		virtual	VO	OnNtcClear		();															//	OtNA[ʒm
		virtual	VO	OnNtcDblClk		();															//	_uNbNʒm
		virtual	VO	OnNtcDropFile	(UI 			  nFiles);									//	t@Chbvʒm
		virtual	VO	OnNtcDropDir	(UI 			  nDirs );									//	fBNghbvʒm
		virtual	VO	OnNtcRClick		(PCAJCTCRCLK 	  pRClk );									//	ENbNʒm

	};
}
/****************************************************************************************************************/
#endif
