#ifndef	AJXVTH_H_
#define	AJXVTH_H_
/****************************************************************************************************************/
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	usPOOG~[V Rg[																		//
//																												//
//--------------------------------------------------------------------------------------------------------------//
namespace  AjxControl {
	class  AJXEXPORT CAjxVth {
		BOOL	m_fUnicode;				//	UNICODE[hʁi͖gpj
	public:
		HWND	m_hCtrl;				//	Rg[̃EChnh

		#ifdef UNICODE
			CAjxVth(BOOL fUnicode = TRUE);	//	RXgN^(UNICODE)
		#else
			CAjxVth(BOOL fUnicode = FALSE);	//	RXgN^(ASCII)
		#endif
		~CAjxVth();							//	fXgN^

		BOOL		SetProp 			(PCAJCVTHPROP pProp);									//	vpeBݒ
		BOOL		GetProp 			(PAJCVTHPROP  pBuf );									//	vpeB擾
		BOOL		GetVramFitSize		(UIP pWidth, UIP pHeight);								//	uq`lɃtBbgEChTCY擾

		BOOL		PutChar				(BC c);													//	P`(ASCII)
		BOOL		PutChar				(WC c);													//	P`(UNICODE)

		BOOL		PutTextAuto			(C_BCP pTxt, UI lTxt = -1);								//	}`oCgR[hʂăeLXg`(ASCII)
		BOOL		PutTextEUC			(C_BCP pTxt, UI lTxt = -1);								//	{dtbR[heLXg`					(ASCII)
		BOOL		PutTextUTF8			(C_BCP pTxt, UI lTxt = -1);								//	tse|WR[heLXg`					(ASCII)

		BOOL		PutText				(C_BCP pTxt, UI lTxt = -1);								//	eLXg`(ASCII)
		BOOL		PutText				(C_WCP pTxt, UI lTxt = -1);								//	eLXg`(UNICODE)

		BOOL		PrintF 				(C_BCP pFmt, ...);										//	eLXg`(ASCII)
		BOOL		PrintF 				(C_WCP pFmt, ...);										//	eLXg`(UNICODE)

		BOOL		TimeStamp			();														//	^CX^v`
		BOOL		HexDump 			(C_VOP pDat, UI lDat);									//	oCif[^̂PUi_v`

		BOOL		Locate				(UI line, UI col);										//	J[\ʒuݒ
		BOOL		SetColor			(UI PaletteNo);											//	eLXg`ppbgݒ
		BOOL		SetBkColor			(UI PaletteNo);											//	wi`ppbgݒ
		BOOL		SetPalette			(UI PaletteNo, COLORREF rgb);							//	pbg̐FR[hݒ

		UI			GetCursorPos		(UIP pLine, UIP pCol);									//	J[\ʒu擾
		UI			GetColor			();														//	eLXg`ppbgԍ擾
		UI			GetBkColor			();														//	wi`ppbgԍ擾
		COLORREF	GetPalette			(UI PaletteNo);											//	pbg̐FR[h擾

		BOOL		Select				(UI slp, UI scp, UI elp, UI ecp);						//	eLXgI
		BOOL		SelectAll			();														//	SẴeLXgI
		BOOL		CopyText			();														//	IeLXgNbv{[hփRs[
		BOOL		SetFont 			();														//	_CAOɂtHg̐ݒ
		BOOL		ShowCaret			(BOOL fShow);											//	Lbg\^\
		BOOL		Clear				();														//	SeLXgNA[
		BOOL		ClearAllText		();														//	V

		BOOL		GetDroppedFile		(BC buf[MAX_PATH]);										//	hbvꂽt@C擾(ASCII)
		BOOL 		GetDroppedFile		(WC buf[MAX_PATH]);										//	hbvꂽt@C擾(UNICODE)

		BOOL		GetDroppedDir		(BC buf[MAX_PATH], BOOL fTailIsDelimiter = TRUE);		//	hbvꂽfBNg擾(ASCII)
		BOOL		GetDroppedDir		(WC buf[MAX_PATH], BOOL fTailIsDelimiter = TRUE);		//	hbvꂽfBNg擾(UNICODE)

		BOOL		LoadProp			(C_BCP pProfileSect =  "VthProp", PCAJCVTHPROPA pDefProp = NULL);	//	vt@CvpeBlǏo(ASCII)
		BOOL		LoadProp			(C_WCP pProfileSect = L"VthProp", PCAJCVTHPROPW pDefProp = NULL);	//	vt@CvpeBlǏo(UNICODE)

		BOOL		SaveProp			(C_BCP pProfileSect =  "VthProp");									//	vt@CփvpeB(ASCII)
		BOOL		SaveProp			(C_WCP pProfileSect = L"VthProp");									//	vt@CփvpeB(UNICODE)

		BOOL		LoadPermInfo		(C_BCP pProfileSect =  "VthPerm_*", C_BCP pKeyPrefix =	"Vth", UI PermItem = AJCVTH_PERM_FONT);	//	ݒ̓ǂݏo(ASCII)
		BOOL		LoadPermInfo		(C_WCP pProfileSect = L"VthPerm_*", C_WCP pKeyPrefix = L"Vth", UI PermItem = AJCVTH_PERM_FONT);	//	ݒ̓ǂݏo(UNICODE)

		BOOL		SavePermInfo		();														//	ݒ̏

		BOOL		EnablePopupMenu		(BOOL fEnable);											//	ENbNɂ|bvAbvj[̋^֎~
		BOOL		SetNtcRClk	   		(BOOL fNtcRClk, UI MsgRBDown, UI MsgRBUp);				//	ENbNʒmݒ

		UI			GetText				(BCP pBuf, UI lBuf);									//	eLXg̎擾(ASCII)
		UI			GetText				(WCP pBuf, UI lBuf);									//	eLXg̎擾(UNICODE)

		UI			GetSelectedText		(BCP pBuf, UI lBuf);									//	IĂeLXg̎擾(ASCII)
		UI			GetSelectedText		(WCP pBuf, UI lBuf);									//	IĂeLXg̎擾(UNICODE)

		UI			GetDblClickedLine	(BCP pBuf, UI lBuf);									//	_uNbNsʒũeLXg擾(ASCII)
		UI			GetDblClickedLine	(WCP pBuf, UI lBuf);									//	_uNbNsʒũeLXg擾(UNICODE)

		UI			GetDblClickedLine	(BCP pBuf, UI lBuf, UIP pLine, UIP pCol);				//	_uNbNsʒũeLXg擾(ASCII)
		UI			GetDblClickedLine	(WCP pBuf, UI lBuf, UIP pLine, UIP pCol);				//	_uNbNsʒũeLXg擾(UNICODE)

		BOOL		SetTipText			(C_BCP pTxt);											//	c[`bv̐ݒ(ASCII)
		BOOL		SetTipText			(C_WCP pTxt);											//	c[`bv̐ݒ(UNICODE)

		BOOL		GetTipText			(BCP pBuf, UI lBuf);									//	c[`bv̎擾(ASCII)
		BOOL		GetTipText			(WCP pBuf, UI lBuf);									//	c[`bv̎擾(UNICODE)

		BOOL		SetTipShowAlways	(BOOL fShowAlways);										//	c[`bv\̐ݒ
		BOOL		GetTipShowAlways	();														//	c[`bv\̎擾

		BOOL		SetFontInfo			(const LOGFONTA *pLogFont);								//	tHg̐ݒ(ASCII)
		BOOL		SetFontInfo			(const LOGFONTA *pLogFont, UI LSpace);					//	tHg̐ݒ(ASCIICsԃXy[X)

		BOOL		SetFontInfo			(const LOGFONTW *pLogFont);								//	tHg̐ݒ(UNICODE)
		BOOL		SetFontInfo			(const LOGFONTW *pLogFont, UI LSpace);					//	tHg̐ݒ(UNICODECsԃXy[X)

		UI			GetFontInfo			(LPLOGFONTA *pBuf);										//	tHg̎擾(ASCII)
		UI			GetFontInfo			(LPLOGFONTW *pBuf);										//	tHg̎擾(UNICODE)

		BOOL		GetCharInfo 		(UIP pCx, UIP pCy, UIP pLy);							//	TCY^s̍擾
		UI			GetLinesPerWindow	();														//	EChɕ\\ȍs̎擾
		UI			GetValidLines		();														//	obt@Ɋi[ĂLȍs̎擾
		UI			GetIxOfWndTopLine	();														//	ECh擪s̈ʒu擾iO`j

		BOOL		SetTitleText		(C_BCP pTitleText, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1, HFONT hFont = NULL);	//	^Cg̐ݒ(ASCII)
		BOOL		SetTitleText		(C_WCP pTitleText, COLORREF TextColor = (COLORREF)-1, COLORREF BackColor = (COLORREF)-1, HFONT hFont = NULL);	//	^Cg̐ݒ(UNICODE)

		BOOL		SaveTextToFile		(C_BCP pPath, BOOL fAllText = TRUE, EAJCTEC tec = AJCTEC_MBC, BOOL fBom = FALSE);	//	eLXgt@C֏(ASCII)
		BOOL		SaveTextToFile		(C_WCP pPath, BOOL fAllText = TRUE, EAJCTEC tec = AJCTEC_MBC, BOOL fBom = FALSE);	//	eLXgt@C֏(UNICODE)

		BOOL		SaveHtmlToFile		(C_BCP pPath, BOOL fAllText = FALSE, UI FontSize = 3);	//	eLXggslkt@C֏(ASCII)
		BOOL		SaveHtmlToFile		(C_WCP pPath, BOOL fAllText = FALSE, UI FontSize = 3);	//	eLXggslkt@C֏(UNICODE)

		BOOL		SaveAllTextWithEsc	(C_BCP pPath, EAJCTEC tec = AJCTEC_MBC, BOOL fBom = FALSE);		//	drbV[PXtSeLXgt@C֏(ASCII)
		BOOL		SaveAllTextWithEsc	(C_WCP pPath, EAJCTEC tec = AJCTEC_MBC, BOOL fBom = FALSE);		//	drbV[PXtSeLXgt@C֏(UNICODE)

		UI			GetLineCount		();														//	obt@Ɋi[Ăs̎擾

		BOOL		GetCursorPosInfo	(UIP pLine, UIP pCol);									//	J[\ʒu̍sԍƌʒu擾(ASCII)

		UI			GetLineText			(UI pos, BCP pBuf, UI lBuf);							//	wsʒu̍seLXg擾(ASCII)
		UI			GetLineText			(UI pos, WCP pBuf, UI lBuf);							//	wsʒu̍seLXg擾(UNICODE)

		UI			GetVScrollPos		();														//	cXN[ʒu̎擾
		UI			GetHScrollPos		();														//	XN[ʒu̎擾

		BOOL		SetVScrollPos		(UI pos);												//	cXN[ʒu̐ݒ
		BOOL		SetHScrollPos		(UI pos);												//	XN[ʒu̐ݒ

		BOOL		GetWindowSize		(LPSIZE pSize);											//	\EChTCYisCj擾

		UI			SearchBelow			(C_BCP pStr, BC delimiter = 0);							//	̌(ASCII)
		UI			SearchBelow			(C_WCP pStr, WC delimiter = 0);							//	̌(UNICODE)

		UI			SearchAbove			(C_BCP pStr, BC delimiter = 0);							//	̑O(ASCII)
		UI			SearchAbove			(C_WCP pStr, WC delimiter = 0);							//	̑O(UNICODE)

		BOOL		Pause				(BOOL fPause);											//	ʕ\̒~^ĊJ

		BOOL		SetLFActInPopupMenu	(BOOL flag);											//	s̐ݒ|bvAbvj[Ɋ܂߂邩ۂ̐ݒ
		BOOL		GetLFActInPopupMenu	();														//	s̐ݒ|bvAbvj[Ɋ܂߂邩ۂ̎擾

		//----- z֐ ---------------------------------------------------------------------------------------//
		virtual	VO	Attach			(HWND hWnd);					//	nh֘At

		virtual	VO	OnNtcDblClk		(UI	flag);						//	_uNbNʒm
		virtual	VO	OnNtcKeyIn		(UI	key, UI rep);				//	L[͒ʒm
		virtual	VO	OnNtcVKeyIn		(UI	key, UI rep);				//	gL[ʒm
		virtual	VO	OnNtcVKeyOut	(UI	key);						//	gL[ʒm
		virtual	VO	OnNtcDropFile	(UI nFiles );					//	t@Chbvʒm
		virtual	VO	OnNtcDropDir	(UI nDirs  );					//	fBNghbvʒm
		virtual	VO	OnNtcCharInfo	(UI	height );					//	TCY̕ωʒm
		virtual	VO	OnNtcHScroll	(UI	left   );					//	XN[ʒm
		virtual	VO	OnNtcVScroll	(UI	top    );					//	cXN[ʒm
		virtual	VO	OnNtcRClick		(PCAJCVTHRCLK	pRClk  );		//	ENbNʒm
		virtual	VO	OnNtcClear		();								//	ʃNA[ʒm
	};
}
/****************************************************************************************************************/
#endif
